/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/strings","vs/base/common/platform","vs/base/common/errors","vs/base/common/lifecycle","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/event","vs/base/common/assert","vs/base/common/objects","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/editor/common/diff/smartLinesDiffComputer","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/standalone/standaloneEnums","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/editor/common/diff/linesDiffComputers","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],K=function(q){for(var t=[],M=0,S=q.length;M<S;M++)t[M]=J[q[M]];return t},Ce=this,Oe=typeof global=="object"?global:{},ue;(function(q){q.global=Ce;var t=function(){function M(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(M.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),M.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=M._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof q.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")},M._isWindows=function(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1},M}();q.Environment=t})(ue||(ue={}));var ue;(function(q){var t=function(){function F(n,_,m){this.type=n,this.detail=_,this.timestamp=m}return F}();q.LoaderEvent=t;var M=function(){function F(n){this._events=[new t(1,"",n)]}return F.prototype.record=function(n,_){this._events.push(new t(n,_,q.Utilities.getHighPerformanceTimestamp()))},F.prototype.getEvents=function(){return this._events},F}();q.LoaderEventRecorder=M;var S=function(){function F(){}return F.prototype.record=function(n,_){},F.prototype.getEvents=function(){return[]},F.INSTANCE=new F,F}();q.NullLoaderEventRecorder=S})(ue||(ue={}));var ue;(function(q){var t=function(){function M(){}return M.fileUriToFilePath=function(S,F){if(F=decodeURI(F).replace(/%23/g,"#"),S){if(/^file:\/\/\//.test(F))return F.substr(8);if(/^file:\/\//.test(F))return F.substr(5)}else if(/^file:\/\//.test(F))return F.substr(7);return F},M.startsWith=function(S,F){return S.length>=F.length&&S.substr(0,F.length)===F},M.endsWith=function(S,F){return S.length>=F.length&&S.substr(S.length-F.length)===F},M.containsQueryString=function(S){return/^[^\#]*\?/gi.test(S)},M.isAbsolutePath=function(S){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(S)},M.forEachProperty=function(S,F){if(S){var n=void 0;for(n in S)S.hasOwnProperty(n)&&F(n,S[n])}},M.isEmpty=function(S){var F=!0;return M.forEachProperty(S,function(){F=!1}),F},M.recursiveClone=function(S){if(!S||typeof S!="object"||S instanceof RegExp||!Array.isArray(S)&&Object.getPrototypeOf(S)!==Object.prototype)return S;var F=Array.isArray(S)?[]:{};return M.forEachProperty(S,function(n,_){_&&typeof _=="object"?F[n]=M.recursiveClone(_):F[n]=_}),F},M.generateAnonymousModule=function(){return"===anonymous"+M.NEXT_ANONYMOUS_ID+++"==="},M.isAnonymousModule=function(S){return M.startsWith(S,"===anonymous")},M.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=q.global.performance&&typeof q.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?q.global.performance.now():Date.now()},M.NEXT_ANONYMOUS_ID=1,M.PERFORMANCE_NOW_PROBED=!1,M.HAS_PERFORMANCE_NOW=!1,M}();q.Utilities=t})(ue||(ue={}));var ue;(function(q){function t(F){if(F instanceof Error)return F;var n=new Error(F.message||String(F)||"Unknown Error");return F.stack&&(n.stack=F.stack),n}q.ensureError=t;var M=function(){function F(){}return F.validateConfigurationOptions=function(n){function _(a){if(a.phase==="loading"){console.error('Loading "'+a.moduleId+'" failed'),console.error(a),console.error("Here are the modules that depend on it:"),console.error(a.neededBy);return}if(a.phase==="factory"){console.error('The factory function of "'+a.moduleId+'" has thrown an exception'),console.error(a),console.error("Here are the modules that depend on it:"),console.error(a.neededBy);return}}if(n=n||{},typeof n.baseUrl!="string"&&(n.baseUrl=""),typeof n.isBuild!="boolean"&&(n.isBuild=!1),typeof n.paths!="object"&&(n.paths={}),typeof n.config!="object"&&(n.config={}),typeof n.catchError>"u"&&(n.catchError=!1),typeof n.recordStats>"u"&&(n.recordStats=!1),typeof n.urlArgs!="string"&&(n.urlArgs=""),typeof n.onError!="function"&&(n.onError=_),Array.isArray(n.ignoreDuplicateModules)||(n.ignoreDuplicateModules=[]),n.baseUrl.length>0&&(q.Utilities.endsWith(n.baseUrl,"/")||(n.baseUrl+="/")),typeof n.cspNonce!="string"&&(n.cspNonce=""),typeof n.preferScriptTags>"u"&&(n.preferScriptTags=!1),n.nodeCachedData&&typeof n.nodeCachedData=="object"&&(typeof n.nodeCachedData.seed!="string"&&(n.nodeCachedData.seed="seed"),(typeof n.nodeCachedData.writeDelay!="number"||n.nodeCachedData.writeDelay<0)&&(n.nodeCachedData.writeDelay=1e3*7),!n.nodeCachedData.path||typeof n.nodeCachedData.path!="string")){var m=t(new Error("INVALID cached data configuration, 'path' MUST be set"));m.phase="configuration",n.onError(m),n.nodeCachedData=void 0}return n},F.mergeConfigurationOptions=function(n,_){n===void 0&&(n=null),_===void 0&&(_=null);var m=q.Utilities.recursiveClone(_||{});return q.Utilities.forEachProperty(n,function(a,o){a==="ignoreDuplicateModules"&&typeof m.ignoreDuplicateModules<"u"?m.ignoreDuplicateModules=m.ignoreDuplicateModules.concat(o):a==="paths"&&typeof m.paths<"u"?q.Utilities.forEachProperty(o,function(p,y){return m.paths[p]=y}):a==="config"&&typeof m.config<"u"?q.Utilities.forEachProperty(o,function(p,y){return m.config[p]=y}):m[a]=q.Utilities.recursiveClone(o)}),F.validateConfigurationOptions(m)},F}();q.ConfigurationOptionsUtil=M;var S=function(){function F(n,_){if(this._env=n,this.options=M.mergeConfigurationOptions(_),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var m=this.options.nodeRequire.main.filename,a=Math.max(m.lastIndexOf("/"),m.lastIndexOf("\\"));this.options.baseUrl=m.substring(0,a+1)}}return F.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var n=0;n<this.options.ignoreDuplicateModules.length;n++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[n]]=!0},F.prototype._createSortedPathsRules=function(){var n=this;this.sortedPathsRules=[],q.Utilities.forEachProperty(this.options.paths,function(_,m){Array.isArray(m)?n.sortedPathsRules.push({from:_,to:m}):n.sortedPathsRules.push({from:_,to:[m]})}),this.sortedPathsRules.sort(function(_,m){return m.from.length-_.from.length})},F.prototype.cloneAndMerge=function(n){return new F(this._env,M.mergeConfigurationOptions(n,this.options))},F.prototype.getOptionsLiteral=function(){return this.options},F.prototype._applyPaths=function(n){for(var _,m=0,a=this.sortedPathsRules.length;m<a;m++)if(_=this.sortedPathsRules[m],q.Utilities.startsWith(n,_.from)){for(var o=[],p=0,y=_.to.length;p<y;p++)o.push(_.to[p]+n.substr(_.from.length));return o}return[n]},F.prototype._addUrlArgsToUrl=function(n){return q.Utilities.containsQueryString(n)?n+"&"+this.options.urlArgs:n+"?"+this.options.urlArgs},F.prototype._addUrlArgsIfNecessaryToUrl=function(n){return this.options.urlArgs?this._addUrlArgsToUrl(n):n},F.prototype._addUrlArgsIfNecessaryToUrls=function(n){if(this.options.urlArgs)for(var _=0,m=n.length;_<m;_++)n[_]=this._addUrlArgsToUrl(n[_]);return n},F.prototype.moduleIdToPaths=function(n){if(this._env.isNode){var _=this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(n);if(_)return this.isBuild()?["empty:"]:["node|"+n]}var m=n,a;if(!q.Utilities.endsWith(m,".js")&&!q.Utilities.isAbsolutePath(m)){a=this._applyPaths(m);for(var o=0,p=a.length;o<p;o++)this.isBuild()&&a[o]==="empty:"||(q.Utilities.isAbsolutePath(a[o])||(a[o]=this.options.baseUrl+a[o]),!q.Utilities.endsWith(a[o],".js")&&!q.Utilities.containsQueryString(a[o])&&(a[o]=a[o]+".js"))}else!q.Utilities.endsWith(m,".js")&&!q.Utilities.containsQueryString(m)&&(m=m+".js"),a=[m];return this._addUrlArgsIfNecessaryToUrls(a)},F.prototype.requireToUrl=function(n){var _=n;return q.Utilities.isAbsolutePath(_)||(_=this._applyPaths(_)[0],q.Utilities.isAbsolutePath(_)||(_=this.options.baseUrl+_)),this._addUrlArgsIfNecessaryToUrl(_)},F.prototype.isBuild=function(){return this.options.isBuild},F.prototype.shouldInvokeFactory=function(n){return!!(!this.options.isBuild||q.Utilities.isAnonymousModule(n)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[n])},F.prototype.isDuplicateMessageIgnoredFor=function(n){return this.ignoreDuplicateModulesMap.hasOwnProperty(n)},F.prototype.getConfigForModule=function(n){if(this.options.config)return this.options.config[n]},F.prototype.shouldCatchError=function(){return this.options.catchError},F.prototype.shouldRecordStats=function(){return this.options.recordStats},F.prototype.onError=function(n){this.options.onError(n)},F}();q.Configuration=S})(ue||(ue={}));var ue;(function(q){var t=function(){function a(o){this._env=o,this._scriptLoader=null,this._callbackMap={}}return a.prototype.load=function(o,p,y,w){var v=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new F;else if(this._env.isElectronRenderer){var e=o.getConfig().getOptionsLiteral().preferScriptTags;e?this._scriptLoader=new M:this._scriptLoader=new n(this._env)}else this._env.isNode?this._scriptLoader=new n(this._env):this._scriptLoader=new M;var A={callback:y,errorback:w};if(this._callbackMap.hasOwnProperty(p)){this._callbackMap[p].push(A);return}this._callbackMap[p]=[A],this._scriptLoader.load(o,p,function(){return v.triggerCallback(p)},function(D){return v.triggerErrorback(p,D)})},a.prototype.triggerCallback=function(o){var p=this._callbackMap[o];delete this._callbackMap[o];for(var y=0;y<p.length;y++)p[y].callback()},a.prototype.triggerErrorback=function(o,p){var y=this._callbackMap[o];delete this._callbackMap[o];for(var w=0;w<y.length;w++)y[w].errorback(p)},a}(),M=function(){function a(){}return a.prototype.attachListeners=function(o,p,y){var w=function(){o.removeEventListener("load",v),o.removeEventListener("error",e)},v=function(A){w(),p()},e=function(A){w(),y(A)};o.addEventListener("load",v),o.addEventListener("error",e)},a.prototype.load=function(o,p,y,w){if(/^node\|/.test(p)){var v=o.getConfig().getOptionsLiteral(),e=_(o.getRecorder(),v.nodeRequire||q.global.nodeRequire),A=p.split("|"),D=null;try{D=e(A[1])}catch(g){w(g);return}o.enqueueDefineAnonymousModule([],function(){return D}),y()}else{var E=document.createElement("script");E.setAttribute("async","async"),E.setAttribute("type","text/javascript"),this.attachListeners(E,y,w);var L=o.getConfig().getOptionsLiteral().trustedTypesPolicy;L&&(p=L.createScriptURL(p)),E.setAttribute("src",p);var h=o.getConfig().getOptionsLiteral().cspNonce;h&&E.setAttribute("nonce",h),document.getElementsByTagName("head")[0].appendChild(E)}},a}();function S(a){var o=a.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var p=o?self.eval(o.createScript("","true")):new Function("true");return p.call(self),!0}catch{return!1}}var F=function(){function a(){this._cachedCanUseEval=null}return a.prototype._canUseEval=function(o){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=S(o)),this._cachedCanUseEval},a.prototype.load=function(o,p,y,w){if(/^node\|/.test(p)){var v=o.getConfig().getOptionsLiteral(),e=_(o.getRecorder(),v.nodeRequire||q.global.nodeRequire),A=p.split("|"),D=null;try{D=e(A[1])}catch(h){w(h);return}o.enqueueDefineAnonymousModule([],function(){return D}),y()}else{var E=o.getConfig().getOptionsLiteral().trustedTypesPolicy,L=/^((http:)|(https:)|(file:))/.test(p)&&p.substring(0,self.origin.length)!==self.origin;if(!L&&this._canUseEval(o)){fetch(p).then(function(h){if(h.status!==200)throw new Error(h.statusText);return h.text()}).then(function(h){h=h+`
//# sourceURL=`+p;var g=E?self.eval(E.createScript("",h)):new Function(h);g.call(self),y()}).then(void 0,w);return}try{E&&(p=E.createScriptURL(p)),importScripts(p),y()}catch(h){w(h)}}},a}(),n=function(){function a(o){this._env=o,this._didInitialize=!1,this._didPatchNodeRequire=!1}return a.prototype._init=function(o){this._didInitialize||(this._didInitialize=!0,this._fs=o("fs"),this._vm=o("vm"),this._path=o("path"),this._crypto=o("crypto"))},a.prototype._initNodeRequire=function(o,p){var y=p.getConfig().getOptionsLiteral().nodeCachedData;if(!y||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var w=this,v=o("module");function e(A){var D=A.constructor,E=function(h){try{return A.require(h)}finally{}};return E.resolve=function(h,g){return D._resolveFilename(h,A,!1,g)},E.resolve.paths=function(h){return D._resolveLookupPaths(h,A)},E.main=process.mainModule,E.extensions=D._extensions,E.cache=D._cache,E}v.prototype._compile=function(A,D){var E=v.wrap(A.replace(/^#!.*/,"")),L=p.getRecorder(),h=w._getCachedDataPath(y,D),g={filename:D},l;try{var r=w._fs.readFileSync(h);l=r.slice(0,16),g.cachedData=r.slice(16),L.record(60,h)}catch{L.record(61,h)}var s=new w._vm.Script(E,g),d=s.runInThisContext(g),c=w._path.dirname(D),N=e(this),b=[this.exports,N,this,D,c,process,Oe,Buffer],f=d.apply(this.exports,b);return w._handleCachedData(s,E,h,!g.cachedData,p),w._verifyCachedData(s,E,h,l,p),f}},a.prototype.load=function(o,p,y,w){var v=this,e=o.getConfig().getOptionsLiteral(),A=_(o.getRecorder(),e.nodeRequire||q.global.nodeRequire),D=e.nodeInstrumenter||function(d){return d};this._init(A),this._initNodeRequire(A,o);var E=o.getRecorder();if(/^node\|/.test(p)){var L=p.split("|"),h=null;try{h=A(L[1])}catch(d){w(d);return}o.enqueueDefineAnonymousModule([],function(){return h}),y()}else{p=q.Utilities.fileUriToFilePath(this._env.isWindows,p);var g=this._path.normalize(p),l=this._getElectronRendererScriptPathOrUri(g),r=Boolean(e.nodeCachedData),s=r?this._getCachedDataPath(e.nodeCachedData,p):void 0;this._readSourceAndCachedData(g,s,E,function(d,c,N,b){if(d){w(d);return}var f;c.charCodeAt(0)===a._BOM?f=a._PREFIX+c.substring(1)+a._SUFFIX:f=a._PREFIX+c+a._SUFFIX,f=D(f,g);var u={filename:l,cachedData:N},R=v._createAndEvalScript(o,f,u,y,w);v._handleCachedData(R,f,s,r&&!N,o),v._verifyCachedData(R,f,s,b,o)})}},a.prototype._createAndEvalScript=function(o,p,y,w,v){var e=o.getRecorder();e.record(31,y.filename);var A=new this._vm.Script(p,y),D=A.runInThisContext(y),E=o.getGlobalAMDDefineFunc(),L=!1,h=function(){return L=!0,E.apply(null,arguments)};return h.amd=E.amd,D.call(q.global,o.getGlobalAMDRequireFunc(),h,y.filename,this._path.dirname(y.filename)),e.record(32,y.filename),L?w():v(new Error("Didn't receive define call in "+y.filename+"!")),A},a.prototype._getElectronRendererScriptPathOrUri=function(o){if(!this._env.isElectronRenderer)return o;var p=o.match(/^([a-z])\:(.*)/i);return p?"file:///"+(p[1].toUpperCase()+":"+p[2]).replace(/\\/g,"/"):"file://"+o},a.prototype._getCachedDataPath=function(o,p){var y=this._crypto.createHash("md5").update(p,"utf8").update(o.seed,"utf8").update(process.arch,"").digest("hex"),w=this._path.basename(p).replace(/\.js$/,"");return this._path.join(o.path,w+"-"+y+".code")},a.prototype._handleCachedData=function(o,p,y,w,v){var e=this;o.cachedDataRejected?this._fs.unlink(y,function(A){v.getRecorder().record(62,y),e._createAndWriteCachedData(o,p,y,v),A&&v.getConfig().onError(A)}):w&&this._createAndWriteCachedData(o,p,y,v)},a.prototype._createAndWriteCachedData=function(o,p,y,w){var v=this,e=Math.ceil(w.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),A=-1,D=0,E=void 0,L=function(){setTimeout(function(){E||(E=v._crypto.createHash("md5").update(p,"utf8").digest());var h=o.createCachedData();if(!(h.length===0||h.length===A||D>=5)){if(h.length<A){L();return}A=h.length,v._fs.writeFile(y,Buffer.concat([E,h]),function(g){g&&w.getConfig().onError(g),w.getRecorder().record(63,y),L()})}},e*Math.pow(4,D++))};L()},a.prototype._readSourceAndCachedData=function(o,p,y,w){if(!p)this._fs.readFile(o,{encoding:"utf8"},w);else{var v=void 0,e=void 0,A=void 0,D=2,E=function(L){L?w(L):--D===0&&w(void 0,v,e,A)};this._fs.readFile(o,{encoding:"utf8"},function(L,h){v=h,E(L)}),this._fs.readFile(p,function(L,h){!L&&h&&h.length>0?(A=h.slice(0,16),e=h.slice(16),y.record(60,p)):y.record(61,p),E()})}},a.prototype._verifyCachedData=function(o,p,y,w,v){var e=this;!w||o.cachedDataRejected||setTimeout(function(){var A=e._crypto.createHash("md5").update(p,"utf8").digest();w.equals(A)||(v.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+y+"' now, but a RESTART IS REQUIRED")),e._fs.unlink(y,function(D){D&&v.getConfig().onError(D)}))},Math.ceil(5e3*(1+Math.random())))},a._BOM=65279,a._PREFIX="(function (require, define, __filename, __dirname) { ",a._SUFFIX=`
});`,a}();function _(a,o){if(o.__$__isRecorded)return o;var p=function(w){a.record(33,w);try{return o(w)}finally{a.record(34,w)}};return p.__$__isRecorded=!0,p}q.ensureRecordedNodeRequire=_;function m(a){return new t(a)}q.createScriptLoader=m})(ue||(ue={}));var ue;(function(q){var t=function(){function m(a){var o=a.lastIndexOf("/");o!==-1?this.fromModulePath=a.substr(0,o+1):this.fromModulePath=""}return m._normalizeModuleId=function(a){var o=a,p;for(p=/\/\.\//;p.test(o);)o=o.replace(p,"/");for(o=o.replace(/^\.\//g,""),p=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;p.test(o);)o=o.replace(p,"/");return o=o.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),o},m.prototype.resolveModule=function(a){var o=a;return q.Utilities.isAbsolutePath(o)||(q.Utilities.startsWith(o,"./")||q.Utilities.startsWith(o,"../"))&&(o=m._normalizeModuleId(this.fromModulePath+o)),o},m.ROOT=new m(""),m}();q.ModuleIdResolver=t;var M=function(){function m(a,o,p,y,w,v){this.id=a,this.strId=o,this.dependencies=p,this._callback=y,this._errorback=w,this.moduleIdResolver=v,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return m._safeInvokeFunction=function(a,o){try{return{returnedValue:a.apply(q.global,o),producedError:null}}catch(p){return{returnedValue:null,producedError:p}}},m._invokeFactory=function(a,o,p,y){return a.shouldInvokeFactory(o)?a.shouldCatchError()?this._safeInvokeFunction(p,y):{returnedValue:p.apply(q.global,y),producedError:null}:{returnedValue:null,producedError:null}},m.prototype.complete=function(a,o,p,y){this._isComplete=!0;var w=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);var v=m._invokeFactory(o,this.strId,this._callback,p);w=v.producedError,a.record(22,this.strId),!w&&typeof v.returnedValue<"u"&&(!this.exportsPassedIn||q.Utilities.isEmpty(this.exports))&&(this.exports=v.returnedValue)}else this.exports=this._callback;if(w){var e=q.ensureError(w);e.phase="factory",e.moduleId=this.strId,e.neededBy=y(this.id),this.error=e,o.onError(e)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},m.prototype.onDependencyError=function(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1},m.prototype.isComplete=function(){return this._isComplete},m}();q.Module=M;var S=function(){function m(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return m.prototype.getMaxModuleId=function(){return this._nextId},m.prototype.getModuleId=function(a){var o=this._strModuleIdToIntModuleId.get(a);return typeof o>"u"&&(o=this._nextId++,this._strModuleIdToIntModuleId.set(a,o),this._intModuleIdToStrModuleId[o]=a),o},m.prototype.getStrModuleId=function(a){return this._intModuleIdToStrModuleId[a]},m}(),F=function(){function m(a){this.id=a}return m.EXPORTS=new m(0),m.MODULE=new m(1),m.REQUIRE=new m(2),m}();q.RegularDependency=F;var n=function(){function m(a,o,p){this.id=a,this.pluginId=o,this.pluginParam=p}return m}();q.PluginDependency=n;var _=function(){function m(a,o,p,y,w){w===void 0&&(w=0),this._env=a,this._scriptLoader=o,this._loaderAvailableTimestamp=w,this._defineFunc=p,this._requireFunc=y,this._moduleIdProvider=new S,this._config=new q.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return m.prototype.reset=function(){return new m(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},m.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},m.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},m._findRelevantLocationInStack=function(a,o){for(var p=function(g){return g.replace(/\\/g,"/")},y=p(a),w=o.split(/\n/),v=0;v<w.length;v++){var e=w[v].match(/(.*):(\d+):(\d+)\)?$/);if(e){var A=e[1],D=e[2],E=e[3],L=Math.max(A.lastIndexOf(" ")+1,A.lastIndexOf("(")+1);if(A=A.substr(L),A=p(A),A===y){var h={line:parseInt(D,10),col:parseInt(E,10)};return h.line===1&&(h.col-=53),h}}}throw new Error("Could not correlate define call site for needle "+a)},m.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var a=[],o=0,p=0,y=this._modules2.length;p<y;p++){var w=this._modules2[p];if(!!w){var v=this._buildInfoPath[w.id]||null,e=this._buildInfoDefineStack[w.id]||null,A=this._buildInfoDependencies[w.id];a[o++]={id:w.strId,path:v,defineLocation:v&&e?m._findRelevantLocationInStack(v,e):null,dependencies:A,shim:null,exports:w.exports}}}return a},m.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new q.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=q.NullLoaderEventRecorder.INSTANCE),this._recorder},m.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},m.prototype.enqueueDefineAnonymousModule=function(a,o){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var p=null;this._config.isBuild()&&(p=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:p,dependencies:a,callback:o}},m.prototype.defineModule=function(a,o,p,y,w,v){var e=this;v===void 0&&(v=new t(a));var A=this._moduleIdProvider.getModuleId(a);if(this._modules2[A]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}var D=new M(A,a,this._normalizeDependencies(o,v),p,y,v);this._modules2[A]=D,this._config.isBuild()&&(this._buildInfoDefineStack[A]=w,this._buildInfoDependencies[A]=(D.dependencies||[]).map(function(E){return e._moduleIdProvider.getStrModuleId(E.id)})),this._resolve(D)},m.prototype._normalizeDependency=function(a,o){if(a==="exports")return F.EXPORTS;if(a==="module")return F.MODULE;if(a==="require")return F.REQUIRE;var p=a.indexOf("!");if(p>=0){var y=o.resolveModule(a.substr(0,p)),w=o.resolveModule(a.substr(p+1)),v=this._moduleIdProvider.getModuleId(y+"!"+w),e=this._moduleIdProvider.getModuleId(y);return new n(v,e,w)}return new F(this._moduleIdProvider.getModuleId(o.resolveModule(a)))},m.prototype._normalizeDependencies=function(a,o){for(var p=[],y=0,w=0,v=a.length;w<v;w++)p[y++]=this._normalizeDependency(a[w],o);return p},m.prototype._relativeRequire=function(a,o,p,y){if(typeof o=="string")return this.synchronousRequire(o,a);this.defineModule(q.Utilities.generateAnonymousModule(),o,p,y,null,a)},m.prototype.synchronousRequire=function(a,o){o===void 0&&(o=new t(a));var p=this._normalizeDependency(a,o),y=this._modules2[p.id];if(!y)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!y.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(y.error)throw y.error;return y.exports},m.prototype.configure=function(a,o){var p=this._config.shouldRecordStats();o?this._config=new q.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!p&&(this._recorder=null)},m.prototype.getConfig=function(){return this._config},m.prototype._onLoad=function(a){if(this._currentAnonymousDefineCall!==null){var o=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),o.dependencies,o.callback,null,o.stack)}},m.prototype._createLoadError=function(a,o){var p=this,y=this._moduleIdProvider.getStrModuleId(a),w=(this._inverseDependencies2[a]||[]).map(function(e){return p._moduleIdProvider.getStrModuleId(e)}),v=q.ensureError(o);return v.phase="loading",v.moduleId=y,v.neededBy=w,v},m.prototype._onLoadError=function(a,o){var p=this._createLoadError(a,o);this._modules2[a]||(this._modules2[a]=new M(a,this._moduleIdProvider.getStrModuleId(a),[],function(){},null,null));for(var y=[],w=0,v=this._moduleIdProvider.getMaxModuleId();w<v;w++)y[w]=!1;var e=!1,A=[];for(A.push(a),y[a]=!0;A.length>0;){var D=A.shift(),E=this._modules2[D];E&&(e=E.onDependencyError(p)||e);var L=this._inverseDependencies2[D];if(L)for(var w=0,v=L.length;w<v;w++){var h=L[w];y[h]||(A.push(h),y[h]=!0)}}e||this._config.onError(p)},m.prototype._hasDependencyPath=function(a,o){var p=this._modules2[a];if(!p)return!1;for(var y=[],w=0,v=this._moduleIdProvider.getMaxModuleId();w<v;w++)y[w]=!1;var e=[];for(e.push(p),y[a]=!0;e.length>0;){var A=e.shift(),D=A.dependencies;if(D)for(var w=0,v=D.length;w<v;w++){var E=D[w];if(E.id===o)return!0;var L=this._modules2[E.id];L&&!y[E.id]&&(y[E.id]=!0,e.push(L))}}return!1},m.prototype._findCyclePath=function(a,o,p){if(a===o||p===50)return[a];var y=this._modules2[a];if(!y)return null;var w=y.dependencies;if(w)for(var v=0,e=w.length;v<e;v++){var A=this._findCyclePath(w[v].id,o,p+1);if(A!==null)return A.push(a),A}return null},m.prototype._createRequire=function(a){var o=this,p=function(y,w,v){return o._relativeRequire(a,y,w,v)};return p.toUrl=function(y){return o._config.requireToUrl(a.resolveModule(y))},p.getStats=function(){return o.getLoaderEvents()},p.hasDependencyCycle=function(){return o._hasDependencyCycle},p.config=function(y,w){w===void 0&&(w=!1),o.configure(y,w)},p.__$__nodeRequire=q.global.nodeRequire,p},m.prototype._loadModule=function(a){var o=this;if(!(this._modules2[a]||this._knownModules2[a])){this._knownModules2[a]=!0;var p=this._moduleIdProvider.getStrModuleId(a),y=this._config.moduleIdToPaths(p),w=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(p.indexOf("/")===-1||w.test(p))&&y.push("node|"+p);var v=-1,e=function(A){if(v++,v>=y.length)o._onLoadError(a,A);else{var D=y[v],E=o.getRecorder();if(o._config.isBuild()&&D==="empty:"){o._buildInfoPath[a]=D,o.defineModule(o._moduleIdProvider.getStrModuleId(a),[],null,null,null),o._onLoad(a);return}E.record(10,D),o._scriptLoader.load(o,D,function(){o._config.isBuild()&&(o._buildInfoPath[a]=D),E.record(11,D),o._onLoad(a)},function(L){E.record(12,D),e(L)})}};e(null)}},m.prototype._loadPluginDependency=function(a,o){var p=this;if(!(this._modules2[o.id]||this._knownModules2[o.id])){this._knownModules2[o.id]=!0;var y=function(w){p.defineModule(p._moduleIdProvider.getStrModuleId(o.id),[],w,null,null)};y.error=function(w){p._config.onError(p._createLoadError(o.id,w))},a.load(o.pluginParam,this._createRequire(t.ROOT),y,this._config.getOptionsLiteral())}},m.prototype._resolve=function(a){var o=this,p=a.dependencies;if(p)for(var y=0,w=p.length;y<w;y++){var v=p[y];if(v===F.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(v===F.MODULE){a.unresolvedDependenciesCount--;continue}if(v===F.REQUIRE){a.unresolvedDependenciesCount--;continue}var e=this._modules2[v.id];if(e&&e.isComplete()){if(e.error){a.onDependencyError(e.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(v.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(v.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");var A=this._findCyclePath(v.id,a.id,0)||[];A.reverse(),A.push(v.id),console.warn(A.map(function(L){return o._moduleIdProvider.getStrModuleId(L)}).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[v.id]=this._inverseDependencies2[v.id]||[],this._inverseDependencies2[v.id].push(a.id),v instanceof n){var D=this._modules2[v.pluginId];if(D&&D.isComplete()){this._loadPluginDependency(D.exports,v);continue}var E=this._inversePluginDependencies2.get(v.pluginId);E||(E=[],this._inversePluginDependencies2.set(v.pluginId,E)),E.push(v),this._loadModule(v.pluginId);continue}this._loadModule(v.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)},m.prototype._onModuleComplete=function(a){var o=this,p=this.getRecorder();if(!a.isComplete()){var y=a.dependencies,w=[];if(y)for(var v=0,e=y.length;v<e;v++){var A=y[v];if(A===F.EXPORTS){w[v]=a.exports;continue}if(A===F.MODULE){w[v]={id:a.strId,config:function(){return o._config.getConfigForModule(a.strId)}};continue}if(A===F.REQUIRE){w[v]=this._createRequire(a.moduleIdResolver);continue}var D=this._modules2[A.id];if(D){w[v]=D.exports;continue}w[v]=null}var E=function(r){return(o._inverseDependencies2[r]||[]).map(function(s){return o._moduleIdProvider.getStrModuleId(s)})};a.complete(p,this._config,w,E);var L=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,L)for(var v=0,e=L.length;v<e;v++){var h=L[v],g=this._modules2[h];g.unresolvedDependenciesCount--,g.unresolvedDependenciesCount===0&&this._onModuleComplete(g)}var l=this._inversePluginDependencies2.get(a.id);if(l){this._inversePluginDependencies2.delete(a.id);for(var v=0,e=l.length;v<e;v++)this._loadPluginDependency(a.exports,l[v])}}},m}();q.ModuleManager=_})(ue||(ue={}));var Q,ue;(function(q){var t=new q.Environment,M=null,S=function(m,a,o){typeof m!="string"&&(o=a,a=m,m=null),(typeof a!="object"||!Array.isArray(a))&&(o=a,a=null),a||(a=["require","exports","module"]),m?M.defineModule(m,a,o,null,null):M.enqueueDefineAnonymousModule(a,o)};S.amd={jQuery:!0};var F=function(m,a){a===void 0&&(a=!1),M.configure(m,a)},n=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){F(arguments[0]);return}if(typeof arguments[0]=="string")return M.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){M.defineModule(q.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};n.config=F,n.getConfig=function(){return M.getConfig().getOptionsLiteral()},n.reset=function(){M=M.reset()},n.getBuildInfo=function(){return M.getBuildInfo()},n.getStats=function(){return M.getLoaderEvents()},n.define=S;function _(){if(typeof q.global.require<"u"||typeof require<"u"){var m=q.global.require||require;if(typeof m=="function"&&typeof m.resolve=="function"){var a=q.ensureRecordedNodeRequire(M.getRecorder(),m);q.global.nodeRequire=a,n.nodeRequire=a,n.__$__nodeRequire=a}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=n:(t.isElectronRenderer||(q.global.define=S),q.global.require=n)}q.init=_,(typeof q.global.define!="function"||!q.global.define.amd)&&(M=new q.ModuleManager(t,q.createScriptLoader(t),S,n,q.Utilities.getHighPerformanceTimestamp()),typeof q.global.require<"u"&&typeof q.global.require!="function"&&n.config(q.global.require),Q=function(){return S.apply(null,arguments)},Q.amd=S.amd,typeof doNotInitLoader>"u"&&_())})(ue||(ue={})),Q(J[54],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function M(m,a,o,p){if(p=p||{},(p["vs/css"]||{}).disabled){o({});return}const w=a.toUrl(m+".css");S(m,w,()=>{o({})},v=>{typeof o.error=="function"&&o.error("Could not find "+w+".")})}t.load=M;function S(m,a,o,p){if(F(m,a)){o();return}n(m,a,o,p)}function F(m,a){const o=document.getElementsByTagName("link");for(let p=0,y=o.length;p<y;p++){const w=o[p].getAttribute("data-name"),v=o[p].getAttribute("href");if(w===m||v===a)return!0}return!1}function n(m,a,o,p){const y=document.createElement("link");y.setAttribute("rel","stylesheet"),y.setAttribute("type","text/css"),y.setAttribute("data-name",m),_(m,y,o,p),y.setAttribute("href",a),(document.head||document.getElementsByTagName("head")[0]).appendChild(y)}function _(m,a,o,p){const y=()=>{a.removeEventListener("load",w),a.removeEventListener("error",v)},w=e=>{y(),o()},v=e=>{y(),p(e)};a.addEventListener("load",w),a.addEventListener("error",v)}}),Q("vs/nls",["require","exports"],function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize=void 0;let M=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const S="i-default";function F(e,A){let D;return A.length===0?D=e:D=e.replace(/\{(\d+)\}/g,(E,L)=>{const h=L[0],g=A[h];let l=E;return typeof g=="string"?l=g:(typeof g=="number"||typeof g=="boolean"||g===void 0||g===null)&&(l=String(g)),l}),M&&(D="\uFF3B"+D.replace(/[aouei]/g,"$&$&")+"\uFF3D"),D}function n(e,A){let D=e[A];return D||(D=e["*"],D)?D:null}function _(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function m(e,A,D){const E=_(e)+_(A)+"vscode/"+_(D),L=await fetch(E);if(L.ok)return await L.json();throw new Error(`${L.status} - ${L.statusText}`)}function a(e){return function(A,D){const E=Array.prototype.slice.call(arguments,2);return F(e[A],E)}}function o(e,A,...D){return F(A,D)}t.localize=o;function p(e){}t.getConfiguredDefaultLocale=p;function y(e){M=e}t.setPseudoTranslation=y;function w(e,A){return{localize:a(A[e]),getConfiguredDefaultLocale:A.getConfiguredDefaultLocale??(D=>{})}}t.create=w;function v(e,A,D,E){const L=E["vs/nls"]??{};if(!e||e.length===0)return D({localize:o,getConfiguredDefaultLocale:()=>L.availableLanguages?.["*"]});const h=L.availableLanguages?n(L.availableLanguages,e):null,g=h===null||h===S;let l=".nls";g||(l=l+"."+h);const r=s=>{Array.isArray(s)?s.localize=a(s):s.localize=a(s[e]),s.getConfiguredDefaultLocale=()=>L.availableLanguages?.["*"],D(s)};typeof L.loadBundle=="function"?L.loadBundle(e,h,(s,d)=>{s?A([e+".nls"],r):r(d)}):L.translationServiceUrl&&!g?(async()=>{try{const s=await m(L.translationServiceUrl,h,e);return r(s)}catch(s){if(!h.includes("-"))return console.error(s),A([e+".nls"],r);try{const d=h.split("-")[0],c=await m(L.translationServiceUrl,d,e);return L.availableLanguages??={},L.availableLanguages["*"]=d,r(c)}catch(d){return console.error(d),A([e+".nls"],r)}}})():A([e+l],r,s=>{if(l===".nls"){console.error("Failed trying to load default language strings",s);return}console.error(`Failed to load message bundle for language ${h}. Falling back to the default language:`,s),A([e+".nls"],r)})}t.load=v}),function(){const q=self.MonacoEnvironment,t=q&&q.baseUrl?q.baseUrl:"../../../",M=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:o=>o,createScript:(o,...p)=>{const y=p.slice(0,-1).join(","),w=p.pop().toString();return`(function anonymous(${y}) { ${w}
})`}}):void 0;function S(){try{return(M?self.eval(M.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}function F(){return new Promise((o,p)=>{if(typeof self.define=="function"&&self.define.amd)return o();const y=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(y)&&y.substring(0,self.origin.length)!==self.origin)&&S()){fetch(y).then(v=>{if(v.status!==200)throw new Error(v.statusText);return v.text()}).then(v=>{v=`${v}
//# sourceURL=${y}`,(M?self.eval(M.createScript("",v)):new Function(v)).call(self),o()}).then(void 0,p);return}M?importScripts(M.createScriptURL(y)):importScripts(y),o()})}function n(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:M,amdModulesPattern:/^vs\//})}function _(o){F().then(()=>{n(),require([o],function(p){setTimeout(function(){const y=p.create((w,v)=>{self.postMessage(w,v)},null);for(self.onmessage=w=>y.onmessage(w.data,w.ports);a.length>0;)self.onmessage(a.shift())},0)})})}typeof self.define=="function"&&self.define.amd&&n();let m=!0;const a=[];self.onmessage=o=>{if(!m){a.push(o);return}m=!1,_(o.data)}}(),Q(J[25],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class M{constructor(F,n,_,m){this.originalStart=F,this.originalLength=n,this.modifiedStart=_,this.modifiedLength=m}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=M}),Q(J[6],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class M{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?h.isErrorNoTelemetry(r)?new h(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(s=>{s(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}t.ErrorHandler=M,t.errorHandler=new M;function S(l){t.errorHandler.setUnexpectedErrorHandler(l)}t.setUnexpectedErrorHandler=S;function F(l){a(l)||t.errorHandler.onUnexpectedError(l)}t.onUnexpectedError=F;function n(l){a(l)||t.errorHandler.onUnexpectedExternalError(l)}t.onUnexpectedExternalError=n;function _(l){if(l instanceof Error){const{name:r,message:s}=l,d=l.stacktrace||l.stack;return{$isError:!0,name:r,message:s,stack:d,noTelemetry:h.isErrorNoTelemetry(l)}}return l}t.transformErrorForSerialization=_;const m="Canceled";function a(l){return l instanceof o?!0:l instanceof Error&&l.name===m&&l.message===m}t.isCancellationError=a;class o extends Error{constructor(){super(m),this.name=this.message}}t.CancellationError=o;function p(){const l=new Error(m);return l.name=l.message,l}t.canceled=p;function y(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}t.illegalArgument=y;function w(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}t.illegalState=w;function v(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=v;function e(l){const r=new Error(`${l} has been disposed`);return r.name="DISPOSED",r}t.disposed=e;function A(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}t.getErrorMessage=A;class D extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}t.NotImplementedError=D;class E extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}t.NotSupportedError=E;class L extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=L;class h extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof h)return r;const s=new h;return s.message=r.message,s.stack=r.stack,s}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}t.ErrorNoTelemetry=h;class g extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype);debugger}}t.BugIndicatingError=g}),Q(J[26],K([0,1,6]),function(q,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function S(k,I=0){return k[k.length-(1+I)]}t.tail=S;function F(k){if(k.length===0)throw new Error("Invalid tail call");return[k.slice(0,k.length-1),k[k.length-1]]}t.tail2=F;function n(k,I,U=(W,j)=>W===j){if(k===I)return!0;if(!k||!I||k.length!==I.length)return!1;for(let W=0,j=k.length;W<j;W++)if(!U(k[W],I[W]))return!1;return!0}t.equals=n;function _(k,I){const U=k.length-1;I<U&&(k[I]=k[U]),k.pop()}t.removeFastWithoutKeepingOrder=_;function m(k,I,U){return a(k.length,W=>U(k[W],I))}t.binarySearch=m;function a(k,I){let U=0,W=k-1;for(;U<=W;){const j=(U+W)/2|0,ie=I(j);if(ie<0)U=j+1;else if(ie>0)W=j-1;else return j}return-(U+1)}t.binarySearch2=a;function o(k,I){let U=0,W=k.length;if(W===0)return 0;for(;U<W;){const j=Math.floor((U+W)/2);I(k[j])?W=j:U=j+1}return U}t.findFirstInSorted=o;function p(k,I,U){if(k=k|0,k>=I.length)throw new TypeError("invalid index");const W=I[Math.floor(I.length*Math.random())],j=[],ie=[],re=[];for(const oe of I){const ae=U(oe,W);ae<0?j.push(oe):ae>0?ie.push(oe):re.push(oe)}return k<j.length?p(k,j,U):k<j.length+re.length?re[0]:p(k-(j.length+re.length),ie,U)}t.quickSelect=p;function y(k,I){const U=[];let W;for(const j of k.slice(0).sort(I))!W||I(W[0],j)!==0?(W=[j],U.push(W)):W.push(j);return U}t.groupBy=y;function w(k,I,U){const W=[];function j(oe,ae,fe){if(ae===0&&fe.length===0)return;const he=W[W.length-1];he&&he.start+he.deleteCount===oe?(he.deleteCount+=ae,he.toInsert.push(...fe)):W.push({start:oe,deleteCount:ae,toInsert:fe})}let ie=0,re=0;for(;;){if(ie===k.length){j(ie,0,I.slice(re));break}if(re===I.length){j(ie,k.length-ie,[]);break}const oe=k[ie],ae=I[re],fe=U(oe,ae);fe===0?(ie+=1,re+=1):fe<0?(j(ie,1,[]),ie+=1):fe>0&&(j(ie,0,[ae]),re+=1)}return W}t.sortedDiff=w;function v(k,I,U){const W=w(k,I,U),j=[],ie=[];for(const re of W)j.push(...k.slice(re.start,re.start+re.deleteCount)),ie.push(...re.toInsert);return{removed:j,added:ie}}t.delta=v;function e(k,I,U){if(U===0)return[];const W=k.slice(0,U).sort(I);return D(k,I,W,U,k.length),W}t.top=e;function A(k,I,U,W,j){return U===0?Promise.resolve([]):new Promise((ie,re)=>{(async()=>{const oe=k.length,ae=k.slice(0,U).sort(I);for(let fe=U,he=Math.min(U+W,oe);fe<oe;fe=he,he=Math.min(he+W,oe)){if(fe>U&&await new Promise(Se=>setTimeout(Se)),j&&j.isCancellationRequested)throw new M.CancellationError;D(k,I,ae,fe,he)}return ae})().then(ie,re)})}t.topAsync=A;function D(k,I,U,W,j){for(const ie=U.length;W<j;W++){const re=k[W];if(I(re,U[ie-1])<0){U.pop();const oe=o(U,ae=>I(re,ae)<0);U.splice(oe,0,re)}}}function E(k){return k.filter(I=>!!I)}t.coalesce=E;function L(k){let I=0;for(let U=0;U<k.length;U++)k[U]&&(k[I]=k[U],I+=1);k.length=I}t.coalesceInPlace=L;function h(k,I,U){k.splice(U,0,k.splice(I,1)[0])}t.move=h;function g(k){return!Array.isArray(k)||k.length===0}t.isFalsyOrEmpty=g;function l(k){return Array.isArray(k)&&k.length>0}t.isNonEmptyArray=l;function r(k,I=U=>U){const U=new Set;return k.filter(W=>{const j=I(W);return U.has(j)?!1:(U.add(j),!0)})}t.distinct=r;function s(k){const I=new Set;return U=>{const W=k(U);return I.has(W)?!1:(I.add(W),!0)}}t.uniqueFilter=s;function d(k,I){const U=c(k,I);if(U!==-1)return k[U]}t.findLast=d;function c(k,I){for(let U=k.length-1;U>=0;U--){const W=k[U];if(I(W))return U}return-1}t.lastIndex=c;function N(k,I){return k.length>0?k[0]:I}t.firstOrDefault=N;function b(k,I){return k.length>0?k[k.length-1]:I}t.lastOrDefault=b;function f(k,I,U=(W,j)=>W===j){let W=0;for(let j=0,ie=Math.min(k.length,I.length);j<ie&&U(k[j],I[j]);j++)W++;return W}t.commonPrefixLength=f;function u(k){return[].concat(...k)}t.flatten=u;function R(k,I){let U=typeof I=="number"?k:0;typeof I=="number"?U=k:(U=0,I=k);const W=[];if(U<=I)for(let j=U;j<I;j++)W.push(j);else for(let j=U;j>I;j--)W.push(j);return W}t.range=R;function T(k,I,U){return k.reduce((W,j)=>(W[I(j)]=U?U(j):j,W),Object.create(null))}t.index=T;function O(k,I){return k.push(I),()=>C(k,I)}t.insert=O;function C(k,I){const U=k.indexOf(I);if(U>-1)return k.splice(U,1),I}t.remove=C;function H(k,I,U){const W=k.slice(0,I),j=k.slice(I);return W.concat(U,j)}t.arrayInsert=H;function z(k,I){let U;if(typeof I=="number"){let W=I;U=()=>{const j=Math.sin(W++)*179426549;return j-Math.floor(j)}}else U=Math.random;for(let W=k.length-1;W>0;W-=1){const j=Math.floor(U()*(W+1)),ie=k[W];k[W]=k[j],k[j]=ie}}t.shuffle=z;function ee(k,I){const U=k.indexOf(I);U>-1&&(k.splice(U,1),k.unshift(I))}t.pushToStart=ee;function ne(k,I){const U=k.indexOf(I);U>-1&&(k.splice(U,1),k.push(I))}t.pushToEnd=ne;function Y(k,I){for(const U of I)k.push(U)}t.pushMany=Y;function Z(k,I){return Array.isArray(k)?k.map(I):I(k)}t.mapArrayOrNot=Z;function i(k){return Array.isArray(k)?k:[k]}t.asArray=i;function Le(k){return k[Math.floor(Math.random()*k.length)]}t.getRandomElement=Le;function Ae(k,I){for(const U of k){const W=I(U);if(W!==void 0)return W}}t.mapFind=Ae;function de(k,I,U){const W=we(k,I),j=k.length,ie=U.length;k.length=j+ie;for(let re=j-1;re>=W;re--)k[re+ie]=k[re];for(let re=0;re<ie;re++)k[re+W]=U[re]}t.insertInto=de;function Ee(k,I,U,W){const j=we(k,I),ie=k.splice(j,U);return de(k,j,W),ie}t.splice=Ee;function we(k,I){return I<0?Math.max(I+k.length,0):Math.min(I,k.length)}var Ne;(function(k){function I(j){return j<0}k.isLessThan=I;function U(j){return j>0}k.isGreaterThan=U;function W(j){return j===0}k.isNeitherLessOrGreaterThan=W,k.greaterThan=1,k.lessThan=-1,k.neitherLessOrGreaterThan=0})(Ne=t.CompareResult||(t.CompareResult={}));function Re(k,I){return(U,W)=>I(k(U),k(W))}t.compareBy=Re;function De(...k){return(I,U)=>{for(const W of k){const j=W(I,U);if(!Ne.isNeitherLessOrGreaterThan(j))return j}return Ne.neitherLessOrGreaterThan}}t.tieBreakComparators=De;const Fe=(k,I)=>k-I;t.numberComparator=Fe;function _e(k,I){if(k.length===0)return;let U=k[0];for(let W=1;W<k.length;W++){const j=k[W];I(j,U)>0&&(U=j)}return U}t.findMaxBy=_e;function Pe(k,I){if(k.length===0)return;let U=k[0];for(let W=1;W<k.length;W++){const j=k[W];I(j,U)>=0&&(U=j)}return U}t.findLastMaxBy=Pe;function te(k,I){return _e(k,(U,W)=>-I(U,W))}t.findMinBy=te;class G{constructor(I){this.f=I,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(I){let U=this.c;for(;U<this.f.length&&I(this.f[U]);)U++;const W=U===this.c?null:this.f.slice(this.c,U);return this.c=U,W}takeFromEndWhile(I){let U=this.d;for(;U>=0&&I(this.f[U]);)U--;const W=U===this.d?null:this.f.slice(U+1,this.d+1);return this.d=U,W}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const I=this.f[this.c];return this.c++,I}removeLast(){const I=this.f[this.d];return this.d--,I}takeCount(I){const U=this.f.slice(this.c,this.c+I);return this.c+=I,U}}t.ArrayQueue=G;class X{constructor(I){this.iterate=I}forEach(I){this.iterate(U=>(I(U),!0))}toArray(){const I=[];return this.iterate(U=>(I.push(U),!0)),I}filter(I){return new X(U=>this.iterate(W=>I(W)?U(W):!0))}map(I){return new X(U=>this.iterate(W=>U(I(W))))}some(I){let U=!1;return this.iterate(W=>(U=I(W),!U)),U}findFirst(I){let U;return this.iterate(W=>I(W)?(U=W,!1):!0),U}findLast(I){let U;return this.iterate(W=>(I(W)&&(U=W),!0)),U}findLastMaxBy(I){let U,W=!0;return this.iterate(j=>((W||Ne.isGreaterThan(I(j,U)))&&(W=!1,U=j),!0)),U}}t.CallbackIterable=X,X.empty=new X(k=>{})}),Q(J[10],K([0,1,6]),function(q,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function S(a,o){if(!a)throw new Error(o?`Assertion failed (${o})`:"Assertion Failed")}t.ok=S;function F(a,o="Unreachable"){throw new Error(o)}t.assertNever=F;function n(a){if(!a)throw new M.BugIndicatingError("Assertion Failed")}t.assert=n;function _(a){if(!a()){debugger;a(),(0,M.onUnexpectedError)(new M.BugIndicatingError("Assertion Failed"))}}t.assertFn=_;function m(a,o){let p=0;for(;p<a.length-1;){const y=a[p],w=a[p+1];if(!o(y,w))return!1;p++}return!0}t.checkAdjacentItems=m}),Q(J[13],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function M(S){const F=this;let n=!1,_;return function(){return n||(n=!0,_=S.apply(F,arguments)),_}}t.once=M}),Q(J[14],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var M;(function(S){function F(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}S.is=F;const n=Object.freeze([]);function _(){return n}S.empty=_;function*m(g){yield g}S.single=m;function a(g){return F(g)?g:m(g)}S.wrap=a;function o(g){return g||n}S.from=o;function p(g){return!g||g[Symbol.iterator]().next().done===!0}S.isEmpty=p;function y(g){return g[Symbol.iterator]().next().value}S.first=y;function w(g,l){for(const r of g)if(l(r))return!0;return!1}S.some=w;function v(g,l){for(const r of g)if(l(r))return r}S.find=v;function*e(g,l){for(const r of g)l(r)&&(yield r)}S.filter=e;function*A(g,l){let r=0;for(const s of g)yield l(s,r++)}S.map=A;function*D(...g){for(const l of g)for(const r of l)yield r}S.concat=D;function E(g,l,r){let s=r;for(const d of g)s=l(s,d);return s}S.reduce=E;function*L(g,l,r=g.length){for(l<0&&(l+=g.length),r<0?r+=g.length:r>g.length&&(r=g.length);l<r;l++)yield g[l]}S.slice=L;function h(g,l=Number.POSITIVE_INFINITY){const r=[];if(l===0)return[r,g];const s=g[Symbol.iterator]();for(let d=0;d<l;d++){const c=s.next();if(c.done)return[r,S.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return s}}]}S.consume=h})(M=t.Iterable||(t.Iterable={}))}),Q(J[27],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var M;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(M=t.KeyCode||(t.KeyCode={}));var S;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(S=t.ScanCode||(t.ScanCode={}));class F{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(A,D){this._keyCodeToStr[A]=D,this._strToKeyCode[D.toLowerCase()]=A}keyCodeToStr(A){return this._keyCodeToStr[A]}strToKeyCode(A){return this._strToKeyCode[A.toLowerCase()]||0}}const n=new F,_=new F,m=new F;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const a=[],o=Object.create(null),p=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>p[e]||0,toEnum:e=>o[e]||0,toString:e=>a[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",A=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],D=[],E=[];for(const L of A){const[h,g,l,r,s,d,c,N,b,f]=L;if(E[l]||(E[l]=!0,a[l]=r,o[r]=l,p[r.toLowerCase()]=l,g&&(t.IMMUTABLE_CODE_TO_KEY_CODE[l]=s,s!==0&&s!==3&&s!==5&&s!==4&&s!==6&&s!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[s]=l))),!D[s]){if(D[s]=!0,!d)throw new Error(`String representation missing for key code ${s} around scan code ${r}`);n.define(s,d),_.define(s,b||d),m.define(s,f||b||d)}c&&(t.EVENT_KEY_CODE_MAP[c]=s),N&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[N]=s)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var y;(function(e){function A(l){return n.keyCodeToStr(l)}e.toString=A;function D(l){return n.strToKeyCode(l)}e.fromString=D;function E(l){return _.keyCodeToStr(l)}e.toUserSettingsUS=E;function L(l){return m.keyCodeToStr(l)}e.toUserSettingsGeneral=L;function h(l){return _.strToKeyCode(l)||m.strToKeyCode(l)}e.fromUserSettings=h;function g(l){if(l>=93&&l<=108)return null;switch(l){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return n.keyCodeToStr(l)}e.toElectronAccelerator=g})(y=t.KeyCodeUtils||(t.KeyCodeUtils={}));var w;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(w=t.KeyMod||(t.KeyMod={}));function v(e,A){const D=(A&65535)<<16>>>0;return(e|D)>>>0}t.KeyChord=v}),Q(J[28],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class M{constructor(F){this.d=F,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(F){this.c=F}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.Lazy=M}),Q(J[7],K([0,1,13,14]),function(q,t,M,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const F=!1;let n=null;function _(b){n=b}if(t.setDisposableTracker=_,F){const b="__is_disposable_tracked__";_(new class{trackDisposable(f){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{f[b]||console.log(u)},3e3)}setParent(f,u){if(f&&f!==L.None)try{f[b]=!0}catch{}}markAsDisposed(f){if(f&&f!==L.None)try{f[b]=!0}catch{}}markAsSingleton(f){}})}function m(b){return n?.trackDisposable(b),b}function a(b){n?.markAsDisposed(b)}function o(b,f){n?.setParent(b,f)}function p(b,f){if(!!n)for(const u of b)n.setParent(u,f)}function y(b){return n?.markAsSingleton(b),b}t.markAsSingleton=y;function w(b){return typeof b.dispose=="function"&&b.dispose.length===0}t.isDisposable=w;function v(b){if(S.Iterable.is(b)){const f=[];for(const u of b)if(u)try{u.dispose()}catch(R){f.push(R)}if(f.length===1)throw f[0];if(f.length>1)throw new AggregateError(f,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}t.dispose=v;function e(b){for(const f of b)w(f)&&f.dispose();return[]}t.disposeIfDisposable=e;function A(...b){const f=D(()=>v(b));return p(b,f),f}t.combinedDisposable=A;function D(b){const f=m({dispose:(0,M.once)(()=>{a(f),b()})});return f}t.toDisposable=D;class E{constructor(){this.c=new Set,this.f=!1,m(this)}dispose(){this.f||(a(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{v(this.c)}finally{this.c.clear()}}add(f){if(!f)return f;if(f===this)throw new Error("Cannot register a disposable on itself!");return o(f,this),this.f?E.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(f),f}}t.DisposableStore=E,E.DISABLE_DISPOSED_WARNING=!1;class L{constructor(){this.q=new E,m(this),o(this.q,this)}dispose(){a(this),this.q.dispose()}B(f){if(f===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(f)}}t.Disposable=L,L.None=Object.freeze({dispose(){}});class h{constructor(){this.b=!1,m(this)}get value(){return this.b?void 0:this.a}set value(f){this.b||f===this.a||(this.a?.dispose(),f&&o(f,this),this.a=f)}clear(){this.value=void 0}dispose(){this.b=!0,a(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const f=this.a;return this.a=void 0,f&&o(f,null),f}}t.MutableDisposable=h;class g{constructor(f){this.b=f,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.RefCountedDisposable=g;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,m(this)}set(f){let u=f;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,a(this))},this}}t.SafeDisposable=l;class r{constructor(){this.a=new Map}acquire(f,...u){let R=this.a.get(f);R||(R={counter:0,object:this.b(f,...u)},this.a.set(f,R));const{object:T}=R,O=(0,M.once)(()=>{--R.counter===0&&(this.c(f,R.object),this.a.delete(f))});return R.counter++,{object:T,dispose:O}}}t.ReferenceCollection=r;class s{constructor(f){this.a=f}async acquire(f,...u){const R=this.a.acquire(f,...u);try{return{object:await R.object,dispose:()=>R.dispose()}}catch(T){throw R.dispose(),T}}}t.AsyncReferenceCollection=s;class d{constructor(f){this.object=f}dispose(){}}t.ImmortalReference=d;function c(b){const f=new E;try{b(f)}finally{f.dispose()}}t.disposeOnReturn=c;class N{constructor(){this.a=new Map,this.b=!1,m(this)}dispose(){a(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{v(this.a.values())}finally{this.a.clear()}}has(f){return this.a.has(f)}get(f){return this.a.get(f)}set(f,u,R=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),R||this.a.get(f)?.dispose(),this.a.set(f,u)}deleteAndDispose(f){this.a.get(f)?.dispose(),this.a.delete(f)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.DisposableMap=N}),Q(J[15],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class M{constructor(n){this.element=n,this.next=M.Undefined,this.prev=M.Undefined}}M.Undefined=new M(void 0);class S{constructor(){this.a=M.Undefined,this.b=M.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===M.Undefined}clear(){let n=this.a;for(;n!==M.Undefined;){const _=n.next;n.prev=M.Undefined,n.next=M.Undefined,n=_}this.a=M.Undefined,this.b=M.Undefined,this.c=0}unshift(n){return this.d(n,!1)}push(n){return this.d(n,!0)}d(n,_){const m=new M(n);if(this.a===M.Undefined)this.a=m,this.b=m;else if(_){const o=this.b;this.b=m,m.prev=o,o.next=m}else{const o=this.a;this.a=m,m.next=o,o.prev=m}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(m))}}shift(){if(this.a!==M.Undefined){const n=this.a.element;return this.e(this.a),n}}pop(){if(this.b!==M.Undefined){const n=this.b.element;return this.e(this.b),n}}e(n){if(n.prev!==M.Undefined&&n.next!==M.Undefined){const _=n.prev;_.next=n.next,n.next.prev=_}else n.prev===M.Undefined&&n.next===M.Undefined?(this.a=M.Undefined,this.b=M.Undefined):n.next===M.Undefined?(this.b=this.b.prev,this.b.next=M.Undefined):n.prev===M.Undefined&&(this.a=this.a.next,this.a.prev=M.Undefined);this.c-=1}*[Symbol.iterator](){let n=this.a;for(;n!==M.Undefined;)yield n.element,n=n.next}}t.LinkedList=S}),Q(J[16],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function M(s){return typeof s=="string"}t.isString=M;function S(s){return Array.isArray(s)&&s.every(d=>M(d))}t.isStringArray=S;function F(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}t.isObject=F;function n(s){const d=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof d}t.isTypedArray=n;function _(s){return typeof s=="number"&&!isNaN(s)}t.isNumber=_;function m(s){return!!s&&typeof s[Symbol.iterator]=="function"}t.isIterable=m;function a(s){return s===!0||s===!1}t.isBoolean=a;function o(s){return typeof s>"u"}t.isUndefined=o;function p(s){return!y(s)}t.isDefined=p;function y(s){return o(s)||s===null}t.isUndefinedOrNull=y;function w(s,d){if(!s)throw new Error(d?`Unexpected type, expected '${d}'`:"Unexpected type")}t.assertType=w;function v(s){if(y(s))throw new Error("Assertion Failed: argument is undefined or null");return s}t.assertIsDefined=v;function e(...s){const d=[];for(let c=0;c<s.length;c++){const N=s[c];if(y(N))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);d.push(N)}return d}t.assertAllDefined=e;const A=Object.prototype.hasOwnProperty;function D(s){if(!F(s))return!1;for(const d in s)if(A.call(s,d))return!1;return!0}t.isEmptyObject=D;function E(s){return typeof s=="function"}t.isFunction=E;function L(...s){return s.length>0&&s.every(E)}t.areFunctions=L;function h(s,d){const c=Math.min(s.length,d.length);for(let N=0;N<c;N++)g(s[N],d[N])}t.validateConstraints=h;function g(s,d){if(M(d)){if(typeof s!==d)throw new Error(`argument does not match constraint: typeof ${d}`)}else if(E(d)){try{if(s instanceof d)return}catch{}if(!y(s)&&s.constructor===d||d.length===1&&d.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=g;function l(s){return s===null?void 0:s}t.withNullAsUndefined=l;function r(s){return typeof s>"u"?null:s}t.withUndefinedAsNull=r}),Q(J[29],K([0,1,16]),function(q,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.getAllCodicons=t.getCodiconFontCharacters=t.getCodiconAriaLabel=void 0;function S(a){return a?a.replace(/\$\((.*?)\)/g,(o,p)=>` ${p} `).trim():""}t.getCodiconAriaLabel=S;const F=Object.create(null);function n(a,o){if((0,M.isString)(o)){const p=F[o];if(p===void 0)throw new Error(`${a} references an unknown codicon: ${o}`);o=p}return F[a]=o,{id:a}}function _(){return F}t.getCodiconFontCharacters=_;function m(){return Object.values(t.Codicon)}t.getAllCodicons=m,t.Codicon={add:n("add",6e4),plus:n("plus",6e4),gistNew:n("gist-new",6e4),repoCreate:n("repo-create",6e4),lightbulb:n("lightbulb",60001),lightBulb:n("light-bulb",60001),repo:n("repo",60002),repoDelete:n("repo-delete",60002),gistFork:n("gist-fork",60003),repoForked:n("repo-forked",60003),gitPullRequest:n("git-pull-request",60004),gitPullRequestAbandoned:n("git-pull-request-abandoned",60004),recordKeys:n("record-keys",60005),keyboard:n("keyboard",60005),tag:n("tag",60006),tagAdd:n("tag-add",60006),tagRemove:n("tag-remove",60006),person:n("person",60007),personFollow:n("person-follow",60007),personOutline:n("person-outline",60007),personFilled:n("person-filled",60007),gitBranch:n("git-branch",60008),gitBranchCreate:n("git-branch-create",60008),gitBranchDelete:n("git-branch-delete",60008),sourceControl:n("source-control",60008),mirror:n("mirror",60009),mirrorPublic:n("mirror-public",60009),star:n("star",60010),starAdd:n("star-add",60010),starDelete:n("star-delete",60010),starEmpty:n("star-empty",60010),comment:n("comment",60011),commentAdd:n("comment-add",60011),alert:n("alert",60012),warning:n("warning",60012),search:n("search",60013),searchSave:n("search-save",60013),logOut:n("log-out",60014),signOut:n("sign-out",60014),logIn:n("log-in",60015),signIn:n("sign-in",60015),eye:n("eye",60016),eyeUnwatch:n("eye-unwatch",60016),eyeWatch:n("eye-watch",60016),circleFilled:n("circle-filled",60017),primitiveDot:n("primitive-dot",60017),closeDirty:n("close-dirty",60017),debugBreakpoint:n("debug-breakpoint",60017),debugBreakpointDisabled:n("debug-breakpoint-disabled",60017),debugHint:n("debug-hint",60017),primitiveSquare:n("primitive-square",60018),edit:n("edit",60019),pencil:n("pencil",60019),info:n("info",60020),issueOpened:n("issue-opened",60020),gistPrivate:n("gist-private",60021),gitForkPrivate:n("git-fork-private",60021),lock:n("lock",60021),mirrorPrivate:n("mirror-private",60021),close:n("close",60022),removeClose:n("remove-close",60022),x:n("x",60022),repoSync:n("repo-sync",60023),sync:n("sync",60023),clone:n("clone",60024),desktopDownload:n("desktop-download",60024),beaker:n("beaker",60025),microscope:n("microscope",60025),vm:n("vm",60026),deviceDesktop:n("device-desktop",60026),file:n("file",60027),fileText:n("file-text",60027),more:n("more",60028),ellipsis:n("ellipsis",60028),kebabHorizontal:n("kebab-horizontal",60028),mailReply:n("mail-reply",60029),reply:n("reply",60029),organization:n("organization",60030),organizationFilled:n("organization-filled",60030),organizationOutline:n("organization-outline",60030),newFile:n("new-file",60031),fileAdd:n("file-add",60031),newFolder:n("new-folder",60032),fileDirectoryCreate:n("file-directory-create",60032),trash:n("trash",60033),trashcan:n("trashcan",60033),history:n("history",60034),clock:n("clock",60034),folder:n("folder",60035),fileDirectory:n("file-directory",60035),symbolFolder:n("symbol-folder",60035),logoGithub:n("logo-github",60036),markGithub:n("mark-github",60036),github:n("github",60036),terminal:n("terminal",60037),console:n("console",60037),repl:n("repl",60037),zap:n("zap",60038),symbolEvent:n("symbol-event",60038),error:n("error",60039),stop:n("stop",60039),variable:n("variable",60040),symbolVariable:n("symbol-variable",60040),array:n("array",60042),symbolArray:n("symbol-array",60042),symbolModule:n("symbol-module",60043),symbolPackage:n("symbol-package",60043),symbolNamespace:n("symbol-namespace",60043),symbolObject:n("symbol-object",60043),symbolMethod:n("symbol-method",60044),symbolFunction:n("symbol-function",60044),symbolConstructor:n("symbol-constructor",60044),symbolBoolean:n("symbol-boolean",60047),symbolNull:n("symbol-null",60047),symbolNumeric:n("symbol-numeric",60048),symbolNumber:n("symbol-number",60048),symbolStructure:n("symbol-structure",60049),symbolStruct:n("symbol-struct",60049),symbolParameter:n("symbol-parameter",60050),symbolTypeParameter:n("symbol-type-parameter",60050),symbolKey:n("symbol-key",60051),symbolText:n("symbol-text",60051),symbolReference:n("symbol-reference",60052),goToFile:n("go-to-file",60052),symbolEnum:n("symbol-enum",60053),symbolValue:n("symbol-value",60053),symbolRuler:n("symbol-ruler",60054),symbolUnit:n("symbol-unit",60054),activateBreakpoints:n("activate-breakpoints",60055),archive:n("archive",60056),arrowBoth:n("arrow-both",60057),arrowDown:n("arrow-down",60058),arrowLeft:n("arrow-left",60059),arrowRight:n("arrow-right",60060),arrowSmallDown:n("arrow-small-down",60061),arrowSmallLeft:n("arrow-small-left",60062),arrowSmallRight:n("arrow-small-right",60063),arrowSmallUp:n("arrow-small-up",60064),arrowUp:n("arrow-up",60065),bell:n("bell",60066),bold:n("bold",60067),book:n("book",60068),bookmark:n("bookmark",60069),debugBreakpointConditionalUnverified:n("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:n("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:n("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:n("debug-breakpoint-data-unverified",60072),debugBreakpointData:n("debug-breakpoint-data",60073),debugBreakpointDataDisabled:n("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:n("debug-breakpoint-log-unverified",60074),debugBreakpointLog:n("debug-breakpoint-log",60075),debugBreakpointLogDisabled:n("debug-breakpoint-log-disabled",60075),briefcase:n("briefcase",60076),broadcast:n("broadcast",60077),browser:n("browser",60078),bug:n("bug",60079),calendar:n("calendar",60080),caseSensitive:n("case-sensitive",60081),check:n("check",60082),checklist:n("checklist",60083),chevronDown:n("chevron-down",60084),dropDownButton:n("drop-down-button",60084),chevronLeft:n("chevron-left",60085),chevronRight:n("chevron-right",60086),chevronUp:n("chevron-up",60087),chromeClose:n("chrome-close",60088),chromeMaximize:n("chrome-maximize",60089),chromeMinimize:n("chrome-minimize",60090),chromeRestore:n("chrome-restore",60091),circle:n("circle",60092),circleOutline:n("circle-outline",60092),debugBreakpointUnverified:n("debug-breakpoint-unverified",60092),circleSlash:n("circle-slash",60093),circuitBoard:n("circuit-board",60094),clearAll:n("clear-all",60095),clippy:n("clippy",60096),closeAll:n("close-all",60097),cloudDownload:n("cloud-download",60098),cloudUpload:n("cloud-upload",60099),code:n("code",60100),collapseAll:n("collapse-all",60101),colorMode:n("color-mode",60102),commentDiscussion:n("comment-discussion",60103),compareChanges:n("compare-changes",60157),creditCard:n("credit-card",60105),dash:n("dash",60108),dashboard:n("dashboard",60109),database:n("database",60110),debugContinue:n("debug-continue",60111),debugDisconnect:n("debug-disconnect",60112),debugPause:n("debug-pause",60113),debugRestart:n("debug-restart",60114),debugStart:n("debug-start",60115),debugStepInto:n("debug-step-into",60116),debugStepOut:n("debug-step-out",60117),debugStepOver:n("debug-step-over",60118),debugStop:n("debug-stop",60119),debug:n("debug",60120),deviceCameraVideo:n("device-camera-video",60121),deviceCamera:n("device-camera",60122),deviceMobile:n("device-mobile",60123),diffAdded:n("diff-added",60124),diffIgnored:n("diff-ignored",60125),diffModified:n("diff-modified",60126),diffRemoved:n("diff-removed",60127),diffRenamed:n("diff-renamed",60128),diff:n("diff",60129),discard:n("discard",60130),editorLayout:n("editor-layout",60131),emptyWindow:n("empty-window",60132),exclude:n("exclude",60133),extensions:n("extensions",60134),eyeClosed:n("eye-closed",60135),fileBinary:n("file-binary",60136),fileCode:n("file-code",60137),fileMedia:n("file-media",60138),filePdf:n("file-pdf",60139),fileSubmodule:n("file-submodule",60140),fileSymlinkDirectory:n("file-symlink-directory",60141),fileSymlinkFile:n("file-symlink-file",60142),fileZip:n("file-zip",60143),files:n("files",60144),filter:n("filter",60145),flame:n("flame",60146),foldDown:n("fold-down",60147),foldUp:n("fold-up",60148),fold:n("fold",60149),folderActive:n("folder-active",60150),folderOpened:n("folder-opened",60151),gear:n("gear",60152),gift:n("gift",60153),gistSecret:n("gist-secret",60154),gist:n("gist",60155),gitCommit:n("git-commit",60156),gitCompare:n("git-compare",60157),gitMerge:n("git-merge",60158),githubAction:n("github-action",60159),githubAlt:n("github-alt",60160),globe:n("globe",60161),grabber:n("grabber",60162),graph:n("graph",60163),gripper:n("gripper",60164),heart:n("heart",60165),home:n("home",60166),horizontalRule:n("horizontal-rule",60167),hubot:n("hubot",60168),inbox:n("inbox",60169),issueClosed:n("issue-closed",60324),issueReopened:n("issue-reopened",60171),issues:n("issues",60172),italic:n("italic",60173),jersey:n("jersey",60174),json:n("json",60175),kebabVertical:n("kebab-vertical",60176),key:n("key",60177),law:n("law",60178),lightbulbAutofix:n("lightbulb-autofix",60179),linkExternal:n("link-external",60180),link:n("link",60181),listOrdered:n("list-ordered",60182),listUnordered:n("list-unordered",60183),liveShare:n("live-share",60184),loading:n("loading",60185),location:n("location",60186),mailRead:n("mail-read",60187),mail:n("mail",60188),markdown:n("markdown",60189),megaphone:n("megaphone",60190),mention:n("mention",60191),milestone:n("milestone",60192),mortarBoard:n("mortar-board",60193),move:n("move",60194),multipleWindows:n("multiple-windows",60195),mute:n("mute",60196),noNewline:n("no-newline",60197),note:n("note",60198),octoface:n("octoface",60199),openPreview:n("open-preview",60200),package_:n("package",60201),paintcan:n("paintcan",60202),pin:n("pin",60203),play:n("play",60204),run:n("run",60204),plug:n("plug",60205),preserveCase:n("preserve-case",60206),preview:n("preview",60207),project:n("project",60208),pulse:n("pulse",60209),question:n("question",60210),quote:n("quote",60211),radioTower:n("radio-tower",60212),reactions:n("reactions",60213),references:n("references",60214),refresh:n("refresh",60215),regex:n("regex",60216),remoteExplorer:n("remote-explorer",60217),remote:n("remote",60218),remove:n("remove",60219),replaceAll:n("replace-all",60220),replace:n("replace",60221),repoClone:n("repo-clone",60222),repoForcePush:n("repo-force-push",60223),repoPull:n("repo-pull",60224),repoPush:n("repo-push",60225),report:n("report",60226),requestChanges:n("request-changes",60227),rocket:n("rocket",60228),rootFolderOpened:n("root-folder-opened",60229),rootFolder:n("root-folder",60230),rss:n("rss",60231),ruby:n("ruby",60232),saveAll:n("save-all",60233),saveAs:n("save-as",60234),save:n("save",60235),screenFull:n("screen-full",60236),screenNormal:n("screen-normal",60237),searchStop:n("search-stop",60238),server:n("server",60240),settingsGear:n("settings-gear",60241),settings:n("settings",60242),shield:n("shield",60243),smiley:n("smiley",60244),sortPrecedence:n("sort-precedence",60245),splitHorizontal:n("split-horizontal",60246),splitVertical:n("split-vertical",60247),squirrel:n("squirrel",60248),starFull:n("star-full",60249),starHalf:n("star-half",60250),symbolClass:n("symbol-class",60251),symbolColor:n("symbol-color",60252),symbolCustomColor:n("symbol-customcolor",60252),symbolConstant:n("symbol-constant",60253),symbolEnumMember:n("symbol-enum-member",60254),symbolField:n("symbol-field",60255),symbolFile:n("symbol-file",60256),symbolInterface:n("symbol-interface",60257),symbolKeyword:n("symbol-keyword",60258),symbolMisc:n("symbol-misc",60259),symbolOperator:n("symbol-operator",60260),symbolProperty:n("symbol-property",60261),wrench:n("wrench",60261),wrenchSubaction:n("wrench-subaction",60261),symbolSnippet:n("symbol-snippet",60262),tasklist:n("tasklist",60263),telescope:n("telescope",60264),textSize:n("text-size",60265),threeBars:n("three-bars",60266),thumbsdown:n("thumbsdown",60267),thumbsup:n("thumbsup",60268),tools:n("tools",60269),triangleDown:n("triangle-down",60270),triangleLeft:n("triangle-left",60271),triangleRight:n("triangle-right",60272),triangleUp:n("triangle-up",60273),twitter:n("twitter",60274),unfold:n("unfold",60275),unlock:n("unlock",60276),unmute:n("unmute",60277),unverified:n("unverified",60278),verified:n("verified",60279),versions:n("versions",60280),vmActive:n("vm-active",60281),vmOutline:n("vm-outline",60282),vmRunning:n("vm-running",60283),watch:n("watch",60284),whitespace:n("whitespace",60285),wholeWord:n("whole-word",60286),window:n("window",60287),wordWrap:n("word-wrap",60288),zoomIn:n("zoom-in",60289),zoomOut:n("zoom-out",60290),listFilter:n("list-filter",60291),listFlat:n("list-flat",60292),listSelection:n("list-selection",60293),selection:n("selection",60293),listTree:n("list-tree",60294),debugBreakpointFunctionUnverified:n("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:n("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:n("debug-breakpoint-function-disabled",60296),debugStackframeActive:n("debug-stackframe-active",60297),circleSmallFilled:n("circle-small-filled",60298),debugStackframeDot:n("debug-stackframe-dot",60298),debugStackframe:n("debug-stackframe",60299),debugStackframeFocused:n("debug-stackframe-focused",60299),debugBreakpointUnsupported:n("debug-breakpoint-unsupported",60300),symbolString:n("symbol-string",60301),debugReverseContinue:n("debug-reverse-continue",60302),debugStepBack:n("debug-step-back",60303),debugRestartFrame:n("debug-restart-frame",60304),callIncoming:n("call-incoming",60306),callOutgoing:n("call-outgoing",60307),menu:n("menu",60308),expandAll:n("expand-all",60309),feedback:n("feedback",60310),groupByRefType:n("group-by-ref-type",60311),ungroupByRefType:n("ungroup-by-ref-type",60312),account:n("account",60313),bellDot:n("bell-dot",60314),debugConsole:n("debug-console",60315),library:n("library",60316),output:n("output",60317),runAll:n("run-all",60318),syncIgnored:n("sync-ignored",60319),pinned:n("pinned",60320),githubInverted:n("github-inverted",60321),debugAlt:n("debug-alt",60305),serverProcess:n("server-process",60322),serverEnvironment:n("server-environment",60323),pass:n("pass",60324),stopCircle:n("stop-circle",60325),playCircle:n("play-circle",60326),record:n("record",60327),debugAltSmall:n("debug-alt-small",60328),vmConnect:n("vm-connect",60329),cloud:n("cloud",60330),merge:n("merge",60331),exportIcon:n("export",60332),graphLeft:n("graph-left",60333),magnet:n("magnet",60334),notebook:n("notebook",60335),redo:n("redo",60336),checkAll:n("check-all",60337),pinnedDirty:n("pinned-dirty",60338),passFilled:n("pass-filled",60339),circleLargeFilled:n("circle-large-filled",60340),circleLarge:n("circle-large",60341),circleLargeOutline:n("circle-large-outline",60341),combine:n("combine",60342),gather:n("gather",60342),table:n("table",60343),variableGroup:n("variable-group",60344),typeHierarchy:n("type-hierarchy",60345),typeHierarchySub:n("type-hierarchy-sub",60346),typeHierarchySuper:n("type-hierarchy-super",60347),gitPullRequestCreate:n("git-pull-request-create",60348),runAbove:n("run-above",60349),runBelow:n("run-below",60350),notebookTemplate:n("notebook-template",60351),debugRerun:n("debug-rerun",60352),workspaceTrusted:n("workspace-trusted",60353),workspaceUntrusted:n("workspace-untrusted",60354),workspaceUnspecified:n("workspace-unspecified",60355),terminalCmd:n("terminal-cmd",60356),terminalDebian:n("terminal-debian",60357),terminalLinux:n("terminal-linux",60358),terminalPowershell:n("terminal-powershell",60359),terminalTmux:n("terminal-tmux",60360),terminalUbuntu:n("terminal-ubuntu",60361),terminalBash:n("terminal-bash",60362),arrowSwap:n("arrow-swap",60363),copy:n("copy",60364),personAdd:n("person-add",60365),filterFilled:n("filter-filled",60366),wand:n("wand",60367),debugLineByLine:n("debug-line-by-line",60368),inspect:n("inspect",60369),layers:n("layers",60370),layersDot:n("layers-dot",60371),layersActive:n("layers-active",60372),compass:n("compass",60373),compassDot:n("compass-dot",60374),compassActive:n("compass-active",60375),azure:n("azure",60376),issueDraft:n("issue-draft",60377),gitPullRequestClosed:n("git-pull-request-closed",60378),gitPullRequestDraft:n("git-pull-request-draft",60379),debugAll:n("debug-all",60380),debugCoverage:n("debug-coverage",60381),runErrors:n("run-errors",60382),folderLibrary:n("folder-library",60383),debugContinueSmall:n("debug-continue-small",60384),beakerStop:n("beaker-stop",60385),graphLine:n("graph-line",60386),graphScatter:n("graph-scatter",60387),pieChart:n("pie-chart",60388),bracket:n("bracket",60388),bracketDot:n("bracket-dot",60389),bracketError:n("bracket-error",60390),lockSmall:n("lock-small",60391),azureDevops:n("azure-devops",60392),verifiedFilled:n("verified-filled",60393),newLine:n("newline",60394),layout:n("layout",60395),layoutActivitybarLeft:n("layout-activitybar-left",60396),layoutActivitybarRight:n("layout-activitybar-right",60397),layoutPanelLeft:n("layout-panel-left",60398),layoutPanelCenter:n("layout-panel-center",60399),layoutPanelJustify:n("layout-panel-justify",60400),layoutPanelRight:n("layout-panel-right",60401),layoutPanel:n("layout-panel",60402),layoutSidebarLeft:n("layout-sidebar-left",60403),layoutSidebarRight:n("layout-sidebar-right",60404),layoutStatusbar:n("layout-statusbar",60405),layoutMenubar:n("layout-menubar",60406),layoutCentered:n("layout-centered",60407),layoutSidebarRightOff:n("layout-sidebar-right-off",60416),layoutPanelOff:n("layout-panel-off",60417),layoutSidebarLeftOff:n("layout-sidebar-left-off",60418),target:n("target",60408),indent:n("indent",60409),recordSmall:n("record-small",60410),errorSmall:n("error-small",60411),arrowCircleDown:n("arrow-circle-down",60412),arrowCircleLeft:n("arrow-circle-left",60413),arrowCircleRight:n("arrow-circle-right",60414),arrowCircleUp:n("arrow-circle-up",60415),heartFilled:n("heart-filled",60420),map:n("map",60421),mapFilled:n("map-filled",60422),circleSmall:n("circle-small",60423),bellSlash:n("bell-slash",60424),bellSlashDot:n("bell-slash-dot",60425),commentUnresolved:n("comment-unresolved",60426),gitPullRequestGoToChanges:n("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:n("git-pull-request-new-changes",60428),searchFuzzy:n("search-fuzzy",60429),commentDraft:n("comment-draft",60430),dialogError:n("dialog-error","error"),dialogWarning:n("dialog-warning","warning"),dialogInfo:n("dialog-info","info"),dialogClose:n("dialog-close","close"),treeItemExpanded:n("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:n("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:n("tree-filter-on-type-off","list-selection"),treeFilterClear:n("tree-filter-clear","close"),treeItemLoading:n("tree-item-loading","loading"),menuSelection:n("menu-selection","check"),menuSubmenu:n("menu-submenu","chevron-right"),menuBarMore:n("menubar-more","more"),scrollbarButtonLeft:n("scrollbar-button-left","triangle-left"),scrollbarButtonRight:n("scrollbar-button-right","triangle-right"),scrollbarButtonUp:n("scrollbar-button-up","triangle-up"),scrollbarButtonDown:n("scrollbar-button-down","triangle-down"),toolBarMore:n("toolbar-more","more"),quickInputBack:n("quick-input-back","arrow-left")}}),Q(J[11],K([0,1,16]),function(q,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function S(E){if(!E||typeof E!="object"||E instanceof RegExp)return E;const L=Array.isArray(E)?[]:{};return Object.entries(E).forEach(([h,g])=>{L[h]=g&&typeof g=="object"?S(g):g}),L}t.deepClone=S;function F(E){if(!E||typeof E!="object")return E;const L=[E];for(;L.length>0;){const h=L.shift();Object.freeze(h);for(const g in h)if(n.call(h,g)){const l=h[g];typeof l=="object"&&!Object.isFrozen(l)&&!(0,M.isTypedArray)(l)&&L.push(l)}}return E}t.deepFreeze=F;const n=Object.prototype.hasOwnProperty;function _(E,L){return m(E,L,new Set)}t.cloneAndChange=_;function m(E,L,h){if((0,M.isUndefinedOrNull)(E))return E;const g=L(E);if(typeof g<"u")return g;if(Array.isArray(E)){const l=[];for(const r of E)l.push(m(r,L,h));return l}if((0,M.isObject)(E)){if(h.has(E))throw new Error("Cannot clone recursive data-structure");h.add(E);const l={};for(const r in E)n.call(E,r)&&(l[r]=m(E[r],L,h));return h.delete(E),l}return E}function a(E,L,h=!0){return(0,M.isObject)(E)?((0,M.isObject)(L)&&Object.keys(L).forEach(g=>{g in E?h&&((0,M.isObject)(E[g])&&(0,M.isObject)(L[g])?a(E[g],L[g],h):E[g]=L[g]):E[g]=L[g]}),E):L}t.mixin=a;function o(E,L){if(E===L)return!0;if(E==null||L===null||L===void 0||typeof E!=typeof L||typeof E!="object"||Array.isArray(E)!==Array.isArray(L))return!1;let h,g;if(Array.isArray(E)){if(E.length!==L.length)return!1;for(h=0;h<E.length;h++)if(!o(E[h],L[h]))return!1}else{const l=[];for(g in E)l.push(g);l.sort();const r=[];for(g in L)r.push(g);if(r.sort(),!o(l,r))return!1;for(h=0;h<l.length;h++)if(!o(E[l[h]],L[l[h]]))return!1}return!0}t.equals=o;function p(E){const L=new Set;return JSON.stringify(E,(h,g)=>{if((0,M.isObject)(g)||Array.isArray(g)){if(L.has(g))return"[Circular]";L.add(g)}return g})}t.safeStringify=p;function y(E,L){const h=Object.create(null);return!E||!L||Object.keys(L).forEach(l=>{const r=E[l],s=L[l];o(r,s)||(h[l]=s)}),h}t.distinct=y;function w(E,L){const h=L.toLowerCase(),g=Object.keys(E).find(l=>l.toLowerCase()===h);return g?E[g]:E[L]}t.getCaseInsensitive=w;function v(E,L){const h=Object.create(null);for(const[g,l]of Object.entries(E))L(g,l)&&(h[g]=l);return h}t.filter=v;function e(E){let L=[],h=Object.getPrototypeOf(E);for(;Object.prototype!==h;)L=L.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return L}t.getAllPropertyNames=e;function A(E){const L=[];for(const h of e(E))typeof E[h]=="function"&&L.push(h);return L}t.getAllMethodNames=A;function D(E,L){const h=l=>function(){const r=Array.prototype.slice.call(arguments,0);return L(l,r)},g={};for(const l of E)g[l]=h(l);return g}t.createProxyObject=D}),Q(J[17],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var M;(function(n){n[n.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",n[n.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",n[n.MAX_UINT_8=255]="MAX_UINT_8",n[n.MAX_UINT_16=65535]="MAX_UINT_16",n[n.MAX_UINT_32=4294967295]="MAX_UINT_32",n[n.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(M=t.Constants||(t.Constants={}));function S(n){return n<0?0:n>255?255:n|0}t.toUint8=S;function F(n){return n<0?0:n>4294967295?4294967295:n|0}t.toUint32=F}),Q(J[18],K([0,1,17]),function(q,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class S{constructor(m){const a=(0,M.toUint8)(m);this.c=a,this.a=S.d(a),this.b=new Map}static d(m){const a=new Uint8Array(256);return a.fill(m),a}set(m,a){const o=(0,M.toUint8)(a);m>=0&&m<256?this.a[m]=o:this.b.set(m,o)}get(m){return m>=0&&m<256?this.a[m]:this.b.get(m)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.CharacterClassifier=S;var F;(function(_){_[_.False=0]="False",_[_.True=1]="True"})(F||(F={}));class n{constructor(){this.a=new S(0)}add(m){this.a.set(m,1)}has(m){return this.a.get(m)===1}clear(){return this.a.clear()}}t.CharacterSet=n}),Q(J[3],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class M{constructor(F,n){this.lineNumber=F,this.column=n}with(F=this.lineNumber,n=this.column){return F===this.lineNumber&&n===this.column?this:new M(F,n)}delta(F=0,n=0){return this.with(this.lineNumber+F,this.column+n)}equals(F){return M.equals(this,F)}static equals(F,n){return!F&&!n?!0:!!F&&!!n&&F.lineNumber===n.lineNumber&&F.column===n.column}isBefore(F){return M.isBefore(this,F)}static isBefore(F,n){return F.lineNumber<n.lineNumber?!0:n.lineNumber<F.lineNumber?!1:F.column<n.column}isBeforeOrEqual(F){return M.isBeforeOrEqual(this,F)}static isBeforeOrEqual(F,n){return F.lineNumber<n.lineNumber?!0:n.lineNumber<F.lineNumber?!1:F.column<=n.column}static compare(F,n){const _=F.lineNumber|0,m=n.lineNumber|0;if(_===m){const a=F.column|0,o=n.column|0;return a-o}return _-m}clone(){return new M(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(F){return new M(F.lineNumber,F.column)}static isIPosition(F){return F&&typeof F.lineNumber=="number"&&typeof F.column=="number"}}t.Position=M}),Q(J[2],K([0,1,3]),function(q,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class S{constructor(n,_,m,a){n>m||n===m&&_>a?(this.startLineNumber=m,this.startColumn=a,this.endLineNumber=n,this.endColumn=_):(this.startLineNumber=n,this.startColumn=_,this.endLineNumber=m,this.endColumn=a)}isEmpty(){return S.isEmpty(this)}static isEmpty(n){return n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn}containsPosition(n){return S.containsPosition(this,n)}static containsPosition(n,_){return!(_.lineNumber<n.startLineNumber||_.lineNumber>n.endLineNumber||_.lineNumber===n.startLineNumber&&_.column<n.startColumn||_.lineNumber===n.endLineNumber&&_.column>n.endColumn)}static strictContainsPosition(n,_){return!(_.lineNumber<n.startLineNumber||_.lineNumber>n.endLineNumber||_.lineNumber===n.startLineNumber&&_.column<=n.startColumn||_.lineNumber===n.endLineNumber&&_.column>=n.endColumn)}containsRange(n){return S.containsRange(this,n)}static containsRange(n,_){return!(_.startLineNumber<n.startLineNumber||_.endLineNumber<n.startLineNumber||_.startLineNumber>n.endLineNumber||_.endLineNumber>n.endLineNumber||_.startLineNumber===n.startLineNumber&&_.startColumn<n.startColumn||_.endLineNumber===n.endLineNumber&&_.endColumn>n.endColumn)}strictContainsRange(n){return S.strictContainsRange(this,n)}static strictContainsRange(n,_){return!(_.startLineNumber<n.startLineNumber||_.endLineNumber<n.startLineNumber||_.startLineNumber>n.endLineNumber||_.endLineNumber>n.endLineNumber||_.startLineNumber===n.startLineNumber&&_.startColumn<=n.startColumn||_.endLineNumber===n.endLineNumber&&_.endColumn>=n.endColumn)}plusRange(n){return S.plusRange(this,n)}static plusRange(n,_){let m,a,o,p;return _.startLineNumber<n.startLineNumber?(m=_.startLineNumber,a=_.startColumn):_.startLineNumber===n.startLineNumber?(m=_.startLineNumber,a=Math.min(_.startColumn,n.startColumn)):(m=n.startLineNumber,a=n.startColumn),_.endLineNumber>n.endLineNumber?(o=_.endLineNumber,p=_.endColumn):_.endLineNumber===n.endLineNumber?(o=_.endLineNumber,p=Math.max(_.endColumn,n.endColumn)):(o=n.endLineNumber,p=n.endColumn),new S(m,a,o,p)}intersectRanges(n){return S.intersectRanges(this,n)}static intersectRanges(n,_){let m=n.startLineNumber,a=n.startColumn,o=n.endLineNumber,p=n.endColumn;const y=_.startLineNumber,w=_.startColumn,v=_.endLineNumber,e=_.endColumn;return m<y?(m=y,a=w):m===y&&(a=Math.max(a,w)),o>v?(o=v,p=e):o===v&&(p=Math.min(p,e)),m>o||m===o&&a>p?null:new S(m,a,o,p)}equalsRange(n){return S.equalsRange(this,n)}static equalsRange(n,_){return!n&&!_?!0:!!n&&!!_&&n.startLineNumber===_.startLineNumber&&n.startColumn===_.startColumn&&n.endLineNumber===_.endLineNumber&&n.endColumn===_.endColumn}getEndPosition(){return S.getEndPosition(this)}static getEndPosition(n){return new M.Position(n.endLineNumber,n.endColumn)}getStartPosition(){return S.getStartPosition(this)}static getStartPosition(n){return new M.Position(n.startLineNumber,n.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(n,_){return new S(this.startLineNumber,this.startColumn,n,_)}setStartPosition(n,_){return new S(n,_,this.endLineNumber,this.endColumn)}collapseToStart(){return S.collapseToStart(this)}static collapseToStart(n){return new S(n.startLineNumber,n.startColumn,n.startLineNumber,n.startColumn)}collapseToEnd(){return S.collapseToEnd(this)}static collapseToEnd(n){return new S(n.endLineNumber,n.endColumn,n.endLineNumber,n.endColumn)}delta(n){return new S(this.startLineNumber+n,this.startColumn,this.endLineNumber+n,this.endColumn)}static fromPositions(n,_=n){return new S(n.lineNumber,n.column,_.lineNumber,_.column)}static lift(n){return n?new S(n.startLineNumber,n.startColumn,n.endLineNumber,n.endColumn):null}static isIRange(n){return n&&typeof n.startLineNumber=="number"&&typeof n.startColumn=="number"&&typeof n.endLineNumber=="number"&&typeof n.endColumn=="number"}static areIntersectingOrTouching(n,_){return!(n.endLineNumber<_.startLineNumber||n.endLineNumber===_.startLineNumber&&n.endColumn<_.startColumn||_.endLineNumber<n.startLineNumber||_.endLineNumber===n.startLineNumber&&_.endColumn<n.startColumn)}static areIntersecting(n,_){return!(n.endLineNumber<_.startLineNumber||n.endLineNumber===_.startLineNumber&&n.endColumn<=_.startColumn||_.endLineNumber<n.startLineNumber||_.endLineNumber===n.startLineNumber&&_.endColumn<=n.startColumn)}static compareRangesUsingStarts(n,_){if(n&&_){const o=n.startLineNumber|0,p=_.startLineNumber|0;if(o===p){const y=n.startColumn|0,w=_.startColumn|0;if(y===w){const v=n.endLineNumber|0,e=_.endLineNumber|0;if(v===e){const A=n.endColumn|0,D=_.endColumn|0;return A-D}return v-e}return y-w}return o-p}return(n?1:0)-(_?1:0)}static compareRangesUsingEnds(n,_){return n.endLineNumber===_.endLineNumber?n.endColumn===_.endColumn?n.startLineNumber===_.startLineNumber?n.startColumn-_.startColumn:n.startLineNumber-_.startLineNumber:n.endColumn-_.endColumn:n.endLineNumber-_.endLineNumber}static spansMultipleLines(n){return n.endLineNumber>n.startLineNumber}toJSON(){return this}}t.Range=S}),Q(J[30],K([0,1,3,2]),function(q,t,M,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var F;(function(_){_[_.LTR=0]="LTR",_[_.RTL=1]="RTL"})(F=t.SelectionDirection||(t.SelectionDirection={}));class n extends S.Range{constructor(m,a,o,p){super(m,a,o,p),this.selectionStartLineNumber=m,this.selectionStartColumn=a,this.positionLineNumber=o,this.positionColumn=p}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(m){return n.selectionsEqual(this,m)}static selectionsEqual(m,a){return m.selectionStartLineNumber===a.selectionStartLineNumber&&m.selectionStartColumn===a.selectionStartColumn&&m.positionLineNumber===a.positionLineNumber&&m.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(m,a){return this.getDirection()===0?new n(this.startLineNumber,this.startColumn,m,a):new n(m,a,this.startLineNumber,this.startColumn)}getPosition(){return new M.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new M.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(m,a){return this.getDirection()===0?new n(m,a,this.endLineNumber,this.endColumn):new n(this.endLineNumber,this.endColumn,m,a)}static fromPositions(m,a=m){return new n(m.lineNumber,m.column,a.lineNumber,a.column)}static fromRange(m,a){return a===0?new n(m.startLineNumber,m.startColumn,m.endLineNumber,m.endColumn):new n(m.endLineNumber,m.endColumn,m.startLineNumber,m.startColumn)}static liftSelection(m){return new n(m.selectionStartLineNumber,m.selectionStartColumn,m.positionLineNumber,m.positionColumn)}static selectionsArrEqual(m,a){if(m&&!a||!m&&a)return!1;if(!m&&!a)return!0;if(m.length!==a.length)return!1;for(let o=0,p=m.length;o<p;o++)if(!this.selectionsEqual(m[o],a[o]))return!1;return!0}static isISelection(m){return m&&typeof m.selectionStartLineNumber=="number"&&typeof m.selectionStartColumn=="number"&&typeof m.positionLineNumber=="number"&&typeof m.positionColumn=="number"}static createWithDirection(m,a,o,p,y){return y===0?new n(m,a,o,p):new n(o,p,m,a)}}t.Selection=n}),Q(J[31],K([0,1,18]),function(q,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMapForWordSeparators=t.WordCharacterClassifier=t.WordCharacterClass=void 0;var S;(function(_){_[_.Regular=0]="Regular",_[_.Whitespace=1]="Whitespace",_[_.WordSeparator=2]="WordSeparator"})(S=t.WordCharacterClass||(t.WordCharacterClass={}));class F extends M.CharacterClassifier{constructor(m){super(0);for(let a=0,o=m.length;a<o;a++)this.set(m.charCodeAt(a),2);this.set(32,1),this.set(9,1)}}t.WordCharacterClassifier=F;function n(_){const m={};return a=>(m.hasOwnProperty(a)||(m[a]=_(a)),m[a])}t.getMapForWordSeparators=n(_=>new F(_))}),Q(J[19],K([0,1,14,7,15]),function(q,t,M,S,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.setDefaultGetWordAtTextConfig=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function n(y=""){let w="(-?\\d*\\.\\d\\w*)|([^";for(const v of t.USUAL_WORD_SEPARATORS)y.indexOf(v)>=0||(w+="\\"+v);return w+="\\s]+)",new RegExp(w,"g")}t.DEFAULT_WORD_REGEXP=n();function _(y){let w=t.DEFAULT_WORD_REGEXP;if(y&&y instanceof RegExp)if(y.global)w=y;else{let v="g";y.ignoreCase&&(v+="i"),y.multiline&&(v+="m"),y.unicode&&(v+="u"),w=new RegExp(y.source,v)}return w.lastIndex=0,w}t.ensureValidWordDefinition=_;const m=new F.LinkedList;m.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a(y){const w=m.unshift(y);return(0,S.toDisposable)(w)}t.setDefaultGetWordAtTextConfig=a;function o(y,w,v,e,A){if(A||(A=M.Iterable.first(m)),v.length>A.maxLen){let g=y-A.maxLen/2;return g<0?g=0:e+=g,v=v.substring(g,y+A.maxLen/2),o(y,w,v,e,A)}const D=Date.now(),E=y-1-e;let L=-1,h=null;for(let g=1;!(Date.now()-D>=A.timeBudget);g++){const l=E-A.windowSize*g;w.lastIndex=Math.max(0,l);const r=p(w,v,E,L);if(!r&&h||(h=r,l<=0))break;L=l}if(h){const g={word:h[0],startColumn:e+1+h.index,endColumn:e+1+h.index+h[0].length};return w.lastIndex=0,g}return null}t.getWordAtText=o;function p(y,w,v,e){let A;for(;A=y.exec(w);){const D=A.index||0;if(D<=v&&y.lastIndex>=v)return A;if(e>0&&D>e)return null}return null}}),Q(J[8],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OffsetRange=t.SequenceDiff=void 0;class M{constructor(n,_){this.seq1Range=n,this.seq2Range=_}reverse(){return new M(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}}t.SequenceDiff=M;class S{constructor(n,_){this.start=n,this.endExclusive=_}get isEmpty(){return this.start===this.endExclusive}delta(n){return new S(this.start+n,this.endExclusive+n)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}join(n){return new S(Math.min(this.start,n.start),Math.max(this.endExclusive,n.endExclusive))}}t.OffsetRange=S}),Q(J[32],K([0,1,8]),function(q,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shiftSequenceDiffs=t.joinSequenceDiffs=t.smoothenSequenceDiffs=t.optimizeSequenceDiffs=void 0;function S(a,o,p){let y=p;return y=n(a,o,y),y=_(a,o,y),y}t.optimizeSequenceDiffs=S;function F(a,o,p){const y=[];for(const w of p){const v=y[y.length-1];if(!v){y.push(w);continue}w.seq1Range.start-v.seq1Range.endExclusive<=2||w.seq2Range.start-v.seq2Range.endExclusive<=2?y[y.length-1]=new M.SequenceDiff(v.seq1Range.join(w.seq1Range),v.seq2Range.join(w.seq2Range)):y.push(w)}return y}t.smoothenSequenceDiffs=F;function n(a,o,p){const y=[];p.length>0&&y.push(p[0]);for(let w=1;w<p.length;w++){const v=y[y.length-1],e=p[w];if(e.seq1Range.isEmpty){let A=!0;const D=e.seq1Range.start-v.seq1Range.endExclusive;for(let E=1;E<=D;E++)if(o.getElement(e.seq2Range.start-E)!==o.getElement(e.seq2Range.endExclusive-E)){A=!1;break}if(A){y[y.length-1]=new M.SequenceDiff(v.seq1Range,new M.OffsetRange(v.seq2Range.start,e.seq2Range.endExclusive-D));continue}}y.push(e)}return y}t.joinSequenceDiffs=n;function _(a,o,p){if(!a.getBoundaryScore||!o.getBoundaryScore)return p;for(let y=0;y<p.length;y++){const w=p[y];if(w.seq1Range.isEmpty){const v=y>0?p[y-1].seq2Range.endExclusive:-1,e=y+1<p.length?p[y+1].seq2Range.start:o.length;p[y]=m(w,a,o,e,v)}else if(w.seq2Range.isEmpty){const v=y>0?p[y-1].seq1Range.endExclusive:-1,e=y+1<p.length?p[y+1].seq1Range.start:a.length;p[y]=m(w.reverse(),o,a,e,v).reverse()}}return p}t.shiftSequenceDiffs=_;function m(a,o,p,y,w){let e=1;for(;a.seq2Range.start-e>w&&p.getElement(a.seq2Range.start-e)===p.getElement(a.seq2Range.endExclusive-e)&&e<20;)e++;e--;let A=0;for(;a.seq2Range.start+A<y&&p.getElement(a.seq2Range.start+A)===p.getElement(a.seq2Range.endExclusive+A)&&A<20;)A++;if(e===0&&A===0)return a;let D=0,E=-1;for(let L=-e;L<=A;L++){const h=a.seq2Range.start+L,g=a.seq2Range.endExclusive+L,l=a.seq1Range.start+L,r=o.getBoundaryScore(l)+p.getBoundaryScore(h)+p.getBoundaryScore(g);r>E&&(E=r,D=L)}return D!==0?new M.SequenceDiff(a.seq1Range.delta(D),a.seq2Range.delta(D)):a}}),Q(J[33],K([0,1,8]),function(q,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MyersDiffAlgorithm=void 0;class S{compute(a,o){if(a.length===0)return[new M.SequenceDiff(new M.OffsetRange(0,0),new M.OffsetRange(0,o.length))];if(o.length===0)return[new M.SequenceDiff(new M.OffsetRange(0,a.length),new M.OffsetRange(0,0))];function p(h,g){for(;h<a.length&&g<o.length&&a.getElement(h)===o.getElement(g);)h++,g++;return h}let y=0;const w=new n;w.set(0,p(0,0));const v=new _;v.set(0,w.get(0)===0?null:new F(null,0,0,w.get(0)));let e=0;e:for(;;)for(y++,e=-y;e<=y;e+=2){const h=e===y?-1:w.get(e+1),g=e===-y?-1:w.get(e-1)+1,l=Math.min(Math.max(h,g),a.length),r=l-e,s=p(l,r);w.set(e,s);const d=l===h?v.get(e+1):v.get(e-1);if(v.set(e,s!==l?new F(d,l,r,s-l):d),w.get(e)===a.length&&w.get(e)-e===o.length)break e}let A=v.get(e);const D=[];let E=a.length,L=o.length;for(;;){const h=A?A.x+A.length:0,g=A?A.y+A.length:0;if((h!==E||g!==L)&&D.push(new M.SequenceDiff(new M.OffsetRange(h,E),new M.OffsetRange(g,L))),!A)break;E=A.x,L=A.y,A=A.prev}return D.reverse(),D}}t.MyersDiffAlgorithm=S;class F{constructor(a,o,p,y){this.prev=a,this.x=o,this.y=p,this.length=y}}class n{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(a){return a<0?(a=-a-1,this.b[a]):this.a[a]}set(a,o){if(a<0){if(a=-a-1,a>=this.b.length){const p=this.b;this.b=new Int32Array(p.length*2),this.b.set(p)}this.b[a]=o}else{if(a>=this.a.length){const p=this.a;this.a=new Int32Array(p.length*2),this.a.set(p)}this.a[a]=o}}}class _{constructor(){this.a=[],this.b=[]}get(a){return a<0?(a=-a-1,this.b[a]):this.a[a]}set(a,o){a<0?(a=-a-1,this.b[a]=o):this.a[a]=o}}}),Q(J[34],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Array2D=void 0;class M{constructor(F,n){this.width=F,this.height=n,this.a=[],this.a=new Array(F*n)}get(F,n){return this.a[F+n*this.width]}set(F,n,_){this.a[F+n*this.width]=_}}t.Array2D=M}),Q(J[35],K([0,1,8,34]),function(q,t,M,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DynamicProgrammingDiffing=void 0;class F{compute(_,m,a){const o=new S.Array2D(_.length,m.length),p=new S.Array2D(_.length,m.length),y=new S.Array2D(_.length,m.length);for(let L=0;L<_.length;L++)for(let h=0;h<m.length;h++){const g=L===0?0:o.get(L-1,h),l=h===0?0:o.get(L,h-1);let r;_.getElement(L)===m.getElement(h)?(L===0||h===0?r=0:r=o.get(L-1,h-1),L>0&&h>0&&p.get(L-1,h-1)===3&&(r+=y.get(L-1,h-1)),r+=a?a(L,h):1):r=-1;const s=Math.max(g,l,r);if(s===r){const d=L>0&&h>0?y.get(L-1,h-1):0;y.set(L,h,d+1),p.set(L,h,3)}else s===g?(y.set(L,h,0),p.set(L,h,1)):s===l&&(y.set(L,h,0),p.set(L,h,2));o.set(L,h,s)}const w=[];let v=_.length,e=m.length;function A(L,h){(L+1!==v||h+1!==e)&&w.push(new M.SequenceDiff(new M.OffsetRange(L+1,v),new M.OffsetRange(h+1,e))),v=L,e=h}let D=_.length-1,E=m.length-1;for(;D>=0&&E>=0;)p.get(D,E)===3?(A(D,E),D--,E--):p.get(D,E)===1?D--:E--;return A(-1,-1),w.reverse(),w}}t.DynamicProgrammingDiffing=F}),Q(J[20],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRange=t.RangeMapping=t.LineRangeMapping=void 0;class M{constructor(_,m,a){this.originalRange=_,this.modifiedRange=m,this.innerChanges=a}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}t.LineRangeMapping=M;class S{constructor(_,m){this.originalRange=_,this.modifiedRange=m}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}t.RangeMapping=S;class F{constructor(_,m){this.startLineNumber=_,this.endLineNumberExclusive=m}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(_){return new F(this.startLineNumber+_,this.endLineNumberExclusive+_)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(_){return new F(Math.min(this.startLineNumber,_.startLineNumber),Math.max(this.endLineNumberExclusive,_.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}}t.LineRange=F}),Q(J[36],K([0,1,10,3,2,8,35,32,33,20]),function(q,t,M,S,F,n,_,m,a,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineSequence=t.lineRangeMappingFromRangeMappings=t.StandardLinesDiffComputer=void 0;class p{constructor(){this.b=new _.DynamicProgrammingDiffing,this.c=new a.MyersDiffAlgorithm}computeDiff(r,s,d){const c=new Map;function N(ne){let Y=c.get(ne);return Y===void 0&&(Y=c.size,c.set(ne,Y)),Y}const b=r.map(ne=>N(ne.trim())),f=s.map(ne=>N(ne.trim())),u=new v(b,r),R=new v(f,s);let T=(()=>u.length+R.length<1500?this.b.compute(u,R,(ne,Y)=>r[ne]===s[Y]?s[Y].length===0?.1:1+Math.log(1+s[Y].length):.99):this.c.compute(u,R))();T=(0,m.optimizeSequenceDiffs)(u,R,T);const O=[],C=ne=>{for(let Y=0;Y<ne;Y++){const Z=H+Y,i=z+Y;if(r[Z]!==s[i]){const Le=this.f(r,s,new n.SequenceDiff(new n.OffsetRange(Z,Z+1),new n.OffsetRange(i,i+1)));for(const Ae of Le)O.push(Ae)}}};let H=0,z=0;for(const ne of T){(0,M.assertFn)(()=>ne.seq1Range.start-H===ne.seq2Range.start-z);const Y=ne.seq1Range.start-H;C(Y),H=ne.seq1Range.endExclusive,z=ne.seq2Range.endExclusive;const Z=this.f(r,s,ne);for(const i of Z)O.push(i)}C(r.length-H);const ee=y(O);return{quitEarly:!1,changes:ee}}f(r,s,d){const c=new A(r,d.seq1Range),N=new A(s,d.seq2Range),b=c.length+N.length<500?this.b.compute(c,N):this.c.compute(c,N);let f=(0,m.optimizeSequenceDiffs)(c,N,b);return f=(0,m.smoothenSequenceDiffs)(c,N,f),f.map(R=>new o.RangeMapping(c.translateRange(R.seq1Range).delta(d.seq1Range.start),N.translateRange(R.seq2Range).delta(d.seq2Range.start)))}}t.StandardLinesDiffComputer=p;function y(l){const r=[];for(const s of w(l,(d,c)=>c.originalRange.startLineNumber-(d.originalRange.endLineNumber-(d.originalRange.endColumn>1?0:1))<=1||c.modifiedRange.startLineNumber-(d.modifiedRange.endLineNumber-(d.modifiedRange.endColumn>1?0:1))<=1)){const d=s[0],c=s[s.length-1];r.push(new o.LineRangeMapping(new o.LineRange(d.originalRange.startLineNumber,c.originalRange.endLineNumber+(c.originalRange.endColumn>1||c.modifiedRange.endColumn>1?1:0)),new o.LineRange(d.modifiedRange.startLineNumber,c.modifiedRange.endLineNumber+(c.originalRange.endColumn>1||c.modifiedRange.endColumn>1?1:0)),s))}return(0,M.assertFn)(()=>(0,M.checkAdjacentItems)(r,(s,d)=>d.originalRange.startLineNumber-s.originalRange.endLineNumberExclusive===d.modifiedRange.startLineNumber-s.modifiedRange.endLineNumberExclusive&&s.originalRange.endLineNumberExclusive<d.originalRange.startLineNumber&&s.modifiedRange.endLineNumberExclusive<d.modifiedRange.startLineNumber)),r}t.lineRangeMappingFromRangeMappings=y;function*w(l,r){let s,d;for(const c of l)d!==void 0&&r(d,c)?s.push(c):(s&&(yield s),s=[c]),d=c;s&&(yield s)}class v{constructor(r,s){this.b=r,this.c=s}getElement(r){return this.b[r]}get length(){return this.b.length}getBoundaryScore(r){const s=r===0?0:e(this.c[r-1]),d=r===this.c.length?0:e(this.c[r]);return 1e3-(s+d)}}t.LineSequence=v;function e(l){let r=0;for(;r<l.length&&(l.charCodeAt(r)===32||l.charCodeAt(r)===9);)r++;return r}class A{constructor(r,s){this.lines=r,this.lineRange=s;let d=0;this.c=new Int32Array(s.length);for(let N=s.start;N<s.endExclusive;N++)d+=r[N].length,this.c[N-s.start]=d+1,d++;this.b=new Int32Array(d);let c=0;for(let N=s.start;N<s.endExclusive;N++){const b=r[N];for(let f=0;f<b.length;f++)this.b[c+f]=b.charCodeAt(f);c+=b.length,N<r.length-1&&(this.b[c]=`
`.charCodeAt(0),c+=1)}}get text(){return[...this.b].map(r=>String.fromCharCode(r)).join("")}getElement(r){return this.b[r]}get length(){return this.b.length}getBoundaryScore(r){const s=h(r>0?this.b[r-1]:-1),d=h(r<this.b.length?this.b[r]:-1);if(s===6&&d===7)return 0;let c=0;return s!==d&&(c+=10,d===1&&(c+=1)),c+=L(s),c+=L(d),c}translateOffset(r){let s=0,d=this.c.length;for(;s<d;){const N=Math.floor((s+d)/2);this.c[N]>r?d=N:s=N+1}const c=s===0?0:this.c[s-1];return new S.Position(s+1,r-c+1)}translateRange(r){return F.Range.fromPositions(this.translateOffset(r.start),this.translateOffset(r.endExclusive))}}var D;(function(l){l[l.WordLower=0]="WordLower",l[l.WordUpper=1]="WordUpper",l[l.WordNumber=2]="WordNumber",l[l.End=3]="End",l[l.Other=4]="Other",l[l.Space=5]="Space",l[l.LineBreakCR=6]="LineBreakCR",l[l.LineBreakLF=7]="LineBreakLF"})(D||(D={}));const E={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function L(l){return E[l]}function h(l){return l===10?7:l===13?6:g(l)?5:l>=97&&l<=122?0:l>=65&&l<=90?1:l>=48&&l<=57?2:l===-1?3:4}function g(l){return l===32||l===9}}),Q(J[37],K([0,1,18]),function(q,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.State=void 0;var S;(function(v){v[v.Invalid=0]="Invalid",v[v.Start=1]="Start",v[v.H=2]="H",v[v.HT=3]="HT",v[v.HTT=4]="HTT",v[v.HTTP=5]="HTTP",v[v.F=6]="F",v[v.FI=7]="FI",v[v.FIL=8]="FIL",v[v.BeforeColon=9]="BeforeColon",v[v.AfterColon=10]="AfterColon",v[v.AlmostThere=11]="AlmostThere",v[v.End=12]="End",v[v.Accept=13]="Accept",v[v.LastKnownState=14]="LastKnownState"})(S=t.State||(t.State={}));class F{constructor(e,A,D){const E=new Uint8Array(e*A);for(let L=0,h=e*A;L<h;L++)E[L]=D;this.a=E,this.rows=e,this.cols=A}get(e,A){return this.a[e*this.cols+A]}set(e,A,D){this.a[e*this.cols+A]=D}}class n{constructor(e){let A=0,D=0;for(let L=0,h=e.length;L<h;L++){const[g,l,r]=e[L];l>A&&(A=l),g>D&&(D=g),r>D&&(D=r)}A++,D++;const E=new F(D,A,0);for(let L=0,h=e.length;L<h;L++){const[g,l,r]=e[L];E.set(g,l,r)}this.a=E,this.b=A}nextState(e,A){return A<0||A>=this.b?0:this.a.get(e,A)}}t.StateMachine=n;let _=null;function m(){return _===null&&(_=new n([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),_}var a;(function(v){v[v.None=0]="None",v[v.ForceTermination=1]="ForceTermination",v[v.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let o=null;function p(){if(o===null){o=new M.CharacterClassifier(0);const v=`, 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let A=0;A<v.length;A++)o.set(v.charCodeAt(A),1);const e=".;:";for(let A=0;A<e.length;A++)o.set(e.charCodeAt(A),2)}return o}class y{static a(e,A,D,E,L){let h=L-1;do{const g=A.charCodeAt(h);if(e.get(g)!==2)break;h--}while(h>E);if(E>0){const g=A.charCodeAt(E-1),l=A.charCodeAt(h);(g===40&&l===41||g===91&&l===93||g===123&&l===125)&&h--}return{range:{startLineNumber:D,startColumn:E+1,endLineNumber:D,endColumn:h+2},url:A.substring(E,h+1)}}static computeLinks(e,A=m()){const D=p(),E=[];for(let L=1,h=e.getLineCount();L<=h;L++){const g=e.getLineContent(L),l=g.length;let r=0,s=0,d=0,c=1,N=!1,b=!1,f=!1,u=!1;for(;r<l;){let R=!1;const T=g.charCodeAt(r);if(c===13){let O;switch(T){case 40:N=!0,O=0;break;case 41:O=N?0:1;break;case 91:f=!0,b=!0,O=0;break;case 93:f=!1,O=b?0:1;break;case 123:u=!0,O=0;break;case 125:O=u?0:1;break;case 39:case 34:case 96:d===T?O=1:d===39||d===34||d===96?O=0:O=1;break;case 42:O=d===42?1:0;break;case 124:O=d===124?1:0;break;case 32:O=f?0:1;break;default:O=D.get(T)}O===1&&(E.push(y.a(D,g,L,s,r)),R=!0)}else if(c===12){let O;T===91?(b=!0,O=0):O=D.get(T),O===1?R=!0:c=13}else c=A.nextState(c,T),c===0&&(R=!0);R&&(c=1,N=!1,b=!1,u=!1,s=r+1,d=T),r++}c===13&&E.push(y.a(D,g,L,s,l))}return E}}t.LinkComputer=y;function w(v){return!v||typeof v.getLineCount!="function"||typeof v.getLineContent!="function"?[]:y.computeLinks(v)}t.computeLinks=w}),Q(J[38],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class M{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(F,n,_,m,a){if(F&&n){const o=this.a(n,a);if(o)return{range:F,value:o}}if(_&&m){const o=this.a(m,a);if(o)return{range:_,value:o}}return null}a(F,n){const _=this.b(F,n);return _!==null?_:this.d(F,n)}b(F,n){const _=Math.pow(10,F.length-(F.lastIndexOf(".")+1));let m=Number(F);const a=parseFloat(F);return!isNaN(m)&&!isNaN(a)&&m===a?m===0&&!n?null:(m=Math.floor(m*_),m+=n?_:-_,String(m/_)):null}d(F,n){return this.e(this.c,F,n)}e(F,n,_){let m=null;for(let a=0,o=F.length;m===null&&a<o;a++)m=this.f(F[a],n,_);return m}f(F,n,_){let m=F.indexOf(n);return m>=0?(m+=_?1:-1,m<0?m=F.length-1:m%=F.length,F[m]):null}}t.BasicInplaceReplace=M,M.INSTANCE=new M}),Q(J[39],K([0,1,11]),function(q,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shouldSynchronizeModel=t.ApplyEditsResult=t.SearchData=t.ValidAnnotatedEditOperation=t.ModelConstants=t.PositionAffinity=t.isITextSnapshot=t.TrackedRangeStickiness=t.FindMatch=t.TextModelResolvedOptions=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.OverviewRulerLane=void 0;var S;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(S=t.OverviewRulerLane||(t.OverviewRulerLane={}));var F;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(F=t.MinimapPosition||(t.MinimapPosition={}));var n;(function(h){h[h.Both=0]="Both",h[h.Right=1]="Right",h[h.Left=2]="Left",h[h.None=3]="None"})(n=t.InjectedTextCursorStops||(t.InjectedTextCursorStops={}));var _;(function(h){h[h.TextDefined=0]="TextDefined",h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(_=t.EndOfLinePreference||(t.EndOfLinePreference={}));var m;(function(h){h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(m=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var a;(function(h){h[h.LF=0]="LF",h[h.CRLF=1]="CRLF"})(a=t.EndOfLineSequence||(t.EndOfLineSequence={}));class o{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(g){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,g.tabSize|0),g.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,g.indentSize|0),this.a=!1),this.insertSpaces=Boolean(g.insertSpaces),this.defaultEOL=g.defaultEOL|0,this.trimAutoWhitespace=Boolean(g.trimAutoWhitespace),this.bracketPairColorizationOptions=g.bracketPairColorizationOptions}equals(g){return this.tabSize===g.tabSize&&this.a===g.a&&this.indentSize===g.indentSize&&this.insertSpaces===g.insertSpaces&&this.defaultEOL===g.defaultEOL&&this.trimAutoWhitespace===g.trimAutoWhitespace&&(0,M.equals)(this.bracketPairColorizationOptions,g.bracketPairColorizationOptions)}createChangeEvent(g){return{tabSize:this.tabSize!==g.tabSize,indentSize:this.indentSize!==g.indentSize,insertSpaces:this.insertSpaces!==g.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==g.trimAutoWhitespace}}}t.TextModelResolvedOptions=o;class p{constructor(g,l){this._findMatchBrand=void 0,this.range=g,this.matches=l}}t.FindMatch=p;var y;(function(h){h[h.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",h[h.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",h[h.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",h[h.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(y=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));function w(h){return h&&typeof h.read=="function"}t.isITextSnapshot=w;var v;(function(h){h[h.Left=0]="Left",h[h.Right=1]="Right",h[h.None=2]="None",h[h.LeftOfInjectedText=3]="LeftOfInjectedText",h[h.RightOfInjectedText=4]="RightOfInjectedText"})(v=t.PositionAffinity||(t.PositionAffinity={}));var e;(function(h){h[h.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(e=t.ModelConstants||(t.ModelConstants={}));class A{constructor(g,l,r,s,d,c){this.identifier=g,this.range=l,this.text=r,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=d,this._isTracked=c}}t.ValidAnnotatedEditOperation=A;class D{constructor(g,l,r){this.regex=g,this.wordSeparators=l,this.simpleSearch=r}}t.SearchData=D;class E{constructor(g,l,r){this.reverseEdits=g,this.changes=l,this.trimAutoWhitespaceLineNumbers=r}}t.ApplyEditsResult=E;function L(h){return!h.isTooLargeForSyncing()&&!h.isForSimpleWidget}t.shouldSynchronizeModel=L}),Q(J[40],K([0,1,26,17]),function(q,t,M,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumIndexOfResult=t.ConstantTimePrefixSumComputer=t.PrefixSumComputer=void 0;class F{constructor(a){this.a=a,this.b=new Uint32Array(a.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(a,o){a=(0,S.toUint32)(a);const p=this.a,y=this.b,w=o.length;return w===0?!1:(this.a=new Uint32Array(p.length+w),this.a.set(p.subarray(0,a),0),this.a.set(p.subarray(a),a+w),this.a.set(o,a),a-1<this.c[0]&&(this.c[0]=a-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(y.subarray(0,this.c[0]+1)),!0)}setValue(a,o){return a=(0,S.toUint32)(a),o=(0,S.toUint32)(o),this.a[a]===o?!1:(this.a[a]=o,a-1<this.c[0]&&(this.c[0]=a-1),!0)}removeValues(a,o){a=(0,S.toUint32)(a),o=(0,S.toUint32)(o);const p=this.a,y=this.b;if(a>=p.length)return!1;const w=p.length-a;return o>=w&&(o=w),o===0?!1:(this.a=new Uint32Array(p.length-o),this.a.set(p.subarray(0,a),0),this.a.set(p.subarray(a+o),a),this.b=new Uint32Array(this.a.length),a-1<this.c[0]&&(this.c[0]=a-1),this.c[0]>=0&&this.b.set(y.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(a){return a<0?0:(a=(0,S.toUint32)(a),this.d(a))}d(a){if(a<=this.c[0])return this.b[a];let o=this.c[0]+1;o===0&&(this.b[0]=this.a[0],o++),a>=this.a.length&&(a=this.a.length-1);for(let p=o;p<=a;p++)this.b[p]=this.b[p-1]+this.a[p];return this.c[0]=Math.max(this.c[0],a),this.b[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let o=0,p=this.a.length-1,y=0,w=0,v=0;for(;o<=p;)if(y=o+(p-o)/2|0,w=this.b[y],v=w-this.a[y],a<v)p=y-1;else if(a>=w)o=y+1;else break;return new _(y,a-v)}}t.PrefixSumComputer=F;class n{constructor(a){this.a=a,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(a){return this.g(),a===0?0:this.d[a-1]}getIndexOf(a){this.g();const o=this.e[a],p=o>0?this.d[o-1]:0;return new _(o,a-p)}removeValues(a,o){this.a.splice(a,o),this.f(a)}insertValues(a,o){this.a=(0,M.arrayInsert)(this.a,a,o),this.f(a)}f(a){this.b=!1,this.c=Math.min(this.c,a-1)}g(){if(!this.b){for(let a=this.c+1,o=this.a.length;a<o;a++){const p=this.a[a],y=a>0?this.d[a-1]:0;this.d[a]=y+p;for(let w=0;w<p;w++)this.e[y+w]=a}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(a,o){this.a[a]!==o&&(this.a[a]=o,this.f(a))}}t.ConstantTimePrefixSumComputer=n;class _{constructor(a,o){this.index=a,this.remainder=o,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=o}}t.PrefixSumIndexOfResult=_}),Q(J[41],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var M;(function(i){i[i.Unknown=0]="Unknown",i[i.Disabled=1]="Disabled",i[i.Enabled=2]="Enabled"})(M=t.AccessibilitySupport||(t.AccessibilitySupport={}));var S;(function(i){i[i.Invoke=1]="Invoke",i[i.Auto=2]="Auto"})(S=t.CodeActionTriggerType||(t.CodeActionTriggerType={}));var F;(function(i){i[i.None=0]="None",i[i.KeepWhitespace=1]="KeepWhitespace",i[i.InsertAsSnippet=4]="InsertAsSnippet"})(F=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var n;(function(i){i[i.Method=0]="Method",i[i.Function=1]="Function",i[i.Constructor=2]="Constructor",i[i.Field=3]="Field",i[i.Variable=4]="Variable",i[i.Class=5]="Class",i[i.Struct=6]="Struct",i[i.Interface=7]="Interface",i[i.Module=8]="Module",i[i.Property=9]="Property",i[i.Event=10]="Event",i[i.Operator=11]="Operator",i[i.Unit=12]="Unit",i[i.Value=13]="Value",i[i.Constant=14]="Constant",i[i.Enum=15]="Enum",i[i.EnumMember=16]="EnumMember",i[i.Keyword=17]="Keyword",i[i.Text=18]="Text",i[i.Color=19]="Color",i[i.File=20]="File",i[i.Reference=21]="Reference",i[i.Customcolor=22]="Customcolor",i[i.Folder=23]="Folder",i[i.TypeParameter=24]="TypeParameter",i[i.User=25]="User",i[i.Issue=26]="Issue",i[i.Snippet=27]="Snippet"})(n=t.CompletionItemKind||(t.CompletionItemKind={}));var _;(function(i){i[i.Deprecated=1]="Deprecated"})(_=t.CompletionItemTag||(t.CompletionItemTag={}));var m;(function(i){i[i.Invoke=0]="Invoke",i[i.TriggerCharacter=1]="TriggerCharacter",i[i.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var a;(function(i){i[i.EXACT=0]="EXACT",i[i.ABOVE=1]="ABOVE",i[i.BELOW=2]="BELOW"})(a=t.ContentWidgetPositionPreference||(t.ContentWidgetPositionPreference={}));var o;(function(i){i[i.NotSet=0]="NotSet",i[i.ContentFlush=1]="ContentFlush",i[i.RecoverFromMarkers=2]="RecoverFromMarkers",i[i.Explicit=3]="Explicit",i[i.Paste=4]="Paste",i[i.Undo=5]="Undo",i[i.Redo=6]="Redo"})(o=t.CursorChangeReason||(t.CursorChangeReason={}));var p;(function(i){i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})(p=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var y;(function(i){i[i.Text=0]="Text",i[i.Read=1]="Read",i[i.Write=2]="Write"})(y=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));var w;(function(i){i[i.None=0]="None",i[i.Keep=1]="Keep",i[i.Brackets=2]="Brackets",i[i.Advanced=3]="Advanced",i[i.Full=4]="Full"})(w=t.EditorAutoIndentStrategy||(t.EditorAutoIndentStrategy={}));var v;(function(i){i[i.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",i[i.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",i[i.accessibilitySupport=2]="accessibilitySupport",i[i.accessibilityPageSize=3]="accessibilityPageSize",i[i.ariaLabel=4]="ariaLabel",i[i.autoClosingBrackets=5]="autoClosingBrackets",i[i.autoClosingDelete=6]="autoClosingDelete",i[i.autoClosingOvertype=7]="autoClosingOvertype",i[i.autoClosingQuotes=8]="autoClosingQuotes",i[i.autoIndent=9]="autoIndent",i[i.automaticLayout=10]="automaticLayout",i[i.autoSurround=11]="autoSurround",i[i.bracketPairColorization=12]="bracketPairColorization",i[i.guides=13]="guides",i[i.codeLens=14]="codeLens",i[i.codeLensFontFamily=15]="codeLensFontFamily",i[i.codeLensFontSize=16]="codeLensFontSize",i[i.colorDecorators=17]="colorDecorators",i[i.colorDecoratorsLimit=18]="colorDecoratorsLimit",i[i.columnSelection=19]="columnSelection",i[i.comments=20]="comments",i[i.contextmenu=21]="contextmenu",i[i.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",i[i.cursorBlinking=23]="cursorBlinking",i[i.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",i[i.cursorStyle=25]="cursorStyle",i[i.cursorSurroundingLines=26]="cursorSurroundingLines",i[i.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",i[i.cursorWidth=28]="cursorWidth",i[i.disableLayerHinting=29]="disableLayerHinting",i[i.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",i[i.domReadOnly=31]="domReadOnly",i[i.dragAndDrop=32]="dragAndDrop",i[i.dropIntoEditor=33]="dropIntoEditor",i[i.emptySelectionClipboard=34]="emptySelectionClipboard",i[i.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",i[i.extraEditorClassName=36]="extraEditorClassName",i[i.fastScrollSensitivity=37]="fastScrollSensitivity",i[i.find=38]="find",i[i.fixedOverflowWidgets=39]="fixedOverflowWidgets",i[i.folding=40]="folding",i[i.foldingStrategy=41]="foldingStrategy",i[i.foldingHighlight=42]="foldingHighlight",i[i.foldingImportsByDefault=43]="foldingImportsByDefault",i[i.foldingMaximumRegions=44]="foldingMaximumRegions",i[i.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",i[i.fontFamily=46]="fontFamily",i[i.fontInfo=47]="fontInfo",i[i.fontLigatures=48]="fontLigatures",i[i.fontSize=49]="fontSize",i[i.fontWeight=50]="fontWeight",i[i.fontVariations=51]="fontVariations",i[i.formatOnPaste=52]="formatOnPaste",i[i.formatOnType=53]="formatOnType",i[i.glyphMargin=54]="glyphMargin",i[i.gotoLocation=55]="gotoLocation",i[i.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",i[i.hover=57]="hover",i[i.inDiffEditor=58]="inDiffEditor",i[i.inlineSuggest=59]="inlineSuggest",i[i.letterSpacing=60]="letterSpacing",i[i.lightbulb=61]="lightbulb",i[i.lineDecorationsWidth=62]="lineDecorationsWidth",i[i.lineHeight=63]="lineHeight",i[i.lineNumbers=64]="lineNumbers",i[i.lineNumbersMinChars=65]="lineNumbersMinChars",i[i.linkedEditing=66]="linkedEditing",i[i.links=67]="links",i[i.matchBrackets=68]="matchBrackets",i[i.minimap=69]="minimap",i[i.mouseStyle=70]="mouseStyle",i[i.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",i[i.mouseWheelZoom=72]="mouseWheelZoom",i[i.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",i[i.multiCursorModifier=74]="multiCursorModifier",i[i.multiCursorPaste=75]="multiCursorPaste",i[i.multiCursorLimit=76]="multiCursorLimit",i[i.occurrencesHighlight=77]="occurrencesHighlight",i[i.overviewRulerBorder=78]="overviewRulerBorder",i[i.overviewRulerLanes=79]="overviewRulerLanes",i[i.padding=80]="padding",i[i.parameterHints=81]="parameterHints",i[i.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",i[i.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",i[i.quickSuggestions=84]="quickSuggestions",i[i.quickSuggestionsDelay=85]="quickSuggestionsDelay",i[i.readOnly=86]="readOnly",i[i.renameOnType=87]="renameOnType",i[i.renderControlCharacters=88]="renderControlCharacters",i[i.renderFinalNewline=89]="renderFinalNewline",i[i.renderLineHighlight=90]="renderLineHighlight",i[i.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",i[i.renderValidationDecorations=92]="renderValidationDecorations",i[i.renderWhitespace=93]="renderWhitespace",i[i.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",i[i.roundedSelection=95]="roundedSelection",i[i.rulers=96]="rulers",i[i.scrollbar=97]="scrollbar",i[i.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",i[i.scrollBeyondLastLine=99]="scrollBeyondLastLine",i[i.scrollPredominantAxis=100]="scrollPredominantAxis",i[i.selectionClipboard=101]="selectionClipboard",i[i.selectionHighlight=102]="selectionHighlight",i[i.selectOnLineNumbers=103]="selectOnLineNumbers",i[i.showFoldingControls=104]="showFoldingControls",i[i.showUnused=105]="showUnused",i[i.snippetSuggestions=106]="snippetSuggestions",i[i.smartSelect=107]="smartSelect",i[i.smoothScrolling=108]="smoothScrolling",i[i.stickyScroll=109]="stickyScroll",i[i.stickyTabStops=110]="stickyTabStops",i[i.stopRenderingLineAfter=111]="stopRenderingLineAfter",i[i.suggest=112]="suggest",i[i.suggestFontSize=113]="suggestFontSize",i[i.suggestLineHeight=114]="suggestLineHeight",i[i.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",i[i.suggestSelection=116]="suggestSelection",i[i.tabCompletion=117]="tabCompletion",i[i.tabIndex=118]="tabIndex",i[i.unicodeHighlighting=119]="unicodeHighlighting",i[i.unusualLineTerminators=120]="unusualLineTerminators",i[i.useShadowDOM=121]="useShadowDOM",i[i.useTabStops=122]="useTabStops",i[i.wordBreak=123]="wordBreak",i[i.wordSeparators=124]="wordSeparators",i[i.wordWrap=125]="wordWrap",i[i.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",i[i.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",i[i.wordWrapColumn=128]="wordWrapColumn",i[i.wordWrapOverride1=129]="wordWrapOverride1",i[i.wordWrapOverride2=130]="wordWrapOverride2",i[i.wrappingIndent=131]="wrappingIndent",i[i.wrappingStrategy=132]="wrappingStrategy",i[i.showDeprecated=133]="showDeprecated",i[i.inlayHints=134]="inlayHints",i[i.editorClassName=135]="editorClassName",i[i.pixelRatio=136]="pixelRatio",i[i.tabFocusMode=137]="tabFocusMode",i[i.layoutInfo=138]="layoutInfo",i[i.wrappingInfo=139]="wrappingInfo"})(v=t.EditorOption||(t.EditorOption={}));var e;(function(i){i[i.TextDefined=0]="TextDefined",i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})(e=t.EndOfLinePreference||(t.EndOfLinePreference={}));var A;(function(i){i[i.LF=0]="LF",i[i.CRLF=1]="CRLF"})(A=t.EndOfLineSequence||(t.EndOfLineSequence={}));var D;(function(i){i[i.None=0]="None",i[i.Indent=1]="Indent",i[i.IndentOutdent=2]="IndentOutdent",i[i.Outdent=3]="Outdent"})(D=t.IndentAction||(t.IndentAction={}));var E;(function(i){i[i.Both=0]="Both",i[i.Right=1]="Right",i[i.Left=2]="Left",i[i.None=3]="None"})(E=t.InjectedTextCursorStops||(t.InjectedTextCursorStops={}));var L;(function(i){i[i.Type=1]="Type",i[i.Parameter=2]="Parameter"})(L=t.InlayHintKind||(t.InlayHintKind={}));var h;(function(i){i[i.Automatic=0]="Automatic",i[i.Explicit=1]="Explicit"})(h=t.InlineCompletionTriggerKind||(t.InlineCompletionTriggerKind={}));var g;(function(i){i[i.DependsOnKbLayout=-1]="DependsOnKbLayout",i[i.Unknown=0]="Unknown",i[i.Backspace=1]="Backspace",i[i.Tab=2]="Tab",i[i.Enter=3]="Enter",i[i.Shift=4]="Shift",i[i.Ctrl=5]="Ctrl",i[i.Alt=6]="Alt",i[i.PauseBreak=7]="PauseBreak",i[i.CapsLock=8]="CapsLock",i[i.Escape=9]="Escape",i[i.Space=10]="Space",i[i.PageUp=11]="PageUp",i[i.PageDown=12]="PageDown",i[i.End=13]="End",i[i.Home=14]="Home",i[i.LeftArrow=15]="LeftArrow",i[i.UpArrow=16]="UpArrow",i[i.RightArrow=17]="RightArrow",i[i.DownArrow=18]="DownArrow",i[i.Insert=19]="Insert",i[i.Delete=20]="Delete",i[i.Digit0=21]="Digit0",i[i.Digit1=22]="Digit1",i[i.Digit2=23]="Digit2",i[i.Digit3=24]="Digit3",i[i.Digit4=25]="Digit4",i[i.Digit5=26]="Digit5",i[i.Digit6=27]="Digit6",i[i.Digit7=28]="Digit7",i[i.Digit8=29]="Digit8",i[i.Digit9=30]="Digit9",i[i.KeyA=31]="KeyA",i[i.KeyB=32]="KeyB",i[i.KeyC=33]="KeyC",i[i.KeyD=34]="KeyD",i[i.KeyE=35]="KeyE",i[i.KeyF=36]="KeyF",i[i.KeyG=37]="KeyG",i[i.KeyH=38]="KeyH",i[i.KeyI=39]="KeyI",i[i.KeyJ=40]="KeyJ",i[i.KeyK=41]="KeyK",i[i.KeyL=42]="KeyL",i[i.KeyM=43]="KeyM",i[i.KeyN=44]="KeyN",i[i.KeyO=45]="KeyO",i[i.KeyP=46]="KeyP",i[i.KeyQ=47]="KeyQ",i[i.KeyR=48]="KeyR",i[i.KeyS=49]="KeyS",i[i.KeyT=50]="KeyT",i[i.KeyU=51]="KeyU",i[i.KeyV=52]="KeyV",i[i.KeyW=53]="KeyW",i[i.KeyX=54]="KeyX",i[i.KeyY=55]="KeyY",i[i.KeyZ=56]="KeyZ",i[i.Meta=57]="Meta",i[i.ContextMenu=58]="ContextMenu",i[i.F1=59]="F1",i[i.F2=60]="F2",i[i.F3=61]="F3",i[i.F4=62]="F4",i[i.F5=63]="F5",i[i.F6=64]="F6",i[i.F7=65]="F7",i[i.F8=66]="F8",i[i.F9=67]="F9",i[i.F10=68]="F10",i[i.F11=69]="F11",i[i.F12=70]="F12",i[i.F13=71]="F13",i[i.F14=72]="F14",i[i.F15=73]="F15",i[i.F16=74]="F16",i[i.F17=75]="F17",i[i.F18=76]="F18",i[i.F19=77]="F19",i[i.NumLock=78]="NumLock",i[i.ScrollLock=79]="ScrollLock",i[i.Semicolon=80]="Semicolon",i[i.Equal=81]="Equal",i[i.Comma=82]="Comma",i[i.Minus=83]="Minus",i[i.Period=84]="Period",i[i.Slash=85]="Slash",i[i.Backquote=86]="Backquote",i[i.BracketLeft=87]="BracketLeft",i[i.Backslash=88]="Backslash",i[i.BracketRight=89]="BracketRight",i[i.Quote=90]="Quote",i[i.OEM_8=91]="OEM_8",i[i.IntlBackslash=92]="IntlBackslash",i[i.Numpad0=93]="Numpad0",i[i.Numpad1=94]="Numpad1",i[i.Numpad2=95]="Numpad2",i[i.Numpad3=96]="Numpad3",i[i.Numpad4=97]="Numpad4",i[i.Numpad5=98]="Numpad5",i[i.Numpad6=99]="Numpad6",i[i.Numpad7=100]="Numpad7",i[i.Numpad8=101]="Numpad8",i[i.Numpad9=102]="Numpad9",i[i.NumpadMultiply=103]="NumpadMultiply",i[i.NumpadAdd=104]="NumpadAdd",i[i.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",i[i.NumpadSubtract=106]="NumpadSubtract",i[i.NumpadDecimal=107]="NumpadDecimal",i[i.NumpadDivide=108]="NumpadDivide",i[i.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",i[i.ABNT_C1=110]="ABNT_C1",i[i.ABNT_C2=111]="ABNT_C2",i[i.AudioVolumeMute=112]="AudioVolumeMute",i[i.AudioVolumeUp=113]="AudioVolumeUp",i[i.AudioVolumeDown=114]="AudioVolumeDown",i[i.BrowserSearch=115]="BrowserSearch",i[i.BrowserHome=116]="BrowserHome",i[i.BrowserBack=117]="BrowserBack",i[i.BrowserForward=118]="BrowserForward",i[i.MediaTrackNext=119]="MediaTrackNext",i[i.MediaTrackPrevious=120]="MediaTrackPrevious",i[i.MediaStop=121]="MediaStop",i[i.MediaPlayPause=122]="MediaPlayPause",i[i.LaunchMediaPlayer=123]="LaunchMediaPlayer",i[i.LaunchMail=124]="LaunchMail",i[i.LaunchApp2=125]="LaunchApp2",i[i.Clear=126]="Clear",i[i.MAX_VALUE=127]="MAX_VALUE"})(g=t.KeyCode||(t.KeyCode={}));var l;(function(i){i[i.Hint=1]="Hint",i[i.Info=2]="Info",i[i.Warning=4]="Warning",i[i.Error=8]="Error"})(l=t.MarkerSeverity||(t.MarkerSeverity={}));var r;(function(i){i[i.Unnecessary=1]="Unnecessary",i[i.Deprecated=2]="Deprecated"})(r=t.MarkerTag||(t.MarkerTag={}));var s;(function(i){i[i.Inline=1]="Inline",i[i.Gutter=2]="Gutter"})(s=t.MinimapPosition||(t.MinimapPosition={}));var d;(function(i){i[i.UNKNOWN=0]="UNKNOWN",i[i.TEXTAREA=1]="TEXTAREA",i[i.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",i[i.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",i[i.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",i[i.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",i[i.CONTENT_TEXT=6]="CONTENT_TEXT",i[i.CONTENT_EMPTY=7]="CONTENT_EMPTY",i[i.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",i[i.CONTENT_WIDGET=9]="CONTENT_WIDGET",i[i.OVERVIEW_RULER=10]="OVERVIEW_RULER",i[i.SCROLLBAR=11]="SCROLLBAR",i[i.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",i[i.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(d=t.MouseTargetType||(t.MouseTargetType={}));var c;(function(i){i[i.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",i[i.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",i[i.TOP_CENTER=2]="TOP_CENTER"})(c=t.OverlayWidgetPositionPreference||(t.OverlayWidgetPositionPreference={}));var N;(function(i){i[i.Left=1]="Left",i[i.Center=2]="Center",i[i.Right=4]="Right",i[i.Full=7]="Full"})(N=t.OverviewRulerLane||(t.OverviewRulerLane={}));var b;(function(i){i[i.Left=0]="Left",i[i.Right=1]="Right",i[i.None=2]="None",i[i.LeftOfInjectedText=3]="LeftOfInjectedText",i[i.RightOfInjectedText=4]="RightOfInjectedText"})(b=t.PositionAffinity||(t.PositionAffinity={}));var f;(function(i){i[i.Off=0]="Off",i[i.On=1]="On",i[i.Relative=2]="Relative",i[i.Interval=3]="Interval",i[i.Custom=4]="Custom"})(f=t.RenderLineNumbersType||(t.RenderLineNumbersType={}));var u;(function(i){i[i.None=0]="None",i[i.Text=1]="Text",i[i.Blocks=2]="Blocks"})(u=t.RenderMinimap||(t.RenderMinimap={}));var R;(function(i){i[i.Smooth=0]="Smooth",i[i.Immediate=1]="Immediate"})(R=t.ScrollType||(t.ScrollType={}));var T;(function(i){i[i.Auto=1]="Auto",i[i.Hidden=2]="Hidden",i[i.Visible=3]="Visible"})(T=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));var O;(function(i){i[i.LTR=0]="LTR",i[i.RTL=1]="RTL"})(O=t.SelectionDirection||(t.SelectionDirection={}));var C;(function(i){i[i.Invoke=1]="Invoke",i[i.TriggerCharacter=2]="TriggerCharacter",i[i.ContentChange=3]="ContentChange"})(C=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var H;(function(i){i[i.File=0]="File",i[i.Module=1]="Module",i[i.Namespace=2]="Namespace",i[i.Package=3]="Package",i[i.Class=4]="Class",i[i.Method=5]="Method",i[i.Property=6]="Property",i[i.Field=7]="Field",i[i.Constructor=8]="Constructor",i[i.Enum=9]="Enum",i[i.Interface=10]="Interface",i[i.Function=11]="Function",i[i.Variable=12]="Variable",i[i.Constant=13]="Constant",i[i.String=14]="String",i[i.Number=15]="Number",i[i.Boolean=16]="Boolean",i[i.Array=17]="Array",i[i.Object=18]="Object",i[i.Key=19]="Key",i[i.Null=20]="Null",i[i.EnumMember=21]="EnumMember",i[i.Struct=22]="Struct",i[i.Event=23]="Event",i[i.Operator=24]="Operator",i[i.TypeParameter=25]="TypeParameter"})(H=t.SymbolKind||(t.SymbolKind={}));var z;(function(i){i[i.Deprecated=1]="Deprecated"})(z=t.SymbolTag||(t.SymbolTag={}));var ee;(function(i){i[i.Hidden=0]="Hidden",i[i.Blink=1]="Blink",i[i.Smooth=2]="Smooth",i[i.Phase=3]="Phase",i[i.Expand=4]="Expand",i[i.Solid=5]="Solid"})(ee=t.TextEditorCursorBlinkingStyle||(t.TextEditorCursorBlinkingStyle={}));var ne;(function(i){i[i.Line=1]="Line",i[i.Block=2]="Block",i[i.Underline=3]="Underline",i[i.LineThin=4]="LineThin",i[i.BlockOutline=5]="BlockOutline",i[i.UnderlineThin=6]="UnderlineThin"})(ne=t.TextEditorCursorStyle||(t.TextEditorCursorStyle={}));var Y;(function(i){i[i.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",i[i.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",i[i.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",i[i.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(Y=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));var Z;(function(i){i[i.None=0]="None",i[i.Same=1]="Same",i[i.Indent=2]="Indent",i[i.DeepIndent=3]="DeepIndent"})(Z=t.WrappingIndent||(t.WrappingIndent={}))}),Q(J[42],K([55,56]),function(q,t){return q.create("vs/base/common/platform",t)}),Q(J[5],K([0,1,42]),function(q,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let S=!1,F=!1,n=!1,_=!1,m=!1,a=!1,o=!1,p=!1,y=!1,w=!1,v,e=t.LANGUAGE_DEFAULT,A,D;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let E;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?E=t.globals.vscode.process:typeof process<"u"&&(E=process);const L=typeof E?.versions?.electron=="string",h=L&&E?.type==="renderer";if(typeof navigator=="object"&&!h)D=navigator.userAgent,S=D.indexOf("Windows")>=0,F=D.indexOf("Macintosh")>=0,p=(D.indexOf("Macintosh")>=0||D.indexOf("iPad")>=0||D.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,n=D.indexOf("Linux")>=0,w=D?.indexOf("Mobi")>=0,a=!0,v=M.getConfiguredDefaultLocale(M.localize(0,null))||t.LANGUAGE_DEFAULT,e=v;else if(typeof E=="object"){S=E.platform==="win32",F=E.platform==="darwin",n=E.platform==="linux",_=n&&!!E.env.SNAP&&!!E.env.SNAP_REVISION,o=L,y=!!E.env.CI||!!E.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const f=E.env.VSCODE_NLS_CONFIG;if(f)try{const u=JSON.parse(f),R=u.availableLanguages["*"];v=u.locale,e=R||t.LANGUAGE_DEFAULT,A=u._translationsConfigFile}catch{}m=!0}else console.error("Unable to resolve platform.");var g;(function(f){f[f.Web=0]="Web",f[f.Mac=1]="Mac",f[f.Linux=2]="Linux",f[f.Windows=3]="Windows"})(g=t.Platform||(t.Platform={}));function l(f){switch(f){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=l;let r=0;F?r=1:S?r=3:n&&(r=2),t.isWindows=S,t.isMacintosh=F,t.isLinux=n,t.isLinuxSnap=_,t.isNative=m,t.isElectron=o,t.isWeb=a,t.isWebWorker=a&&typeof t.globals.importScripts=="function",t.isIOS=p,t.isMobile=w,t.isCI=y,t.platform=r,t.userAgent=D,t.language=e;var s;(function(f){function u(){return t.language}f.value=u;function R(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}f.isDefaultVariant=R;function T(){return t.language==="en"}f.isDefault=T})(s=t.Language||(t.Language={})),t.locale=v,t.translationsConfigFile=A,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const f=[];t.globals.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let T=0,O=f.length;T<O;T++){const C=f[T];if(C.id===R.data.vscodeScheduleAsyncWork){f.splice(T,1),C.callback();return}}});let u=0;return R=>{const T=++u;f.push({id:T,callback:R}),t.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return f=>setTimeout(f)})();var d;(function(f){f[f.Windows=1]="Windows",f[f.Macintosh=2]="Macintosh",f[f.Linux=3]="Linux"})(d=t.OperatingSystem||(t.OperatingSystem={})),t.OS=F||p?2:S?1:3;let c=!0,N=!1;function b(){if(!N){N=!0;const f=new Uint8Array(2);f[0]=1,f[1]=2,c=new Uint16Array(f.buffer)[0]===(2<<8)+1}return c}t.isLittleEndian=b,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),Q(J[43],K([0,1,5]),function(q,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let S;if(typeof M.globals.vscode<"u"&&typeof M.globals.vscode.process<"u"){const F=M.globals.vscode.process;S={get platform(){return F.platform},get arch(){return F.arch},get env(){return F.env},cwd(){return F.cwd()}}}else typeof process<"u"?S={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:S={get platform(){return M.isWindows?"win32":M.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=S.cwd,t.env=S.env,t.platform=S.platform,t.arch=S.arch}),Q(J[44],K([0,1,43]),function(q,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const S=65,F=97,n=90,_=122,m=46,a=47,o=92,p=58,y=63;class w extends Error{constructor(s,d,c){let N;typeof d=="string"&&d.indexOf("not ")===0?(N="must not be",d=d.replace(/^not /,"")):N="must be";const b=s.indexOf(".")!==-1?"property":"argument";let f=`The "${s}" ${b} ${N} of type ${d}`;f+=`. Received type ${typeof c}`,super(f),this.code="ERR_INVALID_ARG_TYPE"}}function v(r,s){if(r===null||typeof r!="object")throw new w(s,"Object",r)}function e(r,s){if(typeof r!="string")throw new w(s,"string",r)}const A=M.platform==="win32";function D(r){return r===a||r===o}function E(r){return r===a}function L(r){return r>=S&&r<=n||r>=F&&r<=_}function h(r,s,d,c){let N="",b=0,f=-1,u=0,R=0;for(let T=0;T<=r.length;++T){if(T<r.length)R=r.charCodeAt(T);else{if(c(R))break;R=a}if(c(R)){if(!(f===T-1||u===1))if(u===2){if(N.length<2||b!==2||N.charCodeAt(N.length-1)!==m||N.charCodeAt(N.length-2)!==m){if(N.length>2){const O=N.lastIndexOf(d);O===-1?(N="",b=0):(N=N.slice(0,O),b=N.length-1-N.lastIndexOf(d)),f=T,u=0;continue}else if(N.length!==0){N="",b=0,f=T,u=0;continue}}s&&(N+=N.length>0?`${d}..`:"..",b=2)}else N.length>0?N+=`${d}${r.slice(f+1,T)}`:N=r.slice(f+1,T),b=T-f-1;f=T,u=0}else R===m&&u!==-1?++u:u=-1}return N}function g(r,s){v(s,"pathObject");const d=s.dir||s.root,c=s.base||`${s.name||""}${s.ext||""}`;return d?d===s.root?`${d}${c}`:`${d}${r}${c}`:c}t.win32={resolve(...r){let s="",d="",c=!1;for(let N=r.length-1;N>=-1;N--){let b;if(N>=0){if(b=r[N],e(b,"path"),b.length===0)continue}else s.length===0?b=M.cwd():(b=M.env[`=${s}`]||M.cwd(),(b===void 0||b.slice(0,2).toLowerCase()!==s.toLowerCase()&&b.charCodeAt(2)===o)&&(b=`${s}\\`));const f=b.length;let u=0,R="",T=!1;const O=b.charCodeAt(0);if(f===1)D(O)&&(u=1,T=!0);else if(D(O))if(T=!0,D(b.charCodeAt(1))){let C=2,H=C;for(;C<f&&!D(b.charCodeAt(C));)C++;if(C<f&&C!==H){const z=b.slice(H,C);for(H=C;C<f&&D(b.charCodeAt(C));)C++;if(C<f&&C!==H){for(H=C;C<f&&!D(b.charCodeAt(C));)C++;(C===f||C!==H)&&(R=`\\\\${z}\\${b.slice(H,C)}`,u=C)}}}else u=1;else L(O)&&b.charCodeAt(1)===p&&(R=b.slice(0,2),u=2,f>2&&D(b.charCodeAt(2))&&(T=!0,u=3));if(R.length>0)if(s.length>0){if(R.toLowerCase()!==s.toLowerCase())continue}else s=R;if(c){if(s.length>0)break}else if(d=`${b.slice(u)}\\${d}`,c=T,T&&s.length>0)break}return d=h(d,!c,"\\",D),c?`${s}\\${d}`:`${s}${d}`||"."},normalize(r){e(r,"path");const s=r.length;if(s===0)return".";let d=0,c,N=!1;const b=r.charCodeAt(0);if(s===1)return E(b)?"\\":r;if(D(b))if(N=!0,D(r.charCodeAt(1))){let u=2,R=u;for(;u<s&&!D(r.charCodeAt(u));)u++;if(u<s&&u!==R){const T=r.slice(R,u);for(R=u;u<s&&D(r.charCodeAt(u));)u++;if(u<s&&u!==R){for(R=u;u<s&&!D(r.charCodeAt(u));)u++;if(u===s)return`\\\\${T}\\${r.slice(R)}\\`;u!==R&&(c=`\\\\${T}\\${r.slice(R,u)}`,d=u)}}}else d=1;else L(b)&&r.charCodeAt(1)===p&&(c=r.slice(0,2),d=2,s>2&&D(r.charCodeAt(2))&&(N=!0,d=3));let f=d<s?h(r.slice(d),!N,"\\",D):"";return f.length===0&&!N&&(f="."),f.length>0&&D(r.charCodeAt(s-1))&&(f+="\\"),c===void 0?N?`\\${f}`:f:N?`${c}\\${f}`:`${c}${f}`},isAbsolute(r){e(r,"path");const s=r.length;if(s===0)return!1;const d=r.charCodeAt(0);return D(d)||s>2&&L(d)&&r.charCodeAt(1)===p&&D(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let s,d;for(let b=0;b<r.length;++b){const f=r[b];e(f,"path"),f.length>0&&(s===void 0?s=d=f:s+=`\\${f}`)}if(s===void 0)return".";let c=!0,N=0;if(typeof d=="string"&&D(d.charCodeAt(0))){++N;const b=d.length;b>1&&D(d.charCodeAt(1))&&(++N,b>2&&(D(d.charCodeAt(2))?++N:c=!1))}if(c){for(;N<s.length&&D(s.charCodeAt(N));)N++;N>=2&&(s=`\\${s.slice(N)}`)}return t.win32.normalize(s)},relative(r,s){if(e(r,"from"),e(s,"to"),r===s)return"";const d=t.win32.resolve(r),c=t.win32.resolve(s);if(d===c||(r=d.toLowerCase(),s=c.toLowerCase(),r===s))return"";let N=0;for(;N<r.length&&r.charCodeAt(N)===o;)N++;let b=r.length;for(;b-1>N&&r.charCodeAt(b-1)===o;)b--;const f=b-N;let u=0;for(;u<s.length&&s.charCodeAt(u)===o;)u++;let R=s.length;for(;R-1>u&&s.charCodeAt(R-1)===o;)R--;const T=R-u,O=f<T?f:T;let C=-1,H=0;for(;H<O;H++){const ee=r.charCodeAt(N+H);if(ee!==s.charCodeAt(u+H))break;ee===o&&(C=H)}if(H!==O){if(C===-1)return c}else{if(T>O){if(s.charCodeAt(u+H)===o)return c.slice(u+H+1);if(H===2)return c.slice(u+H)}f>O&&(r.charCodeAt(N+H)===o?C=H:H===2&&(C=3)),C===-1&&(C=0)}let z="";for(H=N+C+1;H<=b;++H)(H===b||r.charCodeAt(H)===o)&&(z+=z.length===0?"..":"\\..");return u+=C,z.length>0?`${z}${c.slice(u,R)}`:(c.charCodeAt(u)===o&&++u,c.slice(u,R))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const s=t.win32.resolve(r);if(s.length<=2)return r;if(s.charCodeAt(0)===o){if(s.charCodeAt(1)===o){const d=s.charCodeAt(2);if(d!==y&&d!==m)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(L(s.charCodeAt(0))&&s.charCodeAt(1)===p&&s.charCodeAt(2)===o)return`\\\\?\\${s}`;return r},dirname(r){e(r,"path");const s=r.length;if(s===0)return".";let d=-1,c=0;const N=r.charCodeAt(0);if(s===1)return D(N)?r:".";if(D(N)){if(d=c=1,D(r.charCodeAt(1))){let u=2,R=u;for(;u<s&&!D(r.charCodeAt(u));)u++;if(u<s&&u!==R){for(R=u;u<s&&D(r.charCodeAt(u));)u++;if(u<s&&u!==R){for(R=u;u<s&&!D(r.charCodeAt(u));)u++;if(u===s)return r;u!==R&&(d=c=u+1)}}}}else L(N)&&r.charCodeAt(1)===p&&(d=s>2&&D(r.charCodeAt(2))?3:2,c=d);let b=-1,f=!0;for(let u=s-1;u>=c;--u)if(D(r.charCodeAt(u))){if(!f){b=u;break}}else f=!1;if(b===-1){if(d===-1)return".";b=d}return r.slice(0,b)},basename(r,s){s!==void 0&&e(s,"ext"),e(r,"path");let d=0,c=-1,N=!0,b;if(r.length>=2&&L(r.charCodeAt(0))&&r.charCodeAt(1)===p&&(d=2),s!==void 0&&s.length>0&&s.length<=r.length){if(s===r)return"";let f=s.length-1,u=-1;for(b=r.length-1;b>=d;--b){const R=r.charCodeAt(b);if(D(R)){if(!N){d=b+1;break}}else u===-1&&(N=!1,u=b+1),f>=0&&(R===s.charCodeAt(f)?--f===-1&&(c=b):(f=-1,c=u))}return d===c?c=u:c===-1&&(c=r.length),r.slice(d,c)}for(b=r.length-1;b>=d;--b)if(D(r.charCodeAt(b))){if(!N){d=b+1;break}}else c===-1&&(N=!1,c=b+1);return c===-1?"":r.slice(d,c)},extname(r){e(r,"path");let s=0,d=-1,c=0,N=-1,b=!0,f=0;r.length>=2&&r.charCodeAt(1)===p&&L(r.charCodeAt(0))&&(s=c=2);for(let u=r.length-1;u>=s;--u){const R=r.charCodeAt(u);if(D(R)){if(!b){c=u+1;break}continue}N===-1&&(b=!1,N=u+1),R===m?d===-1?d=u:f!==1&&(f=1):d!==-1&&(f=-1)}return d===-1||N===-1||f===0||f===1&&d===N-1&&d===c+1?"":r.slice(d,N)},format:g.bind(null,"\\"),parse(r){e(r,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return s;const d=r.length;let c=0,N=r.charCodeAt(0);if(d===1)return D(N)?(s.root=s.dir=r,s):(s.base=s.name=r,s);if(D(N)){if(c=1,D(r.charCodeAt(1))){let C=2,H=C;for(;C<d&&!D(r.charCodeAt(C));)C++;if(C<d&&C!==H){for(H=C;C<d&&D(r.charCodeAt(C));)C++;if(C<d&&C!==H){for(H=C;C<d&&!D(r.charCodeAt(C));)C++;C===d?c=C:C!==H&&(c=C+1)}}}}else if(L(N)&&r.charCodeAt(1)===p){if(d<=2)return s.root=s.dir=r,s;if(c=2,D(r.charCodeAt(2))){if(d===3)return s.root=s.dir=r,s;c=3}}c>0&&(s.root=r.slice(0,c));let b=-1,f=c,u=-1,R=!0,T=r.length-1,O=0;for(;T>=c;--T){if(N=r.charCodeAt(T),D(N)){if(!R){f=T+1;break}continue}u===-1&&(R=!1,u=T+1),N===m?b===-1?b=T:O!==1&&(O=1):b!==-1&&(O=-1)}return u!==-1&&(b===-1||O===0||O===1&&b===u-1&&b===f+1?s.base=s.name=r.slice(f,u):(s.name=r.slice(f,b),s.base=r.slice(f,u),s.ext=r.slice(b,u))),f>0&&f!==c?s.dir=r.slice(0,f-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(A){const r=/\\/g;return()=>{const s=M.cwd().replace(r,"/");return s.slice(s.indexOf("/"))}}return()=>M.cwd()})();t.posix={resolve(...r){let s="",d=!1;for(let c=r.length-1;c>=-1&&!d;c--){const N=c>=0?r[c]:l();e(N,"path"),N.length!==0&&(s=`${N}/${s}`,d=N.charCodeAt(0)===a)}return s=h(s,!d,"/",E),d?`/${s}`:s.length>0?s:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const s=r.charCodeAt(0)===a,d=r.charCodeAt(r.length-1)===a;return r=h(r,!s,"/",E),r.length===0?s?"/":d?"./":".":(d&&(r+="/"),s?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===a},join(...r){if(r.length===0)return".";let s;for(let d=0;d<r.length;++d){const c=r[d];e(c,"path"),c.length>0&&(s===void 0?s=c:s+=`/${c}`)}return s===void 0?".":t.posix.normalize(s)},relative(r,s){if(e(r,"from"),e(s,"to"),r===s||(r=t.posix.resolve(r),s=t.posix.resolve(s),r===s))return"";const d=1,c=r.length,N=c-d,b=1,f=s.length-b,u=N<f?N:f;let R=-1,T=0;for(;T<u;T++){const C=r.charCodeAt(d+T);if(C!==s.charCodeAt(b+T))break;C===a&&(R=T)}if(T===u)if(f>u){if(s.charCodeAt(b+T)===a)return s.slice(b+T+1);if(T===0)return s.slice(b+T)}else N>u&&(r.charCodeAt(d+T)===a?R=T:T===0&&(R=0));let O="";for(T=d+R+1;T<=c;++T)(T===c||r.charCodeAt(T)===a)&&(O+=O.length===0?"..":"/..");return`${O}${s.slice(b+R)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const s=r.charCodeAt(0)===a;let d=-1,c=!0;for(let N=r.length-1;N>=1;--N)if(r.charCodeAt(N)===a){if(!c){d=N;break}}else c=!1;return d===-1?s?"/":".":s&&d===1?"//":r.slice(0,d)},basename(r,s){s!==void 0&&e(s,"ext"),e(r,"path");let d=0,c=-1,N=!0,b;if(s!==void 0&&s.length>0&&s.length<=r.length){if(s===r)return"";let f=s.length-1,u=-1;for(b=r.length-1;b>=0;--b){const R=r.charCodeAt(b);if(R===a){if(!N){d=b+1;break}}else u===-1&&(N=!1,u=b+1),f>=0&&(R===s.charCodeAt(f)?--f===-1&&(c=b):(f=-1,c=u))}return d===c?c=u:c===-1&&(c=r.length),r.slice(d,c)}for(b=r.length-1;b>=0;--b)if(r.charCodeAt(b)===a){if(!N){d=b+1;break}}else c===-1&&(N=!1,c=b+1);return c===-1?"":r.slice(d,c)},extname(r){e(r,"path");let s=-1,d=0,c=-1,N=!0,b=0;for(let f=r.length-1;f>=0;--f){const u=r.charCodeAt(f);if(u===a){if(!N){d=f+1;break}continue}c===-1&&(N=!1,c=f+1),u===m?s===-1?s=f:b!==1&&(b=1):s!==-1&&(b=-1)}return s===-1||c===-1||b===0||b===1&&s===c-1&&s===d+1?"":r.slice(s,c)},format:g.bind(null,"/"),parse(r){e(r,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return s;const d=r.charCodeAt(0)===a;let c;d?(s.root="/",c=1):c=0;let N=-1,b=0,f=-1,u=!0,R=r.length-1,T=0;for(;R>=c;--R){const O=r.charCodeAt(R);if(O===a){if(!u){b=R+1;break}continue}f===-1&&(u=!1,f=R+1),O===m?N===-1?N=R:T!==1&&(T=1):N!==-1&&(T=-1)}if(f!==-1){const O=b===0&&d?1:b;N===-1||T===0||T===1&&N===f-1&&N===b+1?s.base=s.name=r.slice(O,f):(s.name=r.slice(O,N),s.base=r.slice(O,f),s.ext=r.slice(N,f))}return b>0?s.dir=r.slice(0,b-1):d&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=A?t.win32.normalize:t.posix.normalize,t.isAbsolute=A?t.win32.isAbsolute:t.posix.isAbsolute,t.join=A?t.win32.join:t.posix.join,t.resolve=A?t.win32.resolve:t.posix.resolve,t.relative=A?t.win32.relative:t.posix.relative,t.dirname=A?t.win32.dirname:t.posix.dirname,t.basename=A?t.win32.basename:t.posix.basename,t.extname=A?t.win32.extname:t.posix.extname,t.format=A?t.win32.format:t.posix.format,t.parse=A?t.win32.parse:t.posix.parse,t.toNamespacedPath=A?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=A?t.win32.sep:t.posix.sep,t.delimiter=A?t.win32.delimiter:t.posix.delimiter}),Q(J[21],K([0,1,5]),function(q,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const S=M.globals.performance&&typeof M.globals.performance.now=="function";class F{static create(_=!0){return new F(_)}constructor(_){this.a=S&&_,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?M.globals.performance.now():Date.now()}}t.StopWatch=F}),Q(J[9],K([0,1,6,13,7,15,21]),function(q,t,M,S,F,n,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const m=!1,a=!1;var o;(function(b){b.None=()=>F.Disposable.None;function f(te){if(a){const{onDidAddListener:G}=te,X=e.create();let k=0;te.onDidAddListener=()=>{++k===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),X.print()),G?.()}}}function u(te,G){return Y(te,()=>{},0,void 0,void 0,G)}b.defer=u;function R(te){return(G,X=null,k)=>{let I=!1,U;return U=te(W=>{if(!I)return U?U.dispose():I=!0,G.call(X,W)},null,k),I&&U.dispose(),U}}b.once=R;function T(te,G,X){return ne((k,I=null,U)=>te(W=>k.call(I,G(W)),null,U),X)}b.map=T;function O(te,G,X){return ne((k,I=null,U)=>te(W=>{G(W),k.call(I,W)},null,U),X)}b.forEach=O;function C(te,G,X){return ne((k,I=null,U)=>te(W=>G(W)&&k.call(I,W),null,U),X)}b.filter=C;function H(te){return te}b.signal=H;function z(...te){return(G,X=null,k)=>(0,F.combinedDisposable)(...te.map(I=>I(U=>G.call(X,U),null,k)))}b.any=z;function ee(te,G,X,k){let I=X;return T(te,U=>(I=G(I,U),I),k)}b.reduce=ee;function ne(te,G){let X;const k={onWillAddFirstListener(){X=te(I.fire,I)},onDidRemoveLastListener(){X?.dispose()}};G||f(k);const I=new D(k);return G?.add(I),I.event}function Y(te,G,X=100,k=!1,I,U){let W,j,ie,re=0;const oe={leakWarningThreshold:I,onWillAddFirstListener(){W=te(fe=>{re++,j=G(j,fe),k&&!ie&&(ae.fire(j),j=void 0),clearTimeout(ie),ie=setTimeout(()=>{const he=j;j=void 0,ie=void 0,(!k||re>1)&&ae.fire(he),re=0},X)})},onDidRemoveLastListener(){W.dispose()}};U||f(oe);const ae=new D(oe);return U?.add(ae),ae.event}b.debounce=Y;function Z(te,G=0,X){return b.debounce(te,(k,I)=>k?(k.push(I),k):[I],G,void 0,void 0,X)}b.accumulate=Z;function i(te,G=(k,I)=>k===I,X){let k=!0,I;return C(te,U=>{const W=k||!G(U,I);return k=!1,I=U,W},X)}b.latch=i;function Le(te,G,X){return[b.filter(te,G,X),b.filter(te,k=>!G(k),X)]}b.split=Le;function Ae(te,G=!1,X=[]){let k=X.slice(),I=te(j=>{k?k.push(j):W.fire(j)});const U=()=>{k?.forEach(j=>W.fire(j)),k=null},W=new D({onWillAddFirstListener(){I||(I=te(j=>W.fire(j)))},onDidAddFirstListener(){k&&(G?setTimeout(U):U())},onDidRemoveLastListener(){I&&I.dispose(),I=null}});return W.event}b.buffer=Ae;class de{constructor(G){this.event=G,this.c=new F.DisposableStore}map(G){return new de(T(this.event,G,this.c))}forEach(G){return new de(O(this.event,G,this.c))}filter(G){return new de(C(this.event,G,this.c))}reduce(G,X){return new de(ee(this.event,G,X,this.c))}latch(){return new de(i(this.event,void 0,this.c))}debounce(G,X=100,k=!1,I){return new de(Y(this.event,G,X,k,I,this.c))}on(G,X,k){return this.event(G,X,k)}once(G,X,k){return R(this.event)(G,X,k)}dispose(){this.c.dispose()}}function Ee(te){return new de(te)}b.chain=Ee;function we(te,G,X=k=>k){const k=(...j)=>W.fire(X(...j)),I=()=>te.on(G,k),U=()=>te.removeListener(G,k),W=new D({onWillAddFirstListener:I,onDidRemoveLastListener:U});return W.event}b.fromNodeEventEmitter=we;function Ne(te,G,X=k=>k){const k=(...j)=>W.fire(X(...j)),I=()=>te.addEventListener(G,k),U=()=>te.removeEventListener(G,k),W=new D({onWillAddFirstListener:I,onDidRemoveLastListener:U});return W.event}b.fromDOMEventEmitter=Ne;function Re(te){return new Promise(G=>R(te)(G))}b.toPromise=Re;function De(te,G){return G(void 0),te(X=>G(X))}b.runAndSubscribe=De;function Fe(te,G){let X=null;function k(U){X?.dispose(),X=new F.DisposableStore,G(U,X)}k(void 0);const I=te(U=>k(U));return(0,F.toDisposable)(()=>{I.dispose(),X?.dispose()})}b.runAndSubscribeWithStore=Fe;class _e{constructor(G,X){this.obs=G,this.c=0,this.d=!1;const k={onWillAddFirstListener:()=>{G.addObserver(this)},onDidRemoveLastListener:()=>{G.removeObserver(this)}};X||f(k),this.emitter=new D(k),X&&X.add(this.emitter)}beginUpdate(G){this.c++}handleChange(G,X){this.d=!0}endUpdate(G){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function Pe(te,G){return new _e(te,G).emitter.event}b.fromObservable=Pe})(o=t.Event||(t.Event={}));class p{constructor(f){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${f}_${p.c++}`,p.all.add(this)}start(f){this.d=new _.StopWatch(!0),this.listenerCount=f}stop(){if(this.d){const f=this.d.elapsed();this.durations.push(f),this.elapsedOverall+=f,this.invocationCount+=1,this.d=void 0}}}t.EventProfiling=p,p.all=new Set,p.c=0;let y=-1;function w(b){const f=y;return y=b,{dispose(){y=f}}}t.setGlobalLeakWarningThreshold=w;class v{constructor(f,u=Math.random().toString(18).slice(2,5)){this.threshold=f,this.name=u,this.d=0}dispose(){this.c?.clear()}check(f,u){const R=this.threshold;if(R<=0||u<R)return;this.c||(this.c=new Map);const T=this.c.get(f.value)||0;if(this.c.set(f.value,T+1),this.d-=1,this.d<=0){this.d=R*.5;let O,C=0;for(const[H,z]of this.c)(!O||C<z)&&(O=H,C=z);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${C}):`),console.warn(O)}return()=>{const O=this.c.get(f.value)||0;this.c.set(f.value,O-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(f){this.value=f}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class A{constructor(f,u,R){this.callback=f,this.callbackThis=u,this.stack=R,this.subscription=new F.SafeDisposable}invoke(f){this.callback.call(this.callbackThis,f)}}class D{constructor(f){this.j=!1,this.d=f,this.f=y>0||this.d?.leakWarningThreshold?new v(this.d?.leakWarningThreshold??y):void 0,this.g=this.d?._profName?new p(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(m){const f=Array.from(this.q);queueMicrotask(()=>{for(const u of f)u.subscription.isset()&&(u.subscription.unset(),u.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(f,u,R)=>{if(this.q||(this.q=new n.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),F.Disposable.None;const T=this.q.isEmpty();T&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let O,C;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(C=e.create(),O=this.f.check(C,this.q.size+1)),m&&(C=C??e.create());const H=new A(f,u,C),z=this.q.push(H);T&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,f,u);const ee=H.subscription.set(()=>{O?.(),this.j||(z(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return R instanceof F.DisposableStore?R.add(ee):Array.isArray(R)&&R.push(ee),ee}),this.l}fire(f){if(this.q){this.m||(this.m=new L);for(const u of this.q)this.m.push(this,u,f);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}t.Emitter=D;class E{constructor(){this.c=new n.LinkedList}get size(){return this.c.size}push(f,u,R){this.c.push(new h(f,u,R))}clear(f){const u=new n.LinkedList;for(const R of this.c)R.emitter!==f&&u.push(R);this.c=u}deliver(){for(;this.c.size>0;){const f=this.c.shift();try{f.listener.invoke(f.event)}catch(u){(0,M.onUnexpectedError)(u)}}}}t.EventDeliveryQueue=E;class L extends E{clear(f){this.c.clear()}}class h{constructor(f,u,R){this.emitter=f,this.listener=u,this.event=R}}class g extends D{async fireAsync(f,u,R){if(!!this.q){this.c||(this.c=new n.LinkedList);for(const T of this.q)this.c.push([T,f]);for(;this.c.size>0&&!u.isCancellationRequested;){const[T,O]=this.c.shift(),C=[],H={...O,token:u,waitUntil:z=>{if(Object.isFrozen(C))throw new Error("waitUntil can NOT be called asynchronous");R&&(z=R(z,T.callback)),C.push(z)}};try{T.invoke(H)}catch(z){(0,M.onUnexpectedError)(z);continue}Object.freeze(C),await Promise.allSettled(C).then(z=>{for(const ee of z)ee.status==="rejected"&&(0,M.onUnexpectedError)(ee.reason)})}}}}t.AsyncEmitter=g;class l extends D{constructor(f){super(f),this.h=0,this.s=new n.LinkedList,this.t=f?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const f=Array.from(this.s);this.s.clear(),super.fire(this.t(f))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(f){this.q&&(this.h!==0?this.s.push(f):super.fire(f))}}t.PauseableEmitter=l;class r extends l{constructor(f){super(f),this.c=f.delay??100}fire(f){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(f)}}t.DebounceEmitter=r;class s extends D{constructor(f){super(f),this.c=[],this.h=f?.merge}fire(f){!this.hasListeners()||(this.c.push(f),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(u=>super.fire(u)),this.c=[]}))}}t.MicrotaskEmitter=s;class d{constructor(){this.d=!1,this.f=[],this.c=new D({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(f){const u={event:f,listener:null};this.f.push(u),this.d&&this.j(u);const R=()=>{this.d&&this.k(u);const T=this.f.indexOf(u);this.f.splice(T,1)};return(0,F.toDisposable)((0,S.once)(R))}g(){this.d=!0,this.f.forEach(f=>this.j(f))}h(){this.d=!1,this.f.forEach(f=>this.k(f))}j(f){f.listener=f.event(u=>this.c.fire(u))}k(f){f.listener&&f.listener.dispose(),f.listener=null}dispose(){this.c.dispose()}}t.EventMultiplexer=d;class c{constructor(){this.c=[]}wrapEvent(f){return(u,R,T)=>f(O=>{const C=this.c[this.c.length-1];C?C.push(()=>u.call(R,O)):u.call(R,O)},void 0,T)}bufferEvents(f){const u=[];this.c.push(u);const R=f();return this.c.pop(),u.forEach(T=>T()),R}}t.EventBufferer=c;class N{constructor(){this.c=!1,this.d=o.None,this.f=F.Disposable.None,this.g=new D({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(f){this.d=f,this.c&&(this.f.dispose(),this.f=f(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}t.Relay=N}),Q(J[22],K([0,1,9]),function(q,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const S=Object.freeze(function(m,a){const o=setTimeout(m.bind(a),0);return{dispose(){clearTimeout(o)}}});var F;(function(m){function a(o){return o===m.None||o===m.Cancelled||o instanceof n?!0:!o||typeof o!="object"?!1:typeof o.isCancellationRequested=="boolean"&&typeof o.onCancellationRequested=="function"}m.isCancellationToken=a,m.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:M.Event.None}),m.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:S})})(F=t.CancellationToken||(t.CancellationToken={}));class n{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?S:(this.b||(this.b=new M.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class _{constructor(a){this.a=void 0,this.b=void 0,this.b=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new n),this.a}cancel(){this.a?this.a instanceof n&&this.a.cancel():this.a=F.Cancelled}dispose(a=!1){a&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof n&&this.a.dispose():this.a=F.None}}t.CancellationTokenSource=_}),Q(J[45],K([0,1,22]),function(q,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class S{constructor(m){this.b=m,this.a=null}get(){if(this.a)return this.a;const m=new M.CancellationTokenSource,a=this.b(m.token);return this.a={promise:a,dispose:()=>{this.a=null,m.cancel(),m.dispose()}},this.a}}t.Cache=S;class F{constructor(m){this.c=m,this.a=void 0,this.b=void 0}get(m){const a=JSON.stringify(m);return this.b!==a&&(this.b=a,this.a=this.c(m)),this.a}}t.LRUCachedFunction=F;class n{get cachedValues(){return this.a}constructor(m){this.b=m,this.a=new Map}get(m){if(this.a.has(m))return this.a.get(m);const a=this.b(m);return this.a.set(m,a),a}}t.CachedFunction=n}),Q(J[4],K([0,1,45,28]),function(q,t,M,S){"use strict";var F;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function n(P){return!P||typeof P!="string"?!0:P.trim().length===0}t.isFalsyOrWhitespace=n;const _=/{(\d+)}/g;function m(P,...B){return B.length===0?P:P.replace(_,function(V,$){const x=parseInt($,10);return isNaN(x)||x<0||x>=B.length?V:B[x]})}t.format=m;const a=/{([^}]+)}/g;function o(P,B){return P.replace(a,(V,$)=>B[$]??V)}t.format2=o;function p(P){return P.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}t.escape=p;function y(P){return P.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=y;function w(P,B){let V=0;const $=B.charCodeAt(0);for(let x=P.length-1;x>=0;x--)P.charCodeAt(x)===$&&V++;return V}t.count=w;function v(P,B,V="\u2026"){return P.length<=B?P:`${P.substr(0,B)}${V}`}t.truncate=v;function e(P,B=" "){const V=A(P,B);return D(V,B)}t.trim=e;function A(P,B){if(!P||!B)return P;const V=B.length;if(V===0||P.length===0)return P;let $=0;for(;P.indexOf(B,$)===$;)$=$+V;return P.substring($)}t.ltrim=A;function D(P,B){if(!P||!B)return P;const V=B.length,$=P.length;if(V===0||$===0)return P;let x=$,se=-1;for(;se=P.lastIndexOf(B,x-1),!(se===-1||se+V!==x);){if(se===0)return"";x=se}return P.substring(0,x)}t.rtrim=D;function E(P){return P.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=E;function L(P){return P.replace(/\*/g,"")}t.stripWildcards=L;function h(P,B,V={}){if(!P)throw new Error("Cannot create regex from empty string");B||(P=y(P)),V.wholeWord&&(/\B/.test(P.charAt(0))||(P="\\b"+P),/\B/.test(P.charAt(P.length-1))||(P=P+"\\b"));let $="";return V.global&&($+="g"),V.matchCase||($+="i"),V.multiline&&($+="m"),V.unicode&&($+="u"),new RegExp(P,$)}t.createRegExp=h;function g(P){return P.source==="^"||P.source==="^$"||P.source==="$"||P.source==="^\\s*$"?!1:!!(P.exec("")&&P.lastIndex===0)}t.regExpLeadsToEndlessLoop=g;function l(P){return!!P.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=l;function r(P){return(P.global?"g":"")+(P.ignoreCase?"i":"")+(P.multiline?"m":"")+(P.unicode?"u":"")}t.regExpFlags=r;function s(P){return P.split(/\r\n|\r|\n/)}t.splitLines=s;function d(P){for(let B=0,V=P.length;B<V;B++){const $=P.charCodeAt(B);if($!==32&&$!==9)return B}return-1}t.firstNonWhitespaceIndex=d;function c(P,B=0,V=P.length){for(let $=B;$<V;$++){const x=P.charCodeAt($);if(x!==32&&x!==9)return P.substring(B,$)}return P.substring(B,V)}t.getLeadingWhitespace=c;function N(P,B=P.length-1){for(let V=B;V>=0;V--){const $=P.charCodeAt(V);if($!==32&&$!==9)return V}return-1}t.lastNonWhitespaceIndex=N;function b(P,B,V){const $=[];let x=0;for(const se of P.matchAll(B)){if($.push(P.slice(x,se.index)),se.index===void 0)throw new Error("match.index should be defined");x=se.index+se[0].length,$.push(V(se[0],...se.slice(1),se.index,P,se.groups))}return $.push(P.slice(x)),Promise.all($).then(se=>se.join(""))}t.replaceAsync=b;function f(P,B){return P<B?-1:P>B?1:0}t.compare=f;function u(P,B,V=0,$=P.length,x=0,se=B.length){for(;V<$&&x<se;V++,x++){const be=P.charCodeAt(V),le=B.charCodeAt(x);if(be<le)return-1;if(be>le)return 1}const ce=$-V,ye=se-x;return ce<ye?-1:ce>ye?1:0}t.compareSubstring=u;function R(P,B){return T(P,B,0,P.length,0,B.length)}t.compareIgnoreCase=R;function T(P,B,V=0,$=P.length,x=0,se=B.length){for(;V<$&&x<se;V++,x++){let be=P.charCodeAt(V),le=B.charCodeAt(x);if(be===le)continue;if(be>=128||le>=128)return u(P.toLowerCase(),B.toLowerCase(),V,$,x,se);C(be)&&(be-=32),C(le)&&(le-=32);const ge=be-le;if(ge!==0)return ge}const ce=$-V,ye=se-x;return ce<ye?-1:ce>ye?1:0}t.compareSubstringIgnoreCase=T;function O(P){return P>=48&&P<=57}t.isAsciiDigit=O;function C(P){return P>=97&&P<=122}t.isLowerAsciiLetter=C;function H(P){return P>=65&&P<=90}t.isUpperAsciiLetter=H;function z(P,B){return P.length===B.length&&T(P,B)===0}t.equalsIgnoreCase=z;function ee(P,B){const V=B.length;return B.length>P.length?!1:T(P,B,0,V)===0}t.startsWithIgnoreCase=ee;function ne(P,B){const V=Math.min(P.length,B.length);let $;for($=0;$<V;$++)if(P.charCodeAt($)!==B.charCodeAt($))return $;return V}t.commonPrefixLength=ne;function Y(P,B){const V=Math.min(P.length,B.length);let $;const x=P.length-1,se=B.length-1;for($=0;$<V;$++)if(P.charCodeAt(x-$)!==B.charCodeAt(se-$))return $;return V}t.commonSuffixLength=Y;function Z(P){return 55296<=P&&P<=56319}t.isHighSurrogate=Z;function i(P){return 56320<=P&&P<=57343}t.isLowSurrogate=i;function Le(P,B){return(P-55296<<10)+(B-56320)+65536}t.computeCodePoint=Le;function Ae(P,B,V){const $=P.charCodeAt(V);if(Z($)&&V+1<B){const x=P.charCodeAt(V+1);if(i(x))return Le($,x)}return $}t.getNextCodePoint=Ae;function de(P,B){const V=P.charCodeAt(B-1);if(i(V)&&B>1){const $=P.charCodeAt(B-2);if(Z($))return Le($,V)}return V}class Ee{get offset(){return this.e}constructor(B,V=0){this.c=B,this.d=B.length,this.e=V}setOffset(B){this.e=B}prevCodePoint(){const B=de(this.c,this.e);return this.e-=B>=65536?2:1,B}nextCodePoint(){const B=Ae(this.c,this.d,this.e);return this.e+=B>=65536?2:1,B}eol(){return this.e>=this.d}}t.CodePointIterator=Ee;class we{get offset(){return this.c.offset}constructor(B,V=0){this.c=new Ee(B,V)}nextGraphemeLength(){const B=pe.getInstance(),V=this.c,$=V.offset;let x=B.getGraphemeBreakType(V.nextCodePoint());for(;!V.eol();){const se=V.offset,ce=B.getGraphemeBreakType(V.nextCodePoint());if(Ie(x,ce)){V.setOffset(se);break}x=ce}return V.offset-$}prevGraphemeLength(){const B=pe.getInstance(),V=this.c,$=V.offset;let x=B.getGraphemeBreakType(V.prevCodePoint());for(;V.offset>0;){const se=V.offset,ce=B.getGraphemeBreakType(V.prevCodePoint());if(Ie(ce,x)){V.setOffset(se);break}x=ce}return $-V.offset}eol(){return this.c.eol()}}t.GraphemeIterator=we;function Ne(P,B){return new we(P,B).nextGraphemeLength()}t.nextCharLength=Ne;function Re(P,B){return new we(P,B).prevGraphemeLength()}t.prevCharLength=Re;function De(P,B){B>0&&i(P.charCodeAt(B))&&B--;const V=B+Ne(P,B);return[V-Re(P,V),V]}t.getCharContainingOffset=De;function Fe(P){const B=new we(P);let V=0;for(;!B.eol();)V++,B.nextGraphemeLength();return V}t.charCount=Fe;let _e;function Pe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function te(P){return _e||(_e=Pe()),_e.test(P)}t.containsRTL=te;const G=/^[\t\n\r\x20-\x7E]*$/;function X(P){return G.test(P)}t.isBasicASCII=X,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function k(P){return t.UNUSUAL_LINE_TERMINATORS.test(P)}t.containsUnusualLineTerminators=k;function I(P){return P>=11904&&P<=55215||P>=63744&&P<=64255||P>=65281&&P<=65374}t.isFullWidthCharacter=I;function U(P){return P>=127462&&P<=127487||P===8986||P===8987||P===9200||P===9203||P>=9728&&P<=10175||P===11088||P===11093||P>=127744&&P<=128591||P>=128640&&P<=128764||P>=128992&&P<=129008||P>=129280&&P<=129535||P>=129648&&P<=129782}t.isEmojiImprecise=U;function W(P,B){if(P.length<B)return P;const V=/\b/g;let $=0;for(;V.test(P)&&!(P.length-V.lastIndex<B);)$=V.lastIndex,V.lastIndex+=1;return P.substring($).replace(/^\s/,"")}t.lcut=W;const j=/\x1B\x5B[12]?K/g,ie=/\x1b\[\d+m/g,re=/\x1b\[0?m/g;function oe(P){return P&&(P=P.replace(j,""),P=P.replace(ie,""),P=P.replace(re,"")),P}t.removeAnsiEscapeCodes=oe,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ae(P){return!!(P&&P.length>0&&P.charCodeAt(0)===65279)}t.startsWithUTF8BOM=ae;function fe(P){return ae(P)?P.substr(1):P}t.stripUTF8BOM=fe;function he(P,B){if(!P||!B||P.length<B.length)return!1;const V=B.length,$=P.toLowerCase();let x=0,se=-1;for(;x<V;){const ce=$.indexOf(B[x],se+1);if(ce<0)return!1;se=ce,x++}return!0}t.fuzzyContains=he;function Se(P,B=!1){return P?(B&&(P=P.replace(/\\./g,"")),P.toLowerCase()!==P):!1}t.containsUppercaseCharacter=Se;function Be(P){return P.charAt(0).toUpperCase()+P.slice(1)}t.uppercaseFirstLetter=Be;function qe(P,B=1){if(B===0)return"";let V=-1;do V=P.indexOf(`
`,V+1),B--;while(B>0&&V>=0);return V===-1?P:(P[V-1]==="\r"&&V--,P.substr(0,V))}t.getNLines=qe;function We(P){return P=P%(2*26),P<26?String.fromCharCode(97+P):String.fromCharCode(65+P-26)}t.singleLetterHash=We;function Ve(P){return pe.getInstance().getGraphemeBreakType(P)}t.getGraphemeBreakType=Ve;function Ie(P,B){return P===0?B!==5&&B!==7:P===2&&B===3?!1:P===4||P===2||P===3||B===4||B===2||B===3?!0:!(P===8&&(B===8||B===9||B===11||B===12)||(P===11||P===9)&&(B===9||B===10)||(P===12||P===10)&&B===10||B===5||B===13||B===7||P===1||P===13&&B===14||P===6&&B===6)}var He;(function(P){P[P.Other=0]="Other",P[P.Prepend=1]="Prepend",P[P.CR=2]="CR",P[P.LF=3]="LF",P[P.Control=4]="Control",P[P.Extend=5]="Extend",P[P.Regional_Indicator=6]="Regional_Indicator",P[P.SpacingMark=7]="SpacingMark",P[P.L=8]="L",P[P.V=9]="V",P[P.T=10]="T",P[P.LV=11]="LV",P[P.LVT=12]="LVT",P[P.ZWJ=13]="ZWJ",P[P.Extended_Pictographic=14]="Extended_Pictographic"})(He=t.GraphemeBreakType||(t.GraphemeBreakType={}));class pe{static getInstance(){return pe.c||(pe.c=new pe),pe.c}constructor(){this.d=je()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const V=this.d,$=V.length/3;let x=1;for(;x<=$;)if(B<V[3*x])x=2*x;else if(B>V[3*x+1])x=2*x+1;else return V[3*x+2];return 0}}pe.c=null;function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(P,B){if(P===0)return 0;const V=$e(P,B);if(V!==void 0)return V;const $=new Ee(B,P);return $.prevCodePoint(),$.offset}t.getLeftDeleteOffset=ze;function $e(P,B){const V=new Ee(B,P);let $=V.prevCodePoint();for(;Ge($)||$===65039||$===8419;){if(V.offset===0)return;$=V.prevCodePoint()}if(!U($))return;let x=V.offset;return x>0&&V.prevCodePoint()===8205&&(x=V.offset),x}function Ge(P){return 127995<=P&&P<=127999}var Ue;(function(P){P[P.zwj=8205]="zwj",P[P.emojiVariantSelector=65039]="emojiVariantSelector",P[P.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={})),t.noBreakWhitespace="\xA0";class me{static getInstance(B){return me.d.get(Array.from(B))}static getLocales(){return me.e.value}constructor(B){this.f=B}isAmbiguous(B){return this.f.has(B)}getPrimaryConfusable(B){return this.f.get(B)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.AmbiguousCharacters=me,F=me,me.c=new S.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),me.d=new M.LRUCachedFunction(P=>{function B(le){const ge=new Map;for(let ve=0;ve<le.length;ve+=2)ge.set(le[ve],le[ve+1]);return ge}function V(le,ge){const ve=new Map(le);for(const[ke,Te]of ge)ve.set(ke,Te);return ve}function $(le,ge){if(!le)return ge;const ve=new Map;for(const[ke,Te]of le)ge.has(ke)&&ve.set(ke,Te);return ve}const x=F.c.value;let se=P.filter(le=>!le.startsWith("_")&&le in x);se.length===0&&(se=["_default"]);let ce;for(const le of se){const ge=B(x[le]);ce=$(ce,ge)}const ye=B(x._common),be=V(ye,ce);return new me(be)}),me.e=new S.Lazy(()=>Object.keys(me.c.value).filter(P=>!P.startsWith("_")));class Me{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Me.c())),this.d}static isInvisibleCharacter(B){return Me.e().has(B)}static get codePoints(){return Me.e()}}t.InvisibleCharacters=Me,Me.d=void 0}),Q(J[46],K([0,1,4]),function(q,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function S(E){return F(E,0)}t.hash=S;function F(E,L){switch(typeof E){case"object":return E===null?n(349,L):Array.isArray(E)?a(E,L):o(E,L);case"string":return m(E,L);case"boolean":return _(E,L);case"number":return n(E,L);case"undefined":return n(937,L);default:return n(617,L)}}t.doHash=F;function n(E,L){return(L<<5)-L+E|0}t.numberHash=n;function _(E,L){return n(E?433:863,L)}function m(E,L){L=n(149417,L);for(let h=0,g=E.length;h<g;h++)L=n(E.charCodeAt(h),L);return L}t.stringHash=m;function a(E,L){return L=n(104579,L),E.reduce((h,g)=>F(g,h),L)}function o(E,L){return L=n(181387,L),Object.keys(E).sort().reduce((h,g)=>(h=m(g,h),F(E[g],h)),L)}class p{constructor(){this.g=0}get value(){return this.g}hash(L){return this.g=F(L,this.g),this.g}}t.Hasher=p;var y;(function(E){E[E.BLOCK_SIZE=64]="BLOCK_SIZE",E[E.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function w(E,L,h=32){const g=h-L,l=~((1<<g)-1);return(E<<L|(l&E)>>>g)>>>0}function v(E,L=0,h=E.byteLength,g=0){for(let l=0;l<h;l++)E[L+l]=g}function e(E,L,h="0"){for(;E.length<L;)E=h+E;return E}function A(E,L=32){return E instanceof ArrayBuffer?Array.from(new Uint8Array(E)).map(h=>h.toString(16).padStart(2,"0")).join(""):e((E>>>0).toString(16),L/4)}t.toHexString=A;class D{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(L){const h=L.length;if(h===0)return;const g=this.p;let l=this.r,r=this.u,s,d;for(r!==0?(s=r,d=-1,r=0):(s=L.charCodeAt(0),d=0);;){let c=s;if(M.isHighSurrogate(s))if(d+1<h){const N=L.charCodeAt(d+1);M.isLowSurrogate(N)?(d++,c=M.computeCodePoint(s,N)):c=65533}else{r=s;break}else M.isLowSurrogate(s)&&(c=65533);if(l=this.w(g,l,c),d++,d<h)s=L.charCodeAt(d);else break}this.r=l,this.u=r}w(L,h,g){return g<128?L[h++]=g:g<2048?(L[h++]=192|(g&1984)>>>6,L[h++]=128|(g&63)>>>0):g<65536?(L[h++]=224|(g&61440)>>>12,L[h++]=128|(g&4032)>>>6,L[h++]=128|(g&63)>>>0):(L[h++]=240|(g&1835008)>>>18,L[h++]=128|(g&258048)>>>12,L[h++]=128|(g&4032)>>>6,L[h++]=128|(g&63)>>>0),h>=64&&(this.y(),h-=64,this.t+=64,L[0]=L[64+0],L[1]=L[64+1],L[2]=L[64+2]),h}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),A(this.h)+A(this.l)+A(this.m)+A(this.n)+A(this.o)}x(){this.p[this.r++]=128,v(this.p,this.r),this.r>56&&(this.y(),v(this.p));const L=8*this.t;this.q.setUint32(56,Math.floor(L/4294967296),!1),this.q.setUint32(60,L%4294967296,!1),this.y()}y(){const L=D.g,h=this.q;for(let f=0;f<64;f+=4)L.setUint32(f,h.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)L.setUint32(f,w(L.getUint32(f-12,!1)^L.getUint32(f-32,!1)^L.getUint32(f-56,!1)^L.getUint32(f-64,!1),1),!1);let g=this.h,l=this.l,r=this.m,s=this.n,d=this.o,c,N,b;for(let f=0;f<80;f++)f<20?(c=l&r|~l&s,N=1518500249):f<40?(c=l^r^s,N=1859775393):f<60?(c=l&r|l&s|r&s,N=2400959708):(c=l^r^s,N=3395469782),b=w(g,5)+c+d+N+L.getUint32(f*4,!1)&4294967295,d=s,s=r,r=w(l,30),l=g,g=b;this.h=this.h+g&4294967295,this.l=this.l+l&4294967295,this.m=this.m+r&4294967295,this.n=this.n+s&4294967295,this.o=this.o+d&4294967295}}t.StringSHA1=D,D.g=new DataView(new ArrayBuffer(320))}),Q(J[23],K([0,1,25,46]),function(q,t,M,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class F{constructor(w){this.a=w}getElements(){const w=this.a,v=new Int32Array(w.length);for(let e=0,A=w.length;e<A;e++)v[e]=w.charCodeAt(e);return v}}t.StringDiffSequence=F;function n(y,w,v){return new p(new F(y),new F(w)).ComputeDiff(v).changes}t.stringDiff=n;class _{static Assert(w,v){if(!w)throw new Error(v)}}class m{static Copy(w,v,e,A,D){for(let E=0;E<D;E++)e[A+E]=w[v+E]}static Copy2(w,v,e,A,D){for(let E=0;E<D;E++)e[A+E]=w[v+E]}}var a;(function(y){y[y.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(a||(a={}));class o{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new M.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(w,v){this.b=Math.min(this.b,w),this.c=Math.min(this.c,v),this.d++}AddModifiedElement(w,v){this.b=Math.min(this.b,w),this.c=Math.min(this.c,v),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class p{constructor(w,v,e=null){this.a=e,this.b=w,this.c=v;const[A,D,E]=p.o(w),[L,h,g]=p.o(v);this.d=E&&g,this.e=A,this.f=D,this.g=L,this.h=h,this.k=[],this.m=[]}static n(w){return w.length>0&&typeof w[0]=="string"}static o(w){const v=w.getElements();if(p.n(v)){const e=new Int32Array(v.length);for(let A=0,D=v.length;A<D;A++)e[A]=(0,S.stringHash)(v[A],0);return[v,e,!0]}return v instanceof Int32Array?[[],v,!1]:[[],new Int32Array(v),!1]}p(w,v){return this.f[w]!==this.h[v]?!1:this.d?this.e[w]===this.g[v]:!0}q(w,v){if(!this.p(w,v))return!1;const e=p.r(this.b,w),A=p.r(this.c,v);return e===A}static r(w,v){return typeof w.getStrictElement=="function"?w.getStrictElement(v):null}s(w,v){return this.f[w]!==this.f[v]?!1:this.d?this.e[w]===this.e[v]:!0}u(w,v){return this.h[w]!==this.h[v]?!1:this.d?this.g[w]===this.g[v]:!0}ComputeDiff(w){return this.v(0,this.f.length-1,0,this.h.length-1,w)}v(w,v,e,A,D){const E=[!1];let L=this.w(w,v,e,A,E);return D&&(L=this.z(L)),{quitEarly:E[0],changes:L}}w(w,v,e,A,D){for(D[0]=!1;w<=v&&e<=A&&this.p(w,e);)w++,e++;for(;v>=w&&A>=e&&this.p(v,A);)v--,A--;if(w>v||e>A){let r;return e<=A?(_.Assert(w===v+1,"originalStart should only be one more than originalEnd"),r=[new M.DiffChange(w,0,e,A-e+1)]):w<=v?(_.Assert(e===A+1,"modifiedStart should only be one more than modifiedEnd"),r=[new M.DiffChange(w,v-w+1,e,0)]):(_.Assert(w===v+1,"originalStart should only be one more than originalEnd"),_.Assert(e===A+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const E=[0],L=[0],h=this.y(w,v,e,A,E,L,D),g=E[0],l=L[0];if(h!==null)return h;if(!D[0]){const r=this.w(w,g,e,l,D);let s=[];return D[0]?s=[new M.DiffChange(g+1,v-(g+1)+1,l+1,A-(l+1)+1)]:s=this.w(g+1,v,l+1,A,D),this.H(r,s)}return[new M.DiffChange(w,v-w+1,e,A-e+1)]}x(w,v,e,A,D,E,L,h,g,l,r,s,d,c,N,b,f,u){let R=null,T=null,O=new o,C=v,H=e,z=d[0]-b[0]-A,ee=-1073741824,ne=this.k.length-1;do{const Y=z+w;Y===C||Y<H&&g[Y-1]<g[Y+1]?(r=g[Y+1],c=r-z-A,r<ee&&O.MarkNextChange(),ee=r,O.AddModifiedElement(r+1,c),z=Y+1-w):(r=g[Y-1]+1,c=r-z-A,r<ee&&O.MarkNextChange(),ee=r-1,O.AddOriginalElement(r,c+1),z=Y-1-w),ne>=0&&(g=this.k[ne],w=g[0],C=1,H=g.length-1)}while(--ne>=-1);if(R=O.getReverseChanges(),u[0]){let Y=d[0]+1,Z=b[0]+1;if(R!==null&&R.length>0){const i=R[R.length-1];Y=Math.max(Y,i.getOriginalEnd()),Z=Math.max(Z,i.getModifiedEnd())}T=[new M.DiffChange(Y,s-Y+1,Z,N-Z+1)]}else{O=new o,C=E,H=L,z=d[0]-b[0]-h,ee=1073741824,ne=f?this.m.length-1:this.m.length-2;do{const Y=z+D;Y===C||Y<H&&l[Y-1]>=l[Y+1]?(r=l[Y+1]-1,c=r-z-h,r>ee&&O.MarkNextChange(),ee=r+1,O.AddOriginalElement(r+1,c+1),z=Y+1-D):(r=l[Y-1],c=r-z-h,r>ee&&O.MarkNextChange(),ee=r,O.AddModifiedElement(r+1,c+1),z=Y-1-D),ne>=0&&(l=this.m[ne],D=l[0],C=1,H=l.length-1)}while(--ne>=-1);T=O.getChanges()}return this.H(R,T)}y(w,v,e,A,D,E,L){let h=0,g=0,l=0,r=0,s=0,d=0;w--,e--,D[0]=0,E[0]=0,this.k=[],this.m=[];const c=v-w+(A-e),N=c+1,b=new Int32Array(N),f=new Int32Array(N),u=A-e,R=v-w,T=w-e,O=v-A,H=(R-u)%2===0;b[u]=w,f[R]=v,L[0]=!1;for(let z=1;z<=c/2+1;z++){let ee=0,ne=0;l=this.J(u-z,z,u,N),r=this.J(u+z,z,u,N);for(let Z=l;Z<=r;Z+=2){Z===l||Z<r&&b[Z-1]<b[Z+1]?h=b[Z+1]:h=b[Z-1]+1,g=h-(Z-u)-T;const i=h;for(;h<v&&g<A&&this.p(h+1,g+1);)h++,g++;if(b[Z]=h,h+g>ee+ne&&(ee=h,ne=g),!H&&Math.abs(Z-R)<=z-1&&h>=f[Z])return D[0]=h,E[0]=g,i<=f[Z]&&1447>0&&z<=1447+1?this.x(u,l,r,T,R,s,d,O,b,f,h,v,D,g,A,E,H,L):null}const Y=(ee-w+(ne-e)-z)/2;if(this.a!==null&&!this.a(ee,Y))return L[0]=!0,D[0]=ee,E[0]=ne,Y>0&&1447>0&&z<=1447+1?this.x(u,l,r,T,R,s,d,O,b,f,h,v,D,g,A,E,H,L):(w++,e++,[new M.DiffChange(w,v-w+1,e,A-e+1)]);s=this.J(R-z,z,R,N),d=this.J(R+z,z,R,N);for(let Z=s;Z<=d;Z+=2){Z===s||Z<d&&f[Z-1]>=f[Z+1]?h=f[Z+1]-1:h=f[Z-1],g=h-(Z-R)-O;const i=h;for(;h>w&&g>e&&this.p(h,g);)h--,g--;if(f[Z]=h,H&&Math.abs(Z-u)<=z&&h<=b[Z])return D[0]=h,E[0]=g,i>=b[Z]&&1447>0&&z<=1447+1?this.x(u,l,r,T,R,s,d,O,b,f,h,v,D,g,A,E,H,L):null}if(z<=1447){let Z=new Int32Array(r-l+2);Z[0]=u-l+1,m.Copy2(b,l,Z,1,r-l+1),this.k.push(Z),Z=new Int32Array(d-s+2),Z[0]=R-s+1,m.Copy2(f,s,Z,1,d-s+1),this.m.push(Z)}}return this.x(u,l,r,T,R,s,d,O,b,f,h,v,D,g,A,E,H,L)}z(w){for(let v=0;v<w.length;v++){const e=w[v],A=v<w.length-1?w[v+1].originalStart:this.f.length,D=v<w.length-1?w[v+1].modifiedStart:this.h.length,E=e.originalLength>0,L=e.modifiedLength>0;for(;e.originalStart+e.originalLength<A&&e.modifiedStart+e.modifiedLength<D&&(!E||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!L||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const g=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!g)break;e.originalStart++,e.modifiedStart++}const h=[null];if(v<w.length-1&&this.I(w[v],w[v+1],h)){w[v]=h[0],w.splice(v+1,1),v--;continue}}for(let v=w.length-1;v>=0;v--){const e=w[v];let A=0,D=0;if(v>0){const r=w[v-1];A=r.originalStart+r.originalLength,D=r.modifiedStart+r.modifiedLength}const E=e.originalLength>0,L=e.modifiedLength>0;let h=0,g=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const s=e.originalStart-r,d=e.modifiedStart-r;if(s<A||d<D||E&&!this.s(s,s+e.originalLength)||L&&!this.u(d,d+e.modifiedLength))break;const N=(s===A&&d===D?5:0)+this.G(s,e.originalLength,d,e.modifiedLength);N>g&&(g=N,h=r)}e.originalStart-=h,e.modifiedStart-=h;const l=[null];if(v>0&&this.I(w[v-1],w[v],l)){w[v-1]=l[0],w.splice(v,1),v++;continue}}if(this.d)for(let v=1,e=w.length;v<e;v++){const A=w[v-1],D=w[v],E=D.originalStart-A.originalStart-A.originalLength,L=A.originalStart,h=D.originalStart+D.originalLength,g=h-L,l=A.modifiedStart,r=D.modifiedStart+D.modifiedLength,s=r-l;if(E<5&&g<20&&s<20){const d=this.A(L,g,l,s,E);if(d){const[c,N]=d;(c!==A.originalStart+A.originalLength||N!==A.modifiedStart+A.modifiedLength)&&(A.originalLength=c-A.originalStart,A.modifiedLength=N-A.modifiedStart,D.originalStart=c+E,D.modifiedStart=N+E,D.originalLength=h-D.originalStart,D.modifiedLength=r-D.modifiedStart)}}}return w}A(w,v,e,A,D){if(v<D||A<D)return null;const E=w+v-D+1,L=e+A-D+1;let h=0,g=0,l=0;for(let r=w;r<E;r++)for(let s=e;s<L;s++){const d=this.B(r,s,D);d>0&&d>h&&(h=d,g=r,l=s)}return h>0?[g,l]:null}B(w,v,e){let A=0;for(let D=0;D<e;D++){if(!this.p(w+D,v+D))return 0;A+=this.e[w+D].length}return A}C(w){return w<=0||w>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[w])}D(w,v){if(this.C(w)||this.C(w-1))return!0;if(v>0){const e=w+v;if(this.C(e-1)||this.C(e))return!0}return!1}E(w){return w<=0||w>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[w])}F(w,v){if(this.E(w)||this.E(w-1))return!0;if(v>0){const e=w+v;if(this.E(e-1)||this.E(e))return!0}return!1}G(w,v,e,A){const D=this.D(w,v)?1:0,E=this.F(e,A)?1:0;return D+E}H(w,v){const e=[];if(w.length===0||v.length===0)return v.length>0?v:w;if(this.I(w[w.length-1],v[0],e)){const A=new Array(w.length+v.length-1);return m.Copy(w,0,A,0,w.length-1),A[w.length-1]=e[0],m.Copy(v,1,A,w.length,v.length-1),A}else{const A=new Array(w.length+v.length);return m.Copy(w,0,A,0,w.length),m.Copy(v,0,A,w.length,v.length),A}}I(w,v,e){if(_.Assert(w.originalStart<=v.originalStart,"Left change is not less than or equal to right change"),_.Assert(w.modifiedStart<=v.modifiedStart,"Left change is not less than or equal to right change"),w.originalStart+w.originalLength>=v.originalStart||w.modifiedStart+w.modifiedLength>=v.modifiedStart){const A=w.originalStart;let D=w.originalLength;const E=w.modifiedStart;let L=w.modifiedLength;return w.originalStart+w.originalLength>=v.originalStart&&(D=v.originalStart+v.originalLength-w.originalStart),w.modifiedStart+w.modifiedLength>=v.modifiedStart&&(L=v.modifiedStart+v.modifiedLength-w.modifiedStart),e[0]=new M.DiffChange(A,D,E,L),!0}else return e[0]=null,!1}J(w,v,e,A){if(w>=0&&w<A)return w;const D=e,E=A-e-1,L=v%2===0;if(w<0){const h=D%2===0;return L===h?0:1}else{const h=E%2===0;return L===h?A-1:A-2}}}t.LcsDiff=p}),Q(J[12],K([0,1,44,5]),function(q,t,M,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const F=/^\w[\w\d+.-]*$/,n=/^\//,_=/^\/\//;function m(d,c){if(!d.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!F.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!n.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(d,c){return!d&&!c?"file":d}function o(d,c){switch(d){case"https":case"http":case"file":c?c[0]!==y&&(c=y+c):c=y;break}return c}const p="",y="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{static isUri(c){return c instanceof v?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,N,b,f,u,R=!1){typeof c=="object"?(this.scheme=c.scheme||p,this.authority=c.authority||p,this.path=c.path||p,this.query=c.query||p,this.fragment=c.fragment||p):(this.scheme=a(c,R),this.authority=N||p,this.path=o(this.scheme,b||p),this.query=f||p,this.fragment=u||p,m(this,R))}get fsPath(){return h(this,!1)}with(c){if(!c)return this;let{scheme:N,authority:b,path:f,query:u,fragment:R}=c;return N===void 0?N=this.scheme:N===null&&(N=p),b===void 0?b=this.authority:b===null&&(b=p),f===void 0?f=this.path:f===null&&(f=p),u===void 0?u=this.query:u===null&&(u=p),R===void 0?R=this.fragment:R===null&&(R=p),N===this.scheme&&b===this.authority&&f===this.path&&u===this.query&&R===this.fragment?this:new A(N,b,f,u,R)}static parse(c,N=!1){const b=w.exec(c);return b?new A(b[2]||p,s(b[4]||p),s(b[5]||p),s(b[7]||p),s(b[9]||p),N):new A(p,p,p,p,p)}static file(c){let N=p;if(S.isWindows&&(c=c.replace(/\\/g,y)),c[0]===y&&c[1]===y){const b=c.indexOf(y,2);b===-1?(N=c.substring(2),c=y):(N=c.substring(2,b),c=c.substring(b)||y)}return new A("file",N,c,p,p)}static from(c){const N=new A(c.scheme,c.authority,c.path,c.query,c.fragment);return m(N,!0),N}static joinPath(c,...N){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return S.isWindows&&c.scheme==="file"?b=v.file(M.win32.join(h(c,!0),...N)).path:b=M.posix.join(c.path,...N),c.with({path:b})}toString(c=!1){return g(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof v)return c;{const N=new A(c);return N._formatted=c.external,N._fsPath=c._sep===e?c.fsPath:null,N}}else return c}}t.URI=v;const e=S.isWindows?1:void 0;class A extends v{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(c=!1){return c?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=e),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function E(d,c,N){let b,f=-1;for(let u=0;u<d.length;u++){const R=d.charCodeAt(u);if(R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57||R===45||R===46||R===95||R===126||c&&R===47||N&&R===91||N&&R===93||N&&R===58)f!==-1&&(b+=encodeURIComponent(d.substring(f,u)),f=-1),b!==void 0&&(b+=d.charAt(u));else{b===void 0&&(b=d.substr(0,u));const T=D[R];T!==void 0?(f!==-1&&(b+=encodeURIComponent(d.substring(f,u)),f=-1),b+=T):f===-1&&(f=u)}}return f!==-1&&(b+=encodeURIComponent(d.substring(f))),b!==void 0?b:d}function L(d){let c;for(let N=0;N<d.length;N++){const b=d.charCodeAt(N);b===35||b===63?(c===void 0&&(c=d.substr(0,N)),c+=D[b]):c!==void 0&&(c+=d[N])}return c!==void 0?c:d}function h(d,c){let N;return d.authority&&d.path.length>1&&d.scheme==="file"?N=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?c?N=d.path.substr(1):N=d.path[1].toLowerCase()+d.path.substr(2):N=d.path,S.isWindows&&(N=N.replace(/\//g,"\\")),N}t.uriToFsPath=h;function g(d,c){const N=c?L:E;let b="",{scheme:f,authority:u,path:R,query:T,fragment:O}=d;if(f&&(b+=f,b+=":"),(u||f==="file")&&(b+=y,b+=y),u){let C=u.indexOf("@");if(C!==-1){const H=u.substr(0,C);u=u.substr(C+1),C=H.lastIndexOf(":"),C===-1?b+=N(H,!1,!1):(b+=N(H.substr(0,C),!1,!1),b+=":",b+=N(H.substr(C+1),!1,!0)),b+="@"}u=u.toLowerCase(),C=u.lastIndexOf(":"),C===-1?b+=N(u,!1,!0):(b+=N(u.substr(0,C),!1,!0),b+=u.substr(C))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const C=R.charCodeAt(1);C>=65&&C<=90&&(R=`/${String.fromCharCode(C+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const C=R.charCodeAt(0);C>=65&&C<=90&&(R=`${String.fromCharCode(C+32)}:${R.substr(2)}`)}b+=N(R,!0,!1)}return T&&(b+="?",b+=N(T,!1,!1)),O&&(b+="#",b+=c?O:E(O,!1,!1)),b}function l(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+l(d.substr(3)):d}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(d){return d.match(r)?d.replace(r,c=>l(c)):d}}),Q(J[57],K([0,1,6,9,7,11,5,4]),function(q,t,M,S,F,n,_,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const a="$initialize";let o=!1;function p(d){!_.isWeb||(o||(o=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(d.message))}t.logOnceWebWorkerWarning=p;var y;(function(d){d[d.Request=0]="Request",d[d.Reply=1]="Reply",d[d.SubscribeEvent=2]="SubscribeEvent",d[d.Event=3]="Event",d[d.UnsubscribeEvent=4]="UnsubscribeEvent"})(y||(y={}));class w{constructor(c,N,b,f){this.vsWorker=c,this.req=N,this.method=b,this.args=f,this.type=0}}class v{constructor(c,N,b,f){this.vsWorker=c,this.seq=N,this.res=b,this.err=f,this.type=1}}class e{constructor(c,N,b,f){this.vsWorker=c,this.req=N,this.eventName=b,this.arg=f,this.type=2}}class A{constructor(c,N,b){this.vsWorker=c,this.req=N,this.event=b,this.type=3}}class D{constructor(c,N){this.vsWorker=c,this.req=N,this.type=4}}class E{constructor(c){this.a=-1,this.g=c,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(c){this.a=c}sendMessage(c,N){const b=String(++this.b);return new Promise((f,u)=>{this.c[b]={resolve:f,reject:u},this.o(new w(this.a,b,c,N))})}listen(c,N){let b=null;const f=new S.Emitter({onWillAddFirstListener:()=>{b=String(++this.b),this.d.set(b,f),this.o(new e(this.a,b,c,N))},onDidRemoveLastListener:()=>{this.d.delete(b),this.o(new D(this.a,b)),b=null}});return f.event}handleMessage(c){!c||!c.vsWorker||this.a!==-1&&c.vsWorker!==this.a||this.h(c)}h(c){switch(c.type){case 1:return this.j(c);case 0:return this.k(c);case 2:return this.l(c);case 3:return this.m(c);case 4:return this.n(c)}}j(c){if(!this.c[c.seq]){console.warn("Got reply to unknown seq");return}const N=this.c[c.seq];if(delete this.c[c.seq],c.err){let b=c.err;c.err.$isError&&(b=new Error,b.name=c.err.name,b.message=c.err.message,b.stack=c.err.stack),N.reject(b);return}N.resolve(c.res)}k(c){const N=c.req;this.g.handleMessage(c.method,c.args).then(f=>{this.o(new v(this.a,N,f,void 0))},f=>{f.detail instanceof Error&&(f.detail=(0,M.transformErrorForSerialization)(f.detail)),this.o(new v(this.a,N,void 0,(0,M.transformErrorForSerialization)(f)))})}l(c){const N=c.req,b=this.g.handleEvent(c.eventName,c.arg)(f=>{this.o(new A(this.a,N,f))});this.f.set(N,b)}m(c){if(!this.d.has(c.req)){console.warn("Got event for unknown req");return}this.d.get(c.req).fire(c.event)}n(c){if(!this.f.has(c.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(c.req).dispose(),this.f.delete(c.req)}o(c){const N=[];if(c.type===0)for(let b=0;b<c.args.length;b++)c.args[b]instanceof ArrayBuffer&&N.push(c.args[b]);else c.type===1&&c.res instanceof ArrayBuffer&&N.push(c.res);this.g.sendMessage(c,N)}}class L extends F.Disposable{constructor(c,N,b){super();let f=null;this.a=this.B(c.create("vs/base/common/worker/simpleWorker",C=>{this.c.handleMessage(C)},C=>{f?.(C)})),this.c=new E({sendMessage:(C,H)=>{this.a.postMessage(C,H)},handleMessage:(C,H)=>{if(typeof b[C]!="function")return Promise.reject(new Error("Missing method "+C+" on main thread host."));try{return Promise.resolve(b[C].apply(b,H))}catch(z){return Promise.reject(z)}},handleEvent:(C,H)=>{if(g(C)){const z=b[C].call(b,H);if(typeof z!="function")throw new Error(`Missing dynamic event ${C} on main thread host.`);return z}if(h(C)){const z=b[C];if(typeof z!="function")throw new Error(`Missing event ${C} on main thread host.`);return z}throw new Error(`Malformed event name ${C}`)}}),this.c.setWorkerId(this.a.getId());let u=null;typeof _.globals.require<"u"&&typeof _.globals.require.getConfig=="function"?u=_.globals.require.getConfig():typeof _.globals.requirejs<"u"&&(u=_.globals.requirejs.s.contexts._.config);const R=(0,n.getAllMethodNames)(b);this.b=this.c.sendMessage(a,[this.a.getId(),JSON.parse(JSON.stringify(u)),N,R]);const T=(C,H)=>this.g(C,H),O=(C,H)=>this.c.listen(C,H);this.f=new Promise((C,H)=>{f=H,this.b.then(z=>{C(l(z,T,O))},z=>{H(z),this.h("Worker failed to load "+N,z)})})}getProxyObject(){return this.f}g(c,N){return new Promise((b,f)=>{this.b.then(()=>{this.c.sendMessage(c,N).then(b,f)},f)})}h(c,N){console.error(c),console.info(N)}}t.SimpleWorkerClient=L;function h(d){return d[0]==="o"&&d[1]==="n"&&m.isUpperAsciiLetter(d.charCodeAt(2))}function g(d){return/^onDynamic/.test(d)&&m.isUpperAsciiLetter(d.charCodeAt(9))}function l(d,c,N){const b=R=>function(){const T=Array.prototype.slice.call(arguments,0);return c(R,T)},f=R=>function(T){return N(R,T)},u={};for(const R of d){if(g(R)){u[R]=f(R);continue}if(h(R)){u[R]=N(R,void 0);continue}u[R]=b(R)}return u}class r{constructor(c,N){this.a=N,this.b=null,this.c=new E({sendMessage:(b,f)=>{c(b,f)},handleMessage:(b,f)=>this.d(b,f),handleEvent:(b,f)=>this.f(b,f)})}onmessage(c){this.c.handleMessage(c)}d(c,N){if(c===a)return this.g(N[0],N[1],N[2],N[3]);if(!this.b||typeof this.b[c]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+c));try{return Promise.resolve(this.b[c].apply(this.b,N))}catch(b){return Promise.reject(b)}}f(c,N){if(!this.b)throw new Error("Missing requestHandler");if(g(c)){const b=this.b[c].call(this.b,N);if(typeof b!="function")throw new Error(`Missing dynamic event ${c} on request handler.`);return b}if(h(c)){const b=this.b[c];if(typeof b!="function")throw new Error(`Missing event ${c} on request handler.`);return b}throw new Error(`Malformed event name ${c}`)}g(c,N,b,f){this.c.setWorkerId(c);const T=l(f,(O,C)=>this.c.sendMessage(O,C),(O,C)=>this.c.listen(O,C));return this.a?(this.b=this.a(T),Promise.resolve((0,n.getAllMethodNames)(this.b))):(N&&(typeof N.baseUrl<"u"&&delete N.baseUrl,typeof N.paths<"u"&&typeof N.paths.vs<"u"&&delete N.paths.vs,typeof N.trustedTypesPolicy!==void 0&&delete N.trustedTypesPolicy,N.catchError=!0,_.globals.require.config(N)),new Promise((O,C)=>{(_.globals.require||q)([b],z=>{if(this.b=z.create(T),!this.b){C(new Error("No RequestHandler!"));return}O((0,n.getAllMethodNames)(this.b))},C)}))}}t.SimpleWorkerServer=r;function s(d){return new r(d,null)}t.create=s}),Q(J[24],K([0,1,23,20,4,2,10]),function(q,t,M,S,F,n,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=t.SmartLinesDiffComputer=void 0;const m=3;class a{computeDiff(g,l,r){const d=new A(g,l,{maxComputationTime:r.maxComputationTimeMs,shouldIgnoreTrimWhitespace:r.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),c=[];let N=null;for(const b of d.changes){let f;b.originalEndLineNumber===0?f=new S.LineRange(b.originalStartLineNumber+1,b.originalStartLineNumber+1):f=new S.LineRange(b.originalStartLineNumber,b.originalEndLineNumber+1);let u;b.modifiedEndLineNumber===0?u=new S.LineRange(b.modifiedStartLineNumber+1,b.modifiedStartLineNumber+1):u=new S.LineRange(b.modifiedStartLineNumber,b.modifiedEndLineNumber+1);let R=new S.LineRangeMapping(f,u,b.charChanges?.map(T=>new S.RangeMapping(new n.Range(T.originalStartLineNumber,T.originalStartColumn,T.originalEndLineNumber,T.originalEndColumn),new n.Range(T.modifiedStartLineNumber,T.modifiedStartColumn,T.modifiedEndLineNumber,T.modifiedEndColumn))));N&&(N.modifiedRange.endLineNumberExclusive===R.modifiedRange.startLineNumber||N.originalRange.endLineNumberExclusive===R.originalRange.startLineNumber)&&(R=new S.LineRangeMapping(N.originalRange.join(R.originalRange),N.modifiedRange.join(R.modifiedRange),N.innerChanges&&R.innerChanges?N.innerChanges.concat(R.innerChanges):void 0),c.pop()),c.push(R),N=R}return(0,_.assertFn)(()=>(0,_.checkAdjacentItems)(c,(b,f)=>f.originalRange.startLineNumber-b.originalRange.endLineNumberExclusive===f.modifiedRange.startLineNumber-b.modifiedRange.endLineNumberExclusive&&b.originalRange.endLineNumberExclusive<f.originalRange.startLineNumber&&b.modifiedRange.endLineNumberExclusive<f.modifiedRange.startLineNumber)),{quitEarly:d.quitEarly,changes:c}}}t.SmartLinesDiffComputer=a;function o(h,g,l,r){return new M.LcsDiff(h,g,l).ComputeDiff(r)}class p{constructor(g){const l=[],r=[];for(let s=0,d=g.length;s<d;s++)l[s]=D(g[s],1),r[s]=E(g[s],1);this.lines=g,this.a=l,this.b=r}getElements(){const g=[];for(let l=0,r=this.lines.length;l<r;l++)g[l]=this.lines[l].substring(this.a[l]-1,this.b[l]-1);return g}getStrictElement(g){return this.lines[g]}getStartLineNumber(g){return g+1}getEndLineNumber(g){return g+1}createCharSequence(g,l,r){const s=[],d=[],c=[];let N=0;for(let b=l;b<=r;b++){const f=this.lines[b],u=g?this.a[b]:1,R=g?this.b[b]:f.length+1;for(let T=u;T<R;T++)s[N]=f.charCodeAt(T-1),d[N]=b+1,c[N]=T,N++;!g&&b<r&&(s[N]=10,d[N]=b+1,c[N]=f.length+1,N++)}return new y(s,d,c)}}class y{constructor(g,l,r){this.a=g,this.b=l,this.d=r}toString(){return"["+this.a.map((g,l)=>(g===10?"\\n":String.fromCharCode(g))+`-(${this.b[l]},${this.d[l]})`).join(", ")+"]"}e(g,l){if(g<0||g>=l.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(g){return g>0&&g===this.b.length?this.getEndLineNumber(g-1):(this.e(g,this.b),this.b[g])}getEndLineNumber(g){return g===-1?this.getStartLineNumber(g+1):(this.e(g,this.b),this.a[g]===10?this.b[g]+1:this.b[g])}getStartColumn(g){return g>0&&g===this.d.length?this.getEndColumn(g-1):(this.e(g,this.d),this.d[g])}getEndColumn(g){return g===-1?this.getStartColumn(g+1):(this.e(g,this.d),this.a[g]===10?1:this.d[g]+1)}}class w{constructor(g,l,r,s,d,c,N,b){this.originalStartLineNumber=g,this.originalStartColumn=l,this.originalEndLineNumber=r,this.originalEndColumn=s,this.modifiedStartLineNumber=d,this.modifiedStartColumn=c,this.modifiedEndLineNumber=N,this.modifiedEndColumn=b}static createFromDiffChange(g,l,r){const s=l.getStartLineNumber(g.originalStart),d=l.getStartColumn(g.originalStart),c=l.getEndLineNumber(g.originalStart+g.originalLength-1),N=l.getEndColumn(g.originalStart+g.originalLength-1),b=r.getStartLineNumber(g.modifiedStart),f=r.getStartColumn(g.modifiedStart),u=r.getEndLineNumber(g.modifiedStart+g.modifiedLength-1),R=r.getEndColumn(g.modifiedStart+g.modifiedLength-1);return new w(s,d,c,N,b,f,u,R)}}function v(h){if(h.length<=1)return h;const g=[h[0]];let l=g[0];for(let r=1,s=h.length;r<s;r++){const d=h[r],c=d.originalStart-(l.originalStart+l.originalLength),N=d.modifiedStart-(l.modifiedStart+l.modifiedLength);Math.min(c,N)<m?(l.originalLength=d.originalStart+d.originalLength-l.originalStart,l.modifiedLength=d.modifiedStart+d.modifiedLength-l.modifiedStart):(g.push(d),l=d)}return g}class e{constructor(g,l,r,s,d){this.originalStartLineNumber=g,this.originalEndLineNumber=l,this.modifiedStartLineNumber=r,this.modifiedEndLineNumber=s,this.charChanges=d}static createFromDiffResult(g,l,r,s,d,c,N){let b,f,u,R,T;if(l.originalLength===0?(b=r.getStartLineNumber(l.originalStart)-1,f=0):(b=r.getStartLineNumber(l.originalStart),f=r.getEndLineNumber(l.originalStart+l.originalLength-1)),l.modifiedLength===0?(u=s.getStartLineNumber(l.modifiedStart)-1,R=0):(u=s.getStartLineNumber(l.modifiedStart),R=s.getEndLineNumber(l.modifiedStart+l.modifiedLength-1)),c&&l.originalLength>0&&l.originalLength<20&&l.modifiedLength>0&&l.modifiedLength<20&&d()){const O=r.createCharSequence(g,l.originalStart,l.originalStart+l.originalLength-1),C=s.createCharSequence(g,l.modifiedStart,l.modifiedStart+l.modifiedLength-1);if(O.getElements().length>0&&C.getElements().length>0){let H=o(O,C,d,!0).changes;N&&(H=v(H)),T=[];for(let z=0,ee=H.length;z<ee;z++)T.push(w.createFromDiffChange(H[z],O,C))}}return new e(b,f,u,R,T)}}class A{constructor(g,l,r){this.a=r.shouldComputeCharChanges,this.b=r.shouldPostProcessCharChanges,this.d=r.shouldIgnoreTrimWhitespace,this.e=r.shouldMakePrettyDiff,this.f=g,this.g=l,this.h=new p(g),this.j=new p(l),this.k=L(r.maxComputationTime),this.l=L(r.maxComputationTime===0?0:Math.min(r.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const g=o(this.h,this.j,this.k,this.e),l=g.changes,r=g.quitEarly;if(this.d){const N=[];for(let b=0,f=l.length;b<f;b++)N.push(e.createFromDiffResult(this.d,l[b],this.h,this.j,this.l,this.a,this.b));return{quitEarly:r,changes:N}}const s=[];let d=0,c=0;for(let N=-1,b=l.length;N<b;N++){const f=N+1<b?l[N+1]:null,u=f?f.originalStart:this.f.length,R=f?f.modifiedStart:this.g.length;for(;d<u&&c<R;){const T=this.f[d],O=this.g[c];if(T!==O){{let C=D(T,1),H=D(O,1);for(;C>1&&H>1;){const z=T.charCodeAt(C-2),ee=O.charCodeAt(H-2);if(z!==ee)break;C--,H--}(C>1||H>1)&&this.m(s,d+1,1,C,c+1,1,H)}{let C=E(T,1),H=E(O,1);const z=T.length+1,ee=O.length+1;for(;C<z&&H<ee;){const ne=T.charCodeAt(C-1),Y=T.charCodeAt(H-1);if(ne!==Y)break;C++,H++}(C<z||H<ee)&&this.m(s,d+1,C,z,c+1,H,ee)}}d++,c++}f&&(s.push(e.createFromDiffResult(this.d,f,this.h,this.j,this.l,this.a,this.b)),d+=f.originalLength,c+=f.modifiedLength)}return{quitEarly:r,changes:s}}m(g,l,r,s,d,c,N){if(this.n(g,l,r,s,d,c,N))return;let b;this.a&&(b=[new w(l,r,l,s,d,c,d,N)]),g.push(new e(l,l,d,d,b))}n(g,l,r,s,d,c,N){const b=g.length;if(b===0)return!1;const f=g[b-1];return f.originalEndLineNumber===0||f.modifiedEndLineNumber===0?!1:f.originalEndLineNumber===l&&f.modifiedEndLineNumber===d?(this.a&&f.charChanges&&f.charChanges.push(new w(l,r,l,s,d,c,d,N)),!0):f.originalEndLineNumber+1===l&&f.modifiedEndLineNumber+1===d?(f.originalEndLineNumber=l,f.modifiedEndLineNumber=d,this.a&&f.charChanges&&f.charChanges.push(new w(l,r,l,s,d,c,d,N)),!0):!1}}t.DiffComputer=A;function D(h,g){const l=F.firstNonWhitespaceIndex(h);return l===-1?g:l+1}function E(h,g){const l=F.lastNonWhitespaceIndex(h);return l===-1?g:l+2}function L(h){if(h===0)return()=>!0;const g=Date.now();return()=>Date.now()-g<h}}),Q(J[47],K([0,1,24,36]),function(q,t,M,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.linesDiffComputers=void 0,t.linesDiffComputers={smart:new M.SmartLinesDiffComputer,experimental:new S.StandardLinesDiffComputer}}),Q(J[48],K([0,1,4,3,40]),function(q,t,M,S,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class n{constructor(m,a,o,p){this.c=m,this.d=a,this.f=o,this.g=p,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(m){m.eol&&m.eol!==this.f&&(this.f=m.eol,this.h=null);const a=m.changes;for(const o of a)this.n(o.range),this.o(new S.Position(o.range.startLineNumber,o.range.startColumn),o.text);this.g=m.versionId,this.j=null}k(){if(!this.h){const m=this.f.length,a=this.d.length,o=new Uint32Array(a);for(let p=0;p<a;p++)o[p]=this.d[p].length+m;this.h=new F.PrefixSumComputer(o)}}l(m,a){this.d[m]=a,this.h&&this.h.setValue(m,this.d[m].length+this.f.length)}n(m){if(m.startLineNumber===m.endLineNumber){if(m.startColumn===m.endColumn)return;this.l(m.startLineNumber-1,this.d[m.startLineNumber-1].substring(0,m.startColumn-1)+this.d[m.startLineNumber-1].substring(m.endColumn-1));return}this.l(m.startLineNumber-1,this.d[m.startLineNumber-1].substring(0,m.startColumn-1)+this.d[m.endLineNumber-1].substring(m.endColumn-1)),this.d.splice(m.startLineNumber,m.endLineNumber-m.startLineNumber),this.h&&this.h.removeValues(m.startLineNumber,m.endLineNumber-m.startLineNumber)}o(m,a){if(a.length===0)return;const o=(0,M.splitLines)(a);if(o.length===1){this.l(m.lineNumber-1,this.d[m.lineNumber-1].substring(0,m.column-1)+o[0]+this.d[m.lineNumber-1].substring(m.column-1));return}o[o.length-1]+=this.d[m.lineNumber-1].substring(m.column-1),this.l(m.lineNumber-1,this.d[m.lineNumber-1].substring(0,m.column-1)+o[0]);const p=new Uint32Array(o.length-1);for(let y=1;y<o.length;y++)this.d.splice(m.lineNumber+y-1,0,o[y]),p[y-1]=o[y].length+this.f.length;this.h&&this.h.insertValues(m.lineNumber,p)}}t.MirrorTextModel=n}),Q(J[49],K([0,1,4,31,3,2,39]),function(q,t,M,S,F,n,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Searcher=t.isValidMatch=t.TextModelSearch=t.createFindMatch=t.isMultilineRegexSource=t.SearchParams=void 0;const m=999;class a{constructor(L,h,g,l){this.searchString=L,this.isRegex=h,this.matchCase=g,this.wordSeparators=l}parseSearchRequest(){if(this.searchString==="")return null;let L;this.isRegex?L=o(this.searchString):L=this.searchString.indexOf(`
`)>=0;let h=null;try{h=M.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:L,global:!0,unicode:!0})}catch{return null}if(!h)return null;let g=!this.isRegex&&!L;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new _.SearchData(h,this.wordSeparators?(0,S.getMapForWordSeparators)(this.wordSeparators):null,g?this.searchString:null)}}t.SearchParams=a;function o(E){if(!E||E.length===0)return!1;for(let L=0,h=E.length;L<h;L++){const g=E.charCodeAt(L);if(g===10)return!0;if(g===92){if(L++,L>=h)break;const l=E.charCodeAt(L);if(l===110||l===114||l===87)return!0}}return!1}t.isMultilineRegexSource=o;function p(E,L,h){if(!h)return new _.FindMatch(E,null);const g=[];for(let l=0,r=L.length;l<r;l++)g[l]=L[l];return new _.FindMatch(E,g)}t.createFindMatch=p;class y{constructor(L){const h=[];let g=0;for(let l=0,r=L.length;l<r;l++)L.charCodeAt(l)===10&&(h[g++]=l);this.a=h}findLineFeedCountBeforeOffset(L){const h=this.a;let g=0,l=h.length-1;if(l===-1||L<=h[0])return 0;for(;g<l;){const r=g+((l-g)/2>>0);h[r]>=L?l=r-1:h[r+1]>=L?(g=r,l=r):g=r+1}return g+1}}class w{static findMatches(L,h,g,l,r){const s=h.parseSearchRequest();return s?s.regex.multiline?this.b(L,g,new D(s.wordSeparators,s.regex),l,r):this.c(L,g,s,l,r):[]}static a(L,h,g,l,r,s){let d,c=0;l?(c=l.findLineFeedCountBeforeOffset(r),d=h+r+c):d=h+r;let N;if(l){const R=l.findLineFeedCountBeforeOffset(r+s.length)-c;N=d+s.length+R}else N=d+s.length;const b=L.getPositionAt(d),f=L.getPositionAt(N);return new n.Range(b.lineNumber,b.column,f.lineNumber,f.column)}static b(L,h,g,l,r){const s=L.getOffsetAt(h.getStartPosition()),d=L.getValueInRange(h,1),c=L.getEOL()===`\r
`?new y(d):null,N=[];let b=0,f;for(g.reset(0);f=g.next(d);)if(N[b++]=p(this.a(L,s,d,c,f.index,f[0]),f,l),b>=r)return N;return N}static c(L,h,g,l,r){const s=[];let d=0;if(h.startLineNumber===h.endLineNumber){const N=L.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return d=this.d(g,N,h.startLineNumber,h.startColumn-1,d,s,l,r),s}const c=L.getLineContent(h.startLineNumber).substring(h.startColumn-1);d=this.d(g,c,h.startLineNumber,h.startColumn-1,d,s,l,r);for(let N=h.startLineNumber+1;N<h.endLineNumber&&d<r;N++)d=this.d(g,L.getLineContent(N),N,0,d,s,l,r);if(d<r){const N=L.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);d=this.d(g,N,h.endLineNumber,0,d,s,l,r)}return s}static d(L,h,g,l,r,s,d,c){const N=L.wordSeparators;if(!d&&L.simpleSearch){const u=L.simpleSearch,R=u.length,T=h.length;let O=-R;for(;(O=h.indexOf(u,O+R))!==-1;)if((!N||A(N,h,T,O,R))&&(s[r++]=new _.FindMatch(new n.Range(g,O+1+l,g,O+1+R+l),null),r>=c))return r;return r}const b=new D(L.wordSeparators,L.regex);let f;b.reset(0);do if(f=b.next(h),f&&(s[r++]=p(new n.Range(g,f.index+1+l,g,f.index+1+f[0].length+l),f,d),r>=c))return r;while(f);return r}static findNextMatch(L,h,g,l){const r=h.parseSearchRequest();if(!r)return null;const s=new D(r.wordSeparators,r.regex);return r.regex.multiline?this.e(L,g,s,l):this.f(L,g,s,l)}static e(L,h,g,l){const r=new F.Position(h.lineNumber,1),s=L.getOffsetAt(r),d=L.getLineCount(),c=L.getValueInRange(new n.Range(r.lineNumber,r.column,d,L.getLineMaxColumn(d)),1),N=L.getEOL()===`\r
`?new y(c):null;g.reset(h.column-1);const b=g.next(c);return b?p(this.a(L,s,c,N,b.index,b[0]),b,l):h.lineNumber!==1||h.column!==1?this.e(L,new F.Position(1,1),g,l):null}static f(L,h,g,l){const r=L.getLineCount(),s=h.lineNumber,d=L.getLineContent(s),c=this.g(g,d,s,h.column,l);if(c)return c;for(let N=1;N<=r;N++){const b=(s+N-1)%r,f=L.getLineContent(b+1),u=this.g(g,f,b+1,1,l);if(u)return u}return null}static g(L,h,g,l,r){L.reset(l-1);const s=L.next(h);return s?p(new n.Range(g,s.index+1,g,s.index+1+s[0].length),s,r):null}static findPreviousMatch(L,h,g,l){const r=h.parseSearchRequest();if(!r)return null;const s=new D(r.wordSeparators,r.regex);return r.regex.multiline?this.h(L,g,s,l):this.j(L,g,s,l)}static h(L,h,g,l){const r=this.b(L,new n.Range(1,1,h.lineNumber,h.column),g,l,10*m);if(r.length>0)return r[r.length-1];const s=L.getLineCount();return h.lineNumber!==s||h.column!==L.getLineMaxColumn(s)?this.h(L,new F.Position(s,L.getLineMaxColumn(s)),g,l):null}static j(L,h,g,l){const r=L.getLineCount(),s=h.lineNumber,d=L.getLineContent(s).substring(0,h.column-1),c=this.k(g,d,s,l);if(c)return c;for(let N=1;N<=r;N++){const b=(r+s-N-1)%r,f=L.getLineContent(b+1),u=this.k(g,f,b+1,l);if(u)return u}return null}static k(L,h,g,l){let r=null,s;for(L.reset(0);s=L.next(h);)r=p(new n.Range(g,s.index+1,g,s.index+1+s[0].length),s,l);return r}}t.TextModelSearch=w;function v(E,L,h,g,l){if(g===0)return!0;const r=L.charCodeAt(g-1);if(E.get(r)!==0||r===13||r===10)return!0;if(l>0){const s=L.charCodeAt(g);if(E.get(s)!==0)return!0}return!1}function e(E,L,h,g,l){if(g+l===h)return!0;const r=L.charCodeAt(g+l);if(E.get(r)!==0||r===13||r===10)return!0;if(l>0){const s=L.charCodeAt(g+l-1);if(E.get(s)!==0)return!0}return!1}function A(E,L,h,g,l){return v(E,L,h,g,l)&&e(E,L,h,g,l)}t.isValidMatch=A;class D{constructor(L,h){this._wordSeparators=L,this.a=h,this.b=-1,this.c=0}reset(L){this.a.lastIndex=L,this.b=-1,this.c=0}next(L){const h=L.length;let g;do{if(this.b+this.c===h||(g=this.a.exec(L),!g))return null;const l=g.index,r=g[0].length;if(l===this.b&&r===this.c){if(r===0){M.getNextCodePoint(L,h,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=l,this.c=r,!this._wordSeparators||A(this._wordSeparators,L,h,l,r))return g}while(g);return null}}t.Searcher=D}),Q(J[50],K([0,1,2,49,4,10,19]),function(q,t,M,S,F,n,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.UnicodeTextModelHighlighter=void 0;class m{static computeUnicodeHighlights(e,A,D){const E=D?D.startLineNumber:1,L=D?D.endLineNumber:e.getLineCount(),h=new p(A),g=h.getCandidateCodePoints();let l;g==="allNonBasicAscii"?l=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):l=new RegExp(`${a(Array.from(g))}`,"g");const r=new S.Searcher(null,l),s=[];let d=!1,c,N=0,b=0,f=0;e:for(let u=E,R=L;u<=R;u++){const T=e.getLineContent(u),O=T.length;r.reset(0);do if(c=r.next(T),c){let C=c.index,H=c.index+c[0].length;if(C>0){const Y=T.charCodeAt(C-1);F.isHighSurrogate(Y)&&C--}if(H+1<O){const Y=T.charCodeAt(H-1);F.isHighSurrogate(Y)&&H++}const z=T.substring(C,H);let ee=(0,_.getWordAtText)(C+1,_.DEFAULT_WORD_REGEXP,T,0);ee&&ee.endColumn<=C+1&&(ee=null);const ne=h.shouldHighlightNonBasicASCII(z,ee?ee.word:null);if(ne!==0){ne===3?N++:ne===2?b++:ne===1?f++:(0,n.assertNever)(ne);const Y=1e3;if(s.length>=Y){d=!0;break e}s.push(new M.Range(u,C+1,u,H+1))}}while(c)}return{ranges:s,hasMore:d,ambiguousCharacterCount:N,invisibleCharacterCount:b,nonBasicAsciiCharacterCount:f}}static computeUnicodeHighlightReason(e,A){const D=new p(A);switch(D.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const L=e.codePointAt(0),h=D.ambiguousCharacters.getPrimaryConfusable(L),g=F.AmbiguousCharacters.getLocales().filter(l=>!F.AmbiguousCharacters.getInstance(new Set([...A.allowedLocales,l])).isAmbiguous(L));return{kind:0,confusableWith:String.fromCodePoint(h),notAmbiguousInLocales:g}}case 1:return{kind:2}}}}t.UnicodeTextModelHighlighter=m;function a(v,e){return`[${F.escapeRegExpCharacters(v.map(D=>String.fromCodePoint(D)).join(""))}]`}var o;(function(v){v[v.Ambiguous=0]="Ambiguous",v[v.Invisible=1]="Invisible",v[v.NonBasicAscii=2]="NonBasicAscii"})(o=t.UnicodeHighlighterReasonKind||(t.UnicodeHighlighterReasonKind={}));class p{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=F.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const A of F.InvisibleCharacters.codePoints)y(String.fromCodePoint(A))||e.add(A);if(this.b.ambiguousCharacters)for(const A of this.ambiguousCharacters.getConfusableCodePoints())e.add(A);for(const A of this.a)e.delete(A);return e}shouldHighlightNonBasicASCII(e,A){const D=e.codePointAt(0);if(this.a.has(D))return 0;if(this.b.nonBasicASCII)return 1;let E=!1,L=!1;if(A)for(const h of A){const g=h.codePointAt(0),l=F.isBasicASCII(h);E=E||l,!l&&!this.ambiguousCharacters.isAmbiguous(g)&&!F.InvisibleCharacters.isInvisibleCharacter(g)&&(L=!0)}return!E&&L?0:this.b.invisibleCharacters&&!y(e)&&F.InvisibleCharacters.isInvisibleCharacter(D)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(D)?3:0}}function y(v){return v===" "||v===`
`||v==="	"}var w;(function(v){v[v.None=0]="None",v[v.NonBasicASCII=1]="NonBasicASCII",v[v.Invisible=2]="Invisible",v[v.Ambiguous=3]="Ambiguous"})(w||(w={}))}),Q(J[51],K([0,1,9,7]),function(q,t,M,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationRegistry=void 0;class F{constructor(){this.a=new Map,this.b=new Map,this.c=new M.Emitter,this.onDidChange=this.c.event,this.d=null}fire(m){this.c.fire({changedLanguages:m,changedColorMap:!1})}register(m,a){return this.a.set(m,a),this.fire([m]),(0,S.toDisposable)(()=>{this.a.get(m)===a&&(this.a.delete(m),this.fire([m]))})}registerFactory(m,a){this.b.get(m)?.dispose();const o=new n(this,m,a);return this.b.set(m,o),(0,S.toDisposable)(()=>{const p=this.b.get(m);!p||p!==o||(this.b.delete(m),p.dispose())})}async getOrCreate(m){const a=this.get(m);if(a)return a;const o=this.b.get(m);return!o||o.isResolved?null:(await o.resolve(),this.get(m))}get(m){return this.a.get(m)||null}isResolved(m){if(this.get(m))return!0;const o=this.b.get(m);return!!(!o||o.isResolved)}setColorMap(m){this.d=m,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.TokenizationRegistry=F;class n extends S.Disposable{get isResolved(){return this.c}constructor(m,a,o){super(),this.f=m,this.g=a,this.h=o,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const m=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,m&&!this.a&&this.B(this.f.register(this.g,m))}}}),Q(J[52],K([0,1,29,12,2,51]),function(q,t,M,S,F,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.TokenizationRegistry=t.InlayHintKind=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.FoldingRangeKind=t.SymbolKinds=t.SymbolTag=t.SymbolKind=t.isLocationLink=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.EncodedTokenizationResult=t.TokenizationResult=t.Token=void 0;class _{constructor(R,T,O){this._tokenBrand=void 0,this.offset=R,this.type=T,this.language=O}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=_;class m{constructor(R,T){this._tokenizationResultBrand=void 0,this.tokens=R,this.endState=T}}t.TokenizationResult=m;class a{constructor(R,T){this._encodedTokenizationResultBrand=void 0,this.tokens=R,this.endState=T}}t.EncodedTokenizationResult=a;var o;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(o=t.CompletionItemKind||(t.CompletionItemKind={}));var p;(function(u){const R=new Map;R.set(0,M.Codicon.symbolMethod),R.set(1,M.Codicon.symbolFunction),R.set(2,M.Codicon.symbolConstructor),R.set(3,M.Codicon.symbolField),R.set(4,M.Codicon.symbolVariable),R.set(5,M.Codicon.symbolClass),R.set(6,M.Codicon.symbolStruct),R.set(7,M.Codicon.symbolInterface),R.set(8,M.Codicon.symbolModule),R.set(9,M.Codicon.symbolProperty),R.set(10,M.Codicon.symbolEvent),R.set(11,M.Codicon.symbolOperator),R.set(12,M.Codicon.symbolUnit),R.set(13,M.Codicon.symbolValue),R.set(15,M.Codicon.symbolEnum),R.set(14,M.Codicon.symbolConstant),R.set(15,M.Codicon.symbolEnum),R.set(16,M.Codicon.symbolEnumMember),R.set(17,M.Codicon.symbolKeyword),R.set(27,M.Codicon.symbolSnippet),R.set(18,M.Codicon.symbolText),R.set(19,M.Codicon.symbolColor),R.set(20,M.Codicon.symbolFile),R.set(21,M.Codicon.symbolReference),R.set(22,M.Codicon.symbolCustomColor),R.set(23,M.Codicon.symbolFolder),R.set(24,M.Codicon.symbolTypeParameter),R.set(25,M.Codicon.account),R.set(26,M.Codicon.issues);function T(H){let z=R.get(H);return z||(console.info("No codicon found for CompletionItemKind "+H),z=M.Codicon.symbolProperty),z}u.toIcon=T;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function C(H,z){let ee=O.get(H);return typeof ee>"u"&&!z&&(ee=9),ee}u.fromString=C})(p=t.CompletionItemKinds||(t.CompletionItemKinds={}));var y;(function(u){u[u.Deprecated=1]="Deprecated"})(y=t.CompletionItemTag||(t.CompletionItemTag={}));var w;(function(u){u[u.None=0]="None",u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(w=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var v;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var e;(function(u){u[u.Automatic=0]="Automatic",u[u.Explicit=1]="Explicit"})(e=t.InlineCompletionTriggerKind||(t.InlineCompletionTriggerKind={}));var A;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(A=t.CodeActionTriggerType||(t.CodeActionTriggerType={}));var D;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(D=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var E;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(E=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));function L(u){return u&&S.URI.isUri(u.uri)&&F.Range.isIRange(u.range)&&(F.Range.isIRange(u.originSelectionRange)||F.Range.isIRange(u.targetSelectionRange))}t.isLocationLink=L;var h;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(h=t.SymbolKind||(t.SymbolKind={}));var g;(function(u){u[u.Deprecated=1]="Deprecated"})(g=t.SymbolTag||(t.SymbolTag={}));var l;(function(u){const R=new Map;R.set(0,M.Codicon.symbolFile),R.set(1,M.Codicon.symbolModule),R.set(2,M.Codicon.symbolNamespace),R.set(3,M.Codicon.symbolPackage),R.set(4,M.Codicon.symbolClass),R.set(5,M.Codicon.symbolMethod),R.set(6,M.Codicon.symbolProperty),R.set(7,M.Codicon.symbolField),R.set(8,M.Codicon.symbolConstructor),R.set(9,M.Codicon.symbolEnum),R.set(10,M.Codicon.symbolInterface),R.set(11,M.Codicon.symbolFunction),R.set(12,M.Codicon.symbolVariable),R.set(13,M.Codicon.symbolConstant),R.set(14,M.Codicon.symbolString),R.set(15,M.Codicon.symbolNumber),R.set(16,M.Codicon.symbolBoolean),R.set(17,M.Codicon.symbolArray),R.set(18,M.Codicon.symbolObject),R.set(19,M.Codicon.symbolKey),R.set(20,M.Codicon.symbolNull),R.set(21,M.Codicon.symbolEnumMember),R.set(22,M.Codicon.symbolStruct),R.set(23,M.Codicon.symbolEvent),R.set(24,M.Codicon.symbolOperator),R.set(25,M.Codicon.symbolTypeParameter);function T(O){let C=R.get(O);return C||(console.info("No codicon found for SymbolKind "+O),C=M.Codicon.symbolProperty),C}u.toIcon=T})(l=t.SymbolKinds||(t.SymbolKinds={}));class r{constructor(R){this.value=R}}t.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var s;(function(u){function R(T){return!T||typeof T!="object"?!1:typeof T.id=="string"&&typeof T.title=="string"}u.is=R})(s=t.Command||(t.Command={}));var d;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(d=t.CommentThreadCollapsibleState||(t.CommentThreadCollapsibleState={}));var c;(function(u){u[u.Unresolved=0]="Unresolved",u[u.Resolved=1]="Resolved"})(c=t.CommentThreadState||(t.CommentThreadState={}));var N;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(N=t.CommentMode||(t.CommentMode={}));var b;(function(u){u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(b=t.InlayHintKind||(t.InlayHintKind={})),t.TokenizationRegistry=new n.TokenizationRegistry;var f;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(f=t.ExternalUriOpenerPriority||(t.ExternalUriOpenerPriority={}))}),Q(J[53],K([0,1,22,9,27,12,3,2,30,52,41]),function(q,t,M,S,F,n,_,m,a,o,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class y{static chord(e,A){return(0,F.KeyChord)(e,A)}}t.KeyMod=y,y.CtrlCmd=2048,y.Shift=1024,y.Alt=512,y.WinCtrl=256;function w(){return{editor:void 0,languages:void 0,CancellationTokenSource:M.CancellationTokenSource,Emitter:S.Emitter,KeyCode:p.KeyCode,KeyMod:y,Position:_.Position,Range:m.Range,Selection:a.Selection,SelectionDirection:p.SelectionDirection,MarkerSeverity:p.MarkerSeverity,MarkerTag:p.MarkerTag,Uri:n.URI,Token:o.Token}}t.createMonacoBaseAPI=w}),Q(J[58],K([0,1,23,5,12,3,2,48,19,37,38,53,21,50,24,47,11]),function(q,t,M,S,F,n,_,m,a,o,p,y,w,v,e,A,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class E extends m.MirrorTextModel{get uri(){return this.c}get eol(){return this.f}getValue(){return this.getText()}getLinesContent(){return this.d.slice(0)}getLineCount(){return this.d.length}getLineContent(l){return this.d[l-1]}getWordAtPosition(l,r){const s=(0,a.getWordAtText)(l.column,(0,a.ensureValidWordDefinition)(r),this.d[l.lineNumber-1],0);return s?new _.Range(l.lineNumber,s.startColumn,l.lineNumber,s.endColumn):null}getWordUntilPosition(l,r){const s=this.getWordAtPosition(l,r);return s?{word:this.d[l.lineNumber-1].substring(s.startColumn-1,l.column-1),startColumn:s.startColumn,endColumn:l.column}:{word:"",startColumn:l.column,endColumn:l.column}}words(l){const r=this.d,s=this.p.bind(this);let d=0,c="",N=0,b=[];return{*[Symbol.iterator](){for(;;)if(N<b.length){const f=c.substring(b[N].start,b[N].end);N+=1,yield f}else if(d<r.length)c=r[d],b=s(c,l),N=0,d+=1;else break}}}getLineWords(l,r){const s=this.d[l-1],d=this.p(s,r),c=[];for(const N of d)c.push({word:s.substring(N.start,N.end),startColumn:N.start+1,endColumn:N.end+1});return c}p(l,r){const s=[];let d;for(r.lastIndex=0;(d=r.exec(l))&&d[0].length!==0;)s.push({start:d.index,end:d.index+d[0].length});return s}getValueInRange(l){if(l=this.q(l),l.startLineNumber===l.endLineNumber)return this.d[l.startLineNumber-1].substring(l.startColumn-1,l.endColumn-1);const r=this.f,s=l.startLineNumber-1,d=l.endLineNumber-1,c=[];c.push(this.d[s].substring(l.startColumn-1));for(let N=s+1;N<d;N++)c.push(this.d[N]);return c.push(this.d[d].substring(0,l.endColumn-1)),c.join(r)}offsetAt(l){return l=this.r(l),this.k(),this.h.getPrefixSum(l.lineNumber-2)+(l.column-1)}positionAt(l){l=Math.floor(l),l=Math.max(0,l),this.k();const r=this.h.getIndexOf(l),s=this.d[r.index].length;return{lineNumber:1+r.index,column:1+Math.min(r.remainder,s)}}q(l){const r=this.r({lineNumber:l.startLineNumber,column:l.startColumn}),s=this.r({lineNumber:l.endLineNumber,column:l.endColumn});return r.lineNumber!==l.startLineNumber||r.column!==l.startColumn||s.lineNumber!==l.endLineNumber||s.column!==l.endColumn?{startLineNumber:r.lineNumber,startColumn:r.column,endLineNumber:s.lineNumber,endColumn:s.column}:l}r(l){if(!n.Position.isIPosition(l))throw new Error("bad position");let{lineNumber:r,column:s}=l,d=!1;if(r<1)r=1,s=1,d=!0;else if(r>this.d.length)r=this.d.length,s=this.d[r-1].length+1,d=!0;else{const c=this.d[r-1].length+1;s<1?(s=1,d=!0):s>c&&(s=c,d=!0)}return d?{lineNumber:r,column:s}:l}}class L{constructor(l,r){this.c=l,this.d=Object.create(null),this.f=r,this.g=null}dispose(){this.d=Object.create(null)}h(l){return this.d[l]}j(){const l=[];return Object.keys(this.d).forEach(r=>l.push(this.d[r])),l}acceptNewModel(l){this.d[l.url]=new E(F.URI.parse(l.url),l.lines,l.EOL,l.versionId)}acceptModelChanged(l,r){if(!this.d[l])return;this.d[l].onEvents(r)}acceptRemovedModel(l){!this.d[l]||delete this.d[l]}async computeUnicodeHighlights(l,r,s){const d=this.h(l);return d?v.UnicodeTextModelHighlighter.computeUnicodeHighlights(d,r,s):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(l,r,s,d){const c=this.h(l),N=this.h(r);return!c||!N?null:L.k(c,N,s,d)}static k(l,r,s,d){const c=d==="experimental"?A.linesDiffComputers.experimental:A.linesDiffComputers.smart,N=l.getLinesContent(),b=r.getLinesContent(),f=c.computeDiff(N,b,s);return{identical:f.changes.length>0?!1:this.l(l,r),quitEarly:f.quitEarly,changes:f.changes.map(R=>[R.originalRange.startLineNumber,R.originalRange.endLineNumberExclusive,R.modifiedRange.startLineNumber,R.modifiedRange.endLineNumberExclusive,R.innerChanges?.map(T=>[T.originalRange.startLineNumber,T.originalRange.startColumn,T.originalRange.endLineNumber,T.originalRange.endColumn,T.modifiedRange.startLineNumber,T.modifiedRange.startColumn,T.modifiedRange.endLineNumber,T.modifiedRange.endColumn])])}}static l(l,r){const s=l.getLineCount(),d=r.getLineCount();if(s!==d)return!1;for(let c=1;c<=s;c++){const N=l.getLineContent(c),b=r.getLineContent(c);if(N!==b)return!1}return!0}async computeDirtyDiff(l,r,s){const d=this.h(l),c=this.h(r);if(!d||!c)return null;const N=d.getLinesContent(),b=c.getLinesContent();return new e.DiffComputer(N,b,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:s,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(l,r){const s=this.h(l);if(!s)return r;const d=[];let c;r=r.slice(0).sort((N,b)=>{if(N.range&&b.range)return _.Range.compareRangesUsingStarts(N.range,b.range);const f=N.range?0:1,u=b.range?0:1;return f-u});for(let{range:N,text:b,eol:f}of r){if(typeof f=="number"&&(c=f),_.Range.isEmpty(N)&&!b)continue;const u=s.getValueInRange(N);if(b=b.replace(/\r\n|\n|\r/g,s.eol),u===b)continue;if(Math.max(b.length,u.length)>L.n){d.push({range:N,text:b});continue}const R=(0,M.stringDiff)(u,b,!1),T=s.offsetAt(_.Range.lift(N).getStartPosition());for(const O of R){const C=s.positionAt(T+O.originalStart),H=s.positionAt(T+O.originalStart+O.originalLength),z={text:b.substr(O.modifiedStart,O.modifiedLength),range:{startLineNumber:C.lineNumber,startColumn:C.column,endLineNumber:H.lineNumber,endColumn:H.column}};s.getValueInRange(z.range)!==z.text&&d.push(z)}}return typeof c=="number"&&d.push({eol:c,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),d}async computeLinks(l){const r=this.h(l);return r?(0,o.computeLinks)(r):null}async textualSuggest(l,r,s,d){const c=new w.StopWatch(!0),N=new RegExp(s,d),b=new Set;e:for(const f of l){const u=this.h(f);if(!!u){for(const R of u.words(N))if(!(R===r||!isNaN(Number(R)))&&(b.add(R),b.size>L.o))break e}}return{words:Array.from(b),duration:c.elapsed()}}async computeWordRanges(l,r,s,d){const c=this.h(l);if(!c)return Object.create(null);const N=new RegExp(s,d),b=Object.create(null);for(let f=r.startLineNumber;f<r.endLineNumber;f++){const u=c.getLineWords(f,N);for(const R of u){if(!isNaN(Number(R.word)))continue;let T=b[R.word];T||(T=[],b[R.word]=T),T.push({startLineNumber:f,startColumn:R.startColumn,endLineNumber:f,endColumn:R.endColumn})}}return b}async navigateValueSet(l,r,s,d,c){const N=this.h(l);if(!N)return null;const b=new RegExp(d,c);r.startColumn===r.endColumn&&(r={startLineNumber:r.startLineNumber,startColumn:r.startColumn,endLineNumber:r.endLineNumber,endColumn:r.endColumn+1});const f=N.getValueInRange(r),u=N.getWordAtPosition({lineNumber:r.startLineNumber,column:r.startColumn},b);if(!u)return null;const R=N.getValueInRange(u);return p.BasicInplaceReplace.INSTANCE.navigateValueSet(r,f,u,R,s)}loadForeignModule(l,r,s){const d=(b,f)=>this.c.fhr(b,f),N={host:(0,D.createProxyObject)(s,d),getMirrorModels:()=>this.j()};return this.f?(this.g=this.f(N,r),Promise.resolve((0,D.getAllMethodNames)(this.g))):new Promise((b,f)=>{q([l],u=>{this.g=u.create(N,r),b((0,D.getAllMethodNames)(this.g))},f)})}fmr(l,r){if(!this.g||typeof this.g[l]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+l));try{return Promise.resolve(this.g[l].apply(this.g,r))}catch(s){return Promise.reject(s)}}}t.EditorSimpleWorker=L,L.n=1e5,L.o=1e4;function h(g){return new L(g,null)}t.create=h,typeof importScripts=="function"&&(S.globals.monaco=(0,y.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8be8d96ab86ed4077df554eb62727484d454699f/core/vs/base/worker/workerMain.js.map
