/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/base/common/uri","vs/base/common/types","vs/base/common/path","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/platform/userDataProfile/common/userDataProfile","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/base/common/arrays","vs/base/common/resources","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/network","vs/base/common/strings","vs/base/node/pfs","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/map","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/extensions/common/extensions","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/codicons","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/electron-browser/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/themables","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataProfile/electron-sandbox/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensions","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ae=function(Q){for(var e=[],k=0,T=Q.length;k<T;k++)e[k]=oe[Q[k]];return e};define(oe[63],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function k(O){return(P,I,E)=>{let C=null,b=null;if(typeof E.value=="function"?(C="value",b=E.value):typeof E.get=="function"&&(C="get",b=E.get),!b)throw new Error("not supported");E[C]=O(b,I)}}function T(O,P,I){let E=null,C=null;if(typeof I.value=="function"?(E="value",C=I.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(E="get",C=I.get),!C)throw new Error("not supported");const b=`$memoize$${P}`;I[E]=function(...m){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,m)}),this[b]}}e.memoize=T;function D(O,P,I){return k((E,C)=>{const b=`$debounce$${C}`,m=`$debounce$result$${C}`;return function(...y){this[m]||(this[m]=I?I():void 0),clearTimeout(this[b]),P&&(this[m]=P(this[m],...y),y=[this[m]]),this[b]=setTimeout(()=>{E.apply(this,y),this[m]=I?I():void 0},O)}})}e.debounce=D;function l(O,P,I){return k((E,C)=>{const b=`$throttle$timer$${C}`,m=`$throttle$result$${C}`,y=`$throttle$lastRun$${C}`,u=`$throttle$pending$${C}`;return function(...S){if(this[m]||(this[m]=I?I():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),P&&(this[m]=P(this[m],...S)),this[u])return;const f=this[y]+O;f<=Date.now()?(this[y]=Date.now(),E.apply(this,[this[m]]),this[m]=I?I():void 0):(this[u]=!0,this[b]=setTimeout(()=>{this[u]=!1,this[y]=Date.now(),E.apply(this,[this[m]]),this[m]=I?I():void 0},f-Date.now()))}})}e.throttle=l}),define(oe[9],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?p.isErrorNoTelemetry(i)?new p(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.ErrorHandler=k,e.errorHandler=new k;function T(R){e.errorHandler.setUnexpectedErrorHandler(R)}e.setUnexpectedErrorHandler=T;function D(R){I(R)||e.errorHandler.onUnexpectedError(R)}e.onUnexpectedError=D;function l(R){I(R)||e.errorHandler.onUnexpectedExternalError(R)}e.onUnexpectedExternalError=l;function O(R){if(R instanceof Error){const{name:i,message:o}=R,t=R.stacktrace||R.stack;return{$isError:!0,name:i,message:o,stack:t,noTelemetry:p.isErrorNoTelemetry(R)}}return R}e.transformErrorForSerialization=O;const P="Canceled";function I(R){return R instanceof E?!0:R instanceof Error&&R.name===P&&R.message===P}e.isCancellationError=I;class E extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=E;function C(){const R=new Error(P);return R.name=R.message,R}e.canceled=C;function b(R){return R?new Error(`Illegal argument: ${R}`):new Error("Illegal argument")}e.illegalArgument=b;function m(R){return R?new Error(`Illegal state: ${R}`):new Error("Illegal state")}e.illegalState=m;function y(R){return R?new Error(`readonly property '${R} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function u(R){const i=new Error(`${R} has been disposed`);return i.name="DISPOSED",i}e.disposed=u;function S(R){return R?R.message?R.message:R.stack?R.stack.split(`
`)[0]:String(R):"Error"}e.getErrorMessage=S;class f extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=f;class c extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=c;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=d;class p extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof p)return i;const o=new p;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=p;class w extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,w.prototype);debugger}}e.BugIndicatingError=w}),define(oe[21],ae([0,1,9]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function T(K,Z=0){return K[K.length-(1+Z)]}e.tail=T;function D(K){if(K.length===0)throw new Error("Invalid tail call");return[K.slice(0,K.length-1),K[K.length-1]]}e.tail2=D;function l(K,Z,se=(le,ue)=>le===ue){if(K===Z)return!0;if(!K||!Z||K.length!==Z.length)return!1;for(let le=0,ue=K.length;le<ue;le++)if(!se(K[le],Z[le]))return!1;return!0}e.equals=l;function O(K,Z){const se=K.length-1;Z<se&&(K[Z]=K[se]),K.pop()}e.removeFastWithoutKeepingOrder=O;function P(K,Z,se){return I(K.length,le=>se(K[le],Z))}e.binarySearch=P;function I(K,Z){let se=0,le=K-1;for(;se<=le;){const ue=(se+le)/2|0,pe=Z(ue);if(pe<0)se=ue+1;else if(pe>0)le=ue-1;else return ue}return-(se+1)}e.binarySearch2=I;function E(K,Z){let se=0,le=K.length;if(le===0)return 0;for(;se<le;){const ue=Math.floor((se+le)/2);Z(K[ue])?le=ue:se=ue+1}return se}e.findFirstInSorted=E;function C(K,Z,se){if(K=K|0,K>=Z.length)throw new TypeError("invalid index");const le=Z[Math.floor(Z.length*Math.random())],ue=[],pe=[],ve=[];for(const be of Z){const Ee=se(be,le);Ee<0?ue.push(be):Ee>0?pe.push(be):ve.push(be)}return K<ue.length?C(K,ue,se):K<ue.length+ve.length?ve[0]:C(K-(ue.length+ve.length),pe,se)}e.quickSelect=C;function b(K,Z){const se=[];let le;for(const ue of K.slice(0).sort(Z))!le||Z(le[0],ue)!==0?(le=[ue],se.push(le)):le.push(ue);return se}e.groupBy=b;function m(K,Z,se){const le=[];function ue(be,Ee,Oe){if(Ee===0&&Oe.length===0)return;const Ue=le[le.length-1];Ue&&Ue.start+Ue.deleteCount===be?(Ue.deleteCount+=Ee,Ue.toInsert.push(...Oe)):le.push({start:be,deleteCount:Ee,toInsert:Oe})}let pe=0,ve=0;for(;;){if(pe===K.length){ue(pe,0,Z.slice(ve));break}if(ve===Z.length){ue(pe,K.length-pe,[]);break}const be=K[pe],Ee=Z[ve],Oe=se(be,Ee);Oe===0?(pe+=1,ve+=1):Oe<0?(ue(pe,1,[]),pe+=1):Oe>0&&(ue(pe,0,[Ee]),ve+=1)}return le}e.sortedDiff=m;function y(K,Z,se){const le=m(K,Z,se),ue=[],pe=[];for(const ve of le)ue.push(...K.slice(ve.start,ve.start+ve.deleteCount)),pe.push(...ve.toInsert);return{removed:ue,added:pe}}e.delta=y;function u(K,Z,se){if(se===0)return[];const le=K.slice(0,se).sort(Z);return f(K,Z,le,se,K.length),le}e.top=u;function S(K,Z,se,le,ue){return se===0?Promise.resolve([]):new Promise((pe,ve)=>{(async()=>{const be=K.length,Ee=K.slice(0,se).sort(Z);for(let Oe=se,Ue=Math.min(se+le,be);Oe<be;Oe=Ue,Ue=Math.min(Ue+le,be)){if(Oe>se&&await new Promise(Ye=>setTimeout(Ye)),ue&&ue.isCancellationRequested)throw new k.CancellationError;f(K,Z,Ee,Oe,Ue)}return Ee})().then(pe,ve)})}e.topAsync=S;function f(K,Z,se,le,ue){for(const pe=se.length;le<ue;le++){const ve=K[le];if(Z(ve,se[pe-1])<0){se.pop();const be=E(se,Ee=>Z(ve,Ee)<0);se.splice(be,0,ve)}}}function c(K){return K.filter(Z=>!!Z)}e.coalesce=c;function d(K){let Z=0;for(let se=0;se<K.length;se++)K[se]&&(K[Z]=K[se],Z+=1);K.length=Z}e.coalesceInPlace=d;function p(K,Z,se){K.splice(se,0,K.splice(Z,1)[0])}e.move=p;function w(K){return!Array.isArray(K)||K.length===0}e.isFalsyOrEmpty=w;function R(K){return Array.isArray(K)&&K.length>0}e.isNonEmptyArray=R;function i(K,Z=se=>se){const se=new Set;return K.filter(le=>{const ue=Z(le);return se.has(ue)?!1:(se.add(ue),!0)})}e.distinct=i;function o(K){const Z=new Set;return se=>{const le=K(se);return Z.has(le)?!1:(Z.add(le),!0)}}e.uniqueFilter=o;function t(K,Z){const se=n(K,Z);if(se!==-1)return K[se]}e.findLast=t;function n(K,Z){for(let se=K.length-1;se>=0;se--){const le=K[se];if(Z(le))return se}return-1}e.lastIndex=n;function s(K,Z){return K.length>0?K[0]:Z}e.firstOrDefault=s;function a(K,Z){return K.length>0?K[K.length-1]:Z}e.lastOrDefault=a;function r(K,Z,se=(le,ue)=>le===ue){let le=0;for(let ue=0,pe=Math.min(K.length,Z.length);ue<pe&&se(K[ue],Z[ue]);ue++)le++;return le}e.commonPrefixLength=r;function h(K){return[].concat(...K)}e.flatten=h;function g(K,Z){let se=typeof Z=="number"?K:0;typeof Z=="number"?se=K:(se=0,Z=K);const le=[];if(se<=Z)for(let ue=se;ue<Z;ue++)le.push(ue);else for(let ue=se;ue>Z;ue--)le.push(ue);return le}e.range=g;function v(K,Z,se){return K.reduce((le,ue)=>(le[Z(ue)]=se?se(ue):ue,le),Object.create(null))}e.index=v;function A(K,Z){return K.push(Z),()=>N(K,Z)}e.insert=A;function N(K,Z){const se=K.indexOf(Z);if(se>-1)return K.splice(se,1),Z}e.remove=N;function F(K,Z,se){const le=K.slice(0,Z),ue=K.slice(Z);return le.concat(se,ue)}e.arrayInsert=F;function M(K,Z){let se;if(typeof Z=="number"){let le=Z;se=()=>{const ue=Math.sin(le++)*179426549;return ue-Math.floor(ue)}}else se=Math.random;for(let le=K.length-1;le>0;le-=1){const ue=Math.floor(se()*(le+1)),pe=K[le];K[le]=K[ue],K[ue]=pe}}e.shuffle=M;function L(K,Z){const se=K.indexOf(Z);se>-1&&(K.splice(se,1),K.unshift(Z))}e.pushToStart=L;function $(K,Z){const se=K.indexOf(Z);se>-1&&(K.splice(se,1),K.push(Z))}e.pushToEnd=$;function z(K,Z){for(const se of Z)K.push(se)}e.pushMany=z;function x(K,Z){return Array.isArray(K)?K.map(Z):Z(K)}e.mapArrayOrNot=x;function X(K){return Array.isArray(K)?K:[K]}e.asArray=X;function ie(K){return K[Math.floor(Math.random()*K.length)]}e.getRandomElement=ie;function H(K,Z){for(const se of K){const le=Z(se);if(le!==void 0)return le}}e.mapFind=H;function j(K,Z,se){const le=J(K,Z),ue=K.length,pe=se.length;K.length=ue+pe;for(let ve=ue-1;ve>=le;ve--)K[ve+pe]=K[ve];for(let ve=0;ve<pe;ve++)K[ve+le]=se[ve]}e.insertInto=j;function V(K,Z,se,le){const ue=J(K,Z),pe=K.splice(ue,se);return j(K,ue,le),pe}e.splice=V;function J(K,Z){return Z<0?Math.max(Z+K.length,0):Math.min(Z,K.length)}var _;(function(K){function Z(ue){return ue<0}K.isLessThan=Z;function se(ue){return ue>0}K.isGreaterThan=se;function le(ue){return ue===0}K.isNeitherLessOrGreaterThan=le,K.greaterThan=1,K.lessThan=-1,K.neitherLessOrGreaterThan=0})(_=e.CompareResult||(e.CompareResult={}));function re(K,Z){return(se,le)=>Z(K(se),K(le))}e.compareBy=re;function te(...K){return(Z,se)=>{for(const le of K){const ue=le(Z,se);if(!_.isNeitherLessOrGreaterThan(ue))return ue}return _.neitherLessOrGreaterThan}}e.tieBreakComparators=te;const U=(K,Z)=>K-Z;e.numberComparator=U;function B(K,Z){if(K.length===0)return;let se=K[0];for(let le=1;le<K.length;le++){const ue=K[le];Z(ue,se)>0&&(se=ue)}return se}e.findMaxBy=B;function W(K,Z){if(K.length===0)return;let se=K[0];for(let le=1;le<K.length;le++){const ue=K[le];Z(ue,se)>=0&&(se=ue)}return se}e.findLastMaxBy=W;function q(K,Z){return B(K,(se,le)=>-Z(se,le))}e.findMinBy=q;class Y{constructor(Z){this.f=Z,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(Z){let se=this.c;for(;se<this.f.length&&Z(this.f[se]);)se++;const le=se===this.c?null:this.f.slice(this.c,se);return this.c=se,le}takeFromEndWhile(Z){let se=this.d;for(;se>=0&&Z(this.f[se]);)se--;const le=se===this.d?null:this.f.slice(se+1,this.d+1);return this.d=se,le}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const Z=this.f[this.c];return this.c++,Z}removeLast(){const Z=this.f[this.d];return this.d--,Z}takeCount(Z){const se=this.f.slice(this.c,this.c+Z);return this.c+=Z,se}}e.ArrayQueue=Y;class ee{constructor(Z){this.iterate=Z}forEach(Z){this.iterate(se=>(Z(se),!0))}toArray(){const Z=[];return this.iterate(se=>(Z.push(se),!0)),Z}filter(Z){return new ee(se=>this.iterate(le=>Z(le)?se(le):!0))}map(Z){return new ee(se=>this.iterate(le=>se(Z(le))))}some(Z){let se=!1;return this.iterate(le=>(se=Z(le),!se)),se}findFirst(Z){let se;return this.iterate(le=>Z(le)?(se=le,!1):!0),se}findLast(Z){let se;return this.iterate(le=>(Z(le)&&(se=le),!0)),se}findLastMaxBy(Z){let se,le=!0;return this.iterate(ue=>((le||_.isGreaterThan(Z(ue,se)))&&(le=!1,se=ue),!0)),se}}e.CallbackIterable=ee,ee.empty=new ee(K=>{})}),define(oe[128],ae([0,1,9]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function T(I,E){if(!I)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=T;function D(I,E="Unreachable"){throw new Error(E)}e.assertNever=D;function l(I){if(!I)throw new k.BugIndicatingError("Assertion Failed")}e.assert=l;function O(I){if(!I()){debugger;I(),(0,k.onUnexpectedError)(new k.BugIndicatingError("Assertion Failed"))}}e.assertFn=O;function P(I,E){let C=0;for(;C<I.length-1;){const b=I[C],m=I[C+1];if(!E(b,m))return!1;C++}return!0}e.checkAdjacentItems=P}),define(oe[82],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function k(T){const D=this;let l=!1,O;return function(){return l||(l=!0,O=T.apply(D,arguments)),O}}e.once=k}),define(oe[64],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(T){function D(w){return w&&typeof w=="object"&&typeof w[Symbol.iterator]=="function"}T.is=D;const l=Object.freeze([]);function O(){return l}T.empty=O;function*P(w){yield w}T.single=P;function I(w){return D(w)?w:P(w)}T.wrap=I;function E(w){return w||l}T.from=E;function C(w){return!w||w[Symbol.iterator]().next().done===!0}T.isEmpty=C;function b(w){return w[Symbol.iterator]().next().value}T.first=b;function m(w,R){for(const i of w)if(R(i))return!0;return!1}T.some=m;function y(w,R){for(const i of w)if(R(i))return i}T.find=y;function*u(w,R){for(const i of w)R(i)&&(yield i)}T.filter=u;function*S(w,R){let i=0;for(const o of w)yield R(o,i++)}T.map=S;function*f(...w){for(const R of w)for(const i of R)yield i}T.concat=f;function c(w,R,i){let o=i;for(const t of w)o=R(o,t);return o}T.reduce=c;function*d(w,R,i=w.length){for(R<0&&(R+=w.length),i<0?i+=w.length:i>w.length&&(i=w.length);R<i;R++)yield w[R]}T.slice=d;function p(w,R=Number.POSITIVE_INFINITY){const i=[];if(R===0)return[i,w];const o=w[Symbol.iterator]();for(let t=0;t<R;t++){const n=o.next();if(n.done)return[i,T.empty()];i.push(n.value)}return[i,{[Symbol.iterator](){return o}}]}T.consume=p})(k=e.Iterable||(e.Iterable={}))}),define(oe[35],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(k=e.ScanError||(e.ScanError={}));var T;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var l;(function(i){i.DEFAULT={allowTrailingComma:!0}})(l=e.ParseOptions||(e.ParseOptions={}));function O(i,o=!1){let t=0;const n=i.length;let s="",a=0,r=16,h=0;function g($){let z=0,x=0;for(;z<$;){const X=i.charCodeAt(t);if(X>=48&&X<=57)x=x*16+X-48;else if(X>=65&&X<=70)x=x*16+X-65+10;else if(X>=97&&X<=102)x=x*16+X-97+10;else break;t++,z++}return z<$&&(x=-1),x}function v($){t=$,s="",a=0,r=16,h=0}function A(){const $=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&E(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&E(i.charCodeAt(t)))for(t++;t<i.length&&E(i.charCodeAt(t));)t++;else return h=3,i.substring($,t);let z=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&E(i.charCodeAt(t))){for(t++;t<i.length&&E(i.charCodeAt(t));)t++;z=t}else h=3;return i.substring($,z)}function N(){let $="",z=t;for(;;){if(t>=n){$+=i.substring(z,t),h=2;break}const x=i.charCodeAt(t);if(x===34){$+=i.substring(z,t),t++;break}if(x===92){if($+=i.substring(z,t),t++,t>=n){h=2;break}switch(i.charCodeAt(t++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const ie=g(4);ie>=0?$+=String.fromCharCode(ie):h=4;break}default:h=5}z=t;continue}if(x>=0&&x<=31)if(I(x)){$+=i.substring(z,t),h=2;break}else h=6;t++}return $}function F(){if(s="",h=0,a=t,t>=n)return a=n,r=17;let $=i.charCodeAt(t);if(P($)){do t++,s+=String.fromCharCode($),$=i.charCodeAt(t);while(P($));return r=15}if(I($))return t++,s+=String.fromCharCode($),$===13&&i.charCodeAt(t)===10&&(t++,s+=`
`),r=14;switch($){case 123:return t++,r=1;case 125:return t++,r=2;case 91:return t++,r=3;case 93:return t++,r=4;case 58:return t++,r=6;case 44:return t++,r=5;case 34:return t++,s=N(),r=10;case 47:{const z=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<n&&!I(i.charCodeAt(t));)t++;return s=i.substring(z,t),r=12}if(i.charCodeAt(t+1)===42){t+=2;const x=n-1;let X=!1;for(;t<x;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,X=!0;break}t++}return X||(t++,h=1),s=i.substring(z,t),r=13}return s+=String.fromCharCode($),t++,r=16}case 45:if(s+=String.fromCharCode($),t++,t===n||!E(i.charCodeAt(t)))return r=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=A(),r=11;default:for(;t<n&&M($);)t++,$=i.charCodeAt(t);if(a!==t){switch(s=i.substring(a,t),s){case"true":return r=8;case"false":return r=9;case"null":return r=7}return r=16}return s+=String.fromCharCode($),t++,r=16}}function M($){if(P($)||I($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let $;do $=F();while($>=12&&$<=15);return $}return{setPosition:v,getPosition:()=>t,scan:o?L:F,getToken:()=>r,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>t-a,getTokenError:()=>h}}e.createScanner=O;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function I(i){return i===10||i===13||i===8232||i===8233}function E(i){return i>=48&&i<=57}var C;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(C||(C={}));function b(i,o){const t=[],n=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function h(g,v,A,N){a.value=g,a.offset=v,a.length=A,a.type=N,a.colonOffset=void 0,s=a}try{p(i,{onObjectBegin:(g,v)=>{if(o<=g)throw n;s=void 0,r=o>g,t.push("")},onObjectProperty:(g,v,A)=>{if(o<v||(h(g,v,A,"property"),t[t.length-1]=g,o<=v+A))throw n},onObjectEnd:(g,v)=>{if(o<=g)throw n;s=void 0,t.pop()},onArrayBegin:(g,v)=>{if(o<=g)throw n;s=void 0,t.push(0)},onArrayEnd:(g,v)=>{if(o<=g)throw n;s=void 0,t.pop()},onLiteralValue:(g,v,A)=>{if(o<v||(h(g,v,A,R(g)),o<=v+A))throw n},onSeparator:(g,v,A)=>{if(o<=v)throw n;if(g===":"&&s&&s.type==="property")s.colonOffset=v,r=!1,s=void 0;else if(g===","){const N=t[t.length-1];typeof N=="number"?t[t.length-1]=N+1:(r=!0,t[t.length-1]=""),s=void 0}}})}catch(g){if(g!==n)throw g}return{path:t,previousNode:s,isAtPropertyKey:r,matches:g=>{let v=0;for(let A=0;v<g.length&&A<t.length;A++)if(g[v]===t[A]||g[v]==="*")v++;else if(g[v]!=="**")return!1;return v===g.length}}}e.getLocation=b;function m(i,o=[],t=l.DEFAULT){let n=null,s=[];const a=[];function r(g){Array.isArray(s)?s.push(g):n!==null&&(s[n]=g)}return p(i,{onObjectBegin:()=>{const g={};r(g),a.push(s),s=g,n=null},onObjectProperty:g=>{n=g},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const g=[];r(g),a.push(s),s=g,n=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:r,onError:(g,v,A)=>{o.push({error:g,offset:v,length:A})}},t),s[0]}e.parse=m;function y(i,o=[],t=l.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(g){n.type==="property"&&(n.length=g-n.offset,n=n.parent)}function a(g){return n.children.push(g),g}p(i,{onObjectBegin:g=>{n=a({type:"object",offset:g,length:-1,parent:n,children:[]})},onObjectProperty:(g,v,A)=>{n=a({type:"property",offset:v,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:g,offset:v,length:A,parent:n})},onObjectEnd:(g,v)=>{n.length=g+v-n.offset,n=n.parent,s(g+v)},onArrayBegin:(g,v)=>{n=a({type:"array",offset:g,length:-1,parent:n,children:[]})},onArrayEnd:(g,v)=>{n.length=g+v-n.offset,n=n.parent,s(g+v)},onLiteralValue:(g,v,A)=>{a({type:R(g),offset:v,length:A,parent:n,value:g}),s(v+A)},onSeparator:(g,v,A)=>{n.type==="property"&&(g===":"?n.colonOffset=v:g===","&&s(v))},onError:(g,v,A)=>{o.push({error:g,offset:v,length:A})}},t);const h=n.children[0];return h&&delete h.parent,h}e.parseTree=y;function u(i,o){if(!i)return;let t=i;for(const n of o)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const a of t.children)if(Array.isArray(a.children)&&a.children[0].value===n){t=a.children[1],s=!0;break}if(!s)return}else{const s=n;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}e.findNodeAtLocation=u;function S(i){if(!i.parent||!i.parent.children)return[];const o=S(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;o.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&o.push(t)}return o}e.getNodePath=S;function f(i){switch(i.type){case"array":return i.children.map(f);case"object":{const o=Object.create(null);for(const t of i.children){const n=t.children[1];n&&(o[t.children[0].value]=f(n))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=f;function c(i,o,t=!1){return o>=i.offset&&o<i.offset+i.length||t&&o===i.offset+i.length}e.contains=c;function d(i,o,t=!1){if(c(i,o,t)){const n=i.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=o;s++){const a=d(n[s],o,t);if(a)return a}return i}}e.findNodeAtOffset=d;function p(i,o,t=l.DEFAULT){const n=O(i,!1);function s(re){return re?()=>re(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(re){return re?te=>re(te,n.getTokenOffset(),n.getTokenLength()):()=>!0}const r=s(o.onObjectBegin),h=a(o.onObjectProperty),g=s(o.onObjectEnd),v=s(o.onArrayBegin),A=s(o.onArrayEnd),N=a(o.onLiteralValue),F=a(o.onSeparator),M=s(o.onComment),L=a(o.onError),$=t&&t.disallowComments,z=t&&t.allowTrailingComma;function x(){for(;;){const re=n.scan();switch(n.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:$||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(re){case 12:case 13:$?X(10):M();break;case 16:X(1);break;case 15:case 14:break;default:return re}}}function X(re,te=[],U=[]){if(L(re),te.length+U.length>0){let B=n.getToken();for(;B!==17;){if(te.indexOf(B)!==-1){x();break}else if(U.indexOf(B)!==-1)break;B=x()}}}function ie(re){const te=n.getTokenValue();return re?N(te):h(te),x(),!0}function H(){switch(n.getToken()){case 11:{let re=0;try{re=JSON.parse(n.getTokenValue()),typeof re!="number"&&(X(2),re=0)}catch{X(2)}N(re);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return x(),!0}function j(){return n.getToken()!==10?(X(3,[],[2,5]),!1):(ie(!1),n.getToken()===6?(F(":"),x(),_()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function V(){r(),x();let re=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(re||X(4,[],[]),F(","),x(),n.getToken()===2&&z)break}else re&&X(6,[],[]);j()||X(4,[],[2,5]),re=!0}return g(),n.getToken()!==2?X(7,[2],[]):x(),!0}function J(){v(),x();let re=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(re||X(4,[],[]),F(","),x(),n.getToken()===4&&z)break}else re&&X(6,[],[]);_()||X(4,[],[4,5]),re=!0}return A(),n.getToken()!==4?X(8,[4],[]):x(),!0}function _(){switch(n.getToken()){case 3:return J();case 1:return V();case 10:return ie(!0);default:return H()}}return x(),n.getToken()===17?t.allowEmptyContent?!0:(X(4,[],[]),!1):_()?(n.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.visit=p;function w(i,o){const t=O(i),n=[];let s,a=0,r;do switch(r=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:a!==r&&n.push(i.substring(a,r)),o!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,o)),a=t.getPosition();break}while(s!==17);return n.join("")}e.stripComments=w;function R(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=R}),define(oe[43],ae([0,1,35]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function T(E,C,b){let m,y,u,S,f;if(C){for(S=C.offset,f=S+C.length,u=S;u>0&&!I(E,u-1);)u--;let r=f;for(;r<E.length&&!I(E,r);)r++;y=E.substring(u,r),m=O(y,b)}else y=E,m=0,u=0,S=0,f=E.length;const c=P(b,E);let d=!1,p=0,w;b.insertSpaces?w=l(" ",b.tabSize||4):w="	";const R=(0,k.createScanner)(y,!1);let i=!1;function o(){return c+l(w,m+p)}function t(){let r=R.scan();for(d=!1;r===15||r===14;)d=d||r===14,r=R.scan();return i=r===16||R.getTokenError()!==0,r}const n=[];function s(r,h,g){!i&&h<f&&g>S&&E.substring(h,g)!==r&&n.push({offset:h,length:g-h,content:r})}let a=t();if(a!==17){const r=R.getTokenOffset()+u,h=l(w,m);s(h,u,r)}for(;a!==17;){let r=R.getTokenOffset()+R.getTokenLength()+u,h=t(),g="";for(;!d&&(h===12||h===13);){const A=R.getTokenOffset()+u;s(" ",r,A),r=R.getTokenOffset()+R.getTokenLength()+u,g=h===12?o():"",h=t()}if(h===2)a!==1&&(p--,g=o());else if(h===4)a!==3&&(p--,g=o());else{switch(a){case 3:case 1:p++,g=o();break;case 5:case 12:g=o();break;case 13:d?g=o():g=" ";break;case 6:g=" ";break;case 10:if(h===6){g="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?g=" ":h!==5&&h!==17&&(i=!0);break;case 16:i=!0;break}d&&(h===12||h===13)&&(g=o())}const v=R.getTokenOffset()+u;s(g,r,v),a=h}return n}e.format=T;function D(E,C){const b=JSON.stringify(E,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?b.replace(/\r\n|\r|\n/g,C.eol):b}e.toFormattedString=D;function l(E,C){let b="";for(let m=0;m<C;m++)b+=E;return b}function O(E,C){let b=0,m=0;const y=C.tabSize||4;for(;b<E.length;){const u=E.charAt(b);if(u===" ")m++;else if(u==="	")m+=y;else break;b++}return Math.floor(m/y)}function P(E,C){for(let b=0;b<C.length;b++){const m=C.charAt(b);if(m==="\r")return b+1<C.length&&C.charAt(b+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=P;function I(E,C){return`\r
`.indexOf(E.charAt(C))!==-1}e.isEOL=I}),define(oe[83],ae([0,1,35,43]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(E,C,b){return l(E,C,void 0,b)}e.removeProperty=D;function l(E,C,b,m,y){const u=C.slice(),S=[],f=(0,k.parseTree)(E,S);let c,d;for(;u.length>0&&(d=u.pop(),c=(0,k.findNodeAtLocation)(f,u),c===void 0&&b!==void 0);)typeof d=="string"?b={[d]:b}:b=[b];if(c)if(c.type==="object"&&typeof d=="string"&&Array.isArray(c.children)){const p=(0,k.findNodeAtLocation)(c,[d]);if(p!==void 0)if(b===void 0){if(!p.parent)throw new Error("Malformed AST");const w=c.children.indexOf(p.parent);let R,i=p.parent.offset+p.parent.length;if(w>0){const o=c.children[w-1];R=o.offset+o.length}else R=c.offset+1,c.children.length>1&&(i=c.children[1].offset);return O(E,{offset:R,length:i-R,content:""},m)}else return O(E,{offset:p.offset,length:p.length,content:JSON.stringify(b)},m);else{if(b===void 0)return[];const w=`${JSON.stringify(d)}: ${JSON.stringify(b)}`,R=y?y(c.children.map(o=>o.children[0].value)):c.children.length;let i;if(R>0){const o=c.children[R-1];i={offset:o.offset+o.length,length:0,content:","+w}}else c.children.length===0?i={offset:c.offset+1,length:0,content:w}:i={offset:c.offset+1,length:0,content:w+","};return O(E,i,m)}}else if(c.type==="array"&&typeof d=="number"&&Array.isArray(c.children))if(b!==void 0){const p=`${JSON.stringify(b)}`;let w;if(c.children.length===0||d===0)w={offset:c.offset+1,length:0,content:c.children.length===0?p:p+","};else{const R=d===-1||d>c.children.length?c.children.length:d,i=c.children[R-1];w={offset:i.offset+i.length,length:0,content:","+p}}return O(E,w,m)}else{const p=d,w=c.children[p];let R;if(c.children.length===1)R={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===p){const i=c.children[p-1],o=i.offset+i.length,t=c.offset+c.length;R={offset:o,length:t-2-o,content:""}}else R={offset:w.offset,length:c.children[p+1].offset-w.offset,content:""};return O(E,R,m)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${c.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return O(E,{offset:f?f.offset:0,length:f?f.length:0,content:JSON.stringify(b)},m)}}e.setProperty=l;function O(E,C,b){let m=P(E,C),y=C.offset,u=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;y>0&&!(0,T.isEOL)(m,y-1);)y--;for(;u<m.length&&!(0,T.isEOL)(m,u);)u++}const S=(0,T.format)(m,{offset:y,length:u-y},b);for(let c=S.length-1;c>=0;c--){const d=S[c];m=P(m,d),y=Math.min(y,d.offset),u=Math.max(u,d.offset+d.length),u+=d.content.length-d.length}const f=E.length-(m.length-u)-y;return[{offset:y,length:f,content:m.substring(y,u)}]}e.withFormatting=O;function P(E,C){return E.substring(0,C.offset)+C.content+E.substring(C.offset+C.length)}e.applyEdit=P;function I(E,C){const b=C.slice(0).sort((y,u)=>{const S=y.offset-u.offset;return S===0?y.length-u.length:S});let m=E.length;for(let y=b.length-1;y>=0;y--){const u=b[y];if(u.offset+u.length<=m)E=P(E,u);else throw new Error("Overlapping edit");m=u.offset}return E}e.applyEdits=I}),define(oe[129],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class k{constructor(D){this.d=D,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(D){this.c=D}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=k}),define(oe[2],ae([0,1,82,64]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let l=null;function O(a){l=a}if(e.setDisposableTracker=O,D){const a="__is_disposable_tracked__";O(new class{trackDisposable(r){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[a]||console.log(h)},3e3)}setParent(r,h){if(r&&r!==d.None)try{r[a]=!0}catch{}}markAsDisposed(r){if(r&&r!==d.None)try{r[a]=!0}catch{}}markAsSingleton(r){}})}function P(a){return l?.trackDisposable(a),a}function I(a){l?.markAsDisposed(a)}function E(a,r){l?.setParent(a,r)}function C(a,r){if(!!l)for(const h of a)l.setParent(h,r)}function b(a){return l?.markAsSingleton(a),a}e.markAsSingleton=b;function m(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=m;function y(a){if(T.Iterable.is(a)){const r=[];for(const h of a)if(h)try{h.dispose()}catch(g){r.push(g)}if(r.length===1)throw r[0];if(r.length>1)throw new AggregateError(r,"Encountered errors while disposing of store");return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.dispose=y;function u(a){for(const r of a)m(r)&&r.dispose();return[]}e.disposeIfDisposable=u;function S(...a){const r=f(()=>y(a));return C(a,r),r}e.combinedDisposable=S;function f(a){const r=P({dispose:(0,k.once)(()=>{I(r),a()})});return r}e.toDisposable=f;class c{constructor(){this.c=new Set,this.f=!1,P(this)}dispose(){this.f||(I(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{y(this.c)}finally{this.c.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return E(r,this),this.f?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(r),r}}e.DisposableStore=c,c.DISABLE_DISPOSED_WARNING=!1;class d{constructor(){this.q=new c,P(this),E(this.q,this)}dispose(){I(this),this.q.dispose()}B(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(r)}}e.Disposable=d,d.None=Object.freeze({dispose(){}});class p{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(r){this.b||r===this.a||(this.a?.dispose(),r&&E(r,this),this.a=r)}clear(){this.value=void 0}dispose(){this.b=!0,I(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const r=this.a;return this.a=void 0,r&&E(r,null),r}}e.MutableDisposable=p;class w{constructor(r){this.b=r,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=w;class R{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(r){let h=r;return this.unset=()=>h=void 0,this.isset=()=>h!==void 0,this.dispose=()=>{h&&(h(),h=void 0,I(this))},this}}e.SafeDisposable=R;class i{constructor(){this.a=new Map}acquire(r,...h){let g=this.a.get(r);g||(g={counter:0,object:this.b(r,...h)},this.a.set(r,g));const{object:v}=g,A=(0,k.once)(()=>{--g.counter===0&&(this.c(r,g.object),this.a.delete(r))});return g.counter++,{object:v,dispose:A}}}e.ReferenceCollection=i;class o{constructor(r){this.a=r}async acquire(r,...h){const g=this.a.acquire(r,...h);try{return{object:await g.object,dispose:()=>g.dispose()}}catch(v){throw g.dispose(),v}}}e.AsyncReferenceCollection=o;class t{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=t;function n(a){const r=new c;try{a(r)}finally{r.dispose()}}e.disposeOnReturn=n;class s{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){I(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{y(this.a.values())}finally{this.a.clear()}}has(r){return this.a.has(r)}get(r){return this.a.get(r)}set(r,h,g=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),g||this.a.get(r)?.dispose(),this.a.set(r,h)}deleteAndDispose(r){this.a.get(r)?.dispose(),this.a.delete(r)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=s}),define(oe[84],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{constructor(l){this.element=l,this.next=k.Undefined,this.prev=k.Undefined}}k.Undefined=new k(void 0);class T{constructor(){this.a=k.Undefined,this.b=k.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===k.Undefined}clear(){let l=this.a;for(;l!==k.Undefined;){const O=l.next;l.prev=k.Undefined,l.next=k.Undefined,l=O}this.a=k.Undefined,this.b=k.Undefined,this.c=0}unshift(l){return this.d(l,!1)}push(l){return this.d(l,!0)}d(l,O){const P=new k(l);if(this.a===k.Undefined)this.a=P,this.b=P;else if(O){const E=this.b;this.b=P,P.prev=E,E.next=P}else{const E=this.a;this.a=P,P.next=E,E.prev=P}this.c+=1;let I=!1;return()=>{I||(I=!0,this.e(P))}}shift(){if(this.a!==k.Undefined){const l=this.a.element;return this.e(this.a),l}}pop(){if(this.b!==k.Undefined){const l=this.b.element;return this.e(this.b),l}}e(l){if(l.prev!==k.Undefined&&l.next!==k.Undefined){const O=l.prev;O.next=l.next,l.next.prev=O}else l.prev===k.Undefined&&l.next===k.Undefined?(this.a=k.Undefined,this.b=k.Undefined):l.next===k.Undefined?(this.b=this.b.prev,this.b.next=k.Undefined):l.prev===k.Undefined&&(this.a=this.a.next,this.a.prev=k.Undefined);this.c-=1}*[Symbol.iterator](){let l=this.a;for(;l!==k.Undefined;)yield l.element,l=l.next}}e.LinkedList=T}),define(oe[37],ae([0,1]),function(Q,e){"use strict";var k,T,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function l(u,S,f){let c=u.get(S);return c===void 0&&(c=f,u.set(S,c)),c}e.getOrSet=l;function O(u){const S=[];return u.forEach((f,c)=>{S.push(`${c} => ${f}`)}),`Map(${u.size}) {${S.join(", ")}}`}e.mapToString=O;function P(u){const S=[];return u.forEach(f=>{S.push(f)}),`Set(${u.size}) {${S.join(", ")}}`}e.setToString=P;class I{constructor(S,f){this.uri=S,this.value=f}}class E{constructor(S,f){this[k]="ResourceMap",S instanceof E?(this.b=new Map(S.b),this.c=f??E.a):(this.b=new Map,this.c=S??E.a)}set(S,f){return this.b.set(this.c(S),new I(S,f)),this}get(S){return this.b.get(this.c(S))?.value}has(S){return this.b.has(this.c(S))}get size(){return this.b.size}clear(){this.b.clear()}delete(S){return this.b.delete(this.c(S))}forEach(S,f){typeof f<"u"&&(S=S.bind(f));for(const[c,d]of this.b)S(d.value,d.uri,this)}*values(){for(const S of this.b.values())yield S.value}*keys(){for(const S of this.b.values())yield S.uri}*entries(){for(const S of this.b.values())yield[S.uri,S.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,S]of this.b)yield[S.uri,S.value]}}e.ResourceMap=E,E.a=u=>u.toString();class C{constructor(S,f){this[T]="ResourceSet",!S||typeof S=="function"?this.a=new E(S):(this.a=new E(f),S.forEach(this.add,this))}get size(){return this.a.size}add(S){return this.a.set(S,S),this}clear(){this.a.clear()}delete(S){return this.a.delete(S)}forEach(S,f){this.a.forEach((c,d)=>S.call(f,d,d,this))}has(S){return this.a.has(S)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=C;var b;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class m{constructor(){this[D]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(S){return this.a.has(S)}get(S,f=0){const c=this.a.get(S);if(!!c)return f!==0&&this.j(c,f),c.value}set(S,f,c=0){let d=this.a.get(S);if(d)d.value=f,c!==0&&this.j(d,c);else{switch(d={key:S,value:f,next:void 0,previous:void 0},c){case 0:this.h(d);break;case 1:this.g(d);break;case 2:this.h(d);break;default:this.h(d);break}this.a.set(S,d),this.d++}return this}delete(S){return!!this.remove(S)}remove(S){const f=this.a.get(S);if(!!f)return this.a.delete(S),this.i(f),this.d--,f.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const S=this.b;return this.a.delete(S.key),this.i(S),this.d--,S.value}forEach(S,f){const c=this.e;let d=this.b;for(;d;){if(f?S.bind(f)(d.value,d.key,this):S(d.value,d.key,this),this.e!==c)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const S=this,f=this.e;let c=this.b;const d={[Symbol.iterator](){return d},next(){if(S.e!==f)throw new Error("LinkedMap got modified during iteration.");if(c){const p={value:c.key,done:!1};return c=c.next,p}else return{value:void 0,done:!0}}};return d}values(){const S=this,f=this.e;let c=this.b;const d={[Symbol.iterator](){return d},next(){if(S.e!==f)throw new Error("LinkedMap got modified during iteration.");if(c){const p={value:c.value,done:!1};return c=c.next,p}else return{value:void 0,done:!0}}};return d}entries(){const S=this,f=this.e;let c=this.b;const d={[Symbol.iterator](){return d},next(){if(S.e!==f)throw new Error("LinkedMap got modified during iteration.");if(c){const p={value:[c.key,c.value],done:!1};return c=c.next,p}else return{value:void 0,done:!0}}};return d}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(S){if(S>=this.size)return;if(S===0){this.clear();return}let f=this.b,c=this.size;for(;f&&c>S;)this.a.delete(f.key),f=f.next,c--;this.b=f,this.d=c,f&&(f.previous=void 0),this.e++}g(S){if(!this.b&&!this.c)this.c=S;else if(this.b)S.next=this.b,this.b.previous=S;else throw new Error("Invalid list");this.b=S,this.e++}h(S){if(!this.b&&!this.c)this.b=S;else if(this.c)S.previous=this.c,this.c.next=S;else throw new Error("Invalid list");this.c=S,this.e++}i(S){if(S===this.b&&S===this.c)this.b=void 0,this.c=void 0;else if(S===this.b){if(!S.next)throw new Error("Invalid list");S.next.previous=void 0,this.b=S.next}else if(S===this.c){if(!S.previous)throw new Error("Invalid list");S.previous.next=void 0,this.c=S.previous}else{const f=S.next,c=S.previous;if(!f||!c)throw new Error("Invalid list");f.previous=c,c.next=f}S.next=void 0,S.previous=void 0,this.e++}j(S,f){if(!this.b||!this.c)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(S===this.b)return;const c=S.next,d=S.previous;S===this.c?(d.next=void 0,this.c=d):(c.previous=d,d.next=c),S.previous=void 0,S.next=this.b,this.b.previous=S,this.b=S,this.e++}else if(f===2){if(S===this.c)return;const c=S.next,d=S.previous;S===this.b?(c.previous=void 0,this.b=c):(c.previous=d,d.next=c),S.next=void 0,S.previous=this.c,this.c.next=S,this.c=S,this.e++}}}toJSON(){const S=[];return this.forEach((f,c)=>{S.push([c,f])}),S}fromJSON(S){this.clear();for(const[f,c]of S)this.set(f,c)}}e.LinkedMap=m;class y extends m{constructor(S,f=1){super(),this.k=S,this.l=Math.min(Math.max(0,f),1)}get limit(){return this.k}set limit(S){this.k=S,this.m()}get ratio(){return this.l}set ratio(S){this.l=Math.min(Math.max(0,S),1),this.m()}get(S,f=2){return super.get(S,f)}peek(S){return super.get(S,0)}set(S,f){return super.set(S,f,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=y}),define(oe[85],ae([0,1,37]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const T=new k.LRUCache(1e4);function D(E){return I(E,"NFC",T)}e.normalizeNFC=D;const l=new k.LRUCache(1e4);function O(E){return I(E,"NFD",l)}e.normalizeNFD=O;const P=/[^\u0000-\u0080]/;function I(E,C,b){if(!E)return E;const m=b.get(E);if(m)return m;let y;return P.test(E)?y=E.normalize(C):y=E,b.set(E,y),y}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(C){return O(C).replace(E,"")}}()}),define(oe[130],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function k(P,I,E){return Math.min(Math.max(P,I),E)}e.clamp=k;function T(P,I){return(I+P%I)%I}e.rot=T;class D{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=D;class l{constructor(){this.a=1,this.b=0}update(I){return this.b=this.b+(I-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=l;class O{constructor(I){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(I),this.c.fill(0,0,I)}update(I){const E=this.c[this.d];return this.c[this.d]=I,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=I,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=O}),function(){function Q(D){const l=[];typeof D=="number"&&l.push("code/timeOrigin",D);function O(I){l.push(I,Date.now())}function P(){const I=[];for(let E=0;E<l.length;E+=2)I.push({name:l[E],startTime:l[E+1]});return I}return{mark:O,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const l=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const O of performance.getEntriesByType("mark"))l.push({name:O.name,startTime:Math.round(D+O.startTime)});return l}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function k(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=k(T))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var T in k)(typeof exports=="object"?exports:Q)[T]=k[T]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function k(T){if(e[T])return e[T].exports;var D=e[T]={i:T,l:!1,exports:{}};return Q[T].call(D.exports,D,D.exports,k),D.l=!0,D.exports}return k.m=Q,k.c=e,k.d=function(T,D,l){k.o(T,D)||Object.defineProperty(T,D,{enumerable:!0,get:l})},k.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},k.t=function(T,D){if(1&D&&(T=k(T)),8&D||4&D&&typeof T=="object"&&T&&T.__esModule)return T;var l=Object.create(null);if(k.r(l),Object.defineProperty(l,"default",{enumerable:!0,value:T}),2&D&&typeof T!="string")for(var O in T)k.d(l,O,function(P){return T[P]}.bind(null,O));return l},k.n=function(T){var D=T&&T.__esModule?function(){return T.default}:function(){return T};return k.d(D,"a",D),D},k.o=function(T,D){return Object.prototype.hasOwnProperty.call(T,D)},k.p="",k(k.s=0)}([function(Q,e,k){(function(T){var D;e=Q.exports=U,D=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var l=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],I=e.src=[],E=0,C=E++;I[C]="0|[1-9]\\d*";var b=E++;I[b]="[0-9]+";var m=E++;I[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=E++;I[y]="("+I[C]+")\\.("+I[C]+")\\.("+I[C]+")";var u=E++;I[u]="("+I[b]+")\\.("+I[b]+")\\.("+I[b]+")";var S=E++;I[S]="(?:"+I[C]+"|"+I[m]+")";var f=E++;I[f]="(?:"+I[b]+"|"+I[m]+")";var c=E++;I[c]="(?:-("+I[S]+"(?:\\."+I[S]+")*))";var d=E++;I[d]="(?:-?("+I[f]+"(?:\\."+I[f]+")*))";var p=E++;I[p]="[0-9A-Za-z-]+";var w=E++;I[w]="(?:\\+("+I[p]+"(?:\\."+I[p]+")*))";var R=E++,i="v?"+I[y]+I[c]+"?"+I[w]+"?";I[R]="^"+i+"$";var o="[v=\\s]*"+I[u]+I[d]+"?"+I[w]+"?",t=E++;I[t]="^"+o+"$";var n=E++;I[n]="((?:<|>)?=?)";var s=E++;I[s]=I[b]+"|x|X|\\*";var a=E++;I[a]=I[C]+"|x|X|\\*";var r=E++;I[r]="[v=\\s]*("+I[a]+")(?:\\.("+I[a]+")(?:\\.("+I[a]+")(?:"+I[c]+")?"+I[w]+"?)?)?";var h=E++;I[h]="[v=\\s]*("+I[s]+")(?:\\.("+I[s]+")(?:\\.("+I[s]+")(?:"+I[d]+")?"+I[w]+"?)?)?";var g=E++;I[g]="^"+I[n]+"\\s*"+I[r]+"$";var v=E++;I[v]="^"+I[n]+"\\s*"+I[h]+"$";var A=E++;I[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=E++;I[N]="(?:~>?)";var F=E++;I[F]="(\\s*)"+I[N]+"\\s+",P[F]=new RegExp(I[F],"g");var M=E++;I[M]="^"+I[N]+I[r]+"$";var L=E++;I[L]="^"+I[N]+I[h]+"$";var $=E++;I[$]="(?:\\^)";var z=E++;I[z]="(\\s*)"+I[$]+"\\s+",P[z]=new RegExp(I[z],"g");var x=E++;I[x]="^"+I[$]+I[r]+"$";var X=E++;I[X]="^"+I[$]+I[h]+"$";var ie=E++;I[ie]="^"+I[n]+"\\s*("+o+")$|^$";var H=E++;I[H]="^"+I[n]+"\\s*("+i+")$|^$";var j=E++;I[j]="(\\s*)"+I[n]+"\\s*("+o+"|"+I[r]+")",P[j]=new RegExp(I[j],"g");var V=E++;I[V]="^\\s*("+I[r]+")\\s+-\\s+("+I[r]+")\\s*$";var J=E++;I[J]="^\\s*("+I[h]+")\\s+-\\s+("+I[h]+")\\s*$";var _=E++;I[_]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)D(re,I[re]),P[re]||(P[re]=new RegExp(I[re]));function te(ce,de){if(ce instanceof U)return ce;if(typeof ce!="string"||ce.length>l||!(de?P[t]:P[R]).test(ce))return null;try{return new U(ce,de)}catch{return null}}function U(ce,de){if(ce instanceof U){if(ce.loose===de)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>l)throw new TypeError("version is longer than "+l+" characters");if(!(this instanceof U))return new U(ce,de);D("SemVer",ce,de),this.loose=de;var ge=ce.trim().match(de?P[t]:P[R]);if(!ge)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Pe=+Ce;if(Pe>=0&&Pe<O)return Pe}return Ce}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=te,e.valid=function(ce,de){var ge=te(ce,de);return ge?ge.version:null},e.clean=function(ce,de){var ge=te(ce.trim().replace(/^[=v]+/,""),de);return ge?ge.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(ce){return D("SemVer.compare",this.version,this.loose,ce),ce instanceof U||(ce=new U(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},U.prototype.compareMain=function(ce){return ce instanceof U||(ce=new U(ce,this.loose)),W(this.major,ce.major)||W(this.minor,ce.minor)||W(this.patch,ce.patch)},U.prototype.comparePre=function(ce){if(ce instanceof U||(ce=new U(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var de=0;do{var ge=this.prerelease[de],Ce=ce.prerelease[de];if(D("prerelease compare",de,ge,Ce),ge===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ce)return W(ge,Ce)}while(++de)},U.prototype.inc=function(ce,de){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,de,ge,Ce){typeof ge=="string"&&(Ce=ge,ge=void 0);try{return new U(ce,ge).inc(de,Ce).version}catch{return null}},e.diff=function(ce,de){if(K(ce,de))return null;var ge=te(ce),Ce=te(de);if(ge.prerelease.length||Ce.prerelease.length){for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ce[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ce[Pe])return Pe},e.compareIdentifiers=W;var B=/^[0-9]+$/;function W(ce,de){var ge=B.test(ce),Ce=B.test(de);return ge&&Ce&&(ce=+ce,de=+de),ge&&!Ce?-1:Ce&&!ge?1:ce<de?-1:ce>de?1:0}function q(ce,de,ge){return new U(ce,ge).compare(new U(de,ge))}function Y(ce,de,ge){return q(ce,de,ge)>0}function ee(ce,de,ge){return q(ce,de,ge)<0}function K(ce,de,ge){return q(ce,de,ge)===0}function Z(ce,de,ge){return q(ce,de,ge)!==0}function se(ce,de,ge){return q(ce,de,ge)>=0}function le(ce,de,ge){return q(ce,de,ge)<=0}function ue(ce,de,ge,Ce){var Pe;switch(de){case"===":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce===ge;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce!==ge;break;case"":case"=":case"==":Pe=K(ce,ge,Ce);break;case"!=":Pe=Z(ce,ge,Ce);break;case">":Pe=Y(ce,ge,Ce);break;case">=":Pe=se(ce,ge,Ce);break;case"<":Pe=ee(ce,ge,Ce);break;case"<=":Pe=le(ce,ge,Ce);break;default:throw new TypeError("Invalid operator: "+de)}return Pe}function pe(ce,de){if(ce instanceof pe){if(ce.loose===de)return ce;ce=ce.value}if(!(this instanceof pe))return new pe(ce,de);D("comparator",ce,de),this.loose=de,this.parse(ce),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ce,de){return W(de,ce)},e.major=function(ce,de){return new U(ce,de).major},e.minor=function(ce,de){return new U(ce,de).minor},e.patch=function(ce,de){return new U(ce,de).patch},e.compare=q,e.compareLoose=function(ce,de){return q(ce,de,!0)},e.rcompare=function(ce,de,ge){return q(de,ce,ge)},e.sort=function(ce,de){return ce.sort(function(ge,Ce){return e.compare(ge,Ce,de)})},e.rsort=function(ce,de){return ce.sort(function(ge,Ce){return e.rcompare(ge,Ce,de)})},e.gt=Y,e.lt=ee,e.eq=K,e.neq=Z,e.gte=se,e.lte=le,e.cmp=ue,e.Comparator=pe;var ve={};function be(ce,de){if(ce instanceof be)return ce.loose===de?ce:new be(ce.raw,de);if(ce instanceof pe)return new be(ce.value,de);if(!(this instanceof be))return new be(ce,de);if(this.loose=de,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function Ee(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function Oe(ce,de,ge,Ce,Pe,Le,De,je,Te,Fe,ze,ke,Ne){return((de=Ee(ge)?"":Ee(Ce)?">="+ge+".0.0":Ee(Pe)?">="+ge+"."+Ce+".0":">="+de)+" "+(je=Ee(Te)?"":Ee(Fe)?"<"+(+Te+1)+".0.0":Ee(ze)?"<"+Te+"."+(+Fe+1)+".0":ke?"<="+Te+"."+Fe+"."+ze+"-"+ke:"<="+je)).trim()}function Ue(ce,de){for(var ge=0;ge<ce.length;ge++)if(!ce[ge].test(de))return!1;if(de.prerelease.length){for(ge=0;ge<ce.length;ge++)if(D(ce[ge].semver),ce[ge].semver!==ve&&ce[ge].semver.prerelease.length>0){var Ce=ce[ge].semver;if(Ce.major===de.major&&Ce.minor===de.minor&&Ce.patch===de.patch)return!0}return!1}return!0}function Ye(ce,de,ge){try{de=new be(de,ge)}catch{return!1}return de.test(ce)}function Be(ce,de,ge,Ce){var Pe,Le,De,je,Te;switch(ce=new U(ce,Ce),de=new be(de,Ce),ge){case">":Pe=Y,Le=le,De=ee,je=">",Te=">=";break;case"<":Pe=ee,Le=se,De=Y,je="<",Te="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ye(ce,de,Ce))return!1;for(var Fe=0;Fe<de.set.length;++Fe){var ze=de.set[Fe],ke=null,Ne=null;if(ze.forEach(function(ne){ne.semver===ve&&(ne=new pe(">=0.0.0")),ke=ke||ne,Ne=Ne||ne,Pe(ne.semver,ke.semver,Ce)?ke=ne:De(ne.semver,Ne.semver,Ce)&&(Ne=ne)}),ke.operator===je||ke.operator===Te||(!Ne.operator||Ne.operator===je)&&Le(ce,Ne.semver)||Ne.operator===Te&&De(ce,Ne.semver))return!1}return!0}pe.prototype.parse=function(ce){var de=this.loose?P[ie]:P[H],ge=ce.match(de);if(!ge)throw new TypeError("Invalid comparator: "+ce);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new U(ge[2],this.loose):this.semver=ve},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(ce){return D("Comparator.test",ce,this.loose),this.semver===ve||(typeof ce=="string"&&(ce=new U(ce,this.loose)),ue(ce,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(ce,de){if(!(ce instanceof pe))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(ce.value,de),Ye(this.value,ge,de);if(ce.operator==="")return ge=new be(this.value,de),Ye(ce.semver,ge,de);var Ce=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Le=this.semver.version===ce.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),je=ue(this.semver,"<",ce.semver,de)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Te=ue(this.semver,">",ce.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Ce||Pe||Le&&De||je||Te},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(ce){var de=this.loose;ce=ce.trim(),D("range",ce,de);var ge=de?P[J]:P[V];ce=ce.replace(ge,Oe),D("hyphen replace",ce),ce=ce.replace(P[j],"$1$2$3"),D("comparator trim",ce,P[j]),ce=(ce=(ce=ce.replace(P[F],"$1~")).replace(P[z],"$1^")).split(/\s+/).join(" ");var Ce=de?P[ie]:P[H],Pe=ce.split(" ").map(function(Le){return function(De,je){return D("comp",De),De=function(Te,Fe){return Te.trim().split(/\s+/).map(function(ze){return function(ke,Ne){D("caret",ke,Ne);var ne=Ne?P[X]:P[x];return ke.replace(ne,function(he,fe,me,Se,Ie){var Re;return D("caret",ke,he,fe,me,Se,Ie),Ee(fe)?Re="":Ee(me)?Re=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ee(Se)?Re=fe==="0"?">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+".0 <"+(+fe+1)+".0.0":Ie?(D("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Re=fe==="0"?me==="0"?">="+fe+"."+me+"."+Se+Ie+" <"+fe+"."+me+"."+(+Se+1):">="+fe+"."+me+"."+Se+Ie+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+Se+Ie+" <"+(+fe+1)+".0.0"):(D("no pr"),Re=fe==="0"?me==="0"?">="+fe+"."+me+"."+Se+" <"+fe+"."+me+"."+(+Se+1):">="+fe+"."+me+"."+Se+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+Se+" <"+(+fe+1)+".0.0"),D("caret return",Re),Re})}(ze,Fe)}).join(" ")}(De,je),D("caret",De),De=function(Te,Fe){return Te.trim().split(/\s+/).map(function(ze){return function(ke,Ne){var ne=Ne?P[L]:P[M];return ke.replace(ne,function(he,fe,me,Se,Ie){var Re;return D("tilde",ke,he,fe,me,Se,Ie),Ee(fe)?Re="":Ee(me)?Re=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ee(Se)?Re=">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":Ie?(D("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Re=">="+fe+"."+me+"."+Se+Ie+" <"+fe+"."+(+me+1)+".0"):Re=">="+fe+"."+me+"."+Se+" <"+fe+"."+(+me+1)+".0",D("tilde return",Re),Re})}(ze,Fe)}).join(" ")}(De,je),D("tildes",De),De=function(Te,Fe){return D("replaceXRanges",Te,Fe),Te.split(/\s+/).map(function(ze){return function(ke,Ne){ke=ke.trim();var ne=Ne?P[v]:P[g];return ke.replace(ne,function(he,fe,me,Se,Ie,Re){D("xRange",ke,he,fe,me,Se,Ie,Re);var xe=Ee(me),$e=xe||Ee(Se),Ae=$e||Ee(Ie);return fe==="="&&Ae&&(fe=""),xe?he=fe===">"||fe==="<"?"<0.0.0":"*":fe&&Ae?($e&&(Se=0),Ae&&(Ie=0),fe===">"?(fe=">=",$e?(me=+me+1,Se=0,Ie=0):Ae&&(Se=+Se+1,Ie=0)):fe==="<="&&(fe="<",$e?me=+me+1:Se=+Se+1),he=fe+me+"."+Se+"."+Ie):$e?he=">="+me+".0.0 <"+(+me+1)+".0.0":Ae&&(he=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0"),D("xRange return",he),he})}(ze,Fe)}).join(" ")}(De,je),D("xrange",De),De=function(Te,Fe){return D("replaceStars",Te,Fe),Te.trim().replace(P[_],"")}(De,je),D("stars",De),De}(Le,de)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Le){return!!Le.match(Ce)})),Pe=Pe.map(function(Le){return new pe(Le,de)})},be.prototype.intersects=function(ce,de){if(!(ce instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ce){return ce.set.some(function(Pe){return Pe.every(function(Le){return Ce.intersects(Le,de)})})})})},e.toComparators=function(ce,de){return new be(ce,de).set.map(function(ge){return ge.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},be.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new U(ce,this.loose));for(var de=0;de<this.set.length;de++)if(Ue(this.set[de],ce))return!0;return!1},e.satisfies=Ye,e.maxSatisfying=function(ce,de,ge){var Ce=null,Pe=null;try{var Le=new be(de,ge)}catch{return null}return ce.forEach(function(De){Le.test(De)&&(Ce&&Pe.compare(De)!==-1||(Pe=new U(Ce=De,ge)))}),Ce},e.minSatisfying=function(ce,de,ge){var Ce=null,Pe=null;try{var Le=new be(de,ge)}catch{return null}return ce.forEach(function(De){Le.test(De)&&(Ce&&Pe.compare(De)!==1||(Pe=new U(Ce=De,ge)))}),Ce},e.validRange=function(ce,de){try{return new be(ce,de).range||"*"}catch{return null}},e.ltr=function(ce,de,ge){return Be(ce,de,"<",ge)},e.gtr=function(ce,de,ge){return Be(ce,de,">",ge)},e.outside=Be,e.prerelease=function(ce,de){var ge=te(ce,de);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ce,de,ge){return ce=new be(ce,ge),de=new be(de,ge),ce.intersects(de)},e.coerce=function(ce){if(ce instanceof U)return ce;if(typeof ce!="string")return null;var de=ce.match(P[A]);return de==null?null:te((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,k(1))},function(Q,e){var k,T,D=Q.exports={};function l(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function P(f){if(k===setTimeout)return setTimeout(f,0);if((k===l||!k)&&setTimeout)return k=setTimeout,setTimeout(f,0);try{return k(f,0)}catch{try{return k.call(null,f,0)}catch{return k.call(this,f,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:l}catch{k=l}try{T=typeof clearTimeout=="function"?clearTimeout:O}catch{T=O}})();var I,E=[],C=!1,b=-1;function m(){C&&I&&(C=!1,I.length?E=I.concat(E):b=-1,E.length&&y())}function y(){if(!C){var f=P(m);C=!0;for(var c=E.length;c;){for(I=E,E=[];++b<c;)I&&I[b].run();b=-1,c=E.length}I=null,C=!1,function(d){if(T===clearTimeout)return clearTimeout(d);if((T===O||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(d);try{T(d)}catch{try{return T.call(null,d)}catch{return T.call(this,d)}}}(f)}}function u(f,c){this.fun=f,this.array=c}function S(){}D.nextTick=function(f){var c=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)c[d-1]=arguments[d];E.push(new u(f,c)),E.length!==1||C||P(y)},u.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=S,D.addListener=S,D.once=S,D.off=S,D.removeListener=S,D.removeAllListeners=S,D.emit=S,D.prependListener=S,D.prependOnceListener=S,D.listeners=function(f){return[]},D.binding=function(f){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(f){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(oe[131],ae([0,1]),function(Q,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class T{constructor(P,I,E){this.level=P,this.key=I,this.value=E,this.forward=[]}}const D=void 0;class l{constructor(P,I=2**16){this.comparator=P,this[k]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(I)|0),this.e=new T(this.c,D,D)}get size(){return this.f}clear(){this.e=new T(this.c,D,D)}has(P){return Boolean(l.g(this,P,this.comparator))}get(P){return l.g(this,P,this.comparator)?.value}set(P,I){return l.h(this,P,I,this.comparator)&&(this.f+=1),this}delete(P){const I=l.k(this,P,this.comparator);return I&&(this.f-=1),I}forEach(P,I){let E=this.e.forward[0];for(;E;)P.call(I,E.value,E.key,this),E=E.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",I=this.e.forward[0];for(;I;)P+=`node(${I.key}, ${I.value}, lvl:${I.level})`,I=I.forward[0];return P}static g(P,I,E){let C=P.e;for(let b=P.d-1;b>=0;b--)for(;C.forward[b]&&E(C.forward[b].key,I)<0;)C=C.forward[b];if(C=C.forward[0],C&&E(C.key,I)===0)return C}static h(P,I,E,C){const b=[];let m=P.e;for(let y=P.d-1;y>=0;y--){for(;m.forward[y]&&C(m.forward[y].key,I)<0;)m=m.forward[y];b[y]=m}if(m=m.forward[0],m&&C(m.key,I)===0)return m.value=E,!1;{const y=l.j(P);if(y>P.d){for(let u=P.d;u<y;u++)b[u]=P.e;P.d=y}m=new T(y,I,E);for(let u=0;u<y;u++)m.forward[u]=b[u].forward[u],b[u].forward[u]=m;return!0}}static j(P,I=.5){let E=1;for(;Math.random()<I&&E<P.c;)E+=1;return E}static k(P,I,E){const C=[];let b=P.e;for(let m=P.d-1;m>=0;m--){for(;b.forward[m]&&E(b.forward[m].key,I)<0;)b=b.forward[m];C[m]=b}if(b=b.forward[0],!b||E(b.key,I)!==0)return!1;for(let m=0;m<P.d&&C[m].forward[m]===b;m++)C[m].forward[m]=b.forward[m];for(;P.d>0&&P.e.forward[P.d-1]===D;)P.d-=1;return!0}}e.SkipList=l}),define(oe[44],ae([0,1,9,2]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(w){const R=w;return R?typeof R.read=="function":!1}e.isReadable=D;function l(w){const R=w;return R?[R.on,R.pause,R.resume,R.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=l;function O(w){const R=w;return R?l(R.stream)&&Array.isArray(R.buffer)&&typeof R.ended=="boolean":!1}e.isReadableBufferedStream=O;function P(w,R){return new I(w,R)}e.newWriteableStream=P;class I{constructor(R,i){this.e=R,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(R){if(!this.a.destroyed){if(this.a.flowing)this.g(R);else if(this.b.data.push(R),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(R){this.a.destroyed||(this.a.flowing?this.h(R):this.b.error.push(R))}end(R){this.a.destroyed||(typeof R<"u"&&this.write(R),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(R){this.c.data.slice(0).forEach(i=>i(R))}h(R){this.c.error.length===0?(0,k.onUnexpectedError)(R):this.c.error.slice(0).forEach(i=>i(R))}i(){this.c.end.slice(0).forEach(R=>R())}on(R,i){if(!this.a.destroyed)switch(R){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(R,i){if(this.a.destroyed)return;let o;switch(R){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const t=o.indexOf(i);t>=0&&o.splice(t,1)}}j(){if(this.b.data.length>0){const R=this.e(this.b.data);this.g(R),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const R of this.b.error)this.h(R);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(w,R){const i=[];let o;for(;(o=w.read())!==null;)i.push(o);return R(i)}e.consumeReadable=E;function C(w,R,i){const o=[];let t;for(;(t=w.read())!==null&&o.length<i;)o.push(t);return t===null&&o.length>0?R(o):{read:()=>{if(o.length>0)return o.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return w.read()}}}e.peekReadable=C;function b(w,R){return new Promise((i,o)=>{const t=[];m(w,{onData:n=>{R&&t.push(n)},onError:n=>{R?o(n):i(void 0)},onEnd:()=>{i(R?R(t):void 0)}})})}e.consumeStream=b;function m(w,R){let i=!1;return w.on("error",o=>{i||R.onError(o)}),w.on("end",()=>{i||R.onEnd()}),w.on("data",o=>{i||R.onData(o)}),(0,T.toDisposable)(()=>i=!0)}e.listenStream=m;function y(w,R){return new Promise((i,o)=>{const t=new T.DisposableStore,n=[],s=h=>{if(n.push(h),n.length>R)return t.dispose(),w.pause(),i({stream:w,buffer:n,ended:!1})},a=h=>o(h),r=()=>i({stream:w,buffer:n,ended:!0});t.add((0,T.toDisposable)(()=>w.removeListener("error",a))),w.on("error",a),t.add((0,T.toDisposable)(()=>w.removeListener("end",r))),w.on("end",r),t.add((0,T.toDisposable)(()=>w.removeListener("data",s))),w.on("data",s)})}e.peekStream=y;function u(w,R){const i=P(R);return i.end(w),i}e.toStream=u;function S(){const w=P(()=>{throw new Error("not supported")});return w.end(),w}e.emptyStream=S;function f(w){let R=!1;return{read:()=>R?null:(R=!0,w)}}e.toReadable=f;function c(w,R,i){const o=P(i);return m(w,{onData:t=>o.write(R.data(t)),onError:t=>o.error(R.error?R.error(t):t),onEnd:()=>o.end()}),o}e.transform=c;function d(w,R,i){let o=!1;return{read:()=>{const t=R.read();return o?t:(o=!0,t!==null?i([w,t]):w)}}}e.prefixedReadable=d;function p(w,R,i){let o=!1;const t=P(i);return m(R,{onData:n=>o?t.write(n):(o=!0,t.write(i([w,n]))),onError:n=>t.error(n),onEnd:()=>{o||(o=!0,t.write(w)),t.end()}}),t}e.prefixedStream=p}),define(oe[17],ae([0,1,44]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer<"u";let D,l;class O{static alloc(h){return T?new O(Buffer.allocUnsafe(h)):new O(new Uint8Array(h))}static wrap(h){return T&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new O(h)}static fromString(h,g){return!(g?.dontUseNodeBuffer||!1)&&T?new O(Buffer.from(h)):(D||(D=new TextEncoder),new O(D.encode(h)))}static fromByteArray(h){const g=O.alloc(h.length);for(let v=0,A=h.length;v<A;v++)g.buffer[v]=h[v];return g}static concat(h,g){if(typeof g>"u"){g=0;for(let N=0,F=h.length;N<F;N++)g+=h[N].byteLength}const v=O.alloc(g);let A=0;for(let N=0,F=h.length;N<F;N++){const M=h[N];v.set(M,A),A+=M.byteLength}return v}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=O.alloc(this.byteLength);return h.set(this),h}toString(){return T?this.buffer.toString():(l||(l=new TextDecoder),l.decode(this.buffer))}slice(h,g){return new O(this.buffer.subarray(h,g))}set(h,g){if(h instanceof O)this.buffer.set(h.buffer,g);else if(h instanceof Uint8Array)this.buffer.set(h,g);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),g);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),g);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return E(this.buffer,h)}writeUInt32BE(h,g){C(this.buffer,h,g)}readUInt32LE(h){return b(this.buffer,h)}writeUInt32LE(h,g){m(this.buffer,h,g)}readUInt8(h){return y(this.buffer,h)}writeUInt8(h,g){u(this.buffer,h,g)}}e.VSBuffer=O;function P(r,h){return r[h+0]<<0>>>0|r[h+1]<<8>>>0}e.readUInt16LE=P;function I(r,h,g){r[g+0]=h&255,h=h>>>8,r[g+1]=h&255}e.writeUInt16LE=I;function E(r,h){return r[h]*2**24+r[h+1]*2**16+r[h+2]*2**8+r[h+3]}e.readUInt32BE=E;function C(r,h,g){r[g+3]=h,h=h>>>8,r[g+2]=h,h=h>>>8,r[g+1]=h,h=h>>>8,r[g]=h}e.writeUInt32BE=C;function b(r,h){return r[h+0]<<0>>>0|r[h+1]<<8>>>0|r[h+2]<<16>>>0|r[h+3]<<24>>>0}e.readUInt32LE=b;function m(r,h,g){r[g+0]=h&255,h=h>>>8,r[g+1]=h&255,h=h>>>8,r[g+2]=h&255,h=h>>>8,r[g+3]=h&255}e.writeUInt32LE=m;function y(r,h){return r[h]}e.readUInt8=y;function u(r,h,g){r[g]=h}e.writeUInt8=u;function S(r){return k.consumeReadable(r,h=>O.concat(h))}e.readableToBuffer=S;function f(r){return k.toReadable(r)}e.bufferToReadable=f;function c(r){return k.consumeStream(r,h=>O.concat(h))}e.streamToBuffer=c;async function d(r){return r.ended?O.concat(r.buffer):O.concat([...r.buffer,await c(r.stream)])}e.bufferedStreamToBuffer=d;function p(r){return k.toStream(r,h=>O.concat(h))}e.bufferToStream=p;function w(r){return k.transform(r,{data:h=>typeof h=="string"?O.fromString(h):O.wrap(h)},h=>O.concat(h))}e.streamToBufferReadableStream=w;function R(r){return k.newWriteableStream(h=>O.concat(h),r)}e.newWriteableBufferStream=R;function i(r,h){return k.prefixedReadable(r,h,g=>O.concat(g))}e.prefixedBufferReadable=i;function o(r,h){return k.prefixedStream(r,h,g=>O.concat(g))}e.prefixedBufferStream=o;function t(r){let h=0,g=0,v=0;const A=new Uint8Array(Math.floor(r.length/4*3)),N=M=>{switch(g){case 3:A[v++]=h|M,g=0;break;case 2:A[v++]=h|M>>>2,h=M<<6,g=3;break;case 1:A[v++]=h|M>>>4,h=M<<4,g=2;break;default:h=M<<2,g=1}};for(let M=0;M<r.length;M++){const L=r.charCodeAt(M);if(L>=65&&L<=90)N(L-65);else if(L>=97&&L<=122)N(L-97+26);else if(L>=48&&L<=57)N(L-48+52);else if(L===43||L===45)N(62);else if(L===47||L===95)N(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${r[M]}`)}}const F=v;for(;g>0;)N(0);return O.wrap(A).slice(0,F)}e.decodeBase64=t;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:r},h=!0,g=!1){const v=g?s:n;let A="";const N=r.byteLength%3;let F=0;for(;F<r.byteLength-N;F+=3){const M=r[F+0],L=r[F+1],$=r[F+2];A+=v[M>>>2],A+=v[(M<<4|L>>>4)&63],A+=v[(L<<2|$>>>6)&63],A+=v[$&63]}if(N===1){const M=r[F+0];A+=v[M>>>2],A+=v[M<<4&63],h&&(A+="==")}else if(N===2){const M=r[F+0],L=r[F+1];A+=v[M>>>2],A+=v[(M<<4|L>>>4)&63],A+=v[L<<2&63],h&&(A+="=")}return A}e.encodeBase64=a}),define(oe[12],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function k(o){return typeof o=="string"}e.isString=k;function T(o){return Array.isArray(o)&&o.every(t=>k(t))}e.isStringArray=T;function D(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=D;function l(o){const t=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof t}e.isTypedArray=l;function O(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=O;function P(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=P;function I(o){return o===!0||o===!1}e.isBoolean=I;function E(o){return typeof o>"u"}e.isUndefined=E;function C(o){return!b(o)}e.isDefined=C;function b(o){return E(o)||o===null}e.isUndefinedOrNull=b;function m(o,t){if(!o)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=m;function y(o){if(b(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=y;function u(...o){const t=[];for(let n=0;n<o.length;n++){const s=o[n];if(b(s))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(s)}return t}e.assertAllDefined=u;const S=Object.prototype.hasOwnProperty;function f(o){if(!D(o))return!1;for(const t in o)if(S.call(o,t))return!1;return!0}e.isEmptyObject=f;function c(o){return typeof o=="function"}e.isFunction=c;function d(...o){return o.length>0&&o.every(c)}e.areFunctions=d;function p(o,t){const n=Math.min(o.length,t.length);for(let s=0;s<n;s++)w(o[s],t[s])}e.validateConstraints=p;function w(o,t){if(k(t)){if(typeof o!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(c(t)){try{if(o instanceof t)return}catch{}if(!b(o)&&o.constructor===t||t.length===1&&t.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=w;function R(o){return o===null?void 0:o}e.withNullAsUndefined=R;function i(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=i}),define(oe[52],ae([0,1,12]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=e.getCodiconAriaLabel=void 0;function T(I){return I?I.replace(/\$\((.*?)\)/g,(E,C)=>` ${C} `).trim():""}e.getCodiconAriaLabel=T;const D=Object.create(null);function l(I,E){if((0,k.isString)(E)){const C=D[E];if(C===void 0)throw new Error(`${I} references an unknown codicon: ${E}`);E=C}return D[I]=E,{id:I}}function O(){return D}e.getCodiconFontCharacters=O;function P(){return Object.values(e.Codicon)}e.getAllCodicons=P,e.Codicon={add:l("add",6e4),plus:l("plus",6e4),gistNew:l("gist-new",6e4),repoCreate:l("repo-create",6e4),lightbulb:l("lightbulb",60001),lightBulb:l("light-bulb",60001),repo:l("repo",60002),repoDelete:l("repo-delete",60002),gistFork:l("gist-fork",60003),repoForked:l("repo-forked",60003),gitPullRequest:l("git-pull-request",60004),gitPullRequestAbandoned:l("git-pull-request-abandoned",60004),recordKeys:l("record-keys",60005),keyboard:l("keyboard",60005),tag:l("tag",60006),tagAdd:l("tag-add",60006),tagRemove:l("tag-remove",60006),person:l("person",60007),personFollow:l("person-follow",60007),personOutline:l("person-outline",60007),personFilled:l("person-filled",60007),gitBranch:l("git-branch",60008),gitBranchCreate:l("git-branch-create",60008),gitBranchDelete:l("git-branch-delete",60008),sourceControl:l("source-control",60008),mirror:l("mirror",60009),mirrorPublic:l("mirror-public",60009),star:l("star",60010),starAdd:l("star-add",60010),starDelete:l("star-delete",60010),starEmpty:l("star-empty",60010),comment:l("comment",60011),commentAdd:l("comment-add",60011),alert:l("alert",60012),warning:l("warning",60012),search:l("search",60013),searchSave:l("search-save",60013),logOut:l("log-out",60014),signOut:l("sign-out",60014),logIn:l("log-in",60015),signIn:l("sign-in",60015),eye:l("eye",60016),eyeUnwatch:l("eye-unwatch",60016),eyeWatch:l("eye-watch",60016),circleFilled:l("circle-filled",60017),primitiveDot:l("primitive-dot",60017),closeDirty:l("close-dirty",60017),debugBreakpoint:l("debug-breakpoint",60017),debugBreakpointDisabled:l("debug-breakpoint-disabled",60017),debugHint:l("debug-hint",60017),primitiveSquare:l("primitive-square",60018),edit:l("edit",60019),pencil:l("pencil",60019),info:l("info",60020),issueOpened:l("issue-opened",60020),gistPrivate:l("gist-private",60021),gitForkPrivate:l("git-fork-private",60021),lock:l("lock",60021),mirrorPrivate:l("mirror-private",60021),close:l("close",60022),removeClose:l("remove-close",60022),x:l("x",60022),repoSync:l("repo-sync",60023),sync:l("sync",60023),clone:l("clone",60024),desktopDownload:l("desktop-download",60024),beaker:l("beaker",60025),microscope:l("microscope",60025),vm:l("vm",60026),deviceDesktop:l("device-desktop",60026),file:l("file",60027),fileText:l("file-text",60027),more:l("more",60028),ellipsis:l("ellipsis",60028),kebabHorizontal:l("kebab-horizontal",60028),mailReply:l("mail-reply",60029),reply:l("reply",60029),organization:l("organization",60030),organizationFilled:l("organization-filled",60030),organizationOutline:l("organization-outline",60030),newFile:l("new-file",60031),fileAdd:l("file-add",60031),newFolder:l("new-folder",60032),fileDirectoryCreate:l("file-directory-create",60032),trash:l("trash",60033),trashcan:l("trashcan",60033),history:l("history",60034),clock:l("clock",60034),folder:l("folder",60035),fileDirectory:l("file-directory",60035),symbolFolder:l("symbol-folder",60035),logoGithub:l("logo-github",60036),markGithub:l("mark-github",60036),github:l("github",60036),terminal:l("terminal",60037),console:l("console",60037),repl:l("repl",60037),zap:l("zap",60038),symbolEvent:l("symbol-event",60038),error:l("error",60039),stop:l("stop",60039),variable:l("variable",60040),symbolVariable:l("symbol-variable",60040),array:l("array",60042),symbolArray:l("symbol-array",60042),symbolModule:l("symbol-module",60043),symbolPackage:l("symbol-package",60043),symbolNamespace:l("symbol-namespace",60043),symbolObject:l("symbol-object",60043),symbolMethod:l("symbol-method",60044),symbolFunction:l("symbol-function",60044),symbolConstructor:l("symbol-constructor",60044),symbolBoolean:l("symbol-boolean",60047),symbolNull:l("symbol-null",60047),symbolNumeric:l("symbol-numeric",60048),symbolNumber:l("symbol-number",60048),symbolStructure:l("symbol-structure",60049),symbolStruct:l("symbol-struct",60049),symbolParameter:l("symbol-parameter",60050),symbolTypeParameter:l("symbol-type-parameter",60050),symbolKey:l("symbol-key",60051),symbolText:l("symbol-text",60051),symbolReference:l("symbol-reference",60052),goToFile:l("go-to-file",60052),symbolEnum:l("symbol-enum",60053),symbolValue:l("symbol-value",60053),symbolRuler:l("symbol-ruler",60054),symbolUnit:l("symbol-unit",60054),activateBreakpoints:l("activate-breakpoints",60055),archive:l("archive",60056),arrowBoth:l("arrow-both",60057),arrowDown:l("arrow-down",60058),arrowLeft:l("arrow-left",60059),arrowRight:l("arrow-right",60060),arrowSmallDown:l("arrow-small-down",60061),arrowSmallLeft:l("arrow-small-left",60062),arrowSmallRight:l("arrow-small-right",60063),arrowSmallUp:l("arrow-small-up",60064),arrowUp:l("arrow-up",60065),bell:l("bell",60066),bold:l("bold",60067),book:l("book",60068),bookmark:l("bookmark",60069),debugBreakpointConditionalUnverified:l("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:l("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:l("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:l("debug-breakpoint-data-unverified",60072),debugBreakpointData:l("debug-breakpoint-data",60073),debugBreakpointDataDisabled:l("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:l("debug-breakpoint-log-unverified",60074),debugBreakpointLog:l("debug-breakpoint-log",60075),debugBreakpointLogDisabled:l("debug-breakpoint-log-disabled",60075),briefcase:l("briefcase",60076),broadcast:l("broadcast",60077),browser:l("browser",60078),bug:l("bug",60079),calendar:l("calendar",60080),caseSensitive:l("case-sensitive",60081),check:l("check",60082),checklist:l("checklist",60083),chevronDown:l("chevron-down",60084),dropDownButton:l("drop-down-button",60084),chevronLeft:l("chevron-left",60085),chevronRight:l("chevron-right",60086),chevronUp:l("chevron-up",60087),chromeClose:l("chrome-close",60088),chromeMaximize:l("chrome-maximize",60089),chromeMinimize:l("chrome-minimize",60090),chromeRestore:l("chrome-restore",60091),circle:l("circle",60092),circleOutline:l("circle-outline",60092),debugBreakpointUnverified:l("debug-breakpoint-unverified",60092),circleSlash:l("circle-slash",60093),circuitBoard:l("circuit-board",60094),clearAll:l("clear-all",60095),clippy:l("clippy",60096),closeAll:l("close-all",60097),cloudDownload:l("cloud-download",60098),cloudUpload:l("cloud-upload",60099),code:l("code",60100),collapseAll:l("collapse-all",60101),colorMode:l("color-mode",60102),commentDiscussion:l("comment-discussion",60103),compareChanges:l("compare-changes",60157),creditCard:l("credit-card",60105),dash:l("dash",60108),dashboard:l("dashboard",60109),database:l("database",60110),debugContinue:l("debug-continue",60111),debugDisconnect:l("debug-disconnect",60112),debugPause:l("debug-pause",60113),debugRestart:l("debug-restart",60114),debugStart:l("debug-start",60115),debugStepInto:l("debug-step-into",60116),debugStepOut:l("debug-step-out",60117),debugStepOver:l("debug-step-over",60118),debugStop:l("debug-stop",60119),debug:l("debug",60120),deviceCameraVideo:l("device-camera-video",60121),deviceCamera:l("device-camera",60122),deviceMobile:l("device-mobile",60123),diffAdded:l("diff-added",60124),diffIgnored:l("diff-ignored",60125),diffModified:l("diff-modified",60126),diffRemoved:l("diff-removed",60127),diffRenamed:l("diff-renamed",60128),diff:l("diff",60129),discard:l("discard",60130),editorLayout:l("editor-layout",60131),emptyWindow:l("empty-window",60132),exclude:l("exclude",60133),extensions:l("extensions",60134),eyeClosed:l("eye-closed",60135),fileBinary:l("file-binary",60136),fileCode:l("file-code",60137),fileMedia:l("file-media",60138),filePdf:l("file-pdf",60139),fileSubmodule:l("file-submodule",60140),fileSymlinkDirectory:l("file-symlink-directory",60141),fileSymlinkFile:l("file-symlink-file",60142),fileZip:l("file-zip",60143),files:l("files",60144),filter:l("filter",60145),flame:l("flame",60146),foldDown:l("fold-down",60147),foldUp:l("fold-up",60148),fold:l("fold",60149),folderActive:l("folder-active",60150),folderOpened:l("folder-opened",60151),gear:l("gear",60152),gift:l("gift",60153),gistSecret:l("gist-secret",60154),gist:l("gist",60155),gitCommit:l("git-commit",60156),gitCompare:l("git-compare",60157),gitMerge:l("git-merge",60158),githubAction:l("github-action",60159),githubAlt:l("github-alt",60160),globe:l("globe",60161),grabber:l("grabber",60162),graph:l("graph",60163),gripper:l("gripper",60164),heart:l("heart",60165),home:l("home",60166),horizontalRule:l("horizontal-rule",60167),hubot:l("hubot",60168),inbox:l("inbox",60169),issueClosed:l("issue-closed",60324),issueReopened:l("issue-reopened",60171),issues:l("issues",60172),italic:l("italic",60173),jersey:l("jersey",60174),json:l("json",60175),kebabVertical:l("kebab-vertical",60176),key:l("key",60177),law:l("law",60178),lightbulbAutofix:l("lightbulb-autofix",60179),linkExternal:l("link-external",60180),link:l("link",60181),listOrdered:l("list-ordered",60182),listUnordered:l("list-unordered",60183),liveShare:l("live-share",60184),loading:l("loading",60185),location:l("location",60186),mailRead:l("mail-read",60187),mail:l("mail",60188),markdown:l("markdown",60189),megaphone:l("megaphone",60190),mention:l("mention",60191),milestone:l("milestone",60192),mortarBoard:l("mortar-board",60193),move:l("move",60194),multipleWindows:l("multiple-windows",60195),mute:l("mute",60196),noNewline:l("no-newline",60197),note:l("note",60198),octoface:l("octoface",60199),openPreview:l("open-preview",60200),package_:l("package",60201),paintcan:l("paintcan",60202),pin:l("pin",60203),play:l("play",60204),run:l("run",60204),plug:l("plug",60205),preserveCase:l("preserve-case",60206),preview:l("preview",60207),project:l("project",60208),pulse:l("pulse",60209),question:l("question",60210),quote:l("quote",60211),radioTower:l("radio-tower",60212),reactions:l("reactions",60213),references:l("references",60214),refresh:l("refresh",60215),regex:l("regex",60216),remoteExplorer:l("remote-explorer",60217),remote:l("remote",60218),remove:l("remove",60219),replaceAll:l("replace-all",60220),replace:l("replace",60221),repoClone:l("repo-clone",60222),repoForcePush:l("repo-force-push",60223),repoPull:l("repo-pull",60224),repoPush:l("repo-push",60225),report:l("report",60226),requestChanges:l("request-changes",60227),rocket:l("rocket",60228),rootFolderOpened:l("root-folder-opened",60229),rootFolder:l("root-folder",60230),rss:l("rss",60231),ruby:l("ruby",60232),saveAll:l("save-all",60233),saveAs:l("save-as",60234),save:l("save",60235),screenFull:l("screen-full",60236),screenNormal:l("screen-normal",60237),searchStop:l("search-stop",60238),server:l("server",60240),settingsGear:l("settings-gear",60241),settings:l("settings",60242),shield:l("shield",60243),smiley:l("smiley",60244),sortPrecedence:l("sort-precedence",60245),splitHorizontal:l("split-horizontal",60246),splitVertical:l("split-vertical",60247),squirrel:l("squirrel",60248),starFull:l("star-full",60249),starHalf:l("star-half",60250),symbolClass:l("symbol-class",60251),symbolColor:l("symbol-color",60252),symbolCustomColor:l("symbol-customcolor",60252),symbolConstant:l("symbol-constant",60253),symbolEnumMember:l("symbol-enum-member",60254),symbolField:l("symbol-field",60255),symbolFile:l("symbol-file",60256),symbolInterface:l("symbol-interface",60257),symbolKeyword:l("symbol-keyword",60258),symbolMisc:l("symbol-misc",60259),symbolOperator:l("symbol-operator",60260),symbolProperty:l("symbol-property",60261),wrench:l("wrench",60261),wrenchSubaction:l("wrench-subaction",60261),symbolSnippet:l("symbol-snippet",60262),tasklist:l("tasklist",60263),telescope:l("telescope",60264),textSize:l("text-size",60265),threeBars:l("three-bars",60266),thumbsdown:l("thumbsdown",60267),thumbsup:l("thumbsup",60268),tools:l("tools",60269),triangleDown:l("triangle-down",60270),triangleLeft:l("triangle-left",60271),triangleRight:l("triangle-right",60272),triangleUp:l("triangle-up",60273),twitter:l("twitter",60274),unfold:l("unfold",60275),unlock:l("unlock",60276),unmute:l("unmute",60277),unverified:l("unverified",60278),verified:l("verified",60279),versions:l("versions",60280),vmActive:l("vm-active",60281),vmOutline:l("vm-outline",60282),vmRunning:l("vm-running",60283),watch:l("watch",60284),whitespace:l("whitespace",60285),wholeWord:l("whole-word",60286),window:l("window",60287),wordWrap:l("word-wrap",60288),zoomIn:l("zoom-in",60289),zoomOut:l("zoom-out",60290),listFilter:l("list-filter",60291),listFlat:l("list-flat",60292),listSelection:l("list-selection",60293),selection:l("selection",60293),listTree:l("list-tree",60294),debugBreakpointFunctionUnverified:l("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:l("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:l("debug-breakpoint-function-disabled",60296),debugStackframeActive:l("debug-stackframe-active",60297),circleSmallFilled:l("circle-small-filled",60298),debugStackframeDot:l("debug-stackframe-dot",60298),debugStackframe:l("debug-stackframe",60299),debugStackframeFocused:l("debug-stackframe-focused",60299),debugBreakpointUnsupported:l("debug-breakpoint-unsupported",60300),symbolString:l("symbol-string",60301),debugReverseContinue:l("debug-reverse-continue",60302),debugStepBack:l("debug-step-back",60303),debugRestartFrame:l("debug-restart-frame",60304),callIncoming:l("call-incoming",60306),callOutgoing:l("call-outgoing",60307),menu:l("menu",60308),expandAll:l("expand-all",60309),feedback:l("feedback",60310),groupByRefType:l("group-by-ref-type",60311),ungroupByRefType:l("ungroup-by-ref-type",60312),account:l("account",60313),bellDot:l("bell-dot",60314),debugConsole:l("debug-console",60315),library:l("library",60316),output:l("output",60317),runAll:l("run-all",60318),syncIgnored:l("sync-ignored",60319),pinned:l("pinned",60320),githubInverted:l("github-inverted",60321),debugAlt:l("debug-alt",60305),serverProcess:l("server-process",60322),serverEnvironment:l("server-environment",60323),pass:l("pass",60324),stopCircle:l("stop-circle",60325),playCircle:l("play-circle",60326),record:l("record",60327),debugAltSmall:l("debug-alt-small",60328),vmConnect:l("vm-connect",60329),cloud:l("cloud",60330),merge:l("merge",60331),exportIcon:l("export",60332),graphLeft:l("graph-left",60333),magnet:l("magnet",60334),notebook:l("notebook",60335),redo:l("redo",60336),checkAll:l("check-all",60337),pinnedDirty:l("pinned-dirty",60338),passFilled:l("pass-filled",60339),circleLargeFilled:l("circle-large-filled",60340),circleLarge:l("circle-large",60341),circleLargeOutline:l("circle-large-outline",60341),combine:l("combine",60342),gather:l("gather",60342),table:l("table",60343),variableGroup:l("variable-group",60344),typeHierarchy:l("type-hierarchy",60345),typeHierarchySub:l("type-hierarchy-sub",60346),typeHierarchySuper:l("type-hierarchy-super",60347),gitPullRequestCreate:l("git-pull-request-create",60348),runAbove:l("run-above",60349),runBelow:l("run-below",60350),notebookTemplate:l("notebook-template",60351),debugRerun:l("debug-rerun",60352),workspaceTrusted:l("workspace-trusted",60353),workspaceUntrusted:l("workspace-untrusted",60354),workspaceUnspecified:l("workspace-unspecified",60355),terminalCmd:l("terminal-cmd",60356),terminalDebian:l("terminal-debian",60357),terminalLinux:l("terminal-linux",60358),terminalPowershell:l("terminal-powershell",60359),terminalTmux:l("terminal-tmux",60360),terminalUbuntu:l("terminal-ubuntu",60361),terminalBash:l("terminal-bash",60362),arrowSwap:l("arrow-swap",60363),copy:l("copy",60364),personAdd:l("person-add",60365),filterFilled:l("filter-filled",60366),wand:l("wand",60367),debugLineByLine:l("debug-line-by-line",60368),inspect:l("inspect",60369),layers:l("layers",60370),layersDot:l("layers-dot",60371),layersActive:l("layers-active",60372),compass:l("compass",60373),compassDot:l("compass-dot",60374),compassActive:l("compass-active",60375),azure:l("azure",60376),issueDraft:l("issue-draft",60377),gitPullRequestClosed:l("git-pull-request-closed",60378),gitPullRequestDraft:l("git-pull-request-draft",60379),debugAll:l("debug-all",60380),debugCoverage:l("debug-coverage",60381),runErrors:l("run-errors",60382),folderLibrary:l("folder-library",60383),debugContinueSmall:l("debug-continue-small",60384),beakerStop:l("beaker-stop",60385),graphLine:l("graph-line",60386),graphScatter:l("graph-scatter",60387),pieChart:l("pie-chart",60388),bracket:l("bracket",60388),bracketDot:l("bracket-dot",60389),bracketError:l("bracket-error",60390),lockSmall:l("lock-small",60391),azureDevops:l("azure-devops",60392),verifiedFilled:l("verified-filled",60393),newLine:l("newline",60394),layout:l("layout",60395),layoutActivitybarLeft:l("layout-activitybar-left",60396),layoutActivitybarRight:l("layout-activitybar-right",60397),layoutPanelLeft:l("layout-panel-left",60398),layoutPanelCenter:l("layout-panel-center",60399),layoutPanelJustify:l("layout-panel-justify",60400),layoutPanelRight:l("layout-panel-right",60401),layoutPanel:l("layout-panel",60402),layoutSidebarLeft:l("layout-sidebar-left",60403),layoutSidebarRight:l("layout-sidebar-right",60404),layoutStatusbar:l("layout-statusbar",60405),layoutMenubar:l("layout-menubar",60406),layoutCentered:l("layout-centered",60407),layoutSidebarRightOff:l("layout-sidebar-right-off",60416),layoutPanelOff:l("layout-panel-off",60417),layoutSidebarLeftOff:l("layout-sidebar-left-off",60418),target:l("target",60408),indent:l("indent",60409),recordSmall:l("record-small",60410),errorSmall:l("error-small",60411),arrowCircleDown:l("arrow-circle-down",60412),arrowCircleLeft:l("arrow-circle-left",60413),arrowCircleRight:l("arrow-circle-right",60414),arrowCircleUp:l("arrow-circle-up",60415),heartFilled:l("heart-filled",60420),map:l("map",60421),mapFilled:l("map-filled",60422),circleSmall:l("circle-small",60423),bellSlash:l("bell-slash",60424),bellSlashDot:l("bell-slash-dot",60425),commentUnresolved:l("comment-unresolved",60426),gitPullRequestGoToChanges:l("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:l("git-pull-request-new-changes",60428),searchFuzzy:l("search-fuzzy",60429),commentDraft:l("comment-draft",60430),dialogError:l("dialog-error","error"),dialogWarning:l("dialog-warning","warning"),dialogInfo:l("dialog-info","info"),dialogClose:l("dialog-close","close"),treeItemExpanded:l("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:l("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:l("tree-filter-on-type-off","list-selection"),treeFilterClear:l("tree-filter-clear","close"),treeItemLoading:l("tree-item-loading","loading"),menuSelection:l("menu-selection","check"),menuSubmenu:l("menu-submenu","chevron-right"),menuBarMore:l("menubar-more","more"),scrollbarButtonLeft:l("scrollbar-button-left","triangle-left"),scrollbarButtonRight:l("scrollbar-button-right","triangle-right"),scrollbarButtonUp:l("scrollbar-button-up","triangle-up"),scrollbarButtonDown:l("scrollbar-button-down","triangle-down"),toolBarMore:l("toolbar-more","more"),quickInputBack:l("quick-input-back","arrow-left")}}),define(oe[32],ae([0,1,12]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function T(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const d=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([p,w])=>{d[p]=w&&typeof w=="object"?T(w):w}),d}e.deepClone=T;function D(c){if(!c||typeof c!="object")return c;const d=[c];for(;d.length>0;){const p=d.shift();Object.freeze(p);for(const w in p)if(l.call(p,w)){const R=p[w];typeof R=="object"&&!Object.isFrozen(R)&&!(0,k.isTypedArray)(R)&&d.push(R)}}return c}e.deepFreeze=D;const l=Object.prototype.hasOwnProperty;function O(c,d){return P(c,d,new Set)}e.cloneAndChange=O;function P(c,d,p){if((0,k.isUndefinedOrNull)(c))return c;const w=d(c);if(typeof w<"u")return w;if(Array.isArray(c)){const R=[];for(const i of c)R.push(P(i,d,p));return R}if((0,k.isObject)(c)){if(p.has(c))throw new Error("Cannot clone recursive data-structure");p.add(c);const R={};for(const i in c)l.call(c,i)&&(R[i]=P(c[i],d,p));return p.delete(c),R}return c}function I(c,d,p=!0){return(0,k.isObject)(c)?((0,k.isObject)(d)&&Object.keys(d).forEach(w=>{w in c?p&&((0,k.isObject)(c[w])&&(0,k.isObject)(d[w])?I(c[w],d[w],p):c[w]=d[w]):c[w]=d[w]}),c):d}e.mixin=I;function E(c,d){if(c===d)return!0;if(c==null||d===null||d===void 0||typeof c!=typeof d||typeof c!="object"||Array.isArray(c)!==Array.isArray(d))return!1;let p,w;if(Array.isArray(c)){if(c.length!==d.length)return!1;for(p=0;p<c.length;p++)if(!E(c[p],d[p]))return!1}else{const R=[];for(w in c)R.push(w);R.sort();const i=[];for(w in d)i.push(w);if(i.sort(),!E(R,i))return!1;for(p=0;p<R.length;p++)if(!E(c[R[p]],d[R[p]]))return!1}return!0}e.equals=E;function C(c){const d=new Set;return JSON.stringify(c,(p,w)=>{if((0,k.isObject)(w)||Array.isArray(w)){if(d.has(w))return"[Circular]";d.add(w)}return w})}e.safeStringify=C;function b(c,d){const p=Object.create(null);return!c||!d||Object.keys(d).forEach(R=>{const i=c[R],o=d[R];E(i,o)||(p[R]=o)}),p}e.distinct=b;function m(c,d){const p=d.toLowerCase(),w=Object.keys(c).find(R=>R.toLowerCase()===p);return w?c[w]:c[d]}e.getCaseInsensitive=m;function y(c,d){const p=Object.create(null);for(const[w,R]of Object.entries(c))d(w,R)&&(p[w]=R);return p}e.filter=y;function u(c){let d=[],p=Object.getPrototypeOf(c);for(;Object.prototype!==p;)d=d.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return d}e.getAllPropertyNames=u;function S(c){const d=[];for(const p of u(c))typeof c[p]=="function"&&d.push(p);return d}e.getAllMethodNames=S;function f(c,d){const p=R=>function(){const i=Array.prototype.slice.call(arguments,0);return d(R,i)},w={};for(const R of c)w[R]=p(R);return w}e.createProxyObject=f}),define(oe[132],ae([0,1,52]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var T;(function(O){function P(I){return I&&typeof I=="object"&&typeof I.id=="string"}O.isThemeColor=P})(T=e.ThemeColor||(e.ThemeColor={}));function D(O){return{id:O}}e.themeColorFromId=D;var l;(function(O){O.iconNameSegment="[A-Za-z0-9]+",O.iconNameExpression="[A-Za-z0-9-]+",O.iconModifierExpression="~[A-Za-z]+",O.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${O.iconNameExpression})(${O.iconModifierExpression})?$`);function I(d){const p=P.exec(d.id);if(!p)return I(k.Codicon.error);const[,w,R]=p,i=["codicon","codicon-"+w];return R&&i.push("codicon-modifier-"+R.substring(1)),i}O.asClassNameArray=I;function E(d){return I(d).join(" ")}O.asClassName=E;function C(d){return"."+I(d).join(".")}O.asCSSSelector=C;function b(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||T.isThemeColor(d.color))}O.isThemeIcon=b;const m=new RegExp(`^\\$\\((${O.iconNameExpression}(?:${O.iconModifierExpression})?)\\)$`);function y(d){const p=m.exec(d);if(!p)return;const[,w]=p;return{id:w}}O.fromString=y;function u(d){return{id:d}}O.fromId=u;function S(d,p){let w=d.id;const R=w.lastIndexOf("~");return R!==-1&&(w=w.substring(0,R)),p&&(w=`${w}~${p}`),{id:w}}O.modify=S;function f(d){const p=d.id.lastIndexOf("~");if(p!==-1)return d.id.substring(p+1)}O.getModifier=f;function c(d,p){return d.id===p.id&&d.color?.id===p.color?.id}O.isEqual=c})(l=e.ThemeIcon||(e.ThemeIcon={}))}),define(oe[31],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(D){return k.test(D)}e.isUUID=T,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(P){for(let I=0;I<P.length;I++)P[I]=Math.floor(Math.random()*256);return P};const l=new Uint8Array(16),O=[];for(let P=0;P<256;P++)O.push(P.toString(16).padStart(2,"0"));return function(){D(l),l[6]=l[6]&15|64,l[8]=l[8]&63|128;let I=0,E="";return E+=O[l[I++]],E+=O[l[I++]],E+=O[l[I++]],E+=O[l[I++]],E+="-",E+=O[l[I++]],E+=O[l[I++]],E+="-",E+=O[l[I++]],E+=O[l[I++]],E+="-",E+=O[l[I++]],E+=O[l[I++]],E+="-",E+=O[l[I++]],E+=O[l[I++]],E+=O[l[I++]],E+=O[l[I++]],E+=O[l[I++]],E+=O[l[I++]],E}}()}),define(oe[133],ae([0,1,34]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const T=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(O){const P=O.replace(/\-/g,":").toLowerCase();return!T.has(P)}function l(){const O=(0,k.networkInterfaces)();for(const P in O){const I=O[P];if(I){for(const{mac:E}of I)if(D(E))return E}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=l}),define(oe[134],ae([0,1,86]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function T(P,I,E,C=1){let b=!1;return new Promise(m=>{const y=setTimeout(()=>{if(!b)return b=!0,m(0)},E);D(P,I,C,u=>{if(!b)return b=!0,clearTimeout(y),m(u)})})}e.findFreePort=T;function D(P,I,E,C){if(I===0)return C(0);const b=new k.Socket;b.once("connect",()=>(O(b),D(P+E,I-1,E,C))),b.once("data",()=>{}),b.once("error",m=>(O(b),m.code!=="ECONNREFUSED"?D(P+E,I-1,E,C):C(P))),b.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function l(P,I,E,C="127.0.0.1"){let b=!1,m,y=1;const u=k.createServer({pauseOnConnect:!0});function S(f,c){b||(b=!0,u.removeAllListeners(),u.close(),m&&clearTimeout(m),c(f))}return new Promise(f=>{m=setTimeout(()=>{S(0,f)},E),u.on("listening",()=>{S(P,f)}),u.on("error",c=>{c&&(c.code==="EADDRINUSE"||c.code==="EACCES")&&y<I?(P++,y++,u.listen(P,C)):S(0,f)}),u.on("close",()=>{S(0,f)}),u.listen(P,C)})}e.findFreePortFaster=l;function O(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(I){console.error(I)}}}),define(oe[135],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const k="Offline";function T(l){return l instanceof D?!0:l instanceof Error&&l.name===k&&l.message===k}e.isOfflineError=T;class D extends Error{constructor(){super(k),this.name=this.message}}e.OfflineError=D}),define(oe[136],ae([0,1,17,9,135]),function(Q,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function l(I,E){if(!navigator.onLine)throw new D.OfflineError;I.proxyAuthorization&&(I.headers={...I.headers||{},"Proxy-Authorization":I.proxyAuthorization});const C=new XMLHttpRequest;return new Promise((b,m)=>{C.open(I.type||"GET",I.url||"",!0,I.user,I.password),O(C,I),C.responseType="arraybuffer",C.onerror=y=>m(new Error(C.statusText&&"XHR failed: "+C.statusText||"XHR failed")),C.onload=y=>{b({res:{statusCode:C.status,headers:P(C)},stream:(0,k.bufferToStream)(k.VSBuffer.wrap(new Uint8Array(C.response)))})},C.ontimeout=y=>m(new Error(`XHR timeout: ${I.timeout}ms`)),I.timeout&&(C.timeout=I.timeout),C.send(I.data),E.onCancellationRequested(()=>{C.abort(),m((0,T.canceled)())})})}e.request=l;function O(I,E){if(E.headers){e:for(const C in E.headers){switch(C){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}I.setRequestHeader(C,E.headers[C])}}}function P(I){const E=Object.create(null);for(const C of I.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(C){const b=C.indexOf(":");E[C.substr(0,b).trim().toLowerCase()]=C.substr(b+1).trim()}return E}}),define(oe[137],ae([10,7]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(oe[65],ae([0,1,137]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,D=T*60,l=D*24,O=l*7,P=l*30,I=l*365;function E(b,m,y,u){typeof b!="number"&&(b=b.getTime());const S=Math.round((new Date().getTime()-b)/1e3);if(S<-30)return(0,k.localize)(0,null,E(new Date().getTime()+S*1e3,!1));if(!u&&S<30)return(0,k.localize)(1,null);let f;return S<T?(f=S,m?f===1?y?(0,k.localize)(2,null,f):(0,k.localize)(3,null,f):y?(0,k.localize)(4,null,f):(0,k.localize)(5,null,f):f===1?y?(0,k.localize)(6,null,f):(0,k.localize)(7,null,f):y?(0,k.localize)(8,null,f):(0,k.localize)(9,null,f)):S<D?(f=Math.floor(S/T),m?f===1?y?(0,k.localize)(10,null,f):(0,k.localize)(11,null,f):y?(0,k.localize)(12,null,f):(0,k.localize)(13,null,f):f===1?y?(0,k.localize)(14,null,f):(0,k.localize)(15,null,f):y?(0,k.localize)(16,null,f):(0,k.localize)(17,null,f)):S<l?(f=Math.floor(S/D),m?f===1?y?(0,k.localize)(18,null,f):(0,k.localize)(19,null,f):y?(0,k.localize)(20,null,f):(0,k.localize)(21,null,f):f===1?y?(0,k.localize)(22,null,f):(0,k.localize)(23,null,f):y?(0,k.localize)(24,null,f):(0,k.localize)(25,null,f)):S<O?(f=Math.floor(S/l),m?f===1?(0,k.localize)(26,null,f):(0,k.localize)(27,null,f):f===1?(0,k.localize)(28,null,f):(0,k.localize)(29,null,f)):S<P?(f=Math.floor(S/O),m?f===1?y?(0,k.localize)(30,null,f):(0,k.localize)(31,null,f):y?(0,k.localize)(32,null,f):(0,k.localize)(33,null,f):f===1?y?(0,k.localize)(34,null,f):(0,k.localize)(35,null,f):y?(0,k.localize)(36,null,f):(0,k.localize)(37,null,f)):S<I?(f=Math.floor(S/P),m?f===1?y?(0,k.localize)(38,null,f):(0,k.localize)(39,null,f):y?(0,k.localize)(40,null,f):(0,k.localize)(41,null,f):f===1?y?(0,k.localize)(42,null,f):(0,k.localize)(43,null,f):y?(0,k.localize)(44,null,f):(0,k.localize)(45,null,f)):(f=Math.floor(S/I),m?f===1?y?(0,k.localize)(46,null,f):(0,k.localize)(47,null,f):y?(0,k.localize)(48,null,f):(0,k.localize)(49,null,f):f===1?y?(0,k.localize)(50,null,f):(0,k.localize)(51,null,f):y?(0,k.localize)(52,null,f):(0,k.localize)(53,null,f))}e.fromNow=E;function C(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=C}),define(oe[138],ae([10,7]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,21,12,138]),function(Q,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function l(b,m){return m&&(b.stack||b.stacktrace)?D.localize(0,null,P(b),O(b.stack)||O(b.stacktrace)):P(b)}function O(b){return Array.isArray(b)?b.join(`
`):b}function P(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?D.localize(1,null,b.message):b.message||D.localize(2,null)}function I(b=null,m=!1){if(!b)return D.localize(3,null);if(Array.isArray(b)){const y=k.coalesce(b),u=I(y[0],m);return y.length>1?D.localize(4,null,u,y.length):u}if(T.isString(b))return b;if(b.detail){const y=b.detail;if(y.error)return l(y.error,m);if(y.exception)return l(y.exception,m)}return b.stack?l(b,m):b.message?b.message:D.localize(5,null)}e.toErrorMessage=I;function E(b){const m=b;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=E;function C(b,m){let y;return typeof b=="string"?y=new Error(b):y=b,y.actions=m,y}e.createErrorWithActions=C}),define(oe[139],ae([10,7]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(oe[140],ae([0,1,139]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function T(D){switch(D){case 1:return(0,k.localize)(0,null);case 2:return(0,k.localize)(1,null);case 3:return(0,k.localize)(2,null);case 4:return(0,k.localize)(3,null);case 5:return(0,k.localize)(4,null);case 6:return(0,k.localize)(5,null);case 7:return(0,k.localize)(6,null);case 8:return(0,k.localize)(7,null);case 9:return(0,k.localize)(8,null);default:return""}}e.getParseErrorMessage=T}),define(oe[141],ae([10,7]),function(Q,e){return Q.create("vs/base/common/platform",e)}),define(oe[4],ae([0,1,141]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let T=!1,D=!1,l=!1,O=!1,P=!1,I=!1,E=!1,C=!1,b=!1,m=!1,y,u=e.LANGUAGE_DEFAULT,S,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?c=e.globals.vscode.process:typeof process<"u"&&(c=process);const d=typeof c?.versions?.electron=="string",p=d&&c?.type==="renderer";if(typeof navigator=="object"&&!p)f=navigator.userAgent,T=f.indexOf("Windows")>=0,D=f.indexOf("Macintosh")>=0,C=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,l=f.indexOf("Linux")>=0,m=f?.indexOf("Mobi")>=0,I=!0,y=k.getConfiguredDefaultLocale(k.localize(0,null))||e.LANGUAGE_DEFAULT,u=y;else if(typeof c=="object"){T=c.platform==="win32",D=c.platform==="darwin",l=c.platform==="linux",O=l&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,E=d,b=!!c.env.CI||!!c.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.LANGUAGE_DEFAULT,u=e.LANGUAGE_DEFAULT;const r=c.env.VSCODE_NLS_CONFIG;if(r)try{const h=JSON.parse(r),g=h.availableLanguages["*"];y=h.locale,u=g||e.LANGUAGE_DEFAULT,S=h._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var w;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function R(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=R;let i=0;D?i=1:T?i=3:l&&(i=2),e.isWindows=T,e.isMacintosh=D,e.isLinux=l,e.isLinuxSnap=O,e.isNative=P,e.isElectron=E,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=C,e.isMobile=m,e.isCI=b,e.platform=i,e.userAgent=f,e.language=u;var o;(function(r){function h(){return e.language}r.value=h;function g(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=g;function v(){return e.language==="en"}r.isDefault=v})(o=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=S,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const r=[];e.globals.addEventListener("message",g=>{if(g.data&&g.data.vscodeScheduleAsyncWork)for(let v=0,A=r.length;v<A;v++){const N=r[v];if(N.id===g.data.vscodeScheduleAsyncWork){r.splice(v,1),N.callback();return}}});let h=0;return g=>{const v=++h;r.push({id:v,callback:g}),e.globals.postMessage({vscodeScheduleAsyncWork:v},"*")}}return r=>setTimeout(r)})();var t;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||C?2:T?1:3;let n=!0,s=!1;function a(){if(!s){s=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,n=new Uint16Array(r.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(oe[36],ae([0,1,4]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let T;if(typeof k.globals.vscode<"u"&&typeof k.globals.vscode.process<"u"){const D=k.globals.vscode.process;T={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.platform=T.platform,e.arch=T.arch}),define(oe[13],ae([0,1,36]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const T=65,D=97,l=90,O=122,P=46,I=47,E=92,C=58,b=63;class m extends Error{constructor(o,t,n){let s;typeof t=="string"&&t.indexOf("not ")===0?(s="must not be",t=t.replace(/^not /,"")):s="must be";const a=o.indexOf(".")!==-1?"property":"argument";let r=`The "${o}" ${a} ${s} of type ${t}`;r+=`. Received type ${typeof n}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function y(i,o){if(i===null||typeof i!="object")throw new m(o,"Object",i)}function u(i,o){if(typeof i!="string")throw new m(o,"string",i)}const S=k.platform==="win32";function f(i){return i===I||i===E}function c(i){return i===I}function d(i){return i>=T&&i<=l||i>=D&&i<=O}function p(i,o,t,n){let s="",a=0,r=-1,h=0,g=0;for(let v=0;v<=i.length;++v){if(v<i.length)g=i.charCodeAt(v);else{if(n(g))break;g=I}if(n(g)){if(!(r===v-1||h===1))if(h===2){if(s.length<2||a!==2||s.charCodeAt(s.length-1)!==P||s.charCodeAt(s.length-2)!==P){if(s.length>2){const A=s.lastIndexOf(t);A===-1?(s="",a=0):(s=s.slice(0,A),a=s.length-1-s.lastIndexOf(t)),r=v,h=0;continue}else if(s.length!==0){s="",a=0,r=v,h=0;continue}}o&&(s+=s.length>0?`${t}..`:"..",a=2)}else s.length>0?s+=`${t}${i.slice(r+1,v)}`:s=i.slice(r+1,v),a=v-r-1;r=v,h=0}else g===P&&h!==-1?++h:h=-1}return s}function w(i,o){y(o,"pathObject");const t=o.dir||o.root,n=o.base||`${o.name||""}${o.ext||""}`;return t?t===o.root?`${t}${n}`:`${t}${i}${n}`:n}e.win32={resolve(...i){let o="",t="",n=!1;for(let s=i.length-1;s>=-1;s--){let a;if(s>=0){if(a=i[s],u(a,"path"),a.length===0)continue}else o.length===0?a=k.cwd():(a=k.env[`=${o}`]||k.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==o.toLowerCase()&&a.charCodeAt(2)===E)&&(a=`${o}\\`));const r=a.length;let h=0,g="",v=!1;const A=a.charCodeAt(0);if(r===1)f(A)&&(h=1,v=!0);else if(f(A))if(v=!0,f(a.charCodeAt(1))){let N=2,F=N;for(;N<r&&!f(a.charCodeAt(N));)N++;if(N<r&&N!==F){const M=a.slice(F,N);for(F=N;N<r&&f(a.charCodeAt(N));)N++;if(N<r&&N!==F){for(F=N;N<r&&!f(a.charCodeAt(N));)N++;(N===r||N!==F)&&(g=`\\\\${M}\\${a.slice(F,N)}`,h=N)}}}else h=1;else d(A)&&a.charCodeAt(1)===C&&(g=a.slice(0,2),h=2,r>2&&f(a.charCodeAt(2))&&(v=!0,h=3));if(g.length>0)if(o.length>0){if(g.toLowerCase()!==o.toLowerCase())continue}else o=g;if(n){if(o.length>0)break}else if(t=`${a.slice(h)}\\${t}`,n=v,v&&o.length>0)break}return t=p(t,!n,"\\",f),n?`${o}\\${t}`:`${o}${t}`||"."},normalize(i){u(i,"path");const o=i.length;if(o===0)return".";let t=0,n,s=!1;const a=i.charCodeAt(0);if(o===1)return c(a)?"\\":i;if(f(a))if(s=!0,f(i.charCodeAt(1))){let h=2,g=h;for(;h<o&&!f(i.charCodeAt(h));)h++;if(h<o&&h!==g){const v=i.slice(g,h);for(g=h;h<o&&f(i.charCodeAt(h));)h++;if(h<o&&h!==g){for(g=h;h<o&&!f(i.charCodeAt(h));)h++;if(h===o)return`\\\\${v}\\${i.slice(g)}\\`;h!==g&&(n=`\\\\${v}\\${i.slice(g,h)}`,t=h)}}}else t=1;else d(a)&&i.charCodeAt(1)===C&&(n=i.slice(0,2),t=2,o>2&&f(i.charCodeAt(2))&&(s=!0,t=3));let r=t<o?p(i.slice(t),!s,"\\",f):"";return r.length===0&&!s&&(r="."),r.length>0&&f(i.charCodeAt(o-1))&&(r+="\\"),n===void 0?s?`\\${r}`:r:s?`${n}\\${r}`:`${n}${r}`},isAbsolute(i){u(i,"path");const o=i.length;if(o===0)return!1;const t=i.charCodeAt(0);return f(t)||o>2&&d(t)&&i.charCodeAt(1)===C&&f(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,t;for(let a=0;a<i.length;++a){const r=i[a];u(r,"path"),r.length>0&&(o===void 0?o=t=r:o+=`\\${r}`)}if(o===void 0)return".";let n=!0,s=0;if(typeof t=="string"&&f(t.charCodeAt(0))){++s;const a=t.length;a>1&&f(t.charCodeAt(1))&&(++s,a>2&&(f(t.charCodeAt(2))?++s:n=!1))}if(n){for(;s<o.length&&f(o.charCodeAt(s));)s++;s>=2&&(o=`\\${o.slice(s)}`)}return e.win32.normalize(o)},relative(i,o){if(u(i,"from"),u(o,"to"),i===o)return"";const t=e.win32.resolve(i),n=e.win32.resolve(o);if(t===n||(i=t.toLowerCase(),o=n.toLowerCase(),i===o))return"";let s=0;for(;s<i.length&&i.charCodeAt(s)===E;)s++;let a=i.length;for(;a-1>s&&i.charCodeAt(a-1)===E;)a--;const r=a-s;let h=0;for(;h<o.length&&o.charCodeAt(h)===E;)h++;let g=o.length;for(;g-1>h&&o.charCodeAt(g-1)===E;)g--;const v=g-h,A=r<v?r:v;let N=-1,F=0;for(;F<A;F++){const L=i.charCodeAt(s+F);if(L!==o.charCodeAt(h+F))break;L===E&&(N=F)}if(F!==A){if(N===-1)return n}else{if(v>A){if(o.charCodeAt(h+F)===E)return n.slice(h+F+1);if(F===2)return n.slice(h+F)}r>A&&(i.charCodeAt(s+F)===E?N=F:F===2&&(N=3)),N===-1&&(N=0)}let M="";for(F=s+N+1;F<=a;++F)(F===a||i.charCodeAt(F)===E)&&(M+=M.length===0?"..":"\\..");return h+=N,M.length>0?`${M}${n.slice(h,g)}`:(n.charCodeAt(h)===E&&++h,n.slice(h,g))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.win32.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===E){if(o.charCodeAt(1)===E){const t=o.charCodeAt(2);if(t!==b&&t!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(d(o.charCodeAt(0))&&o.charCodeAt(1)===C&&o.charCodeAt(2)===E)return`\\\\?\\${o}`;return i},dirname(i){u(i,"path");const o=i.length;if(o===0)return".";let t=-1,n=0;const s=i.charCodeAt(0);if(o===1)return f(s)?i:".";if(f(s)){if(t=n=1,f(i.charCodeAt(1))){let h=2,g=h;for(;h<o&&!f(i.charCodeAt(h));)h++;if(h<o&&h!==g){for(g=h;h<o&&f(i.charCodeAt(h));)h++;if(h<o&&h!==g){for(g=h;h<o&&!f(i.charCodeAt(h));)h++;if(h===o)return i;h!==g&&(t=n=h+1)}}}}else d(s)&&i.charCodeAt(1)===C&&(t=o>2&&f(i.charCodeAt(2))?3:2,n=t);let a=-1,r=!0;for(let h=o-1;h>=n;--h)if(f(i.charCodeAt(h))){if(!r){a=h;break}}else r=!1;if(a===-1){if(t===-1)return".";a=t}return i.slice(0,a)},basename(i,o){o!==void 0&&u(o,"ext"),u(i,"path");let t=0,n=-1,s=!0,a;if(i.length>=2&&d(i.charCodeAt(0))&&i.charCodeAt(1)===C&&(t=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let r=o.length-1,h=-1;for(a=i.length-1;a>=t;--a){const g=i.charCodeAt(a);if(f(g)){if(!s){t=a+1;break}}else h===-1&&(s=!1,h=a+1),r>=0&&(g===o.charCodeAt(r)?--r===-1&&(n=a):(r=-1,n=h))}return t===n?n=h:n===-1&&(n=i.length),i.slice(t,n)}for(a=i.length-1;a>=t;--a)if(f(i.charCodeAt(a))){if(!s){t=a+1;break}}else n===-1&&(s=!1,n=a+1);return n===-1?"":i.slice(t,n)},extname(i){u(i,"path");let o=0,t=-1,n=0,s=-1,a=!0,r=0;i.length>=2&&i.charCodeAt(1)===C&&d(i.charCodeAt(0))&&(o=n=2);for(let h=i.length-1;h>=o;--h){const g=i.charCodeAt(h);if(f(g)){if(!a){n=h+1;break}continue}s===-1&&(a=!1,s=h+1),g===P?t===-1?t=h:r!==1&&(r=1):t!==-1&&(r=-1)}return t===-1||s===-1||r===0||r===1&&t===s-1&&t===n+1?"":i.slice(t,s)},format:w.bind(null,"\\"),parse(i){u(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const t=i.length;let n=0,s=i.charCodeAt(0);if(t===1)return f(s)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(f(s)){if(n=1,f(i.charCodeAt(1))){let N=2,F=N;for(;N<t&&!f(i.charCodeAt(N));)N++;if(N<t&&N!==F){for(F=N;N<t&&f(i.charCodeAt(N));)N++;if(N<t&&N!==F){for(F=N;N<t&&!f(i.charCodeAt(N));)N++;N===t?n=N:N!==F&&(n=N+1)}}}}else if(d(s)&&i.charCodeAt(1)===C){if(t<=2)return o.root=o.dir=i,o;if(n=2,f(i.charCodeAt(2))){if(t===3)return o.root=o.dir=i,o;n=3}}n>0&&(o.root=i.slice(0,n));let a=-1,r=n,h=-1,g=!0,v=i.length-1,A=0;for(;v>=n;--v){if(s=i.charCodeAt(v),f(s)){if(!g){r=v+1;break}continue}h===-1&&(g=!1,h=v+1),s===P?a===-1?a=v:A!==1&&(A=1):a!==-1&&(A=-1)}return h!==-1&&(a===-1||A===0||A===1&&a===h-1&&a===r+1?o.base=o.name=i.slice(r,h):(o.name=i.slice(r,a),o.base=i.slice(r,h),o.ext=i.slice(a,h))),r>0&&r!==n?o.dir=i.slice(0,r-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const R=(()=>{if(S){const i=/\\/g;return()=>{const o=k.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>k.cwd()})();e.posix={resolve(...i){let o="",t=!1;for(let n=i.length-1;n>=-1&&!t;n--){const s=n>=0?i[n]:R();u(s,"path"),s.length!==0&&(o=`${s}/${o}`,t=s.charCodeAt(0)===I)}return o=p(o,!t,"/",c),t?`/${o}`:o.length>0?o:"."},normalize(i){if(u(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===I,t=i.charCodeAt(i.length-1)===I;return i=p(i,!o,"/",c),i.length===0?o?"/":t?"./":".":(t&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return u(i,"path"),i.length>0&&i.charCodeAt(0)===I},join(...i){if(i.length===0)return".";let o;for(let t=0;t<i.length;++t){const n=i[t];u(n,"path"),n.length>0&&(o===void 0?o=n:o+=`/${n}`)}return o===void 0?".":e.posix.normalize(o)},relative(i,o){if(u(i,"from"),u(o,"to"),i===o||(i=e.posix.resolve(i),o=e.posix.resolve(o),i===o))return"";const t=1,n=i.length,s=n-t,a=1,r=o.length-a,h=s<r?s:r;let g=-1,v=0;for(;v<h;v++){const N=i.charCodeAt(t+v);if(N!==o.charCodeAt(a+v))break;N===I&&(g=v)}if(v===h)if(r>h){if(o.charCodeAt(a+v)===I)return o.slice(a+v+1);if(v===0)return o.slice(a+v)}else s>h&&(i.charCodeAt(t+v)===I?g=v:v===0&&(g=0));let A="";for(v=t+g+1;v<=n;++v)(v===n||i.charCodeAt(v)===I)&&(A+=A.length===0?"..":"/..");return`${A}${o.slice(a+g)}`},toNamespacedPath(i){return i},dirname(i){if(u(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===I;let t=-1,n=!0;for(let s=i.length-1;s>=1;--s)if(i.charCodeAt(s)===I){if(!n){t=s;break}}else n=!1;return t===-1?o?"/":".":o&&t===1?"//":i.slice(0,t)},basename(i,o){o!==void 0&&u(o,"ext"),u(i,"path");let t=0,n=-1,s=!0,a;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let r=o.length-1,h=-1;for(a=i.length-1;a>=0;--a){const g=i.charCodeAt(a);if(g===I){if(!s){t=a+1;break}}else h===-1&&(s=!1,h=a+1),r>=0&&(g===o.charCodeAt(r)?--r===-1&&(n=a):(r=-1,n=h))}return t===n?n=h:n===-1&&(n=i.length),i.slice(t,n)}for(a=i.length-1;a>=0;--a)if(i.charCodeAt(a)===I){if(!s){t=a+1;break}}else n===-1&&(s=!1,n=a+1);return n===-1?"":i.slice(t,n)},extname(i){u(i,"path");let o=-1,t=0,n=-1,s=!0,a=0;for(let r=i.length-1;r>=0;--r){const h=i.charCodeAt(r);if(h===I){if(!s){t=r+1;break}continue}n===-1&&(s=!1,n=r+1),h===P?o===-1?o=r:a!==1&&(a=1):o!==-1&&(a=-1)}return o===-1||n===-1||a===0||a===1&&o===n-1&&o===t+1?"":i.slice(o,n)},format:w.bind(null,"/"),parse(i){u(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const t=i.charCodeAt(0)===I;let n;t?(o.root="/",n=1):n=0;let s=-1,a=0,r=-1,h=!0,g=i.length-1,v=0;for(;g>=n;--g){const A=i.charCodeAt(g);if(A===I){if(!h){a=g+1;break}continue}r===-1&&(h=!1,r=g+1),A===P?s===-1?s=g:v!==1&&(v=1):s!==-1&&(v=-1)}if(r!==-1){const A=a===0&&t?1:a;s===-1||v===0||v===1&&s===r-1&&s===a+1?o.base=o.name=i.slice(A,r):(o.name=i.slice(A,s),o.base=i.slice(A,r),o.ext=i.slice(s,r))}return a>0?o.dir=i.slice(0,a-1):t&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=S?e.win32.normalize:e.posix.normalize,e.isAbsolute=S?e.win32.isAbsolute:e.posix.isAbsolute,e.join=S?e.win32.join:e.posix.join,e.resolve=S?e.win32.resolve:e.posix.resolve,e.relative=S?e.win32.relative:e.posix.relative,e.dirname=S?e.win32.dirname:e.posix.dirname,e.basename=S?e.win32.basename:e.posix.basename,e.extname=S?e.win32.extname:e.posix.extname,e.format=S?e.win32.format:e.posix.format,e.parse=S?e.win32.parse:e.posix.parse,e.toNamespacedPath=S?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=S?e.win32.sep:e.posix.sep,e.delimiter=S?e.win32.delimiter:e.posix.delimiter}),define(oe[142],ae([0,1,13]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function l(C){const b=(0,k.extname)(C),m=T[b.toLowerCase()];return m!==void 0?m:O(C)}e.getMediaOrTextMime=l;function O(C){const b=(0,k.extname)(C);return D[b.toLowerCase()]}e.getMediaMime=O;function P(C){for(const b in D)if(D[b]===C)return b}e.getExtensionForMimeType=P;const I=/^(.+)\/(.+?)(;.+)?$/;function E(C,b){const m=I.exec(C);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:b?void 0:C}e.normalizeMimeType=E}),define(oe[87],ae([0,1,4]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var T;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(T=e.Source||(e.Source={}));var D;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function l(P,...I){const E=I.reduce((m,y)=>(m[y]=!0,m),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(m=>!E[m]).forEach(m=>{for(let y=0;y<C.length;y++)if(m.search(C[y])!==-1){delete P[m];break}})}e.sanitizeProcessEnvironment=l;function O(P){!P||(delete P.DEBUG,k.isMacintosh&&delete P.DYLD_LIBRARY_PATH,k.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=O}),define(oe[88],ae([0,1,4]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const T=k.globals.performance&&typeof k.globals.performance.now=="function";class D{static create(O=!0){return new D(O)}constructor(O){this.a=T&&O,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?k.globals.performance.now():Date.now()}}e.StopWatch=D}),define(oe[3],ae([0,1,9,82,2,84,88]),function(Q,e,k,T,D,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,I=!1;var E;(function(a){a.None=()=>D.Disposable.None;function r(q){if(I){const{onDidAddListener:Y}=q,ee=u.create();let K=0;q.onDidAddListener=()=>{++K===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ee.print()),Y?.()}}}function h(q,Y){return z(q,()=>{},0,void 0,void 0,Y)}a.defer=h;function g(q){return(Y,ee=null,K)=>{let Z=!1,se;return se=q(le=>{if(!Z)return se?se.dispose():Z=!0,Y.call(ee,le)},null,K),Z&&se.dispose(),se}}a.once=g;function v(q,Y,ee){return $((K,Z=null,se)=>q(le=>K.call(Z,Y(le)),null,se),ee)}a.map=v;function A(q,Y,ee){return $((K,Z=null,se)=>q(le=>{Y(le),K.call(Z,le)},null,se),ee)}a.forEach=A;function N(q,Y,ee){return $((K,Z=null,se)=>q(le=>Y(le)&&K.call(Z,le),null,se),ee)}a.filter=N;function F(q){return q}a.signal=F;function M(...q){return(Y,ee=null,K)=>(0,D.combinedDisposable)(...q.map(Z=>Z(se=>Y.call(ee,se),null,K)))}a.any=M;function L(q,Y,ee,K){let Z=ee;return v(q,se=>(Z=Y(Z,se),Z),K)}a.reduce=L;function $(q,Y){let ee;const K={onWillAddFirstListener(){ee=q(Z.fire,Z)},onDidRemoveLastListener(){ee?.dispose()}};Y||r(K);const Z=new f(K);return Y?.add(Z),Z.event}function z(q,Y,ee=100,K=!1,Z,se){let le,ue,pe,ve=0;const be={leakWarningThreshold:Z,onWillAddFirstListener(){le=q(Oe=>{ve++,ue=Y(ue,Oe),K&&!pe&&(Ee.fire(ue),ue=void 0),clearTimeout(pe),pe=setTimeout(()=>{const Ue=ue;ue=void 0,pe=void 0,(!K||ve>1)&&Ee.fire(Ue),ve=0},ee)})},onDidRemoveLastListener(){le.dispose()}};se||r(be);const Ee=new f(be);return se?.add(Ee),Ee.event}a.debounce=z;function x(q,Y=0,ee){return a.debounce(q,(K,Z)=>K?(K.push(Z),K):[Z],Y,void 0,void 0,ee)}a.accumulate=x;function X(q,Y=(K,Z)=>K===Z,ee){let K=!0,Z;return N(q,se=>{const le=K||!Y(se,Z);return K=!1,Z=se,le},ee)}a.latch=X;function ie(q,Y,ee){return[a.filter(q,Y,ee),a.filter(q,K=>!Y(K),ee)]}a.split=ie;function H(q,Y=!1,ee=[]){let K=ee.slice(),Z=q(ue=>{K?K.push(ue):le.fire(ue)});const se=()=>{K?.forEach(ue=>le.fire(ue)),K=null},le=new f({onWillAddFirstListener(){Z||(Z=q(ue=>le.fire(ue)))},onDidAddFirstListener(){K&&(Y?setTimeout(se):se())},onDidRemoveLastListener(){Z&&Z.dispose(),Z=null}});return le.event}a.buffer=H;class j{constructor(Y){this.event=Y,this.c=new D.DisposableStore}map(Y){return new j(v(this.event,Y,this.c))}forEach(Y){return new j(A(this.event,Y,this.c))}filter(Y){return new j(N(this.event,Y,this.c))}reduce(Y,ee){return new j(L(this.event,Y,ee,this.c))}latch(){return new j(X(this.event,void 0,this.c))}debounce(Y,ee=100,K=!1,Z){return new j(z(this.event,Y,ee,K,Z,this.c))}on(Y,ee,K){return this.event(Y,ee,K)}once(Y,ee,K){return g(this.event)(Y,ee,K)}dispose(){this.c.dispose()}}function V(q){return new j(q)}a.chain=V;function J(q,Y,ee=K=>K){const K=(...ue)=>le.fire(ee(...ue)),Z=()=>q.on(Y,K),se=()=>q.removeListener(Y,K),le=new f({onWillAddFirstListener:Z,onDidRemoveLastListener:se});return le.event}a.fromNodeEventEmitter=J;function _(q,Y,ee=K=>K){const K=(...ue)=>le.fire(ee(...ue)),Z=()=>q.addEventListener(Y,K),se=()=>q.removeEventListener(Y,K),le=new f({onWillAddFirstListener:Z,onDidRemoveLastListener:se});return le.event}a.fromDOMEventEmitter=_;function re(q){return new Promise(Y=>g(q)(Y))}a.toPromise=re;function te(q,Y){return Y(void 0),q(ee=>Y(ee))}a.runAndSubscribe=te;function U(q,Y){let ee=null;function K(se){ee?.dispose(),ee=new D.DisposableStore,Y(se,ee)}K(void 0);const Z=q(se=>K(se));return(0,D.toDisposable)(()=>{Z.dispose(),ee?.dispose()})}a.runAndSubscribeWithStore=U;class B{constructor(Y,ee){this.obs=Y,this.c=0,this.d=!1;const K={onWillAddFirstListener:()=>{Y.addObserver(this)},onDidRemoveLastListener:()=>{Y.removeObserver(this)}};ee||r(K),this.emitter=new f(K),ee&&ee.add(this.emitter)}beginUpdate(Y){this.c++}handleChange(Y,ee){this.d=!0}endUpdate(Y){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function W(q,Y){return new B(q,Y).emitter.event}a.fromObservable=W})(E=e.Event||(e.Event={}));class C{constructor(r){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${r}_${C.c++}`,C.all.add(this)}start(r){this.d=new O.StopWatch(!0),this.listenerCount=r}stop(){if(this.d){const r=this.d.elapsed();this.durations.push(r),this.elapsedOverall+=r,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=C,C.all=new Set,C.c=0;let b=-1;function m(a){const r=b;return b=a,{dispose(){b=r}}}e.setGlobalLeakWarningThreshold=m;class y{constructor(r,h=Math.random().toString(18).slice(2,5)){this.threshold=r,this.name=h,this.d=0}dispose(){this.c?.clear()}check(r,h){const g=this.threshold;if(g<=0||h<g)return;this.c||(this.c=new Map);const v=this.c.get(r.value)||0;if(this.c.set(r.value,v+1),this.d-=1,this.d<=0){this.d=g*.5;let A,N=0;for(const[F,M]of this.c)(!A||N<M)&&(A=F,N=M);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${N}):`),console.warn(A)}return()=>{const A=this.c.get(r.value)||0;this.c.set(r.value,A-1)}}}class u{static create(){return new u(new Error().stack??"")}constructor(r){this.value=r}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class S{constructor(r,h,g){this.callback=r,this.callbackThis=h,this.stack=g,this.subscription=new D.SafeDisposable}invoke(r){this.callback.call(this.callbackThis,r)}}class f{constructor(r){this.j=!1,this.d=r,this.f=b>0||this.d?.leakWarningThreshold?new y(this.d?.leakWarningThreshold??b):void 0,this.g=this.d?._profName?new C(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const r=Array.from(this.q);queueMicrotask(()=>{for(const h of r)h.subscription.isset()&&(h.subscription.unset(),h.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(r,h,g)=>{if(this.q||(this.q=new l.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),D.Disposable.None;const v=this.q.isEmpty();v&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let A,N;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(N=u.create(),A=this.f.check(N,this.q.size+1)),P&&(N=N??u.create());const F=new S(r,h,N),M=this.q.push(F);v&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,r,h);const L=F.subscription.set(()=>{A?.(),this.j||(M(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return g instanceof D.DisposableStore?g.add(L):Array.isArray(g)&&g.push(L),L}),this.l}fire(r){if(this.q){this.m||(this.m=new d);for(const h of this.q)this.m.push(this,h,r);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=f;class c{constructor(){this.c=new l.LinkedList}get size(){return this.c.size}push(r,h,g){this.c.push(new p(r,h,g))}clear(r){const h=new l.LinkedList;for(const g of this.c)g.emitter!==r&&h.push(g);this.c=h}deliver(){for(;this.c.size>0;){const r=this.c.shift();try{r.listener.invoke(r.event)}catch(h){(0,k.onUnexpectedError)(h)}}}}e.EventDeliveryQueue=c;class d extends c{clear(r){this.c.clear()}}class p{constructor(r,h,g){this.emitter=r,this.listener=h,this.event=g}}class w extends f{async fireAsync(r,h,g){if(!!this.q){this.c||(this.c=new l.LinkedList);for(const v of this.q)this.c.push([v,r]);for(;this.c.size>0&&!h.isCancellationRequested;){const[v,A]=this.c.shift(),N=[],F={...A,token:h,waitUntil:M=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");g&&(M=g(M,v.callback)),N.push(M)}};try{v.invoke(F)}catch(M){(0,k.onUnexpectedError)(M);continue}Object.freeze(N),await Promise.allSettled(N).then(M=>{for(const L of M)L.status==="rejected"&&(0,k.onUnexpectedError)(L.reason)})}}}}e.AsyncEmitter=w;class R extends f{constructor(r){super(r),this.h=0,this.s=new l.LinkedList,this.t=r?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const r=Array.from(this.s);this.s.clear(),super.fire(this.t(r))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(r){this.q&&(this.h!==0?this.s.push(r):super.fire(r))}}e.PauseableEmitter=R;class i extends R{constructor(r){super(r),this.c=r.delay??100}fire(r){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(r)}}e.DebounceEmitter=i;class o extends f{constructor(r){super(r),this.c=[],this.h=r?.merge}fire(r){!this.hasListeners()||(this.c.push(r),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(h=>super.fire(h)),this.c=[]}))}}e.MicrotaskEmitter=o;class t{constructor(){this.d=!1,this.f=[],this.c=new f({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(r){const h={event:r,listener:null};this.f.push(h),this.d&&this.j(h);const g=()=>{this.d&&this.k(h);const v=this.f.indexOf(h);this.f.splice(v,1)};return(0,D.toDisposable)((0,T.once)(g))}g(){this.d=!0,this.f.forEach(r=>this.j(r))}h(){this.d=!1,this.f.forEach(r=>this.k(r))}j(r){r.listener=r.event(h=>this.c.fire(h))}k(r){r.listener&&r.listener.dispose(),r.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=t;class n{constructor(){this.c=[]}wrapEvent(r){return(h,g,v)=>r(A=>{const N=this.c[this.c.length-1];N?N.push(()=>h.call(g,A)):h.call(g,A)},void 0,v)}bufferEvents(r){const h=[];this.c.push(h);const g=r();return this.c.pop(),h.forEach(v=>v()),g}}e.EventBufferer=n;class s{constructor(){this.c=!1,this.d=E.None,this.f=D.Disposable.None,this.g=new f({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(r){this.d=r,this.c&&(this.f.dispose(),this.f=r(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=s}),define(oe[25],ae([0,1,3]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const T=Object.freeze(function(P,I){const E=setTimeout(P.bind(I),0);return{dispose(){clearTimeout(E)}}});var D;(function(P){function I(E){return E===P.None||E===P.Cancelled||E instanceof l?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}P.isCancellationToken=I,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(D=e.CancellationToken||(e.CancellationToken={}));class l{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new k.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(I){this.a=void 0,this.b=void 0,this.b=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new l),this.a}cancel(){this.a?this.a instanceof l&&this.a.cancel():this.a=D.Cancelled}dispose(I=!1){I&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof l&&this.a.dispose():this.a=D.None}}e.CancellationTokenSource=O}),define(oe[143],ae([0,1,25]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class T{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new k.CancellationTokenSource,I=this.b(P.token);return this.a={promise:I,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=T;class D{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const I=JSON.stringify(P);return this.b!==I&&(this.b=I,this.a=this.c(P)),this.a}}e.LRUCachedFunction=D;class l{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const I=this.b(P);return this.a.set(P,I),I}}e.CachedFunction=l}),define(oe[27],ae([0,1,143,129]),function(Q,e,k,T){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function l(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}e.isFalsyOrWhitespace=l;const O=/{(\d+)}/g;function P(ne,...he){return he.length===0?ne:ne.replace(O,function(fe,me){const Se=parseInt(me,10);return isNaN(Se)||Se<0||Se>=he.length?fe:he[Se]})}e.format=P;const I=/{([^}]+)}/g;function E(ne,he){return ne.replace(I,(fe,me)=>he[me]??fe)}e.format2=E;function C(ne){return ne.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=C;function b(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function m(ne,he){let fe=0;const me=he.charCodeAt(0);for(let Se=ne.length-1;Se>=0;Se--)ne.charCodeAt(Se)===me&&fe++;return fe}e.count=m;function y(ne,he,fe="\u2026"){return ne.length<=he?ne:`${ne.substr(0,he)}${fe}`}e.truncate=y;function u(ne,he=" "){const fe=S(ne,he);return f(fe,he)}e.trim=u;function S(ne,he){if(!ne||!he)return ne;const fe=he.length;if(fe===0||ne.length===0)return ne;let me=0;for(;ne.indexOf(he,me)===me;)me=me+fe;return ne.substring(me)}e.ltrim=S;function f(ne,he){if(!ne||!he)return ne;const fe=he.length,me=ne.length;if(fe===0||me===0)return ne;let Se=me,Ie=-1;for(;Ie=ne.lastIndexOf(he,Se-1),!(Ie===-1||Ie+fe!==Se);){if(Ie===0)return"";Se=Ie}return ne.substring(0,Se)}e.rtrim=f;function c(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=c;function d(ne){return ne.replace(/\*/g,"")}e.stripWildcards=d;function p(ne,he,fe={}){if(!ne)throw new Error("Cannot create regex from empty string");he||(ne=b(ne)),fe.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let me="";return fe.global&&(me+="g"),fe.matchCase||(me+="i"),fe.multiline&&(me+="m"),fe.unicode&&(me+="u"),new RegExp(ne,me)}e.createRegExp=p;function w(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function R(ne){return!!ne.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=R;function i(ne){return(ne.global?"g":"")+(ne.ignoreCase?"i":"")+(ne.multiline?"m":"")+(ne.unicode?"u":"")}e.regExpFlags=i;function o(ne){return ne.split(/\r\n|\r|\n/)}e.splitLines=o;function t(ne){for(let he=0,fe=ne.length;he<fe;he++){const me=ne.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.firstNonWhitespaceIndex=t;function n(ne,he=0,fe=ne.length){for(let me=he;me<fe;me++){const Se=ne.charCodeAt(me);if(Se!==32&&Se!==9)return ne.substring(he,me)}return ne.substring(he,fe)}e.getLeadingWhitespace=n;function s(ne,he=ne.length-1){for(let fe=he;fe>=0;fe--){const me=ne.charCodeAt(fe);if(me!==32&&me!==9)return fe}return-1}e.lastNonWhitespaceIndex=s;function a(ne,he,fe){const me=[];let Se=0;for(const Ie of ne.matchAll(he)){if(me.push(ne.slice(Se,Ie.index)),Ie.index===void 0)throw new Error("match.index should be defined");Se=Ie.index+Ie[0].length,me.push(fe(Ie[0],...Ie.slice(1),Ie.index,ne,Ie.groups))}return me.push(ne.slice(Se)),Promise.all(me).then(Ie=>Ie.join(""))}e.replaceAsync=a;function r(ne,he){return ne<he?-1:ne>he?1:0}e.compare=r;function h(ne,he,fe=0,me=ne.length,Se=0,Ie=he.length){for(;fe<me&&Se<Ie;fe++,Se++){const $e=ne.charCodeAt(fe),Ae=he.charCodeAt(Se);if($e<Ae)return-1;if($e>Ae)return 1}const Re=me-fe,xe=Ie-Se;return Re<xe?-1:Re>xe?1:0}e.compareSubstring=h;function g(ne,he){return v(ne,he,0,ne.length,0,he.length)}e.compareIgnoreCase=g;function v(ne,he,fe=0,me=ne.length,Se=0,Ie=he.length){for(;fe<me&&Se<Ie;fe++,Se++){let $e=ne.charCodeAt(fe),Ae=he.charCodeAt(Se);if($e===Ae)continue;if($e>=128||Ae>=128)return h(ne.toLowerCase(),he.toLowerCase(),fe,me,Se,Ie);N($e)&&($e-=32),N(Ae)&&(Ae-=32);const qe=$e-Ae;if(qe!==0)return qe}const Re=me-fe,xe=Ie-Se;return Re<xe?-1:Re>xe?1:0}e.compareSubstringIgnoreCase=v;function A(ne){return ne>=48&&ne<=57}e.isAsciiDigit=A;function N(ne){return ne>=97&&ne<=122}e.isLowerAsciiLetter=N;function F(ne){return ne>=65&&ne<=90}e.isUpperAsciiLetter=F;function M(ne,he){return ne.length===he.length&&v(ne,he)===0}e.equalsIgnoreCase=M;function L(ne,he){const fe=he.length;return he.length>ne.length?!1:v(ne,he,0,fe)===0}e.startsWithIgnoreCase=L;function $(ne,he){const fe=Math.min(ne.length,he.length);let me;for(me=0;me<fe;me++)if(ne.charCodeAt(me)!==he.charCodeAt(me))return me;return fe}e.commonPrefixLength=$;function z(ne,he){const fe=Math.min(ne.length,he.length);let me;const Se=ne.length-1,Ie=he.length-1;for(me=0;me<fe;me++)if(ne.charCodeAt(Se-me)!==he.charCodeAt(Ie-me))return me;return fe}e.commonSuffixLength=z;function x(ne){return 55296<=ne&&ne<=56319}e.isHighSurrogate=x;function X(ne){return 56320<=ne&&ne<=57343}e.isLowSurrogate=X;function ie(ne,he){return(ne-55296<<10)+(he-56320)+65536}e.computeCodePoint=ie;function H(ne,he,fe){const me=ne.charCodeAt(fe);if(x(me)&&fe+1<he){const Se=ne.charCodeAt(fe+1);if(X(Se))return ie(me,Se)}return me}e.getNextCodePoint=H;function j(ne,he){const fe=ne.charCodeAt(he-1);if(X(fe)&&he>1){const me=ne.charCodeAt(he-2);if(x(me))return ie(me,fe)}return fe}class V{get offset(){return this.e}constructor(he,fe=0){this.c=he,this.d=he.length,this.e=fe}setOffset(he){this.e=he}prevCodePoint(){const he=j(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=H(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}e.CodePointIterator=V;class J{get offset(){return this.c.offset}constructor(he,fe=0){this.c=new V(he,fe)}nextGraphemeLength(){const he=Le.getInstance(),fe=this.c,me=fe.offset;let Se=he.getGraphemeBreakType(fe.nextCodePoint());for(;!fe.eol();){const Ie=fe.offset,Re=he.getGraphemeBreakType(fe.nextCodePoint());if(Ce(Se,Re)){fe.setOffset(Ie);break}Se=Re}return fe.offset-me}prevGraphemeLength(){const he=Le.getInstance(),fe=this.c,me=fe.offset;let Se=he.getGraphemeBreakType(fe.prevCodePoint());for(;fe.offset>0;){const Ie=fe.offset,Re=he.getGraphemeBreakType(fe.prevCodePoint());if(Ce(Re,Se)){fe.setOffset(Ie);break}Se=Re}return me-fe.offset}eol(){return this.c.eol()}}e.GraphemeIterator=J;function _(ne,he){return new J(ne,he).nextGraphemeLength()}e.nextCharLength=_;function re(ne,he){return new J(ne,he).prevGraphemeLength()}e.prevCharLength=re;function te(ne,he){he>0&&X(ne.charCodeAt(he))&&he--;const fe=he+_(ne,he);return[fe-re(ne,fe),fe]}e.getCharContainingOffset=te;function U(ne){const he=new J(ne);let fe=0;for(;!he.eol();)fe++,he.nextGraphemeLength();return fe}e.charCount=U;let B;function W(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function q(ne){return B||(B=W()),B.test(ne)}e.containsRTL=q;const Y=/^[\t\n\r\x20-\x7E]*$/;function ee(ne){return Y.test(ne)}e.isBasicASCII=ee,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function K(ne){return e.UNUSUAL_LINE_TERMINATORS.test(ne)}e.containsUnusualLineTerminators=K;function Z(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}e.isFullWidthCharacter=Z;function se(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}e.isEmojiImprecise=se;function le(ne,he){if(ne.length<he)return ne;const fe=/\b/g;let me=0;for(;fe.test(ne)&&!(ne.length-fe.lastIndex<he);)me=fe.lastIndex,fe.lastIndex+=1;return ne.substring(me).replace(/^\s/,"")}e.lcut=le;const ue=/\x1B\x5B[12]?K/g,pe=/\x1b\[\d+m/g,ve=/\x1b\[0?m/g;function be(ne){return ne&&(ne=ne.replace(ue,""),ne=ne.replace(pe,""),ne=ne.replace(ve,"")),ne}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Oe(ne){return Ee(ne)?ne.substr(1):ne}e.stripUTF8BOM=Oe;function Ue(ne,he){if(!ne||!he||ne.length<he.length)return!1;const fe=he.length,me=ne.toLowerCase();let Se=0,Ie=-1;for(;Se<fe;){const Re=me.indexOf(he[Se],Ie+1);if(Re<0)return!1;Ie=Re,Se++}return!0}e.fuzzyContains=Ue;function Ye(ne,he=!1){return ne?(he&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}e.containsUppercaseCharacter=Ye;function Be(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}e.uppercaseFirstLetter=Be;function ce(ne,he=1){if(he===0)return"";let fe=-1;do fe=ne.indexOf(`
`,fe+1),he--;while(he>0&&fe>=0);return fe===-1?ne:(ne[fe-1]==="\r"&&fe--,ne.substr(0,fe))}e.getNLines=ce;function de(ne){return ne=ne%(2*26),ne<26?String.fromCharCode(97+ne):String.fromCharCode(65+ne-26)}e.singleLetterHash=de;function ge(ne){return Le.getInstance().getGraphemeBreakType(ne)}e.getGraphemeBreakType=ge;function Ce(ne,he){return ne===0?he!==5&&he!==7:ne===2&&he===3?!1:ne===4||ne===2||ne===3||he===4||he===2||he===3?!0:!(ne===8&&(he===8||he===9||he===11||he===12)||(ne===11||ne===9)&&(he===9||he===10)||(ne===12||ne===10)&&he===10||he===5||he===13||he===7||ne===1||ne===13&&he===14||ne===6&&he===6)}var Pe;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Le{static getInstance(){return Le.c||(Le.c=new Le),Le.c}constructor(){this.d=De()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const fe=this.d,me=fe.length/3;let Se=1;for(;Se<=me;)if(he<fe[3*Se])Se=2*Se;else if(he>fe[3*Se+1])Se=2*Se+1;else return fe[3*Se+2];return 0}}Le.c=null;function De(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(ne,he){if(ne===0)return 0;const fe=Te(ne,he);if(fe!==void 0)return fe;const me=new V(he,ne);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=je;function Te(ne,he){const fe=new V(he,ne);let me=fe.prevCodePoint();for(;Fe(me)||me===65039||me===8419;){if(fe.offset===0)return;me=fe.prevCodePoint()}if(!se(me))return;let Se=fe.offset;return Se>0&&fe.prevCodePoint()===8205&&(Se=fe.offset),Se}function Fe(ne){return 127995<=ne&&ne<=127999}var ze;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class ke{static getInstance(he){return ke.d.get(Array.from(he))}static getLocales(){return ke.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=ke,D=ke,ke.c=new T.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ke.d=new k.LRUCachedFunction(ne=>{function he(Ae){const qe=new Map;for(let He=0;He<Ae.length;He+=2)qe.set(Ae[He],Ae[He+1]);return qe}function fe(Ae,qe){const He=new Map(Ae);for(const[et,rt]of qe)He.set(et,rt);return He}function me(Ae,qe){if(!Ae)return qe;const He=new Map;for(const[et,rt]of Ae)qe.has(et)&&He.set(et,rt);return He}const Se=D.c.value;let Ie=ne.filter(Ae=>!Ae.startsWith("_")&&Ae in Se);Ie.length===0&&(Ie=["_default"]);let Re;for(const Ae of Ie){const qe=he(Se[Ae]);Re=me(Re,qe)}const xe=he(Se._common),$e=fe(xe,Re);return new ke($e)}),ke.e=new T.Lazy(()=>Object.keys(ke.c.value).filter(ne=>!ne.startsWith("_")));class Ne{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ne.c())),this.d}static isInvisibleCharacter(he){return Ne.e().has(he)}static get codePoints(){return Ne.e()}}e.InvisibleCharacters=Ne,Ne.d=void 0}),define(oe[48],ae([0,1,13,4,27,12]),function(Q,e,k,T,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function O(s){return s===47||s===92}e.isPathSeparator=O;function P(s){return s.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=P;function I(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=I;function E(s,a=k.posix.sep){if(!s)return"";const r=s.length,h=s.charCodeAt(0);if(O(h)){if(O(s.charCodeAt(1))&&!O(s.charCodeAt(2))){let v=3;const A=v;for(;v<r&&!O(s.charCodeAt(v));v++);if(A!==v&&!O(s.charCodeAt(v+1))){for(v+=1;v<r;v++)if(O(s.charCodeAt(v)))return s.slice(0,v+1).replace(/[\\/]/g,a)}}return a}else if(c(h)&&s.charCodeAt(1)===58)return O(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let g=s.indexOf("://");if(g!==-1){for(g+=3;g<r;g++)if(O(s.charCodeAt(g)))return s.slice(0,g+1)}return""}e.getRoot=E;function C(s){if(!T.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let r=2;const h=r;for(;r<s.length&&(a=s.charCodeAt(r),a!==92);r++);return!(h===r||(a=s.charCodeAt(r+1),isNaN(a)||a===92))}e.isUNC=C;const b=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(s,a=T.isWindows){const r=a?b:m;return!(!s||s.length===0||/^\s+$/.test(s)||(r.lastIndex=0,r.test(s))||a&&y.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=u;function S(s,a,r){const h=s===a;return!r||h?h:!s||!a?!1:(0,D.equalsIgnoreCase)(s,a)}e.isEqual=S;function f(s,a,r,h=k.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(r){if(!(0,D.startsWithIgnoreCase)(s,a))return!1;if(a.length===s.length)return!0;let v=a.length;return a.charAt(a.length-1)===h&&v--,s.charAt(v)===h}return a.charAt(a.length-1)!==h&&(a+=h),s.indexOf(a)===0}e.isEqualOrParent=f;function c(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=c;function d(s,a){return T.isWindows&&s.endsWith(":")&&(s+=k.sep),(0,k.isAbsolute)(s)||(s=(0,k.join)(a,s)),s=(0,k.normalize)(s),T.isWindows?(s=(0,D.rtrim)(s,k.sep),s.endsWith(":")&&(s+=k.sep)):(s=(0,D.rtrim)(s,k.sep),s||(s=k.sep)),s}e.sanitizeFilePath=d;function p(s){const a=(0,k.normalize)(s);return T.isWindows?s.length>3?!1:w(a)&&(s.length===2||a.charCodeAt(2)===92):a===k.posix.sep}e.isRootOrDriveLetter=p;function w(s,a=T.isWindows){return a?c(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=w;function R(s){return w(s)?s[0]:void 0}e.getDriveLetter=R;function i(s,a,r){return a.length>s.length?-1:s===a?0:(r&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}e.indexOfPath=i;function o(s){const a=s.split(":");let r,h,g;for(const v of a){const A=Number(v);(0,l.isNumber)(A)?h===void 0?h=A:g===void 0&&(g=A):r=r?[r,v].join(":"):v}if(!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:h!==void 0?h:void 0,column:g!==void 0?g:h!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(s,a,r=8){let h="";for(let v=0;v<r;v++)h+=t.charAt(Math.floor(Math.random()*t.length));let g;return a?g=`${a}-${h}`:g=h,s?(0,k.join)(s,g):g}e.randomPath=n}),define(oe[66],ae([0,1,27]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function T(c){return D(c,0)}e.hash=T;function D(c,d){switch(typeof c){case"object":return c===null?l(349,d):Array.isArray(c)?I(c,d):E(c,d);case"string":return P(c,d);case"boolean":return O(c,d);case"number":return l(c,d);case"undefined":return l(937,d);default:return l(617,d)}}e.doHash=D;function l(c,d){return(d<<5)-d+c|0}e.numberHash=l;function O(c,d){return l(c?433:863,d)}function P(c,d){d=l(149417,d);for(let p=0,w=c.length;p<w;p++)d=l(c.charCodeAt(p),d);return d}e.stringHash=P;function I(c,d){return d=l(104579,d),c.reduce((p,w)=>D(w,p),d)}function E(c,d){return d=l(181387,d),Object.keys(c).sort().reduce((p,w)=>(p=P(w,p),D(c[w],p)),d)}class C{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=D(d,this.g),this.g}}e.Hasher=C;var b;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function m(c,d,p=32){const w=p-d,R=~((1<<w)-1);return(c<<d|(R&c)>>>w)>>>0}function y(c,d=0,p=c.byteLength,w=0){for(let R=0;R<p;R++)c[d+R]=w}function u(c,d,p="0"){for(;c.length<d;)c=p+c;return c}function S(c,d=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(p=>p.toString(16).padStart(2,"0")).join(""):u((c>>>0).toString(16),d/4)}e.toHexString=S;class f{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const p=d.length;if(p===0)return;const w=this.p;let R=this.r,i=this.u,o,t;for(i!==0?(o=i,t=-1,i=0):(o=d.charCodeAt(0),t=0);;){let n=o;if(k.isHighSurrogate(o))if(t+1<p){const s=d.charCodeAt(t+1);k.isLowSurrogate(s)?(t++,n=k.computeCodePoint(o,s)):n=65533}else{i=o;break}else k.isLowSurrogate(o)&&(n=65533);if(R=this.w(w,R,n),t++,t<p)o=d.charCodeAt(t);else break}this.r=R,this.u=i}w(d,p,w){return w<128?d[p++]=w:w<2048?(d[p++]=192|(w&1984)>>>6,d[p++]=128|(w&63)>>>0):w<65536?(d[p++]=224|(w&61440)>>>12,d[p++]=128|(w&4032)>>>6,d[p++]=128|(w&63)>>>0):(d[p++]=240|(w&1835008)>>>18,d[p++]=128|(w&258048)>>>12,d[p++]=128|(w&4032)>>>6,d[p++]=128|(w&63)>>>0),p>=64&&(this.y(),p-=64,this.t+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),S(this.h)+S(this.l)+S(this.m)+S(this.n)+S(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=f.g,p=this.q;for(let r=0;r<64;r+=4)d.setUint32(r,p.getUint32(r,!1),!1);for(let r=64;r<320;r+=4)d.setUint32(r,m(d.getUint32(r-12,!1)^d.getUint32(r-32,!1)^d.getUint32(r-56,!1)^d.getUint32(r-64,!1),1),!1);let w=this.h,R=this.l,i=this.m,o=this.n,t=this.o,n,s,a;for(let r=0;r<80;r++)r<20?(n=R&i|~R&o,s=1518500249):r<40?(n=R^i^o,s=1859775393):r<60?(n=R&i|R&o|i&o,s=2400959708):(n=R^i^o,s=3395469782),a=m(w,5)+n+t+s+d.getUint32(r*4,!1)&4294967295,t=o,o=i,i=m(R,30),R=w,w=a;this.h=this.h+w&4294967295,this.l=this.l+R&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+t&4294967295}}e.StringSHA1=f,f.g=new DataView(new ArrayBuffer(320))}),define(oe[89],ae([0,1,27]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(T||(T={})),function(D){const l="error",O="warning",P="warn",I="info",E="ignore";function C(m){return m?k.equalsIgnoreCase(l,m)?D.Error:k.equalsIgnoreCase(O,m)||k.equalsIgnoreCase(P,m)?D.Warning:k.equalsIgnoreCase(I,m)?D.Info:D.Ignore:D.Ignore}D.fromValue=C;function b(m){switch(m){case D.Error:return l;case D.Warning:return O;case D.Info:return I;default:return E}}D.toString=b}(T||(T={})),e.default=T}),define(oe[49],ae([0,1,21,27]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class D{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const u=y.charCodeAt(0),S=this.b.charCodeAt(this.c);return u-S}value(){return this.b[this.c]}}e.StringIterator=D;class l{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,T.compareSubstring)(y,this.b,0,y.length,this.c,this.d):(0,T.compareSubstringIgnoreCase)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=l;class O{constructor(y=!0,u=!0){this.f=y,this.g=u}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let u=y.length-1;u>=0;u--,this.c--){const S=this.b.charCodeAt(u);if(!(S===47||this.f&&S===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const u=this.b.charCodeAt(this.e);if(u===47||this.f&&u===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,T.compareSubstring)(y,this.b,0,y.length,this.d,this.e):(0,T.compareSubstringIgnoreCase)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=O;var P;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(P||(P={}));class I{constructor(y,u){this.f=y,this.g=u,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,T.compareIgnoreCase)(y,this.c.scheme);if(this.d[this.e]===2)return(0,T.compareIgnoreCase)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,T.compare)(y,this.c.query);if(this.d[this.e]===5)return(0,T.compare)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=I;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(C||(C={}));class b{static forUris(y=()=>!1,u=()=>!1){return new b(new I(y,u))}static forPaths(y=!1){return new b(new O(void 0,!y))}static forStrings(){return new b(new D)}static forConfigKeys(){return new b(new l)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,u){if(u){const S=u.slice(0);(0,k.shuffle)(S);for(const f of S)this.set(f,y)}else{const S=y.slice(0);(0,k.shuffle)(S);for(const f of S)this.set(f[0],f[1])}}set(y,u){const S=this.b.reset(y);let f;this.c||(this.c=new E,this.c.segment=S.value());const c=[];for(f=this.c;;){const p=S.cmp(f.segment);if(p>0)f.left||(f.left=new E,f.left.segment=S.value()),c.push([-1,f]),f=f.left;else if(p<0)f.right||(f.right=new E,f.right.segment=S.value()),c.push([1,f]),f=f.right;else if(S.hasNext())S.next(),f.mid||(f.mid=new E,f.mid.segment=S.value()),c.push([0,f]),f=f.mid;else break}const d=f.value;f.value=u,f.key=y;for(let p=c.length-1;p>=0;p--){const w=c[p][1];w.updateHeight();const R=w.balanceFactor();if(R<-1||R>1){const i=c[p][0],o=c[p+1][0];if(i===1&&o===1)c[p][1]=w.rotateLeft();else if(i===-1&&o===-1)c[p][1]=w.rotateRight();else if(i===1&&o===-1)w.right=c[p+1][1]=c[p+1][1].rotateRight(),c[p][1]=w.rotateLeft();else if(i===-1&&o===1)w.left=c[p+1][1]=c[p+1][1].rotateLeft(),c[p][1]=w.rotateRight();else throw new Error;if(p>0)switch(c[p-1][0]){case-1:c[p-1][1].left=c[p][1];break;case 1:c[p-1][1].right=c[p][1];break;case 0:c[p-1][1].mid=c[p][1];break}else this.c=c[0][1]}}return d}get(y){return this.d(y)?.value}d(y){const u=this.b.reset(y);let S=this.c;for(;S;){const f=u.cmp(S.segment);if(f>0)S=S.left;else if(f<0)S=S.right;else if(u.hasNext())u.next(),S=S.mid;else break}return S}has(y){const u=this.d(y);return!(u?.value===void 0&&u?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,u){const S=this.b.reset(y),f=[];let c=this.c;for(;c;){const d=S.cmp(c.segment);if(d>0)f.push([-1,c]),c=c.left;else if(d<0)f.push([1,c]),c=c.right;else if(S.hasNext())S.next(),f.push([0,c]),c=c.mid;else break}if(!!c){if(u?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const d=this.f(c.right);if(d.key){const{key:p,value:w,segment:R}=d;this.e(d.key,!1),c.key=p,c.value=w,c.segment=R}}else{const d=c.left??c.right;if(f.length>0){const[p,w]=f[f.length-1];switch(p){case-1:w.left=d;break;case 0:w.mid=d;break;case 1:w.right=d;break}}else this.c=d}for(let d=f.length-1;d>=0;d--){const p=f[d][1];p.updateHeight();const w=p.balanceFactor();if(w>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),f[d][1]=p.rotateLeft()):w<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),f[d][1]=p.rotateRight()),d>0)switch(f[d-1][0]){case-1:f[d-1][1].left=f[d][1];break;case 1:f[d-1][1].right=f[d][1];break;case 0:f[d-1][1].mid=f[d][1];break}else this.c=f[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const u=this.b.reset(y);let S=this.c,f;for(;S;){const c=u.cmp(S.segment);if(c>0)S=S.left;else if(c<0)S=S.right;else if(u.hasNext())u.next(),f=S.value||f,S=S.mid;else break}return S&&S.value||f}findSuperstr(y){return this.g(y,!1)}g(y,u){const S=this.b.reset(y);let f=this.c;for(;f;){const c=S.cmp(f.segment);if(c>0)f=f.left;else if(c<0)f=f.right;else if(S.hasNext())S.next(),f=f.mid;else return f.mid?this.h(f.mid):u?f.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[u,S]of this)y(S,u)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const u=[];return this.j(y,u),u[Symbol.iterator]()}j(y,u){!y||(y.left&&this.j(y.left,u),y.value&&u.push([y.key,y.value]),y.mid&&this.j(y.mid,u),y.right&&this.j(y.right,u))}_isBalanced(){const y=u=>{if(!u)return!0;const S=u.balanceFactor();return S<-1||S>1?!1:y(u.left)&&y(u.right)};return y(this.c)}}e.TernarySearchTree=b}),define(oe[11],ae([0,1,13,4]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,l=/^\//,O=/^\/\//;function P(t,n){if(!t.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!D.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!l.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(t,n){return!t&&!n?"file":t}function E(t,n){switch(t){case"https":case"http":case"file":n?n[0]!==b&&(n=b+n):n=b;break}return n}const C="",b="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(n){return n instanceof y?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,s,a,r,h,g=!1){typeof n=="object"?(this.scheme=n.scheme||C,this.authority=n.authority||C,this.path=n.path||C,this.query=n.query||C,this.fragment=n.fragment||C):(this.scheme=I(n,g),this.authority=s||C,this.path=E(this.scheme,a||C),this.query=r||C,this.fragment=h||C,P(this,g))}get fsPath(){return p(this,!1)}with(n){if(!n)return this;let{scheme:s,authority:a,path:r,query:h,fragment:g}=n;return s===void 0?s=this.scheme:s===null&&(s=C),a===void 0?a=this.authority:a===null&&(a=C),r===void 0?r=this.path:r===null&&(r=C),h===void 0?h=this.query:h===null&&(h=C),g===void 0?g=this.fragment:g===null&&(g=C),s===this.scheme&&a===this.authority&&r===this.path&&h===this.query&&g===this.fragment?this:new S(s,a,r,h,g)}static parse(n,s=!1){const a=m.exec(n);return a?new S(a[2]||C,o(a[4]||C),o(a[5]||C),o(a[7]||C),o(a[9]||C),s):new S(C,C,C,C,C)}static file(n){let s=C;if(T.isWindows&&(n=n.replace(/\\/g,b)),n[0]===b&&n[1]===b){const a=n.indexOf(b,2);a===-1?(s=n.substring(2),n=b):(s=n.substring(2,a),n=n.substring(a)||b)}return new S("file",s,n,C,C)}static from(n){const s=new S(n.scheme,n.authority,n.path,n.query,n.fragment);return P(s,!0),s}static joinPath(n,...s){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return T.isWindows&&n.scheme==="file"?a=y.file(k.win32.join(p(n,!0),...s)).path:a=k.posix.join(n.path,...s),n.with({path:a})}toString(n=!1){return w(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof y)return n;{const s=new S(n);return s._formatted=n.external,s._fsPath=n._sep===u?n.fsPath:null,s}}else return n}}e.URI=y;const u=T.isWindows?1:void 0;class S extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(n=!1){return n?w(this,!0):(this._formatted||(this._formatted=w(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=u),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function c(t,n,s){let a,r=-1;for(let h=0;h<t.length;h++){const g=t.charCodeAt(h);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||n&&g===47||s&&g===91||s&&g===93||s&&g===58)r!==-1&&(a+=encodeURIComponent(t.substring(r,h)),r=-1),a!==void 0&&(a+=t.charAt(h));else{a===void 0&&(a=t.substr(0,h));const v=f[g];v!==void 0?(r!==-1&&(a+=encodeURIComponent(t.substring(r,h)),r=-1),a+=v):r===-1&&(r=h)}}return r!==-1&&(a+=encodeURIComponent(t.substring(r))),a!==void 0?a:t}function d(t){let n;for(let s=0;s<t.length;s++){const a=t.charCodeAt(s);a===35||a===63?(n===void 0&&(n=t.substr(0,s)),n+=f[a]):n!==void 0&&(n+=t[s])}return n!==void 0?n:t}function p(t,n){let s;return t.authority&&t.path.length>1&&t.scheme==="file"?s=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?n?s=t.path.substr(1):s=t.path[1].toLowerCase()+t.path.substr(2):s=t.path,T.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=p;function w(t,n){const s=n?d:c;let a="",{scheme:r,authority:h,path:g,query:v,fragment:A}=t;if(r&&(a+=r,a+=":"),(h||r==="file")&&(a+=b,a+=b),h){let N=h.indexOf("@");if(N!==-1){const F=h.substr(0,N);h=h.substr(N+1),N=F.lastIndexOf(":"),N===-1?a+=s(F,!1,!1):(a+=s(F.substr(0,N),!1,!1),a+=":",a+=s(F.substr(N+1),!1,!0)),a+="@"}h=h.toLowerCase(),N=h.lastIndexOf(":"),N===-1?a+=s(h,!1,!0):(a+=s(h.substr(0,N),!1,!0),a+=h.substr(N))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const N=g.charCodeAt(1);N>=65&&N<=90&&(g=`/${String.fromCharCode(N+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const N=g.charCodeAt(0);N>=65&&N<=90&&(g=`${String.fromCharCode(N+32)}:${g.substr(2)}`)}a+=s(g,!0,!1)}return v&&(a+="?",a+=s(v,!1,!1)),A&&(a+="#",a+=n?A:c(A,!1,!1)),a}function R(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+R(t.substr(3)):t}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(t){return t.match(i)?t.replace(i,n=>R(n)):t}}),define(oe[144],ae([0,1,11]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function T(E){const C=E;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.isRemoteConsoleLog=T;function D(E){const C=[];let b;try{const m=JSON.parse(E.arguments),y=m[m.length-1];y&&y.__$stack&&(m.pop(),b=y.__$stack),C.push(...m)}catch{C.push("Unable to log remote console arguments",E.arguments)}return{args:C,stack:b}}e.parse=D;function l(E){if(typeof E!="string")return l(D(E).stack);const C=E;if(C){const b=O(C),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(m&&m.length===4)return{uri:k.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=l;function O(E){if(!E)return E;const C=E.indexOf(`
`);return C===-1?E:E.substring(0,C)}function P(E,C){const{args:b,stack:m}=D(E),y=typeof b[0]=="string"&&b.length===1;let u=O(m);u&&(u=`(${u.trim()})`);let S=[];if(typeof b[0]=="string"?u&&y?S=[`%c[${C}] %c${b[0]} %c${u}`,I("blue"),I(""),I("grey")]:S=[`%c[${C}] %c${b[0]}`,I("blue"),I(""),...b.slice(1)]:S=[`%c[${C}]%`,I("blue"),...b],u&&!y&&S.push(u),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,S)}e.log=P;function I(E){return`color: ${E}`}}),define(oe[67],ae([0,1,17,27,11]),function(Q,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function l(E){return JSON.stringify(E,P)}e.stringify=l;function O(E){let C=JSON.parse(E);return C=I(C),C}e.parse=O;function P(E,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,T.regExpFlags)(C)}:C}function I(E,C=0){if(!E||C>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return D.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 16:return new Date(E.source)}if(E instanceof k.VSBuffer||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let b=0;b<E.length;++b)E[b]=I(E[b],C+1);else for(const b in E)Object.hasOwnProperty.call(E,b)&&(E[b]=I(E[b],C+1))}return E}e.revive=I}),define(oe[26],ae([0,1,9,4,11]),function(Q,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var l;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls",E.vscodeSourceControl="vscode-scm"})(l=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class O{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${l.vscodeRemoteResource}`}setPreferredWebSchema(C){this.d=C}setDelegate(C){this.e=C}setServerRootPath(C){this.f=`${C}/${l.vscodeRemoteResource}`}set(C,b,m){this.a[C]=b,this.b[C]=m}setConnectionToken(C,b){this.c[C]=b}getPreferredWebSchema(){return this.d}rewrite(C){if(this.e)try{return this.e(C)}catch(f){return k.onUnexpectedError(f),C}const b=C.authority;let m=this.a[b];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const y=this.b[b],u=this.c[b];let S=`path=${encodeURIComponent(C.path)}`;return typeof u=="string"&&(S+=`&${e.connectionTokenQueryName}=${encodeURIComponent(u)}`),D.URI.from({scheme:T.isWeb?this.d:l.vscodeRemoteResource,authority:`${m}:${y}`,path:this.f,query:S})}}e.RemoteAuthorities=new O,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(C){const b=this.b(C,Q);return this.uriToBrowserUri(b)}uriToBrowserUri(C){return C.scheme===l.vscodeRemote?e.RemoteAuthorities.rewrite(C):C.scheme===l.file&&(T.isNative||T.isWebWorker&&T.globals.origin===`${l.vscodeFileResource}://${P.a}`)?C.with({scheme:l.vscodeFileResource,authority:C.authority||P.a,query:null,fragment:null}):C}asFileUri(C){const b=this.b(C,Q);return this.uriToFileUri(b)}uriToFileUri(C){return C.scheme===l.vscodeFileResource?C.with({scheme:l.file,authority:C.authority!==P.a?C.authority:null,query:null,fragment:null}):C}b(C,b){return D.URI.isUri(C)?C:D.URI.parse(b.toUrl(C))}}P.a="vscode-app",e.FileAccess=new P;var I;(function(E){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);E.CoopAndCoep=Object.freeze(C.get("3"));const b="vscode-coi";function m(u){let S;typeof u=="string"?S=new URL(u).searchParams:u instanceof URL?S=u.searchParams:D.URI.isUri(u)&&(S=new URL(u.toString(!0)).searchParams);const f=S?.get(b);if(!!f)return C.get(f)}E.getHeadersFromQuery=m;function y(u,S,f){if(!globalThis.crossOriginIsolated)return;const c=S&&f?"3":f?"2":"1";u instanceof URLSearchParams?u.set(b,c):u[b]=c}E.addSearchParam=y})(I=e.COI||(e.COI={}))}),define(oe[22],ae([0,1,48,26,13,4,27,11]),function(Q,e,k,T,D,l,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(y){return(0,P.uriToFsPath)(y,!0)}e.originalFSPath=I;class E{constructor(u){this.a=u}compare(u,S,f=!1){return u===S?0:(0,O.compare)(this.getComparisonKey(u,f),this.getComparisonKey(S,f))}isEqual(u,S,f=!1){return u===S?!0:!u||!S?!1:this.getComparisonKey(u,f)===this.getComparisonKey(S,f)}getComparisonKey(u,S=!1){return u.with({path:this.a(u)?u.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(u){return this.a(u)}isEqualOrParent(u,S,f=!1){if(u.scheme===S.scheme){if(u.scheme===T.Schemas.file)return k.isEqualOrParent(I(u),I(S),this.a(u))&&u.query===S.query&&(f||u.fragment===S.fragment);if((0,e.isEqualAuthority)(u.authority,S.authority))return k.isEqualOrParent(u.path,S.path,this.a(u),"/")&&u.query===S.query&&(f||u.fragment===S.fragment)}return!1}joinPath(u,...S){return P.URI.joinPath(u,...S)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return D.posix.basename(u.path)}extname(u){return D.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let S;return u.scheme===T.Schemas.file?S=P.URI.file(D.dirname(I(u))).path:(S=D.posix.dirname(u.path),u.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),S="/")),u.with({path:S})}normalizePath(u){if(!u.path.length)return u;let S;return u.scheme===T.Schemas.file?S=P.URI.file(D.normalize(I(u))).path:S=D.posix.normalize(u.path),u.with({path:S})}relativePath(u,S){if(u.scheme!==S.scheme||!(0,e.isEqualAuthority)(u.authority,S.authority))return;if(u.scheme===T.Schemas.file){const d=D.relative(I(u),I(S));return l.isWindows?k.toSlashes(d):d}let f=u.path||"/";const c=S.path||"/";if(this.a(u)){let d=0;for(const p=Math.min(f.length,c.length);d<p&&!(f.charCodeAt(d)!==c.charCodeAt(d)&&f.charAt(d).toLowerCase()!==c.charAt(d).toLowerCase());d++);f=c.substr(0,d)+f.substr(d)}return D.posix.relative(f,c)}resolvePath(u,S){if(u.scheme===T.Schemas.file){const f=P.URI.file(D.resolve(I(u),S));return u.with({authority:f.authority,path:f.path})}return S=k.toPosixPath(S),u.with({path:D.posix.resolve(u.path,S)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,S){return u===S||u!==void 0&&S!==void 0&&(0,O.equalsIgnoreCase)(u,S)}hasTrailingPathSeparator(u,S=D.sep){if(u.scheme===T.Schemas.file){const f=I(u);return f.length>k.getRoot(f).length&&f[f.length-1]===S}else{const f=u.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,S=D.sep){return(0,e.hasTrailingPathSeparator)(u,S)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,S=D.sep){let f=!1;if(u.scheme===T.Schemas.file){const c=I(u);f=c!==void 0&&c.length===k.getRoot(c).length&&c[c.length-1]===S}else{S="/";const c=u.path;f=c.length===1&&c.charCodeAt(c.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(u,S)?u.with({path:u.path+"/"}):u}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(y=>y.scheme===T.Schemas.file?!l.isLinux:!0),e.extUriIgnorePathCase=new E(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function C(y,u){const S=[];for(let f=0;f<y.length;f++){const c=u(y[f]);y.some((d,p)=>p===f?!1:(0,e.isEqualOrParent)(c,u(d)))||S.push(y[f])}return S}e.distinctParents=C;var b;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function u(S){const f=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(p=>{const[w,R]=p.split(":");w&&R&&f.set(w,R)});const d=S.path.substring(0,S.path.indexOf(";"));return d&&f.set(y.META_DATA_MIME,d),f}y.parseMetaData=u})(b=e.DataUri||(e.DataUri={}));function m(y,u,S){if(u){let f=y.path;return f&&f[0]!==D.posix.sep&&(f=D.posix.sep+f),y.with({scheme:S,authority:u,path:f})}return y.with({scheme:S})}e.toLocalResource=m}),define(oe[6],ae([0,1,25,9,3,2,22,4]),function(Q,e,k,T,D,l,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(te){return!!te&&typeof te.then=="function"}e.isThenable=I;function E(te){const U=new k.CancellationTokenSource,B=te(U.token),W=new Promise((q,Y)=>{const ee=U.token.onCancellationRequested(()=>{ee.dispose(),U.dispose(),Y(new T.CancellationError)});Promise.resolve(B).then(K=>{ee.dispose(),U.dispose(),q(K)},K=>{ee.dispose(),U.dispose(),Y(K)})});return new class{cancel(){U.cancel()}then(q,Y){return W.then(q,Y)}catch(q){return this.then(void 0,q)}finally(q){return W.finally(q)}}}e.createCancelablePromise=E;function C(te,U,B){return new Promise((W,q)=>{const Y=U.onCancellationRequested(()=>{Y.dispose(),W(B)});te.then(W,q).finally(()=>Y.dispose())})}e.raceCancellation=C;function b(te,U){return new Promise((B,W)=>{const q=U.onCancellationRequested(()=>{q.dispose(),W(new T.CancellationError)});te.then(B,W).finally(()=>q.dispose())})}e.raceCancellationError=b;async function m(te){let U=-1;const B=te.map((q,Y)=>q.then(ee=>(U=Y,ee))),W=await Promise.race(B);return te.forEach((q,Y)=>{Y!==U&&q.cancel()}),W}e.raceCancellablePromises=m;function y(te,U,B){let W;const q=setTimeout(()=>{W?.(void 0),B?.()},U);return Promise.race([te.finally(()=>clearTimeout(q)),new Promise(Y=>W=Y)])}e.raceTimeout=y;function u(te){return new Promise((U,B)=>{const W=te();I(W)?W.then(U,B):U(W)})}e.asPromise=u;class S{constructor(){this.a=null,this.b=null,this.d=null}queue(U){if(this.a){if(this.d=U,!this.b){const B=()=>{this.b=null;const W=this.queue(this.d);return this.d=null,W};this.b=new Promise(W=>{this.a.then(B,B).then(W)})}return new Promise((B,W)=>{this.b.then(B,W)})}return this.a=U(),new Promise((B,W)=>{this.a.then(q=>{this.a=null,B(q)},q=>{this.a=null,W(q)})})}}e.Throttler=S;class f{constructor(){this.a=Promise.resolve(null)}queue(U){return this.a=this.a.then(()=>U(),()=>U())}}e.Sequencer=f;class c{constructor(){this.a=new Map}queue(U,B){const q=(this.a.get(U)??Promise.resolve()).catch(()=>{}).then(B).finally(()=>{this.a.get(U)===q&&this.a.delete(U)});return this.a.set(U,q),q}}e.SequencerByKey=c;const d=(te,U)=>{let B=!0;const W=setTimeout(()=>{B=!1,U()},te);return{isTriggered:()=>B,dispose:()=>{clearTimeout(W),B=!1}}},p=te=>{let U=!0;return queueMicrotask(()=>{U&&(U=!1,te())}),{isTriggered:()=>U,dispose:()=>{U=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class w{constructor(U){this.defaultDelay=U,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(U,B=this.defaultDelay){this.g=U,this.h(),this.b||(this.b=new Promise((q,Y)=>{this.d=q,this.f=Y}).then(()=>{if(this.b=null,this.d=null,this.g){const q=this.g;return this.g=null,q()}}));const W=()=>{this.a=null,this.d?.(null)};return this.a=B===e.MicrotaskDelay?p(W):d(B,W),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=w;class R{constructor(U){this.a=new w(U),this.b=new S}trigger(U,B){return this.a.trigger(()=>this.b.queue(U),B)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=R;class i{constructor(){this.a=!1,this.b=new Promise((U,B)=>{this.d=U})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=i;class o extends i{constructor(U){super(),this.f=setTimeout(()=>this.open(),U)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=o;function t(te,U){return U?new Promise((B,W)=>{const q=setTimeout(()=>{Y.dispose(),B()},te),Y=U.onCancellationRequested(()=>{clearTimeout(q),Y.dispose(),W(new T.CancellationError)})}):E(B=>t(te,B))}e.timeout=t;function n(te,U=0){const B=setTimeout(te,U);return(0,l.toDisposable)(()=>clearTimeout(B))}e.disposableTimeout=n;function s(te){const U=[];let B=0;const W=te.length;function q(){return B<W?te[B++]():null}function Y(ee){ee!=null&&U.push(ee);const K=q();return K?K.then(Y):Promise.resolve(U)}return Promise.resolve(null).then(Y)}e.sequence=s;function a(te,U=W=>!!W,B=null){let W=0;const q=te.length,Y=()=>{if(W>=q)return Promise.resolve(B);const ee=te[W++];return Promise.resolve(ee()).then(Z=>U(Z)?Promise.resolve(Z):Y())};return Y()}e.first=a;function r(te,U=W=>!!W,B=null){if(te.length===0)return Promise.resolve(B);let W=te.length;const q=()=>{W=-1;for(const Y of te)Y.cancel?.()};return new Promise((Y,ee)=>{for(const K of te)K.then(Z=>{--W>=0&&U(Z)?(q(),Y(Z)):W===0&&Y(B)}).catch(Z=>{--W>=0&&(q(),ee(Z))})})}e.firstParallel=r;class h{constructor(U){this.a=0,this.d=U,this.f=[],this.b=0,this.g=new D.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(U){return this.a++,new Promise((B,W)=>{this.f.push({factory:U,c:B,e:W}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const U=this.f.shift();this.b++;const B=U.factory();B.then(U.c,U.e),B.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=h;class g extends h{constructor(){super(1)}}e.Queue=g;class v{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const U=new H;return this.b.add(U),U.p}d(){for(const[,U]of this.a)if(U.size>0)return!1;return!0}queueFor(U,B=O.extUri){const W=B.getComparisonKey(U);let q=this.a.get(W);return q||(q=new g,D.Event.once(q.onDrained)(()=>{q?.dispose(),this.a.delete(W),this.f()}),this.a.set(W,q)),q}f(){!this.d()||this.g()}g(){for(const U of this.b)U.complete();this.b.clear()}dispose(){for(const[,U]of this.a)U.dispose();this.a.clear(),this.g()}}e.ResourceQueue=v;class A{constructor(U,B){this.a=-1,typeof U=="function"&&typeof B=="number"&&this.setIfNotSet(U,B)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(U,B){this.cancel(),this.a=setTimeout(()=>{this.a=-1,U()},B)}setIfNotSet(U,B){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,U()},B))}}e.TimeoutTimer=A;class N{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(U,B){this.cancel(),this.a=setInterval(()=>{U()},B)}}e.IntervalTimer=N;class F{constructor(U,B){this.b=-1,this.a=U,this.d=B,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(U=this.d){this.cancel(),this.b=setTimeout(this.f,U)}get delay(){return this.d}set delay(U){this.d=U}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=F;class M{constructor(U,B){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.a=U,this.b=B,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(U=this.b){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(U/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=M;class L extends F{constructor(U,B){super(U,B),this.j=[]}work(U){this.j.push(U),this.isScheduled()||this.schedule()}h(){const U=this.j;this.j=[],this.a?.(U)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=L;class $ extends l.Disposable{constructor(U,B){super(),this.g=U,this.h=B,this.a=[],this.b=this.B(new l.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(U){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+U.length>this.g.maxBufferedWork)return!1}else if(this.pending+U.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const B of U)this.a.push(B);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new F(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=te=>{(0,P.setTimeout0)(()=>{if(U)return;const B=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,B-Date.now())}}))});let U=!1;return{dispose(){U||(U=!0)}}}:e.runWhenIdle=(te,U)=>{const B=requestIdleCallback(te,typeof U=="number"?{timeout:U}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(B))}}}}();class z{constructor(U){this.d=!1,this.a=()=>{try{this.f=U()}catch(B){this.g=B}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=z;async function x(te,U,B){let W;for(let q=0;q<B;q++)try{return await te()}catch(Y){W=Y,await t(U)}throw W}e.retry=x;class X{hasPending(U){return this.a?typeof U=="number"?this.a.taskId===U:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(U,B,W){return this.a={taskId:U,cancel:()=>W?.(),promise:B},B.then(()=>this.d(U),()=>this.d(U)),B}d(U){this.a&&U===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const U=this.b;this.b=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this.b)this.b.run=U;else{let B,W;const q=new Promise((Y,ee)=>{B=Y,W=ee});this.b={run:U,promise:q,promiseResolve:B,promiseReject:W}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=X;class ie{constructor(U,B=()=>Date.now()){this.d=U,this.f=B,this.a=0,this.b=0}increment(){const U=this.f();return U-this.a>this.d&&(this.a=U,this.b=0),this.b++,this.b}}e.IntervalCounter=ie;class H{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((U,B)=>{this.a=U,this.b=B})}complete(U){return new Promise(B=>{this.a(U),this.f=!0,B()})}error(U){return new Promise(B=>{this.b(U),this.d=!0,B()})}cancel(){new Promise(U=>{this.b(new T.CancellationError),this.d=!0,U()})}}e.DeferredPromise=H;var j;(function(te){async function U(W){let q;const Y=await Promise.all(W.map(ee=>ee.then(K=>K,K=>{q||(q=K)})));if(typeof q<"u")throw q;return Y}te.settled=U;function B(W){return new Promise(async(q,Y)=>{try{await W(q,Y)}catch(ee){Y(ee)}})}te.withAsyncBody=B})(j=e.Promises||(e.Promises={}));var V;(function(te){te[te.Initial=0]="Initial",te[te.DoneOK=1]="DoneOK",te[te.DoneError=2]="DoneError"})(V||(V={}));class J{static fromArray(U){return new J(B=>{B.emitMany(U)})}static fromPromise(U){return new J(async B=>{B.emitMany(await U)})}static fromPromises(U){return new J(async B=>{await Promise.all(U.map(async W=>B.emitOne(await W)))})}static merge(U){return new J(async B=>{await Promise.all(U.map(async W=>{for await(const q of W)B.emitOne(q)}))})}constructor(U){this.a=0,this.b=[],this.d=null,this.f=new D.Emitter,queueMicrotask(async()=>{const B={emitOne:W=>this.g(W),emitMany:W=>this.h(W),reject:W=>this.k(W)};try{await Promise.resolve(U(B)),this.j()}catch(W){this.k(W)}finally{B.emitOne=void 0,B.emitMany=void 0,B.reject=void 0}})}[Symbol.asyncIterator](){let U=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(U<this.b.length)return{done:!1,value:this.b[U++]};if(this.a===1)return{done:!0,value:void 0};await D.Event.toPromise(this.f.event)}while(!0)}}}static map(U,B){return new J(async W=>{for await(const q of U)W.emitOne(B(q))})}map(U){return J.map(this,U)}static filter(U,B){return new J(async W=>{for await(const q of U)B(q)&&W.emitOne(q)})}filter(U){return J.filter(this,U)}static coalesce(U){return J.filter(U,B=>!!B)}coalesce(){return J.coalesce(this)}static async toPromise(U){const B=[];for await(const W of U)B.push(W);return B}toPromise(){return J.toPromise(this)}g(U){this.a===0&&(this.b.push(U),this.f.fire())}h(U){this.a===0&&(this.b=this.b.concat(U),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(U){this.a===0&&(this.a=2,this.d=U,this.f.fire())}}e.AsyncIterableObject=J,J.EMPTY=J.fromArray([]);class _ extends J{constructor(U,B){super(B),this.l=U}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=_;function re(te){const U=new k.CancellationTokenSource,B=te(U.token);return new _(U,async W=>{const q=U.token.onCancellationRequested(()=>{q.dispose(),U.dispose(),W.reject(new T.CancellationError)});try{for await(const Y of B){if(U.token.isCancellationRequested)return;W.emitOne(Y)}q.dispose(),U.dispose()}catch(Y){q.dispose(),U.dispose(),W.reject(Y)}})}e.createCancelableAsyncIterable=re}),define(oe[90],ae([0,1,21,6,48,37,13,4,27]),function(Q,e,k,T,D,l,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function E(){return Object.create(null)}e.getEmptyExpression=E,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const C="[/\\\\]",b="[^/\\\\]",m=/\//g;function y(H,j){switch(H){case 0:return"";case 1:return`${b}*?`;default:return`(?:${C}|${b}+${C}${j?`|${C}${b}+`:""})*?`}}function u(H,j){if(!H)return[];const V=[];let J=!1,_=!1,re="";for(const te of H){switch(te){case j:if(!J&&!_){V.push(re),re="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":_=!0;break;case"]":_=!1;break}re+=te}return re&&V.push(re),V}e.splitGlobAware=u;function S(H){if(!H)return"";let j="";const V=u(H,e.GLOB_SPLIT);if(V.every(J=>J===e.GLOBSTAR))j=".*";else{let J=!1;V.forEach((_,re)=>{if(_===e.GLOBSTAR){if(J)return;j+=y(2,re===V.length-1)}else{let te=!1,U="",B=!1,W="";for(const q of _){if(q!=="}"&&te){U+=q;continue}if(B&&(q!=="]"||!W)){let Y;q==="-"?Y=q:(q==="^"||q==="!")&&!W?Y="^":q===e.GLOB_SPLIT?Y="":Y=(0,I.escapeRegExpCharacters)(q),W+=Y;continue}switch(q){case"{":te=!0;continue;case"[":B=!0;continue;case"}":{j+=`(?:${u(U,",").map(K=>S(K)).join("|")})`,te=!1,U="";break}case"]":{j+="["+W+"]",B=!1,W="";break}case"?":j+=b;continue;case"*":j+=y(1);continue;default:j+=(0,I.escapeRegExpCharacters)(q)}}re<V.length-1&&(V[re+1]!==e.GLOBSTAR||re+2<V.length)&&(j+=C)}J=_===e.GLOBSTAR})}return j}const f=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,p=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,R=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new l.LRUCache(1e4),o=function(){return!1},t=function(){return null};function n(H,j){if(!H)return t;let V;typeof H!="string"?V=H.pattern:V=H,V=V.trim();const J=`${V}_${!!j.trimForExclusions}`;let _=i.get(J);if(_)return s(_,H);let re;return f.test(V)?_=r(V.substr(4),V):(re=c.exec(a(V,j)))?_=h(re[1],V):(j.trimForExclusions?p:d).test(V)?_=g(V,j):(re=w.exec(a(V,j)))?_=v(re[1].substr(1),V,!0):(re=R.exec(a(V,j)))?_=v(re[1],V,!1):_=A(V),i.set(J,_),s(_,H)}function s(H,j){if(typeof j=="string")return H;const V=function(J,_){return(0,D.isEqualOrParent)(J,j.base,!P.isLinux)?H((0,I.ltrim)(J.substr(j.base.length),O.sep),_):null};return V.allBasenames=H.allBasenames,V.allPaths=H.allPaths,V.basenames=H.basenames,V.patterns=H.patterns,V}function a(H,j){return j.trimForExclusions&&H.endsWith("/**")?H.substr(0,H.length-2):H}function r(H,j){return function(V,J){return typeof V=="string"&&V.endsWith(H)?j:null}}function h(H,j){const V=`/${H}`,J=`\\${H}`,_=function(te,U){return typeof te!="string"?null:U?U===H?j:null:te===H||te.endsWith(V)||te.endsWith(J)?j:null},re=[H];return _.basenames=re,_.patterns=[j],_.allBasenames=re,_}function g(H,j){const V=X(H.slice(1,-1).split(",").map(U=>n(U,j)).filter(U=>U!==t),H),J=V.length;if(!J)return t;if(J===1)return V[0];const _=function(U,B){for(let W=0,q=V.length;W<q;W++)if(V[W](U,B))return H;return null},re=V.find(U=>!!U.allBasenames);re&&(_.allBasenames=re.allBasenames);const te=V.reduce((U,B)=>B.allPaths?U.concat(B.allPaths):U,[]);return te.length&&(_.allPaths=te),_}function v(H,j,V){const J=O.sep===O.posix.sep,_=J?H:H.replace(m,O.sep),re=O.sep+_,te=O.posix.sep+H;let U;return V?U=function(B,W){return typeof B=="string"&&(B===_||B.endsWith(re)||!J&&(B===H||B.endsWith(te)))?j:null}:U=function(B,W){return typeof B=="string"&&(B===_||!J&&B===H)?j:null},U.allPaths=[(V?"*/":"./")+H],U}function A(H){try{const j=new RegExp(`^${S(H)}$`);return function(V){return j.lastIndex=0,typeof V=="string"&&j.test(V)?H:null}}catch{return t}}function N(H,j,V){return!H||typeof j!="string"?!1:F(H)(j,void 0,V)}e.match=N;function F(H,j={}){if(!H)return o;if(typeof H=="string"||M(H)){const V=n(H,j);if(V===t)return o;const J=function(_,re){return!!V(_,re)};return V.allBasenames&&(J.allBasenames=V.allBasenames),V.allPaths&&(J.allPaths=V.allPaths),J}return z(H,j)}e.parse=F;function M(H){const j=H;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}e.isRelativePattern=M;function L(H){return H.allBasenames||[]}e.getBasenameTerms=L;function $(H){return H.allPaths||[]}e.getPathTerms=$;function z(H,j){const V=X(Object.getOwnPropertyNames(H).map(U=>x(U,H[U],j)).filter(U=>U!==t)),J=V.length;if(!J)return t;if(!V.some(U=>!!U.requiresSiblings)){if(J===1)return V[0];const U=function(q,Y){let ee;for(let K=0,Z=V.length;K<Z;K++){const se=V[K](q,Y);if(typeof se=="string")return se;(0,T.isThenable)(se)&&(ee||(ee=[]),ee.push(se))}return ee?(async()=>{for(const K of ee){const Z=await K;if(typeof Z=="string")return Z}return null})():null},B=V.find(q=>!!q.allBasenames);B&&(U.allBasenames=B.allBasenames);const W=V.reduce((q,Y)=>Y.allPaths?q.concat(Y.allPaths):q,[]);return W.length&&(U.allPaths=W),U}const _=function(U,B,W){let q,Y;for(let ee=0,K=V.length;ee<K;ee++){const Z=V[ee];Z.requiresSiblings&&W&&(B||(B=(0,O.basename)(U)),q||(q=B.substr(0,B.length-(0,O.extname)(U).length)));const se=Z(U,B,q,W);if(typeof se=="string")return se;(0,T.isThenable)(se)&&(Y||(Y=[]),Y.push(se))}return Y?(async()=>{for(const ee of Y){const K=await ee;if(typeof K=="string")return K}return null})():null},re=V.find(U=>!!U.allBasenames);re&&(_.allBasenames=re.allBasenames);const te=V.reduce((U,B)=>B.allPaths?U.concat(B.allPaths):U,[]);return te.length&&(_.allPaths=te),_}function x(H,j,V){if(j===!1)return t;const J=n(H,V);if(J===t)return t;if(typeof j=="boolean")return J;if(j){const _=j.when;if(typeof _=="string"){const re=(te,U,B,W)=>{if(!W||!J(te,U))return null;const q=_.replace("$(basename)",()=>B),Y=W(q);return(0,T.isThenable)(Y)?Y.then(ee=>ee?H:null):Y?H:null};return re.requiresSiblings=!0,re}}return J}function X(H,j){const V=H.filter(U=>!!U.basenames);if(V.length<2)return H;const J=V.reduce((U,B)=>{const W=B.basenames;return W?U.concat(W):U},[]);let _;if(j){_=[];for(let U=0,B=J.length;U<B;U++)_.push(j)}else _=V.reduce((U,B)=>{const W=B.patterns;return W?U.concat(W):U},[]);const re=function(U,B){if(typeof U!="string")return null;if(!B){let q;for(q=U.length;q>0;q--){const Y=U.charCodeAt(q-1);if(Y===47||Y===92)break}B=U.substr(q)}const W=J.indexOf(B);return W!==-1?_[W]:null};re.basenames=J,re.patterns=_,re.allBasenames=J;const te=H.filter(U=>!U.basenames);return te.push(re),te}function ie(H,j){return(0,k.equals)(H,j,(V,J)=>typeof V=="string"&&typeof J=="string"?V===J:typeof V!="string"&&typeof J!="string"?V.base===J.base&&V.pattern===J.pattern:!1)}e.patternsEquals=ie}),define(oe[145],ae([0,1,17,11]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(b){return b.toJSON()}class l{constructor(m){this.a=m}transformIncoming(m){const y=this.a.transformIncoming(m);return y===m?m:D(T.URI.from(y))}transformOutgoing(m){const y=this.a.transformOutgoing(m);return y===m?m:D(T.URI.from(y))}transformOutgoingURI(m){const y=this.a.transformOutgoing(m);return y===m?m:T.URI.from(y)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.URITransformer=l,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function O(b,m,y){if(!b||y>200)return null;if(typeof b=="object"){if(b instanceof T.URI)return m.transformOutgoing(b);for(const u in b)if(Object.hasOwnProperty.call(b,u)){const S=O(b[u],m,y+1);S!==null&&(b[u]=S)}}return null}function P(b,m){const y=O(b,m,0);return y===null?b:y}e.transformOutgoingURIs=P;function I(b,m,y,u){if(!b||u>200)return null;if(typeof b=="object"){if(b.$mid===1)return y?T.URI.revive(m.transformIncoming(b)):m.transformIncoming(b);if(b instanceof k.VSBuffer)return null;for(const S in b)if(Object.hasOwnProperty.call(b,S)){const f=I(b[S],m,y,u+1);f!==null&&(b[S]=f)}}return null}function E(b,m){const y=I(b,m,!1,0);return y===null?b:y}e.transformIncomingURIs=E;function C(b,m){const y=I(b,m,!0,0);return y===null?b:y}e.transformAndReviveIncomingURIs=C}),define(oe[146],ae([0,1,34,9,49,31,133]),function(Q,e,k,T,D,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(C){return this.a||(this.a=D.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(C)}value(){if(this.b===void 0){let C=0,b=0;const m=(0,k.networkInterfaces)();for(const y in m){const u=m[y];if(u)for(const{mac:S,internal:f}of u)f||(b+=1,this.c(S.toUpperCase())&&(C+=1))}this.b=b>0?C/b:0}return this.b}};let P;async function I(){return P||(P=(async()=>await E()||l.generateUuid())()),P}e.getMachineId=I;async function E(){try{const C=await new Promise((m,y)=>{Q(["crypto"],m,y)}),b=(0,O.getMac)();return C.createHash("sha256").update(b,"utf8").digest("hex")}catch(C){T.onUnexpectedError(C);return}}}),define(oe[28],ae([0,1,53,34,290,6,48,85,13,4,22,11]),function(Q,e,k,T,D,l,O,P,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function y(z,x=m.UNLINK){if((0,O.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");return x===m.UNLINK?S(z):u(z)}async function u(z){try{const x=(0,O.randomPath)((0,T.tmpdir)());try{await k.promises.rename(z,x)}catch(X){return X.code==="ENOENT"?void 0:S(z)}S(x).catch(X=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function S(z){return(0,D.promisify)(k.rm)(z,{recursive:!0,force:!0,maxRetries:3})}function f(z){if((0,O.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync(z,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function c(z,x){return w(await(x?d(z):(0,D.promisify)(k.readdir)(z)))}async function d(z){try{return await(0,D.promisify)(k.readdir)(z,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const x=[],X=await c(z);for(const ie of X){let H=!1,j=!1,V=!1;try{const J=await e.Promises.lstat((0,I.join)(z,ie));H=J.isFile(),j=J.isDirectory(),V=J.isSymbolicLink()}catch(J){console.warn("[node.js fs] unexpected error from lstat after readdir: ",J)}x.push({name:ie,isFile:()=>H,isDirectory:()=>j,isSymbolicLink:()=>V})}return x}function p(z){return w(k.readdirSync(z))}e.readdirSync=p;function w(z){return z.map(x=>typeof x=="string"?E.isMacintosh?(0,P.normalizeNFC)(x):x:(x.name=E.isMacintosh?(0,P.normalizeNFC)(x.name):x.name,x))}async function R(z){const x=await c(z),X=[];for(const ie of x)await o.existsDirectory((0,I.join)(z,ie))&&X.push(ie);return X}function i(z,x=1e3){return new Promise(X=>{let ie=!1;const H=setInterval(()=>{ie||(ie=!0,k.access(z,j=>{ie=!1,j&&(clearInterval(H),X(void 0))}))},x)})}e.whenDeleted=i;var o;(function(z){async function x(H){let j;try{if(j=await e.Promises.lstat(H),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(E.isWindows&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(J){if(J.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw J}throw V}}z.stat=x;async function X(H){try{const{stat:j,symbolicLink:V}=await z.stat(H);return j.isFile()&&V?.dangling!==!0}catch{}return!1}z.existsFile=X;async function ie(H){try{const{stat:j,symbolicLink:V}=await z.stat(H);return j.isDirectory()&&V?.dangling!==!0}catch{}return!1}z.existsDirectory=ie})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new l.ResourceQueue;function n(z,x,X){return t.queueFor(b.URI.file(z),C.extUriBiasedIgnorePathCase).queue(()=>{const ie=g(X);return new Promise((H,j)=>r(z,x,ie,V=>V?j(V):H()))})}let s=!0;function a(z){s=z}e.configureFlushOnWrite=a;function r(z,x,X,ie){if(!s)return k.writeFile(z,x,{mode:X.mode,flag:X.flag},ie);k.open(z,X.flag,X.mode,(H,j)=>{if(H)return ie(H);k.writeFile(j,x,V=>{if(V)return k.close(j,()=>ie(V));k.fdatasync(j,J=>(J&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",J),a(!1)),k.close(j,_=>ie(_))))})})}function h(z,x,X){const ie=g(X);if(!s)return k.writeFileSync(z,x,{mode:ie.mode,flag:ie.flag});const H=k.openSync(z,ie.flag,ie.mode);try{k.writeFileSync(H,x);try{k.fdatasyncSync(H)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),a(!1)}}finally{k.closeSync(H)}}e.writeFileSync=h;function g(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function v(z,x){if(z!==x)try{await e.Promises.rename(z,x)}catch(X){if(z.toLowerCase()!==x.toLowerCase()&&X.code==="EXDEV"||z.endsWith("."))await A(z,x,{preserveSymlinks:!1}),await y(z,m.MOVE);else throw X}}async function A(z,x,X){return F(z,x,{root:{source:z,target:x},options:X,handledSourcePaths:new Set})}const N=511;async function F(z,x,X){if(X.handledSourcePaths.has(z))return;X.handledSourcePaths.add(z);const{stat:ie,symbolicLink:H}=await o.stat(z);if(H){if(X.options.preserveSymlinks)try{return await $(z,x,X)}catch(j){console.warn("[node.js fs] copy of symlink failed: ",j)}if(H.dangling)return}return ie.isDirectory()?M(z,x,ie.mode&N,X):L(z,x,ie.mode&N)}async function M(z,x,X,ie){await e.Promises.mkdir(x,{recursive:!0,mode:X});const H=await c(z);for(const j of H)await F((0,I.join)(z,j),(0,I.join)(x,j),ie)}async function L(z,x,X){await e.Promises.copyFile(z,x),await e.Promises.chmod(x,X)}async function $(z,x,X){let ie=await e.Promises.readlink(z);(0,O.isEqualOrParent)(ie,X.root.source,!E.isLinux)&&(ie=(0,I.join)(X.root.target,ie.substr(X.root.source.length+1))),await e.Promises.symlink(ie,x)}e.Promises=new class{get access(){return(0,D.promisify)(k.access)}get stat(){return(0,D.promisify)(k.stat)}get lstat(){return(0,D.promisify)(k.lstat)}get utimes(){return(0,D.promisify)(k.utimes)}get read(){return(z,x,X,ie,H)=>new Promise((j,V)=>{k.read(z,x,X,ie,H,(J,_,re)=>J?V(J):j({bytesRead:_,buffer:re}))})}get readFile(){return(0,D.promisify)(k.readFile)}get write(){return(z,x,X,ie,H)=>new Promise((j,V)=>{k.write(z,x,X,ie,H,(J,_,re)=>J?V(J):j({bytesWritten:_,buffer:re}))})}get appendFile(){return(0,D.promisify)(k.appendFile)}get fdatasync(){return(0,D.promisify)(k.fdatasync)}get truncate(){return(0,D.promisify)(k.truncate)}get rename(){return(0,D.promisify)(k.rename)}get copyFile(){return(0,D.promisify)(k.copyFile)}get open(){return(0,D.promisify)(k.open)}get close(){return(0,D.promisify)(k.close)}get symlink(){return(0,D.promisify)(k.symlink)}get readlink(){return(0,D.promisify)(k.readlink)}get chmod(){return(0,D.promisify)(k.chmod)}get mkdir(){return(0,D.promisify)(k.mkdir)}get unlink(){return(0,D.promisify)(k.unlink)}get rmdir(){return(0,D.promisify)(k.rmdir)}get realpath(){return(0,D.promisify)(k.realpath)}async exists(z){try{return await e.Promises.access(z),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return R}get writeFile(){return n}get rm(){return y}get move(){return v}get copy(){return A}}}),define(oe[147],ae([0,1,53,13,4,27,28]),function(Q,e,k,T,D,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(m){if(D.isLinux)return m;const y=(0,T.dirname)(m);if(m===y)return m;const u=((0,T.basename)(m)||m).toLowerCase();try{const f=(0,O.readdirSync)(y).filter(c=>c.toLowerCase()===u);if(f.length===1){const c=P(y);if(c)return(0,T.join)(c,f[0])}else if(f.length>1){const c=f.indexOf(u);if(c>=0){const d=P(y);if(d)return(0,T.join)(d,f[c])}}}catch{}return null}e.realcaseSync=P;async function I(m){if(D.isLinux)return m;const y=(0,T.dirname)(m);if(m===y)return m;const u=((0,T.basename)(m)||m).toLowerCase();try{const f=(await O.Promises.readdir(y)).filter(c=>c.toLowerCase()===u);if(f.length===1){const c=await I(y);if(c)return(0,T.join)(c,f[0])}else if(f.length>1){const c=f.indexOf(u);if(c>=0){const d=await I(y);if(d)return(0,T.join)(d,f[c])}}}catch{}return null}e.realcase=I;async function E(m){try{return await O.Promises.realpath(m)}catch{const u=b(m);return await O.Promises.access(u,k.constants.R_OK),u}}e.realpath=E;function C(m){try{return k.realpathSync(m)}catch{const u=b(m);return k.accessSync(u,k.constants.R_OK),u}}e.realpathSync=C;function b(m){return(0,l.rtrim)((0,T.normalize)(m),T.sep)}}),define(oe[91],ae([0,1,34,13,28]),function(Q,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const l=/^\d+$/,O=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var I;(function(w){w[w.x64=0]="x64",w[w.x86=1]="x86",w[w.ARM=2]="ARM"})(I||(I={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class b{constructor(R,i,o){this.exePath=R,this.displayName=i,this.a=o}async exists(){return this.a===void 0&&(this.a=await D.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:w=!1}={}){return w?E===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:w=!1,findPreview:R=!1}={}){const i=m({useAlternateBitness:w});if(!i)return null;const o=T.join(i,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(o))return null;let t=-1,n=null;for(const r of await D.Promises.readdir(o)){let h=-1;if(R){const v=r.indexOf("-");if(v<0)continue;const A=r.substring(0,v);if(!l.test(A)||r.substring(v+1)!=="preview")continue;h=parseInt(A,10)}else{if(!l.test(r))continue;h=parseInt(r,10)}if(h<=t)continue;const g=T.join(o,r,"pwsh.exe");!await D.SymlinkSupport.existsFile(g)||(n=g,t=h)}if(!n)return null;const s=i.includes("x86")?" (x86)":"",a=R?" Preview":"";return new b(n,`PowerShell${a}${s}`,!0)}async function u({findPreview:w}={}){if(!process.env.LOCALAPPDATA)return null;const R=T.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(R))return null;const{pwshMsixDirRegex:i,pwshMsixName:o}=w?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const t of await D.Promises.readdir(R))if(i.test(t)){const n=T.join(R,t,"pwsh.exe");return new b(n,o)}return null}function S(){const w=T.join(k.homedir(),".dotnet","tools","pwsh.exe");return new b(w,".NET Core PowerShell Global Tool")}function f(){const w=T.join(process.env.windir,E===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(w,"Windows PowerShell",!0)}async function*c(){let w=await y();w&&(yield w),w=await y({useAlternateBitness:!0}),w&&(yield w),w=await u(),w&&(yield w),w=S(),w&&(yield w),w=await y({findPreview:!0}),w&&(yield w),w=await u({findPreview:!0}),w&&(yield w),w=await y({useAlternateBitness:!0,findPreview:!0}),w&&(yield w),w=f(),w&&(yield w)}async function*d(){for await(const w of c())await w.exists()&&(yield w)}e.enumeratePowerShellInstallations=d;async function p(){for await(const w of d())return w;return null}e.getFirstAvailablePowerShellInstallation=p}),define(oe[92],ae([0,1,13,4,36,87,12,28]),function(Q,e,k,T,D,l,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return l.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return l.TerminateResponseCode}});function I(b=D.env){return b.comspec||"cmd.exe"}e.getWindowsShell=I;function E(b){let m=[],y=!1;const u=function(S){if(y){m.push(S);return}(!b.send(S,c=>{if(c&&console.error(c),y=!1,m.length>0){const d=m.slice(0);m=[],d.forEach(p=>u(p))}})||T.isWindows)&&(y=!0)};return{send:u}}e.createQueuedSender=E;var C;(function(b){async function m(y,u,S){if(k.isAbsolute(y))return y;if(u===void 0&&(u=D.cwd()),k.dirname(y)!=="."||(S===void 0&&O.isString(D.env.PATH)&&(S=D.env.PATH.split(k.delimiter)),S===void 0||S.length===0))return k.join(u,y);async function c(d){if(await P.Promises.exists(d)){let p;try{p=await P.Promises.stat(d)}catch(w){w.message.startsWith("EACCES")&&(p=await P.Promises.lstat(d))}return p?!p.isDirectory():!1}return!1}for(const d of S){let p;if(k.isAbsolute(d)?p=k.join(d,y):p=k.join(u,d,y),await c(p))return p;let w=p+".com";if(await c(w)||(w=p+".exe",await c(w)))return w}return k.join(u,y)}b.findExecutable=m})(C=e.win32||(e.win32={}))}),define(oe[148],ae([0,1,50,26]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(O){return new Promise((P,I)=>{let E;const C=new Map;function b(y,u,S,f,c){const d=C.get(u);if(y===O||d){const p={name:m(S),cmd:S,pid:y,ppid:u,load:f,mem:c};C.set(y,p),y===O&&(E=p),d&&(d.children||(d.children=[]),d.children.push(p),d.children.length>1&&(d.children=d.children.sort((w,R)=>w.pid-R.pid)))}}function m(y){const u=/--vscode-window-kind=shared-process/,S=/--vscode-window-kind=issue-reporter/,f=/--vscode-window-kind=process-explorer/,c=/--utility-sub-type=network/,d=/--utility-sub-type=node.mojom.NodeService/,p=/--crashes-directory/,w=/\\pipe\\winpty-control/,R=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(p.exec(y))return"electron-crash-reporter";if(w.exec(y))return"winpty-process";if(R.exec(y))return"console-window-host (Windows internal process)";let o=i.exec(y);if(o&&o.length===2){if(o[1]==="renderer")return u.exec(y)?"shared-process":S.exec(y)?"issue-reporter":f.exec(y)?"process-explorer":"window";if(o[1]==="utility"){if(c.exec(y))return"utility-network-service";if(d.exec(y))return"extension-host"}else if(o[1]==="extensionHost")return"extension-host";return o[1]}const t=/[a-zA-Z-]+\.js/g;let n="";do o=t.exec(y),o&&(n+=o+" ");while(o);return n&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${n}`:y}if(process.platform==="win32"){const y=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substr(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substr(5):u;new Promise((u,S)=>{Q(["windows-process-tree"],u,S)}).then(u=>{u.getProcessList(O,S=>{if(!S){I(new Error(`Root process ${O} not found`));return}u.getProcessCpuUsage(S,f=>{const c=new Map;f.forEach(d=>{const p=y(d.commandLine||"");c.set(d.pid,{name:m(p),cmd:p,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),E=c.get(O),E?(c.forEach(d=>{const p=c.get(d.ppid);p&&(p.children||(p.children=[]),p.children.push(d))}),c.forEach(d=>{d.children&&(d.children=d.children.sort((p,w)=>p.pid-w.pid))}),P(E)):I(new Error(`Root process ${O} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let y=function(){let u=[E];const S=[];for(;u.length;){const c=u.shift();c&&(S.push(c.pid),c.children&&(u=u.concat(c.children)))}let f=JSON.stringify(T.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);f+=" "+S.join(" "),(0,k.exec)(f,{},(c,d,p)=>{if(c||p)I(c||new Error(p.toString()));else{const w=d.toString().split(`
`);for(let R=0;R<S.length;R++){const i=C.get(S[R]);i.load=parseFloat(w[R])}if(!E){I(new Error(`Root process ${O} not found`));return}P(E)}})};(0,k.exec)("which ps",{},(u,S,f)=>{if(u||f)if(process.platform!=="linux")I(u||new Error(f.toString()));else{const c=JSON.stringify(T.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,k.exec)(c,{},(d,p,w)=>{d||w?I(d||new Error(w.toString())):(l(p,b),y())})}else{const c=S.toString().trim(),d="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${c} ${d}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(p,w,R)=>{p||R&&!R.includes("screen size is bogus")?I(p||new Error(R.toString())):(l(w,b),process.platform==="linux"?y():E?P(E):I(new Error(`Root process ${O} not found`)))})}})}})}e.listProcesses=D;function l(O,P){const I=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=O.toString().split(`
`);for(const C of E){const b=I.exec(C.trim());b&&b.length===6&&P(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(oe[149],ae([0,1,34,4,91,92]),function(Q,e,k,T,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function O(b,m){return b===1?T.isWindows?C():l.getWindowsShell(m):I(b,m)}e.getSystemShell=O;let P=null;function I(b,m){if(T.isLinux&&b===2||T.isMacintosh&&b===3)return"/bin/bash";if(!P){let y;if(T.isWindows)y="/bin/bash";else{if(y=m.SHELL,!y)try{y=(0,k.userInfo)().shell}catch{}y||(y="sh"),y==="/bin/false"&&(y="/bin/bash")}P=y}return P}let E=null;async function C(){return E||(E=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),E}});var ye=this&&this.__decorate||function(Q,e,k,T){var D=arguments.length,l=D<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,k):T,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")l=Reflect.decorate(Q,e,k,T);else for(var P=Q.length-1;P>=0;P--)(O=Q[P])&&(l=(D<3?O(l):D>3?O(e,k,l):O(e,k))||l);return D>3&&l&&Object.defineProperty(e,k,l),l};define(oe[39],ae([0,1,21,6,17,25,63,9,3,2,67,27,12]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var y;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(y||(y={}));function u(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(S||(S={}));function f(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(c||(c={}));function d(j){let V=0;for(let J=0;;J+=7){const _=j.read(1);if(V|=(_.buffer[0]&127)<<J,!(_.buffer[0]&128))return V}}const p=t(0);function w(j,V){if(V===0){j.write(p);return}let J=0;for(let re=V;re!==0;re=re>>>7)J++;const _=D.VSBuffer.alloc(J);for(let re=0;V!==0;re++)_.buffer[re]=V&127,V=V>>>7,V>0&&(_.buffer[re]|=128);j.write(_)}class R{constructor(V){this.b=V,this.a=0}read(V){const J=this.b.slice(this.a,this.a+V);return this.a+=J.byteLength,J}}e.BufferReader=R;class i{constructor(){this.a=[]}get buffer(){return D.VSBuffer.concat(this.a)}write(V){this.a.push(V)}}e.BufferWriter=i;var o;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object",j[j.Int=6]="Int"})(o||(o={}));function t(j){const V=D.VSBuffer.alloc(1);return V.writeUInt8(j,0),V}const n={Undefined:t(o.Undefined),String:t(o.String),Buffer:t(o.Buffer),VSBuffer:t(o.VSBuffer),Array:t(o.Array),Object:t(o.Object),Uint:t(o.Int)},s=typeof Buffer<"u";function a(j,V){if(typeof V>"u")j.write(n.Undefined);else if(typeof V=="string"){const J=D.VSBuffer.fromString(V);j.write(n.String),w(j,J.byteLength),j.write(J)}else if(s&&Buffer.isBuffer(V)){const J=D.VSBuffer.wrap(V);j.write(n.Buffer),w(j,J.byteLength),j.write(J)}else if(V instanceof D.VSBuffer)j.write(n.VSBuffer),w(j,V.byteLength),j.write(V);else if(Array.isArray(V)){j.write(n.Array),w(j,V.length);for(const J of V)a(j,J)}else if(typeof V=="number"&&(V|0)===V)j.write(n.Uint),w(j,V);else{const J=D.VSBuffer.fromString(JSON.stringify(V));j.write(n.Object),w(j,J.byteLength),j.write(J)}}e.serialize=a;function r(j){switch(j.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return j.read(d(j)).toString();case o.Buffer:return j.read(d(j)).buffer;case o.VSBuffer:return j.read(d(j));case o.Array:{const J=d(j),_=[];for(let re=0;re<J;re++)_.push(r(j));return _}case o.Object:return JSON.parse(j.read(d(j)).toString());case o.Int:return d(j)}}e.deserialize=r;class h{constructor(V,J,_=null,re=1e3){this.h=V,this.j=J,this.k=_,this.l=re,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:200})}registerChannel(V,J){this.b.set(V,J),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const J=this.o([V.type]);this.k?.logOutgoing(J,0,1,f(V.type));return}case 201:case 202:case 204:case 203:{const J=this.o([V.type,V.id],V.data);this.k?.logOutgoing(J,V.id,1,f(V.type),V.data);return}}}o(V,J=void 0){const _=new i;return a(_,V),a(_,J),this.p(_.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const J=new R(V),_=r(J),re=r(J),te=_[0];switch(te){case 100:return this.k?.logIncoming(V.byteLength,_[1],1,`${u(te)}: ${_[2]}.${_[3]}`,re),this.s({type:te,id:_[1],channelName:_[2],name:_[3],arg:re});case 102:return this.k?.logIncoming(V.byteLength,_[1],1,`${u(te)}: ${_[2]}.${_[3]}`,re),this.t({type:te,id:_[1],channelName:_[2],name:_[3],arg:re});case 101:return this.k?.logIncoming(V.byteLength,_[1],1,`${u(te)}`),this.u({type:te,id:_[1]});case 103:return this.k?.logIncoming(V.byteLength,_[1],1,`${u(te)}`),this.u({type:te,id:_[1]})}}s(V){const J=this.b.get(V.channelName);if(!J){this.v(V);return}const _=new l.CancellationTokenSource;let re;try{re=J.call(this.j,V.name,V.arg,_.token)}catch(B){re=Promise.reject(B)}const te=V.id;re.then(B=>{this.m({id:te,data:B,type:201}),this.d.delete(V.id)},B=>{B instanceof Error?this.m({id:te,data:{message:B.message,name:B.name,stack:B.stack?B.stack.split?B.stack.split(`
`):B.stack:void 0},type:202}):this.m({id:te,data:B,type:203}),this.d.delete(V.id)});const U=(0,E.toDisposable)(()=>_.cancel());this.d.set(V.id,U)}t(V){const J=this.b.get(V.channelName);if(!J){this.v(V);return}const _=V.id,te=J.listen(this.j,V.name,V.arg)(U=>this.m({id:_,data:U,type:204}));this.d.set(V.id,te)}u(V){const J=this.d.get(V.id);J&&(J.dispose(),this.d.delete(V.id))}v(V){let J=this.g.get(V.channelName);J||(J=[],this.g.set(V.channelName,J));const _=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);J.push({request:V,timeoutTimer:_})}w(V){const J=this.g.get(V);if(J){for(const _ of J)switch(clearTimeout(_.timeoutTimer),_.request.type){case 100:this.s(_.request);break;case 102:this.t(_.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,E.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=h;var g;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class v{constructor(V,J=null){this.l=V,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new I.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(_=>this.s(_)),this.j=J}getChannel(V){const J=this;return{call(_,re,te){return J.a?Promise.reject(new P.CancellationError):J.m(V,_,re,te)},listen(_,re){return J.a?I.Event.None:J.o(V,_,re)}}}m(V,J,_,re=l.CancellationToken.None){const te=this.g++,B={id:te,type:100,channelName:V,name:J,arg:_};if(re.isCancellationRequested)return Promise.reject(new P.CancellationError);let W;return new Promise((Y,ee)=>{if(re.isCancellationRequested)return ee(new P.CancellationError);const K=()=>{const ue=pe=>{switch(pe.type){case 201:this.f.delete(te),Y(pe.data);break;case 202:{this.f.delete(te);const ve=new Error(pe.data.message);ve.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,ve.name=pe.data.name,ee(ve);break}case 203:this.f.delete(te),ee(pe.data);break}};this.f.set(te,ue),this.p(B)};let Z=null;this.b===c.Idle?K():(Z=(0,T.createCancelablePromise)(ue=>this.u()),Z.then(()=>{Z=null,K()}));const se=()=>{Z?(Z.cancel(),Z=null):this.p({id:te,type:101}),ee(new P.CancellationError)},le=re.onCancellationRequested(se);W=(0,E.combinedDisposable)((0,E.toDisposable)(se),le),this.d.add(W)}).finally(()=>{this.d.delete(W)})}o(V,J,_){const re=this.g++,U={id:re,type:102,channelName:V,name:J,arg:_};let B=null;const W=new I.Emitter({onWillAddFirstListener:()=>{B=(0,T.createCancelablePromise)(Y=>this.u()),B.then(()=>{B=null,this.d.add(W),this.p(U)})},onDidRemoveLastListener:()=>{B?(B.cancel(),B=null):(this.d.delete(W),this.p({id:re,type:103}))}}),q=Y=>W.fire(Y.data);return this.f.set(re,q),W.event}p(V){switch(V.type){case 100:case 102:{const J=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(J,V.id,0,`${u(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const J=this.q([V.type,V.id]);this.j?.logOutgoing(J,V.id,0,u(V.type));return}}}q(V,J=void 0){const _=new i;return a(_,V),a(_,J),this.r(_.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const J=new R(V),_=r(J),re=r(J),te=_[0];switch(te){case 200:return this.j?.logIncoming(V.byteLength,0,0,f(te)),this.t({type:_[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,_[1],0,f(te),re),this.t({type:_[0],id:_[1],data:re})}}t(V){if(V.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return I.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,E.dispose)(this.d.values()),this.d.clear()}}ye([O.memoize],v.prototype,"onDidInitializePromise",null),e.ChannelClient=v;class A{get connections(){const V=[];return this.f.forEach(J=>V.push(J)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new I.Emitter,this.onDidAddConnection=this.g.event,this.h=new I.Emitter,this.onDidRemoveConnection=this.h.event,V(({protocol:J,onDidClientDisconnect:_})=>{I.Event.once(J.onMessage)(te=>{const U=new R(te),B=r(U),W=new h(J,B),q=new v(J);this.a.forEach((ee,K)=>W.registerChannel(K,ee));const Y={channelServer:W,channelClient:q,ctx:B};this.f.add(Y),this.g.fire(Y),_(()=>{W.dispose(),q.dispose(),this.f.delete(Y),this.h.fire(Y)})})})}getChannel(V,J){const _=this;return{call(re,te,U){let B;if((0,m.isFunction)(J)){const q=(0,k.getRandomElement)(_.connections.filter(J));B=q?Promise.resolve(q):I.Event.toPromise(I.Event.filter(_.onDidAddConnection,J))}else B=J.routeCall(_,re,te);const W=B.then(q=>q.channelClient.getChannel(V));return F(W).call(re,te,U)},listen(re,te){if((0,m.isFunction)(J))return _.j(V,J,re,te);const U=J.routeEvent(_,re,te).then(B=>B.channelClient.getChannel(V));return F(U).listen(re,te)}}}j(V,J,_,re){const te=this;let U=new E.DisposableStore;const B=new I.Emitter({onWillAddFirstListener:()=>{U=new E.DisposableStore;const W=new I.EventMultiplexer,q=new Map,Y=K=>{const se=K.channelClient.getChannel(V).listen(_,re),le=W.add(se);q.set(K,le)},ee=K=>{const Z=q.get(K);!Z||(Z.dispose(),q.delete(K))};te.connections.filter(J).forEach(Y),I.Event.filter(te.onDidAddConnection,J)(Y,void 0,U),te.onDidRemoveConnection(ee,void 0,U),W.event(B.fire,B,U),U.add(W)},onDidRemoveLastListener:()=>{U.dispose()}});return B.event}registerChannel(V,J){this.a.set(V,J),this.f.forEach(_=>{_.channelServer.registerChannel(V,J)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=A;class N{constructor(V,J,_=null){const re=new i;a(re,J),V.send(re.buffer),this.a=new v(V,_),this.d=new h(V,J,_)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,J){this.d.registerChannel(V,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=N;function F(j){return{call(V,J,_){return j.then(re=>re.call(V,J,_))},listen(V,J){const _=new I.Relay;return j.then(re=>_.input=re.listen(V,J)),_.event}}}e.getDelayedChannel=F;function M(j){let V=!1;return{call(J,_,re){return V?j.call(J,_,re):(0,T.timeout)(0).then(()=>V=!0).then(()=>j.call(J,_,re))},listen(J,_){if(V)return j.listen(J,_);const re=new I.Relay;return(0,T.timeout)(0).then(()=>V=!0).then(()=>re.input=j.listen(J,_)),re.event}}}e.getNextTickChannel=M;class L{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const J of V.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await I.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.StaticRouter=L;var $;(function(j){function V(te,U){const B=te,W=U&&U.disableMarshalling,q=new Map;for(const Y in B)_(Y)&&q.set(Y,I.Event.buffer(B[Y],!0));return new class{listen(Y,ee,K){const Z=q.get(ee);if(Z)return Z;if(re(ee)){const se=B[ee];if(typeof se=="function")return se.call(B,K)}throw new Error(`Event not found: ${ee}`)}call(Y,ee,K){const Z=B[ee];if(typeof Z=="function"){if(!W&&Array.isArray(K))for(let se=0;se<K.length;se++)K[se]=(0,C.revive)(K[se]);return Z.apply(B,K)}throw new Error(`Method not found: ${ee}`)}}}j.fromService=V;function J(te,U){const B=U&&U.disableMarshalling;return new Proxy({},{get(W,q){if(typeof q=="string")return U?.properties?.has(q)?U.properties.get(q):re(q)?function(Y){return te.listen(q,Y)}:_(q)?te.listen(q):async function(...Y){let ee;U&&!(0,m.isUndefinedOrNull)(U.context)?ee=[U.context,...Y]:ee=Y;const K=await te.call(q,ee);return B?K:(0,C.revive)(K)};throw new Error(`Property not found: ${String(q)}`)}})}j.toService=J;function _(te){return te[0]==="o"&&te[1]==="n"&&b.isUpperAsciiLetter(te.charCodeAt(2))}function re(te){return/^onDynamic/.test(te)&&b.isUpperAsciiLetter(te.charCodeAt(9))}})($=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){const V=j.toString();if(V!=="[object Object]")return V}return j}function X(j){return Array.isArray(j)?j.map(x):x(j)}function ie(j,V,J,_,re,te,U){U=X(U);const B=z[re],W=B[_%B.length];let q=[`%c[${j}]%c[${String(V).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(te)?(q=q.concat(U),q.push(")")):q.push(U),console.log.apply(console,q)}class H{constructor(V,J){this.d=V,this.f=J,this.a=0,this.b=0}logOutgoing(V,J,_,re,te){this.b+=V,ie(this.d,this.b,V,J,_,re,te)}logIncoming(V,J,_,re,te){this.a+=V,ie(this.f,this.a,V,J,_,re,te)}}e.IPCLogger=H}),define(oe[150],ae([0,1,17,3,39]),function(Q,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class l{constructor(I){this.a=I,this.onMessage=T.Event.fromDOMEventEmitter(this.a,"message",E=>k.VSBuffer.wrap(E.data)),I.start()}send(I){this.a.postMessage(I.buffer)}disconnect(){this.a.close()}}e.Protocol=l;class O extends D.IPCClient{constructor(I,E){const C=new l(I);super(C,E),this.b=C}dispose(){this.b.disconnect()}}e.Client=O}),define(oe[93],ae([0,1,6,17,3,2,39]),function(Q,e,k,T,D,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(v){v.Created="created",v.Read="read",v.Write="write",v.Open="open",v.Error="error",v.Close="close",v.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",v.NodeEndReceived="nodeEndReceived",v.NodeEndSent="nodeEndSent",v.NodeDrainBegin="nodeDrainBegin",v.NodeDrainEnd="nodeDrainEnd",v.zlibInflateError="zlibInflateError",v.zlibInflateData="zlibInflateData",v.zlibInflateInitialWrite="zlibInflateInitialWrite",v.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",v.zlibInflateWrite="zlibInflateWrite",v.zlibInflateFlushFired="zlibInflateFlushFired",v.zlibDeflateError="zlibDeflateError",v.zlibDeflateData="zlibDeflateData",v.zlibDeflateWrite="zlibDeflateWrite",v.zlibDeflateFlushFired="zlibDeflateFlushFired",v.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",v.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",v.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",v.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",v.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",v.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",v.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",v.ProtocolHeaderRead="protocolHeaderRead",v.ProtocolMessageRead="protocolMessageRead",v.ProtocolHeaderWrite="protocolHeaderWrite",v.ProtocolMessageWrite="protocolMessageWrite",v.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(v){v.enableDiagnostics=!1,v.records=[];const A=new WeakMap;let N=0;function F(L,$){if(!A.has(L)){const z=String(++N);A.set(L,z)}return A.get(L)}function M(L,$,z,x){if(!v.enableDiagnostics)return;const X=F(L,$);if(x instanceof T.VSBuffer||x instanceof Uint8Array||x instanceof ArrayBuffer||ArrayBuffer.isView(x)){const ie=T.VSBuffer.alloc(x.byteLength);ie.set(x),v.records.push({timestamp:Date.now(),id:X,label:$,type:z,buff:ie})}else v.records.push({timestamp:Date.now(),id:X,label:$,type:z,data:x})}v.traceSocketEvent=M})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var E;(function(v){v[v.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",v[v.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function b(){return C||(C=T.VSBuffer.alloc(0)),C}class m{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(A){this.a.push(A),this.b+=A.byteLength}read(A){return this.c(A,!0)}peek(A){return this.c(A,!1)}c(A,N){if(A===0)return b();if(A>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===A){const $=this.a[0];return N&&(this.a.shift(),this.b-=A),$}if(this.a[0].byteLength>A){const $=this.a[0].slice(0,A);return N&&(this.a[0]=this.a[0].slice(A),this.b-=A),$}const F=T.VSBuffer.alloc(A);let M=0,L=0;for(;A>0;){const $=this.a[L];if($.byteLength>A){const z=$.slice(0,A);F.set(z,M),M+=A,N&&(this.a[L]=$.slice(A),this.b-=A),A-=A}else F.set($,M),M+=$.byteLength,N?(this.a.shift(),this.b-=$.byteLength):L++,A-=$.byteLength}return F}}e.ChunkStream=m;var y;(function(v){v[v.None=0]="None",v[v.Regular=1]="Regular",v[v.Control=2]="Control",v[v.Ack=3]="Ack",v[v.Disconnect=5]="Disconnect",v[v.ReplayRequest=6]="ReplayRequest",v[v.Pause=7]="Pause",v[v.Resume=8]="Resume",v[v.KeepAlive=9]="KeepAlive",v[v.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",v[v.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(y||(y={}));function u(v){switch(v){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var S;(function(v){v[v.HeaderLength=13]="HeaderLength",v[v.AcknowledgeTime=2e3]="AcknowledgeTime",v[v.TimeoutTime=2e4]="TimeoutTime",v[v.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",v[v.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",v[v.KeepAliveSendTime=5e3]="KeepAliveSendTime",v[v.LatencySampleTime=6e4]="LatencySampleTime",v[v.LatencySampleCount=5]="LatencySampleCount",v[v.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",v[v.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(S=e.ProtocolConstants||(e.ProtocolConstants={}));class f{constructor(A,N,F,M){this.type=A,this.id=N,this.ack=F,this.data=M,this.writtenTime=0}get size(){return this.data.byteLength}}class c extends l.Disposable{constructor(A){super(),this.f=this.B(new D.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=A,this.b=!1,this.c=new m,this.B(this.a.onData(N=>this.acceptChunk(N))),this.lastReadTime=Date.now()}acceptChunk(A){if(!(!A||A.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(A);this.c.byteLength>=this.g.readLen;){const N=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=N.readUInt32BE(9),this.g.messageType=N.readUInt8(0),this.g.id=N.readUInt32BE(1),this.g.ack=N.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:u(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const F=this.g.messageType,M=this.g.id,L=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",N),this.f.fire(new f(F,M,L,N)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class d{constructor(A){this.k=null,this.a=!1,this.b=!1,this.c=A,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(A){if(this.a)return;A.writtenTime=Date.now(),this.lastWriteTime=Date.now();const N=T.VSBuffer.alloc(13);N.writeUInt8(A.type,0),N.writeUInt32BE(A.id,1),N.writeUInt32BE(A.ack,5),N.writeUInt32BE(A.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:u(A.type),id:A.id,ack:A.ack,messageSize:A.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",A.data),this.j(N,A.data)}g(A,N){const F=this.f===0;return this.d.push(A,N),this.f+=A.byteLength+N.byteLength,F}h(){const A=T.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,A}j(A,N){this.g(A,N)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const A=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:A.byteLength}),this.c.write(A)}}class p extends l.Disposable{constructor(A){super(),this.f=new D.Emitter,this.onMessage=this.f.event,this.g=new D.Emitter,this.onDidDispose=this.g.event,this.a=A,this.b=this.B(new d(this.a)),this.c=this.B(new c(this.a)),this.B(this.c.onMessage(N=>{N.type===1&&this.f.fire(N.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(A){this.b.write(new f(1,0,0,A))}}e.Protocol=p;class w extends O.IPCClient{static fromSocket(A,N){return new w(new p(A),N)}get onDidDispose(){return this.b.onDidDispose}constructor(A,N,F=null){super(A,N,F),this.b=A}dispose(){super.dispose();const A=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),A.end()}}e.Client=w;class R{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new D.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(A){this.b?this.d.length>0?this.d.push(A):this.a.fire(A):this.d.push(A)}flushBuffer(){this.d=[]}}e.BufferedEmitter=R;class i{constructor(A){this.data=A,this.next=null}}class o{constructor(){this.a=null,this.b=null}length(){let A=0,N=this.a;for(;N;)N=N.next,A++;return A}peek(){return this.a?this.a.data:null}toArray(){const A=[];let N=0,F=this.a;for(;F;)A[N++]=F.data,F=F.next;return A}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(A){const N=new i(A);if(!this.a){this.a=N,this.b=N;return}this.b.next=N,this.b=N}}class t{static getInstance(){return t.b||(t.b=new t),t.b}constructor(){this.c=[];const A=Date.now();for(let N=0;N<t.a;N++)this.c[N]=A-1e3*N;setInterval(()=>{for(let N=t.a;N>=1;N--)this.c[N]=this.c[N-1];this.c[0]=Date.now()},1e3)}d(){const A=Date.now(),N=(1+t.a)*1e3;let F=0;for(let M=0;M<t.a;M++)A-this.c[M]<=N&&F++;return 1-F/t.a}hasHighLoad(){return this.d()>=.5}}t.a=10,t.b=null;var n;(function(v){v[v.Good=0]="Good",v[v.Poor=1]="Poor"})(n=e.ConnectionHealth||(e.ConnectionHealth={}));function s(v){switch(v){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=s;class a{constructor(A){this.connectionHealth=A}}e.ConnectionHealthChangedEvent=a;class r{constructor(A,N){this.roundTripTime=A,this.recentHighRoundTripCount=N}}e.HighRoundTripTimeEvent=r;class h{get unacknowledgedCount(){return this.c-this.d}constructor(A){this.x=new R,this.onControlMessage=this.x.event,this.y=new R,this.onMessage=this.y.event,this.z=new R,this.onDidDispose=this.z.event,this.A=new R,this.onSocketClose=this.A.event,this.B=new R,this.onSocketTimeout=this.B.event,this.C=new R,this.onHighRoundTripTime=this.C.event,this.D=new R,this.onDidChangeConnectionHealth=this.D.event,this.u=A.loadEstimator??t.getInstance(),this.v=A.measureRoundTripTime??!1,this.w=A.sendKeepAlive??!0,this.a=!1,this.b=new o,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new l.DisposableStore,this.o=A.socket,this.p=this.t.add(new d(this.o)),this.q=this.t.add(new c(this.o)),this.t.add(this.q.onMessage(N=>this.E(N))),this.t.add(this.o.onClose(N=>this.A.fire(N))),this.r=this.t.add(new g),this.t.add(this.r.onSendLatencyRequest(N=>this.J(N))),this.t.add(this.r.onHighRoundTripTime(N=>this.C.fire(N))),this.t.add(this.r.onDidChangeConnectionHealth(N=>this.D.fire(N))),this.v&&this.r.start(),A.initialChunk&&this.q.acceptChunk(A.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const A=new f(5,0,0,b());this.p.write(A),this.p.flush()}sendPause(){const A=new f(7,0,0,b());this.p.write(A)}sendResume(){const A=new f(8,0,0,b());this.p.write(A)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(A,N){this.a=!0,this.t.dispose(),this.t=new l.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=A,this.p=this.t.add(new d(this.o)),this.q=this.t.add(new c(this.o)),this.t.add(this.q.onMessage(F=>this.E(F))),this.t.add(this.o.onClose(F=>this.A.fire(F))),this.r=this.t.add(new g),this.t.add(this.r.onSendLatencyRequest(F=>this.J(F))),this.t.add(this.r.onHighRoundTripTime(F=>this.C.fire(F))),this.t.add(this.r.onDidChangeConnectionHealth(F=>this.D.fire(F))),this.q.acceptChunk(N)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const A=new f(3,0,this.h,b());this.p.write(A);const N=this.b.toArray();for(let F=0,M=N.length;F<M;F++)this.p.write(N[F]);this.G()}acceptDisconnect(){this.z.fire()}E(A){if(A.ack>this.d){this.d=A.ack;do{const N=this.b.peek();if(N&&N.id<=A.ack)this.b.pop();else break}while(!0)}switch(A.type){case 0:break;case 1:{if(A.id>this.g)if(A.id!==this.g+1){const N=Date.now();N-this.m>1e4&&(this.m=N,this.p.write(new f(6,0,0,b())))}else this.g=A.id,this.j=Date.now(),this.F(),this.y.fire(A.data);break}case 2:{this.x.fire(A.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const N=this.b.toArray();for(let F=0,M=N.length;F<M;F++)this.p.write(N[F]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(A.data);break}case 11:{this.r.handleResponse(A.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(A){const N=++this.c;this.h=this.g;const F=new f(1,N,this.h,A);this.b.push(F),this.a||(this.p.write(F),this.G())}sendControl(A){const N=new f(2,0,0,A);this.p.write(N)}F(){if(this.g<=this.h||this.k)return;const A=Date.now()-this.j;if(A>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-A+5)}G(){if(this.c<=this.d||this.f||this.a)return;const A=this.b.peek(),N=Date.now()-A.writtenTime,F=Date.now()-this.q.lastReadTime,M=Date.now()-this.n;if(N>=2e4&&F>=2e4&&M>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:N,timeSinceLastReceivedSomeData:F});return}const L=Math.max(2e4-N,2e4-F,2e4-M,500);this.f=setTimeout(()=>{this.f=null,this.G()},L)}H(){if(this.g<=this.h)return;this.h=this.g;const A=new f(3,0,this.h,b());this.p.write(A)}I(){this.h=this.g;const A=new f(9,0,this.h,b());this.p.write(A)}J(A){this.h=this.g;const N=new f(10,0,this.h,A);this.p.write(N)}K(A){this.h=this.g;const N=new f(11,0,this.h,A);this.p.write(N)}}e.PersistentProtocol=h;class g extends l.Disposable{constructor(){super(),this.a=this.B(new D.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new D.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new D.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new k.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},A=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const A=++this.h,N=T.VSBuffer.alloc(4);N.writeUInt32BE(A,0),this.a.fire(N)},6e4)}handleResponse(A){if(A.byteLength!==4)return;const N=A.readUInt32BE(0);if(this.g<=0||N!==this.h)return;const F=Date.now()-this.g,M=this.k++;this.j[M%this.j.length]=F;const L=this.l,$=this.j.filter(z=>z>=1e3).length;this.l=$>=3?1:0,F>1e3&&this.b.fire(new r(F,$)),L!==this.l&&this.c.fire(this.l)}}}),define(oe[151],ae([0,1,94,3,39,150]),function(Q,e,k,T,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class O extends D.IPCServer{static b(){const I=T.Event.fromNodeEventEmitter(k.ipcRenderer,"vscode:createMessageChannel",(E,C)=>C);return T.Event.map(I,E=>{const{port1:C,port2:b}=new MessageChannel,y={protocol:new l.Protocol(C),onDidClientDisconnect:T.Event.fromDOMEventEmitter(C,"close")};return k.ipcRenderer.postMessage("vscode:createMessageChannelResult",E,[b]),y})}constructor(){super(O.b())}}e.Server=O}),define(oe[68],ae([0,1,50,6,17,25,144,9,3,2,32,92,87,39]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class u extends y.ChannelServer{constructor(c){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:I.Event.fromNodeEventEmitter(process,"message",d=>D.VSBuffer.wrap(Buffer.from(d,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.Server=u;class S{constructor(c,d){this.i=c,this.j=d,this.c=new Set,this.g=new Map,this.h=new I.Emitter,this.onDidProcessExit=this.h.event;const p=d&&d.timeout?d.timeout:6e4;this.b=new T.Delayer(p),this.d=null,this.f=null}getChannel(c){const d=this;return{call(p,w,R){return d.k(c,p,w,R)},listen(p,w){return d.l(c,p,w)}}}k(c,d,p,w=l.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(w.isCancellationRequested)return Promise.reject(P.canceled());this.b.cancel();const R=this.n(c),i=(0,T.createCancelablePromise)(n=>R.call(d,p,n)),o=w.onCancellationRequested(()=>i.cancel()),t=(0,E.toDisposable)(()=>i.cancel());return this.c.add(t),i.finally(()=>{o.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(c,d,p){if(!this.b)return I.Event.None;this.b.cancel();let w;const R=new I.Emitter({onWillAddFirstListener:()=>{w=this.n(c).listen(d,p)(R.fire,R),this.c.add(w)},onDidRemoveLastListener:()=>{this.c.delete(w),w.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return R.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,m.removeDangerousEnvVariables)(d.env),this.d=(0,k.fork)(this.i,c,d);const p=new I.Emitter;I.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,O.isRemoteConsoleLog)(s)){(0,O.log)(s,`IPC Library: ${this.j.serverName}`);return}p.fire(D.VSBuffer.wrap(Buffer.from(s,"base64")))});const R=this.j.useQueue?(0,b.createQueuedSender)(this.d):this.d,i=s=>this.d&&this.d.connected&&R.send(s.buffer.toString("base64")),o=p.event,t={send:i,onMessage:o};this.f=new y.ChannelClient(t);const n=()=>this.o();process.once("exit",n),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,a)=>{process.removeListener("exit",n),this.c.forEach(r=>(0,E.dispose)(r)),this.c.clear(),s!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:a})})}return this.f}n(c){let d=this.g.get(c);return d||(d=this.m.getChannel(c),this.g.set(c,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=S}),define(oe[152],ae([0,1,17,9,3,2,13,4,31,39,93]),function(Q,e,k,T,D,l,O,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function b(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class m{traceSocketEvent(r,h){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,r,h)}constructor(r,h=""){this.f=!0,this.debugLabel=h,this.socket=r,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=g=>{if(this.traceSocketEvent("error",{code:g?.code,message:g?.message}),g){if(g.code==="EPIPE")return;(0,T.onUnexpectedError)(g)}},this.socket.on("error",this.a),this.b=g=>{this.traceSocketEvent("close",{hadError:g}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(r){const h=g=>{this.traceSocketEvent("read",g),r(k.VSBuffer.wrap(g))};return this.socket.on("data",h),{dispose:()=>this.socket.off("data",h)}}onClose(r){const h=g=>{r({type:0,hadError:g,error:void 0})};return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(r){const h=()=>{r()};return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(r){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",r),this.socket.write(r.buffer,h=>{if(h){if(h.code==="EPIPE")return;(0,T.onUnexpectedError)(h)}})}catch(h){if(h.code==="EPIPE")return;(0,T.onUnexpectedError)(h)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((r,h)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),r();return}const g=()=>{this.socket.off("close",g),this.socket.off("end",g),this.socket.off("error",g),this.socket.off("timeout",g),this.socket.off("drain",g),this.traceSocketEvent("nodeDrainEnd"),r()};this.socket.on("close",g),this.socket.on("end",g),this.socket.on("error",g),this.socket.on("timeout",g),this.socket.on("drain",g)})}}e.NodeSocket=m;var y;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var u;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(u||(u={}));class S extends l.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(r,h){this.socket.traceSocketEvent(r,h)}constructor(r,h,g,v){super(),this.f=this.B(new D.Emitter),this.g=this.B(new D.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=r,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:h,inflateBytesLength:g?.byteLength||0,recordInflateBytes:v}),this.a=this.B(new f(this,h,g,v,this.f,(A,N)=>this.k(A,N))),this.B(this.a.onError(A=>{console.error(A),(0,T.onUnexpectedError)(A),this.g.fire({type:0,hadError:!0,error:A})})),this.b=new C.ChunkStream,this.B(this.socket.onData(A=>this.l(A))),this.B(this.socket.onClose(A=>this.g.fire(A)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(r){return this.f.event(r)}onClose(r){return this.g.event(r)}onEnd(r){return this.socket.onEnd(r)}write(r){this.a.writeMessage(r)}k(r,h){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",r);let g=2;r.byteLength<126?g+=0:r.byteLength<2**16?g+=2:g+=8;const v=k.VSBuffer.alloc(g);if(h?v.writeUInt8(194,0):v.writeUInt8(130,0),r.byteLength<126)v.writeUInt8(r.byteLength,1);else if(r.byteLength<2**16){v.writeUInt8(126,1);let A=1;v.writeUInt8(r.byteLength>>>8&255,++A),v.writeUInt8(r.byteLength>>>0&255,++A)}else{v.writeUInt8(127,1);let A=1;v.writeUInt8(0,++A),v.writeUInt8(0,++A),v.writeUInt8(0,++A),v.writeUInt8(0,++A),v.writeUInt8(r.byteLength>>>24&255,++A),v.writeUInt8(r.byteLength>>>16&255,++A),v.writeUInt8(r.byteLength>>>8&255,++A),v.writeUInt8(r.byteLength>>>0&255,++A)}this.socket.write(k.VSBuffer.concat([v,r]))}end(){this.h=!0,this.socket.end()}l(r){if(r.byteLength!==0){for(this.b.acceptChunk(r);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const h=this.b.peek(this.j.readLen),g=h.readUInt8(0),v=(g&128)>>>7,A=(g&64)>>>6,N=h.readUInt8(1),F=(N&128)>>>7,M=N&127;this.j.state=2,this.j.readLen=2+(F?4:0)+(M===126?2:0)+(M===127?8:0),this.j.fin=v,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(A)),this.j.firstFrameOfMessage=Boolean(v),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const h=this.b.read(this.j.readLen),g=h.readUInt8(1),v=(g&128)>>>7;let A=g&127,N=1;A===126?A=h.readUInt8(++N)*2**8+h.readUInt8(++N):A===127&&(A=h.readUInt8(++N)*0+h.readUInt8(++N)*0+h.readUInt8(++N)*0+h.readUInt8(++N)*0+h.readUInt8(++N)*2**24+h.readUInt8(++N)*2**16+h.readUInt8(++N)*2**8+h.readUInt8(++N));let F=0;v&&(F=h.readUInt8(++N)*2**24+h.readUInt8(++N)*2**16+h.readUInt8(++N)*2**8+h.readUInt8(++N)),this.j.state=3,this.j.readLen=A,this.j.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const h=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",h),p(h,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",h),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(h,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await D.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=S;class f extends l.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:k.VSBuffer.alloc(0)}constructor(r,h,g,v,A,N){super(),this.k=r,this.l=A,this.m=N,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new D.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,h?(this.b=this.B(new c(this.k,v,g,{windowBits:15})),this.f=this.B(new d(this.k,{windowBits:15})),this.B(this.b.onError(F=>this.a.fire(F))),this.B(this.f.onError(F=>this.a.fire(F)))):(this.b=null,this.f=null)}writeMessage(r){this.g.push(r),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const r=this.g.shift();if(this.f){const h=await this.r(this.f,r);this.m(h,!0)}else this.m(r,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(r,h){return new Promise((g,v)=>{r.write(h),r.flush(A=>g(A))})}acceptFrame(r,h,g){this.h.push({data:r,isCompressed:h,isLastFrameOfMessage:g}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const r=this.h.shift();if(this.b&&r.isCompressed){const h=await this.u(this.b,r.data,r.isLastFrameOfMessage);this.l.fire(h)}else this.l.fire(r.data)}this.s=!1}}u(r,h,g){return new Promise((v,A)=>{r.write(h),g&&r.write(k.VSBuffer.fromByteArray([0,0,255,255])),r.flush(N=>v(N))})}}class c extends l.Disposable{get recordedInflateBytes(){return this.j?k.VSBuffer.concat(this.f):k.VSBuffer.alloc(0)}constructor(r,h,g,v){super(),this.h=r,this.j=h,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=b().zlib.createInflateRaw(v),this.b.on("error",A=>{this.h.traceSocketEvent("zlibInflateError",{message:A?.message,code:A?.code}),this.a.fire(A)}),this.b.on("data",A=>{this.h.traceSocketEvent("zlibInflateData",A),this.g.push(k.VSBuffer.wrap(A))}),g&&(this.h.traceSocketEvent("zlibInflateInitialWrite",g.buffer),this.b.write(g.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(r){this.j&&this.f.push(r.clone()),this.h.traceSocketEvent("zlibInflateWrite",r),this.b.write(r.buffer)}flush(r){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const h=k.VSBuffer.concat(this.g);this.g.length=0,r(h)})}}class d extends l.Disposable{constructor(r,h){super(),this.g=r,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.f=[],this.b=b().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",g=>{this.g.traceSocketEvent("zlibDeflateError",{message:g?.message,code:g?.code}),this.a.fire(g)}),this.b.on("data",g=>{this.g.traceSocketEvent("zlibDeflateData",g),this.f.push(k.VSBuffer.wrap(g))})}write(r){this.g.traceSocketEvent("zlibDeflateWrite",r.buffer),this.b.write(r.buffer)}flush(r){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let h=k.VSBuffer.concat(this.f);this.f.length=0,h=h.slice(0,h.byteLength-4),r(h)})}}function p(a,r){if(r===0)return;const h=a.byteLength>>>2;for(let M=0;M<h;M++){const L=a.readUInt32BE(M*4);a.writeUInt32BE(L^r,M*4)}const g=h*4,v=a.byteLength-g,A=r>>>24&255,N=r>>>16&255,F=r>>>8&255;v>=1&&a.writeUInt8(a.readUInt8(g)^A,g),v>=2&&a.writeUInt8(a.readUInt8(g+1)^N,g+1),v>=3&&a.writeUInt8(a.readUInt8(g+2)^F,g+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const w={[2]:107,[1]:103};function R(){const a=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let r;return e.XDG_RUNTIME_DIR?r=(0,O.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):r=(0,O.join)(b().os.tmpdir(),`vscode-ipc-${a}.sock`),o(r),r}e.createRandomIPCHandle=R;function i(a,r,h){const g=b().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${g}-${h}-${r}-sock`;let v;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?v=(0,O.join)(e.XDG_RUNTIME_DIR,`vscode-${g.substr(0,8)}-${h}-${r}.sock`):v=(0,O.join)(a,`${h}-${r}.sock`),o(v),v}e.createStaticIPCHandle=i;function o(a){const r=w[P.platform];typeof r=="number"&&a.length>=r&&console.warn(`WARNING: IPC handle "${a}" is longer than ${r} chars, try a shorter --user-data-dir`)}class t extends E.IPCServer{static b(r){const h=D.Event.fromNodeEventEmitter(r,"connection");return D.Event.map(h,g=>({protocol:new C.Protocol(new m(g,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(g,"close"))}))}constructor(r){super(t.b(r)),this.d=r}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=t;function n(a){return new Promise((r,h)=>{const g=b().net.createServer();g.on("error",h),g.listen(a,()=>{g.removeListener("error",h),r(new t(g))})})}e.serve=n;function s(a,r){return new Promise((h,g)=>{const v=b().net.createConnection(a,()=>{v.removeListener("error",g),h(C.Client.fromSocket(new m(v,`ipc-client${r}`),r))});v.once("error",g)})}e.connect=s}),define(oe[69],ae([0,1,6,3,2,12]),function(Q,e,k,T,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var O;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O=e.StorageHint||(e.StorageHint={}));function P(b){const m=b;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var I;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(I=e.StorageState||(e.StorageState={}));class E extends D.Disposable{constructor(m,y=Object.create(null)){super(),this.m=m,this.n=y,this.b=this.B(new T.Emitter),this.onDidChangeStorage=this.b.event,this.c=I.None,this.f=new Map,this.g=new k.ThrottledDelayer(E.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(m=>this.r(m)))}r(m){m.changed?.forEach((y,u)=>this.s(u,y)),m.deleted?.forEach(y=>this.s(y,void 0))}s(m,y){if(this.c===I.Closed)return;let u=!1;(0,l.isUndefinedOrNull)(y)?u=this.f.delete(m):this.f.get(m)!==y&&(this.f.set(m,y),u=!0),u&&this.b.fire(m)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===I.None&&(this.c=I.Initialized,this.n.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(m,y){const u=this.f.get(m);return(0,l.isUndefinedOrNull)(u)?y:u}getBoolean(m,y){const u=this.get(m);return(0,l.isUndefinedOrNull)(u)?y:u==="true"}getNumber(m,y){const u=this.get(m);return(0,l.isUndefinedOrNull)(u)?y:parseInt(u,10)}async set(m,y){if(this.c===I.Closed)return;if((0,l.isUndefinedOrNull)(y))return this.delete(m);const u=String(y);if(this.f.get(m)!==u)return this.f.set(m,u),this.j.set(m,u),this.h.delete(m),this.b.fire(m),this.w()}async delete(m){if(!(this.c===I.Closed||!this.f.delete(m)))return this.h.has(m)||this.h.add(m),this.j.delete(m),this.b.fire(m),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=I.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const m={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(m).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(m){if(!!this.u)return this.w(m)}async w(m){return this.g.trigger(()=>this.v(),m)}async whenFlushed(){if(!!this.u)return new Promise(m=>this.l.push(m))}isInMemory(){return this.n.hint===O.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=E,E.a=100;class C{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(m){m.insert?.forEach((y,u)=>this.a.set(u,y)),m.delete?.forEach(y=>this.a.delete(y))}async close(){}}e.InMemoryStorageDatabase=C}),define(oe[153],ae([10,7]),function(Q,e){return Q.create("vs/base/node/zip",e)}),define(oe[154],ae([10,7]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[155],ae([10,7]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(oe[156],ae([10,7]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(oe[157],ae([10,7]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[158],ae([10,7]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[159],ae([10,7]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[160],ae([10,7]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[161],ae([10,7]),function(Q,e){return Q.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(oe[162],ae([10,7]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[163],ae([10,7]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[164],ae([10,7]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[165],ae([10,7]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(oe[166],ae([10,7]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(oe[167],ae([10,7]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(oe[168],ae([10,7]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[169],ae([10,7]),function(Q,e){return Q.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[170],ae([10,7]),function(Q,e){return Q.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(oe[171],ae([10,7]),function(Q,e){return Q.create("vs/platform/remoteTunnel/electron-browser/remoteTunnelService",e)}),define(oe[172],ae([10,7]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(oe[173],ae([10,7]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(oe[174],ae([10,7]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(oe[175],ae([10,7]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[176],ae([10,7]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(oe[177],ae([10,7]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalProfiles",e)}),define(oe[178],ae([10,7]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[179],ae([10,7]),function(Q,e){return Q.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[180],ae([10,7]),function(Q,e){return Q.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[181],ae([10,7]),function(Q,e){return Q.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[182],ae([10,7]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[183],ae([10,7]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[184],ae([10,7]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(oe[185],ae([10,7]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[186],ae([10,7]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[187],ae([10,7]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(oe[95],ae([0,1,65,63,26,13,36,22,11]),function(Q,e,k,T,D,l,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class E{get appRoot(){return(0,l.dirname)(D.FileAccess.asFileUri("").fsPath)}get userHome(){return I.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return I.URI.file((0,l.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(this.b.tmpDir)}get cacheHome(){return I.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const u=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,l.join)(this.userDataPath,"logs",u)}return this.args.logsPath}get userDataSyncLogResource(){return I.URI.file((0,l.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return I.URI.file((0,l.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(I.URI.file((0,l.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=O.env.VSCODE_PORTABLE;return u?I.URI.file((0,l.join)(u,"argv.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,l.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,l.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,l.resolve)(u):(0,l.normalize)((0,l.join)(D.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const u=this.args["extensions-download-dir"];return u?I.URI.file((0,l.resolve)(u)):I.URI.file((0,l.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,l.resolve)(u);const S=O.env.VSCODE_EXTENSIONS;if(S)return S;const f=O.env.VSCODE_PORTABLE;return f?(0,l.join)(f,"extensions"):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(S=>/^[^:/?#]+?:\/\//.test(S)?I.URI.parse(S):I.URI.file((0,l.normalize)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?I.URI.parse(u):I.URI.file((0,l.normalize)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(u=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(u))}get extensionLogLevel(){const u=[];for(const S of this.args.log||[]){const f=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(S);f&&f[1]&&f[2]&&u.push([f[1],f[2]])}return u.length?u:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return I.URI.file((0,l.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const u=O.env.VSCODE_PORTABLE;return u?I.URI.file((0,l.join)(u,"policy.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(u){this.args.continueOn=u}get args(){return this.a}constructor(u,S,f){this.a=u,this.b=S,this.c=f,this.editSessionId=this.args.editSessionId}}ye([T.memoize],E.prototype,"appRoot",null),ye([T.memoize],E.prototype,"userHome",null),ye([T.memoize],E.prototype,"userDataPath",null),ye([T.memoize],E.prototype,"appSettingsHome",null),ye([T.memoize],E.prototype,"tmpDir",null),ye([T.memoize],E.prototype,"cacheHome",null),ye([T.memoize],E.prototype,"stateResource",null),ye([T.memoize],E.prototype,"userRoamingDataHome",null),ye([T.memoize],E.prototype,"userDataSyncHome",null),ye([T.memoize],E.prototype,"userDataSyncLogResource",null),ye([T.memoize],E.prototype,"editSessionsLogResource",null),ye([T.memoize],E.prototype,"sync",null),ye([T.memoize],E.prototype,"machineSettingsResource",null),ye([T.memoize],E.prototype,"workspaceStorageHome",null),ye([T.memoize],E.prototype,"localHistoryHome",null),ye([T.memoize],E.prototype,"keyboardLayoutResource",null),ye([T.memoize],E.prototype,"argvResource",null),ye([T.memoize],E.prototype,"isExtensionDevelopment",null),ye([T.memoize],E.prototype,"untitledWorkspacesHome",null),ye([T.memoize],E.prototype,"installSourcePath",null),ye([T.memoize],E.prototype,"builtinExtensionsPath",null),ye([T.memoize],E.prototype,"extensionsPath",null),ye([T.memoize],E.prototype,"extensionDevelopmentLocationURI",null),ye([T.memoize],E.prototype,"extensionDevelopmentKind",null),ye([T.memoize],E.prototype,"extensionTestsLocationURI",null),ye([T.memoize],E.prototype,"debugExtensionHost",null),ye([T.memoize],E.prototype,"logLevel",null),ye([T.memoize],E.prototype,"extensionLogLevel",null),ye([T.memoize],E.prototype,"serviceMachineIdResource",null),ye([T.memoize],E.prototype,"telemetryLogResource",null),ye([T.memoize],E.prototype,"disableWorkspaceTrust",null),ye([T.memoize],E.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=E;function C(y,u){return m(y["inspect-extensions"],y["inspect-brk-extensions"],5870,u,y.debugId,y.extensionEnvironment)}e.parseExtensionHostPort=C;function b(y,u){return m(y["inspect-ptyhost"],y["inspect-brk-ptyhost"],5877,u,y.extensionEnvironment)}e.parsePtyHostPort=b;function m(y,u,S,f,c,d){const w=Number(u||y)||(f?null:S),R=w?Boolean(!!u):!1;let i;if(d)try{i=JSON.parse(d)}catch{}return{port:w,break:R,debugId:c,env:i}}}),define(oe[188],ae([0,1,291,4,155]),function(Q,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const l={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,D.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,D.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,D.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},category:{type:"string",cat:"e",description:(0,D.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,D.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,D.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,D.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,D.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,D.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const O={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(S,f,c=O){const d=S.find(a=>a.length>0&&a[0]!=="-"),p={},w=["_"],R=[],i={};let o;for(const a in f){const r=f[a];r.type==="subcommand"?a===d&&(o=r):(r.alias&&(p[a]=r.alias),r.type==="string"||r.type==="string[]"?(w.push(a),r.deprecates&&w.push(...r.deprecates)):r.type==="boolean"&&(R.push(a),r.deprecates&&R.push(...r.deprecates)),r.global&&(i[a]=r))}if(o&&d){const a=i;for(const v in o.options)a[v]=o.options[v];const r=S.filter(v=>v!==d),h=c.getSubcommandReporter?c.getSubcommandReporter(d):void 0,g=P(r,a,h);return{[d]:g,_:[]}}const t=k(S,{string:w,boolean:R,alias:p}),n={},s=t;n._=t._.map(a=>String(a)).filter(a=>a.length>0),delete s._;for(const a in f){const r=f[a];if(r.type==="subcommand")continue;r.alias&&delete s[r.alias];let h=s[a];if(r.deprecates)for(const g of r.deprecates)s.hasOwnProperty(g)&&(h||(h=s[g],h&&c.onDeprecatedOption(g,r.deprecationMessage||(0,D.localize)(36,null,a))),delete s[g]);if(typeof h<"u"){if(r.type==="string[]"){if(Array.isArray(h)||(h=[h]),!r.allowEmptyValue){const g=h.filter(v=>v.length>0);g.length!==h.length&&(c.onEmptyValue(a),h=g.length>0?g:void 0)}}else r.type==="string"&&(Array.isArray(h)?(h=h.pop(),c.onMultipleValues(a,h)):!h&&!r.allowEmptyValue&&(c.onEmptyValue(a),h=void 0));n[a]=h,r.deprecationMessage&&c.onDeprecatedOption(a,r.deprecationMessage)}delete s[a]}for(const a in s)c.onUnknownOption(a);return n}e.parseArgs=P;function I(S,f){let c="";return f.args&&(Array.isArray(f.args)?c=` <${f.args.join("> <")}>`:c=` <${f.args}>`),f.alias?`-${f.alias} --${S}${c}`:`--${S}${c}`}function E(S,f){const c=[];for(const d in S){const p=S[d],w=I(d,p);c.push([w,p.description])}return C(c,f)}e.formatOptions=E;function C(S,f){const d=S.reduce((R,i)=>Math.max(R,i[0].length),12)+2+1;if(f-d<25)return S.reduce((R,i)=>R.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const p=f-d-1,w=[];for(const R of S){const i=R[0],o=m(R[1],p),t=b(d-i.length-2);w.push("  "+i+t+o[0]);for(let n=1;n<o.length;n++)w.push(b(d)+o[n])}return w}function b(S){return" ".repeat(S)}function m(S,f){const c=[];for(;S.length;){const d=S.length<f?S.length:S.lastIndexOf(" ",f),p=S.slice(0,d).trim();S=S.slice(d),c.push(p)}return c}function y(S,f,c,d,p){const w=process.stdout.isTTY&&process.stdout.columns||80,R=p?.noInputFiles!==!0?`[${(0,D.localize)(37,null)}...]`:"",i=[`${S} ${c}`];i.push(""),i.push(`${(0,D.localize)(38,null)}: ${f} [${(0,D.localize)(39,null)}]${R}`),i.push(""),p?.noPipe!==!0&&(T.isWindows?i.push((0,D.localize)(40,null,f)):i.push((0,D.localize)(41,null,f)),i.push(""));const o={},t=[];for(const n in d){const s=d[n];if(s.type==="subcommand")s.description&&t.push({command:n,description:s.description});else if(s.description&&s.cat){let a=o[s.cat];a||(o[s.cat]=a={}),a[n]=s}}for(const n in o){const s=n,a=o[s];a&&(i.push(l[s]),i.push(...E(a,w)),i.push(""))}return t.length&&(i.push((0,D.localize)(42,null)),i.push(...C(t.map(n=>[n.command,n.description]),w)),i.push("")),i.join(`
`)}e.buildHelpMessage=y;function u(S,f){return`${S||(0,D.localize)(43,null)}
${f||(0,D.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=u}),define(oe[189],ae([0,1,292,156,188]),function(Q,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const l=2048;function O(m,y){const u=(w,R)=>{console.warn((0,T.localize)(0,null,w,R))},S=w=>{console.warn((0,T.localize)(1,null,w))},f=(w,R)=>{console.warn((0,T.localize)(2,null,w,R))},c=w=>({onUnknownOption:R=>{w!=="tunnel"&&console.warn((0,T.localize)(3,null,R,w))},onMultipleValues:u,onEmptyValue:S,onDeprecatedOption:f,getSubcommandReporter:w!=="tunnel"?c:void 0}),d={onUnknownOption:w=>{console.warn((0,T.localize)(4,null,w))},onMultipleValues:u,onEmptyValue:S,onDeprecatedOption:f,getSubcommandReporter:c},p=(0,D.parseArgs)(m,D.OPTIONS,y?d:void 0);return p.goto&&p._.forEach(w=>k(/^(\w:)?[^:]+(:\d*){0,2}$/.test(w),(0,T.localize)(5,null))),p["max-memory"]&&k(parseInt(p["max-memory"])>=l,`The max-memory argument cannot be specified lower than ${l} MB.`),p}function P(m){const y=m.findIndex(u=>!/^-/.test(u));if(y>-1)return[...m.slice(0,y),...m.slice(y+1)]}function I(m){let[,...y]=m;process.env.VSCODE_DEV&&(y=P(y)||[]);const u=!b(process.env);return O(y,u)}e.parseMainProcessArgv=I;function E(m){let[,,...y]=m;return process.env.VSCODE_DEV&&(y=P(y)||[]),O(y,!0)}e.parseCLIProcessArgv=E;function C(m,...y){const u=m.indexOf("--");return u===-1?m.push(...y):m.splice(u,0,...y),m}e.addArg=C;function b(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),function(){"use strict";function Q(e,k,T){function D(O,P){const I=l(O,P),E=[I];return e.isAbsolute(I)||E.unshift(T),e.resolve(...E)}function l(O,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const I=process.env.VSCODE_PORTABLE;if(I)return e.join(I,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,P);const C=O["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(b,"AppData","Roaming")}break;case"darwin":E=e.join(k.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,P)}return{getUserDataPath:D}}if(typeof define=="function")define(oe[190],ae([293,34,36]),function(e,k,T){return Q(e,k,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),k=require("os");module.exports=Q(e,k,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[191],ae([0,1,34,95,190]),function(Q,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class l extends T.AbstractNativeEnvironmentService{constructor(P,I){super(P,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,D.getUserDataPath)(P,I.nameShort)},I)}}e.NativeEnvironmentService=l}),define(oe[192],ae([0,1,11]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const T=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,l=/^([^@]+@)?([^:]+)(:\d+)?$/,O=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,I=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function E(f){const c=f.match(O);return c?c[1]:null}function C(f){if(f.indexOf("://")===-1){const c=f.match(T);return c?E(c[2]):null}try{const c=k.URI.parse(f);if(c.authority)return E(c.authority)}catch{}return null}function b(f,c){const d=new Set;let p;for(;p=P.exec(f);){const R=C(p[1]);R&&d.add(R)}const w=new Set(c);return Array.from(d).map(R=>w.has(R)?R:R.replace(I,"a"))}e.getDomainsOfRemotes=b;function m(f){const c=f.match(l);return c?c[2]:null}function y(f,c,d){return f&&c?(d&&c.endsWith(".git")&&(c=c.substr(0,c.length-4)),c.indexOf("/")===0?`${f}${c}`:`${f}/${c}`):null}function u(f,c){if(f.indexOf("://")===-1){const d=f.match(D);if(d)return y(d[2],d[3],c)}try{const d=k.URI.parse(f);if(d.authority)return y(m(d.authority),d.path,c)}catch{}return null}function S(f,c=!1){const d=[];let p;for(;p=P.exec(f);){const w=u(p[1],c);w&&d.push(w)}return d}e.getRemotes=S}),define(oe[193],ae([0,1,12,159]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function D(O,P,I){try{l(O,P,I)}catch(E){console.error(E?.message??E)}return O}e.localizeManifest=D;function l(O,P,I){const E=(C,b,m)=>{const y=C[b];if((0,k.isString)(y)){const u=y,S=u.length;if(S>1&&u[0]==="%"&&u[S-1]==="%"){const f=u.substr(1,S-2);let c=P[f];c===void 0&&I&&(c=I[f]);const d=typeof c=="string"?c:c?.message,p=I?.[f],w=typeof p=="string"?p:p?.message;if(!d){w||console.warn(`[${O.name}]: ${(0,T.localize)(0,null,f)}`);return}if(m&&(b==="title"||b==="category")&&w&&w!==d){const R={value:d,original:w};C[b]=R}else C[b]=d}}else if((0,k.isObject)(y))for(const u in y)y.hasOwnProperty(u)&&(u==="commands"?E(y,u,!0):E(y,u,m));else if(Array.isArray(y))for(let u=0;u<y.length;u++)E(y,u,m)};for(const C in O)O.hasOwnProperty(C)&&E(O,C)}}),define(oe[194],ae([0,1,9]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class T{constructor(){this.a=new Map}register(l,O){this.a.set(l,O)}updateManifest(l){if(!(typeof l.main>"u"&&typeof l.browser>"u")&&(l.activationEvents===void 0&&Object.assign(l,{activationEvents:[]}),!(!Array.isArray(l.activationEvents)||!l.contributes)))for(const O in l.contributes){const P=this.a.get(O);if(!P)continue;const I=l.contributes[O],E=Array.isArray(I)?I:[I];try{P(E,l.activationEvents)}catch(C){(0,k.onUnexpectedError)(C)}}}}e.ImplicitActivationEventsImpl=T,e.ImplicitActivationEvents=new T}),define(oe[195],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class k{constructor(l){this.a=l}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(l,O,P,I){return this.a.call("promptImportantExtensionsInstallNotification",[l,O,P,I])}promptWorkspaceRecommendations(l){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=k;class T{constructor(l){this.a=l}listen(l,O){throw new Error(`Event not found: ${O}`)}call(l,O,P){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${O}`)}}e.ExtensionRecommendationNotificationServiceChannel=T}),define(oe[70],ae([0,1,22,89,164,54]),function(Q,e,k,T,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function I(c){return c=c.trim(),c==="*"||O.test(c)}e.isValidVersionStr=I;function E(c){if(!I(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=c.match(O);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=E;function C(c){if(!c)return null;const d=c.majorBase,p=c.majorMustEqual,w=c.minorBase;let R=c.minorMustEqual;const i=c.patchBase;let o=c.patchMustEqual;c.hasCaret&&(d===0||(R=!1),o=!1);let t=0;if(c.preRelease){const n=P.exec(c.preRelease);if(n){const[,s,a,r]=n;t=Date.UTC(Number(s),Number(a)-1,Number(r))}}return{majorBase:d,majorMustEqual:p,minorBase:w,minorMustEqual:R,patchBase:i,patchMustEqual:o,isMinimum:c.hasGreaterEquals,notBefore:t}}e.normalizeVersion=C;function b(c,d,p){let w;typeof c=="string"?w=C(E(c)):w=c;let R;d instanceof Date?R=d.getTime():typeof d=="string"&&(R=new Date(d).getTime());let i;if(typeof p=="string"?i=C(E(p)):i=p,!w||!i)return!1;const o=w.majorBase,t=w.minorBase,n=w.patchBase;let s=i.majorBase,a=i.minorBase,r=i.patchBase;const h=i.notBefore;let g=i.majorMustEqual,v=i.minorMustEqual,A=i.patchMustEqual;return i.isMinimum?o>s?!0:o<s?!1:t>a?!0:t<a||R&&R<h?!1:n>=r:(o===1&&s===0&&(!g||!v||!A)&&(s=1,a=0,r=0,g=!0,v=!1,A=!1),o<s?!1:o>s?!g:t<a?!1:t>a?!v:n<r?!1:n>r?!A:!(R&&R<h))}e.isValidVersion=b;function m(c,d,p,w,R){const i=[];if(typeof w.publisher<"u"&&typeof w.publisher!="string")return i.push([T.default.Error,D.localize(0,null)]),i;if(typeof w.name!="string")return i.push([T.default.Error,D.localize(1,null,"name")]),i;if(typeof w.version!="string")return i.push([T.default.Error,D.localize(2,null,"version")]),i;if(!w.engines)return i.push([T.default.Error,D.localize(3,null,"engines")]),i;if(typeof w.engines.vscode!="string")return i.push([T.default.Error,D.localize(4,null,"engines.vscode")]),i;if(typeof w.extensionDependencies<"u"&&!f(w.extensionDependencies))return i.push([T.default.Error,D.localize(5,null,"extensionDependencies")]),i;if(typeof w.activationEvents<"u"){if(!f(w.activationEvents))return i.push([T.default.Error,D.localize(6,null,"activationEvents")]),i;if(typeof w.main>"u"&&typeof w.browser>"u")return i.push([T.default.Error,D.localize(7,null,"activationEvents","main")]),i}if(typeof w.extensionKind<"u"&&typeof w.main>"u"&&i.push([T.default.Warning,D.localize(8,null,"extensionKind")]),typeof w.main<"u"){if(typeof w.main!="string")return i.push([T.default.Error,D.localize(9,null,"main")]),i;{const n=(0,k.joinPath)(p,w.main);(0,k.isEqualOrParent)(n,p)||i.push([T.default.Warning,D.localize(10,null,n.path,p.path)])}if(typeof w.activationEvents>"u")return i.push([T.default.Error,D.localize(11,null,"activationEvents","main")]),i}if(typeof w.browser<"u"){if(typeof w.browser!="string")return i.push([T.default.Error,D.localize(12,null,"browser")]),i;{const n=(0,k.joinPath)(p,w.browser);(0,k.isEqualOrParent)(n,p)||i.push([T.default.Warning,D.localize(13,null,n.path,p.path)])}if(typeof w.activationEvents>"u")return i.push([T.default.Error,D.localize(14,null,"activationEvents","browser")]),i}if(!l.valid(w.version))return i.push([T.default.Error,D.localize(15,null)]),i;const o=[];if(!y(c,d,w,R,o))for(const n of o)i.push([T.default.Error,n]);return i}e.validateExtensionManifest=m;function y(c,d,p,w,R){return w||typeof p.main>"u"&&typeof p.browser>"u"?!0:S(c,d,p.engines.vscode,R)}e.isValidExtensionVersion=y;function u(c,d,p){return c==="*"||S(d,p,c)}e.isEngineValid=u;function S(c,d,p,w=[]){const R=C(E(p));if(!R)return w.push(D.localize(16,null,p)),!1;if(R.majorBase===0){if(!R.majorMustEqual||!R.minorMustEqual)return w.push(D.localize(17,null,p)),!1}else if(!R.majorMustEqual)return w.push(D.localize(18,null,p)),!1;return b(c,d,R)?!0:(w.push(D.localize(19,null,c,p)),!1)}function f(c){if(!Array.isArray(c))return!1;for(let d=0,p=c.length;d<p;d++)if(typeof c[d]!="string")return!1;return!0}}),define(oe[45],ae([0,1,17,31]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(l,O,P){let I=P&&P.get("storage.serviceMachineId",-1)||null;if(I)return I;try{const C=(await O.readFile(l.serviceMachineIdResource)).value.toString();I=(0,T.isUUID)(C)?C:null}catch{I=null}if(!I){I=(0,T.generateUuid)();try{await O.writeFile(l.serviceMachineIdResource,k.VSBuffer.fromString(I))}catch{}}return P?.store("storage.serviceMachineId",I,-1,1),I}e.getServiceMachineId=D}),define(oe[55],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(D,l=[],O=!1){this.ctor=D,this.staticArguments=l,this.supportsDelayedInstantiation=O}}e.SyncDescriptor=k}),define(oe[71],ae([0,1,55]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const T=[];var D;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function l(P,I,E){I instanceof k.SyncDescriptor||(I=new k.SyncDescriptor(I,[],Boolean(E))),T.push([P,I])}e.registerSingleton=l;function O(){return T}e.getSingletonServiceDescriptors=O}),define(oe[196],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(l,O){this.key=l,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.Node=k;class T{constructor(l){this.b=l,this.a=new Map}roots(){const l=[];for(const O of this.a.values())O.outgoing.size===0&&l.push(O);return l}insertEdge(l,O){const P=this.lookupOrInsertNode(l),I=this.lookupOrInsertNode(O);P.outgoing.set(I.key,I),I.incoming.set(P.key,P)}removeNode(l){const O=this.b(l);this.a.delete(O);for(const P of this.a.values())P.outgoing.delete(O),P.incoming.delete(O)}lookupOrInsertNode(l){const O=this.b(l);let P=this.a.get(O);return P||(P=new k(O,l),this.a.set(O,P)),P}lookup(l){return this.a.get(this.b(l))}isEmpty(){return this.a.size===0}toString(){const l=[];for(const[O,P]of this.a)l.push(`${O}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return l.join(`
`)}findCycleSlow(){for(const[l,O]of this.a){const P=new Set([l]),I=this.c(O,P);if(I)return I}}c(l,O){for(const[P,I]of l.outgoing){if(O.has(P))return[...O,P].join(" -> ");O.add(P);const E=this.c(I,O);if(E)return E;O.delete(P)}}}e.Graph=T}),define(oe[5],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function P(I){return I[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=P})(k=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function T(O,P,I){P[k.DI_TARGET]===P?P[k.DI_DEPENDENCIES].push({id:O,index:I}):(P[k.DI_DEPENDENCIES]=[{id:O,index:I}],P[k.DI_TARGET]=P)}function D(O){if(k.serviceIds.has(O))return k.serviceIds.get(O);const P=function(I,E,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(P,I,C)};return P.toString=()=>O,k.serviceIds.set(O,P),P}e.createDecorator=D;function l(O){return O}e.refineServiceDecorator=l}),define(oe[197],ae([0,1,5]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,k.createDecorator)("checksumService")}),define(oe[16],ae([0,1,12,11,5]),function(Q,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function l(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof T.URI)}e.isConfigurationOverrides=l;function O(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof T.URI)}e.isConfigurationUpdateOverrides=O;var P;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=I;function E(c,d){const p=Object.create(null);for(const w in c)C(p,w,c[w],d);return p}e.toValuesTree=E;function C(c,d,p,w){const R=d.split("."),i=R.pop();let o=c;for(let t=0;t<R.length;t++){const n=R[t];let s=o[n];switch(typeof s){case"undefined":s=o[n]=Object.create(null);break;case"object":break;default:w(`Ignoring ${d} as ${R.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[i]=p}catch{w(`Ignoring ${d} as ${R.join(".")} is ${JSON.stringify(o)}`)}else w(`Ignoring ${d} as ${R.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=C;function b(c,d){const p=d.split(".");m(c,p)}e.removeFromValueTree=b;function m(c,d){const p=d.shift();if(d.length===0){delete c[p];return}if(Object.keys(c).indexOf(p)!==-1){const w=c[p];typeof w=="object"&&!Array.isArray(w)&&(m(w,d),Object.keys(w).length===0&&delete c[p])}}function y(c,d,p){function w(o,t){let n=o;for(const s of t){if(typeof n!="object"||n===null)return;n=n[s]}return n}const R=d.split("."),i=w(c,R);return typeof i>"u"?p:i}e.getConfigurationValue=y;function u(c,d,p){Object.keys(d).forEach(w=>{w!=="__proto__"&&(w in c?k.isObject(c[w])&&k.isObject(d[w])?u(c[w],d[w],p):p&&(c[w]=d[w]):c[w]=d[w])})}e.merge=u;function S(c,d,p){const w=c.inspect(d),R=c.inspect(p);return typeof w.userValue<"u"||typeof w.workspaceValue<"u"||typeof w.workspaceFolderValue<"u"?w.value:typeof R.userValue<"u"||typeof R.workspaceValue<"u"||typeof R.workspaceFolderValue<"u"?R.value:w.defaultValue}e.getMigratedSettingValue=S;function f(c){return c.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=f}),define(oe[198],ae([0,1,4,27,5]),function(Q,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",k.isMacintosh),l.set("isLinux",k.isLinux),l.set("isWindows",k.isWindows),l.set("isWeb",k.isWeb),l.set("isMacNative",k.isMacintosh&&!k.isWeb),l.set("isEdge",k.isEdge),l.set("isFirefox",k.isFirefox),l.set("isChrome",k.isChrome),l.set("isSafari",k.isSafari);const O=Object.prototype.hasOwnProperty;var P;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return b.INSTANCE}static true(){return m.INSTANCE}static has(L){return y.create(L)}static equals(L,$){return u.create(L,$)}static notEquals(L,$){return c.create(L,$)}static regex(L,$){return t.create(L,$)}static in(L,$){return S.create(L,$)}static notIn(L,$){return f.create(L,$)}static not(L){return d.create(L)}static and(...L){return a.create(L,null,!0)}static or(...L){return r.create(L,null,!0)}static greater(L,$){return w.create(L,$)}static greaterEquals(L,$){return R.create(L,$)}static smaller(L,$){return i.create(L,$)}static smallerEquals(L,$){return o.create(L,$)}static deserialize(L,$=!1){if(!!L)return this.c(L,$)}static c(L,$){const z=L.split("||");return r.create(z.map(x=>this.d(x,$)),null,!0)}static d(L,$){const z=L.split("&&");return a.create(z.map(x=>this.f(x,$)),null,!0)}static f(L,$){if(L=L.trim(),L.indexOf("!=")>=0){const z=L.split("!=");return c.create(z[0].trim(),this.g(z[1],$))}if(L.indexOf("==")>=0){const z=L.split("==");return u.create(z[0].trim(),this.g(z[1],$))}if(L.indexOf("=~")>=0){const z=L.split("=~");return t.create(z[0].trim(),this.h(z[1],$))}if(L.indexOf(" not in ")>=0){const z=L.split(" not in ");return f.create(z[0].trim(),this.g(z[1],$))}if(L.indexOf(" in ")>=0){const z=L.split(" in ");return S.create(z[0].trim(),this.g(z[1],$))}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const z=L.split(">=");return R.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const z=L.split(">");return w.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const z=L.split("<=");return o.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const z=L.split("<");return i.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(L)?d.create(L.substr(1).trim()):y.create(L)}static g(L,$){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;const z=/^'([^']*)'$/.exec(L);return z?z[1].trim():L}static h(L,$){if((0,T.isFalsyOrWhitespace)(L)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const z=L.indexOf("/"),x=L.lastIndexOf("/");if(z===x||z<0){if($)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}const X=L.slice(z+1,x),ie=L[x+1]==="i"?"i":"";try{return new RegExp(X,ie)}catch(H){if($)throw new Error(`bad regexp-value '${L}', parse error: ${H}`);return console.warn(`bad regexp-value '${L}', parse error: ${H}`),null}}}e.ContextKeyExpr=I;function E(M,L){const $=M?M.substituteConstants():void 0,z=L?L.substituteConstants():void 0;return!$&&!z?!0:!$||!z?!1:$.equals(z)}e.expressionsAreEqualWithConstantSubstitution=E;function C(M,L){return M.cmp(L)}class b{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=b,b.INSTANCE=new b;class m{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class y{static create(L,$=null){const z=l.get(L);return typeof z=="boolean"?z?m.INSTANCE:b.INSTANCE:new y(L,$)}constructor(L,$){this.key=L,this.c=$,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:g(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=l.get(this.key);return typeof L=="boolean"?L?m.INSTANCE:b.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.c||(this.c=d.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=y;class u{static create(L,$,z=null){if(typeof $=="boolean")return $?y.create(L,z):d.create(L,z);const x=l.get(L);return typeof x=="boolean"?$===(x?"true":"false")?m.INSTANCE:b.INSTANCE:new u(L,$,z)}constructor(L,$,z){this.c=L,this.d=$,this.f=z,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:v(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=l.get(this.c);if(typeof L=="boolean"){const $=L?"true":"false";return this.d===$?m.INSTANCE:b.INSTANCE}return this}evaluate(L){return L.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(L){return L.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=c.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=u;class S{static create(L,$){return new S(L,$)}constructor(L,$){this.d=L,this.f=$,this.type=10,this.c=null}cmp(L){return L.type!==this.type?this.type-L.type:v(this.d,this.f,L.d,L.f)}equals(L){return L.type===this.type?this.d===L.d&&this.f===L.f:!1}substituteConstants(){return this}evaluate(L){const $=L.getValue(this.f),z=L.getValue(this.d);return Array.isArray($)?$.includes(z):typeof z=="string"&&typeof $=="object"&&$!==null?O.call($,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(L){return L.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=S;class f{static create(L,$){return new f(L,$)}constructor(L,$){this.d=L,this.f=$,this.type=11,this.c=S.create(L,$)}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(L){return L.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=f;class c{static create(L,$,z=null){if(typeof $=="boolean")return $?d.create(L,z):y.create(L,z);const x=l.get(L);return typeof x=="boolean"?$===(x?"true":"false")?b.INSTANCE:m.INSTANCE:new c(L,$,z)}constructor(L,$,z){this.c=L,this.d=$,this.f=z,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:v(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=l.get(this.c);if(typeof L=="boolean"){const $=L?"true":"false";return this.d===$?b.INSTANCE:m.INSTANCE}return this}evaluate(L){return L.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(L){return L.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=u.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=c;class d{static create(L,$=null){const z=l.get(L);return typeof z=="boolean"?z?b.INSTANCE:m.INSTANCE:new d(L,$)}constructor(L,$){this.c=L,this.d=$,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:g(this.c,L.c)}equals(L){return L.type===this.type?this.c===L.c:!1}substituteConstants(){const L=l.get(this.c);return typeof L=="boolean"?L?b.INSTANCE:m.INSTANCE:this}evaluate(L){return!L.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(L){return L.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.ContextKeyNotExpr=d;function p(M,L){if(typeof M=="string"){const $=parseFloat(M);isNaN($)||(M=$)}return typeof M=="string"||typeof M=="number"?L(M):b.INSTANCE}class w{static create(L,$,z=null){return p($,x=>new w(L,x,z))}constructor(L,$,z){this.c=L,this.d=$,this.f=z,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:v(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=o.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=w;class R{static create(L,$,z=null){return p($,x=>new R(L,x,z))}constructor(L,$,z){this.c=L,this.d=$,this.f=z,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:v(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=R;class i{static create(L,$,z=null){return p($,x=>new i(L,x,z))}constructor(L,$,z){this.c=L,this.d=$,this.f=z,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:v(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=i;class o{static create(L,$,z=null){return p($,x=>new o(L,x,z))}constructor(L,$,z){this.c=L,this.d=$,this.f=z,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:v(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=o;class t{static create(L,$){return new t(L,$)}constructor(L,$){this.d=L,this.f=$,this.type=7,this.c=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.d<L.d)return-1;if(this.d>L.d)return 1;const $=this.f?this.f.source:"",z=L.f?L.f.source:"";return $<z?-1:$>z?1:0}equals(L){if(L.type===this.type){const $=this.f?this.f.source:"",z=L.f?L.f.source:"";return this.d===L.d&&$===z}return!1}substituteConstants(){return this}evaluate(L){const $=L.getValue(this.d);return this.f?this.f.test($):!1}serialize(){const L=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${L}`}keys(){return[this.d]}map(L){return L.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=n.create(this)),this.c}}e.ContextKeyRegexExpr=t;class n{static create(L){return new n(L)}constructor(L){this.c=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(L){return new n(this.c.map(L))}negate(){return this.c}}e.ContextKeyNotRegexExpr=n;function s(M){let L=null;for(let $=0,z=M.length;$<z;$++){const x=M[$].substituteConstants();if(M[$]!==x&&L===null){L=[];for(let X=0;X<$;X++)L[X]=M[X]}L!==null&&(L[$]=x)}return L===null?M:L}class a{static create(L,$,z){return a.d(L,$,z)}constructor(L,$){this.expr=L,this.c=$,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let $=0,z=this.expr.length;$<z;$++){const x=C(this.expr[$],L.expr[$]);if(x!==0)return x}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let $=0,z=this.expr.length;$<z;$++)if(!this.expr[$].equals(L.expr[$]))return!1;return!0}return!1}substituteConstants(){const L=s(this.expr);return L===this.expr?this:a.create(L,this.c,!1)}evaluate(L){for(let $=0,z=this.expr.length;$<z;$++)if(!this.expr[$].evaluate(L))return!1;return!0}static d(L,$,z){const x=[];let X=!1;for(const ie of L)if(!!ie){if(ie.type===1){X=!0;continue}if(ie.type===0)return b.INSTANCE;if(ie.type===6){x.push(...ie.expr);continue}x.push(ie)}if(x.length===0&&X)return m.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(C);for(let ie=1;ie<x.length;ie++)x[ie-1].equals(x[ie])&&(x.splice(ie,1),ie--);if(x.length===1)return x[0];for(;x.length>1;){const ie=x[x.length-1];if(ie.type!==9)break;x.pop();const H=x.pop(),j=x.length===0,V=r.create(ie.expr.map(J=>a.create([J,H],null,z)),null,j);V&&(x.push(V),x.sort(C))}if(x.length===1)return x[0];if(z){for(let ie=0;ie<x.length;ie++)for(let H=ie+1;H<x.length;H++)if(x[ie].negate().equals(x[H]))return b.INSTANCE;if(x.length===1)return x[0]}return new a(x,$)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const $ of this.expr)L.push(...$.keys());return L}map(L){return new a(this.expr.map($=>$.map(L)),null)}negate(){if(!this.c){const L=[];for(const $ of this.expr)L.push($.negate());this.c=r.create(L,this,!0)}return this.c}}class r{static create(L,$,z){return r.d(L,$,z)}constructor(L,$){this.expr=L,this.c=$,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let $=0,z=this.expr.length;$<z;$++){const x=C(this.expr[$],L.expr[$]);if(x!==0)return x}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let $=0,z=this.expr.length;$<z;$++)if(!this.expr[$].equals(L.expr[$]))return!1;return!0}return!1}substituteConstants(){const L=s(this.expr);return L===this.expr?this:r.create(L,this.c,!1)}evaluate(L){for(let $=0,z=this.expr.length;$<z;$++)if(this.expr[$].evaluate(L))return!0;return!1}static d(L,$,z){let x=[],X=!1;if(L){for(let ie=0,H=L.length;ie<H;ie++){const j=L[ie];if(!!j){if(j.type===0){X=!0;continue}if(j.type===1)return m.INSTANCE;if(j.type===9){x=x.concat(j.expr);continue}x.push(j)}}if(x.length===0&&X)return b.INSTANCE;x.sort(C)}if(x.length!==0){if(x.length===1)return x[0];for(let ie=1;ie<x.length;ie++)x[ie-1].equals(x[ie])&&(x.splice(ie,1),ie--);if(x.length===1)return x[0];if(z){for(let ie=0;ie<x.length;ie++)for(let H=ie+1;H<x.length;H++)if(x[ie].negate().equals(x[H]))return m.INSTANCE;if(x.length===1)return x[0]}return new r(x,$)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const $ of this.expr)L.push(...$.keys());return L}map(L){return new r(this.expr.map($=>$.map(L)),null)}negate(){if(!this.c){const L=[];for(const $ of this.expr)L.push($.negate());for(;L.length>1;){const $=L.shift(),z=L.shift(),x=[];for(const X of F($))for(const ie of F(z))x.push(a.create([X,ie],null,!1));L.unshift(r.create(x,null,!1))}this.c=r.create(L,this,!0)}return this.c}}class h extends y{static all(){return h.d.values()}constructor(L,$,z){super(L,null),this.f=$,typeof z=="object"?h.d.push({...z,key:L}):z!==!0&&h.d.push({key:L,description:z,type:$!=null?typeof $:void 0})}bindTo(L){return L.createKey(this.key,this.f)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return u.create(this.key,L)}notEqualsTo(L){return c.create(this.key,L)}}e.RawContextKey=h,h.d=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService");function g(M,L){return M<L?-1:M>L?1:0}function v(M,L,$,z){return M<$?-1:M>$?1:L<z?-1:L>z?1:0}function A(M,L){if(M.type===0||L.type===1)return!0;if(M.type===9)return L.type===9?N(M.expr,L.expr):!1;if(L.type===9){for(const $ of L.expr)if(A(M,$))return!0;return!1}if(M.type===6){if(L.type===6)return N(L.expr,M.expr);for(const $ of M.expr)if(A($,L))return!0;return!1}return M.equals(L)}e.implies=A;function N(M,L){let $=0,z=0;for(;$<M.length&&z<L.length;){const x=M[$].cmp(L[z]);if(x<0)return!1;x===0&&$++,z++}return $===M.length}function F(M){return M.type===9?M.expr:[M]}}),define(oe[96],ae([0,1,5]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function T(l){return!!l.hostName&&!!l.errorMessage}e.isRemoteDiagnosticError=T;class D{async getPerformanceInfo(O,P){return{}}async getSystemInfo(O,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,P){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.NullDiagnosticsService=D}),define(oe[97],ae([0,1,5]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(oe[15],ae([0,1,5]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(oe[30],ae([0,1,158,5]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function l(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=l;function O(c,d){switch(c){case 3:return d==="x64"?"win32-x64":d==="ia32"?"win32-ia32":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=O;function P(c,d){return d==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function I(c,d,p){return P(d,p)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===p?!0:E(p).includes(c)}e.isTargetPlatformCompatible=I;function E(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=E;function C(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=C;var b;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var m;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var y;(function(c){c.Install="install",c.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var u;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(u=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var S;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Internal="Internal",c.Signature="Signature"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class f extends Error{constructor(d,p){super(d),this.code=p,this.name=p}}e.ExtensionManagementError=f,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,k.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(oe[199],ae([0,1,3,2,67,32,11,145,30]),function(Q,e,k,T,D,l,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function E(f,c){return O.URI.revive(c?c.transformIncoming(f):f)}function C(f,c){return c?c.transformOutgoingURI(f):f}function b(f,c){c=c||P.DefaultURITransformer;const d=f.manifest;return{...(0,P.transformAndReviveIncomingURIs)({...f,manifest:void 0},c),manifest:d}}function m(f,c){return c?(0,l.cloneAndChange)(f,d=>d instanceof O.URI?c.transformOutgoingURI(d):void 0):f}class y{constructor(c,d){this.a=c,this.b=d,this.onInstallExtension=k.Event.buffer(c.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(c.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(c.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(c.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=k.Event.buffer(c.onDidUpdateExtensionMetadata,!0)}listen(c,d){const p=this.b(c);switch(d){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,w=>w.map(R=>({...R,local:R.local?m(R.local,p):R.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension;case"onDidUpdateExtensionMetadata":return this.onDidUpdateExtensionMetadata}throw new Error("Invalid listen")}call(c,d,p){const w=this.b(c);switch(d){case"zip":return this.a.zip(b(p[0],w)).then(R=>C(R,w));case"unzip":return this.a.unzip(E(p[0],w));case"install":return this.a.install(E(p[0],w),(0,D.revive)(p[1]));case"installFromLocation":return this.a.installFromLocation(E(p[0],w),O.URI.revive(p[1]));case"getManifest":return this.a.getManifest(E(p[0],w));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(p[0]);case"installFromGallery":return this.a.installFromGallery(p[0],(0,D.revive)(p[1]));case"uninstall":return this.a.uninstall(b(p[0],w),(0,D.revive)(p[1]));case"reinstallFromGallery":return this.a.reinstallFromGallery(b(p[0],w));case"getInstalled":return this.a.getInstalled(p[0],O.URI.revive(p[1])).then(R=>R.map(i=>m(i,w)));case"getMetadata":return this.a.getMetadata(b(p[0],w),O.URI.revive(p[1]));case"updateMetadata":return this.a.updateMetadata(b(p[0],w),p[1],O.URI.revive(p[2])).then(R=>m(R,w));case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(p[0],p[1])}throw new Error("Invalid call")}}e.ExtensionManagementChannel=y;class u extends T.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(c){super(),this.k=c,this.c=this.B(new k.Emitter),this.f=this.B(new k.Emitter),this.g=this.B(new k.Emitter),this.h=this.B(new k.Emitter),this.j=this.B(new k.Emitter),this.B(this.k.listen("onInstallExtension")(d=>this.c.fire({identifier:d.identifier,source:this.l(d.source)?O.URI.revive(d.source):d.source,profileLocation:O.URI.revive(d.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(d=>this.f.fire(d.map(p=>({...p,local:p.local?b(p.local,null):p.local,source:this.l(p.source)?O.URI.revive(p.source):p.source,profileLocation:O.URI.revive(p.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(d=>this.g.fire({identifier:d.identifier,profileLocation:O.URI.revive(d.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(d=>this.h.fire({...d,profileLocation:O.URI.revive(d.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(d=>this.j.fire(b(d,null))))}l(c){return c?typeof c.path=="string"&&typeof c.scheme=="string":!1}getTargetPlatform(){return this.m||(this.m=this.k.call("getTargetPlatform")),this.m}async canInstall(c){const d=await this.getTargetPlatform();return c.allTargetPlatforms.some(p=>(0,I.isTargetPlatformCompatible)(p,c.allTargetPlatforms,d))}zip(c){return Promise.resolve(this.k.call("zip",[c]).then(d=>O.URI.revive(d)))}unzip(c){return Promise.resolve(this.k.call("unzip",[c]))}install(c,d){return Promise.resolve(this.k.call("install",[c,d])).then(p=>b(p,null))}installFromLocation(c,d){return Promise.resolve(this.k.call("installFromLocation",[c,d])).then(p=>b(p,null))}getManifest(c){return Promise.resolve(this.k.call("getManifest",[c]))}installFromGallery(c,d){return Promise.resolve(this.k.call("installFromGallery",[c,d])).then(p=>b(p,null))}uninstall(c,d){return Promise.resolve(this.k.call("uninstall",[c,d]))}reinstallFromGallery(c){return Promise.resolve(this.k.call("reinstallFromGallery",[c])).then(d=>b(d,null))}getInstalled(c=null,d){return Promise.resolve(this.k.call("getInstalled",[c,d])).then(p=>p.map(w=>b(w,null)))}getMetadata(c,d){return Promise.resolve(this.k.call("getMetadata",[c,d]))}updateMetadata(c,d,p){return Promise.resolve(this.k.call("updateMetadata",[c,d,p])).then(w=>b(w,null))}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(c,d){const p=await this.k.call("download",[c,d]);return O.URI.revive(p)}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=u;class S{constructor(c){this.a=c}listen(c,d){throw new Error("Invalid listen")}call(c,d,p){switch(d){case"getConfigBasedTips":return this.a.getConfigBasedTips(O.URI.revive(p[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=S}),define(oe[98],ae([0,1,5]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,k.createDecorator)("IExtensionSignatureVerificationService");class T{b(){return this.a||(this.a=new Promise((l,O)=>Q(["node-vsce-sign"],async P=>l(P),O))),this.a}async verify(l,O){let P;try{P=await this.b()}catch{return!1}return P.verify(l,O)}}e.ExtensionSignatureVerificationService=T}),define(oe[99],ae([0,1,5]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var T;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(T=e.RecommendationSource||(e.RecommendationSource={}));function D(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var l;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(l=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,k.createDecorator)("IExtensionRecommendationNotificationService")}),define(oe[14],ae([0,1,49,13,27,12,11,166,5,4]),function(Q,e,k,T,D,l,O,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function C(j){return j.create===!0}e.isFileOpenForWriteOptions=C;var b;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var m;(function(j){j[j.Readonly=1]="Readonly"})(m=e.FilePermission||(e.FilePermission={}));var y;(function(j){j[j.None=0]="None",j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock",j[j.FileAtomicRead=16384]="FileAtomicRead",j[j.FileClone=32768]="FileClone"})(y=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function u(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=u;function S(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=S;function f(j){return!!(j.capabilities&32768)}e.hasFileCloneCapability=f;function c(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function d(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=d;function p(j){return u(j)?!!(j.capabilities&16384):!1}e.hasFileAtomicReadCapability=p;var w;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class R extends Error{constructor(V,J){super(V),this.code=J}}e.FileSystemProviderError=R;function i(j,V){const J=new R(j.toString(),V);return t(J,V),J}e.createFileSystemProviderError=i;function o(j){return j||i((0,P.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=o;function t(j,V){return j.name=V?`${V} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=t;function n(j){if(!j)return w.Unknown;if(j instanceof R)return j.code;const V=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!V)return w.Unknown;switch(V[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=n;function s(j){if(j instanceof A)return j.fileOperationResult;switch(n(j)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var a;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY",j[j.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class r{constructor(V,J,_){this.resource=V,this.operation=J,this.target=_}isOperation(V){return this.operation===V}}e.FileOperationEvent=r;var h;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class g{constructor(V,J){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const _=new Map;for(const re of V){const te=_.get(re.type);switch(te?te.push([re.resource,re]):_.set(re.type,[[re.resource,re]]),re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}}for(const[re,te]of _)switch(re){case 1:this.a=k.TernarySearchTree.forUris(()=>J),this.a.fill(te);break;case 0:this.b=k.TernarySearchTree.forUris(()=>J),this.b.fill(te);break;case 2:this.c=k.TernarySearchTree.forUris(()=>J),this.c.fill(te);break}}contains(V,...J){return this.d(V,{includeChildren:!1},...J)}affects(V,...J){return this.d(V,{includeChildren:!0},...J)}d(V,J,..._){if(!V)return!1;const re=_.length>0;return!!((!re||_.includes(1))&&(this.a?.get(V)||J.includeChildren&&this.a?.findSuperstr(V))||(!re||_.includes(0))&&(this.b?.get(V)||J.includeChildren&&this.b?.findSuperstr(V))||(!re||_.includes(2))&&(this.c?.findSubstr(V)||J.includeChildren&&this.c?.findSuperstr(V)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=g;function v(j,V,J){return!j||!V||j===V||V.length>j.length?!1:(V.charAt(V.length-1)!==T.sep&&(V+=T.sep),J?(0,D.startsWithIgnoreCase)(j,V):j.indexOf(V)===0)}e.isParent=v;class A extends Error{constructor(V,J,_){super(V),this.fileOperationResult=J,this.options=_}}e.FileOperationError=A;class N extends A{constructor(V,J,_,re){super(V,J,re),this.fileOperationResult=J,this.size=_}}e.TooLargeFileOperationError=N;class F extends A{constructor(V,J,_){super(V,2,_),this.stat=J}}e.NotModifiedSinceFileOperationError=F;var M;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(M=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var L;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(L=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function $(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=$;async function z(j,V){if(!V.hasProvider(O.URI.from({scheme:j.scheme})))return new Promise(J=>{const _=V.onDidChangeFileSystemProviderRegistrations(re=>{re.scheme===j.scheme&&re.added&&(_.dispose(),J())})})}e.whenProviderRegistered=z,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class x{static formatSize(V){return(0,l.isNumber)(V)||(V=0),V<x.KB?(0,P.localize)(1,null,V.toFixed(0)):V<x.MB?(0,P.localize)(2,null,(V/x.KB).toFixed(2)):V<x.GB?(0,P.localize)(3,null,(V/x.MB).toFixed(2)):V<x.TB?(0,P.localize)(4,null,(V/x.GB).toFixed(2)):(0,P.localize)(5,null,(V/x.TB).toFixed(2))}}e.ByteSize=x,x.KB=1024,x.MB=x.KB*x.KB,x.GB=x.MB*x.KB,x.TB=x.GB*x.KB;var X;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(X=e.Arch||(e.Arch={}));function ie(j){return{maxFileSize:j===0?300*x.MB:16*x.GB,maxHeapSize:j===0?700*x.MB:2*700*x.MB}}e.getPlatformFileLimits=ie;function H(j){return E.isWeb?j?10*x.MB:50*x.MB:j?100*x.MB:1024*x.MB}e.getLargeFileConfirmationLimit=H});var G=this&&this.__param||function(Q,e){return function(k,T){e(k,T,Q)}};define(oe[200],ae([0,1,100,44,14]),function(Q,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let l=class{constructor(P){this.a=P}async checksum(P){const I=(await this.a.readFileStream(P)).value;return new Promise((E,C)=>{const b=(0,k.createHash)("md5");(0,T.listenStream)(I,{onData:m=>b.update(m.buffer),onError:m=>C(m),onEnd:()=>E(b.digest("base64").replace(/=+$/,""))})})}};l=ye([G(0,D.IFileService)],l),e.ChecksumService=l}),define(oe[201],ae([0,1,17,38,9,3,2,44,11,31,14]),function(Q,e,k,T,D,l,O,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class b extends O.Disposable{constructor(y,u){super(),this.a=y,this.b=u,this.onDidChangeCapabilities=l.Event.None,this.f=this.B(new l.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new l.Emitter),this.onDidWatchError=this.g.event,this.h=(0,E.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(y){return this.a.call("stat",[y])}readdir(y){return this.a.call("readdir",[y])}async readFile(y,u){const{buffer:S}=await this.a.call("readFile",[y,u]);return S}readFileStream(y,u,S){const f=(0,P.newWriteableStream)(d=>k.VSBuffer.concat(d.map(p=>k.VSBuffer.wrap(p))).buffer),c=this.a.listen("readFileStream",[y,u])(d=>{if(d instanceof k.VSBuffer)f.write(d.buffer);else{if(d==="end")f.end();else{let p;if(d instanceof Error)p=d;else{const w=d;p=(0,C.createFileSystemProviderError)(w.message??(0,T.toErrorMessage)(w),w.code??C.FileSystemProviderErrorCode.Unknown)}f.error(p),f.end()}c.dispose()}});return S.onCancellationRequested(()=>{f.error((0,D.canceled)()),f.end(),c.dispose()}),f}writeFile(y,u,S){return this.a.call("writeFile",[y,k.VSBuffer.wrap(u),S])}open(y,u){return this.a.call("open",[y,u])}close(y){return this.a.call("close",[y])}async read(y,u,S,f,c){const[d,p]=await this.a.call("read",[y,u,c]);return S.set(d.buffer.slice(0,p),f),p}write(y,u,S,f,c){return this.a.call("write",[y,u,k.VSBuffer.wrap(S),f,c])}mkdir(y){return this.a.call("mkdir",[y])}delete(y,u){return this.a.call("delete",[y,u])}rename(y,u,S){return this.a.call("rename",[y,u,S])}copy(y,u,S){return this.a.call("copy",[y,u,S])}cloneFile(y,u){return this.a.call("cloneFile",[y,u])}i(){this.B(this.a.listen("fileChange",[this.h])(y=>{if(Array.isArray(y)){const u=y;this.f.fire(u.map(S=>({resource:I.URI.revive(S.resource),type:S.type})))}else{const u=y;this.g.fire(u)}}))}watch(y,u){const S=(0,E.generateUuid)();return this.a.call("watch",[this.h,S,y,u]),(0,O.toDisposable)(()=>this.a.call("unwatch",[this.h,S]))}}e.DiskFileSystemProviderClient=b}),define(oe[101],ae([0,1,17,9,167,14]),function(Q,e,k,T,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function O(C,b,m,y,u,S){let f;try{await P(C,b,m,y,u,S)}catch(c){f=c}finally{f&&u.errorTransformer&&(f=u.errorTransformer(f)),typeof f<"u"&&m.error(f),m.end()}}e.readFileIntoStream=O;async function P(C,b,m,y,u,S){I(S);const f=await C.open(b,{create:!1});try{I(S);let c=0,d=0,p=u&&typeof u.length=="number"?u.length:void 0,w=k.VSBuffer.alloc(Math.min(u.bufferSize,typeof p=="number"?p:u.bufferSize)),R=u&&typeof u.position=="number"?u.position:0,i=0;do d=await C.read(f,R,w.buffer,i,w.byteLength-i),R+=d,i+=d,c+=d,typeof p=="number"&&(p-=d),i===w.byteLength&&(await m.write(y(w)),w=k.VSBuffer.alloc(Math.min(u.bufferSize,typeof p=="number"?p:u.bufferSize)),i=0);while(d>0&&(typeof p!="number"||p>0)&&I(S)&&E(c,u));if(i>0){let o=i;typeof p=="number"&&(o=Math.min(i,p)),m.write(y(w.slice(0,o)))}}catch(c){throw(0,l.ensureFileSystemProviderError)(c)}finally{await C.close(f)}}function I(C){if(C.isCancellationRequested)throw(0,T.canceled)();return!0}function E(C,b){if(b?.limits){if(typeof b.limits.memory=="number"&&C>b.limits.memory)throw(0,l.createFileSystemProviderError)((0,D.localize)(0,null),l.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&C>b.limits.size)throw(0,l.createFileSystemProviderError)((0,D.localize)(1,null),l.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(oe[56],ae([0,1,90,2,13,4,11,14]),function(Q,e,k,T,D,l,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function I(c){return c.recursive===!0}e.isRecursiveWatchRequest=I;class E extends T.Disposable{constructor(d,p,w,R){super(),this.h=d,this.i=p,this.j=w,this.k=R,this.c=this.B(new T.MutableDisposable),this.f=void 0,this.g=0}m(){const d=new T.DisposableStore;this.c.value=d,this.b=this.l(d),this.b.setVerboseLogging(this.j),d.add(this.b.onDidChangeFile(p=>this.h(p))),d.add(this.b.onDidLogMessage(p=>this.i(p))),d.add(this.b.onDidError(p=>this.n(p)))}n(d){this.k.restartOnError?this.g<E.a&&this.f?(this.r(`restarting watcher after error: ${d}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${d}`):this.r(d)}p(d){this.g++,this.m(),this.watch(d)}async watch(d){this.f=d,await this.b?.watch(d)}async setVerboseLogging(d){this.j=d,await this.b?.setVerboseLogging(d)}r(d){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${d}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=E,E.a=5;class C extends E{constructor(d,p,w){super(d,p,w,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=C;class b extends E{constructor(d,p,w){super(d,p,w,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function m(c){return c.map(d=>({type:d.type,resource:O.URI.file(d.path)}))}e.toFileChanges=m;function y(c){const d=new f;for(const p of c)d.processEvent(p);return d.coalesce()}e.coalesceEvents=y;function u(c,d){return typeof d=="string"&&!d.startsWith(k.GLOBSTAR)&&!(0,D.isAbsolute)(d)?{base:c,pattern:d}:d}e.normalizeWatcherPattern=u;function S(c,d){const p=[];for(const w of d)p.push((0,k.parse)(u(c,w)));return p}e.parseWatcherPatterns=S;class f{constructor(){this.a=new Set,this.b=new Map}c(d){return l.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const p=this.b.get(this.c(d));let w=!1;if(p){const R=p.type,i=d.type;p.path!==d.path&&(d.type===2||d.type===1)?w=!0:R===1&&i===2?(this.b.delete(this.c(d)),this.a.delete(p)):R===2&&i===1?p.type=0:R===1&&i===0||(p.type=i)}else w=!0;w&&(this.a.add(d),this.b.set(this.c(d),d))}coalesce(){const d=[],p=[];return Array.from(this.a).filter(w=>w.type!==2?(d.push(w),!1):!0).sort((w,R)=>w.path.length-R.path.length).filter(w=>p.some(R=>(0,P.isParent)(w.path,R,!l.isLinux))?!1:(p.push(w.path),!0)).concat(d)}}}),define(oe[202],ae([0,1,53,6,25,48,2,85,13,4,147,28,56]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class y extends O.Disposable{constructor(f,c,d,p){super(),this.j=f,this.k=c,this.l=d,this.m=p,this.c=this.B(new T.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},w=>this.k(w))),this.f=this.B(new T.RunOnceWorker(w=>this.u(w),y.b)),this.g=(0,m.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,m.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new D.CancellationTokenSource,this.ready=this.n()}async n(){try{const f=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const c=await b.Promises.stat(f);this.B(await this.s(f,c.isDirectory()))}catch(f){f.code!=="ENOENT"?this.w(f):this.z(f)}}async r(f){let c=f.path;try{c=await b.Promises.realpath(f.path),f.path===c&&(c=await(0,C.realcase)(f.path)??f.path),f.path!==c&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${c})`)}catch{}return c}async s(f,c){if(E.isMacintosh&&(0,l.isEqualOrParent)(f,"/Volumes/",!0))return this.w(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),O.Disposable.None;const d=new D.CancellationTokenSource(this.i.token),p=new O.DisposableStore;try{const w=(0,I.basename)(f),R=(0,k.watch)(f);p.add((0,O.toDisposable)(()=>{R.removeAllListeners(),R.close()})),this.z(`Started watching: '${f}'`);const i=new Set;if(c)try{for(const t of await b.Promises.readdir(f))i.add(t)}catch(t){this.w(t)}const o=new Map;p.add((0,O.toDisposable)(()=>{for(const[,t]of o)t.dispose();o.clear()})),R.on("error",(t,n)=>{this.w(`Failed to watch ${f} for changes using fs.watch() (${t}, ${n})`),this.dispose()}),R.on("change",(t,n)=>{if(d.token.isCancellationRequested)return;this.z(`[raw] ["${t}"] ${n}`);let s="";if(n&&(s=n.toString(),E.isMacintosh&&(s=(0,P.normalizeNFC)(s))),!(!s||t!=="change"&&t!=="rename"))if(c)if(t==="rename"){o.get(s)?.dispose();const a=setTimeout(async()=>{if(o.delete(s),s===w&&!await b.Promises.exists(f)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const r=await this.v((0,I.join)(f,s));if(d.token.isCancellationRequested)return;let h;r?i.has(s)?h=0:(h=1,i.add(s)):(i.delete(s),h=2),this.t({path:(0,I.join)(this.j.path,s),type:h})},y.a);o.set(s,(0,O.toDisposable)(()=>clearTimeout(a)))}else{let a;i.has(s)?a=0:(a=1,i.add(s)),this.t({path:(0,I.join)(this.j.path,s),type:a})}else if(t==="rename"||s!==w){const a=setTimeout(async()=>{const r=await b.Promises.exists(f);d.token.isCancellationRequested||(r?(this.t({path:this.j.path,type:0},!0),p.add(await this.s(f,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},y.a);p.clear(),p.add((0,O.toDisposable)(()=>clearTimeout(a)))}else this.t({path:this.j.path,type:0},!0)})}catch(w){await b.Promises.exists(f)&&!d.token.isCancellationRequested&&this.w(`Failed to watch ${f} for changes using fs.watch() (${w.toString()})`)}return(0,O.toDisposable)(()=>{d.dispose(!0),p.dispose()})}t(f,c=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`),!c&&this.g.some(d=>d(f.path))?this.m&&this.z(` >> ignored (excluded) ${f.path}`):!c&&this.h&&this.h.length>0&&!this.h.some(d=>d(f.path))?this.m&&this.z(` >> ignored (not included) ${f.path}`):this.f.work(f))}u(f){const c=(0,m.coalesceEvents)(f);if(c.length>0){if(this.m)for(const p of c)this.z(`>> normalized ${p.type===1?"[ADDED]":p.type===2?"[DELETED]":"[CHANGED]"} ${p.path}`);this.c.work(c)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(f){if(E.isLinux)return b.Promises.exists(f);try{const c=(0,I.basename)(f);return(await b.Promises.readdir((0,I.dirname)(f))).some(p=>p===c)}catch(c){return this.z(c),!1}}setVerboseLogging(f){this.m=f}w(f){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}y(f){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}z(f){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=y,y.a=100,y.b=75;async function u(S,f,c,d,p=512){const w=await b.Promises.open(S,"r"),R=Buffer.allocUnsafe(p),i=new D.CancellationTokenSource(d);let o,t=!1;const n={path:S,excludes:[],recursive:!1},s=new y(n,a=>{(async()=>{for(const{type:r}of a)if(r===0){if(t)return;t=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:h}=await b.Promises.read(w,R,0,p,null);if(!h||i.token.isCancellationRequested)break;f(R.slice(0,h))}}catch(h){o=new Error(h),i.dispose(!0)}finally{t=!1}}})()});return await s.ready,c(),new Promise((a,r)=>{i.token.onCancellationRequested(async()=>{s.dispose();try{await b.Promises.close(w)}catch(h){o=new Error(h)}o?r(o):a()})})}e.watchFileContents=u}),define(oe[203],ae([0,1,3,90,2,4,202]),function(Q,e,k,T,D,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends D.Disposable{constructor(){super(...arguments),this.a=this.B(new k.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new k.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=k.Event.None,this.c=new Map,this.f=!1}async watch(E){const C=this.i(E),b=C.filter(y=>{const u=this.c.get(y.path);return u?!(0,T.patternsEquals)(u.request.excludes,y.excludes)||!(0,T.patternsEquals)(u.request.includes,y.includes):!0}),m=Array.from(this.c.values()).filter(({request:y})=>!C.find(u=>u.path===y.path&&(0,T.patternsEquals)(u.excludes,y.excludes)&&(0,T.patternsEquals)(u.includes,y.includes))).map(({request:y})=>y.path);b.length&&this.j(`Request to start watching: ${b.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"})`).join(",")}`),m.length&&this.j(`Request to stop watching: ${m.join(",")}`);for(const y of m)this.h(y);for(const y of b)this.g(y)}g(E){const C=new O.NodeJSFileWatcherLibrary(E,m=>this.a.fire(m),m=>this.b.fire(m),this.f),b={request:E,instance:C};this.c.set(E.path,b)}async stop(){for(const[E]of this.c)this.h(E);this.c.clear()}h(E){const C=this.c.get(E);C&&(this.c.delete(E),C.instance.dispose())}i(E){const C=new Map;for(const b of E){const m=l.isLinux?b.path:b.path.toLowerCase();C.set(m,b)}return Array.from(C.values())}async setVerboseLogging(E){this.f=E;for(const[,C]of this.c)C.instance.setVerboseLogging(E)}j(E){this.f&&this.b.fire({type:"trace",message:this.k(E)})}k(E,C){return C?`[File Watcher (node.js)] ${E} (path: ${C.request.path})`:`[File Watcher (node.js)] ${E}`}}e.NodeJSWatcher=P}),define(oe[204],ae([0,1,56,203]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends k.AbstractNonRecursiveWatcherClient{constructor(O,P,I){super(O,P,I),this.m()}l(){return new T.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(oe[205],ae([0,1,26,39,68,56]),function(Q,e,k,T,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class O extends l.AbstractUniversalWatcherClient{constructor(I,E,C){super(I,E,C),this.m()}l(I){const E=I.add(new D.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return I.add(E.onDidProcessExit(({code:C,signal:b})=>this.n(`terminated by itself with code ${C}, signal: ${b}`))),T.ProxyChannel.toService((0,T.getNextTickChannel)(E.getChannel("watcher")))}}e.UniversalWatcherClient=O}),define(oe[72],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...D){this.a=new Map;for(const[l,O]of D)this.set(l,O)}set(D,l){const O=this.a.get(D);return this.a.set(D,l),O}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.ServiceCollection=k}),define(oe[206],ae([0,1,6,9,2,55,196,5,72,84]),function(Q,e,k,T,D,l,O,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const C=!1;class b extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class m{constructor(f=new I.ServiceCollection,c=!1,d,p=C){this.f=f,this.g=c,this.h=d,this.i=p,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=p?d?._globalGraph??new O.Graph(w=>w):void 0}createChild(f){return new m(f,this.g,this,this.i)}invokeFunction(f,...c){const d=u.traceInvocation(this.i,f);let p=!1;try{return f({get:R=>{if(p)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(R,d);if(!i)throw new Error(`[invokeFunction] unknown service '${R}'`);return i}},...c)}finally{p=!0,d.stop()}}createInstance(f,...c){let d,p;return f instanceof l.SyncDescriptor?(d=u.traceCreation(this.i,f.ctor),p=this.j(f.ctor,f.staticArguments.concat(c),d)):(d=u.traceCreation(this.i,f),p=this.j(f,c,d)),d.stop(),p}j(f,c=[],d){const p=P._util.getServiceDependencies(f).sort((i,o)=>i.index-o.index),w=[];for(const i of p){const o=this.m(i.id,d);o||this.u(`[createInstance] ${f.name} depends on UNKNOWN service ${i.id}.`,!1),w.push(o)}const R=p.length>0?p[0].index:c.length;if(c.length!==R){console.trace(`[createInstance] First service dependency of ${f.name} at position ${R+1} conflicts with ${c.length} static arguments`);const i=R-c.length;i>0?c=c.concat(new Array(i)):c=c.slice(0,R)}return Reflect.construct(f,c.concat(w))}k(f,c){if(this.f.get(f)instanceof l.SyncDescriptor)this.f.set(f,c);else if(this.h)this.h.k(f,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(f){const c=this.f.get(f);return!c&&this.h?this.h.l(f):c}m(f,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const d=this.l(f);return d instanceof l.SyncDescriptor?this.q(f,d,c.branch(f,!0)):(c.branch(f,!1),d)}q(f,c,d){if(this.o.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.o.add(f);try{return this.r(f,c,d)}finally{this.o.delete(f)}}r(f,c,d){const p=new O.Graph(i=>i.id.toString());let w=0;const R=[{id:f,desc:c,_trace:d}];for(;R.length;){const i=R.pop();if(p.lookupOrInsertNode(i),w++>1e3)throw new b(p);for(const o of P._util.getServiceDependencies(i.desc.ctor)){const t=this.l(o.id);if(t||this.u(`[createInstance] ${f} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),t instanceof l.SyncDescriptor){const n={id:o.id,desc:t,_trace:i._trace.branch(o.id,!0)};p.insertEdge(i,n),R.push(n)}}}for(;;){const i=p.roots();if(i.length===0){if(!p.isEmpty())throw new b(p);break}for(const{data:o}of i){if(this.l(o.id)instanceof l.SyncDescriptor){const n=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,n)}p.removeNode(o)}}return this.l(f)}s(f,c,d=[],p,w){if(this.f.get(f)instanceof l.SyncDescriptor)return this.t(f,c,d,p,w);if(this.h)return this.h.s(f,c,d,p,w);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(f,c,d=[],p,w){if(p){const R=new m(void 0,this.g,this,this.i);R.c=String(f);const i=new Map,o=new k.IdleValue(()=>{const t=R.j(c,d,w);for(const[n,s]of i){const a=t[n];if(typeof a=="function")for(const r of s)a.apply(t,r)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,n){if(!o.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let r=i.get(n);return r||(r=new E.LinkedList,i.set(n,r)),(g,v,A)=>{const N=r.push([g,v,A]);return(0,D.toDisposable)(N)}}if(n in t)return t[n];const s=o.value;let a=s[n];return typeof a!="function"||(a=a.bind(s),t[n]=a),a},set(t,n,s){return o.value[n]=s,!0},getPrototypeOf(t){return c.prototype}})}else return this.j(c,d,w)}u(f,c){if(c&&console.warn(f),this.g)throw new Error(f)}}e.InstantiationService=m;var y;(function(S){S[S.None=0]="None",S[S.Creation=1]="Creation",S[S.Invocation=2]="Invocation",S[S.Branch=3]="Branch"})(y||(y={}));class u{static traceInvocation(f,c){return f?new u(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):u.c}static traceCreation(f,c){return f?new u(1,c.name):u.c}constructor(f,c){this.type=f,this.name=c,this.g=Date.now(),this.h=[]}branch(f,c){const d=new u(3,f.toString());return this.h.push([f,c,d]),d}stop(){const f=Date.now()-this.g;u.f+=f;let c=!1;function d(w,R){const i=[],o=new Array(w+1).join("	");for(const[t,n,s]of R.h)if(n&&s){c=!0,i.push(`${o}CREATES -> ${t}`);const a=d(w+1,s);a&&i.push(a)}else i.push(`${o}uses -> ${t}`);return i.join(`
`)}const p=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${u.f.toFixed(2)}ms)`];(f>2||c)&&u.all.add(p.join(`
`))}}e.Trace=u,u.all=new Set,u.c=new class extends u{constructor(){super(0,null)}stop(){}branch(){return this}},u.f=0}),define(oe[207],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class k{constructor(D,l){this.a=D,this.b=l}getChannel(D){return this.a.getChannel(D,this.b)}registerChannel(D,l){this.a.registerChannel(D,l)}}e.MessagePortMainProcessService=k}),define(oe[57],ae([0,1,39,55,71,5]),function(Q,e,k,T,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class O{constructor(y,u,S,f){const c=S.getChannel(y);return P(u)?f.createInstance(new T.SyncDescriptor(u.channelClientCtor,[c])):k.ProxyChannel.toService(c,u?.proxyOptions)}}function P(m){return!!m?.channelClientCtor}e.IMainProcessService=(0,l.createDecorator)("mainProcessService");let I=class extends O{constructor(y,u,S,f){super(y,u,S,f)}};I=ye([G(2,e.IMainProcessService),G(3,l.IInstantiationService)],I);function E(m,y,u){(0,D.registerSingleton)(m,new T.SyncDescriptor(I,[y,u],!0))}e.registerMainProcessRemoteService=E,e.ISharedProcessService=(0,l.createDecorator)("sharedProcessService");let C=class extends O{constructor(y,u,S,f){super(y,u,S,f)}};C=ye([G(2,e.ISharedProcessService),G(3,l.IInstantiationService)],C);function b(m,y,u){(0,D.registerSingleton)(m,new T.SyncDescriptor(C,[y,u],!0))}e.registerSharedProcessRemoteService=b}),define(oe[73],ae([0,1,25,2,4,169,30,5]),function(Q,e,k,T,D,l,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function I(C){return C.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=I,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let E=class extends T.Disposable{constructor(b){super(),this.c=b}async getAvailableLanguages(){const b=new k.CancellationTokenSource;setTimeout(()=>b.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},b.token)}catch{return[]}const u=m.firstPage.filter(S=>S.properties.localizedLanguages?.length&&S.tags.some(f=>f.startsWith("lp-"))).map(S=>{const f=S.properties.localizedLanguages?.[0],c=I(S);return{...this.f(c,f,S),extensionId:S.identifier.id,galleryExtension:S}});return u.push({...this.f("en","English"),extensionId:"default"}),u}f(b,m,y){const u=m??b;let S;if(u!==b&&(S=`(${b})`),b.toLowerCase()===D.language.toLowerCase()&&(S??="",S+=(0,l.localize)(0,null)),y?.installCount){S??="";const f=y.installCount;let c;f>1e6?c=`${Math.floor(f/1e5)/10}M`:f>1e3?c=`${Math.floor(f/1e3)}K`:c=String(f),S+=` $(cloud-download) ${c}`}return{id:b,label:u,description:S}}};E=ye([G(0,O.IExtensionGalleryService)],E),e.LanguagePackBaseService=E}),define(oe[208],ae([0,1,2,73]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends k.Disposable{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};D=ye([G(0,T.ILanguagePackService)],D),e.LocalizationsUpdater=D}),define(oe[8],ae([0,1,38,3,2,37,4,12,11,5]),function(Q,e,k,T,D,l,O,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.setLogLevel=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function C(){return new Date().toISOString()}function b(h){return(0,P.isNumber)(h)}e.isLogLevel=b;var m;(function(h){h[h.Off=0]="Off",h[h.Trace=1]="Trace",h[h.Debug=2]="Debug",h[h.Info=3]="Info",h[h.Warning=4]="Warning",h[h.Error=5]="Error"})(m=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=m.Info;function y(h,g,v){switch(g){case m.Trace:h.trace(v);break;case m.Debug:h.debug(v);break;case m.Info:h.info(v);break;case m.Warning:h.warn(v);break;case m.Error:h.error(v);break;case m.Off:break;default:throw new Error(`Invalid log level ${g}`)}}e.log=y;function u(h){let g="";for(let v=0;v<h.length;v++){let A=h[v];if(typeof A=="object")try{A=JSON.stringify(A)}catch{}g+=(v>0?" ":"")+A}return g}e.format=u;class S extends D.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new T.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(g){this.b!==g&&(this.b=g,this.c.fire(this.b))}getLevel(){return this.b}f(g){return this.b!==m.Off&&this.b<=g}}e.AbstractLogger=S;class f extends S{constructor(g){super(),this.h=g}f(g){return this.h||super.f(g)}trace(g,...v){this.f(m.Trace)&&this.g(m.Trace,u([g,...v]))}debug(g,...v){this.f(m.Debug)&&this.g(m.Debug,u([g,...v]))}info(g,...v){this.f(m.Info)&&this.g(m.Info,u([g,...v]))}warn(g,...v){this.f(m.Warning)&&this.g(m.Warning,u([g,...v]))}error(g,...v){if(this.f(m.Error))if(g instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=g.stack,this.g(m.Error,u(A))}else this.g(m.Error,u([g,...v]))}flush(){}}e.AbstractMessageLogger=f;class c extends S{constructor(g=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(g),this.g=!O.isWindows}trace(g,...v){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,g,...v):console.log(`[main ${C()}]`,g,...v))}debug(g,...v){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,g,...v):console.log(`[main ${C()}]`,g,...v))}info(g,...v){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,g,...v):console.log(`[main ${C()}]`,g,...v))}warn(g,...v){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${C()}]\x1B[0m`,g,...v):console.warn(`[main ${C()}]`,g,...v))}error(g,...v){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${C()}]\x1B[0m`,g,...v):console.error(`[main ${C()}]`,g,...v))}dispose(){}flush(){}}e.ConsoleMainLogger=c;class d extends S{constructor(g=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(g)}trace(g,...v){this.f(m.Trace)&&console.log("%cTRACE","color: #888",g,...v)}debug(g,...v){this.f(m.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",g,...v)}info(g,...v){this.f(m.Info)&&console.log("%c INFO","color: #33f",g,...v)}warn(g,...v){this.f(m.Warning)&&console.log("%c WARN","color: #993",g,...v)}error(g,...v){this.f(m.Error)&&console.log("%c  ERR","color: #f33",g,...v)}dispose(){}flush(){}}e.ConsoleLogger=d;class p extends S{constructor(g,v=e.DEFAULT_LOG_LEVEL){super(),this.g=g,this.setLevel(v)}trace(g,...v){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(g),...v])}debug(g,...v){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(g),...v])}info(g,...v){this.f(m.Info)&&this.g.log(m.Info,[this.h(g),...v])}warn(g,...v){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(g),...v])}error(g,...v){this.f(m.Error)&&this.g.log(m.Error,[this.h(g),...v])}h(g){return typeof g=="string"?g:(0,k.toErrorMessage)(g,this.f(m.Trace))}dispose(){}flush(){}}e.AdapterLogger=p;class w extends S{constructor(g){super(),this.g=g,g.length&&this.setLevel(g[0].getLevel())}setLevel(g){for(const v of this.g)v.setLevel(g);super.setLevel(g)}trace(g,...v){for(const A of this.g)A.trace(g,...v)}debug(g,...v){for(const A of this.g)A.debug(g,...v)}info(g,...v){for(const A of this.g)A.info(g,...v)}warn(g,...v){for(const A of this.g)A.warn(g,...v)}error(g,...v){for(const A of this.g)A.error(g,...v)}flush(){for(const g of this.g)g.flush()}dispose(){for(const g of this.g)g.dispose()}}e.MultiplexLogger=w;class R extends D.Disposable{constructor(g,v){if(super(),this.j=g,this.b=new l.ResourceMap,this.c=new l.ResourceMap,this.f=this.B(new T.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new T.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new T.Emitter),this.onDidChangeVisibility=this.h.event,v)for(const A of v)this.c.set(A.resource,A)}getLogger(g){return this.b.get(g)}createLogger(g,v,A){let N=this.b.get(g);if(!N){const F=v?.logLevel==="always"?m.Trace:v?.logLevel;N=this.k(g,F??this.getLogLevel(g)??this.j,v),this.b.set(g,N),A||this.registerLogger({resource:g,id:v?.id??g.toString(),logLevel:F,name:v?.name,hidden:v?.hidden,extensionId:v?.extensionId})}return N}setLogLevel(g,v){if(I.URI.isUri(g)){const A=g,N=v,F=this.c.get(A);F&&N!==F.logLevel&&(F.logLevel=N===this.j?void 0:N,this.b.get(A)?.setLevel(N),this.c.set(F.resource,F),this.g.fire([A,N]))}else{this.j=g;for(const[A,N]of this.b.entries())this.c.get(A)?.logLevel===void 0&&N.setLevel(this.j);this.g.fire(this.j)}}setVisibility(g,v){const A=this.c.get(g);A&&v!==!A.hidden&&(A.hidden=!v,this.c.set(A.resource,A),this.h.fire([g,v]))}getLogLevel(g){let v;return g&&(v=this.c.get(g)?.logLevel),v??this.j}registerLogger(g){const v=this.c.get(g.resource);v?v.hidden!==g.hidden&&this.setVisibility(g.resource,!g.hidden):(this.c.set(g.resource,g),this.f.fire({added:[g],removed:[]}))}deregisterLogger(g){const v=this.c.get(g);if(v){this.c.delete(g);const A=this.b.get(g);A&&(this.b.delete(g),A.dispose()),this.f.fire({added:[],removed:[v]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(g){return this.c.get(g)}dispose(){this.b.forEach(g=>g.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=R;class i{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(g){}getLevel(){return m.Info}trace(g,...v){}debug(g,...v){}info(g,...v){}warn(g,...v){}error(g,...v){}critical(g,...v){}dispose(){}flush(){}}e.NullLogger=i;class o extends i{}e.NullLogService=o;class t extends R{constructor(){super(m.Info)}k(g,v,A){return new i}}e.NullLoggerService=t;function n(h){if(h.verbose)return m.Trace;if(typeof h.logLevel=="string"){const g=a(h.logLevel.toLowerCase());if(g!==void 0)return g}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function s(h){switch(h){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.LogLevelToString=s;function a(h){switch(h){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.parseLogLevel=a;function r(h,g){b(g)?h.setLogLevel(g):h.setLogLevel(g[0],g[1])}e.setLogLevel=r}),define(oe[209],ae([0,1,6,9,2,13,28,15,8]),function(Q,e,k,T,D,l,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let E=class extends D.Disposable{constructor(b,m){super(),this.a=b,this.b=m,this.B(new k.RunOnceScheduler(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const b=(0,l.basename)(this.a.logsPath),m=(0,l.dirname)(this.a.logsPath),S=(await O.Promises.readdir(m)).filter(c=>/^\d{8}T\d{6}$/.test(c)).sort().filter(c=>c!==b),f=S.slice(0,Math.max(0,S.length-9));f.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${f.join(", ")}'`),await Promise.all(f.map(c=>O.Promises.rm((0,l.join)(m,c)))))}catch(b){(0,T.onUnexpectedError)(b)}}};E=ye([G(0,P.IEnvironmentService),G(1,I.ILogService)],E),e.LogsDataCleaner=E}),define(oe[210],ae([0,1,21,6,9,3,2,13,56,8]),function(Q,e,k,T,D,l,O,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class C extends O.Disposable{constructor(m,y){super(),this.a=m,this.b=y,this.c=this.B(new l.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new l.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new T.ThrottledDelayer(0)),this.s=[],this.t=this.B(new T.ThrottledDelayer(0))}watch(m,y){return y.recursive||this.b?.watcher?.forceUniversal?this.l(m,y):this.u(m,y)}l(m,y){const u={path:this.C(m),excludes:y.excludes,includes:y.includes,recursive:y.recursive},S=(0,k.insert)(this.j,u);return this.m(),(0,O.toDisposable)(()=>{S(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(m=>(0,D.onUnexpectedError)(m))}n(){this.h||(this.h=this.B(this.p(y=>this.c.fire((0,I.toFileChanges)(y)),y=>this.z(y),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const y of this.j)(0,I.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const y of this.j)(0,I.isRecursiveWatchRequest)(y)&&m.includes(y.path)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(m,y){const u={path:this.C(m),excludes:y.excludes,includes:y.includes,recursive:!1},S=(0,k.insert)(this.s,u);return this.v(),(0,O.toDisposable)(()=>{S(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(m=>(0,D.onUnexpectedError)(m))}w(){return this.r||(this.r=this.B(this.y(m=>this.c.fire((0,I.toFileChanges)(m)),m=>this.z(m),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)}))),this.r.watch(this.s)}z(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}C(m){return(0,P.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=C}),define(oe[211],ae([0,1,21,6,17,25,3,66,64,2,49,26,102,22,44,165,14,101,8,9]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u,S,f,c,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class extends E.Disposable{constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new O.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new O.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new O.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new O.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new T.ResourceQueue)}registerProvider(i,o){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${i}`);const t=new E.DisposableStore;return this.h.set(i,o),this.c.fire({added:!0,scheme:i,provider:o}),t.add(o.onDidChangeFile(n=>this.R.fire(new f.FileChangesEvent(n,!this.O(o))))),typeof o.onDidWatchError=="function"&&t.add(o.onDidWatchError(n=>this.S.fire(new Error(n)))),t.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:i}))),(0,E.toDisposable)(()=>{this.c.fire({added:!1,scheme:i,provider:o}),this.h.delete(i),(0,E.dispose)(t)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const o=[];this.f.fire({scheme:i,join(t){o.push(t)}}),!this.h.has(i)&&await T.Promises.settled(o)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,o){const t=this.h.get(i.scheme);return!!(t&&t.capabilities&o)}listCapabilities(){return I.Iterable.map(this.h,([i,o])=>({scheme:i,capabilities:o.capabilities}))}async j(i){if(!(0,y.isAbsolutePath)(i))throw new f.FileOperationError((0,S.localize)(0,null,this.nb(i)),8);await this.activateProvider(i.scheme);const o=this.h.get(i.scheme);if(!o){const t=new p.ErrorNoTelemetry;throw t.message=(0,S.localize)(1,null,i.toString()),t}return o}async k(i){const o=await this.j(i);if((0,f.hasOpenReadWriteCloseCapability)(o)||(0,f.hasReadWriteCapability)(o)||(0,f.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(i){const o=await this.j(i);if((0,f.hasOpenReadWriteCloseCapability)(o)||(0,f.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,o){try{return await this.n(i,o)}catch(t){throw(0,f.toFileSystemProviderErrorCode)(t)===f.FileSystemProviderErrorCode.FileNotFound?new f.FileOperationError((0,S.localize)(2,null,this.nb(i)),1):(0,f.ensureFileSystemProviderError)(t)}}async n(i,o){const t=await this.j(i),n=this.O(t),s=o?.resolveTo,a=o?.resolveSingleChildDescendants,r=o?.resolveMetadata,h=await t.stat(i);let g;return this.p(t,i,h,void 0,!!r,(v,A)=>(g||(g=C.TernarySearchTree.forUris(()=>!n),g.set(i,!0),s&&g.fill(!0,s)),g.get(v.resource)||g.findSuperstr(v.resource.with({query:null,fragment:null}))?!0:v.isDirectory&&a?A===1:!1))}async p(i,o,t,n,s,a){const{providerExtUri:r}=this.N(i),h={resource:o,name:r.basename(o),isFile:(t.type&f.FileType.File)!==0,isDirectory:(t.type&f.FileType.Directory)!==0,isSymbolicLink:(t.type&f.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&f.FilePermission.Readonly)||Boolean(i.capabilities&2048),etag:(0,f.etag)({mtime:t.mtime,size:t.size}),children:void 0};if(h.isDirectory&&a(h,n)){try{const g=await i.readdir(o),v=await T.Promises.settled(g.map(async([A,N])=>{try{const F=r.joinPath(o,A),M=s?await i.stat(F):{type:N};return await this.p(i,F,M,g.length,s,a)}catch(F){return this.b.trace(F),null}}));h.children=(0,k.coalesce)(v)}catch(g){this.b.trace(g),h.children=[]}return h}return h}async resolveAll(i){return T.Promises.settled(i.map(async o=>{try{return{stat:await this.n(o.resource,o.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(i){const o=await this.j(i),t=await o.stat(i);return this.p(o,i,t,void 0,!0,()=>!1)}async exists(i){const o=await this.j(i);try{return!!await o.stat(i)}catch{return!1}}async canCreateFile(i,o){try{await this.r(i,o)}catch(t){return t}return!0}async r(i,o){if(!o?.overwrite&&await this.exists(i))throw new f.FileOperationError((0,S.localize)(3,null,this.nb(i)),3,o)}async createFile(i,o=D.VSBuffer.fromString(""),t){await this.r(i,t);const n=await this.writeFile(i,o);return this.m.fire(new f.FileOperationEvent(i,0,n)),n}async writeFile(i,o,t){const n=this.lb(await this.l(i),i),{providerExtUri:s}=this.N(n);try{await this.s(n,i,t)||await this.P(n,s.dirname(i));let r;if((0,f.hasReadWriteCapability)(n)&&!(o instanceof D.VSBuffer))if((0,u.isReadableStream)(o)){const h=await(0,u.peekStream)(o,3);h.ended?r=D.VSBuffer.concat(h.buffer):r=h}else r=(0,u.peekReadable)(o,h=>D.VSBuffer.concat(h),3);else r=o;!(0,f.hasOpenReadWriteCloseCapability)(n)||(0,f.hasReadWriteCapability)(n)&&r instanceof D.VSBuffer?await this.cb(n,i,t,r):await this.Y(n,i,t,r instanceof D.VSBuffer?(0,D.bufferToReadable)(r):r),this.m.fire(new f.FileOperationEvent(i,4))}catch(a){throw new f.FileOperationError((0,S.localize)(4,null,this.nb(i),(0,f.ensureFileSystemProviderError)(a).toString()),(0,f.toFileOperationResult)(a),t)}return this.resolve(i,{resolveMetadata:!0})}async s(i,o,t){if(!!t?.unlock&&!(i.capabilities&8192))throw new Error((0,S.localize)(5,null,this.nb(o)));let s;try{s=await i.stat(o)}catch{return}if((s.type&f.FileType.Directory)!==0)throw new f.FileOperationError((0,S.localize)(6,null,this.nb(o)),0,t);if(this.mb(o,s),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==f.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&t.mtime<s.mtime&&t.etag!==(0,f.etag)({mtime:t.mtime,size:s.size}))throw new f.FileOperationError((0,S.localize)(7,null),3,t);return s}async readFile(i,o,t){const n=await this.k(i);return o?.atomic?this.t(n,i,o,t):this.u(n,i,o,t)}async t(i,o,t,n){return new Promise((s,a)=>{this.X.queueFor(o,this.N(i).providerExtUri).queue(async()=>{try{const r=await this.u(i,o,t,n);s(r)}catch(r){a(r)}})})}async u(i,o,t,n){const s=await this.v(i,o,{...t,preferUnbuffered:!0},n);return{...s,value:await(0,D.streamToBuffer)(s.value)}}async readFileStream(i,o,t){const n=await this.k(i);return this.v(n,i,o,t)}async v(i,o,t,n){const s=new l.CancellationTokenSource(n),a=this.F(o,t).then(h=>h,h=>{throw s.cancel(),h});let r;try{return typeof t?.etag=="string"&&t.etag!==f.ETAG_DISABLED&&await a,t?.atomic&&(0,f.hasFileAtomicReadCapability)(i)||!((0,f.hasOpenReadWriteCloseCapability)(i)||(0,f.hasFileReadStreamCapability)(i))||(0,f.hasReadWriteCapability)(i)&&t?.preferUnbuffered?r=this.D(i,o,t):(0,f.hasFileReadStreamCapability)(i)?r=this.z(i,o,s.token,t):r=this.C(i,o,s.token,t),{...await a,value:r}}catch(h){throw r&&await(0,u.consumeStream)(r),this.w(h,o,t)}}w(i,o,t){const n=(0,S.localize)(8,null,this.nb(o),(0,f.ensureFileSystemProviderError)(i).toString());return i instanceof f.NotModifiedSinceFileOperationError?new f.NotModifiedSinceFileOperationError(n,i.stat,t):i instanceof f.TooLargeFileOperationError?new f.TooLargeFileOperationError(n,i.fileOperationResult,i.size,i.options):new f.FileOperationError(n,(0,f.toFileOperationResult)(i),t)}z(i,o,t,n=Object.create(null)){const s=i.readFileStream(o,n,t);return(0,u.transform)(s,{data:a=>a instanceof D.VSBuffer?a:D.VSBuffer.wrap(a),error:a=>this.w(a,o,n)},a=>D.VSBuffer.concat(a))}C(i,o,t,n=Object.create(null)){const s=(0,D.newWriteableBufferStream)();return(0,c.readFileIntoStream)(i,o,s,a=>a,{...n,bufferSize:this.a,errorTransformer:a=>this.w(a,o,n)},t),s}D(i,o,t){const n=(0,u.newWriteableStream)(s=>D.VSBuffer.concat(s));return(async()=>{try{let s;t?.atomic&&(0,f.hasFileAtomicReadCapability)(i)?s=await i.readFile(o,{atomic:!0}):s=await i.readFile(o),typeof t?.position=="number"&&(s=s.slice(t.position)),typeof t?.length=="number"&&(s=s.slice(0,t.length)),this.G(o,s.byteLength,t),n.end(D.VSBuffer.wrap(s))}catch(s){n.error(s),n.end()}})(),n}async F(i,o){const t=await this.resolve(i,{resolveMetadata:!0});if(t.isDirectory)throw new f.FileOperationError((0,S.localize)(9,null,this.nb(i)),0,o);if(typeof o?.etag=="string"&&o.etag!==f.ETAG_DISABLED&&o.etag===t.etag)throw new f.NotModifiedSinceFileOperationError((0,S.localize)(10,null),t,o);return this.G(i,t.size,o),t}G(i,o,t){if(t?.limits){let n;if(typeof t.limits.memory=="number"&&o>t.limits.memory&&(n=9),typeof t.limits.size=="number"&&o>t.limits.size&&(n=7),typeof n=="number")throw new f.TooLargeFileOperationError((0,S.localize)(11,null,this.nb(i)),n,o,t)}}async canMove(i,o,t){return this.H(i,o,"move",t)}async canCopy(i,o,t){return this.H(i,o,"copy",t)}async H(i,o,t,n){if(i.toString()!==o.toString())try{const s=t==="move"?this.lb(await this.l(i),i):await this.k(i),a=this.lb(await this.l(o),o);await this.M(s,i,a,o,t,n)}catch(s){return s}return!0}async move(i,o,t){const n=this.lb(await this.l(i),i),s=this.lb(await this.l(o),o),a=await this.I(n,i,s,o,"move",!!t),r=await this.resolve(o,{resolveMetadata:!0});return this.m.fire(new f.FileOperationEvent(i,a==="move"?2:3,r)),r}async copy(i,o,t){const n=await this.k(i),s=this.lb(await this.l(o),o),a=await this.I(n,i,s,o,"copy",!!t),r=await this.resolve(o,{resolveMetadata:!0});return this.m.fire(new f.FileOperationEvent(i,a==="copy"?3:2,r)),r}async I(i,o,t,n,s,a){if(o.toString()===n.toString())return s;const{exists:r,isSameResourceWithDifferentPathCase:h}=await this.M(i,o,t,n,s,a);if(r&&!h&&a&&await this.del(n,{recursive:!0}),await this.P(t,this.N(t).providerExtUri.dirname(n)),s==="copy"){if(i===t&&(0,f.hasFileFolderCopyCapability)(i))await i.copy(o,n,{overwrite:a});else{const g=await this.resolve(o);g.isDirectory?await this.L(i,g,t,n):await this.J(i,o,t,n)}return s}else return i===t?(await i.rename(o,n,{overwrite:a}),s):(await this.I(i,o,t,n,"copy",a),await this.del(o,{recursive:!0}),"copy")}async J(i,o,t,n){if((0,f.hasOpenReadWriteCloseCapability)(i)&&(0,f.hasOpenReadWriteCloseCapability)(t))return this.eb(i,o,t,n);if((0,f.hasOpenReadWriteCloseCapability)(i)&&(0,f.hasReadWriteCapability)(t))return this.kb(i,o,t,n);if((0,f.hasReadWriteCapability)(i)&&(0,f.hasOpenReadWriteCloseCapability)(t))return this.ib(i,o,t,n);if((0,f.hasReadWriteCapability)(i)&&(0,f.hasReadWriteCapability)(t))return this.gb(i,o,t,n)}async L(i,o,t,n){await t.mkdir(n),Array.isArray(o.children)&&await T.Promises.settled(o.children.map(async s=>{const a=this.N(t).providerExtUri.joinPath(n,s.name);return s.isDirectory?this.L(i,await this.resolve(s.resource),t,a):this.J(i,s.resource,t,a)}))}async M(i,o,t,n,s,a){let r=!1;if(i===t){const{providerExtUri:g,isPathCaseSensitive:v}=this.N(i);if(v||(r=g.isEqual(o,n)),r&&s==="copy")throw new Error((0,S.localize)(12,null,this.nb(o),this.nb(n)));if(!r&&g.isEqualOrParent(n,o))throw new Error((0,S.localize)(13,null,this.nb(o),this.nb(n)))}const h=await this.exists(n);if(h&&!r){if(!a)throw new f.FileOperationError((0,S.localize)(14,null,this.nb(o),this.nb(n)),4);if(i===t){const{providerExtUri:g}=this.N(i);if(g.isEqualOrParent(o,n))throw new Error((0,S.localize)(15,null,this.nb(o),this.nb(n)))}}return{exists:h,isSameResourceWithDifferentPathCase:r}}N(i){const o=this.O(i);return{providerExtUri:o?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:o}}O(i){return!!(i.capabilities&1024)}async createFolder(i){const o=this.lb(await this.j(i),i);await this.P(o,i);const t=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new f.FileOperationEvent(i,0,t)),t}async P(i,o){const t=[],{providerExtUri:n}=this.N(i);for(;!n.isEqual(o,n.dirname(o));)try{if(((await i.stat(o)).type&f.FileType.Directory)===0)throw new Error((0,S.localize)(16,null,this.nb(o)));break}catch(s){if((0,f.toFileSystemProviderErrorCode)(s)!==f.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(n.basename(o)),o=n.dirname(o)}for(let s=t.length-1;s>=0;s--){o=n.joinPath(o,t[s]);try{await i.mkdir(o)}catch(a){if((0,f.toFileSystemProviderErrorCode)(a)!==f.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(i,o){try{await this.Q(i,o)}catch(t){return t}return!0}async Q(i,o){const t=this.lb(await this.j(i),i);if(!!o?.useTrash&&!(t.capabilities&4096))throw new Error((0,S.localize)(17,null,this.nb(i)));let s;try{s=await t.stat(i)}catch{}if(s)this.mb(i,s);else throw new f.FileOperationError((0,S.localize)(18,null,this.nb(i)),1);if(!!!o?.recursive){const r=await this.resolve(i);if(r.isDirectory&&Array.isArray(r.children)&&r.children.length>0)throw new Error((0,S.localize)(19,null,this.nb(i)))}return t}async del(i,o){const t=await this.Q(i,o),n=!!o?.useTrash,s=!!o?.recursive;await t.delete(i,{recursive:s,useTrash:n}),this.m.fire(new f.FileOperationEvent(i,1))}async cloneFile(i,o){const t=await this.j(i),n=this.lb(await this.l(o),o);if(t===n&&this.N(t).providerExtUri.isEqual(i,o))return;if(t===n&&(0,f.hasFileCloneCapability)(t))return t.cloneFile(i,o);await this.P(n,this.N(n).providerExtUri.dirname(o));const s=this.X.queueFor(i,this.N(t).providerExtUri);return t===n&&(0,f.hasFileFolderCopyCapability)(t)?s.queue(()=>t.copy(i,o,{overwrite:!0})):s.queue(()=>this.J(t,i,n,o))}watch(i,o={recursive:!1,excludes:[]}){const t=new E.DisposableStore;let n=!1,s=()=>{n=!0};return t.add((0,E.toDisposable)(()=>s())),(async()=>{try{const a=await this.W(i,o);n?(0,E.dispose)(a):s=()=>(0,E.dispose)(a)}catch(a){this.b.error(a)}})(),t}async W(i,o){const t=await this.j(i),n=(0,P.hash)([this.N(t).providerExtUri.getComparisonKey(i),o]);let s=this.U.get(n);return s||(s={count:0,disposable:t.watch(i,o)},this.U.set(n,s)),s.count+=1,(0,E.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,E.dispose)(s.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,i]of this.U)(0,E.dispose)(i.disposable);this.U.clear()}async Y(i,o,t,n){return this.X.queueFor(o,this.N(i).providerExtUri).queue(async()=>{const s=await i.open(o,{create:!0,unlock:t?.unlock??!1});try{(0,u.isReadableStream)(n)||(0,u.isReadableBufferedStream)(n)?await this.Z(i,s,n):await this.ab(i,s,n)}catch(a){throw(0,f.ensureFileSystemProviderError)(a)}finally{await i.close(s)}})}async Z(i,o,t){let n=0,s;if((0,u.isReadableBufferedStream)(t)){if(t.buffer.length>0){const a=D.VSBuffer.concat(t.buffer);await this.bb(i,o,a,a.byteLength,n,0),n+=a.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise((a,r)=>{(0,u.listenStream)(s,{onData:async h=>{s.pause();try{await this.bb(i,o,h,h.byteLength,n,0)}catch(g){return r(g)}n+=h.byteLength,setTimeout(()=>s.resume())},onError:h=>r(h),onEnd:()=>a()})})}async ab(i,o,t){let n=0,s;for(;(s=t.read())!==null;)await this.bb(i,o,s,s.byteLength,n,0),n+=s.byteLength}async bb(i,o,t,n,s,a){let r=0;for(;r<n;)r+=await i.write(o,s+r,t.buffer,a+r,n-r)}async cb(i,o,t,n){return this.X.queueFor(o,this.N(i).providerExtUri).queue(()=>this.db(i,o,t,n))}async db(i,o,t,n){let s;n instanceof D.VSBuffer?s=n:(0,u.isReadableStream)(n)?s=await(0,D.streamToBuffer)(n):(0,u.isReadableBufferedStream)(n)?s=await(0,D.bufferedStreamToBuffer)(n):s=(0,D.readableToBuffer)(n),await i.writeFile(o,s.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async eb(i,o,t,n){return this.X.queueFor(n,this.N(t).providerExtUri).queue(()=>this.fb(i,o,t,n))}async fb(i,o,t,n){let s,a;try{s=await i.open(o,{create:!1}),a=await t.open(n,{create:!0,unlock:!1});const r=D.VSBuffer.alloc(this.a);let h=0,g=0,v=0;do v=await i.read(s,h,r.buffer,g,r.byteLength-g),await this.bb(t,a,r,v,h,g),h+=v,g+=v,g===r.byteLength&&(g=0);while(v>0)}catch(r){throw(0,f.ensureFileSystemProviderError)(r)}finally{await T.Promises.settled([typeof s=="number"?i.close(s):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async gb(i,o,t,n){return this.X.queueFor(n,this.N(t).providerExtUri).queue(()=>this.hb(i,o,t,n))}async hb(i,o,t,n){return t.writeFile(n,await i.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async ib(i,o,t,n){return this.X.queueFor(n,this.N(t).providerExtUri).queue(()=>this.jb(i,o,t,n))}async jb(i,o,t,n){const s=await t.open(n,{create:!0,unlock:!1});try{const a=await i.readFile(o);await this.bb(t,s,D.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,f.ensureFileSystemProviderError)(a)}finally{await t.close(s)}}async kb(i,o,t,n){const s=await(0,D.streamToBuffer)(this.C(i,o,l.CancellationToken.None));await this.cb(t,n,void 0,s)}lb(i,o){if(i.capabilities&2048)throw new f.FileOperationError((0,S.localize)(20,null,this.nb(o)),6);return i}mb(i,o){if((o.permissions??0)&f.FilePermission.Readonly)throw new f.FileOperationError((0,S.localize)(21,null,this.nb(i)),6)}nb(i){return i.scheme===b.Schemas.file?i.fsPath:i.toString(!0)}};w=ye([G(0,d.ILogService)],w),e.FileService=w}),define(oe[212],ae([0,1,53,294,6,37,17,3,48,2,13,4,22,44,28,168,14,101,210,38,205,204]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u,S,f,c,d,p,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,T.gracefulify)(k)}catch(o){console.error(`Error enabling graceful-fs: ${(0,p.toErrorMessage)(o)}`)}})();class i extends d.AbstractDiskFileSystemProvider{constructor(t,n){super(t,n),this.onDidChangeCapabilities=P.Event.None,this.H=new l.ResourceMap(s=>m.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,b.isLinux&&(this.F|=1024)),this.F}async stat(t){try{const{stat:n,symbolicLink:s}=await u.SymlinkSupport.stat(this.C(t));return{type:this.G(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.Y(n)}}async readdir(t){try{const n=await u.Promises.readdir(this.C(t),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async a=>{try{let r;a.isSymbolicLink()?r=(await this.stat((0,m.joinPath)(t,a.name))).type:r=this.G(a),s.push([a.name,r])}catch(r){this.a.trace(r)}})),s}catch(n){throw this.Y(n)}}G(t,n){let s;return n?.dangling?s=f.FileType.Unknown:t.isFile()?s=f.FileType.File:t.isDirectory()?s=f.FileType.Directory:s=f.FileType.Unknown,n&&(s|=f.FileType.SymbolicLink),s}async I(t){const n=this.C(t);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.H.get(t);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const a=new D.Barrier;return this.H.set(t,a),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,E.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.H.get(t)===a&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.H.delete(t)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),a.open()})}async readFile(t,n){let s;try{n?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(t)})`),s=await this.I(t));const a=this.C(t);return await u.Promises.readFile(a)}catch(a){throw this.Y(a)}finally{s?.dispose()}}J(t){i.D&&this.a.trace(t)}readFileStream(t,n,s){const a=(0,y.newWriteableStream)(r=>O.VSBuffer.concat(r.map(h=>O.VSBuffer.wrap(h))).buffer);return(0,c.readFileIntoStream)(this,t,a,r=>r.buffer,{...n,bufferSize:256*1024},s),a}async writeFile(t,n,s){let a;try{const r=this.C(t);if(!s.create||!s.overwrite){if(await u.Promises.exists(r)){if(!s.overwrite)throw(0,f.createFileSystemProviderError)((0,S.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,f.createFileSystemProviderError)((0,S.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(t,{create:!0,unlock:s.unlock}),await this.write(a,0,n,0,n.byteLength)}catch(r){throw await this.Z(t,r)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(t){i.O=t}async open(t,n){const s=this.C(t);let a;(0,f.isFileOpenForWriteOptions)(n)&&(a=await this.I(t));let r;try{if((0,f.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:g}=await u.SymlinkSupport.stat(s);g.mode&128||await u.Promises.chmod(s,g.mode|128)}catch(g){this.a.trace(g)}let h;if((0,f.isFileOpenForWriteOptions)(n)){if(b.isWindows)try{await u.Promises.truncate(s,0),h="r+"}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}h||(h="w")}else h="r";r=await u.Promises.open(s,h)}catch(h){throw a?.dispose(),(0,f.isFileOpenForWriteOptions)(n)?await this.Z(t,h):this.Y(h)}if(this.L.set(r,0),(0,f.isFileOpenForWriteOptions)(n)&&this.N.set(r,t),a){const h=this.M.get(r);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${r} (${s})`),this.M.set(r,a),h&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${r} (${s})`),h.dispose())}return r}async close(t){const n=this.M.get(t);try{if(this.L.delete(t),this.N.delete(t)&&i.O)try{await u.Promises.fdatasync(t)}catch(s){i.configureFlushOnWrite(!1),this.a.error(s)}return await u.Promises.close(t)}catch(s){throw this.Y(s)}finally{n&&(this.M.get(t)===n&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.M.delete(t)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,s,a,r){const h=this.P(t,n);let g=null;try{g=(await u.Promises.read(t,s,a,r,h)).bytesRead}catch(v){throw this.Y(v)}finally{this.Q(t,h,g)}return g}P(t,n){return n===this.L.get(t)?null:n}Q(t,n,s){const a=this.L.get(t);typeof a=="number"&&(typeof n=="number"||(typeof s=="number"?this.L.set(t,a+s):this.L.delete(t)))}async write(t,n,s,a,r){return(0,D.retry)(()=>this.R(t,n,s,a,r),100,3)}async R(t,n,s,a,r){const h=this.P(t,n);let g=null;try{g=(await u.Promises.write(t,s,a,r,h)).bytesWritten}catch(v){throw await this.Z(this.N.get(t),v)}finally{this.Q(t,h,g)}return g}async mkdir(t){try{await u.Promises.mkdir(this.C(t))}catch(n){throw this.Y(n)}}async delete(t,n){try{const s=this.C(t);n.recursive?await u.Promises.rm(s,u.RimRafMode.MOVE):await u.Promises.unlink(s)}catch(s){throw this.Y(s)}}async rename(t,n,s){const a=this.C(t),r=this.C(n);if(a!==r)try{await this.S(t,n,"move",s.overwrite),await u.Promises.move(a,r)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,S.localize)(2,null,(0,C.basename)(a),(0,C.basename)((0,C.dirname)(r)),h.toString()))),this.Y(h)}}async copy(t,n,s){const a=this.C(t),r=this.C(n);if(a!==r)try{await this.S(t,n,"copy",s.overwrite),await u.Promises.copy(a,r,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,S.localize)(3,null,(0,C.basename)(a),(0,C.basename)((0,C.dirname)(r)),h.toString()))),this.Y(h)}}async S(t,n,s,a){const r=this.C(t),h=this.C(n);let g=!1;if(!!(this.capabilities&1024)||(g=(0,I.isEqual)(r,h,!0)),g&&s==="copy")throw(0,f.createFileSystemProviderError)((0,S.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(!g&&await u.Promises.exists(h)){if(!a)throw(0,f.createFileSystemProviderError)((0,S.localize)(5,null),f.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(t,n){return this.U(t,n,!1)}async U(t,n,s){const a=this.C(t),r=this.C(n),h=!!(this.capabilities&1024);if((0,I.isEqual)(a,r,!h))return;const g=new E.DisposableStore;try{const[v,A]=await Promise.all([this.I(t),this.I(n)]);g.add(v),g.add(A),s&&await u.Promises.mkdir((0,C.dirname)(r),{recursive:!0}),await u.Promises.copyFile(a,r)}catch(v){if(v.code==="ENOENT"&&!s)return this.U(t,n,!0);throw this.Y(v)}finally{g.dispose()}}p(t,n,s){return new w.UniversalWatcherClient(a=>t(a),a=>n(a),s)}y(t,n,s){return new R.NodeJSWatcherClient(a=>t(a),a=>n(a),s)}Y(t){if(t instanceof f.FileSystemProviderError)return t;let n;switch(t.code){case"ENOENT":n=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=f.FileSystemProviderErrorCode.NoPermissions;break;default:n=f.FileSystemProviderErrorCode.Unknown}return(0,f.createFileSystemProviderError)(t,n)}async Z(t,n){let s=this.Y(n);if(t&&s.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await u.SymlinkSupport.stat(this.C(t));a.mode&128||(s=(0,f.createFileSystemProviderError)(n,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return s}}e.DiskFileSystemProvider=i,i.D=!1,i.O=!0}),define(oe[103],ae([0,1,6,3,2,5,8]),function(Q,e,k,T,D,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,l.createDecorator)("lifecycleSharedProcessService");let P=class extends D.Disposable{constructor(E){super(),this.c=E,this.a=void 0,this.b=this.B(new T.Emitter),this.onWillShutdown=this.b.event}fireOnWillShutdown(){if(this.a)return this.a;this.c.trace("Lifecycle#onWillShutdown.fire()");const E=[];return this.b.fire({join(C){E.push(C)}}),this.a=(async()=>{try{await k.Promises.settled(E)}catch(C){this.c.error(C)}})(),this.a}};P=ye([G(0,O.ILogService)],P),e.SharedProcessLifecycleService=P}),define(oe[104],ae([0,1,11,8,2]),function(Q,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class l extends T.AbstractLoggerService{constructor(C,b,m,y){super(b,m.map(u=>({...u,resource:k.URI.revive(u.resource),hidden:u.hidden||!!u.extensionId}))),this.l=C,this.m=y,this.B(y.listen("onDidChangeLogLevel",C)(u=>{(0,T.isLogLevel)(u)?super.setLogLevel(u):super.setLogLevel(k.URI.revive(u[0]),u[1])})),this.B(y.listen("onDidChangeVisibility",C)(([u,S])=>super.setVisibility(k.URI.revive(u),S))),this.B(y.listen("onDidChangeLoggers",C)(({added:u,removed:S})=>{for(const f of u)super.registerLogger({...f,resource:k.URI.revive(f.resource)});for(const f of S)super.deregisterLogger(f.resource)}))}createConsoleMainLogger(){return new T.AdapterLogger({log:(C,b)=>{this.m.call("consoleLog",[C,b])}})}registerLogger(C){super.registerLogger(C),this.m.call("registerLogger",[C,this.l])}deregisterLogger(C){super.deregisterLogger(C),this.m.call("deregisterLogger",[C,this.l])}setLogLevel(C,b){super.setLogLevel(C,b),this.m.call("setLogLevel",[C,b])}setVisibility(C,b){super.setVisibility(C,b),this.m.call("setVisibility",[C,b])}k(C,b,m){return new O(this.m,C,b,m)}static setLogLevel(C,b,m){return C.call("setLogLevel",[b,m])}}e.LoggerChannelClient=l;class O extends T.AbstractMessageLogger{constructor(C,b,m,y){super(y?.logLevel==="always"),this.m=C,this.n=b,this.k=!1,this.l=[],this.setLevel(m),this.m.call("createLogger",[b,y]).then(()=>{this.r(this.l),this.k=!0})}g(C,b){const m=[[C,b]];this.k?this.r(m):this.l.push(...m)}r(C){this.m.call("log",[this.n,C])}}class P{constructor(C){this.a=C}listen(C,b,m){switch(b){case"onDidChangeLoggers":return this.a.onDidChangeLoggers;case"onDidChangeVisibility":return this.a.onDidChangeVisibility;case"onDidChangeLogLevel":return this.a.onDidChangeLogLevel}throw new Error(`Event not found: ${b}`)}async call(C,b,m){switch(b){case"setLogLevel":return(0,T.isLogLevel)(m[0])?this.a.setLogLevel(m[0]):this.a.setLogLevel(k.URI.revive(m[0]),m[1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()])}throw new Error(`Call not found: ${b}`)}}e.LoggerChannel=P;class I extends D.Disposable{constructor(C,b){super(),b.call("setLogLevel",[C.getLogLevel()]),this.B(C.onDidChangeLogLevel(m=>b.call("setLogLevel",[m]))),b.call("getRegisteredLoggers").then(m=>{for(const y of m)C.registerLogger({...y,resource:k.URI.revive(y.resource)})}),this.B(b.listen("onDidChangeVisibility")(([m,y])=>C.setVisibility(k.URI.revive(m),y))),this.B(b.listen("onDidChangeLoggers")(({added:m,removed:y})=>{for(const u of m)C.registerLogger({...u,resource:k.URI.revive(u.resource)});for(const u of y)C.deregisterLogger(u.resource)}))}}e.RemoteLoggerChannelClient=I}),define(oe[213],ae([0,1,2,8]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class D extends k.Disposable{constructor(O,P=[]){super(),this.a=new T.MultiplexLogger([O,...P]),this.B(O.onDidChangeLogLevel(I=>this.setLevel(I)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...P){this.a.trace(O,...P)}debug(O,...P){this.a.debug(O,...P)}info(O,...P){this.a.info(O,...P)}warn(O,...P){this.a.warn(O,...P)}error(O,...P){this.a.error(O,...P)}flush(){this.a.flush()}}e.LogService=D}),define(oe[58],ae([0,1,5]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,k.createDecorator)("nativeHostService")}),define(oe[59],ae([0,1,3,64,2,5]),function(Q,e,k,T,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,l.createDecorator)("policy");class O extends D.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new k.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(E){const C=Object.keys(this.f).length;return this.f={...E,...this.f},C!==Object.keys(this.f).length&&await this.i(E),T.Iterable.reduce(this.g.entries(),(b,[m,y])=>({...b,[m]:y}),{})}getPolicyValue(E){return this.g.get(E)}serialize(){return T.Iterable.reduce(Object.entries(this.f),(E,[C,b])=>({...E,[C]:{definition:b,value:this.g.get(C)}}),{})}}e.AbstractPolicyService=O;class P{constructor(){this.onDidChange=k.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(oe[214],ae([0,1,3,2,59]),function(Q,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class l{constructor(I){this.b=I,this.a=new T.DisposableStore}listen(I,E){switch(E){case"onDidChange":return k.Event.map(this.b.onDidChange,C=>C.reduce((b,m)=>({...b,[m]:this.b.getPolicyValue(m)??null}),{}),this.a)}throw new Error(`Event not found: ${E}`)}call(I,E,C){switch(E){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${E}`)}dispose(){this.a.dispose()}}e.PolicyChannel=l;class O extends D.AbstractPolicyService{constructor(I,E){super(),this.a=E;for(const C in I){const{definition:b,value:m}=I[C];this.f[C]=b,m!==void 0&&this.g.set(C,m)}this.a.listen("onDidChange")(C=>{for(const b in C){const m=C[b];m===null?this.g.delete(b):this.g.set(b,m)}this.h.fire(Object.keys(C))})}async i(I){const E=await this.a.call("updatePolicyDefinitions",I);for(const C in E)this.g.set(C,E[C])}}e.PolicyChannelClient=O}),define(oe[105],ae([0,1,4,36]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof k.globals.vscode<"u"&&typeof k.globals.vscode.context<"u"){const l=k.globals.vscode.context.configuration();if(l)D=l.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(D=globalThis._VSCODE_PRODUCT_JSON,T.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const l=globalThis._VSCODE_PACKAGE_JSON;Object.assign(D,{version:l.version})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(oe[23],ae([0,1,5]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(oe[215],ae([0,1,6,9,2,13,28,8,23]),function(Q,e,k,T,D,l,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let E=class extends D.Disposable{constructor(b,m,y){super(),this.b=m,this.c=y,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,b&&this.B(new k.RunOnceScheduler(()=>{this.f(b)},3e4)).schedule()}async f(b){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),y=(0,l.dirname)(b),u=(0,l.basename)(b),S=await O.Promises.readdir(y);await Promise.all(S.map(async f=>{if(f===u)return;const c=(0,l.join)(y,f),d=await O.Promises.stat(c);if(d.isDirectory()&&m-d.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${f}.`),O.Promises.rm(c)}))}catch(m){(0,T.onUnexpectedError)(m)}}};E=ye([G(1,I.IProductService),G(2,P.ILogService)],E),e.CodeCacheCleaner=E}),define(oe[216],ae([0,1,6,9,2,13,28,15,8,23]),function(Q,e,k,T,D,l,O,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let C=class extends D.Disposable{constructor(m,y,u){super(),this.b=m,this.c=y,this.f=u,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new k.RunOnceScheduler(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),y=JSON.parse(await O.Promises.readFile((0,l.join)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const d of Object.keys(y)){const p=y[d];m[`${p.hash}.${d}`]=!0}const u=(0,l.join)(this.b.userDataPath,"clp");if(!await O.Promises.exists(u))return;const f=await O.Promises.readdir(u);for(const d of f){if(m[d]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${d}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${d}`),await O.Promises.rm((0,l.join)(u,d))}const c=Date.now();for(const d of Object.keys(m)){const p=(0,l.join)(u,d),w=await O.Promises.readdir(p);for(const R of w){if(R==="tcf.json")continue;const i=(0,l.join)(p,R),o=await O.Promises.stat(i);o.isDirectory()&&c-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,l.join)(d,R)}`),await O.Promises.rm(i))}}}catch(m){(0,T.onUnexpectedError)(m)}}};C=ye([G(0,P.INativeEnvironmentService),G(1,I.ILogService),G(2,E.IProductService)],C),e.LanguagePackCachedDataCleaner=C}),define(oe[217],ae([0,1,21,2,22,192,14,23]),function(Q,e,k,T,D,l,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let I=class extends T.Disposable{constructor(C,b){super(),this.b=C,this.c=b,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,m])=>this.a.set(m.configPath,m))}getConfigBasedTips(C){return this.f(C)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(C){const b=[];for(const[m,y]of this.a)if(!(y.configScheme&&y.configScheme!==C.scheme))try{const u=await this.b.readFile((0,D.joinPath)(C,m)),S=new Map;Object.entries(y.recommendations).forEach(([c,d])=>{if((0,k.isNonEmptyArray)(d.remotes))for(const p of d.remotes)S.set(p,{extensionId:c,extensionName:d.name,configName:y.configName,important:!!d.important,isExtensionPack:!!d.isExtensionPack,whenNotInstalled:d.whenNotInstalled});else b.push({extensionId:c,extensionName:d.name,configName:y.configName,important:!!d.important,isExtensionPack:!!d.isExtensionPack,whenNotInstalled:d.whenNotInstalled})});const f=(0,l.getDomainsOfRemotes)(u.value.toString(),[...S.keys()]);for(const c of f){const d=S.get(c);d&&b.push(d)}}catch{}return b}};I=ye([G(0,O.IFileService),G(1,P.IProductService)],I),e.ExtensionTipsService=I}),define(oe[218],ae([0,1,13,5]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,T.createDecorator)("IV8InspectProfilingService");var D;(function(l){function O(I){return Boolean(I.samples&&I.timeDeltas)}l.isValidProfile=O;function P(I,E="noAbsolutePaths"){for(const C of I.nodes)C.callFrame&&C.callFrame.url&&((0,k.isAbsolute)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,k.join)(E,(0,k.basename)(C.callFrame.url)));return I}l.rewriteAbsolutePaths=P})(D=e.Utils||(e.Utils={}))}),define(oe[219],ae([0,1,31]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class T{constructor(){this.a=new Map}async startProfiling(l){const P=await(await new Promise((E,C)=>{Q(["v8-inspect-profiler"],E,C)})).startProfiling({port:l.port,checkForPaused:!0}),I=(0,k.generateUuid)();return this.a.set(I,P),I}async stopProfiling(l){const O=this.a.get(l);if(!O)throw new Error(`UNKNOWN session '${l}'`);const P=await O.stop();return this.a.delete(l),P.profile}}e.InspectProfilingService=T}),define(oe[40],ae([0,1,128,12]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.a=new Map}add(O,P){k.ok(T.isString(O)),k.ok(T.isObject(P)),k.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,P)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.Registry=new D}),define(oe[106],ae([0,1,3,40]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class l{constructor(){this.b=new k.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(I,E){this.a[D(I)]=E,this.b.fire(I)}notifySchemaChanged(I){this.b.fire(I)}getSchemaContributions(){return{schemas:this.a}}}const O=new l;T.Registry.add(e.Extensions.JSONContribution,O)}),define(oe[46],ae([0,1,21,3,12,154,16,106,40]),function(Q,e,k,T,D,l,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var E;(function(R){R.Multiline="multilineText",R.Singleline="singlelineText"})(E=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(R){R[R.APPLICATION=1]="APPLICATION",R[R.MACHINE=2]="MACHINE",R[R.WINDOW=3]="WINDOW",R[R.RESOURCE=4]="RESOURCE",R[R.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",R[R.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=I.Registry.as(P.Extensions.JSONContribution);class m{constructor(){this.h=new Set,this.i=new T.Emitter,this.onDidSchemaChange=this.i.event,this.j=new T.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:l.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const t=new Set;this.n(i,o,t),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(i){const o=new Set;this.o(i,o),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const t=new Set;this.o(o,t),this.n(i,!1,t),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const t=[];for(const{overrides:n,source:s}of i)for(const a in n)if(o.add(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const r=this.a.get(a),h=r?.valuesSources??new Map;if(s)for(const N of Object.keys(n[a]))h.set(N,s);const g={...r?.value||{},...n[a]};this.a.set(a,{source:s,value:g,valuesSources:h});const v=(0,O.getLanguageTagSettingPlainKey)(a),A={type:"object",default:g,description:l.localize(1,null,v),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:g,source:D.isString(s)?void 0:s,defaultValueSource:s};t.push(...S(a)),this.d[a]=A,this.b.properties[a]=A}else{this.a.set(a,{value:n[a],source:s});const r=this.d[a];r&&(this.w(a,r),this.r(a,r))}this.m(t)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:t,source:n}of i)for(const s in t){const a=this.a.get(s),r=D.isString(n)?n:n?.id,h=D.isString(a?.source)?a?.source:a?.source?.id;if(r===h)if(o.add(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const g=this.d[s];g&&(this.w(s,g),this.r(s,g))}}this.u()}deltaConfiguration(i){let o=!1;const t=new Set;i.removedDefaults&&(this.l(i.removedDefaults,t),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,t),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,t),i.addedConfigurations&&this.n(i.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,t){i.forEach(n=>{this.p(n,o,n.extensionInfo,n.restrictedProperties,void 0,t),this.c.push(n),this.q(n)})}o(i,o){const t=n=>{if(n.properties)for(const s in n.properties){o.add(s);const a=this.d[s];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[s],this.s(s,n.properties[s])}n.allOf?.forEach(s=>t(s))};for(const n of i){t(n);const s=this.c.indexOf(n);s!==-1&&this.c.splice(s,1)}}p(i,o=!0,t,n,s=3,a){s=D.isUndefinedOrNull(i.scope)?s:i.scope;const r=i.properties;if(r)for(const g in r){const v=r[g];if(o&&p(g,v)){delete r[g];continue}if(v.source=t,v.defaultDefaultValue=r[g].default,this.w(g,v),e.OVERRIDE_PROPERTY_REGEX.test(g)?v.scope=void 0:(v.scope=D.isUndefinedOrNull(v.scope)?s:v.scope,v.restricted=D.isUndefinedOrNull(v.restricted)?!!n?.includes(g):v.restricted),r[g].hasOwnProperty("included")&&!r[g].included){this.f[g]=r[g],delete r[g];continue}else this.d[g]=r[g],r[g].policy?.name&&this.e.set(r[g].policy.name,g);!r[g].deprecationMessage&&r[g].markdownDeprecationMessage&&(r[g].deprecationMessage=r[g].markdownDeprecationMessage),a.add(g)}const h=i.allOf;if(h)for(const g of h)this.p(g,o,t,n,s,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=t=>{const n=t.properties;if(n)for(const a in n)this.r(a,n[a]);t.allOf?.forEach(o)};o(i)}r(i,o){switch(e.allSettings.properties[i]=o,o.scope){case 1:e.applicationSettings.properties[i]=o;break;case 2:e.machineSettings.properties[i]=o;break;case 6:e.machineOverridableSettings.properties[i]=o;break;case 3:e.windowSettings.properties[i]=o;break;case 4:e.resourceSettings.properties[i]=o;break;case 5:e.resourceSettings.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.allSettings.properties[i],o.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,t={type:"object",description:l.localize(2,null),errorMessage:l.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(o,t),e.allSettings.properties[o]=t,e.applicationSettings.properties[o]=t,e.machineSettings.properties[o]=t,e.machineOverridableSettings.properties[o]=t,e.windowSettings.properties[o]=t,e.resourceSettings.properties[o]=t}}v(){const i={type:"object",description:l.localize(4,null),errorMessage:l.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,o){const t=this.a.get(i);let n=t?.value,s=t?.source;D.isUndefined(n)&&(n=o.defaultDefaultValue,s=void 0),D.isUndefined(n)&&(n=c(o.type)),o.default=n,o.defaultValueSource=s}}const y="\\[([^\\]]+)\\]",u=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(R){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(R)){let o=u.exec(R);for(;o?.length;){const t=o[1].trim();t&&i.push(t),o=u.exec(R)}}return(0,k.distinct)(i)}e.overrideIdentifiersFromKey=S;function f(R){return R.reduce((i,o)=>`${i}[${o}]`,"")}e.keyFromOverrideIdentifiers=f;function c(R){switch(Array.isArray(R)?R[0]:R){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=c;const d=new m;I.Registry.add(e.Extensions.Configuration,d);function p(R,i){return R.trim()?e.OVERRIDE_PROPERTY_REGEX.test(R)?l.localize(7,null,R):d.getConfigurationProperties()[R]!==void 0?l.localize(8,null,R):i.policy?.name&&d.getPolicyConfigurations().get(i.policy?.name)!==void 0?l.localize(9,null,R,i.policy?.name,d.getPolicyConfigurations().get(i.policy?.name)):null:l.localize(6,null)}e.validateProperty=p;function w(){const R=[],i=d.getConfigurationProperties();for(const o of Object.keys(i))R.push([o,i[o].scope]);return R.push(["launch",4]),R.push(["task",4]),R}e.getScopes=w}),define(oe[74],ae([0,1,21,3,35,2,37,32,12,11,16,46,40]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function y(o){return Object.isFrozen(o)?o:P.deepFreeze(o)}class u{constructor(t={},n=[],s=[],a){this.b=t,this.c=n,this.d=s,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof u)return n;const s=new S("");return s.parseRaw(n),s.configurationModel});this.f=t.reduce((n,s)=>s===n?s:n.merge(s),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,C.getConfigurationValue)(this.contents,t):this.contents}inspect(t,n){const s=this.rawConfiguration.getValue(t),a=n?this.rawConfiguration.getOverrideValue(t,n):void 0,r=n?this.rawConfiguration.override(n).getValue(t):s;return{value:s,override:a,merged:r}}getOverrideValue(t,n){const s=this.i(n);return s?t?(0,C.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const s of this.overrides)s.identifiers.includes(t)&&n.push(...s.keys);return k.distinct(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return k.distinct(t)}override(t){let n=this.a.get(t);return n||(n=this.g(t),this.a.set(t,n)),n}merge(...t){const n=P.deepClone(this.contents),s=P.deepClone(this.overrides),a=[...this.keys],r=this.raw?.length?[...this.raw]:[this];for(const h of t)if(r.push(...h.raw?.length?h.raw:[h]),!h.isEmpty()){this.h(n,h.contents);for(const g of h.overrides){const[v]=s.filter(A=>k.equals(A.identifiers,g.identifiers));v?(this.h(v.contents,g.contents),v.keys.push(...g.keys),v.keys=k.distinct(v.keys)):s.push(P.deepClone(g))}for(const g of h.keys)a.indexOf(g)===-1&&a.push(g)}return new u(n,a,s,r.every(h=>h instanceof u)?void 0:r)}g(t){const n=this.i(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const s={};for(const a of k.distinct([...Object.keys(this.contents),...Object.keys(n)])){let r=this.contents[a];const h=n[a];h&&(typeof r=="object"&&typeof h=="object"?(r=P.deepClone(r),this.h(r,h)):r=h),s[a]=r}return new u(s,this.keys,this.overrides)}h(t,n){for(const s of Object.keys(n)){if(s in t&&I.isObject(t[s])&&I.isObject(n[s])){this.h(t[s],n[s]);continue}t[s]=P.deepClone(n[s])}}i(t){let n=null,s=null;const a=r=>{r&&(s?this.h(s,r):s=P.deepClone(r))};for(const r of this.overrides)k.equals(r.identifiers,[t])?n=r.contents:r.identifiers.includes(t)&&a(r.contents);return a(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.j(t,n,!0)}setValue(t,n){this.j(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,C.removeFromValueTree)(this.contents,t),b.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>k.equals(s.identifiers,(0,b.overrideIdentifiersFromKey)(t))),1))}j(t,n,s){(0,C.addToValueTree)(this.contents,t,n,a=>console.error(a)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),b.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.push({identifiers:(0,b.overrideIdentifiersFromKey)(t),keys:Object.keys(this.contents[t]),contents:(0,C.toValuesTree)(this.contents[t],a=>console.error(a))})}}e.ConfigurationModel=u;class S{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new u}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,n){if(!I.isUndefinedOrNull(t)){const s=this.g(t);this.parseRaw(s,n)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,n){this.a=t;const{contents:s,keys:a,overrides:r,restricted:h,hasExcludedProperties:g}=this.h(t,n);this.b=new u(s,a,r,g?[t]:void 0),this.c=h||[]}g(t){let n={},s=null,a=[];const r=[],h=[];function g(A){Array.isArray(a)?a.push(A):s!==null&&(a[s]=A)}const v={onObjectBegin:()=>{const A={};g(A),r.push(a),a=A,s=null},onObjectProperty:A=>{s=A},onObjectEnd:()=>{a=r.pop()},onArrayBegin:()=>{const A=[];g(A),r.push(a),a=A,s=null},onArrayEnd:()=>{a=r.pop()},onLiteralValue:g,onError:(A,N,F)=>{h.push({error:A,offset:N,length:F})}};if(t)try{D.visit(t,v),n=a[0]||{}}catch(A){console.error(`Error while parsing settings file ${this.f}: ${A}`),this.d=[A]}return n}h(t,n){const s=m.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),a=this.i(t,s,!0,n);t=a.raw;const r=(0,C.toValuesTree)(t,v=>console.error(`Conflict in settings file ${this.f}: ${v}`)),h=Object.keys(t),g=this.j(t,v=>console.error(`Conflict in settings file ${this.f}: ${v}`));return{contents:r,keys:h,overrides:g,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(t,n,s,a){let r=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:t,restricted:[],hasExcludedProperties:r};const h={},g=[];for(const v in t)if(b.OVERRIDE_PROPERTY_REGEX.test(v)&&s){const A=this.i(t[v],n,!1,a);h[v]=A.raw,r=r||A.hasExcludedProperties,g.push(...A.restricted)}else{const A=n[v],N=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&g.push(v),(N===void 0||a.scopes===void 0||a.scopes.includes(N))&&!(a.skipRestricted&&A?.restricted)?h[v]=t[v]:r=!0}return{raw:h,restricted:g,hasExcludedProperties:r}}j(t,n){const s=[];for(const a of Object.keys(t))if(b.OVERRIDE_PROPERTY_REGEX.test(a)){const r={};for(const h in t[a])r[h]=t[a][h];s.push({identifiers:(0,b.overrideIdentifiersFromKey)(a),keys:Object.keys(r),contents:(0,C.toValuesTree)(r,n)})}return s}}e.ConfigurationModelParser=S;class f extends l.Disposable{constructor(t,n,s,a){super(),this.f=t,this.g=n,this.h=a,this.c=this.B(new T.Emitter),this.onDidChange=this.c.event,this.a=new S(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(s.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(T.Event.any(T.Event.filter(this.h.onDidFilesChange,r=>r.contains(this.f)),T.Event.filter(this.h.onDidRunOperation,r=>(r.isOperation(0)||r.isOperation(3)||r.isOperation(1)||r.isOperation(4))&&s.isEqual(r.resource,t)))(()=>this.c.fire()))}async loadConfiguration(){try{const t=await this.h.readFile(this.f);return this.a.parse(t.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new u}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=f;class c{constructor(t,n,s,a,r,h,g,v,A,N,F,M,L){this.a=t,this.b=n,this.c=s,this.overrideIdentifiers=a,this.d=r,this.f=h,this.g=g,this.h=v,this.i=A,this.j=N,this.k=F,this.l=M,this.m=L}get value(){return y(this.c)}n(t,n,s){const a=t.inspect(n,s);return{get value(){return y(a.value)},get override(){return y(a.override)},get merged(){return y(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class d{constructor(t,n,s,a,r=new u,h=new u,g=new O.ResourceMap,v=new u,A=new O.ResourceMap){this.c=t,this.d=n,this.f=s,this.g=a,this.h=r,this.i=h,this.j=g,this.l=v,this.m=A,this.a=null,this.b=new O.ResourceMap,this.n=null}getValue(t,n,s){return this.q(t,n,s).getValue(t)}updateValue(t,n,s={}){let a;s.resource?(a=this.m.get(s.resource),a||(a=new u,this.m.set(s.resource,a))):a=this.l,n===void 0?a.removeValue(t):a.setValue(t,n),s.resource||(this.a=null)}inspect(t,n,s){const a=this.q(t,n,s),r=this.u(n.resource,s),h=n.resource?this.m.get(n.resource)||this.l:this.l,g=new Set;for(const v of a.overrides)for(const A of v.identifiers)a.getOverrideValue(t,A)!==void 0&&g.add(A);return new c(t,n,a.getValue(t),g.size?[...g]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,r||void 0,h)}keys(t){const n=this.u(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,n){this.j.set(t,n),this.b.delete(t)}deleteFolderConfiguration(t){this.p.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=[];if(!n){const{added:a,updated:r,removed:h}=R(this.c,t);n=[...a,...r,...h]}for(const a of n)for(const r of(0,b.overrideIdentifiersFromKey)(a)){const h=this.c.getKeysForOverrideIdentifier(r),g=t.getKeysForOverrideIdentifier(r),v=[...g.filter(A=>h.indexOf(A)===-1),...h.filter(A=>g.indexOf(A)===-1),...h.filter(A=>!P.equals(this.c.override(r).getValue(A),t.override(r).getValue(A)))];s.push([r,v])}return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:s,removed:a}=R(this.d,t),r=[...n,...s,...a];return r.length&&this.updatePolicyConfiguration(t),{keys:r,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:s,removed:a,overrides:r}=R(this.applicationConfiguration,t),h=[...n,...s,...a];return h.length&&this.updateApplicationConfiguration(t),{keys:h,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:a,overrides:r}=R(this.localUserConfiguration,t),h=[...n,...s,...a];return h.length&&this.updateLocalUserConfiguration(t),{keys:h,overrides:r}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:a,overrides:r}=R(this.remoteUserConfiguration,t),h=[...n,...s,...a];return h.length&&this.updateRemoteUserConfiguration(t),{keys:h,overrides:r}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:a,overrides:r}=R(this.workspaceConfiguration,t),h=[...n,...s,...a];return h.length&&this.updateWorkspaceConfiguration(t),{keys:h,overrides:r}}compareAndUpdateFolderConfiguration(t,n){const s=this.p.get(t),{added:a,updated:r,removed:h,overrides:g}=R(s,n),v=[...a,...r,...h];return(v.length||!s)&&this.updateFolderConfiguration(t,n),{keys:v,overrides:g}}compareAndDeleteFolderConfiguration(t){const n=this.p.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:a,removed:r,overrides:h}=R(n,void 0);return{keys:[...s,...a,...r],overrides:h}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(t,n,s){let a=this.r(n,s);return n.overrideIdentifier&&(a=a.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(a=a.merge(this.d)),a}r({resource:t},n){let s=this.s();if(n&&t){const a=n.getFolder(t);a&&(s=this.t(a.uri)||s);const r=this.m.get(t);r&&(s=s.merge(r))}return s}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(t){let n=this.b.get(t);if(!n){const s=this.s(),a=this.j.get(t);a?(n=s.merge(a),this.b.set(t,n)):n=s}return n}u(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,n)=>{const{contents:s,overrides:a,keys:r}=this.j.get(n);return t.push([n,{contents:s,overrides:a,keys:r}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this.i.keys.forEach(n=>t.add(n)),this.j.forEach(n=>n.keys.forEach(s=>t.add(s))),[...t.values()]}v(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}w(t){const n=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.i.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(a=>n.add(a))),[...n.values()]}static parse(t){const n=this.x(t.defaults),s=this.x(t.policy),a=this.x(t.application),r=this.x(t.user),h=this.x(t.workspace),g=t.folders.reduce((v,A)=>(v.set(E.URI.revive(A[0]),this.x(A[1])),v),new O.ResourceMap);return new d(n,s,a,r,new u,h,g,new u,new O.ResourceMap)}static x(t){return new u(t.contents,t.keys,t.overrides)}}e.Configuration=d;function p(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,n=new Map;for(const a of o)a.keys.forEach(r=>t.add(r)),a.overrides.forEach(([r,h])=>{const g=(0,O.getOrSet)(n,r,new Set);h.forEach(v=>g.add(v))});const s=[];return n.forEach((a,r)=>s.push([r,[...a.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=p;class w{constructor(t,n,s,a){this.change=t,this.f=n,this.g=s,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const r of t.keys)this.affectedKeys.add(r);for(const[,r]of t.overrides)for(const h of r)this.affectedKeys.add(h);this.d=this.a;for(const r of this.affectedKeys)this.d+=r+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=d.parse(this.f.data)),this.i}affectsConfiguration(t,n){const s=this.a+t,a=this.d.indexOf(s);if(a<0)return!1;const r=a+s.length;if(r>=this.d.length)return!1;const h=this.d.charCodeAt(r);if(h!==this.b&&h!==this.c)return!1;if(n){const g=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.f?.workspace):void 0,v=this.g.getValue(t,n,this.h);return!P.equals(g,v)}return!0}}e.ConfigurationChangeEvent=w;function R(o,t){const{added:n,removed:s,updated:a}=i(t?.rawConfiguration,o?.rawConfiguration),r=[],h=o?.getAllOverrideIdentifiers()||[],g=t?.getAllOverrideIdentifiers()||[];if(t){const v=g.filter(A=>!h.includes(A));for(const A of v)r.push([A,t.getKeysForOverrideIdentifier(A)])}if(o){const v=h.filter(A=>!g.includes(A));for(const A of v)r.push([A,o.getKeysForOverrideIdentifier(A)])}if(t&&o){for(const v of h)if(g.includes(v)){const A=i({contents:o.getOverrideValue(void 0,v)||{},keys:o.getKeysForOverrideIdentifier(v)},{contents:t.getOverrideValue(void 0,v)||{},keys:t.getKeysForOverrideIdentifier(v)});r.push([v,[...A.added,...A.removed,...A.updated]])}}return{added:n,removed:s,updated:a,overrides:r}}function i(o,t){const n=o?t?o.keys.filter(r=>t.keys.indexOf(r)===-1):[...o.keys]:[],s=t?o?t.keys.filter(r=>o.keys.indexOf(r)===-1):[...t.keys]:[],a=[];if(o&&t){for(const r of t.keys)if(o.keys.indexOf(r)!==-1){const h=(0,C.getConfigurationValue)(t.contents,r),g=(0,C.getConfigurationValue)(o.contents,r);P.equals(h,g)||a.push(r)}}return{added:n,removed:s,updated:a}}}),define(oe[220],ae([0,1,21,3,2,32,12,74,46,8,59,40]),function(Q,e,k,T,D,l,O,P,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class m extends D.Disposable{constructor(){super(...arguments),this.a=this.B(new T.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(b.Registry.as(I.Extensions.Configuration).onDidUpdateConfiguration(({properties:f,defaultsOverrides:c})=>this.c(Array.from(f),c))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(f,c){this.h(f,b.Registry.as(I.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:f})}f(){return{}}g(){this.b=new P.ConfigurationModel;const f=b.Registry.as(I.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(f),f)}h(f,c){const d=this.f();for(const p of f){const w=d[p],R=c[p];w!==void 0?this.b.addValue(p,w):R?this.b.addValue(p,R.default):this.b.removeValue(p)}}}e.DefaultConfiguration=m;class y{constructor(){this.onDidChangeConfiguration=T.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=y;let u=class extends D.Disposable{get configurationModel(){return this.b}constructor(f,c,d){super(),this.c=f,this.f=c,this.g=d,this.a=this.B(new T.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(f=>this.i(f))),this.B(this.c.onDidChangeConfiguration(async({properties:f})=>this.j(await this.h(f),!0))),this.b}async h(f){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",f);const c={},d=[],p=b.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(const w of f){const R=p[w];if(!R){d.push(w);continue}if(R.policy){if(R.type!=="string"&&R.type!=="number"){this.g.warn(`Policy ${R.policy.name} has unsupported type ${R.type}`);continue}d.push(w),c[R.policy.name]={type:R.type}}}return(0,O.isEmptyObject)(c)||await this.f.updatePolicyDefinitions(c),d}i(f){this.g.trace("PolicyConfiguration#onDidChangePolicies",f);const c=b.Registry.as(I.Extensions.Configuration).getPolicyConfigurations(),d=(0,k.coalesce)(f.map(p=>c.get(p)));this.j(d,!0)}j(f,c){this.g.trace("PolicyConfiguration#update",f);const d=b.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),p=[],w=this.b.isEmpty();for(const R of f){const i=d[R]?.policy?.name;if(i){const o=this.f.getPolicyValue(i);(w?o!==void 0:!(0,l.equals)(this.b.getValue(R),o))&&p.push([R,o])}else this.b.getValue(R)!==void 0&&p.push([R,void 0])}if(p.length){this.g.trace("PolicyConfiguration#changed",p);const R=this.b;this.b=new P.ConfigurationModel;for(const i of R.keys)this.b.setValue(i,R.getValue(i));for(const[i,o]of p)o===void 0?this.b.removeValue(i):this.b.setValue(i,o);c&&this.a.fire(this.b)}}};u=ye([G(1,C.IPolicyService),G(2,E.ILogService)],u),e.PolicyConfiguration=u}),define(oe[221],ae([0,1,6,3,2,22,16,74,220,59]),function(Q,e,k,T,D,l,O,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class C extends D.Disposable{constructor(m,y,u,S){super(),this.i=m,this.h=this.B(new T.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new I.DefaultConfiguration),this.c=u instanceof E.NullPolicyService?new I.NullPolicyConfiguration:this.B(new I.PolicyConfiguration(this.b,u,S)),this.f=this.B(new P.UserSettings(this.i,void 0,l.extUriBiasedIgnorePathCase,y)),this.a=new P.Configuration(this.b.configurationModel,this.c.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.g=this.B(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:f,properties:c})=>this.k(f,c))),this.B(this.c.onDidChangeConfiguration(f=>this.l(f))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,y,u]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.Configuration(m,y,new P.ConfigurationModel,u)}getConfigurationData(){return this.a.toData()}getValue(m,y){const u=typeof m=="string"?m:void 0,S=(0,O.isConfigurationOverrides)(m)?m:(0,O.isConfigurationOverrides)(y)?y:{};return this.a.getValue(u,S,void 0)}updateValue(m,y,u,S){return Promise.reject(new Error("not supported"))}inspect(m){return this.a.inspect(m,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.j(m)}j(m){const y=this.a.toData(),u=this.a.compareAndUpdateLocalUserConfiguration(m);this.m(u,y,2)}k(m,y){const u=this.a.toData(),S=this.a.compareAndUpdateDefaultConfiguration(m,y);this.m(S,u,7)}l(m){const y=this.a.toData(),u=this.a.compareAndUpdatePolicyConfiguration(m);this.m(u,y,7)}m(m,y,u){const S=new P.ConfigurationChangeEvent(m,{data:y},this.a);S.source=u,S.sourceConfig=this.n(u),this.h.fire(S)}n(m){switch(m){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=C}),define(oe[222],ae([0,1,9,5]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,T.createDecorator)("remoteAuthorityResolverService");var D;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class l extends k.ErrorNoTelemetry{static isNotAvailable(I){return I instanceof l&&I._code===D.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof l&&I._code===D.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof l&&I._code===D.NoResolverFound}static isHandled(I){return I instanceof l&&I.isHandled}constructor(I,E=D.Unknown,C){super(I),this._message=I,this._code=E,this._detail=C,this.isHandled=E===D.NotAvailable&&C===!0,Object.setPrototypeOf(this,l.prototype)}}e.RemoteAuthorityResolverError=l;function O(P){const I=P.indexOf("+");return I===-1?P:P.substring(0,I)}e.getRemoteAuthorityPrefix=O}),define(oe[75],ae([0,1,26]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function T(E){return E.scheme===k.Schemas.vscodeRemote?E.authority:void 0}e.getRemoteAuthority=T;function D(E){if(!E)return;const C=E.indexOf("+");return C<0?E:E.substr(0,C)}e.getRemoteName=D;function l(E){return`/${E.quality??"oss"}-${E.commit??"dev"}`}e.getRemoteServerRootPath=l;function O(E){const{host:C,port:b}=I(E);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:b}}e.parseAuthorityWithPort=O;function P(E,C){let{host:b,port:m}=I(E);return typeof m>"u"&&(m=C),{host:b,port:m}}e.parseAuthorityWithOptionalPort=P;function I(E){const C=E.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const b=E.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const m=E.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:E,port:void 0}}}),define(oe[42],ae([0,1,27,5,75]),function(Q,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function l(u){if(typeof u=="object"&&u!==null&&u.supported!==!0)return u.description}e.getWorkspaceSupportTypeMessage=l;function O(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=O,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(u){u[u.System=0]="System",u[u.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var I;(function(u){u.WIN32_X64="win32-x64",u.WIN32_IA32="win32-ia32",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(I=e.TargetPlatform||(e.TargetPlatform={}));class E{constructor(S){this.value=S,this.c=S.toLowerCase()}static equals(S,f){if(typeof S>"u"||S===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof S=="string"||typeof f=="string"){const c=typeof S=="string"?S:S.value,d=typeof f=="string"?f:f.value;return k.equalsIgnoreCase(c,d)}return S.c===f.c}static toKey(S){return typeof S=="string"?S.toLowerCase():S.c}}e.ExtensionIdentifier=E;function C(u){return b(u)}e.isApplicationScopedExtension=C;function b(u){return u.contributes&&u.contributes.localizations?u.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function m(u){return u.contributes&&u.contributes.authentication?u.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function y(u,S){if(S){const f=`onResolveRemoteAuthority:${(0,D.getRemoteName)(S)}`;return u.activationEvents?.indexOf(f)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(oe[223],ae([0,1,2,13,28,42]),function(Q,e,k,T,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class O extends k.Disposable{constructor(I,E){super(),this.b=I,this.a=(0,T.join)(this.b.userDataPath,l.MANIFEST_CACHE_FOLDER,l.USER_MANIFEST_CACHE_FILE),this.B(E.onDidInstallExtensions(C=>this.c(C))),this.B(E.onDidUninstallExtension(C=>this.f(C)))}c(I){I.some(E=>!!E.local)&&this.invalidate()}f(I){I.error||this.invalidate()}invalidate(){D.Promises.rm(this.a,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=O}),define(oe[224],ae([0,1,6,17,25,9,3,2,102,88,31,93,222,75]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const u=30*1e3;var S;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(S=e.ConnectionType||(e.ConnectionType={}));function f(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function c(W){const q=new D.CancellationTokenSource;return setTimeout(()=>q.cancel(),W),q.token}function d(W,q){if(W.isCancellationRequested||q.isCancellationRequested)return D.CancellationToken.Cancelled;const Y=new D.CancellationTokenSource;return W.onCancellationRequested(()=>Y.cancel()),q.onCancellationRequested(()=>Y.cancel()),Y.token}class p{get didTimeout(){return this.c==="timedout"}constructor(q){this.c="pending",this.d=new P.DisposableStore,this.promise=new Promise((Y,ee)=>{this.f=Y,this.g=ee}),q.isCancellationRequested?this.h():this.d.add(q.onCancellationRequested(()=>this.h()))}registerDisposable(q){this.c==="pending"?this.d.add(q):q.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const q=new Error("Time limit reached");return q.code="ETIMEDOUT",q.syscall="connect",q}resolve(q){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(q))}reject(q){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(q))}}function w(W,q){const Y=new p(q);return Y.registerDisposable(W.onControlMessage(ee=>{const K=JSON.parse(ee.toString()),Z=J(K);Z?Y.reject(Z):Y.resolve(K)})),Y.promise}function R(W,q,Y,ee,K,Z,se,le,ue){const pe=new p(ue),ve=E.StopWatch.create(!1);return W.info(`Creating a socket (${le})...`),I.mark(`code/willCreateSocket/${se}`),q.connect(Y,ee,K,Z,le,(be,Ee)=>{pe.didTimeout?(I.mark(`code/didCreateSocketError/${se}`),W.info(`Creating a socket (${le}) finished after ${ve.elapsed()} ms, but this is too late and has timed out already.`),be&&W.error(be),Ee?.dispose()):be||!Ee?(I.mark(`code/didCreateSocketError/${se}`),W.info(`Creating a socket (${le}) returned an error after ${ve.elapsed()} ms.`),pe.reject(be)):(I.mark(`code/didCreateSocketOK/${se}`),W.info(`Creating a socket (${le}) was successful after ${ve.elapsed()} ms.`),pe.resolve(Ee))}),pe.promise}function i(W,q){const Y=new p(q);return W.then(ee=>{Y.didTimeout||Y.resolve(ee)},ee=>{Y.didTimeout||Y.reject(ee)}),Y.promise}async function o(W,q,Y,ee){const K=U(W,q);W.logService.trace(`${K} 1/6. invoking socketFactory.connect().`);let Z;try{Z=await R(W.logService,W.socketFactory,W.host,W.port,(0,y.getRemoteServerRootPath)(W),`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,f(q),`renderer-${f(q)}-${W.reconnectionToken}`,ee)}catch(ve){throw W.logService.error(`${K} socketFactory.connect() failed or timed out. Error:`),W.logService.error(ve),ve}W.logService.trace(`${K} 2/6. socketFactory.connect() was successful.`);let se,le;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection(Z,null),se=W.reconnectionProtocol,le=!1):(se=new b.PersistentProtocol({socket:Z,measureRoundTripTime:!0}),le=!0),W.logService.trace(`${K} 3/6. sending AuthRequest control message.`);const ue=await i(W.signService.createNewMessage((0,C.generateUuid)()),ee),pe={type:"auth",auth:W.connectionToken||"00000000000000000000",data:ue.data};se.sendControl(T.VSBuffer.fromString(JSON.stringify(pe)));try{const ve=await w(se,d(ee,c(1e4)));if(ve.type!=="sign"||typeof ve.data!="string"){const Ue=new Error("Unexpected handshake message");throw Ue.code="VSCODE_CONNECTION_ERROR",Ue}if(W.logService.trace(`${K} 4/6. received SignRequest control message.`),!await i(W.signService.validate(ue,ve.signedData),ee)){const Ue=new Error("Refused to connect to unsupported server");throw Ue.code="VSCODE_CONNECTION_ERROR",Ue}const Ee=await i(W.signService.sign(ve.data),ee),Oe={type:"connectionType",commit:W.commit,signedData:Ee,desiredConnectionType:q};return Y&&(Oe.args=Y),W.logService.trace(`${K} 5/6. sending ConnectionTypeRequest control message.`),se.sendControl(T.VSBuffer.fromString(JSON.stringify(Oe))),{protocol:se,ownsProtocol:le}}catch(ve){throw ve&&ve.code==="ETIMEDOUT"&&(W.logService.error(`${K} the handshake timed out. Error:`),W.logService.error(ve)),ve&&ve.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${K} received error control message when negotiating connection. Error:`),W.logService.error(ve)),le&&V(se),ve}}async function t(W,q,Y,ee){const K=Date.now(),Z=U(W,q),{protocol:se,ownsProtocol:le}=await o(W,q,Y,ee),ue=new p(ee);return ue.registerDisposable(se.onControlMessage(pe=>{const ve=JSON.parse(pe.toString()),be=J(ve);be?(W.logService.error(`${Z} received error control message when negotiating connection. Error:`),W.logService.error(be),le&&V(se),ue.reject(be)):(W.reconnectionProtocol?.endAcceptReconnection(),W.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${B(K)}!`),ue.resolve({protocol:se,firstMessage:ve}))})),ue.promise}async function n(W,q){const{protocol:Y}=await t(W,1,void 0,q);return{protocol:Y}}async function s(W,q,Y){const{protocol:ee,firstMessage:K}=await t(W,2,q,Y),Z=K&&K.debugPort;return{protocol:ee,debugPort:Z}}async function a(W,q,Y){const ee=Date.now(),K=U(W,3),{protocol:Z}=await o(W,3,q,Y);return W.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${B(ee)}!`),Z}async function r(W,q,Y){const{host:ee,port:K,connectionToken:Z}=await W.addressProvider.getAddress();return{commit:W.commit,quality:W.quality,host:ee,port:K,connectionToken:Z,reconnectionToken:q,reconnectionProtocol:Y,socketFactory:W.socketFactory,signService:W.signService,logService:W.logService}}async function h(W,q,Y){return v(W,async ee=>{const{protocol:K}=await n(ee,D.CancellationToken.None);return new H(W,q,Y,ee.reconnectionToken,K)})}e.connectRemoteAgentManagement=h;async function g(W,q){return v(W,async Y=>{const{protocol:ee,debugPort:K}=await s(Y,q,D.CancellationToken.None);return new j(W,q,Y.reconnectionToken,ee,K)})}e.connectRemoteAgentExtensionHost=g;async function v(W,q){for(let ee=1;;ee++)try{const K=(0,C.generateUuid)(),Z=await r(W,K,null);return await q(Z)}catch(K){if(ee<5)W.logService.error(`[remote-connection][attempt ${ee}] An error occurred in initial connection! Will retry... Error:`),W.logService.error(K);else throw W.logService.error(`[remote-connection][attempt ${ee}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),W.logService.error(K),ie.triggerPermanentFailure(0,0,m.RemoteAuthorityResolverError.isHandled(K)),K}}async function A(W,q,Y){const ee=await r(W,(0,C.generateUuid)(),null);return await a(ee,{host:q,port:Y},D.CancellationToken.None)}e.connectRemoteAgentTunnel=A;function N(W){return(0,k.createCancelablePromise)(q=>new Promise((Y,ee)=>{const K=setTimeout(Y,W*1e3);q.onCancellationRequested(()=>{clearTimeout(K),Y()})}))}var F;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain",W[W.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(F=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class M{constructor(q,Y){this.reconnectionToken=q,this.millisSinceLastIncomingData=Y,this.type=0}}e.ConnectionLostEvent=M;class L{constructor(q,Y,ee,K){this.reconnectionToken=q,this.millisSinceLastIncomingData=Y,this.durationSeconds=ee,this.c=K,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=L;class ${constructor(q,Y,ee){this.reconnectionToken=q,this.millisSinceLastIncomingData=Y,this.attempt=ee,this.type=2}}e.ReconnectionRunningEvent=$;class z{constructor(q,Y,ee){this.reconnectionToken=q,this.millisSinceLastIncomingData=Y,this.attempt=ee,this.type=4}}e.ConnectionGainEvent=z;class x{constructor(q,Y){this.reconnectionToken=q,this.connectionHealth=Y,this.type=5}}e.ConnectionHealthChangedEvent=x;class X{constructor(q,Y,ee,K){this.reconnectionToken=q,this.millisSinceLastIncomingData=Y,this.attempt=ee,this.handled=K,this.type=3}}e.ReconnectionPermanentFailureEvent=X;class ie extends P.Disposable{static triggerPermanentFailure(q,Y,ee){this._permanentFailure=!0,this.f=q,this.g=Y,this.h=ee,this.i.forEach(K=>K.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(q=>q.r())}static debugPauseSocketWriting(){this.i.forEach(q=>q.v())}get k(){return this.c||ie._permanentFailure}constructor(q,Y,ee,K,Z){super(),this.m=q,this.n=Y,this.reconnectionToken=ee,this.protocol=K,this.p=Z,this.j=this.B(new O.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new z(this.reconnectionToken,0,0)),this.B(K.onSocketClose(se=>{const le=te(this.m,this.reconnectionToken,!0);se?se.type===0?(this.n.logService.info(`${le} received socket close event (hadError: ${se.hadError}).`),se.error&&this.n.logService.error(se.error)):(this.n.logService.info(`${le} received socket close event (wasClean: ${se.wasClean}, code: ${se.code}, reason: ${se.reason}).`),se.event&&this.n.logService.error(se.event)):this.n.logService.info(`${le} received socket close event.`),this.r()})),this.B(K.onSocketTimeout(se=>{const le=te(this.m,this.reconnectionToken,!0);this.n.logService.info(`${le} received socket timeout event (unacknowledgedMsgCount: ${se.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${se.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${se.timeSinceLastReceivedSomeData}).`),this.r()})),this.B(K.onHighRoundTripTime(se=>{const le=re(this.m,this.reconnectionToken);this.n.logService.info(`${le} high roundtrip time: ${se.roundTripTime}ms (${se.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(K.onDidChangeConnectionHealth(se=>{this.j.fire(new x(this.reconnectionToken,se))})),ie.i.push(this),this.B((0,P.toDisposable)(()=>{const se=ie.i.indexOf(this);se>=0&&ie.i.splice(se,1)})),this.k&&this.u(ie.f,ie.g,ie.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const q=te(this.m,this.reconnectionToken,!0);this.n.logService.info(`${q} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const Y=[0,5,5,10,10,10,10,10,30];let ee=-1;do{ee++;const K=ee<Y.length?Y[ee]:Y[Y.length-1];try{if(K>0){const se=N(K);this.j.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),K,se)),this.n.logService.info(`${q} waiting for ${K} seconds before reconnecting...`);try{await se}catch{}}if(this.k){this.n.logService.error(`${q} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new $(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ee+1)),this.n.logService.info(`${q} resolving connection...`);const Z=await r(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${q} connecting to ${Z.host}:${Z.port}...`),await this.w(Z,c(u)),this.n.logService.info(`${q} reconnected!`),this.j.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ee+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(Z),this.t(this.protocol.getMillisSinceLastIncomingData(),ee+1,!1);break}if(ee>360){this.n.logService.error(`${q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(Z),this.t(this.protocol.getMillisSinceLastIncomingData(),ee+1,!1);break}if(m.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Z)){this.n.logService.info(`${q} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this.n.logService.info(`${q} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(Z);continue}if((0,l.isCancellationError)(Z)){this.n.logService.info(`${q} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(Z);continue}if(Z instanceof m.RemoteAuthorityResolverError){this.n.logService.error(`${q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(Z),this.t(this.protocol.getMillisSinceLastIncomingData(),ee+1,m.RemoteAuthorityResolverError.isHandled(Z));break}this.n.logService.error(`${q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(Z),this.t(this.protocol.getMillisSinceLastIncomingData(),ee+1,!1);break}}while(!this.k)}t(q,Y,ee){this.p?ie.triggerPermanentFailure(q,Y,ee):this.u(q,Y,ee)}u(q,Y,ee){this.j.fire(new X(this.reconnectionToken,q,Y,ee)),V(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ie,ie._permanentFailure=!1,ie.f=0,ie.g=0,ie.h=!1,ie.i=[];class H extends ie{constructor(q,Y,ee,K,Z){super(1,q,K,Z,!0),this.client=this.B(new b.Client(Z,{remoteAuthority:Y,clientId:ee},q.ipcLogger))}async w(q,Y){await n(q,Y)}}e.ManagementPersistentConnection=H;class j extends ie{constructor(q,Y,ee,K,Z){super(2,q,ee,K,!1),this.y=Y,this.debugPort=Z}async w(q,Y){await s(q,this.y,Y)}}e.ExtensionHostPersistentConnection=j;function V(W){try{W.acceptDisconnect();const q=W.getSocket();W.dispose(),q.dispose()}catch(q){(0,l.onUnexpectedError)(q)}}function J(W){if(W&&W.type==="error"){const q=new Error(`Connection error: ${W.reason}`);return q.code="VSCODE_CONNECTION_ERROR",q}return null}function _(W,q){for(;W.length<q;)W+=" ";return W}function re(W,q){return`[remote-connection][${_(f(W),13)}][${q.substr(0,5)}\u2026]`}function te(W,q,Y){return`${re(W,q)}[${Y?"reconnect":"initial"}]`}function U(W,q){return`${te(q,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.host}:${W.port}]`}function B(W){return`${Date.now()-W} ms`}}),define(oe[225],ae([0,1,5]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,k.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(oe[226],ae([0,1,86,152]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,l,O,P,I,E){const C=m=>E(m,void 0),b=k.createConnection({host:D,port:l},()=>{b.removeListener("error",C);const m=Buffer.alloc(16);for(let f=0;f<16;f++)m[f]=Math.round(Math.random()*256);const y=m.toString("base64"),u=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${l}${O}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`];b.write(u.join(`\r
`)+`\r
\r
`);const S=f=>{f.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",S),E(void 0,new T.NodeSocket(b,I)))};b.on("data",S)});b.setNoDelay(!0),b.once("error",C)}}}),define(oe[107],ae([0,1,5,170]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOG_CHANNEL_ID=e.LOGGER_NAME=e.LOG_FILE_NAME=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,k.createDecorator)("IRemoteTunnelService");var D;(function(l){l.disconnected={type:"disconnected"},l.uninitialized={type:"uninitialized"},l.connected=O=>({type:"connected",info:O}),l.connecting=O=>({type:"connecting",progress:O})})(D=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.LOG_FILE_NAME="remoteTunnelService.log",e.LOGGER_NAME=(0,T.localize)(0,null),e.LOG_CHANNEL_ID="remoteTunnelServiceLog"}),define(oe[227],ae([0,1,136,16,8]),function(Q,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let l=class{constructor(P,I){this.a=P,this.b=I}async request(P,I){this.b.trace("RequestService#request (browser) - begin",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.a.getValue("http.proxyAuthorization"));try{const E=await(0,k.request)(P,I);return this.b.trace("RequestService#request (browser) - success",P.url),E}catch(E){throw this.b.error("RequestService#request (browser) - error",P.url,E),E}}async resolveProxy(P){}};l=ye([G(0,T.IConfigurationService),G(1,D.ILogService)],l),e.RequestService=l}),define(oe[60],ae([0,1,17,172,46,5,40]),function(Q,e,k,T,D,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,l.createDecorator)("requestService");function P(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.isSuccess=P;function I(S){return S.res.statusCode===204}async function E(S){return I(S)?null:(await(0,k.streamToBuffer)(S.stream)).toString()}e.asText=E;async function C(S){if(!P(S))throw new Error("Server returned "+S.res.statusCode);return E(S)}e.asTextOrError=C;async function b(S){if(!P(S))throw new Error("Server returned "+S.res.statusCode);if(I(S))return null;const c=(await(0,k.streamToBuffer)(S.stream)).toString();try{return JSON.parse(c)}catch(d){throw d.message+=`:
`+c,d}}e.asJson=b;function m(S){u(S)}e.updateProxyConfigurationsScope=m;let y;function u(S){const f=O.Registry.as(D.Extensions.Configuration),c=y;y={id:"http",order:15,title:(0,T.localize)(0,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,T.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,T.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,T.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,T.localize)(4,null),(0,T.localize)(5,null),(0,T.localize)(6,null),(0,T.localize)(7,null)],default:"override",description:(0,T.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,T.localize)(9,null),restricted:!0}}},f.updateConfigurations({add:[y],remove:c?[c]:[]})}u(2)}),define(oe[228],ae([0,1,25,26,14,60]),function(Q,e,k,T,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let O=class{constructor(I,E){this.a=I,this.b=E}async download(I,E,C=k.CancellationToken.None){if(I.scheme===T.Schemas.file||I.scheme===T.Schemas.vscodeRemote){await this.b.copy(I,E);return}const b={type:"GET",url:I.toString(!0)},m=await this.a.request(b,C);if(m.res.statusCode===200)await this.b.writeFile(E,m.stream);else{const y=await(0,l.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${y}`)}}};O=ye([G(0,l.IRequestService),G(1,D.IFileService)],O),e.DownloadService=O}),define(oe[229],ae([0,1,17,25]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class D{constructor(P){this.a=P}listen(P,I){throw new Error("Invalid listen")}call(P,I,E,C=T.CancellationToken.None){switch(I){case"request":return this.a.request(E[0],C).then(async({res:b,stream:m})=>{const y=await(0,k.streamToBuffer)(m);return[{statusCode:b.statusCode,headers:b.headers},y]});case"resolveProxy":return this.a.resolveProxy(E[0])}throw new Error("Invalid call")}}e.RequestChannel=D;class l{constructor(P){this.a=P}async request(P,I){const[E,C]=await this.a.call("request",[P],I);return{res:E,stream:(0,k.bufferToStream)(C)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.RequestChannelClient=l}),define(oe[230],ae([0,1,12,227,229]),function(Q,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class l{constructor(P,I,E,C){this.c=I,this.d=E,this.e=C,this.a=new T.RequestService(I,C),this.b=new D.RequestChannelClient(P.getChannel("request"))}request(P,I){return this.f().request(P,I)}async resolveProxy(P){return this.f().resolveProxy(P)}f(){return this.g()?(this.e.trace("Using main request service"),this.b):(this.e.trace("Using browser request service"),this.a)}g(){const P=this.c.getValue("developer.sharedProcess.redirectRequestsToMain");return(0,k.isBoolean)(P)?P:this.d.quality!=="stable"}}e.SharedProcessRequestService=l}),define(oe[108],ae([0,1,66,5]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function D(l){return(0,k.hash)({moduleId:l.process.moduleId,windowId:l.reply.windowId})}e.hash=D,e.ISharedProcessWorkerService=(0,T.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(oe[231],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var k;(function(T){T.Spawn="vscode:shared-process->shared-process-worker=spawn",T.Terminate="vscode:shared-process->shared-process-worker=terminate",T.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",T.Ready="vscode:shared-process-worker->shared-process=ready",T.Ack="vscode:shared-process-worker->shared-process=ack",T.Trace="vscode:shared-process-worker->shared-process=trace",T.Info="vscode:shared-process-worker->shared-process=info",T.Warn="vscode:shared-process-worker->shared-process=warn",T.Error="vscode:shared-process-worker->shared-process=error"})(k=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(oe[232],ae([0,1,94,6,25,3,2,26,31,8,108,231]),function(Q,e,k,T,D,l,O,P,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let m=class{constructor(S){this.d=S,this.a=new Map,this.b=new Map,this.c=new Map}async createWorker(S){const f=`window: ${S.reply.windowId}, moduleId: ${S.process.moduleId}`;this.d.trace(`SharedProcess: createWorker (${f})`);const c=(0,C.hash)(S);this.b.has(c)&&(this.d.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${f})`),this.f(S));const d=new D.CancellationTokenSource;let p,w,R;this.b.set(c,n=>{d.dispose(!0),p?.terminate(S,D.CancellationToken.None),w?.close(),R?.close(),this.b.delete(c);const s=this.c.get(c);s&&(this.c.delete(c),s({reason:n}))}),p=await this.e(S);const i=new Promise(n=>{this.c.set(c,n)});if(d.token.isCancellationRequested)return i;const{port1:o,port2:t}=new MessageChannel;return w=o,R=t,await p.spawn(S,R,d.token),d.token.isCancellationRequested||(this.d.trace(`SharedProcess: createWorker sending message port back to window (${f})`),k.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",S,[w])),i}e(S){let f=this.a.get(S.process.moduleId);if(!f){this.d.trace(`SharedProcess: creating new web worker (${S.process.moduleId})`);const c=new y(S.process.type,this.d);f=c.init(),c.onDidProcessSelfTerminate(({configuration:d,reason:p})=>{this.f(d,p)}),this.a.set(S.process.moduleId,f)}return f}async disposeWorker(S){return this.f(S)}f(S,f){const c=this.b.get((0,C.hash)(S));c&&(this.d.trace(`SharedProcess: disposeWorker (window: ${S.reply.windowId}, moduleId: ${S.process.moduleId})`),c(f))}};m=ye([G(0,E.ILogService)],m),e.SharedProcessWorkerService=m;class y extends O.Disposable{constructor(S,f){super(),this.f=S,this.g=f,this.a=this.B(new l.Emitter),this.onDidProcessSelfTerminate=this.a.event,this.b=this.h(),this.c=new Map}async init(){return await this.b,this}h(){const S=new T.DeferredPromise,f=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.f})`});return f.onerror=c=>{this.g.error(`SharedProcess: worker error (${this.f})`,c.message)},f.onmessageerror=c=>{this.g.error(`SharedProcess: worker message error (${this.f})`,c)},f.onmessage=c=>{const{id:d,message:p,configuration:w,nonce:R}=c.data;switch(d){case b.SharedProcessWorkerMessages.Ready:S.complete(f);break;case b.SharedProcessWorkerMessages.Ack:if(R){const i=this.c.get(R);i&&(this.c.delete(R),i())}break;case b.SharedProcessWorkerMessages.SelfTerminated:w&&p&&this.a.fire({configuration:w,reason:JSON.parse(p)});break;case b.SharedProcessWorkerMessages.Trace:this.g.trace(`SharedProcess (worker, ${this.f}):`,p);break;case b.SharedProcessWorkerMessages.Info:p&&this.g.info(p);break;case b.SharedProcessWorkerMessages.Warn:this.g.warn(`SharedProcess (worker, ${this.f}):`,p);break;case b.SharedProcessWorkerMessages.Error:this.g.error(`SharedProcess (worker, ${this.f}):`,p);break;default:this.g.warn(`SharedProcess: unexpected worker message (${this.f})`,c)}},f.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),S.p}async i(S,f,c){const d=await this.b;if(!f.isCancellationRequested)return new Promise(p=>{const w=(0,I.generateUuid)();this.c.set(w,p);const R={...S,nonce:w};c?d.postMessage(R,[c]):d.postMessage(R),f.onCancellationRequested(()=>{this.c.delete(w)&&p()})})}spawn(S,f,c){const d={id:b.SharedProcessWorkerMessages.Spawn,configuration:S,environment:{bootstrapPath:P.FileAccess.asFileUri("bootstrap-fork").fsPath}};return this.i(d,c,f)}terminate(S,f){const c={id:b.SharedProcessWorkerMessages.Terminate,configuration:S};return this.i(c,f)}}}),define(oe[233],ae([0,1,63,26,191]),function(Q,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class l extends D.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:T.Schemas.vscodeUserData})}}ye([k.memoize],l.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=l}),define(oe[234],ae([0,1,50,13,173,25,38,9,4,31,149,189,6,130]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let u;async function S(c,d,p,w){return p["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):I.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(w)&&!p["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(w)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=m.Promises.withAsyncBody(async(R,i)=>{const o=new l.CancellationTokenSource;let t=1e4;const n=c.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(t=(0,y.clamp)(n,1,120)*1e3);const s=setTimeout(()=>{o.dispose(!0),i(new Error((0,D.localize)(0,null)))},t);try{R(await f(d,o.token))}catch(a){!(0,P.isCancellationError)(a)&&!o.token.isCancellationRequested?i(new Error((0,D.localize)(1,null,(0,O.toErrorMessage)(a)))):R({})}finally{clearTimeout(s),o.dispose()}})),u)}e.getResolvedShellEnv=S;async function f(c,d){const p=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",p);const w=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",w);const R=(0,E.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(R+"({.*})"+R),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",o);const t=await(0,C.getSystemShell)(I.OS,o);return c.trace("getUnixShellEnvironment#shell",t),new Promise((n,s)=>{if(d.isCancellationRequested)return s(new P.CancellationError);const a=(0,T.basename)(t);let r,h;const g=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(r=`& '${process.execPath}' ${g} -p '''${R}'' + JSON.stringify(process.env) + ''${R}'''`,h=["-Login","-Command"]):(r=`'${process.execPath}' ${g} -p '"${R}" + JSON.stringify(process.env) + "${R}"'`,a==="tcsh"||a==="csh"?h=["-ic"]:h=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),r);const v=(0,k.spawn)(t,[...h,r],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});d.onCancellationRequested(()=>(v.kill(),s(new P.CancellationError))),v.on("error",F=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,O.toErrorMessage)(F)),s(F)});const A=[];v.stdout.on("data",F=>A.push(F));const N=[];v.stderr.on("data",F=>N.push(F)),v.on("close",(F,M)=>{const L=Buffer.concat(A).toString("utf8");c.trace("getUnixShellEnvironment#raw",L);const $=Buffer.concat(N).toString("utf8");if($.trim()&&c.trace("getUnixShellEnvironment#stderr",$),F||M)return s(new Error((0,D.localize)(2,null,F,M)));const z=i.exec(L),x=z?z[1]:"{}";try{const X=JSON.parse(x);p?X.ELECTRON_RUN_AS_NODE=p:delete X.ELECTRON_RUN_AS_NODE,w?X.ELECTRON_NO_ATTACH_CONSOLE=w:delete X.ELECTRON_NO_ATTACH_CONSOLE,delete X.VSCODE_RESOLVING_ENVIRONMENT,delete X.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",X),n(X)}catch(X){c.error("getUnixShellEnvironment#errorCaught",(0,O.toErrorMessage)(X)),s(X)}})})}}),define(oe[109],ae([0,1,5]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,k.createDecorator)(e.SIGN_SERVICE_ID)}),define(oe[235],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class k{constructor(){this.b=new Map}c(){return new Promise((D,l)=>Q(["vsda"],D,l))}async createNewMessage(D){try{const l=await this.c(),O=new l.validator;if(O){const P=String(k.a++);return this.b.set(P,O),{id:P,data:O.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,l){if(!D.id)return!0;const O=this.b.get(D.id);if(!O)return!1;this.b.delete(D.id);try{return O.validate(l)==="ok"}catch{return!1}}async sign(D){try{const l=await this.c(),O=new l.signer;if(O)return O.sign(D)}catch{}return D}}e.SignService=k,k.a=1}),define(oe[76],ae([0,1,3,2]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class D extends T.Disposable{constructor(b,m,y){super(),this.a=b,this.b=m,this.c=y}async getItems(){const b={profile:this.b,workspace:this.c},m=await this.a.call("getItems",b);return new Map(m)}updateItems(b){const m={profile:this.b,workspace:this.c};return b.insert&&(m.insert=Array.from(b.insert.entries())),b.delete&&(m.delete=Array.from(b.delete.values())),this.a.call("updateItems",m)}}class l extends D{constructor(b,m){super(b,m,void 0),this.f=this.B(new k.Emitter),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(b=>this.h(b)))}h(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this.f.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}}class O extends l{constructor(b){super(b,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=O;class P extends l{constructor(b,m){super(b,m)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=P;class I extends D{constructor(b,m){super(b,void 0,m),this.onDidChangeItemsExternal=k.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=I;class E{constructor(b){this.a=b}isUsed(b){const m={payload:b,profile:void 0,workspace:void 0};return this.a.call("isUsed",m)}}e.StorageClient=E}),define(oe[110],ae([0,1,4,36,11,31]),function(Q,e,k,T,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function O(E){if(k.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function P(E,C,b,m,y,u,S,f,c,d){const p=Object.create(null);p["common.machineId"]=S,p.sessionID=(0,l.generateUuid)()+Date.now(),p.commitHash=y,p.version=u,p["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,k.PlatformToString)(k.platform),p["common.nodePlatform"]=T.platform,p["common.nodeArch"]=m,p["common.product"]=d||"desktop",f&&(p["common.msftInternal"]=f);let w=0;const R=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-R,enumerable:!0},"common.sequence":{get:()=>w++,enumerable:!0}}),k.isLinuxSnap&&(p["common.snap"]="true");const i=O(b);i&&(p["common.platformDetail"]=i);try{const o=await E.readFile(D.URI.file(c));p["common.source"]=o.value.toString().slice(0,30)}catch{}return p}e.resolveCommonProperties=P;function I(E){const C=T.env.USERDNSDOMAIN;if(!C)return!1;const b=C.toLowerCase();return E.some(m=>b===m)}e.verifyMicrosoftInternalDomain=I}),define(oe[19],ae([0,1,5]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var T;(function(l){l[l.NONE=0]="NONE",l[l.CRASH=1]="CRASH",l[l.ERROR=2]="ERROR",l[l.USAGE=3]="USAGE"})(T=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(l){l.OFF="off",l.CRASH="crash",l.ERROR="error",l.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(oe[236],ae([0,1,34,6,35,26,13,4,11,146,28,148,96,14,23,19]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const f=new Map;async function c(i,o){const t=`${i}::${o.join(":")}`,n=f.get(t);if(n)return n;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,r=new Map,h=2e4;function g(A,N,F,M){const L=N.substring(A.length+1);return T.Promises.withAsyncBody(async $=>{let z;try{z=await C.Promises.readdir(N,{withFileTypes:!0})}catch{$();return}if(M.count>=h){M.count+=z.length,M.maxReached=!0,$();return}let x=z.length;if(x===0){$();return}let X=z;M.count+z.length>h&&(M.maxReached=!0,x=h-M.count,X=z.slice(0,x)),M.count+=z.length;for(const ie of X)if(ie.isDirectory()){if(F.includes(ie.name)||await g(A,(0,O.join)(N,ie.name),F,M),--x===0){$();return}}else{const H=ie.name.lastIndexOf(".");if(H>=0){const j=ie.name.substring(H+1);j&&a.set(j,(a.get(j)??0)+1)}for(const j of s)j.relativePathPattern?.test(L)!==!1&&j.filePattern.test(ie.name)&&r.set(j.tag,(r.get(j.tag)??0)+1);if(--x===0){$();return}}})}const v=T.Promises.withAsyncBody(async A=>{const N={count:0,maxReached:!1};await g(i,i,o,N);const F=await w(i);A({configFiles:d(r),fileTypes:d(a),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:F})});return f.set(t,v),v}e.collectWorkspaceStats=c;function d(i){return Array.from(i.entries(),([o,t])=>({name:o,count:t})).sort((o,t)=>t.count-o.count)}function p(){const i={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/y.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/y.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(E.virtualMachineHint.value()*100)}%`},o=k.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}e.getMachineInfo=p;async function w(i){try{const o=new Map,t=(0,O.join)(i,".vscode","launch.json"),n=await C.Promises.readFile(t),s=[],a=(0,D.parse)(n.toString(),s);if(s.length)return console.log(`Unable to parse ${t}`),[];if((0,D.getNodeType)(a)==="object"&&a.configurations)for(const r of a.configurations){const h=r.type;h&&(o.has(h)?o.set(h,o.get(h)+1):o.set(h,1))}return d(o)}catch{return[]}}e.collectLaunchConfigs=w;let R=class{constructor(o,t){this.c=o,this.d=t}f(o){const t=[];return t.push(`OS Version:       ${o.os}`),t.push(`CPUs:             ${o.cpus}`),t.push(`Memory (System):  ${o.memory}`),t.push(`VM:               ${o.vmHint}`),t.join(`
`)}g(o){const t=[];t.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),t.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const n=k.cpus();return n&&n.length>0&&t.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),t.push(`Memory (System):  ${(k.totalmem()/y.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/y.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||t.push(`Load (avg):       ${k.loadavg().map(s=>Math.round(s)).join(", ")}`),t.push(`VM:               ${Math.round(E.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${o.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(o,t){return Promise.all([(0,b.listProcesses)(o.mainPID),this.k(o)]).then(async n=>{let[s,a]=n,r=this.m(o,s);return t.forEach(h=>{if((0,m.isRemoteDiagnosticError)(h))r+=`
${h.errorMessage}`,a+=`
${h.errorMessage}`;else if(r+=`

Remote: ${h.hostName}`,h.processes&&(r+=`
${this.m(o,h.processes)}`),h.workspaceMetadata){a+=`
|  Remote: ${h.hostName}`;for(const g of Object.keys(h.workspaceMetadata)){const v=h.workspaceMetadata[g];let A=`${v.fileCount} files`;v.maxFilesReached&&(A=`more than ${A}`),a+=`|    Folder (${g}): ${A}`,a+=this.h(v)}}}),{processInfo:r,workspaceInfo:a}})}async getSystemInfo(o,t){const{memory:n,vmHint:s,os:a,cpus:r}=p(),h={os:a,memory:n,cpus:r,vmHint:s,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:t};return P.isWindows||(h.load=`${k.loadavg().map(g=>Math.round(g)).join(", ")}`),P.isLinux&&(h.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(h)}async getDiagnostics(o,t){const n=[];return(0,b.listProcesses)(o.mainPID).then(async s=>(n.push(""),n.push(this.g(o)),n.push(""),n.push(this.m(o,s)),o.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(o))),t.forEach(a=>{if((0,m.isRemoteDiagnosticError)(a))n.push(`
${a.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${a.hostName}`),n.push(this.f(a.machineInfo)),a.processes&&n.push(this.m(o,a.processes)),a.workspaceMetadata)for(const r of Object.keys(a.workspaceMetadata)){const h=a.workspaceMetadata[r];let g=`${h.fileCount} files`;h.maxFilesReached&&(g=`more than ${g}`),n.push(`Folder (${r}): ${g}`),n.push(this.h(h))}}),n.push(""),n.push(""),n.join(`
`)))}h(o){const t=[];let s=0;const a=(v,A)=>{const N=` ${v}(${A})`;s+N.length>60?(t.push(r),r="|                 ",s=r.length):s+=N.length,r+=N};let r="|      File types:";const h=10,g=o.fileTypes.length>h?h:o.fileTypes.length;for(let v=0;v<g;v++){const A=o.fileTypes[v];a(A.name,A.count)}if(t.push(r),o.configFiles.length>=0&&(r="|      Conf files:",s=0,o.configFiles.forEach(v=>{a(v.name,v.count)}),t.push(r)),o.launchConfigFiles.length>0){let v="|      Launch Configs:";o.launchConfigFiles.forEach(A=>{v+=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`}),t.push(v)}return t.join(`
`)}j(o){const t=Math.max(...Object.keys(o).map(n=>n.length));return Object.keys(o).map(n=>`${n}:  ${" ".repeat(t-n.length)}  ${o[n]}`).join(`
                  `)}k(o){const t=[],n=[];return o.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(t.push(`|  Window (${s.title})`),s.folderURIs.forEach(a=>{const r=I.URI.revive(a);if(r.scheme===l.Schemas.file){const h=r.fsPath;n.push(c(h,["node_modules",".git"]).then(g=>{let v=`${g.fileCount} files`;g.maxFilesReached&&(v=`more than ${v}`),t.push(`|    Folder (${(0,O.basename)(h)}): ${v}`),t.push(this.h(g))}).catch(g=>{t.push(`|      Error: Unable to collect workspace stats for folder ${h} (${g.toString()})`)}))}else t.push(`|    Folder (${r.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(s=>t.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(o,t){const n=new Map;o.windows.forEach(a=>n.set(a.pid,a.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),t&&this.n(o.mainPID,n,s,t,0),s.join(`
`)}n(o,t,n,s,a){const r=a===0;let h;r?h=s.pid===o?`${this.d.applicationName} main`:"remote agent":(h=`${"  ".repeat(a)} ${s.name}`,s.name==="window"&&(h=`${h} (${t.get(s.pid)})`));const g=process.platform==="win32"?s.mem:k.totalmem()*(s.mem/100);n.push(`${s.load.toFixed(0).padStart(5," ")}	${(g/y.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${h}`),Array.isArray(s.children)&&s.children.forEach(v=>this.n(o,t,n,v,a+1))}async getWorkspaceFileExtensions(o){const t=new Set;for(const{uri:n}of o.folders){const s=I.URI.revive(n);if(s.scheme!==l.Schemas.file)continue;const a=s.fsPath;try{(await c(a,["node_modules",".git"])).fileTypes.forEach(h=>t.add(h.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(o){for(const{uri:t}of o.folders){const n=I.URI.revive(t);if(n.scheme!==l.Schemas.file)continue;const s=n.fsPath;try{const a=await c(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),a.fileTypes.forEach(r=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:r.name,count:r.count})}),a.launchConfigFiles.forEach(r=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:r.name,count:r.count})}),a.configFiles.forEach(r=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:r.name,count:r.count})})}catch{}}}};R=ye([G(0,S.ITelemetryService),G(1,u.IProductService)],R),e.DiagnosticsService=R}),define(oe[237],ae([0,1,107,3,19,15,2,8,13,50,23,4,6,103,16,171,34,11]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u,S,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;let d=class extends O.Disposable{constructor(w,R,i,o,t,n){super(),this.p=w,this.r=R,this.s=i,this.t=n,this.b=new T.Emitter,this.onDidTokenFailed=this.b.event,this.c=new T.Emitter,this.onDidChangeTunnelStatus=this.c.event,this.f=new T.Emitter,this.onDidChangeAccount=this.f.event,this.j=k.TunnelStates.disconnected;const s=c.URI.file((0,I.join)(i.logsPath,k.LOG_FILE_NAME));this.g=this.B(o.createLogger(s,{name:k.LOGGER_NAME,id:k.LOG_CHANNEL_ID})),this.k=new m.Delayer(100),this.B(this.g.onDidChangeLogLevel(a=>this.g.info("Log level changed to "+(0,P.LogLevelToString)(a)))),this.B(t.onWillShutdown(a=>{this.i&&(this.i.cancel(),this.i=void 0),this.dispose()})),this.B(n.onDidChangeConfiguration(a=>{a.affectsConfiguration(k.CONFIGURATION_KEY_HOST_NAME)&&this.k.trigger(()=>this.v())}))}async getAccount(){return this.h}async updateAccount(w){if(w&&this.h?w.token!==this.h.token||w.providerId!==this.h.providerId:w!==this.h){this.h=w,this.f.fire(w),w?this.g.info(`Account updated: ${w.accountLabel} (${w.providerId})`):this.g.info("Account reset"),this.p.publicLog2("remoteTunnel.enablement",{enabled:!!w});try{await this.k.trigger(()=>this.v())}catch(R){this.g.error(R)}}return this.j}u(){if(!this.n){let w;b.isMacintosh?w=this.s.appRoot:w=(0,I.dirname)((0,I.dirname)(this.s.appRoot)),this.n=(0,I.join)(w,"bin",`${this.r.tunnelApplicationName}${b.isWindows?".exe":""}`)}return this.n}async v(){if(this.i&&(this.i.cancel(),this.i=void 0),!this.h){this.w(k.TunnelStates.disconnected);return}const{token:w,providerId:R,accountLabel:i}=this.h;this.w(k.TunnelStates.connecting((0,S.localize)(0,null,i,R)));const o=(r,h)=>{r=r.replaceAll(w,"*".repeat(4)),h?this.g.error(r):this.g.info(r),!this.s.isBuilt&&r.startsWith("   Compiling")&&this.w(k.TunnelStates.connecting((0,S.localize)(1,null)))},t=this.y("login",["user","login","--provider",R,"--access-token",w,"--log",(0,P.LogLevelToString)(this.g.getLevel())],o);this.i=t;try{if(await t,this.i!==t)return}catch(r){this.g.error(r),this.i=void 0,this.b.fire(!0),this.w(k.TunnelStates.disconnected);return}const n=this.z();n?this.w(k.TunnelStates.connecting((0,S.localize)(2,null,n))):this.w(k.TunnelStates.connecting((0,S.localize)(3,null)));const s=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,P.LogLevelToString)(this.g.getLevel())];n?s.push("--name",n):s.push("--random-name");const a=this.y("tunnel",s,(r,h)=>{h?this.g.error(r):this.g.info(r);const g=r.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(g){const v={link:g[1],domain:g[2],hostName:g[4]};this.w(k.TunnelStates.connected(v))}else r.match(/error refreshing token/)&&(a.cancel(),this.b.fire(!0),this.w(k.TunnelStates.disconnected))});this.i=a,a.finally(()=>{a===this.i&&(this.g.info("tunnel process terminated"),this.i=void 0,this.h=void 0,this.w(k.TunnelStates.disconnected))})}async getTunnelStatus(){return this.j}w(w){this.j=w,this.c.fire(w)}y(w,R,i=()=>{}){return(0,m.createCancelablePromise)(o=>new Promise((t,n)=>{o.isCancellationRequested&&t();let s;if(o.onCancellationRequested(()=>{s&&(this.g.info(`${w} terminating(${s.pid})`),s.kill())}),!this.s.isBuilt)i("Building tunnel CLI from sources and run",!1),i(`${w} Spawning: cargo run -- tunnel ${R.join(" ")}`,!1),s=(0,E.spawn)("cargo",["run","--","tunnel",...R],{cwd:(0,I.join)(this.s.appRoot,"cli")});else{i("Running tunnel CLI",!1);const a=this.u();i(`${w} Spawning: ${a} tunnel ${R.join(" ")}`,!1),s=(0,E.spawn)(a,["tunnel",...R],{cwd:(0,f.homedir)()})}s.stdout.on("data",a=>{if(s){const r=a.toString();i(r,!1)}}),s.stderr.on("data",a=>{if(s){const r=a.toString();i(r,!0)}}),s.on("exit",a=>{s&&(i(`${w} exit(${s.pid}): + ${a} `,!1),s=void 0,a===0?t():n())}),s.on("error",a=>{s&&(i(`${w} error(${s.pid}): + ${a} `,!0),s=void 0,n())})}))}async getHostName(){return this.z()}z(){let w=this.t.getValue(k.CONFIGURATION_KEY_HOST_NAME)||(0,f.hostname)();return w=w.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),w||void 0}};d=ye([G(0,D.ITelemetryService),G(1,C.IProductService),G(2,l.INativeEnvironmentService),G(3,P.ILoggerService),G(4,y.ISharedProcessLifecycleService),G(5,u.IConfigurationService)],d),e.RemoteTunnelService=d}),define(oe[111],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class k{constructor(l){this.b=l}listen(l,O){throw new Error(`Event not found: ${O}`)}call(l,O,{eventName:P,data:I}){return this.b.forEach(E=>E.log(P,I)),Promise.resolve(null)}}e.TelemetryAppenderChannel=k;class T{constructor(l){this.b=l}log(l,O){return this.b.call("log",{eventName:l,data:O}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=T}),define(oe[47],ae([0,1,32,12,3,16,75,110,19]),function(Q,e,k,T,D,l,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class E{constructor(r){this.value=r}}e.TelemetryTrustedValue=E;class C{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(r,h){return Promise.resolve(void 0)}publicLog2(r,h){return this.publicLog(r,h)}publicLogError(r,h){return Promise.resolve(void 0)}publicLogError2(r,h){return this.publicLogError(r,h)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=C,e.NullTelemetryService=new C;class b{async publicLog(r,h,g){}async publicLogError(r,h,g){}}e.NullEndpointTelemetryService=b,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(a,r){return D.Event.debounce(r.onDidChangeConfiguration,(g,v)=>{const A=g?new Set([...g.affectedKeys,...v.affectedKeys]):v.affectedKeys;return{...v,affectedKeys:A}},1e3,!0)(g=>{g.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,l.ConfigurationTargetToString)(g.source),configurationKeys:w(g.affectedKeys)})})}e.configurationTelemetry=m;function y(a,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!a.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=y;function u(a,r){return!(r.isBuilt||r.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}e.isLoggingOnly=u;function S(a){const r=a.getValue(I.TELEMETRY_SETTING_ID),h=a.getValue(I.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(a.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||h===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=S;function f(a){const r={},h={},g={};p(a,g);for(let v in g){v=v.length>150?v.substr(v.length-149):v;const A=g[v];typeof A=="number"?h[v]=A:typeof A=="boolean"?h[v]=A?1:0:typeof A=="string"?(A.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${A.length}`),r[v]=A.substring(0,8191)):typeof A<"u"&&A!==null&&(r[v]=A)}return{properties:r,measurements:h}}e.validateTelemetryData=f;const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function d(a){if(!a)return"none";const r=(0,O.getRemoteName)(a);return c.has(r)?r:"other"}e.cleanRemoteAuthority=d;function p(a,r,h=0,g){if(!!a)for(const v of Object.getOwnPropertyNames(a)){const A=a[v],N=g?g+v:v;Array.isArray(A)?r[N]=(0,k.safeStringify)(A):A instanceof Date?r[N]=A.toISOString():(0,T.isObject)(A)?h<2?p(A,r,h+1,N+"."):r[N]=(0,k.safeStringify)(A):r[N]=A}}function w(a){if(!a)return[];const r=[];return R(r,"",a),r}function R(a,r,h){h&&typeof h=="object"&&!Array.isArray(h)?Object.keys(h).forEach(g=>R(a,r?`${r}.${g}`:g,h[g])):a.push(r)}function i(a,r){const h=a.msftInternalDomains||[],g=r.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(h)||g}e.isInternalTelemetry=i;function o(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=o;function t(a,r){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let h=a;const g=[];for(const F of r)for(;;){const M=F.exec(a);if(!M)break;g.push([M.index,F.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,A=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let N=0;for(h="";;){const F=A.exec(a);if(!F)break;const M=g.some(([L,$])=>F.index<$&&L<A.lastIndex);!v.test(F[0])&&!M&&(h+=a.substring(N,F.index)+"<REDACTED: user-file-path>",N=A.lastIndex)}return N<a.length&&(h+=a.substr(N)),h}function n(a){if(!a)return a;const r=a.toLowerCase(),h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const g of h)if(g.regex.test(r))return`<REDACTED: ${g.label}>`;return a}function s(a,r){return(0,k.cloneAndChange)(a,h=>{if(h instanceof E)return h.value;if(typeof h=="string"){let g=h.replaceAll("%20"," ");g=t(g,r);for(const v of r)g=g.replace(v,"");return g=n(g),g}})}e.cleanData=s}),define(oe[33],ae([0,1,27,30,42,4,11,9,36,47]),function(Q,e,k,T,D,l,O,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function C(t,n){return t.uuid&&n.uuid?t.uuid===n.uuid:t.id===n.id?!0:(0,k.compareIgnoreCase)(t.id,n.id)===0}e.areSameExtensions=C;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(n){const s=n.manifest?n.manifest.version:n.version,a=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new m(n.identifier,s,a)}static parse(n){const s=b.exec(n);return s&&s[1]&&s[2]?new m({id:s[1]},s[2],s[4]||void 0):null}constructor(n,s,a="undefined"){this.version=s,this.targetPlatform=a,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof m?C(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=m;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function u(t){const n=y.exec(t);return n&&n[1]?[f(n[1]),n[2]]:[f(t),void 0]}e.getIdAndVersion=u;function S(t,n){return`${t}.${n}`}e.getExtensionId=S;function f(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=f;function c(t,n){return f(S(t,n))}e.getGalleryExtensionId=c;function d(t,n){const s=[],a=r=>{for(const h of s)if(h.some(g=>C(n(g),n(r))))return h;return null};for(const r of t){const h=a(r);h?h.push(r):s.push([r])}return s}e.groupByExtension=d;function p(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function w(t){return{id:new E.TelemetryTrustedValue(t.identifier.id),name:new E.TelemetryTrustedValue(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function R(t,n){const s=[],a=n.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const r=a.shift();if(r&&s.every(h=>!C(h.identifier,{id:r}))){const h=t.filter(g=>C(g.identifier,{id:r}));h.length===1&&(s.push(h[0]),a.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=R;async function i(t,n){if(!l.isLinux)return!1;let s;try{s=(await t.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(r){n.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(r))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=i;async function o(t,n){const s=await i(t,n),a=(0,T.getTargetPlatform)(s?"alpine":l.platform,I.arch);return n.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=o}),define(oe[238],ae([0,1,25,33]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function D(l,O,P,I,E){try{const C=await l.getExtensionsControlManifest();if(!C.deprecated)return;const b=await l.getInstalled(1);for(const[m,y]of Object.entries(C.deprecated)){if(!y?.extension)continue;const{id:u,autoMigrate:S,preRelease:f}=y.extension;if(!S)continue;const c=b.find(p=>(0,T.areSameExtensions)(p.identifier,{id:m}));if(!c)continue;const d=(await O.getExtensions([{id:u,preRelease:f}],{targetPlatform:await l.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0];if(!d){E.info(`Skipping migrating '${c.identifier.id}' extension because, the comaptible target '${u}' extension is not found`);continue}try{E.info(`Migrating '${c.identifier.id}' extension to '${u}' extension...`);const p=!I.getDisabledExtensions().some(R=>(0,T.areSameExtensions)(R,c.identifier));await l.uninstall(c),E.info(`Uninstalled the unsupported extension '${c.identifier.id}'`);let w=b.find(R=>(0,T.areSameExtensions)(R.identifier,{id:u}));(!w||!w.isPreReleaseVersion&&p)&&(w=await l.installFromGallery(d,{installPreReleaseVersion:!0,isMachineScoped:c.isMachineScoped,operation:4}),E.info(`Installed the pre-release extension '${w.identifier.id}'`),p||(await I.disableExtension(w.identifier),E.info(`Disabled the pre-release extension '${w.identifier.id}' because the unsupported extension '${c.identifier.id}' is disabled`)),S.storage&&(P.addToMigrationList((0,T.getExtensionId)(c.manifest.publisher,c.manifest.name),(0,T.getExtensionId)(w.manifest.publisher,w.manifest.name)),E.info("Added pre-release extension to the storage migration list"))),E.info(`Migrated '${c.identifier.id}' extension to '${u}' extension.`)}catch(p){E.error(p)}}}catch(C){E.error(C)}}e.migrateUnsupportedExtensions=D}),define(oe[239],ae([0,1,6,9,2,26,4,22,54,12,31,28,16,15,30,33,98,14,8,23]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u,S,f,c,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let w=class yt extends D.Disposable{constructor(i,o,t,n,s,a,r){super(),this.h=o,this.i=t,this.j=n,this.k=s,this.l=a,this.m=r,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.v()}async download(i,o){await this.g;const t=(0,P.joinPath)(this.extensionsDownloadDir,this.w(i));try{await this.t(i,t,s=>this.i.download(i,s,o))}catch(s){throw new u.ExtensionManagementError(s.message,u.ExtensionManagementErrorCode.Download)}let n="Unverified";if(await this.n(i)){const s=await this.r(i);try{await this.l.verify(t.fsPath,s.fsPath)&&(n="Verified"),this.m.info(`Extension signature verification: ${i.identifier.id}. Verification status: ${n}.`)}catch(a){const r=a.code;if(r==="UnknownError")n="UnknownError",this.m.warn(`Extension signature verification: ${i.identifier.id}. Verification status: ${n}.`);else throw await this.delete(s),await this.delete(t),new u.ExtensionManagementError(r,u.ExtensionManagementErrorCode.Signature)}}return{location:t,verificationStatus:n}}async n(i){if(!i.isSigned)return!1;const o=this.j.getValue("extensions.verifySignature");return(0,E.isBoolean)(o)?o:this.k.quality!=="stable"}async r(i){await this.g;const o=(0,P.joinPath)(this.extensionsDownloadDir,`${this.w(i)}${yt.c}`);return await this.t(i,o,t=>this.i.downloadSignatureArchive(i,t)),o}async t(i,o,t){if(await this.h.exists(o))return;if(o.scheme!==l.Schemas.file){await t(o);return}const n=(0,P.joinPath)(this.extensionsDownloadDir,`.${(0,C.generateUuid)()}`);await this.h.exists(n)||await t(n);try{await this.u(n,o,Date.now()+2*60*1e3)}catch(s){try{await this.h.del(n)}catch{}if(s.code==="ENOTEMPTY")this.m.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,o.path);else throw this.m.info(`Rename failed because of ${(0,T.getErrorMessage)(s)}. Deleted the file from downloaded location`,n.path),s}}async delete(i){await this.g,await this.h.del(i)}async u(i,o,t){try{await b.Promises.rename(i.fsPath,o.fsPath)}catch(n){if(O.isWindows&&n&&n.code==="EPERM"&&Date.now()<t)return this.m.info(`Failed renaming ${i} to ${o} with 'EPERM' error. Trying again...`),this.u(i,o,t);throw n}}async v(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.m.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const o=[],t=[],n=[];for(const r of i.children)if(r.name.endsWith(yt.c))n.push(r.resource);else{const h=S.ExtensionKey.parse(r.name);h&&t.push([h,r])}const s=(0,S.groupByExtension)(t,([r])=>r),a=[];for(const r of s)r.sort((h,g)=>I.rcompare(h[0].version,g[0].version)),o.push(...r.slice(1).map(h=>h[1].resource)),a.push(r[0][1]);a.sort((r,h)=>r.mtime-h.mtime),o.push(...a.slice(0,Math.max(0,a.length-this.f)).map(r=>r.resource)),o.push(...n),await k.Promises.settled(o.map(r=>(this.m.trace("Deleting from cache",r.path),this.h.del(r))))}}catch(i){this.m.error(i)}}w(i){return this.f?S.ExtensionKey.create(i).toString().toLowerCase():(0,C.generateUuid)()}};w.c=".sigzip",w=ye([G(0,y.INativeEnvironmentService),G(1,c.IFileService),G(2,u.IExtensionGalleryService),G(3,m.IConfigurationService),G(4,p.IProductService),G(5,f.IExtensionSignatureVerificationService),G(6,d.ILogService)],w),e.ExtensionsDownloader=w}),define(oe[240],ae([0,1,3,2,37,33,42]),function(Q,e,k,T,D,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class P extends T.Disposable{constructor(E,C,b,m,y,u,S){super(),this.f=E,this.g=C,this.h=b,this.i=m,this.j=y,this.k=u,this.l=S,this.a=this.B(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new T.DisposableMap),this.m().then(null,f=>S.error(f))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(E=>this.p(E.added,E.removed))),this.B(this.i.onAddExtensions(E=>this.r(E))),this.B(this.i.onDidAddExtensions(E=>this.s(E))),this.B(this.i.onRemoveExtensions(E=>this.t(E))),this.B(this.i.onDidRemoveExtensions(E=>this.u(E))),this.B(this.k.onDidFilesChange(E=>this.v(E)))}async p(E,C){try{await Promise.all(C.map(b=>(this.c.deleteAndDispose(b.id),this.z(b.extensionsResource)))),E.length&&await Promise.all(E.map(b=>(this.c.set(b.id,(0,T.combinedDisposable)(this.k.watch(this.j.extUri.dirname(b.extensionsResource)),this.k.watch(b.extensionsResource))),this.y(b.extensionsResource))))}catch(b){throw this.l.error(b),b}}async r(E){for(const C of E.extensions)this.D(this.G(C.identifier,C.version),E.profileLocation)}async s(E){for(const C of E.extensions){const b=this.G(C.identifier,C.version);E.error?this.F(b,E.profileLocation):this.D(b,E.profileLocation)}}async t(E){for(const C of E.extensions)this.F(this.G(C.identifier,C.version),E.profileLocation)}async u(E){let C=!1;for(const b of E.extensions){const m=this.G(b.identifier,b.version);E.error?this.D(m,E.profileLocation):(this.F(m,E.profileLocation),C=C||!this.b.has(m))}C&&await this.C()}v(E){for(const C of this.h.profiles)E.contains(C.extensionsResource,0,1)&&this.w(C.extensionsResource)}async w(E){const C=[],b=[],m=await this.i.scanProfileExtensions(E),y=new Set,u=new Set;for(const[S,f]of this.b)f.has(E)&&u.add(S);for(const S of m){const f=this.G(S.identifier,S.version);y.add(f),u.has(f)||(C.push(S.identifier),this.D(f,E))}for(const S of u)if(!y.has(S)){const f=this.H(S);f&&(b.push(f.identifier),this.F(S,E))}(C.length||b.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:E}:void 0,removed:b.length?{extensions:b,profileLocation:E}:void 0})}async y(E){const C=await this.i.scanProfileExtensions(E);for(const b of C)this.D(this.G(b.identifier,b.version),E)}async z(E){for(const C of[...this.b.keys()])this.F(C,E);await this.C()}async C(){const C=(await this.f.getAllUserInstalled()).filter(b=>b.installedTimestamp&&!this.b.has(this.G(b.identifier,b.manifest.version)));C.length&&await this.f.markAsUninstalled(...C)}D(E,C){let b=this.b.get(E);b||this.b.set(E,b=new D.ResourceSet(m=>this.j.extUri.getComparisonKey(m))),b.add(C)}F(E,C){const b=this.b.get(E);b&&b.delete(C),b?.size||this.b.delete(E)}G(E,C){return`${O.ExtensionIdentifier.toKey(E.id)}@${C}`}H(E){const[C,b]=(0,l.getIdAndVersion)(E);return b?{identifier:{id:C},version:b}:void 0}}e.ExtensionsWatcher=P}),define(oe[241],ae([0,1,45,47]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(l,O,P,I,E,C,b){const m={"X-Market-Client-Id":`VSCode ${l}`,"User-Agent":`VSCode ${l} (${O.nameShort})`};if((0,T.supportsTelemetry)(O,P)&&(0,T.getTelemetryLevel)(I)===3){const y=await(0,k.getServiceMachineId)(P,E,C),{machineId:u}=await b.getTelemetryInfo();m["X-Market-User-Id"]=y,m["VSCode-SessionId"]=u||y}return m}e.resolveMarketplaceHeaders=D}),define(oe[242],ae([0,1,100,21,6,2,26,13,28,15,30,33,8,73,4,11]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let f=class extends y.LanguagePackBaseService{constructor(w,R,i,o){super(i),this.h=w,this.i=o,this.g=this.B(new c(R,o)),this.h.registerParticipant({postInstall:async t=>this.j(t),postUninstall:async t=>this.k(t)})}async getBuiltInExtensionTranslationsUri(w){const i=(await this.g.getLanguagePacks())[u.Language.value()];if(!i){this.i.warn(`No language pack found for ${u.Language.value()}`);return}const o=i.translations[w];return o?S.URI.file(o):void 0}async getInstalledLanguages(){const w=await this.g.getLanguagePacks(),R=Object.keys(w).map(i=>{const o=w[i];return{...this.f(i,o.label),extensionId:o.extensions[0].extensionIdentifier.id}});return R.push({...this.f("en","English"),extensionId:"default"}),R.sort((i,o)=>i.label.localeCompare(o.label)),R}async j(w){w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",w.identifier.id),await this.update())}async k(w){const R=await this.g.getLanguagePacks();Object.keys(R).some(i=>R[i]&&R[i].extensions.some(o=>(0,b.areSameExtensions)(o.extensionIdentifier,w.identifier)))&&(this.i.info("Removing language packs from the extension",w.identifier.id),await this.update())}async update(){const[w,R]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),i=await this.g.update(R);return!(0,T.equals)(Object.keys(w),Object.keys(i))}};f=ye([G(0,C.IExtensionManagementService),G(1,E.INativeEnvironmentService),G(2,C.IExtensionGalleryService),G(3,m.ILogService)],f),e.NativeLanguagePackService=f;let c=class extends l.Disposable{constructor(w,R){super(),this.i=R,this.c={},this.f=(0,P.join)(w.userDataPath,"languagepacks.json"),this.g=new D.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(w){return this.m(R=>{Object.keys(R).forEach(i=>delete R[i]),this.j(R,...w)}).then(()=>this.c)}j(w,...R){for(const i of R)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.k(w,i);Object.keys(w).forEach(i=>this.l(w[i]))}k(w,R){const i=R.identifier,o=R.manifest.contributes&&R.manifest.contributes.localizations?R.manifest.contributes.localizations:[];for(const t of o)if(R.location.scheme===O.Schemas.file&&d(t)){let n=w[t.languageId];n||(n={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},w[t.languageId]=n);const s=n.extensions.filter(a=>(0,b.areSameExtensions)(a.extensionIdentifier,i))[0];s?s.version=R.manifest.version:n.extensions.push({extensionIdentifier:i,version:R.manifest.version});for(const a of t.translations)n.translations[a.id]=(0,P.join)(R.location.fsPath,a.path)}}l(w){if(w){const R=(0,k.createHash)("md5");for(const i of w.extensions)R.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);w.hash=R.digest("hex")}}m(w=()=>null){return this.g.queue(()=>{let R=null;return I.Promises.readFile(this.f,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch{return{}}}).then(i=>(R=w(i),i)).then(i=>{for(const t of Object.keys(i))i[t]||delete i[t];this.c=i,this.h=!0;const o=JSON.stringify(this.c);return this.i.debug("Writing language packs",o),I.Promises.writeFile(this.f,o)}).then(()=>R,i=>this.i.error(i))})}};c=ye([G(0,E.INativeEnvironmentService),G(1,m.ILogService)],c);function d(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const w of p.translations)if(typeof w.id!="string"||typeof w.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(oe[243],ae([0,1,9,32,47]),function(Q,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const l="https://mobile.events.data.microsoft.com/OneCollector/1.0",O="https://mobile.events.data.microsoft.com/ping";async function P(E,C,b){const m=await new Promise((c,d)=>{Q(["@microsoft/1ds-core-js"],c,d)}),y=await new Promise((c,d)=>{Q(["@microsoft/1ds-post-js"],c,d)}),u=new m.AppInsightsCore,S=new y.PostChannel,f={instrumentationKey:E,endpointUrl:l,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[S]]};if(b){f.extensionConfig={};const c={alwaysUseXhrOverride:!0,httpXHROverride:b};f.extensionConfig[S.identifier]=c}return u.initialize(f,[]),u.addTelemetryInitializer(c=>{C&&(c.ext=c.ext??{},c.ext.utc=c.ext.utc??{},c.ext.utc.flags=8462029)}),u}class I{constructor(C,b,m,y,u){this.e=C,this.f=b,this.g=m,this.h=u,this.c=l,this.d=O,this.g||(this.g={}),typeof y=="function"?this.a=y():this.a=y,this.b=null}i(C){if(!!this.a){if(typeof this.a!="string"){C(this.a);return}this.b||(this.b=P(this.a,this.e,this.h)),this.b.then(b=>{C(b)},b=>{(0,k.onUnexpectedError)(b),console.error(b)})}}log(C,b){if(!this.a)return;b=(0,T.mixin)(b,this.g),b=(0,D.validateTelemetryData)(b);const m=this.f+"/"+C;try{this.i(y=>{y.pluginVersionString=b?.properties.version??"Unknown",y.track({name:m,baseData:{name:m,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this.a?new Promise(C=>{this.i(b=>{b.unload(!0,()=>{this.a=void 0,C(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=I}),define(oe[112],ae([0,1,2,174,15,8,23,47]),function(Q,e,k,T,D,l,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let I=class extends k.Disposable{constructor(C,b,m,y,u=""){super(),this.b=u;const S=b.getLogger(m.telemetryLogResource);if(S)this.a=this.B(S);else{const c=(0,P.isLoggingOnly)(y,m)?" (Not Sent)":"",d=m.telemetryLogResource,p=()=>(0,P.supportsTelemetry)(y,m)&&C.getLevel()===l.LogLevel.Trace;this.a=this.B(b.createLogger(d,{id:P.telemetryLogChannelId,name:(0,T.localize)(0,null,c),hidden:!p()})),this.B(C.onDidChangeLogLevel(()=>b.setVisibility(d,p()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(C,b){this.a.trace(`${this.b}telemetry/${C}`,(0,P.validateTelemetryData)(b))}};I=ye([G(0,l.ILogService),G(1,l.ILoggerService),G(2,D.IEnvironmentService),G(3,O.IProductService)],I),e.TelemetryLogAppender=I}),define(oe[113],ae([0,1,2,32,4,27,175,16,46,105,23,40,19,47]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let u=class{constructor(c,d,p){this.k=d,this.l=p,this.d={},this.i=new k.DisposableStore,this.j=[],this.b=c.appenders,this.c=c.commonProperties||Promise.resolve({}),this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const w of this.f)this.j.push(new RegExp((0,l.escapeRegExpCharacters)(w),"gi")),w.indexOf("\\")>=0&&this.j.push(new RegExp((0,l.escapeRegExpCharacters)(w.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(w=>{(w.affectsConfiguration(m.TELEMETRY_SETTING_ID)||w.affectsConfiguration(m.TELEMETRY_OLD_SETTING_ID)||w.affectsConfiguration(m.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(c,d){this.d[c]=d}m(){let c=(0,y.getTelemetryLevel)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const p=d.usage?3:d.error?2:0;c=Math.min(c,p)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const c=await this.c,d=c.sessionID,p=c["common.machineId"],w=c["common.firstSessionDate"],R=c["common.msftInternal"];return{sessionId:d,machineId:p,firstSessionDate:w,msftInternal:R}}dispose(){this.i.dispose()}n(c,d,p){return this.g<d?Promise.resolve(void 0):this.c.then(w=>{p=(0,T.mixin)(p,this.d),p=(0,y.cleanData)(p,this.j),p=(0,T.mixin)(p,w),this.b.forEach(R=>R.log(c,p))},w=>{console.error(w)})}publicLog(c,d){return this.n(c,3,d)}publicLog2(c,d){return this.publicLog(c,d)}publicLogError(c,d){return this.h?this.n(c,2,d):Promise.resolve(void 0)}publicLogError2(c,d){return this.publicLogError(c,d)}};u.IDLE_START_EVENT_NAME="UserIdleStart",u.IDLE_STOP_EVENT_NAME="UserIdleStop",u=ye([G(1,P.IConfigurationService),G(2,C.IProductService)],u),e.TelemetryService=u;function S(){const f=(0,O.localize)(0,null,E.default.nameLong),c=E.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=D.isWeb?"":(0,O.localize)(3,null),p=(0,O.localize)(4,null),w=(0,O.localize)(5,null),R=(0,O.localize)(6,null),i=(0,O.localize)(7,null),o=`
|       | ${p} | ${w} | ${R} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,O.localize)(8,null);return`
${f} ${c} ${d}

&nbsp;

${i}
${o}

&nbsp;

${t}
`}b.Registry.as(I.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,O.localize)(9,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:S(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(I.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,O.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,O.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[244],ae([0,1,295,243]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class D extends T.AbstractOneDataSystemAppender{constructor(O,P,I,E){const C={sendPOST:(b,m)=>{const y={method:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data)}};try{const u=k.request(b.urlString,y,S=>{S.on("data",function(f){m(S.statusCode??200,S.headers,f.toString())}),S.on("error",function(f){m(0,{})})});u.write(b.data),u.end()}catch{m(0,{})}}};super(O,P,I,E,C)}}e.OneDataSystemAppender=D}),define(oe[245],ae([0,1,26,68,16,15,8,23,19,111,112,113]),function(Q,e,k,T,D,l,O,P,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let m=class{constructor(u,S,f,c,d,p){this.b=u,this.c=S,this.d=f,this.e=c,this.f=d,this.g=p,this.a=new Map}async h(u){if(!this.a.has(u.id)){const{machineId:S,sessionId:f}=await this.c.getTelemetryInfo(),c=Object.create(null);c["common.vscodemachineid"]=S,c["common.vscodesessionid"]=f;const d=[u.id,JSON.stringify(c),u.aiKey],w=new T.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:d,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),R=[new E.TelemetryAppenderClient(w),new C.TelemetryLogAppender(this.d,this.e,this.f,this.g,`[${u.id}] `)];this.a.set(u.id,new b.TelemetryService({appenders:R,sendErrorTelemetry:u.sendErrorTelemetry},this.b,this.g))}return this.a.get(u.id)}async publicLog(u,S,f){await(await this.h(u)).publicLog(S,f)}async publicLogError(u,S,f){await(await this.h(u)).publicLogError(S,f)}};m=ye([G(0,D.IConfigurationService),G(1,I.ITelemetryService),G(2,O.ILogService),G(3,O.ILoggerService),G(4,l.IEnvironmentService),G(5,P.IProductService)],m),e.CustomEndpointTelemetryService=m}),define(oe[114],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var k;(function(T){T[T.Replace=1]="Replace",T[T.Append=2]="Append",T[T.Prepend=3]="Prepend"})(k=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(oe[246],ae([0,1,4,114]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class D{constructor(I){this.collections=I,this.map=new Map,I.forEach((E,C)=>{const b=E.map.entries();let m=b.next();for(;!m.done;){const y=m.value[0];let u=this.map.get(y);if(u||(u=[],this.map.set(y,u)),u.length>0&&u[0].type===T.EnvironmentVariableMutatorType.Replace){m=b.next();continue}const S=m.value[1];u.unshift({extensionIdentifier:C,value:S.value,type:S.type}),m=b.next()}})}async applyToProcessEnvironment(I,E){let C;k.isWindows&&(C={},Object.keys(I).forEach(b=>C[b.toLowerCase()]=b));for(const[b,m]of this.map){const y=k.isWindows&&C[b.toLowerCase()]||b;for(const u of m){const S=E?await E(u.value):u.value;switch(u.type){case T.EnvironmentVariableMutatorType.Append:I[y]=(I[y]||"")+S;break;case T.EnvironmentVariableMutatorType.Prepend:I[y]=S+(I[y]||"");break;case T.EnvironmentVariableMutatorType.Replace:I[y]=S;break}}}}diff(I){const E=new Map,C=new Map,b=new Map;if(I.map.forEach((m,y)=>{const u=this.map.get(y),S=l(m,u);S&&E.set(y,S)}),this.map.forEach((m,y)=>{const u=I.map.get(y),S=l(m,u);S&&b.set(y,S)}),this.map.forEach((m,y)=>{const u=I.map.get(y),S=O(m,u);S&&C.set(y,S)}),!(E.size===0&&C.size===0&&b.size===0))return{added:E,changed:C,removed:b}}}e.MergedEnvironmentVariableCollection=D;function l(P,I){if(!I)return P;const E=new Set;I.forEach(b=>E.add(b.extensionIdentifier));const C=[];return P.forEach(b=>{E.has(b.extensionIdentifier)||C.push(b)}),C.length===0?void 0:C}function O(P,I){if(!I)return;const E=new Map;I.forEach(b=>E.set(b.extensionIdentifier,b));const C=[];return P.forEach(b=>{const m=E.get(b.extensionIdentifier);m&&(b.type!==m.type||b.value!==m.value)&&C.push(m)}),C.length===0?void 0:C}}),define(oe[247],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function k(O){return[...O.entries()]}e.serializeEnvironmentVariableCollection=k;function T(O){return new Map(O)}e.deserializeEnvironmentVariableCollection=T;function D(O){return Array.from(O.entries()).map(P=>[P[0],k(P[1].map)])}e.serializeEnvironmentVariableCollections=D;function l(O){return new Map(O.map(P=>[P[0],{map:T(P[1])}]))}e.deserializeEnvironmentVariableCollections=l}),define(oe[248],ae([0,1,6,25,3,2,8]),function(Q,e,k,T,D,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends l.Disposable{constructor(E,C){super(),this.h=C,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new D.Emitter),this.onCreateRequest=this.g.event,this.b=E===void 0?15e3:E}createRequest(E){return new Promise((C,b)=>{const m=++this.a;this.c.set(m,C),this.g.fire({requestId:m,...E});const y=new T.CancellationTokenSource;(0,k.timeout)(this.b,y.token).then(()=>b(`Request ${m} timed out (${this.b}ms)`)),this.f.set(m,[(0,l.toDisposable)(()=>y.cancel())])})}acceptReply(E,C){const b=this.c.get(E);b?(this.c.delete(E),(0,l.dispose)(this.f.get(E)||[]),this.f.delete(E),b(C)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${E}`)}};P=ye([G(1,O.ILogService)],P),e.RequestStore=P}),define(oe[115],ae([0,1,5]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var T;(function(p){p.Shell="terminal.integrated.shell.",p.ShellArgs="terminal.integrated.shellArgs.",p.DefaultProfile="terminal.integrated.defaultProfile.",p.Profiles="terminal.integrated.profiles."})(T=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(p){p.ShellLinux="terminal.integrated.shell.linux",p.ShellMacOs="terminal.integrated.shell.osx",p.ShellWindows="terminal.integrated.shell.windows",p.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",p.AutomationShellLinux="terminal.integrated.automationShell.linux",p.AutomationShellMacOs="terminal.integrated.automationShell.osx",p.AutomationShellWindows="terminal.integrated.automationShell.windows",p.AutomationProfileLinux="terminal.integrated.automationProfile.linux",p.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",p.AutomationProfileWindows="terminal.integrated.automationProfile.windows",p.ShellArgsLinux="terminal.integrated.shellArgs.linux",p.ShellArgsMacOs="terminal.integrated.shellArgs.osx",p.ShellArgsWindows="terminal.integrated.shellArgs.windows",p.ProfilesWindows="terminal.integrated.profiles.windows",p.ProfilesMacOs="terminal.integrated.profiles.osx",p.ProfilesLinux="terminal.integrated.profiles.linux",p.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",p.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",p.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",p.UseWslProfiles="terminal.integrated.useWslProfiles",p.TabsDefaultColor="terminal.integrated.tabs.defaultColor",p.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",p.TabsEnabled="terminal.integrated.tabs.enabled",p.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",p.TabsHideCondition="terminal.integrated.tabs.hideCondition",p.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",p.TabsShowActions="terminal.integrated.tabs.showActions",p.TabsLocation="terminal.integrated.tabs.location",p.TabsFocusMode="terminal.integrated.tabs.focusMode",p.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",p.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",p.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",p.CopyOnSelection="terminal.integrated.copyOnSelection",p.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",p.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",p.FontFamily="terminal.integrated.fontFamily",p.FontSize="terminal.integrated.fontSize",p.LetterSpacing="terminal.integrated.letterSpacing",p.LineHeight="terminal.integrated.lineHeight",p.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",p.TabStopWidth="terminal.integrated.tabStopWidth",p.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",p.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",p.BellDuration="terminal.integrated.bellDuration",p.FontWeight="terminal.integrated.fontWeight",p.FontWeightBold="terminal.integrated.fontWeightBold",p.CursorBlinking="terminal.integrated.cursorBlinking",p.CursorStyle="terminal.integrated.cursorStyle",p.CursorWidth="terminal.integrated.cursorWidth",p.Scrollback="terminal.integrated.scrollback",p.DetectLocale="terminal.integrated.detectLocale",p.DefaultLocation="terminal.integrated.defaultLocation",p.GpuAcceleration="terminal.integrated.gpuAcceleration",p.TerminalTitleSeparator="terminal.integrated.tabs.separator",p.TerminalTitle="terminal.integrated.tabs.title",p.TerminalDescription="terminal.integrated.tabs.description",p.RightClickBehavior="terminal.integrated.rightClickBehavior",p.Cwd="terminal.integrated.cwd",p.ConfirmOnExit="terminal.integrated.confirmOnExit",p.ConfirmOnKill="terminal.integrated.confirmOnKill",p.EnableBell="terminal.integrated.enableBell",p.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",p.AllowChords="terminal.integrated.allowChords",p.AllowMnemonics="terminal.integrated.allowMnemonics",p.EnvMacOs="terminal.integrated.env.osx",p.EnvLinux="terminal.integrated.env.linux",p.EnvWindows="terminal.integrated.env.windows",p.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",p.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",p.ShowExitAlert="terminal.integrated.showExitAlert",p.SplitCwd="terminal.integrated.splitCwd",p.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",p.WordSeparators="terminal.integrated.wordSeparators",p.EnableFileLinks="terminal.integrated.enableFileLinks",p.UnicodeVersion="terminal.integrated.unicodeVersion",p.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",p.LocalEchoEnabled="terminal.integrated.localEchoEnabled",p.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",p.LocalEchoStyle="terminal.integrated.localEchoStyle",p.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",p.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",p.CustomGlyphs="terminal.integrated.customGlyphs",p.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",p.InheritEnv="terminal.integrated.inheritEnv",p.ShowLinkHover="terminal.integrated.showLinkHover",p.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",p.AutoReplies="terminal.integrated.autoReplies",p.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",p.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",p.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",p.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",p.SmoothScrolling="terminal.integrated.smoothScrolling"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var l;(function(p){p.FileName="ptyhost"})(l=e.TerminalLogConstants||(e.TerminalLogConstants={}));var O;(function(p){p.PowerShell="pwsh",p.Bash="bash",p.Fish="fish",p.Sh="sh",p.Csh="csh",p.Ksh="ksh",p.Zsh="zsh"})(O=e.PosixShellType||(e.PosixShellType={}));var P;(function(p){p.CommandPrompt="cmd",p.PowerShell="pwsh",p.Wsl="wsl",p.GitBash="gitbash"})(P=e.WindowsShellType||(e.WindowsShellType={}));var I;(function(p){p[p.Api=0]="Api",p[p.Process=1]="Process",p[p.Sequence=2]="Sequence",p[p.Config=3]="Config"})(I=e.TitleEventSource||(e.TitleEventSource={}));var E;(function(p){p.LocalPty="localPty",p.PtyHost="ptyHost",p.Logger="logger",p.Heartbeat="heartbeat"})(E=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,k.createDecorator)("ptyService");var C;(function(p){p.Cwd="cwd",p.InitialCwd="initialCwd",p.FixedDimensions="fixedDimensions",p.Title="title",p.ShellType="shellType",p.HasChildProcesses="hasChildProcesses",p.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",p.OverrideDimensions="overrideDimensions",p.FailedShellIntegrationActivation="failedShellIntegrationActivation",p.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(C=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(p){p[p.BeatInterval=5e3]="BeatInterval",p[p.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",p[p.SecondWaitMultiplier=1]="SecondWaitMultiplier",p[p.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var m;(function(p){p[p.Panel=1]="Panel",p[p.Editor=2]="Editor"})(m=e.TerminalLocation||(e.TerminalLocation={}));var y;(function(p){p.TerminalView="view",p.Editor="editor"})(y=e.TerminalLocationString||(e.TerminalLocationString={}));var u;(function(p){p[p.GraceTime=6e4]="GraceTime",p[p.ShortGraceTime=6e3]="ShortGraceTime"})(u=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var S;(function(p){p[p.HighWatermarkChars=1e5]="HighWatermarkChars",p[p.LowWatermarkChars=5e3]="LowWatermarkChars",p[p.CharCountAckSize=5e3]="CharCountAckSize"})(S=e.FlowControlConstants||(e.FlowControlConstants={}));var f;(function(p){p.GitBash="Git Bash",p.Pwsh="PowerShell"})(f=e.ProfileSource||(e.ProfileSource={}));var c;(function(p){p[p.Off=0]="Off",p[p.FinalTerm=1]="FinalTerm",p[p.VSCode=2]="VSCode"})(c=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var d;(function(p){p[p.Unknown=0]="Unknown",p[p.Shutdown=1]="Shutdown",p[p.Process=2]="Process",p[p.User=3]="User",p[p.Extension=4]="Extension"})(d=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(oe[249],ae([0,1,52,11,177,132]),function(Q,e,k,T,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function O(m,y){const u=[{name:null,description:(0,D.localize)(0,null)}];return u.push(...m.map(S=>({name:S.profileName,description:P(S)}))),y&&u.push(...y.map(S=>({name:S.title,description:I(S)}))),{values:u.map(S=>S.name),markdownDescriptions:u.map(S=>S.description)}}e.createProfileSchemaEnums=O;function P(m){let y=`$(${l.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:k.Codicon.terminal.id}) ${m.profileName}
- path: ${m.path}`;return m.args&&(typeof m.args=="string"?y+=`
- args: "${m.args}"`:y+=`
- args: [${m.args.length===0?"":`'${m.args.join("','")}'`}]`),m.overrideName!==void 0&&(y+=`
- overrideName: ${m.overrideName}`),m.color&&(y+=`
- color: ${m.color}`),m.env&&(y+=`
- env: ${JSON.stringify(m.env)}`),y}function I(m){return`$(${l.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:k.Codicon.terminal.id}) ${m.title}
- extensionIdentifier: ${m.extensionIdentifier}`}function E(m,y){if(!m&&!y)return!0;if(typeof m=="string"&&typeof y=="string")return m===y;if(Array.isArray(m)&&Array.isArray(y)){if(m.length!==y.length)return!1;for(let u=0;u<m.length;u++)if(m[u]!==y[u])return!1;return!0}return!1}e.terminalProfileArgsMatch=E;function C(m,y){if(!m&&!y)return!0;if(!m||!y)return!1;if(l.ThemeIcon.isThemeIcon(m)&&l.ThemeIcon.isThemeIcon(y))return m.id===y.id&&m.color===y.color;if(typeof m=="object"&&"light"in m&&"dark"in m&&typeof y=="object"&&"light"in y&&"dark"in y){const u=m,S=y;if((T.URI.isUri(u.light)||b(u.light))&&(T.URI.isUri(u.dark)||b(u.dark))&&(T.URI.isUri(S.light)||b(S.light))&&(T.URI.isUri(S.dark)||b(S.dark)))return u.light.path===S.light.path&&u.dark.path===S.dark.path}if(T.URI.isUri(m)&&T.URI.isUri(y)||b(m)||b(y)){const u=m,S=y;return u.path===S.path&&u.scheme===S.scheme}return!1}e.terminalIconsEqual=C;function b(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}e.isUriComponents=b}),define(oe[250],ae([0,1,52,176,46,40,249]),function(Q,e,k,T,D,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,k.getAllCodicons)(),w=>w.id),markdownEnumDescriptions:Array.from((0,k.getAllCodicons)(),w=>`$(${w.id})`)};const P={args:{description:(0,T.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,T.localize)(1,null),type:"boolean"},icon:{description:(0,T.localize)(2,null),...e.terminalIconSchema},color:{description:(0,T.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,T.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},I={type:"object",required:["path"],properties:{path:{description:(0,T.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},E={type:"object",required:["path"],properties:{path:{description:(0,T.localize)(6,null),type:["string"],items:{type:"string"}},...P}},C=(0,T.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),b=(0,T.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),m=(0,T.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),y=(0,T.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),u=(0,T.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),S=(0,T.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),f={id:"terminal",order:100,title:(0,T.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:u},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,T.localize)(26,null)}},{type:"string",markdownDescription:(0,T.localize)(27,null)}],default:[],markdownDeprecationMessage:m},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,T.localize)(29,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,T.localize)(30,null),type:"string"},id:{description:(0,T.localize)(31,null),type:"string"},title:{description:(0,T.localize)(32,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,T.localize)(34,null),type:"string"},id:{description:(0,T.localize)(35,null),type:"string"},title:{description:(0,T.localize)(36,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,T.localize)(38,null),type:"string"},id:{description:(0,T.localize)(39,null),type:"string"},title:{description:(0,T.localize)(40,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.useWslProfiles"]:{description:(0,T.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,T.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,T.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,T.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,T.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function c(){l.Registry.as(D.Extensions.Configuration).registerConfiguration(f),p()}e.registerTerminalPlatformConfiguration=c;let d;function p(w,R){const i=l.Registry.as(D.Extensions.Configuration);let o;w&&(o=(0,O.createProfileSchemaEnums)(w?.profiles,R));const t=d;d={id:"terminal",order:100,title:(0,T.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:w?.os===3?o?.values:void 0,markdownEnumDescriptions:w?.os===3?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:w?.os===2?o?.values:void 0,markdownEnumDescriptions:w?.os===2?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:w?.os===1?o?.values:void 0,markdownEnumDescriptions:w?.os===1?o?.markdownDescriptions:void 0}}},i.updateConfigurations({add:[d],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=p}),define(oe[251],ae([0,1,5]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,k.createDecorator)("localPtyService")}),define(oe[252],ae([0,1,34,26,32,13,4,36,27,12,28,114,247,246]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function u(){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(k.release());let s=0;return n&&n.length===4&&(s=parseInt(n[3])),s}e.getWindowsBuildNumber=u;async function S(n,s,a,r=P.env,h=C.Promises.exists){if(l.isAbsolute(n))return await h(n)?n:void 0;if(s===void 0&&(s=P.cwd()),l.dirname(n)!=="."){const N=l.join(s,n);return await h(N)?N:void 0}const v=(0,D.getCaseInsensitive)(r,"PATH");if(a===void 0&&(0,E.isString)(v)&&(a=v.split(l.delimiter)),a===void 0||a.length===0){const N=l.join(s,n);return await h(N)?N:void 0}for(const N of a){let F;if(l.isAbsolute(N)?F=l.join(N,n):F=l.join(s,N,n),await h(F))return F;if(O.isWindows){let M=F+".com";if(await h(M)||(M=F+".exe",await h(M)))return M}}const A=l.join(s,n);return await h(A)?A:void 0}e.findExecutable=S;function f(n,s,a,r,h){if(!s.shellIntegration.enabled||!n.executable||n.isFeatureTerminal||n.hideFromUser||n.ignoreShellIntegration||O.isWindows&&!s.windowsEnableConpty)return;const g=n.args,v=P.platform==="win32"?l.basename(n.executable).toLowerCase():l.basename(n.executable),A=l.dirname(T.FileAccess.asFileUri("").fsPath);let N;const F={VSCODE_INJECTION:"1"};if(O.isWindows){if(v==="pwsh.exe"||v==="powershell.exe")return!g||o(g)?N=p.get(d.WindowsPwsh):i(g)&&(N=p.get(d.WindowsPwshLogin)),N?(N=[...N],N[N.length-1]=(0,I.format)(N[N.length-1],A,""),{newArgs:N,envMixin:F}):void 0;r.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args);return}switch(v){case"bash":return!g||g.length===0?N=p.get(d.Bash):t(g)&&(F.VSCODE_SHELL_LOGIN="1",c(s,F),N=p.get(d.Bash)),N?(N=[...N],N[N.length-1]=(0,I.format)(N[N.length-1],A),{newArgs:N,envMixin:F}):void 0;case"fish":{const M=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",L=l.join(A,"out/vs/workbench/contrib/xdg_data");return F.XDG_DATA_DIRS=`${M}:${L}`,c(s,F),{newArgs:void 0,envMixin:F}}case"pwsh":return!g||o(g)?N=p.get(d.Pwsh):i(g)&&(N=p.get(d.PwshLogin)),N?(N=[...N],N[N.length-1]=(0,I.format)(N[N.length-1],A,""),{newArgs:N,envMixin:F}):void 0;case"zsh":{if(!g||g.length===0?N=p.get(d.Zsh):t(g)?(N=p.get(d.ZshLogin),c(s,F)):(g===p.get(d.Zsh)||g===p.get(d.ZshLogin))&&(N=g),!N)return;N=[...N],N[N.length-1]=(0,I.format)(N[N.length-1],A);let M;try{M=k.userInfo().username}catch{M="unknown"}const L=l.join(k.tmpdir(),`${M}-${h.applicationName}-zsh`);F.ZDOTDIR=L;const $=a?.ZDOTDIR??k.homedir()??"~";F.USER_ZDOTDIR=$;const z=[];return z.push({source:l.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:l.join(L,".zshrc")}),z.push({source:l.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:l.join(L,".zprofile")}),z.push({source:l.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:l.join(L,".zshenv")}),z.push({source:l.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:l.join(L,".zlogin")}),{newArgs:N,envMixin:F,filesToCopy:z}}}r.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args)}e.getShellIntegrationInjection=f;function c(n,s){if(O.isMacintosh&&n.environmentVariableCollections){const a=(0,m.deserializeEnvironmentVariableCollections)(n.environmentVariableCollections),h=new y.MergedEnvironmentVariableCollection(a).map.get("PATH"),g=[];if(h)for(const v of h)v.type===b.EnvironmentVariableMutatorType.Prepend&&g.push(v.value);g.length>0&&(s.VSCODE_PATH_PREFIX=g.join(""))}}var d;(function(n){n.WindowsPwsh="windows-pwsh",n.WindowsPwshLogin="windows-pwsh-login",n.Pwsh="pwsh",n.PwshLogin="pwsh-login",n.Zsh="zsh",n.ZshLogin="zsh-login",n.Bash="bash"})(d||(d={}));const p=new Map;p.set(d.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),p.set(d.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),p.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),p.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),p.set(d.Zsh,["-i"]),p.set(d.ZshLogin,["-il"]),p.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const w=["-login","-l"],R=["-nol","-nologo"];function i(n){return typeof n=="string"?w.includes(n.toLowerCase()):n.length===1&&w.includes(n[0].toLowerCase())||n.length===2&&(w.includes(n[0].toLowerCase())||w.includes(n[1].toLowerCase()))&&(R.includes(n[0].toLowerCase())||R.includes(n[1].toLowerCase()))}function o(n){return typeof n=="string"?R.includes(n.toLowerCase()):n.length===0||n?.length===1&&R.includes(n[0].toLowerCase())}function t(n){return n==="string"&&w.includes(n.toLowerCase())||typeof n!="string"&&n.length===1&&w.includes(n[0].toLowerCase())}}),define(oe[253],ae([0,1,50,52,13,4,12,28,91,252]),function(Q,e,k,T,D,l,O,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let C,b=!0;function m(o,t,n,s,a=process.env,r,h,g,v){return r=r||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},l.isWindows?y(n,r,a,h,s.getValue("terminal.integrated.useWslProfiles")!==!1,o&&typeof o=="object"?{...o}:s.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:s.getValue("terminal.integrated.defaultProfile.windows"),v,g):w(r,h,n,o&&typeof o=="object"?{...o}:s.getValue(l.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:s.getValue(l.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),v,g,a)}e.detectAvailableProfiles=m;async function y(o,t,n,s,a,r,h,g,v){const A=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),N=`${process.env.windir}\\${A?"Sysnative":"System32"}`;let F=!1;(0,E.getWindowsBuildNumber)()>=16299&&(F=!0),await f(g);const M=new Map;if(o){M.set("PowerShell",{source:"PowerShell",icon:T.Codicon.terminalPowershell,isAutoDetected:!0}),M.set("Windows PowerShell",{path:`${N}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:T.Codicon.terminalPowershell,isAutoDetected:!0}),M.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),M.set("Command Prompt",{path:`${N}\\cmd.exe`,icon:T.Codicon.terminalCmd,isAutoDetected:!0}),M.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),M.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:T.Codicon.terminalBash,isAutoDetected:!0});const $=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;M.set("Cmder",{path:`${N}\\cmd.exe`,args:["/K",$],requiresPath:process.env.CMDER_ROOT?$:{path:$,isUnsafe:!0},isAutoDetected:!0})}R(r,M);const L=await u(M.entries(),h,t,n,s,v);if(o||a)try{const $=await d(`${N}\\${F?"wsl":"bash"}.exe`,h);for(const z of $)(!r||!(z.profileName in r))&&L.push(z)}catch{b&&(s?.info("WSL is not installed, so could not detect WSL profiles"),b=!1)}return L}async function u(o,t,n,s=process.env,a,r){const h=[];for(const[g,v]of o){if(v===null)continue;let A,N,F;if("source"in v){const z=C?.get(v.source);if(!z)continue;A=z.paths,N=v.args||z.args,v.icon?F=S(v.icon):z.icon&&(F=z.icon)}else A=Array.isArray(v.path)?v.path:[v.path],N=l.isWindows||Array.isArray(v.args)?v.args:void 0,F=S(v.icon);let M;if(r){const z=A.map(X=>typeof X=="string"?X:X.path),x=await r(z);M=new Array(A.length);for(let X=0;X<A.length;X++)typeof A[X]=="string"?M[X]=x[X]:M[X]={path:x[X],isUnsafe:!0}}else M=A.slice();let L;if(v.requiresPath){let z;if((0,O.isString)(v.requiresPath)?z=v.requiresPath:(z=v.requiresPath.path,v.requiresPath.isUnsafe&&(L=z)),!await n.existsFile(z))continue}const $=await i(g,t,M,n,s,N,v.env,v.overrideName,v.isAutoDetected,L);$?($.isAutoDetected=v.isAutoDetected,$.icon=F,$.color=v.color,h.push($)):a?.debug("Terminal profile not validated",g,A)}return a?.debug("Validated terminal profiles",h),h}function S(o){return typeof o=="string"?{id:o}:o}async function f(o){C&&!o||(C=new Map,C.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),C.set("PowerShell",{profileName:"PowerShell",paths:o||await c(),icon:T.Codicon.terminalPowershell}))}async function c(){const o=[];for await(const t of(0,I.enumeratePowerShellInstallations)())o.push(t.exePath);return o}async function d(o,t){const n=[],s=await new Promise((h,g)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(v,A)=>{if(v)return g("Problem occurred when getting wsl distros");h(A)})});if(!s)return[];const a=new RegExp(/[\r?\n]/),r=s.split(a).filter(h=>h.trim().length>0&&h!=="");for(const h of r){if(h===""||h.startsWith("docker-desktop"))continue;const g=`${h} (WSL)`,v={profileName:g,path:o,args:["-d",`${h}`],isDefault:g===t,icon:p(h),isAutoDetected:!1};n.push(v)}return n}function p(o){return o.includes("Ubuntu")?T.Codicon.terminalUbuntu:o.includes("Debian")?T.Codicon.terminalDebian:T.Codicon.terminalLinux}async function w(o,t,n,s,a,r,h,g){const v=new Map;if(n){const A=(await o.readFile("/etc/shells")).toString(),N=r||A.split(`
`).filter(M=>M.trim().includes("#")&&M.trim().length>0),F=new Map;for(const M of N){let L=(0,D.basename)(M),$=F.get(L)||0;$++,$>1&&(L=`${L} (${$})`),F.set(L,$),v.set(L,{path:M,isAutoDetected:!0})}}return R(s,v),await u(v.entries(),a,o,g,t,h)}function R(o,t){if(!!o)for(const[n,s]of Object.entries(o))s===null||!("path"in s)&&!("source"in s)?t.delete(n):(s.icon=s.icon||t.get(n)?.icon,t.set(n,s))}async function i(o,t,n,s,a,r,h,g,v,A){if(n.length===0)return Promise.resolve(void 0);const N=n.shift();if(N==="")return i(o,t,n,s,a,r,h,g,v);const F=typeof N!="string"&&N.isUnsafe,M=typeof N=="string"?N:N.path,L={profileName:o,path:M,args:r,env:h,overrideName:g,isAutoDetected:v,isDefault:o===t,isUnsafePath:F,requiresUnsafePath:A};if((0,D.basename)(M)===M){const z=a.PATH?a.PATH.split(D.delimiter):void 0,x=await(0,E.findExecutable)(M,void 0,z,void 0,s.existsFile);return x?(L.path=x,L.isFromPath=!0,L):i(o,t,n,s,a,r)}return await s.existsFile((0,D.normalize)(M))?L:i(o,t,n,s,a,r,h,g,v)}}),define(oe[254],ae([0,1,3,2,26,4,39,68,16,15,95,234,8,248,115,250,253,104]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u,S,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var d;(function(R){R[R.MaxRestarts=5]="MaxRestarts"})(d||(d={}));let p=0,w=class extends T.Disposable{constructor(i,o,t,n,s,a){super(),this.C=i,this.D=o,this.F=t,this.G=n,this.H=s,this.I=a,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new k.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new k.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new k.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new k.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new k.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new k.Emitter),this.onProcessData=this.s.event,this.t=this.B(new k.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new k.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new k.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new k.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new k.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new k.Emitter),this.onProcessExit=this.z.event,(0,S.registerTerminalPlatformConfiguration)(),this.c=this.M(),this.B((0,T.toDisposable)(()=>this.O())),this.f=this.B(new y.RequestStore(void 0,this.H)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.N(),this.B(this.F.onDidChangeConfiguration(async r=>{r.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.L()}))}initialize(){this.L()}get J(){return this.F.getValue("terminal.integrated.ignoreProcessNames")}async L(){return this.b.refreshIgnoreProcessNames?.(this.J)}async M(){if(l.isWindows)return process.env;try{return await(0,b.getResolvedShellEnv)(this.F,this.H,{_:[]},process.env)}catch(i){return this.H.error("ptyHost was unable to resolve shell environment",i),{}}}N(){const i={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.G.logsPath],env:{VSCODE_LAST_PTY_ID:p,VSCODE_PTY_LOG_NAME:this.D,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},o=(0,C.parsePtyHostPort)(this.G.args,this.G.isBuilt);o&&(o.break&&o.port?i.debugBrk=o.port:!o.break&&o.port&&(i.debug=o.port));const t=new P.Client(D.FileAccess.asFileUri("bootstrap-fork").fsPath,i);this.m.fire(),O.ProxyChannel.toService(t.getChannel(u.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.P()),this.P(),this.B(t.onDidProcessExit(a=>{this.l.fire(a.code),this.i||(this.g<=d.MaxRestarts?(this.H.error(`ptyHost terminated unexpectedly with code ${a.code}`),this.g++,this.restartPtyHost()):this.H.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))})),this.B(new c.RemoteLoggerChannelClient(this.I,t.getChannel(u.TerminalIpcChannels.Logger)));const s=O.ProxyChannel.toService(t.getChannel(u.TerminalIpcChannels.PtyHost));return this.B(s.onProcessData(a=>this.s.fire(a))),this.B(s.onProcessReady(a=>this.t.fire(a))),this.B(s.onProcessExit(a=>this.z.fire(a))),this.B(s.onDidChangeProperty(a=>this.y.fire(a))),this.B(s.onProcessReplay(a=>this.u.fire(a))),this.B(s.onProcessOrphanQuestion(a=>this.v.fire(a))),this.B(s.onDidRequestDetach(a=>this.w.fire(a))),[t,s]}dispose(){this.i=!0,super.dispose()}async createProcess(i,o,t,n,s,a,r,h,g,v,A){const N=setTimeout(()=>this.S(),u.HeartbeatConstants.CreateProcessTimeout),F=await this.b.createProcess(i,o,t,n,s,a,r,h,g,v,A);return clearTimeout(N),p=Math.max(p,F),F}updateTitle(i,o,t){return this.b.updateTitle(i,o,t)}updateIcon(i,o,t,n){return this.b.updateIcon(i,o,t,n)}attachToProcess(i){return this.b.attachToProcess(i)}detachFromProcess(i,o){return this.b.detachFromProcess(i,o)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(i){return this.b.start(i)}shutdown(i,o){return this.b.shutdown(i,o)}input(i,o){return this.b.input(i,o)}processBinary(i,o){return this.b.processBinary(i,o)}resize(i,o,t){return this.b.resize(i,o,t)}acknowledgeDataEvent(i,o){return this.b.acknowledgeDataEvent(i,o)}setUnicodeVersion(i,o){return this.b.setUnicodeVersion(i,o)}getInitialCwd(i){return this.b.getInitialCwd(i)}getCwd(i){return this.b.getCwd(i)}getLatency(i){return this.b.getLatency(i)}orphanQuestionReply(i){return this.b.orphanQuestionReply(i)}installAutoReply(i,o){return this.b.installAutoReply(i,o)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(i){return this.b.uninstallAutoReply(i)}getDefaultSystemShell(i){return this.b.getDefaultSystemShell(i)}async getProfiles(i,o,t,n=!1){const s=await this.c;return(0,f.detectAvailableProfiles)(o,t,n,this.F,s,void 0,this.H,this.W.bind(this,i))}getEnvironment(){return this.b.getEnvironment()}getWslPath(i,o){return this.b.getWslPath(i,o)}getRevivedPtyNewId(i){return this.b.getRevivedPtyNewId(i)}setTerminalLayoutInfo(i){return this.b.setTerminalLayoutInfo(i)}async getTerminalLayoutInfo(i){return await this.b.getTerminalLayoutInfo(i)}async requestDetachInstance(i,o){return this.b.requestDetachInstance(i,o)}async acceptDetachInstanceReply(i,o){return this.b.acceptDetachInstanceReply(i,o)}async freePortKillProcess(i){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(i)}async serializeTerminalState(i){return this.b.serializeTerminalState(i)}async reviveTerminalProcesses(i,o){return this.b.reviveTerminalProcesses(i,o)}async refreshProperty(i,o){return this.b.refreshProperty(i,o)}async updateProperty(i,o,t){return this.b.updateProperty(i,o,t)}async restartPtyHost(){this.h=!0,this.O(),[this.a,this.b]=this.N()}O(){this.b.shutdownAll?.(),this.a.dispose()}P(){this.U(),this.j=setTimeout(()=>this.Q(),u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}Q(){this.H.warn(`No ptyHost heartbeat after ${u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.R(),u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.SecondWaitMultiplier)}R(){this.H.error(`No ptyHost heartbeat after ${(u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier+u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}S(){this.U(),this.H.error(`No ptyHost response to createProcess after ${u.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}U(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}W(i,o){return this.f.createRequest({workspaceId:i,originalText:o})}async acceptPtyHostResolvedVariables(i,o){this.f.acceptReply(i,o)}};w=ye([G(2,I.IConfigurationService),G(3,E.IEnvironmentService),G(4,m.ILogService),G(5,m.ILoggerService)],w),e.PtyHostService=w}),define(oe[77],ae([0,1,3,16,5,8]),function(Q,e,k,T,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var O;(function(S){S.Http="http",S.Https="https"})(O=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(S){S.ConstantPrivate="constantPrivate",S.Private="private",S.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var I;(function(S){S[S.Notify=1]="Notify",S[S.OpenBrowser=2]="OpenBrowser",S[S.OpenPreview=3]="OpenPreview",S[S.Silent=4]="Silent",S[S.Ignore=5]="Ignore",S[S.OpenBrowserOnce=6]="OpenBrowserOnce"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function E(S){if(S.scheme!=="http"&&S.scheme!=="https")return;const f=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(S.authority);if(!!f)return{address:f[1],port:+f[2]}}e.extractLocalHostUriMetaDataForPortMapping=E,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(S){return e.LOCALHOST_ADDRESSES.indexOf(S)>=0}e.isLocalhost=C,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(S){return e.ALL_INTERFACES_ADDRESSES.indexOf(S)>=0}e.isAllInterfaces=b;function m(S,f,c,d){if(c===1)return!1;if(c===2&&b(f)){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(p?.length===4&&parseInt(p[1])>=18)return!1}return S<1024}e.isPortPrivileged=m;class y{constructor(f,c,d){this.remoteAddress=f,this.localAddress=c,this.b=d,this.a=new k.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=y;let u=class{constructor(f,c){this.i=f,this.j=c,this.a=new k.Emitter,this.onTunnelOpened=this.a.event,this.b=new k.Emitter,this.onTunnelClosed=this.b.event,this.c=new k.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const f=this.j.getValue("remote.localPortHost");return!f||f==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(f){return this.e=f,f?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(f){this.f=f.elevation,this.g=f.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const f=[],c=Array.from(this.d.values());for(const d of c){const p=Array.from(d.values());for(const w of p){const R=await w.value;R&&f.push(R)}}return f}async dispose(){for(const f of this.d.values()){for(const{value:c}of f.values())await c.then(d=>d?.dispose());f.clear()}this.d.clear()}setEnvironmentTunnel(f,c,d,p,w){this.o(f,c,Promise.resolve({tunnelRemoteHost:f,tunnelRemotePort:c,localAddress:d,privacy:p,protocol:w,dispose:()=>Promise.resolve()}))}async getExistingTunnel(f,c){(b(f)||C(f))&&(f=e.LOCALHOST_ADDRESSES[0]);const d=this.q(f,c);if(d)return++d.refcount,d.value}openTunnel(f,c,d,p,w,R=!1,i,o){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${d} on local port ${w}.`),!f)return;if(c||(c="localhost"),p||(p=this.k),this.e&&this.h.has(d)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.r(f,c,d,p,w,R,i,o);return t?t.then(n=>{if(!n){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(c,d);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.m(n);return(n.tunnelRemoteHost!==c||n.tunnelRemotePort!==d)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(s),s}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}m(f){return{tunnelRemotePort:f.tunnelRemotePort,tunnelRemoteHost:f.tunnelRemoteHost,tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress,privacy:f.privacy,protocol:f.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${f.tunnelRemoteHost}:${f.tunnelRemotePort} `);const c=this.d.get(f.tunnelRemoteHost);if(c){const d=c.get(f.tunnelRemotePort);d&&(d.refcount--,await this.n(f.tunnelRemoteHost,f.tunnelRemotePort,d))}}}}async n(f,c,d){if(d.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${f}:${c}.`);const p=d.value.then(async w=>{w&&(await w.dispose(!0),this.b.fire({host:w.tunnelRemoteHost,port:w.tunnelRemotePort}))});return this.d.has(f)&&this.d.get(f).delete(c),p}}async closeTunnel(f,c){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${f}:${c} `);const d=this.d.get(f);if(d&&d.has(c)){const p=d.get(c);p.refcount=0,await this.n(f,c,p)}}o(f,c,d){this.d.has(f)||this.d.set(f,new Map),this.d.get(f).set(c,{refcount:1,value:d})}async p(f,c){const d=this.d.get(f);d&&(await d.get(c)||d.delete(c),d.size===0&&this.d.delete(f))}q(f,c){const d=[f];C(f)?(d.push(...e.LOCALHOST_ADDRESSES),d.push(...e.ALL_INTERFACES_ADDRESSES)):b(f)&&d.push(...e.ALL_INTERFACES_ADDRESSES);const p=d.map(w=>this.d.get(w));for(const w of p){const R=w?.get(c);if(R)return R}}canTunnel(f){return!!E(f)}s(f,c,d,p,w,R,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${d} on local port ${p}.`);const o=d;this.h.add(o);const t=p===void 0?d:p,n={elevationRequired:w?this.isPortPrivileged(t):!1},s={remoteAddress:{host:c,port:d},localAddressPort:p,privacy:R,public:R?R!==P.Private:void 0,protocol:i},a=f.forwardPort(s,n);return a?(this.o(c,d,a),a.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(o)})):this.h.delete(o),a}};u=ye([G(0,l.ILogService),G(1,T.IConfigurationService)],u),e.AbstractTunnelService=u}),define(oe[255],ae([0,1,8,77,2,9,6]),function(Q,e,k,T,D,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends D.Disposable{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.DeferredPromise),this.b.p)}setAddress(C){this.a=C,this.b&&(this.b.complete(C),this.b=null)}setTunnel(C){this.B(C)}}let I=class kt extends D.Disposable{constructor(C,b){super(),this.f=C,this.g=b,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(C=>C.dispose())}async createTunnel(){return{id:String(++kt.a)}}async startTunnel(C,b,m,y,u,S,f){const c=new P,d=await Promise.resolve(this.f.openTunnel(C,c,m,y,u,S,f));if(!d)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${m}:${y} (remote).`),c.dispose(),new Error("Could not create tunnel");if(this.c.has(b))throw this.c.delete(b),c.dispose(),await d.dispose(),(0,l.canceled)();return c.setTunnel(d),this.b.set(b,c),this.g.info(`[SharedProcessTunnelService] Created tunnel ${b}: ${d.localAddress} (local) to ${m}:${y} (remote).`),{tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress}}async setAddress(C,b){const m=this.b.get(C);!m||m.setAddress(b)}async destroyTunnel(C){const b=this.b.get(C);if(b){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${C}.`),this.b.delete(C),await b.dispose();return}this.c.add(C)}};I.a=0,I=ye([G(0,T.ISharedTunnelsService),G(1,k.ILogService)],I),e.SharedProcessTunnelService=I}),define(oe[256],ae([0,1,86,34,134,226,6,2,16,8,23,224,77,109,4]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function S(w,R,i,o,t){let n;for(let s=3;s&&(n?.dispose(),n=await new f(w,R,i,o,t).waitForReady(),!(t&&D.BROWSER_RESTRICTED_PORTS[t]||!D.BROWSER_RESTRICTED_PORTS[n.tunnelLocalPort]));s--);return n}class f extends P.Disposable{constructor(R,i,o,t,n){super(),this.j=i,this.k=n,this.privacy=m.TunnelPrivacyId.Private,this.i=new Map,this.a=R,this.b=k.createServer(),this.c=new O.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=s=>this.l(s),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(i=>{i()})}async waitForReady(){const R=this.k??this.tunnelRemotePort,i=(0,m.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let o=await(0,D.findFreePortFaster)(R,2,1e3,i),t=null;return this.b.listen(o,this.j),await this.c.wait(),t=this.b.address(),t||(o=0,this.b.listen(o,this.j),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async l(R){R.pause();const i=(0,m.isLocalhost)(this.tunnelRemoteHost)||(0,m.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,b.connectRemoteAgentTunnel)(this.a,i,this.tunnelRemotePort),t=o.getSocket().socket,n=o.readEntireBuffer();o.dispose(),n.byteLength>0&&R.write(n.buffer),R.on("end",()=>{R.localAddress&&this.i.delete(R.localAddress),t.end()}),R.on("close",()=>t.end()),R.on("error",()=>{R.localAddress&&this.i.delete(R.localAddress),t.destroy()}),t.on("end",()=>R.end()),t.on("close",()=>R.end()),t.on("error",()=>{R.destroy()}),R.pipe(t),t.pipe(R),R.localAddress&&this.i.set(R.localAddress,()=>{R.end(),t.end()})}}let c=class extends m.AbstractTunnelService{constructor(R,i,o,t,n){super(i,n),this.t=R,this.u=o,this.v=t}isPortPrivileged(R){return(0,m.isPortPrivileged)(R,this.k,u.OS,T.release())}r(R,i,o,t,n,s,a,r){const h=this.q(i,o);if(h)return++h.refcount,h.value;if(this.e)return this.s(this.e,i,o,n,s,a,r);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${i}:${o} on local port ${n}.`);const g={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:R,signService:this.u,logService:this.i,ipcLogger:null},v=S(g,t,i,o,n);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(i,o,v),v}}};c=ye([G(1,E.ILogService),G(2,y.ISignService),G(3,C.IProductService),G(4,I.IConfigurationService)],c),e.BaseTunnelService=c;let d=class extends c{constructor(R,i,o,t){super(l.nodeSocketFactory,R,i,o,t)}};d=ye([G(0,E.ILogService),G(1,y.ISignService),G(2,C.IProductService),G(3,I.IConfigurationService)],d),e.TunnelService=d;let p=class extends P.Disposable{constructor(R,i,o,t){super(),this.b=R,this.c=i,this.f=o,this.g=t,this.a=new Map}async openTunnel(R,i,o,t,n,s,a,r,h){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${o}:${t} on local port ${s}.`),!this.a.has(R)){const g=new d(this.b,this.f,this.c,this.g);this.B(g),this.a.set(R,g),g.onTunnelClosed(async()=>{(await g.tunnels).length===0&&(g.dispose(),this.a.delete(R))})}return this.a.get(R).openTunnel(i,o,t,n,s,a,r,h)}};p=ye([G(0,E.ILogService),G(1,C.IProductService),G(2,y.ISignService),G(3,I.IConfigurationService)],p),e.SharedTunnelsService=p}),define(oe[29],ae([0,1,5]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(oe[257],ae([0,1,29,71,14,22,131,3,2]),function(Q,e,k,T,D,l,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class E{constructor(m){this.uri=m,this.time=E._clock++}touch(){return this.time=E._clock++,this}}E._clock=0;let C=class{constructor(m){this.g=m,this.c=new I.DisposableStore,this.f=2**16;const y=new Map,u=S=>{let f=y.get(S.scheme);return f===void 0&&(f=m.hasProvider(S)&&!this.g.hasCapability(S,1024),y.set(S.scheme,f)),f};this.c.add(P.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(S=>{y.delete(S.scheme)})),this.extUri=new l.ExtUri(u),this.d=new O.SkipList((S,f)=>this.extUri.compare(S,f,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,l.normalizePath)(m));const y=this.d.get(m);return y?y.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new E(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((u,S)=>u[1].touch<S[1].touch?1:u[1].touch>S[1].touch?-1:0);E._clock=0,this.d.clear();const y=this.f*.5;for(let u=0;u<y;u++)this.d.set(m[u][0],m[u][1].touch())}};C=ye([G(0,D.IFileService)],C),e.UriIdentityService=C,(0,T.registerSingleton)(k.IUriIdentityService,C,1)}),define(oe[258],ae([0,1,3,2,14,44,49,17]),function(Q,e,k,T,D,l,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class I extends T.Disposable{get capabilities(){return this.f.capabilities&-5}constructor(C,b,m,y){super(),this.c=C,this.f=b,this.g=m,this.h=y,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new k.Emitter),this.onDidChangeFile=this.a.event,this.b=O.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(u=>this.i(u)))}watch(C,b){this.b.set(C,C);const m=this.f.watch(this.j(C),b);return(0,T.toDisposable)(()=>{this.b.delete(C),m.dispose()})}stat(C){return this.f.stat(this.j(C))}mkdir(C){return this.f.mkdir(this.j(C))}rename(C,b,m){return this.f.rename(this.j(C),this.j(b),m)}readFile(C){return this.f.readFile(this.j(C),{atomic:!0})}readFileStream(C,b,m){const y=(0,l.newWriteableStream)(u=>P.VSBuffer.concat(u.map(S=>P.VSBuffer.wrap(S))).buffer);return(async()=>{try{const u=await this.readFile(C);y.end(u)}catch(u){y.error(u),y.end()}})(),y}readdir(C){return this.f.readdir(this.j(C))}writeFile(C,b,m){return this.f.writeFile(this.j(C),b,m)}delete(C,b){return this.f.delete(this.j(C),b)}copy(C,b,m){if((0,D.hasFileFolderCopyCapability)(this.f))return this.f.copy(this.j(C),this.j(b),m);throw new Error("copy not supported")}i(C){const b=[];for(const m of C){if(m.resource.scheme!==this.c)continue;const y=this.k(m.resource);this.b.findSubstr(y)&&b.push({resource:y,type:m.type})}b.length&&(this.h.debug("User data changed"),this.a.fire(b))}j(C){return C.with({scheme:this.c})}k(C){return C.with({scheme:this.g})}}e.FileUserDataProvider=I}),define(oe[61],ae([0,1,83]),function(Q,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function T(O,P,I,E){const C=(0,k.setProperty)(O,P,I,E)[0];return C&&(O=O.substring(0,C.offset)+C.content+O.substring(C.offset+C.length)),O}e.edit=T;function D(O,P,I){let E=I;for(;E>=0;){if(O.charAt(E)===P.charAt(P.length-1)&&P.length===1)return E+1;if(E--,P.length===2&&E>=0&&O.charAt(E)===P.charAt(0))return E+2}return 0}e.getLineStartOffset=D;function l(O,P,I){let E=I;for(;E>=0;)if(O.charAt(E)===P.charAt(P.length-1)&&P.length===1||(E++,P.length===2&&E>=0&&O.charAt(E)===P.charAt(1)))return E;return O.length-1}e.getLineEndOffset=l}),define(oe[259],ae([0,1,32,54,12]),function(Q,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function l(y,u,S,f,c,d){const p=[],w=[],R=[];if(!u){const $=y.filter(({identifier:z})=>c.every(x=>x.toLowerCase()!==z.id.toLowerCase()));return{local:{added:p,removed:w,updated:R},remote:$.length>0?{added:$,updated:[],removed:[],all:$}:null}}y=y.map(b),u=u.map(b),S=S?S.map(b):null;const i=new Map,o=$=>{$.uuid&&i.set($.id.toLowerCase(),$.uuid)};y.forEach(({identifier:$})=>o($)),u.forEach(({identifier:$})=>o($)),S?.forEach(({identifier:$})=>o($));const t=$=>{const z=$.identifier.uuid||i.get($.identifier.id.toLowerCase());return z?`uuid:${z}`:`id:${$.identifier.id.toLowerCase()}`},n=($,z)=>($.set(t(z),z),$),s=y.reduce(n,new Map),a=u.reduce(n,new Map),r=u.reduce(($,z)=>n($,(0,k.deepClone)(z)),new Map),h=S?S.reduce(n,new Map):null,g=f.reduce(n,new Map),v=c.reduce(($,z)=>{const x=i.get(z.toLowerCase());return $.add(x?`uuid:${x}`:`id:${z.toLowerCase()}`)},new Set),A=d.reduce(($,{id:z,uuid:x})=>(x=x??i.get(z.toLowerCase()),$.add(x?`uuid:${x}`:`id:${z.toLowerCase()}`)),new Set),N=O(s,a,v,!1);if(N.added.size>0||N.removed.size>0||N.updated.size>0){const $=O(h,s,v,!1),z=O(h,a,v,!0),x=(X,ie,H,j)=>{let V,J,_;return ie.installed?(V=j.pinned,_=j.preRelease,V&&(J=j.version)):(V=H.pinned,_=H.preRelease,V&&(J=H.version)),V===void 0&&(V=ie.pinned,V&&(J=ie.version)),_===void 0&&(_=ie.preRelease),{...j,installed:ie.installed||H.installed,pinned:V,preRelease:_,version:J??(H.version&&(!ie.installed||T.gt(H.version,ie.version))?H.version:ie.version),state:I(ie,H,h?.get(X))}};for(const X of z.removed.values()){const ie=s.get(X);if(!ie)continue;const H=(0,D.assertIsDefined)(h?.get(X)),j=!A.has(X)&&H.installed;ie.installed&&j?w.push(ie.identifier):r.set(X,ie)}for(const X of z.added.values()){const ie=(0,D.assertIsDefined)(a.get(X)),H=s.get(X);if(H){if(N.updated.has(X)){const j=x(X,H,ie,ie);P(H,ie,!1,!1)||R.push(m(j,X)),r.set(X,j)}}else ie.installed&&p.push(m(ie,X))}for(const X of z.updated.values()){const ie=(0,D.assertIsDefined)(a.get(X)),H=(0,D.assertIsDefined)(h?.get(X)),j=s.get(X);if(j)if(!A.has(X)&&H.installed&&j.installed&&!ie.installed)w.push(j.identifier);else{const J=x(X,j,ie,ie);R.push(m(J,X)),r.set(X,J)}else ie.installed&&p.push(m(ie,X))}for(const X of $.added.values())z.added.has(X)||r.set(X,(0,D.assertIsDefined)(s.get(X)));for(const X of $.updated.values()){if(z.removed.has(X)||z.updated.has(X))continue;const ie=(0,D.assertIsDefined)(s.get(X)),H=(0,D.assertIsDefined)(a.get(X));r.set(X,x(X,ie,H,ie))}for(const X of $.removed.values())z.updated.has(X)||z.removed.has(X)||g.has(X)||!(0,D.assertIsDefined)(a.get(X)).installed||A.has(X)||!(0,D.assertIsDefined)(h?.get(X)).installed||r.delete(X)}const F=[],M=O(a,r,new Set,!0),L=M.added.size>0||M.updated.size>0||M.removed.size>0;return L&&r.forEach(($,z)=>F.push(m($,z))),{local:{added:p,removed:w,updated:R},remote:L?{added:[...M.added].map($=>r.get($)),updated:[...M.updated].map($=>r.get($)),removed:[...M.removed].map($=>a.get($)),all:F}:null}}e.merge=l;function O(y,u,S,f){const c=y?[...y.keys()].filter(i=>!S.has(i)):[],d=[...u.keys()].filter(i=>!S.has(i)),p=d.filter(i=>c.indexOf(i)===-1).reduce((i,o)=>(i.add(o),i),new Set),w=c.filter(i=>d.indexOf(i)===-1).reduce((i,o)=>(i.add(o),i),new Set),R=new Set;for(const i of c){if(w.has(i))continue;const o=y.get(i),t=u.get(i);(!t||!P(o,t,f,!0))&&R.add(i)}return{added:p,removed:w,updated:R}}function P(y,u,S,f){return!(y.disabled!==u.disabled||f&&y.installed!==u.installed||y.installed&&u.installed&&(y.preRelease!==u.preRelease||y.pinned!==u.pinned||u.pinned&&y.version!==u.version)||!C(y.state,u.state)||S&&y.version!==u.version)}function I(y,u,S){const f=y.state,c=u.state,d=S?.state;if(!u.version||f&&T.gt(y.version,u.version))return f;if(c&&T.gt(u.version,y.version)||!f)return c;if(!c)return f;const p=(0,k.deepClone)(f),w=d?E(d,c):{added:Object.keys(c).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set},R=d?E(d,f):{added:Object.keys(f).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set};for(const i of[...w.added.values(),...w.updated.values()])p[i]=c[i];for(const i of w.removed.values())R.updated.has(i)||delete p[i];return p}function E(y,u){const S=Object.keys(y),f=Object.keys(u),c=f.filter(w=>S.indexOf(w)===-1).reduce((w,R)=>(w.add(R),w),new Set),d=S.filter(w=>f.indexOf(w)===-1).reduce((w,R)=>(w.add(R),w),new Set),p=new Set;for(const w of S){if(d.has(w))continue;const R=y[w],i=u[w];(0,k.equals)(R,i)||p.add(w)}return{added:c,removed:d,updated:p}}function C(y={},u={}){const{added:S,removed:f,updated:c}=E(y,u);return S.size===0&&f.size===0&&c.size===0}function b(y){return{...y,disabled:!!y.disabled,installed:!!y.installed}}function m(y,u){const S={identifier:{id:y.identifier.id,uuid:u.startsWith("uuid:")?u.substring(5):void 0},version:y.version,preRelease:!!y.preRelease,pinned:!!y.pinned};return y.disabled&&(S.disabled=!0),y.installed&&(S.installed=!0),y.state&&(S.state=y.state),S}}),define(oe[116],ae([0,1,21,16,5]),function(Q,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let l=class{constructor(P){this.a=P}hasToNeverSyncExtension(P){return this.b().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.b().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,I){let E=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return E=E.filter(C=>C!==P&&C!==`-${P}`),I&&E.push(P.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,2)}updateSynchronizedExtensions(P,I){let E=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return E=E.filter(C=>C!==P&&C!==`-${P}`),I&&E.push(`-${P.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,2)}getIgnoredExtensions(P){const I=P.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),E=this.b().map(m=>m.toLowerCase()),C=[],b=[];if(Array.isArray(E))for(const m of E)m.startsWith("-")?b.push(m.substring(1)):C.push(m);return(0,k.distinct)([...I,...C].filter(m=>b.indexOf(m)===-1))}b(){let P=this.a.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.a.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(I=>I.toLowerCase())}};l=ye([G(0,T.IConfigurationService)],l),e.IgnoredExtensionsManagementService=l}),define(oe[260],ae([0,1,21,35,32,198,61]),function(Q,e,k,T,D,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(w){return(0,T.parse)(w)||[]}e.parseKeybindings=P;async function I(w,R,i,o,t){const n=P(w),s=P(R),a=i?P(i):null,r=[...n,...s,...a||[]].map(x=>x.key),h=await t.resolveUserBindings(r),g=C(n,s,a,h);if(!g.hasLocalForwarded&&!g.hasRemoteForwarded)return{mergeContent:w,hasChanges:!1,hasConflicts:!1};if(!g.hasLocalForwarded&&g.hasRemoteForwarded)return{mergeContent:R,hasChanges:!0,hasConflicts:!1};if(g.hasLocalForwarded&&!g.hasRemoteForwarded)return{mergeContent:w,hasChanges:!0,hasConflicts:!1};const v=m(n),A=m(s),N=a?m(a):null,F=u(v,A,h),M=N?u(N,v,h):{added:[...v.keys()].reduce((x,X)=>(x.add(X),x),new Set),removed:new Set,updated:new Set},L=N?u(N,A,h):{added:[...A.keys()].reduce((x,X)=>(x.add(X),x),new Set),removed:new Set,updated:new Set},$=E(F,M,L);let z=w;for(const x of $.removed.values())$.conflicts.has(x)||(z=d(z,x,o));for(const x of $.added.values()){if($.conflicts.has(x))continue;const X=A.get(x);if(X.some(ie=>ie.command!==`-${x}`&&g.conflicts.has(h[ie.key]))){$.conflicts.add(x);continue}z=c(z,X,o)}for(const x of $.updated.values()){if($.conflicts.has(x))continue;const X=A.get(x);if(X.some(ie=>ie.command!==`-${x}`&&g.conflicts.has(h[ie.key]))){$.conflicts.add(x);continue}z=p(z,x,X,o)}return{mergeContent:z,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=I;function E(w,R,i){const o=new Set,t=new Set,n=new Set,s=new Set;for(const a of R.removed.values())i.updated.has(a)&&s.add(a);for(const a of i.removed.values())s.has(a)||(R.updated.has(a)?s.add(a):t.add(a));for(const a of R.added.values())s.has(a)||i.added.has(a)&&w.updated.has(a)&&s.add(a);for(const a of i.added.values())s.has(a)||(R.added.has(a)?w.updated.has(a)&&s.add(a):o.add(a));for(const a of R.updated.values())s.has(a)||i.updated.has(a)&&w.updated.has(a)&&s.add(a);for(const a of i.updated.values())s.has(a)||(R.updated.has(a)?w.updated.has(a)&&s.add(a):n.add(a));return{added:o,removed:t,updated:n,conflicts:s}}function C(w,R,i,o){const t=new Set,n=b(w,o),s=b(R,o),a=i?b(i,o):null,r=y(n,s);if(r.added.size===0&&r.removed.size===0&&r.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const h=a?y(a,n):{added:[...n.keys()].reduce((M,L)=>(M.add(L),M),new Set),removed:new Set,updated:new Set};if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const g=a?y(a,s):{added:[...s.keys()].reduce((M,L)=>(M.add(L),M),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:v,removed:A,updated:N,conflicts:F}=E(r,h,g);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:v,removed:A,updated:N,conflicts:F}}function b(w,R){const i=new Map;for(const o of w){const t=R[o.key];let n=i.get(t);n||(n=[],i.set(t,n)),n.push(o)}return i}function m(w){const R=new Map;for(const i of w){const o=i.command[0]==="-"?i.command.substring(1):i.command;let t=R.get(o);t||(t=[],R.set(o,t)),t.push(i)}return R}function y(w,R){const i=[...w.keys()],o=[...R.keys()],t=o.filter(a=>i.indexOf(a)===-1).reduce((a,r)=>(a.add(r),a),new Set),n=i.filter(a=>o.indexOf(a)===-1).reduce((a,r)=>(a.add(r),a),new Set),s=new Set;for(const a of i){if(n.has(a))continue;const r=w.get(a).map(g=>({...g,key:a})),h=R.get(a).map(g=>({...g,key:a}));(0,k.equals)(r,h,(g,v)=>f(g,v))||s.add(a)}return{added:t,removed:n,updated:s}}function u(w,R,i){const o=[...w.keys()],t=[...R.keys()],n=t.filter(r=>o.indexOf(r)===-1).reduce((r,h)=>(r.add(h),r),new Set),s=o.filter(r=>t.indexOf(r)===-1).reduce((r,h)=>(r.add(h),r),new Set),a=new Set;for(const r of o){if(s.has(r))continue;const h=w.get(r).map(v=>({...v,key:i[v.key]})),g=R.get(r).map(v=>({...v,key:i[v.key]}));S(h,g)||a.add(r)}return{added:n,removed:s,updated:a}}function S(w,R){return!(!(0,k.equals)(w.filter(({command:i})=>i[0]!=="-"),R.filter(({command:i})=>i[0]!=="-"),(i,o)=>f(i,o))||!(0,k.equals)(w.filter(({command:i})=>i[0]==="-"),R.filter(({command:i})=>i[0]==="-"),(i,o)=>f(i,o)))}function f(w,R){if(w.command!==R.command||w.key!==R.key)return!1;const i=l.ContextKeyExpr.deserialize(w.when),o=l.ContextKeyExpr.deserialize(R.when);return!(i&&!o||!i&&o||i&&o&&!i.equals(o)||!D.equals(w.args,R.args))}function c(w,R,i){for(const o of R)w=O.edit(w,[-1],o,i);return w}function d(w,R,i){const o=P(w);for(let t=o.length-1;t>=0;t--)(o[t].command===R||o[t].command===`-${R}`)&&(w=O.edit(w,[t],void 0,i));return w}function p(w,R,i,o){const t=P(w),n=t.findIndex(s=>s.command===R||s.command===`-${R}`);for(let s=t.length-1;s>=0;s--)(t[s].command===R||t[s].command===`-${R}`)&&(w=O.edit(w,[s],void 0,o));for(let s=i.length-1;s>=0;s--)w=O.edit(w,[n],i[s],o);return w}}),define(oe[261],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function k(l,O,P){const I={},E={},C=new Set;if(!O)return{local:{added:I,updated:E,removed:[...C.values()]},remote:{added:l,updated:{},removed:[]},conflicts:[]};const b=T(l,O);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{local:{added:I,updated:E,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=T(P,l),y=T(P,O),u={},S={},f=new Set,c=new Set;for(const d of m.removed.values())y.updated.has(d)?I[d]=O[d]:f.add(d);for(const d of y.removed.values())c.has(d)||(m.updated.has(d)?c.add(d):C.add(d));for(const d of m.updated.values())c.has(d)||(y.updated.has(d)?b.updated.has(d)&&c.add(d):S[d]=l[d]);for(const d of y.updated.values())c.has(d)||(m.updated.has(d)?b.updated.has(d)&&c.add(d):l[d]!==void 0&&(E[d]=O[d]));for(const d of m.added.values())c.has(d)||(y.added.has(d)?b.updated.has(d)&&c.add(d):u[d]=l[d]);for(const d of y.added.values())c.has(d)||(m.added.has(d)?b.updated.has(d)&&c.add(d):I[d]=O[d]);return{local:{added:I,removed:[...C.values()],updated:E},remote:{added:u,removed:[...f.values()],updated:S},conflicts:[...c.values()]}}e.merge=k;function T(l,O){const P=l?Object.keys(l):[],I=O?Object.keys(O):[],E=I.filter(m=>P.indexOf(m)===-1).reduce((m,y)=>(m.add(y),m),new Set),C=P.filter(m=>I.indexOf(m)===-1).reduce((m,y)=>(m.add(y),m),new Set),b=new Set;for(const m of P){if(C.has(m))continue;const y=l[m],u=O[m];y!==u&&b.add(m)}return{added:E,removed:C,updated:b}}function D(l,O){const{added:P,removed:I,updated:E}=T(l,O);return P.size===0&&I.size===0&&E.size===0}e.areSame=D}),define(oe[262],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(D,l,O,P){const I={added:[],removed:[],updated:[]};let E={added:[],removed:[],updated:[]};if(!l){const b=D.filter(({id:m})=>!P.includes(m));return b.length?E.added=b:E=null,{local:I,remote:E}}const C=T(D,l,P);if(C.added.length>0||C.removed.length>0||C.updated.length>0){const b=T(O,D,P),m=T(O,l,P);for(const y of m.removed){const u=D.find(S=>S.id===y);u&&I.removed.push(u)}for(const y of m.added){const u=l.find(S=>S.id===y);b.added.includes(y)?C.updated.includes(y)&&I.updated.push(u):I.added.push(u)}for(const y of m.updated)I.updated.push(l.find(u=>u.id===y));for(const y of b.added)m.added.includes(y)||E.added.push(D.find(u=>u.id===y));for(const y of b.updated)m.removed.includes(y)||m.updated.includes(y)||E.updated.push(D.find(u=>u.id===y));for(const y of b.removed){const u=l.find(S=>S.id===y);u&&E.removed.push(u)}}return E.added.length===0&&E.removed.length===0&&E.updated.length===0&&(E=null),{local:I,remote:E}}e.merge=k;function T(D,l,O){D=D?D.filter(({id:m})=>!O.includes(m)):[],l=l.filter(({id:m})=>!O.includes(m));const P=D.map(({id:m})=>m),I=l.map(({id:m})=>m),E=I.filter(m=>P.indexOf(m)===-1),C=P.filter(m=>I.indexOf(m)===-1),b=[];for(const{id:m,name:y,shortName:u}of D){if(C.includes(m))continue;const S=l.find(f=>f.id===m);(!S||S.name!==y||S.shortName!==u)&&b.push(m)}return{added:E,removed:C,updated:b}}}),define(oe[24],ae([0,1,21,12,183,46,30,5,106,40]),function(Q,e,k,T,D,l,O,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EXTENSIONS_SYNC_CONTEXT_KEY=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const s=E.Registry.as(l.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(a=>!!s[a].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function b(){const s=E.Registry.as(l.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(s).filter(g=>!!s[g].ignoreSync),r=Object.keys(s).filter(g=>s[g].scope===2||s[g].scope===6),h=C();return(0,k.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...a,...r,...h])}e.getDefaultIgnoredSettings=b,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function m(){const s="vscode://schemas/ignoredSettings",a=E.Registry.as(l.Extensions.Configuration);a.registerConfiguration({id:"settingsSync",order:30,title:(0,D.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,D.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,D.localize)(2,null),items:[{type:"string",pattern:O.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,D.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,D.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const r=E.Registry.as(I.Extensions.JSONContribution),h=()=>{const g=C(),v=b().filter(M=>M!==e.CONFIGURATION_SYNC_STORE_KEY),A=Object.keys(l.allSettings.properties).filter(M=>v.indexOf(M)===-1),N=v.filter(M=>g.indexOf(M)===-1),F={items:{type:"string",enum:[...A,...N.map(M=>`-${M}`)]}};r.registerSchema(s,F)};return a.onDidUpdateConfiguration(()=>h())}e.registerConfiguration=m;function y(s){return s&&(0,T.isObject)(s)&&(0,T.isString)(s.id)&&Array.isArray(s.scopes)}e.isAuthenticationProvider=y;var u;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState",s.Profiles="profiles"})(u=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function S(s,...a){return s?[s,...a]:a}e.getPathSegments=S;function f(s,a,r,h){return h.joinPath(r.userDataSyncHome,...S(s,a,`lastSync${a}.json`))}e.getLastSyncResourceUri=f,e.IUserDataSyncStoreManagementService=(0,P.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,P.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,P.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function c(s){const a={};return a[e.HEADER_EXECUTION_ID]=s,a}e.createSyncHeaders=c;var d;(function(s){s.Unauthorized="Unauthorized",s.NotFound="NotFound",s.MethodNotFound="MethodNotFound",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoCollection="NoCollection",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyProfiles="LocalTooManyProfiles",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.Unknown="Unknown"})(d=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class p extends Error{constructor(a,r,h,g){super(a),this.code=r,this.resource=h,this.operationId=g,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=p;class w extends p{constructor(a,r,h,g,v){super(a,h,void 0,v),this.url=r,this.serverCode=g}}e.UserDataSyncStoreError=w;class R extends p{constructor(a,r){super(a,r)}}e.UserDataAutoSyncError=R,function(s){function a(r){if(r instanceof s)return r;const h=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(r.name);if(h&&h[1]){const g=h[2]==="unknown"?void 0:h[2],v=h[3]==="unknown"?void 0:h[3];return new s(r.message,h[1],g,v)}return new s(r.message,"Unknown")}s.toUserDataSyncError=a}(p=e.UserDataSyncError||(e.UserDataSyncError={}));var i;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(i=e.SyncStatus||(e.SyncStatus={}));var o;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(o=e.Change||(e.Change={}));var t;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function n(s){return`sync.enable.${s}`}e.getEnablementKey=n,e.IUserDataSyncEnablementService=(0,P.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,P.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,P.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,P.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,P.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,P.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSyncLog",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview",e.EXTENSIONS_SYNC_CONTEXT_KEY="extensionsSync"}),define(oe[263],ae([0,1,32,24]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(O,P,I,E,C){if(!P)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const b=l(O,P);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const m=I?l(I,P):{added:Object.keys(P).reduce((d,p)=>(d.add(p),d),new Set),removed:new Set,updated:new Set},y=I?l(I,O):{added:Object.keys(O).reduce((d,p)=>(d.add(p),d),new Set),removed:new Set,updated:new Set},u={added:{},removed:[],updated:{}},S=k.deepClone(P),f=!I;for(const d of y.added.values())d!==T.SYNC_SERVICE_URL_TYPE&&f&&m.added.has(d)||(S[d]=O[d]);for(const d of y.updated.values())S[d]=O[d];for(const d of y.removed.values())E.unregistered.includes(d)||delete S[d];for(const d of m.added.values()){const p=P[d];if(E.machine.includes(d)){C.info(`GlobalState: Skipped adding ${d} in local storage because it is declared as machine scoped.`);continue}if(I&&y.added.has(d))continue;const w=O[d];w&&w.value===p.value||d===T.SYNC_SERVICE_URL_TYPE&&f&&y.added.has(d)||(w?u.updated[d]=p:u.added[d]=p)}for(const d of m.updated.values()){const p=P[d];if(E.machine.includes(d)){C.info(`GlobalState: Skipped updating ${d} in local storage because it is declared as machine scoped.`);continue}if(y.updated.has(d)||y.removed.has(d))continue;const w=O[d];w&&w.value===p.value||(u.updated[d]=p)}for(const d of m.removed.values()){if(E.machine.includes(d)){C.trace(`GlobalState: Skipped removing ${d} in local storage because it is declared as machine scoped.`);continue}y.updated.has(d)||y.removed.has(d)||u.removed.push(d)}const c=l(P,S);return{local:u,remote:{added:[...c.added],updated:[...c.updated],removed:[...c.removed],all:c.added.size===0&&c.removed.size===0&&c.updated.size===0?null:S}}}e.merge=D;function l(O,P){const I=Object.keys(O),E=Object.keys(P),C=E.filter(y=>I.indexOf(y)===-1).reduce((y,u)=>(y.add(u),y),new Set),b=I.filter(y=>E.indexOf(y)===-1).reduce((y,u)=>(y.add(u),y),new Set),m=new Set;for(const y of I){if(b.has(y))continue;const u=O[y],S=P[y];k.equals(u,S)||m.add(y)}return{added:C,removed:b,updated:m}}}),define(oe[264],ae([0,1,21,35,83,43,32,61,24]),function(Q,e,k,T,D,l,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function E(r,h,g){let v=[];g?v=b(g):v=C(h);const A=[],N=[...(0,I.getDisallowedIgnoredSettings)()];if(Array.isArray(v))for(const F of v)F.startsWith("-")?N.push(F.substring(1)):A.push(F);return(0,k.distinct)([...r,...A].filter(F=>N.indexOf(F)===-1))}e.getIgnoredSettings=E;function C(r){let h=r.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=r.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:r.getValue("settingsSync.ignoredSettings")||[]}function b(r){const h=(0,T.parse)(r);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function m(r,h){const g=(0,T.parse)(r)||{};let v="{}";for(const A of Object.keys(g)){const N=(0,D.setProperty)(v,[A],g[A],h);v=(0,D.applyEdits)(v,N)}return v}e.removeComments=m;function y(r,h,g,v){if(g.length){const A=a(h),N=(0,T.parse)(h)||{},F=(0,T.parse)(r);if(!F)return r;const M=[];for(const L of g){const $=N[L],z=F[L];$===void 0?r=P.edit(r,[L],void 0,v):z!==void 0?r=P.edit(r,[L],$,v):M.push(i(L,A))}M.sort((L,$)=>L.startOffset-$.startOffset),M.forEach(L=>r=d(L.setting.key,h,r,v))}return r}e.updateIgnoredSettings=y;function u(r,h,g,v,A,N){const F=y(r,h,v,N),M=g!==F,L=g!==h;if(!M&&!L)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!L)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(L&&!M)return{conflictsSettings:[],localContent:y(h,r,v,N),remoteContent:null,hasConflicts:!1};if(g===null&&f(r)){const q=S(r,h,v)?null:y(h,r,v,N);return{conflictsSettings:[],localContent:q,remoteContent:null,hasConflicts:!1}}let $=r,z=h;const x=(0,T.parse)(r),X=(0,T.parse)(h),ie=g?(0,T.parse)(g):null,H=v.reduce((q,Y)=>(q.add(Y),q),new Set),j=c(x,X,H),V=c(ie,x,H),J=c(ie,X,H),_=new Map,re=new Set,te=q=>{re.add(q);const Y=A.filter(({key:ee})=>ee===q)[0];Y?($=P.edit($,[q],Y.value,N),z=P.edit(z,[q],Y.value,N)):_.set(q,{key:q,localValue:x[q],remoteValue:X[q]})};for(const q of V.removed.values())J.updated.has(q)?te(q):z=P.edit(z,[q],void 0,N);for(const q of J.removed.values())re.has(q)||(V.updated.has(q)?te(q):$=P.edit($,[q],void 0,N));for(const q of V.updated.values())re.has(q)||(J.updated.has(q)?j.updated.has(q)&&te(q):z=P.edit(z,[q],x[q],N));for(const q of J.updated.values())re.has(q)||(V.updated.has(q)?j.updated.has(q)&&te(q):$=P.edit($,[q],X[q],N));for(const q of V.added.values())re.has(q)||(J.added.has(q)?j.updated.has(q)&&te(q):z=d(q,$,z,N));for(const q of J.added.values())re.has(q)||(V.added.has(q)?j.updated.has(q)&&te(q):$=d(q,z,$,N));const U=_.size>0||!S($,z,v),B=U||!S($,r,[]),W=U||!S(z,h,[]);return{localContent:B?$:null,remoteContent:W?z:null,conflictsSettings:[..._.values()],hasConflicts:U}}e.merge=u;function S(r,h,g){if(r===h)return!0;const v=(0,T.parse)(r),A=(0,T.parse)(h),N=g.reduce((L,$)=>(L.add($),L),new Set),F=a(r).filter(L=>!(L.setting&&N.has(L.setting.key))),M=a(h).filter(L=>!(L.setting&&N.has(L.setting.key)));if(F.length!==M.length)return!1;for(let L=0;L<F.length;L++){const $=F[L],z=M[L];if($.setting&&z.setting){if($.setting.key!==z.setting.key||!O.equals(v[$.setting.key],A[$.setting.key]))return!1}else if(!$.setting&&!z.setting){if($.value!==z.value)return!1}else return!1}return!0}e.areSame=S;function f(r){return r?a(r).length===0:!0}e.isEmpty=f;function c(r,h,g){const v=r?Object.keys(r).filter(L=>!g.has(L)):[],A=Object.keys(h).filter(L=>!g.has(L)),N=A.filter(L=>v.indexOf(L)===-1).reduce((L,$)=>(L.add($),L),new Set),F=v.filter(L=>A.indexOf(L)===-1).reduce((L,$)=>(L.add($),L),new Set),M=new Set;if(r)for(const L of v){if(F.has(L))continue;const $=r[L],z=h[L];O.equals($,z)||M.add(L)}return{added:N,removed:F,updated:M}}function d(r,h,g,v){const A=(0,T.parse)(h),N=a(h),F=a(g),M=p(r,N,F);return w(g,r,A[r],M,F,v)}e.addSetting=d;function p(r,h,g){const v=h.findIndex(N=>N.setting?.key===r),A=h[v-1];if(A){if(A.setting){const F=i(A.setting.key,g);if(F)return{index:g.indexOf(F),insertAfter:!0}}else{const F=o(v,h);if(F){const M=i(F.setting.key,g);if(M){const L=t(g.indexOf(M),g),$=n(h,F,h[v]);if(L){const z=n(g,M,L),x=s($,z);return x?{index:g.indexOf(x),insertAfter:!0}:{index:g.indexOf(L),insertAfter:!1}}else{const z=n(g,M,g[g.length-1]),x=s($,z);return x?{index:g.indexOf(x),insertAfter:!0}:{index:g.length-1,insertAfter:!0}}}}}const N=h[v+1];if(N)if(N.setting){const F=i(N.setting.key,g);if(F)return{index:g.indexOf(F),insertAfter:!1}}else{const F=t(v,h);if(F){const M=i(F.setting.key,g);if(M){const L=o(g.indexOf(M),g),$=n(h,h[v],F);if(L){const z=n(g,L,M),x=s($.reverse(),z.reverse());return x?{index:g.indexOf(x),insertAfter:!1}:{index:g.indexOf(L),insertAfter:!0}}else{const z=n(g,g[0],M),x=s($.reverse(),z.reverse());return x?{index:g.indexOf(x),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:g.length-1,insertAfter:!0}}function w(r,h,g,v,A,N){let F;return v.index===-1?F=(0,D.setProperty)(r,[h],g,N):F=R(r,h,g,v,A,N).map(M=>(0,D.withFormatting)(r,M,N)[0]),(0,D.applyEdits)(r,F)}function R(r,h,g,v,A,N){const F=`${JSON.stringify(h)}: ${JSON.stringify(g)}`,M=(0,l.getEOL)(N,r),L=A[v.index];if(v.insertAfter){const $=[];if(L.setting)$.push({offset:L.endOffset,length:0,content:","+F});else{const z=t(v.index,A),x=o(v.index,A),X=x?.setting?.commaOffset;x&&X===void 0&&$.push({offset:x.endOffset,length:0,content:","});const ie=X!==void 0&&X>L.endOffset;$.push({offset:ie?X+1:L.endOffset,length:0,content:z?M+F+",":M+F})}return $}else{if(L.setting)return[{offset:L.startOffset,length:0,content:F+","}];const $=(A[v.index-1]&&!A[v.index-1].setting?M:"")+F+(t(v.index,A)?",":"")+M;return[{offset:L.startOffset,length:0,content:$}]}}function i(r,h){return h.filter(g=>g.setting?.key===r)[0]}function o(r,h){for(let g=r-1;g>=0;g--)if(h[g].setting)return h[g]}function t(r,h){for(let g=r+1;g<h.length;g++)if(h[g].setting)return h[g]}function n(r,h,g){const v=r.indexOf(h),A=r.indexOf(g);return r.filter((N,F)=>v<F&&F<A)}function s(r,h){if(r.length&&h.length){let g=0;for(;g<h.length&&g<r.length;g++)if(r[g].value!==h[g].value)return h[g-1];return h[g-1]}}function a(r){const h=[];let g=-1,v,A;const N={onObjectBegin:F=>{g++},onObjectProperty:(F,M,L)=>{g===0&&(v=M,A=F)},onObjectEnd:(F,M)=>{g--,g===0&&h.push({startOffset:v,endOffset:F+M,value:r.substring(v,F+M),setting:{key:A,commaOffset:void 0}})},onArrayBegin:(F,M)=>{g++},onArrayEnd:(F,M)=>{g--,g===0&&h.push({startOffset:v,endOffset:F+M,value:r.substring(v,F+M),setting:{key:A,commaOffset:void 0}})},onLiteralValue:(F,M,L)=>{g===0&&h.push({startOffset:v,endOffset:M+L,value:r.substring(v,M+L),setting:{key:A,commaOffset:void 0}})},onSeparator:(F,M,L)=>{if(g===0&&F===","){let $=h.length-1;for(;$>=0&&!h[$].setting;$--);const z=h[$];z&&h.splice($,1,{startOffset:z.startOffset,endOffset:z.endOffset,value:z.value,setting:{key:z.setting.key,commaOffset:M}})}},onComment:(F,M)=>{g===0&&h.push({startOffset:F,endOffset:F+M,value:r.substring(F,F+M)})}};return(0,T.visit)(r,N),h}}),define(oe[78],ae([0,1,3,2,5,24]),function(Q,e,k,T,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,D.createDecorator)("IUserDataSyncAccountService");let O=class extends T.Disposable{get account(){return this.a}constructor(I,E){super(),this.g=I,this.h=E,this.b=this.B(new k.Emitter),this.onDidChangeAccount=this.b.event,this.c=this.B(new k.Emitter),this.onTokenFailed=this.c.event,this.f=!1,this.B(I.onTokenFailed(()=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f),this.updateAccount(void 0),this.c.fire(this.f),this.f=!0})),this.B(I.onTokenSucceed(()=>this.f=!1))}async updateAccount(I){(I&&this.a?I.token!==this.a.token||I.authenticationProviderId!==this.a.authenticationProviderId:I!==this.a)&&(this.a=I,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(I))}};O=ye([G(0,l.IUserDataSyncStoreService),G(1,l.IUserDataSyncLogService)],O),e.UserDataSyncAccountService=O}),define(oe[265],ae([0,1,2,11]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(m){this.a=m}listen(m,y){switch(y){case"onError":return this.a.onError}throw new Error(`Event not found: ${y}`)}call(m,y,u){switch(y){case"triggerSync":return this.a.triggerSync(u[0],u[1],u[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(u[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class l{constructor(m){this.a=m}listen(m,y){throw new Error(`Event not found: ${y}`)}call(m,y,u){switch(y){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(u[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(T.URI.revive(u[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=l;class O{constructor(m){this.a=m}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.a.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.a.call("resolveFormattingOptions",[m])}}e.UserDataSyncUtilServiceClient=O;class P{constructor(m){this.a=m}listen(m,y){switch(y){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${y}`)}async call(m,y,u){switch(y){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(u[0],u[1]);case"setEnablements":return this.a.setEnablements(u)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class I{constructor(m){this.a=m}listen(m,y){switch(y){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${y}`)}call(m,y,u){switch(y){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(u)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=I;class E{constructor(m){this.a=m}listen(m,y){switch(y){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${y}`)}call(m,y,u){switch(y){case"switch":return this.a.switch(u[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=E;class C extends k.Disposable{constructor(m){super(),this.a=m,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.a.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.a.call("getPreviousUserDataSyncStore");return this.b(m)}b(m){return{url:T.URI.revive(m.url),type:m.type,defaultUrl:T.URI.revive(m.defaultUrl),insidersUrl:T.URI.revive(m.insidersUrl),stableUrl:T.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=C}),define(oe[266],ae([0,1,184,15,8,24]),function(Q,e,k,T,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let O=class extends D.AbstractLogger{constructor(I,E){super(),this.g=this.B(I.createLogger(E.userDataSyncLogResource,{id:l.USER_DATA_SYNC_LOG_ID,name:(0,k.localize)(0,null)}))}trace(I,...E){this.g.trace(I,...E)}debug(I,...E){this.g.debug(I,...E)}info(I,...E){this.g.info(I,...E)}warn(I,...E){this.g.warn(I,...E)}error(I,...E){this.g.error(I,...E)}flush(){this.g.flush()}};O=ye([G(0,D.ILoggerService),G(1,T.IEnvironmentService)],O),e.UserDataSyncLogService=O}),define(oe[267],ae([0,1,6,3,2]),function(Q,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class l extends D.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:I,getActiveWindowId:E}){super(),this.a=this.B(new D.DisposableStore),T.Event.latch(T.Event.any(P,I))(this.f,this,this.a),this.b=(0,k.createCancelablePromise)(()=>E()),(async()=>{try{const b=await this.b;this.c=typeof this.c=="number"?this.c:b}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=l}),define(oe[117],ae([0,1,187,13,49,22,11,5,26]),function(Q,e,k,T,D,l,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function E(t){const n=t;return typeof n?.id=="string"&&O.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=E;function C(t){return typeof t?.id=="string"&&!E(t)&&!m(t)}e.isEmptyWorkspaceIdentifier=C,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function b(t,n){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,T.basename)(t)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const s=t;return s.configuration?{id:s.id,configPath:s.configuration}:s.folders.length===1?{id:s.id,uri:s.folders[0].uri}:{id:s.id}}e.toWorkspaceIdentifier=b;function m(t){const n=t;return typeof n?.id=="string"&&O.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=m;function y(t){const n=t;if(n?.uri)return{id:n.id,uri:O.URI.revive(n.uri)};const s=t;if(s?.configPath)return{id:s.id,configPath:O.URI.revive(s.configPath)};if(t?.id)return{id:t.id}}e.reviveIdentifier=y;var u;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(u=e.WorkbenchState||(e.WorkbenchState={}));function S(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=S;function f(t){const n=t;return!!(n&&typeof n=="object"&&O.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=f;class c{constructor(n,s,a,r,h){this.h=n,this.j=a,this.k=r,this.l=h,this.c=D.TernarySearchTree.forUris(this.l,()=>!0),this.folders=s}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=D.TernarySearchTree.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=c;class d{constructor(n,s){this.raw=s,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,l.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function p(t){return new d({uri:t,index:0,name:(0,l.basenameOrAuthority)(t)},{uri:t.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function w(t,n){return l.extUriBiasedIgnorePathCase.isEqualOrParent(t,n.untitledWorkspacesHome)}e.isUntitledWorkspace=w;function R(t){let n;return O.URI.isUri(t)?n=t:n=t.configuration,n?.scheme===I.Schemas.tmp}e.isTemporaryWorkspace=R;function i(t,n){return!w(t,n)&&!R(t)}e.isSavedWorkspace=i;function o(t){return(typeof t=="string"?(0,T.extname)(t):(0,l.extname)(t))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=o}),define(oe[18],ae([0,1,66,3,2,22,11,178,15,14,5,8,117,37,29,6,31,27,12]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u,S,f,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function p(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&O.URI.isUri(n.location)&&O.URI.isUri(n.globalStorageHome)&&O.URI.isUri(n.settingsResource)&&O.URI.isUri(n.keybindingsResource)&&O.URI.isUri(n.tasksResource)&&O.URI.isUri(n.snippetsHome)&&O.URI.isUri(n.extensionsResource))}e.isUserDataProfile=p,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,C.createDecorator)("IUserDataProfilesService");function w(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,location:O.URI.revive(t.location).with({scheme:n}),globalStorageHome:O.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:O.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:O.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:O.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:O.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:O.URI.revive(t.extensionsResource)?.with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=w;function R(t,n,s,a){return{id:t,name:n,location:s,isDefault:!1,shortName:a?.shortName,globalStorageHome:(0,l.joinPath)(s,"globalStorage"),settingsResource:(0,l.joinPath)(s,"settings.json"),keybindingsResource:(0,l.joinPath)(s,"keybindings.json"),tasksResource:(0,l.joinPath)(s,"tasks.json"),snippetsHome:(0,l.joinPath)(s,"snippets"),extensionsResource:(0,l.joinPath)(s,"extensions.json"),useDefaultFlags:a?.useDefaultFlags,isTransient:a?.transient}}e.toUserDataProfile=R;let i=class extends D.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(n,s,a,r){super(),this.m=n,this.n=s,this.r=a,this.s=r,this.f=!1,this.g=this.B(new T.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new T.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new T.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new T.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new y.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,l.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(n){this.f!==n&&(this.t=void 0,this.f=n)}isEnabled(){return this.f}get u(){if(!this.t){const n=[];if(this.f)for(const h of this.G()){if(!h.name||!(0,d.isString)(h.name)||!h.location){this.s.warn("Skipping the invalid stored profile",h.location||h.name);continue}n.push(R((0,l.basename)(h.location),h.name,h.location,{shortName:h.shortName,useDefaultFlags:h.useDefaultFlags}))}const s=new y.ResourceMap,a=new Map,r=R((0,k.hash)(this.m.userRoamingDataHome.path).toString(16),(0,P.localize)(0,null),this.m.userRoamingDataHome);if(n.unshift({...r,extensionsResource:this.L()??r.extensionsResource,isDefault:!0}),n.length){const h=this.I();if(h.workspaces)for(const[g,v]of Object.entries(h.workspaces)){const A=O.URI.parse(g),N=O.URI.parse(v),F=n.find(M=>this.r.extUri.isEqual(M.location,N));F&&s.set(A,F)}if(h.emptyWindows)for(const[g,v]of Object.entries(h.emptyWindows)){const A=O.URI.parse(v),N=n.find(F=>this.r.extUri.isEqual(F.location,A));N&&a.set(g,N)}}this.t={profiles:n,workspaces:s,emptyWindows:a}}return this.t}async createTransientProfile(n){const s="Temp",a=new RegExp(`${(0,c.escapeRegExpCharacters)(s)}\\s(\\d+)`);let r=0;for(const g of this.profiles){const v=a.exec(g.name),A=v?parseInt(v[1]):0;r=A>r?A:r}const h=`${s} ${r+1}`;return this.createProfile((0,k.hash)((0,f.generateUuid)()).toString(16),h,{transient:!0},n)}async createNamedProfile(n,s,a){return this.createProfile((0,k.hash)((0,f.generateUuid)()).toString(16),n,s,a)}async createProfile(n,s,a,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const h=await this.v(n,s,a);return r&&await this.setProfileForWorkspace(r,h),h}async v(n,s,a){if(!(0,d.isString)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let r=this.k.get(s);return r||(r=(async()=>{try{const h=this.profiles.find(A=>A.name===s||A.id===n);if(h)return h;const g=R(n,s,(0,l.joinPath)(this.profilesHome,n),a);await this.n.createFolder(g.location);const v=[];return this.h.fire({profile:g,join(A){v.push(A)}}),await S.Promises.settled(v),this.z([g],[],[]),g}finally{this.k.delete(s)}})(),this.k.set(s,r)),r}async updateProfile(n,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let a=this.profiles.find(r=>r.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);return a=R(a.id,s.name??a.name,a.location,{shortName:s.shortName??a.shortName,transient:s.transient??a.isTransient,useDefaultFlags:s.useDefaultFlags??a.useDefaultFlags}),this.z([],[],[a]),a}async removeProfile(n){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(r=>r.id===n.id);if(!s)throw new Error(`Profile '${n.name}' does not exist`);const a=[];this.i.fire({profile:s,join(r){a.push(r)}});try{await Promise.allSettled(a)}catch(r){this.s.error(r)}for(const r of[...this.u.emptyWindows.keys()])s.id===this.u.emptyWindows.get(r)?.id&&this.u.emptyWindows.delete(r);for(const r of[...this.u.workspaces.keys()])s.id===this.u.workspaces.get(r)?.id&&this.u.workspaces.delete(r);this.F(),this.z([],[s],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(s.location,{recursive:!0})}catch(r){this.s.error(r)}}async setProfileForWorkspace(n,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const a=this.profiles.find(r=>r.id===s.id);if(!a)throw new Error(`Profile '${s.name}' does not exist`);this.D(n,a)}unsetWorkspace(n,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.D(n,void 0,s)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.F(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const n=await this.n.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(s=>s.isDirectory&&this.profiles.every(a=>!this.r.extUri.isEqual(a.location,s.resource))).map(s=>this.n.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.l.profiles.filter(s=>!this.y(s));await Promise.allSettled(n.map(s=>this.removeProfile(s)))}getProfileForWorkspace(n){const s=this.w(n);return O.URI.isUri(s)?this.l.workspaces.get(s)??this.u.workspaces.get(s):this.l.emptyWindows.get(s)??this.u.emptyWindows.get(s)}w(n){return(0,m.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,m.isWorkspaceIdentifier)(n)?n.configPath:n.id}y(n){return!!([...this.l.emptyWindows.values()].some(s=>this.r.extUri.isEqual(s.location,n.location))||[...this.l.workspaces.values()].some(s=>this.r.extUri.isEqual(s.location,n.location))||[...this.u.emptyWindows.values()].some(s=>this.r.extUri.isEqual(s.location,n.location))||[...this.u.workspaces.values()].some(s=>this.r.extUri.isEqual(s.location,n.location)))}z(n,s,a){const r=[...this.profiles,...n],h=[];this.l.profiles=[];for(let g of r)g.isDefault||s.some(v=>g.id===v.id)||(g=a.find(v=>g.id===v.id)??g,g.isTransient?this.l.profiles.push(g):h.push({location:g.location,name:g.name,shortName:g.shortName,useDefaultFlags:g.useDefaultFlags}));this.H(h),this.t=void 0,this.C(n,s,a)}C(n,s,a){this.g.fire({added:n,removed:s,updated:a,all:this.profiles})}D(n,s,a){a=s?.isTransient?!0:a,a||this.D(n,void 0,!0);const r=this.w(n),h=a?this.l:this.u;O.URI.isUri(r)?(h.workspaces.delete(r),s&&h.workspaces.set(r,s)):(h.emptyWindows.delete(r),s&&h.emptyWindows.set(r,s)),a||this.F()}F(){const n={};for(const[a,r]of this.u.workspaces.entries())n[a.toString()]=r.location.toString();const s={};for(const[a,r]of this.u.emptyWindows.entries())s[a.toString()]=r.location.toString();this.J({workspaces:n,emptyWindows:s}),this.t=void 0}G(){return[]}H(n){throw new Error("not implemented")}I(){return{}}J(n){throw new Error("not implemented")}L(){}};i.b="userDataProfiles",i.c="profileAssociations",i=ye([G(0,I.IEnvironmentService),G(1,E.IFileService),G(2,u.IUriIdentityService),G(3,b.ILogService)],i),e.UserDataProfilesService=i;class o extends i{constructor(){super(...arguments),this.a=[],this.O={}}G(){return this.a}H(n){this.a=n}I(){return this.O}J(n){this.O=n}}e.InMemoryUserDataProfilesService=o}),define(oe[268],ae([0,1,6,2,18]),function(Q,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let l=class extends T.Disposable{constructor(P){super(),this.B(new k.RunOnceScheduler(()=>{P.cleanUp()},10*1e3)).schedule()}};l=ye([G(0,D.IUserDataProfilesService)],l),e.UserDataProfilesCleaner=l}),define(oe[269],ae([0,1,21,6,25,9,3,2,4,11,157,30,33,42,8,23,19,18]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u,S,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var d;(function(t){t.Verified="Verified",t.Unverified="Unverified",t.UnknownError="UnknownError"})(d=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let p=class extends P.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(n,s,a,r,h){super(),this.t=n,this.u=s,this.v=a,this.w=r,this.y=h,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new O.Emitter),this.m=this.B(new O.Emitter),this.n=this.B(new O.Emitter),this.p=this.B(new O.Emitter),this.s=[],this.B((0,P.toDisposable)(()=>{this.j.forEach(({task:g})=>g.cancel()),this.k.forEach(g=>g.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(n){const s=await this.getTargetPlatform();return n.allTargetPlatforms.some(a=>(0,b.isTargetPlatformCompatible)(a,n.allTargetPlatforms,s))}async installFromGallery(n,s={}){try{if(!this.t.isEnabled())throw new b.ExtensionManagementError(C.localize(0,null),b.ExtensionManagementErrorCode.Internal);const a=await this.G(n,!!s.installGivenVersion,!!s.installPreReleaseVersion);return await this.z(a.manifest,a.extension,s)}catch(a){throw i(this.u,"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(n),error:a}),this.v.error("Failed to install extension.",n.identifier.id),this.v.error(a),R(a)}}async uninstall(n,s={}){return this.v.trace("ExtensionManagementService#uninstall",n.identifier.id),this.I(n,s)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.O(),this.h=n),this.g}registerParticipant(n){this.s.push(n)}async z(n,s,a){const r={...a,installOnlyNewlyAddedFromExtensionPack:E.URI.isUri(s)?a.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,y.isApplicationScopedExtension)(n)?this.y.defaultProfile.extensionsResource:a.profileLocation??this.P()},h=M=>`${m.ExtensionKey.create(M).toString()}${r.profileLocation?`-${r.profileLocation.toString()}`:""}`;if(!E.URI.isUri(s)){const M=this.j.get(h(s));if(M){this.v.info("Extensions is already requested to install",s.identifier.id);const{local:L}=await M.task.waitUntilTaskIsFinished();return L}}const g=[],v=[],A=[],N=this.Q(n,s,r);E.URI.isUri(s)||this.j.set(h(s),{task:N,waitingTasks:[]}),this.l.fire({identifier:N.identifier,source:s,profileLocation:r.profileLocation}),this.v.info("Installing extension:",N.identifier.id),g.push({task:N,manifest:n});let F=!1;try{if(r.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",N.identifier.id);else try{const L=await this.F(N.identifier,n,!!r.installOnlyNewlyAddedFromExtensionPack,!!r.installPreReleaseVersion,r.profileLocation),$=await this.getInstalled(void 0,r.profileLocation);for(const{gallery:z,manifest:x}of(0,k.distinct)(L,({gallery:X})=>X.identifier.id)){F=F||!!x.extensionDependencies?.some(H=>(0,m.areSameExtensions)({id:H},N.identifier));const X=h(z),ie=this.j.get(X);if(ie){if(this.C(N,ie.task)){const H=ie.task.identifier;this.v.info("Waiting for already requested installing extension",H.id,N.identifier.id),ie.waitingTasks.push(N),v.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,j=>j.some(V=>(0,m.areSameExtensions)(V.identifier,H)))).then(j=>{if(this.v.info("Finished waiting for already requested installing extension",H.id,N.identifier.id),!j.find(J=>(0,m.areSameExtensions)(J.identifier,H))?.local)throw new Error(`Extension ${H.id} is not installed`)}))}}else if(!$.some(({identifier:H})=>(0,m.areSameExtensions)(H,z.identifier))){const H=this.Q(x,z,{...r,donotIncludePackAndDependencies:!0});this.j.set(X,{task:H,waitingTasks:[N]}),this.l.fire({identifier:H.identifier,source:z,profileLocation:r.profileLocation}),this.v.info("Installing extension:",H.identifier.id,N.identifier.id),g.push({task:H,manifest:x})}}}catch(L){if(E.URI.isUri(N.source))(0,k.isNonEmptyArray)(n.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",N.identifier.id,L.message),(0,k.isNonEmptyArray)(n.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",N.identifier.id,L.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",N.identifier.id),L}const M=g.reduce((L,{task:$,manifest:z})=>(L.set($.identifier.id.toLowerCase(),{task:$,manifest:z}),L),new Map);for(;M.size;){let L;const $=[...M.values()].filter(({manifest:z})=>!z.extensionDependencies?.some(x=>M.has(x.toLowerCase())));$.length?L=M.size===1?$:$.filter(({task:z})=>!(z===N&&!F)):(this.v.info("Found extensions with circular dependencies",$.map(({task:z})=>z.identifier.id)),L=[...M.values()]),await this.D(L.map(async({task:z})=>{const x=new Date().getTime();try{const{local:X}=await z.run();if(await this.D(this.s.map(ie=>ie.postInstall(X,z.source,r,D.CancellationToken.None))),!E.URI.isUri(z.source)){const ie=z.operation===3,H=ie?void 0:(new Date().getTime()-z.source.lastUpdated)/1e3;if(i(this.u,ie?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-x,durationSinceUpdate:H}),I.isWeb&&z.operation!==3)try{await this.t.reportStatistic(X.manifest.publisher,X.manifest.name,X.manifest.version,"install")}catch{}}A.push({local:X,identifier:z.identifier,operation:z.operation,source:z.source,context:r.context,profileLocation:r.profileLocation,applicationScoped:X.isApplicationScoped})}catch(X){throw E.URI.isUri(z.source)||i(this.u,z.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-x,error:X}),this.v.error("Error while installing the extension:",z.identifier.id),X}finally{M.delete(z.identifier.id.toLowerCase())}}))}return v.length&&await this.D(v),A.forEach(({identifier:L})=>this.v.info("Extension installed successfully:",L.id)),this.m.fire(A),A.filter(({identifier:L})=>(0,m.areSameExtensions)(L,N.identifier))[0].local}catch(M){if(g.forEach(({task:L})=>L.cancel()),A.length)try{const L=await Promise.allSettled(A.map(({local:$})=>this.R($,{versionOnly:!0,profileLocation:r.profileLocation}).run()));for(let $=0;$<L.length;$++){const z=L[$],{identifier:x}=A[$];z.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",x.id):this.v.warn("Rollback: Error while uninstalling extension",x.id,(0,l.getErrorMessage)(z.reason))}}catch(L){this.v.warn("Error while rolling back extensions",(0,l.getErrorMessage)(L),A.map(({identifier:$})=>$.id))}throw this.m.fire(g.map(({task:L})=>({identifier:L.identifier,operation:2,source:L.source,context:r.context,profileLocation:r.profileLocation}))),M}finally{for(const{task:M}of g)M.source&&!E.URI.isUri(M.source)&&this.j.delete(h(M.source))}}C(n,s){for(const[,{task:a,waitingTasks:r}]of this.j.entries())if(a===n&&(r.includes(s)||r.some(h=>this.C(h,s)))||a===s&&r[0]&&!this.C(n,r[0]))return!1;return!0}async D(n){const s=[],a=[],r=await Promise.allSettled(n);for(const h of r)h.status==="fulfilled"?s.push(h.value):a.push(h.reason);if(a.length)throw w(a);return s}async F(n,s,a,r,h){if(!this.t.isEnabled())return[];const g=await this.getInstalled(void 0,h),v=[],A=[],N=async(F,M)=>{v.push(F);const L=M.extensionDependencies||[],$=[...L];if(M.extensionPack){const z=a?g.find(x=>(0,m.areSameExtensions)(x.identifier,F)):void 0;for(const x of M.extensionPack)z&&z.manifest.extensionPack&&z.manifest.extensionPack.some(X=>(0,m.areSameExtensions)({id:X},{id:x}))||$.every(X=>!(0,m.areSameExtensions)({id:X},{id:x}))&&$.push(x)}if($.length){const z=$.filter(x=>v.every(X=>!(0,m.areSameExtensions)(X,{id:x})));if(z.length){const x=await this.t.getExtensions(z.map(X=>({id:X,preRelease:r})),D.CancellationToken.None);for(const X of x){if(v.find(j=>(0,m.areSameExtensions)(j,X.identifier)))continue;const ie=L.some(j=>(0,m.areSameExtensions)({id:j},X.identifier));let H;try{H=await this.G(X,!1,r)}catch(j){if(j instanceof b.ExtensionManagementError&&j.code===b.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ie){this.v.info("Skipping the packed extension as it cannot be installed",X.identifier.id);continue}else throw j}A.push({gallery:H.extension,manifest:H.manifest}),await N(H.extension.identifier,H.manifest)}}}};return await N(n,s),A}async G(n,s,a){if((await this.getExtensionsControlManifest()).malicious.some(v=>(0,m.areSameExtensions)(n.identifier,v)))throw new b.ExtensionManagementError(C.localize(1,null,n.identifier.id),b.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const v=await this.getTargetPlatform();throw new b.ExtensionManagementError(C.localize(2,null,n.identifier.id,this.w.nameLong,(0,b.TargetPlatformToString)(v)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const h=await this.H(n,s,a);if(h){if(a&&!s&&n.hasPreReleaseVersion&&!h.properties.isPreReleaseVersion)throw new b.ExtensionManagementError(C.localize(3,null,n.identifier.id,this.w.nameLong,this.w.version),b.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!a&&n.properties.isPreReleaseVersion&&(await this.t.getExtensions([n.identifier],D.CancellationToken.None))[0]?new b.ExtensionManagementError(C.localize(4,null,n.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.ExtensionManagementError(C.localize(5,null,n.identifier.id,this.w.nameLong,this.w.version),b.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",h.identifier.id);const g=await this.t.getManifest(h,D.CancellationToken.None);if(g===null)throw new b.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(g.version!==h.version)throw new b.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:h,manifest:g}}async H(n,s,a){const r=await this.getTargetPlatform();let h=null;return!s&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==a&&(h=(await this.t.getExtensions([{...n.identifier,preRelease:a}],{targetPlatform:r,compatible:!0},D.CancellationToken.None))[0]||null),!h&&await this.t.isExtensionCompatible(n,a,r)&&(h=n),h||(s?h=(await this.t.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:r,compatible:!0},D.CancellationToken.None))[0]||null:h=await this.t.getCompatibleExtension(n,a,r)),h}async I(n,s){const a={...s,profileLocation:n.isApplicationScoped?this.y.defaultProfile.extensionsResource:s.profileLocation??this.P()},r=F=>`${F.id.toLowerCase()}${a.versionOnly?`-${n.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,h=this.k.get(r(n.identifier));if(h)return this.v.info("Extensions is already requested to uninstall",n.identifier.id),h.waitUntilTaskIsFinished();const g=F=>{const M=this.R(F,a);return this.k.set(r(M.extension.identifier),M),a.profileLocation?this.v.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.v.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this.n.fire({identifier:F.identifier,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped}),M},v=(F,M)=>{M?a.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString(),M.message):this.v.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,M.message):a.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),i(this.u,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(F),error:M}),this.p.fire({identifier:F.identifier,error:M?.code,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped})},A=[],N=[];try{A.push(g(n));const F=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const M=this.M(n,F);for(const L of M)this.k.has(r(L.identifier))?this.v.info("Extensions is already requested to uninstall",L.identifier.id):A.push(g(L))}a.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.J(A.map(M=>M.extension),F,n),await this.D(A.map(async M=>{try{if(await M.run(),await this.D(this.s.map(L=>L.postUninstall(M.extension,a,D.CancellationToken.None))),M.extension.identifier.uuid)try{await this.t.reportStatistic(M.extension.manifest.publisher,M.extension.manifest.name,M.extension.manifest.version,"uninstall")}catch{}v(M.extension)}catch(L){const $=L instanceof b.ExtensionManagementError?L:new b.ExtensionManagementError((0,l.getErrorMessage)(L),b.ExtensionManagementErrorCode.Internal);throw v(M.extension,$),$}finally{N.push(M)}}))}catch(F){const M=F instanceof b.ExtensionManagementError?F:new b.ExtensionManagementError((0,l.getErrorMessage)(F),b.ExtensionManagementErrorCode.Internal);for(const L of A){try{L.cancel()}catch{}N.includes(L)||v(L.extension,M)}throw M}finally{for(const F of A)this.k.delete(r(F.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}J(n,s,a){for(const r of n){const h=this.N(r,s);if(h.length){const g=h.filter(v=>!n.some(A=>(0,m.areSameExtensions)(A.identifier,v.identifier)));if(g.length)throw new Error(this.L(r,g,a))}}}L(n,s,a){return a===n?s.length===1?C.localize(6,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?C.localize(7,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):C.localize(8,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?C.localize(9,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?C.localize(10,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):C.localize(11,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}M(n,s,a=[]){if(a.indexOf(n)!==-1)return[];a.push(n);const r=n.manifest.extensionPack?n.manifest.extensionPack:[];if(r.length){const h=s.filter(v=>!v.isBuiltin&&r.some(A=>(0,m.areSameExtensions)({id:A},v.identifier))),g=[];for(const v of h)g.push(...this.M(v,s,a));return[...h,...g]}return[]}N(n,s){return s.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(r=>(0,m.areSameExtensions)({id:r},n.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const n=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};p=ye([G(0,b.IExtensionGalleryService),G(1,f.ITelemetryService),G(2,u.ILogService),G(3,S.IProductService),G(4,c.IUserDataProfilesService)],p),e.AbstractExtensionManagementService=p;function w(t){const n=Array.isArray(t)?t:[t];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((s,a)=>new Error(`${s.message}${s.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=w;function R(t){if(t instanceof b.ExtensionManagementError)return t;const n=new b.ExtensionManagementError(t.message,b.ExtensionManagementErrorCode.Internal);return n.stack=t.stack,n}function i(t,n,{extensionData:s,verificationStatus:a,duration:r,error:h,durationSinceUpdate:g}){let v,A;h&&(h instanceof b.ExtensionManagementError?(v=h.code,h.code===b.ExtensionManagementErrorCode.Signature&&(A=h.message)):v=b.ExtensionManagementErrorCode.Internal),t.publicLog(n,{...s,verificationStatus:a,success:!h,duration:r,errorcode:v,errorcodeDetail:A,durationSinceUpdate:g})}e.reportTelemetry=i;class o{constructor(){this.d=new T.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,T.createCancelablePromise)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,T.createCancelablePromise)(n=>new Promise((s,a)=>{const r=n.onCancellationRequested(()=>{r.dispose(),a(new l.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=o}),define(oe[51],ae([0,1,6,17,2,3,37,11,33,42,14,5,8,18,29,12,9,19]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u,S,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class p extends Error{constructor(t,n){super(t),this.code=n}}e.ExtensionsProfileScanningError=p,e.IExtensionsProfileScannerService=(0,b.createDecorator)("IExtensionsProfileScannerService");let w=class extends D.Disposable{constructor(t,n,s,a,r,h){super(),this.h=t,this.i=n,this.j=s,this.k=a,this.l=r,this.m=h,this.a=this.B(new l.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new l.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new l.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new l.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new O.ResourceMap}scanProfileExtensions(t,n){return this.n(t,void 0,n)}async addExtensionsToProfile(t,n){const s=[],a=[];try{return await this.n(n,r=>{const h=[];for(const g of r)t.some(([v])=>(0,I.areSameExtensions)(v.identifier,g.identifier)&&v.manifest.version!==g.version)?s.push(g):h.push(g);for(const[g,v]of t)if(!h.some(A=>(0,I.areSameExtensions)(A.identifier,g.identifier)&&A.version===g.manifest.version)){const A={identifier:g.identifier,version:g.manifest.version,location:g.location,metadata:v};a.push(A),h.push(A)}return a.length&&this.a.fire({extensions:a,profileLocation:n}),s.length&&this.c.fire({extensions:s,profileLocation:n}),h}),a.length&&this.b.fire({extensions:a,profileLocation:n}),s.length&&this.f.fire({extensions:s,profileLocation:n}),a}catch(r){throw a.length&&this.b.fire({extensions:a,error:r,profileLocation:n}),s.length&&this.f.fire({extensions:s,error:r,profileLocation:n}),r}}async updateMetadata(t,n){const s=[];return await this.n(n,a=>{const r=[];for(const h of a){const g=t.find(([v])=>(0,I.areSameExtensions)(v.identifier,h.identifier)&&v.manifest.version===h.version);g&&(h.metadata={...h.metadata,...g[1]},s.push(h)),r.push(h)}return r}),s}async removeExtensionFromProfile(t,n){const s=[];this.c.fire({extensions:s,profileLocation:n});try{await this.n(n,a=>{const r=[];for(const h of a)(0,I.areSameExtensions)(h.identifier,t.identifier)?s.push(h):r.push(h);return s.length&&this.c.fire({extensions:s,profileLocation:n}),r}),s.length&&this.f.fire({extensions:s,profileLocation:n})}catch(a){throw s.length&&this.f.fire({extensions:s,error:a,profileLocation:n}),a}}async n(t,n,s){return this.v(t).queue(async()=>{let a=[],r;try{const h=await this.i.readFile(t);r=JSON.parse(h.value.toString())}catch(h){if((0,C.toFileOperationResult)(h)!==1)throw h;if(this.k.extUri.isEqual(t,this.j.defaultProfile.extensionsResource)&&(r=await this.u()),!r&&s?.bailOutWhenFileNotFound)throw new p((0,f.getErrorMessage)(h),"ERROR_PROFILE_NOT_FOUND")}if(r){Array.isArray(r)||this.p(t);let h=!1;for(const g of r){R(g)||this.p(t);let v;if((0,S.isString)(g.location))v=this.s(g.location);else{v=P.URI.revive(g.location);const A=this.r(v);A&&(h=!0,g.location=A)}a.push({identifier:g.identifier,location:v,version:g.version,metadata:g.metadata})}h&&await this.i.writeFile(t,T.VSBuffer.fromString(JSON.stringify(r)))}if(n){a=n(a);const h=a.map(g=>({identifier:g.identifier,version:g.version,location:this.r(g.location)??g.location.toJSON(),metadata:g.metadata}));await this.i.writeFile(t,T.VSBuffer.fromString(JSON.stringify(h)))}return a})}p(t){const n=new p(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.l.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}r(t){return this.k.extUri.isEqualOrParent(t,this.h)?this.k.extUri.relativePath(this.h,t):void 0}s(t){return this.k.extUri.joinPath(this.h,t)}async u(){return this.t||(this.t=(async()=>{const t=this.k.extUri.joinPath(this.j.defaultProfile.location,"extensions.json");let n;try{n=(await this.i.readFile(t)).value.toString()}catch(a){if((0,C.toFileOperationResult)(a)===1)return;throw a}this.m.info("Migrating extensions from old default profile location",t.toString());let s;try{const a=JSON.parse(n);Array.isArray(a)&&a.every(r=>R(r))?s=a:this.m.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.m.error(a)}if(s)try{await this.i.createFile(this.j.defaultProfile.extensionsResource,T.VSBuffer.fromString(JSON.stringify(s)),{overwrite:!1}),this.m.info("Migrated extensions from old default profile location to new location",t.toString(),this.j.defaultProfile.extensionsResource.toString())}catch(a){if((0,C.toFileOperationResult)(a)===3)this.m.info("Migration from old default profile location to new location is done by another window",t.toString(),this.j.defaultProfile.extensionsResource.toString());else throw a}try{await this.i.del(t)}catch(a){(0,C.toFileOperationResult)(a)!==1&&this.m.error(a)}return s})()),this.t}v(t){let n=this.g.get(t);return n||(n=new k.Queue,this.g.set(t,n)),n}};w=ye([G(1,C.IFileService),G(2,y.IUserDataProfilesService),G(3,u.IUriIdentityService),G(4,c.ITelemetryService),G(5,m.ILogService)],w),e.AbstractExtensionsProfileScannerService=w;function R(o){return(0,S.isObject)(o)&&(0,E.isIExtensionIdentifier)(o.identifier)&&(i(o.location)||(0,S.isString)(o.location))&&o.version&&(0,S.isString)(o.version)}function i(o){return o?(0,S.isString)(o.path)&&(0,S.isString)(o.scheme):!1}}),define(oe[79],ae([0,1,21,6,32,17,9,35,140,2,26,13,4,22,54,89,12,11,160,15,33,42,70,14,5,8,23,3,67,51,18,29,193,194]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u,S,f,c,d,p,w,R,i,o,t,n,s,a,r,h,g,v,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var F;(function(ie){function H(j,V){if(j===V)return!0;const J=Object.keys(j),_=new Set;for(const re of Object.keys(V))_.add(re);if(J.length!==_.size)return!1;for(const re of J){if(j[re]!==V[re])return!1;_.delete(re)}return _.size===0}ie.equals=H})(F=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let M=class extends E.Disposable{constructor(H,j,V,J,_,re,te,U,B,W,q,Y){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=j,this.l=V,this.m=J,this.n=_,this.p=re,this.r=te,this.s=U,this.t=B,this.u=W,this.v=q,this.w=Y,this.g=this.B(new a.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,y.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(z,(0,y.joinPath)(this.m,R.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(z,(0,y.joinPath)(this.m,R.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance($,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,w.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(H,j,V){const[J,_]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(j)]),re=V?await this.scanExtensionsUnderDevelopment(H,[...J,..._]):[];return this.F(J,_,re,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const j=[];j.push(this.G(!!H.useCache,H.language)),j.push(this.H(H.language,!!H.checkControlFile));const[V,J]=await Promise.all(j);return this.D([...V,...J],0,H,!1)}async scanUserExtensions(H){const j=H.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",j);const V=this.v.extUri.isEqual(H.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,J=await this.J(j,!!H.profileLocation,1,!H.includeUninstalled,H.language,!0,V),_=H.useCache&&!J.devMode&&J.excludeObsolete?this.j:this.k;let re;try{re=await _.scanExtensions(J)}catch(te){if(te instanceof h.ExtensionsProfileScanningError&&te.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),re=await _.scanExtensions(J);else throw te}return re=await this.D(re,1,H,!0),this.s.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(H,j){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const V=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(J=>J.scheme===C.Schemas.file).map(async J=>{const _=await this.J(J,!1,1,!0,H.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(_)).map(te=>(te.type=j.find(U=>(0,w.areSameExtensions)(U.identifier,te.identifier))?.type??te.type,this.k.validate(te,_)))}))).flat();return this.D(V,"development",H,!0)}return[]}async scanExistingExtension(H,j,V){const J=await this.J(H,!1,j,!0,V.language,!0,void 0),_=await this.k.scanExtension(J);return!_||!V.includeInvalid&&!_.isValid?null:_}async scanOneOrMultipleExtensions(H,j,V){const J=await this.J(H,!1,j,!0,V.language,!0,void 0),_=await this.k.scanOneOrMultipleExtensions(J);return this.D(_,j,V,!0)}async scanMetadata(H){const j=(0,y.joinPath)(H,"package.json"),V=(await this.r.readFile(j)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(H,j){const V=(0,y.joinPath)(H,"package.json"),J=(await this.r.readFile(V)).value.toString(),_=JSON.parse(J);j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,j.installedTimestamp=j.installedTimestamp||void 0,_.__metadata={..._.__metadata,...j},await this.r.writeFile((0,y.joinPath)(H,"package.json"),l.VSBuffer.fromString(JSON.stringify(_,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof h.ExtensionsProfileScanningError&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw H}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.p.addExtensionsToProfile(H.map(j=>[j,j.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,l.VSBuffer.fromString(JSON.stringify([])))}catch(j){(0,o.toFileOperationResult)(j)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.getErrorMessage)(j))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.s.error(H)}finally{this.z=void 0}})()),this.z}async D(H,j,V,J){return V.includeAllVersions||(H=this.F(j===0?H:void 0,j===1?H:void 0,j==="development"?H:void 0,await this.getTargetPlatform(),J)),V.includeInvalid||(H=H.filter(_=>_.isValid)),H.sort((_,re)=>{const te=b.basename(_.location.fsPath),U=b.basename(re.location.fsPath);return te<U?-1:te>U?1:0})}F(H,j,V,J,_){const re=(U,B,W)=>{if(U.isValid&&!B.isValid)return!1;if(U.isValid===B.isValid){if(_&&u.gt(U.manifest.version,B.manifest.version))return this.s.debug(`Skipping extension ${B.location.path} with lower version ${B.manifest.version} in favour of ${U.location.path} with version ${U.manifest.version}`),!1;if(u.eq(U.manifest.version,B.manifest.version)){if(U.type===0)return this.s.debug(`Skipping extension ${B.location.path} in favour of system extension ${U.location.path} with same version`),!1;if(U.targetPlatform===J)return this.s.debug(`Skipping extension ${B.location.path} from different target platform ${B.targetPlatform}`),!1}}return W?this.s.warn(`Overwriting user extension ${U.location.path} with ${B.location.path}.`):this.s.debug(`Overwriting user extension ${U.location.path} with ${B.location.path}.`),!0},te=new Map;return H?.forEach(U=>{const B=R.ExtensionIdentifier.toKey(U.identifier.id),W=te.get(B);(!W||re(W,U,!1))&&te.set(B,U)}),j?.forEach(U=>{const B=R.ExtensionIdentifier.toKey(U.identifier.id),W=te.get(B);if(!W&&H&&U.type===0){this.s.debug(`Skipping obsolete system extension ${U.location.path}.`);return}(!W||re(W,U,!1))&&te.set(B,U)}),V?.forEach(U=>{const B=R.ExtensionIdentifier.toKey(U.identifier.id),W=te.get(B);(!W||re(W,U,!0))&&te.set(B,U),te.set(B,U)}),[...te.values()]}async G(H,j){this.s.trace("Started scanning system extensions");const V=await this.J(this.systemExtensionsLocation,!1,0,!0,j,!0,void 0),_=await(H&&!V.devMode?this.i:this.k).scanExtensions(V);return this.s.trace("Scanned system extensions:",_.length),_}async H(H,j){const V=this.t.isBuilt?[]:this.u.builtInExtensions;if(!V?.length)return[];this.s.trace("Started scanning dev system extensions");const J=j?await this.I():{},_=[],re=c.URI.file(b.normalize(b.join(C.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const U of V){const B=J[U.name]||"marketplace";switch(B){case"disabled":break;case"marketplace":_.push((0,y.joinPath)(re,U.name));break;default:_.push(c.URI.file(B));break}}const te=await Promise.all(_.map(async U=>this.k.scanExtension(await this.J(U,!1,0,!0,H,!0,void 0))));return this.s.trace("Scanned dev system extensions:",te.length),(0,k.coalesce)(te)}async I(){try{const H=await this.r.readFile(this.l);return JSON.parse(H.value.toString())}catch{return{}}}async J(H,j,V,J,_,re,te){const U=await this.f(_??m.language),B=await this.L(H),W=j&&!this.v.extUri.isEqual(H,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,q=W?await this.L(W):void 0;return new L(H,B,W,q,j,te,V,J,re,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,_,U)}async L(H){try{const j=await this.r.stat(H);if(typeof j.mtime=="number")return j.mtime}catch{}}};M=ye([G(4,g.IUserDataProfilesService),G(5,h.IExtensionsProfileScannerService),G(6,o.IFileService),G(7,n.ILogService),G(8,p.IEnvironmentService),G(9,s.IProductService),G(10,v.IUriIdentityService),G(11,t.IInstantiationService)],M),e.AbstractExtensionsScannerService=M;class L{constructor(H,j,V,J,_,re,te,U,B,W,q,Y,ee,K,Z){this.location=H,this.mtime=j,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=J,this.profile=_,this.profileScanOptions=re,this.type=te,this.excludeObsolete=U,this.validate=B,this.productVersion=W,this.productDate=q,this.productCommit=Y,this.devMode=ee,this.language=K,this.translations=Z}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,j){return(0,y.isEqual)(H.location,j.location)&&H.mtime===j.mtime&&(0,y.isEqual)(H.applicationExtensionslocation,j.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===j.applicationExtensionslocationMtime&&H.profile===j.profile&&D.equals(H.profileScanOptions,j.profileScanOptions)&&H.type===j.type&&H.excludeObsolete===j.excludeObsolete&&H.validate===j.validate&&H.productVersion===j.productVersion&&H.productDate===j.productDate&&H.productCommit===j.productCommit&&H.devMode===j.devMode&&H.language===j.language&&F.equals(H.translations,j.translations)}}e.ExtensionScannerInput=L;let $=class extends E.Disposable{constructor(H,j,V,J,_){super(),this.f=H,this.g=j,this.h=V,this.i=J,this.j=_}async scanExtensions(H){const j=H.profile?await this.l(H):await this.k(H);let V={};if(H.excludeObsolete&&H.type===1)try{const J=(await this.i.readFile(this.f)).value.toString();V=JSON.parse(J)}catch{}return(0,f.isEmptyObject)(V)?j:j.filter(J=>!V[w.ExtensionKey.create(J).toString()])}async k(H){const j=await this.i.resolve(H.location);if(!j.children?.length)return[];const V=await Promise.all(j.children.map(async J=>{if(!J.isDirectory||H.type===1&&(0,y.basename)(J.resource).indexOf(".")===0)return null;const _=new L(J.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(_)}));return(0,k.coalesce)(V).sort((J,_)=>J.location.path<_.location.path?-1:1)}async l(H){let j=await this.m(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.h.extUri.isEqual(H.location,H.applicationExtensionslocation)){j=j.filter(J=>!J.metadata?.isApplicationScoped);const V=await this.m(H.applicationExtensionslocation,J=>!!J.metadata?.isApplicationScoped,H);j.push(...V)}return j}async m(H,j,V){const J=await this.g.scanProfileExtensions(H,V.profileScanOptions);if(!J.length)return[];const _=await Promise.all(J.map(async re=>{if(j(re)){const te=new L(re.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(te,re.metadata)}return null}));return(0,k.coalesce)(_)}async scanOneOrMultipleExtensions(H){try{if(await this.i.exists((0,y.joinPath)(H.location,"package.json"))){const j=await this.scanExtension(H);return j?[j]:[]}else return await this.scanExtensions(H)}catch(j){return this.j.error(`Error scanning extensions at ${H.location.path}:`,(0,O.getErrorMessage)(j)),[]}}async scanExtension(H,j){try{let V=await this.scanExtensionManifest(H.location);if(V){V.publisher||(V.publisher=R.UNDEFINED_PUBLISHER),j=j??V.__metadata,delete V.__metadata;const J=(0,w.getGalleryExtensionId)(V.publisher,V.name),_=j?.id?{id:J,uuid:j.id}:{id:J},re=j?.isSystem?0:H.type,te=re===0||!!j?.isBuiltin;N.ImplicitActivationEvents.updateManifest(V),V=await this.n(H.location,V,L.createNlsConfiguration(H));const U={type:re,identifier:_,manifest:V,location:H.location,isBuiltin:te,targetPlatform:j?.targetPlatform??"undefined",metadata:j,isValid:!0,validations:[]};return H.validate?this.validate(U,H):U}}catch(V){H.type!==0&&this.j.error(V)}return null}validate(H,j){let V=!0;const J=(0,i.validateExtensionManifest)(j.productVersion,j.productDate,j.location,H.manifest,H.isBuiltin);for(const[_,re]of J)_===S.default.Error&&(V=!1,this.j.error(this.t(j.location,re)));return H.isValid=V,H.validations=J,H}async scanExtensionManifest(H){const j=(0,y.joinPath)(H,"package.json");let V;try{V=(await this.i.readFile(j)).value.toString()}catch(_){return(0,o.toFileOperationResult)(_)!==1&&this.j.error(this.t(H,(0,d.localize)(0,null,j.path,_.message))),null}let J;try{J=JSON.parse(V)}catch{const re=[];(0,P.parse)(V,re);for(const te of re)this.j.error(this.t(H,(0,d.localize)(1,null,j.path,te.offset,te.length,(0,I.getParseErrorMessage)(te.error))));return null}return(0,P.getNodeType)(J)!=="object"?(this.j.error(this.t(H,(0,d.localize)(2,null,j.path))),null):J}async n(H,j,V){const J=await this.p(H,j,V);if(J)try{const _=[],re=await this.r(J.default,_);if(_.length>0)return _.forEach(U=>{this.j.error(this.t(H,(0,d.localize)(3,null,J.default?.path,(0,I.getParseErrorMessage)(U.error))))}),j;if((0,P.getNodeType)(J)!=="object")return this.j.error(this.t(H,(0,d.localize)(4,null,J.default?.path))),j;const te=J.values||Object.create(null);return(0,A.localizeManifest)(j,te,re)}catch{}return j}async p(H,j,V){const J=(0,y.joinPath)(H,"package.nls.json"),_=(B,W)=>{W.forEach(q=>{this.j.error(this.t(H,(0,d.localize)(5,null,B?.path,(0,I.getParseErrorMessage)(q.error))))})},re=B=>{this.j.error(this.t(H,(0,d.localize)(6,null,B?.path)))},te=`${j.publisher}.${j.name}`,U=V.translations[te];if(U)try{const B=c.URI.file(U),W=(await this.i.readFile(B)).value.toString(),q=[],Y=(0,P.parse)(W,q);return q.length>0?(_(B,q),{values:void 0,default:J}):(0,P.getNodeType)(Y)!=="object"?(re(B),{values:void 0,default:J}):{values:Y.contents?Y.contents.package:void 0,default:J}}catch{return{values:void 0,default:J}}else{if(!await this.i.exists(J))return;let W;try{W=await this.s(H,V)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const q=(await this.i.readFile(W.localized)).value.toString(),Y=[],ee=(0,P.parse)(q,Y);return Y.length>0?(_(W.localized,Y),{values:void 0,default:W.original}):(0,P.getNodeType)(ee)!=="object"?(re(W.localized),{values:void 0,default:W.original}):{values:ee,default:W.original}}catch{return{values:void 0,default:W.original}}}}async r(H,j){if(H)try{const V=(await this.i.readFile(H)).value.toString();return(0,P.parse)(V,j)}catch{}}s(H,j){return new Promise((V,J)=>{const _=re=>{const te=(0,y.joinPath)(H,`package.nls.${re}.json`);this.i.exists(te).then(U=>{U&&V({localized:te,original:(0,y.joinPath)(H,"package.nls.json")});const B=re.lastIndexOf("-");B===-1?V({localized:(0,y.joinPath)(H,"package.nls.json"),original:null}):(re=re.substring(0,B),_(re))})};if(j.devMode||j.pseudo||!j.language)return V({localized:(0,y.joinPath)(H,"package.nls.json"),original:null});_(j.language)})}t(H,j){return`[${H.path}]: ${j}`}};$=ye([G(1,h.IExtensionsProfileScannerService),G(2,v.IUriIdentityService),G(3,o.IFileService),G(4,n.ILogService)],$);let z=class extends ${constructor(H,j,V,J,_,re){super(j,V,J,_,re),this.y=H,this.v=this.B(new T.ThrottledDelayer(3e3)),this.w=this.B(new a.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(H){const j=await this.z();if(this.u=H,j&&j.input&&L.equals(j.input,this.u))return this.j.debug("Using cached extensions scan result",H.location.toString()),this.v.trigger(()=>this.D()),j.result.map(J=>(J.location=c.URI.revive(J.location),J));const V=await super.scanExtensions(H);return await this.C({input:H,result:V}),V}async z(){try{const H=await this.i.readFile(this.y),j=JSON.parse(H.value.toString());return{result:j.result,input:(0,r.revive)(j.input)}}catch(H){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,O.getErrorMessage)(H))}return null}async C(H){try{await this.i.writeFile(this.y,l.VSBuffer.fromString(JSON.stringify(H)))}catch(j){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,O.getErrorMessage)(j))}}async D(){if(!this.u)return;const H=await this.z();if(!H)return;const j=H.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!D.equals(V,j))try{await this.i.del(this.y),this.w.fire()}catch(J){this.j.error(J)}}};z=ye([G(2,h.IExtensionsProfileScannerService),G(3,v.IUriIdentityService),G(4,o.IFileService),G(5,n.ILogService)],z);function x(ie,H){const j=(0,w.getExtensionId)(ie.manifest.publisher,ie.manifest.name);return{id:j,identifier:new R.ExtensionIdentifier(j),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:H,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}e.toExtensionDescription=x;class X extends M{constructor(H,j,V,J,_,re,te,U,B,W,q,Y){super(H,j,(0,y.joinPath)(V,".vscode-oss-dev","extensions","control.json"),(0,y.joinPath)(J,R.MANIFEST_CACHE_FOLDER),_,re,te,U,B,W,q,Y),this.M=(async()=>{if(m.translationsConfigFile)try{const ee=await this.r.readFile(c.URI.file(m.translationsConfigFile));return JSON.parse(ee.value.toString())}catch{}return Object.create(null)})()}f(H){return this.M}}e.NativeExtensionsScannerService=X}),define(oe[270],ae([0,1,8,18,29,19,51,14,15,11]),function(Q,e,k,T,D,l,O,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let C=class extends O.AbstractExtensionsProfileScannerService{constructor(m,y,u,S,f,c){super(E.URI.file(m.extensionsPath),y,u,S,f,c)}};C=ye([G(0,I.INativeEnvironmentService),G(1,P.IFileService),G(2,T.IUserDataProfilesService),G(3,D.IUriIdentityService),G(4,l.ITelemetryService),G(5,k.ILogService)],C),e.ExtensionsProfileScannerService=C}),define(oe[271],ae([0,1,50,6,38,3,2,26,13,28,8,18]),function(Q,e,k,T,D,l,O,P,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends O.Disposable{constructor(u,S){super(),this.b=u,this.f=S,this.a=new T.Limiter(5)}async postUninstall(u){const S=this.g(u,"uninstall");return S&&(this.f.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(S.script,"uninstall",S.args,!0,u).then(()=>this.f.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),f=>this.f.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${f}`)))),E.Promises.rm(this.j(u)).then(void 0,f=>this.f.error("Error while removing extension storage path",f))}g(u,S){const f=`vscode:${S}`;if(u.location.scheme===P.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[f]=="string"){const c=u.manifest.scripts[f].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(u.identifier.id,u.manifest.version,`${f} should be a node script`),null):{script:(0,I.join)(u.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(u,S,f,c,d){return new Promise((p,w)=>{const R=this.i(u,S,f,d);let i;const o=t=>{i&&(clearTimeout(i),i=null),t?w(t):p(void 0)};R.on("error",t=>{o((0,D.toErrorMessage)(t)||"Unknown")}),R.on("exit",(t,n)=>{o(t?`post-${S} process exited with code ${t}`:void 0)}),c&&(i=setTimeout(()=>{i=null,R.kill(),w("timed out")},5e3))})}i(u,S,f,c){const d={silent:!0,execArgv:void 0},p=(0,k.fork)(u,[`--type=extension-post-${S}`,...f],d);p.stdout.setEncoding("utf8"),p.stderr.setEncoding("utf8");const w=l.Event.fromNodeEventEmitter(p.stdout,"data"),R=l.Event.fromNodeEventEmitter(p.stderr,"data");w(t=>this.f.info(c.identifier.id,c.manifest.version,`post-${S}`,t)),R(t=>this.f.error(c.identifier.id,c.manifest.version,`post-${S}`,t));const i=l.Event.any(l.Event.map(w,t=>({data:`%c${t}`,format:[""]})),l.Event.map(R,t=>({data:`%c${t}`,format:["color: red"]})));return l.Event.debounce(i,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(c.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),p}j(u){return(0,I.join)(this.b.defaultProfile.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};m=ye([G(0,b.IUserDataProfilesService),G(1,C.ILogService)],m),e.ExtensionsLifecycle=m}),define(oe[272],ae([0,1,11,15,51,79,14,5,8,23,29,18]),function(Q,e,k,T,D,l,O,P,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let m=class extends l.NativeExtensionsScannerService{constructor(u,S,f,c,d,p,w,R){super(k.URI.file(d.builtinExtensionsPath),k.URI.file(d.extensionsPath),d.userHome,k.URI.file(d.userDataPath),u,S,f,c,d,p,w,R)}};m=ye([G(0,b.IUserDataProfilesService),G(1,D.IExtensionsProfileScannerService),G(2,O.IFileService),G(3,I.ILogService),G(4,T.INativeEnvironmentService),G(5,E.IProductService),G(6,C.IUriIdentityService),G(7,P.IInstantiationService)],m),e.ExtensionsScannerService=m}),define(oe[20],ae([0,1,6,3,2,102,12,69,5,18]),function(Q,e,k,T,D,l,O,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,I.createDecorator)("storageService");var C;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(C=e.WillSaveStateReason||(e.WillSaveStateReason={}));var b;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(b=e.StorageScope||(e.StorageScope={}));var m;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));function y(d){const p=d.get(e.TARGET_KEY);if(p)try{return JSON.parse(p)}catch{}return Object.create(null)}e.loadKeyTargets=y;class u extends D.Disposable{constructor(p={flushInterval:u.a}){super(),this.j=p,this.b=this.B(new T.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new T.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new T.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new k.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new D.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,k.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,D.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,l.mark)("code/willInitStorage");try{await this.J()}finally{(0,l.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(p,w){if(w===e.TARGET_KEY){switch(p){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:p})}else this.b.fire({scope:p,key:w,target:this.F(p)[w]})}r(p){this.f.fire({reason:p})}get(p,w,R){return this.L(w)?.get(p,R)}getBoolean(p,w,R){return this.L(w)?.getBoolean(p,R)}getNumber(p,w,R){return this.L(w)?.getNumber(p,R)}store(p,w,R,i){if((0,O.isUndefinedOrNull)(w)){this.remove(p,R);return}this.t(()=>{this.u(p,R,i),this.L(R)?.set(p,w)})}remove(p,w){this.t(()=>{this.u(p,w,void 0),this.L(w)?.delete(p)})}t(p){this.b.pause(),this.c.pause();try{p()}finally{this.b.resume(),this.c.resume()}}keys(p,w){const R=[],i=this.F(p);for(const o of Object.keys(i))i[o]===w&&R.push(o);return R}u(p,w,R){const i=this.F(w);typeof R=="number"?i[p]!==R&&(i[p]=R,this.L(w)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[p]=="number"&&(delete i[p],this.L(w)?.set(e.TARGET_KEY,JSON.stringify(i)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(p){switch(p){case-1:return this.D;case 0:return this.z;default:return this.w}}G(p){const w=this.L(p);return w?y(w):Object.create(null)}isNew(p){return this.getBoolean(e.IS_NEW_KEY,p)===!0}async flush(p=C.NONE){this.f.fire({reason:p});const w=this.L(-1),R=this.L(0),i=this.L(1);switch(p){case C.NONE:await k.Promises.settled([w?.whenFlushed()??Promise.resolve(),R?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await k.Promises.settled([w?.flush(0)??Promise.resolve(),R?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const p=this.L(-1)?.items??new Map,w=this.L(0)?.items??new Map,R=this.L(1)?.items??new Map;return c(p,w,R,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(p,w){return this.r(C.NONE),(0,E.isUserDataProfile)(p)?this.N(p,w):this.O(p,w)}H(p,w){return!(p.id===w.id||S(w)&&S(p))}I(p,w,R,i){this.t(()=>{if(i)for(const[o,t]of p)w.set(o,t);else{const o=new Set;for(const[t,n]of p)o.add(t),w.get(t)!==n&&this.n(R,t);for(const[t]of w.items)o.has(t)||this.n(R,t)}})}}e.AbstractStorageService=u,u.a=60*1e3;function S(d){return d.isDefault||!!d.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=S;class f extends u{constructor(){super(),this.p=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(p=>this.n(1,p))),this.B(this.P.onDidChangeStorage(p=>this.n(0,p))),this.B(this.p.onDidChangeStorage(p=>this.n(-1,p)))}L(p){switch(p){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(p){switch(p){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(p){return!1}}e.InMemoryStorageService=f;async function c(d,p,w,R,i,o){const t=N=>{try{return JSON.parse(N)}catch{return N}},n=new Map,s=new Map;d.forEach((N,F)=>{n.set(F,N),s.set(F,t(N))});const a=new Map,r=new Map;p.forEach((N,F)=>{a.set(F,N),r.set(F,t(N))});const h=new Map,g=new Map;w.forEach((N,F)=>{h.set(F,N),g.set(F,t(N))}),console.group(R!==i?`Storage: Application (path: ${R})`:`Storage: Application & Profile (path: ${R}, default profile)`);const v=[];if(n.forEach((N,F)=>{v.push({key:F,value:N})}),console.table(v),console.groupEnd(),console.log(s),R!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const N=[];a.forEach((F,M)=>{N.push({key:M,value:F})}),console.table(N),console.groupEnd(),console.log(r)}console.group(`Storage: Workspace (path: ${o})`);const A=[];h.forEach((N,F)=>{A.push({key:F,value:N})}),console.table(A),console.groupEnd(),console.log(g)}e.logStorage=c}),define(oe[118],ae([0,1,3,2,12,30,33,20]),function(Q,e,k,T,D,l,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let I=class extends T.Disposable{constructor(b,m){super(),this.a=new k.Emitter,this.onDidChangeEnablement=this.a.event,this.b=this.B(new E(b)),this.B(this.b.onDidChange(y=>this.a.fire({extensions:y,source:"storage"}))),this.B(m.onDidInstallExtensions(y=>y.forEach(({local:u,operation:S})=>{u&&S===4&&this.f(u.identifier)})))}async enableExtension(b,m){return this.f(b)?(this.a.fire({extensions:[b],source:m}),!0):!1}async disableExtension(b,m){return this.c(b)?(this.a.fire({extensions:[b],source:m}),!0):!1}getDisabledExtensions(){return this.h(l.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(b){const m=this.getDisabledExtensions();return m.every(y=>!(0,O.areSameExtensions)(y,b))?(m.push(b),this.g(m),!0):!1}f(b){const m=this.getDisabledExtensions();for(let y=0;y<m.length;y++){const u=m[y];if((0,O.areSameExtensions)(u,b))return m.splice(y,1),this.g(m),!0}return!1}g(b){this.i(l.DISABLED_EXTENSIONS_STORAGE_PATH,b)}h(b){return this.b.get(b,0)}i(b,m){this.b.set(b,m,0)}};I=ye([G(0,P.IStorageService),G(1,l.IExtensionManagementService)],I),e.GlobalExtensionEnablementService=I;class E extends T.Disposable{constructor(b){super(),this.c=b,this.a=Object.create(null),this.b=this.B(new k.Emitter),this.onDidChange=this.b.event,this.B(b.onDidChangeValue(m=>this.f(m)))}get(b,m){let y;return m===0?((0,D.isUndefinedOrNull)(this.a[b])&&(this.a[b]=this.g(b,m)),y=this.a[b]):y=this.g(b,m),JSON.parse(y)}set(b,m,y){const u=JSON.stringify(m.map(({id:f,uuid:c})=>({id:f,uuid:c})));this.g(b,y)!==u&&(y===0&&(m.length?this.a[b]=u:delete this.a[b]),this.h(b,m.length?u:void 0,y))}f(b){if(b.scope===0&&!(0,D.isUndefinedOrNull)(this.a[b.key])&&this.g(b.key,b.scope)!==this.a[b.key]){const y=this.get(b.key,b.scope);delete this.a[b.key];const u=this.get(b.key,b.scope),S=y.filter(c=>!u.some(d=>(0,O.areSameExtensions)(c,d))),f=u.filter(c=>!y.some(d=>(0,O.areSameExtensions)(d,c)));(S.length||f.length)&&this.b.fire([...S,...f])}}g(b,m){return this.c.get(b,m,"[]")}h(b,m,y){m?this.c.store(b,m,y,1):this.c.remove(b,y)}}e.StorageManager=E}),define(oe[273],ae([0,1,21,25,9,4,36,12,11,16,15,30,33,70,14,8,23,60,241,20,19]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u,S,f,c,d,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const R=l.isWeb?"web":(0,b.getTargetPlatform)(l.platform,O.arch);var i;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function o(...U){return String(U.reduce((B,W)=>B|W,0))}var t;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const n={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},r={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class h{constructor(B=r){this.d=B}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(B,W=this.d.pageSize){return new h({...this.d,pageNumber:B,pageSize:W})}withFilter(B,...W){const q=[...this.d.criteria,...W.length?W.map(Y=>({filterType:B,value:Y})):[{filterType:B}]];return new h({...this.d,criteria:q})}withSortBy(B){return new h({...this.d,sortBy:B})}withSortOrder(B){return new h({...this.d,sortOrder:B})}withFlags(...B){return new h({...this.d,flags:B.reduce((W,q)=>W|q,0)})}withAssetTypes(...B){return new h({...this.d,assetTypes:B})}withSource(B){return new h({...this.d,source:B})}get raw(){const{criteria:B,pageNumber:W,pageSize:q,sortBy:Y,sortOrder:ee,flags:K,assetTypes:Z}=this.d;return{filters:[{criteria:B,pageNumber:W,pageSize:q,sortBy:Y,sortOrder:ee}],assetTypes:Z,flags:K}}get searchText(){const B=this.d.criteria.filter(W=>W.filterType===t.SearchText)[0];return B&&B.value?B.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(B=>String(B.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function g(U,B){const W=(U||[]).filter(q=>q.statisticName===B)[0];return W?W.value:0}function v(U){const B="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(q=>q.assetType.indexOf(B)===0).reduce((q,Y)=>{const ee=F(U,Y.assetType);return ee&&q.push([Y.assetType.substring(B.length),ee]),q},[])}function A(U){if(U.properties){const B=U.properties.filter(Y=>Y.key===n.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),q=B.filter(Y=>W.test(Y.value))[0];return q?{uri:q.value,fallbackUri:q.value}:null}return F(U,n.Repository)}function N(U){return{uri:`${U.fallbackAssetUri}/${n.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${n.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function F(U,B){return U.files.filter(q=>q.assetType===B)[0]?{uri:`${U.assetUri}/${B}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${B}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function M(U,B){const W=U.properties?U.properties.filter(Y=>Y.key===B):[],q=W.length>0&&W[0].value;return q?q.split(",").map(Y=>(0,m.adoptToGalleryExtensionId)(Y)):[]}function L(U){const B=U.properties?U.properties.filter(W=>W.key===s.Engine):[];return B.length>0&&B[0].value||""}function $(U){const B=U.properties?U.properties.filter(W=>W.key===s.PreRelease):[];return B.length>0&&B[0].value==="true"}function z(U){const B=U.properties?U.properties.filter(q=>q.key===s.LocalizedLanguages):[],W=B.length>0&&B[0].value||"";return W?W.split(","):[]}function x(U){return U.properties?.find(B=>B.key===s.SponsorLink)?.value}function X(U){return U.indexOf("preview")!==-1}function ie(U){return U.targetPlatform?(0,b.toTargetPlatform)(U.targetPlatform):"undefined"}function H(U){const B=(0,k.distinct)(U.versions.map(ie)),W=!!U.tags?.includes(b.WEB_EXTENSION_TAG),q=B.indexOf("web");return W?q===-1&&B.push("web"):q!==-1&&B.splice(q,1),B}function j(U,B){const W=(0,b.getFallbackTargetPlarforms)(B);for(let q=0;q<U.length;q++){const Y=U[q];if(Y.version===U[q-1]?.version){let ee=q;const K=ie(Y);if(K===B)for(;ee>0&&U[ee-1].version===Y.version;)ee--;else if(W.includes(K))for(;ee>0&&U[ee-1].version===Y.version&&ie(U[ee-1])!==B;)ee--;ee!==q&&(U.splice(q,1),U.splice(ee,0,Y))}}return U}e.sortExtensionVersions=j;function V(U,B,W){U.telemetryData={index:B,querySource:W}}function J(U,B,W){const q=U.versions[0],Y={manifest:F(B,n.Manifest),readme:F(B,n.Details),changelog:F(B,n.Changelog),license:F(B,n.License),repository:A(B),download:N(B),icon:F(B,n.Icon),signature:F(B,n.Signature),coreTranslations:v(B)};return{identifier:{id:(0,m.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:B.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,publisherSponsorLink:x(q),description:U.shortDescription||"",installCount:g(U.statistics,"install"),rating:g(U.statistics,"averagerating"),ratingCount:g(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:W,assets:Y,properties:{dependencies:M(B,s.Dependency),extensionPack:M(B,s.ExtensionPack),engine:L(B),localizedLanguages:z(B),targetPlatform:ie(B),isPreReleaseVersion:$(B)},hasPreReleaseVersion:$(q),hasReleaseVersion:!0,preview:X(U.flags),isSigned:!!Y.signature}}let _=class{constructor(B,W,q,Y,ee,K,Z,se){this.k=W,this.l=q,this.n=Y,this.o=ee,this.q=K,this.u=Z,this.w=se;const le=Z.extensionsGallery,ue=le?.servicePPEUrl&&se.getValue("_extensionsGallery.enablePPE");this.d=ue?le.servicePPEUrl:le?.serviceUrl,this.g=ue?void 0:le?.searchUrl,this.h=le?.controlUrl,this.j=(0,d.resolveMarketplaceHeaders)(Z.version,Z,this.n,this.w,this.q,B,this.o)}x(B=""){return`${this.d}${B}`}isEnabled(){return!!this.d}async getExtensions(B,W,q){const Y=T.CancellationToken.isCancellationToken(W)?{}:W,ee=T.CancellationToken.isCancellationToken(W)?W:q,K=[],Z=[],se=[],le=[];let ue=!0;for(const be of B){be.uuid?Z.push(be.uuid):K.push(be.id);const Ee=!!(be.version||be.preRelease);se.push({id:be.id,uuid:be.uuid,includePreRelease:Ee}),be.version&&le.push({id:be.id,uuid:be.uuid,version:be.version}),ue=ue&&!!be.hasPreRelease&&!Ee}if(!Z.length&&!K.length)return[];let pe=new h().withPage(1,B.length);Z.length&&(pe=pe.withFilter(t.ExtensionId,...Z)),K.length&&(pe=pe.withFilter(t.ExtensionName,...K)),(Y.queryAllVersions||ue)&&(pe=pe.withFlags(pe.flags,i.IncludeVersions)),Y.source&&(pe=pe.withSource(Y.source));const{extensions:ve}=await this.z(pe,{targetPlatform:Y.targetPlatform??R,includePreRelease:se,versions:le,compatible:!!Y.compatible},ee);return Y.source&&ve.forEach((be,Ee)=>V(be,Ee,Y.source)),ve}async getCompatibleExtension(B,W,q){if((0,b.isNotWebExtensionInWebTargetPlatform)(B.allTargetPlatforms,q))return null;if(await this.isExtensionCompatible(B,W,q))return B;const Y=new h().withFlags(i.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,B.identifier.uuid),{extensions:ee}=await this.z(Y,{targetPlatform:q,compatible:!0,includePreRelease:W},T.CancellationToken.None);return ee[0]||null}async isExtensionCompatible(B,W,q){if(!(0,b.isTargetPlatformCompatible)(B.properties.targetPlatform,B.allTargetPlatforms,q)||!W&&B.properties.isPreReleaseVersion)return!1;let Y=B.properties.engine;if(!Y){const ee=await this.getManifest(B,T.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");Y=ee.engines.vscode}return(0,y.isEngineValid)(Y,this.u.version,this.u.date)}async y(B,W,q,Y,ee){if(!(0,b.isTargetPlatformCompatible)(ie(B),Y,ee)||W!=="any"&&$(B)!==(W==="prerelease"))return!1;if(q)try{const K=await this.E(B);if(!(0,y.isEngineValid)(K,this.u.version,this.u.date))return!1}catch(K){return this.l.error(`Error while getting the engine for the version ${B.version}.`,(0,D.getErrorMessage)(K)),!1}return!0}async query(B,W){let q=B.text||"";const Y=B.pageSize??50;let ee=new h().withPage(1,Y);q?(q=q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,pe,ve)=>(ee=ee.withFilter(t.Category,ve||pe),"")),q=q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,pe,ve)=>(ee=ee.withFilter(t.Tag,ve||pe),"")),q=q.replace(/\bfeatured(\s+|\b|$)/g,()=>(ee=ee.withFilter(t.Featured),"")),q=q.trim(),q&&(q=q.length<200?q:q.substring(0,200),ee=ee.withFilter(t.SearchText,q)),ee=ee.withSortBy(0)):B.ids?ee=ee.withFilter(t.ExtensionId,...B.ids):B.names?ee=ee.withFilter(t.ExtensionName,...B.names):ee=ee.withSortBy(4),typeof B.sortBy=="number"&&(ee=ee.withSortBy(B.sortBy)),typeof B.sortOrder=="number"&&(ee=ee.withSortOrder(B.sortOrder)),B.source&&(ee=ee.withSource(B.source));const K=async(ue,pe)=>{const{extensions:ve,total:be}=await this.z(ue,{targetPlatform:R,compatible:!1,includePreRelease:!!B.includePreRelease},pe);return ve.forEach((Ee,Oe)=>V(Ee,(ue.pageNumber-1)*ue.pageSize+Oe,B.source)),{extensions:ve,total:be}},{extensions:Z,total:se}=await K(ee,W),le=async(ue,pe)=>{if(pe.isCancellationRequested)throw new D.CancellationError;const{extensions:ve}=await K(ee.withPage(ue+1),pe);return ve};return{firstPage:Z,total:se,pageSize:ee.pageSize,getPage:le}}async z(B,W,q){const Y=B.flags;!!(B.flags&i.IncludeLatestVersionOnly)&&!!(B.flags&i.IncludeVersions)&&(B=B.withFlags(B.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(B.flags&i.IncludeLatestVersionOnly)&&!(B.flags&i.IncludeVersions)&&(B=B.withFlags(B.flags,i.IncludeLatestVersionOnly)),W.versions?.length&&(B=B.withFlags(B.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),B=B.withFlags(B.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:ee,total:K}=await this.B(B,q);if(!(B.flags&i.IncludeLatestVersionOnly)){const ue=[];for(const pe of ee){const ve=await this.A(pe,W);ve&&ue.push(ve)}return{extensions:ue,total:K}}const se=[],le=new Map;for(let ue=0;ue<ee.length;ue++){const pe=ee[ue],ve={id:(0,m.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},be=(0,P.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(Oe=>(0,m.areSameExtensions)(Oe,ve))?.includePreRelease;if(W.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(H(pe),W.targetPlatform))continue;const Ee=await this.A(pe,W);!Ee||Ee.properties.isPreReleaseVersion&&(!be||!Ee.hasReleaseVersion)||!Ee.properties.isPreReleaseVersion&&Ee.properties.targetPlatform!==W.targetPlatform&&Ee.hasPreReleaseVersion?le.set(pe.extensionId,ue):se.push([ue,Ee])}if(le.size){const ue=new Date().getTime(),pe=new h().withFlags(Y&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,le.size).withFilter(t.ExtensionId,...le.keys()),{extensions:ve}=await this.z(pe,W,q);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ue,count:le.size});for(const be of ve){const Ee=le.get(be.identifier.uuid);se.push([Ee,be])}}return{extensions:se.sort((ue,pe)=>ue[0]-pe[0]).map(([,ue])=>ue),total:K}}async A(B,W){const q={id:(0,m.getGalleryExtensionId)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},Y=W.versions?.find(se=>(0,m.areSameExtensions)(se,q))?.version,ee=(0,P.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(se=>(0,m.areSameExtensions)(se,q))?.includePreRelease,K=H(B),Z=j(B.versions,W.targetPlatform);if(W.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(K,W.targetPlatform))return null;for(let se=0;se<Z.length;se++){const le=Z[se];if(!(Y&&le.version!==Y)){if(await this.y(le,ee?"any":"release",W.compatible,K,W.targetPlatform))return J(B,le,K);if(Y&&le.version===Y)return null}}return Y||W.compatible?null:J(B,B.versions[0],K)}async B(B,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");B=B.withFlags(B.flags,i.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,o(i.Unpublished));const q=await this.j,Y=JSON.stringify(B.raw),ee={...q,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Y.length)},K=new Date().getTime();let Z,se,le=0;try{if(Z=await this.k.request({type:"POST",url:this.g&&B.criteria.some(pe=>pe.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:Y,headers:ee},W),Z.res.statusCode&&Z.res.statusCode>=400&&Z.res.statusCode<500)return{galleryExtensions:[],total:le};const ue=await(0,c.asJson)(Z);if(ue){const pe=ue.results[0],ve=pe.extensions,be=pe.resultMetadata&&pe.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return le=be&&be.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:ve,total:le}}return{galleryExtensions:[],total:le}}catch(ue){throw se=ue,ue}finally{this.o.publicLog2("galleryService:query",{...B.telemetryData,requestBodySize:String(Y.length),duration:new Date().getTime()-K,success:!!Z&&(0,c.isSuccess)(Z),responseBodySize:Z?.res.headers["Content-Length"],statusCode:Z?String(Z.res.statusCode):void 0,errorCode:se?(0,D.isCancellationError)(se)?"canceled":(0,D.getErrorMessage)(se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(le)})}}async reportStatistic(B,W,q,Y){if(!this.isEnabled())return;const ee=l.isWeb?this.x(`/itemName/${B}.${W}/version/${q}/statType/${Y==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${B}/extensions/${W}/${q}/stats?statType=${Y}`),K=l.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",se={...await this.j,Accept:K};try{await this.k.request({type:"POST",url:ee,headers:se},T.CancellationToken.None)}catch{}}async download(B,W,q){this.l.trace("ExtensionGalleryService#download",B.identifier.id);const Y=(0,m.getGalleryExtensionTelemetryData)(B),ee=new Date().getTime(),K=ue=>this.o.publicLog("galleryService:downloadVSIX",{...Y,duration:ue}),Z=q===2?"install":q===3?"update":"",se=Z?{uri:`${B.assets.download.uri}${I.URI.parse(B.assets.download.uri).query?"&":"?"}${Z}=true`,fallbackUri:`${B.assets.download.fallbackUri}${I.URI.parse(B.assets.download.fallbackUri).query?"&":"?"}${Z}=true`}:B.assets.download,le=await this.D(se);await this.q.writeFile(W,le.stream),K(new Date().getTime()-ee)}async downloadSignatureArchive(B,W){if(!B.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",B.identifier.id);const q=await this.D(B.assets.signature);await this.q.writeFile(W,q.stream)}async getReadme(B,W){if(B.assets.readme){const q=await this.D(B.assets.readme,{},W);return await(0,c.asTextOrError)(q)||""}return""}async getManifest(B,W){if(B.assets.manifest){const q=await this.D(B.assets.manifest,{},W),Y=await(0,c.asTextOrError)(q);return Y?JSON.parse(Y):null}return null}async C(B,W){const q=F(B,n.Manifest);if(!q)throw new Error("Manifest was not found");const Y={"Accept-Encoding":"gzip"},ee=await this.D(q,{headers:Y});return await(0,c.asJson)(ee)}async getCoreTranslation(B,W){const q=B.assets.coreTranslations.filter(Y=>Y[0]===W.toUpperCase())[0];if(q){const Y=await this.D(q[1]),ee=await(0,c.asTextOrError)(Y);return ee?JSON.parse(ee):null}return null}async getChangelog(B,W){if(B.assets.changelog){const q=await this.D(B.assets.changelog,{},W);return await(0,c.asTextOrError)(q)||""}return""}async getAllCompatibleVersions(B,W,q){let Y=new h().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);B.identifier.uuid?Y=Y.withFilter(t.ExtensionId,B.identifier.uuid):Y=Y.withFilter(t.ExtensionName,B.identifier.id);const{galleryExtensions:ee}=await this.B(Y,T.CancellationToken.None);if(!ee.length)return[];const K=H(ee[0]);if((0,b.isNotWebExtensionInWebTargetPlatform)(K,q))return[];const Z=[];await Promise.all(ee[0].versions.map(async ue=>{try{await this.y(ue,W?"any":"release",!0,K,q)&&Z.push(ue)}catch{}}));const se=[],le=new Set;for(const ue of j(Z,q))le.has(ue.version)||(le.add(ue.version),se.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:$(ue)}));return se}async D(B,W={},q=T.CancellationToken.None){const Y=await this.j,ee={type:"GET"},K={...Y,...W.headers||{}};W={...W,...ee,headers:K};const Z=B.uri,se=B.fallbackUri,le={...W,url:Z};try{const ue=await this.k.request(le,q);if(ue.res.statusCode===200)return ue;const pe=await(0,c.asTextOrError)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${pe}`)}catch(ue){if((0,D.isCancellationError)(ue))throw ue;const pe=(0,D.getErrorMessage)(ue);this.o.publicLog2("galleryService:cdnFallback",{url:Z,message:pe});const ve={...W,url:se};return this.k.request(ve,q)}}async E(B){let W=L(B);if(!W){const q=await this.C(B,T.CancellationToken.None);if(!q)throw new Error("Manifest was not found");W=q.engines.vscode}return W}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const B=await this.k.request({type:"GET",url:this.h},T.CancellationToken.None);if(B.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,c.asJson)(B),q=[],Y={};if(W){for(const ee of W.malicious)q.push({id:ee});if(W.migrateToPreRelease)for(const[ee,K]of Object.entries(W.migrateToPreRelease))(!K.engine||(0,y.isEngineValid)(K.engine,this.u.version,this.u.date))&&(Y[ee.toLowerCase()]={disallowInstall:!0,extension:{id:K.id,displayName:K.displayName,autoMigrate:{storage:!!K.migrateStorage},preRelease:!0}});if(W.deprecated)for(const[ee,K]of Object.entries(W.deprecated))K&&(Y[ee.toLowerCase()]=(0,P.isBoolean)(K)?{}:K)}return{malicious:q,deprecated:Y}}};_=ye([G(1,c.IRequestService),G(2,S.ILogService),G(3,C.IEnvironmentService),G(4,w.ITelemetryService),G(5,u.IFileService),G(6,f.IProductService),G(7,E.IConfigurationService)],_);let re=class extends _{constructor(B,W,q,Y,ee,K,Z,se){super(B,W,q,Y,ee,K,Z,se)}};re=ye([G(0,p.IStorageService),G(1,c.IRequestService),G(2,S.ILogService),G(3,C.IEnvironmentService),G(4,w.ITelemetryService),G(5,u.IFileService),G(6,f.IProductService),G(7,E.IConfigurationService)],re),e.ExtensionGalleryService=re;let te=class extends _{constructor(B,W,q,Y,ee,K,Z){super(void 0,B,W,q,Y,ee,K,Z)}};te=ye([G(0,c.IRequestService),G(1,S.ILogService),G(2,C.IEnvironmentService),G(3,w.ITelemetryService),G(4,u.IFileService),G(5,f.IProductService),G(6,E.IConfigurationService)],te),e.ExtensionGalleryServiceWithNoStorageService=te}),define(oe[80],ae([0,1,5,3,2,20,33,23,21,8,12]),function(Q,e,k,T,D,l,O,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,k.createDecorator)("IExtensionStorageService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let m=class Qe extends D.Disposable{static b(u){return`extensionKeys/${(0,O.adoptToGalleryExtensionId)(u.id)}@${u.version}`}static c(u){const S=b.exec(u);if(S&&S[1])return{id:S[1],version:S[2]}}static async removeOutdatedExtensionVersions(u,S){const f=await u.getInstalled(),c=[];for(const[d,p]of Qe.f(S)){const w=f.find(R=>(0,O.areSameExtensions)(R.identifier,{id:d}))?.manifest.version;for(const R of p)w!==R&&c.push(Qe.b({id:d,version:R}))}for(const d of c)S.remove(d,0)}static f(u){const S=new Map,f=u.keys(0,1);for(const c of f){const d=Qe.c(c);if(d){let p=S.get(d.id.toLowerCase());p||S.set(d.id.toLowerCase(),p=[]),p.push(d.version)}}return S}constructor(u,S,f){super(),this.i=u,this.j=S,this.k=f,this.g=this.B(new T.Emitter),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=Qe.f(u),this.B(this.i.onDidChangeValue(c=>this.l(c)))}l(u){if(u.scope!==0)return;if(this.h.has(u.key.toLowerCase())){this.g.fire();return}const S=Qe.c(u.key);if(S){if(this.i.get(u.key,0)===void 0)this.h.delete(S.id.toLowerCase());else{let f=this.h.get(S.id.toLowerCase());f||this.h.set(S.id.toLowerCase(),f=[]),f.push(S.version),this.g.fire()}return}}m(u){if((0,C.isString)(u))return u;const S=u.manifest?u.manifest.publisher:u.publisher,f=u.manifest?u.manifest.name:u.name;return(0,O.getExtensionId)(S,f)}getExtensionState(u,S){const f=this.m(u),c=this.getExtensionStateRaw(u,S);if(c)try{return JSON.parse(c)}catch(d){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${S}): ${d}`)}}getExtensionStateRaw(u,S){const f=this.m(u),c=this.i.get(f,S?0:1);return c&&c?.length>Qe.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${f}, global: ${S}): ${c.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),c}setExtensionState(u,S,f){const c=this.m(u);S===void 0?this.i.remove(c,f?0:1):this.i.store(c,JSON.stringify(S),f?0:1,1)}setKeysForSync(u,S){this.i.store(Qe.b(u),JSON.stringify(S),0,1)}getKeysForSync(u){const S=this.j.extensionSyncedKeys?.[u.id.toLowerCase()],f=this.i.get(Qe.b(u),0),c=f?JSON.parse(f):void 0;return c&&S?(0,I.distinct)([...c,...S]):c||S}addToMigrationList(u,S){if(u!==S){const f=this.n.filter(c=>!c.includes(u)&&!c.includes(S));f.push([u,S]),this.n=f}}getSourceExtensionToMigrate(u){const S=this.n.find(([,f])=>u===f);return S?S[0]:void 0}get n(){const u=this.i.get("extensionStorage.migrationList",-1,"[]");try{const S=JSON.parse(u);if(Array.isArray(S))return S}catch{}return[]}set n(u){u.length?this.i.store("extensionStorage.migrationList",JSON.stringify(u),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};m.a=512*1024,m=ye([G(0,l.IStorageService),G(1,P.IProductService),G(2,E.ILogService)],m),e.ExtensionStorageService=m}),define(oe[274],ae([0,1,21,6,3,13,4,36,11,161,15,30,33,217,99,14,58,23,20,19]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u,S,f,c,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const w="extensionTips/promptedExecutableTips",R="extensionTips/lastPromptedMediumImpExeTime";let i=class extends y.ExtensionTipsService{constructor(t,n,s,a,r,h,g,v){super(g,v),this.m=t,this.n=n,this.p=s,this.r=a,this.s=r,this.t=h,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,v.exeBasedExtensionTips&&Object.entries(v.exeBasedExtensionTips).forEach(([A,N])=>{const F=[],M=[],L=[];Object.entries(N.recommendations).forEach(([$,z])=>{z.important?N.important?F.push({extensionId:$,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):M.push({extensionId:$,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):L.push({extensionId:$,extensionName:z.name,isExtensionPack:!!z.isExtensionPack})}),F.length&&this.g.set(A,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:F}),M.length&&this.h.set(A,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:M}),L.length&&this.j.set(A,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:L})}),(0,T.timeout)(3e3).then(async()=>{await this.u(),this.w(),this.y()})}async getImportantExecutableBasedTips(){const t=await this.I(this.g),n=await this.I(this.h);return[...t,...n]}getOtherExecutableBasedTips(){return this.I(this.j)}async u(){const t=await this.I(this.g),n=await this.I(this.h),s=await this.p.getInstalled();this.k=this.v(t,s),this.l=this.v(n,s)}v(t,n){const s=new Map;t.forEach(v=>s.set(v.extensionId.toLowerCase(),v));const{installed:a,uninstalled:r}=this.H([...s.keys()],n);for(const v of a){const A=s.get(v);A&&this.n.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:v,exeName:A.exeName})}for(const v of r){const A=s.get(v);A&&this.n.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:v,exeName:A.exeName})}const h=this.F(),g=new Map;for(const v of r){const A=s.get(v);if(A&&(!h[A.exeName]||!h[A.exeName].includes(A.extensionId))){let N=g.get(A.exeName);N||(N=[],g.set(A.exeName,N)),N.push(A)}}return g}w(){if(this.k.size===0)return;const[t,n]=[...this.k.entries()][0];this.z(n).then(s=>{switch(s){case"reacted":this.G(n[0].exeName,n);break;case"ignored":this.k.delete(t);break;case"incompatibleWindow":{const a=D.Event.once(D.Event.latch(D.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(a(()=>this.w()));break}case"toomany":{const a=this.B((0,T.disposableTimeout)(()=>{a.dispose(),this.w()},36e5));break}}})}y(){if(this.l.size===0)return;const t=this.C(),n=Date.now()-t,s=7*24*60*60*1e3;if(n<s){const h=this.B((0,T.disposableTimeout)(()=>{h.dispose(),this.y()},s-n));return}const[a,r]=[...this.l.entries()][0];this.z(r).then(h=>{switch(h){case"reacted":{this.D(Date.now()),this.l.delete(a),this.G(r[0].exeName,r);const g=this.B((0,T.disposableTimeout)(()=>{g.dispose(),this.y()},s));break}case"ignored":this.l.delete(a),this.y();break;case"incompatibleWindow":{const g=D.Event.once(D.Event.latch(D.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(g(()=>this.y()));break}case"toomany":{const g=this.B((0,T.disposableTimeout)(()=>{g.dispose(),this.y()},36e5));break}}})}async z(t){const n=await this.p.getInstalled(1),s=t.filter(r=>!r.whenNotInstalled||r.whenNotInstalled.every(h=>n.every(g=>!(0,m.areSameExtensions)(g.identifier,{id:h})))).map(({extensionId:r})=>r.toLowerCase()),a=(0,E.localize)(0,null,t[0].exeFriendlyName);return this.t.promptImportantExtensionsInstallNotification(s,a,`@exe:"${t[0].exeName}"`,3)}C(){let t=this.r.getNumber(R,-1);return t||(t=Date.now(),this.D(t)),t}D(t){this.r.store(R,t,-1,1)}F(){return JSON.parse(this.r.get(w,-1,"{}"))}G(t,n){const s=this.F();s[t]=n.map(({extensionId:a})=>a.toLowerCase()),this.r.store(w,JSON.stringify(s),-1,0)}H(t,n){const s=[],a=[],r=n.reduce((h,g)=>(h.add(g.identifier.id.toLowerCase()),h),new Set);return t.forEach(h=>{r.has(h.toLowerCase())?s.push(h):a.push(h)}),{installed:s,uninstalled:a}}async I(t){const n=[],s=new Map;for(const a of t.keys()){const r=t.get(a);if(!r||!(0,k.isNonEmptyArray)(r.recommendations))continue;const h=[];O.isWindows?r.windowsPath&&h.push(r.windowsPath.replace("%USERPROFILE%",()=>P.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>P.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>P.env.ProgramFiles).replace("%APPDATA%",()=>P.env.APPDATA).replace("%WINDIR%",()=>P.env.WINDIR)):(h.push((0,l.join)("/usr/local/bin",a)),h.push((0,l.join)("/usr/bin",a)),h.push((0,l.join)(this.m.userHome.fsPath,a)));for(const g of h){let v=s.get(g);if(v===void 0&&(v=await this.b.exists(I.URI.file(g)),s.set(g,v)),v)for(const{extensionId:A,extensionName:N,isExtensionPack:F,whenNotInstalled:M}of r.recommendations)n.push({extensionId:A,extensionName:N,isExtensionPack:F,exeName:a,exeFriendlyName:r.exeFriendlyName,windowsPath:r.windowsPath,whenNotInstalled:M})}}return n}};i=ye([G(0,C.INativeEnvironmentService),G(1,p.ITelemetryService),G(2,b.IExtensionManagementService),G(3,d.IStorageService),G(4,f.INativeHostService),G(5,u.IExtensionRecommendationNotificationService),G(6,S.IFileService),G(7,c.IProductService)],i),e.ExtensionTipsService=i}),define(oe[275],ae([0,1,6,2,22,69,20,76,18]),function(Q,e,k,T,D,l,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class E extends O.AbstractStorageService{constructor(b,m,y,u){super(),this.X=b,this.Y=m,this.Z=y,this.ab=u,this.p=this.Y.defaultProfile,this.s=this.bb(),this.P=this.Y.currentProfile,this.Q=this.B(new T.DisposableStore),this.R=this.cb(this.P),this.S=this.X?.id,this.U=this.B(new T.DisposableStore),this.W=this.db(this.X)}bb(){const b=this.B(new P.ApplicationStorageDatabaseClient(this.Z.getChannel("storage"))),m=this.B(new l.Storage(b));return this.B(m.onDidChangeStorage(y=>this.n(-1,y))),m}cb(b){this.Q.clear(),this.P=b;let m;if((0,O.isProfileUsingDefaultStorage)(b))m=this.s;else{const y=this.Q.add(new P.ProfileStorageDatabaseClient(this.Z.getChannel("storage"),b));m=this.Q.add(new l.Storage(y))}return this.Q.add(m.onDidChangeStorage(y=>this.n(0,y))),m}db(b){this.U.clear(),this.S=b?.id;let m;if(b){const y=this.U.add(new P.WorkspaceStorageDatabaseClient(this.Z.getChannel("storage"),b));m=this.U.add(new l.Storage(y)),this.U.add(m.onDidChangeStorage(u=>this.n(1,u)))}return m}async J(){await k.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(b){switch(b){case-1:return this.s;case 0:return this.R;default:return this.W}}M(b){switch(b){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,D.joinPath)(this.ab.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.r(O.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(b,m){if(!this.H(this.P,b))return;const y=this.R,u=y.items;y!==this.s&&await y.close(),this.R=this.cb(b),await this.R.init(),this.I(u,this.R,0,m)}async O(b,m){const y=this.W,u=y?.items??new Map;await y?.close(),this.W=this.db(b),await this.W.init(),this.I(u,this.W,1,m)}hasScope(b){return(0,I.isUserDataProfile)(b)?this.P.id===b.id:this.S===b.id}}e.NativeStorageService=E}),define(oe[62],ae([0,1,2,69,5,20]),function(Q,e,k,T,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,D.createDecorator)("IUserDataProfileStorageService");let O=class extends k.Disposable{constructor(E){super(),this.a=E}async readStorageData(E){return this.withProfileScopedStorageService(E,async C=>this.b(C))}async updateStorageData(E,C,b){return this.withProfileScopedStorageService(E,async m=>this.c(m,C,b))}async withProfileScopedStorageService(E,C){if(this.a.hasScope(E))return C(this.a);const b=await this.createStorageDatabase(E),m=new P(b);try{await m.initialize();const y=await C(m);return await m.flush(),y}finally{m.dispose(),await this.f(b)}}b(E){const C=new Map,b=m=>{for(const y of E.keys(0,m))C.set(y,{value:E.get(y,0),target:m})};return b(0),b(1),C}c(E,C,b){for(const[m,y]of C)E.store(m,y,0,b)}async f(E){try{await E.close()}finally{(0,k.isDisposable)(E)&&E.dispose()}}};O=ye([G(0,l.IStorageService)],O),e.AbstractUserDataProfileStorageService=O;class P extends l.AbstractStorageService{constructor(E){super({flushInterval:100}),this.p=this.B(new T.Storage(E))}J(){return this.p.init()}L(E){return E===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(oe[276],ae([0,1,3,2,22,15,57,18]),function(Q,e,k,T,D,l,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let I=class extends T.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.b}constructor(C,b,m){super(),this.b=[],this.c=this.B(new k.Emitter),this.onDidChangeProfiles=this.c.event,this.f=!0,this.a=b.getChannel("userDataProfiles"),this.profilesHome=(0,D.joinPath)(m.userRoamingDataHome,"profiles"),this.b=C.map(y=>(0,P.reviveProfile)(y,this.profilesHome.scheme)),this.B(this.a.listen("onDidChangeProfiles")(y=>{const u=y.added.map(c=>(0,P.reviveProfile)(c,this.profilesHome.scheme)),S=y.removed.map(c=>(0,P.reviveProfile)(c,this.profilesHome.scheme)),f=y.updated.map(c=>(0,P.reviveProfile)(c,this.profilesHome.scheme));this.b=y.all.map(c=>(0,P.reviveProfile)(c,this.profilesHome.scheme)),this.c.fire({added:u,removed:S,updated:f,all:this.profiles})})),this.onDidResetWorkspaces=this.a.listen("onDidResetWorkspaces")}setEnablement(C){this.f=C}isEnabled(){return this.f}async createNamedProfile(C,b,m){const y=await this.a.call("createNamedProfile",[C,b,m]);return(0,P.reviveProfile)(y,this.profilesHome.scheme)}async createProfile(C,b,m,y){const u=await this.a.call("createProfile",[C,b,m,y]);return(0,P.reviveProfile)(u,this.profilesHome.scheme)}async createTransientProfile(C){const b=await this.a.call("createTransientProfile",[C]);return(0,P.reviveProfile)(b,this.profilesHome.scheme)}async setProfileForWorkspace(C,b){await this.a.call("setProfileForWorkspace",[C,b])}removeProfile(C){return this.a.call("removeProfile",[C])}async updateProfile(C,b){const m=await this.a.call("updateProfile",[C,b]);return(0,P.reviveProfile)(m,this.profilesHome.scheme)}resetWorkspaces(){return this.a.call("resetWorkspaces")}cleanUp(){return this.a.call("cleanUp")}cleanUpTransientProfiles(){return this.a.call("cleanUpTransientProfiles")}};I=ye([G(1,O.IMainProcessService),G(2,l.IEnvironmentService)],I),e.UserDataProfilesNativeService=I}),define(oe[277],ae([0,1,3,2,57,8,62,20,76,18,71]),function(Q,e,k,T,D,l,O,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfileStorageService=void 0;let b=class extends O.AbstractUserDataProfileStorageService{constructor(y,u,S,f){super(S),this.h=y;const c=y.getChannel("profileStorageListener"),d=this.B(new T.MutableDisposable);this.g=this.B(new k.Emitter({onWillAddFirstListener:()=>{d.value=c.listen("onDidChange")(p=>{f.trace("profile storage changes",p),this.g.fire({targetChanges:p.targetChanges.map(w=>(0,E.reviveProfile)(w,u.profilesHome.scheme)),valueChanges:p.valueChanges.map(w=>({...w,profile:(0,E.reviveProfile)(w.profile,u.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>d.value=void 0})),this.onDidChange=this.g.event}async createStorageDatabase(y){const u=this.h.getChannel("storage");return(0,P.isProfileUsingDefaultStorage)(y)?new I.ApplicationStorageDatabaseClient(u):new I.ProfileStorageDatabaseClient(u,y)}};b=ye([G(0,D.IMainProcessService),G(1,E.IUserDataProfilesService),G(2,P.IStorageService),G(3,l.ILogService)],b),e.UserDataProfileStorageService=b,(0,C.registerSingleton)(O.IUserDataProfileStorageService,b,1)}),define(oe[41],ae([0,1,21,6,17,25,3,35,2,27,12,179,16,15,14,8,45,20,19,29,24,18]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u,S,f,c,d,p,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function i(h){return!!(h&&h.ref!==void 0&&typeof h.ref=="string"&&h.ref!==""&&h.syncData!==void 0&&(h.syncData===null||o(h.syncData)))}e.isRemoteUserData=i;function o(h){return!!(h&&h.version!==void 0&&typeof h.version=="number"&&h.content!==void 0&&typeof h.content=="string"&&(Object.keys(h).length===2||Object.keys(h).length===3&&h.machineId!==void 0&&typeof h.machineId=="string"))}e.isSyncData=o;function t(h,g){return`${(0,E.uppercaseFirstLetter)(h)}${g.isDefault?"":` (${g.name})`}`}e.getSyncResourceLogLabel=t;let n=class extends I.Disposable{get status(){return this.k}get conflicts(){return{...this.syncResource,conflicts:this.m}}constructor(g,v,A,N,F,M,L,$,z,x,X,ie){super(),this.syncResource=g,this.collection=v,this.C=A,this.D=N,this.F=F,this.G=M,this.H=L,this.I=$,this.J=z,this.L=x,this.M=X,this.c=null,this.k="idle",this.l=this.B(new O.Emitter),this.onDidChangeStatus=this.l.event,this.m=[],this.n=this.B(new O.Emitter),this.onDidChangeConflicts=this.n.event,this.s=new T.ThrottledDelayer(50),this.t=this.B(new O.Emitter),this.onDidChangeLocal=this.t.event,this.v=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.w=!1,this.z={},this.resource=this.syncResource.syncResource,this.y=t(g.syncResource,g.profile),this.h=ie.extUri,this.f=this.h.joinPath(N.userDataSyncHome,...(0,w.getPathSegments)(g.profile.isDefault?void 0:g.profile.id,g.syncResource)),this.g=this.h.joinPath(this.f,w.PREVIEW_DIR_NAME),this.u=(0,w.getLastSyncResourceUri)(g.profile.isDefault?void 0:g.profile.id,g.syncResource,N,this.h),this.j=(0,f.getServiceMachineId)(N,A,F)}triggerLocalChange(){this.s.trigger(()=>this.N())}async N(){if(this.status==="hasConflicts"){this.L.info(`${this.y}: In conflicts state and local change detected. Syncing again...`);const g=await this.c;this.c=null;const v=await this.S(g.remoteUserData,g.lastSyncUserData,!0,this.lb());this.O(v)}else{this.L.trace(`${this.y}: Checking for local changes...`);const g=await this.getLastSyncUserData();(g?await this.rb(g):!0)&&this.t.fire()}}O(g){this.k!==g&&(this.k=g,this.l.fire(g))}async sync(g,v={}){await this.P(g,!0,this.lb(),v)}async preview(g,v,A={}){return this.P(g,!1,v,A)}async apply(g,v={}){try{this.z={...v};const A=await this.X(g);return this.O(A),this.c}finally{this.z={}}}async P(g,v,A,N){try{if(this.z={...N},this.status==="hasConflicts")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.L.trace(`${this.y}: Started synchronizing ${this.resource.toLowerCase()}...`),this.O("syncing");let F="idle";try{const M=await this.getLastSyncUserData(),L=await this.R(g,M);return F=await this.S(L,M,v,A),F==="hasConflicts"?this.L.info(`${this.y}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):F==="idle"&&this.L.trace(`${this.y}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.O(F)}}finally{this.z={}}}async replace(g){const v=this.hb(g);if(!v)return!1;await this.stop();try{this.L.trace(`${this.y}: Started resetting ${this.resource.toLowerCase()}...`),this.O("syncing");const A=await this.getLastSyncUserData(),N=await this.R(null,A),F=await this.Q(N),M=await this.nb({ref:N.ref,syncData:v},A,F,this.lb(),l.CancellationToken.None),L=[];for(const $ of M){const z=await this.pb($,$.remoteResource,void 0,l.CancellationToken.None),{remoteChange:x}=await this.pb($,$.previewResource,$.remoteContent,l.CancellationToken.None);L.push([$,{...z,remoteChange:x!==0?x:2}])}await this.qb(N,A,L,!1),this.L.info(`${this.y}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.O("idle")}return!0}async Q(g){const v=await this.j;return!!g.syncData?.machineId&&g.syncData.machineId===v}async R(g,v){if(v){const A=g?g[this.resource]:void 0;if(v.ref===A||A===void 0&&v.syncData===null)return v}return this.getRemoteUserData(v)}async S(g,v,A,N){if(g.syncData&&g.syncData.version>this.mb)throw this.J.publicLog2("sync/incompatible",{source:this.resource}),new w.UserDataSyncError((0,b.localize)(0,null,this.resource,this.mb,g.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.U(g,v,A,N)}catch(F){if(F instanceof w.UserDataSyncError)switch(F.code){case"LocalPreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize ${this.y} as there is a new local version available. Synchronizing again...`),this.S(g,v,A,N);case"Conflict":case"PreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),g=await this.getRemoteUserData(null),v=await this.getLastSyncUserData(),this.S(g,v,A,N)}throw F}}async U(g,v,A,N){try{const F=await this.Q(g),M=!F&&v===null&&this.db()!==void 0,L=A&&!M;this.c||(this.c=(0,T.createCancelablePromise)(z=>this.bb(g,v,F,L,N,z)));let $=await this.c;if(A&&M){this.L.info(`${this.y}: Accepting remote because it was synced before and the last sync data is not available.`);for(const z of $.resourcePreviews)$=await this.accept(z.remoteResource)||$}return this.Z($.resourcePreviews),$.resourcePreviews.some(({mergeState:z})=>z==="conflict")?"hasConflicts":A?await this.X(!1):"syncing"}catch(F){throw this.c=null,F}}async merge(g){return await this.W(g,async v=>{const A=await this.ob(v,l.CancellationToken.None);await this.C.writeFile(v.previewResource,D.VSBuffer.fromString(A?.content||""));const N=A&&!A.hasConflicts?await this.pb(v,v.previewResource,void 0,l.CancellationToken.None):void 0;return v.acceptResult=N,v.mergeState=A.hasConflicts?"conflict":N?"accepted":"preview",v.localChange=N?N.localChange:A.localChange,v.remoteChange=N?N.remoteChange:A.remoteChange,v}),this.c}async accept(g,v){return await this.W(g,async A=>{const N=await this.pb(A,g,v,l.CancellationToken.None);return A.acceptResult=N,A.mergeState="accepted",A.localChange=N.localChange,A.remoteChange=N.remoteChange,A}),this.c}async discard(g){return await this.W(g,async v=>{const A=await this.ob(v,l.CancellationToken.None);return await this.C.writeFile(v.previewResource,D.VSBuffer.fromString(A.content||"")),v.acceptResult=void 0,v.mergeState="preview",v.localChange=A.localChange,v.remoteChange=A.remoteChange,v}),this.c}async W(g,v){if(!this.c)return;let A=await this.c;const N=A.resourcePreviews.findIndex(({localResource:F,remoteResource:M,previewResource:L})=>this.h.isEqual(F,g)||this.h.isEqual(M,g)||this.h.isEqual(L,g));N!==-1&&(this.c=(0,T.createCancelablePromise)(async F=>{const M=[...A.resourcePreviews];return M[N]=await v(M[N]),{...A,resourcePreviews:M}}),A=await this.c,this.Z(A.resourcePreviews),A.resourcePreviews.some(({mergeState:F})=>F==="conflict")?this.O("hasConflicts"):this.O("syncing"))}async X(g){if(!this.c)return"idle";const v=await this.c;return v.resourcePreviews.some(({mergeState:A})=>A==="conflict")?"hasConflicts":v.resourcePreviews.some(({mergeState:A})=>A!=="accepted")?"syncing":(await this.qb(v.remoteUserData,v.lastSyncUserData,v.resourcePreviews.map(A=>[A,A.acceptResult]),g),this.c=null,await this.Y(),"idle")}async Y(){try{await this.C.del(this.g,{recursive:!0})}catch{}}Z(g){const v=g.filter(({mergeState:A})=>A==="conflict");(0,k.equals)(this.m,v,(A,N)=>this.h.isEqual(A.previewResource,N.previewResource))||(this.m=v,this.n.fire(this.conflicts))}async hasPreviouslySynced(){const g=await this.getLastSyncUserData();return!!g&&g.syncData!==null}async ab(g){const v=this.c?await this.c:null;if(v)for(const A of v.resourcePreviews){if(this.h.isEqual(A.acceptedResource,g))return A.acceptResult?A.acceptResult.content:null;if(this.h.isEqual(A.remoteResource,g))return A.remoteContent;if(this.h.isEqual(A.localResource,g))return A.localContent;if(this.h.isEqual(A.baseResource,g))return A.baseContent}return null}async resetLocal(){this.F.remove(this.v,-1);try{await this.C.del(this.u)}catch(g){(0,u.toFileOperationResult)(g)!==1&&this.L.error(g)}}async bb(g,v,A,N,F,M){const L=await this.nb(g,v,A,F,M),$=[];for(const z of L){const x=z.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(z.localChange===0&&z.remoteChange===0)$.push({...z,acceptedResource:x,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const X=N?await this.ob(z,M):void 0;if(M.isCancellationRequested)break;await this.C.writeFile(z.previewResource,D.VSBuffer.fromString(X?.content||""));const ie=X&&!X.hasConflicts?await this.pb(z,z.previewResource,void 0,M):void 0;$.push({...z,acceptResult:ie,mergeState:X?.hasConflicts?"conflict":ie?"accepted":"preview",localChange:ie?ie.localChange:X?X.localChange:z.localChange,remoteChange:ie?ie.remoteChange:X?X.remoteChange:z.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:g,lastSyncUserData:v,resourcePreviews:$,isLastSyncFromCurrentMachine:A}}async getLastSyncUserData(){let g=this.db();if(g||(g=await this.gb()),!g)return this.L.info(`${this.y}: Last sync data state does not exist.`),null;const v=JSON.parse(g),A=this.I.getResourceSyncStateVersion(this.resource);if(this.w=!!v.version&&!!A&&v.version!==A,this.w)return this.L.info(`${this.y}: Reset last sync state because last sync state version ${v.version} is not compatible with current sync state version ${A}.`),await this.resetLocal(),null;let N,F=1;for(;N===void 0&&F++<6;)try{const M=await this.eb();M&&(M.ref===v.ref?N=M.syncData:this.L.info(`${this.y}: Last sync data stored locally is not same as the last sync state.`));break}catch(M){if(M instanceof u.FileOperationError&&M.fileOperationResult===1){this.L.info(`${this.y}: Last sync resource does not exist locally.`);break}else{if(M instanceof w.UserDataSyncError)throw M;this.L.error(M,F)}}if(N===void 0)try{const M=await this.G.resolveResourceContent(this.resource,v.ref,this.collection,this.z);N=M===null?null:this.hb(M),await this.fb({ref:v.ref,syncData:N})}catch(M){if(M instanceof w.UserDataSyncError&&M.code==="NotFound")this.L.info(`${this.y}: Last sync resource does not exist remotely.`);else throw M}return N===void 0?null:{...v,syncData:N}}async cb(g,v={}){if(v.ref||v.version)throw new Error("Cannot have core properties as additional");const A=this.I.getResourceSyncStateVersion(this.resource),N={ref:g.ref,version:A,...v};this.F.store(this.v,JSON.stringify(N),-1,1),await this.fb(g)}db(){return this.F.get(this.v,-1)}async eb(){const g=(await this.C.readFile(this.u)).value.toString();try{const v=g?JSON.parse(g):void 0;if(i(v))return v}catch(v){this.L.error(v)}}async fb(g){await this.C.writeFile(this.u,D.VSBuffer.fromString(JSON.stringify(g)))}async gb(){try{const g=await this.C.readFile(this.u),v=JSON.parse(g.value.toString());await this.C.del(this.u),v.ref&&v.content!==void 0&&(this.F.store(this.v,JSON.stringify({...v,content:void 0}),-1,1),await this.fb({ref:v.ref,syncData:v.content===null?null:JSON.parse(v.content)}))}catch(g){g instanceof u.FileOperationError&&g.fileOperationResult===1?this.L.debug(`${this.y}: Migrating last sync user data. Resource does not exist.`):this.L.error(g)}return this.F.get(this.v,-1)}async getRemoteUserData(g){const{ref:v,content:A}=await this.ib(g);let N=null;return A!==null&&(N=this.hb(A)),{ref:v,syncData:N}}hb(g){try{const v=JSON.parse(g);if(o(v))return v}catch(v){this.L.error(v)}throw new w.UserDataSyncError((0,b.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async ib(g){const v=g?{ref:g.ref,content:g.syncData?JSON.stringify(g.syncData):null}:null;return this.G.readResource(this.resource,v,this.collection,this.z)}async jb(g,v){const A=await this.j,N={version:this.mb,machineId:A,content:g};try{return v=await this.G.writeResource(this.resource,JSON.stringify(N),v,this.collection,this.z),{ref:v,syncData:N}}catch(F){throw F instanceof w.UserDataSyncError&&F.code==="TooLarge"&&(F=new w.UserDataSyncError(F.message,F.code,this.resource)),F}}async kb(g){const v={version:this.mb,content:g};return this.H.backup(this.syncResource.profile,this.resource,JSON.stringify(v))}async stop(){this.status!=="idle"&&(this.L.trace(`${this.y}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.Z([]),await this.Y(),this.O("idle"),this.L.info(`${this.y}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}lb(){return this.M.getValue(w.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};n=ye([G(2,u.IFileService),G(3,y.IEnvironmentService),G(4,c.IStorageService),G(5,w.IUserDataSyncStoreService),G(6,w.IUserDataSyncBackupStoreService),G(7,w.IUserDataSyncEnablementService),G(8,d.ITelemetryService),G(9,w.IUserDataSyncLogService),G(10,m.IConfigurationService),G(11,p.IUriIdentityService)],n),e.AbstractSynchroniser=n;let s=class extends n{constructor(g,v,A,N,F,M,L,$,z,x,X,ie,H){super(v,A,N,F,M,L,$,z,x,X,ie,H),this.i=g,this.B(this.C.watch(this.h.dirname(g))),this.B(this.C.onDidFilesChange(j=>this.tb(j)))}async p(){try{return await this.C.readFile(this.i)}catch{return null}}async r(g,v,A){try{v?await this.C.writeFile(this.i,D.VSBuffer.fromString(g),A?void 0:v):await this.C.createFile(this.i,D.VSBuffer.fromString(g),{overwrite:A})}catch(N){throw N instanceof u.FileOperationError&&N.fileOperationResult===1||N instanceof u.FileOperationError&&N.fileOperationResult===3?new w.UserDataSyncError(N.message,"LocalPreconditionFailed"):N}}async sb(){try{await this.C.del(this.i)}catch(g){if(!(g instanceof u.FileOperationError&&g.fileOperationResult===1))throw g}}tb(g){!g.contains(this.i)||this.triggerLocalChange()}};s=ye([G(3,u.IFileService),G(4,y.IEnvironmentService),G(5,c.IStorageService),G(6,w.IUserDataSyncStoreService),G(7,w.IUserDataSyncBackupStoreService),G(8,w.IUserDataSyncEnablementService),G(9,d.ITelemetryService),G(10,w.IUserDataSyncLogService),G(11,m.IConfigurationService),G(12,p.IUriIdentityService)],s),e.AbstractFileSynchroniser=s;let a=class extends s{constructor(g,v,A,N,F,M,L,$,z,x,X,ie,H,j){super(g,v,A,N,F,M,L,$,z,x,X,H,j),this.ub=ie,this.wb=void 0}vb(g,v){const A=[],N=(0,P.parse)(g,A,{allowEmptyContent:!0,allowTrailingComma:!0});return A.length>0||!(0,C.isUndefined)(N)&&v!==Array.isArray(N)}xb(){return this.wb||(this.wb=this.ub.resolveFormattingOptions(this.i)),this.wb}};a=ye([G(3,u.IFileService),G(4,y.IEnvironmentService),G(5,c.IStorageService),G(6,w.IUserDataSyncStoreService),G(7,w.IUserDataSyncBackupStoreService),G(8,w.IUserDataSyncEnablementService),G(9,d.ITelemetryService),G(10,w.IUserDataSyncLogService),G(11,w.IUserDataSyncUtilService),G(12,m.IConfigurationService),G(13,p.IUriIdentityService)],a),e.AbstractJsonFileSynchroniser=a;let r=class{constructor(g,v,A,N,F,M,L){this.resource=g,this.g=v,this.h=A,this.j=N,this.k=F,this.l=M,this.d=L.extUri,this.f=(0,w.getLastSyncResourceUri)(void 0,this.resource,A,this.d)}async initialize({ref:g,content:v}){if(!v){this.j.info("Remote content does not exist.",this.resource);return}const A=this.m(v);if(!!A)try{await this.doInitialize({ref:g,syncData:A})}catch(N){this.j.error(N)}}m(g){try{const v=JSON.parse(g);if(o(v))return v}catch(v){this.j.error(v)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(g,v={}){if(v.ref||v.version)throw new Error("Cannot have core properties as additional");const A={ref:g.ref,version:void 0,...v};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(A),-1,1),await this.k.writeFile(this.f,D.VSBuffer.fromString(JSON.stringify(g)))}};r=ye([G(1,R.IUserDataProfilesService),G(2,y.IEnvironmentService),G(3,S.ILogService),G(4,u.IFileService),G(5,c.IStorageService),G(6,p.IUriIdentityService)],r),e.AbstractInitializer=r}),define(oe[119],ae([0,1,6,25,9,3,43,2,27,16,15,118,30,33,80,14,5,72,8,20,19,29,18,41,259,116,24,62]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u,S,f,c,d,p,w,R,i,o,t,n,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function r(F,M){const L=JSON.parse(F.content);if(F.version===1||F.version===2){const $=(await M.getInstalled(0)).filter(z=>z.isBuiltin);for(const z of L)F.version===1&&(z.enabled===!1&&(z.disabled=!0),delete z.enabled),F.version===2&&$.every(x=>!(0,y.areSameExtensions)(x.identifier,z.identifier))&&(z.installed=!0)}return L}function h(F){return JSON.parse(F.content)}e.parseExtensions=h;function g(F,M){return F.sort((L,$)=>!L.identifier.uuid&&$.identifier.uuid?-1:L.identifier.uuid&&!$.identifier.uuid?1:(0,I.compare)(L.identifier.id,$.identifier.id)),M?(0,O.toFormattedString)(F,{}):JSON.stringify(F)}e.stringify=g;let v=class extends o.AbstractSynchroniser{constructor(M,L,$,z,x,X,ie,H,j,V,J,_,re,te,U,B,W){super({syncResource:"extensions",profile:M},L,z,$,x,X,ie,_,re,V,J,U),this.yb=H,this.zb=j,this.Ab=W,this.mb=5,this.sb=this.h.joinPath(this.g,"extensions.json"),this.tb=this.sb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"base"}),this.ub=this.sb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.vb=this.sb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.wb=this.sb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.xb=this.Ab.createInstance(A),this.B(l.Event.any(l.Event.filter(this.yb.onDidInstallExtensions,q=>q.some(({local:Y})=>!!Y)),l.Event.filter(this.yb.onDidUninstallExtension,q=>!q.error),l.Event.filter(B.onDidChange,q=>q.valueChanges.some(({profile:Y,changes:ee})=>this.syncResource.profile.id===Y.id&&ee.some(K=>K.key===m.DISABLED_EXTENSIONS_STORAGE_PATH))),te.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async nb(M,L){const $=M.syncData?await r(M.syncData,this.yb):null,z=L?.skippedExtensions||[],x=L?.builtinExtensions||[],X=L?.syncData?await r(L.syncData,this.yb):null,{localExtensions:ie,ignoredExtensions:H}=await this.xb.getLocalExtensions(this.syncResource.profile);$?this.L.trace(`${this.y}: Merging remote extensions with local extensions...`):this.L.trace(`${this.y}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:j,remote:V}=(0,t.merge)(ie,$,X,z,H,x),J={local:j,remote:V,content:this.Db(ie,j.added,j.updated,j.removed),localChange:j.added.length>0||j.removed.length>0||j.updated.length>0?2:0,remoteChange:V!==null?2:0},_=this.Jb(ie,!1);return[{skippedExtensions:z,builtinExtensions:x,baseResource:this.tb,baseContent:X?this.Jb(X,!1):_,localResource:this.ub,localContent:_,localExtensions:ie,remoteResource:this.vb,remoteExtensions:$,remoteContent:$?this.Jb($,!1):null,previewResource:this.sb,previewResult:J,localChange:J.localChange,remoteChange:J.remoteChange,acceptedResource:this.wb}]}async rb(M){const L=M.syncData?await r(M.syncData,this.yb):null,{localExtensions:$,ignoredExtensions:z}=await this.xb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,t.merge)($,L,L,M.skippedExtensions||[],z,M.builtinExtensions||[]);return x!==null}Db(M,L,$,z){const x=[...L,...$],X=new Set,ie=H=>{X.add(H.id.toLowerCase()),H.uuid&&X.add(H.uuid)};x.forEach(({identifier:H})=>ie(H)),z.forEach(ie);for(const H of M)X.has(H.identifier.id.toLowerCase())||H.identifier.uuid&&X.has(H.identifier.uuid)||x.push(H);return this.Jb(x,!1)}async ob(M,L){return{...M.previewResult,hasConflicts:!1}}async pb(M,L,$,z){if(this.h.isEqual(L,this.ub))return this.Gb(M);if(this.h.isEqual(L,this.vb))return this.Hb(M);if(this.h.isEqual(L,this.sb))return M.previewResult;throw new Error(`Invalid Resource: ${L.toString()}`)}async Gb(M){const L=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),$=this.zb.getIgnoredExtensions(L),z=(0,t.merge)(M.localExtensions,null,null,M.skippedExtensions,$,M.builtinExtensions),{local:x,remote:X}=z;return{content:M.localContent,local:x,remote:X,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:X!==null?2:0}}async Hb(M){const L=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),$=this.zb.getIgnoredExtensions(L),z=M.remoteContent?JSON.parse(M.remoteContent):null;if(z!==null){const x=(0,t.merge)(M.localExtensions,z,M.localExtensions,[],$,M.builtinExtensions),{local:X,remote:ie}=x;return{content:M.remoteContent,local:X,remote:ie,localChange:X.added.length>0||X.removed.length>0||X.updated.length>0?2:0,remoteChange:ie!==null?2:0}}else return{content:M.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(M,L,$,z){let{skippedExtensions:x,localExtensions:X}=$[0][0];const{local:ie,remote:H,localChange:j,remoteChange:V}=$[0][1];if(j===0&&V===0&&this.L.info(`${this.y}: No changes found during synchronizing extensions.`),j!==0&&(await this.kb(JSON.stringify(X)),x=await this.xb.updateLocalExtensions(ie.added,ie.removed,ie.updated,x,this.syncResource.profile)),H){this.L.trace(`${this.y}: Updating remote extensions...`);const J=JSON.stringify(H.all);M=await this.jb(J,z?null:M.ref),this.L.info(`${this.y}: Updated remote extensions.${H.added.length?` Added: ${JSON.stringify(H.added.map(_=>_.identifier.id))}.`:""}${H.updated.length?` Updated: ${JSON.stringify(H.updated.map(_=>_.identifier.id))}.`:""}${H.removed.length?` Removed: ${JSON.stringify(H.removed.map(_=>_.identifier.id))}.`:""}`)}if(L?.ref!==M.ref){this.L.trace(`${this.y}: Updating last synchronized extensions...`);const J=X.filter(_=>!_.installed).map(_=>_.identifier);await this.cb(M,{skippedExtensions:x,builtinExtensions:J}),this.L.info(`${this.y}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(_=>_.identifier.id))}.`:""}`)}}async resolveContent(M){if(this.h.isEqual(this.vb,M)||this.h.isEqual(this.tb,M)||this.h.isEqual(this.ub,M)||this.h.isEqual(this.wb,M)){const L=await this.ab(M);return L&&this.Jb(JSON.parse(L),!0)}return null}Jb(M,L){return g(M,L)}async hasLocalData(){try{const{localExtensions:M}=await this.xb.getLocalExtensions(this.syncResource.profile);if(M.some(L=>L.installed||L.disabled))return!0}catch{}return!1}};v=ye([G(2,C.IEnvironmentService),G(3,S.IFileService),G(4,p.IStorageService),G(5,s.IUserDataSyncStoreService),G(6,s.IUserDataSyncBackupStoreService),G(7,m.IExtensionManagementService),G(8,n.IIgnoredExtensionsManagementService),G(9,s.IUserDataSyncLogService),G(10,E.IConfigurationService),G(11,s.IUserDataSyncEnablementService),G(12,w.ITelemetryService),G(13,u.IExtensionStorageService),G(14,R.IUriIdentityService),G(15,a.IUserDataProfileStorageService),G(16,f.IInstantiationService)],v),e.ExtensionsSynchroniser=v;let A=class{constructor(M,L,$,z,x,X){this.a=M,this.b=L,this.c=$,this.d=z,this.f=x,this.g=X}async getLocalExtensions(M){const L=await this.a.getInstalled(void 0,M.extensionsResource),$=this.d.getIgnoredExtensions(L);return{localExtensions:await this.j(M,async(x,X)=>{const ie=x.getDisabledExtensions();return L.map(H=>{const{identifier:j,isBuiltin:V,manifest:J,preRelease:_,pinned:re}=H,te={identifier:j,preRelease:_,version:J.version,pinned:!!re};ie.some(U=>(0,y.areSameExtensions)(U,j))&&(te.disabled=!0),V||(te.installed=!0);try{const U=X.getKeysForSync({id:j.id,version:J.version});if(U){const B=X.getExtensionState(H,!0)||{};te.state=Object.keys(B).reduce((W,q)=>(U.includes(q)&&(W[q]=B[q]),W),{})}}catch(U){this.g.info(`${(0,o.getSyncResourceLogLabel)("extensions",M)}: Error while parsing extension state`,(0,D.getErrorMessage)(U))}return te})}),ignoredExtensions:$}}async updateLocalExtensions(M,L,$,z,x){const X=(0,o.getSyncResourceLogLabel)("extensions",x),ie=[],H=[],j=[],V=await this.a.getInstalled(void 0,x.extensionsResource);if((M.length||$.length)&&await this.j(x,async(_,re)=>{await k.Promises.settled([...M,...$].map(async te=>{const U=V.find(q=>(0,y.areSameExtensions)(q.identifier,te.identifier));if(U&&U.isBuiltin){te.state&&U.manifest.version===te.version&&this.h(te.state,U,U.manifest.version,re),_.getDisabledExtensions().some(Y=>(0,y.areSameExtensions)(Y,te.identifier))!==!!te.disabled&&(te.disabled?(this.g.trace(`${X}: Disabling extension...`,te.identifier.id),await _.disableExtension(te.identifier),this.g.info(`${X}: Disabled extension`,te.identifier.id)):(this.g.trace(`${X}: Enabling extension...`,te.identifier.id),await _.enableExtension(te.identifier),this.g.info(`${X}: Enabled extension`,te.identifier.id))),H.push(te.identifier);return}const B=te.pinned?te.version:void 0,W=(await this.c.getExtensions([{...te.identifier,version:B,preRelease:B?void 0:te.preRelease}],T.CancellationToken.None))[0];if(te.state&&(U?U.manifest.version===te.version:!!W)&&this.h(te.state,U||W,U?.manifest.version,re),W)try{_.getDisabledExtensions().some(Y=>(0,y.areSameExtensions)(Y,te.identifier))!==!!te.disabled&&(te.disabled?(this.g.trace(`${X}: Disabling extension...`,te.identifier.id,W.version),await _.disableExtension(W.identifier),this.g.info(`${X}: Disabled extension`,te.identifier.id,W.version)):(this.g.trace(`${X}: Enabling extension...`,te.identifier.id,W.version),await _.enableExtension(W.identifier),this.g.info(`${X}: Enabled extension`,te.identifier.id,W.version))),(!U||U.preRelease!==te.preRelease||U.pinned!==te.pinned||B&&U.manifest.version!==B)&&(await this.a.canInstall(W)?ie.push([te,W]):(this.g.info(`${X}: Skipped synchronizing extension because it cannot be installed.`,W.displayName||W.identifier.id),j.push(te)))}catch(q){j.push(te),this.g.error(q),this.g.info(`${X}: Skipped synchronizing extension`,W.displayName||W.identifier.id)}else j.push(te),this.g.info(`${X}: Skipped synchronizing extension because the extension is not found.`,te.identifier.id)}))}),L.length){const _=V.filter(({identifier:re,isBuiltin:te})=>!te&&L.some(U=>(0,y.areSameExtensions)(re,U)));await k.Promises.settled(_.map(async re=>{this.g.trace(`${X}: Uninstalling local extension...`,re.identifier.id),await this.a.uninstall(re,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${X}: Uninstalled local extension.`,re.identifier.id),H.push(re.identifier)}))}for(const[_,re]of ie)try{this.g.trace(`${X}: Installing extension...`,re.identifier.id,re.version),await this.a.installFromGallery(re,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:_.pinned&&!!_.version,installPreReleaseVersion:_.preRelease,profileLocation:x.extensionsResource,context:{[s.EXTENSIONS_SYNC_CONTEXT_KEY]:!0}}),this.g.info(`${X}: Installed extension.`,re.identifier.id,re.version),H.push(re.identifier)}catch(te){j.push(_),te instanceof m.ExtensionManagementError&&[m.ExtensionManagementErrorCode.Incompatible,m.ExtensionManagementErrorCode.IncompatiblePreRelease,m.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(te.code)?this.g.info(`${X}: Skipped synchronizing extension because the compatible extension is not found.`,re.displayName||re.identifier.id):(this.g.error(te),this.g.info(`${X}: Skipped synchronizing extension`,re.displayName||re.identifier.id))}const J=[];for(const _ of z)H.some(re=>(0,y.areSameExtensions)(re,_.identifier))||J.push(_);for(const _ of j)J.some(re=>(0,y.areSameExtensions)(re.identifier,_.identifier))||J.push(_);return J}h(M,L,$,z){const x=z.getExtensionState(L,!0)||{},X=$?z.getKeysForSync({id:L.identifier.id,version:$}):void 0;X?X.forEach(ie=>{x[ie]=M[ie]}):Object.keys(M).forEach(ie=>x[ie]=M[ie]),z.setExtensionState(L,x,!0)}async j(M,L){return this.b.withProfileScopedStorageService(M,async $=>{const z=new P.DisposableStore,x=this.f.createChild(new c.ServiceCollection([p.IStorageService,$])),X=z.add(x.createInstance(b.GlobalExtensionEnablementService)),ie=z.add(x.createInstance(u.ExtensionStorageService));try{return await L(X,ie)}finally{z.dispose()}})}};A=ye([G(0,m.IExtensionManagementService),G(1,a.IUserDataProfileStorageService),G(2,m.IExtensionGalleryService),G(3,n.IIgnoredExtensionsManagementService),G(4,f.IInstantiationService),G(5,s.IUserDataSyncLogService)],A),e.LocalExtensionsProvider=A;let N=class extends o.AbstractInitializer{constructor(M,L,$,z,x,X,ie,H){super("extensions",z,x,X,$,ie,H),this.o=M,this.p=L}async q(M){return M.syncData?await r(M.syncData,this.o):null}t(M,L){const $=[],z=[],x=[];for(const X of M){if(this.p.hasToNeverSyncExtension(X.identifier.id))continue;const ie=L.find(H=>(0,y.areSameExtensions)(H.identifier,X.identifier));ie?($.push(ie),X.disabled&&x.push(X.identifier)):X.installed&&(z.push({...X.identifier,preRelease:!!X.preRelease}),X.disabled&&x.push(X.identifier))}return{installedExtensions:$,newExtensions:z,disabledExtensions:x,remoteExtensions:M}}};N=ye([G(0,m.IExtensionManagementService),G(1,n.IIgnoredExtensionsManagementService),G(2,S.IFileService),G(3,i.IUserDataProfilesService),G(4,C.IEnvironmentService),G(5,d.ILogService),G(6,p.IStorageService),G(7,R.IUriIdentityService)],N),e.AbstractExtensionsInitializer=N}),define(oe[120],ae([0,1,17,9,3,35,43,4,31,16,15,14,8,45,20,19,29,41,61,263,24,18,62,5]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u,S,f,c,d,p,w,R,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const t="globalState.argv.",n=["locale"];function s(A,N){const F=A.storage?Object.keys(A.storage).sort():[],M={};return F.forEach(L=>M[L]=A.storage[L]),A.storage=M,N?(0,O.toFormattedString)(A,{}):JSON.stringify(A)}e.stringify=s;const a=1;let r=class extends c.AbstractSynchroniser{constructor(N,F,M,L,$,z,x,X,ie,H,j,V,J,_){super({syncResource:"globalState",profile:N},F,L,X,V,$,z,ie,H,x,j,J),this.wb=M,this.mb=a,this.p=this.h.joinPath(this.g,"globalState.json"),this.r=this.p.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"base"}),this.sb=this.p.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.tb=this.p.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.ub=this.p.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.vb=_.createInstance(h),this.B(L.watch(this.h.dirname(this.D.argvResource))),this.B(D.Event.any(D.Event.filter(L.onDidFilesChange,re=>re.contains(this.D.argvResource)),D.Event.filter(M.onDidChange,re=>!!(re.targetChanges.some(te=>this.syncResource.profile.id===te.id)||re.valueChanges.some(({profile:te,changes:U})=>this.syncResource.profile.id===te.id&&U.some(B=>B.target===0)))))(()=>this.triggerLocalChange()))}async nb(N,F,M){const L=N.syncData?JSON.parse(N.syncData.content):null;F=F===null&&M?N:F;const $=F&&F.syncData?JSON.parse(F.syncData.content):null,z=await this.vb.getLocalGlobalState(this.syncResource.profile);L?this.L.trace(`${this.y}: Merging remote ui state with local ui state...`):this.L.trace(`${this.y}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const x=await this.Eb($),{local:X,remote:ie}=(0,p.merge)(z.storage,L?L.storage:null,$?$.storage:null,x,this.L),H={content:null,local:X,remote:ie,localChange:Object.keys(X.added).length>0||Object.keys(X.updated).length>0||X.removed.length>0?2:0,remoteChange:ie.all!==null?2:0},j=s(z,!1);return[{baseResource:this.r,baseContent:$?s($,!1):j,localResource:this.sb,localContent:j,localUserData:z,remoteResource:this.tb,remoteContent:L?s(L,!1):null,previewResource:this.p,previewResult:H,localChange:H.localChange,remoteChange:H.remoteChange,acceptedResource:this.ub,storageKeys:x}]}async rb(N){const F=N.syncData?JSON.parse(N.syncData.content):null;if(F===null)return!0;const M=await this.vb.getLocalGlobalState(this.syncResource.profile),L=await this.Eb(F),{remote:$}=(0,p.merge)(M.storage,F.storage,F.storage,L,this.L);return $.all!==null}async ob(N,F){return{...N.previewResult,hasConflicts:!1}}async pb(N,F,M,L){if(this.h.isEqual(F,this.sb))return this.Bb(N);if(this.h.isEqual(F,this.tb))return this.Cb(N);if(this.h.isEqual(F,this.p))return N.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async Bb(N){return{content:N.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(N.localUserData.storage),removed:[],updated:[],all:N.localUserData.storage},localChange:0,remoteChange:2}}async Cb(N){if(N.remoteContent!==null){const F=JSON.parse(N.remoteContent),{local:M,remote:L}=(0,p.merge)(N.localUserData.storage,F.storage,null,N.storageKeys,this.L);return{content:N.remoteContent,local:M,remote:L,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:L!==null?2:0}}else return{content:N.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async qb(N,F,M,L){const{localUserData:$}=M[0][0],{local:z,remote:x,localChange:X,remoteChange:ie}=M[0][1];if(X===0&&ie===0&&this.L.info(`${this.y}: No changes found during synchronizing ui state.`),X!==0&&(this.L.trace(`${this.y}: Updating local ui state...`),await this.kb(JSON.stringify($)),await this.vb.writeLocalGlobalState(z,this.syncResource.profile),this.L.info(`${this.y}: Updated local ui state`)),ie!==0){this.L.trace(`${this.y}: Updating remote ui state...`);const H=JSON.stringify({storage:x.all});N=await this.jb(H,L?null:N.ref),this.L.info(`${this.y}: Updated remote ui state.${x.added.length?` Added: ${x.added}.`:""}${x.updated.length?` Updated: ${x.updated}.`:""}${x.removed.length?` Removed: ${x.removed}.`:""}`)}F?.ref!==N.ref&&(this.L.trace(`${this.y}: Updating last synchronized ui state...`),await this.cb(N),this.L.info(`${this.y}: Updated last synchronized ui state`))}async resolveContent(N){if(this.h.isEqual(this.tb,N)||this.h.isEqual(this.r,N)||this.h.isEqual(this.sb,N)||this.h.isEqual(this.ub,N)){const F=await this.ab(N);return F&&s(JSON.parse(F),!0)}return null}async hasLocalData(){try{const{storage:N}=await this.vb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(N).length>1||N[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async Eb(N){const F=await this.wb.readStorageData(this.syncResource.profile),M=[],L=[];for(const[x,X]of F)X.target===0?M.push(x):X.target===1&&L.push(x);const $=[...M,...L],z=N?.storage?Object.keys(N.storage).filter(x=>!x.startsWith(t)&&!$.includes(x)&&F.get(x)!==void 0):[];if(!P.isWeb){const x=[...w.ALL_SYNC_RESOURCES.map(X=>(0,w.getEnablementKey)(X)),w.SYNC_SERVICE_URL_TYPE];z.push(...x),L.push(...x)}return{user:M,machine:L,unregistered:z}}};r=ye([G(2,i.IUserDataProfileStorageService),G(3,b.IFileService),G(4,w.IUserDataSyncStoreService),G(5,w.IUserDataSyncBackupStoreService),G(6,w.IUserDataSyncLogService),G(7,C.IEnvironmentService),G(8,w.IUserDataSyncEnablementService),G(9,S.ITelemetryService),G(10,E.IConfigurationService),G(11,u.IStorageService),G(12,f.IUriIdentityService),G(13,o.IInstantiationService)],r),e.GlobalStateSynchroniser=r;let h=class{constructor(N,F,M,L){this.a=N,this.b=F,this.c=M,this.d=L}async getLocalGlobalState(N){const F={};if(N.isDefault){const L=await this.f(),$=(0,l.parse)(L);for(const z of n)$[z]!==void 0&&(F[`${t}${z}`]={version:1,value:$[z]})}const M=await this.c.readStorageData(N);for(const[L,$]of M)$.value&&$.target===0&&(F[L]={version:1,value:$.value});return{storage:F}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const N=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),N.value.toString()}catch(N){this.d.debug((0,T.getErrorMessage)(N))}return"{}"}async writeLocalGlobalState({added:N,removed:F,updated:M},L){const $=(0,c.getSyncResourceLogLabel)("globalState",L),z={},x=new Map,X=await this.c.readStorageData(L),ie=(H,j)=>{for(const V of H){if(V.startsWith(t)){z[V.substring(t.length)]=j?j[V].value:void 0;continue}if(j){const J=j[V];J.value!==X.get(V)?.value&&x.set(V,J.value)}else X.get(V)!==void 0&&x.set(V,void 0)}};if(ie(Object.keys(N),N),ie(Object.keys(M),M),ie(F),Object.keys(z).length){this.d.trace(`${$}: Updating locale...`);const H=await this.f();let j=H;for(const V of Object.keys(z))j=(0,d.edit)(j,[V],z[V],{});H!==j&&(this.d.trace(`${$}: Updating locale...`),await this.a.writeFile(this.b.argvResource,k.VSBuffer.fromString(j)),this.d.info(`${$}: Updated locale.`)),this.d.info(`${$}: Updated locale`)}x.size&&(this.d.trace(`${$}: Updating global state...`),await this.c.updateStorageData(L,x,0),this.d.info(`${$}: Updated global state`,[...x.keys()]))}};h=ye([G(0,b.IFileService),G(1,C.IEnvironmentService),G(2,i.IUserDataProfileStorageService),G(3,w.IUserDataSyncLogService)],h),e.LocalGlobalStateProvider=h;let g=class extends c.AbstractInitializer{constructor(N,F,M,L,$,z){super("globalState",M,L,$,F,N,z)}async doInitialize(N){const F=N.syncData?JSON.parse(N.syncData.content):null;if(!F){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const M={},L={};for(const $ of Object.keys(F.storage))$.startsWith(t)?M[$.substring(t.length)]=F.storage[$].value:this.l.get($,0)===void 0&&(L[$]=F.storage[$].value);if(Object.keys(M).length){let $="{}";try{$=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const z of Object.keys(M))$=(0,d.edit)($,[z],M[z],{});await this.k.writeFile(this.h.argvResource,k.VSBuffer.fromString($))}if(Object.keys(L).length)for(const $ of Object.keys(L))this.l.store($,L[$],0,0)}};g=ye([G(0,u.IStorageService),G(1,b.IFileService),G(2,R.IUserDataProfilesService),G(3,C.IEnvironmentService),G(4,w.IUserDataSyncLogService),G(5,f.IUriIdentityService)],g),e.GlobalStateInitializer=g;let v=class{constructor(N,F,M,L,$){this.a=N,this.b=F,this.c=M,this.d=L,this.f=$}getSyncStoreType(N){return this.h(N)?.storage[w.SYNC_SERVICE_URL_TYPE]?.value}async sync(N){const F=(0,w.createSyncHeaders)((0,I.generateUuid)());try{return await this.g(N,F)}catch(M){if(M instanceof w.UserDataSyncError)switch(M.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(N,F)}throw M}}async g(N,F){const M=await this.a.readResource("globalState",null,void 0,F),L=this.h(M)||{storage:{}};L.storage[w.SYNC_SERVICE_URL_TYPE]={value:N,version:a};const $=await(0,y.getServiceMachineId)(this.c,this.d,this.b),z={version:a,machineId:$,content:s(L,!1)};await this.a.writeResource("globalState",JSON.stringify(z),M.ref,void 0,F)}h({content:N}){if(!N)return null;const F=JSON.parse(N);if((0,c.isSyncData)(F))return F?JSON.parse(F.content):null;throw new Error("Invalid remote data")}};v=ye([G(1,u.IStorageService),G(2,C.IEnvironmentService),G(3,b.IFileService),G(4,m.ILogService)],v),e.UserDataSyncStoreTypeSynchronizer=v}),define(oe[121],ae([0,1,21,17,3,35,4,12,180,16,15,14,20,19,29,18,41,260,24]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u,S,f,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function p(i,o,t){try{const n=JSON.parse(i);if(!o)return(0,P.isUndefined)(n.all)?null:n.all;switch(O.OS){case 2:return(0,P.isUndefined)(n.mac)?null:n.mac;case 3:return(0,P.isUndefined)(n.linux)?null:n.linux;case 1:return(0,P.isUndefined)(n.windows)?null:n.windows}}catch(n){return t.error(n),null}}e.getKeybindingsContentFromSyncContent=p;let w=class extends f.AbstractJsonFileSynchroniser{constructor(o,t,n,s,a,r,h,g,v,A,N,F,M){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},t,g,v,A,n,s,h,F,a,N,r,M),this.mb=2,this.zb=this.h.joinPath(this.g,"keybindings.json"),this.Ab=this.zb.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),this.Bb=this.zb.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.Cb=this.zb.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Db=this.zb.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.B(D.Event.filter(r.onDidChangeConfiguration,L=>L.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async nb(o,t,n,s){const a=o.syncData?p(o.syncData.content,s.keybindingsPerPlatform??this.Lb(),this.L):null;t=t===null&&n?o:t;const r=t?this.Jb(t):null,h=await this.p(),g=await this.xb();let v=null,A=!1,N=!1,F=!1;if(a){let $=h?h.value.toString():"[]";if($=$||"[]",this.vb($,!0))throw new d.UserDataSyncError((0,I.localize)(0,null),"LocalInvalidContent",this.resource);if(!r||r!==$||r!==a){this.L.trace(`${this.y}: Merging remote keybindings with local keybindings...`);const z=await(0,c.merge)($,a,r,g,this.ub);z.hasChanges&&(v=z.mergeContent,F=z.hasConflicts,A=F||z.mergeContent!==$,N=F||z.mergeContent!==a)}}else h&&(this.L.trace(`${this.y}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),v=h.value.toString(),N=!0);const M={content:F?r:v,localChange:A?h?2:1:0,remoteChange:N?2:0,hasConflicts:F},L=h?h.value.toString():null;return[{fileContent:h,baseResource:this.Ab,baseContent:r,localResource:this.Bb,localContent:L,localChange:M.localChange,remoteResource:this.Cb,remoteContent:a,remoteChange:M.remoteChange,previewResource:this.zb,previewResult:M,acceptedResource:this.Db}]}async rb(o){const t=this.Jb(o);if(t===null)return!0;const n=await this.p(),s=n?n.value.toString():"",a=await this.xb(),r=await(0,c.merge)(s||"[]",t,t,a,this.ub);return r.hasConflicts||r.mergeContent!==t}async ob(o,t){return o.previewResult}async pb(o,t,n,s){if(this.h.isEqual(t,this.Bb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.Cb))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.zb))return n===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async qb(o,t,n,s){const{fileContent:a}=n[0][0];let{content:r,localChange:h,remoteChange:g}=n[0][1];if(h===0&&g===0&&this.L.info(`${this.y}: No changes found during synchronizing keybindings.`),r!==null&&(r=r.trim(),r=r||"[]",this.vb(r,!0)))throw new d.UserDataSyncError((0,I.localize)(1,null),"LocalInvalidContent",this.resource);if(h!==0&&(this.L.trace(`${this.y}: Updating local keybindings...`),a&&await this.kb(this.Kb(a.value.toString())),await this.r(r||"[]",a,s),this.L.info(`${this.y}: Updated local keybindings`)),g!==0){this.L.trace(`${this.y}: Updating remote keybindings...`);const v=this.Kb(r||"[]",o.syncData?.content);o=await this.jb(v,s?null:o.ref),this.L.info(`${this.y}: Updated remote keybindings`)}try{await this.C.del(this.zb)}catch{}t?.ref!==o.ref&&(this.L.trace(`${this.y}: Updating last synchronized keybindings...`),await this.cb(o,{platformSpecific:this.Lb()}),this.L.info(`${this.y}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.p();if(o){const t=(0,l.parse)(o.value.toString());if((0,k.isNonEmptyArray)(t))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Cb,o)||this.h.isEqual(this.Ab,o)||this.h.isEqual(this.Bb,o)||this.h.isEqual(this.Db,o)?this.ab(o):null}Jb(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Lb()?null:p(o.syncData.content,this.Lb(),this.L)}Kb(o,t){let n={};try{n=JSON.parse(t||"{}")}catch(s){this.L.error(s)}switch(this.Lb()?delete n.all:n.all=o,O.OS){case 2:n.mac=o;break;case 3:n.linux=o;break;case 1:n.windows=o;break}return JSON.stringify(n)}Lb(){return!!this.M.getValue(d.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};w=ye([G(2,d.IUserDataSyncStoreService),G(3,d.IUserDataSyncBackupStoreService),G(4,d.IUserDataSyncLogService),G(5,E.IConfigurationService),G(6,d.IUserDataSyncEnablementService),G(7,b.IFileService),G(8,C.IEnvironmentService),G(9,m.IStorageService),G(10,d.IUserDataSyncUtilService),G(11,y.ITelemetryService),G(12,u.IUriIdentityService)],w),e.KeybindingsSynchroniser=w;let R=class extends f.AbstractInitializer{constructor(o,t,n,s,a,r){super("keybindings",t,n,s,o,a,r)}async doInitialize(o){const t=o.syncData?this.i(o.syncData.content):null;if(!t){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,T.VSBuffer.fromString(t)),await this.n(o)}async c(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),t=(0,l.parse)(o.value.toString());return!(0,k.isNonEmptyArray)(t)}catch(o){return o.fileOperationResult===1}}i(o){try{return p(o,!0,this.j)}catch(t){return this.j.error(t),null}}};R=ye([G(0,b.IFileService),G(1,S.IUserDataProfilesService),G(2,C.IEnvironmentService),G(3,d.IUserDataSyncLogService),G(4,m.IStorageService),G(5,u.IUriIdentityService)],R),e.KeybindingsInitializer=R}),define(oe[122],ae([0,1,17,3,181,16,74,15,30,14,20,19,29,18,41,61,264,24]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u,S,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function d(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function p(i){const o=JSON.parse(i);return d(o)?o:{settings:i}}e.parseSettingsSyncContent=p;let w=class extends u.AbstractJsonFileSynchroniser{constructor(o,t,n,s,a,r,h,g,v,A,N,F,M,L){super(o.settingsResource,{syncResource:"settings",profile:o},t,n,s,a,r,h,N,F,g,v,A,L),this.zb=M,this.mb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.Jb=void 0}async getRemoteUserDataSyncConfiguration(o){const t=await this.getLastSyncUserData(),n=await this.R(o,t),s=this.Gb(n),a=new O.ConfigurationModelParser(c.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&a.parse(s.settings),a.configurationModel.getValue(c.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async nb(o,t,n){const s=await this.p(),a=await this.xb(),r=this.Gb(o);t=t===null&&n?o:t;const h=t?this.Gb(t):null,g=await this.Kb();let v=null,A=!1,N=!1,F=!1;if(r){let z=s?s.value.toString().trim():"{}";z=z||"{}",this.Lb(z),this.L.trace(`${this.y}: Merging remote settings with local settings...`);const x=(0,f.merge)(z,r.settings,h?h.settings:null,g,[],a);v=x.localContent||x.remoteContent,A=x.localContent!==null,N=x.remoteContent!==null,F=x.hasConflicts}else s&&(this.L.trace(`${this.y}: Remote settings does not exist. Synchronizing settings for the first time.`),v=s.value.toString().trim()||"{}",this.Lb(v),N=!0);const M=s?s.value.toString():null,L=h?.settings??null,$={content:F?L:v,localChange:A?2:0,remoteChange:N?2:0,hasConflicts:F};return[{fileContent:s,baseResource:this.baseResource,baseContent:L,localResource:this.localResource,localContent:M,localChange:$.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:$.remoteChange,previewResource:this.previewResource,previewResult:$,acceptedResource:this.acceptedResource}]}async rb(o){const t=this.Gb(o);if(t===null)return!0;const n=await this.p(),s=n?n.value.toString().trim():"",a=await this.Kb(),r=await this.xb();return(0,f.merge)(s||"{}",t.settings,t.settings,a,[],r).remoteContent!==null}async ob(o,t){const n=await this.xb(),s=await this.Kb();return{...o.previewResult,content:o.previewResult.content?(0,f.updateIgnoredSettings)(o.previewResult.content,"{}",s,n):null}}async pb(o,t,n,s){const a=await this.xb(),r=await this.Kb();if(this.h.isEqual(t,this.localResource))return{content:o.fileContent?(0,f.updateIgnoredSettings)(o.fileContent.value.toString(),"{}",r,a):null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.remoteResource))return{content:o.remoteContent!==null?(0,f.updateIgnoredSettings)(o.remoteContent,o.fileContent?o.fileContent.value.toString():"{}",r,a):null,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.previewResource))return n===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:n!==null?(0,f.updateIgnoredSettings)(n,o.fileContent?o.fileContent.value.toString():"{}",r,a):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async qb(o,t,n,s){const{fileContent:a}=n[0][0];let{content:r,localChange:h,remoteChange:g}=n[0][1];if(h===0&&g===0&&this.L.info(`${this.y}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Lb(r),h!==0&&(this.L.trace(`${this.y}: Updating local settings...`),a&&await this.kb(JSON.stringify(this.Ib(a.value.toString()))),await this.r(r,a,s),await this.M.reloadConfiguration(3),this.L.info(`${this.y}: Updated local settings`)),g!==0){const v=await this.xb(),A=this.Gb(o),N=await this.Kb(r);r=(0,f.updateIgnoredSettings)(r,A?A.settings:"{}",N,v),this.L.trace(`${this.y}: Updating remote settings...`),o=await this.jb(JSON.stringify(this.Ib(r)),s?null:o.ref),this.L.info(`${this.y}: Updated remote settings`)}try{await this.C.del(this.previewResource)}catch{}t?.ref!==o.ref&&(this.L.trace(`${this.y}: Updating last synchronized settings...`),await this.cb(o),this.L.info(`${this.y}: Updated last synchronized settings`))}async hasLocalData(){try{const o=await this.p();if(o){const t=await this.xb(),n=(0,S.edit)(o.value.toString(),[c.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,f.isEmpty)(n)}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.remoteResource,o)||this.h.isEqual(this.localResource,o)||this.h.isEqual(this.acceptedResource,o)||this.h.isEqual(this.baseResource,o)?this.ab(o):null}async ab(o){let t=await super.ab(o);if(t){const n=await this.xb(),s=await this.Kb();t=(0,f.updateIgnoredSettings)(t,"{}",s,n)}return t}Gb(o){return o.syncData?this.Hb(o.syncData.content):null}Hb(o){try{return p(o)}catch(t){this.L.error(t)}return null}Ib(o){return{settings:o}}async Kb(o){if(!this.Jb){this.Jb=this.ub.resolveDefaultIgnoredSettings();const n=T.Event.any(T.Event.filter(this.zb.onDidInstallExtensions,s=>s.some(({local:a})=>!!a)),T.Event.filter(this.zb.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Jb=void 0})}const t=await this.Jb;return(0,f.getIgnoredSettings)(t,this.M,o)}Lb(o){if(this.vb(o,!1))throw new c.UserDataSyncError((0,D.localize)(0,null),"LocalInvalidContent",this.resource)}};w=ye([G(2,E.IFileService),G(3,P.IEnvironmentService),G(4,C.IStorageService),G(5,c.IUserDataSyncStoreService),G(6,c.IUserDataSyncBackupStoreService),G(7,c.IUserDataSyncLogService),G(8,c.IUserDataSyncUtilService),G(9,l.IConfigurationService),G(10,c.IUserDataSyncEnablementService),G(11,b.ITelemetryService),G(12,I.IExtensionManagementService),G(13,m.IUriIdentityService)],w),e.SettingsSynchroniser=w;let R=class extends u.AbstractInitializer{constructor(o,t,n,s,a,r){super("settings",t,n,s,o,a,r)}async doInitialize(o){const t=o.syncData?this.i(o.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,k.VSBuffer.fromString(t.settings)),await this.n(o)}async c(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,f.isEmpty)(o.value.toString().trim())}catch(o){return o.fileOperationResult===1}}i(o){try{return p(o)}catch(t){this.j.error(t)}return null}};R=ye([G(0,E.IFileService),G(1,y.IUserDataProfilesService),G(2,P.IEnvironmentService),G(3,c.IUserDataSyncLogService),G(4,C.IStorageService),G(5,m.IUriIdentityService)],R),e.SettingsInitializer=R}),define(oe[123],ae([0,1,17,3,32,16,15,14,20,19,29,18,41,261,24]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function S(d){return JSON.parse(d.content)}e.parseSnippets=S;let f=class extends m.AbstractSynchroniser{constructor(p,w,R,i,o,t,n,s,a,r,h,g){super({syncResource:"snippets",profile:p},w,i,R,o,t,n,r,h,s,a,g),this.mb=1,this.p=p.snippetsHome,this.B(this.C.watch(R.userRoamingDataHome)),this.B(this.C.watch(this.p)),this.B(T.Event.filter(this.C.onDidFilesChange,v=>v.affects(this.p))(()=>this.triggerLocalChange()))}async nb(p,w,R){const i=await this.Cb(),o=this.Bb(i),t=p.syncData?this.Ab(p.syncData):null;w=w===null&&R?p:w;const n=w&&w.syncData?this.Ab(w.syncData):null;t?this.L.trace(`${this.y}: Merging remote snippets with local snippets...`):this.L.trace(`${this.y}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,y.merge)(o,t,n);return this.wb(s,i,t||{},n||{})}async rb(p){const w=p.syncData?this.Ab(p.syncData):null;if(w===null)return!0;const R=await this.Cb(),i=this.Bb(R),o=(0,y.merge)(i,w,w);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async ob(p,w){return p.previewResult}async pb(p,w,R,i){if(this.h.isEqualOrParent(w,this.g.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:p.fileContent?p.fileContent.value.toString():null,localChange:0,remoteChange:p.fileContent?p.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(w,this.g.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:p.remoteContent,localChange:p.remoteContent!==null?p.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(w,this.g))return R===void 0?{content:p.previewResult.content,localChange:p.previewResult.localChange,remoteChange:p.previewResult.remoteChange}:{content:R,localChange:R===null?p.fileContent!==null?3:0:2,remoteChange:R===null?p.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async qb(p,w,R,i){const o=R.map(([t,n])=>({...t,acceptResult:n}));o.every(({localChange:t,remoteChange:n})=>t===0&&n===0)&&this.L.info(`${this.y}: No changes found during synchronizing snippets.`),o.some(({localChange:t})=>t!==0)&&(await this.xb(o),await this.yb(o,i)),o.some(({remoteChange:t})=>t!==0)&&(p=await this.zb(o,p,i)),w?.ref!==p.ref&&(this.L.trace(`${this.y}: Updating last synchronized snippets...`),await this.cb(p),this.L.info(`${this.y}: Updated last synchronized snippets`));for(const{previewResource:t}of o)try{await this.C.del(t)}catch{}}wb(p,w,R,i){const o=new Map;for(const t of Object.keys(p.local.added)){const n={content:p.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};o.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[t],previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(p.local.updated)){const n={content:p.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},s=w[t]?w[t].value.toString():null;o.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[t],previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of p.local.removed){const n={content:null,hasConflicts:!1,localChange:3,remoteChange:0},s=w[t]?w[t].value.toString():null;o.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(p.remote.added)){const n={content:p.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},s=w[t]?w[t].value.toString():null;o.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(p.remote.updated)){const n={content:p.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},s=w[t]?w[t].value.toString():null;o.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[t],previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of p.remote.removed){const n={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[t],previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of p.conflicts){const n={content:i[t]??null,hasConflicts:!0,localChange:w[t]?2:1,remoteChange:R[t]?2:1},s=w[t]?w[t].value.toString():null;o.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[t]||null,localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(w))if(!o.has(t)){const n={content:w[t]?w[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},s=w[t]?w[t].value.toString():null;o.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[t]||null,localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...o.values()]}async resolveContent(p){return this.h.isEqualOrParent(p,this.g.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.h.isEqualOrParent(p,this.g.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.h.isEqualOrParent(p,this.g.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.h.isEqualOrParent(p,this.g.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.ab(p):null}async hasLocalData(){try{const p=await this.Cb();if(Object.keys(p).length)return!0}catch{}return!1}async xb(p){const w={};for(const R of p)R.fileContent&&(w[this.h.basename(R.localResource)]=R.fileContent);await this.kb(JSON.stringify(this.Bb(w)))}async yb(p,w){for(const{fileContent:R,acceptResult:i,localResource:o,remoteResource:t,localChange:n}of p)if(n!==0){const s=t?this.h.basename(t):this.h.basename(o),a=this.h.joinPath(this.p,s);n===3?(this.L.trace(`${this.y}: Deleting snippet...`,this.h.basename(a)),await this.C.del(a),this.L.info(`${this.y}: Deleted snippet`,this.h.basename(a))):n===1?(this.L.trace(`${this.y}: Creating snippet...`,this.h.basename(a)),await this.C.createFile(a,k.VSBuffer.fromString(i.content),{overwrite:w}),this.L.info(`${this.y}: Created snippet`,this.h.basename(a))):(this.L.trace(`${this.y}: Updating snippet...`,this.h.basename(a)),await this.C.writeFile(a,k.VSBuffer.fromString(i.content),w?void 0:R),this.L.info(`${this.y}: Updated snippet`,this.h.basename(a)))}}async zb(p,w,R){const i=w.syncData?this.Ab(w.syncData):{},o=(0,D.deepClone)(i);for(const{acceptResult:t,localResource:n,remoteResource:s,remoteChange:a}of p)if(a!==0){const r=n?this.h.basename(n):this.h.basename(s);a===3?delete o[r]:o[r]=t.content}return(0,y.areSame)(i,o)||(this.L.trace(`${this.y}: Updating remote snippets...`),w=await this.jb(JSON.stringify(o),R?null:w.ref),this.L.info(`${this.y}: Updated remote snippets`)),w}Ab(p){return S(p)}Bb(p){const w={};for(const R of Object.keys(p))w[R]=p[R].value.toString();return w}async Cb(){const p={};let w;try{w=await this.C.resolve(this.p)}catch(R){if(R instanceof P.FileOperationError&&R.fileOperationResult===1)return p;throw R}for(const R of w.children||[]){const i=R.resource,o=this.h.extname(i);if(o===".json"||o===".code-snippets"){const t=this.h.relativePath(this.p,i),n=await this.C.readFile(i);p[t]=n}}return p}};f=ye([G(2,O.IEnvironmentService),G(3,P.IFileService),G(4,I.IStorageService),G(5,u.IUserDataSyncStoreService),G(6,u.IUserDataSyncBackupStoreService),G(7,u.IUserDataSyncLogService),G(8,l.IConfigurationService),G(9,u.IUserDataSyncEnablementService),G(10,E.ITelemetryService),G(11,C.IUriIdentityService)],f),e.SnippetsSynchroniser=f;let c=class extends m.AbstractInitializer{constructor(p,w,R,i,o,t){super("snippets",w,R,i,p,o,t)}async doInitialize(p){const w=p.syncData?JSON.parse(p.syncData.content):null;if(!w){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(w)){const o=w[i];if(o){const t=this.d.joinPath(this.g.defaultProfile.snippetsHome,i);await this.k.createFile(t,k.VSBuffer.fromString(o)),this.j.info("Created snippet",this.d.basename(t))}}await this.n(p)}async c(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(p){return p.fileOperationResult===1}}};c=ye([G(0,P.IFileService),G(1,b.IUserDataProfilesService),G(2,O.IEnvironmentService),G(3,u.IUserDataSyncLogService),G(4,I.IStorageService),G(5,C.IUriIdentityService)],c),e.SnippetsInitializer=c}),define(oe[124],ae([0,1,17,16,15,14,20,19,29,18,41,24]),function(Q,e,k,T,D,l,O,P,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function m(f,c){try{return JSON.parse(f).tasks??null}catch(d){return c.error(d),null}}e.getTasksContentFromSyncContent=m;let y=class extends C.AbstractFileSynchroniser{constructor(c,d,p,w,R,i,o,t,n,s,a,r){super(c.tasksResource,{syncResource:"tasks",profile:c},d,t,n,s,p,w,o,a,R,i,r),this.mb=1,this.vb=this.h.joinPath(this.g,"tasks.json"),this.wb=this.vb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"base"}),this.xb=this.vb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"local"}),this.yb=this.vb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.zb=this.vb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async nb(c,d,p,w){const R=c.syncData?m(c.syncData.content,this.L):null;d=d===null&&p?c:d;const i=d?.syncData?m(d.syncData.content,this.L):null,o=await this.p();let t=null,n=!1,s=!1,a=!1;if(c.syncData){const g=o?o.value.toString():null;if(!i||i!==g||i!==R){this.L.trace(`${this.y}: Merging remote tasks with local tasks...`);const v=S(g,R,i);t=v.content,a=v.hasConflicts,n=v.hasLocalChanged,s=v.hasRemoteChanged}}else o&&(this.L.trace(`${this.y}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=o.value.toString(),s=!0);const r={content:a?i:t,localChange:n?o?2:1:0,remoteChange:s?2:0,hasConflicts:a},h=o?o.value.toString():null;return[{fileContent:o,baseResource:this.wb,baseContent:i,localResource:this.xb,localContent:h,localChange:r.localChange,remoteResource:this.yb,remoteContent:R,remoteChange:r.remoteChange,previewResource:this.vb,previewResult:r,acceptedResource:this.zb}]}async rb(c){const d=c?.syncData?m(c.syncData.content,this.L):null;if(d===null)return!0;const p=await this.p(),w=p?p.value.toString():null,R=S(w,d,d);return R.hasLocalChanged||R.hasRemoteChanged}async ob(c,d){return c.previewResult}async pb(c,d,p,w){if(this.h.isEqual(d,this.xb))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(d,this.yb))return{content:c.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(d,this.vb))return p===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:p,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async qb(c,d,p,w){const{fileContent:R}=p[0][0],{content:i,localChange:o,remoteChange:t}=p[0][1];if(o===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing tasks.`),o!==0&&(this.L.trace(`${this.y}: Updating local tasks...`),R&&await this.kb(JSON.stringify(this.Fb(R.value.toString()))),i?await this.r(i,R,w):await this.sb(),this.L.info(`${this.y}: Updated local tasks`)),t!==0){this.L.trace(`${this.y}: Updating remote tasks...`);const n=JSON.stringify(this.Fb(i));c=await this.jb(n,w?null:c.ref),this.L.info(`${this.y}: Updated remote tasks`)}try{await this.C.del(this.vb)}catch{}d?.ref!==c.ref&&(this.L.trace(`${this.y}: Updating last synchronized tasks...`),await this.cb(c),this.L.info(`${this.y}: Updated last synchronized tasks`))}async hasLocalData(){return this.C.exists(this.i)}async resolveContent(c){return this.h.isEqual(this.yb,c)||this.h.isEqual(this.wb,c)||this.h.isEqual(this.xb,c)||this.h.isEqual(this.zb,c)?this.ab(c):null}Fb(c){return c?{tasks:c}:{}}};y=ye([G(2,b.IUserDataSyncStoreService),G(3,b.IUserDataSyncBackupStoreService),G(4,b.IUserDataSyncLogService),G(5,T.IConfigurationService),G(6,b.IUserDataSyncEnablementService),G(7,l.IFileService),G(8,D.IEnvironmentService),G(9,O.IStorageService),G(10,P.ITelemetryService),G(11,I.IUriIdentityService)],y),e.TasksSynchroniser=y;let u=class extends C.AbstractInitializer{constructor(c,d,p,w,R,i){super("tasks",d,p,w,c,R,i),this.c=this.g.defaultProfile.tasksResource}async doInitialize(c){const d=c.syncData?m(c.syncData.content,this.j):null;if(!d){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,k.VSBuffer.fromString(d)),await this.n(c)}async i(){return this.k.exists(this.c)}};u=ye([G(0,l.IFileService),G(1,E.IUserDataProfilesService),G(2,D.IEnvironmentService),G(3,b.IUserDataSyncLogService),G(4,O.IStorageService),G(5,I.IUriIdentityService)],u),e.TasksInitializer=u;function S(f,c,d){if(f===null&&c===null&&d===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(f===c)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const p=d!==f,w=d!==c;return!p&&!w?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:p&&!w?{content:f,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:w&&!p?{content:c,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:f,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[125],ae([0,1,43,16,15,14,20,19,29,18,41,262,24]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let y=class extends C.AbstractSynchroniser{constructor(c,d,p,w,R,i,o,t,n,s,a,r,h){super({syncResource:"profiles",profile:c},d,w,R,i,o,t,a,r,n,s,h),this.r=p,this.mb=1,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const c=await this.getLastSyncUserData();return c?.syncData?S(c.syncData):null}async getRemoteSyncedProfiles(c){const d=await this.getLastSyncUserData(),p=await this.R(c,d);return p?.syncData?S(p.syncData):null}async nb(c,d,p){if(!this.r.isEnabled())throw new m.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const w=c.syncData?S(c.syncData):null,R=d?.syncData?S(d.syncData):null,i=this.zb(),{local:o,remote:t}=(0,b.merge)(i,w,R,[]),n={local:o,remote:t,content:R?this.Ab(R):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:t!==null?2:0},s=u(i,!1);return[{baseResource:this.baseResource,baseContent:R?this.Ab(R):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:w?this.Ab(w):null,remoteProfiles:w,previewResource:this.previewResource,previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.acceptedResource}]}async rb(c){const d=c?.syncData?S(c.syncData):null,p=this.zb(),{remote:w}=(0,b.merge)(p,d,d,[]);return!!w?.added.length||!!w?.removed.length||!!w?.updated.length}async ob(c,d){return{...c.previewResult,hasConflicts:!1}}async pb(c,d,p,w){if(this.h.isEqual(d,this.localResource))return this.wb(c);if(this.h.isEqual(d,this.remoteResource))return this.xb(c);if(this.h.isEqual(d,this.previewResource))return c.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async wb(c){const d=this.zb(),p=(0,b.merge)(d,null,null,[]),{local:w,remote:R}=p;return{content:c.localContent,local:w,remote:R,localChange:w.added.length>0||w.removed.length>0||w.updated.length>0?2:0,remoteChange:R!==null?2:0}}async xb(c){const d=c.remoteContent?JSON.parse(c.remoteContent):null,p=[],w=[];for(const R of this.zb()){const i=d?.find(o=>o.id===R.id);i&&(p.push({id:R.id,name:R.name,collection:i.collection}),w.push(R))}if(d!==null){const R=(0,b.merge)(w,d,p,[]),{local:i,remote:o}=R;return{content:c.remoteContent,local:i,remote:o,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:c.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(c,d,p,w){const{local:R,remote:i,localChange:o,remoteChange:t}=p[0][1];o===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing profiles.`);const n=p[0][0].remoteProfiles||[];if(n.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new m.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.kb(u(this.zb(),!1));const s=[];for(const a of R.added)s.push((async()=>{this.L.trace(`${this.y}: Creating '${a.name}' profile...`),await this.r.createProfile(a.id,a.name,{shortName:a.shortName}),this.L.info(`${this.y}: Created profile '${a.name}'.`)})());for(const a of R.removed)s.push((async()=>{this.L.trace(`${this.y}: Removing '${a.name}' profile...`),await this.r.removeProfile(a),this.L.info(`${this.y}: Removed profile '${a.name}'.`)})());for(const a of R.updated){const r=this.r.profiles.find(h=>h.id===a.id);r?s.push((async()=>{this.L.trace(`${this.y}: Updating '${a.name}' profile...`),await this.r.updateProfile(r,{name:a.name,shortName:a.shortName}),this.L.info(`${this.y}: Updated profile '${a.name}'.`)})()):this.L.info(`${this.y}: Could not find profile with id '${a.id}' to update.`)}await Promise.all(s)}if(t!==0){this.L.trace(`${this.y}: Updating remote profiles...`);const s=[],a=n.length+(i?.added.length??0)<=20;if(a)for(const r of i?.added||[]){const h=await this.G.createCollection(this.z);s.push(h),n.push({id:r.id,name:r.name,collection:h,shortName:r.shortName})}else this.L.info(`${this.y}: Could not create remote profiles as there are too many profiles.`);for(const r of i?.removed||[])n.splice(n.findIndex(({id:h})=>r.id===h),1);for(const r of i?.updated||[]){const h=n.find(({id:g})=>r.id===g);h&&n.splice(n.indexOf(h),1,{id:r.id,name:r.name,collection:h.collection,shortName:r.shortName})}try{c=await this.updateRemoteProfiles(n,w?null:c.ref),this.L.info(`${this.y}: Updated remote profiles.${a&&i?.added.length?` Added: ${JSON.stringify(i.added.map(r=>r.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(r=>r.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(r=>r.name))}.`:""}`)}catch(r){if(s.length){this.L.info(`${this.y}: Failed to update remote profiles. Cleaning up added collections...`);for(const h of s)await this.G.deleteCollection(h,this.z)}throw r}for(const r of i?.removed||[])await this.G.deleteCollection(r.collection,this.z)}d?.ref!==c.ref&&(this.L.trace(`${this.y}: Updating last synchronized profiles...`),await this.cb(c),this.L.info(`${this.y}: Updated last synchronized profiles.`))}async updateRemoteProfiles(c,d){return this.jb(this.Ab(c),d)}async hasLocalData(){return this.zb().length>0}async resolveContent(c){if(this.h.isEqual(this.remoteResource,c)||this.h.isEqual(this.baseResource,c)||this.h.isEqual(this.localResource,c)||this.h.isEqual(this.acceptedResource,c)){const d=await this.ab(c);return d&&(0,k.toFormattedString)(JSON.parse(d),{})}return null}zb(){return this.r.profiles.filter(c=>!c.isDefault&&!c.isTransient)}Ab(c){return JSON.stringify([...c].sort((d,p)=>d.name.localeCompare(p.name)))}};y=ye([G(2,E.IUserDataProfilesService),G(3,l.IFileService),G(4,D.IEnvironmentService),G(5,O.IStorageService),G(6,m.IUserDataSyncStoreService),G(7,m.IUserDataSyncBackupStoreService),G(8,m.IUserDataSyncLogService),G(9,T.IConfigurationService),G(10,m.IUserDataSyncEnablementService),G(11,P.ITelemetryService),G(12,I.IUriIdentityService)],y),e.UserDataProfilesManifestSynchroniser=y;function u(f,c){const d=[...f].sort((p,w)=>p.name.localeCompare(w.name)).map(p=>({id:p.id,name:p.name}));return c?(0,k.toFormattedString)(d,{}):JSON.stringify(d)}e.stringifyLocalProfiles=u;function S(f){return JSON.parse(f.content)}e.parseUserDataProfilesManifest=S}),define(oe[278],ae([0,1,6,17,65,2,22,16,15,14,18,24]),function(Q,e,k,T,D,l,O,P,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let m=class extends l.Disposable{constructor(u,S,f,c,d){super(),this.a=u,this.b=S,this.c=f,this.f=c,this.g=d,this.h()}async h(){for(const S of this.g.profiles)for(const f of b.ALL_SYNC_RESOURCES)try{await this.j(this.i(S,f))}catch(c){this.f.error(c)}let u;try{u=await this.b.resolve(this.a.userDataSyncHome)}catch(S){(0,E.toFileOperationResult)(S)!==1&&this.f.error(S);return}if(u.children){for(const S of u.children)if(S.isDirectory&&!this.g.profiles.some(f=>f.id===S.name))try{this.f.info("Deleting non existing profile from backup",S.resource.path),await this.b.del(S.resource,{recursive:!0})}catch(f){this.f.error(f)}}}async getAllRefs(u,S){const f=this.i(u,S),c=await this.b.resolve(f);return c.children?c.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort().reverse().map(p=>({ref:p.name,created:this.k(p)})):[]}async resolveContent(u,S,f){const c=this.i(u,S),d=(0,O.joinPath)(c,f);try{return(await this.b.readFile(d)).value.toString()}catch(p){return this.f.error(p),null}}async backup(u,S,f){const c=this.i(u,S),d=(0,O.joinPath)(c,`${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(d,T.VSBuffer.fromString(f))}catch(p){this.f.error(p)}try{this.j(c)}catch{}}i(u,S){return(0,O.joinPath)(this.a.userDataSyncHome,...u.isDefault?[S]:[u.id,S])}async j(u){try{try{if(!await this.b.exists(u))return}catch{return}const S=await this.b.resolve(u);if(S.children){const f=S.children.filter(w=>w.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(w.name)).sort(),c=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let d=f.filter(w=>Date.now()-this.k(w)>c);const p=f.length-d.length;p<10&&(d=d.slice(10-p)),await k.Promises.settled(d.map(async w=>{this.f.info("Deleting from backup",w.resource.path),await this.b.del(w.resource)}))}}catch(S){this.f.error(S)}}k(u){return u.ctime||new Date(parseInt(u.name.substring(0,4)),parseInt(u.name.substring(4,6))-1,parseInt(u.name.substring(6,8)),parseInt(u.name.substring(9,11)),parseInt(u.name.substring(11,13)),parseInt(u.name.substring(13,15))).getTime()}};m=ye([G(0,I.IEnvironmentService),G(1,E.IFileService),G(2,P.IConfigurationService),G(3,b.IUserDataSyncLogService),G(4,C.IUserDataProfilesService)],m),e.UserDataSyncBackupStoreService=m}),define(oe[279],ae([0,1,3,2,4,15,20,19,24]),function(Q,e,k,T,D,l,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const E="sync.enable";let C=class extends T.Disposable{constructor(m,y,u,S){super(),this.c=m,this.f=y,this.g=u,this.h=S,this.a=new k.Emitter,this.onDidChangeEnablement=this.a.event,this.b=new k.Emitter,this.onDidChangeResourceEnablement=this.b.event,this.B(m.onDidChangeValue(f=>this.j(f)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(E,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.f.publicLog2(E,{enabled:m}),this.c.store(E,m,-1,1))}isResourceEnabled(m){return this.c.getBoolean((0,I.getEnablementKey)(m),-1,!0)}setResourceEnablement(m,y){if(this.isResourceEnabled(m)!==y){const u=(0,I.getEnablementKey)(m);this.i(u,y)}}getResourceSyncStateVersion(m){}i(m,y){this.c.store(m,y,-1,D.isWeb?0:1)}j(m){if(m.scope!==-1)return;if(E===m.key){this.a.fire(this.isEnabled());return}const y=I.ALL_SYNC_RESOURCES.filter(u=>(0,I.getEnablementKey)(u)===m.key)[0];if(y){this.b.fire([y,this.isResourceEnabled(y)]);return}}};C=ye([G(0,O.IStorageService),G(1,P.ITelemetryService),G(2,l.IEnvironmentService),G(3,I.IUserDataSyncStoreManagementService)],C),e.UserDataSyncEnablementService=C}),define(oe[81],ae([0,1,3,2,4,27,185,15,14,5,23,45,20,24]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,E.createDecorator)("IUserDataSyncMachinesService");const u="sync.currentMachineName",S="Safari",f="Chrome",c="Edge",d="Firefox",p="Android";function w(o){switch(o){case S:case f:case c:case d:case p:case(0,D.PlatformToString)(0):return!0}return!1}e.isWebPlatform=w;function R(){return D.isSafari?S:D.isChrome?f:D.isEdge?c:D.isFirefox?d:D.isAndroid?p:(0,D.PlatformToString)(D.isWeb?0:D.platform)}let i=class st extends T.Disposable{constructor(t,n,s,a,r,h){super(),this.h=s,this.i=a,this.j=r,this.k=h,this.c=this.B(new k.Emitter),this.onDidChange=this.c.event,this.g=null,this.f=(0,b.getServiceMachineId)(t,n,s)}async getMachines(t){const n=await this.f;return(await this.m(t)).machines.map(a=>({...a,isCurrent:a.id===n}))}async addCurrentMachine(t){const n=await this.f,s=await this.m(t);s.machines.some(({id:a})=>a===n)||(s.machines.push({id:n,name:this.l(s.machines),platform:R()}),await this.n(s))}async removeCurrentMachine(t){const n=await this.f,s=await this.m(t),a=s.machines.filter(({id:r})=>r!==n);a.length!==s.machines.length&&(s.machines=a,await this.n(s))}async renameMachine(t,n,s){const a=await this.m(s),r=a.machines.find(({id:h})=>h===t);if(r){r.name=n,await this.n(a);const h=await this.f;t===h&&this.h.store(u,n,-1,1)}}async setEnablements(t){const n=await this.m();for(const[s,a]of t){const r=n.machines.find(h=>h.id===s);r&&(r.disabled=a?void 0:!0)}await this.n(n)}l(t){const n=this.h.get(u,-1);if(n)return n;const s=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${R()} (${this.k.nameShort})`,a=new RegExp(`${(0,l.escapeRegExpCharacters)(s)}\\s#(\\d+)`);let r=0;for(const h of t){const g=a.exec(h.name),v=g?parseInt(g[1]):0;r=v>r?v:r}return`${s} #${r+1}`}async m(t){this.g=await this.p(t);const n=this.r(this.g);if(n.version!==st.a)throw new Error((0,O.localize)(0,null,this.k.nameLong));return n}async n(t){const n=JSON.stringify(t),s=await this.i.writeResource(st.b,n,this.g?.ref||null);this.g={ref:s,content:n},this.c.fire()}async p(t){if(this.g){const n=t&&t.latest?t.latest[st.b]:void 0;if(this.g.ref===n)return this.g;if(n===void 0&&this.g.content===null)return this.g}return this.i.readResource(st.b,this.g)}r(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(n){this.j.error(n)}return{version:st.a,machines:[]}}};i.a=1,i.b="machines",i=ye([G(0,P.IEnvironmentService),G(1,I.IFileService),G(2,m.IStorageService),G(3,y.IUserDataSyncStoreService),G(4,y.IUserDataSyncLogService),G(5,C.IProductService)],i),e.UserDataSyncMachinesService=i}),define(oe[280],ae([0,1,6,65,38,9,3,2,4,22,11,182,23,20,19,24,78,81]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u,S,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const d="sync.disableMachineEventually",p="sync.sessionId",w="sync.storeUrl",R="sync.productQuality";let i=class extends P.Disposable{get j(){const n=this.z.get(w,-1);return n?C.URI.parse(n):void 0}set j(n){n?this.z.store(w,n.toString(),-1,1):this.z.remove(w,-1)}get l(){return this.z.get(R,-1)}set l(n){n?this.z.store(R,n,-1,1):this.z.remove(R,-1)}constructor(n,s,a,r,h,g,v,A,N,F){super(),this.n=s,this.p=a,this.r=r,this.s=h,this.u=g,this.v=v,this.w=A,this.y=N,this.z=F,this.a=this.B(new P.MutableDisposable),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.Emitter),this.onError=this.h.event,this.N=[],this.f=this.B(new k.ThrottledDelayer(this.O())),this.i=this.j,this.j=s.userDataSyncStore?.url,this.k=this.l,this.l=n.quality,this.j&&(this.u.info("Using settings sync service",this.j.toString()),this.B(s.onDidChangeUserDataSyncStore(()=>{(0,E.isEqual)(this.j,s.userDataSyncStore?.url)||(this.i=this.j,this.j=s.userDataSyncStore?.url,this.j&&this.u.info("Using settings sync service",this.j.toString()))})),this.r.isEnabled()?this.u.info("Auto Sync is enabled."):this.u.info("Auto Sync is disabled."),this.C(),this.L()&&this.J(),this.B(v.onDidChangeAccount(()=>this.C())),this.B(a.onDidChangeDonotMakeRequestsUntil(()=>this.C())),this.B(h.onDidChangeLocal(M=>this.triggerSync([M],!1,!1))),this.B(O.Event.filter(this.r.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}C(){const{enabled:n,message:s}=this.F();n?this.a.value===void 0&&(this.a.value=new o(this.i,1e3*60*5,this.n,this.p,this.s,this.y,this.u,this.z),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(a=>this.I(a))),this.D()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(s&&this.u.info(s),this.a.clear()):s&&this.r.isEnabled()&&this.u.info(s))}D(){return!0}F(){return this.r.isEnabled()?this.v.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,T.toLocalISOString)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(n,s,a){try{this.v.account&&!a&&await this.y.removeCurrentMachine(),this.G(!1),this.z.remove(p,-1),n?(this.w.publicLog2("sync/turnOffEveryWhere"),await this.s.reset()):await this.s.resetLocal()}catch(r){if(this.u.error(r),s)this.G(!1);else throw r}}G(n){this.r.isEnabled()!==n&&(this.r.setEnablement(n),this.C())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(n){if(!n){this.b=0;return}const s=S.UserDataSyncError.toUserDataSyncError(n);s instanceof S.UserDataAutoSyncError&&this.w.publicLog2("autosync/error",{code:s.code,service:this.n.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"?(this.g=!0,this.u.info("Auto Sync: Suspended sync because of making too many requests to server"),this.C()):s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?I.isWeb&&s.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.u.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.u.error(s),this.b++),this.h.fire(s)}async J(){this.z.store(d,!0,-1,1),await(0,k.timeout)(1e3*60*10),this.L()&&(this.M(),!this.r.isEnabled()&&this.v.account&&await this.y.removeCurrentMachine())}L(){return this.z.getBoolean(d,-1,!1)}M(){this.z.remove(d,-1)}async triggerSync(n,s,a){if(this.a.value===void 0)return this.f.cancel();if(s&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.u.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...n),this.f.trigger(async()=>{this.u.trace("activity sources",...this.N);const r=this.v.account?.authenticationProviderId||"";this.w.publicLog2("sync/triggered",{sources:this.N,providerId:r}),this.N=[],this.a.value&&await this.a.value.sync("Activity",a)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};i=ye([G(0,m.IProductService),G(1,S.IUserDataSyncStoreManagementService),G(2,S.IUserDataSyncStoreService),G(3,S.IUserDataSyncEnablementService),G(4,S.IUserDataSyncService),G(5,S.IUserDataSyncLogService),G(6,f.IUserDataSyncAccountService),G(7,u.ITelemetryService),G(8,c.IUserDataSyncMachinesService),G(9,y.IStorageService)],i),e.UserDataAutoSyncService=i;class o extends P.Disposable{constructor(n,s,a,r,h,g,v,A){super(),this.j=n,this.k=s,this.l=a,this.m=r,this.n=h,this.p=g,this.r=v,this.s=A,this.b=this.B(new P.MutableDisposable),this.c=this.B(new O.Emitter),this.onDidStartSync=this.c.event,this.f=this.B(new O.Emitter),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.u())),this.B((0,P.toDisposable)(()=>{this.i&&(this.i.cancel(),this.r.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.r.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}u(){this.b.value=(0,k.disposableTimeout)(()=>this.sync(o.a,!1),this.k)}sync(n,s){const a=(0,k.createCancelablePromise)(async r=>{if(this.i)try{this.r.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(h){if((0,l.isCancellationError)(h))return}return this.y(n,s,r)});return this.i=a,this.i.finally(()=>this.i=void 0),this.i}v(){return this.j!==void 0&&!(0,E.isEqual)(this.j,this.l.userDataSyncStore?.url)}async w(){const n=await this.l.getPreviousUserDataSyncStore(),s=this.l.userDataSyncStore;return!!s&&!!n&&(!(0,E.isEqual)(s.defaultUrl,n.defaultUrl)||!(0,E.isEqual)(s.insidersUrl,n.insidersUrl)||!(0,E.isEqual)(s.stableUrl,n.stableUrl))}async y(n,s,a){this.r.info(`Auto Sync: Triggered by ${n}`),this.c.fire();let r;try{await this.z(s,a)}catch(h){if(this.r.error(h),r=h,S.UserDataSyncError.toUserDataSyncError(h).code==="MethodNotFound")try{this.r.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.n.cleanUpRemoteData(),this.r.info("Auto Sync: Retrying sync..."),await this.z(s,a),r=void 0}catch(g){this.r.error(g),r=g}}this.f.fire(r)}async z(n,s){if(this.h=await this.n.createSyncTask(this.g,n),s.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.v()?await this.w()?new S.UserDataAutoSyncError((0,b.localize)(0,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,b.localize)(1,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,b.localize)(2,null),"TurnedOff");const a=this.s.get(p,-1);if(a&&this.g&&a!==this.g.session)throw this.v()?await this.w()?new S.UserDataAutoSyncError((0,b.localize)(3,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,b.localize)(4,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,b.localize)(5,null),"SessionExpired");const r=await this.p.getMachines(this.g||void 0);if(s.isCancellationRequested)return;const h=r.find(g=>g.isCurrent);if(h?.disabled)throw new S.UserDataAutoSyncError((0,b.localize)(6,null),"TurnedOff");if(await this.h.run(),this.g===null)try{this.g=await this.m.manifest(null)}catch(g){throw new S.UserDataAutoSyncError((0,D.toErrorMessage)(g),g instanceof S.UserDataSyncError?g.code:"Unknown")}this.g&&this.g.session!==a&&this.s.store(p,this.g.session,-1,1),!s.isCancellationRequested&&(h||await this.p.addCurrentMachine(this.g||void 0))}register(n){return super.B(n)}}o.a="Interval"}),define(oe[281],ae([0,1,11,186,15,14,45,20,29,24,18,41,123,122,121,16,124,119,120,5,125,43]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u,S,f,c,d,p,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let i=class Ve{constructor(t,n,s,a,r,h,g,v,A,N){this.e=t,this.f=n,this.g=s,this.h=r,this.i=h,this.j=g,this.k=v,this.l=A,this.m=N,this.d=a.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const n=this.K(t.content,"profiles");return(0,w.parseUserDataProfilesManifest)(n)}return[]}async getRemoteSyncResourceHandles(t,n){return(await this.e.getAllResourceRefs(t,n?.collection)).map(({created:a,ref:r})=>({created:a,uri:this.I({remote:!0,syncResource:t,profile:n?.id??this.k.defaultProfile.id,collection:n?.collection,ref:r,node:void 0})}))}async getLocalSyncResourceHandles(t,n){return(await this.f.getAllRefs(n,t)).map(({created:a,ref:r})=>({created:a,uri:this.I({remote:!1,syncResource:t,profile:n.id,collection:void 0,ref:r,node:void 0})}))}resolveUserDataSyncResource({uri:t}){const n=this.J(t),s=n?this.k.profiles.find(a=>a.id===n.profile):void 0;return n&&s?{profile:s,syncResource:n?.syncResource}:void 0}async getAssociatedResources({uri:t}){const n=this.J(t);if(!n)return[];const s=this.k.profiles.find(a=>a.id===n.profile);switch(n.syncResource){case"settings":return this.r(t,s);case"keybindings":return this.t(t,s);case"tasks":return this.v(t,s);case"snippets":return this.x(t,s);case"globalState":return this.C(t,s);case"extensions":return this.z(t,s);case"profiles":return this.F(t,s)}}async getMachineId({uri:t}){const n=this.J(t);if(!!n){if(n.remote){if(n.ref){const{content:s}=await this.L(n.syncResource,n.ref,n.collection);if(s)return this.K(s,n.syncResource)?.machineId}return}return(0,O.getServiceMachineId)(this.h,this.j,this.i)}}async resolveContent(t){const n=this.J(t);if(!n||n.node===Ve.a)return null;if(n.ref){const s=await this.n(n.remote,n.syncResource,n.profile,n.collection,n.ref);return n.node&&s?this.o(n.syncResource,s,n.node):s}return!n.remote&&!n.node?this.q(n.syncResource,n.profile):null}async n(t,n,s,a,r){if(t){const{content:g}=await this.L(n,r,a);return g}const h=this.k.profiles.find(g=>g.id===s);return h?this.f.resolveContent(h,n,r):null}o(t,n,s){const a=this.K(n,t);switch(t){case"settings":return this.s(a,s);case"keybindings":return this.u(a,s);case"tasks":return this.w(a,s);case"snippets":return this.y(a,s);case"globalState":return this.D(a,s);case"extensions":return this.A(a,s);case"profiles":return this.G(a,s)}}async q(t,n){const s=this.k.profiles.find(a=>a.id===n);if(!s)return null;switch(t){case"globalState":return this.E(s);case"extensions":return this.B(s);case"profiles":return this.H(s);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}r(t,n){const s=this.d.joinPath(t,"settings.json"),a=n?n.settingsResource:this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:a}]}s(t,n){switch(n){case"settings.json":return(0,y.parseSettingsSyncContent)(t.content).settings}return null}t(t,n){const s=this.d.joinPath(t,"keybindings.json"),a=n?n.keybindingsResource:this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:a}]}u(t,n){switch(n){case"keybindings.json":return(0,u.getKeybindingsContentFromSyncContent)(t.content,!!this.l.getValue(E.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.g)}return null}v(t,n){const s=this.d.joinPath(t,"tasks.json"),a=n?n.tasksResource:this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:a}]}w(t,n){switch(n){case"tasks.json":return(0,f.getTasksContentFromSyncContent)(t.content,this.g)}return null}async x(t,n){const s=await this.resolveContent(t);if(s){const a=this.K(s,"snippets");if(a){const r=(0,m.parseSnippets)(a),h=[];for(const g of Object.keys(r)){const v=this.d.joinPath(t,g),A=n?this.d.joinPath(n.snippetsHome,g):this.d.joinPath(t,Ve.a);h.push({resource:v,comparableResource:A})}return h}}return[]}y(t,n){return(0,m.parseSnippets)(t)[n]||null}z(t,n){const s=this.d.joinPath(t,"extensions.json"),a=n?this.I({remote:!1,syncResource:"extensions",profile:n.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:a}]}A(t,n){switch(n){case"extensions.json":return(0,c.stringify)((0,c.parseExtensions)(t),!0)}return null}async B(t){const{localExtensions:n}=await this.m.createInstance(c.LocalExtensionsProvider).getLocalExtensions(t);return(0,c.stringify)(n,!0)}C(t,n){const s=this.d.joinPath(t,"globalState.json"),a=n?this.I({remote:!1,syncResource:"globalState",profile:n.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:a}]}D(t,n){switch(n){case"globalState.json":return(0,d.stringify)(JSON.parse(t.content),!0)}return null}async E(t){const n=await this.m.createInstance(d.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,d.stringify)(n,!0)}F(t,n){const s=this.d.joinPath(t,"profiles.json"),a=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:s,comparableResource:a}]}G(t,n){switch(n){case"profiles.json":return(0,R.toFormattedString)(JSON.parse(t.content),{})}return null}async H(t){return(0,w.stringifyLocalProfiles)(this.k.profiles.filter(n=>!n.isDefault&&!n.isTransient),!0)}I(t){const n=t.remote?Ve.b:Ve.c,s=[t.syncResource,t.profile];return t.collection&&s.push(`collection:${t.collection}`),t.ref&&s.push(`ref:${t.ref}`),t.node&&s.push(t.node),this.d.joinPath(k.URI.from({scheme:E.USER_DATA_SYNC_SCHEME,authority:n,path:"/"}),...s)}J(t){if(t.scheme!==E.USER_DATA_SYNC_SCHEME||t.authority!==Ve.c&&t.authority!==Ve.b)return;const n=[];for(;t.path!=="/";)n.unshift(this.d.basename(t)),t=this.d.dirname(t);if(n.length<2)return;const s=t.authority===Ve.b,a=n.shift(),r=n.shift();let h,g,v;for(;n.length;){const A=n.shift();A.startsWith("collection:")?h=A.substring(11):A.startsWith("ref:")?g=A.substring(4):v=A}return{remote:s,syncResource:a,profile:r,collection:h,ref:g,node:v}}K(t,n){try{const s=JSON.parse(t);if((0,b.isSyncData)(s))return s}catch(s){this.g.error(s)}throw new E.UserDataSyncError((0,T.localize)(0,null),"IncompatibleRemoteContent",n)}async L(t,n,s){const a=await this.e.resolveResourceContent(t,n,s);return{ref:n,content:a}}};i.a="not-existing-resource",i.b="remote-backup",i.c="local-backup",i=ye([G(0,E.IUserDataSyncStoreService),G(1,E.IUserDataSyncBackupStoreService),G(2,E.IUserDataSyncLogService),G(3,I.IUriIdentityService),G(4,D.IEnvironmentService),G(5,P.IStorageService),G(6,l.IFileService),G(7,C.IUserDataProfilesService),G(8,S.IConfigurationService),G(9,p.IInstantiationService)],i),e.UserDataSyncResourceProviderService=i}),define(oe[282],ae([0,1,21,6,25,38,3,2,22,12,31,16,30,5,20,19,18,119,120,121,122,123,124,125,24]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u,S,f,c,d,p,w,R,i,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const n="sync.lastSyncTime";let s=class extends P.Disposable{get status(){return this.f}get conflicts(){return this.i}get lastSyncTime(){return this.m}constructor(v,A,N,F,M,L,$,z,x){super(),this.v=v,this.w=A,this.y=N,this.z=F,this.C=M,this.D=L,this.F=$,this.G=z,this.H=x,this.f="uninitialized",this.g=this.B(new O.Emitter),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.Emitter),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.B(new O.Emitter),this.onDidChangeConflicts=this.j.event,this.k=[],this.l=this.B(new O.Emitter),this.onSyncErrors=this.l.event,this.m=void 0,this.n=this.B(new O.Emitter),this.onDidChangeLastSyncTime=this.n.event,this.r=this.B(new O.Emitter),this.onDidResetLocal=this.r.event,this.t=this.B(new O.Emitter),this.onDidResetRemote=this.t.event,this.u=new Map,this.f=A.userDataSyncStore?"idle":"uninitialized",this.m=this.D.getNumber(n,-1,void 0),this.B((0,P.toDisposable)(()=>this.W()))}async createSyncTask(v,A){this.X(),this.z.info("Sync started.");const N=new Date().getTime(),F=(0,C.generateUuid)();try{const z=(0,t.createSyncHeaders)(F);A&&(z["Cache-Control"]="no-cache"),v=await this.v.manifest(v,z)}catch(z){const x=t.UserDataSyncError.toUserDataSyncError(z);throw h(x,F,this.w,this.C),x}const M=!1,L=this;let $;return{manifest:v,async run(){if(M)throw new Error("Can run a task only once");$=(0,T.createCancelablePromise)(z=>L.I(v,!1,F,z)),await $.finally(()=>$=void 0),L.z.info(`Sync done. Took ${new Date().getTime()-N}ms`),L.S()},stop(){return $?.cancel(),L.N()}}}async createManualSyncTask(){if(this.X(),this.F.isEnabled())throw new t.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.z.info("Sync started.");const v=new Date().getTime(),A=(0,C.generateUuid)(),N=(0,t.createSyncHeaders)(A);let F;try{F=await this.v.manifest(null,N)}catch($){const z=t.UserDataSyncError.toUserDataSyncError($);throw h(z,A,this.w,this.C),z}await this.resetLocal();const M=this,L=new D.CancellationTokenSource;return{id:A,async merge(){return M.I(F,!0,A,L.token)},async apply(){try{try{await M.L(F,A,L.token)}catch($){if(t.UserDataSyncError.toUserDataSyncError($).code==="MethodNotFound")M.z.info("Client is making invalid requests. Cleaning up data..."),await M.cleanUpRemoteData(),M.z.info("Applying manual sync again..."),await M.L(F,A,L.token);else throw $}}catch($){throw M.z.error($),$}M.z.info(`Sync done. Took ${new Date().getTime()-v}ms`),M.S()},async stop(){L.cancel(),await M.N(),await M.resetLocal()}}}async I(v,A,N,F){this.k=[];try{this.status!=="hasConflicts"&&this.Q("syncing");const M=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.k.push(...await this.M(M,v,A,N,F));const L=M.enabled.find($=>$.resource==="profiles");if(L){const $=await L.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.J($,v,A,N,F)}}finally{this.l.fire(this.k)}}async J(v,A,N,F,M){for(const L of v){if(M.isCancellationRequested)return;const $=this.G.profiles.find(x=>x.id===L.id);if(!$){this.z.error(`Profile with id:${L.id} and name: ${L.name} does not exist locally to sync.`);continue}this.z.info("Syncing profile.",L.name);const z=this.getOrCreateActiveProfileSynchronizer($,L);this.k.push(...await this.M(z,A,N,F,M))}for(const[L,$]of this.u.entries())this.G.profiles.some(z=>z.id===$[0].profile.id)||($[1].dispose(),this.u.delete(L))}async L(v,A,N){const F=this.U();for(const x of F){if(N.isCancellationRequested)return;await x.apply(A,N)}const M=F.find(x=>x.profile.isDefault);if(!M)return;const L=M.enabled.find(x=>x.resource==="profiles");if(!L)return;const z=(await L.getRemoteSyncedProfiles(v?.latest??null)||[]).filter(x=>F.every(X=>X.profile.id!==x.id));z.length&&await this.J(z,v,!1,A,N)}async M(v,A,N,F,M){return(await v.sync(A,N,F,M)).map(([$,z])=>({profile:v.profile,syncResource:$,error:z}))}async N(){this.status!=="idle"&&await Promise.allSettled(this.U().map(v=>v.stop()))}async resolveContent(v){const A=await this.H.resolveContent(v);if(A)return A;for(const N of this.U())for(const F of N.enabled){const M=await F.resolveContent(v);if(M)return M}return null}async replace(v){this.X();const A=this.H.resolveUserDataSyncResource(v);if(!A)return;const N=await this.resolveContent(v.uri);!N||await this.O(A.profile,async F=>{if(A.syncResource===F.resource)return await F.replace(N),!0})}async accept(v,A,N,F){this.X(),await this.O(v.profile,async M=>{if(v.syncResource===M.resource)return await M.accept(A,N),F&&await M.apply((0,E.isBoolean)(F)?!1:F.force,(0,t.createSyncHeaders)((0,C.generateUuid)())),!0})}getRemoteProfiles(){return this.H.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(v,A){return this.H.getRemoteSyncResourceHandles(v,A)}async getLocalSyncResourceHandles(v,A){return this.H.getLocalSyncResourceHandles(v,A??this.G.defaultProfile)}async getAssociatedResources(v){return this.H.getAssociatedResources(v)}async getMachineId(v){return this.H.getMachineId(v)}async hasLocalData(){return!!await this.O(this.G.defaultProfile,async A=>{if(A.resource!=="globalState"&&await A.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.O(this.G.defaultProfile,async A=>{if(await A.hasPreviouslySynced())return!0})}async reset(){this.X(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.X();try{await this.v.clear(),this.z.info("Cleared data on server")}catch(v){this.z.error(v)}this.t.fire()}async resetLocal(){this.X(),this.m=void 0,this.D.remove(n,-1);for(const[v]of this.u.values())try{await v.resetLocal()}catch(A){this.z.error(A)}this.W(),this.r.fire(),this.z.info("Did reset the local sync state.")}async cleanUpRemoteData(){const v=await this.H.getRemoteSyncedProfiles(),A=v.map(L=>L.collection),N=await this.v.getAllCollections(),F=N.filter(L=>!A.includes(L));F.length&&(this.z.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(L=>this.v.deleteCollection(L))),this.z.info("Deleted redundant collections on server"));const M=v.filter(L=>N.includes(L.collection));if(M.length!==v.length){this.z.info("Updating remote profiles with invalid collections on server");const L=this.y.createInstance(o.UserDataProfilesManifestSynchroniser,this.G.defaultProfile,void 0);try{await L.updateRemoteProfiles(M,null),this.z.info("Updated remote profiles on server")}finally{L.dispose()}}}async O(v,A){const N=new P.DisposableStore;try{const F=this.u.get(v.id);if(F){const x=await this.P(F[0],A,N);return(0,E.isUndefined)(x)?null:x}if(v.isDefault){const x=N.add(this.y.createInstance(a,v,void 0)),X=await this.P(x,A,N);return(0,E.isUndefined)(X)?null:X}if(this.G.isEnabled())return null;const M=N.add(this.y.createInstance(o.UserDataProfilesManifestSynchroniser,v,void 0)),L=await this.v.manifest(null),z=(await M.getRemoteSyncedProfiles(L?.latest??null)||[]).find(x=>x.id===v.id);if(z){const x=N.add(this.y.createInstance(a,v,z.collection)),X=await this.P(x,A,N);return(0,E.isUndefined)(X)?null:X}return null}finally{N.dispose()}}async P(v,A,N){const F=[...v.enabled,...v.disabled.map(M=>N.add(v.createSynchronizer(M)))];for(const M of F){const L=await A(M);if(!(0,E.isUndefined)(L))return L}}Q(v){const A=this.f;this.f!==v&&(this.f=v,this.g.fire(v),A==="hasConflicts"&&this.S())}R(){const v=this.U().map(A=>A.conflicts).flat();(0,k.equals)(this.i,v,(A,N)=>A.profile.id===N.profile.id&&A.syncResource===N.syncResource&&(0,k.equals)(A.conflicts,N.conflicts,(F,M)=>(0,I.isEqual)(F.previewResource,M.previewResource)))||(this.i=v,this.j.fire(v))}S(){this.status==="idle"&&(this.m=new Date().getTime(),this.D.store(n,this.m,-1,1),this.n.fire(this.m))}getOrCreateActiveProfileSynchronizer(v,A){let N=this.u.get(v.id);if(N&&N[0].collection!==A?.collection&&(this.z.error("Profile synchronizer collection does not match with the remote sync profile collection"),N[1].dispose(),N=void 0,this.u.delete(v.id)),!N){const F=new P.DisposableStore,M=F.add(this.y.createInstance(a,v,A?.collection));F.add(M.onDidChangeStatus(L=>this.Q(L))),F.add(M.onDidChangeConflicts(L=>this.R())),F.add(M.onDidChangeLocal(L=>this.h.fire(L))),this.u.set(v.id,N=[M,F])}return N[0]}U(){const v=[];for(const[A]of this.u.values())v.push(A);return v}W(){this.u.forEach(([,v])=>v.dispose()),this.u.clear()}X(){if(!this.w.userDataSyncStore)throw new Error("Not enabled")}};s=ye([G(0,t.IUserDataSyncStoreService),G(1,t.IUserDataSyncStoreManagementService),G(2,y.IInstantiationService),G(3,t.IUserDataSyncLogService),G(4,S.ITelemetryService),G(5,u.IStorageService),G(6,t.IUserDataSyncEnablementService),G(7,f.IUserDataProfilesService),G(8,t.IUserDataSyncResourceProviderService)],s),e.UserDataSyncService=s;let a=class extends P.Disposable{get enabled(){return this.f.sort((v,A)=>v[1]-A[1]).map(([v])=>v)}get disabled(){return t.ALL_SYNC_RESOURCES.filter(v=>!this.l.isResourceEnabled(v))}get status(){return this.g}get conflicts(){return this.j}constructor(v,A,N,F,M,L,$,z,x,X){super(),this.profile=v,this.collection=A,this.l=N,this.m=F,this.n=M,this.r=L,this.t=$,this.u=z,this.v=x,this.w=X,this.f=[],this.g="idle",this.h=this.B(new O.Emitter),this.onDidChangeStatus=this.h.event,this.i=this.B(new O.Emitter),this.onDidChangeLocal=this.i.event,this.j=[],this.k=this.B(new O.Emitter),this.onDidChangeConflicts=this.k.event,this.B(N.onDidChangeResourceEnablement(([ie,H])=>this.y(ie,H))),this.B((0,P.toDisposable)(()=>this.f.splice(0,this.f.length).forEach(([,,ie])=>ie.dispose())));for(const ie of t.ALL_SYNC_RESOURCES)N.isResourceEnabled(ie)&&this.z(ie)}y(v,A){A?this.z(v):this.C(v)}z(v){if(this.f.some(([M])=>M.resource===v))return;if(v==="extensions"&&!this.n.isEnabled()){this.u.info("Skipping extensions sync because gallery is not configured");return}if(v==="profiles"&&(!this.profile.isDefault||!this.v.isEnabled()))return;const A=new P.DisposableStore,N=A.add(this.createSynchronizer(v));A.add(N.onDidChangeStatus(()=>this.G())),A.add(N.onDidChangeConflicts(()=>this.H())),A.add(N.onDidChangeLocal(()=>this.i.fire(v)));const F=this.I(v);this.f.push([N,F,A])}C(v){const A=this.f.findIndex(([N])=>N.resource===v);if(A!==-1){const[[N,,F]]=this.f.splice(A,1);F.dispose(),this.G(),Promise.allSettled([N.stop(),N.resetLocal()]).then(null,M=>this.u.error(M))}}createSynchronizer(v){switch(v){case"settings":return this.m.createInstance(w.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.m.createInstance(p.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.m.createInstance(R.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.m.createInstance(i.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.m.createInstance(d.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.m.createInstance(c.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.m.createInstance(o.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(v,A,N,F){if(F.isCancellationRequested)return[];const M=this.enabled;if(!M.length)return[];try{const L=[],$=(0,t.createSyncHeaders)(N),z=(this.collection?v?.collections?.[this.collection]?.latest:v?.latest)??null,x=A?await this.D(z):{};for(const X of M){if(F.isCancellationRequested)return[];if(!this.l.isResourceEnabled(X.resource))return[];try{if(A){const ie=await X.preview(z,x,$);if(ie)for(const H of ie.resourcePreviews)(H.localChange!==0||H.remoteChange!==0)&&H.mergeState==="preview"&&await X.merge(H.previewResource)}else await X.sync(z,$)}catch(ie){const H=t.UserDataSyncError.toUserDataSyncError(ie);if(h(H,N,this.r,this.t),r(ie))throw H;this.u.error(ie),this.u.error(`${X.resource}: ${(0,l.toErrorMessage)(ie)}`),L.push([X.resource,H])}}return L}finally{this.G()}}async apply(v,A){const N=(0,t.createSyncHeaders)(v);for(const F of this.enabled){if(A.isCancellationRequested)return;try{await F.apply(!1,N)}catch(M){const L=t.UserDataSyncError.toUserDataSyncError(M);if(h(L,v,this.r,this.t),r(M))throw L;this.u.error(M),this.u.error(`${F.resource}: ${(0,l.toErrorMessage)(M)}`)}}}async stop(){for(const v of this.enabled)try{v.status!=="idle"&&await v.stop()}catch(A){this.u.error(A)}}async resetLocal(){for(const v of this.enabled)try{await v.resetLocal()}catch(A){this.u.error(`${v.resource}: ${(0,l.toErrorMessage)(A)}`),this.u.error(A)}}async D(v){if(!this.profile.isDefault)return{};const A=this.w.getValue(t.USER_DATA_SYNC_CONFIGURATION_SCOPE),N=this.enabled.find(F=>F instanceof w.SettingsSynchroniser);if(N){const F=await N.getRemoteUserDataSyncConfiguration(v);return{...A,...F}}return A}F(v){this.g!==v&&(this.g=v,this.h.fire(v))}G(){return this.H(),this.enabled.some(v=>v.status==="hasConflicts")?this.F("hasConflicts"):this.enabled.some(v=>v.status==="syncing")?this.F("syncing"):this.F("idle")}H(){const v=this.enabled.filter(A=>A.status==="hasConflicts").filter(A=>A.conflicts.conflicts.length>0).map(A=>A.conflicts);(0,k.equals)(this.j,v,(A,N)=>A.syncResource===N.syncResource&&(0,k.equals)(A.conflicts,N.conflicts,(F,M)=>(0,I.isEqual)(F.previewResource,M.previewResource)))||(this.j=v,this.k.fire(v))}I(v){switch(v){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6}}};a=ye([G(2,t.IUserDataSyncEnablementService),G(3,y.IInstantiationService),G(4,m.IExtensionGalleryService),G(5,t.IUserDataSyncStoreManagementService),G(6,S.ITelemetryService),G(7,t.IUserDataSyncLogService),G(8,f.IUserDataProfilesService),G(9,b.IConfigurationService)],a);function r(g){if(g instanceof t.UserDataSyncError)switch(g.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function h(g,v,A,N){N.publicLog2("sync/error",{code:g.code,serverCode:g instanceof t.UserDataSyncStoreError?String(g.serverCode):void 0,url:g instanceof t.UserDataSyncStoreError?g.url:void 0,resource:g.resource,executionId:v,service:A.userDataSyncStore.url.toString()})}}),define(oe[283],ae([0,1,3,2,11,18,24]),function(Q,e,k,T,D,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function P(m,y){return{...m,profile:(0,l.reviveProfile)(m.profile,y.profilesHome.scheme)}}function I(m){return{created:m.created,uri:D.URI.revive(m.uri)}}class E{constructor(y,u,S){this.c=y,this.d=u,this.f=S,this.a=new Map,this.b=new k.Emitter}listen(y,u){switch(u){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${u}`)}async call(y,u,S){try{return await this.g(y,u,S)}catch(f){throw this.f.error(f),f}}async g(y,u,S){switch(u){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(D.URI.revive(S[0]));case"accept":return this.c.accept(P(S[0],this.d),D.URI.revive(S[1]),S[2],S[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(S[0],(0,l.reviveProfile)(S[1],this.d.profilesHome.scheme));case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(S[0],S[1]);case"replace":return this.c.replace(I(S[0]));case"getAssociatedResources":return this.c.getAssociatedResources(I(S[0]));case"getMachineId":return this.c.getMachineId(I(S[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if(u.startsWith("manualSync/")){const f=u.substring(11),c=S[0],d=this.h(c);switch(S=S.slice(1),f){case"merge":return d.merge();case"apply":return d.apply().then(()=>this.a.delete(this.j(d.id)));case"stop":return d.stop().finally(()=>this.a.delete(this.j(d.id)))}}throw new Error("Invalid call")}h(y){const u=this.a.get(this.j(y));if(!u)throw new Error(`Manual sync taks not found: ${y}`);return u}async i(){const y=await this.c.createManualSyncTask();return this.a.set(this.j(y.id),y),y.id}j(y){return`manualSyncTask-${y}`}}e.UserDataSyncChannel=E;let C=class extends T.Disposable{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(y,u){super(),this.k=u,this.b="uninitialized",this.c=this.B(new k.Emitter),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new k.Emitter),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.B(new k.Emitter),this.onDidChangeLastSyncTime=this.i.event,this.j=this.B(new k.Emitter),this.onSyncErrors=this.j.event,this.a={call(S,f,c){return y.call(S,f,c).then(null,d=>{throw O.UserDataSyncError.toUserDataSyncError(d)})},listen(S,f){return y.listen(S,f)}},this.a.call("_getInitialData").then(([S,f,c])=>{this.l(S),this.m(f),c&&this.n(c),this.B(this.a.listen("onDidChangeStatus")(d=>this.l(d))),this.B(this.a.listen("onDidChangeLastSyncTime")(d=>this.n(d)))}),this.B(this.a.listen("onDidChangeConflicts")(S=>this.m(S))),this.B(this.a.listen("onSyncErrors")(S=>this.j.fire(S.map(f=>({...f,error:O.UserDataSyncError.toUserDataSyncError(f.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const y=await this.a.call("createManualSyncTask"),u=this;return new b(y,{async call(f,c,d){return u.a.call(`manualSync/${f}`,[y,...Array.isArray(c)?c:[c]],d)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(y,u,S,f){return this.a.call("accept",[y,u,S,f])}resolveContent(y){return this.a.call("resolveContent",[y])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(y,u){return(await this.a.call("getLocalSyncResourceHandles",[y,u])).map(({created:f,uri:c})=>({created:f,uri:D.URI.revive(c)}))}async getRemoteSyncResourceHandles(y,u){return(await this.a.call("getRemoteSyncResourceHandles",[y,u])).map(({created:f,uri:c})=>({created:f,uri:D.URI.revive(c)}))}async getAssociatedResources(y){return(await this.a.call("getAssociatedResources",[y])).map(({resource:S,comparableResource:f})=>({resource:D.URI.revive(S),comparableResource:D.URI.revive(f)}))}getMachineId(y){return this.a.call("getMachineId",[y])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(y){return this.a.call("replace",[y])}async l(y){this.b=y,this.c.fire(y)}async m(y){this.f=y.map(u=>({syncResource:u.syncResource,profile:(0,l.reviveProfile)(u.profile,this.k.profilesHome.scheme),conflicts:u.conflicts.map(S=>({...S,baseResource:D.URI.revive(S.baseResource),localResource:D.URI.revive(S.localResource),remoteResource:D.URI.revive(S.remoteResource),previewResource:D.URI.revive(S.previewResource)}))})),this.g.fire(this.f)}n(y){this.h!==y&&(this.h=y,this.i.fire(y))}};C=ye([G(1,l.IUserDataProfilesService)],C),e.UserDataSyncChannelClient=C;class b extends T.Disposable{constructor(y,u){super(),this.id=y,this.a=u}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(oe[284],ae([0,1,6,25,9,3,2,142,4,22,12,11,31,16,15,14,23,60,45,20,24]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u,S,f,c,d,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const R="sync.previous.store",i="sync.donot-make-requests-until",o="sync.user-session-id",t="sync.machine-session-id",n=100,s=1e3*60*5;let a=class extends O.Disposable{get userDataSyncStore(){return this.b}get c(){return this.h.get(w.SYNC_SERVICE_URL_TYPE,-1)}set c(N){this.h.store(w.SYNC_SERVICE_URL_TYPE,N,-1,I.isWeb?0:1)}constructor(N,F,M){super(),this.f=N,this.g=F,this.h=M,this.a=this.B(new l.Emitter),this.onDidChangeUserDataSyncStore=this.a.event,this.i(),this.B(l.Event.filter(M.onDidChangeValue,L=>L.key===w.SYNC_SERVICE_URL_TYPE&&L.scope===-1&&this.c!==this.userDataSyncStore?.type)(()=>this.i()))}i(){this.b=this.j(this.f[w.CONFIGURATION_SYNC_STORE_KEY],this.g.getValue(w.CONFIGURATION_SYNC_STORE_KEY)),this.a.fire()}j(N,F){N=I.isWeb&&N?.web?{...N,...N.web}:N;const M={...N||{},...F||{}};if(M&&(0,C.isString)(M.url)&&(0,C.isObject)(M.authenticationProviders)&&Object.keys(M.authenticationProviders).every(L=>Array.isArray(M.authenticationProviders[L].scopes))){const L=M,$=!!L.canSwitch&&!F?.url,z=L.url===L.insidersUrl?"insiders":"stable",x=($?this.c:void 0)||z,X=F?.url||(x==="insiders"?L.insidersUrl:x==="stable"?L.stableUrl:L.url);return{url:b.URI.parse(X),type:x,defaultType:z,defaultUrl:b.URI.parse(L.url),stableUrl:b.URI.parse(L.stableUrl),insidersUrl:b.URI.parse(L.insidersUrl),canSwitch:$,authenticationProviders:Object.keys(L.authenticationProviders).reduce((ie,H)=>(ie.push({id:H,scopes:L.authenticationProviders[H].scopes}),ie),[])}}}};a=ye([G(0,f.IProductService),G(1,y.IConfigurationService),G(2,p.IStorageService)],a),e.AbstractUserDataSyncStoreManagementService=a;let r=class extends a{constructor(N,F,M){super(N,F,M);const L=this.h.get(R,-1);L&&(this.k=JSON.parse(L));const $=this.f[w.CONFIGURATION_SYNC_STORE_KEY];$?this.h.store(R,JSON.stringify($),-1,1):this.h.remove(R,-1)}async switch(N){N!==this.c&&(this.c=N,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};r=ye([G(0,f.IProductService),G(1,y.IConfigurationService),G(2,p.IStorageService)],r),e.UserDataSyncStoreManagementService=r;let h=class extends O.Disposable{get donotMakeRequestsUntil(){return this.i}constructor(N,F,M,L,$,z,x){super(),this.k=M,this.l=L,this.n=x,this.g=this.B(new l.Emitter),this.onTokenFailed=this.g.event,this.h=this.B(new l.Emitter),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.B(new l.Emitter),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.s=void 0,this.p(N),this.c=(0,d.getServiceMachineId)($,z,x).then(X=>{const ie={"X-Client-Name":`${F.applicationName}${I.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(ie["X-Client-Commit"]=F.commit),ie}),this.f=new v(n,s,this.k,this.l),this.r(),this.B((0,O.toDisposable)(()=>{this.s&&(this.s.cancel(),this.s=void 0)}))}setAuthToken(N,F){this.b={token:N,type:F}}p(N){this.a=N?(0,E.joinPath)(N,"v1"):void 0}r(){const N=this.n.getNumber(i,-1);N&&Date.now()<N&&this.t(new Date(N))}t(N){this.i?.getTime()!==N?.getTime()&&(this.i=N,this.s&&(this.s.cancel(),this.s=void 0),this.i?(this.n.store(i,this.i.getTime(),-1,1),this.s=(0,k.createCancelablePromise)(F=>(0,k.timeout)(this.i.getTime()-Date.now(),F).then(()=>this.t(void 0))),this.s.then(null,F=>null)):this.n.remove(i,-1),this.j.fire())}async getAllCollections(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.a,"collection").toString();N={...N},N["Content-Type"]="application/json";const M=await this.w(F,{type:"GET",headers:N},[],T.CancellationToken.None);return(await(0,c.asJson)(M))?.map(({id:L})=>L)||[]}async createCollection(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.a,"collection").toString();N={...N},N["Content-Type"]=P.Mimes.text;const M=await this.w(F,{type:"POST",headers:N},[],T.CancellationToken.None),L=await(0,c.asTextOrError)(M);if(!L)throw new w.UserDataSyncStoreError("Server did not return the collection id",F,"NoCollection",M.res.statusCode,M.res.headers[w.HEADER_OPERATION_ID]);return L}async deleteCollection(N,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=N?(0,E.joinPath)(this.a,"collection",N).toString():(0,E.joinPath)(this.a,"collection").toString();F={...F},await this.w(M,{type:"DELETE",headers:F},[],T.CancellationToken.None)}async getAllResourceRefs(N,F){if(!this.a)throw new Error("No settings sync store url configured.");const M=this.u(this.a,F,N),L={},$=await this.w(M.toString(),{type:"GET",headers:L},[],T.CancellationToken.None);return(await(0,c.asJson)($)||[]).map(({url:x,created:X})=>({ref:(0,E.relativePath)(M,M.with({path:x})),created:X*1e3}))}async resolveResourceContent(N,F,M,L={}){if(!this.a)throw new Error("No settings sync store url configured.");const $=(0,E.joinPath)(this.u(this.a,M,N),F).toString();L={...L},L["Cache-Control"]="no-cache";const z=await this.w($,{type:"GET",headers:L},[],T.CancellationToken.None);return await(0,c.asTextOrError)(z)}async deleteResource(N,F,M){if(!this.a)throw new Error("No settings sync store url configured.");const L=F!==null?(0,E.joinPath)(this.u(this.a,M,N),F).toString():this.u(this.a,M,N).toString(),$={};await this.w(L,{type:"DELETE",headers:$},[],T.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,E.joinPath)(this.a,"resource").toString(),F={"Content-Type":P.Mimes.text};await this.w(N,{type:"DELETE",headers:F},[],T.CancellationToken.None)}async readResource(N,F,M,L={}){if(!this.a)throw new Error("No settings sync store url configured.");const $=(0,E.joinPath)(this.u(this.a,M,N),"latest").toString();L={...L},L["Cache-Control"]="no-cache",F&&(L["If-None-Match"]=F.ref);const z=await this.w($,{type:"GET",headers:L},[304],T.CancellationToken.None);let x=null;if(z.res.statusCode===304&&(x=F),x===null){const X=z.res.headers.etag;if(!X)throw new w.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",z.res.statusCode,z.res.headers[w.HEADER_OPERATION_ID]);const ie=await(0,c.asTextOrError)(z);if(!ie&&z.res.statusCode===304)throw new w.UserDataSyncStoreError("Empty response",$,"EmptyResponse",z.res.statusCode,z.res.headers[w.HEADER_OPERATION_ID]);x={ref:X,content:ie}}return x}async writeResource(N,F,M,L,$={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=this.u(this.a,L,N).toString();$={...$},$["Content-Type"]=P.Mimes.text,M&&($["If-Match"]=M);const x=await this.w(z,{type:"POST",data:F,headers:$},[],T.CancellationToken.None),X=x.res.headers.etag;if(!X)throw new w.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",x.res.statusCode,x.res.headers[w.HEADER_OPERATION_ID]);return X}async manifest(N,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,E.joinPath)(this.a,"manifest").toString();F={...F},F["Content-Type"]="application/json",N&&(F["If-None-Match"]=N.ref);const L=await this.w(M,{type:"GET",headers:F},[304],T.CancellationToken.None);let $=null;if(L.res.statusCode===304&&($=N),!$){const x=L.res.headers.etag;if(!x)throw new w.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",L.res.statusCode,L.res.headers[w.HEADER_OPERATION_ID]);const X=await(0,c.asTextOrError)(L);if(!X&&L.res.statusCode===304)throw new w.UserDataSyncStoreError("Empty response",M,"EmptyResponse",L.res.statusCode,L.res.headers[w.HEADER_OPERATION_ID]);X&&($={...JSON.parse(X),ref:x})}const z=this.n.get(o,-1);return z&&$&&z!==$.session&&this.v(),$===null&&z&&this.v(),$&&this.n.store(o,$.session,-1,1),$}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.v()}u(N,F,M){return F?(0,E.joinPath)(N,"collection",F,"resource",M):(0,E.joinPath)(N,"resource",M)}v(){this.n.remove(o,-1),this.n.remove(t,-1)}async w(N,F,M,L){if(!this.b)throw new w.UserDataSyncStoreError("No Auth Token Available",N,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new w.UserDataSyncStoreError(`${F.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",void 0,void 0);this.t(void 0);const $=await this.c;F.headers={...F.headers||{},...$,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.y(F.headers),this.l.trace("Sending request to server",{url:N,type:F.type,headers:{...F.headers,authorization:void 0}});let z;try{z=await this.f.request(N,F,L)}catch(j){if(!(j instanceof w.UserDataSyncStoreError)){let V="RequestFailed";const J=(0,D.getErrorMessage)(j).toLowerCase();J.includes("xhr timeout")?V="RequestTimeout":J.includes("protocol")&&J.includes("not supported")?V="RequestProtocolNotSupported":J.includes("request path contains unescaped characters")?V="RequestPathNotEscaped":J.includes("headers must be an object")?V="RequestHeadersNotObject":(0,D.isCancellationError)(j)&&(V="RequestCanceled"),j=new w.UserDataSyncStoreError(`Connection refused for the request '${N}'.`,N,V,void 0,void 0)}throw this.l.info("Request failed",N),j}const x=z.res.headers[w.HEADER_OPERATION_ID],X={url:N,status:z.res.statusCode,"execution-id":F.headers[w.HEADER_EXECUTION_ID],"operation-id":x},ie=(0,c.isSuccess)(z)||z.res.statusCode&&M.indexOf(z.res.statusCode)!==-1;let H="";if(ie?this.l.trace("Request succeeded",X):(this.l.info("Request failed",X),H=await(0,c.asText)(z)||""),z.res.statusCode===401)throw this.b=void 0,this.g.fire(),new w.UserDataSyncStoreError(`Request '${N}' failed because of Unauthorized (401).`,N,"Unauthorized",z.res.statusCode,x);if(this.h.fire(),z.res.statusCode===404)throw new w.UserDataSyncStoreError(`${F.type} request '${N}' failed because the requested resource is not found (404).`,N,"NotFound",z.res.statusCode,x);if(z.res.statusCode===405)throw new w.UserDataSyncStoreError(`${F.type} request '${N}' failed because the requested endpoint is not found (405). ${H}`,N,"MethodNotFound",z.res.statusCode,x);if(z.res.statusCode===409)throw new w.UserDataSyncStoreError(`${F.type} request '${N}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,N,"Conflict",z.res.statusCode,x);if(z.res.statusCode===410)throw new w.UserDataSyncStoreError(`${F.type} request '${N}' failed because the requested resource is not longer available (410).`,N,"Gone",z.res.statusCode,x);if(z.res.statusCode===412)throw new w.UserDataSyncStoreError(`${F.type} request '${N}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,N,"PreconditionFailed",z.res.statusCode,x);if(z.res.statusCode===413)throw new w.UserDataSyncStoreError(`${F.type} request '${N}' failed because of too large payload (413).`,N,"TooLarge",z.res.statusCode,x);if(z.res.statusCode===426)throw new w.UserDataSyncStoreError(`${F.type} request '${N}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,N,"UpgradeRequired",z.res.statusCode,x);if(z.res.statusCode===429){const j=z.res.headers["retry-after"];throw j?(this.t(new Date(Date.now()+parseInt(j)*1e3)),new w.UserDataSyncStoreError(`${F.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",z.res.statusCode,x)):new w.UserDataSyncStoreError(`${F.type} request '${N}' failed because of too many requests (429).`,N,"RemoteTooManyRequests",z.res.statusCode,x)}if(!ie)throw new w.UserDataSyncStoreError("Server returned "+z.res.statusCode,N,"Unknown",z.res.statusCode,x);return z}y(N){let F=this.n.get(t,-1);F===void 0&&(F=(0,m.generateUuid)(),this.n.store(t,F,-1,1)),N["X-Machine-Session-Id"]=F;const M=this.n.get(o,-1);M!==void 0&&(N["X-User-Session-Id"]=M)}};h=ye([G(1,f.IProductService),G(2,c.IRequestService),G(3,w.IUserDataSyncLogService),G(4,u.IEnvironmentService),G(5,S.IFileService),G(6,p.IStorageService)],h),e.UserDataSyncStoreClient=h;let g=class extends h{constructor(N,F,M,L,$,z,x){super(N.userDataSyncStore?.url,F,M,L,$,z,x),this.B(N.onDidChangeUserDataSyncStore(()=>this.p(N.userDataSyncStore?.url)))}};g=ye([G(0,w.IUserDataSyncStoreManagementService),G(1,f.IProductService),G(2,c.IRequestService),G(3,w.IUserDataSyncLogService),G(4,u.IEnvironmentService),G(5,S.IFileService),G(6,p.IStorageService)],g),e.UserDataSyncStoreService=g;class v{constructor(N,F,M,L){this.c=N,this.d=F,this.f=M,this.g=L,this.a=[],this.b=void 0}request(N,F,M){if(this.h()&&this.i(),F.url=N,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new w.UserDataSyncStoreError(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,N,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(N),this.f.request(F,M)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.RequestsSession=v}),define(oe[285],ae([0,1,3,58,23,20,19,280,24,78,81]),function(Q,e,k,T,D,l,O,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let b=class extends P.UserDataAutoSyncService{constructor(y,u,S,f,c,d,p,w,R,i,o){super(y,u,S,f,c,p,w,R,i,o),this.B(k.Event.debounce(k.Event.any(k.Event.map(d.onDidFocusWindow,()=>"windowFocus"),k.Event.map(d.onDidOpenWindow,()=>"windowOpen")),(t,n)=>t?[...t,n]:[n],1e3)(t=>this.triggerSync(t,!0,!1)))}};b=ye([G(0,D.IProductService),G(1,I.IUserDataSyncStoreManagementService),G(2,I.IUserDataSyncStoreService),G(3,I.IUserDataSyncEnablementService),G(4,I.IUserDataSyncService),G(5,T.INativeHostService),G(6,I.IUserDataSyncLogService),G(7,E.IUserDataSyncAccountService),G(8,O.ITelemetryService),G(9,C.IUserDataSyncMachinesService),G(10,l.IStorageService)],b),e.UserDataAutoSyncService=b}),define(oe[286],ae([0,1,100,26,4,22]),function(Q,e,k,T,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function O(E){function C(){let b=E.scheme===T.Schemas.file?(0,l.originalFSPath)(E):E.toString();return D.isLinux||(b=b.toLowerCase()),(0,k.createHash)("md5").update(b).digest("hex")}return{id:C(),configPath:E}}e.getWorkspaceIdentifier=O;function P(E,C){function b(){if(E.scheme!==T.Schemas.file)return(0,k.createHash)("md5").update(E.toString()).digest("hex");if(!C)return;let y;return D.isLinux?y=C.ino:D.isMacintosh?y=C.birthtime.getTime():D.isWindows&&(typeof C.birthtimeMs=="number"?y=Math.floor(C.birthtimeMs):y=C.birthtime.getTime()),(0,k.createHash)("md5").update(E.fsPath).update(y?String(y):"").digest("hex")}const m=b();if(typeof m=="string")return{id:m,uri:E}}e.getSingleFolderWorkspaceIdentifier=P;function I(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=I}),define(oe[287],ae([0,1,6,9,2,13,28,15,57,8,58,76,117,286]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let u=class extends D.Disposable{constructor(f,c,d,p){super(),this.a=f,this.b=c,this.c=d,this.f=p,this.B(new k.RunOnceScheduler(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const f=await O.Promises.readdir(this.a.workspaceStorageHome.fsPath),c=new b.StorageClient(this.f.getChannel("storage"));await Promise.all(f.map(async d=>{const p=(0,l.join)(this.a.workspaceStorageHome.fsPath,d);d.length===y.NON_EMPTY_WORKSPACE_ID_LENGTH||d===m.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.c.getWindows()).some(i=>i.workspace?.id===d)||await c.isUsed(p)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${d} as it seems to be an unused empty workspace.`),await O.Promises.rm(p))}))}catch(f){(0,T.onUnexpectedError)(f)}}};u=ye([G(0,P.INativeEnvironmentService),G(1,E.ILogService),G(2,C.INativeHostService),G(3,I.IMainProcessService)],u),e.UnusedWorkspaceStorageDataCleaner=u}),define(oe[126],ae([0,1,53,6,13,12,28,153,296,297]),function(Q,e,k,T,D,l,O,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class C extends Error{constructor(i,o){let t=o.message;switch(i){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=i,this.cause=o}}e.ExtractError=C;function b(R){const i=R.externalFileAttributes>>16||33188;return[448,56,7].map(o=>i&o).reduce((o,t)=>o+t,i&61440)}function m(R){if(R instanceof C)return R;let i;return/end of central directory record signature not found/.test(R.message)&&(i="CorruptZip"),new C(i,R)}function y(R,i,o,t,n,s){const a=D.dirname(i),r=D.join(t,a);if(!r.startsWith(t))return Promise.reject(new Error(P.localize(0,null,i)));const h=D.join(t,i);let g;return s.onCancellationRequested(()=>{g?.destroy()}),Promise.resolve(O.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((v,A)=>{if(!s.isCancellationRequested)try{g=(0,k.createWriteStream)(h,{mode:o}),g.once("close",()=>v()),g.once("error",A),R.once("error",A),R.pipe(g)}catch(N){A(N)}}))}function u(R,i,o,t){let n=(0,T.createCancelablePromise)(()=>Promise.resolve()),s=0;return t.onCancellationRequested(()=>{n.cancel(),R.close()}),new Promise((a,r)=>{const h=new T.Sequencer,g=v=>{v.isCancellationRequested||(s++,R.readEntry())};R.once("error",r),R.once("close",()=>n.then(()=>{t.isCancellationRequested||R.entryCount===s?a():r(new C("Incomplete",new Error(P.localize(1,null,s,R.entryCount))))},r)),R.readEntry(),R.on("entry",v=>{if(t.isCancellationRequested)return;if(!o.sourcePathRegex.test(v.fileName)){g(t);return}const A=v.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test(A)){const M=D.join(i,A);n=(0,T.createCancelablePromise)(L=>O.Promises.mkdir(M,{recursive:!0}).then(()=>g(L)).then(void 0,r));return}const N=f(R,v),F=b(v);n=(0,T.createCancelablePromise)(M=>h.queue(()=>N.then(L=>y(L,A,F,i,o,M).then(()=>g(M)))).then(null,r))})})}function S(R,i=!1){return new Promise((o,t)=>{(0,I.open)(R,i?{lazyEntries:!0}:void 0,(n,s)=>{n?t(m(n)):o((0,l.assertIsDefined)(s))})})}function f(R,i){return new Promise((o,t)=>{R.openReadStream(i,(n,s)=>{n?t(m(n)):o((0,l.assertIsDefined)(s))})})}function c(R,i){return new Promise((o,t)=>{const n=new E.ZipFile;i.forEach(a=>{a.contents?n.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&n.addFile(a.localPath,a.path)}),n.end();const s=(0,k.createWriteStream)(R);n.outputStream.pipe(s),n.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>o(R))})}e.zip=c;function d(R,i,o={},t){const n=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let s=S(R,!0);return o.overwrite&&(s=s.then(a=>O.Promises.rm(i).then(()=>a))),s.then(a=>u(a,i,{sourcePathRegex:n},t))}e.extract=d;function p(R,i){return S(R).then(o=>new Promise((t,n)=>{o.on("entry",s=>{s.fileName===i&&f(o,s).then(a=>t(a),a=>n(a))}),o.once("close",()=>n(new Error(P.localize(2,null,i))))}))}function w(R,i){return p(R,i).then(o=>new Promise((t,n)=>{const s=[];o.once("error",n),o.on("data",a=>s.push(a)),o.on("end",()=>t(Buffer.concat(s)))}))}e.buffer=w}),define(oe[288],ae([0,1,126,163]),function(Q,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(l){return(0,k.buffer)(l,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,T.localize)(0,null))}})}e.getManifest=D}),define(oe[127],ae([0,1,6,25,38,9,3,2,37,26,13,4,22,54,12,11,31,28,126,162,97,15,269,30,33,51,79,239,271,288,223,240,42,70,14,5,8,23,19,29,18]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u,S,f,c,d,p,w,R,i,o,t,n,s,a,r,h,g,v,A,N,F,M,L,$,z,x,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,M.refineServiceDecorator)(o.IExtensionManagementService);let ie=class extends i.AbstractExtensionManagementService{constructor(U,B,W,q,Y,ee,K,Z,se,le,ue,pe){super(U,B,W,le,pe),this.Z=Y,this.ab=ee,this.bb=K,this.cb=se,this.db=ue,this.X=this.B(new O.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new I.ResourceSet;const ve=this.B(Z.createInstance(r.ExtensionsLifecycle));this.S=this.B(Z.createInstance(H,Ee=>ve.postUninstall(Ee))),this.U=this.B(new g.ExtensionsManifestCache(q,this)),this.W=this.B(Z.createInstance(a.ExtensionsDownloader));const be=this.B(new v.ExtensionsWatcher(this,this.Z,pe,ee,ue,se,W));this.B(be.onDidChangeExtensionsByAnotherSource(Ee=>this.kb(Ee))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,t.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip(U){this.v.trace("ExtensionManagementService#zip",U.identifier.id);const B=await this.jb(U),W=await(0,d.zip)((0,m.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)()).fsPath,B);return S.URI.file(W)}async unzip(U){return this.v.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const{location:B,cleanup:W}=await this.fb(U),q=C.resolve(B.fsPath);try{return await(0,h.getManifest)(q)}finally{await W()}}getInstalled(U,B){return this.S.scanExtensions(U??null,B)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(U,B={}){this.v.trace("ExtensionManagementService#install",U.toString());const{location:W,cleanup:q}=await this.fb(U);try{const Y=await(0,h.getManifest)(C.resolve(W.fsPath));if(Y.engines&&Y.engines.vscode&&!(0,N.isEngineValid)(Y.engines.vscode,this.w.version,this.w.date))throw new Error(p.localize(0,null,(0,t.getGalleryExtensionId)(Y.publisher,Y.name),this.w.version));return await this.z(Y,W,B)}finally{await q()}}async installFromLocation(U,B){this.v.trace("ExtensionManagementService#installFromLocation",U.toString());const W=await this.S.scanUserExtensionAtLocation(U);if(!W)throw new Error(`Cannot find a valid extension from the location ${U.toString()}`);return await this.ob([W],B),this.v.info("Successfully installed extension",W.identifier.id,B.toString()),W}getMetadata(U,B=this.y.defaultProfile.extensionsResource){return this.S.scanMetadata(U,B)}async updateMetadata(U,B,W=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",U.identifier.id),B.isPreReleaseVersion&&(B.preRelease=!0),B.isMachineScoped=B.isMachineScoped||void 0,B.isBuiltin=B.isBuiltin||void 0,B.pinned=B.pinned||void 0,U=await this.S.updateMetadata(U,B,W),this.U.invalidate(),this.X.fire(U),U}async reinstallFromGallery(U){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",U.identifier.id),!this.t.isEnabled())throw new Error(p.localize(1,null));const B=await this.getTargetPlatform(),[W]=await this.t.getExtensions([{...U.identifier,preRelease:U.preRelease}],{targetPlatform:B,compatible:!0},T.CancellationToken.None);if(!W)throw new Error(p.localize(2,null));await this.S.setUninstalled(U);try{await this.S.removeUninstalledExtension(U)}catch(q){throw new Error(p.localize(3,null,(0,D.toErrorMessage)(q)))}return this.installFromGallery(W)}markAsUninstalled(...U){return this.S.setUninstalled(...U)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(U,B){const{location:W}=await this.W.download(U,B);return W}async fb(U){if(U.scheme===E.Schemas.file)return{location:U,async cleanup(){}};this.v.trace("Downloading extension from",U.toString());const B=(0,m.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)());return await this.bb.download(U,B),this.v.info("Downloaded extension to",B.toString()),{location:B,cleanup:async()=>{try{await this.cb.del(B)}catch(q){this.v.error(q)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(U,B,W){let q;if(S.URI.isUri(B))q=new J(U,B,W,this.t,this.S,this.v);else{const Y=t.ExtensionKey.create(B).toString();q=this.Y.get(Y),q||(this.Y.set(Y,q=new V(U,B,W,this.W,this.S,this.v)),q.waitUntilTaskIsFinished().then(()=>this.Y.delete(Y)))}return new _(q,W.profileLocation,this.db,this.y,this.Z,this.ab)}R(U,B){return new re(U,B.profileLocation,this.ab)}async jb(U){const B=async q=>{let Y=await c.Promises.readdir(q);Y=Y.map(Z=>C.join(q,Z));const ee=await Promise.all(Y.map(Z=>c.Promises.stat(Z)));let K=Promise.resolve([]);return ee.forEach((Z,se)=>{const le=Y[se];Z.isFile()&&(K=K.then(ue=>[...ue,le])),Z.isDirectory()&&(K=K.then(ue=>B(le).then(pe=>[...ue,...pe])))}),K};return(await B(U.location.fsPath)).map(q=>({path:`extension/${C.relative(U.location.fsPath,q)}`,localPath:q}))}async kb({added:U,removed:B}){if(B)for(const W of B.extensions)this.v.info("Extensions removed from another source",W.id,B.profileLocation.toString()),this.p.fire({identifier:W,profileLocation:B.profileLocation});if(U){const q=(await this.S.scanExtensions(1,U.profileLocation)).filter(Y=>U.extensions.some(ee=>(0,t.areSameExtensions)(ee,Y.identifier)));this.m.fire(q.map(Y=>(this.v.info("Extensions added from another source",Y.identifier.id,U.profileLocation.toString()),{identifier:Y.identifier,local:Y,profileLocation:U.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(B=>this.lb.add(B)));const U=await this.cb.resolve(this.Z.userExtensionsLocation);for(const B of U.children??[])B.isDirectory&&this.lb.add(B.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(B=>this.nb(B)))}async nb(U){if(!U.affects(this.Z.userExtensionsLocation,1))return;const B=[];for(const W of U.rawAdded){if(this.lb.has(W)||!this.db.extUri.isEqual(this.db.extUri.dirname(W),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(W,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(W).startsWith(".")||!(await this.cb.stat(W)).isDirectory)continue;const q=await this.S.scanUserExtensionAtLocation(W);q&&q.installedTimestamp===void 0&&(this.lb.add(W),B.push(q))}B.length&&(await this.ob(B,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",B.map(W=>W.identifier.id)))}async ob(U,B){await this.ab.addExtensionsToProfile(U.map(W=>[W,void 0]),B),this.m.fire(U.map(W=>({local:W,identifier:W.identifier,operation:1,profileLocation:B})))}};ie=ye([G(0,o.IExtensionGalleryService),G(1,z.ITelemetryService),G(2,L.ILogService),G(3,R.INativeEnvironmentService),G(4,s.IExtensionsScannerService),G(5,n.IExtensionsProfileScannerService),G(6,w.IDownloadService),G(7,M.IInstantiationService),G(8,F.IFileService),G(9,$.IProductService),G(10,x.IUriIdentityService),G(11,X.IUserDataProfilesService)],ie),e.ExtensionManagementService=ie;let H=class extends P.Disposable{constructor(U,B,W,q,Y){super(),this.j=U,this.k=B,this.l=W,this.m=q,this.n=Y,this.h=this.B(new O.Emitter),this.onExtract=this.h.event,this.c=(0,m.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new k.Queue}async cleanUp(){await this.w()}async scanExtensions(U,B){const W={includeInvalid:!0,profileLocation:B};let q=[];return U===null||U===0?q.push(...await this.l.scanAllExtensions({includeInvalid:!0},W,!1)):U===1&&q.push(...await this.l.scanUserExtensions(W)),q=U!==null?q.filter(Y=>Y.type===U):q,Promise.all(q.map(Y=>this.v(Y)))}async scanAllUserExtensions(U){const B=await this.l.scanUserExtensions({includeAllVersions:!U,includeInvalid:!0});return Promise.all(B.map(W=>this.v(W)))}async scanUserExtensionAtLocation(U){try{const B=await this.l.scanExistingExtension(U,1,{includeInvalid:!0});if(B)return await this.v(B)}catch(B){this.n.error(B)}return null}async extractUserExtension(U,B,W,q){const Y=U.toString(),ee=C.join(this.l.userExtensionsLocation.fsPath,`.${(0,f.generateUuid)()}`),K=C.join(this.l.userExtensionsLocation.fsPath,Y);try{await c.Promises.rm(K)}catch{throw new o.ExtensionManagementError(p.localize(4,null,K,U.id),o.ExtensionManagementErrorCode.Delete)}await this.s(U,B,ee,q),await this.l.updateMetadata(S.URI.file(ee),W);try{this.h.fire(S.URI.file(K)),await this.t(U,ee,K,Date.now()+2*60*1e3),this.n.info("Renamed to",K)}catch(Z){try{await c.Promises.rm(ee)}catch{}if(Z.code==="ENOTEMPTY")this.n.info("Rename failed because extension was installed by another source. So ignoring renaming.",U.id);else throw this.n.info(`Rename failed because of ${(0,l.getErrorMessage)(Z)}. Deleted from extracted location`,ee),Z}return this.u(S.URI.file(K),1)}async scanMetadata(U,B){return B?(await this.m.scanProfileExtensions(B)).find(q=>(0,t.areSameExtensions)(q.identifier,U.identifier))?.metadata:this.l.scanMetadata(U.location)}async updateMetadata(U,B,W){return W?await this.m.updateMetadata([[U,B]],W):await this.l.updateMetadata(U.location,B),this.u(U.location,U.type)}getUninstalledExtensions(){return this.p()}async setUninstalled(...U){const B=U.map(W=>t.ExtensionKey.create(W));await this.p(W=>B.forEach(q=>{W[q.toString()]=!0,this.n.info("Marked extension as uninstalled",q.toString())}))}async setInstalled(U){await this.p(q=>delete q[U.toString()]);const W=(await this.scanAllUserExtensions(!0)).find(q=>t.ExtensionKey.create(q).equals(U))||null;return W?this.updateMetadata(W,{installedTimestamp:Date.now()}):null}async removeExtension(U,B){this.n.trace(`Deleting ${B} extension from disk`,U.identifier.id,U.location.fsPath),await c.Promises.rm(U.location.fsPath),this.n.info("Deleted from disk",U.identifier.id,U.location.fsPath)}async removeUninstalledExtension(U){await this.removeExtension(U,"uninstalled"),await this.p(B=>delete B[t.ExtensionKey.create(U).toString()])}async p(U){return this.g.queue(async()=>{let B;try{B=await c.Promises.readFile(this.c,"utf8")}catch(q){if(q.code!=="ENOENT")throw q}let W={};if(B)try{W=JSON.parse(B)}catch{}return U&&(U(W),Object.keys(W).length?await c.Promises.writeFile(this.c,JSON.stringify(W)):await c.Promises.rm(this.c)),W})}async s(U,B,W,q){this.n.trace(`Started extracting the extension from ${B} to ${W}`);try{await c.Promises.rm(W)}catch(Y){throw new o.ExtensionManagementError(this.y(Y).message,o.ExtensionManagementErrorCode.Delete)}try{await(0,d.extract)(B,W,{sourcePath:"extension",overwrite:!0},q),this.n.info(`Extracted extension to ${W}:`,U.id)}catch(Y){try{await c.Promises.rm(W)}catch{}let ee=o.ExtensionManagementErrorCode.Extract;throw Y instanceof d.ExtractError&&(Y.type==="CorruptZip"?ee=o.ExtensionManagementErrorCode.CorruptZip:Y.type==="Incomplete"&&(ee=o.ExtensionManagementErrorCode.IncompleteZip)),new o.ExtensionManagementError(Y.message,ee)}}async t(U,B,W,q){try{await c.Promises.rename(B,W)}catch(Y){if(b.isWindows&&Y&&Y.code==="EPERM"&&Date.now()<q)return this.n.info(`Failed renaming ${B} to ${W} with 'EPERM' error. Trying again...`,U.id),this.t(U,B,W,q);throw new o.ExtensionManagementError(Y.message||p.localize(5,null,B,W),Y.code||o.ExtensionManagementErrorCode.Rename)}}async u(U,B){const W=await this.l.scanExistingExtension(U,B,{includeInvalid:!0});if(W)return this.v(W);throw new Error(p.localize(6,null,U.path))}async v(U){const B=await this.k.resolve(U.location);let W,q;return B.children&&(W=B.children.find(({name:Y})=>/^readme(\.txt|\.md|)$/i.test(Y))?.resource,q=B.children.find(({name:Y})=>/^changelog(\.txt|\.md|)$/i.test(Y))?.resource),{identifier:U.identifier,type:U.type,isBuiltin:U.isBuiltin||!!U.metadata?.isBuiltin,location:U.location,manifest:U.manifest,targetPlatform:U.targetPlatform,validations:U.validations,isValid:U.isValid,readmeUrl:W,changelogUrl:q,publisherDisplayName:U.metadata?.publisherDisplayName||null,publisherId:U.metadata?.publisherId||null,isApplicationScoped:!!U.metadata?.isApplicationScoped,isMachineScoped:!!U.metadata?.isMachineScoped,isPreReleaseVersion:!!U.metadata?.isPreReleaseVersion,preRelease:!!U.metadata?.preRelease,installedTimestamp:U.metadata?.installedTimestamp,updated:!!U.metadata?.updated,pinned:!!U.metadata?.pinned}}async w(){const U=await this.getUninstalledExtensions(),B=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),W=new Set;for(const ee of B)U[t.ExtensionKey.create(ee).toString()]||W.add(ee.identifier.id.toLowerCase());const q=(0,t.groupByExtension)(B,ee=>ee.identifier);await k.Promises.settled(q.map(async ee=>{const K=ee.sort((Z,se)=>y.rcompare(Z.manifest.version,se.manifest.version))[0];W.has(K.identifier.id.toLowerCase())||await this.j(await this.v(K))}));const Y=B.filter(ee=>ee.metadata&&U[t.ExtensionKey.create(ee).toString()]);await k.Promises.settled(Y.map(ee=>this.removeUninstalledExtension(ee)))}y(U){const B=Array.isArray(U)?U:[U];return B.length===1?B[0]instanceof Error?B[0]:new Error(B[0]):B.reduce((W,q)=>new Error(`${W.message}${W.message?",":""}${q instanceof Error?q.message:q}`),new Error(""))}};H=ye([G(1,F.IFileService),G(2,s.IExtensionsScannerService),G(3,n.IExtensionsProfileScannerService),G(4,L.ILogService)],H),e.ExtensionsScanner=H;class j extends i.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,u.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(U,B,W,q,Y){super(),this.identifier=U,this.source=B,this.l=W,this.m=q,this.n=Y,this.j="Unverified",this.k=2}async o(U,B){try{const W=await this.p(U.key);if(W)return this.m.updateMetadata(W,U.metadata)}catch{throw b.isMacintosh?new o.ExtensionManagementError(p.localize(7,null),o.ExtensionManagementErrorCode.Internal):new o.ExtensionManagementError(p.localize(8,null),o.ExtensionManagementErrorCode.Internal)}return this.s(U,B)}async p(U){if(!await this.q(U))return null;this.n.trace("Removing the extension from uninstalled list:",U.id);const W=await this.m.setInstalled(U);return this.n.info("Removed the extension from uninstalled list:",U.id),W}async q(U){return!!(await this.m.getUninstalledExtensions())[U.toString()]}async s({zipPath:U,key:B,metadata:W},q){const Y=await this.m.extractUserExtension(B,U,W,q);return this.n.info("Extracting completed.",B.id),Y}}class V extends j{constructor(U,B,W,q,Y,ee){super(B.identifier,B,W,Y,ee),this.t=U,this.u=B,this.v=q}async h(U){const W=(await this.m.scanExtensions(null,this.l.profileLocation)).find(K=>(0,t.areSameExtensions)(K.identifier,this.u.identifier));W&&(this.k=3);const q={id:this.u.identifier.uuid,publisherId:this.u.publisherId,publisherDisplayName:this.u.publisherDisplayName,targetPlatform:this.u.properties.targetPlatform,isApplicationScoped:(0,A.isApplicationScopedExtension)(this.t),isMachineScoped:this.l.isMachineScoped||W?.isMachineScoped,isBuiltin:this.l.isBuiltin||W?.isBuiltin,isSystem:W?.type===0?!0:void 0,updated:!!W,isPreReleaseVersion:this.u.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0,preRelease:this.u.properties.isPreReleaseVersion||((0,u.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:W?.preRelease)};if(W?.manifest.version===this.u.version)return{local:await this.m.updateMetadata(W,q),metadata:q};const{location:Y,verificationStatus:ee}=await this.v.download(this.u,this.k);try{return this.j=ee,this.x(Y.fsPath),{local:await this.o({zipPath:Y.fsPath,key:t.ExtensionKey.create(this.u),metadata:q},U),metadata:q}}catch(K){try{await this.v.delete(Y)}catch(Z){this.n.warn("Error while deleting the downloaded file",Y.toString(),(0,l.getErrorMessage)(Z))}throw K}}async x(U){try{await(0,h.getManifest)(U)}catch(B){throw new o.ExtensionManagementError((0,i.joinErrors)(B).message,o.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=V;class J extends j{constructor(U,B,W,q,Y,ee){super({id:(0,t.getGalleryExtensionId)(U.publisher,U.name)},B,W,Y,ee),this.t=U,this.u=B,this.v=q}async h(U){const B=new t.ExtensionKey(this.identifier,this.t.version),q=(await this.m.scanExtensions(1,this.l.profileLocation)).find(K=>(0,t.areSameExtensions)(this.identifier,K.identifier)),Y=await this.x(this.identifier.id,this.t.version,U);if(Y.isApplicationScoped=(0,A.isApplicationScopedExtension)(this.t),Y.isMachineScoped=this.l.isMachineScoped||q?.isMachineScoped,Y.isBuiltin=this.l.isBuiltin||q?.isBuiltin,Y.installedTimestamp=Date.now(),Y.pinned=this.l.installGivenVersion?!0:void 0,q)if(this.k=3,B.equals(new t.ExtensionKey(q.identifier,q.manifest.version)))try{await this.m.removeExtension(q,"existing")}catch{throw new Error(p.localize(9,null,this.t.displayName||this.t.name))}else!this.l.profileLocation&&y.gt(q.manifest.version,this.t.version)&&await this.m.setUninstalled(q);else{const K=await this.p(B);if(K)try{await this.m.removeExtension(K,"existing")}catch{throw new Error(p.localize(10,null,this.t.displayName||this.t.name))}}return{local:await this.o({zipPath:C.resolve(this.u.fsPath),key:B,metadata:Y},U),metadata:Y}}async x(U,B,W){try{let[q]=await this.v.getExtensions([{id:U,version:B}],W);if(q||([q]=await this.v.getExtensions([{id:U}],W)),q)return{id:q.identifier.uuid,publisherDisplayName:q.publisherDisplayName,publisherId:q.publisherId,isPreReleaseVersion:q.properties.isPreReleaseVersion,preRelease:q.properties.isPreReleaseVersion||this.l.installPreReleaseVersion}}catch{}return{}}}class _{get verificationStatus(){return this.d.verificationStatus}constructor(U,B,W,q,Y,ee){this.d=U,this.g=B,this.h=W,this.j=q,this.k=Y,this.l=ee,this.identifier=this.d.identifier,this.source=this.d.source,this.operation=this.d.operation,this.c=this.m()}async m(){const U=await this.d.waitUntilTaskIsFinished();return this.h.extUri.isEqual(this.j.defaultProfile.extensionsResource,this.g)&&await this.k.initializeDefaultProfileExtensions(),await this.l.addExtensionsToProfile([[U.local,U.metadata]],this.g),U}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class re extends i.AbstractExtensionTask{constructor(U,B,W){super(),this.extension=U,this.j=B,this.k=W}async h(U){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(oe[289],ae([0,1,2,30,80,238,127,8,20]),function(Q,e,k,T,D,l,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let E=class extends k.Disposable{constructor(b,m,y,u,S,f){super(),b.removeUninstalledExtensions(),(0,l.migrateUnsupportedExtensions)(b,m,y,u,f),D.ExtensionStorageService.removeOutdatedExtensionVersions(b,S)}};E=ye([G(0,O.INativeServerExtensionManagementService),G(1,T.IExtensionGalleryService),G(2,D.IExtensionStorageService),G(3,T.IGlobalExtensionEnablementService),G(4,I.IStorageService),G(5,P.ILogService)],E),e.ExtensionsContributions=E}),define(oe[298],ae([0,1,94,34,38,9,2,26,22,11,39,151,215,216,208,209,287,197,200,16,221,96,236,97,228,15,233,118,273,30,98,199,274,127,99,195,14,211,212,55,5,206,72,207,57,73,242,8,104,58,105,23,60,20,275,110,19,111,112,113,47,245,115,251,254,80,116,24,78,278,265,266,81,279,282,283,284,285,277,62,267,109,235,77,256,225,255,108,232,29,257,4,258,201,219,218,79,272,18,51,214,59,276,230,244,268,237,107,103,281,289,270,7,213]),function(Q,e,k,T,D,l,O,P,I,E,C,b,m,y,u,S,f,c,d,p,w,R,i,o,t,n,s,a,r,h,g,v,A,N,F,M,L,$,z,x,X,ie,H,j,V,J,_,re,te,U,B,W,q,Y,ee,K,Z,se,le,ue,pe,ve,be,Ee,Oe,Ue,Ye,Be,ce,de,ge,Ce,Pe,Le,De,je,Te,Fe,ze,ke,Ne,ne,he,fe,me,Se,Ie,Re,xe,$e,Ae,qe,He,et,rt,vt,Lt,At,St,Ot,Tt,wt,Nt,Ut,Mt,Ft,jt,bt,Et,$t,Bt,zt,Ct,qt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Wt extends O.Disposable{constructor(we){super(),this.f=we,this.a=this.B(new b.Server),this.b=void 0,this.c=void 0,this.g()}g(){const we=async()=>{this.c&&(await this.c.fireOnWillShutdown(),this.c.dispose(),this.c=void 0),this.dispose()};process.once("exit",we),k.ipcRenderer.once("vscode:electron-main->shared-process=exit",we);const Me="vscode:electron-main->shared-process=disposeWorker",Ge=(Je,it)=>{this.h(it)};k.ipcRenderer.on(Me,Ge),this.B((0,O.toDisposable)(()=>k.ipcRenderer.removeListener(Me,Ge)))}h(we){this.b?.disposeWorker(we)}async open(){const we=await this.i();(0,Be.registerConfiguration)(),we.invokeFunction(Me=>{const Ge=Me.get(re.ILogService);Ge.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Me),this.k(Ge)}),this.B((0,O.combinedDisposable)(we.createInstance(m.CodeCacheCleaner,this.f.codeCachePath),we.createInstance(y.LanguagePackCachedDataCleaner),we.createInstance(f.UnusedWorkspaceStorageDataCleaner),we.createInstance(S.LogsDataCleaner),we.createInstance(u.LocalizationsUpdater),we.createInstance(Bt.ExtensionsContributions),we.createInstance(Ft.UserDataProfilesCleaner)))}async i(){const we=new H.ServiceCollection,Me={_serviceBrand:void 0,...B.default};we.set(W.IProductService,Me);const Ge=new C.StaticRouter(Ze=>Ze==="main"),Je=new j.MessagePortMainProcessService(this.a,Ge);we.set(V.IMainProcessService,Je);const it=this.f.policiesData?new Tt.PolicyChannelClient(this.f.policiesData,Je.getChannel("policy")):new wt.NullPolicyService;we.set(wt.IPolicyService,it);const Ke=new s.SharedProcessEnvironmentService(this.f.args,Me);we.set(n.INativeEnvironmentService,Ke);const tt=new te.LoggerChannelClient(void 0,this.f.logLevel,this.f.loggers,Je.getChannel("logger"));we.set(re.ILoggerService,tt);const ut=this.B(tt.createLogger((0,I.joinPath)(E.URI.file(Ke.logsPath),"sharedprocess.log"),{id:"sharedLog",name:(0,Ct.localize)(0,null)})),ht=this.B(new re.ConsoleLogger(this.f.logLevel)),We=this.B(new qt.LogService(ut,[ht]));we.set(re.ILogService,We),this.c=new Et.SharedProcessLifecycleService(We),we.set(Et.ISharedProcessLifecycleService,this.c),this.b=new xe.SharedProcessWorkerService(We),we.set(Re.ISharedProcessWorkerService,this.b);const _e=this.B(new $.FileService(We));we.set(L.IFileService,_e);const ft=this.B(new z.DiskFileSystemProvider(We));_e.registerProvider(P.Schemas.file,ft);const dt=this.B(new He.FileUserDataProvider(P.Schemas.file,this.B(new et.DiskFileSystemProviderClient(Je.getChannel(et.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:qe.isLinux})),P.Schemas.vscodeUserData,We));_e.registerProvider(P.Schemas.vscodeUserData,dt);const nt=this.B(new Nt.UserDataProfilesNativeService(this.f.profiles,Je,Ke));we.set(St.IUserDataProfilesService,nt);const Xe=this.B(new w.ConfigurationService(nt.defaultProfile.settingsResource,_e,it,We));we.set(p.IConfigurationService,Xe);const ot=new ee.NativeStorageService(void 0,{defaultProfile:nt.defaultProfile,currentProfile:nt.defaultProfile},Je,Ke);we.set(Y.IStorageService,ot),this.B((0,O.toDisposable)(()=>ot.flush())),await Promise.all([Xe.initialize(),ot.initialize()]);const gt=new Ae.UriIdentityService(_e);we.set($e.IUriIdentityService,gt),we.set(q.IRequestService,new Ut.SharedProcessRequestService(Je,Xe,Me,We)),we.set(c.IChecksumService,new x.SyncDescriptor(d.ChecksumService,void 0,!1)),we.set(vt.IV8InspectProfilingService,new x.SyncDescriptor(rt.InspectProfilingService,void 0,!1));const ct=C.ProxyChannel.toService(Je.getChannel("nativeHost"),{context:this.f.windowId});we.set(U.INativeHostService,ct),we.set(o.IDownloadService,new x.SyncDescriptor(t.DownloadService,void 0,!0));const mt=this.B(new Ne.ActiveWindowManager(ct)),xt=new C.StaticRouter(Ze=>mt.getActiveClientId().then(pt=>Ze===pt));we.set(F.IExtensionRecommendationNotificationService,new M.ExtensionRecommendationNotificationServiceChannelClient(this.a.getChannel("extensionRecommendationNotification",xt)));let lt;const at=[],Pt=(0,pe.isInternalTelemetry)(Me,Xe);if((0,pe.supportsTelemetry)(Me,Ke)){const Ze=new le.TelemetryLogAppender(We,tt,Ke,Me);at.push(Ze);const{installSourcePath:pt}=Ke;if(Me.aiConfig?.ariaKey){const Dt=new Mt.OneDataSystemAppender(Pt,"monacoworkbench",null,Me.aiConfig.ariaKey);this.B((0,O.toDisposable)(()=>Dt.flush())),at.push(Dt)}lt=new ue.TelemetryService({appenders:at,commonProperties:(0,K.resolveCommonProperties)(_e,(0,T.release)(),(0,T.hostname)(),process.arch,Me.commit,Me.version,this.f.machineId,Pt,pt),sendErrorTelemetry:!0,piiPaths:(0,pe.getPiiPathsFromEnvironment)(Ke)},Xe,Me)}else{lt=pe.NullTelemetryService;const Ze=pe.NullAppender;at.push(Ze)}this.a.registerChannel("telemetryAppender",new se.TelemetryAppenderChannel(at)),we.set(Z.ITelemetryService,lt);const Ht=new ve.CustomEndpointTelemetryService(Xe,lt,We,tt,Ke,Me);we.set(Z.ICustomEndpointTelemetryService,Ht),we.set(Ot.IExtensionsProfileScannerService,new x.SyncDescriptor(zt.ExtensionsProfileScannerService,void 0,!0)),we.set(Lt.IExtensionsScannerService,new x.SyncDescriptor(At.ExtensionsScannerService,void 0,!0)),we.set(g.IExtensionSignatureVerificationService,new x.SyncDescriptor(g.ExtensionSignatureVerificationService,void 0,!0)),we.set(N.INativeServerExtensionManagementService,new x.SyncDescriptor(N.ExtensionManagementService,void 0,!0)),we.set(h.IExtensionGalleryService,new x.SyncDescriptor(r.ExtensionGalleryService,void 0,!0)),we.set(h.IExtensionTipsService,new x.SyncDescriptor(A.ExtensionTipsService,void 0,!1)),we.set(J.ILanguagePackService,new x.SyncDescriptor(_.NativeLanguagePackService,void 0,!1)),we.set(R.IDiagnosticsService,new x.SyncDescriptor(i.DiagnosticsService,void 0,!1)),we.set(ce.IUserDataSyncAccountService,new x.SyncDescriptor(ce.UserDataSyncAccountService,void 0,!0)),we.set(Be.IUserDataSyncLogService,new x.SyncDescriptor(Ce.UserDataSyncLogService,void 0,!0)),we.set(Be.IUserDataSyncUtilService,new ge.UserDataSyncUtilServiceClient(this.a.getChannel("userDataSyncUtil",Ze=>Ze.ctx!=="main"))),we.set(h.IGlobalExtensionEnablementService,new x.SyncDescriptor(a.GlobalExtensionEnablementService,void 0,!1)),we.set(Ye.IIgnoredExtensionsManagementService,new x.SyncDescriptor(Ye.IgnoredExtensionsManagementService,void 0,!0)),we.set(Ue.IExtensionStorageService,new x.SyncDescriptor(Ue.ExtensionStorageService)),we.set(Be.IUserDataSyncStoreManagementService,new x.SyncDescriptor(Te.UserDataSyncStoreManagementService,void 0,!0)),we.set(Be.IUserDataSyncStoreService,new x.SyncDescriptor(Te.UserDataSyncStoreService,void 0,!0)),we.set(Pe.IUserDataSyncMachinesService,new x.SyncDescriptor(Pe.UserDataSyncMachinesService,void 0,!0)),we.set(Be.IUserDataSyncBackupStoreService,new x.SyncDescriptor(de.UserDataSyncBackupStoreService,void 0,!1)),we.set(Be.IUserDataSyncEnablementService,new x.SyncDescriptor(Le.UserDataSyncEnablementService,void 0,!0)),we.set(Be.IUserDataSyncService,new x.SyncDescriptor(De.UserDataSyncService,void 0,!1)),we.set(ke.IUserDataProfileStorageService,new x.SyncDescriptor(ze.UserDataProfileStorageService,void 0,!0)),we.set(Be.IUserDataSyncResourceProviderService,new x.SyncDescriptor($t.UserDataSyncResourceProviderService,void 0,!0));const Rt=new Oe.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Xe.getValue("terminal.integrated.persistentSessionScrollback")??100},(0,Ct.localize)(1,null),Xe,Ke,We,tt);return Rt.initialize(),we.set(Ee.ILocalPtyService,this.B(Rt)),we.set(ne.ISignService,new x.SyncDescriptor(he.SignService,void 0,!1)),we.set(fe.ISharedTunnelsService,new x.SyncDescriptor(me.SharedTunnelsService)),we.set(Se.ISharedProcessTunnelService,new x.SyncDescriptor(Ie.SharedProcessTunnelService)),we.set(bt.IRemoteTunnelService,new x.SyncDescriptor(jt.RemoteTunnelService)),new ie.InstantiationService(we)}j(we){const Me=new v.ExtensionManagementChannel(we.get(h.IExtensionManagementService),()=>null);this.a.registerChannel("extensions",Me);const Ge=C.ProxyChannel.fromService(we.get(J.ILanguagePackService));this.a.registerChannel("languagePacks",Ge);const Je=C.ProxyChannel.fromService(we.get(R.IDiagnosticsService));this.a.registerChannel("diagnostics",Je);const it=new v.ExtensionTipsChannel(we.get(h.IExtensionTipsService));this.a.registerChannel("extensionTipsService",it);const Ke=C.ProxyChannel.fromService(we.get(c.IChecksumService));this.a.registerChannel("checksum",Ke);const tt=C.ProxyChannel.fromService(we.get(vt.IV8InspectProfilingService));this.a.registerChannel("v8InspectProfiling",tt);const ut=new ge.UserDataSyncMachinesServiceChannel(we.get(Pe.IUserDataSyncMachinesService));this.a.registerChannel("userDataSyncMachines",ut);const ht=C.ProxyChannel.fromService(we.get(Z.ICustomEndpointTelemetryService));this.a.registerChannel("customEndpointTelemetry",ht);const We=new ge.UserDataSyncAccountServiceChannel(we.get(ce.IUserDataSyncAccountService));this.a.registerChannel("userDataSyncAccount",We);const _e=new ge.UserDataSyncStoreManagementServiceChannel(we.get(Be.IUserDataSyncStoreManagementService));this.a.registerChannel("userDataSyncStoreManagement",_e);const ft=new je.UserDataSyncChannel(we.get(Be.IUserDataSyncService),we.get(St.IUserDataProfilesService),we.get(re.ILogService));this.a.registerChannel("userDataSync",ft);const dt=this.B(we.get(X.IInstantiationService).createInstance(Fe.UserDataAutoSyncService)),nt=new ge.UserDataAutoSyncChannel(dt);this.a.registerChannel("userDataAutoSync",nt);const Xe=we.get(Ee.ILocalPtyService),ot=C.ProxyChannel.fromService(Xe);this.a.registerChannel(be.TerminalIpcChannels.LocalPty,ot);const gt=C.ProxyChannel.fromService(we.get(Se.ISharedProcessTunnelService));this.a.registerChannel(Se.ipcSharedProcessTunnelChannelName,gt);const ct=C.ProxyChannel.fromService(we.get(Re.ISharedProcessWorkerService));this.a.registerChannel(Re.ipcSharedProcessWorkerChannelName,ct);const mt=C.ProxyChannel.fromService(we.get(bt.IRemoteTunnelService));this.a.registerChannel("remoteTunnel",mt)}k(we){window.addEventListener("unhandledrejection",Me=>{(0,l.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,l.setUnexpectedErrorHandler)(Me=>{const Ge=(0,D.toErrorMessage)(Me,!0);!Ge||we.error(`[uncaught exception in sharedProcess]: ${Ge}`)})}}async function Vt(It){const we=new Wt(It);k.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await we.open(),k.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Vt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8be8d96ab86ed4077df554eb62727484d454699f/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
