/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/base/common/types","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/errors","electron","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","os","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/uuid","vs/base/common/extpath","vs/platform/environment/common/environment","vs/platform/state/electron-main/state","vs/base/common/process","vs/base/common/labels","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/map","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/json","vs/base/common/objects","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/update/common/update","vs/base/common/functional","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/remote/common/remoteHosts","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/processes","vs/base/common/severity","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensions/common/extensions","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/update/electron-main/abstractUpdateService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/parts/sandbox/electron-main/electronTypes","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/shell/node/shellEnv","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/codicons","vs/base/common/themables","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","vs/platform/utilityProcess/electron-main/utilityProcess","string_decoder","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","https","vscode-policy-watcher","zlib","vs/code/electron-main/main"],ie=function(V){for(var e=[],I=0,L=V.length;I<L;I++)e[I]=te[V[I]];return e};define(te[122],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function I(P,h){const m=Math.pow(10,h);return Math.round(P*m)/m}class L{constructor(h,m,S,v=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,S))|0,this.a=I(Math.max(Math.min(1,v),0),3)}static equals(h,m){return h.r===m.r&&h.g===m.g&&h.b===m.b&&h.a===m.a}}e.RGBA=L;class k{constructor(h,m,S,v){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=I(Math.max(Math.min(1,m),0),3),this.l=I(Math.max(Math.min(1,S),0),3),this.a=I(Math.max(Math.min(1,v),0),3)}static equals(h,m){return h.h===m.h&&h.s===m.s&&h.l===m.l&&h.a===m.a}static fromRGBA(h){const m=h.r/255,S=h.g/255,v=h.b/255,b=h.a,f=Math.max(m,S,v),p=Math.min(m,S,v);let w=0,c=0;const u=(p+f)/2,g=f-p;if(g>0){switch(c=Math.min(u<=.5?g/(2*u):g/(2-2*u),1),f){case m:w=(S-v)/g+(S<v?6:0);break;case S:w=(v-m)/g+2;break;case v:w=(m-S)/g+4;break}w*=60,w=Math.round(w)}return new k(w,c,u,b)}static i(h,m,S){return S<0&&(S+=1),S>1&&(S-=1),S<1/6?h+(m-h)*6*S:S<1/2?m:S<2/3?h+(m-h)*(2/3-S)*6:h}static toRGBA(h){const m=h.h/360,{s:S,l:v,a:b}=h;let f,p,w;if(S===0)f=p=w=v;else{const c=v<.5?v*(1+S):v+S-v*S,u=2*v-c;f=k.i(u,c,m+1/3),p=k.i(u,c,m),w=k.i(u,c,m-1/3)}return new L(Math.round(f*255),Math.round(p*255),Math.round(w*255),b)}}e.HSLA=k;class o{constructor(h,m,S,v){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=I(Math.max(Math.min(1,m),0),3),this.v=I(Math.max(Math.min(1,S),0),3),this.a=I(Math.max(Math.min(1,v),0),3)}static equals(h,m){return h.h===m.h&&h.s===m.s&&h.v===m.v&&h.a===m.a}static fromRGBA(h){const m=h.r/255,S=h.g/255,v=h.b/255,b=Math.max(m,S,v),f=Math.min(m,S,v),p=b-f,w=b===0?0:p/b;let c;return p===0?c=0:b===m?c=((S-v)/p%6+6)%6:b===S?c=(v-m)/p+2:c=(m-S)/p+4,new o(Math.round(c*60),w,b,h.a)}static toRGBA(h){const{h:m,s:S,v,a:b}=h,f=v*S,p=f*(1-Math.abs(m/60%2-1)),w=v-f;let[c,u,g]=[0,0,0];return m<60?(c=f,u=p):m<120?(c=p,u=f):m<180?(u=f,g=p):m<240?(u=p,g=f):m<300?(c=p,g=f):m<=360&&(c=f,g=p),c=Math.round((c+w)*255),u=Math.round((u+w)*255),g=Math.round((g+w)*255),new L(c,u,g,b)}}e.HSVA=o;class C{static fromHex(h){return C.Format.CSS.parseHex(h)||C.red}static equals(h,m){return!h&&!m?!0:!h||!m?!1:h.equals(m)}get hsla(){return this.i?this.i:k.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:o.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof L)this.rgba=h;else if(h instanceof k)this.i=h,this.rgba=k.toRGBA(h);else if(h instanceof o)this.j=h,this.rgba=o.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&L.equals(this.rgba,h.rgba)&&k.equals(this.hsla,h.hsla)&&o.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=C.k(this.rgba.r),m=C.k(this.rgba.g),S=C.k(this.rgba.b),v=.2126*h+.7152*m+.0722*S;return I(v,4)}static k(h){const m=h/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(h){const m=this.getRelativeLuminance(),S=h.getRelativeLuminance();return m>S?(m+.05)/(S+.05):(S+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const m=this.getRelativeLuminance(),S=h.getRelativeLuminance();return m>S}isDarkerThan(h){const m=this.getRelativeLuminance(),S=h.getRelativeLuminance();return m<S}lighten(h){return new C(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new C(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:m,g:S,b:v,a:b}=this.rgba;return new C(new L(m,S,v,b*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new C(new L(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const m=h.rgba,S=this.rgba.a,v=m.a,b=S+v*(1-S);if(b<1e-6)return C.transparent;const f=this.rgba.r*S/b+m.r*v*(1-S)/b,p=this.rgba.g*S/b+m.g*v*(1-S)/b,w=this.rgba.b*S/b+m.b*v*(1-S)/b;return new C(new L(f,p,w,b))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:m,g:S,b:v,a:b}=this.rgba;return new C(new L(h.rgba.r-b*(h.rgba.r-m),h.rgba.g-b*(h.rgba.g-S),h.rgba.b-b*(h.rgba.b-v),1))}flatten(...h){const m=h.reduceRight((S,v)=>C.o(v,S));return C.o(this,m)}static o(h,m){const S=1-h.rgba.a;return new C(new L(S*m.rgba.r+h.rgba.a*h.rgba.r,S*m.rgba.g+h.rgba.a*h.rgba.g,S*m.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this.u||(this.u=C.Format.CSS.format(this)),this.u}static getLighterColor(h,m,S){if(h.isLighterThan(m))return h;S=S||.5;const v=h.getRelativeLuminance(),b=m.getRelativeLuminance();return S=S*(b-v)/b,h.lighten(S)}static getDarkerColor(h,m,S){if(h.isDarkerThan(m))return h;S=S||.5;const v=h.getRelativeLuminance(),b=m.getRelativeLuminance();return S=S*(v-b)/v,h.darken(S)}}e.Color=C,C.white=new C(new L(255,255,255,1)),C.black=new C(new L(0,0,0,1)),C.red=new C(new L(255,0,0,1)),C.blue=new C(new L(0,0,255,1)),C.green=new C(new L(0,255,0,1)),C.cyan=new C(new L(0,255,255,1)),C.lightgrey=new C(new L(211,211,211,1)),C.transparent=new C(new L(0,0,0,0)),function(P){let h;(function(m){let S;(function(v){function b(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:P.Format.CSS.formatRGBA(t)}v.formatRGB=b;function f(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}v.formatRGBA=f;function p(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(t)}v.formatHSL=p;function w(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}v.formatHSLA=w;function c(t){const a=t.toString(16);return a.length!==2?"0"+a:a}function u(t){return`#${c(t.rgba.r)}${c(t.rgba.g)}${c(t.rgba.b)}`}v.formatHex=u;function g(t,a=!1){return a&&t.rgba.a===1?P.Format.CSS.formatHex(t):`#${c(t.rgba.r)}${c(t.rgba.g)}${c(t.rgba.b)}${c(Math.round(t.rgba.a*255))}`}v.formatHexA=g;function D(t){return t.isOpaque()?P.Format.CSS.formatHex(t):P.Format.CSS.formatRGBA(t)}v.format=D;function E(t){const a=t.length;if(a===0||t.charCodeAt(0)!==35)return null;if(a===7){const i=16*R(t.charCodeAt(1))+R(t.charCodeAt(2)),n=16*R(t.charCodeAt(3))+R(t.charCodeAt(4)),r=16*R(t.charCodeAt(5))+R(t.charCodeAt(6));return new P(new L(i,n,r,1))}if(a===9){const i=16*R(t.charCodeAt(1))+R(t.charCodeAt(2)),n=16*R(t.charCodeAt(3))+R(t.charCodeAt(4)),r=16*R(t.charCodeAt(5))+R(t.charCodeAt(6)),l=16*R(t.charCodeAt(7))+R(t.charCodeAt(8));return new P(new L(i,n,r,l/255))}if(a===4){const i=R(t.charCodeAt(1)),n=R(t.charCodeAt(2)),r=R(t.charCodeAt(3));return new P(new L(16*i+i,16*n+n,16*r+r))}if(a===5){const i=R(t.charCodeAt(1)),n=R(t.charCodeAt(2)),r=R(t.charCodeAt(3)),l=R(t.charCodeAt(4));return new P(new L(16*i+i,16*n+n,16*r+r,(16*l+l)/255))}return null}v.parseHex=E;function R(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(S=m.CSS||(m.CSS={}))})(h=P.Format||(P.Format={}))}(C=e.Color||(e.Color={}))}),define(te[54],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function I(C){return(P,h,m)=>{let S=null,v=null;if(typeof m.value=="function"?(S="value",v=m.value):typeof m.get=="function"&&(S="get",v=m.get),!v)throw new Error("not supported");m[S]=C(v,h)}}function L(C,P,h){let m=null,S=null;if(typeof h.value=="function"?(m="value",S=h.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(m="get",S=h.get),!S)throw new Error("not supported");const v=`$memoize$${P}`;h[m]=function(...b){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,b)}),this[v]}}e.memoize=L;function k(C,P,h){return I((m,S)=>{const v=`$debounce$${S}`,b=`$debounce$result$${S}`;return function(...f){this[b]||(this[b]=h?h():void 0),clearTimeout(this[v]),P&&(this[b]=P(this[b],...f),f=[this[b]]),this[v]=setTimeout(()=>{m.apply(this,f),this[b]=h?h():void 0},C)}})}e.debounce=k;function o(C,P,h){return I((m,S)=>{const v=`$throttle$timer$${S}`,b=`$throttle$result$${S}`,f=`$throttle$lastRun$${S}`,p=`$throttle$pending$${S}`;return function(...w){if(this[b]||(this[b]=h?h():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),P&&(this[b]=P(this[b],...w)),this[p])return;const c=this[f]+C;c<=Date.now()?(this[f]=Date.now(),m.apply(this,[this[b]]),this[b]=h?h():void 0):(this[p]=!0,this[v]=setTimeout(()=>{this[p]=!1,this[f]=Date.now(),m.apply(this,[this[b]]),this[b]=h?h():void 0},c-Date.now()))}})}e.throttle=o}),define(te[13],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class I{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?D.isErrorNoTelemetry(t)?new D(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(a=>{a(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.ErrorHandler=I,e.errorHandler=new I;function L(R){e.errorHandler.setUnexpectedErrorHandler(R)}e.setUnexpectedErrorHandler=L;function k(R){h(R)||e.errorHandler.onUnexpectedError(R)}e.onUnexpectedError=k;function o(R){h(R)||e.errorHandler.onUnexpectedExternalError(R)}e.onUnexpectedExternalError=o;function C(R){if(R instanceof Error){const{name:t,message:a}=R,i=R.stacktrace||R.stack;return{$isError:!0,name:t,message:a,stack:i,noTelemetry:D.isErrorNoTelemetry(R)}}return R}e.transformErrorForSerialization=C;const P="Canceled";function h(R){return R instanceof m?!0:R instanceof Error&&R.name===P&&R.message===P}e.isCancellationError=h;class m extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=m;function S(){const R=new Error(P);return R.name=R.message,R}e.canceled=S;function v(R){return R?new Error(`Illegal argument: ${R}`):new Error("Illegal argument")}e.illegalArgument=v;function b(R){return R?new Error(`Illegal state: ${R}`):new Error("Illegal state")}e.illegalState=b;function f(R){return R?new Error(`readonly property '${R} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function p(R){const t=new Error(`${R} has been disposed`);return t.name="DISPOSED",t}e.disposed=p;function w(R){return R?R.message?R.message:R.stack?R.stack.split(`
`)[0]:String(R):"Error"}e.getErrorMessage=w;class c extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=c;class u extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=u;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=g;class D extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof D)return t;const a=new D;return a.message=t.message,a.stack=t.stack,a}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=D;class E extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype);debugger}}e.BugIndicatingError=E}),define(te[25],ie([0,1,13]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function L(N,q=0){return N[N.length-(1+q)]}e.tail=L;function k(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.tail2=k;function o(N,q,Q=(oe,ue)=>oe===ue){if(N===q)return!0;if(!N||!q||N.length!==q.length)return!1;for(let oe=0,ue=N.length;oe<ue;oe++)if(!Q(N[oe],q[oe]))return!1;return!0}e.equals=o;function C(N,q){const Q=N.length-1;q<Q&&(N[q]=N[Q]),N.pop()}e.removeFastWithoutKeepingOrder=C;function P(N,q,Q){return h(N.length,oe=>Q(N[oe],q))}e.binarySearch=P;function h(N,q){let Q=0,oe=N-1;for(;Q<=oe;){const ue=(Q+oe)/2|0,ye=q(ue);if(ye<0)Q=ue+1;else if(ye>0)oe=ue-1;else return ue}return-(Q+1)}e.binarySearch2=h;function m(N,q){let Q=0,oe=N.length;if(oe===0)return 0;for(;Q<oe;){const ue=Math.floor((Q+oe)/2);q(N[ue])?oe=ue:Q=ue+1}return Q}e.findFirstInSorted=m;function S(N,q,Q){if(N=N|0,N>=q.length)throw new TypeError("invalid index");const oe=q[Math.floor(q.length*Math.random())],ue=[],ye=[],ke=[];for(const Ae of q){const Re=Q(Ae,oe);Re<0?ue.push(Ae):Re>0?ye.push(Ae):ke.push(Ae)}return N<ue.length?S(N,ue,Q):N<ue.length+ke.length?ke[0]:S(N-(ue.length+ke.length),ye,Q)}e.quickSelect=S;function v(N,q){const Q=[];let oe;for(const ue of N.slice(0).sort(q))!oe||q(oe[0],ue)!==0?(oe=[ue],Q.push(oe)):oe.push(ue);return Q}e.groupBy=v;function b(N,q,Q){const oe=[];function ue(Ae,Re,Fe){if(Re===0&&Fe.length===0)return;const we=oe[oe.length-1];we&&we.start+we.deleteCount===Ae?(we.deleteCount+=Re,we.toInsert.push(...Fe)):oe.push({start:Ae,deleteCount:Re,toInsert:Fe})}let ye=0,ke=0;for(;;){if(ye===N.length){ue(ye,0,q.slice(ke));break}if(ke===q.length){ue(ye,N.length-ye,[]);break}const Ae=N[ye],Re=q[ke],Fe=Q(Ae,Re);Fe===0?(ye+=1,ke+=1):Fe<0?(ue(ye,1,[]),ye+=1):Fe>0&&(ue(ye,0,[Re]),ke+=1)}return oe}e.sortedDiff=b;function f(N,q,Q){const oe=b(N,q,Q),ue=[],ye=[];for(const ke of oe)ue.push(...N.slice(ke.start,ke.start+ke.deleteCount)),ye.push(...ke.toInsert);return{removed:ue,added:ye}}e.delta=f;function p(N,q,Q){if(Q===0)return[];const oe=N.slice(0,Q).sort(q);return c(N,q,oe,Q,N.length),oe}e.top=p;function w(N,q,Q,oe,ue){return Q===0?Promise.resolve([]):new Promise((ye,ke)=>{(async()=>{const Ae=N.length,Re=N.slice(0,Q).sort(q);for(let Fe=Q,we=Math.min(Q+oe,Ae);Fe<Ae;Fe=we,we=Math.min(we+oe,Ae)){if(Fe>Q&&await new Promise(pe=>setTimeout(pe)),ue&&ue.isCancellationRequested)throw new I.CancellationError;c(N,q,Re,Fe,we)}return Re})().then(ye,ke)})}e.topAsync=w;function c(N,q,Q,oe,ue){for(const ye=Q.length;oe<ue;oe++){const ke=N[oe];if(q(ke,Q[ye-1])<0){Q.pop();const Ae=m(Q,Re=>q(ke,Re)<0);Q.splice(Ae,0,ke)}}}function u(N){return N.filter(q=>!!q)}e.coalesce=u;function g(N){let q=0;for(let Q=0;Q<N.length;Q++)N[Q]&&(N[q]=N[Q],q+=1);N.length=q}e.coalesceInPlace=g;function D(N,q,Q){N.splice(Q,0,N.splice(q,1)[0])}e.move=D;function E(N){return!Array.isArray(N)||N.length===0}e.isFalsyOrEmpty=E;function R(N){return Array.isArray(N)&&N.length>0}e.isNonEmptyArray=R;function t(N,q=Q=>Q){const Q=new Set;return N.filter(oe=>{const ue=q(oe);return Q.has(ue)?!1:(Q.add(ue),!0)})}e.distinct=t;function a(N){const q=new Set;return Q=>{const oe=N(Q);return q.has(oe)?!1:(q.add(oe),!0)}}e.uniqueFilter=a;function i(N,q){const Q=n(N,q);if(Q!==-1)return N[Q]}e.findLast=i;function n(N,q){for(let Q=N.length-1;Q>=0;Q--){const oe=N[Q];if(q(oe))return Q}return-1}e.lastIndex=n;function r(N,q){return N.length>0?N[0]:q}e.firstOrDefault=r;function l(N,q){return N.length>0?N[N.length-1]:q}e.lastOrDefault=l;function s(N,q,Q=(oe,ue)=>oe===ue){let oe=0;for(let ue=0,ye=Math.min(N.length,q.length);ue<ye&&Q(N[ue],q[ue]);ue++)oe++;return oe}e.commonPrefixLength=s;function d(N){return[].concat(...N)}e.flatten=d;function y(N,q){let Q=typeof q=="number"?N:0;typeof q=="number"?Q=N:(Q=0,q=N);const oe=[];if(Q<=q)for(let ue=Q;ue<q;ue++)oe.push(ue);else for(let ue=Q;ue>q;ue--)oe.push(ue);return oe}e.range=y;function M(N,q,Q){return N.reduce((oe,ue)=>(oe[q(ue)]=Q?Q(ue):ue,oe),Object.create(null))}e.index=M;function O(N,q){return N.push(q),()=>j(N,q)}e.insert=O;function j(N,q){const Q=N.indexOf(q);if(Q>-1)return N.splice(Q,1),q}e.remove=j;function K(N,q,Q){const oe=N.slice(0,q),ue=N.slice(q);return oe.concat(Q,ue)}e.arrayInsert=K;function x(N,q){let Q;if(typeof q=="number"){let oe=q;Q=()=>{const ue=Math.sin(oe++)*179426549;return ue-Math.floor(ue)}}else Q=Math.random;for(let oe=N.length-1;oe>0;oe-=1){const ue=Math.floor(Q()*(oe+1)),ye=N[oe];N[oe]=N[ue],N[ue]=ye}}e.shuffle=x;function J(N,q){const Q=N.indexOf(q);Q>-1&&(N.splice(Q,1),N.unshift(q))}e.pushToStart=J;function re(N,q){const Q=N.indexOf(q);Q>-1&&(N.splice(Q,1),N.push(q))}e.pushToEnd=re;function se(N,q){for(const Q of q)N.push(Q)}e.pushMany=se;function ae(N,q){return Array.isArray(N)?N.map(q):q(N)}e.mapArrayOrNot=ae;function fe(N){return Array.isArray(N)?N:[N]}e.asArray=fe;function ge(N){return N[Math.floor(Math.random()*N.length)]}e.getRandomElement=ge;function H(N,q){for(const Q of N){const oe=q(Q);if(oe!==void 0)return oe}}e.mapFind=H;function F(N,q,Q){const oe=z(N,q),ue=N.length,ye=Q.length;N.length=ue+ye;for(let ke=ue-1;ke>=oe;ke--)N[ke+ye]=N[ke];for(let ke=0;ke<ye;ke++)N[ke+oe]=Q[ke]}e.insertInto=F;function U(N,q,Q,oe){const ue=z(N,q),ye=N.splice(ue,Q);return F(N,ue,oe),ye}e.splice=U;function z(N,q){return q<0?Math.max(q+N.length,0):Math.min(q,N.length)}var Y;(function(N){function q(ue){return ue<0}N.isLessThan=q;function Q(ue){return ue>0}N.isGreaterThan=Q;function oe(ue){return ue===0}N.isNeitherLessOrGreaterThan=oe,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(Y=e.CompareResult||(e.CompareResult={}));function ne(N,q){return(Q,oe)=>q(N(Q),N(oe))}e.compareBy=ne;function _(...N){return(q,Q)=>{for(const oe of N){const ue=oe(q,Q);if(!Y.isNeitherLessOrGreaterThan(ue))return ue}return Y.neitherLessOrGreaterThan}}e.tieBreakComparators=_;const $=(N,q)=>N-q;e.numberComparator=$;function A(N,q){if(N.length===0)return;let Q=N[0];for(let oe=1;oe<N.length;oe++){const ue=N[oe];q(ue,Q)>0&&(Q=ue)}return Q}e.findMaxBy=A;function T(N,q){if(N.length===0)return;let Q=N[0];for(let oe=1;oe<N.length;oe++){const ue=N[oe];q(ue,Q)>=0&&(Q=ue)}return Q}e.findLastMaxBy=T;function W(N,q){return A(N,(Q,oe)=>-q(Q,oe))}e.findMinBy=W;class B{constructor(q){this.f=q,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(q){let Q=this.c;for(;Q<this.f.length&&q(this.f[Q]);)Q++;const oe=Q===this.c?null:this.f.slice(this.c,Q);return this.c=Q,oe}takeFromEndWhile(q){let Q=this.d;for(;Q>=0&&q(this.f[Q]);)Q--;const oe=Q===this.d?null:this.f.slice(Q+1,this.d+1);return this.d=Q,oe}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const q=this.f[this.c];return this.c++,q}removeLast(){const q=this.f[this.d];return this.d--,q}takeCount(q){const Q=this.f.slice(this.c,this.c+q);return this.c+=q,Q}}e.ArrayQueue=B;class G{constructor(q){this.iterate=q}forEach(q){this.iterate(Q=>(q(Q),!0))}toArray(){const q=[];return this.iterate(Q=>(q.push(Q),!0)),q}filter(q){return new G(Q=>this.iterate(oe=>q(oe)?Q(oe):!0))}map(q){return new G(Q=>this.iterate(oe=>Q(q(oe))))}some(q){let Q=!1;return this.iterate(oe=>(Q=q(oe),!Q)),Q}findFirst(q){let Q;return this.iterate(oe=>q(oe)?(Q=oe,!1):!0),Q}findLast(q){let Q;return this.iterate(oe=>(q(oe)&&(Q=oe),!0)),Q}findLastMaxBy(q){let Q,oe=!0;return this.iterate(ue=>((oe||Y.isGreaterThan(q(ue,Q)))&&(oe=!1,Q=ue),!0)),Q}}e.CallbackIterable=G,G.empty=new G(N=>{})}),define(te[123],ie([0,1,13]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function L(h,m){if(!h)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=L;function k(h,m="Unreachable"){throw new Error(m)}e.assertNever=k;function o(h){if(!h)throw new I.BugIndicatingError("Assertion Failed")}e.assert=o;function C(h){if(!h()){debugger;h(),(0,I.onUnexpectedError)(new I.BugIndicatingError("Assertion Failed"))}}e.assertFn=C;function P(h,m){let S=0;for(;S<h.length-1;){const v=h[S],b=h[S+1];if(!m(v,b))return!1;S++}return!0}e.checkAdjacentItems=P}),define(te[49],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function I(L){const k=this;let o=!1,C;return function(){return o||(o=!0,C=L.apply(k,arguments)),C}}e.once=I}),define(te[69],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(L){function k(E){return E&&typeof E=="object"&&typeof E[Symbol.iterator]=="function"}L.is=k;const o=Object.freeze([]);function C(){return o}L.empty=C;function*P(E){yield E}L.single=P;function h(E){return k(E)?E:P(E)}L.wrap=h;function m(E){return E||o}L.from=m;function S(E){return!E||E[Symbol.iterator]().next().done===!0}L.isEmpty=S;function v(E){return E[Symbol.iterator]().next().value}L.first=v;function b(E,R){for(const t of E)if(R(t))return!0;return!1}L.some=b;function f(E,R){for(const t of E)if(R(t))return t}L.find=f;function*p(E,R){for(const t of E)R(t)&&(yield t)}L.filter=p;function*w(E,R){let t=0;for(const a of E)yield R(a,t++)}L.map=w;function*c(...E){for(const R of E)for(const t of R)yield t}L.concat=c;function u(E,R,t){let a=t;for(const i of E)a=R(a,i);return a}L.reduce=u;function*g(E,R,t=E.length){for(R<0&&(R+=E.length),t<0?t+=E.length:t>E.length&&(t=E.length);R<t;R++)yield E[R]}L.slice=g;function D(E,R=Number.POSITIVE_INFINITY){const t=[];if(R===0)return[t,E];const a=E[Symbol.iterator]();for(let i=0;i<R;i++){const n=a.next();if(n.done)return[t,L.empty()];t.push(n.value)}return[t,{[Symbol.iterator](){return a}}]}L.consume=D})(I=e.Iterable||(e.Iterable={}))}),define(te[43],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var o;(function(t){t.DEFAULT={allowTrailingComma:!0}})(o=e.ParseOptions||(e.ParseOptions={}));function C(t,a=!1){let i=0;const n=t.length;let r="",l=0,s=16,d=0;function y(re){let se=0,ae=0;for(;se<re;){const fe=t.charCodeAt(i);if(fe>=48&&fe<=57)ae=ae*16+fe-48;else if(fe>=65&&fe<=70)ae=ae*16+fe-65+10;else if(fe>=97&&fe<=102)ae=ae*16+fe-97+10;else break;i++,se++}return se<re&&(ae=-1),ae}function M(re){i=re,r="",l=0,s=16,d=0}function O(){const re=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&m(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&m(t.charCodeAt(i)))for(i++;i<t.length&&m(t.charCodeAt(i));)i++;else return d=3,t.substring(re,i);let se=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&m(t.charCodeAt(i))){for(i++;i<t.length&&m(t.charCodeAt(i));)i++;se=i}else d=3;return t.substring(re,se)}function j(){let re="",se=i;for(;;){if(i>=n){re+=t.substring(se,i),d=2;break}const ae=t.charCodeAt(i);if(ae===34){re+=t.substring(se,i),i++;break}if(ae===92){if(re+=t.substring(se,i),i++,i>=n){d=2;break}switch(t.charCodeAt(i++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const ge=y(4);ge>=0?re+=String.fromCharCode(ge):d=4;break}default:d=5}se=i;continue}if(ae>=0&&ae<=31)if(h(ae)){re+=t.substring(se,i),d=2;break}else d=6;i++}return re}function K(){if(r="",d=0,l=i,i>=n)return l=n,s=17;let re=t.charCodeAt(i);if(P(re)){do i++,r+=String.fromCharCode(re),re=t.charCodeAt(i);while(P(re));return s=15}if(h(re))return i++,r+=String.fromCharCode(re),re===13&&t.charCodeAt(i)===10&&(i++,r+=`
`),s=14;switch(re){case 123:return i++,s=1;case 125:return i++,s=2;case 91:return i++,s=3;case 93:return i++,s=4;case 58:return i++,s=6;case 44:return i++,s=5;case 34:return i++,r=j(),s=10;case 47:{const se=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!h(t.charCodeAt(i));)i++;return r=t.substring(se,i),s=12}if(t.charCodeAt(i+1)===42){i+=2;const ae=n-1;let fe=!1;for(;i<ae;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,fe=!0;break}i++}return fe||(i++,d=1),r=t.substring(se,i),s=13}return r+=String.fromCharCode(re),i++,s=16}case 45:if(r+=String.fromCharCode(re),i++,i===n||!m(t.charCodeAt(i)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=O(),s=11;default:for(;i<n&&x(re);)i++,re=t.charCodeAt(i);if(l!==i){switch(r=t.substring(l,i),r){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return r+=String.fromCharCode(re),i++,s=16}}function x(re){if(P(re)||h(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function J(){let re;do re=K();while(re>=12&&re<=15);return re}return{setPosition:M,getPosition:()=>i,scan:a?J:K,getToken:()=>s,getTokenValue:()=>r,getTokenOffset:()=>l,getTokenLength:()=>i-l,getTokenError:()=>d}}e.createScanner=C;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function m(t){return t>=48&&t<=57}var S;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(S||(S={}));function v(t,a){const i=[],n=new Object;let r;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function d(y,M,O,j){l.value=y,l.offset=M,l.length=O,l.type=j,l.colonOffset=void 0,r=l}try{D(t,{onObjectBegin:(y,M)=>{if(a<=y)throw n;r=void 0,s=a>y,i.push("")},onObjectProperty:(y,M,O)=>{if(a<M||(d(y,M,O,"property"),i[i.length-1]=y,a<=M+O))throw n},onObjectEnd:(y,M)=>{if(a<=y)throw n;r=void 0,i.pop()},onArrayBegin:(y,M)=>{if(a<=y)throw n;r=void 0,i.push(0)},onArrayEnd:(y,M)=>{if(a<=y)throw n;r=void 0,i.pop()},onLiteralValue:(y,M,O)=>{if(a<M||(d(y,M,O,R(y)),a<=M+O))throw n},onSeparator:(y,M,O)=>{if(a<=M)throw n;if(y===":"&&r&&r.type==="property")r.colonOffset=M,s=!1,r=void 0;else if(y===","){const j=i[i.length-1];typeof j=="number"?i[i.length-1]=j+1:(s=!0,i[i.length-1]=""),r=void 0}}})}catch(y){if(y!==n)throw y}return{path:i,previousNode:r,isAtPropertyKey:s,matches:y=>{let M=0;for(let O=0;M<y.length&&O<i.length;O++)if(y[M]===i[O]||y[M]==="*")M++;else if(y[M]!=="**")return!1;return M===y.length}}}e.getLocation=v;function b(t,a=[],i=o.DEFAULT){let n=null,r=[];const l=[];function s(y){Array.isArray(r)?r.push(y):n!==null&&(r[n]=y)}return D(t,{onObjectBegin:()=>{const y={};s(y),l.push(r),r=y,n=null},onObjectProperty:y=>{n=y},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const y=[];s(y),l.push(r),r=y,n=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:s,onError:(y,M,O)=>{a.push({error:y,offset:M,length:O})}},i),r[0]}e.parse=b;function f(t,a=[],i=o.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(y){n.type==="property"&&(n.length=y-n.offset,n=n.parent)}function l(y){return n.children.push(y),y}D(t,{onObjectBegin:y=>{n=l({type:"object",offset:y,length:-1,parent:n,children:[]})},onObjectProperty:(y,M,O)=>{n=l({type:"property",offset:M,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:y,offset:M,length:O,parent:n})},onObjectEnd:(y,M)=>{n.length=y+M-n.offset,n=n.parent,r(y+M)},onArrayBegin:(y,M)=>{n=l({type:"array",offset:y,length:-1,parent:n,children:[]})},onArrayEnd:(y,M)=>{n.length=y+M-n.offset,n=n.parent,r(y+M)},onLiteralValue:(y,M,O)=>{l({type:R(y),offset:M,length:O,parent:n,value:y}),r(M+O)},onSeparator:(y,M,O)=>{n.type==="property"&&(y===":"?n.colonOffset=M:y===","&&r(M))},onError:(y,M,O)=>{a.push({error:y,offset:M,length:O})}},i);const d=n.children[0];return d&&delete d.parent,d}e.parseTree=f;function p(t,a){if(!t)return;let i=t;for(const n of a)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const l of i.children)if(Array.isArray(l.children)&&l.children[0].value===n){i=l.children[1],r=!0;break}if(!r)return}else{const r=n;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=p;function w(t){if(!t.parent||!t.parent.children)return[];const a=w(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;a.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&a.push(i)}return a}e.getNodePath=w;function c(t){switch(t.type){case"array":return t.children.map(c);case"object":{const a=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(a[i.children[0].value]=c(n))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=c;function u(t,a,i=!1){return a>=t.offset&&a<t.offset+t.length||i&&a===t.offset+t.length}e.contains=u;function g(t,a,i=!1){if(u(t,a,i)){const n=t.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=a;r++){const l=g(n[r],a,i);if(l)return l}return t}}e.findNodeAtOffset=g;function D(t,a,i=o.DEFAULT){const n=C(t,!1);function r(ne){return ne?()=>ne(n.getTokenOffset(),n.getTokenLength()):()=>!0}function l(ne){return ne?_=>ne(_,n.getTokenOffset(),n.getTokenLength()):()=>!0}const s=r(a.onObjectBegin),d=l(a.onObjectProperty),y=r(a.onObjectEnd),M=r(a.onArrayBegin),O=r(a.onArrayEnd),j=l(a.onLiteralValue),K=l(a.onSeparator),x=r(a.onComment),J=l(a.onError),re=i&&i.disallowComments,se=i&&i.allowTrailingComma;function ae(){for(;;){const ne=n.scan();switch(n.getTokenError()){case 4:fe(14);break;case 5:fe(15);break;case 3:fe(13);break;case 1:re||fe(11);break;case 2:fe(12);break;case 6:fe(16);break}switch(ne){case 12:case 13:re?fe(10):x();break;case 16:fe(1);break;case 15:case 14:break;default:return ne}}}function fe(ne,_=[],$=[]){if(J(ne),_.length+$.length>0){let A=n.getToken();for(;A!==17;){if(_.indexOf(A)!==-1){ae();break}else if($.indexOf(A)!==-1)break;A=ae()}}}function ge(ne){const _=n.getTokenValue();return ne?j(_):d(_),ae(),!0}function H(){switch(n.getToken()){case 11:{let ne=0;try{ne=JSON.parse(n.getTokenValue()),typeof ne!="number"&&(fe(2),ne=0)}catch{fe(2)}j(ne);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return ae(),!0}function F(){return n.getToken()!==10?(fe(3,[],[2,5]),!1):(ge(!1),n.getToken()===6?(K(":"),ae(),Y()||fe(4,[],[2,5])):fe(5,[],[2,5]),!0)}function U(){s(),ae();let ne=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ne||fe(4,[],[]),K(","),ae(),n.getToken()===2&&se)break}else ne&&fe(6,[],[]);F()||fe(4,[],[2,5]),ne=!0}return y(),n.getToken()!==2?fe(7,[2],[]):ae(),!0}function z(){M(),ae();let ne=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ne||fe(4,[],[]),K(","),ae(),n.getToken()===4&&se)break}else ne&&fe(6,[],[]);Y()||fe(4,[],[4,5]),ne=!0}return O(),n.getToken()!==4?fe(8,[4],[]):ae(),!0}function Y(){switch(n.getToken()){case 3:return z();case 1:return U();case 10:return ge(!0);default:return H()}}return ae(),n.getToken()===17?i.allowEmptyContent?!0:(fe(4,[],[]),!1):Y()?(n.getToken()!==17&&fe(9,[],[]),!0):(fe(4,[],[]),!1)}e.visit=D;function E(t,a){const i=C(t),n=[];let r,l=0,s;do switch(s=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:l!==s&&n.push(t.substring(l,s)),a!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,a)),l=i.getPosition();break}while(r!==17);return n.join("")}e.stripComments=E;function R(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=R}),define(te[124],ie([0,1,43]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function L(m,S,v){let b,f,p,w,c;if(S){for(w=S.offset,c=w+S.length,p=w;p>0&&!h(m,p-1);)p--;let s=c;for(;s<m.length&&!h(m,s);)s++;f=m.substring(p,s),b=C(f,v)}else f=m,b=0,p=0,w=0,c=m.length;const u=P(v,m);let g=!1,D=0,E;v.insertSpaces?E=o(" ",v.tabSize||4):E="	";const R=(0,I.createScanner)(f,!1);let t=!1;function a(){return u+o(E,b+D)}function i(){let s=R.scan();for(g=!1;s===15||s===14;)g=g||s===14,s=R.scan();return t=s===16||R.getTokenError()!==0,s}const n=[];function r(s,d,y){!t&&d<c&&y>w&&m.substring(d,y)!==s&&n.push({offset:d,length:y-d,content:s})}let l=i();if(l!==17){const s=R.getTokenOffset()+p,d=o(E,b);r(d,p,s)}for(;l!==17;){let s=R.getTokenOffset()+R.getTokenLength()+p,d=i(),y="";for(;!g&&(d===12||d===13);){const O=R.getTokenOffset()+p;r(" ",s,O),s=R.getTokenOffset()+R.getTokenLength()+p,y=d===12?a():"",d=i()}if(d===2)l!==1&&(D--,y=a());else if(d===4)l!==3&&(D--,y=a());else{switch(l){case 3:case 1:D++,y=a();break;case 5:case 12:y=a();break;case 13:g?y=a():y=" ";break;case 6:y=" ";break;case 10:if(d===6){y="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?y=" ":d!==5&&d!==17&&(t=!0);break;case 16:t=!0;break}g&&(d===12||d===13)&&(y=a())}const M=R.getTokenOffset()+p;r(y,s,M),l=d}return n}e.format=L;function k(m,S){const v=JSON.stringify(m,void 0,S.insertSpaces?S.tabSize||4:"	");return S.eol!==void 0?v.replace(/\r\n|\r|\n/g,S.eol):v}e.toFormattedString=k;function o(m,S){let v="";for(let b=0;b<S;b++)v+=m;return v}function C(m,S){let v=0,b=0;const f=S.tabSize||4;for(;v<m.length;){const p=m.charAt(v);if(p===" ")b++;else if(p==="	")b+=f;else break;v++}return Math.floor(b/f)}function P(m,S){for(let v=0;v<S.length;v++){const b=S.charAt(v);if(b==="\r")return v+1<S.length&&S.charAt(v+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=P;function h(m,S){return`\r
`.indexOf(m.charAt(S))!==-1}e.isEOL=h}),define(te[125],ie([0,1,43,124]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(m,S,v){return o(m,S,void 0,v)}e.removeProperty=k;function o(m,S,v,b,f){const p=S.slice(),w=[],c=(0,I.parseTree)(m,w);let u,g;for(;p.length>0&&(g=p.pop(),u=(0,I.findNodeAtLocation)(c,p),u===void 0&&v!==void 0);)typeof g=="string"?v={[g]:v}:v=[v];if(u)if(u.type==="object"&&typeof g=="string"&&Array.isArray(u.children)){const D=(0,I.findNodeAtLocation)(u,[g]);if(D!==void 0)if(v===void 0){if(!D.parent)throw new Error("Malformed AST");const E=u.children.indexOf(D.parent);let R,t=D.parent.offset+D.parent.length;if(E>0){const a=u.children[E-1];R=a.offset+a.length}else R=u.offset+1,u.children.length>1&&(t=u.children[1].offset);return C(m,{offset:R,length:t-R,content:""},b)}else return C(m,{offset:D.offset,length:D.length,content:JSON.stringify(v)},b);else{if(v===void 0)return[];const E=`${JSON.stringify(g)}: ${JSON.stringify(v)}`,R=f?f(u.children.map(a=>a.children[0].value)):u.children.length;let t;if(R>0){const a=u.children[R-1];t={offset:a.offset+a.length,length:0,content:","+E}}else u.children.length===0?t={offset:u.offset+1,length:0,content:E}:t={offset:u.offset+1,length:0,content:E+","};return C(m,t,b)}}else if(u.type==="array"&&typeof g=="number"&&Array.isArray(u.children))if(v!==void 0){const D=`${JSON.stringify(v)}`;let E;if(u.children.length===0||g===0)E={offset:u.offset+1,length:0,content:u.children.length===0?D:D+","};else{const R=g===-1||g>u.children.length?u.children.length:g,t=u.children[R-1];E={offset:t.offset+t.length,length:0,content:","+D}}return C(m,E,b)}else{const D=g,E=u.children[D];let R;if(u.children.length===1)R={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===D){const t=u.children[D-1],a=t.offset+t.length,i=u.offset+u.length;R={offset:a,length:i-2-a,content:""}}else R={offset:E.offset,length:u.children[D+1].offset-E.offset,content:""};return C(m,R,b)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${u.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return C(m,{offset:c?c.offset:0,length:c?c.length:0,content:JSON.stringify(v)},b)}}e.setProperty=o;function C(m,S,v){let b=P(m,S),f=S.offset,p=S.offset+S.content.length;if(S.length===0||S.content.length===0){for(;f>0&&!(0,L.isEOL)(b,f-1);)f--;for(;p<b.length&&!(0,L.isEOL)(b,p);)p++}const w=(0,L.format)(b,{offset:f,length:p-f},v);for(let u=w.length-1;u>=0;u--){const g=w[u];b=P(b,g),f=Math.min(f,g.offset),p=Math.max(p,g.offset+g.length),p+=g.content.length-g.length}const c=m.length-(b.length-p)-f;return[{offset:f,length:c,content:b.substring(f,p)}]}e.withFormatting=C;function P(m,S){return m.substring(0,S.offset)+S.content+m.substring(S.offset+S.length)}e.applyEdit=P;function h(m,S){const v=S.slice(0).sort((f,p)=>{const w=f.offset-p.offset;return w===0?f.length-p.length:w});let b=m.length;for(let f=v.length-1;f>=0;f--){const p=v[f];if(p.offset+p.length<=b)m=P(m,p);else throw new Error("Overlapping edit");b=p.offset}return m}e.applyEdits=h}),define(te[126],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class I{constructor(k){this.d=k,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(k){this.c=k}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=I}),define(te[2],ie([0,1,49,69]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let o=null;function C(l){o=l}if(e.setDisposableTracker=C,k){const l="__is_disposable_tracked__";C(new class{trackDisposable(s){const d=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[l]||console.log(d)},3e3)}setParent(s,d){if(s&&s!==g.None)try{s[l]=!0}catch{}}markAsDisposed(s){if(s&&s!==g.None)try{s[l]=!0}catch{}}markAsSingleton(s){}})}function P(l){return o?.trackDisposable(l),l}function h(l){o?.markAsDisposed(l)}function m(l,s){o?.setParent(l,s)}function S(l,s){if(!!o)for(const d of l)o.setParent(d,s)}function v(l){return o?.markAsSingleton(l),l}e.markAsSingleton=v;function b(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=b;function f(l){if(L.Iterable.is(l)){const s=[];for(const d of l)if(d)try{d.dispose()}catch(y){s.push(y)}if(s.length===1)throw s[0];if(s.length>1)throw new AggregateError(s,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=f;function p(l){for(const s of l)b(s)&&s.dispose();return[]}e.disposeIfDisposable=p;function w(...l){const s=c(()=>f(l));return S(l,s),s}e.combinedDisposable=w;function c(l){const s=P({dispose:(0,I.once)(()=>{h(s),l()})});return s}e.toDisposable=c;class u{constructor(){this.c=new Set,this.f=!1,P(this)}dispose(){this.f||(h(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{f(this.c)}finally{this.c.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return m(s,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(s),s}}e.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this.q=new u,P(this),m(this.q,this)}dispose(){h(this),this.q.dispose()}B(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(s)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class D{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(s){this.b||s===this.a||(this.a?.dispose(),s&&m(s,this),this.a=s)}clear(){this.value=void 0}dispose(){this.b=!0,h(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const s=this.a;return this.a=void 0,s&&m(s,null),s}}e.MutableDisposable=D;class E{constructor(s){this.b=s,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=E;class R{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(s){let d=s;return this.unset=()=>d=void 0,this.isset=()=>d!==void 0,this.dispose=()=>{d&&(d(),d=void 0,h(this))},this}}e.SafeDisposable=R;class t{constructor(){this.a=new Map}acquire(s,...d){let y=this.a.get(s);y||(y={counter:0,object:this.b(s,...d)},this.a.set(s,y));const{object:M}=y,O=(0,I.once)(()=>{--y.counter===0&&(this.c(s,y.object),this.a.delete(s))});return y.counter++,{object:M,dispose:O}}}e.ReferenceCollection=t;class a{constructor(s){this.a=s}async acquire(s,...d){const y=this.a.acquire(s,...d);try{return{object:await y.object,dispose:()=>y.dispose()}}catch(M){throw y.dispose(),M}}}e.AsyncReferenceCollection=a;class i{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=i;function n(l){const s=new u;try{l(s)}finally{s.dispose()}}e.disposeOnReturn=n;class r{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){h(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(s){return this.a.has(s)}get(s){return this.a.get(s)}set(s,d,y=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),y||this.a.get(s)?.dispose(),this.a.set(s,d)}deleteAndDispose(s){this.a.get(s)?.dispose(),this.a.delete(s)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=r}),define(te[98],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class I{constructor(o){this.element=o,this.next=I.Undefined,this.prev=I.Undefined}}I.Undefined=new I(void 0);class L{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let o=this.a;for(;o!==I.Undefined;){const C=o.next;o.prev=I.Undefined,o.next=I.Undefined,o=C}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(o){return this.d(o,!1)}push(o){return this.d(o,!0)}d(o,C){const P=new I(o);if(this.a===I.Undefined)this.a=P,this.b=P;else if(C){const m=this.b;this.b=P,P.prev=m,m.next=P}else{const m=this.a;this.a=P,P.next=m,m.prev=P}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(P))}}shift(){if(this.a!==I.Undefined){const o=this.a.element;return this.e(this.a),o}}pop(){if(this.b!==I.Undefined){const o=this.b.element;return this.e(this.b),o}}e(o){if(o.prev!==I.Undefined&&o.next!==I.Undefined){const C=o.prev;C.next=o.next,o.next.prev=C}else o.prev===I.Undefined&&o.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):o.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):o.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let o=this.a;for(;o!==I.Undefined;)yield o.element,o=o.next}}e.LinkedList=L}),define(te[38],ie([0,1]),function(V,e){"use strict";var I,L,k;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function o(p,w,c){let u=p.get(w);return u===void 0&&(u=c,p.set(w,u)),u}e.getOrSet=o;function C(p){const w=[];return p.forEach((c,u)=>{w.push(`${u} => ${c}`)}),`Map(${p.size}) {${w.join(", ")}}`}e.mapToString=C;function P(p){const w=[];return p.forEach(c=>{w.push(c)}),`Set(${p.size}) {${w.join(", ")}}`}e.setToString=P;class h{constructor(w,c){this.uri=w,this.value=c}}class m{constructor(w,c){this[I]="ResourceMap",w instanceof m?(this.b=new Map(w.b),this.c=c??m.a):(this.b=new Map,this.c=w??m.a)}set(w,c){return this.b.set(this.c(w),new h(w,c)),this}get(w){return this.b.get(this.c(w))?.value}has(w){return this.b.has(this.c(w))}get size(){return this.b.size}clear(){this.b.clear()}delete(w){return this.b.delete(this.c(w))}forEach(w,c){typeof c<"u"&&(w=w.bind(c));for(const[u,g]of this.b)w(g.value,g.uri,this)}*values(){for(const w of this.b.values())yield w.value}*keys(){for(const w of this.b.values())yield w.uri}*entries(){for(const w of this.b.values())yield[w.uri,w.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,w]of this.b)yield[w.uri,w.value]}}e.ResourceMap=m,m.a=p=>p.toString();class S{constructor(w,c){this[L]="ResourceSet",!w||typeof w=="function"?this.a=new m(w):(this.a=new m(c),w.forEach(this.add,this))}get size(){return this.a.size}add(w){return this.a.set(w,w),this}clear(){this.a.clear()}delete(w){return this.a.delete(w)}forEach(w,c){this.a.forEach((u,g)=>w.call(c,g,g,this))}has(w){return this.a.has(w)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=S;var v;(function(p){p[p.None=0]="None",p[p.AsOld=1]="AsOld",p[p.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class b{constructor(){this[k]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(w){return this.a.has(w)}get(w,c=0){const u=this.a.get(w);if(!!u)return c!==0&&this.j(u,c),u.value}set(w,c,u=0){let g=this.a.get(w);if(g)g.value=c,u!==0&&this.j(g,u);else{switch(g={key:w,value:c,next:void 0,previous:void 0},u){case 0:this.h(g);break;case 1:this.g(g);break;case 2:this.h(g);break;default:this.h(g);break}this.a.set(w,g),this.d++}return this}delete(w){return!!this.remove(w)}remove(w){const c=this.a.get(w);if(!!c)return this.a.delete(w),this.i(c),this.d--,c.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const w=this.b;return this.a.delete(w.key),this.i(w),this.d--,w.value}forEach(w,c){const u=this.e;let g=this.b;for(;g;){if(c?w.bind(c)(g.value,g.key,this):w(g.value,g.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const w=this,c=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(w.e!==c)throw new Error("LinkedMap got modified during iteration.");if(u){const D={value:u.key,done:!1};return u=u.next,D}else return{value:void 0,done:!0}}};return g}values(){const w=this,c=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(w.e!==c)throw new Error("LinkedMap got modified during iteration.");if(u){const D={value:u.value,done:!1};return u=u.next,D}else return{value:void 0,done:!0}}};return g}entries(){const w=this,c=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(w.e!==c)throw new Error("LinkedMap got modified during iteration.");if(u){const D={value:[u.key,u.value],done:!1};return u=u.next,D}else return{value:void 0,done:!0}}};return g}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(w){if(w>=this.size)return;if(w===0){this.clear();return}let c=this.b,u=this.size;for(;c&&u>w;)this.a.delete(c.key),c=c.next,u--;this.b=c,this.d=u,c&&(c.previous=void 0),this.e++}g(w){if(!this.b&&!this.c)this.c=w;else if(this.b)w.next=this.b,this.b.previous=w;else throw new Error("Invalid list");this.b=w,this.e++}h(w){if(!this.b&&!this.c)this.b=w;else if(this.c)w.previous=this.c,this.c.next=w;else throw new Error("Invalid list");this.c=w,this.e++}i(w){if(w===this.b&&w===this.c)this.b=void 0,this.c=void 0;else if(w===this.b){if(!w.next)throw new Error("Invalid list");w.next.previous=void 0,this.b=w.next}else if(w===this.c){if(!w.previous)throw new Error("Invalid list");w.previous.next=void 0,this.c=w.previous}else{const c=w.next,u=w.previous;if(!c||!u)throw new Error("Invalid list");c.previous=u,u.next=c}w.next=void 0,w.previous=void 0,this.e++}j(w,c){if(!this.b||!this.c)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(w===this.b)return;const u=w.next,g=w.previous;w===this.c?(g.next=void 0,this.c=g):(u.previous=g,g.next=u),w.previous=void 0,w.next=this.b,this.b.previous=w,this.b=w,this.e++}else if(c===2){if(w===this.c)return;const u=w.next,g=w.previous;w===this.b?(u.previous=void 0,this.b=u):(u.previous=g,g.next=u),w.next=void 0,w.previous=this.c,this.c.next=w,this.c=w,this.e++}}}toJSON(){const w=[];return this.forEach((c,u)=>{w.push([u,c])}),w}fromJSON(w){this.clear();for(const[c,u]of w)this.set(c,u)}}e.LinkedMap=b;class f extends b{constructor(w,c=1){super(),this.k=w,this.l=Math.min(Math.max(0,c),1)}get limit(){return this.k}set limit(w){this.k=w,this.m()}get ratio(){return this.l}set ratio(w){this.l=Math.min(Math.max(0,w),1),this.m()}get(w,c=2){return super.get(w,c)}peek(w){return super.get(w,0)}set(w,c){return super.set(w,c,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=f}),define(te[79],ie([0,1,38]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new I.LRUCache(1e4);function k(m){return h(m,"NFC",L)}e.normalizeNFC=k;const o=new I.LRUCache(1e4);function C(m){return h(m,"NFD",o)}e.normalizeNFD=C;const P=/[^\u0000-\u0080]/;function h(m,S,v){if(!m)return m;const b=v.get(m);if(b)return b;let f;return P.test(m)?f=m.normalize(S):f=m,v.set(m,f),f}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(S){return C(S).replace(m,"")}}()}),define(te[127],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function I(P,h,m){return Math.min(Math.max(P,h),m)}e.clamp=I;function L(P,h){return(h+P%h)%h}e.rot=L;class k{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=k;class o{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=o;class C{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const m=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=m,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=C}),function(){function V(k){const o=[];typeof k=="number"&&o.push("code/timeOrigin",k);function C(h){o.push(h,Date.now())}function P(){const h=[];for(let m=0;m<o.length;m+=2)h.push({name:o[m],startTime:o[m+1]});return h}return{mark:C,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const o=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const C of performance.getEntriesByType("mark"))o.push({name:C.name,startTime:Math.round(k+C.startTime)});return o}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function I(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=I(L))}(),function(V,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var L in I)(typeof exports=="object"?exports:V)[L]=I[L]}}(typeof self<"u"?self:this,function(){return function(V){var e={};function I(L){if(e[L])return e[L].exports;var k=e[L]={i:L,l:!1,exports:{}};return V[L].call(k.exports,k,k.exports,I),k.l=!0,k.exports}return I.m=V,I.c=e,I.d=function(L,k,o){I.o(L,k)||Object.defineProperty(L,k,{enumerable:!0,get:o})},I.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},I.t=function(L,k){if(1&k&&(L=I(L)),8&k||4&k&&typeof L=="object"&&L&&L.__esModule)return L;var o=Object.create(null);if(I.r(o),Object.defineProperty(o,"default",{enumerable:!0,value:L}),2&k&&typeof L!="string")for(var C in L)I.d(o,C,function(P){return L[P]}.bind(null,C));return o},I.n=function(L){var k=L&&L.__esModule?function(){return L.default}:function(){return L};return I.d(k,"a",k),k},I.o=function(L,k){return Object.prototype.hasOwnProperty.call(L,k)},I.p="",I(I.s=0)}([function(V,e,I){(function(L){var k;e=V.exports=$,k=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var o=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],h=e.src=[],m=0,S=m++;h[S]="0|[1-9]\\d*";var v=m++;h[v]="[0-9]+";var b=m++;h[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=m++;h[f]="("+h[S]+")\\.("+h[S]+")\\.("+h[S]+")";var p=m++;h[p]="("+h[v]+")\\.("+h[v]+")\\.("+h[v]+")";var w=m++;h[w]="(?:"+h[S]+"|"+h[b]+")";var c=m++;h[c]="(?:"+h[v]+"|"+h[b]+")";var u=m++;h[u]="(?:-("+h[w]+"(?:\\."+h[w]+")*))";var g=m++;h[g]="(?:-?("+h[c]+"(?:\\."+h[c]+")*))";var D=m++;h[D]="[0-9A-Za-z-]+";var E=m++;h[E]="(?:\\+("+h[D]+"(?:\\."+h[D]+")*))";var R=m++,t="v?"+h[f]+h[u]+"?"+h[E]+"?";h[R]="^"+t+"$";var a="[v=\\s]*"+h[p]+h[g]+"?"+h[E]+"?",i=m++;h[i]="^"+a+"$";var n=m++;h[n]="((?:<|>)?=?)";var r=m++;h[r]=h[v]+"|x|X|\\*";var l=m++;h[l]=h[S]+"|x|X|\\*";var s=m++;h[s]="[v=\\s]*("+h[l]+")(?:\\.("+h[l]+")(?:\\.("+h[l]+")(?:"+h[u]+")?"+h[E]+"?)?)?";var d=m++;h[d]="[v=\\s]*("+h[r]+")(?:\\.("+h[r]+")(?:\\.("+h[r]+")(?:"+h[g]+")?"+h[E]+"?)?)?";var y=m++;h[y]="^"+h[n]+"\\s*"+h[s]+"$";var M=m++;h[M]="^"+h[n]+"\\s*"+h[d]+"$";var O=m++;h[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=m++;h[j]="(?:~>?)";var K=m++;h[K]="(\\s*)"+h[j]+"\\s+",P[K]=new RegExp(h[K],"g");var x=m++;h[x]="^"+h[j]+h[s]+"$";var J=m++;h[J]="^"+h[j]+h[d]+"$";var re=m++;h[re]="(?:\\^)";var se=m++;h[se]="(\\s*)"+h[re]+"\\s+",P[se]=new RegExp(h[se],"g");var ae=m++;h[ae]="^"+h[re]+h[s]+"$";var fe=m++;h[fe]="^"+h[re]+h[d]+"$";var ge=m++;h[ge]="^"+h[n]+"\\s*("+a+")$|^$";var H=m++;h[H]="^"+h[n]+"\\s*("+t+")$|^$";var F=m++;h[F]="(\\s*)"+h[n]+"\\s*("+a+"|"+h[s]+")",P[F]=new RegExp(h[F],"g");var U=m++;h[U]="^\\s*("+h[s]+")\\s+-\\s+("+h[s]+")\\s*$";var z=m++;h[z]="^\\s*("+h[d]+")\\s+-\\s+("+h[d]+")\\s*$";var Y=m++;h[Y]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)k(ne,h[ne]),P[ne]||(P[ne]=new RegExp(h[ne]));function _(Z,ce){if(Z instanceof $)return Z;if(typeof Z!="string"||Z.length>o||!(ce?P[i]:P[R]).test(Z))return null;try{return new $(Z,ce)}catch{return null}}function $(Z,ce){if(Z instanceof $){if(Z.loose===ce)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>o)throw new TypeError("version is longer than "+o+" characters");if(!(this instanceof $))return new $(Z,ce);k("SemVer",Z,ce),this.loose=ce;var de=Z.trim().match(ce?P[i]:P[R]);if(!de)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var Ce=+Ee;if(Ce>=0&&Ce<C)return Ce}return Ee}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=_,e.valid=function(Z,ce){var de=_(Z,ce);return de?de.version:null},e.clean=function(Z,ce){var de=_(Z.trim().replace(/^[=v]+/,""),ce);return de?de.version:null},e.SemVer=$,$.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},$.prototype.toString=function(){return this.version},$.prototype.compare=function(Z){return k("SemVer.compare",this.version,this.loose,Z),Z instanceof $||(Z=new $(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},$.prototype.compareMain=function(Z){return Z instanceof $||(Z=new $(Z,this.loose)),T(this.major,Z.major)||T(this.minor,Z.minor)||T(this.patch,Z.patch)},$.prototype.comparePre=function(Z){if(Z instanceof $||(Z=new $(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var ce=0;do{var de=this.prerelease[ce],Ee=Z.prerelease[ce];if(k("prerelease compare",ce,de,Ee),de===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(de===void 0)return-1;if(de!==Ee)return T(de,Ee)}while(++ce)},$.prototype.inc=function(Z,ce){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ce),this.inc("pre",ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ce),this.inc("pre",ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}ce&&(this.prerelease[0]===ce?isNaN(this.prerelease[1])&&(this.prerelease=[ce,0]):this.prerelease=[ce,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,ce,de,Ee){typeof de=="string"&&(Ee=de,de=void 0);try{return new $(Z,de).inc(ce,Ee).version}catch{return null}},e.diff=function(Z,ce){if(N(Z,ce))return null;var de=_(Z),Ee=_(ce);if(de.prerelease.length||Ee.prerelease.length){for(var Ce in de)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&de[Ce]!==Ee[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in de)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&de[Ce]!==Ee[Ce])return Ce},e.compareIdentifiers=T;var A=/^[0-9]+$/;function T(Z,ce){var de=A.test(Z),Ee=A.test(ce);return de&&Ee&&(Z=+Z,ce=+ce),de&&!Ee?-1:Ee&&!de?1:Z<ce?-1:Z>ce?1:0}function W(Z,ce,de){return new $(Z,de).compare(new $(ce,de))}function B(Z,ce,de){return W(Z,ce,de)>0}function G(Z,ce,de){return W(Z,ce,de)<0}function N(Z,ce,de){return W(Z,ce,de)===0}function q(Z,ce,de){return W(Z,ce,de)!==0}function Q(Z,ce,de){return W(Z,ce,de)>=0}function oe(Z,ce,de){return W(Z,ce,de)<=0}function ue(Z,ce,de,Ee){var Ce;switch(ce){case"===":typeof Z=="object"&&(Z=Z.version),typeof de=="object"&&(de=de.version),Ce=Z===de;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof de=="object"&&(de=de.version),Ce=Z!==de;break;case"":case"=":case"==":Ce=N(Z,de,Ee);break;case"!=":Ce=q(Z,de,Ee);break;case">":Ce=B(Z,de,Ee);break;case">=":Ce=Q(Z,de,Ee);break;case"<":Ce=G(Z,de,Ee);break;case"<=":Ce=oe(Z,de,Ee);break;default:throw new TypeError("Invalid operator: "+ce)}return Ce}function ye(Z,ce){if(Z instanceof ye){if(Z.loose===ce)return Z;Z=Z.value}if(!(this instanceof ye))return new ye(Z,ce);k("comparator",Z,ce),this.loose=ce,this.parse(Z),this.semver===ke?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(Z,ce){return T(ce,Z)},e.major=function(Z,ce){return new $(Z,ce).major},e.minor=function(Z,ce){return new $(Z,ce).minor},e.patch=function(Z,ce){return new $(Z,ce).patch},e.compare=W,e.compareLoose=function(Z,ce){return W(Z,ce,!0)},e.rcompare=function(Z,ce,de){return W(ce,Z,de)},e.sort=function(Z,ce){return Z.sort(function(de,Ee){return e.compare(de,Ee,ce)})},e.rsort=function(Z,ce){return Z.sort(function(de,Ee){return e.rcompare(de,Ee,ce)})},e.gt=B,e.lt=G,e.eq=N,e.neq=q,e.gte=Q,e.lte=oe,e.cmp=ue,e.Comparator=ye;var ke={};function Ae(Z,ce){if(Z instanceof Ae)return Z.loose===ce?Z:new Ae(Z.raw,ce);if(Z instanceof ye)return new Ae(Z.value,ce);if(!(this instanceof Ae))return new Ae(Z,ce);if(this.loose=ce,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function Re(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function Fe(Z,ce,de,Ee,Ce,Le,Te,He,je,ze,xe,Ne,Ve){return((ce=Re(de)?"":Re(Ee)?">="+de+".0.0":Re(Ce)?">="+de+"."+Ee+".0":">="+ce)+" "+(He=Re(je)?"":Re(ze)?"<"+(+je+1)+".0.0":Re(xe)?"<"+je+"."+(+ze+1)+".0":Ne?"<="+je+"."+ze+"."+xe+"-"+Ne:"<="+He)).trim()}function we(Z,ce){for(var de=0;de<Z.length;de++)if(!Z[de].test(ce))return!1;if(ce.prerelease.length){for(de=0;de<Z.length;de++)if(k(Z[de].semver),Z[de].semver!==ke&&Z[de].semver.prerelease.length>0){var Ee=Z[de].semver;if(Ee.major===ce.major&&Ee.minor===ce.minor&&Ee.patch===ce.patch)return!0}return!1}return!0}function pe(Z,ce,de){try{ce=new Ae(ce,de)}catch{return!1}return ce.test(Z)}function Se(Z,ce,de,Ee){var Ce,Le,Te,He,je;switch(Z=new $(Z,Ee),ce=new Ae(ce,Ee),de){case">":Ce=B,Le=oe,Te=G,He=">",je=">=";break;case"<":Ce=G,Le=Q,Te=B,He="<",je="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(Z,ce,Ee))return!1;for(var ze=0;ze<ce.set.length;++ze){var xe=ce.set[ze],Ne=null,Ve=null;if(xe.forEach(function(X){X.semver===ke&&(X=new ye(">=0.0.0")),Ne=Ne||X,Ve=Ve||X,Ce(X.semver,Ne.semver,Ee)?Ne=X:Te(X.semver,Ve.semver,Ee)&&(Ve=X)}),Ne.operator===He||Ne.operator===je||(!Ve.operator||Ve.operator===He)&&Le(Z,Ve.semver)||Ve.operator===je&&Te(Z,Ve.semver))return!1}return!0}ye.prototype.parse=function(Z){var ce=this.loose?P[ge]:P[H],de=Z.match(ce);if(!de)throw new TypeError("Invalid comparator: "+Z);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new $(de[2],this.loose):this.semver=ke},ye.prototype.toString=function(){return this.value},ye.prototype.test=function(Z){return k("Comparator.test",Z,this.loose),this.semver===ke||(typeof Z=="string"&&(Z=new $(Z,this.loose)),ue(Z,this.operator,this.semver,this.loose))},ye.prototype.intersects=function(Z,ce){if(!(Z instanceof ye))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new Ae(Z.value,ce),pe(this.value,de,ce);if(Z.operator==="")return de=new Ae(this.value,ce),pe(Z.semver,de,ce);var Ee=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),Le=this.semver.version===Z.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),He=ue(this.semver,"<",Z.semver,ce)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),je=ue(this.semver,">",Z.semver,ce)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return Ee||Ce||Le&&Te||He||je},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(Z){var ce=this.loose;Z=Z.trim(),k("range",Z,ce);var de=ce?P[z]:P[U];Z=Z.replace(de,Fe),k("hyphen replace",Z),Z=Z.replace(P[F],"$1$2$3"),k("comparator trim",Z,P[F]),Z=(Z=(Z=Z.replace(P[K],"$1~")).replace(P[se],"$1^")).split(/\s+/).join(" ");var Ee=ce?P[ge]:P[H],Ce=Z.split(" ").map(function(Le){return function(Te,He){return k("comp",Te),Te=function(je,ze){return je.trim().split(/\s+/).map(function(xe){return function(Ne,Ve){k("caret",Ne,Ve);var X=Ve?P[fe]:P[ae];return Ne.replace(X,function(le,he,me,be,Oe){var qe;return k("caret",Ne,le,he,me,be,Oe),Re(he)?qe="":Re(me)?qe=">="+he+".0.0 <"+(+he+1)+".0.0":Re(be)?qe=he==="0"?">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":">="+he+"."+me+".0 <"+(+he+1)+".0.0":Oe?(k("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),qe=he==="0"?me==="0"?">="+he+"."+me+"."+be+Oe+" <"+he+"."+me+"."+(+be+1):">="+he+"."+me+"."+be+Oe+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+be+Oe+" <"+(+he+1)+".0.0"):(k("no pr"),qe=he==="0"?me==="0"?">="+he+"."+me+"."+be+" <"+he+"."+me+"."+(+be+1):">="+he+"."+me+"."+be+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+be+" <"+(+he+1)+".0.0"),k("caret return",qe),qe})}(xe,ze)}).join(" ")}(Te,He),k("caret",Te),Te=function(je,ze){return je.trim().split(/\s+/).map(function(xe){return function(Ne,Ve){var X=Ve?P[J]:P[x];return Ne.replace(X,function(le,he,me,be,Oe){var qe;return k("tilde",Ne,le,he,me,be,Oe),Re(he)?qe="":Re(me)?qe=">="+he+".0.0 <"+(+he+1)+".0.0":Re(be)?qe=">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":Oe?(k("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),qe=">="+he+"."+me+"."+be+Oe+" <"+he+"."+(+me+1)+".0"):qe=">="+he+"."+me+"."+be+" <"+he+"."+(+me+1)+".0",k("tilde return",qe),qe})}(xe,ze)}).join(" ")}(Te,He),k("tildes",Te),Te=function(je,ze){return k("replaceXRanges",je,ze),je.split(/\s+/).map(function(xe){return function(Ne,Ve){Ne=Ne.trim();var X=Ve?P[M]:P[y];return Ne.replace(X,function(le,he,me,be,Oe,qe){k("xRange",Ne,le,he,me,be,Oe,qe);var tt=Re(me),Ze=tt||Re(be),Ge=Ze||Re(Oe);return he==="="&&Ge&&(he=""),tt?le=he===">"||he==="<"?"<0.0.0":"*":he&&Ge?(Ze&&(be=0),Ge&&(Oe=0),he===">"?(he=">=",Ze?(me=+me+1,be=0,Oe=0):Ge&&(be=+be+1,Oe=0)):he==="<="&&(he="<",Ze?me=+me+1:be=+be+1),le=he+me+"."+be+"."+Oe):Ze?le=">="+me+".0.0 <"+(+me+1)+".0.0":Ge&&(le=">="+me+"."+be+".0 <"+me+"."+(+be+1)+".0"),k("xRange return",le),le})}(xe,ze)}).join(" ")}(Te,He),k("xrange",Te),Te=function(je,ze){return k("replaceStars",je,ze),je.trim().replace(P[Y],"")}(Te,He),k("stars",Te),Te}(Le,ce)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Le){return!!Le.match(Ee)})),Ce=Ce.map(function(Le){return new ye(Le,ce)})},Ae.prototype.intersects=function(Z,ce){if(!(Z instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(Ee){return Z.set.some(function(Ce){return Ce.every(function(Le){return Ee.intersects(Le,ce)})})})})},e.toComparators=function(Z,ce){return new Ae(Z,ce).set.map(function(de){return de.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new $(Z,this.loose));for(var ce=0;ce<this.set.length;ce++)if(we(this.set[ce],Z))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(Z,ce,de){var Ee=null,Ce=null;try{var Le=new Ae(ce,de)}catch{return null}return Z.forEach(function(Te){Le.test(Te)&&(Ee&&Ce.compare(Te)!==-1||(Ce=new $(Ee=Te,de)))}),Ee},e.minSatisfying=function(Z,ce,de){var Ee=null,Ce=null;try{var Le=new Ae(ce,de)}catch{return null}return Z.forEach(function(Te){Le.test(Te)&&(Ee&&Ce.compare(Te)!==1||(Ce=new $(Ee=Te,de)))}),Ee},e.validRange=function(Z,ce){try{return new Ae(Z,ce).range||"*"}catch{return null}},e.ltr=function(Z,ce,de){return Se(Z,ce,"<",de)},e.gtr=function(Z,ce,de){return Se(Z,ce,">",de)},e.outside=Se,e.prerelease=function(Z,ce){var de=_(Z,ce);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(Z,ce,de){return Z=new Ae(Z,de),ce=new Ae(ce,de),Z.intersects(ce)},e.coerce=function(Z){if(Z instanceof $)return Z;if(typeof Z!="string")return null;var ce=Z.match(P[O]);return ce==null?null:_((ce[1]||"0")+"."+(ce[2]||"0")+"."+(ce[3]||"0"))}}).call(this,I(1))},function(V,e){var I,L,k=V.exports={};function o(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function P(c){if(I===setTimeout)return setTimeout(c,0);if((I===o||!I)&&setTimeout)return I=setTimeout,setTimeout(c,0);try{return I(c,0)}catch{try{return I.call(null,c,0)}catch{return I.call(this,c,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:o}catch{I=o}try{L=typeof clearTimeout=="function"?clearTimeout:C}catch{L=C}})();var h,m=[],S=!1,v=-1;function b(){S&&h&&(S=!1,h.length?m=h.concat(m):v=-1,m.length&&f())}function f(){if(!S){var c=P(b);S=!0;for(var u=m.length;u;){for(h=m,m=[];++v<u;)h&&h[v].run();v=-1,u=m.length}h=null,S=!1,function(g){if(L===clearTimeout)return clearTimeout(g);if((L===C||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(g);try{L(g)}catch{try{return L.call(null,g)}catch{return L.call(this,g)}}}(c)}}function p(c,u){this.fun=c,this.array=u}function w(){}k.nextTick=function(c){var u=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)u[g-1]=arguments[g];m.push(new p(c,u)),m.length!==1||S||P(f)},p.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=w,k.addListener=w,k.once=w,k.off=w,k.removeListener=w,k.removeAllListeners=w,k.emit=w,k.prependListener=w,k.prependOnceListener=w,k.listeners=function(c){return[]},k.binding=function(c){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(c){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(te[128],ie([0,1]),function(V,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(P,h,m){this.level=P,this.key=h,this.value=m,this.forward=[]}}const k=void 0;class o{constructor(P,h=2**16){this.comparator=P,this[I]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new L(this.c,k,k)}get size(){return this.f}clear(){this.e=new L(this.c,k,k)}has(P){return Boolean(o.g(this,P,this.comparator))}get(P){return o.g(this,P,this.comparator)?.value}set(P,h){return o.h(this,P,h,this.comparator)&&(this.f+=1),this}delete(P){const h=o.k(this,P,this.comparator);return h&&(this.f-=1),h}forEach(P,h){let m=this.e.forward[0];for(;m;)P.call(h,m.value,m.key,this),m=m.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",h=this.e.forward[0];for(;h;)P+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return P}static g(P,h,m){let S=P.e;for(let v=P.d-1;v>=0;v--)for(;S.forward[v]&&m(S.forward[v].key,h)<0;)S=S.forward[v];if(S=S.forward[0],S&&m(S.key,h)===0)return S}static h(P,h,m,S){const v=[];let b=P.e;for(let f=P.d-1;f>=0;f--){for(;b.forward[f]&&S(b.forward[f].key,h)<0;)b=b.forward[f];v[f]=b}if(b=b.forward[0],b&&S(b.key,h)===0)return b.value=m,!1;{const f=o.j(P);if(f>P.d){for(let p=P.d;p<f;p++)v[p]=P.e;P.d=f}b=new L(f,h,m);for(let p=0;p<f;p++)b.forward[p]=v[p].forward[p],v[p].forward[p]=b;return!0}}static j(P,h=.5){let m=1;for(;Math.random()<h&&m<P.c;)m+=1;return m}static k(P,h,m){const S=[];let v=P.e;for(let b=P.d-1;b>=0;b--){for(;v.forward[b]&&m(v.forward[b].key,h)<0;)v=v.forward[b];S[b]=v}if(v=v.forward[0],!v||m(v.key,h)!==0)return!1;for(let b=0;b<P.d&&S[b].forward[b]===v;b++)S[b].forward[b]=v.forward[b];for(;P.d>0&&P.e.forward[P.d-1]===k;)P.d-=1;return!0}}e.SkipList=o}),define(te[59],ie([0,1,13,2]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(E){const R=E;return R?typeof R.read=="function":!1}e.isReadable=k;function o(E){const R=E;return R?[R.on,R.pause,R.resume,R.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=o;function C(E){const R=E;return R?o(R.stream)&&Array.isArray(R.buffer)&&typeof R.ended=="boolean":!1}e.isReadableBufferedStream=C;function P(E,R){return new h(E,R)}e.newWriteableStream=P;class h{constructor(R,t){this.e=R,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(R){if(!this.a.destroyed){if(this.a.flowing)this.g(R);else if(this.b.data.push(R),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(R){this.a.destroyed||(this.a.flowing?this.h(R):this.b.error.push(R))}end(R){this.a.destroyed||(typeof R<"u"&&this.write(R),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(R){this.c.data.slice(0).forEach(t=>t(R))}h(R){this.c.error.length===0?(0,I.onUnexpectedError)(R):this.c.error.slice(0).forEach(t=>t(R))}i(){this.c.end.slice(0).forEach(R=>R())}on(R,t){if(!this.a.destroyed)switch(R){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(R,t){if(this.a.destroyed)return;let a;switch(R){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const i=a.indexOf(t);i>=0&&a.splice(i,1)}}j(){if(this.b.data.length>0){const R=this.e(this.b.data);this.g(R),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const R of this.b.error)this.h(R);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function m(E,R){const t=[];let a;for(;(a=E.read())!==null;)t.push(a);return R(t)}e.consumeReadable=m;function S(E,R,t){const a=[];let i;for(;(i=E.read())!==null&&a.length<t;)a.push(i);return i===null&&a.length>0?R(a):{read:()=>{if(a.length>0)return a.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return E.read()}}}e.peekReadable=S;function v(E,R){return new Promise((t,a)=>{const i=[];b(E,{onData:n=>{R&&i.push(n)},onError:n=>{R?a(n):t(void 0)},onEnd:()=>{t(R?R(i):void 0)}})})}e.consumeStream=v;function b(E,R){let t=!1;return E.on("error",a=>{t||R.onError(a)}),E.on("end",()=>{t||R.onEnd()}),E.on("data",a=>{t||R.onData(a)}),(0,L.toDisposable)(()=>t=!0)}e.listenStream=b;function f(E,R){return new Promise((t,a)=>{const i=new L.DisposableStore,n=[],r=d=>{if(n.push(d),n.length>R)return i.dispose(),E.pause(),t({stream:E,buffer:n,ended:!1})},l=d=>a(d),s=()=>t({stream:E,buffer:n,ended:!0});i.add((0,L.toDisposable)(()=>E.removeListener("error",l))),E.on("error",l),i.add((0,L.toDisposable)(()=>E.removeListener("end",s))),E.on("end",s),i.add((0,L.toDisposable)(()=>E.removeListener("data",r))),E.on("data",r)})}e.peekStream=f;function p(E,R){const t=P(R);return t.end(E),t}e.toStream=p;function w(){const E=P(()=>{throw new Error("not supported")});return E.end(),E}e.emptyStream=w;function c(E){let R=!1;return{read:()=>R?null:(R=!0,E)}}e.toReadable=c;function u(E,R,t){const a=P(t);return b(E,{onData:i=>a.write(R.data(i)),onError:i=>a.error(R.error?R.error(i):i),onEnd:()=>a.end()}),a}e.transform=u;function g(E,R,t){let a=!1;return{read:()=>{const i=R.read();return a?i:(a=!0,i!==null?t([E,i]):E)}}}e.prefixedReadable=g;function D(E,R,t){let a=!1;const i=P(t);return b(R,{onData:n=>a?i.write(n):(a=!0,i.write(t([E,n]))),onError:n=>i.error(n),onEnd:()=>{a||(a=!0,i.write(E)),i.end()}}),i}e.prefixedStream=D}),define(te[17],ie([0,1,59]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer<"u";let k,o;class C{static alloc(d){return L?new C(Buffer.allocUnsafe(d)):new C(new Uint8Array(d))}static wrap(d){return L&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new C(d)}static fromString(d,y){return!(y?.dontUseNodeBuffer||!1)&&L?new C(Buffer.from(d)):(k||(k=new TextEncoder),new C(k.encode(d)))}static fromByteArray(d){const y=C.alloc(d.length);for(let M=0,O=d.length;M<O;M++)y.buffer[M]=d[M];return y}static concat(d,y){if(typeof y>"u"){y=0;for(let j=0,K=d.length;j<K;j++)y+=d[j].byteLength}const M=C.alloc(y);let O=0;for(let j=0,K=d.length;j<K;j++){const x=d[j];M.set(x,O),O+=x.byteLength}return M}constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}clone(){const d=C.alloc(this.byteLength);return d.set(this),d}toString(){return L?this.buffer.toString():(o||(o=new TextDecoder),o.decode(this.buffer))}slice(d,y){return new C(this.buffer.subarray(d,y))}set(d,y){if(d instanceof C)this.buffer.set(d.buffer,y);else if(d instanceof Uint8Array)this.buffer.set(d,y);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),y);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),y);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return m(this.buffer,d)}writeUInt32BE(d,y){S(this.buffer,d,y)}readUInt32LE(d){return v(this.buffer,d)}writeUInt32LE(d,y){b(this.buffer,d,y)}readUInt8(d){return f(this.buffer,d)}writeUInt8(d,y){p(this.buffer,d,y)}}e.VSBuffer=C;function P(s,d){return s[d+0]<<0>>>0|s[d+1]<<8>>>0}e.readUInt16LE=P;function h(s,d,y){s[y+0]=d&255,d=d>>>8,s[y+1]=d&255}e.writeUInt16LE=h;function m(s,d){return s[d]*2**24+s[d+1]*2**16+s[d+2]*2**8+s[d+3]}e.readUInt32BE=m;function S(s,d,y){s[y+3]=d,d=d>>>8,s[y+2]=d,d=d>>>8,s[y+1]=d,d=d>>>8,s[y]=d}e.writeUInt32BE=S;function v(s,d){return s[d+0]<<0>>>0|s[d+1]<<8>>>0|s[d+2]<<16>>>0|s[d+3]<<24>>>0}e.readUInt32LE=v;function b(s,d,y){s[y+0]=d&255,d=d>>>8,s[y+1]=d&255,d=d>>>8,s[y+2]=d&255,d=d>>>8,s[y+3]=d&255}e.writeUInt32LE=b;function f(s,d){return s[d]}e.readUInt8=f;function p(s,d,y){s[y]=d}e.writeUInt8=p;function w(s){return I.consumeReadable(s,d=>C.concat(d))}e.readableToBuffer=w;function c(s){return I.toReadable(s)}e.bufferToReadable=c;function u(s){return I.consumeStream(s,d=>C.concat(d))}e.streamToBuffer=u;async function g(s){return s.ended?C.concat(s.buffer):C.concat([...s.buffer,await u(s.stream)])}e.bufferedStreamToBuffer=g;function D(s){return I.toStream(s,d=>C.concat(d))}e.bufferToStream=D;function E(s){return I.transform(s,{data:d=>typeof d=="string"?C.fromString(d):C.wrap(d)},d=>C.concat(d))}e.streamToBufferReadableStream=E;function R(s){return I.newWriteableStream(d=>C.concat(d),s)}e.newWriteableBufferStream=R;function t(s,d){return I.prefixedReadable(s,d,y=>C.concat(y))}e.prefixedBufferReadable=t;function a(s,d){return I.prefixedStream(s,d,y=>C.concat(y))}e.prefixedBufferStream=a;function i(s){let d=0,y=0,M=0;const O=new Uint8Array(Math.floor(s.length/4*3)),j=x=>{switch(y){case 3:O[M++]=d|x,y=0;break;case 2:O[M++]=d|x>>>2,d=x<<6,y=3;break;case 1:O[M++]=d|x>>>4,d=x<<4,y=2;break;default:d=x<<2,y=1}};for(let x=0;x<s.length;x++){const J=s.charCodeAt(x);if(J>=65&&J<=90)j(J-65);else if(J>=97&&J<=122)j(J-97+26);else if(J>=48&&J<=57)j(J-48+52);else if(J===43||J===45)j(62);else if(J===47||J===95)j(63);else{if(J===61)break;throw new SyntaxError(`Unexpected base64 character ${s[x]}`)}}const K=M;for(;y>0;)j(0);return C.wrap(O).slice(0,K)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:s},d=!0,y=!1){const M=y?r:n;let O="";const j=s.byteLength%3;let K=0;for(;K<s.byteLength-j;K+=3){const x=s[K+0],J=s[K+1],re=s[K+2];O+=M[x>>>2],O+=M[(x<<4|J>>>4)&63],O+=M[(J<<2|re>>>6)&63],O+=M[re&63]}if(j===1){const x=s[K+0];O+=M[x>>>2],O+=M[x<<4&63],d&&(O+="==")}else if(j===2){const x=s[K+0],J=s[K+1];O+=M[x>>>2],O+=M[(x<<4|J>>>4)&63],O+=M[J<<2&63],d&&(O+="=")}return O}e.encodeBase64=l}),define(te[10],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function I(a){return typeof a=="string"}e.isString=I;function L(a){return Array.isArray(a)&&a.every(i=>I(i))}e.isStringArray=L;function k(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=k;function o(a){const i=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof i}e.isTypedArray=o;function C(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=C;function P(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=P;function h(a){return a===!0||a===!1}e.isBoolean=h;function m(a){return typeof a>"u"}e.isUndefined=m;function S(a){return!v(a)}e.isDefined=S;function v(a){return m(a)||a===null}e.isUndefinedOrNull=v;function b(a,i){if(!a)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=b;function f(a){if(v(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=f;function p(...a){const i=[];for(let n=0;n<a.length;n++){const r=a[n];if(v(r))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);i.push(r)}return i}e.assertAllDefined=p;const w=Object.prototype.hasOwnProperty;function c(a){if(!k(a))return!1;for(const i in a)if(w.call(a,i))return!1;return!0}e.isEmptyObject=c;function u(a){return typeof a=="function"}e.isFunction=u;function g(...a){return a.length>0&&a.every(u)}e.areFunctions=g;function D(a,i){const n=Math.min(a.length,i.length);for(let r=0;r<n;r++)E(a[r],i[r])}e.validateConstraints=D;function E(a,i){if(I(i)){if(typeof a!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(u(i)){try{if(a instanceof i)return}catch{}if(!v(a)&&a.constructor===i||i.length===1&&i.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=E;function R(a){return a===null?void 0:a}e.withNullAsUndefined=R;function t(a){return typeof a>"u"?null:a}e.withUndefinedAsNull=t}),define(te[129],ie([0,1,10]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=e.getCodiconAriaLabel=void 0;function L(h){return h?h.replace(/\$\((.*?)\)/g,(m,S)=>` ${S} `).trim():""}e.getCodiconAriaLabel=L;const k=Object.create(null);function o(h,m){if((0,I.isString)(m)){const S=k[m];if(S===void 0)throw new Error(`${h} references an unknown codicon: ${m}`);m=S}return k[h]=m,{id:h}}function C(){return k}e.getCodiconFontCharacters=C;function P(){return Object.values(e.Codicon)}e.getAllCodicons=P,e.Codicon={add:o("add",6e4),plus:o("plus",6e4),gistNew:o("gist-new",6e4),repoCreate:o("repo-create",6e4),lightbulb:o("lightbulb",60001),lightBulb:o("light-bulb",60001),repo:o("repo",60002),repoDelete:o("repo-delete",60002),gistFork:o("gist-fork",60003),repoForked:o("repo-forked",60003),gitPullRequest:o("git-pull-request",60004),gitPullRequestAbandoned:o("git-pull-request-abandoned",60004),recordKeys:o("record-keys",60005),keyboard:o("keyboard",60005),tag:o("tag",60006),tagAdd:o("tag-add",60006),tagRemove:o("tag-remove",60006),person:o("person",60007),personFollow:o("person-follow",60007),personOutline:o("person-outline",60007),personFilled:o("person-filled",60007),gitBranch:o("git-branch",60008),gitBranchCreate:o("git-branch-create",60008),gitBranchDelete:o("git-branch-delete",60008),sourceControl:o("source-control",60008),mirror:o("mirror",60009),mirrorPublic:o("mirror-public",60009),star:o("star",60010),starAdd:o("star-add",60010),starDelete:o("star-delete",60010),starEmpty:o("star-empty",60010),comment:o("comment",60011),commentAdd:o("comment-add",60011),alert:o("alert",60012),warning:o("warning",60012),search:o("search",60013),searchSave:o("search-save",60013),logOut:o("log-out",60014),signOut:o("sign-out",60014),logIn:o("log-in",60015),signIn:o("sign-in",60015),eye:o("eye",60016),eyeUnwatch:o("eye-unwatch",60016),eyeWatch:o("eye-watch",60016),circleFilled:o("circle-filled",60017),primitiveDot:o("primitive-dot",60017),closeDirty:o("close-dirty",60017),debugBreakpoint:o("debug-breakpoint",60017),debugBreakpointDisabled:o("debug-breakpoint-disabled",60017),debugHint:o("debug-hint",60017),primitiveSquare:o("primitive-square",60018),edit:o("edit",60019),pencil:o("pencil",60019),info:o("info",60020),issueOpened:o("issue-opened",60020),gistPrivate:o("gist-private",60021),gitForkPrivate:o("git-fork-private",60021),lock:o("lock",60021),mirrorPrivate:o("mirror-private",60021),close:o("close",60022),removeClose:o("remove-close",60022),x:o("x",60022),repoSync:o("repo-sync",60023),sync:o("sync",60023),clone:o("clone",60024),desktopDownload:o("desktop-download",60024),beaker:o("beaker",60025),microscope:o("microscope",60025),vm:o("vm",60026),deviceDesktop:o("device-desktop",60026),file:o("file",60027),fileText:o("file-text",60027),more:o("more",60028),ellipsis:o("ellipsis",60028),kebabHorizontal:o("kebab-horizontal",60028),mailReply:o("mail-reply",60029),reply:o("reply",60029),organization:o("organization",60030),organizationFilled:o("organization-filled",60030),organizationOutline:o("organization-outline",60030),newFile:o("new-file",60031),fileAdd:o("file-add",60031),newFolder:o("new-folder",60032),fileDirectoryCreate:o("file-directory-create",60032),trash:o("trash",60033),trashcan:o("trashcan",60033),history:o("history",60034),clock:o("clock",60034),folder:o("folder",60035),fileDirectory:o("file-directory",60035),symbolFolder:o("symbol-folder",60035),logoGithub:o("logo-github",60036),markGithub:o("mark-github",60036),github:o("github",60036),terminal:o("terminal",60037),console:o("console",60037),repl:o("repl",60037),zap:o("zap",60038),symbolEvent:o("symbol-event",60038),error:o("error",60039),stop:o("stop",60039),variable:o("variable",60040),symbolVariable:o("symbol-variable",60040),array:o("array",60042),symbolArray:o("symbol-array",60042),symbolModule:o("symbol-module",60043),symbolPackage:o("symbol-package",60043),symbolNamespace:o("symbol-namespace",60043),symbolObject:o("symbol-object",60043),symbolMethod:o("symbol-method",60044),symbolFunction:o("symbol-function",60044),symbolConstructor:o("symbol-constructor",60044),symbolBoolean:o("symbol-boolean",60047),symbolNull:o("symbol-null",60047),symbolNumeric:o("symbol-numeric",60048),symbolNumber:o("symbol-number",60048),symbolStructure:o("symbol-structure",60049),symbolStruct:o("symbol-struct",60049),symbolParameter:o("symbol-parameter",60050),symbolTypeParameter:o("symbol-type-parameter",60050),symbolKey:o("symbol-key",60051),symbolText:o("symbol-text",60051),symbolReference:o("symbol-reference",60052),goToFile:o("go-to-file",60052),symbolEnum:o("symbol-enum",60053),symbolValue:o("symbol-value",60053),symbolRuler:o("symbol-ruler",60054),symbolUnit:o("symbol-unit",60054),activateBreakpoints:o("activate-breakpoints",60055),archive:o("archive",60056),arrowBoth:o("arrow-both",60057),arrowDown:o("arrow-down",60058),arrowLeft:o("arrow-left",60059),arrowRight:o("arrow-right",60060),arrowSmallDown:o("arrow-small-down",60061),arrowSmallLeft:o("arrow-small-left",60062),arrowSmallRight:o("arrow-small-right",60063),arrowSmallUp:o("arrow-small-up",60064),arrowUp:o("arrow-up",60065),bell:o("bell",60066),bold:o("bold",60067),book:o("book",60068),bookmark:o("bookmark",60069),debugBreakpointConditionalUnverified:o("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:o("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:o("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:o("debug-breakpoint-data-unverified",60072),debugBreakpointData:o("debug-breakpoint-data",60073),debugBreakpointDataDisabled:o("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:o("debug-breakpoint-log-unverified",60074),debugBreakpointLog:o("debug-breakpoint-log",60075),debugBreakpointLogDisabled:o("debug-breakpoint-log-disabled",60075),briefcase:o("briefcase",60076),broadcast:o("broadcast",60077),browser:o("browser",60078),bug:o("bug",60079),calendar:o("calendar",60080),caseSensitive:o("case-sensitive",60081),check:o("check",60082),checklist:o("checklist",60083),chevronDown:o("chevron-down",60084),dropDownButton:o("drop-down-button",60084),chevronLeft:o("chevron-left",60085),chevronRight:o("chevron-right",60086),chevronUp:o("chevron-up",60087),chromeClose:o("chrome-close",60088),chromeMaximize:o("chrome-maximize",60089),chromeMinimize:o("chrome-minimize",60090),chromeRestore:o("chrome-restore",60091),circle:o("circle",60092),circleOutline:o("circle-outline",60092),debugBreakpointUnverified:o("debug-breakpoint-unverified",60092),circleSlash:o("circle-slash",60093),circuitBoard:o("circuit-board",60094),clearAll:o("clear-all",60095),clippy:o("clippy",60096),closeAll:o("close-all",60097),cloudDownload:o("cloud-download",60098),cloudUpload:o("cloud-upload",60099),code:o("code",60100),collapseAll:o("collapse-all",60101),colorMode:o("color-mode",60102),commentDiscussion:o("comment-discussion",60103),compareChanges:o("compare-changes",60157),creditCard:o("credit-card",60105),dash:o("dash",60108),dashboard:o("dashboard",60109),database:o("database",60110),debugContinue:o("debug-continue",60111),debugDisconnect:o("debug-disconnect",60112),debugPause:o("debug-pause",60113),debugRestart:o("debug-restart",60114),debugStart:o("debug-start",60115),debugStepInto:o("debug-step-into",60116),debugStepOut:o("debug-step-out",60117),debugStepOver:o("debug-step-over",60118),debugStop:o("debug-stop",60119),debug:o("debug",60120),deviceCameraVideo:o("device-camera-video",60121),deviceCamera:o("device-camera",60122),deviceMobile:o("device-mobile",60123),diffAdded:o("diff-added",60124),diffIgnored:o("diff-ignored",60125),diffModified:o("diff-modified",60126),diffRemoved:o("diff-removed",60127),diffRenamed:o("diff-renamed",60128),diff:o("diff",60129),discard:o("discard",60130),editorLayout:o("editor-layout",60131),emptyWindow:o("empty-window",60132),exclude:o("exclude",60133),extensions:o("extensions",60134),eyeClosed:o("eye-closed",60135),fileBinary:o("file-binary",60136),fileCode:o("file-code",60137),fileMedia:o("file-media",60138),filePdf:o("file-pdf",60139),fileSubmodule:o("file-submodule",60140),fileSymlinkDirectory:o("file-symlink-directory",60141),fileSymlinkFile:o("file-symlink-file",60142),fileZip:o("file-zip",60143),files:o("files",60144),filter:o("filter",60145),flame:o("flame",60146),foldDown:o("fold-down",60147),foldUp:o("fold-up",60148),fold:o("fold",60149),folderActive:o("folder-active",60150),folderOpened:o("folder-opened",60151),gear:o("gear",60152),gift:o("gift",60153),gistSecret:o("gist-secret",60154),gist:o("gist",60155),gitCommit:o("git-commit",60156),gitCompare:o("git-compare",60157),gitMerge:o("git-merge",60158),githubAction:o("github-action",60159),githubAlt:o("github-alt",60160),globe:o("globe",60161),grabber:o("grabber",60162),graph:o("graph",60163),gripper:o("gripper",60164),heart:o("heart",60165),home:o("home",60166),horizontalRule:o("horizontal-rule",60167),hubot:o("hubot",60168),inbox:o("inbox",60169),issueClosed:o("issue-closed",60324),issueReopened:o("issue-reopened",60171),issues:o("issues",60172),italic:o("italic",60173),jersey:o("jersey",60174),json:o("json",60175),kebabVertical:o("kebab-vertical",60176),key:o("key",60177),law:o("law",60178),lightbulbAutofix:o("lightbulb-autofix",60179),linkExternal:o("link-external",60180),link:o("link",60181),listOrdered:o("list-ordered",60182),listUnordered:o("list-unordered",60183),liveShare:o("live-share",60184),loading:o("loading",60185),location:o("location",60186),mailRead:o("mail-read",60187),mail:o("mail",60188),markdown:o("markdown",60189),megaphone:o("megaphone",60190),mention:o("mention",60191),milestone:o("milestone",60192),mortarBoard:o("mortar-board",60193),move:o("move",60194),multipleWindows:o("multiple-windows",60195),mute:o("mute",60196),noNewline:o("no-newline",60197),note:o("note",60198),octoface:o("octoface",60199),openPreview:o("open-preview",60200),package_:o("package",60201),paintcan:o("paintcan",60202),pin:o("pin",60203),play:o("play",60204),run:o("run",60204),plug:o("plug",60205),preserveCase:o("preserve-case",60206),preview:o("preview",60207),project:o("project",60208),pulse:o("pulse",60209),question:o("question",60210),quote:o("quote",60211),radioTower:o("radio-tower",60212),reactions:o("reactions",60213),references:o("references",60214),refresh:o("refresh",60215),regex:o("regex",60216),remoteExplorer:o("remote-explorer",60217),remote:o("remote",60218),remove:o("remove",60219),replaceAll:o("replace-all",60220),replace:o("replace",60221),repoClone:o("repo-clone",60222),repoForcePush:o("repo-force-push",60223),repoPull:o("repo-pull",60224),repoPush:o("repo-push",60225),report:o("report",60226),requestChanges:o("request-changes",60227),rocket:o("rocket",60228),rootFolderOpened:o("root-folder-opened",60229),rootFolder:o("root-folder",60230),rss:o("rss",60231),ruby:o("ruby",60232),saveAll:o("save-all",60233),saveAs:o("save-as",60234),save:o("save",60235),screenFull:o("screen-full",60236),screenNormal:o("screen-normal",60237),searchStop:o("search-stop",60238),server:o("server",60240),settingsGear:o("settings-gear",60241),settings:o("settings",60242),shield:o("shield",60243),smiley:o("smiley",60244),sortPrecedence:o("sort-precedence",60245),splitHorizontal:o("split-horizontal",60246),splitVertical:o("split-vertical",60247),squirrel:o("squirrel",60248),starFull:o("star-full",60249),starHalf:o("star-half",60250),symbolClass:o("symbol-class",60251),symbolColor:o("symbol-color",60252),symbolCustomColor:o("symbol-customcolor",60252),symbolConstant:o("symbol-constant",60253),symbolEnumMember:o("symbol-enum-member",60254),symbolField:o("symbol-field",60255),symbolFile:o("symbol-file",60256),symbolInterface:o("symbol-interface",60257),symbolKeyword:o("symbol-keyword",60258),symbolMisc:o("symbol-misc",60259),symbolOperator:o("symbol-operator",60260),symbolProperty:o("symbol-property",60261),wrench:o("wrench",60261),wrenchSubaction:o("wrench-subaction",60261),symbolSnippet:o("symbol-snippet",60262),tasklist:o("tasklist",60263),telescope:o("telescope",60264),textSize:o("text-size",60265),threeBars:o("three-bars",60266),thumbsdown:o("thumbsdown",60267),thumbsup:o("thumbsup",60268),tools:o("tools",60269),triangleDown:o("triangle-down",60270),triangleLeft:o("triangle-left",60271),triangleRight:o("triangle-right",60272),triangleUp:o("triangle-up",60273),twitter:o("twitter",60274),unfold:o("unfold",60275),unlock:o("unlock",60276),unmute:o("unmute",60277),unverified:o("unverified",60278),verified:o("verified",60279),versions:o("versions",60280),vmActive:o("vm-active",60281),vmOutline:o("vm-outline",60282),vmRunning:o("vm-running",60283),watch:o("watch",60284),whitespace:o("whitespace",60285),wholeWord:o("whole-word",60286),window:o("window",60287),wordWrap:o("word-wrap",60288),zoomIn:o("zoom-in",60289),zoomOut:o("zoom-out",60290),listFilter:o("list-filter",60291),listFlat:o("list-flat",60292),listSelection:o("list-selection",60293),selection:o("selection",60293),listTree:o("list-tree",60294),debugBreakpointFunctionUnverified:o("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:o("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:o("debug-breakpoint-function-disabled",60296),debugStackframeActive:o("debug-stackframe-active",60297),circleSmallFilled:o("circle-small-filled",60298),debugStackframeDot:o("debug-stackframe-dot",60298),debugStackframe:o("debug-stackframe",60299),debugStackframeFocused:o("debug-stackframe-focused",60299),debugBreakpointUnsupported:o("debug-breakpoint-unsupported",60300),symbolString:o("symbol-string",60301),debugReverseContinue:o("debug-reverse-continue",60302),debugStepBack:o("debug-step-back",60303),debugRestartFrame:o("debug-restart-frame",60304),callIncoming:o("call-incoming",60306),callOutgoing:o("call-outgoing",60307),menu:o("menu",60308),expandAll:o("expand-all",60309),feedback:o("feedback",60310),groupByRefType:o("group-by-ref-type",60311),ungroupByRefType:o("ungroup-by-ref-type",60312),account:o("account",60313),bellDot:o("bell-dot",60314),debugConsole:o("debug-console",60315),library:o("library",60316),output:o("output",60317),runAll:o("run-all",60318),syncIgnored:o("sync-ignored",60319),pinned:o("pinned",60320),githubInverted:o("github-inverted",60321),debugAlt:o("debug-alt",60305),serverProcess:o("server-process",60322),serverEnvironment:o("server-environment",60323),pass:o("pass",60324),stopCircle:o("stop-circle",60325),playCircle:o("play-circle",60326),record:o("record",60327),debugAltSmall:o("debug-alt-small",60328),vmConnect:o("vm-connect",60329),cloud:o("cloud",60330),merge:o("merge",60331),exportIcon:o("export",60332),graphLeft:o("graph-left",60333),magnet:o("magnet",60334),notebook:o("notebook",60335),redo:o("redo",60336),checkAll:o("check-all",60337),pinnedDirty:o("pinned-dirty",60338),passFilled:o("pass-filled",60339),circleLargeFilled:o("circle-large-filled",60340),circleLarge:o("circle-large",60341),circleLargeOutline:o("circle-large-outline",60341),combine:o("combine",60342),gather:o("gather",60342),table:o("table",60343),variableGroup:o("variable-group",60344),typeHierarchy:o("type-hierarchy",60345),typeHierarchySub:o("type-hierarchy-sub",60346),typeHierarchySuper:o("type-hierarchy-super",60347),gitPullRequestCreate:o("git-pull-request-create",60348),runAbove:o("run-above",60349),runBelow:o("run-below",60350),notebookTemplate:o("notebook-template",60351),debugRerun:o("debug-rerun",60352),workspaceTrusted:o("workspace-trusted",60353),workspaceUntrusted:o("workspace-untrusted",60354),workspaceUnspecified:o("workspace-unspecified",60355),terminalCmd:o("terminal-cmd",60356),terminalDebian:o("terminal-debian",60357),terminalLinux:o("terminal-linux",60358),terminalPowershell:o("terminal-powershell",60359),terminalTmux:o("terminal-tmux",60360),terminalUbuntu:o("terminal-ubuntu",60361),terminalBash:o("terminal-bash",60362),arrowSwap:o("arrow-swap",60363),copy:o("copy",60364),personAdd:o("person-add",60365),filterFilled:o("filter-filled",60366),wand:o("wand",60367),debugLineByLine:o("debug-line-by-line",60368),inspect:o("inspect",60369),layers:o("layers",60370),layersDot:o("layers-dot",60371),layersActive:o("layers-active",60372),compass:o("compass",60373),compassDot:o("compass-dot",60374),compassActive:o("compass-active",60375),azure:o("azure",60376),issueDraft:o("issue-draft",60377),gitPullRequestClosed:o("git-pull-request-closed",60378),gitPullRequestDraft:o("git-pull-request-draft",60379),debugAll:o("debug-all",60380),debugCoverage:o("debug-coverage",60381),runErrors:o("run-errors",60382),folderLibrary:o("folder-library",60383),debugContinueSmall:o("debug-continue-small",60384),beakerStop:o("beaker-stop",60385),graphLine:o("graph-line",60386),graphScatter:o("graph-scatter",60387),pieChart:o("pie-chart",60388),bracket:o("bracket",60388),bracketDot:o("bracket-dot",60389),bracketError:o("bracket-error",60390),lockSmall:o("lock-small",60391),azureDevops:o("azure-devops",60392),verifiedFilled:o("verified-filled",60393),newLine:o("newline",60394),layout:o("layout",60395),layoutActivitybarLeft:o("layout-activitybar-left",60396),layoutActivitybarRight:o("layout-activitybar-right",60397),layoutPanelLeft:o("layout-panel-left",60398),layoutPanelCenter:o("layout-panel-center",60399),layoutPanelJustify:o("layout-panel-justify",60400),layoutPanelRight:o("layout-panel-right",60401),layoutPanel:o("layout-panel",60402),layoutSidebarLeft:o("layout-sidebar-left",60403),layoutSidebarRight:o("layout-sidebar-right",60404),layoutStatusbar:o("layout-statusbar",60405),layoutMenubar:o("layout-menubar",60406),layoutCentered:o("layout-centered",60407),layoutSidebarRightOff:o("layout-sidebar-right-off",60416),layoutPanelOff:o("layout-panel-off",60417),layoutSidebarLeftOff:o("layout-sidebar-left-off",60418),target:o("target",60408),indent:o("indent",60409),recordSmall:o("record-small",60410),errorSmall:o("error-small",60411),arrowCircleDown:o("arrow-circle-down",60412),arrowCircleLeft:o("arrow-circle-left",60413),arrowCircleRight:o("arrow-circle-right",60414),arrowCircleUp:o("arrow-circle-up",60415),heartFilled:o("heart-filled",60420),map:o("map",60421),mapFilled:o("map-filled",60422),circleSmall:o("circle-small",60423),bellSlash:o("bell-slash",60424),bellSlashDot:o("bell-slash-dot",60425),commentUnresolved:o("comment-unresolved",60426),gitPullRequestGoToChanges:o("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:o("git-pull-request-new-changes",60428),searchFuzzy:o("search-fuzzy",60429),commentDraft:o("comment-draft",60430),dialogError:o("dialog-error","error"),dialogWarning:o("dialog-warning","warning"),dialogInfo:o("dialog-info","info"),dialogClose:o("dialog-close","close"),treeItemExpanded:o("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:o("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:o("tree-filter-on-type-off","list-selection"),treeFilterClear:o("tree-filter-clear","close"),treeItemLoading:o("tree-item-loading","loading"),menuSelection:o("menu-selection","check"),menuSubmenu:o("menu-submenu","chevron-right"),menuBarMore:o("menubar-more","more"),scrollbarButtonLeft:o("scrollbar-button-left","triangle-left"),scrollbarButtonRight:o("scrollbar-button-right","triangle-right"),scrollbarButtonUp:o("scrollbar-button-up","triangle-up"),scrollbarButtonDown:o("scrollbar-button-down","triangle-down"),toolBarMore:o("toolbar-more","more"),quickInputBack:o("quick-input-back","arrow-left")}}),define(te[44],ie([0,1,10]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const g=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([D,E])=>{g[D]=E&&typeof E=="object"?L(E):E}),g}e.deepClone=L;function k(u){if(!u||typeof u!="object")return u;const g=[u];for(;g.length>0;){const D=g.shift();Object.freeze(D);for(const E in D)if(o.call(D,E)){const R=D[E];typeof R=="object"&&!Object.isFrozen(R)&&!(0,I.isTypedArray)(R)&&g.push(R)}}return u}e.deepFreeze=k;const o=Object.prototype.hasOwnProperty;function C(u,g){return P(u,g,new Set)}e.cloneAndChange=C;function P(u,g,D){if((0,I.isUndefinedOrNull)(u))return u;const E=g(u);if(typeof E<"u")return E;if(Array.isArray(u)){const R=[];for(const t of u)R.push(P(t,g,D));return R}if((0,I.isObject)(u)){if(D.has(u))throw new Error("Cannot clone recursive data-structure");D.add(u);const R={};for(const t in u)o.call(u,t)&&(R[t]=P(u[t],g,D));return D.delete(u),R}return u}function h(u,g,D=!0){return(0,I.isObject)(u)?((0,I.isObject)(g)&&Object.keys(g).forEach(E=>{E in u?D&&((0,I.isObject)(u[E])&&(0,I.isObject)(g[E])?h(u[E],g[E],D):u[E]=g[E]):u[E]=g[E]}),u):g}e.mixin=h;function m(u,g){if(u===g)return!0;if(u==null||g===null||g===void 0||typeof u!=typeof g||typeof u!="object"||Array.isArray(u)!==Array.isArray(g))return!1;let D,E;if(Array.isArray(u)){if(u.length!==g.length)return!1;for(D=0;D<u.length;D++)if(!m(u[D],g[D]))return!1}else{const R=[];for(E in u)R.push(E);R.sort();const t=[];for(E in g)t.push(E);if(t.sort(),!m(R,t))return!1;for(D=0;D<R.length;D++)if(!m(u[R[D]],g[R[D]]))return!1}return!0}e.equals=m;function S(u){const g=new Set;return JSON.stringify(u,(D,E)=>{if((0,I.isObject)(E)||Array.isArray(E)){if(g.has(E))return"[Circular]";g.add(E)}return E})}e.safeStringify=S;function v(u,g){const D=Object.create(null);return!u||!g||Object.keys(g).forEach(R=>{const t=u[R],a=g[R];m(t,a)||(D[R]=a)}),D}e.distinct=v;function b(u,g){const D=g.toLowerCase(),E=Object.keys(u).find(R=>R.toLowerCase()===D);return E?u[E]:u[g]}e.getCaseInsensitive=b;function f(u,g){const D=Object.create(null);for(const[E,R]of Object.entries(u))g(E,R)&&(D[E]=R);return D}e.filter=f;function p(u){let g=[],D=Object.getPrototypeOf(u);for(;Object.prototype!==D;)g=g.concat(Object.getOwnPropertyNames(D)),D=Object.getPrototypeOf(D);return g}e.getAllPropertyNames=p;function w(u){const g=[];for(const D of p(u))typeof u[D]=="function"&&g.push(D);return g}e.getAllMethodNames=w;function c(u,g){const D=R=>function(){const t=Array.prototype.slice.call(arguments,0);return g(R,t)},E={};for(const R of u)E[R]=D(R);return E}e.createProxyObject=c}),define(te[130],ie([0,1,129]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(C){function P(h){return h&&typeof h=="object"&&typeof h.id=="string"}C.isThemeColor=P})(L=e.ThemeColor||(e.ThemeColor={}));function k(C){return{id:C}}e.themeColorFromId=k;var o;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function h(g){const D=P.exec(g.id);if(!D)return h(I.Codicon.error);const[,E,R]=D,t=["codicon","codicon-"+E];return R&&t.push("codicon-modifier-"+R.substring(1)),t}C.asClassNameArray=h;function m(g){return h(g).join(" ")}C.asClassName=m;function S(g){return"."+h(g).join(".")}C.asCSSSelector=S;function v(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||L.isThemeColor(g.color))}C.isThemeIcon=v;const b=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function f(g){const D=b.exec(g);if(!D)return;const[,E]=D;return{id:E}}C.fromString=f;function p(g){return{id:g}}C.fromId=p;function w(g,D){let E=g.id;const R=E.lastIndexOf("~");return R!==-1&&(E=E.substring(0,R)),D&&(E=`${E}~${D}`),{id:E}}C.modify=w;function c(g){const D=g.id.lastIndexOf("~");if(D!==-1)return g.id.substring(D+1)}C.getModifier=c;function u(g,D){return g.id===D.id&&g.color?.id===D.color?.id}C.isEqual=u})(o=e.ThemeIcon||(e.ThemeIcon={}))}),define(te[31],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(k){return I.test(k)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(P){for(let h=0;h<P.length;h++)P[h]=Math.floor(Math.random()*256);return P};const o=new Uint8Array(16),C=[];for(let P=0;P<256;P++)C.push(P.toString(16).padStart(2,"0"));return function(){k(o),o[6]=o[6]&15|64,o[8]=o[8]&63|128;let h=0,m="";return m+=C[o[h++]],m+=C[o[h++]],m+=C[o[h++]],m+=C[o[h++]],m+="-",m+=C[o[h++]],m+=C[o[h++]],m+="-",m+=C[o[h++]],m+=C[o[h++]],m+="-",m+=C[o[h++]],m+=C[o[h++]],m+="-",m+=C[o[h++]],m+=C[o[h++]],m+=C[o[h++]],m+=C[o[h++]],m+=C[o[h++]],m+=C[o[h++]],m}}()}),define(te[131],ie([0,1,80,41,49]),function(V,e,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function o(C,P){if(await new Promise((S,v)=>{const b=L.createReadStream(C),f=I.createHash("sha1");b.pipe(f);const p=(0,k.once)((w,c)=>{b.removeAllListeners(),f.removeAllListeners(),w?v(w):S(c)});b.once("error",p),b.once("end",p),f.once("error",p),f.once("data",w=>p(void 0,w.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.checksum=o}),define(te[132],ie([0,1,26]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(C){const P=C.replace(/\-/g,":").toLowerCase();return!L.has(P)}function o(){const C=(0,I.networkInterfaces)();for(const P in C){const h=C[P];if(h){for(const{mac:m}of h)if(k(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=o}),define(te[99],ie([0,1,81]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function L(P,h,m,S=1){let v=!1;return new Promise(b=>{const f=setTimeout(()=>{if(!v)return v=!0,b(0)},m);k(P,h,S,p=>{if(!v)return v=!0,clearTimeout(f),b(p)})})}e.findFreePort=L;function k(P,h,m,S){if(h===0)return S(0);const v=new I.Socket;v.once("connect",()=>(C(v),k(P+m,h-1,m,S))),v.once("data",()=>{}),v.once("error",b=>(C(v),b.code!=="ECONNREFUSED"?k(P+m,h-1,m,S):S(P))),v.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function o(P,h,m,S="127.0.0.1"){let v=!1,b,f=1;const p=I.createServer({pauseOnConnect:!0});function w(c,u){v||(v=!0,p.removeAllListeners(),p.close(),b&&clearTimeout(b),u(c))}return new Promise(c=>{b=setTimeout(()=>{w(0,c)},m),p.on("listening",()=>{w(P,c)}),p.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&f<h?(P++,f++,p.listen(P,S)):w(0,c)}),p.on("close",()=>{w(0,c)}),p.listen(P,S)})}e.findFreePortFaster=o;function C(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(h){console.error(h)}}}),define(te[133],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(te[134],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class I{constructor(k,o){this.a=k,this.onMessage=o}send(k){try{this.a.send("vscode:message",k.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=I}),define(te[42],ie([0,1,14,13]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class k{constructor(){this.a=new WeakMap}on(C,P){const h=(m,...S)=>{this.b(C,m)&&P(m,...S)};return this.a.set(P,h),I.ipcMain.on(C,h),this}once(C,P){return I.ipcMain.once(C,(h,...m)=>{this.b(C,h)&&P(h,...m)}),this}handle(C,P){return I.ipcMain.handle(C,(h,...m)=>this.b(C,h)?P(h,...m):Promise.reject(`Invalid channel '${C}' or sender for ipcMain.handle() usage.`)),this}removeHandler(C){return I.ipcMain.removeHandler(C),this}removeListener(C,P){const h=this.a.get(P);return h&&(I.ipcMain.removeListener(C,h),this.a.delete(P)),this}b(C,P){if(!C||!C.startsWith("vscode:"))return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${C}' because the channel is unknown.`),!1;const h=P.senderFrame,m=h.url;if(!m)return!0;let S="unknown";try{S=new URL(m).host}catch{return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${C}' because of a malformed URL '${m}'.`),!1}return S!=="vscode-app"?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${C}' because of a bad origin of '${S}'.`),!1):h.parent!==null?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${C}' because sender of origin '${S}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new k}),define(te[135],ie([0,1,14,42,10,133]),function(V,e,I,L,k,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function C(){L.validatedIpcMain.on(o.CONTEXT_MENU_CHANNEL,(h,m,S,v,b)=>{const f=P(h,v,S);f.popup({window:(0,k.withNullAsUndefined)(I.BrowserWindow.fromWebContents(h.sender)),x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{f&&h.sender.send(o.CONTEXT_MENU_CLOSE_CHANNEL,m)}})})}e.registerContextMenuListener=C;function P(h,m,S){const v=new I.Menu;return S.forEach(b=>{let f;b.type==="separator"?f=new I.MenuItem({type:b.type}):Array.isArray(b.submenu)?f=new I.MenuItem({submenu:P(h,m,b.submenu),label:b.label}):f=new I.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(p,w,c)=>h.sender.send(m,b.id,c)}),v.append(f)}),v}}),define(te[100],ie([0,1,14]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.canUseUtilityProcess=e.UtilityProcess=void 0,e.UtilityProcess=I.utilityProcess,e.canUseUtilityProcess=typeof e.UtilityProcess<"u"}),define(te[136],ie([12,11]),function(V,e){return V.create("vs/base/common/date",e)}),define(te[137],ie([0,1,136]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,k=L*60,o=k*24,C=o*7,P=o*30,h=o*365;function m(v,b,f,p){typeof v!="number"&&(v=v.getTime());const w=Math.round((new Date().getTime()-v)/1e3);if(w<-30)return(0,I.localize)(0,null,m(new Date().getTime()+w*1e3,!1));if(!p&&w<30)return(0,I.localize)(1,null);let c;return w<L?(c=w,b?c===1?f?(0,I.localize)(2,null,c):(0,I.localize)(3,null,c):f?(0,I.localize)(4,null,c):(0,I.localize)(5,null,c):c===1?f?(0,I.localize)(6,null,c):(0,I.localize)(7,null,c):f?(0,I.localize)(8,null,c):(0,I.localize)(9,null,c)):w<k?(c=Math.floor(w/L),b?c===1?f?(0,I.localize)(10,null,c):(0,I.localize)(11,null,c):f?(0,I.localize)(12,null,c):(0,I.localize)(13,null,c):c===1?f?(0,I.localize)(14,null,c):(0,I.localize)(15,null,c):f?(0,I.localize)(16,null,c):(0,I.localize)(17,null,c)):w<o?(c=Math.floor(w/k),b?c===1?f?(0,I.localize)(18,null,c):(0,I.localize)(19,null,c):f?(0,I.localize)(20,null,c):(0,I.localize)(21,null,c):c===1?f?(0,I.localize)(22,null,c):(0,I.localize)(23,null,c):f?(0,I.localize)(24,null,c):(0,I.localize)(25,null,c)):w<C?(c=Math.floor(w/o),b?c===1?(0,I.localize)(26,null,c):(0,I.localize)(27,null,c):c===1?(0,I.localize)(28,null,c):(0,I.localize)(29,null,c)):w<P?(c=Math.floor(w/C),b?c===1?f?(0,I.localize)(30,null,c):(0,I.localize)(31,null,c):f?(0,I.localize)(32,null,c):(0,I.localize)(33,null,c):c===1?f?(0,I.localize)(34,null,c):(0,I.localize)(35,null,c):f?(0,I.localize)(36,null,c):(0,I.localize)(37,null,c)):w<h?(c=Math.floor(w/P),b?c===1?f?(0,I.localize)(38,null,c):(0,I.localize)(39,null,c):f?(0,I.localize)(40,null,c):(0,I.localize)(41,null,c):c===1?f?(0,I.localize)(42,null,c):(0,I.localize)(43,null,c):f?(0,I.localize)(44,null,c):(0,I.localize)(45,null,c)):(c=Math.floor(w/h),b?c===1?f?(0,I.localize)(46,null,c):(0,I.localize)(47,null,c):f?(0,I.localize)(48,null,c):(0,I.localize)(49,null,c):c===1?f?(0,I.localize)(50,null,c):(0,I.localize)(51,null,c):f?(0,I.localize)(52,null,c):(0,I.localize)(53,null,c))}e.fromNow=m;function S(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=S}),define(te[138],ie([12,11]),function(V,e){return V.create("vs/base/common/errorMessage",e)}),define(te[45],ie([0,1,25,10,138]),function(V,e,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function o(v,b){return b&&(v.stack||v.stacktrace)?k.localize(0,null,P(v),C(v.stack)||C(v.stacktrace)):P(v)}function C(v){return Array.isArray(v)?v.join(`
`):v}function P(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?k.localize(1,null,v.message):v.message||k.localize(2,null)}function h(v=null,b=!1){if(!v)return k.localize(3,null);if(Array.isArray(v)){const f=I.coalesce(v),p=h(f[0],b);return f.length>1?k.localize(4,null,p,f.length):p}if(L.isString(v))return v;if(v.detail){const f=v.detail;if(f.error)return o(f.error,b);if(f.exception)return o(f.exception,b)}return v.stack?o(v,b):v.message?v.message:k.localize(5,null)}e.toErrorMessage=h;function m(v){const b=v;return b instanceof Error&&Array.isArray(b.actions)}e.isErrorWithActions=m;function S(v,b){let f;return typeof v=="string"?f=new Error(v):f=v,f.actions=b,f}e.createErrorWithActions=S}),define(te[139],ie([12,11]),function(V,e){return V.create("vs/base/common/jsonErrorMessages",e)}),define(te[140],ie([0,1,139]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function L(k){switch(k){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}e.getParseErrorMessage=L}),define(te[141],ie([12,11]),function(V,e){return V.create("vs/base/common/platform",e)}),define(te[4],ie([0,1,141]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let L=!1,k=!1,o=!1,C=!1,P=!1,h=!1,m=!1,S=!1,v=!1,b=!1,f,p=e.LANGUAGE_DEFAULT,w,c;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const g=typeof u?.versions?.electron=="string",D=g&&u?.type==="renderer";if(typeof navigator=="object"&&!D)c=navigator.userAgent,L=c.indexOf("Windows")>=0,k=c.indexOf("Macintosh")>=0,S=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,o=c.indexOf("Linux")>=0,b=c?.indexOf("Mobi")>=0,h=!0,f=I.getConfiguredDefaultLocale(I.localize(0,null))||e.LANGUAGE_DEFAULT,p=f;else if(typeof u=="object"){L=u.platform==="win32",k=u.platform==="darwin",o=u.platform==="linux",C=o&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,m=g,v=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.LANGUAGE_DEFAULT,p=e.LANGUAGE_DEFAULT;const s=u.env.VSCODE_NLS_CONFIG;if(s)try{const d=JSON.parse(s),y=d.availableLanguages["*"];f=d.locale,p=y||e.LANGUAGE_DEFAULT,w=d._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var E;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function R(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=R;let t=0;k?t=1:L?t=3:o&&(t=2),e.isWindows=L,e.isMacintosh=k,e.isLinux=o,e.isLinuxSnap=C,e.isNative=P,e.isElectron=m,e.isWeb=h,e.isWebWorker=h&&typeof e.globals.importScripts=="function",e.isIOS=S,e.isMobile=b,e.isCI=v,e.platform=t,e.userAgent=c,e.language=p;var a;(function(s){function d(){return e.language}s.value=d;function y(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=y;function M(){return e.language==="en"}s.isDefault=M})(a=e.Language||(e.Language={})),e.locale=f,e.translationsConfigFile=w,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const s=[];e.globals.addEventListener("message",y=>{if(y.data&&y.data.vscodeScheduleAsyncWork)for(let M=0,O=s.length;M<O;M++){const j=s[M];if(j.id===y.data.vscodeScheduleAsyncWork){s.splice(M,1),j.callback();return}}});let d=0;return y=>{const M=++d;s.push({id:M,callback:y}),e.globals.postMessage({vscodeScheduleAsyncWork:M},"*")}}return s=>setTimeout(s)})();var i;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||S?2:L?1:3;let n=!0,r=!1;function l(){if(!r){r=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,n=new Uint16Array(s.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(te[35],ie([0,1,4]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.process<"u"){const k=I.globals.vscode.process;L={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return I.isWindows?"win32":I.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(te[9],ie([0,1,35]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,k=97,o=90,C=122,P=46,h=47,m=92,S=58,v=63;class b extends Error{constructor(a,i,n){let r;typeof i=="string"&&i.indexOf("not ")===0?(r="must not be",i=i.replace(/^not /,"")):r="must be";const l=a.indexOf(".")!==-1?"property":"argument";let s=`The "${a}" ${l} ${r} of type ${i}`;s+=`. Received type ${typeof n}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function f(t,a){if(t===null||typeof t!="object")throw new b(a,"Object",t)}function p(t,a){if(typeof t!="string")throw new b(a,"string",t)}const w=I.platform==="win32";function c(t){return t===h||t===m}function u(t){return t===h}function g(t){return t>=L&&t<=o||t>=k&&t<=C}function D(t,a,i,n){let r="",l=0,s=-1,d=0,y=0;for(let M=0;M<=t.length;++M){if(M<t.length)y=t.charCodeAt(M);else{if(n(y))break;y=h}if(n(y)){if(!(s===M-1||d===1))if(d===2){if(r.length<2||l!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const O=r.lastIndexOf(i);O===-1?(r="",l=0):(r=r.slice(0,O),l=r.length-1-r.lastIndexOf(i)),s=M,d=0;continue}else if(r.length!==0){r="",l=0,s=M,d=0;continue}}a&&(r+=r.length>0?`${i}..`:"..",l=2)}else r.length>0?r+=`${i}${t.slice(s+1,M)}`:r=t.slice(s+1,M),l=M-s-1;s=M,d=0}else y===P&&d!==-1?++d:d=-1}return r}function E(t,a){f(a,"pathObject");const i=a.dir||a.root,n=a.base||`${a.name||""}${a.ext||""}`;return i?i===a.root?`${i}${n}`:`${i}${t}${n}`:n}e.win32={resolve(...t){let a="",i="",n=!1;for(let r=t.length-1;r>=-1;r--){let l;if(r>=0){if(l=t[r],p(l,"path"),l.length===0)continue}else a.length===0?l=I.cwd():(l=I.env[`=${a}`]||I.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==a.toLowerCase()&&l.charCodeAt(2)===m)&&(l=`${a}\\`));const s=l.length;let d=0,y="",M=!1;const O=l.charCodeAt(0);if(s===1)c(O)&&(d=1,M=!0);else if(c(O))if(M=!0,c(l.charCodeAt(1))){let j=2,K=j;for(;j<s&&!c(l.charCodeAt(j));)j++;if(j<s&&j!==K){const x=l.slice(K,j);for(K=j;j<s&&c(l.charCodeAt(j));)j++;if(j<s&&j!==K){for(K=j;j<s&&!c(l.charCodeAt(j));)j++;(j===s||j!==K)&&(y=`\\\\${x}\\${l.slice(K,j)}`,d=j)}}}else d=1;else g(O)&&l.charCodeAt(1)===S&&(y=l.slice(0,2),d=2,s>2&&c(l.charCodeAt(2))&&(M=!0,d=3));if(y.length>0)if(a.length>0){if(y.toLowerCase()!==a.toLowerCase())continue}else a=y;if(n){if(a.length>0)break}else if(i=`${l.slice(d)}\\${i}`,n=M,M&&a.length>0)break}return i=D(i,!n,"\\",c),n?`${a}\\${i}`:`${a}${i}`||"."},normalize(t){p(t,"path");const a=t.length;if(a===0)return".";let i=0,n,r=!1;const l=t.charCodeAt(0);if(a===1)return u(l)?"\\":t;if(c(l))if(r=!0,c(t.charCodeAt(1))){let d=2,y=d;for(;d<a&&!c(t.charCodeAt(d));)d++;if(d<a&&d!==y){const M=t.slice(y,d);for(y=d;d<a&&c(t.charCodeAt(d));)d++;if(d<a&&d!==y){for(y=d;d<a&&!c(t.charCodeAt(d));)d++;if(d===a)return`\\\\${M}\\${t.slice(y)}\\`;d!==y&&(n=`\\\\${M}\\${t.slice(y,d)}`,i=d)}}}else i=1;else g(l)&&t.charCodeAt(1)===S&&(n=t.slice(0,2),i=2,a>2&&c(t.charCodeAt(2))&&(r=!0,i=3));let s=i<a?D(t.slice(i),!r,"\\",c):"";return s.length===0&&!r&&(s="."),s.length>0&&c(t.charCodeAt(a-1))&&(s+="\\"),n===void 0?r?`\\${s}`:s:r?`${n}\\${s}`:`${n}${s}`},isAbsolute(t){p(t,"path");const a=t.length;if(a===0)return!1;const i=t.charCodeAt(0);return c(i)||a>2&&g(i)&&t.charCodeAt(1)===S&&c(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let a,i;for(let l=0;l<t.length;++l){const s=t[l];p(s,"path"),s.length>0&&(a===void 0?a=i=s:a+=`\\${s}`)}if(a===void 0)return".";let n=!0,r=0;if(typeof i=="string"&&c(i.charCodeAt(0))){++r;const l=i.length;l>1&&c(i.charCodeAt(1))&&(++r,l>2&&(c(i.charCodeAt(2))?++r:n=!1))}if(n){for(;r<a.length&&c(a.charCodeAt(r));)r++;r>=2&&(a=`\\${a.slice(r)}`)}return e.win32.normalize(a)},relative(t,a){if(p(t,"from"),p(a,"to"),t===a)return"";const i=e.win32.resolve(t),n=e.win32.resolve(a);if(i===n||(t=i.toLowerCase(),a=n.toLowerCase(),t===a))return"";let r=0;for(;r<t.length&&t.charCodeAt(r)===m;)r++;let l=t.length;for(;l-1>r&&t.charCodeAt(l-1)===m;)l--;const s=l-r;let d=0;for(;d<a.length&&a.charCodeAt(d)===m;)d++;let y=a.length;for(;y-1>d&&a.charCodeAt(y-1)===m;)y--;const M=y-d,O=s<M?s:M;let j=-1,K=0;for(;K<O;K++){const J=t.charCodeAt(r+K);if(J!==a.charCodeAt(d+K))break;J===m&&(j=K)}if(K!==O){if(j===-1)return n}else{if(M>O){if(a.charCodeAt(d+K)===m)return n.slice(d+K+1);if(K===2)return n.slice(d+K)}s>O&&(t.charCodeAt(r+K)===m?j=K:K===2&&(j=3)),j===-1&&(j=0)}let x="";for(K=r+j+1;K<=l;++K)(K===l||t.charCodeAt(K)===m)&&(x+=x.length===0?"..":"\\..");return d+=j,x.length>0?`${x}${n.slice(d,y)}`:(n.charCodeAt(d)===m&&++d,n.slice(d,y))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const a=e.win32.resolve(t);if(a.length<=2)return t;if(a.charCodeAt(0)===m){if(a.charCodeAt(1)===m){const i=a.charCodeAt(2);if(i!==v&&i!==P)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(g(a.charCodeAt(0))&&a.charCodeAt(1)===S&&a.charCodeAt(2)===m)return`\\\\?\\${a}`;return t},dirname(t){p(t,"path");const a=t.length;if(a===0)return".";let i=-1,n=0;const r=t.charCodeAt(0);if(a===1)return c(r)?t:".";if(c(r)){if(i=n=1,c(t.charCodeAt(1))){let d=2,y=d;for(;d<a&&!c(t.charCodeAt(d));)d++;if(d<a&&d!==y){for(y=d;d<a&&c(t.charCodeAt(d));)d++;if(d<a&&d!==y){for(y=d;d<a&&!c(t.charCodeAt(d));)d++;if(d===a)return t;d!==y&&(i=n=d+1)}}}}else g(r)&&t.charCodeAt(1)===S&&(i=a>2&&c(t.charCodeAt(2))?3:2,n=i);let l=-1,s=!0;for(let d=a-1;d>=n;--d)if(c(t.charCodeAt(d))){if(!s){l=d;break}}else s=!1;if(l===-1){if(i===-1)return".";l=i}return t.slice(0,l)},basename(t,a){a!==void 0&&p(a,"ext"),p(t,"path");let i=0,n=-1,r=!0,l;if(t.length>=2&&g(t.charCodeAt(0))&&t.charCodeAt(1)===S&&(i=2),a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let s=a.length-1,d=-1;for(l=t.length-1;l>=i;--l){const y=t.charCodeAt(l);if(c(y)){if(!r){i=l+1;break}}else d===-1&&(r=!1,d=l+1),s>=0&&(y===a.charCodeAt(s)?--s===-1&&(n=l):(s=-1,n=d))}return i===n?n=d:n===-1&&(n=t.length),t.slice(i,n)}for(l=t.length-1;l>=i;--l)if(c(t.charCodeAt(l))){if(!r){i=l+1;break}}else n===-1&&(r=!1,n=l+1);return n===-1?"":t.slice(i,n)},extname(t){p(t,"path");let a=0,i=-1,n=0,r=-1,l=!0,s=0;t.length>=2&&t.charCodeAt(1)===S&&g(t.charCodeAt(0))&&(a=n=2);for(let d=t.length-1;d>=a;--d){const y=t.charCodeAt(d);if(c(y)){if(!l){n=d+1;break}continue}r===-1&&(l=!1,r=d+1),y===P?i===-1?i=d:s!==1&&(s=1):i!==-1&&(s=-1)}return i===-1||r===-1||s===0||s===1&&i===r-1&&i===n+1?"":t.slice(i,r)},format:E.bind(null,"\\"),parse(t){p(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const i=t.length;let n=0,r=t.charCodeAt(0);if(i===1)return c(r)?(a.root=a.dir=t,a):(a.base=a.name=t,a);if(c(r)){if(n=1,c(t.charCodeAt(1))){let j=2,K=j;for(;j<i&&!c(t.charCodeAt(j));)j++;if(j<i&&j!==K){for(K=j;j<i&&c(t.charCodeAt(j));)j++;if(j<i&&j!==K){for(K=j;j<i&&!c(t.charCodeAt(j));)j++;j===i?n=j:j!==K&&(n=j+1)}}}}else if(g(r)&&t.charCodeAt(1)===S){if(i<=2)return a.root=a.dir=t,a;if(n=2,c(t.charCodeAt(2))){if(i===3)return a.root=a.dir=t,a;n=3}}n>0&&(a.root=t.slice(0,n));let l=-1,s=n,d=-1,y=!0,M=t.length-1,O=0;for(;M>=n;--M){if(r=t.charCodeAt(M),c(r)){if(!y){s=M+1;break}continue}d===-1&&(y=!1,d=M+1),r===P?l===-1?l=M:O!==1&&(O=1):l!==-1&&(O=-1)}return d!==-1&&(l===-1||O===0||O===1&&l===d-1&&l===s+1?a.base=a.name=t.slice(s,d):(a.name=t.slice(s,l),a.base=t.slice(s,d),a.ext=t.slice(l,d))),s>0&&s!==n?a.dir=t.slice(0,s-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const R=(()=>{if(w){const t=/\\/g;return()=>{const a=I.cwd().replace(t,"/");return a.slice(a.indexOf("/"))}}return()=>I.cwd()})();e.posix={resolve(...t){let a="",i=!1;for(let n=t.length-1;n>=-1&&!i;n--){const r=n>=0?t[n]:R();p(r,"path"),r.length!==0&&(a=`${r}/${a}`,i=r.charCodeAt(0)===h)}return a=D(a,!i,"/",u),i?`/${a}`:a.length>0?a:"."},normalize(t){if(p(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===h,i=t.charCodeAt(t.length-1)===h;return t=D(t,!a,"/",u),t.length===0?a?"/":i?"./":".":(i&&(t+="/"),a?`/${t}`:t)},isAbsolute(t){return p(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let a;for(let i=0;i<t.length;++i){const n=t[i];p(n,"path"),n.length>0&&(a===void 0?a=n:a+=`/${n}`)}return a===void 0?".":e.posix.normalize(a)},relative(t,a){if(p(t,"from"),p(a,"to"),t===a||(t=e.posix.resolve(t),a=e.posix.resolve(a),t===a))return"";const i=1,n=t.length,r=n-i,l=1,s=a.length-l,d=r<s?r:s;let y=-1,M=0;for(;M<d;M++){const j=t.charCodeAt(i+M);if(j!==a.charCodeAt(l+M))break;j===h&&(y=M)}if(M===d)if(s>d){if(a.charCodeAt(l+M)===h)return a.slice(l+M+1);if(M===0)return a.slice(l+M)}else r>d&&(t.charCodeAt(i+M)===h?y=M:M===0&&(y=0));let O="";for(M=i+y+1;M<=n;++M)(M===n||t.charCodeAt(M)===h)&&(O+=O.length===0?"..":"/..");return`${O}${a.slice(l+y)}`},toNamespacedPath(t){return t},dirname(t){if(p(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===h;let i=-1,n=!0;for(let r=t.length-1;r>=1;--r)if(t.charCodeAt(r)===h){if(!n){i=r;break}}else n=!1;return i===-1?a?"/":".":a&&i===1?"//":t.slice(0,i)},basename(t,a){a!==void 0&&p(a,"ext"),p(t,"path");let i=0,n=-1,r=!0,l;if(a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let s=a.length-1,d=-1;for(l=t.length-1;l>=0;--l){const y=t.charCodeAt(l);if(y===h){if(!r){i=l+1;break}}else d===-1&&(r=!1,d=l+1),s>=0&&(y===a.charCodeAt(s)?--s===-1&&(n=l):(s=-1,n=d))}return i===n?n=d:n===-1&&(n=t.length),t.slice(i,n)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===h){if(!r){i=l+1;break}}else n===-1&&(r=!1,n=l+1);return n===-1?"":t.slice(i,n)},extname(t){p(t,"path");let a=-1,i=0,n=-1,r=!0,l=0;for(let s=t.length-1;s>=0;--s){const d=t.charCodeAt(s);if(d===h){if(!r){i=s+1;break}continue}n===-1&&(r=!1,n=s+1),d===P?a===-1?a=s:l!==1&&(l=1):a!==-1&&(l=-1)}return a===-1||n===-1||l===0||l===1&&a===n-1&&a===i+1?"":t.slice(a,n)},format:E.bind(null,"/"),parse(t){p(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const i=t.charCodeAt(0)===h;let n;i?(a.root="/",n=1):n=0;let r=-1,l=0,s=-1,d=!0,y=t.length-1,M=0;for(;y>=n;--y){const O=t.charCodeAt(y);if(O===h){if(!d){l=y+1;break}continue}s===-1&&(d=!1,s=y+1),O===P?r===-1?r=y:M!==1&&(M=1):r!==-1&&(M=-1)}if(s!==-1){const O=l===0&&i?1:l;r===-1||M===0||M===1&&r===s-1&&r===l+1?a.base=a.name=t.slice(O,s):(a.name=t.slice(O,r),a.base=t.slice(O,s),a.ext=t.slice(r,s))}return l>0?a.dir=t.slice(0,l-1):i&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w?e.win32.normalize:e.posix.normalize,e.isAbsolute=w?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w?e.win32.join:e.posix.join,e.resolve=w?e.win32.resolve:e.posix.resolve,e.relative=w?e.win32.relative:e.posix.relative,e.dirname=w?e.win32.dirname:e.posix.dirname,e.basename=w?e.win32.basename:e.posix.basename,e.extname=w?e.win32.extname:e.posix.extname,e.format=w?e.win32.format:e.posix.format,e.parse=w?e.win32.parse:e.posix.parse,e.toNamespacedPath=w?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w?e.win32.sep:e.posix.sep,e.delimiter=w?e.win32.delimiter:e.posix.delimiter}),define(te[82],ie([0,1,4]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(L=e.Source||(e.Source={}));var k;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function o(P,...h){const m=h.reduce((b,f)=>(b[f]=!0,b),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(b=>!m[b]).forEach(b=>{for(let f=0;f<S.length;f++)if(b.search(S[f])!==-1){delete P[b];break}})}e.sanitizeProcessEnvironment=o;function C(P){!P||(delete P.DEBUG,I.isMacintosh&&delete P.DYLD_LIBRARY_PATH,I.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=C}),define(te[70],ie([0,1,4]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=I.globals.performance&&typeof I.globals.performance.now=="function";class k{static create(C=!0){return new k(C)}constructor(C){this.a=L&&C,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?I.globals.performance.now():Date.now()}}e.StopWatch=k}),define(te[3],ie([0,1,13,49,2,98,70]),function(V,e,I,L,k,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,h=!1;var m;(function(l){l.None=()=>k.Disposable.None;function s(W){if(h){const{onDidAddListener:B}=W,G=p.create();let N=0;W.onDidAddListener=()=>{++N===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),G.print()),B?.()}}}function d(W,B){return se(W,()=>{},0,void 0,void 0,B)}l.defer=d;function y(W){return(B,G=null,N)=>{let q=!1,Q;return Q=W(oe=>{if(!q)return Q?Q.dispose():q=!0,B.call(G,oe)},null,N),q&&Q.dispose(),Q}}l.once=y;function M(W,B,G){return re((N,q=null,Q)=>W(oe=>N.call(q,B(oe)),null,Q),G)}l.map=M;function O(W,B,G){return re((N,q=null,Q)=>W(oe=>{B(oe),N.call(q,oe)},null,Q),G)}l.forEach=O;function j(W,B,G){return re((N,q=null,Q)=>W(oe=>B(oe)&&N.call(q,oe),null,Q),G)}l.filter=j;function K(W){return W}l.signal=K;function x(...W){return(B,G=null,N)=>(0,k.combinedDisposable)(...W.map(q=>q(Q=>B.call(G,Q),null,N)))}l.any=x;function J(W,B,G,N){let q=G;return M(W,Q=>(q=B(q,Q),q),N)}l.reduce=J;function re(W,B){let G;const N={onWillAddFirstListener(){G=W(q.fire,q)},onDidRemoveLastListener(){G?.dispose()}};B||s(N);const q=new c(N);return B?.add(q),q.event}function se(W,B,G=100,N=!1,q,Q){let oe,ue,ye,ke=0;const Ae={leakWarningThreshold:q,onWillAddFirstListener(){oe=W(Fe=>{ke++,ue=B(ue,Fe),N&&!ye&&(Re.fire(ue),ue=void 0),clearTimeout(ye),ye=setTimeout(()=>{const we=ue;ue=void 0,ye=void 0,(!N||ke>1)&&Re.fire(we),ke=0},G)})},onDidRemoveLastListener(){oe.dispose()}};Q||s(Ae);const Re=new c(Ae);return Q?.add(Re),Re.event}l.debounce=se;function ae(W,B=0,G){return l.debounce(W,(N,q)=>N?(N.push(q),N):[q],B,void 0,void 0,G)}l.accumulate=ae;function fe(W,B=(N,q)=>N===q,G){let N=!0,q;return j(W,Q=>{const oe=N||!B(Q,q);return N=!1,q=Q,oe},G)}l.latch=fe;function ge(W,B,G){return[l.filter(W,B,G),l.filter(W,N=>!B(N),G)]}l.split=ge;function H(W,B=!1,G=[]){let N=G.slice(),q=W(ue=>{N?N.push(ue):oe.fire(ue)});const Q=()=>{N?.forEach(ue=>oe.fire(ue)),N=null},oe=new c({onWillAddFirstListener(){q||(q=W(ue=>oe.fire(ue)))},onDidAddFirstListener(){N&&(B?setTimeout(Q):Q())},onDidRemoveLastListener(){q&&q.dispose(),q=null}});return oe.event}l.buffer=H;class F{constructor(B){this.event=B,this.c=new k.DisposableStore}map(B){return new F(M(this.event,B,this.c))}forEach(B){return new F(O(this.event,B,this.c))}filter(B){return new F(j(this.event,B,this.c))}reduce(B,G){return new F(J(this.event,B,G,this.c))}latch(){return new F(fe(this.event,void 0,this.c))}debounce(B,G=100,N=!1,q){return new F(se(this.event,B,G,N,q,this.c))}on(B,G,N){return this.event(B,G,N)}once(B,G,N){return y(this.event)(B,G,N)}dispose(){this.c.dispose()}}function U(W){return new F(W)}l.chain=U;function z(W,B,G=N=>N){const N=(...ue)=>oe.fire(G(...ue)),q=()=>W.on(B,N),Q=()=>W.removeListener(B,N),oe=new c({onWillAddFirstListener:q,onDidRemoveLastListener:Q});return oe.event}l.fromNodeEventEmitter=z;function Y(W,B,G=N=>N){const N=(...ue)=>oe.fire(G(...ue)),q=()=>W.addEventListener(B,N),Q=()=>W.removeEventListener(B,N),oe=new c({onWillAddFirstListener:q,onDidRemoveLastListener:Q});return oe.event}l.fromDOMEventEmitter=Y;function ne(W){return new Promise(B=>y(W)(B))}l.toPromise=ne;function _(W,B){return B(void 0),W(G=>B(G))}l.runAndSubscribe=_;function $(W,B){let G=null;function N(Q){G?.dispose(),G=new k.DisposableStore,B(Q,G)}N(void 0);const q=W(Q=>N(Q));return(0,k.toDisposable)(()=>{q.dispose(),G?.dispose()})}l.runAndSubscribeWithStore=$;class A{constructor(B,G){this.obs=B,this.c=0,this.d=!1;const N={onWillAddFirstListener:()=>{B.addObserver(this)},onDidRemoveLastListener:()=>{B.removeObserver(this)}};G||s(N),this.emitter=new c(N),G&&G.add(this.emitter)}beginUpdate(B){this.c++}handleChange(B,G){this.d=!0}endUpdate(B){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function T(W,B){return new A(W,B).emitter.event}l.fromObservable=T})(m=e.Event||(e.Event={}));class S{constructor(s){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${s}_${S.c++}`,S.all.add(this)}start(s){this.d=new C.StopWatch(!0),this.listenerCount=s}stop(){if(this.d){const s=this.d.elapsed();this.durations.push(s),this.elapsedOverall+=s,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=S,S.all=new Set,S.c=0;let v=-1;function b(l){const s=v;return v=l,{dispose(){v=s}}}e.setGlobalLeakWarningThreshold=b;class f{constructor(s,d=Math.random().toString(18).slice(2,5)){this.threshold=s,this.name=d,this.d=0}dispose(){this.c?.clear()}check(s,d){const y=this.threshold;if(y<=0||d<y)return;this.c||(this.c=new Map);const M=this.c.get(s.value)||0;if(this.c.set(s.value,M+1),this.d-=1,this.d<=0){this.d=y*.5;let O,j=0;for(const[K,x]of this.c)(!O||j<x)&&(O=K,j=x);console.warn(`[${this.name}] potential listener LEAK detected, having ${d} listeners already. MOST frequent listener (${j}):`),console.warn(O)}return()=>{const O=this.c.get(s.value)||0;this.c.set(s.value,O-1)}}}class p{static create(){return new p(new Error().stack??"")}constructor(s){this.value=s}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class w{constructor(s,d,y){this.callback=s,this.callbackThis=d,this.stack=y,this.subscription=new k.SafeDisposable}invoke(s){this.callback.call(this.callbackThis,s)}}class c{constructor(s){this.j=!1,this.d=s,this.f=v>0||this.d?.leakWarningThreshold?new f(this.d?.leakWarningThreshold??v):void 0,this.g=this.d?._profName?new S(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const s=Array.from(this.q);queueMicrotask(()=>{for(const d of s)d.subscription.isset()&&(d.subscription.unset(),d.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(s,d,y)=>{if(this.q||(this.q=new o.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),k.Disposable.None;const M=this.q.isEmpty();M&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let O,j;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(j=p.create(),O=this.f.check(j,this.q.size+1)),P&&(j=j??p.create());const K=new w(s,d,j),x=this.q.push(K);M&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,s,d);const J=K.subscription.set(()=>{O?.(),this.j||(x(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return y instanceof k.DisposableStore?y.add(J):Array.isArray(y)&&y.push(J),J}),this.l}fire(s){if(this.q){this.m||(this.m=new g);for(const d of this.q)this.m.push(this,d,s);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=c;class u{constructor(){this.c=new o.LinkedList}get size(){return this.c.size}push(s,d,y){this.c.push(new D(s,d,y))}clear(s){const d=new o.LinkedList;for(const y of this.c)y.emitter!==s&&d.push(y);this.c=d}deliver(){for(;this.c.size>0;){const s=this.c.shift();try{s.listener.invoke(s.event)}catch(d){(0,I.onUnexpectedError)(d)}}}}e.EventDeliveryQueue=u;class g extends u{clear(s){this.c.clear()}}class D{constructor(s,d,y){this.emitter=s,this.listener=d,this.event=y}}class E extends c{async fireAsync(s,d,y){if(!!this.q){this.c||(this.c=new o.LinkedList);for(const M of this.q)this.c.push([M,s]);for(;this.c.size>0&&!d.isCancellationRequested;){const[M,O]=this.c.shift(),j=[],K={...O,token:d,waitUntil:x=>{if(Object.isFrozen(j))throw new Error("waitUntil can NOT be called asynchronous");y&&(x=y(x,M.callback)),j.push(x)}};try{M.invoke(K)}catch(x){(0,I.onUnexpectedError)(x);continue}Object.freeze(j),await Promise.allSettled(j).then(x=>{for(const J of x)J.status==="rejected"&&(0,I.onUnexpectedError)(J.reason)})}}}}e.AsyncEmitter=E;class R extends c{constructor(s){super(s),this.h=0,this.s=new o.LinkedList,this.t=s?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const s=Array.from(this.s);this.s.clear(),super.fire(this.t(s))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(s){this.q&&(this.h!==0?this.s.push(s):super.fire(s))}}e.PauseableEmitter=R;class t extends R{constructor(s){super(s),this.c=s.delay??100}fire(s){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(s)}}e.DebounceEmitter=t;class a extends c{constructor(s){super(s),this.c=[],this.h=s?.merge}fire(s){!this.hasListeners()||(this.c.push(s),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(d=>super.fire(d)),this.c=[]}))}}e.MicrotaskEmitter=a;class i{constructor(){this.d=!1,this.f=[],this.c=new c({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(s){const d={event:s,listener:null};this.f.push(d),this.d&&this.j(d);const y=()=>{this.d&&this.k(d);const M=this.f.indexOf(d);this.f.splice(M,1)};return(0,k.toDisposable)((0,L.once)(y))}g(){this.d=!0,this.f.forEach(s=>this.j(s))}h(){this.d=!1,this.f.forEach(s=>this.k(s))}j(s){s.listener=s.event(d=>this.c.fire(d))}k(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=i;class n{constructor(){this.c=[]}wrapEvent(s){return(d,y,M)=>s(O=>{const j=this.c[this.c.length-1];j?j.push(()=>d.call(y,O)):d.call(y,O)},void 0,M)}bufferEvents(s){const d=[];this.c.push(d);const y=s();return this.c.pop(),d.forEach(M=>M()),y}}e.EventBufferer=n;class r{constructor(){this.c=!1,this.d=m.None,this.f=k.Disposable.None,this.g=new c({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(s){this.d=s,this.c&&(this.f.dispose(),this.f=s(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=r}),define(te[22],ie([0,1,3]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(P,h){const m=setTimeout(P.bind(h),0);return{dispose(){clearTimeout(m)}}});var k;(function(P){function h(m){return m===P.None||m===P.Cancelled||m instanceof o?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}P.isCancellationToken=h,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(k=e.CancellationToken||(e.CancellationToken={}));class o{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new I.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(h){this.a=void 0,this.b=void 0,this.b=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new o),this.a}cancel(){this.a?this.a instanceof o&&this.a.cancel():this.a=k.Cancelled}dispose(h=!1){h&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof o&&this.a.dispose():this.a=k.None}}e.CancellationTokenSource=C}),define(te[142],ie([0,1,22]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class L{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new I.CancellationTokenSource,h=this.b(P.token);return this.a={promise:h,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=L;class k{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const h=JSON.stringify(P);return this.b!==h&&(this.b=h,this.a=this.c(P)),this.a}}e.LRUCachedFunction=k;class o{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const h=this.b(P);return this.a.set(P,h),h}}e.CachedFunction=o}),define(te[27],ie([0,1,142,126]),function(V,e,I,L){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function o(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=o;const C=/{(\d+)}/g;function P(X,...le){return le.length===0?X:X.replace(C,function(he,me){const be=parseInt(me,10);return isNaN(be)||be<0||be>=le.length?he:le[be]})}e.format=P;const h=/{([^}]+)}/g;function m(X,le){return X.replace(h,(he,me)=>le[me]??he)}e.format2=m;function S(X){return X.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=S;function v(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=v;function b(X,le){let he=0;const me=le.charCodeAt(0);for(let be=X.length-1;be>=0;be--)X.charCodeAt(be)===me&&he++;return he}e.count=b;function f(X,le,he="\u2026"){return X.length<=le?X:`${X.substr(0,le)}${he}`}e.truncate=f;function p(X,le=" "){const he=w(X,le);return c(he,le)}e.trim=p;function w(X,le){if(!X||!le)return X;const he=le.length;if(he===0||X.length===0)return X;let me=0;for(;X.indexOf(le,me)===me;)me=me+he;return X.substring(me)}e.ltrim=w;function c(X,le){if(!X||!le)return X;const he=le.length,me=X.length;if(he===0||me===0)return X;let be=me,Oe=-1;for(;Oe=X.lastIndexOf(le,be-1),!(Oe===-1||Oe+he!==be);){if(Oe===0)return"";be=Oe}return X.substring(0,be)}e.rtrim=c;function u(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function g(X){return X.replace(/\*/g,"")}e.stripWildcards=g;function D(X,le,he={}){if(!X)throw new Error("Cannot create regex from empty string");le||(X=v(X)),he.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let me="";return he.global&&(me+="g"),he.matchCase||(me+="i"),he.multiline&&(me+="m"),he.unicode&&(me+="u"),new RegExp(X,me)}e.createRegExp=D;function E(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=E;function R(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=R;function t(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=t;function a(X){return X.split(/\r\n|\r|\n/)}e.splitLines=a;function i(X){for(let le=0,he=X.length;le<he;le++){const me=X.charCodeAt(le);if(me!==32&&me!==9)return le}return-1}e.firstNonWhitespaceIndex=i;function n(X,le=0,he=X.length){for(let me=le;me<he;me++){const be=X.charCodeAt(me);if(be!==32&&be!==9)return X.substring(le,me)}return X.substring(le,he)}e.getLeadingWhitespace=n;function r(X,le=X.length-1){for(let he=le;he>=0;he--){const me=X.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.lastNonWhitespaceIndex=r;function l(X,le,he){const me=[];let be=0;for(const Oe of X.matchAll(le)){if(me.push(X.slice(be,Oe.index)),Oe.index===void 0)throw new Error("match.index should be defined");be=Oe.index+Oe[0].length,me.push(he(Oe[0],...Oe.slice(1),Oe.index,X,Oe.groups))}return me.push(X.slice(be)),Promise.all(me).then(Oe=>Oe.join(""))}e.replaceAsync=l;function s(X,le){return X<le?-1:X>le?1:0}e.compare=s;function d(X,le,he=0,me=X.length,be=0,Oe=le.length){for(;he<me&&be<Oe;he++,be++){const Ze=X.charCodeAt(he),Ge=le.charCodeAt(be);if(Ze<Ge)return-1;if(Ze>Ge)return 1}const qe=me-he,tt=Oe-be;return qe<tt?-1:qe>tt?1:0}e.compareSubstring=d;function y(X,le){return M(X,le,0,X.length,0,le.length)}e.compareIgnoreCase=y;function M(X,le,he=0,me=X.length,be=0,Oe=le.length){for(;he<me&&be<Oe;he++,be++){let Ze=X.charCodeAt(he),Ge=le.charCodeAt(be);if(Ze===Ge)continue;if(Ze>=128||Ge>=128)return d(X.toLowerCase(),le.toLowerCase(),he,me,be,Oe);j(Ze)&&(Ze-=32),j(Ge)&&(Ge-=32);const et=Ze-Ge;if(et!==0)return et}const qe=me-he,tt=Oe-be;return qe<tt?-1:qe>tt?1:0}e.compareSubstringIgnoreCase=M;function O(X){return X>=48&&X<=57}e.isAsciiDigit=O;function j(X){return X>=97&&X<=122}e.isLowerAsciiLetter=j;function K(X){return X>=65&&X<=90}e.isUpperAsciiLetter=K;function x(X,le){return X.length===le.length&&M(X,le)===0}e.equalsIgnoreCase=x;function J(X,le){const he=le.length;return le.length>X.length?!1:M(X,le,0,he)===0}e.startsWithIgnoreCase=J;function re(X,le){const he=Math.min(X.length,le.length);let me;for(me=0;me<he;me++)if(X.charCodeAt(me)!==le.charCodeAt(me))return me;return he}e.commonPrefixLength=re;function se(X,le){const he=Math.min(X.length,le.length);let me;const be=X.length-1,Oe=le.length-1;for(me=0;me<he;me++)if(X.charCodeAt(be-me)!==le.charCodeAt(Oe-me))return me;return he}e.commonSuffixLength=se;function ae(X){return 55296<=X&&X<=56319}e.isHighSurrogate=ae;function fe(X){return 56320<=X&&X<=57343}e.isLowSurrogate=fe;function ge(X,le){return(X-55296<<10)+(le-56320)+65536}e.computeCodePoint=ge;function H(X,le,he){const me=X.charCodeAt(he);if(ae(me)&&he+1<le){const be=X.charCodeAt(he+1);if(fe(be))return ge(me,be)}return me}e.getNextCodePoint=H;function F(X,le){const he=X.charCodeAt(le-1);if(fe(he)&&le>1){const me=X.charCodeAt(le-2);if(ae(me))return ge(me,he)}return he}class U{get offset(){return this.e}constructor(le,he=0){this.c=le,this.d=le.length,this.e=he}setOffset(le){this.e=le}prevCodePoint(){const le=F(this.c,this.e);return this.e-=le>=65536?2:1,le}nextCodePoint(){const le=H(this.c,this.d,this.e);return this.e+=le>=65536?2:1,le}eol(){return this.e>=this.d}}e.CodePointIterator=U;class z{get offset(){return this.c.offset}constructor(le,he=0){this.c=new U(le,he)}nextGraphemeLength(){const le=Le.getInstance(),he=this.c,me=he.offset;let be=le.getGraphemeBreakType(he.nextCodePoint());for(;!he.eol();){const Oe=he.offset,qe=le.getGraphemeBreakType(he.nextCodePoint());if(Ee(be,qe)){he.setOffset(Oe);break}be=qe}return he.offset-me}prevGraphemeLength(){const le=Le.getInstance(),he=this.c,me=he.offset;let be=le.getGraphemeBreakType(he.prevCodePoint());for(;he.offset>0;){const Oe=he.offset,qe=le.getGraphemeBreakType(he.prevCodePoint());if(Ee(qe,be)){he.setOffset(Oe);break}be=qe}return me-he.offset}eol(){return this.c.eol()}}e.GraphemeIterator=z;function Y(X,le){return new z(X,le).nextGraphemeLength()}e.nextCharLength=Y;function ne(X,le){return new z(X,le).prevGraphemeLength()}e.prevCharLength=ne;function _(X,le){le>0&&fe(X.charCodeAt(le))&&le--;const he=le+Y(X,le);return[he-ne(X,he),he]}e.getCharContainingOffset=_;function $(X){const le=new z(X);let he=0;for(;!le.eol();)he++,le.nextGraphemeLength();return he}e.charCount=$;let A;function T(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(X){return A||(A=T()),A.test(X)}e.containsRTL=W;const B=/^[\t\n\r\x20-\x7E]*$/;function G(X){return B.test(X)}e.isBasicASCII=G,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function N(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=N;function q(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=q;function Q(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=Q;function oe(X,le){if(X.length<le)return X;const he=/\b/g;let me=0;for(;he.test(X)&&!(X.length-he.lastIndex<le);)me=he.lastIndex,he.lastIndex+=1;return X.substring(me).replace(/^\s/,"")}e.lcut=oe;const ue=/\x1B\x5B[12]?K/g,ye=/\x1b\[\d+m/g,ke=/\x1b\[0?m/g;function Ae(X){return X&&(X=X.replace(ue,""),X=X.replace(ye,""),X=X.replace(ke,"")),X}e.removeAnsiEscapeCodes=Ae,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Re(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Re;function Fe(X){return Re(X)?X.substr(1):X}e.stripUTF8BOM=Fe;function we(X,le){if(!X||!le||X.length<le.length)return!1;const he=le.length,me=X.toLowerCase();let be=0,Oe=-1;for(;be<he;){const qe=me.indexOf(le[be],Oe+1);if(qe<0)return!1;Oe=qe,be++}return!0}e.fuzzyContains=we;function pe(X,le=!1){return X?(le&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=pe;function Se(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=Se;function Z(X,le=1){if(le===0)return"";let he=-1;do he=X.indexOf(`
`,he+1),le--;while(le>0&&he>=0);return he===-1?X:(X[he-1]==="\r"&&he--,X.substr(0,he))}e.getNLines=Z;function ce(X){return X=X%(2*26),X<26?String.fromCharCode(97+X):String.fromCharCode(65+X-26)}e.singleLetterHash=ce;function de(X){return Le.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=de;function Ee(X,le){return X===0?le!==5&&le!==7:X===2&&le===3?!1:X===4||X===2||X===3||le===4||le===2||le===3?!0:!(X===8&&(le===8||le===9||le===11||le===12)||(X===11||X===9)&&(le===9||le===10)||(X===12||X===10)&&le===10||le===5||le===13||le===7||X===1||X===13&&le===14||X===6&&le===6)}var Ce;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(Ce=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Le{static getInstance(){return Le.c||(Le.c=new Le),Le.c}constructor(){this.d=Te()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const he=this.d,me=he.length/3;let be=1;for(;be<=me;)if(le<he[3*be])be=2*be;else if(le>he[3*be+1])be=2*be+1;else return he[3*be+2];return 0}}Le.c=null;function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(X,le){if(X===0)return 0;const he=je(X,le);if(he!==void 0)return he;const me=new U(le,X);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=He;function je(X,le){const he=new U(le,X);let me=he.prevCodePoint();for(;ze(me)||me===65039||me===8419;){if(he.offset===0)return;me=he.prevCodePoint()}if(!Q(me))return;let be=he.offset;return be>0&&he.prevCodePoint()===8205&&(be=he.offset),be}function ze(X){return 127995<=X&&X<=127999}var xe;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(xe||(xe={})),e.noBreakWhitespace="\xA0";class Ne{static getInstance(le){return Ne.d.get(Array.from(le))}static getLocales(){return Ne.e.value}constructor(le){this.f=le}isAmbiguous(le){return this.f.has(le)}getPrimaryConfusable(le){return this.f.get(le)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=Ne,k=Ne,Ne.c=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ne.d=new I.LRUCachedFunction(X=>{function le(Ge){const et=new Map;for(let it=0;it<Ge.length;it+=2)et.set(Ge[it],Ge[it+1]);return et}function he(Ge,et){const it=new Map(Ge);for(const[st,dt]of et)it.set(st,dt);return it}function me(Ge,et){if(!Ge)return et;const it=new Map;for(const[st,dt]of Ge)et.has(st)&&it.set(st,dt);return it}const be=k.c.value;let Oe=X.filter(Ge=>!Ge.startsWith("_")&&Ge in be);Oe.length===0&&(Oe=["_default"]);let qe;for(const Ge of Oe){const et=le(be[Ge]);qe=me(qe,et)}const tt=le(be._common),Ze=he(tt,qe);return new Ne(Ze)}),Ne.e=new L.Lazy(()=>Object.keys(Ne.c.value).filter(X=>!X.startsWith("_")));class Ve{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ve.c())),this.d}static isInvisibleCharacter(le){return Ve.e().has(le)}static get codePoints(){return Ve.e()}}e.InvisibleCharacters=Ve,Ve.d=void 0}),define(te[32],ie([0,1,9,4,27,10]),function(V,e,I,L,k,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(r){return r===47||r===92}e.isPathSeparator=C;function P(r){return r.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=P;function h(r){return r.indexOf("/")===-1&&(r=P(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=h;function m(r,l=I.posix.sep){if(!r)return"";const s=r.length,d=r.charCodeAt(0);if(C(d)){if(C(r.charCodeAt(1))&&!C(r.charCodeAt(2))){let M=3;const O=M;for(;M<s&&!C(r.charCodeAt(M));M++);if(O!==M&&!C(r.charCodeAt(M+1))){for(M+=1;M<s;M++)if(C(r.charCodeAt(M)))return r.slice(0,M+1).replace(/[\\/]/g,l)}}return l}else if(u(d)&&r.charCodeAt(1)===58)return C(r.charCodeAt(2))?r.slice(0,2)+l:r.slice(0,2);let y=r.indexOf("://");if(y!==-1){for(y+=3;y<s;y++)if(C(r.charCodeAt(y)))return r.slice(0,y+1)}return""}e.getRoot=m;function S(r){if(!L.isWindows||!r||r.length<5)return!1;let l=r.charCodeAt(0);if(l!==92||(l=r.charCodeAt(1),l!==92))return!1;let s=2;const d=s;for(;s<r.length&&(l=r.charCodeAt(s),l!==92);s++);return!(d===s||(l=r.charCodeAt(s+1),isNaN(l)||l===92))}e.isUNC=S;const v=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(r,l=L.isWindows){const s=l?v:b;return!(!r||r.length===0||/^\s+$/.test(r)||(s.lastIndex=0,s.test(r))||l&&f.test(r)||r==="."||r===".."||l&&r[r.length-1]==="."||l&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=p;function w(r,l,s){const d=r===l;return!s||d?d:!r||!l?!1:(0,k.equalsIgnoreCase)(r,l)}e.isEqual=w;function c(r,l,s,d=I.sep){if(r===l)return!0;if(!r||!l||l.length>r.length)return!1;if(s){if(!(0,k.startsWithIgnoreCase)(r,l))return!1;if(l.length===r.length)return!0;let M=l.length;return l.charAt(l.length-1)===d&&M--,r.charAt(M)===d}return l.charAt(l.length-1)!==d&&(l+=d),r.indexOf(l)===0}e.isEqualOrParent=c;function u(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=u;function g(r,l){return L.isWindows&&r.endsWith(":")&&(r+=I.sep),(0,I.isAbsolute)(r)||(r=(0,I.join)(l,r)),r=(0,I.normalize)(r),L.isWindows?(r=(0,k.rtrim)(r,I.sep),r.endsWith(":")&&(r+=I.sep)):(r=(0,k.rtrim)(r,I.sep),r||(r=I.sep)),r}e.sanitizeFilePath=g;function D(r){const l=(0,I.normalize)(r);return L.isWindows?r.length>3?!1:E(l)&&(r.length===2||l.charCodeAt(2)===92):l===I.posix.sep}e.isRootOrDriveLetter=D;function E(r,l=L.isWindows){return l?u(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=E;function R(r){return E(r)?r[0]:void 0}e.getDriveLetter=R;function t(r,l,s){return l.length>r.length?-1:r===l?0:(s&&(r=r.toLowerCase(),l=l.toLowerCase()),r.indexOf(l))}e.indexOfPath=t;function a(r){const l=r.split(":");let s,d,y;for(const M of l){const O=Number(M);(0,o.isNumber)(O)?d===void 0?d=O:y===void 0&&(y=O):s=s?[s,M].join(":"):M}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:d!==void 0?d:void 0,column:y!==void 0?y:d!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(r,l,s=8){let d="";for(let M=0;M<s;M++)d+=i.charAt(Math.floor(Math.random()*i.length));let y;return l?y=`${l}-${d}`:y=d,r?(0,I.join)(r,y):y}e.randomPath=n}),define(te[71],ie([0,1,27]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(u){return k(u,0)}e.hash=L;function k(u,g){switch(typeof u){case"object":return u===null?o(349,g):Array.isArray(u)?h(u,g):m(u,g);case"string":return P(u,g);case"boolean":return C(u,g);case"number":return o(u,g);case"undefined":return o(937,g);default:return o(617,g)}}e.doHash=k;function o(u,g){return(g<<5)-g+u|0}e.numberHash=o;function C(u,g){return o(u?433:863,g)}function P(u,g){g=o(149417,g);for(let D=0,E=u.length;D<E;D++)g=o(u.charCodeAt(D),g);return g}e.stringHash=P;function h(u,g){return g=o(104579,g),u.reduce((D,E)=>k(E,D),g)}function m(u,g){return g=o(181387,g),Object.keys(u).sort().reduce((D,E)=>(D=P(E,D),k(u[E],D)),g)}class S{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=k(g,this.g),this.g}}e.Hasher=S;var v;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function b(u,g,D=32){const E=D-g,R=~((1<<E)-1);return(u<<g|(R&u)>>>E)>>>0}function f(u,g=0,D=u.byteLength,E=0){for(let R=0;R<D;R++)u[g+R]=E}function p(u,g,D="0"){for(;u.length<g;)u=D+u;return u}function w(u,g=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(D=>D.toString(16).padStart(2,"0")).join(""):p((u>>>0).toString(16),g/4)}e.toHexString=w;class c{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const D=g.length;if(D===0)return;const E=this.p;let R=this.r,t=this.u,a,i;for(t!==0?(a=t,i=-1,t=0):(a=g.charCodeAt(0),i=0);;){let n=a;if(I.isHighSurrogate(a))if(i+1<D){const r=g.charCodeAt(i+1);I.isLowSurrogate(r)?(i++,n=I.computeCodePoint(a,r)):n=65533}else{t=a;break}else I.isLowSurrogate(a)&&(n=65533);if(R=this.w(E,R,n),i++,i<D)a=g.charCodeAt(i);else break}this.r=R,this.u=t}w(g,D,E){return E<128?g[D++]=E:E<2048?(g[D++]=192|(E&1984)>>>6,g[D++]=128|(E&63)>>>0):E<65536?(g[D++]=224|(E&61440)>>>12,g[D++]=128|(E&4032)>>>6,g[D++]=128|(E&63)>>>0):(g[D++]=240|(E&1835008)>>>18,g[D++]=128|(E&258048)>>>12,g[D++]=128|(E&4032)>>>6,g[D++]=128|(E&63)>>>0),D>=64&&(this.y(),D-=64,this.t+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),D}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=c.g,D=this.q;for(let s=0;s<64;s+=4)g.setUint32(s,D.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)g.setUint32(s,b(g.getUint32(s-12,!1)^g.getUint32(s-32,!1)^g.getUint32(s-56,!1)^g.getUint32(s-64,!1),1),!1);let E=this.h,R=this.l,t=this.m,a=this.n,i=this.o,n,r,l;for(let s=0;s<80;s++)s<20?(n=R&t|~R&a,r=1518500249):s<40?(n=R^t^a,r=1859775393):s<60?(n=R&t|R&a|t&a,r=2400959708):(n=R^t^a,r=3395469782),l=b(E,5)+n+i+r+g.getUint32(s*4,!1)&4294967295,i=a,a=t,t=b(R,30),R=E,E=l;this.h=this.h+E&4294967295,this.l=this.l+R&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+i&4294967295}}e.StringSHA1=c,c.g=new DataView(new ArrayBuffer(320))}),define(te[83],ie([0,1,27]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(L||(L={})),function(k){const o="error",C="warning",P="warn",h="info",m="ignore";function S(b){return b?I.equalsIgnoreCase(o,b)?k.Error:I.equalsIgnoreCase(C,b)||I.equalsIgnoreCase(P,b)?k.Warning:I.equalsIgnoreCase(h,b)?k.Info:k.Ignore:k.Ignore}k.fromValue=S;function v(b){switch(b){case k.Error:return o;case k.Warning:return C;case k.Info:return h;default:return m}}k.toString=v}(L||(L={})),e.default=L}),define(te[60],ie([0,1,25,27]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class k{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const p=f.charCodeAt(0),w=this.b.charCodeAt(this.c);return p-w}value(){return this.b[this.c]}}e.StringIterator=k;class o{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,L.compareSubstring)(f,this.b,0,f.length,this.c,this.d):(0,L.compareSubstringIgnoreCase)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=o;class C{constructor(f=!0,p=!0){this.f=f,this.g=p}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let p=f.length-1;p>=0;p--,this.c--){const w=this.b.charCodeAt(p);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,L.compareSubstring)(f,this.b,0,f.length,this.d,this.e):(0,L.compareSubstringIgnoreCase)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=C;var P;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(P||(P={}));class h{constructor(f,p){this.f=f,this.g=p,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,L.compareIgnoreCase)(f,this.c.scheme);if(this.d[this.e]===2)return(0,L.compareIgnoreCase)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,L.compare)(f,this.c.query);if(this.d[this.e]===5)return(0,L.compare)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=h;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(S||(S={}));class v{static forUris(f=()=>!1,p=()=>!1){return new v(new h(f,p))}static forPaths(f=!1){return new v(new C(void 0,!f))}static forStrings(){return new v(new k)}static forConfigKeys(){return new v(new o)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,p){if(p){const w=p.slice(0);(0,I.shuffle)(w);for(const c of w)this.set(c,f)}else{const w=f.slice(0);(0,I.shuffle)(w);for(const c of w)this.set(c[0],c[1])}}set(f,p){const w=this.b.reset(f);let c;this.c||(this.c=new m,this.c.segment=w.value());const u=[];for(c=this.c;;){const D=w.cmp(c.segment);if(D>0)c.left||(c.left=new m,c.left.segment=w.value()),u.push([-1,c]),c=c.left;else if(D<0)c.right||(c.right=new m,c.right.segment=w.value()),u.push([1,c]),c=c.right;else if(w.hasNext())w.next(),c.mid||(c.mid=new m,c.mid.segment=w.value()),u.push([0,c]),c=c.mid;else break}const g=c.value;c.value=p,c.key=f;for(let D=u.length-1;D>=0;D--){const E=u[D][1];E.updateHeight();const R=E.balanceFactor();if(R<-1||R>1){const t=u[D][0],a=u[D+1][0];if(t===1&&a===1)u[D][1]=E.rotateLeft();else if(t===-1&&a===-1)u[D][1]=E.rotateRight();else if(t===1&&a===-1)E.right=u[D+1][1]=u[D+1][1].rotateRight(),u[D][1]=E.rotateLeft();else if(t===-1&&a===1)E.left=u[D+1][1]=u[D+1][1].rotateLeft(),u[D][1]=E.rotateRight();else throw new Error;if(D>0)switch(u[D-1][0]){case-1:u[D-1][1].left=u[D][1];break;case 1:u[D-1][1].right=u[D][1];break;case 0:u[D-1][1].mid=u[D][1];break}else this.c=u[0][1]}}return g}get(f){return this.d(f)?.value}d(f){const p=this.b.reset(f);let w=this.c;for(;w;){const c=p.cmp(w.segment);if(c>0)w=w.left;else if(c<0)w=w.right;else if(p.hasNext())p.next(),w=w.mid;else break}return w}has(f){const p=this.d(f);return!(p?.value===void 0&&p?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,p){const w=this.b.reset(f),c=[];let u=this.c;for(;u;){const g=w.cmp(u.segment);if(g>0)c.push([-1,u]),u=u.left;else if(g<0)c.push([1,u]),u=u.right;else if(w.hasNext())w.next(),c.push([0,u]),u=u.mid;else break}if(!!u){if(p?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const g=this.f(u.right);if(g.key){const{key:D,value:E,segment:R}=g;this.e(g.key,!1),u.key=D,u.value=E,u.segment=R}}else{const g=u.left??u.right;if(c.length>0){const[D,E]=c[c.length-1];switch(D){case-1:E.left=g;break;case 0:E.mid=g;break;case 1:E.right=g;break}}else this.c=g}for(let g=c.length-1;g>=0;g--){const D=c[g][1];D.updateHeight();const E=D.balanceFactor();if(E>1?(D.right.balanceFactor()>=0||(D.right=D.right.rotateRight()),c[g][1]=D.rotateLeft()):E<-1&&(D.left.balanceFactor()<=0||(D.left=D.left.rotateLeft()),c[g][1]=D.rotateRight()),g>0)switch(c[g-1][0]){case-1:c[g-1][1].left=c[g][1];break;case 1:c[g-1][1].right=c[g][1];break;case 0:c[g-1][1].mid=c[g][1];break}else this.c=c[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const p=this.b.reset(f);let w=this.c,c;for(;w;){const u=p.cmp(w.segment);if(u>0)w=w.left;else if(u<0)w=w.right;else if(p.hasNext())p.next(),c=w.value||c,w=w.mid;else break}return w&&w.value||c}findSuperstr(f){return this.g(f,!1)}g(f,p){const w=this.b.reset(f);let c=this.c;for(;c;){const u=w.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(w.hasNext())w.next(),c=c.mid;else return c.mid?this.h(c.mid):p?c.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[p,w]of this)f(w,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const p=[];return this.j(f,p),p[Symbol.iterator]()}j(f,p){!f||(f.left&&this.j(f.left,p),f.value&&p.push([f.key,f.value]),f.mid&&this.j(f.mid,p),f.right&&this.j(f.right,p))}_isBalanced(){const f=p=>{if(!p)return!0;const w=p.balanceFactor();return w<-1||w>1?!1:f(p.left)&&f(p.right)};return f(this.c)}}e.TernarySearchTree=v}),define(te[7],ie([0,1,9,4]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,o=/^\//,C=/^\/\//;function P(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!k.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!o.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(i,n){return!i&&!n?"file":i}function m(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==v&&(n=v+n):n=v;break}return n}const S="",v="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(n){return n instanceof f?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,r,l,s,d,y=!1){typeof n=="object"?(this.scheme=n.scheme||S,this.authority=n.authority||S,this.path=n.path||S,this.query=n.query||S,this.fragment=n.fragment||S):(this.scheme=h(n,y),this.authority=r||S,this.path=m(this.scheme,l||S),this.query=s||S,this.fragment=d||S,P(this,y))}get fsPath(){return D(this,!1)}with(n){if(!n)return this;let{scheme:r,authority:l,path:s,query:d,fragment:y}=n;return r===void 0?r=this.scheme:r===null&&(r=S),l===void 0?l=this.authority:l===null&&(l=S),s===void 0?s=this.path:s===null&&(s=S),d===void 0?d=this.query:d===null&&(d=S),y===void 0?y=this.fragment:y===null&&(y=S),r===this.scheme&&l===this.authority&&s===this.path&&d===this.query&&y===this.fragment?this:new w(r,l,s,d,y)}static parse(n,r=!1){const l=b.exec(n);return l?new w(l[2]||S,a(l[4]||S),a(l[5]||S),a(l[7]||S),a(l[9]||S),r):new w(S,S,S,S,S)}static file(n){let r=S;if(L.isWindows&&(n=n.replace(/\\/g,v)),n[0]===v&&n[1]===v){const l=n.indexOf(v,2);l===-1?(r=n.substring(2),n=v):(r=n.substring(2,l),n=n.substring(l)||v)}return new w("file",r,n,S,S)}static from(n){const r=new w(n.scheme,n.authority,n.path,n.query,n.fragment);return P(r,!0),r}static joinPath(n,...r){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return L.isWindows&&n.scheme==="file"?l=f.file(I.win32.join(D(n,!0),...r)).path:l=I.posix.join(n.path,...r),n.with({path:l})}toString(n=!1){return E(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof f)return n;{const r=new w(n);return r._formatted=n.external,r._fsPath=n._sep===p?n.fsPath:null,r}}else return n}}e.URI=f;const p=L.isWindows?1:void 0;class w extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=D(this,!1)),this._fsPath}toString(n=!1){return n?E(this,!0):(this._formatted||(this._formatted=E(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=p),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const c={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(i,n,r){let l,s=-1;for(let d=0;d<i.length;d++){const y=i.charCodeAt(d);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||n&&y===47||r&&y===91||r&&y===93||r&&y===58)s!==-1&&(l+=encodeURIComponent(i.substring(s,d)),s=-1),l!==void 0&&(l+=i.charAt(d));else{l===void 0&&(l=i.substr(0,d));const M=c[y];M!==void 0?(s!==-1&&(l+=encodeURIComponent(i.substring(s,d)),s=-1),l+=M):s===-1&&(s=d)}}return s!==-1&&(l+=encodeURIComponent(i.substring(s))),l!==void 0?l:i}function g(i){let n;for(let r=0;r<i.length;r++){const l=i.charCodeAt(r);l===35||l===63?(n===void 0&&(n=i.substr(0,r)),n+=c[l]):n!==void 0&&(n+=i[r])}return n!==void 0?n:i}function D(i,n){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,L.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=D;function E(i,n){const r=n?g:u;let l="",{scheme:s,authority:d,path:y,query:M,fragment:O}=i;if(s&&(l+=s,l+=":"),(d||s==="file")&&(l+=v,l+=v),d){let j=d.indexOf("@");if(j!==-1){const K=d.substr(0,j);d=d.substr(j+1),j=K.lastIndexOf(":"),j===-1?l+=r(K,!1,!1):(l+=r(K.substr(0,j),!1,!1),l+=":",l+=r(K.substr(j+1),!1,!0)),l+="@"}d=d.toLowerCase(),j=d.lastIndexOf(":"),j===-1?l+=r(d,!1,!0):(l+=r(d.substr(0,j),!1,!0),l+=d.substr(j))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const j=y.charCodeAt(1);j>=65&&j<=90&&(y=`/${String.fromCharCode(j+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const j=y.charCodeAt(0);j>=65&&j<=90&&(y=`${String.fromCharCode(j+32)}:${y.substr(2)}`)}l+=r(y,!0,!1)}return M&&(l+="?",l+=r(M,!1,!1)),O&&(l+="#",l+=n?O:u(O,!1,!1)),l}function R(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+R(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(i){return i.match(t)?i.replace(t,n=>R(n)):i}}),define(te[143],ie([0,1,7]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(m){const S=m;return S&&typeof S.type=="string"&&typeof S.severity=="string"}e.isRemoteConsoleLog=L;function k(m){const S=[];let v;try{const b=JSON.parse(m.arguments),f=b[b.length-1];f&&f.__$stack&&(b.pop(),v=f.__$stack),S.push(...b)}catch{S.push("Unable to log remote console arguments",m.arguments)}return{args:S,stack:v}}e.parse=k;function o(m){if(typeof m!="string")return o(k(m).stack);const S=m;if(S){const v=C(S),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(b&&b.length===4)return{uri:I.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=o;function C(m){if(!m)return m;const S=m.indexOf(`
`);return S===-1?m:m.substring(0,S)}function P(m,S){const{args:v,stack:b}=k(m),f=typeof v[0]=="string"&&v.length===1;let p=C(b);p&&(p=`(${p.trim()})`);let w=[];if(typeof v[0]=="string"?p&&f?w=[`%c[${S}] %c${v[0]} %c${p}`,h("blue"),h(""),h("grey")]:w=[`%c[${S}] %c${v[0]}`,h("blue"),h(""),...v.slice(1)]:w=[`%c[${S}]%`,h("blue"),...v],p&&!f&&w.push(p),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,w)}e.log=P;function h(m){return`color: ${m}`}}),define(te[72],ie([0,1,17,27,7]),function(V,e,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function o(m){return JSON.stringify(m,P)}e.stringify=o;function C(m){let S=JSON.parse(m);return S=h(S),S}e.parse=C;function P(m,S){return S instanceof RegExp?{$mid:2,source:S.source,flags:(0,L.regExpFlags)(S)}:S}function h(m,S=0){if(!m||S>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return k.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 16:return new Date(m.source)}if(m instanceof I.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let v=0;v<m.length;++v)m[v]=h(m[v],S+1);else for(const v in m)Object.hasOwnProperty.call(m,v)&&(m[v]=h(m[v],S+1))}return m}e.revive=h}),define(te[15],ie([0,1,13,4,7]),function(V,e,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var o;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebook="vscode-notebook",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractive="vscode-interactive",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(o=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${o.vscodeRemoteResource}`}setPreferredWebSchema(S){this.d=S}setDelegate(S){this.e=S}setServerRootPath(S){this.f=`${S}/${o.vscodeRemoteResource}`}set(S,v,b){this.a[S]=v,this.b[S]=b}setConnectionToken(S,v){this.c[S]=v}getPreferredWebSchema(){return this.d}rewrite(S){if(this.e)try{return this.e(S)}catch(c){return I.onUnexpectedError(c),S}const v=S.authority;let b=this.a[v];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const f=this.b[v],p=this.c[v];let w=`path=${encodeURIComponent(S.path)}`;return typeof p=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),k.URI.from({scheme:L.isWeb?this.d:o.vscodeRemoteResource,authority:`${b}:${f}`,path:this.f,query:w})}}e.RemoteAuthorities=new C,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(S){const v=this.b(S,V);return this.uriToBrowserUri(v)}uriToBrowserUri(S){return S.scheme===o.vscodeRemote?e.RemoteAuthorities.rewrite(S):S.scheme===o.file&&(L.isNative||L.isWebWorker&&L.globals.origin===`${o.vscodeFileResource}://${P.a}`)?S.with({scheme:o.vscodeFileResource,authority:S.authority||P.a,query:null,fragment:null}):S}asFileUri(S){const v=this.b(S,V);return this.uriToFileUri(v)}uriToFileUri(S){return S.scheme===o.vscodeFileResource?S.with({scheme:o.file,authority:S.authority!==P.a?S.authority:null,query:null,fragment:null}):S}b(S,v){return k.URI.isUri(S)?S:k.URI.parse(v.toUrl(S))}}P.a="vscode-app",e.FileAccess=new P;var h;(function(m){const S=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(S.get("3"));const v="vscode-coi";function b(p){let w;typeof p=="string"?w=new URL(p).searchParams:p instanceof URL?w=p.searchParams:k.URI.isUri(p)&&(w=new URL(p.toString(!0)).searchParams);const c=w?.get(v);if(!!c)return S.get(c)}m.getHeadersFromQuery=b;function f(p,w,c){if(!globalThis.crossOriginIsolated)return;const u=w&&c?"3":c?"2":"1";p instanceof URLSearchParams?p.set(v,u):p[v]=u}m.addSearchParam=f})(h=e.COI||(e.COI={}))}),define(te[20],ie([0,1,32,15,9,4,27,7]),function(V,e,I,L,k,o,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function h(f){return(0,P.uriToFsPath)(f,!0)}e.originalFSPath=h;class m{constructor(p){this.a=p}compare(p,w,c=!1){return p===w?0:(0,C.compare)(this.getComparisonKey(p,c),this.getComparisonKey(w,c))}isEqual(p,w,c=!1){return p===w?!0:!p||!w?!1:this.getComparisonKey(p,c)===this.getComparisonKey(w,c)}getComparisonKey(p,w=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,w,c=!1){if(p.scheme===w.scheme){if(p.scheme===L.Schemas.file)return I.isEqualOrParent(h(p),h(w),this.a(p))&&p.query===w.query&&(c||p.fragment===w.fragment);if((0,e.isEqualAuthority)(p.authority,w.authority))return I.isEqualOrParent(p.path,w.path,this.a(p),"/")&&p.query===w.query&&(c||p.fragment===w.fragment)}return!1}joinPath(p,...w){return P.URI.joinPath(p,...w)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return k.posix.basename(p.path)}extname(p){return k.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let w;return p.scheme===L.Schemas.file?w=P.URI.file(k.dirname(h(p))).path:(w=k.posix.dirname(p.path),p.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),w="/")),p.with({path:w})}normalizePath(p){if(!p.path.length)return p;let w;return p.scheme===L.Schemas.file?w=P.URI.file(k.normalize(h(p))).path:w=k.posix.normalize(p.path),p.with({path:w})}relativePath(p,w){if(p.scheme!==w.scheme||!(0,e.isEqualAuthority)(p.authority,w.authority))return;if(p.scheme===L.Schemas.file){const g=k.relative(h(p),h(w));return o.isWindows?I.toSlashes(g):g}let c=p.path||"/";const u=w.path||"/";if(this.a(p)){let g=0;for(const D=Math.min(c.length,u.length);g<D&&!(c.charCodeAt(g)!==u.charCodeAt(g)&&c.charAt(g).toLowerCase()!==u.charAt(g).toLowerCase());g++);c=u.substr(0,g)+c.substr(g)}return k.posix.relative(c,u)}resolvePath(p,w){if(p.scheme===L.Schemas.file){const c=P.URI.file(k.resolve(h(p),w));return p.with({authority:c.authority,path:c.path})}return w=I.toPosixPath(w),p.with({path:k.posix.resolve(p.path,w)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,w){return p===w||p!==void 0&&w!==void 0&&(0,C.equalsIgnoreCase)(p,w)}hasTrailingPathSeparator(p,w=k.sep){if(p.scheme===L.Schemas.file){const c=h(p);return c.length>I.getRoot(c).length&&c[c.length-1]===w}else{const c=p.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,w=k.sep){return(0,e.hasTrailingPathSeparator)(p,w)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,w=k.sep){let c=!1;if(p.scheme===L.Schemas.file){const u=h(p);c=u!==void 0&&u.length===I.getRoot(u).length&&u[u.length-1]===w}else{w="/";const u=p.path;c=u.length===1&&u.charCodeAt(u.length-1)===47}return!c&&!(0,e.hasTrailingPathSeparator)(p,w)?p.with({path:p.path+"/"}):p}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(f=>f.scheme===L.Schemas.file?!o.isLinux:!0),e.extUriIgnorePathCase=new m(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function S(f,p){const w=[];for(let c=0;c<f.length;c++){const u=p(f[c]);f.some((g,D)=>D===c?!1:(0,e.isEqualOrParent)(u,p(g)))||w.push(f[c])}return w}e.distinctParents=S;var v;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function p(w){const c=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(D=>{const[E,R]=D.split(":");E&&R&&c.set(E,R)});const g=w.path.substring(0,w.path.indexOf(";"));return g&&c.set(f.META_DATA_MIME,g),c}f.parseMetaData=p})(v=e.DataUri||(e.DataUri={}));function b(f,p,w){if(p){let c=f.path;return c&&c[0]!==k.posix.sep&&(c=k.posix.sep+c),f.with({scheme:w,authority:p,path:c})}return f.with({scheme:w})}e.toLocalResource=b}),define(te[8],ie([0,1,22,13,3,2,20,4]),function(V,e,I,L,k,o,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function h(_){return!!_&&typeof _.then=="function"}e.isThenable=h;function m(_){const $=new I.CancellationTokenSource,A=_($.token),T=new Promise((W,B)=>{const G=$.token.onCancellationRequested(()=>{G.dispose(),$.dispose(),B(new L.CancellationError)});Promise.resolve(A).then(N=>{G.dispose(),$.dispose(),W(N)},N=>{G.dispose(),$.dispose(),B(N)})});return new class{cancel(){$.cancel()}then(W,B){return T.then(W,B)}catch(W){return this.then(void 0,W)}finally(W){return T.finally(W)}}}e.createCancelablePromise=m;function S(_,$,A){return new Promise((T,W)=>{const B=$.onCancellationRequested(()=>{B.dispose(),T(A)});_.then(T,W).finally(()=>B.dispose())})}e.raceCancellation=S;function v(_,$){return new Promise((A,T)=>{const W=$.onCancellationRequested(()=>{W.dispose(),T(new L.CancellationError)});_.then(A,T).finally(()=>W.dispose())})}e.raceCancellationError=v;async function b(_){let $=-1;const A=_.map((W,B)=>W.then(G=>($=B,G))),T=await Promise.race(A);return _.forEach((W,B)=>{B!==$&&W.cancel()}),T}e.raceCancellablePromises=b;function f(_,$,A){let T;const W=setTimeout(()=>{T?.(void 0),A?.()},$);return Promise.race([_.finally(()=>clearTimeout(W)),new Promise(B=>T=B)])}e.raceTimeout=f;function p(_){return new Promise(($,A)=>{const T=_();h(T)?T.then($,A):$(T)})}e.asPromise=p;class w{constructor(){this.a=null,this.b=null,this.d=null}queue($){if(this.a){if(this.d=$,!this.b){const A=()=>{this.b=null;const T=this.queue(this.d);return this.d=null,T};this.b=new Promise(T=>{this.a.then(A,A).then(T)})}return new Promise((A,T)=>{this.b.then(A,T)})}return this.a=$(),new Promise((A,T)=>{this.a.then(W=>{this.a=null,A(W)},W=>{this.a=null,T(W)})})}}e.Throttler=w;class c{constructor(){this.a=Promise.resolve(null)}queue($){return this.a=this.a.then(()=>$(),()=>$())}}e.Sequencer=c;class u{constructor(){this.a=new Map}queue($,A){const W=(this.a.get($)??Promise.resolve()).catch(()=>{}).then(A).finally(()=>{this.a.get($)===W&&this.a.delete($)});return this.a.set($,W),W}}e.SequencerByKey=u;const g=(_,$)=>{let A=!0;const T=setTimeout(()=>{A=!1,$()},_);return{isTriggered:()=>A,dispose:()=>{clearTimeout(T),A=!1}}},D=_=>{let $=!0;return queueMicrotask(()=>{$&&($=!1,_())}),{isTriggered:()=>$,dispose:()=>{$=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class E{constructor($){this.defaultDelay=$,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger($,A=this.defaultDelay){this.g=$,this.h(),this.b||(this.b=new Promise((W,B)=>{this.d=W,this.f=B}).then(()=>{if(this.b=null,this.d=null,this.g){const W=this.g;return this.g=null,W()}}));const T=()=>{this.a=null,this.d?.(null)};return this.a=A===e.MicrotaskDelay?D(T):g(A,T),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=E;class R{constructor($){this.a=new E($),this.b=new w}trigger($,A){return this.a.trigger(()=>this.b.queue($),A)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=R;class t{constructor(){this.a=!1,this.b=new Promise(($,A)=>{this.d=$})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=t;class a extends t{constructor($){super(),this.f=setTimeout(()=>this.open(),$)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=a;function i(_,$){return $?new Promise((A,T)=>{const W=setTimeout(()=>{B.dispose(),A()},_),B=$.onCancellationRequested(()=>{clearTimeout(W),B.dispose(),T(new L.CancellationError)})}):m(A=>i(_,A))}e.timeout=i;function n(_,$=0){const A=setTimeout(_,$);return(0,o.toDisposable)(()=>clearTimeout(A))}e.disposableTimeout=n;function r(_){const $=[];let A=0;const T=_.length;function W(){return A<T?_[A++]():null}function B(G){G!=null&&$.push(G);const N=W();return N?N.then(B):Promise.resolve($)}return Promise.resolve(null).then(B)}e.sequence=r;function l(_,$=T=>!!T,A=null){let T=0;const W=_.length,B=()=>{if(T>=W)return Promise.resolve(A);const G=_[T++];return Promise.resolve(G()).then(q=>$(q)?Promise.resolve(q):B())};return B()}e.first=l;function s(_,$=T=>!!T,A=null){if(_.length===0)return Promise.resolve(A);let T=_.length;const W=()=>{T=-1;for(const B of _)B.cancel?.()};return new Promise((B,G)=>{for(const N of _)N.then(q=>{--T>=0&&$(q)?(W(),B(q)):T===0&&B(A)}).catch(q=>{--T>=0&&(W(),G(q))})})}e.firstParallel=s;class d{constructor($){this.a=0,this.d=$,this.f=[],this.b=0,this.g=new k.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue($){return this.a++,new Promise((A,T)=>{this.f.push({factory:$,c:A,e:T}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const $=this.f.shift();this.b++;const A=$.factory();A.then($.c,$.e),A.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=d;class y extends d{constructor(){super(1)}}e.Queue=y;class M{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const $=new H;return this.b.add($),$.p}d(){for(const[,$]of this.a)if($.size>0)return!1;return!0}queueFor($,A=C.extUri){const T=A.getComparisonKey($);let W=this.a.get(T);return W||(W=new y,k.Event.once(W.onDrained)(()=>{W?.dispose(),this.a.delete(T),this.f()}),this.a.set(T,W)),W}f(){!this.d()||this.g()}g(){for(const $ of this.b)$.complete();this.b.clear()}dispose(){for(const[,$]of this.a)$.dispose();this.a.clear(),this.g()}}e.ResourceQueue=M;class O{constructor($,A){this.a=-1,typeof $=="function"&&typeof A=="number"&&this.setIfNotSet($,A)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet($,A){this.cancel(),this.a=setTimeout(()=>{this.a=-1,$()},A)}setIfNotSet($,A){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,$()},A))}}e.TimeoutTimer=O;class j{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet($,A){this.cancel(),this.a=setInterval(()=>{$()},A)}}e.IntervalTimer=j;class K{constructor($,A){this.b=-1,this.a=$,this.d=A,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule($=this.d){this.cancel(),this.b=setTimeout(this.f,$)}get delay(){return this.d}set delay($){this.d=$}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=K;class x{constructor($,A){A%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.a=$,this.b=A,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule($=this.b){$%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil($/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=x;class J extends K{constructor($,A){super($,A),this.j=[]}work($){this.j.push($),this.isScheduled()||this.schedule()}h(){const $=this.j;this.j=[],this.a?.($)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=J;class re extends o.Disposable{constructor($,A){super(),this.g=$,this.h=A,this.a=[],this.b=this.B(new o.MutableDisposable),this.f=!1}get pending(){return this.a.length}work($){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+$.length>this.g.maxBufferedWork)return!1}else if(this.pending+$.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const A of $)this.a.push(A);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=re,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=_=>{(0,P.setTimeout0)(()=>{if($)return;const A=Date.now()+15;_(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,A-Date.now())}}))});let $=!1;return{dispose(){$||($=!0)}}}:e.runWhenIdle=(_,$)=>{const A=requestIdleCallback(_,typeof $=="number"?{timeout:$}:void 0);let T=!1;return{dispose(){T||(T=!0,cancelIdleCallback(A))}}}}();class se{constructor($){this.d=!1,this.a=()=>{try{this.f=$()}catch(A){this.g=A}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=se;async function ae(_,$,A){let T;for(let W=0;W<A;W++)try{return await _()}catch(B){T=B,await i($)}throw T}e.retry=ae;class fe{hasPending($){return this.a?typeof $=="number"?this.a.taskId===$:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending($,A,T){return this.a={taskId:$,cancel:()=>T?.(),promise:A},A.then(()=>this.d($),()=>this.d($)),A}d($){this.a&&$===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const $=this.b;this.b=void 0,$.run().then($.promiseResolve,$.promiseReject)}}setNext($){if(this.b)this.b.run=$;else{let A,T;const W=new Promise((B,G)=>{A=B,T=G});this.b={run:$,promise:W,promiseResolve:A,promiseReject:T}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=fe;class ge{constructor($,A=()=>Date.now()){this.d=$,this.f=A,this.a=0,this.b=0}increment(){const $=this.f();return $-this.a>this.d&&(this.a=$,this.b=0),this.b++,this.b}}e.IntervalCounter=ge;class H{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise(($,A)=>{this.a=$,this.b=A})}complete($){return new Promise(A=>{this.a($),this.f=!0,A()})}error($){return new Promise(A=>{this.b($),this.d=!0,A()})}cancel(){new Promise($=>{this.b(new L.CancellationError),this.d=!0,$()})}}e.DeferredPromise=H;var F;(function(_){async function $(T){let W;const B=await Promise.all(T.map(G=>G.then(N=>N,N=>{W||(W=N)})));if(typeof W<"u")throw W;return B}_.settled=$;function A(T){return new Promise(async(W,B)=>{try{await T(W,B)}catch(G){B(G)}})}_.withAsyncBody=A})(F=e.Promises||(e.Promises={}));var U;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(U||(U={}));class z{static fromArray($){return new z(A=>{A.emitMany($)})}static fromPromise($){return new z(async A=>{A.emitMany(await $)})}static fromPromises($){return new z(async A=>{await Promise.all($.map(async T=>A.emitOne(await T)))})}static merge($){return new z(async A=>{await Promise.all($.map(async T=>{for await(const W of T)A.emitOne(W)}))})}constructor($){this.a=0,this.b=[],this.d=null,this.f=new k.Emitter,queueMicrotask(async()=>{const A={emitOne:T=>this.g(T),emitMany:T=>this.h(T),reject:T=>this.k(T)};try{await Promise.resolve($(A)),this.j()}catch(T){this.k(T)}finally{A.emitOne=void 0,A.emitMany=void 0,A.reject=void 0}})}[Symbol.asyncIterator](){let $=0;return{next:async()=>{do{if(this.a===2)throw this.d;if($<this.b.length)return{done:!1,value:this.b[$++]};if(this.a===1)return{done:!0,value:void 0};await k.Event.toPromise(this.f.event)}while(!0)}}}static map($,A){return new z(async T=>{for await(const W of $)T.emitOne(A(W))})}map($){return z.map(this,$)}static filter($,A){return new z(async T=>{for await(const W of $)A(W)&&T.emitOne(W)})}filter($){return z.filter(this,$)}static coalesce($){return z.filter($,A=>!!A)}coalesce(){return z.coalesce(this)}static async toPromise($){const A=[];for await(const T of $)A.push(T);return A}toPromise(){return z.toPromise(this)}g($){this.a===0&&(this.b.push($),this.f.fire())}h($){this.a===0&&(this.b=this.b.concat($),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k($){this.a===0&&(this.a=2,this.d=$,this.f.fire())}}e.AsyncIterableObject=z,z.EMPTY=z.fromArray([]);class Y extends z{constructor($,A){super(A),this.l=$}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=Y;function ne(_){const $=new I.CancellationTokenSource,A=_($.token);return new Y($,async T=>{const W=$.token.onCancellationRequested(()=>{W.dispose(),$.dispose(),T.reject(new L.CancellationError)});try{for await(const B of A){if($.token.isCancellationRequested)return;T.emitOne(B)}W.dispose(),$.dispose()}catch(B){W.dispose(),$.dispose(),T.reject(B)}})}e.createCancelableAsyncIterable=ne}),define(te[101],ie([0,1,25,8,32,38,9,4,27]),function(V,e,I,L,k,o,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const S="[/\\\\]",v="[^/\\\\]",b=/\//g;function f(H,F){switch(H){case 0:return"";case 1:return`${v}*?`;default:return`(?:${S}|${v}+${S}${F?`|${S}${v}+`:""})*?`}}function p(H,F){if(!H)return[];const U=[];let z=!1,Y=!1,ne="";for(const _ of H){switch(_){case F:if(!z&&!Y){U.push(ne),ne="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":Y=!0;break;case"]":Y=!1;break}ne+=_}return ne&&U.push(ne),U}e.splitGlobAware=p;function w(H){if(!H)return"";let F="";const U=p(H,e.GLOB_SPLIT);if(U.every(z=>z===e.GLOBSTAR))F=".*";else{let z=!1;U.forEach((Y,ne)=>{if(Y===e.GLOBSTAR){if(z)return;F+=f(2,ne===U.length-1)}else{let _=!1,$="",A=!1,T="";for(const W of Y){if(W!=="}"&&_){$+=W;continue}if(A&&(W!=="]"||!T)){let B;W==="-"?B=W:(W==="^"||W==="!")&&!T?B="^":W===e.GLOB_SPLIT?B="":B=(0,h.escapeRegExpCharacters)(W),T+=B;continue}switch(W){case"{":_=!0;continue;case"[":A=!0;continue;case"}":{F+=`(?:${p($,",").map(N=>w(N)).join("|")})`,_=!1,$="";break}case"]":{F+="["+T+"]",A=!1,T="";break}case"?":F+=v;continue;case"*":F+=f(1);continue;default:F+=(0,h.escapeRegExpCharacters)(W)}}ne<U.length-1&&(U[ne+1]!==e.GLOBSTAR||ne+2<U.length)&&(F+=S)}z=Y===e.GLOBSTAR})}return F}const c=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,D=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,R=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new o.LRUCache(1e4),a=function(){return!1},i=function(){return null};function n(H,F){if(!H)return i;let U;typeof H!="string"?U=H.pattern:U=H,U=U.trim();const z=`${U}_${!!F.trimForExclusions}`;let Y=t.get(z);if(Y)return r(Y,H);let ne;return c.test(U)?Y=s(U.substr(4),U):(ne=u.exec(l(U,F)))?Y=d(ne[1],U):(F.trimForExclusions?D:g).test(U)?Y=y(U,F):(ne=E.exec(l(U,F)))?Y=M(ne[1].substr(1),U,!0):(ne=R.exec(l(U,F)))?Y=M(ne[1],U,!1):Y=O(U),t.set(z,Y),r(Y,H)}function r(H,F){if(typeof F=="string")return H;const U=function(z,Y){return(0,k.isEqualOrParent)(z,F.base,!P.isLinux)?H((0,h.ltrim)(z.substr(F.base.length),C.sep),Y):null};return U.allBasenames=H.allBasenames,U.allPaths=H.allPaths,U.basenames=H.basenames,U.patterns=H.patterns,U}function l(H,F){return F.trimForExclusions&&H.endsWith("/**")?H.substr(0,H.length-2):H}function s(H,F){return function(U,z){return typeof U=="string"&&U.endsWith(H)?F:null}}function d(H,F){const U=`/${H}`,z=`\\${H}`,Y=function(_,$){return typeof _!="string"?null:$?$===H?F:null:_===H||_.endsWith(U)||_.endsWith(z)?F:null},ne=[H];return Y.basenames=ne,Y.patterns=[F],Y.allBasenames=ne,Y}function y(H,F){const U=fe(H.slice(1,-1).split(",").map($=>n($,F)).filter($=>$!==i),H),z=U.length;if(!z)return i;if(z===1)return U[0];const Y=function($,A){for(let T=0,W=U.length;T<W;T++)if(U[T]($,A))return H;return null},ne=U.find($=>!!$.allBasenames);ne&&(Y.allBasenames=ne.allBasenames);const _=U.reduce(($,A)=>A.allPaths?$.concat(A.allPaths):$,[]);return _.length&&(Y.allPaths=_),Y}function M(H,F,U){const z=C.sep===C.posix.sep,Y=z?H:H.replace(b,C.sep),ne=C.sep+Y,_=C.posix.sep+H;let $;return U?$=function(A,T){return typeof A=="string"&&(A===Y||A.endsWith(ne)||!z&&(A===H||A.endsWith(_)))?F:null}:$=function(A,T){return typeof A=="string"&&(A===Y||!z&&A===H)?F:null},$.allPaths=[(U?"*/":"./")+H],$}function O(H){try{const F=new RegExp(`^${w(H)}$`);return function(U){return F.lastIndex=0,typeof U=="string"&&F.test(U)?H:null}}catch{return i}}function j(H,F,U){return!H||typeof F!="string"?!1:K(H)(F,void 0,U)}e.match=j;function K(H,F={}){if(!H)return a;if(typeof H=="string"||x(H)){const U=n(H,F);if(U===i)return a;const z=function(Y,ne){return!!U(Y,ne)};return U.allBasenames&&(z.allBasenames=U.allBasenames),U.allPaths&&(z.allPaths=U.allPaths),z}return se(H,F)}e.parse=K;function x(H){const F=H;return F?typeof F.base=="string"&&typeof F.pattern=="string":!1}e.isRelativePattern=x;function J(H){return H.allBasenames||[]}e.getBasenameTerms=J;function re(H){return H.allPaths||[]}e.getPathTerms=re;function se(H,F){const U=fe(Object.getOwnPropertyNames(H).map($=>ae($,H[$],F)).filter($=>$!==i)),z=U.length;if(!z)return i;if(!U.some($=>!!$.requiresSiblings)){if(z===1)return U[0];const $=function(W,B){let G;for(let N=0,q=U.length;N<q;N++){const Q=U[N](W,B);if(typeof Q=="string")return Q;(0,L.isThenable)(Q)&&(G||(G=[]),G.push(Q))}return G?(async()=>{for(const N of G){const q=await N;if(typeof q=="string")return q}return null})():null},A=U.find(W=>!!W.allBasenames);A&&($.allBasenames=A.allBasenames);const T=U.reduce((W,B)=>B.allPaths?W.concat(B.allPaths):W,[]);return T.length&&($.allPaths=T),$}const Y=function($,A,T){let W,B;for(let G=0,N=U.length;G<N;G++){const q=U[G];q.requiresSiblings&&T&&(A||(A=(0,C.basename)($)),W||(W=A.substr(0,A.length-(0,C.extname)($).length)));const Q=q($,A,W,T);if(typeof Q=="string")return Q;(0,L.isThenable)(Q)&&(B||(B=[]),B.push(Q))}return B?(async()=>{for(const G of B){const N=await G;if(typeof N=="string")return N}return null})():null},ne=U.find($=>!!$.allBasenames);ne&&(Y.allBasenames=ne.allBasenames);const _=U.reduce(($,A)=>A.allPaths?$.concat(A.allPaths):$,[]);return _.length&&(Y.allPaths=_),Y}function ae(H,F,U){if(F===!1)return i;const z=n(H,U);if(z===i)return i;if(typeof F=="boolean")return z;if(F){const Y=F.when;if(typeof Y=="string"){const ne=(_,$,A,T)=>{if(!T||!z(_,$))return null;const W=Y.replace("$(basename)",()=>A),B=T(W);return(0,L.isThenable)(B)?B.then(G=>G?H:null):B?H:null};return ne.requiresSiblings=!0,ne}}return z}function fe(H,F){const U=H.filter($=>!!$.basenames);if(U.length<2)return H;const z=U.reduce(($,A)=>{const T=A.basenames;return T?$.concat(T):$},[]);let Y;if(F){Y=[];for(let $=0,A=z.length;$<A;$++)Y.push(F)}else Y=U.reduce(($,A)=>{const T=A.patterns;return T?$.concat(T):$},[]);const ne=function($,A){if(typeof $!="string")return null;if(!A){let W;for(W=$.length;W>0;W--){const B=$.charCodeAt(W-1);if(B===47||B===92)break}A=$.substr(W)}const T=z.indexOf(A);return T!==-1?Y[T]:null};ne.basenames=z,ne.patterns=Y,ne.allBasenames=z;const _=H.filter($=>!$.basenames);return _.push(ne),_}function ge(H,F){return(0,I.equals)(H,F,(U,z)=>typeof U=="string"&&typeof z=="string"?U===z:typeof U!="string"&&typeof z!="string"?U.base===z.base&&U.pattern===z.pattern:!1)}e.patternsEquals=ge}),define(te[36],ie([0,1,25,32,9,4,20,27]),function(V,e,I,L,k,o,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function h(i,n){const{os:r,tildify:l,relative:s}=n;if(s){const M=m(i,s,r);if(typeof M=="string")return M}let d=i.fsPath;if(r===1&&!o.isWindows?d=d.replace(/\//g,"\\"):r!==1&&o.isWindows&&(d=d.replace(/\\/g,"/")),r!==1&&l?.userHome){const M=l.userHome.fsPath;let O;i.scheme!==l.userHome.scheme&&i.path.startsWith(k.posix.sep)?O=l.userHome.with({path:i.path}).fsPath:O=i.fsPath,d=b(O,M,r)}return(r===1?k.win32:k.posix).normalize(S(d,r===1))}e.getPathLabel=h;function m(i,n,r){const l=r===1?k.win32:k.posix,s=r===3?C.extUri:C.extUriIgnorePathCase,d=n.getWorkspace(),y=(0,I.firstOrDefault)(d.folders);if(!y)return;i.scheme!==y.uri.scheme&&i.path.startsWith(k.posix.sep)&&(i=y.uri.with({path:i.path}));const M=n.getWorkspaceFolder(i);if(!M)return;let O;if(s.isEqual(M.uri,i)?O="":O=s.relativePath(M.uri,i)??"",O&&(O=l.normalize(O)),d.folders.length>1&&!n.noPrefix){const j=M.name?M.name:s.basenameOrAuthority(M.uri);O=O?`${j} \u2022 ${O}`:j}return O}function S(i,n=o.isWindows){return(0,L.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=S;let v=Object.create(null);function b(i,n,r=o.OS){if(r===1||!i||!n)return i;let l=v.original===n?v.normalized:void 0;l||(l=n,o.isWindows&&(l=(0,L.toSlashes)(l)),l=`${(0,P.rtrim)(l,k.posix.sep)}${k.posix.sep}`,v={original:n,normalized:l});let s=i;return o.isWindows&&(s=(0,L.toSlashes)(s)),(r===3?s.startsWith(l):(0,P.startsWithIgnoreCase)(s,l))?`~/${s.substr(l.length)}`:i}e.tildify=b;function f(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=f;const p="\u2026",w="\\\\",c="~";function u(i,n=k.sep){const r=new Array(i.length);let l=!1;for(let s=0;s<i.length;s++){const d=i[s];if(d===""){r[s]=`.${n}`;continue}if(!d){r[s]=d;continue}l=!0;let y="",M=d;M.indexOf(w)===0?(y=M.substr(0,M.indexOf(w)+w.length),M=M.substr(M.indexOf(w)+w.length)):M.indexOf(n)===0?(y=M.substr(0,M.indexOf(n)+n.length),M=M.substr(M.indexOf(n)+n.length)):M.indexOf(c)===0&&(y=M.substr(0,M.indexOf(c)+c.length),M=M.substr(M.indexOf(c)+c.length));const O=M.split(n);for(let j=1;l&&j<=O.length;j++)for(let K=O.length-j;l&&K>=0;K--){l=!1;let x=O.slice(K,K+j).join(n);for(let J=0;!l&&J<i.length;J++)if(J!==s&&i[J]&&i[J].indexOf(x)>-1){const re=K+j===O.length,se=K>0&&i[J].indexOf(n)>-1?n+x:x,ae=i[J].endsWith(se);l=!re||ae}if(!l){let J="";(O[0].endsWith(":")||y!=="")&&(K===1&&(K=0,j++,x=O[0]+n+x),K>0&&(J=O[0]+n),J=y+J),K>0&&(J=J+p+n),J=J+x,K+j<O.length&&(J=J+n+p),r[s]=J}}l&&(r[s]=d)}return r}e.shorten=u;var g;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function D(i,n=Object.create(null)){const r=[];let l=!1,s="";for(const d of i)if(d==="$"||l&&d==="{")s&&r.push({value:s,type:g.TEXT}),s="",l=!0;else if(d==="}"&&l){const y=n[s];if(typeof y=="string")y.length&&r.push({value:y,type:g.VARIABLE});else if(y){const M=r[r.length-1];(!M||M.type!==g.SEPARATOR)&&r.push({value:y.label,type:g.SEPARATOR})}s="",l=!1}else s+=d;return s&&!l&&r.push({value:s,type:g.TEXT}),r.filter((d,y)=>{if(d.type===g.SEPARATOR){const M=r[y-1],O=r[y+1];return[M,O].every(j=>j&&(j.type===g.VARIABLE||j.type===g.TEXT)&&j.value.length>0)}return!0}).map(d=>d.value).join("")}e.template=D;function E(i,n){return o.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,o.isMacintosh?"&":"&&"):i.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.mnemonicMenuLabel=E;function R(i,n){return o.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):o.isWindows?i.replace(/&&|&/g,r=>r==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=R;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function a(i){const n=i.indexOf("/")!==-1?k.posix:k.win32,r=n.basename(i),l=n.dirname(i);return r.length?{name:r,parentPath:l}:{name:l,parentPath:""}}e.splitName=a}),define(te[144],ie([0,1,17,7]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(v){return v.toJSON()}class o{constructor(b){this.a=b}transformIncoming(b){const f=this.a.transformIncoming(b);return f===b?b:k(L.URI.from(f))}transformOutgoing(b){const f=this.a.transformOutgoing(b);return f===b?b:k(L.URI.from(f))}transformOutgoingURI(b){const f=this.a.transformOutgoing(b);return f===b?b:L.URI.from(f)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.URITransformer=o,e.DefaultURITransformer=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function C(v,b,f){if(!v||f>200)return null;if(typeof v=="object"){if(v instanceof L.URI)return b.transformOutgoing(v);for(const p in v)if(Object.hasOwnProperty.call(v,p)){const w=C(v[p],b,f+1);w!==null&&(v[p]=w)}}return null}function P(v,b){const f=C(v,b,0);return f===null?v:f}e.transformOutgoingURIs=P;function h(v,b,f,p){if(!v||p>200)return null;if(typeof v=="object"){if(v.$mid===1)return f?L.URI.revive(b.transformIncoming(v)):b.transformIncoming(v);if(v instanceof I.VSBuffer)return null;for(const w in v)if(Object.hasOwnProperty.call(v,w)){const c=h(v[w],b,f,p+1);c!==null&&(v[w]=c)}}return null}function m(v,b){const f=h(v,b,!1,0);return f===null?v:f}e.transformIncomingURIs=m;function S(v,b){const f=h(v,b,!0,0);return f===null?v:f}e.transformAndReviveIncomingURIs=S}),define(te[84],ie([0,1,26,13,60,31,132]),function(V,e,I,L,k,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(S){return this.a||(this.a=k.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(S)}value(){if(this.b===void 0){let S=0,v=0;const b=(0,I.networkInterfaces)();for(const f in b){const p=b[f];if(p)for(const{mac:w,internal:c}of p)c||(v+=1,this.c(w.toUpperCase())&&(S+=1))}this.b=v>0?S/v:0}return this.b}};let P;async function h(){return P||(P=(async()=>await m()||o.generateUuid())()),P}e.getMachineId=h;async function m(){try{const S=await new Promise((b,f)=>{V(["crypto"],b,f)}),v=(0,C.getMac)();return S.createHash("sha256").update(v,"utf8").digest("hex")}catch(S){L.onUnexpectedError(S);return}}}),define(te[23],ie([0,1,41,26,145,8,32,79,9,4,20,7]),function(V,e,I,L,k,o,C,P,h,m,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function f(se,ae=b.UNLINK){if((0,C.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return ae===b.UNLINK?w(se):p(se)}async function p(se){try{const ae=(0,C.randomPath)((0,L.tmpdir)());try{await I.promises.rename(se,ae)}catch(fe){return fe.code==="ENOENT"?void 0:w(se)}w(ae).catch(fe=>{})}catch(ae){if(ae.code!=="ENOENT")throw ae}}async function w(se){return(0,k.promisify)(I.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function c(se){if((0,C.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=c;async function u(se,ae){return E(await(ae?g(se):(0,k.promisify)(I.readdir)(se)))}async function g(se){try{return await(0,k.promisify)(I.readdir)(se,{withFileTypes:!0})}catch(ge){console.warn("[node.js fs] readdir with filetypes failed with error: ",ge)}const ae=[],fe=await u(se);for(const ge of fe){let H=!1,F=!1,U=!1;try{const z=await e.Promises.lstat((0,h.join)(se,ge));H=z.isFile(),F=z.isDirectory(),U=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}ae.push({name:ge,isFile:()=>H,isDirectory:()=>F,isSymbolicLink:()=>U})}return ae}function D(se){return E(I.readdirSync(se))}e.readdirSync=D;function E(se){return se.map(ae=>typeof ae=="string"?m.isMacintosh?(0,P.normalizeNFC)(ae):ae:(ae.name=m.isMacintosh?(0,P.normalizeNFC)(ae.name):ae.name,ae))}async function R(se){const ae=await u(se),fe=[];for(const ge of ae)await a.existsDirectory((0,h.join)(se,ge))&&fe.push(ge);return fe}function t(se,ae=1e3){return new Promise(fe=>{let ge=!1;const H=setInterval(()=>{ge||(ge=!0,I.access(se,F=>{ge=!1,F&&(clearInterval(H),fe(void 0))}))},ae)})}e.whenDeleted=t;var a;(function(se){async function ae(H){let F;try{if(F=await e.Promises.lstat(H),!F.isSymbolicLink())return{stat:F}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(m.isWindows&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw z}throw U}}se.stat=ae;async function fe(H){try{const{stat:F,symbolicLink:U}=await se.stat(H);return F.isFile()&&U?.dangling!==!0}catch{}return!1}se.existsFile=fe;async function ge(H){try{const{stat:F,symbolicLink:U}=await se.stat(H);return F.isDirectory()&&U?.dangling!==!0}catch{}return!1}se.existsDirectory=ge})(a=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new o.ResourceQueue;function n(se,ae,fe){return i.queueFor(v.URI.file(se),S.extUriBiasedIgnorePathCase).queue(()=>{const ge=y(fe);return new Promise((H,F)=>s(se,ae,ge,U=>U?F(U):H()))})}let r=!0;function l(se){r=se}e.configureFlushOnWrite=l;function s(se,ae,fe,ge){if(!r)return I.writeFile(se,ae,{mode:fe.mode,flag:fe.flag},ge);I.open(se,fe.flag,fe.mode,(H,F)=>{if(H)return ge(H);I.writeFile(F,ae,U=>{if(U)return I.close(F,()=>ge(U));I.fdatasync(F,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),l(!1)),I.close(F,Y=>ge(Y))))})})}function d(se,ae,fe){const ge=y(fe);if(!r)return I.writeFileSync(se,ae,{mode:ge.mode,flag:ge.flag});const H=I.openSync(se,ge.flag,ge.mode);try{I.writeFileSync(H,ae);try{I.fdatasyncSync(H)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),l(!1)}}finally{I.closeSync(H)}}e.writeFileSync=d;function y(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function M(se,ae){if(se!==ae)try{await e.Promises.rename(se,ae)}catch(fe){if(se.toLowerCase()!==ae.toLowerCase()&&fe.code==="EXDEV"||se.endsWith("."))await O(se,ae,{preserveSymlinks:!1}),await f(se,b.MOVE);else throw fe}}async function O(se,ae,fe){return K(se,ae,{root:{source:se,target:ae},options:fe,handledSourcePaths:new Set})}const j=511;async function K(se,ae,fe){if(fe.handledSourcePaths.has(se))return;fe.handledSourcePaths.add(se);const{stat:ge,symbolicLink:H}=await a.stat(se);if(H){if(fe.options.preserveSymlinks)try{return await re(se,ae,fe)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(H.dangling)return}return ge.isDirectory()?x(se,ae,ge.mode&j,fe):J(se,ae,ge.mode&j)}async function x(se,ae,fe,ge){await e.Promises.mkdir(ae,{recursive:!0,mode:fe});const H=await u(se);for(const F of H)await K((0,h.join)(se,F),(0,h.join)(ae,F),ge)}async function J(se,ae,fe){await e.Promises.copyFile(se,ae),await e.Promises.chmod(ae,fe)}async function re(se,ae,fe){let ge=await e.Promises.readlink(se);(0,C.isEqualOrParent)(ge,fe.root.source,!m.isLinux)&&(ge=(0,h.join)(fe.root.target,ge.substr(fe.root.source.length+1))),await e.Promises.symlink(ge,ae)}e.Promises=new class{get access(){return(0,k.promisify)(I.access)}get stat(){return(0,k.promisify)(I.stat)}get lstat(){return(0,k.promisify)(I.lstat)}get utimes(){return(0,k.promisify)(I.utimes)}get read(){return(se,ae,fe,ge,H)=>new Promise((F,U)=>{I.read(se,ae,fe,ge,H,(z,Y,ne)=>z?U(z):F({bytesRead:Y,buffer:ne}))})}get readFile(){return(0,k.promisify)(I.readFile)}get write(){return(se,ae,fe,ge,H)=>new Promise((F,U)=>{I.write(se,ae,fe,ge,H,(z,Y,ne)=>z?U(z):F({bytesWritten:Y,buffer:ne}))})}get appendFile(){return(0,k.promisify)(I.appendFile)}get fdatasync(){return(0,k.promisify)(I.fdatasync)}get truncate(){return(0,k.promisify)(I.truncate)}get rename(){return(0,k.promisify)(I.rename)}get copyFile(){return(0,k.promisify)(I.copyFile)}get open(){return(0,k.promisify)(I.open)}get close(){return(0,k.promisify)(I.close)}get symlink(){return(0,k.promisify)(I.symlink)}get readlink(){return(0,k.promisify)(I.readlink)}get chmod(){return(0,k.promisify)(I.chmod)}get mkdir(){return(0,k.promisify)(I.mkdir)}get unlink(){return(0,k.promisify)(I.unlink)}get rmdir(){return(0,k.promisify)(I.rmdir)}get realpath(){return(0,k.promisify)(I.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return R}get writeFile(){return n}get rm(){return f}get move(){return M}get copy(){return O}}}),define(te[102],ie([0,1,41,9,4,27,23]),function(V,e,I,L,k,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(b){if(k.isLinux)return b;const f=(0,L.dirname)(b);if(b===f)return b;const p=((0,L.basename)(b)||b).toLowerCase();try{const c=(0,C.readdirSync)(f).filter(u=>u.toLowerCase()===p);if(c.length===1){const u=P(f);if(u)return(0,L.join)(u,c[0])}else if(c.length>1){const u=c.indexOf(p);if(u>=0){const g=P(f);if(g)return(0,L.join)(g,c[u])}}}catch{}return null}e.realcaseSync=P;async function h(b){if(k.isLinux)return b;const f=(0,L.dirname)(b);if(b===f)return b;const p=((0,L.basename)(b)||b).toLowerCase();try{const c=(await C.Promises.readdir(f)).filter(u=>u.toLowerCase()===p);if(c.length===1){const u=await h(f);if(u)return(0,L.join)(u,c[0])}else if(c.length>1){const u=c.indexOf(p);if(u>=0){const g=await h(f);if(g)return(0,L.join)(g,c[u])}}}catch{}return null}e.realcase=h;async function m(b){try{return await C.Promises.realpath(b)}catch{const p=v(b);return await C.Promises.access(p,I.constants.R_OK),p}}e.realpath=m;function S(b){try{return I.realpathSync(b)}catch{const p=v(b);return I.accessSync(p,I.constants.R_OK),p}}e.realpathSync=S;function v(b){return(0,o.rtrim)((0,L.normalize)(b),L.sep)}}),define(te[146],ie([0,1,26,9,23]),function(V,e,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const o=/^\d+$/,C=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var h;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(h||(h={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let S;process.env.PROCESSOR_ARCHITEW6432?S=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?S=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?S=1:S=0;class v{constructor(R,t,a){this.exePath=R,this.displayName=t,this.a=a}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function b({useAlternateBitness:E=!1}={}){return E?m===0?process.env["ProgramFiles(x86)"]||null:S===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:E=!1,findPreview:R=!1}={}){const t=b({useAlternateBitness:E});if(!t)return null;const a=L.join(t,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(a))return null;let i=-1,n=null;for(const s of await k.Promises.readdir(a)){let d=-1;if(R){const M=s.indexOf("-");if(M<0)continue;const O=s.substring(0,M);if(!o.test(O)||s.substring(M+1)!=="preview")continue;d=parseInt(O,10)}else{if(!o.test(s))continue;d=parseInt(s,10)}if(d<=i)continue;const y=L.join(a,s,"pwsh.exe");!await k.SymlinkSupport.existsFile(y)||(n=y,i=d)}if(!n)return null;const r=t.includes("x86")?" (x86)":"",l=R?" Preview":"";return new v(n,`PowerShell${l}${r}`,!0)}async function p({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const R=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(R))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=E?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const i of await k.Promises.readdir(R))if(t.test(i)){const n=L.join(R,i,"pwsh.exe");return new v(n,a)}return null}function w(){const E=L.join(I.homedir(),".dotnet","tools","pwsh.exe");return new v(E,".NET Core PowerShell Global Tool")}function c(){const E=L.join(process.env.windir,m===1&&S!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(E,"Windows PowerShell",!0)}async function*u(){let E=await f();E&&(yield E),E=await f({useAlternateBitness:!0}),E&&(yield E),E=await p(),E&&(yield E),E=w(),E&&(yield E),E=await f({findPreview:!0}),E&&(yield E),E=await p({findPreview:!0}),E&&(yield E),E=await f({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=c(),E&&(yield E)}async function*g(){for await(const E of u())await E.exists()&&(yield E)}e.enumeratePowerShellInstallations=g;async function D(){for await(const E of g())return E;return null}e.getFirstAvailablePowerShellInstallation=D}),define(te[85],ie([0,1,9,4,35,82,10,23]),function(V,e,I,L,k,o,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return o.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return o.TerminateResponseCode}});function h(v=k.env){return v.comspec||"cmd.exe"}e.getWindowsShell=h;function m(v){let b=[],f=!1;const p=function(w){if(f){b.push(w);return}(!v.send(w,u=>{if(u&&console.error(u),f=!1,b.length>0){const g=b.slice(0);b=[],g.forEach(D=>p(D))}})||L.isWindows)&&(f=!0)};return{send:p}}e.createQueuedSender=m;var S;(function(v){async function b(f,p,w){if(I.isAbsolute(f))return f;if(p===void 0&&(p=k.cwd()),I.dirname(f)!=="."||(w===void 0&&C.isString(k.env.PATH)&&(w=k.env.PATH.split(I.delimiter)),w===void 0||w.length===0))return I.join(p,f);async function u(g){if(await P.Promises.exists(g)){let D;try{D=await P.Promises.stat(g)}catch(E){E.message.startsWith("EACCES")&&(D=await P.Promises.lstat(g))}return D?!D.isDirectory():!1}return!1}for(const g of w){let D;if(I.isAbsolute(g)?D=I.join(g,f):D=I.join(p,g,f),await u(D))return D;let E=D+".com";if(await u(E)||(E=D+".exe",await u(E)))return E}return I.join(p,f)}v.findExecutable=b})(S=e.win32||(e.win32={}))}),define(te[103],ie([0,1,46,15]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(C){return new Promise((P,h)=>{let m;const S=new Map;function v(f,p,w,c,u){const g=S.get(p);if(f===C||g){const D={name:b(w),cmd:w,pid:f,ppid:p,load:c,mem:u};S.set(f,D),f===C&&(m=D),g&&(g.children||(g.children=[]),g.children.push(D),g.children.length>1&&(g.children=g.children.sort((E,R)=>E.pid-R.pid)))}}function b(f){const p=/--vscode-window-kind=shared-process/,w=/--vscode-window-kind=issue-reporter/,c=/--vscode-window-kind=process-explorer/,u=/--utility-sub-type=network/,g=/--utility-sub-type=node.mojom.NodeService/,D=/--crashes-directory/,E=/\\pipe\\winpty-control/,R=/conhost\.exe/,t=/--type=([a-zA-Z-]+)/;if(D.exec(f))return"electron-crash-reporter";if(E.exec(f))return"winpty-process";if(R.exec(f))return"console-window-host (Windows internal process)";let a=t.exec(f);if(a&&a.length===2){if(a[1]==="renderer")return p.exec(f)?"shared-process":w.exec(f)?"issue-reporter":c.exec(f)?"process-explorer":"window";if(a[1]==="utility"){if(u.exec(f))return"utility-network-service";if(g.exec(f))return"extension-host"}else if(a[1]==="extensionHost")return"extension-host";return a[1]}const i=/[a-zA-Z-]+\.js/g;let n="";do a=i.exec(f),a&&(n+=a+" ");while(a);return n&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron_node ${n}`:f}if(process.platform==="win32"){const f=p=>p.indexOf("\\\\?\\")===0||p.indexOf("\\??\\")===0?p.substr(4):p.indexOf('"\\\\?\\')===0||p.indexOf('"\\??\\')===0?'"'+p.substr(5):p;new Promise((p,w)=>{V(["windows-process-tree"],p,w)}).then(p=>{p.getProcessList(C,w=>{if(!w){h(new Error(`Root process ${C} not found`));return}p.getProcessCpuUsage(w,c=>{const u=new Map;c.forEach(g=>{const D=f(g.commandLine||"");u.set(g.pid,{name:b(D),cmd:D,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),m=u.get(C),m?(u.forEach(g=>{const D=u.get(g.ppid);D&&(D.children||(D.children=[]),D.children.push(g))}),u.forEach(g=>{g.children&&(g.children=g.children.sort((D,E)=>D.pid-E.pid))}),P(m)):h(new Error(`Root process ${C} not found`))})},p.ProcessDataFlag.CommandLine|p.ProcessDataFlag.Memory)})}else{let f=function(){let p=[m];const w=[];for(;p.length;){const u=p.shift();u&&(w.push(u.pid),u.children&&(p=p.concat(u.children)))}let c=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);c+=" "+w.join(" "),(0,I.exec)(c,{},(u,g,D)=>{if(u||D)h(u||new Error(D.toString()));else{const E=g.toString().split(`
`);for(let R=0;R<w.length;R++){const t=S.get(w[R]);t.load=parseFloat(E[R])}if(!m){h(new Error(`Root process ${C} not found`));return}P(m)}})};(0,I.exec)("which ps",{},(p,w,c)=>{if(p||c)if(process.platform!=="linux")h(p||new Error(c.toString()));else{const u=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(u,{},(g,D,E)=>{g||E?h(g||new Error(E.toString())):(o(D,v),f())})}else{const u=w.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,I.exec)(`${u} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(D,E,R)=>{D||R&&!R.includes("screen size is bogus")?h(D||new Error(R.toString())):(o(E,v),process.platform==="linux"?f():m?P(m):h(new Error(`Root process ${C} not found`)))})}})}})}e.listProcesses=k;function o(C,P){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=C.toString().split(`
`);for(const S of m){const v=h.exec(S.trim());v&&v.length===6&&P(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}}),define(te[147],ie([0,1,26,4,146,85]),function(V,e,I,L,k,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function C(v,b){return v===1?L.isWindows?S():o.getWindowsShell(b):h(v,b)}e.getSystemShell=C;let P=null;function h(v,b){if(L.isLinux&&v===2||L.isMacintosh&&v===3)return"/bin/bash";if(!P){let f;if(L.isWindows)f="/bin/bash";else{if(f=b.SHELL,!f)try{f=(0,I.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}P=f}return P}let m=null;async function S(){return m||(m=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),m}});var ve=this&&this.__decorate||function(V,e,I,L){var k=arguments.length,o=k<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,I):L,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")o=Reflect.decorate(V,e,I,L);else for(var P=V.length-1;P>=0;P--)(C=V[P])&&(o=(k<3?C(o):k>3?C(e,I,o):C(e,I))||o);return k>3&&o&&Object.defineProperty(e,I,o),o};define(te[47],ie([0,1,25,8,17,22,54,13,3,2,72,27,10]),function(V,e,I,L,k,o,C,P,h,m,S,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var f;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(f||(f={}));function p(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(w||(w={}));function c(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(u||(u={}));function g(F){let U=0;for(let z=0;;z+=7){const Y=F.read(1);if(U|=(Y.buffer[0]&127)<<z,!(Y.buffer[0]&128))return U}}const D=i(0);function E(F,U){if(U===0){F.write(D);return}let z=0;for(let ne=U;ne!==0;ne=ne>>>7)z++;const Y=k.VSBuffer.alloc(z);for(let ne=0;U!==0;ne++)Y.buffer[ne]=U&127,U=U>>>7,U>0&&(Y.buffer[ne]|=128);F.write(Y)}class R{constructor(U){this.b=U,this.a=0}read(U){const z=this.b.slice(this.a,this.a+U);return this.a+=z.byteLength,z}}e.BufferReader=R;class t{constructor(){this.a=[]}get buffer(){return k.VSBuffer.concat(this.a)}write(U){this.a.push(U)}}e.BufferWriter=t;var a;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object",F[F.Int=6]="Int"})(a||(a={}));function i(F){const U=k.VSBuffer.alloc(1);return U.writeUInt8(F,0),U}const n={Undefined:i(a.Undefined),String:i(a.String),Buffer:i(a.Buffer),VSBuffer:i(a.VSBuffer),Array:i(a.Array),Object:i(a.Object),Uint:i(a.Int)},r=typeof Buffer<"u";function l(F,U){if(typeof U>"u")F.write(n.Undefined);else if(typeof U=="string"){const z=k.VSBuffer.fromString(U);F.write(n.String),E(F,z.byteLength),F.write(z)}else if(r&&Buffer.isBuffer(U)){const z=k.VSBuffer.wrap(U);F.write(n.Buffer),E(F,z.byteLength),F.write(z)}else if(U instanceof k.VSBuffer)F.write(n.VSBuffer),E(F,U.byteLength),F.write(U);else if(Array.isArray(U)){F.write(n.Array),E(F,U.length);for(const z of U)l(F,z)}else if(typeof U=="number"&&(U|0)===U)F.write(n.Uint),E(F,U);else{const z=k.VSBuffer.fromString(JSON.stringify(U));F.write(n.Object),E(F,z.byteLength),F.write(z)}}e.serialize=l;function s(F){switch(F.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return F.read(g(F)).toString();case a.Buffer:return F.read(g(F)).buffer;case a.VSBuffer:return F.read(g(F));case a.Array:{const z=g(F),Y=[];for(let ne=0;ne<z;ne++)Y.push(s(F));return Y}case a.Object:return JSON.parse(F.read(g(F)).toString());case a.Int:return g(F)}}e.deserialize=s;class d{constructor(U,z,Y=null,ne=1e3){this.h=U,this.j=z,this.k=Y,this.l=ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(_=>this.q(_)),this.m({type:200})}registerChannel(U,z){this.b.set(U,z),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const z=this.o([U.type]);this.k?.logOutgoing(z,0,1,c(U.type));return}case 201:case 202:case 204:case 203:{const z=this.o([U.type,U.id],U.data);this.k?.logOutgoing(z,U.id,1,c(U.type),U.data);return}}}o(U,z=void 0){const Y=new t;return l(Y,U),l(Y,z),this.p(Y.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const z=new R(U),Y=s(z),ne=s(z),_=Y[0];switch(_){case 100:return this.k?.logIncoming(U.byteLength,Y[1],1,`${p(_)}: ${Y[2]}.${Y[3]}`,ne),this.s({type:_,id:Y[1],channelName:Y[2],name:Y[3],arg:ne});case 102:return this.k?.logIncoming(U.byteLength,Y[1],1,`${p(_)}: ${Y[2]}.${Y[3]}`,ne),this.t({type:_,id:Y[1],channelName:Y[2],name:Y[3],arg:ne});case 101:return this.k?.logIncoming(U.byteLength,Y[1],1,`${p(_)}`),this.u({type:_,id:Y[1]});case 103:return this.k?.logIncoming(U.byteLength,Y[1],1,`${p(_)}`),this.u({type:_,id:Y[1]})}}s(U){const z=this.b.get(U.channelName);if(!z){this.v(U);return}const Y=new o.CancellationTokenSource;let ne;try{ne=z.call(this.j,U.name,U.arg,Y.token)}catch(A){ne=Promise.reject(A)}const _=U.id;ne.then(A=>{this.m({id:_,data:A,type:201}),this.d.delete(U.id)},A=>{A instanceof Error?this.m({id:_,data:{message:A.message,name:A.name,stack:A.stack?A.stack.split?A.stack.split(`
`):A.stack:void 0},type:202}):this.m({id:_,data:A,type:203}),this.d.delete(U.id)});const $=(0,m.toDisposable)(()=>Y.cancel());this.d.set(U.id,$)}t(U){const z=this.b.get(U.channelName);if(!z){this.v(U);return}const Y=U.id,_=z.listen(this.j,U.name,U.arg)($=>this.m({id:Y,data:$,type:204}));this.d.set(U.id,_)}u(U){const z=this.d.get(U.id);z&&(z.dispose(),this.d.delete(U.id))}v(U){let z=this.g.get(U.channelName);z||(z=[],this.g.set(U.channelName,z));const Y=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);z.push({request:U,timeoutTimer:Y})}w(U){const z=this.g.get(U);if(z){for(const Y of z)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.s(Y.request);break;case 102:this.t(Y.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,m.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=d;var y;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(y=e.RequestInitiator||(e.RequestInitiator={}));class M{constructor(U,z=null){this.l=U,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Y=>this.s(Y)),this.j=z}getChannel(U){const z=this;return{call(Y,ne,_){return z.a?Promise.reject(new P.CancellationError):z.m(U,Y,ne,_)},listen(Y,ne){return z.a?h.Event.None:z.o(U,Y,ne)}}}m(U,z,Y,ne=o.CancellationToken.None){const _=this.g++,A={id:_,type:100,channelName:U,name:z,arg:Y};if(ne.isCancellationRequested)return Promise.reject(new P.CancellationError);let T;return new Promise((B,G)=>{if(ne.isCancellationRequested)return G(new P.CancellationError);const N=()=>{const ue=ye=>{switch(ye.type){case 201:this.f.delete(_),B(ye.data);break;case 202:{this.f.delete(_);const ke=new Error(ye.data.message);ke.stack=Array.isArray(ye.data.stack)?ye.data.stack.join(`
`):ye.data.stack,ke.name=ye.data.name,G(ke);break}case 203:this.f.delete(_),G(ye.data);break}};this.f.set(_,ue),this.p(A)};let q=null;this.b===u.Idle?N():(q=(0,L.createCancelablePromise)(ue=>this.u()),q.then(()=>{q=null,N()}));const Q=()=>{q?(q.cancel(),q=null):this.p({id:_,type:101}),G(new P.CancellationError)},oe=ne.onCancellationRequested(Q);T=(0,m.combinedDisposable)((0,m.toDisposable)(Q),oe),this.d.add(T)}).finally(()=>{this.d.delete(T)})}o(U,z,Y){const ne=this.g++,$={id:ne,type:102,channelName:U,name:z,arg:Y};let A=null;const T=new h.Emitter({onWillAddFirstListener:()=>{A=(0,L.createCancelablePromise)(B=>this.u()),A.then(()=>{A=null,this.d.add(T),this.p($)})},onDidRemoveLastListener:()=>{A?(A.cancel(),A=null):(this.d.delete(T),this.p({id:ne,type:103}))}}),W=B=>T.fire(B.data);return this.f.set(ne,W),T.event}p(U){switch(U.type){case 100:case 102:{const z=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(z,U.id,0,`${p(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const z=this.q([U.type,U.id]);this.j?.logOutgoing(z,U.id,0,p(U.type));return}}}q(U,z=void 0){const Y=new t;return l(Y,U),l(Y,z),this.r(Y.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const z=new R(U),Y=s(z),ne=s(z),_=Y[0];switch(_){case 200:return this.j?.logIncoming(U.byteLength,0,0,c(_)),this.t({type:Y[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,Y[1],0,c(_),ne),this.t({type:Y[0],id:Y[1],data:ne})}}t(U){if(U.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,m.dispose)(this.d.values()),this.d.clear()}}ve([C.memoize],M.prototype,"onDidInitializePromise",null),e.ChannelClient=M;class O{get connections(){const U=[];return this.f.forEach(z=>U.push(z)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new h.Emitter,this.onDidAddConnection=this.g.event,this.h=new h.Emitter,this.onDidRemoveConnection=this.h.event,U(({protocol:z,onDidClientDisconnect:Y})=>{h.Event.once(z.onMessage)(_=>{const $=new R(_),A=s($),T=new d(z,A),W=new M(z);this.a.forEach((G,N)=>T.registerChannel(N,G));const B={channelServer:T,channelClient:W,ctx:A};this.f.add(B),this.g.fire(B),Y(()=>{T.dispose(),W.dispose(),this.f.delete(B),this.h.fire(B)})})})}getChannel(U,z){const Y=this;return{call(ne,_,$){let A;if((0,b.isFunction)(z)){const W=(0,I.getRandomElement)(Y.connections.filter(z));A=W?Promise.resolve(W):h.Event.toPromise(h.Event.filter(Y.onDidAddConnection,z))}else A=z.routeCall(Y,ne,_);const T=A.then(W=>W.channelClient.getChannel(U));return K(T).call(ne,_,$)},listen(ne,_){if((0,b.isFunction)(z))return Y.j(U,z,ne,_);const $=z.routeEvent(Y,ne,_).then(A=>A.channelClient.getChannel(U));return K($).listen(ne,_)}}}j(U,z,Y,ne){const _=this;let $=new m.DisposableStore;const A=new h.Emitter({onWillAddFirstListener:()=>{$=new m.DisposableStore;const T=new h.EventMultiplexer,W=new Map,B=N=>{const Q=N.channelClient.getChannel(U).listen(Y,ne),oe=T.add(Q);W.set(N,oe)},G=N=>{const q=W.get(N);!q||(q.dispose(),W.delete(N))};_.connections.filter(z).forEach(B),h.Event.filter(_.onDidAddConnection,z)(B,void 0,$),_.onDidRemoveConnection(G,void 0,$),T.event(A.fire,A,$),$.add(T)},onDidRemoveLastListener:()=>{$.dispose()}});return A.event}registerChannel(U,z){this.a.set(U,z),this.f.forEach(Y=>{Y.channelServer.registerChannel(U,z)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=O;class j{constructor(U,z,Y=null){const ne=new t;l(ne,z),U.send(ne.buffer),this.a=new M(U,Y),this.d=new d(U,z,Y)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,z){this.d.registerChannel(U,z)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=j;function K(F){return{call(U,z,Y){return F.then(ne=>ne.call(U,z,Y))},listen(U,z){const Y=new h.Relay;return F.then(ne=>Y.input=ne.listen(U,z)),Y.event}}}e.getDelayedChannel=K;function x(F){let U=!1;return{call(z,Y,ne){return U?F.call(z,Y,ne):(0,L.timeout)(0).then(()=>U=!0).then(()=>F.call(z,Y,ne))},listen(z,Y){if(U)return F.listen(z,Y);const ne=new h.Relay;return(0,L.timeout)(0).then(()=>U=!0).then(()=>ne.input=F.listen(z,Y)),ne.event}}}e.getNextTickChannel=x;class J{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const z of U.connections)if(await Promise.resolve(this.a(z.ctx)))return Promise.resolve(z);return await h.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.StaticRouter=J;var re;(function(F){function U(_,$){const A=_,T=$&&$.disableMarshalling,W=new Map;for(const B in A)Y(B)&&W.set(B,h.Event.buffer(A[B],!0));return new class{listen(B,G,N){const q=W.get(G);if(q)return q;if(ne(G)){const Q=A[G];if(typeof Q=="function")return Q.call(A,N)}throw new Error(`Event not found: ${G}`)}call(B,G,N){const q=A[G];if(typeof q=="function"){if(!T&&Array.isArray(N))for(let Q=0;Q<N.length;Q++)N[Q]=(0,S.revive)(N[Q]);return q.apply(A,N)}throw new Error(`Method not found: ${G}`)}}}F.fromService=U;function z(_,$){const A=$&&$.disableMarshalling;return new Proxy({},{get(T,W){if(typeof W=="string")return $?.properties?.has(W)?$.properties.get(W):ne(W)?function(B){return _.listen(W,B)}:Y(W)?_.listen(W):async function(...B){let G;$&&!(0,b.isUndefinedOrNull)($.context)?G=[$.context,...B]:G=B;const N=await _.call(W,G);return A?N:(0,S.revive)(N)};throw new Error(`Property not found: ${String(W)}`)}})}F.toService=z;function Y(_){return _[0]==="o"&&_[1]==="n"&&v.isUpperAsciiLetter(_.charCodeAt(2))}function ne(_){return/^onDynamic/.test(_)&&v.isUpperAsciiLetter(_.charCodeAt(9))}})(re=e.ProxyChannel||(e.ProxyChannel={}));const se=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ae(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){const U=F.toString();if(U!=="[object Object]")return U}return F}function fe(F){return Array.isArray(F)?F.map(ae):ae(F)}function ge(F,U,z,Y,ne,_,$){$=fe($);const A=se[ne],T=A[Y%A.length];let W=[`%c[${F}]%c[${String(U).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${T}`];/\($/.test(_)?(W=W.concat($),W.push(")")):W.push($),console.log.apply(console,W)}class H{constructor(U,z){this.d=U,this.f=z,this.a=0,this.b=0}logOutgoing(U,z,Y,ne,_){this.b+=U,ge(this.d,this.b,U,z,Y,ne,_)}logIncoming(U,z,Y,ne,_){this.a+=U,ge(this.f,this.a,U,z,Y,ne,_)}}e.IPCLogger=H}),define(te[148],ie([0,1,17,3,47]),function(V,e,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class o{constructor(h){this.a=h,this.onMessage=L.Event.fromDOMEventEmitter(this.a,"message",m=>I.VSBuffer.wrap(m.data)),h.start()}send(h){this.a.postMessage(h.buffer)}disconnect(){this.a.close()}}e.Protocol=o;class C extends k.IPCClient{constructor(h,m){const S=new o(h);super(S,m),this.b=S}dispose(){this.b.disconnect()}}e.Client=C}),define(te[104],ie([0,1,8,17,3,2,47]),function(V,e,I,L,k,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(M){M.Created="created",M.Read="read",M.Write="write",M.Open="open",M.Error="error",M.Close="close",M.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",M.NodeEndReceived="nodeEndReceived",M.NodeEndSent="nodeEndSent",M.NodeDrainBegin="nodeDrainBegin",M.NodeDrainEnd="nodeDrainEnd",M.zlibInflateError="zlibInflateError",M.zlibInflateData="zlibInflateData",M.zlibInflateInitialWrite="zlibInflateInitialWrite",M.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",M.zlibInflateWrite="zlibInflateWrite",M.zlibInflateFlushFired="zlibInflateFlushFired",M.zlibDeflateError="zlibDeflateError",M.zlibDeflateData="zlibDeflateData",M.zlibDeflateWrite="zlibDeflateWrite",M.zlibDeflateFlushFired="zlibDeflateFlushFired",M.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",M.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",M.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",M.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",M.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",M.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",M.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",M.ProtocolHeaderRead="protocolHeaderRead",M.ProtocolMessageRead="protocolMessageRead",M.ProtocolHeaderWrite="protocolHeaderWrite",M.ProtocolMessageWrite="protocolMessageWrite",M.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var h;(function(M){M.enableDiagnostics=!1,M.records=[];const O=new WeakMap;let j=0;function K(J,re){if(!O.has(J)){const se=String(++j);O.set(J,se)}return O.get(J)}function x(J,re,se,ae){if(!M.enableDiagnostics)return;const fe=K(J,re);if(ae instanceof L.VSBuffer||ae instanceof Uint8Array||ae instanceof ArrayBuffer||ArrayBuffer.isView(ae)){const ge=L.VSBuffer.alloc(ae.byteLength);ge.set(ae),M.records.push({timestamp:Date.now(),id:fe,label:re,type:se,buff:ge})}else M.records.push({timestamp:Date.now(),id:fe,label:re,type:se,data:ae})}M.traceSocketEvent=x})(h=e.SocketDiagnostics||(e.SocketDiagnostics={}));var m;(function(M){M[M.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",M[M.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(m=e.SocketCloseEventType||(e.SocketCloseEventType={}));let S=null;function v(){return S||(S=L.VSBuffer.alloc(0)),S}class b{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(O){this.a.push(O),this.b+=O.byteLength}read(O){return this.c(O,!0)}peek(O){return this.c(O,!1)}c(O,j){if(O===0)return v();if(O>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===O){const re=this.a[0];return j&&(this.a.shift(),this.b-=O),re}if(this.a[0].byteLength>O){const re=this.a[0].slice(0,O);return j&&(this.a[0]=this.a[0].slice(O),this.b-=O),re}const K=L.VSBuffer.alloc(O);let x=0,J=0;for(;O>0;){const re=this.a[J];if(re.byteLength>O){const se=re.slice(0,O);K.set(se,x),x+=O,j&&(this.a[J]=re.slice(O),this.b-=O),O-=O}else K.set(re,x),x+=re.byteLength,j?(this.a.shift(),this.b-=re.byteLength):J++,O-=re.byteLength}return K}}e.ChunkStream=b;var f;(function(M){M[M.None=0]="None",M[M.Regular=1]="Regular",M[M.Control=2]="Control",M[M.Ack=3]="Ack",M[M.Disconnect=5]="Disconnect",M[M.ReplayRequest=6]="ReplayRequest",M[M.Pause=7]="Pause",M[M.Resume=8]="Resume",M[M.KeepAlive=9]="KeepAlive",M[M.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",M[M.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(f||(f={}));function p(M){switch(M){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var w;(function(M){M[M.HeaderLength=13]="HeaderLength",M[M.AcknowledgeTime=2e3]="AcknowledgeTime",M[M.TimeoutTime=2e4]="TimeoutTime",M[M.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",M[M.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",M[M.KeepAliveSendTime=5e3]="KeepAliveSendTime",M[M.LatencySampleTime=6e4]="LatencySampleTime",M[M.LatencySampleCount=5]="LatencySampleCount",M[M.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",M[M.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class c{constructor(O,j,K,x){this.type=O,this.id=j,this.ack=K,this.data=x,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends o.Disposable{constructor(O){super(),this.f=this.B(new k.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=O,this.b=!1,this.c=new b,this.B(this.a.onData(j=>this.acceptChunk(j))),this.lastReadTime=Date.now()}acceptChunk(O){if(!(!O||O.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(O);this.c.byteLength>=this.g.readLen;){const j=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=j.readUInt32BE(9),this.g.messageType=j.readUInt8(0),this.g.id=j.readUInt32BE(1),this.g.ack=j.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:p(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const K=this.g.messageType,x=this.g.id,J=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",j),this.f.fire(new c(K,x,J,j)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(O){this.k=null,this.a=!1,this.b=!1,this.c=O,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(O){if(this.a)return;O.writtenTime=Date.now(),this.lastWriteTime=Date.now();const j=L.VSBuffer.alloc(13);j.writeUInt8(O.type,0),j.writeUInt32BE(O.id,1),j.writeUInt32BE(O.ack,5),j.writeUInt32BE(O.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:p(O.type),id:O.id,ack:O.ack,messageSize:O.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",O.data),this.j(j,O.data)}g(O,j){const K=this.f===0;return this.d.push(O,j),this.f+=O.byteLength+j.byteLength,K}h(){const O=L.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,O}j(O,j){this.g(O,j)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const O=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:O.byteLength}),this.c.write(O)}}class D extends o.Disposable{constructor(O){super(),this.f=new k.Emitter,this.onMessage=this.f.event,this.g=new k.Emitter,this.onDidDispose=this.g.event,this.a=O,this.b=this.B(new g(this.a)),this.c=this.B(new u(this.a)),this.B(this.c.onMessage(j=>{j.type===1&&this.f.fire(j.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(O){this.b.write(new c(1,0,0,O))}}e.Protocol=D;class E extends C.IPCClient{static fromSocket(O,j){return new E(new D(O),j)}get onDidDispose(){return this.b.onDidDispose}constructor(O,j,K=null){super(O,j,K),this.b=O}dispose(){super.dispose();const O=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),O.end()}}e.Client=E;class R{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new k.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(O){this.b?this.d.length>0?this.d.push(O):this.a.fire(O):this.d.push(O)}flushBuffer(){this.d=[]}}e.BufferedEmitter=R;class t{constructor(O){this.data=O,this.next=null}}class a{constructor(){this.a=null,this.b=null}length(){let O=0,j=this.a;for(;j;)j=j.next,O++;return O}peek(){return this.a?this.a.data:null}toArray(){const O=[];let j=0,K=this.a;for(;K;)O[j++]=K.data,K=K.next;return O}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(O){const j=new t(O);if(!this.a){this.a=j,this.b=j;return}this.b.next=j,this.b=j}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const O=Date.now();for(let j=0;j<i.a;j++)this.c[j]=O-1e3*j;setInterval(()=>{for(let j=i.a;j>=1;j--)this.c[j]=this.c[j-1];this.c[0]=Date.now()},1e3)}d(){const O=Date.now(),j=(1+i.a)*1e3;let K=0;for(let x=0;x<i.a;x++)O-this.c[x]<=j&&K++;return 1-K/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;var n;(function(M){M[M.Good=0]="Good",M[M.Poor=1]="Poor"})(n=e.ConnectionHealth||(e.ConnectionHealth={}));function r(M){switch(M){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=r;class l{constructor(O){this.connectionHealth=O}}e.ConnectionHealthChangedEvent=l;class s{constructor(O,j){this.roundTripTime=O,this.recentHighRoundTripCount=j}}e.HighRoundTripTimeEvent=s;class d{get unacknowledgedCount(){return this.c-this.d}constructor(O){this.x=new R,this.onControlMessage=this.x.event,this.y=new R,this.onMessage=this.y.event,this.z=new R,this.onDidDispose=this.z.event,this.A=new R,this.onSocketClose=this.A.event,this.B=new R,this.onSocketTimeout=this.B.event,this.C=new R,this.onHighRoundTripTime=this.C.event,this.D=new R,this.onDidChangeConnectionHealth=this.D.event,this.u=O.loadEstimator??i.getInstance(),this.v=O.measureRoundTripTime??!1,this.w=O.sendKeepAlive??!0,this.a=!1,this.b=new a,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new o.DisposableStore,this.o=O.socket,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(j=>this.E(j))),this.t.add(this.o.onClose(j=>this.A.fire(j))),this.r=this.t.add(new y),this.t.add(this.r.onSendLatencyRequest(j=>this.J(j))),this.t.add(this.r.onHighRoundTripTime(j=>this.C.fire(j))),this.t.add(this.r.onDidChangeConnectionHealth(j=>this.D.fire(j))),this.v&&this.r.start(),O.initialChunk&&this.q.acceptChunk(O.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const O=new c(5,0,0,v());this.p.write(O),this.p.flush()}sendPause(){const O=new c(7,0,0,v());this.p.write(O)}sendResume(){const O=new c(8,0,0,v());this.p.write(O)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(O,j){this.a=!0,this.t.dispose(),this.t=new o.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=O,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(K=>this.E(K))),this.t.add(this.o.onClose(K=>this.A.fire(K))),this.r=this.t.add(new y),this.t.add(this.r.onSendLatencyRequest(K=>this.J(K))),this.t.add(this.r.onHighRoundTripTime(K=>this.C.fire(K))),this.t.add(this.r.onDidChangeConnectionHealth(K=>this.D.fire(K))),this.q.acceptChunk(j)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const O=new c(3,0,this.h,v());this.p.write(O);const j=this.b.toArray();for(let K=0,x=j.length;K<x;K++)this.p.write(j[K]);this.G()}acceptDisconnect(){this.z.fire()}E(O){if(O.ack>this.d){this.d=O.ack;do{const j=this.b.peek();if(j&&j.id<=O.ack)this.b.pop();else break}while(!0)}switch(O.type){case 0:break;case 1:{if(O.id>this.g)if(O.id!==this.g+1){const j=Date.now();j-this.m>1e4&&(this.m=j,this.p.write(new c(6,0,0,v())))}else this.g=O.id,this.j=Date.now(),this.F(),this.y.fire(O.data);break}case 2:{this.x.fire(O.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const j=this.b.toArray();for(let K=0,x=j.length;K<x;K++)this.p.write(j[K]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(O.data);break}case 11:{this.r.handleResponse(O.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(O){const j=++this.c;this.h=this.g;const K=new c(1,j,this.h,O);this.b.push(K),this.a||(this.p.write(K),this.G())}sendControl(O){const j=new c(2,0,0,O);this.p.write(j)}F(){if(this.g<=this.h||this.k)return;const O=Date.now()-this.j;if(O>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-O+5)}G(){if(this.c<=this.d||this.f||this.a)return;const O=this.b.peek(),j=Date.now()-O.writtenTime,K=Date.now()-this.q.lastReadTime,x=Date.now()-this.n;if(j>=2e4&&K>=2e4&&x>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:j,timeSinceLastReceivedSomeData:K});return}const J=Math.max(2e4-j,2e4-K,2e4-x,500);this.f=setTimeout(()=>{this.f=null,this.G()},J)}H(){if(this.g<=this.h)return;this.h=this.g;const O=new c(3,0,this.h,v());this.p.write(O)}I(){this.h=this.g;const O=new c(9,0,this.h,v());this.p.write(O)}J(O){this.h=this.g;const j=new c(10,0,this.h,O);this.p.write(j)}K(O){this.h=this.g;const j=new c(11,0,this.h,O);this.p.write(j)}}e.PersistentProtocol=d;class y extends o.Disposable{constructor(){super(),this.a=this.B(new k.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new k.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new k.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new I.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},O=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const O=++this.h,j=L.VSBuffer.alloc(4);j.writeUInt32BE(O,0),this.a.fire(j)},6e4)}handleResponse(O){if(O.byteLength!==4)return;const j=O.readUInt32BE(0);if(this.g<=0||j!==this.h)return;const K=Date.now()-this.g,x=this.k++;this.j[x%this.j.length]=K;const J=this.l,re=this.j.filter(se=>se>=1e3).length;this.l=re>=3?1:0,K>1e3&&this.b.fire(new s(K,re)),J!==this.l&&this.c.fire(this.l)}}}),define(te[149],ie([0,1,42,17,3,2,47,134]),function(V,e,I,L,k,o,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function h(S,v){const b=k.Event.fromNodeEventEmitter(I.validatedIpcMain,v,(p,w)=>({event:p,message:w})),f=k.Event.filter(b,({event:p})=>p.sender.id===S);return k.Event.map(f,({message:p})=>p&&L.VSBuffer.wrap(p))}class m extends C.IPCServer{static d(){const v=k.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:hello",({sender:b})=>b);return k.Event.map(v,b=>{const f=b.id;m.b.get(f)?.dispose();const w=new k.Emitter;m.b.set(f,(0,o.toDisposable)(()=>w.fire()));const c=h(f,"vscode:message"),u=k.Event.any(k.Event.signal(h(f,"vscode:disconnect")),w.event);return{protocol:new P.Protocol(b,c),onDidClientDisconnect:u}})}constructor(){super(m.d())}}e.Server=m,m.b=new Map}),define(te[105],ie([0,1,42,3,31,148]),function(V,e,I,L,k,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class C extends o.Client{constructor(m,S){super({addEventListener:(v,b)=>m.addListener(v,b),removeEventListener:(v,b)=>m.removeListener(v,b),postMessage:v=>m.postMessage(v),start:()=>m.start(),close:()=>m.close()},S)}}e.Client=C;async function P(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const m=(0,k.generateUuid)();h.webContents.send("vscode:createMessageChannel",m);const S=L.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:createMessageChannelResult",(b,f)=>({nonce:f,port:b.ports[0]})),{port:v}=await L.Event.toPromise(L.Event.once(L.Event.filter(S,b=>b.nonce===m)));return v}e.connect=P}),define(te[150],ie([0,1,46,8,17,22,143,13,3,2,44,85,82,47]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends f.ChannelServer{constructor(u){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",g=>k.VSBuffer.wrap(Buffer.from(g,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=p;class w{constructor(u,g){this.i=u,this.j=g,this.c=new Set,this.g=new Map,this.h=new h.Emitter,this.onDidProcessExit=this.h.event;const D=g&&g.timeout?g.timeout:6e4;this.b=new L.Delayer(D),this.d=null,this.f=null}getChannel(u){const g=this;return{call(D,E,R){return g.k(u,D,E,R)},listen(D,E){return g.l(u,D,E)}}}k(u,g,D,E=o.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(P.canceled());this.b.cancel();const R=this.n(u),t=(0,L.createCancelablePromise)(n=>R.call(g,D,n)),a=E.onCancellationRequested(()=>t.cancel()),i=(0,m.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{a.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(u,g,D){if(!this.b)return h.Event.None;this.b.cancel();let E;const R=new h.Emitter({onWillAddFirstListener:()=>{E=this.n(u).listen(g,D)(R.fire,R),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return R.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,S.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,b.removeDangerousEnvVariables)(g.env),this.d=(0,I.fork)(this.i,u,g);const D=new h.Emitter;h.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,C.isRemoteConsoleLog)(r)){(0,C.log)(r,`IPC Library: ${this.j.serverName}`);return}D.fire(k.VSBuffer.wrap(Buffer.from(r,"base64")))});const R=this.j.useQueue?(0,v.createQueuedSender)(this.d):this.d,t=r=>this.d&&this.d.connected&&R.send(r.buffer.toString("base64")),a=D.event,i={send:t,onMessage:a};this.f=new f.ChannelClient(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,l)=>{process.removeListener("exit",n),this.c.forEach(s=>(0,m.dispose)(s)),this.c.clear(),r!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:l})})}return this.f}n(u){let g=this.g.get(u);return g||(g=this.m.getChannel(u),this.g.set(u,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=w}),define(te[86],ie([0,1,17,13,3,2,9,4,31,47,104]),function(V,e,I,L,k,o,C,P,h,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function v(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class b{traceSocketEvent(s,d){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,s,d)}constructor(s,d=""){this.f=!0,this.debugLabel=d,this.socket=s,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=y=>{if(this.traceSocketEvent("error",{code:y?.code,message:y?.message}),y){if(y.code==="EPIPE")return;(0,L.onUnexpectedError)(y)}},this.socket.on("error",this.a),this.b=y=>{this.traceSocketEvent("close",{hadError:y}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(s){const d=y=>{this.traceSocketEvent("read",y),s(I.VSBuffer.wrap(y))};return this.socket.on("data",d),{dispose:()=>this.socket.off("data",d)}}onClose(s){const d=y=>{s({type:0,hadError:y,error:void 0})};return this.socket.on("close",d),{dispose:()=>this.socket.off("close",d)}}onEnd(s){const d=()=>{s()};return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(s){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",s),this.socket.write(s.buffer,d=>{if(d){if(d.code==="EPIPE")return;(0,L.onUnexpectedError)(d)}})}catch(d){if(d.code==="EPIPE")return;(0,L.onUnexpectedError)(d)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((s,d)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),s();return}const y=()=>{this.socket.off("close",y),this.socket.off("end",y),this.socket.off("error",y),this.socket.off("timeout",y),this.socket.off("drain",y),this.traceSocketEvent("nodeDrainEnd"),s()};this.socket.on("close",y),this.socket.on("end",y),this.socket.on("error",y),this.socket.on("timeout",y),this.socket.on("drain",y)})}}e.NodeSocket=b;var f;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(f||(f={}));var p;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(p||(p={}));class w extends o.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(s,d){this.socket.traceSocketEvent(s,d)}constructor(s,d,y,M){super(),this.f=this.B(new k.Emitter),this.g=this.B(new k.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=s,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:d,inflateBytesLength:y?.byteLength||0,recordInflateBytes:M}),this.a=this.B(new c(this,d,y,M,this.f,(O,j)=>this.k(O,j))),this.B(this.a.onError(O=>{console.error(O),(0,L.onUnexpectedError)(O),this.g.fire({type:0,hadError:!0,error:O})})),this.b=new S.ChunkStream,this.B(this.socket.onData(O=>this.l(O))),this.B(this.socket.onClose(O=>this.g.fire(O)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(s){return this.f.event(s)}onClose(s){return this.g.event(s)}onEnd(s){return this.socket.onEnd(s)}write(s){this.a.writeMessage(s)}k(s,d){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",s);let y=2;s.byteLength<126?y+=0:s.byteLength<2**16?y+=2:y+=8;const M=I.VSBuffer.alloc(y);if(d?M.writeUInt8(194,0):M.writeUInt8(130,0),s.byteLength<126)M.writeUInt8(s.byteLength,1);else if(s.byteLength<2**16){M.writeUInt8(126,1);let O=1;M.writeUInt8(s.byteLength>>>8&255,++O),M.writeUInt8(s.byteLength>>>0&255,++O)}else{M.writeUInt8(127,1);let O=1;M.writeUInt8(0,++O),M.writeUInt8(0,++O),M.writeUInt8(0,++O),M.writeUInt8(0,++O),M.writeUInt8(s.byteLength>>>24&255,++O),M.writeUInt8(s.byteLength>>>16&255,++O),M.writeUInt8(s.byteLength>>>8&255,++O),M.writeUInt8(s.byteLength>>>0&255,++O)}this.socket.write(I.VSBuffer.concat([M,s]))}end(){this.h=!0,this.socket.end()}l(s){if(s.byteLength!==0){for(this.b.acceptChunk(s);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const d=this.b.peek(this.j.readLen),y=d.readUInt8(0),M=(y&128)>>>7,O=(y&64)>>>6,j=d.readUInt8(1),K=(j&128)>>>7,x=j&127;this.j.state=2,this.j.readLen=2+(K?4:0)+(x===126?2:0)+(x===127?8:0),this.j.fin=M,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(O)),this.j.firstFrameOfMessage=Boolean(M),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const d=this.b.read(this.j.readLen),y=d.readUInt8(1),M=(y&128)>>>7;let O=y&127,j=1;O===126?O=d.readUInt8(++j)*2**8+d.readUInt8(++j):O===127&&(O=d.readUInt8(++j)*0+d.readUInt8(++j)*0+d.readUInt8(++j)*0+d.readUInt8(++j)*0+d.readUInt8(++j)*2**24+d.readUInt8(++j)*2**16+d.readUInt8(++j)*2**8+d.readUInt8(++j));let K=0;M&&(K=d.readUInt8(++j)*2**24+d.readUInt8(++j)*2**16+d.readUInt8(++j)*2**8+d.readUInt8(++j)),this.j.state=3,this.j.readLen=O,this.j.mask=K,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const d=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",d),D(d,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",d),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(d,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class c extends o.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:I.VSBuffer.alloc(0)}constructor(s,d,y,M,O,j){super(),this.k=s,this.l=O,this.m=j,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,d?(this.b=this.B(new u(this.k,M,y,{windowBits:15})),this.f=this.B(new g(this.k,{windowBits:15})),this.B(this.b.onError(K=>this.a.fire(K))),this.B(this.f.onError(K=>this.a.fire(K)))):(this.b=null,this.f=null)}writeMessage(s){this.g.push(s),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const s=this.g.shift();if(this.f){const d=await this.r(this.f,s);this.m(d,!0)}else this.m(s,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(s,d){return new Promise((y,M)=>{s.write(d),s.flush(O=>y(O))})}acceptFrame(s,d,y){this.h.push({data:s,isCompressed:d,isLastFrameOfMessage:y}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const s=this.h.shift();if(this.b&&s.isCompressed){const d=await this.u(this.b,s.data,s.isLastFrameOfMessage);this.l.fire(d)}else this.l.fire(s.data)}this.s=!1}}u(s,d,y){return new Promise((M,O)=>{s.write(d),y&&s.write(I.VSBuffer.fromByteArray([0,0,255,255])),s.flush(j=>M(j))})}}class u extends o.Disposable{get recordedInflateBytes(){return this.j?I.VSBuffer.concat(this.f):I.VSBuffer.alloc(0)}constructor(s,d,y,M){super(),this.h=s,this.j=d,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=v().zlib.createInflateRaw(M),this.b.on("error",O=>{this.h.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent("zlibInflateData",O),this.g.push(I.VSBuffer.wrap(O))}),y&&(this.h.traceSocketEvent("zlibInflateInitialWrite",y.buffer),this.b.write(y.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(s){this.j&&this.f.push(s.clone()),this.h.traceSocketEvent("zlibInflateWrite",s),this.b.write(s.buffer)}flush(s){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const d=I.VSBuffer.concat(this.g);this.g.length=0,s(d)})}}class g extends o.Disposable{constructor(s,d){super(),this.g=s,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.f=[],this.b=v().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",y=>{this.g.traceSocketEvent("zlibDeflateError",{message:y?.message,code:y?.code}),this.a.fire(y)}),this.b.on("data",y=>{this.g.traceSocketEvent("zlibDeflateData",y),this.f.push(I.VSBuffer.wrap(y))})}write(s){this.g.traceSocketEvent("zlibDeflateWrite",s.buffer),this.b.write(s.buffer)}flush(s){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let d=I.VSBuffer.concat(this.f);this.f.length=0,d=d.slice(0,d.byteLength-4),s(d)})}}function D(l,s){if(s===0)return;const d=l.byteLength>>>2;for(let x=0;x<d;x++){const J=l.readUInt32BE(x*4);l.writeUInt32BE(J^s,x*4)}const y=d*4,M=l.byteLength-y,O=s>>>24&255,j=s>>>16&255,K=s>>>8&255;M>=1&&l.writeUInt8(l.readUInt8(y)^O,y),M>=2&&l.writeUInt8(l.readUInt8(y+1)^j,y+1),M>=3&&l.writeUInt8(l.readUInt8(y+2)^K,y+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const E={[2]:107,[1]:103};function R(){const l=(0,h.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let s;return e.XDG_RUNTIME_DIR?s=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):s=(0,C.join)(v().os.tmpdir(),`vscode-ipc-${l}.sock`),a(s),s}e.createRandomIPCHandle=R;function t(l,s,d){const y=v().crypto.createHash("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${y}-${d}-${s}-sock`;let M;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?M=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${y.substr(0,8)}-${d}-${s}.sock`):M=(0,C.join)(l,`${d}-${s}.sock`),a(M),M}e.createStaticIPCHandle=t;function a(l){const s=E[P.platform];typeof s=="number"&&l.length>=s&&console.warn(`WARNING: IPC handle "${l}" is longer than ${s} chars, try a shorter --user-data-dir`)}class i extends m.IPCServer{static b(s){const d=k.Event.fromNodeEventEmitter(s,"connection");return k.Event.map(d,y=>({protocol:new S.Protocol(new b(y,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(y,"close"))}))}constructor(s){super(i.b(s)),this.d=s}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=i;function n(l){return new Promise((s,d)=>{const y=v().net.createServer();y.on("error",d),y.listen(l,()=>{y.removeListener("error",d),s(new i(y))})})}e.serve=n;function r(l,s){return new Promise((d,y)=>{const M=v().net.createConnection(l,()=>{M.removeListener("error",y),d(S.Client.fromSocket(new b(M,`ipc-client${s}`),s))});M.once("error",y)})}e.connect=r}),define(te[106],ie([0,1,8,3,2,10]),function(V,e,I,L,k,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var C;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(C=e.StorageHint||(e.StorageHint={}));function P(v){const b=v;return b?.changed instanceof Map||b?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var h;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(h=e.StorageState||(e.StorageState={}));class m extends k.Disposable{constructor(b,f=Object.create(null)){super(),this.m=b,this.n=f,this.b=this.B(new L.Emitter),this.onDidChangeStorage=this.b.event,this.c=h.None,this.f=new Map,this.g=new I.ThrottledDelayer(m.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(b=>this.r(b)))}r(b){b.changed?.forEach((f,p)=>this.s(p,f)),b.deleted?.forEach(f=>this.s(f,void 0))}s(b,f){if(this.c===h.Closed)return;let p=!1;(0,o.isUndefinedOrNull)(f)?p=this.f.delete(b):this.f.get(b)!==f&&(this.f.set(b,f),p=!0),p&&this.b.fire(b)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===h.None&&(this.c=h.Initialized,this.n.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(b,f){const p=this.f.get(b);return(0,o.isUndefinedOrNull)(p)?f:p}getBoolean(b,f){const p=this.get(b);return(0,o.isUndefinedOrNull)(p)?f:p==="true"}getNumber(b,f){const p=this.get(b);return(0,o.isUndefinedOrNull)(p)?f:parseInt(p,10)}async set(b,f){if(this.c===h.Closed)return;if((0,o.isUndefinedOrNull)(f))return this.delete(b);const p=String(f);if(this.f.get(b)!==p)return this.f.set(b,p),this.j.set(b,p),this.h.delete(b),this.b.fire(b),this.w()}async delete(b){if(!(this.c===h.Closed||!this.f.delete(b)))return this.h.has(b)||this.h.add(b),this.j.delete(b),this.b.fire(b),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=h.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const b={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(b).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(b){if(!!this.u)return this.w(b)}async w(b){return this.g.trigger(()=>this.v(),b)}async whenFlushed(){if(!!this.u)return new Promise(b=>this.l.push(b))}isInMemory(){return this.n.hint===C.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=m,m.a=100;class S{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(b){b.insert?.forEach((f,p)=>this.a.set(p,f)),b.delete?.forEach(f=>this.a.delete(f))}async close(){}}e.InMemoryStorageDatabase=S}),define(te[151],ie([0,1,8,3,38,9,23]),function(V,e,I,L,k,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class P{get onDidChangeItemsExternal(){return L.Event.None}constructor(S,v=Object.create(null)){this.g=S,this.h=v,this.c=(0,o.basename)(this.g),this.d=new h(this.h.logging),this.f=this.n(this.g)}async getItems(){const S=await this.f,v=new Map;return(await this.s(S,"SELECT * FROM ItemTable")).forEach(f=>v.set(f.key,f.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${v.size} rows`),v}async updateItems(S){const v=await this.f;return this.j(v,S)}j(S,v){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${v.insert?(0,k.mapToString)(v.insert):"0"}), delete(${v.delete?(0,k.setToString)(v.delete):"0"})`),this.t(S,()=>{const b=v.insert,f=v.delete;if(b&&b.size>0){const p=[];p.push([]);let w=0;b.forEach((c,u)=>{let g=p[w];g.length>P.b&&(w++,g=[],p.push(g)),g.push(u,c)}),p.forEach(c=>{this.u(S,`INSERT INTO ItemTable VALUES ${new Array(c.length/2).fill("(?,?)").join(",")}`,u=>u.run(c),()=>{const u=[];let g=0;return b.forEach((D,E)=>{u.push(E),g+=D.length}),`Keys: ${u.join(", ")} Length: ${g}`})})}if(f&&f.size){const p=[];p.push([]);let w=0;f.forEach(c=>{let u=p[w];u.length>P.b&&(w++,u=[],p.push(u)),u.push(c)}),p.forEach(c=>{this.u(S,`DELETE FROM ItemTable WHERE key IN (${new Array(c.length).fill("?").join(",")})`,u=>u.run(c),()=>{const u=[];return f.forEach(g=>{u.push(g)}),`Keys: ${u.join(", ")}`})})}})}async close(S){this.d.trace(`[storage ${this.c}] close()`);const v=await this.f;return this.k(v,S)}k(S,v){return new Promise((b,f)=>{S.db.close(p=>(p&&this.o(S,`[storage ${this.c}] close(): ${p}`),this.g===P.IN_MEMORY_PATH?b():!S.isErroneous&&!S.isInMemory?this.l().then(b,w=>(this.d.error(`[storage ${this.c}] backup(): ${w}`),b())):typeof v=="function"?C.Promises.unlink(this.g).then(()=>this.p(this.g).then(w=>{const c=()=>this.k(w,void 0);return this.j(w,{insert:v()}).then(()=>c(),u=>(c(),Promise.reject(u)))})).then(b,f):f(p||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const S=this.m(this.g);return C.Promises.copy(this.g,S,{preserveSymlinks:!1})}m(S){return`${S}.backup`}async checkIntegrity(S){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${S})`);const v=await this.f,b=await this.r(v,S?"PRAGMA integrity_check":"PRAGMA quick_check"),f=S?b.integrity_check:b.quick_check;return v.isErroneous?`${f} (last error: ${v.lastError})`:v.isInMemory?`${f} (in-memory!)`:f}async n(S,v=!0){this.d.trace(`[storage ${this.c}] open(${S}, retryOnBusy: ${v})`);try{return await this.p(S)}catch(b){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${b}`),b.code==="SQLITE_BUSY"&&v)return await(0,I.timeout)(P.a),this.n(S,!1);try{await C.Promises.unlink(S);try{await C.Promises.rename(this.m(S),S)}catch{}return await this.p(S)}catch(f){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${f}`),this.p(P.IN_MEMORY_PATH)}}}o(S,v){S.isErroneous=!0,S.lastError=v,this.d.error(v)}p(S){return new Promise((v,b)=>{new Promise((f,p)=>{V(["@vscode/sqlite3"],f,p)}).then(f=>{const p={db:new(this.d.isTracing?f.verbose().Database:f.Database)(S,w=>w?p.db&&w.code!=="SQLITE_CANTOPEN"?p.db.close(()=>b(w)):b(w):this.q(p,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>v(p),c=>p.db.close(()=>b(c)))),isInMemory:S===P.IN_MEMORY_PATH};p.db.on("error",w=>this.o(p,`[storage ${this.c}] Error (event): ${w}`)),this.d.isTracing&&p.db.on("trace",w=>this.d.trace(`[storage ${this.c}] Trace (event): ${w}`))},b)})}q(S,v){return new Promise((b,f)=>{S.db.exec(v,p=>p?(this.o(S,`[storage ${this.c}] exec(): ${p}`),f(p)):b())})}r(S,v){return new Promise((b,f)=>{S.db.get(v,(p,w)=>p?(this.o(S,`[storage ${this.c}] get(): ${p}`),f(p)):b(w))})}s(S,v){return new Promise((b,f)=>{S.db.all(v,(p,w)=>p?(this.o(S,`[storage ${this.c}] all(): ${p}`),f(p)):b(w))})}t(S,v){return new Promise((b,f)=>{S.db.serialize(()=>{S.db.run("BEGIN TRANSACTION"),v(),S.db.run("END TRANSACTION",p=>p?(this.o(S,`[storage ${this.c}] transaction(): ${p}`),f(p)):b())})})}u(S,v,b,f){const p=S.db.prepare(v),w=c=>{this.o(S,`[storage ${this.c}] prepare(): ${c} (${v}). Details: ${f()}`)};p.on("error",w),b(p),p.finalize(c=>{c&&w(c),p.removeListener("error",w)})}}e.SQLiteStorageDatabase=P,P.IN_MEMORY_PATH=":memory:",P.a=2e3,P.b=256;class h{constructor(S){S&&typeof S.logTrace=="function"&&process.env[h.VSCODE_TRACE_STORAGE]&&(this.a=S.logTrace),S&&typeof S.logError=="function"&&(this.b=S.logError)}get isTracing(){return!!this.a}trace(S){this.a?.(S)}error(S){this.b?.(S)}}h.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(te[152],ie([12,11]),function(V,e){return V.create("vs/code/electron-main/app",e)}),define(te[153],ie([12,11]),function(V,e){return V.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[154],ie([12,11]),function(V,e){return V.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[155],ie([12,11]),function(V,e){return V.create("vs/platform/environment/node/argv",e)}),define(te[156],ie([12,11]),function(V,e){return V.create("vs/platform/environment/node/argvHelper",e)}),define(te[157],ie([12,11]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[158],ie([12,11]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[159],ie([12,11]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[160],ie([12,11]),function(V,e){return V.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[161],ie([12,11]),function(V,e){return V.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[162],ie([12,11]),function(V,e){return V.create("vs/platform/files/common/fileService",e)}),define(te[163],ie([12,11]),function(V,e){return V.create("vs/platform/files/common/files",e)}),define(te[164],ie([12,11]),function(V,e){return V.create("vs/platform/files/common/io",e)}),define(te[165],ie([12,11]),function(V,e){return V.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[166],ie([12,11]),function(V,e){return V.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[167],ie([12,11]),function(V,e){return V.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[168],ie([12,11]),function(V,e){return V.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[169],ie([12,11]),function(V,e){return V.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[170],ie([12,11]),function(V,e){return V.create("vs/platform/request/common/request",e)}),define(te[171],ie([12,11]),function(V,e){return V.create("vs/platform/shell/node/shellEnv",e)}),define(te[172],ie([12,11]),function(V,e){return V.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[173],ie([12,11]),function(V,e){return V.create("vs/platform/update/common/update.config.contribution",e)}),define(te[174],ie([12,11]),function(V,e){return V.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[175],ie([12,11]),function(V,e){return V.create("vs/platform/windows/electron-main/windowImpl",e)}),define(te[176],ie([12,11]),function(V,e){return V.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[177],ie([12,11]),function(V,e){return V.create("vs/platform/workspace/common/workspace",e)}),define(te[178],ie([12,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[179],ie([12,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[180],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function I(k){return k&&k.hasOwnProperty("folderUri")}e.isFolderBackupInfo=I;function L(k){return k&&k.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=L}),define(te[181],ie([0,1,7]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function L(C){return typeof C?.backupFolder=="string"}e.isEmptyWindowBackupInfo=L;function k(C){let P=[];try{Array.isArray(C.workspaces)&&(P=C.workspaces.map(h=>({workspace:{id:h.id,configPath:I.URI.parse(h.configURIPath)},remoteAuthority:h.remoteAuthority})))}catch{}return P}e.deserializeWorkspaceInfos=k;function o(C){let P=[];try{Array.isArray(C.folders)&&(P=C.folders.map(h=>({folderUri:I.URI.parse(h.folderUri),remoteAuthority:h.remoteAuthority})))}catch{}return P}e.deserializeFolderInfos=o}),define(te[182],ie([0,1,3,2]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this.a=new I.Emitter,this.b=new I.Emitter,this.c=new I.Emitter,this.d=new I.Emitter}call(P,h,m){switch(h){case"close":return Promise.resolve(this.a.fire({sessionId:m[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:m[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:m[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:m[0],port:m[1],subId:m[2]}))}throw new Error("Method not implemented.")}listen(P,h,m){switch(h){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class o extends L.Disposable{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,h,m){this.b.call("attach",[P,h,m])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,h){this.b.call("terminate",[P,h])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,h){return this.b.call("openExtensionDevelopmentHostWindow",[P,h])}}e.ExtensionHostDebugChannelClient=o}),define(te[183],ie([0,1,137,54,15,9,35,20,7]),function(V,e,I,L,k,o,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class m{get appRoot(){return(0,o.dirname)(k.FileAccess.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,o.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const p=(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,o.join)(this.userDataPath,"logs",p)}return this.args.logsPath}get userDataSyncLogResource(){return h.URI.file((0,o.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return h.URI.file((0,o.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(h.URI.file((0,o.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=C.env.VSCODE_PORTABLE;return p?h.URI.file((0,o.join)(p,"argv.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,o.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,o.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,o.resolve)(p):(0,o.normalize)((0,o.join)(k.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const p=this.args["extensions-download-dir"];return p?h.URI.file((0,o.resolve)(p)):h.URI.file((0,o.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,o.resolve)(p);const w=C.env.VSCODE_EXTENSIONS;if(w)return w;const c=C.env.VSCODE_PORTABLE;return c?(0,o.join)(c,"extensions"):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(w=>/^[^:/?#]+?:\/\//.test(w)?h.URI.parse(w):h.URI.file((0,o.normalize)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?h.URI.parse(p):h.URI.file((0,o.normalize)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(p=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(p))}get extensionLogLevel(){const p=[];for(const w of this.args.log||[]){const c=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(w);c&&c[1]&&c[2]&&p.push([c[1],c[2]])}return p.length?p:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return h.URI.file((0,o.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const p=C.env.VSCODE_PORTABLE;return p?h.URI.file((0,o.join)(p,"policy.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(p){this.args.continueOn=p}get args(){return this.a}constructor(p,w,c){this.a=p,this.b=w,this.c=c,this.editSessionId=this.args.editSessionId}}ve([L.memoize],m.prototype,"appRoot",null),ve([L.memoize],m.prototype,"userHome",null),ve([L.memoize],m.prototype,"userDataPath",null),ve([L.memoize],m.prototype,"appSettingsHome",null),ve([L.memoize],m.prototype,"tmpDir",null),ve([L.memoize],m.prototype,"cacheHome",null),ve([L.memoize],m.prototype,"stateResource",null),ve([L.memoize],m.prototype,"userRoamingDataHome",null),ve([L.memoize],m.prototype,"userDataSyncHome",null),ve([L.memoize],m.prototype,"userDataSyncLogResource",null),ve([L.memoize],m.prototype,"editSessionsLogResource",null),ve([L.memoize],m.prototype,"sync",null),ve([L.memoize],m.prototype,"machineSettingsResource",null),ve([L.memoize],m.prototype,"workspaceStorageHome",null),ve([L.memoize],m.prototype,"localHistoryHome",null),ve([L.memoize],m.prototype,"keyboardLayoutResource",null),ve([L.memoize],m.prototype,"argvResource",null),ve([L.memoize],m.prototype,"isExtensionDevelopment",null),ve([L.memoize],m.prototype,"untitledWorkspacesHome",null),ve([L.memoize],m.prototype,"installSourcePath",null),ve([L.memoize],m.prototype,"builtinExtensionsPath",null),ve([L.memoize],m.prototype,"extensionsPath",null),ve([L.memoize],m.prototype,"extensionDevelopmentLocationURI",null),ve([L.memoize],m.prototype,"extensionDevelopmentKind",null),ve([L.memoize],m.prototype,"extensionTestsLocationURI",null),ve([L.memoize],m.prototype,"debugExtensionHost",null),ve([L.memoize],m.prototype,"logLevel",null),ve([L.memoize],m.prototype,"extensionLogLevel",null),ve([L.memoize],m.prototype,"serviceMachineIdResource",null),ve([L.memoize],m.prototype,"telemetryLogResource",null),ve([L.memoize],m.prototype,"disableWorkspaceTrust",null),ve([L.memoize],m.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=m;function S(f,p){return b(f["inspect-extensions"],f["inspect-brk-extensions"],5870,p,f.debugId,f.extensionEnvironment)}e.parseExtensionHostPort=S;function v(f,p){return b(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,p,f.extensionEnvironment)}e.parsePtyHostPort=v;function b(f,p,w,c,u,g){const E=Number(p||f)||(c?null:w),R=E?Boolean(!!p):!1;let t;if(g)try{t=JSON.parse(g)}catch{}return{port:E,break:R,debugId:u,env:t}}}),define(te[107],ie([0,1,285,4,155]),function(V,e,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const o={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,k.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(17,null)},category:{type:"string",cat:"e",description:(0,k.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,k.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,k.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(w,c,u=C){const g=w.find(l=>l.length>0&&l[0]!=="-"),D={},E=["_"],R=[],t={};let a;for(const l in c){const s=c[l];s.type==="subcommand"?l===g&&(a=s):(s.alias&&(D[l]=s.alias),s.type==="string"||s.type==="string[]"?(E.push(l),s.deprecates&&E.push(...s.deprecates)):s.type==="boolean"&&(R.push(l),s.deprecates&&R.push(...s.deprecates)),s.global&&(t[l]=s))}if(a&&g){const l=t;for(const M in a.options)l[M]=a.options[M];const s=w.filter(M=>M!==g),d=u.getSubcommandReporter?u.getSubcommandReporter(g):void 0,y=P(s,l,d);return{[g]:y,_:[]}}const i=I(w,{string:E,boolean:R,alias:D}),n={},r=i;n._=i._.map(l=>String(l)).filter(l=>l.length>0),delete r._;for(const l in c){const s=c[l];if(s.type==="subcommand")continue;s.alias&&delete r[s.alias];let d=r[l];if(s.deprecates)for(const y of s.deprecates)r.hasOwnProperty(y)&&(d||(d=r[y],d&&u.onDeprecatedOption(y,s.deprecationMessage||(0,k.localize)(36,null,l))),delete r[y]);if(typeof d<"u"){if(s.type==="string[]"){if(Array.isArray(d)||(d=[d]),!s.allowEmptyValue){const y=d.filter(M=>M.length>0);y.length!==d.length&&(u.onEmptyValue(l),d=y.length>0?y:void 0)}}else s.type==="string"&&(Array.isArray(d)?(d=d.pop(),u.onMultipleValues(l,d)):!d&&!s.allowEmptyValue&&(u.onEmptyValue(l),d=void 0));n[l]=d,s.deprecationMessage&&u.onDeprecatedOption(l,s.deprecationMessage)}delete r[l]}for(const l in r)u.onUnknownOption(l);return n}e.parseArgs=P;function h(w,c){let u="";return c.args&&(Array.isArray(c.args)?u=` <${c.args.join("> <")}>`:u=` <${c.args}>`),c.alias?`-${c.alias} --${w}${u}`:`--${w}${u}`}function m(w,c){const u=[];for(const g in w){const D=w[g],E=h(g,D);u.push([E,D.description])}return S(u,c)}e.formatOptions=m;function S(w,c){const g=w.reduce((R,t)=>Math.max(R,t[0].length),12)+2+1;if(c-g<25)return w.reduce((R,t)=>R.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const D=c-g-1,E=[];for(const R of w){const t=R[0],a=b(R[1],D),i=v(g-t.length-2);E.push("  "+t+i+a[0]);for(let n=1;n<a.length;n++)E.push(v(g)+a[n])}return E}function v(w){return" ".repeat(w)}function b(w,c){const u=[];for(;w.length;){const g=w.length<c?w.length:w.lastIndexOf(" ",c),D=w.slice(0,g).trim();w=w.slice(g),u.push(D)}return u}function f(w,c,u,g,D){const E=process.stdout.isTTY&&process.stdout.columns||80,R=D?.noInputFiles!==!0?`[${(0,k.localize)(37,null)}...]`:"",t=[`${w} ${u}`];t.push(""),t.push(`${(0,k.localize)(38,null)}: ${c} [${(0,k.localize)(39,null)}]${R}`),t.push(""),D?.noPipe!==!0&&(L.isWindows?t.push((0,k.localize)(40,null,c)):t.push((0,k.localize)(41,null,c)),t.push(""));const a={},i=[];for(const n in g){const r=g[n];if(r.type==="subcommand")r.description&&i.push({command:n,description:r.description});else if(r.description&&r.cat){let l=a[r.cat];l||(a[r.cat]=l={}),l[n]=r}}for(const n in a){const r=n,l=a[r];l&&(t.push(o[r]),t.push(...m(l,E)),t.push(""))}return i.length&&(t.push((0,k.localize)(42,null)),t.push(...S(i.map(n=>[n.command,n.description]),E)),t.push("")),t.join(`
`)}e.buildHelpMessage=f;function p(w,c){return`${w||(0,k.localize)(43,null)}
${c||(0,k.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=p}),define(te[184],ie([0,1,81,182,107]),function(V,e,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class o extends L.ExtensionHostDebugBroadcastChannel{constructor(P){super(),this.f=P}call(P,h,m){return h==="openExtensionDevelopmentHostWindow"?this.g(m[0],m[1]):super.call(P,h,m)}async g(P,h){const m=(0,k.parseArgs)(P,k.OPTIONS);m.debugRenderer=h;const S=m.extensionDevelopmentPath;if(!S)return{success:!1};const[v]=await this.f.openExtensionDevelopmentHostWindow(S,{context:5,cli:m,forceProfile:m.profile,forceTempProfile:m["profile-temp"]});if(!h)return{success:!0};const b=v.win;if(!b)return{success:!0};const f=b.webContents.debugger;let p=f.isAttached()?1/0:0;const w=(0,I.createServer)(c=>{p++===0&&f.attach();let u=!1;const g=R=>{u||c.write(JSON.stringify(R)+"\0")},D=(R,t,a,i)=>g({method:t,params:a,sessionId:i});b.on("close",()=>{f.removeListener("message",D),c.end(),u=!0}),f.addListener("message",D);let E=Buffer.alloc(0);c.on("data",R=>{E=Buffer.concat([E,R]);for(let t=E.indexOf(0);t!==-1;t=E.indexOf(0)){let a;try{const i=E.slice(0,t).toString("utf8");E=E.slice(t+1),a=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}f.sendCommand(a.method,a.params,a.sessionId).then(i=>g({id:a.id,sessionId:a.sessionId,result:i})).catch(i=>g({id:a.id,sessionId:a.sessionId,error:{code:0,message:i.message}}))}}),c.on("error",R=>{console.error("error on cdp pipe:",R)}),c.on("close",()=>{u=!0,--p===0&&f.detach()})});return await new Promise(c=>w.listen(0,c)),b.on("close",()=>w.close()),{rendererDebugPort:w.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=o}),define(te[61],ie([0,1,286,156,107]),function(V,e,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const o=2048;function C(b,f){const p=(E,R)=>{console.warn((0,L.localize)(0,null,E,R))},w=E=>{console.warn((0,L.localize)(1,null,E))},c=(E,R)=>{console.warn((0,L.localize)(2,null,E,R))},u=E=>({onUnknownOption:R=>{E!=="tunnel"&&console.warn((0,L.localize)(3,null,R,E))},onMultipleValues:p,onEmptyValue:w,onDeprecatedOption:c,getSubcommandReporter:E!=="tunnel"?u:void 0}),g={onUnknownOption:E=>{console.warn((0,L.localize)(4,null,E))},onMultipleValues:p,onEmptyValue:w,onDeprecatedOption:c,getSubcommandReporter:u},D=(0,k.parseArgs)(b,k.OPTIONS,f?g:void 0);return D.goto&&D._.forEach(E=>I(/^(\w:)?[^:]+(:\d*){0,2}$/.test(E),(0,L.localize)(5,null))),D["max-memory"]&&I(parseInt(D["max-memory"])>=o,`The max-memory argument cannot be specified lower than ${o} MB.`),D}function P(b){const f=b.findIndex(p=>!/^-/.test(p));if(f>-1)return[...b.slice(0,f),...b.slice(f+1)]}function h(b){let[,...f]=b;process.env.VSCODE_DEV&&(f=P(f)||[]);const p=!v(process.env);return C(f,p)}e.parseMainProcessArgv=h;function m(b){let[,,...f]=b;return process.env.VSCODE_DEV&&(f=P(f)||[]),C(f,!0)}e.parseCLIProcessArgv=m;function S(b,...f){const p=b.indexOf("--");return p===-1?b.push(...f):b.splice(p,0,...f),b}e.addArg=S;function v(b){return b.VSCODE_CLI==="1"}e.isLaunchedFromCli=v}),function(){"use strict";function V(e,I,L){function k(C,P){const h=o(C,P),m=[h];return e.isAbsolute(h)||m.unshift(L),e.resolve(...m)}function o(C,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,P);const S=C["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(v,"AppData","Roaming")}break;case"darwin":m=e.join(I.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,P)}return{getUserDataPath:k}}if(typeof define=="function")define(te[185],ie([186,26,35]),function(e,I,L){return V(e,I,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=V(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[187],ie([0,1,26,183,185]),function(V,e,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class o extends L.AbstractNativeEnvironmentService{constructor(P,h){super(P,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,k.getUserDataPath)(P,h.nameShort)},h)}}e.NativeEnvironmentService=o}),define(te[188],ie([0,1,41,26,32]),function(V,e,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function o(C){const P=(0,k.randomPath)((0,L.tmpdir)());try{return(0,I.writeFileSync)(P,""),C&&console.log(`Marker file for --wait created: ${P}`),P}catch(h){C&&console.error(`Failed to create marker file for --wait: ${h}`);return}}e.createWaitMarkerFileSync=o}),define(te[189],ie([0,1,10,158]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(C,P,h){try{o(C,P,h)}catch(m){console.error(m?.message??m)}return C}e.localizeManifest=k;function o(C,P,h){const m=(S,v,b)=>{const f=S[v];if((0,I.isString)(f)){const p=f,w=p.length;if(w>1&&p[0]==="%"&&p[w-1]==="%"){const c=p.substr(1,w-2);let u=P[c];u===void 0&&h&&(u=h[c]);const g=typeof u=="string"?u:u?.message,D=h?.[c],E=typeof D=="string"?D:D?.message;if(!g){E||console.warn(`[${C.name}]: ${(0,L.localize)(0,null,c)}`);return}if(b&&(v==="title"||v==="category")&&E&&E!==g){const R={value:g,original:E};S[v]=R}else S[v]=g}}else if((0,I.isObject)(f))for(const p in f)f.hasOwnProperty(p)&&(p==="commands"?m(f,p,!0):m(f,p,b));else if(Array.isArray(f))for(let p=0;p<f.length;p++)m(f,p,b)};for(const S in C)C.hasOwnProperty(S)&&m(C,S)}}),define(te[190],ie([0,1,13]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class L{constructor(){this.a=new Map}register(o,C){this.a.set(o,C)}updateManifest(o){if(!(typeof o.main>"u"&&typeof o.browser>"u")&&(o.activationEvents===void 0&&Object.assign(o,{activationEvents:[]}),!(!Array.isArray(o.activationEvents)||!o.contributes)))for(const C in o.contributes){const P=this.a.get(C);if(!P)continue;const h=o.contributes[C],m=Array.isArray(h)?h:[h];try{P(m,o.activationEvents)}catch(S){(0,I.onUnexpectedError)(S)}}}}e.ImplicitActivationEventsImpl=L,e.ImplicitActivationEvents=new L}),define(te[191],ie([0,1,20,83,160,192]),function(V,e,I,L,k,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function h(u){return u=u.trim(),u==="*"||C.test(u)}e.isValidVersionStr=h;function m(u){if(!h(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=u.match(C);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=m;function S(u){if(!u)return null;const g=u.majorBase,D=u.majorMustEqual,E=u.minorBase;let R=u.minorMustEqual;const t=u.patchBase;let a=u.patchMustEqual;u.hasCaret&&(g===0||(R=!1),a=!1);let i=0;if(u.preRelease){const n=P.exec(u.preRelease);if(n){const[,r,l,s]=n;i=Date.UTC(Number(r),Number(l)-1,Number(s))}}return{majorBase:g,majorMustEqual:D,minorBase:E,minorMustEqual:R,patchBase:t,patchMustEqual:a,isMinimum:u.hasGreaterEquals,notBefore:i}}e.normalizeVersion=S;function v(u,g,D){let E;typeof u=="string"?E=S(m(u)):E=u;let R;g instanceof Date?R=g.getTime():typeof g=="string"&&(R=new Date(g).getTime());let t;if(typeof D=="string"?t=S(m(D)):t=D,!E||!t)return!1;const a=E.majorBase,i=E.minorBase,n=E.patchBase;let r=t.majorBase,l=t.minorBase,s=t.patchBase;const d=t.notBefore;let y=t.majorMustEqual,M=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?a>r?!0:a<r?!1:i>l?!0:i<l||R&&R<d?!1:n>=s:(a===1&&r===0&&(!y||!M||!O)&&(r=1,l=0,s=0,y=!0,M=!1,O=!1),a<r?!1:a>r?!y:i<l?!1:i>l?!M:n<s?!1:n>s?!O:!(R&&R<d))}e.isValidVersion=v;function b(u,g,D,E,R){const t=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return t.push([L.default.Error,k.localize(0,null)]),t;if(typeof E.name!="string")return t.push([L.default.Error,k.localize(1,null,"name")]),t;if(typeof E.version!="string")return t.push([L.default.Error,k.localize(2,null,"version")]),t;if(!E.engines)return t.push([L.default.Error,k.localize(3,null,"engines")]),t;if(typeof E.engines.vscode!="string")return t.push([L.default.Error,k.localize(4,null,"engines.vscode")]),t;if(typeof E.extensionDependencies<"u"&&!c(E.extensionDependencies))return t.push([L.default.Error,k.localize(5,null,"extensionDependencies")]),t;if(typeof E.activationEvents<"u"){if(!c(E.activationEvents))return t.push([L.default.Error,k.localize(6,null,"activationEvents")]),t;if(typeof E.main>"u"&&typeof E.browser>"u")return t.push([L.default.Error,k.localize(7,null,"activationEvents","main")]),t}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&t.push([L.default.Warning,k.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return t.push([L.default.Error,k.localize(9,null,"main")]),t;{const n=(0,I.joinPath)(D,E.main);(0,I.isEqualOrParent)(n,D)||t.push([L.default.Warning,k.localize(10,null,n.path,D.path)])}if(typeof E.activationEvents>"u")return t.push([L.default.Error,k.localize(11,null,"activationEvents","main")]),t}if(typeof E.browser<"u"){if(typeof E.browser!="string")return t.push([L.default.Error,k.localize(12,null,"browser")]),t;{const n=(0,I.joinPath)(D,E.browser);(0,I.isEqualOrParent)(n,D)||t.push([L.default.Warning,k.localize(13,null,n.path,D.path)])}if(typeof E.activationEvents>"u")return t.push([L.default.Error,k.localize(14,null,"activationEvents","browser")]),t}if(!o.valid(E.version))return t.push([L.default.Error,k.localize(15,null)]),t;const a=[];if(!f(u,g,E,R,a))for(const n of a)t.push([L.default.Error,n]);return t}e.validateExtensionManifest=b;function f(u,g,D,E,R){return E||typeof D.main>"u"&&typeof D.browser>"u"?!0:w(u,g,D.engines.vscode,R)}e.isValidExtensionVersion=f;function p(u,g,D){return u==="*"||w(g,D,u)}e.isEngineValid=p;function w(u,g,D,E=[]){const R=S(m(D));if(!R)return E.push(k.localize(16,null,D)),!1;if(R.majorBase===0){if(!R.majorMustEqual||!R.minorMustEqual)return E.push(k.localize(17,null,D)),!1}else if(!R.majorMustEqual)return E.push(k.localize(18,null,D)),!1;return v(u,g,R)?!0:(E.push(k.localize(19,null,u,D)),!1)}function c(u){if(!Array.isArray(u))return!1;for(let g=0,D=u.length;g<D;g++)if(typeof u[g]!="string")return!1;return!0}}),define(te[193],ie([0,1,17,31]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(o,C,P){let h=P&&P.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const S=(await C.readFile(o.serviceMachineIdResource)).value.toString();h=(0,L.isUUID)(S)?S:null}catch{h=null}if(!h){h=(0,L.generateUuid)();try{await C.writeFile(o.serviceMachineIdResource,I.VSBuffer.fromString(h))}catch{}}return P?.store("storage.serviceMachineId",h,-1,1),h}e.getServiceMachineId=k}),define(te[73],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class I{constructor(k,o=[],C=!1){this.ctor=k,this.staticArguments=o,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=I}),define(te[194],ie([0,1,73]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var k;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function o(P,h,m){h instanceof I.SyncDescriptor||(h=new I.SyncDescriptor(h,[],Boolean(m))),L.push([P,h])}e.registerSingleton=o;function C(){return L}e.getSingletonServiceDescriptors=C}),define(te[195],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class I{constructor(o,C){this.key=o,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=I;class L{constructor(o){this.b=o,this.a=new Map}roots(){const o=[];for(const C of this.a.values())C.outgoing.size===0&&o.push(C);return o}insertEdge(o,C){const P=this.lookupOrInsertNode(o),h=this.lookupOrInsertNode(C);P.outgoing.set(h.key,h),h.incoming.set(P.key,P)}removeNode(o){const C=this.b(o);this.a.delete(C);for(const P of this.a.values())P.outgoing.delete(C),P.incoming.delete(C)}lookupOrInsertNode(o){const C=this.b(o);let P=this.a.get(C);return P||(P=new I(C,o),this.a.set(C,P)),P}lookup(o){return this.a.get(this.b(o))}isEmpty(){return this.a.size===0}toString(){const o=[];for(const[C,P]of this.a)o.push(`${C}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return o.join(`
`)}findCycleSlow(){for(const[o,C]of this.a){const P=new Set([o]),h=this.c(C,P);if(h)return h}}c(o,C){for(const[P,h]of o.outgoing){if(C.has(P))return[...C,P].join(" -> ");C.add(P);const m=this.c(h,C);if(m)return m;C.delete(P)}}}e.Graph=L}),define(te[6],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var I;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function P(h){return h[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=P})(I=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function L(C,P,h){P[I.DI_TARGET]===P?P[I.DI_DEPENDENCIES].push({id:C,index:h}):(P[I.DI_DEPENDENCIES]=[{id:C,index:h}],P[I.DI_TARGET]=P)}function k(C){if(I.serviceIds.has(C))return I.serviceIds.get(C);const P=function(h,m,S){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(P,h,S)};return P.toString=()=>C,I.serviceIds.set(C,P),P}e.createDecorator=k;function o(C){return C}e.refineServiceDecorator=o}),define(te[62],ie([0,1,6]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,I.createDecorator)("backupMainService")}),define(te[18],ie([0,1,10,7,6]),function(V,e,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function o(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof L.URI)}e.isConfigurationOverrides=o;function C(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=C;var P;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function h(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=h;function m(u,g){const D=Object.create(null);for(const E in u)S(D,E,u[E],g);return D}e.toValuesTree=m;function S(u,g,D,E){const R=g.split("."),t=R.pop();let a=u;for(let i=0;i<R.length;i++){const n=R[i];let r=a[n];switch(typeof r){case"undefined":r=a[n]=Object.create(null);break;case"object":break;default:E(`Ignoring ${g} as ${R.slice(0,i+1).join(".")} is ${JSON.stringify(r)}`);return}a=r}if(typeof a=="object"&&a!==null)try{a[t]=D}catch{E(`Ignoring ${g} as ${R.join(".")} is ${JSON.stringify(a)}`)}else E(`Ignoring ${g} as ${R.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=S;function v(u,g){const D=g.split(".");b(u,D)}e.removeFromValueTree=v;function b(u,g){const D=g.shift();if(g.length===0){delete u[D];return}if(Object.keys(u).indexOf(D)!==-1){const E=u[D];typeof E=="object"&&!Array.isArray(E)&&(b(E,g),Object.keys(E).length===0&&delete u[D])}}function f(u,g,D){function E(a,i){let n=a;for(const r of i){if(typeof n!="object"||n===null)return;n=n[r]}return n}const R=g.split("."),t=E(u,R);return typeof t>"u"?D:t}e.getConfigurationValue=f;function p(u,g,D){Object.keys(g).forEach(E=>{E!=="__proto__"&&(E in u?I.isObject(u[E])&&I.isObject(g[E])?p(u[E],g[E],D):D&&(u[E]=g[E]):u[E]=g[E])})}e.merge=p;function w(u,g,D){const E=u.inspect(g),R=u.inspect(D);return typeof E.userValue<"u"||typeof E.workspaceValue<"u"||typeof E.workspaceFolderValue<"u"?E.value:typeof R.userValue<"u"||typeof R.workspaceValue<"u"||typeof R.workspaceFolderValue<"u"?R.value:E.defaultValue}e.getMigratedSettingValue=w;function c(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=c}),define(te[74],ie([0,1,6]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,I.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,I.createDecorator)("credentialsMainService");class L{constructor(){this.a={}}async getPassword(o,C){return this.a[o]?.[C]??null}async setPassword(o,C,P){this.a[o]=this.a[o]??{},this.a[o][C]=P}async deletePassword(o,C){return this.a[o]?.[C]?(delete this.a[o][C],Object.keys(this.a[o]).length===0&&delete this.a[o],!0):!1}async findPassword(o){return JSON.stringify(this.a[o])??null}async findCredentials(o){const C=[];for(const P of Object.keys(this.a[o]||{}))C.push({account:P,password:this.a[o][P]});return C}async clear(){this.a={}}}e.InMemoryCredentialsProvider=L}),define(te[87],ie([0,1,6]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,I.createDecorator)(e.ID);function L(o){return!!o.hostName&&!!o.errorMessage}e.isRemoteDiagnosticError=L;class k{async getPerformanceInfo(C,P){return{}}async getSystemInfo(C,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,P){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.NullDiagnosticsService=k}),define(te[108],ie([0,1,6]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,I.createDecorator)("encryptionMainService")}),define(te[33],ie([0,1,6]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,I.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,I.refineServiceDecorator)(e.IEnvironmentService)}),define(te[28],ie([0,1,54,9,86,33,187,6]),function(V,e,I,L,k,o,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,P.refineServiceDecorator)(o.IEnvironmentService);class h extends C.NativeEnvironmentService{get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ve([I.memoize],h.prototype,"cachedLanguagesPath",null),ve([I.memoize],h.prototype,"backupHome",null),ve([I.memoize],h.prototype,"mainIPCHandle",null),ve([I.memoize],h.prototype,"mainLockfile",null),ve([I.memoize],h.prototype,"disableUpdates",null),ve([I.memoize],h.prototype,"disableKeytar",null),ve([I.memoize],h.prototype,"crossOriginIsolated",null),ve([I.memoize],h.prototype,"codeCachePath",null),ve([I.memoize],h.prototype,"useCodeCache",null),e.EnvironmentMainService=h}),define(te[196],ie([0,1,157,6]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function o(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=o;function C(u,g){switch(u){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function P(u,g){return g==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function h(u,g,D){return P(g,D)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===D?!0:m(D).includes(u)}e.isTargetPlatformCompatible=h;function m(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function S(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=S;var v;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var b;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(b=e.SortOrder||(e.SortOrder={}));var f;(function(u){u.Install="install",u.Uninstall="uninstall"})(f=e.StatisticType||(e.StatisticType={}));var p;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var w;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(w=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class c extends Error{constructor(g,D){super(g),this.code=D,this.name=D}}e.ExtensionManagementError=c,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,I.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,I.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(te[197],ie([0,1,6]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,I.createDecorator)("extensionUrlTrustService")}),define(te[198],ie([0,1,6]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,I.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[109],ie([0,1,6]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,I.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,I.createDecorator)("externalTerminal")}),define(te[199],ie([0,1,46,15,9,4,82,23,85,161,109]),function(V,e,I,L,k,o,C,P,h,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const v=m.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends b{openTerminal(E,R){return this.spawnTerminal(I,E,h.getWindowsShell(),R)}spawnTerminal(E,R,t,a){const i=R.windowsExec||f.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const n=k.basename(i).toLowerCase();if(n==="cmder"||n==="cmder.exe")return E.spawn(i,a?[a]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return i.indexOf(" ")>=0&&r.push('""'),r.push(i),(n==="wt"||n==="wt.exe")&&r.push("-d ."),new Promise((l,s)=>{const d=c(process),y=E.spawn(t,r,{cwd:a,env:d});y.on("error",s),y.on("exit",()=>l())})}runInTerminal(E,R,t,a,i){const n="windowsExec"in i&&i.windowsExec?i.windowsExec:f.getDefaultTerminalWindows();return new Promise((r,l)=>{const s=`"${R} - ${v}"`,d=`""${t.join('" "')}" & pause"`,y=["/c","start",s,"/wait",n,"/c",d],M=Object.assign({},c(process),a);Object.keys(M).filter(K=>M[K]===null).forEach(K=>delete M[K]);const O={cwd:R,env:M,windowsVerbatimArguments:!0};I.spawn(f.b,y,O).on("error",K=>{l(u(K))}),r(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return f.d}}e.WindowsExternalTerminalService=f,f.b="cmd.exe";class p extends b{openTerminal(E,R){return this.spawnTerminal(I,E,R)}runInTerminal(E,R,t,a,i){const n=i.osxExec||S.DEFAULT_TERMINAL_OSX;return new Promise((r,l)=>{if(n===S.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const s=n===S.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",y=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${s}.scpt`).fsPath,"-t",E||v,"-w",R];for(const j of t)y.push("-a"),y.push(j);if(a){const j=Object.assign({},c(process),a);for(const K in j){const x=j[K];x===null?(y.push("-u"),y.push(K)):(y.push("-e"),y.push(`${K}=${x}`))}}let M="";const O=I.spawn(p.b,y);O.on("error",j=>{l(u(j))}),O.stderr.on("data",j=>{M+=j.toString()}),O.on("exit",j=>{if(j===0)r(void 0);else if(M){const K=M.split(`
`,1);l(new Error(K[0]))}else l(new Error(m.localize(1,null,s,j)))})}else l(new Error(m.localize(2,null,n)))})}spawnTerminal(E,R,t){const a=R.osxExec||S.DEFAULT_TERMINAL_OSX;return new Promise((i,n)=>{const r=["-a",a];t&&r.push(t);const l=c(process),s=E.spawn("/usr/bin/open",r,{cwd:t,env:l});s.on("error",n),s.on("exit",()=>i())})}}e.MacExternalTerminalService=p,p.b="/usr/bin/osascript";class w extends b{openTerminal(E,R){return this.spawnTerminal(I,E,R)}runInTerminal(E,R,t,a,i){const n=i.linuxExec?Promise.resolve(i.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((r,l)=>{const s=[];n.then(d=>{d.indexOf("gnome-terminal")>=0?s.push("-x"):s.push("-e"),s.push("bash"),s.push("-c");const y=`${g(t)}; echo; read -p "${w.b}" -n1;`;s.push(`''${y}''`);const M=Object.assign({},c(process),a);Object.keys(M).filter(x=>M[x]===null).forEach(x=>delete M[x]);const O={cwd:R,env:M};let j="";const K=I.spawn(d,s,O);K.on("error",x=>{l(u(x))}),K.stderr.on("data",x=>{j+=x.toString()}),K.on("exit",x=>{if(x===0)r(void 0);else if(j){const J=j.split(`
`,1);l(new Error(J[0]))}else l(new Error(m.localize(4,null,d,x)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!o.isLinux)w.d=Promise.resolve("xterm");else{const E=await P.Promises.exists("/etc/debian_version");w.d=new Promise(R=>{E?R("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?R("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?R("konsole"):process.env.COLORTERM?R(process.env.COLORTERM):process.env.TERM?R(process.env.TERM):R("xterm")})}return w.d}spawnTerminal(E,R,t){const a=R.linuxExec?Promise.resolve(R.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{a.then(r=>{const l=c(process),s=E.spawn(r,[],{cwd:t,env:l});s.on("error",n),s.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=w,w.b=m.localize(3,null);function c(D){const E={...D.env};return(0,C.sanitizeProcessEnvironment)(E),E}function u(D){return"errno"in D&&D.errno==="ENOENT"&&"path"in D&&typeof D.path=="string"?new Error(m.localize(5,null,D.path)):D}function g(D){let E="";for(const R of D)R.indexOf(" ")>=0?E+='"'+R+'"':E+=R,E+=" ";return E}}),define(te[16],ie([0,1,60,9,27,10,7,163,6,4]),function(V,e,I,L,k,o,C,P,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,h.createDecorator)("fileService");function S(F){return F.create===!0}e.isFileOpenForWriteOptions=S;var v;(function(F){F[F.Unknown=0]="Unknown",F[F.File=1]="File",F[F.Directory=2]="Directory",F[F.SymbolicLink=64]="SymbolicLink"})(v=e.FileType||(e.FileType={}));var b;(function(F){F[F.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var f;(function(F){F[F.None=0]="None",F[F.FileReadWrite=2]="FileReadWrite",F[F.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",F[F.FileReadStream=16]="FileReadStream",F[F.FileFolderCopy=8]="FileFolderCopy",F[F.PathCaseSensitive=1024]="PathCaseSensitive",F[F.Readonly=2048]="Readonly",F[F.Trash=4096]="Trash",F[F.FileWriteUnlock=8192]="FileWriteUnlock",F[F.FileAtomicRead=16384]="FileAtomicRead",F[F.FileClone=32768]="FileClone"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(F){return!!(F.capabilities&2)}e.hasReadWriteCapability=p;function w(F){return!!(F.capabilities&8)}e.hasFileFolderCopyCapability=w;function c(F){return!!(F.capabilities&32768)}e.hasFileCloneCapability=c;function u(F){return!!(F.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function g(F){return!!(F.capabilities&16)}e.hasFileReadStreamCapability=g;function D(F){return p(F)?!!(F.capabilities&16384):!1}e.hasFileAtomicReadCapability=D;var E;(function(F){F.FileExists="EntryExists",F.FileNotFound="EntryNotFound",F.FileNotADirectory="EntryNotADirectory",F.FileIsADirectory="EntryIsADirectory",F.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",F.FileTooLarge="EntryTooLarge",F.FileWriteLocked="EntryWriteLocked",F.NoPermissions="NoPermissions",F.Unavailable="Unavailable",F.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class R extends Error{constructor(U,z){super(U),this.code=z}}e.FileSystemProviderError=R;function t(F,U){const z=new R(F.toString(),U);return i(z,U),z}e.createFileSystemProviderError=t;function a(F){return F||t((0,P.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=a;function i(F,U){return F.name=U?`${U} (FileSystemError)`:"FileSystemError",F}e.markAsFileSystemProviderError=i;function n(F){if(!F)return E.Unknown;if(F instanceof R)return F.code;const U=/^(.+) \(FileSystemError\)$/.exec(F.name);if(!U)return E.Unknown;switch(U[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=n;function r(F){if(F instanceof O)return F.fileOperationResult;switch(n(F)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var l;(function(F){F[F.CREATE=0]="CREATE",F[F.DELETE=1]="DELETE",F[F.MOVE=2]="MOVE",F[F.COPY=3]="COPY",F[F.WRITE=4]="WRITE"})(l=e.FileOperation||(e.FileOperation={}));class s{constructor(U,z,Y){this.resource=U,this.operation=z,this.target=Y}isOperation(U){return this.operation===U}}e.FileOperationEvent=s;var d;(function(F){F[F.UPDATED=0]="UPDATED",F[F.ADDED=1]="ADDED",F[F.DELETED=2]="DELETED"})(d=e.FileChangeType||(e.FileChangeType={}));class y{constructor(U,z){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const Y=new Map;for(const ne of U){const _=Y.get(ne.type);switch(_?_.push([ne.resource,ne]):Y.set(ne.type,[[ne.resource,ne]]),ne.type){case 1:this.rawAdded.push(ne.resource);break;case 0:this.rawUpdated.push(ne.resource);break;case 2:this.rawDeleted.push(ne.resource);break}}for(const[ne,_]of Y)switch(ne){case 1:this.a=I.TernarySearchTree.forUris(()=>z),this.a.fill(_);break;case 0:this.b=I.TernarySearchTree.forUris(()=>z),this.b.fill(_);break;case 2:this.c=I.TernarySearchTree.forUris(()=>z),this.c.fill(_);break}}contains(U,...z){return this.d(U,{includeChildren:!1},...z)}affects(U,...z){return this.d(U,{includeChildren:!0},...z)}d(U,z,...Y){if(!U)return!1;const ne=Y.length>0;return!!((!ne||Y.includes(1))&&(this.a?.get(U)||z.includeChildren&&this.a?.findSuperstr(U))||(!ne||Y.includes(0))&&(this.b?.get(U)||z.includeChildren&&this.b?.findSuperstr(U))||(!ne||Y.includes(2))&&(this.c?.findSubstr(U)||z.includeChildren&&this.c?.findSuperstr(U)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=y;function M(F,U,z){return!F||!U||F===U||U.length>F.length?!1:(U.charAt(U.length-1)!==L.sep&&(U+=L.sep),z?(0,k.startsWithIgnoreCase)(F,U):F.indexOf(U)===0)}e.isParent=M;class O extends Error{constructor(U,z,Y){super(U),this.fileOperationResult=z,this.options=Y}}e.FileOperationError=O;class j extends O{constructor(U,z,Y,ne){super(U,z,ne),this.fileOperationResult=z,this.size=Y}}e.TooLargeFileOperationError=j;class K extends O{constructor(U,z,Y){super(U,2,Y),this.stat=z}}e.NotModifiedSinceFileOperationError=K;var x;(function(F){F[F.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",F[F.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",F[F.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",F[F.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",F[F.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",F[F.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",F[F.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",F[F.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",F[F.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",F[F.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",F[F.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",F[F.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(x=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var J;(function(F){F[F.FILE=0]="FILE",F[F.FOLDER=1]="FOLDER",F[F.ROOT_FOLDER=2]="ROOT_FOLDER"})(J=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function re(F){if(!(typeof F.size!="number"||typeof F.mtime!="number"))return F.mtime.toString(29)+F.size.toString(31)}e.etag=re;async function se(F,U){if(!U.hasProvider(C.URI.from({scheme:F.scheme})))return new Promise(z=>{const Y=U.onDidChangeFileSystemProviderRegistrations(ne=>{ne.scheme===F.scheme&&ne.added&&(Y.dispose(),z())})})}e.whenProviderRegistered=se,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ae{static formatSize(U){return(0,o.isNumber)(U)||(U=0),U<ae.KB?(0,P.localize)(1,null,U.toFixed(0)):U<ae.MB?(0,P.localize)(2,null,(U/ae.KB).toFixed(2)):U<ae.GB?(0,P.localize)(3,null,(U/ae.MB).toFixed(2)):U<ae.TB?(0,P.localize)(4,null,(U/ae.GB).toFixed(2)):(0,P.localize)(5,null,(U/ae.TB).toFixed(2))}}e.ByteSize=ae,ae.KB=1024,ae.MB=ae.KB*ae.KB,ae.GB=ae.MB*ae.KB,ae.TB=ae.GB*ae.KB;var fe;(function(F){F[F.IA32=0]="IA32",F[F.OTHER=1]="OTHER"})(fe=e.Arch||(e.Arch={}));function ge(F){return{maxFileSize:F===0?300*ae.MB:16*ae.GB,maxHeapSize:F===0?700*ae.MB:2*700*ae.MB}}e.getPlatformFileLimits=ge;function H(F){return m.isWeb?F?10*ae.MB:50*ae.MB:F?100*ae.MB:1024*ae.MB}e.getLargeFileConfirmationLimit=H}),define(te[200],ie([0,1,17,45,13,3,2,59,7,31,16]),function(V,e,I,L,k,o,C,P,h,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class v extends C.Disposable{constructor(f,p){super(),this.a=f,this.b=p,this.onDidChangeCapabilities=o.Event.None,this.f=this.B(new o.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new o.Emitter),this.onDidWatchError=this.g.event,this.h=(0,m.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,p){const{buffer:w}=await this.a.call("readFile",[f,p]);return w}readFileStream(f,p,w){const c=(0,P.newWriteableStream)(g=>I.VSBuffer.concat(g.map(D=>I.VSBuffer.wrap(D))).buffer),u=this.a.listen("readFileStream",[f,p])(g=>{if(g instanceof I.VSBuffer)c.write(g.buffer);else{if(g==="end")c.end();else{let D;if(g instanceof Error)D=g;else{const E=g;D=(0,S.createFileSystemProviderError)(E.message??(0,L.toErrorMessage)(E),E.code??S.FileSystemProviderErrorCode.Unknown)}c.error(D),c.end()}u.dispose()}});return w.onCancellationRequested(()=>{c.error((0,k.canceled)()),c.end(),u.dispose()}),c}writeFile(f,p,w){return this.a.call("writeFile",[f,I.VSBuffer.wrap(p),w])}open(f,p){return this.a.call("open",[f,p])}close(f){return this.a.call("close",[f])}async read(f,p,w,c,u){const[g,D]=await this.a.call("read",[f,p,u]);return w.set(g.buffer.slice(0,D),c),D}write(f,p,w,c,u){return this.a.call("write",[f,p,I.VSBuffer.wrap(w),c,u])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,p){return this.a.call("delete",[f,p])}rename(f,p,w){return this.a.call("rename",[f,p,w])}copy(f,p,w){return this.a.call("copy",[f,p,w])}cloneFile(f,p){return this.a.call("cloneFile",[f,p])}i(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const p=f;this.f.fire(p.map(w=>({resource:h.URI.revive(w.resource),type:w.type})))}else{const p=f;this.g.fire(p)}}))}watch(f,p){const w=(0,m.generateUuid)();return this.a.call("watch",[this.h,w,f,p]),(0,C.toDisposable)(()=>this.a.call("unwatch",[this.h,w]))}}e.DiskFileSystemProviderClient=v}),define(te[110],ie([0,1,17,13,164,16]),function(V,e,I,L,k,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function C(S,v,b,f,p,w){let c;try{await P(S,v,b,f,p,w)}catch(u){c=u}finally{c&&p.errorTransformer&&(c=p.errorTransformer(c)),typeof c<"u"&&b.error(c),b.end()}}e.readFileIntoStream=C;async function P(S,v,b,f,p,w){h(w);const c=await S.open(v,{create:!1});try{h(w);let u=0,g=0,D=p&&typeof p.length=="number"?p.length:void 0,E=I.VSBuffer.alloc(Math.min(p.bufferSize,typeof D=="number"?D:p.bufferSize)),R=p&&typeof p.position=="number"?p.position:0,t=0;do g=await S.read(c,R,E.buffer,t,E.byteLength-t),R+=g,t+=g,u+=g,typeof D=="number"&&(D-=g),t===E.byteLength&&(await b.write(f(E)),E=I.VSBuffer.alloc(Math.min(p.bufferSize,typeof D=="number"?D:p.bufferSize)),t=0);while(g>0&&(typeof D!="number"||D>0)&&h(w)&&m(u,p));if(t>0){let a=t;typeof D=="number"&&(a=Math.min(t,D)),b.write(f(E.slice(0,a)))}}catch(u){throw(0,o.ensureFileSystemProviderError)(u)}finally{await S.close(c)}}function h(S){if(S.isCancellationRequested)throw(0,L.canceled)();return!0}function m(S,v){if(v?.limits){if(typeof v.limits.memory=="number"&&S>v.limits.memory)throw(0,o.createFileSystemProviderError)((0,k.localize)(0,null),o.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof v.limits.size=="number"&&S>v.limits.size)throw(0,o.createFileSystemProviderError)((0,k.localize)(1,null),o.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[75],ie([0,1,101,2,9,4,7,16]),function(V,e,I,L,k,o,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function h(u){return u.recursive===!0}e.isRecursiveWatchRequest=h;class m extends L.Disposable{constructor(g,D,E,R){super(),this.h=g,this.i=D,this.j=E,this.k=R,this.c=this.B(new L.MutableDisposable),this.f=void 0,this.g=0}m(){const g=new L.DisposableStore;this.c.value=g,this.b=this.l(g),this.b.setVerboseLogging(this.j),g.add(this.b.onDidChangeFile(D=>this.h(D))),g.add(this.b.onDidLogMessage(D=>this.i(D))),g.add(this.b.onDidError(D=>this.n(D)))}n(g){this.k.restartOnError?this.g<m.a&&this.f?(this.r(`restarting watcher after error: ${g}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${g}`):this.r(g)}p(g){this.g++,this.m(),this.watch(g)}async watch(g){this.f=g,await this.b?.watch(g)}async setVerboseLogging(g){this.j=g,await this.b?.setVerboseLogging(g)}r(g){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${g}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=m,m.a=5;class S extends m{constructor(g,D,E){super(g,D,E,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=S;class v extends m{constructor(g,D,E){super(g,D,E,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=v;function b(u){return u.map(g=>({type:g.type,resource:C.URI.file(g.path)}))}e.toFileChanges=b;function f(u){const g=new c;for(const D of u)g.processEvent(D);return g.coalesce()}e.coalesceEvents=f;function p(u,g){return typeof g=="string"&&!g.startsWith(I.GLOBSTAR)&&!(0,k.isAbsolute)(g)?{base:u,pattern:g}:g}e.normalizeWatcherPattern=p;function w(u,g){const D=[];for(const E of g)D.push((0,I.parse)(p(u,E)));return D}e.parseWatcherPatterns=w;class c{constructor(){this.a=new Set,this.b=new Map}c(g){return o.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const D=this.b.get(this.c(g));let E=!1;if(D){const R=D.type,t=g.type;D.path!==g.path&&(g.type===2||g.type===1)?E=!0:R===1&&t===2?(this.b.delete(this.c(g)),this.a.delete(D)):R===2&&t===1?D.type=0:R===1&&t===0||(D.type=t)}else E=!0;E&&(this.a.add(g),this.b.set(this.c(g),g))}coalesce(){const g=[],D=[];return Array.from(this.a).filter(E=>E.type!==2?(g.push(E),!1):!0).sort((E,R)=>E.path.length-R.path.length).filter(E=>D.some(R=>(0,P.isParent)(E.path,R,!o.isLinux))?!1:(D.push(E.path),!0)).concat(g)}}}),define(te[201],ie([0,1,41,8,22,32,2,79,9,4,102,23,75]),function(V,e,I,L,k,o,C,P,h,m,S,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class f extends C.Disposable{constructor(c,u,g,D){super(),this.j=c,this.k=u,this.l=g,this.m=D,this.c=this.B(new L.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},E=>this.k(E))),this.f=this.B(new L.RunOnceWorker(E=>this.u(E),f.b)),this.g=(0,b.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,b.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new k.CancellationTokenSource,this.ready=this.n()}async n(){try{const c=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const u=await v.Promises.stat(c);this.B(await this.s(c,u.isDirectory()))}catch(c){c.code!=="ENOENT"?this.w(c):this.z(c)}}async r(c){let u=c.path;try{u=await v.Promises.realpath(c.path),c.path===u&&(u=await(0,S.realcase)(c.path)??c.path),c.path!==u&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${c.path}, real: ${u})`)}catch{}return u}async s(c,u){if(m.isMacintosh&&(0,o.isEqualOrParent)(c,"/Volumes/",!0))return this.w(`Refusing to watch ${c} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.Disposable.None;const g=new k.CancellationTokenSource(this.i.token),D=new C.DisposableStore;try{const E=(0,h.basename)(c),R=(0,I.watch)(c);D.add((0,C.toDisposable)(()=>{R.removeAllListeners(),R.close()})),this.z(`Started watching: '${c}'`);const t=new Set;if(u)try{for(const i of await v.Promises.readdir(c))t.add(i)}catch(i){this.w(i)}const a=new Map;D.add((0,C.toDisposable)(()=>{for(const[,i]of a)i.dispose();a.clear()})),R.on("error",(i,n)=>{this.w(`Failed to watch ${c} for changes using fs.watch() (${i}, ${n})`),this.dispose()}),R.on("change",(i,n)=>{if(g.token.isCancellationRequested)return;this.z(`[raw] ["${i}"] ${n}`);let r="";if(n&&(r=n.toString(),m.isMacintosh&&(r=(0,P.normalizeNFC)(r))),!(!r||i!=="change"&&i!=="rename"))if(u)if(i==="rename"){a.get(r)?.dispose();const l=setTimeout(async()=>{if(a.delete(r),r===E&&!await v.Promises.exists(c)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const s=await this.v((0,h.join)(c,r));if(g.token.isCancellationRequested)return;let d;s?t.has(r)?d=0:(d=1,t.add(r)):(t.delete(r),d=2),this.t({path:(0,h.join)(this.j.path,r),type:d})},f.a);a.set(r,(0,C.toDisposable)(()=>clearTimeout(l)))}else{let l;t.has(r)?l=0:(l=1,t.add(r)),this.t({path:(0,h.join)(this.j.path,r),type:l})}else if(i==="rename"||r!==E){const l=setTimeout(async()=>{const s=await v.Promises.exists(c);g.token.isCancellationRequested||(s?(this.t({path:this.j.path,type:0},!0),D.add(await this.s(c,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},f.a);D.clear(),D.add((0,C.toDisposable)(()=>clearTimeout(l)))}else this.t({path:this.j.path,type:0},!0)})}catch(E){await v.Promises.exists(c)&&!g.token.isCancellationRequested&&this.w(`Failed to watch ${c} for changes using fs.watch() (${E.toString()})`)}return(0,C.toDisposable)(()=>{g.dispose(!0),D.dispose()})}t(c,u=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`),!u&&this.g.some(g=>g(c.path))?this.m&&this.z(` >> ignored (excluded) ${c.path}`):!u&&this.h&&this.h.length>0&&!this.h.some(g=>g(c.path))?this.m&&this.z(` >> ignored (not included) ${c.path}`):this.f.work(c))}u(c){const u=(0,b.coalesceEvents)(c);if(u.length>0){if(this.m)for(const D of u)this.z(`>> normalized ${D.type===1?"[ADDED]":D.type===2?"[DELETED]":"[CHANGED]"} ${D.path}`);this.c.work(u)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(c){if(m.isLinux)return v.Promises.exists(c);try{const u=(0,h.basename)(c);return(await v.Promises.readdir((0,h.dirname)(c))).some(D=>D===u)}catch(u){return this.z(u),!1}}setVerboseLogging(c){this.m=c}w(c){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${c}`})}y(c){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${c}`})}z(c){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${c}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=f,f.a=100,f.b=75;async function p(w,c,u,g,D=512){const E=await v.Promises.open(w,"r"),R=Buffer.allocUnsafe(D),t=new k.CancellationTokenSource(g);let a,i=!1;const n={path:w,excludes:[],recursive:!1},r=new f(n,l=>{(async()=>{for(const{type:s}of l)if(s===0){if(i)return;i=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:d}=await v.Promises.read(E,R,0,D,null);if(!d||t.token.isCancellationRequested)break;c(R.slice(0,d))}}catch(d){a=new Error(d),t.dispose(!0)}finally{i=!1}}})()});return await r.ready,u(),new Promise((l,s)=>{t.token.onCancellationRequested(async()=>{r.dispose();try{await v.Promises.close(E)}catch(d){a=new Error(d)}a?s(a):l()})})}e.watchFileContents=p}),define(te[202],ie([0,1,3,101,2,4,201]),function(V,e,I,L,k,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new I.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new I.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=I.Event.None,this.c=new Map,this.f=!1}async watch(m){const S=this.i(m),v=S.filter(f=>{const p=this.c.get(f.path);return p?!(0,L.patternsEquals)(p.request.excludes,f.excludes)||!(0,L.patternsEquals)(p.request.includes,f.includes):!0}),b=Array.from(this.c.values()).filter(({request:f})=>!S.find(p=>p.path===f.path&&(0,L.patternsEquals)(p.excludes,f.excludes)&&(0,L.patternsEquals)(p.includes,f.includes))).map(({request:f})=>f.path);v.length&&this.j(`Request to start watching: ${v.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),b.length&&this.j(`Request to stop watching: ${b.join(",")}`);for(const f of b)this.h(f);for(const f of v)this.g(f)}g(m){const S=new C.NodeJSFileWatcherLibrary(m,b=>this.a.fire(b),b=>this.b.fire(b),this.f),v={request:m,instance:S};this.c.set(m.path,v)}async stop(){for(const[m]of this.c)this.h(m);this.c.clear()}h(m){const S=this.c.get(m);S&&(this.c.delete(m),S.instance.dispose())}i(m){const S=new Map;for(const v of m){const b=o.isLinux?v.path:v.path.toLowerCase();S.set(b,v)}return Array.from(S.values())}async setVerboseLogging(m){this.f=m;for(const[,S]of this.c)S.instance.setVerboseLogging(m)}j(m){this.f&&this.b.fire({type:"trace",message:this.k(m)})}k(m,S){return S?`[File Watcher (node.js)] ${m} (path: ${S.request.path})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=P}),define(te[203],ie([0,1,75,202]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends I.AbstractNonRecursiveWatcherClient{constructor(C,P,h){super(C,P,h),this.m()}l(){return new L.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(te[204],ie([0,1,15,47,150,75]),function(V,e,I,L,k,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class C extends o.AbstractUniversalWatcherClient{constructor(h,m,S){super(h,m,S),this.m()}l(h){const m=h.add(new k.Client(I.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(m.onDidProcessExit(({code:S,signal:v})=>this.n(`terminated by itself with code ${S}, signal: ${v}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(m.getChannel("watcher")))}}e.UniversalWatcherClient=C}),define(te[88],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class I{constructor(...k){this.a=new Map;for(const[o,C]of k)this.set(o,C)}set(k,o){const C=this.a.get(k);return this.a.set(k,o),C}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.ServiceCollection=I}),define(te[205],ie([0,1,8,13,2,73,195,6,88,98]),function(V,e,I,L,k,o,C,P,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const S=!1;class v extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class b{constructor(c=new h.ServiceCollection,u=!1,g,D=S){this.f=c,this.g=u,this.h=g,this.i=D,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=D?g?._globalGraph??new C.Graph(E=>E):void 0}createChild(c){return new b(c,this.g,this,this.i)}invokeFunction(c,...u){const g=p.traceInvocation(this.i,c);let D=!1;try{return c({get:R=>{if(D)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(R,g);if(!t)throw new Error(`[invokeFunction] unknown service '${R}'`);return t}},...u)}finally{D=!0,g.stop()}}createInstance(c,...u){let g,D;return c instanceof o.SyncDescriptor?(g=p.traceCreation(this.i,c.ctor),D=this.j(c.ctor,c.staticArguments.concat(u),g)):(g=p.traceCreation(this.i,c),D=this.j(c,u,g)),g.stop(),D}j(c,u=[],g){const D=P._util.getServiceDependencies(c).sort((t,a)=>t.index-a.index),E=[];for(const t of D){const a=this.m(t.id,g);a||this.u(`[createInstance] ${c.name} depends on UNKNOWN service ${t.id}.`,!1),E.push(a)}const R=D.length>0?D[0].index:u.length;if(u.length!==R){console.trace(`[createInstance] First service dependency of ${c.name} at position ${R+1} conflicts with ${u.length} static arguments`);const t=R-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,R)}return Reflect.construct(c,u.concat(E))}k(c,u){if(this.f.get(c)instanceof o.SyncDescriptor)this.f.set(c,u);else if(this.h)this.h.k(c,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(c){const u=this.f.get(c);return!u&&this.h?this.h.l(c):u}m(c,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const g=this.l(c);return g instanceof o.SyncDescriptor?this.q(c,g,u.branch(c,!0)):(u.branch(c,!1),g)}q(c,u,g){if(this.o.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.o.add(c);try{return this.r(c,u,g)}finally{this.o.delete(c)}}r(c,u,g){const D=new C.Graph(t=>t.id.toString());let E=0;const R=[{id:c,desc:u,_trace:g}];for(;R.length;){const t=R.pop();if(D.lookupOrInsertNode(t),E++>1e3)throw new v(D);for(const a of P._util.getServiceDependencies(t.desc.ctor)){const i=this.l(a.id);if(i||this.u(`[createInstance] ${c} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),i instanceof o.SyncDescriptor){const n={id:a.id,desc:i,_trace:t._trace.branch(a.id,!0)};D.insertEdge(t,n),R.push(n)}}}for(;;){const t=D.roots();if(t.length===0){if(!D.isEmpty())throw new v(D);break}for(const{data:a}of t){if(this.l(a.id)instanceof o.SyncDescriptor){const n=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,n)}D.removeNode(a)}}return this.l(c)}s(c,u,g=[],D,E){if(this.f.get(c)instanceof o.SyncDescriptor)return this.t(c,u,g,D,E);if(this.h)return this.h.s(c,u,g,D,E);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(c,u,g=[],D,E){if(D){const R=new b(void 0,this.g,this,this.i);R.c=String(c);const t=new Map,a=new I.IdleValue(()=>{const i=R.j(u,g,E);for(const[n,r]of t){const l=i[n];if(typeof l=="function")for(const s of r)l.apply(i,s)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!a.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let s=t.get(n);return s||(s=new m.LinkedList,t.set(n,s)),(y,M,O)=>{const j=s.push([y,M,O]);return(0,k.toDisposable)(j)}}if(n in i)return i[n];const r=a.value;let l=r[n];return typeof l!="function"||(l=l.bind(r),i[n]=l),l},set(i,n,r){return a.value[n]=r,!0},getPrototypeOf(i){return u.prototype}})}else return this.j(u,g,E)}u(c,u){if(u&&console.warn(c),this.g)throw new Error(c)}}e.InstantiationService=b;var f;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(f||(f={}));class p{static traceInvocation(c,u){return c?new p(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(c,u){return c?new p(1,u.name):p.c}constructor(c,u){this.type=c,this.name=u,this.g=Date.now(),this.h=[]}branch(c,u){const g=new p(3,c.toString());return this.h.push([c,u,g]),g}stop(){const c=Date.now()-this.g;p.f+=c;let u=!1;function g(E,R){const t=[],a=new Array(E+1).join("	");for(const[i,n,r]of R.h)if(n&&r){u=!0,t.push(`${a}CREATES -> ${i}`);const l=g(E+1,r);l&&t.push(l)}else t.push(`${a}uses -> ${i}`);return t.join(`
`)}const D=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(c>2||u)&&p.all.add(D.join(`
`))}}e.Trace=p,p.all=new Set,p.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}},p.f=0}),define(te[5],ie([0,1,45,3,2,38,4,10,7,6]),function(V,e,I,L,k,o,C,P,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.setLogLevel=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function S(){return new Date().toISOString()}function v(d){return(0,P.isNumber)(d)}e.isLogLevel=v;var b;(function(d){d[d.Off=0]="Off",d[d.Trace=1]="Trace",d[d.Debug=2]="Debug",d[d.Info=3]="Info",d[d.Warning=4]="Warning",d[d.Error=5]="Error"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function f(d,y,M){switch(y){case b.Trace:d.trace(M);break;case b.Debug:d.debug(M);break;case b.Info:d.info(M);break;case b.Warning:d.warn(M);break;case b.Error:d.error(M);break;case b.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=f;function p(d){let y="";for(let M=0;M<d.length;M++){let O=d[M];if(typeof O=="object")try{O=JSON.stringify(O)}catch{}y+=(M>0?" ":"")+O}return y}e.format=p;class w extends k.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new L.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==b.Off&&this.b<=y}}e.AbstractLogger=w;class c extends w{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...M){this.f(b.Trace)&&this.g(b.Trace,p([y,...M]))}debug(y,...M){this.f(b.Debug)&&this.g(b.Debug,p([y,...M]))}info(y,...M){this.f(b.Info)&&this.g(b.Info,p([y,...M]))}warn(y,...M){this.f(b.Warning)&&this.g(b.Warning,p([y,...M]))}error(y,...M){if(this.f(b.Error))if(y instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=y.stack,this.g(b.Error,p(O))}else this.g(b.Error,p([y,...M]))}flush(){}}e.AbstractMessageLogger=c;class u extends w{constructor(y=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(y),this.g=!C.isWindows}trace(y,...M){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,y,...M):console.log(`[main ${S()}]`,y,...M))}debug(y,...M){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,y,...M):console.log(`[main ${S()}]`,y,...M))}info(y,...M){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,y,...M):console.log(`[main ${S()}]`,y,...M))}warn(y,...M){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,y,...M):console.warn(`[main ${S()}]`,y,...M))}error(y,...M){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,y,...M):console.error(`[main ${S()}]`,y,...M))}dispose(){}flush(){}}e.ConsoleMainLogger=u;class g extends w{constructor(y=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(y)}trace(y,...M){this.f(b.Trace)&&console.log("%cTRACE","color: #888",y,...M)}debug(y,...M){this.f(b.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",y,...M)}info(y,...M){this.f(b.Info)&&console.log("%c INFO","color: #33f",y,...M)}warn(y,...M){this.f(b.Warning)&&console.log("%c WARN","color: #993",y,...M)}error(y,...M){this.f(b.Error)&&console.log("%c  ERR","color: #f33",y,...M)}dispose(){}flush(){}}e.ConsoleLogger=g;class D extends w{constructor(y,M=e.DEFAULT_LOG_LEVEL){super(),this.g=y,this.setLevel(M)}trace(y,...M){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(y),...M])}debug(y,...M){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(y),...M])}info(y,...M){this.f(b.Info)&&this.g.log(b.Info,[this.h(y),...M])}warn(y,...M){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(y),...M])}error(y,...M){this.f(b.Error)&&this.g.log(b.Error,[this.h(y),...M])}h(y){return typeof y=="string"?y:(0,I.toErrorMessage)(y,this.f(b.Trace))}dispose(){}flush(){}}e.AdapterLogger=D;class E extends w{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const M of this.g)M.setLevel(y);super.setLevel(y)}trace(y,...M){for(const O of this.g)O.trace(y,...M)}debug(y,...M){for(const O of this.g)O.debug(y,...M)}info(y,...M){for(const O of this.g)O.info(y,...M)}warn(y,...M){for(const O of this.g)O.warn(y,...M)}error(y,...M){for(const O of this.g)O.error(y,...M)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose()}}e.MultiplexLogger=E;class R extends k.Disposable{constructor(y,M){if(super(),this.j=y,this.b=new o.ResourceMap,this.c=new o.ResourceMap,this.f=this.B(new L.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new L.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new L.Emitter),this.onDidChangeVisibility=this.h.event,M)for(const O of M)this.c.set(O.resource,O)}getLogger(y){return this.b.get(y)}createLogger(y,M,O){let j=this.b.get(y);if(!j){const K=M?.logLevel==="always"?b.Trace:M?.logLevel;j=this.k(y,K??this.getLogLevel(y)??this.j,M),this.b.set(y,j),O||this.registerLogger({resource:y,id:M?.id??y.toString(),logLevel:K,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId})}return j}setLogLevel(y,M){if(h.URI.isUri(y)){const O=y,j=M,K=this.c.get(O);K&&j!==K.logLevel&&(K.logLevel=j===this.j?void 0:j,this.b.get(O)?.setLevel(j),this.c.set(K.resource,K),this.g.fire([O,j]))}else{this.j=y;for(const[O,j]of this.b.entries())this.c.get(O)?.logLevel===void 0&&j.setLevel(this.j);this.g.fire(this.j)}}setVisibility(y,M){const O=this.c.get(y);O&&M!==!O.hidden&&(O.hidden=!M,this.c.set(O.resource,O),this.h.fire([y,M]))}getLogLevel(y){let M;return y&&(M=this.c.get(y)?.logLevel),M??this.j}registerLogger(y){const M=this.c.get(y.resource);M?M.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.c.set(y.resource,y),this.f.fire({added:[y],removed:[]}))}deregisterLogger(y){const M=this.c.get(y);if(M){this.c.delete(y);const O=this.b.get(y);O&&(this.b.delete(y),O.dispose()),this.f.fire({added:[],removed:[M]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(y){return this.c.get(y)}dispose(){this.b.forEach(y=>y.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=R;class t{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(y){}getLevel(){return b.Info}trace(y,...M){}debug(y,...M){}info(y,...M){}warn(y,...M){}error(y,...M){}critical(y,...M){}dispose(){}flush(){}}e.NullLogger=t;class a extends t{}e.NullLogService=a;class i extends R{constructor(){super(b.Info)}k(y,M,O){return new t}}e.NullLoggerService=i;function n(d){if(d.verbose)return b.Trace;if(typeof d.logLevel=="string"){const y=l(d.logLevel.toLowerCase());if(y!==void 0)return y}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function r(d){switch(d){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.LogLevelToString=r;function l(d){switch(d){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.parseLogLevel=l;function s(d,y){v(y)?d.setLogLevel(y):d.setLogLevel(y[0],y[1])}e.setLogLevel=s});var ee=this&&this.__param||function(V,e){return function(I,L){e(I,L,V)}};define(te[206],ie([0,1,74,3,2,5,4,8]),function(V,e,I,L,k,o,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let h=class Pt extends k.Disposable{constructor(S){super(),this.g=S,this.c=this.B(new L.Emitter),this.onDidChangePassword=this.c.event}async getPassword(S,v){this.g.trace("Getting password from keytar:",S,v);let b;try{b=await this.h()}catch{return null}const f=await(0,P.retry)(()=>b.getPassword(S,v),50,3);if(!f)return this.g.trace("Did not get a password from keytar for account:",v),f;let p,w;try{const c=JSON.parse(f);p=c.content,w=c.hasNextChunk}catch{}if(!p||!w)return this.g.trace("Got password from keytar for account:",v),f;try{let c=1;for(;w;){const u=await(0,P.retry)(()=>b.getPassword(S,`${v}-${c}`),50,3),g=JSON.parse(u);p+=g.content,w=g.hasNextChunk,c++}return this.g.trace(`Got ${c}-chunked password from keytar for account:`,v),p}catch(c){return this.g.error(c),f}}async setPassword(S,v,b){this.g.trace("Setting password using keytar:",S,v);let f;try{f=await this.h()}catch(p){throw this.i?.(p),p}if(C.isWindows&&b.length>Pt.a){let p=0,w=0,c=!0;for(;c;){const u=b.substring(p,p+Pt.b);p+=Pt.b,c=b.length-p>0;const g={content:u,hasNextChunk:c};await(0,P.retry)(()=>f.setPassword(S,w?`${v}-${w}`:v,JSON.stringify(g)),50,3),w++}this.g.trace(`Got${w?` ${w}-chunked`:""} password from keytar for account:`,v)}else await(0,P.retry)(()=>f.setPassword(S,v,b),50,3),this.g.trace("Got password from keytar for account:",v);this.c.fire({service:S,account:v})}async deletePassword(S,v){this.g.trace("Deleting password using keytar:",S,v);let b;try{b=await this.h()}catch(u){throw this.i?.(u),u}const f=await b.getPassword(S,v);if(!f)return this.g.trace("Did not get a password to delete from keytar for account:",v),!1;let p,w;try{const u=JSON.parse(f);p=u.content,w=u.hasNextChunk}catch{}let c=0;if(p&&w)try{for(c++;w;){const u=`${v}-${c}`,g=await b.getPassword(S,u);await b.deletePassword(S,u),w=JSON.parse(g).hasNextChunk,c++}}catch(u){this.g.error(u)}return await b.deletePassword(S,v)?(this.c.fire({service:S,account:v}),this.g.trace(`Deleted${c?` ${c}-chunked`:""} password from keytar for account:`,v),!0):(this.g.trace(`Keytar failed to delete${c?` ${c}-chunked`:""} password for account:`,v),!1)}async findPassword(S){let v;try{v=await this.h()}catch{return null}return await v.findPassword(S)}async findCredentials(S){let v;try{v=await this.h()}catch{return[]}return await v.findCredentials(S)}clear(){return this.f instanceof I.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};h.a=2500,h.b=h.a-100,h=ve([ee(0,o.ILogService)],h),e.BaseCredentialsMainService=h}),define(te[207],ie([0,1,5]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let L=class{constructor(o,C){this.a=o,this.b=C}c(){return new Promise((o,C)=>V(["vscode-encrypt"],o,C))}async encrypt(o){let C;try{C=await this.c()}catch{return o}try{return C.encrypt(this.a,o)}catch(P){return this.b.error(P),o}}async decrypt(o){let C;try{C=await this.c()}catch{return o}try{return C.decrypt(this.a,o)}catch(P){return this.b.error(P),o}}};L=ve([ee(1,I.ILogService)],L),e.EncryptionMainService=L}),define(te[208],ie([0,1,25,8,13,3,2,9,75,5]),function(V,e,I,L,k,o,C,P,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class S extends C.Disposable{constructor(b,f){super(),this.a=b,this.b=f,this.c=this.B(new o.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new o.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new L.ThrottledDelayer(0)),this.s=[],this.t=this.B(new L.ThrottledDelayer(0))}watch(b,f){return f.recursive||this.b?.watcher?.forceUniversal?this.l(b,f):this.u(b,f)}l(b,f){const p={path:this.C(b),excludes:f.excludes,includes:f.includes,recursive:f.recursive},w=(0,I.insert)(this.j,p);return this.m(),(0,C.toDisposable)(()=>{w(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(b=>(0,k.onUnexpectedError)(b))}n(){this.h||(this.h=this.B(this.p(f=>this.c.fire((0,h.toFileChanges)(f)),f=>this.z(f),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const f of this.j)(0,h.isRecursiveWatchRequest)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const f of this.j)(0,h.isRecursiveWatchRequest)(f)&&b.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(b,f){const p={path:this.C(b),excludes:f.excludes,includes:f.includes,recursive:!1},w=(0,I.insert)(this.s,p);return this.v(),(0,C.toDisposable)(()=>{w(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(b=>(0,k.onUnexpectedError)(b))}w(){return this.r||(this.r=this.B(this.y(b=>this.c.fire((0,h.toFileChanges)(b)),b=>this.z(b),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)}))),this.r.watch(this.s)}z(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}C(b){return(0,P.normalize)(b.fsPath)}}e.AbstractDiskFileSystemProvider=S}),define(te[209],ie([0,1,25,8,17,22,3,71,69,2,60,15,63,20,59,162,16,110,5,13]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f,p,w,c,u,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let E=class extends m.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new C.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new C.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new C.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new C.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new L.ResourceQueue)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${t}`);const i=new m.DisposableStore;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),i.add(a.onDidChangeFile(n=>this.R.fire(new c.FileChangesEvent(n,!this.O(a))))),typeof a.onDidWatchError=="function"&&i.add(a.onDidWatchError(n=>this.S.fire(new Error(n)))),i.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,m.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,m.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(i){a.push(i)}}),!this.h.has(t)&&await L.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&a)}listCapabilities(){return h.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,f.isAbsolutePath)(t))throw new c.FileOperationError((0,w.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const i=new D.ErrorNoTelemetry;throw i.message=(0,w.localize)(1,null,t.toString()),i}return a}async k(t){const a=await this.j(t);if((0,c.hasOpenReadWriteCloseCapability)(a)||(0,c.hasReadWriteCapability)(a)||(0,c.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const a=await this.j(t);if((0,c.hasOpenReadWriteCloseCapability)(a)||(0,c.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.n(t,a)}catch(i){throw(0,c.toFileSystemProviderErrorCode)(i)===c.FileSystemProviderErrorCode.FileNotFound?new c.FileOperationError((0,w.localize)(2,null,this.nb(t)),1):(0,c.ensureFileSystemProviderError)(i)}}async n(t,a){const i=await this.j(t),n=this.O(i),r=a?.resolveTo,l=a?.resolveSingleChildDescendants,s=a?.resolveMetadata,d=await i.stat(t);let y;return this.p(i,t,d,void 0,!!s,(M,O)=>(y||(y=S.TernarySearchTree.forUris(()=>!n),y.set(t,!0),r&&y.fill(!0,r)),y.get(M.resource)||y.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&l?O===1:!1))}async p(t,a,i,n,r,l){const{providerExtUri:s}=this.N(t),d={resource:a,name:s.basename(a),isFile:(i.type&c.FileType.File)!==0,isDirectory:(i.type&c.FileType.Directory)!==0,isSymbolicLink:(i.type&c.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&c.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,c.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(d.isDirectory&&l(d,n)){try{const y=await t.readdir(a),M=await L.Promises.settled(y.map(async([O,j])=>{try{const K=s.joinPath(a,O),x=r?await t.stat(K):{type:j};return await this.p(t,K,x,y.length,r,l)}catch(K){return this.b.trace(K),null}}));d.children=(0,I.coalesce)(M)}catch(y){this.b.trace(y),d.children=[]}return d}return d}async resolveAll(t){return L.Promises.settled(t.map(async a=>{try{return{stat:await this.n(a.resource,a.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),i=await a.stat(t);return this.p(a,t,i,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.r(t,a)}catch(i){return i}return!0}async r(t,a){if(!a?.overwrite&&await this.exists(t))throw new c.FileOperationError((0,w.localize)(3,null,this.nb(t)),3,a)}async createFile(t,a=k.VSBuffer.fromString(""),i){await this.r(t,i);const n=await this.writeFile(t,a);return this.m.fire(new c.FileOperationEvent(t,0,n)),n}async writeFile(t,a,i){const n=this.lb(await this.l(t),t),{providerExtUri:r}=this.N(n);try{await this.s(n,t,i)||await this.P(n,r.dirname(t));let s;if((0,c.hasReadWriteCapability)(n)&&!(a instanceof k.VSBuffer))if((0,p.isReadableStream)(a)){const d=await(0,p.peekStream)(a,3);d.ended?s=k.VSBuffer.concat(d.buffer):s=d}else s=(0,p.peekReadable)(a,d=>k.VSBuffer.concat(d),3);else s=a;!(0,c.hasOpenReadWriteCloseCapability)(n)||(0,c.hasReadWriteCapability)(n)&&s instanceof k.VSBuffer?await this.cb(n,t,i,s):await this.Y(n,t,i,s instanceof k.VSBuffer?(0,k.bufferToReadable)(s):s),this.m.fire(new c.FileOperationEvent(t,4))}catch(l){throw new c.FileOperationError((0,w.localize)(4,null,this.nb(t),(0,c.ensureFileSystemProviderError)(l).toString()),(0,c.toFileOperationResult)(l),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,a,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,w.localize)(5,null,this.nb(a)));let r;try{r=await t.stat(a)}catch{return}if((r.type&c.FileType.Directory)!==0)throw new c.FileOperationError((0,w.localize)(6,null,this.nb(a)),0,i);if(this.mb(a,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==c.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,c.etag)({mtime:i.mtime,size:r.size}))throw new c.FileOperationError((0,w.localize)(7,null),3,i);return r}async readFile(t,a,i){const n=await this.k(t);return a?.atomic?this.t(n,t,a,i):this.u(n,t,a,i)}async t(t,a,i,n){return new Promise((r,l)=>{this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{try{const s=await this.u(t,a,i,n);r(s)}catch(s){l(s)}})})}async u(t,a,i,n){const r=await this.v(t,a,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,k.streamToBuffer)(r.value)}}async readFileStream(t,a,i){const n=await this.k(t);return this.v(n,t,a,i)}async v(t,a,i,n){const r=new o.CancellationTokenSource(n),l=this.F(a,i).then(d=>d,d=>{throw r.cancel(),d});let s;try{return typeof i?.etag=="string"&&i.etag!==c.ETAG_DISABLED&&await l,i?.atomic&&(0,c.hasFileAtomicReadCapability)(t)||!((0,c.hasOpenReadWriteCloseCapability)(t)||(0,c.hasFileReadStreamCapability)(t))||(0,c.hasReadWriteCapability)(t)&&i?.preferUnbuffered?s=this.D(t,a,i):(0,c.hasFileReadStreamCapability)(t)?s=this.z(t,a,r.token,i):s=this.C(t,a,r.token,i),{...await l,value:s}}catch(d){throw s&&await(0,p.consumeStream)(s),this.w(d,a,i)}}w(t,a,i){const n=(0,w.localize)(8,null,this.nb(a),(0,c.ensureFileSystemProviderError)(t).toString());return t instanceof c.NotModifiedSinceFileOperationError?new c.NotModifiedSinceFileOperationError(n,t.stat,i):t instanceof c.TooLargeFileOperationError?new c.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new c.FileOperationError(n,(0,c.toFileOperationResult)(t),i)}z(t,a,i,n=Object.create(null)){const r=t.readFileStream(a,n,i);return(0,p.transform)(r,{data:l=>l instanceof k.VSBuffer?l:k.VSBuffer.wrap(l),error:l=>this.w(l,a,n)},l=>k.VSBuffer.concat(l))}C(t,a,i,n=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,u.readFileIntoStream)(t,a,r,l=>l,{...n,bufferSize:this.a,errorTransformer:l=>this.w(l,a,n)},i),r}D(t,a,i){const n=(0,p.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r;i?.atomic&&(0,c.hasFileAtomicReadCapability)(t)?r=await t.readFile(a,{atomic:!0}):r=await t.readFile(a),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.G(a,r.byteLength,i),n.end(k.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async F(t,a){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new c.FileOperationError((0,w.localize)(9,null,this.nb(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==c.ETAG_DISABLED&&a.etag===i.etag)throw new c.NotModifiedSinceFileOperationError((0,w.localize)(10,null),i,a);return this.G(t,i.size,a),i}G(t,a,i){if(i?.limits){let n;if(typeof i.limits.memory=="number"&&a>i.limits.memory&&(n=9),typeof i.limits.size=="number"&&a>i.limits.size&&(n=7),typeof n=="number")throw new c.TooLargeFileOperationError((0,w.localize)(11,null,this.nb(t)),n,a,i)}}async canMove(t,a,i){return this.H(t,a,"move",i)}async canCopy(t,a,i){return this.H(t,a,"copy",i)}async H(t,a,i,n){if(t.toString()!==a.toString())try{const r=i==="move"?this.lb(await this.l(t),t):await this.k(t),l=this.lb(await this.l(a),a);await this.M(r,t,l,a,i,n)}catch(r){return r}return!0}async move(t,a,i){const n=this.lb(await this.l(t),t),r=this.lb(await this.l(a),a),l=await this.I(n,t,r,a,"move",!!i),s=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new c.FileOperationEvent(t,l==="move"?2:3,s)),s}async copy(t,a,i){const n=await this.k(t),r=this.lb(await this.l(a),a),l=await this.I(n,t,r,a,"copy",!!i),s=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new c.FileOperationEvent(t,l==="copy"?3:2,s)),s}async I(t,a,i,n,r,l){if(a.toString()===n.toString())return r;const{exists:s,isSameResourceWithDifferentPathCase:d}=await this.M(t,a,i,n,r,l);if(s&&!d&&l&&await this.del(n,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(n)),r==="copy"){if(t===i&&(0,c.hasFileFolderCopyCapability)(t))await t.copy(a,n,{overwrite:l});else{const y=await this.resolve(a);y.isDirectory?await this.L(t,y,i,n):await this.J(t,a,i,n)}return r}else return t===i?(await t.rename(a,n,{overwrite:l}),r):(await this.I(t,a,i,n,"copy",l),await this.del(a,{recursive:!0}),"copy")}async J(t,a,i,n){if((0,c.hasOpenReadWriteCloseCapability)(t)&&(0,c.hasOpenReadWriteCloseCapability)(i))return this.eb(t,a,i,n);if((0,c.hasOpenReadWriteCloseCapability)(t)&&(0,c.hasReadWriteCapability)(i))return this.kb(t,a,i,n);if((0,c.hasReadWriteCapability)(t)&&(0,c.hasOpenReadWriteCloseCapability)(i))return this.ib(t,a,i,n);if((0,c.hasReadWriteCapability)(t)&&(0,c.hasReadWriteCapability)(i))return this.gb(t,a,i,n)}async L(t,a,i,n){await i.mkdir(n),Array.isArray(a.children)&&await L.Promises.settled(a.children.map(async r=>{const l=this.N(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.L(t,await this.resolve(r.resource),i,l):this.J(t,r.resource,i,l)}))}async M(t,a,i,n,r,l){let s=!1;if(t===i){const{providerExtUri:y,isPathCaseSensitive:M}=this.N(t);if(M||(s=y.isEqual(a,n)),s&&r==="copy")throw new Error((0,w.localize)(12,null,this.nb(a),this.nb(n)));if(!s&&y.isEqualOrParent(n,a))throw new Error((0,w.localize)(13,null,this.nb(a),this.nb(n)))}const d=await this.exists(n);if(d&&!s){if(!l)throw new c.FileOperationError((0,w.localize)(14,null,this.nb(a),this.nb(n)),4);if(t===i){const{providerExtUri:y}=this.N(t);if(y.isEqualOrParent(a,n))throw new Error((0,w.localize)(15,null,this.nb(a),this.nb(n)))}}return{exists:d,isSameResourceWithDifferentPathCase:s}}N(t){const a=this.O(t);return{providerExtUri:a?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:a}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.lb(await this.j(t),t);await this.P(a,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new c.FileOperationEvent(t,0,i)),i}async P(t,a){const i=[],{providerExtUri:n}=this.N(t);for(;!n.isEqual(a,n.dirname(a));)try{if(((await t.stat(a)).type&c.FileType.Directory)===0)throw new Error((0,w.localize)(16,null,this.nb(a)));break}catch(r){if((0,c.toFileSystemProviderErrorCode)(r)!==c.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(a)),a=n.dirname(a)}for(let r=i.length-1;r>=0;r--){a=n.joinPath(a,i[r]);try{await t.mkdir(a)}catch(l){if((0,c.toFileSystemProviderErrorCode)(l)!==c.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(t,a){try{await this.Q(t,a)}catch(i){return i}return!0}async Q(t,a){const i=this.lb(await this.j(t),t);if(!!a?.useTrash&&!(i.capabilities&4096))throw new Error((0,w.localize)(17,null,this.nb(t)));let r;try{r=await i.stat(t)}catch{}if(r)this.mb(t,r);else throw new c.FileOperationError((0,w.localize)(18,null,this.nb(t)),1);if(!!!a?.recursive){const s=await this.resolve(t);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,w.localize)(19,null,this.nb(t)))}return i}async del(t,a){const i=await this.Q(t,a),n=!!a?.useTrash,r=!!a?.recursive;await i.delete(t,{recursive:r,useTrash:n}),this.m.fire(new c.FileOperationEvent(t,1))}async cloneFile(t,a){const i=await this.j(t),n=this.lb(await this.l(a),a);if(i===n&&this.N(i).providerExtUri.isEqual(t,a))return;if(i===n&&(0,c.hasFileCloneCapability)(i))return i.cloneFile(t,a);await this.P(n,this.N(n).providerExtUri.dirname(a));const r=this.X.queueFor(t,this.N(i).providerExtUri);return i===n&&(0,c.hasFileFolderCopyCapability)(i)?r.queue(()=>i.copy(t,a,{overwrite:!0})):r.queue(()=>this.J(i,t,n,a))}watch(t,a={recursive:!1,excludes:[]}){const i=new m.DisposableStore;let n=!1,r=()=>{n=!0};return i.add((0,m.toDisposable)(()=>r())),(async()=>{try{const l=await this.W(t,a);n?(0,m.dispose)(l):r=()=>(0,m.dispose)(l)}catch(l){this.b.error(l)}})(),i}async W(t,a){const i=await this.j(t),n=(0,P.hash)([this.N(i).providerExtUri.getComparisonKey(t),a]);let r=this.U.get(n);return r||(r={count:0,disposable:i.watch(t,a)},this.U.set(n,r)),r.count+=1,(0,m.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,m.dispose)(r.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,m.dispose)(t.disposable);this.U.clear()}async Y(t,a,i,n){return this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{const r=await t.open(a,{create:!0,unlock:i?.unlock??!1});try{(0,p.isReadableStream)(n)||(0,p.isReadableBufferedStream)(n)?await this.Z(t,r,n):await this.ab(t,r,n)}catch(l){throw(0,c.ensureFileSystemProviderError)(l)}finally{await t.close(r)}})}async Z(t,a,i){let n=0,r;if((0,p.isReadableBufferedStream)(i)){if(i.buffer.length>0){const l=k.VSBuffer.concat(i.buffer);await this.bb(t,a,l,l.byteLength,n,0),n+=l.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((l,s)=>{(0,p.listenStream)(r,{onData:async d=>{r.pause();try{await this.bb(t,a,d,d.byteLength,n,0)}catch(y){return s(y)}n+=d.byteLength,setTimeout(()=>r.resume())},onError:d=>s(d),onEnd:()=>l()})})}async ab(t,a,i){let n=0,r;for(;(r=i.read())!==null;)await this.bb(t,a,r,r.byteLength,n,0),n+=r.byteLength}async bb(t,a,i,n,r,l){let s=0;for(;s<n;)s+=await t.write(a,r+s,i.buffer,l+s,n-s)}async cb(t,a,i,n){return this.X.queueFor(a,this.N(t).providerExtUri).queue(()=>this.db(t,a,i,n))}async db(t,a,i,n){let r;n instanceof k.VSBuffer?r=n:(0,p.isReadableStream)(n)?r=await(0,k.streamToBuffer)(n):(0,p.isReadableBufferedStream)(n)?r=await(0,k.bufferedStreamToBuffer)(n):r=(0,k.readableToBuffer)(n),await t.writeFile(a,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,a,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.fb(t,a,i,n))}async fb(t,a,i,n){let r,l;try{r=await t.open(a,{create:!1}),l=await i.open(n,{create:!0,unlock:!1});const s=k.VSBuffer.alloc(this.a);let d=0,y=0,M=0;do M=await t.read(r,d,s.buffer,y,s.byteLength-y),await this.bb(i,l,s,M,d,y),d+=M,y+=M,y===s.byteLength&&(y=0);while(M>0)}catch(s){throw(0,c.ensureFileSystemProviderError)(s)}finally{await L.Promises.settled([typeof r=="number"?t.close(r):Promise.resolve(),typeof l=="number"?i.close(l):Promise.resolve()])}}async gb(t,a,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.hb(t,a,i,n))}async hb(t,a,i,n){return i.writeFile(n,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async ib(t,a,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.jb(t,a,i,n))}async jb(t,a,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const l=await t.readFile(a);await this.bb(i,r,k.VSBuffer.wrap(l),l.byteLength,0,0)}catch(l){throw(0,c.ensureFileSystemProviderError)(l)}finally{await i.close(r)}}async kb(t,a,i,n){const r=await(0,k.streamToBuffer)(this.C(t,a,o.CancellationToken.None));await this.cb(i,n,void 0,r)}lb(t,a){if(t.capabilities&2048)throw new c.FileOperationError((0,w.localize)(20,null,this.nb(a)),6);return t}mb(t,a){if((a.permissions??0)&c.FilePermission.Readonly)throw new c.FileOperationError((0,w.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===v.Schemas.file?t.fsPath:t.toString(!0)}};E=ve([ee(0,g.ILogService)],E),e.FileService=E}),define(te[89],ie([0,1,41,287,8,38,17,3,32,2,9,4,20,59,23,166,16,110,208,45,204,203]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f,p,w,c,u,g,D,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(I)}catch(a){console.error(`Error enabling graceful-fs: ${(0,D.toErrorMessage)(a)}`)}})();class t extends g.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=P.Event.None,this.H=new o.ResourceMap(r=>b.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,v.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:n,symbolicLink:r}=await p.SymlinkSupport.stat(this.C(i));return{type:this.G(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.Y(n)}}async readdir(i){try{const n=await p.Promises.readdir(this.C(i),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async l=>{try{let s;l.isSymbolicLink()?s=(await this.stat((0,b.joinPath)(i,l.name))).type:s=this.G(l),r.push([l.name,s])}catch(s){this.a.trace(s)}})),r}catch(n){throw this.Y(n)}}G(i,n){let r;return n?.dangling?r=c.FileType.Unknown:i.isFile()?r=c.FileType.File:i.isDirectory()?r=c.FileType.Directory:r=c.FileType.Unknown,n&&(r|=c.FileType.SymbolicLink),r}async I(i){const n=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const l=new k.Barrier;return this.H.set(i,l),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,m.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.H.get(i)===l&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),l.open()})}async readFile(i,n){let r;try{n?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),r=await this.I(i));const l=this.C(i);return await p.Promises.readFile(l)}catch(l){throw this.Y(l)}finally{r?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,n,r){const l=(0,f.newWriteableStream)(s=>C.VSBuffer.concat(s.map(d=>C.VSBuffer.wrap(d))).buffer);return(0,u.readFileIntoStream)(this,i,l,s=>s.buffer,{...n,bufferSize:256*1024},r),l}async writeFile(i,n,r){let l;try{const s=this.C(i);if(!r.create||!r.overwrite){if(await p.Promises.exists(s)){if(!r.overwrite)throw(0,c.createFileSystemProviderError)((0,w.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,c.createFileSystemProviderError)((0,w.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(l,0,n,0,n.byteLength)}catch(s){throw await this.Z(i,s)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(i){t.O=i}async open(i,n){const r=this.C(i);let l;(0,c.isFileOpenForWriteOptions)(n)&&(l=await this.I(i));let s;try{if((0,c.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:y}=await p.SymlinkSupport.stat(r);y.mode&128||await p.Promises.chmod(r,y.mode|128)}catch(y){this.a.trace(y)}let d;if((0,c.isFileOpenForWriteOptions)(n)){if(v.isWindows)try{await p.Promises.truncate(r,0),d="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}d||(d="w")}else d="r";s=await p.Promises.open(r,d)}catch(d){throw l?.dispose(),(0,c.isFileOpenForWriteOptions)(n)?await this.Z(i,d):this.Y(d)}if(this.L.set(s,0),(0,c.isFileOpenForWriteOptions)(n)&&this.N.set(s,i),l){const d=this.M.get(s);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${s} (${r})`),this.M.set(s,l),d&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${s} (${r})`),d.dispose())}return s}async close(i){const n=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await p.Promises.fdatasync(i)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await p.Promises.close(i)}catch(r){throw this.Y(r)}finally{n&&(this.M.get(i)===n&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,r,l,s){const d=this.P(i,n);let y=null;try{y=(await p.Promises.read(i,r,l,s,d)).bytesRead}catch(M){throw this.Y(M)}finally{this.Q(i,d,y)}return y}P(i,n){return n===this.L.get(i)?null:n}Q(i,n,r){const l=this.L.get(i);typeof l=="number"&&(typeof n=="number"||(typeof r=="number"?this.L.set(i,l+r):this.L.delete(i)))}async write(i,n,r,l,s){return(0,k.retry)(()=>this.R(i,n,r,l,s),100,3)}async R(i,n,r,l,s){const d=this.P(i,n);let y=null;try{y=(await p.Promises.write(i,r,l,s,d)).bytesWritten}catch(M){throw await this.Z(this.N.get(i),M)}finally{this.Q(i,d,y)}return y}async mkdir(i){try{await p.Promises.mkdir(this.C(i))}catch(n){throw this.Y(n)}}async delete(i,n){try{const r=this.C(i);n.recursive?await p.Promises.rm(r,p.RimRafMode.MOVE):await p.Promises.unlink(r)}catch(r){throw this.Y(r)}}async rename(i,n,r){const l=this.C(i),s=this.C(n);if(l!==s)try{await this.S(i,n,"move",r.overwrite),await p.Promises.move(l,s)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,w.localize)(2,null,(0,S.basename)(l),(0,S.basename)((0,S.dirname)(s)),d.toString()))),this.Y(d)}}async copy(i,n,r){const l=this.C(i),s=this.C(n);if(l!==s)try{await this.S(i,n,"copy",r.overwrite),await p.Promises.copy(l,s,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,w.localize)(3,null,(0,S.basename)(l),(0,S.basename)((0,S.dirname)(s)),d.toString()))),this.Y(d)}}async S(i,n,r,l){const s=this.C(i),d=this.C(n);let y=!1;if(!!(this.capabilities&1024)||(y=(0,h.isEqual)(s,d,!0)),y&&r==="copy")throw(0,c.createFileSystemProviderError)((0,w.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(!y&&await p.Promises.exists(d)){if(!l)throw(0,c.createFileSystemProviderError)((0,w.localize)(5,null),c.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.U(i,n,!1)}async U(i,n,r){const l=this.C(i),s=this.C(n),d=!!(this.capabilities&1024);if((0,h.isEqual)(l,s,!d))return;const y=new m.DisposableStore;try{const[M,O]=await Promise.all([this.I(i),this.I(n)]);y.add(M),y.add(O),r&&await p.Promises.mkdir((0,S.dirname)(s),{recursive:!0}),await p.Promises.copyFile(l,s)}catch(M){if(M.code==="ENOENT"&&!r)return this.U(i,n,!0);throw this.Y(M)}finally{y.dispose()}}p(i,n,r){return new E.UniversalWatcherClient(l=>i(l),l=>n(l),r)}y(i,n,r){return new R.NodeJSWatcherClient(l=>i(l),l=>n(l),r)}Y(i){if(i instanceof c.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=c.FileSystemProviderErrorCode.NoPermissions;break;default:n=c.FileSystemProviderErrorCode.Unknown}return(0,c.createFileSystemProviderError)(i,n)}async Z(i,n){let r=this.Y(n);if(i&&r.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await p.SymlinkSupport.stat(this.C(i));l.mode&128||(r=(0,c.createFileSystemProviderError)(n,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return r}}e.DiskFileSystemProvider=t,t.D=!1,t.O=!0}),define(te[210],ie([0,1,3,89,2,17,59,22]),function(V,e,I,L,k,o,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class h extends k.Disposable{constructor(v,b){super(),this.a=v,this.b=b,this.w=new Map,this.y=new Map}call(v,b,f){const p=this.c(v);switch(b){case"stat":return this.g(p,f[0]);case"readdir":return this.h(p,f[0]);case"open":return this.l(p,f[0],f[1]);case"close":return this.m(f[0]);case"read":return this.n(f[0],f[1],f[2]);case"readFile":return this.i(p,f[0],f[1]);case"write":return this.p(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.k(p,f[0],f[1],f[2]);case"rename":return this.t(p,f[0],f[1],f[2]);case"copy":return this.u(p,f[0],f[1],f[2]);case"cloneFile":return this.v(p,f[0],f[1]);case"mkdir":return this.r(p,f[0]);case"delete":return this.s(p,f[0],f[1]);case"watch":return this.C(p,f[0],f[1],f[2],f[3]);case"unwatch":return this.D(f[0],f[1])}throw new Error(`IPC Command ${b} not found`)}listen(v,b,f){const p=this.c(v);switch(b){case"fileChange":return this.z(p,f[0]);case"readFileStream":return this.j(p,f[0],f[1])}throw new Error(`Unknown event ${b}`)}g(v,b){const f=this.f(v,b,!0);return this.a.stat(f)}h(v,b){const f=this.f(v,b);return this.a.readdir(f)}async i(v,b,f){const p=this.f(v,b,!0),w=await this.a.readFile(p,f);return o.VSBuffer.wrap(w)}j(v,b,f){const p=this.f(v,b,!0),w=new P.CancellationTokenSource,c=new I.Emitter({onDidRemoveLastListener:()=>{w.cancel()}}),u=this.a.readFileStream(p,f,w.token);return(0,C.listenStream)(u,{onData:g=>c.fire(o.VSBuffer.wrap(g)),onError:g=>c.fire(g),onEnd:()=>{c.fire("end"),c.dispose(),w.dispose()}}),c.event}k(v,b,f,p){const w=this.f(v,b);return this.a.writeFile(w,f.buffer,p)}l(v,b,f){const p=this.f(v,b,!0);return this.a.open(p,f)}m(v){return this.a.close(v)}async n(v,b,f){const p=o.VSBuffer.alloc(f),w=0,c=await this.a.read(v,b,p.buffer,w,f);return[p,c]}p(v,b,f,p,w){return this.a.write(v,b,f.buffer,p,w)}r(v,b){const f=this.f(v,b);return this.a.mkdir(f)}s(v,b,f){const p=this.f(v,b);return this.a.delete(p,f)}t(v,b,f,p){const w=this.f(v,b),c=this.f(v,f);return this.a.rename(w,c,p)}u(v,b,f,p){const w=this.f(v,b),c=this.f(v,f);return this.a.copy(w,c,p)}v(v,b,f){const p=this.f(v,b),w=this.f(v,f);return this.a.cloneFile(p,w)}z(v,b){const f=new I.Emitter({onWillAddFirstListener:()=>{this.w.set(b,this.F(v,f))},onDidRemoveLastListener:()=>{(0,k.dispose)(this.w.get(b)),this.w.delete(b)}});return f.event}async C(v,b,f,p,w){const c=this.w.get(b);if(c){const u=this.f(v,p),g=c.watch(f,u,w);this.y.set(b+f,g)}}async D(v,b){const f=v+b,p=this.y.get(f);p&&((0,k.dispose)(p),this.y.delete(f))}dispose(){super.dispose();for(const[,v]of this.y)v.dispose();this.y.clear();for(const[,v]of this.w)v.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=h;class m extends k.Disposable{constructor(v,b,f,p){super(),this.c=v,this.f=f,this.g=p,this.a=new Map,this.b=this.B(new L.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(b)}h(v){const b=this.B(new I.Emitter);this.B(b.event(f=>{v.fire(f.map(p=>({resource:this.c.transformOutgoingURI(p.resource),type:p.type})))})),this.B(this.b.onDidChangeFile(f=>b.fire(f))),this.B(this.b.onDidWatchError(f=>v.fire(f)))}i(v){}j(v){}watch(v,b,f){const p=this.j(this.g);return Array.isArray(p)&&(f.excludes=[...f.excludes,...p]),this.a.set(v,this.b.watch(b,f)),(0,k.toDisposable)(()=>{(0,k.dispose)(this.a.get(v)),this.a.delete(v)})}dispose(){super.dispose();for(const[,v]of this.a)v.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=m}),define(te[211],ie([0,1,14,165,4,7,16,9,210,144]),function(V,e,I,L,k,o,C,P,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class S extends h.AbstractDiskFileSystemProviderChannel{constructor(f,p,w){super(f,p),this.G=w}c(f){return m.DefaultURITransformer}f(f,p){return o.URI.revive(p)}async s(f,p,w){if(!w.useTrash)return super.s(f,p,w);const c=this.f(f,p),u=(0,P.normalize)(c.fsPath);try{await I.shell.trashItem(u)}catch{throw(0,C.createFileSystemProviderError)(k.isWindows?(0,L.localize)(0,null,(0,P.basename)(u)):(0,L.localize)(1,null,(0,P.basename)(u)),C.FileSystemProviderErrorCode.Unknown)}}F(f,p){return new v(f,p,this.b,this.G)}}e.DiskFileSystemProviderChannel=S;class v extends h.AbstractSessionFileWatcher{watch(f,p,w){if(w.recursive)throw(0,C.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",C.FileSystemProviderErrorCode.Unavailable);return super.watch(f,p,w)}}}),define(te[212],ie([0,1,5]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class L extends I.AbstractMessageLogger{constructor(o=I.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(o),this.B(this.onDidChangeLogLevel(C=>{this.l?.setLevel(C)}))}set logger(o){this.l=o;for(const{level:C,message:P}of this.k)(0,I.log)(o,C,P);this.k=[]}g(o,C){this.l?(0,I.log)(this.l,o,C):this.getLevel()<=o&&this.k.push({level:o,message:C})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogger=L}),define(te[213],ie([0,1,2,5]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class k extends I.Disposable{constructor(C,P=[]){super(),this.a=new L.MultiplexLogger([C,...P]),this.B(C.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...P){this.a.trace(C,...P)}debug(C,...P){this.a.debug(C,...P)}info(C,...P){this.a.info(C,...P)}warn(C,...P){this.a.warn(C,...P)}error(C,...P){this.a.error(C,...P)}flush(){this.a.flush()}}e.LogService=k}),define(te[214],ie([0,1,7,5]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class k{constructor(C){this.b=C,this.a=new Map}listen(C,P,h){switch(P){case"onDidChangeLoggers":return h?this.b.getOnDidChangeLoggersEvent(h):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return h?this.b.getOnDidChangeLogLevelEvent(h):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return h?this.b.getOnDidChangeVisibilityEvent(h):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${P}`)}async call(C,P,h){switch(P){case"createLogger":this.c(I.URI.revive(h[0]),h[1]);return;case"log":return this.e(I.URI.revive(h[0]),h[1]);case"consoleLog":return this.d(h[0],h[1]);case"setLogLevel":return this.b.setLogLevel(I.URI.revive(h[0]),h[1]);case"setVisibility":return this.b.setVisibility(I.URI.revive(h[0]),h[1]);case"registerLogger":return this.b.registerLogger({...h[0],resource:I.URI.revive(h[0].resource)},h[1]);case"deregisterLogger":return this.b.deregisterLogger(I.URI.revive(h[0]))}throw new Error(`Call not found: ${P}`)}c(C,P){this.a.set(C.toString(),this.b.createLogger(C,P))}d(C,P){let h=console.log;switch(C){case L.LogLevel.Error:h=console.error;break;case L.LogLevel.Warning:h=console.warn;break;case L.LogLevel.Info:h=console.info;break}h.call(console,...P)}e(C,P){const h=this.a.get(C.toString());if(!h)throw new Error("Create the logger before logging");for(const[m,S]of P)(0,L.log)(h,m,S)}}e.LoggerChannel=k}),define(te[215],ie([0,1,16,5]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(m){m[m.Trace=0]="Trace",m[m.Debug=1]="Debug",m[m.Info=2]="Info",m[m.Warning=3]="Warning",m[m.Error=4]="Error",m[m.Critical=5]="Critical",m[m.Off=6]="Off"})(k||(k={}));async function o(m,S,v,b,f){try{const p=await new Promise((c,u)=>{V(["spdlog"],c,u)});p.setFlushOn(k.Trace);const w=await p.createAsyncRotatingLogger(m,S,v,b);return f?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(p){console.error(p)}return null}function C(m,S,v){switch(S){case L.LogLevel.Trace:m.trace(v);break;case L.LogLevel.Debug:m.debug(v);break;case L.LogLevel.Info:m.info(v);break;case L.LogLevel.Warning:m.warn(v);break;case L.LogLevel.Error:m.error(v);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${S}`)}}function P(m,S){switch(S){case L.LogLevel.Trace:m.setLevel(k.Trace);break;case L.LogLevel.Debug:m.setLevel(k.Debug);break;case L.LogLevel.Info:m.setLevel(k.Info);break;case L.LogLevel.Warning:m.setLevel(k.Warning);break;case L.LogLevel.Error:m.setLevel(k.Error);break;case L.LogLevel.Off:m.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${S}`)}}class h extends L.AbstractMessageLogger{constructor(S,v,b,f,p){super(),this.k=[],this.setLevel(p),this.l=this.n(S,v,b,f),this.B(this.onDidChangeLogLevel(w=>{this.m&&P(this.m,w)}))}async n(S,v,b,f){const p=b?6:1,w=30/p*I.ByteSize.MB,c=await o(S,v,w,p,f);if(c){this.m=c,P(this.m,this.getLevel());for(const{level:u,message:g}of this.k)C(this.m,u,g);this.k=[]}}g(S,v){this.m?C(this.m,S,v):this.getLevel()<=S&&this.k.push({level:S,message:v})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=h}),define(te[216],ie([0,1,31,5,215]),function(V,e,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class o extends L.AbstractLoggerService{k(P,h,m){return new k.SpdLogLogger(m?.name||(0,I.generateUuid)(),P.fsPath,!m?.donotRotate,!!m?.donotUseFormatters,h)}}e.LoggerService=o}),define(te[64],ie([0,1,38,3,6,5,216]),function(V,e,I,L,k,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,k.refineServiceDecorator)(o.ILoggerService);class P extends C.LoggerService{constructor(){super(...arguments),this.m=new I.ResourceMap}registerLogger(m,S){S!==void 0&&this.m.set(m.resource,S),super.registerLogger(m)}deregisterLogger(m){this.m.delete(m),super.deregisterLogger(m)}getRegisteredLoggers(m){const S=[];for(const v of super.getRegisteredLoggers())this.n(v.resource,m)&&S.push(v);return S}getOnDidChangeLogLevelEvent(m){return L.Event.filter(this.onDidChangeLogLevel,S=>(0,o.isLogLevel)(S)||this.n(S[0],m))}getOnDidChangeVisibilityEvent(m){return L.Event.filter(this.onDidChangeVisibility,([S])=>this.n(S,m))}getOnDidChangeLoggersEvent(m){return L.Event.filter(L.Event.map(this.onDidChangeLoggers,S=>({added:[...S.added].filter(b=>this.n(b.resource,m)),removed:[...S.removed].filter(b=>this.n(b.resource,m))})),S=>S.added.length>0||S.removed.length>0)}deregisterLoggers(m){for(const[S,v]of this.m)v===m&&this.deregisterLogger(S)}n(m,S){const v=this.m.get(m);return v===void 0||v===S}dispose(){super.dispose(),this.m.clear()}}e.LoggerMainService=P}),define(te[217],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function I(C){return C.submenu!==void 0}e.isMenubarMenuItemSubmenu=I;function L(C){return C.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function k(C){return C.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function o(C){return!I(C)&&!L(C)&&!k(C)}e.isMenubarMenuItemAction=o}),define(te[39],ie([0,1,3,69,2,6]),function(V,e,I,L,k,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,o.createDecorator)("policy");class C extends k.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new I.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(m){const S=Object.keys(this.f).length;return this.f={...m,...this.f},S!==Object.keys(this.f).length&&await this.i(m),L.Iterable.reduce(this.g.entries(),(v,[b,f])=>({...v,[b]:f}),{})}getPolicyValue(m){return this.g.get(m)}serialize(){return L.Iterable.reduce(Object.entries(this.f),(m,[S,v])=>({...m,[S]:{definition:v,value:this.g.get(S)}}),{})}}e.AbstractPolicyService=C;class P{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(te[218],ie([0,1,8,3,69,10,16,5,39]),function(V,e,I,L,k,o,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function m(v,b){const f=[];for(const p of new Set(k.Iterable.concat(v.keys(),b.keys())))v.get(p)!==b.get(p)&&f.push(p);return f}let S=class extends h.AbstractPolicyService{constructor(b,f,p){super(),this.j=b,this.k=f,this.l=p,this.c=this.B(new I.ThrottledDelayer(500));const w=L.Event.filter(f.onDidFilesChange,c=>c.affects(b));this.B(f.watch(b)),this.B(w(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const b=new Map;try{const f=await this.k.readFile(this.j),p=JSON.parse(f.value.toString());if(!(0,o.isObject)(p))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(p))this.f[w]&&b.set(w,p[w])}catch(f){f.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",f)}return b}async p(){const b=await this.n(),f=m(this.g,b);this.g=b,f.length>0&&this.h.fire(f)}};S=ve([ee(1,C.IFileService),ee(2,P.ILogService)],S),e.FilePolicyService=S}),define(te[219],ie([0,1,3,2,39]),function(V,e,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class o{constructor(h){this.b=h,this.a=new L.DisposableStore}listen(h,m){switch(m){case"onDidChange":return I.Event.map(this.b.onDidChange,S=>S.reduce((v,b)=>({...v,[b]:this.b.getPolicyValue(b)??null}),{}),this.a)}throw new Error(`Event not found: ${m}`)}call(h,m,S){switch(m){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(S)}throw new Error(`Call not found: ${m}`)}dispose(){this.a.dispose()}}e.PolicyChannel=o;class C extends k.AbstractPolicyService{constructor(h,m){super(),this.a=m;for(const S in h){const{definition:v,value:b}=h[S];this.f[S]=v,b!==void 0&&this.g.set(S,b)}this.a.listen("onDidChange")(S=>{for(const v in S){const b=S[v];b===null?this.g.delete(v):this.g.set(v,b)}this.h.fire(Object.keys(S))})}async i(h){const m=await this.a.call("updatePolicyDefinitions",h);for(const S in m)this.g.set(S,m[S])}}e.PolicyChannelClient=C}),define(te[65],ie([0,1,4,35]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.context<"u"){const o=I.globals.vscode.context.configuration();if(o)k=o.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(k=globalThis._VSCODE_PRODUCT_JSON,L.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`,serverDataFolderName:k.serverDataFolderName?`${k.serverDataFolderName}-dev`:void 0}),!k.version){const o=globalThis._VSCODE_PACKAGE_JSON;Object.assign(k,{version:o.version})}}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=k}),define(te[19],ie([0,1,6]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,I.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(te[220],ie([0,1,80,5,19]),function(V,e,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let o=class{constructor(P,h){this.b=P,this.c=h,this.a=new Map}async isExtensionUrlTrusted(P,h){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const m=/^(.*)#([^#]+)$/.exec(h);if(!m)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",h),!1;const[,S,v]=m;let b=this.a.get(P);if(!b){if(b=this.b.trustedExtensionUrlPublicKeys[P],!b||b.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",P),!1;this.a.set(P,[...b])}const f=Buffer.from(decodeURIComponent(v),"base64");if(f.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",h),!1;const p=f.slice(0,6),w=f.readUIntBE(0,6),c=Date.now()-w;if(c<0||c>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",h),!1;const u=f.slice(6),g=I.createVerify("SHA256");g.write(p),g.write(Buffer.from(S)),g.end();for(let D=0;D<b.length;D++){let E=b[D];if(E!==null){if(typeof E=="string")try{E=I.createPublicKey({key:Buffer.from(E,"base64"),format:"der",type:"spki"}),b[D]=E}catch(R){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${D+1} for ${P}:`,R),b[D]=null;continue}if(g.verify(E,u))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",h),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",h),!1}};o=ve([ee(0,k.IProductService),ee(1,L.ILogService)],o),e.ExtensionUrlTrustService=o}),define(te[221],ie([0,1,8,5]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let k=class{constructor(C,P,h){this.a=C,this.b=P,this.c=h}async inspect(C){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,I.timeout)(C);const h=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),h.profile}async d(){const C=this.a.webContents.debugger;C.attach(),await C.sendCommand("Profiler.enable")}async e(){const C=this.a.webContents.debugger;await C.sendCommand("Profiler.disable"),C.detach()}};k=ve([ee(2,L.ILogService)],k),e.WindowProfiler=k}),define(te[66],ie([0,1,6]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,I.createDecorator)("protocolMainService")}),define(te[50],ie([0,1,123,10]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.a=new Map}add(C,P){I.ok(L.isString(C)),I.ok(L.isObject(P)),I.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,P)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.Registry=new k}),define(te[222],ie([0,1,3,50]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class o{constructor(){this.b=new I.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,m){this.a[k(h)]=m,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const C=new o;L.Registry.add(e.Extensions.JSONContribution,C)}),define(te[67],ie([0,1,25,3,10,153,18,222,50]),function(V,e,I,L,k,o,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(R){R.Multiline="multilineText",R.Singleline="singlelineText"})(m=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var S;(function(R){R[R.APPLICATION=1]="APPLICATION",R[R.MACHINE=2]="MACHINE",R[R.WINDOW=3]="WINDOW",R[R.RESOURCE=4]="RESOURCE",R[R.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",R[R.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const v=h.Registry.as(P.Extensions.JSONContribution);class b{constructor(){this.h=new Set,this.i=new L.Emitter,this.onDidSchemaChange=this.i.event,this.j=new L.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:o.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const i=new Set;this.n(t,a,i),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const a=new Set;this.o(t,a),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const i=new Set;this.o(a,i),this.n(t,!1,i),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const i=[];for(const{overrides:n,source:r}of t)for(const l in n)if(a.add(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const s=this.a.get(l),d=s?.valuesSources??new Map;if(r)for(const j of Object.keys(n[l]))d.set(j,r);const y={...s?.value||{},...n[l]};this.a.set(l,{source:r,value:y,valuesSources:d});const M=(0,C.getLanguageTagSettingPlainKey)(l),O={type:"object",default:y,description:o.localize(1,null,M),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:y,source:k.isString(r)?void 0:r,defaultValueSource:r};i.push(...w(l)),this.d[l]=O,this.b.properties[l]=O}else{this.a.set(l,{value:n[l],source:r});const s=this.d[l];s&&(this.w(l,s),this.r(l,s))}this.m(i)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:i,source:n}of t)for(const r in i){const l=this.a.get(r),s=k.isString(n)?n:n?.id,d=k.isString(l?.source)?l?.source:l?.source?.id;if(s===d)if(a.add(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const y=this.d[r];y&&(this.w(r,y),this.r(r,y))}}this.u()}deltaConfiguration(t){let a=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,i){t.forEach(n=>{this.p(n,a,n.extensionInfo,n.restrictedProperties,void 0,i),this.c.push(n),this.q(n)})}o(t,a){const i=n=>{if(n.properties)for(const r in n.properties){a.add(r);const l=this.d[r];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[r],this.s(r,n.properties[r])}n.allOf?.forEach(r=>i(r))};for(const n of t){i(n);const r=this.c.indexOf(n);r!==-1&&this.c.splice(r,1)}}p(t,a=!0,i,n,r=3,l){r=k.isUndefinedOrNull(t.scope)?r:t.scope;const s=t.properties;if(s)for(const y in s){const M=s[y];if(a&&D(y,M)){delete s[y];continue}if(M.source=i,M.defaultDefaultValue=s[y].default,this.w(y,M),e.OVERRIDE_PROPERTY_REGEX.test(y)?M.scope=void 0:(M.scope=k.isUndefinedOrNull(M.scope)?r:M.scope,M.restricted=k.isUndefinedOrNull(M.restricted)?!!n?.includes(y):M.restricted),s[y].hasOwnProperty("included")&&!s[y].included){this.f[y]=s[y],delete s[y];continue}else this.d[y]=s[y],s[y].policy?.name&&this.e.set(s[y].policy.name,y);!s[y].deprecationMessage&&s[y].markdownDeprecationMessage&&(s[y].deprecationMessage=s[y].markdownDeprecationMessage),l.add(y)}const d=t.allOf;if(d)for(const y of d)this.p(y,a,i,n,r,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=i=>{const n=i.properties;if(n)for(const l in n)this.r(l,n[l]);i.allOf?.forEach(a)};a(t)}r(t,a){switch(e.allSettings.properties[t]=a,a.scope){case 1:e.applicationSettings.properties[t]=a;break;case 2:e.machineSettings.properties[t]=a;break;case 6:e.machineOverridableSettings.properties[t]=a;break;case 3:e.windowSettings.properties[t]=a;break;case 4:e.resourceSettings.properties[t]=a;break;case 5:e.resourceSettings.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.allSettings.properties[t],a.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,i={type:"object",description:o.localize(2,null),errorMessage:o.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(a,i),e.allSettings.properties[a]=i,e.applicationSettings.properties[a]=i,e.machineSettings.properties[a]=i,e.machineOverridableSettings.properties[a]=i,e.windowSettings.properties[a]=i,e.resourceSettings.properties[a]=i}}v(){const t={type:"object",description:o.localize(4,null),errorMessage:o.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,a){const i=this.a.get(t);let n=i?.value,r=i?.source;k.isUndefined(n)&&(n=a.defaultDefaultValue,r=void 0),k.isUndefined(n)&&(n=u(a.type)),a.default=n,a.defaultValueSource=r}}const f="\\[([^\\]]+)\\]",p=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function w(R){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(R)){let a=p.exec(R);for(;a?.length;){const i=a[1].trim();i&&t.push(i),a=p.exec(R)}}return(0,I.distinct)(t)}e.overrideIdentifiersFromKey=w;function c(R){return R.reduce((t,a)=>`${t}[${a}]`,"")}e.keyFromOverrideIdentifiers=c;function u(R){switch(Array.isArray(R)?R[0]:R){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const g=new b;h.Registry.add(e.Extensions.Configuration,g);function D(R,t){return R.trim()?e.OVERRIDE_PROPERTY_REGEX.test(R)?o.localize(7,null,R):g.getConfigurationProperties()[R]!==void 0?o.localize(8,null,R):t.policy?.name&&g.getPolicyConfigurations().get(t.policy?.name)!==void 0?o.localize(9,null,R,t.policy?.name,g.getPolicyConfigurations().get(t.policy?.name)):null:o.localize(6,null)}e.validateProperty=D;function E(){const R=[],t=g.getConfigurationProperties();for(const a of Object.keys(t))R.push([a,t[a].scope]);return R.push(["launch",4]),R.push(["task",4]),R}e.getScopes=E}),define(te[111],ie([0,1,25,3,43,2,38,44,10,7,18,67,50]),function(V,e,I,L,k,o,C,P,h,m,S,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function f(a){return Object.isFrozen(a)?a:P.deepFreeze(a)}class p{constructor(i={},n=[],r=[],l){this.b=i,this.c=n,this.d=r,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof p)return n;const r=new w("");return r.parseRaw(n),r.configurationModel});this.f=i.reduce((n,r)=>r===n?r:n.merge(r),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,S.getConfigurationValue)(this.contents,i):this.contents}inspect(i,n){const r=this.rawConfiguration.getValue(i),l=n?this.rawConfiguration.getOverrideValue(i,n):void 0,s=n?this.rawConfiguration.override(n).getValue(i):r;return{value:r,override:l,merged:s}}getOverrideValue(i,n){const r=this.i(n);return r?i?(0,S.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const r of this.overrides)r.identifiers.includes(i)&&n.push(...r.keys);return I.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return I.distinct(i)}override(i){let n=this.a.get(i);return n||(n=this.g(i),this.a.set(i,n)),n}merge(...i){const n=P.deepClone(this.contents),r=P.deepClone(this.overrides),l=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const d of i)if(s.push(...d.raw?.length?d.raw:[d]),!d.isEmpty()){this.h(n,d.contents);for(const y of d.overrides){const[M]=r.filter(O=>I.equals(O.identifiers,y.identifiers));M?(this.h(M.contents,y.contents),M.keys.push(...y.keys),M.keys=I.distinct(M.keys)):r.push(P.deepClone(y))}for(const y of d.keys)l.indexOf(y)===-1&&l.push(y)}return new p(n,l,r,s.every(d=>d instanceof p)?void 0:s)}g(i){const n=this.i(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const l of I.distinct([...Object.keys(this.contents),...Object.keys(n)])){let s=this.contents[l];const d=n[l];d&&(typeof s=="object"&&typeof d=="object"?(s=P.deepClone(s),this.h(s,d)):s=d),r[l]=s}return new p(r,this.keys,this.overrides)}h(i,n){for(const r of Object.keys(n)){if(r in i&&h.isObject(i[r])&&h.isObject(n[r])){this.h(i[r],n[r]);continue}i[r]=P.deepClone(n[r])}}i(i){let n=null,r=null;const l=s=>{s&&(r?this.h(r,s):r=P.deepClone(s))};for(const s of this.overrides)I.equals(s.identifiers,[i])?n=s.contents:s.identifiers.includes(i)&&l(s.contents);return l(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.j(i,n,!0)}setValue(i,n){this.j(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,S.removeFromValueTree)(this.contents,i),v.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(r=>I.equals(r.identifiers,(0,v.overrideIdentifiersFromKey)(i))),1))}j(i,n,r){(0,S.addToValueTree)(this.contents,i,n,l=>console.error(l)),r=r||this.keys.indexOf(i)===-1,r&&this.keys.push(i),v.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,v.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,S.toValuesTree)(this.contents[i],l=>console.error(l))})}}e.ConfigurationModel=p;class w{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!h.isUndefinedOrNull(i)){const r=this.g(i);this.parseRaw(r,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:r,keys:l,overrides:s,restricted:d,hasExcludedProperties:y}=this.h(i,n);this.b=new p(r,l,s,y?[i]:void 0),this.c=d||[]}g(i){let n={},r=null,l=[];const s=[],d=[];function y(O){Array.isArray(l)?l.push(O):r!==null&&(l[r]=O)}const M={onObjectBegin:()=>{const O={};y(O),s.push(l),l=O,r=null},onObjectProperty:O=>{r=O},onObjectEnd:()=>{l=s.pop()},onArrayBegin:()=>{const O=[];y(O),s.push(l),l=O,r=null},onArrayEnd:()=>{l=s.pop()},onLiteralValue:y,onError:(O,j,K)=>{d.push({error:O,offset:j,length:K})}};if(i)try{k.visit(i,M),n=l[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return n}h(i,n){const r=b.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),l=this.i(i,r,!0,n);i=l.raw;const s=(0,S.toValuesTree)(i,M=>console.error(`Conflict in settings file ${this.f}: ${M}`)),d=Object.keys(i),y=this.j(i,M=>console.error(`Conflict in settings file ${this.f}: ${M}`));return{contents:s,keys:d,overrides:y,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(i,n,r,l){let s=!1;if(!l?.scopes&&!l?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:s};const d={},y=[];for(const M in i)if(v.OVERRIDE_PROPERTY_REGEX.test(M)&&r){const O=this.i(i[M],n,!1,l);d[M]=O.raw,s=s||O.hasExcludedProperties,y.push(...O.restricted)}else{const O=n[M],j=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&y.push(M),(j===void 0||l.scopes===void 0||l.scopes.includes(j))&&!(l.skipRestricted&&O?.restricted)?d[M]=i[M]:s=!0}return{raw:d,restricted:y,hasExcludedProperties:s}}j(i,n){const r=[];for(const l of Object.keys(i))if(v.OVERRIDE_PROPERTY_REGEX.test(l)){const s={};for(const d in i[l])s[d]=i[l][d];r.push({identifiers:(0,v.overrideIdentifiersFromKey)(l),keys:Object.keys(s),contents:(0,S.toValuesTree)(s,n)})}return r}}e.ConfigurationModelParser=w;class c extends o.Disposable{constructor(i,n,r,l){super(),this.f=i,this.g=n,this.h=l,this.c=this.B(new L.Emitter),this.onDidChange=this.c.event,this.a=new w(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(L.Event.any(L.Event.filter(this.h.onDidFilesChange,s=>s.contains(this.f)),L.Event.filter(this.h.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&r.isEqual(s.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new p}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=c;class u{constructor(i,n,r,l,s,d,y,M,O,j,K,x,J){this.a=i,this.b=n,this.c=r,this.overrideIdentifiers=l,this.d=s,this.f=d,this.g=y,this.h=M,this.i=O,this.j=j,this.k=K,this.l=x,this.m=J}get value(){return f(this.c)}n(i,n,r){const l=i.inspect(n,r);return{get value(){return f(l.value)},get override(){return f(l.override)},get merged(){return f(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class g{constructor(i,n,r,l,s=new p,d=new p,y=new C.ResourceMap,M=new p,O=new C.ResourceMap){this.c=i,this.d=n,this.f=r,this.g=l,this.h=s,this.i=d,this.j=y,this.l=M,this.m=O,this.a=null,this.b=new C.ResourceMap,this.n=null}getValue(i,n,r){return this.q(i,n,r).getValue(i)}updateValue(i,n,r={}){let l;r.resource?(l=this.m.get(r.resource),l||(l=new p,this.m.set(r.resource,l))):l=this.l,n===void 0?l.removeValue(i):l.setValue(i,n),r.resource||(this.a=null)}inspect(i,n,r){const l=this.q(i,n,r),s=this.u(n.resource,r),d=n.resource?this.m.get(n.resource)||this.l:this.l,y=new Set;for(const M of l.overrides)for(const O of M.identifiers)l.getOverrideValue(i,O)!==void 0&&y.add(O);return new u(i,n,l.getValue(i),y.size?[...y]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,s||void 0,d)}keys(i){const n=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,n){this.j.set(i,n),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const r=[];if(!n){const{added:l,updated:s,removed:d}=R(this.c,i);n=[...l,...s,...d]}for(const l of n)for(const s of(0,v.overrideIdentifiersFromKey)(l)){const d=this.c.getKeysForOverrideIdentifier(s),y=i.getKeysForOverrideIdentifier(s),M=[...y.filter(O=>d.indexOf(O)===-1),...d.filter(O=>y.indexOf(O)===-1),...d.filter(O=>!P.equals(this.c.override(s).getValue(O),i.override(s).getValue(O)))];r.push([s,M])}return this.updateDefaultConfiguration(i),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:r,removed:l}=R(this.d,i),s=[...n,...r,...l];return s.length&&this.updatePolicyConfiguration(i),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:r,removed:l,overrides:s}=R(this.applicationConfiguration,i),d=[...n,...r,...l];return d.length&&this.updateApplicationConfiguration(i),{keys:d,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:r,removed:l,overrides:s}=R(this.localUserConfiguration,i),d=[...n,...r,...l];return d.length&&this.updateLocalUserConfiguration(i),{keys:d,overrides:s}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:r,removed:l,overrides:s}=R(this.remoteUserConfiguration,i),d=[...n,...r,...l];return d.length&&this.updateRemoteUserConfiguration(i),{keys:d,overrides:s}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:r,removed:l,overrides:s}=R(this.workspaceConfiguration,i),d=[...n,...r,...l];return d.length&&this.updateWorkspaceConfiguration(i),{keys:d,overrides:s}}compareAndUpdateFolderConfiguration(i,n){const r=this.p.get(i),{added:l,updated:s,removed:d,overrides:y}=R(r,n),M=[...l,...s,...d];return(M.length||!r)&&this.updateFolderConfiguration(i,n),{keys:M,overrides:y}}compareAndDeleteFolderConfiguration(i){const n=this.p.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:l,removed:s,overrides:d}=R(n,void 0);return{keys:[...r,...l,...s],overrides:d}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,n,r){let l=this.r(n,r);return n.overrideIdentifier&&(l=l.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(l=l.merge(this.d)),l}r({resource:i},n){let r=this.s();if(n&&i){const l=n.getFolder(i);l&&(r=this.t(l.uri)||r);const s=this.m.get(i);s&&(r=r.merge(s))}return r}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let n=this.b.get(i);if(!n){const r=this.s(),l=this.j.get(i);l?(n=r.merge(l),this.b.set(i,n)):n=r}return n}u(i,n){if(n&&i){const r=n.getFolder(i);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,n)=>{const{contents:r,overrides:l,keys:s}=this.j.get(n);return i.push([n,{contents:r,overrides:l,keys:s}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.i.keys.forEach(n=>i.add(n)),this.j.forEach(n=>n.keys.forEach(r=>i.add(r))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}w(i){const n=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.i.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(l=>n.add(l))),[...n.values()]}static parse(i){const n=this.x(i.defaults),r=this.x(i.policy),l=this.x(i.application),s=this.x(i.user),d=this.x(i.workspace),y=i.folders.reduce((M,O)=>(M.set(m.URI.revive(O[0]),this.x(O[1])),M),new C.ResourceMap);return new g(n,r,l,s,new p,d,y,new p,new C.ResourceMap)}static x(i){return new p(i.contents,i.keys,i.overrides)}}e.Configuration=g;function D(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,n=new Map;for(const l of a)l.keys.forEach(s=>i.add(s)),l.overrides.forEach(([s,d])=>{const y=(0,C.getOrSet)(n,s,new Set);d.forEach(M=>y.add(M))});const r=[];return n.forEach((l,s)=>r.push([s,[...l.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=D;class E{constructor(i,n,r,l){this.change=i,this.f=n,this.g=r,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const s of i.keys)this.affectedKeys.add(s);for(const[,s]of i.overrides)for(const d of s)this.affectedKeys.add(d);this.d=this.a;for(const s of this.affectedKeys)this.d+=s+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=g.parse(this.f.data)),this.i}affectsConfiguration(i,n){const r=this.a+i,l=this.d.indexOf(r);if(l<0)return!1;const s=l+r.length;if(s>=this.d.length)return!1;const d=this.d.charCodeAt(s);if(d!==this.b&&d!==this.c)return!1;if(n){const y=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,M=this.g.getValue(i,n,this.h);return!P.equals(y,M)}return!0}}e.ConfigurationChangeEvent=E;function R(a,i){const{added:n,removed:r,updated:l}=t(i?.rawConfiguration,a?.rawConfiguration),s=[],d=a?.getAllOverrideIdentifiers()||[],y=i?.getAllOverrideIdentifiers()||[];if(i){const M=y.filter(O=>!d.includes(O));for(const O of M)s.push([O,i.getKeysForOverrideIdentifier(O)])}if(a){const M=d.filter(O=>!y.includes(O));for(const O of M)s.push([O,a.getKeysForOverrideIdentifier(O)])}if(i&&a){for(const M of d)if(y.includes(M)){const O=t({contents:a.getOverrideValue(void 0,M)||{},keys:a.getKeysForOverrideIdentifier(M)},{contents:i.getOverrideValue(void 0,M)||{},keys:i.getKeysForOverrideIdentifier(M)});s.push([M,[...O.added,...O.removed,...O.updated]])}}return{added:n,removed:r,updated:l,overrides:s}}function t(a,i){const n=a?i?a.keys.filter(s=>i.keys.indexOf(s)===-1):[...a.keys]:[],r=i?a?i.keys.filter(s=>a.keys.indexOf(s)===-1):[...i.keys]:[],l=[];if(a&&i){for(const s of i.keys)if(a.keys.indexOf(s)!==-1){const d=(0,S.getConfigurationValue)(i.contents,s),y=(0,S.getConfigurationValue)(a.contents,s);P.equals(d,y)||l.push(s)}}return{added:n,removed:r,updated:l}}}),define(te[223],ie([0,1,25,3,2,44,10,111,67,5,39,50]),function(V,e,I,L,k,o,C,P,h,m,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class b extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new L.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(v.Registry.as(h.Extensions.Configuration).onDidUpdateConfiguration(({properties:c,defaultsOverrides:u})=>this.c(Array.from(c),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(c,u){this.h(c,v.Registry.as(h.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:c})}f(){return{}}g(){this.b=new P.ConfigurationModel;const c=v.Registry.as(h.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(c),c)}h(c,u){const g=this.f();for(const D of c){const E=g[D],R=u[D];E!==void 0?this.b.addValue(D,E):R?this.b.addValue(D,R.default):this.b.removeValue(D)}}}e.DefaultConfiguration=b;class f{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=f;let p=class extends k.Disposable{get configurationModel(){return this.b}constructor(c,u,g){super(),this.c=c,this.f=u,this.g=g,this.a=this.B(new L.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(c=>this.i(c))),this.B(this.c.onDidChangeConfiguration(async({properties:c})=>this.j(await this.h(c),!0))),this.b}async h(c){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",c);const u={},g=[],D=v.Registry.as(h.Extensions.Configuration).getConfigurationProperties();for(const E of c){const R=D[E];if(!R){g.push(E);continue}if(R.policy){if(R.type!=="string"&&R.type!=="number"){this.g.warn(`Policy ${R.policy.name} has unsupported type ${R.type}`);continue}g.push(E),u[R.policy.name]={type:R.type}}}return(0,C.isEmptyObject)(u)||await this.f.updatePolicyDefinitions(u),g}i(c){this.g.trace("PolicyConfiguration#onDidChangePolicies",c);const u=v.Registry.as(h.Extensions.Configuration).getPolicyConfigurations(),g=(0,I.coalesce)(c.map(D=>u.get(D)));this.j(g,!0)}j(c,u){this.g.trace("PolicyConfiguration#update",c);const g=v.Registry.as(h.Extensions.Configuration).getConfigurationProperties(),D=[],E=this.b.isEmpty();for(const R of c){const t=g[R]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(E?a!==void 0:!(0,o.equals)(this.b.getValue(R),a))&&D.push([R,a])}else this.b.getValue(R)!==void 0&&D.push([R,void 0])}if(D.length){this.g.trace("PolicyConfiguration#changed",D);const R=this.b;this.b=new P.ConfigurationModel;for(const t of R.keys)this.b.setValue(t,R.getValue(t));for(const[t,a]of D)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);u&&this.a.fire(this.b)}}};p=ve([ee(1,S.IPolicyService),ee(2,m.ILogService)],p),e.PolicyConfiguration=p}),define(te[224],ie([0,1,8,3,2,20,18,111,223,39]),function(V,e,I,L,k,o,C,P,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class S extends k.Disposable{constructor(b,f,p,w){super(),this.i=b,this.h=this.B(new L.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new h.DefaultConfiguration),this.c=p instanceof m.NullPolicyService?new h.NullPolicyConfiguration:this.B(new h.PolicyConfiguration(this.b,p,w)),this.f=this.B(new P.UserSettings(this.i,void 0,o.extUriBiasedIgnorePathCase,f)),this.a=new P.Configuration(this.b.configurationModel,this.c.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.g=this.B(new I.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:c,properties:u})=>this.k(c,u))),this.B(this.c.onDidChangeConfiguration(c=>this.l(c))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[b,f,p]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.Configuration(b,f,new P.ConfigurationModel,p)}getConfigurationData(){return this.a.toData()}getValue(b,f){const p=typeof b=="string"?b:void 0,w=(0,C.isConfigurationOverrides)(b)?b:(0,C.isConfigurationOverrides)(f)?f:{};return this.a.getValue(p,w,void 0)}updateValue(b,f,p,w){return Promise.reject(new Error("not supported"))}inspect(b){return this.a.inspect(b,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const b=await this.f.loadConfiguration();this.j(b)}j(b){const f=this.a.toData(),p=this.a.compareAndUpdateLocalUserConfiguration(b);this.m(p,f,2)}k(b,f){const p=this.a.toData(),w=this.a.compareAndUpdateDefaultConfiguration(b,f);this.m(w,p,7)}l(b){const f=this.a.toData(),p=this.a.compareAndUpdatePolicyConfiguration(b);this.m(p,f,7)}m(b,f,p){const w=new P.ConfigurationChangeEvent(b,{data:f},this.a);w.source=p,w.sourceConfig=this.n(p),this.h.fire(w)}n(b){switch(b){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=S}),define(te[225],ie([0,1,13,6]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var k;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class o extends I.ErrorNoTelemetry{static isNotAvailable(h){return h instanceof o&&h._code===k.NotAvailable}static isTemporarilyNotAvailable(h){return h instanceof o&&h._code===k.TemporarilyNotAvailable}static isNoResolverFound(h){return h instanceof o&&h._code===k.NoResolverFound}static isHandled(h){return h instanceof o&&h.isHandled}constructor(h,m=k.Unknown,S){super(h),this._message=h,this._code=m,this._detail=S,this.isHandled=m===k.NotAvailable&&S===!0,Object.setPrototypeOf(this,o.prototype)}}e.RemoteAuthorityResolverError=o;function C(P){const h=P.indexOf("+");return h===-1?P:P.substring(0,h)}e.getRemoteAuthorityPrefix=C}),define(te[55],ie([0,1,15]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(m){return m.scheme===I.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=L;function k(m){if(!m)return;const S=m.indexOf("+");return S<0?m:m.substr(0,S)}e.getRemoteName=k;function o(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=o;function C(m){const{host:S,port:v}=h(m);if(typeof v>"u")throw new Error("Remote authority doesn't contain a port!");return{host:S,port:v}}e.parseAuthorityWithPort=C;function P(m,S){let{host:v,port:b}=h(m);return typeof b>"u"&&(b=S),{host:v,port:b}}e.parseAuthorityWithOptionalPort=P;function h(m){const S=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(S)return{host:S[1],port:parseInt(S[2],10)};const v=m.match(/^(\[[0-9a-z:]+\])$/);if(v)return{host:v[1],port:void 0};const b=m.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:m,port:void 0}}}),define(te[90],ie([0,1,27,6,55]),function(V,e,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function o(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.getWorkspaceSupportTypeMessage=o;function C(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var h;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(h=e.TargetPlatform||(e.TargetPlatform={}));class m{constructor(w){this.value=w,this.c=w.toLowerCase()}static equals(w,c){if(typeof w>"u"||w===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof w=="string"||typeof c=="string"){const u=typeof w=="string"?w:w.value,g=typeof c=="string"?c:c.value;return I.equalsIgnoreCase(u,g)}return w.c===c.c}static toKey(w){return typeof w=="string"?w.toLowerCase():w.c}}e.ExtensionIdentifier=m;function S(p){return v(p)}e.isApplicationScopedExtension=S;function v(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=v;function b(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=b;function f(p,w){if(w){const c=`onResolveRemoteAuthority:${(0,k.getRemoteName)(w)}`;return p.activationEvents?.indexOf(c)!==-1}return!1}e.isResolverExtension=f,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[226],ie([0,1,8,17,22,13,3,2,63,70,31,104,225,55]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const p=30*1e3;var w;(function(T){T[T.Management=1]="Management",T[T.ExtensionHost=2]="ExtensionHost",T[T.Tunnel=3]="Tunnel"})(w=e.ConnectionType||(e.ConnectionType={}));function c(T){switch(T){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(T){const W=new k.CancellationTokenSource;return setTimeout(()=>W.cancel(),T),W.token}function g(T,W){if(T.isCancellationRequested||W.isCancellationRequested)return k.CancellationToken.Cancelled;const B=new k.CancellationTokenSource;return T.onCancellationRequested(()=>B.cancel()),W.onCancellationRequested(()=>B.cancel()),B.token}class D{get didTimeout(){return this.c==="timedout"}constructor(W){this.c="pending",this.d=new P.DisposableStore,this.promise=new Promise((B,G)=>{this.f=B,this.g=G}),W.isCancellationRequested?this.h():this.d.add(W.onCancellationRequested(()=>this.h()))}registerDisposable(W){this.c==="pending"?this.d.add(W):W.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(W))}reject(W){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(W))}}function E(T,W){const B=new D(W);return B.registerDisposable(T.onControlMessage(G=>{const N=JSON.parse(G.toString()),q=z(N);q?B.reject(q):B.resolve(N)})),B.promise}function R(T,W,B,G,N,q,Q,oe,ue){const ye=new D(ue),ke=m.StopWatch.create(!1);return T.info(`Creating a socket (${oe})...`),h.mark(`code/willCreateSocket/${Q}`),W.connect(B,G,N,q,oe,(Ae,Re)=>{ye.didTimeout?(h.mark(`code/didCreateSocketError/${Q}`),T.info(`Creating a socket (${oe}) finished after ${ke.elapsed()} ms, but this is too late and has timed out already.`),Ae&&T.error(Ae),Re?.dispose()):Ae||!Re?(h.mark(`code/didCreateSocketError/${Q}`),T.info(`Creating a socket (${oe}) returned an error after ${ke.elapsed()} ms.`),ye.reject(Ae)):(h.mark(`code/didCreateSocketOK/${Q}`),T.info(`Creating a socket (${oe}) was successful after ${ke.elapsed()} ms.`),ye.resolve(Re))}),ye.promise}function t(T,W){const B=new D(W);return T.then(G=>{B.didTimeout||B.resolve(G)},G=>{B.didTimeout||B.reject(G)}),B.promise}async function a(T,W,B,G){const N=$(T,W);T.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let q;try{q=await R(T.logService,T.socketFactory,T.host,T.port,(0,f.getRemoteServerRootPath)(T),`reconnectionToken=${T.reconnectionToken}&reconnection=${T.reconnectionProtocol?"true":"false"}`,c(W),`renderer-${c(W)}-${T.reconnectionToken}`,G)}catch(ke){throw T.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),T.logService.error(ke),ke}T.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let Q,oe;T.reconnectionProtocol?(T.reconnectionProtocol.beginAcceptReconnection(q,null),Q=T.reconnectionProtocol,oe=!1):(Q=new v.PersistentProtocol({socket:q,measureRoundTripTime:!0}),oe=!0),T.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const ue=await t(T.signService.createNewMessage((0,S.generateUuid)()),G),ye={type:"auth",auth:T.connectionToken||"00000000000000000000",data:ue.data};Q.sendControl(L.VSBuffer.fromString(JSON.stringify(ye)));try{const ke=await E(Q,g(G,u(1e4)));if(ke.type!=="sign"||typeof ke.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(T.logService.trace(`${N} 4/6. received SignRequest control message.`),!await t(T.signService.validate(ue,ke.signedData),G)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const Re=await t(T.signService.sign(ke.data),G),Fe={type:"connectionType",commit:T.commit,signedData:Re,desiredConnectionType:W};return B&&(Fe.args=B),T.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),Q.sendControl(L.VSBuffer.fromString(JSON.stringify(Fe))),{protocol:Q,ownsProtocol:oe}}catch(ke){throw ke&&ke.code==="ETIMEDOUT"&&(T.logService.error(`${N} the handshake timed out. Error:`),T.logService.error(ke)),ke&&ke.code==="VSCODE_CONNECTION_ERROR"&&(T.logService.error(`${N} received error control message when negotiating connection. Error:`),T.logService.error(ke)),oe&&U(Q),ke}}async function i(T,W,B,G){const N=Date.now(),q=$(T,W),{protocol:Q,ownsProtocol:oe}=await a(T,W,B,G),ue=new D(G);return ue.registerDisposable(Q.onControlMessage(ye=>{const ke=JSON.parse(ye.toString()),Ae=z(ke);Ae?(T.logService.error(`${q} received error control message when negotiating connection. Error:`),T.logService.error(Ae),oe&&U(Q),ue.reject(Ae)):(T.reconnectionProtocol?.endAcceptReconnection(),T.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${A(N)}!`),ue.resolve({protocol:Q,firstMessage:ke}))})),ue.promise}async function n(T,W){const{protocol:B}=await i(T,1,void 0,W);return{protocol:B}}async function r(T,W,B){const{protocol:G,firstMessage:N}=await i(T,2,W,B),q=N&&N.debugPort;return{protocol:G,debugPort:q}}async function l(T,W,B){const G=Date.now(),N=$(T,3),{protocol:q}=await a(T,3,W,B);return T.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${A(G)}!`),q}async function s(T,W,B){const{host:G,port:N,connectionToken:q}=await T.addressProvider.getAddress();return{commit:T.commit,quality:T.quality,host:G,port:N,connectionToken:q,reconnectionToken:W,reconnectionProtocol:B,socketFactory:T.socketFactory,signService:T.signService,logService:T.logService}}async function d(T,W,B){return M(T,async G=>{const{protocol:N}=await n(G,k.CancellationToken.None);return new H(T,W,B,G.reconnectionToken,N)})}e.connectRemoteAgentManagement=d;async function y(T,W){return M(T,async B=>{const{protocol:G,debugPort:N}=await r(B,W,k.CancellationToken.None);return new F(T,W,B.reconnectionToken,G,N)})}e.connectRemoteAgentExtensionHost=y;async function M(T,W){for(let G=1;;G++)try{const N=(0,S.generateUuid)(),q=await s(T,N,null);return await W(q)}catch(N){if(G<5)T.logService.error(`[remote-connection][attempt ${G}] An error occurred in initial connection! Will retry... Error:`),T.logService.error(N);else throw T.logService.error(`[remote-connection][attempt ${G}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),T.logService.error(N),ge.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled(N)),N}}async function O(T,W,B){const G=await s(T,(0,S.generateUuid)(),null);return await l(G,{host:W,port:B},k.CancellationToken.None)}e.connectRemoteAgentTunnel=O;function j(T){return(0,I.createCancelablePromise)(W=>new Promise((B,G)=>{const N=setTimeout(B,T*1e3);W.onCancellationRequested(()=>{clearTimeout(N),B()})}))}var K;(function(T){T[T.ConnectionLost=0]="ConnectionLost",T[T.ReconnectionWait=1]="ReconnectionWait",T[T.ReconnectionRunning=2]="ReconnectionRunning",T[T.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",T[T.ConnectionGain=4]="ConnectionGain",T[T.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(K=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class x{constructor(W,B){this.reconnectionToken=W,this.millisSinceLastIncomingData=B,this.type=0}}e.ConnectionLostEvent=x;class J{constructor(W,B,G,N){this.reconnectionToken=W,this.millisSinceLastIncomingData=B,this.durationSeconds=G,this.c=N,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=J;class re{constructor(W,B,G){this.reconnectionToken=W,this.millisSinceLastIncomingData=B,this.attempt=G,this.type=2}}e.ReconnectionRunningEvent=re;class se{constructor(W,B,G){this.reconnectionToken=W,this.millisSinceLastIncomingData=B,this.attempt=G,this.type=4}}e.ConnectionGainEvent=se;class ae{constructor(W,B){this.reconnectionToken=W,this.connectionHealth=B,this.type=5}}e.ConnectionHealthChangedEvent=ae;class fe{constructor(W,B,G,N){this.reconnectionToken=W,this.millisSinceLastIncomingData=B,this.attempt=G,this.handled=N,this.type=3}}e.ReconnectionPermanentFailureEvent=fe;class ge extends P.Disposable{static triggerPermanentFailure(W,B,G){this._permanentFailure=!0,this.f=W,this.g=B,this.h=G,this.i.forEach(N=>N.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(W=>W.r())}static debugPauseSocketWriting(){this.i.forEach(W=>W.v())}get k(){return this.c||ge._permanentFailure}constructor(W,B,G,N,q){super(),this.m=W,this.n=B,this.reconnectionToken=G,this.protocol=N,this.p=q,this.j=this.B(new C.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new se(this.reconnectionToken,0,0)),this.B(N.onSocketClose(Q=>{const oe=_(this.m,this.reconnectionToken,!0);Q?Q.type===0?(this.n.logService.info(`${oe} received socket close event (hadError: ${Q.hadError}).`),Q.error&&this.n.logService.error(Q.error)):(this.n.logService.info(`${oe} received socket close event (wasClean: ${Q.wasClean}, code: ${Q.code}, reason: ${Q.reason}).`),Q.event&&this.n.logService.error(Q.event)):this.n.logService.info(`${oe} received socket close event.`),this.r()})),this.B(N.onSocketTimeout(Q=>{const oe=_(this.m,this.reconnectionToken,!0);this.n.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${Q.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Q.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Q.timeSinceLastReceivedSomeData}).`),this.r()})),this.B(N.onHighRoundTripTime(Q=>{const oe=ne(this.m,this.reconnectionToken);this.n.logService.info(`${oe} high roundtrip time: ${Q.roundTripTime}ms (${Q.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(N.onDidChangeConnectionHealth(Q=>{this.j.fire(new ae(this.reconnectionToken,Q))})),ge.i.push(this),this.B((0,P.toDisposable)(()=>{const Q=ge.i.indexOf(this);Q>=0&&ge.i.splice(Q,1)})),this.k&&this.u(ge.f,ge.g,ge.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const W=_(this.m,this.reconnectionToken,!0);this.n.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const B=[0,5,5,10,10,10,10,10,30];let G=-1;do{G++;const N=G<B.length?B[G]:B[B.length-1];try{if(N>0){const Q=j(N);this.j.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,Q)),this.n.logService.info(`${W} waiting for ${N} seconds before reconnecting...`);try{await Q}catch{}}if(this.k){this.n.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1)),this.n.logService.info(`${W} resolving connection...`);const q=await s(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${W} connecting to ${q.host}:${q.port}...`),await this.w(q,u(p)),this.n.logService.info(`${W} reconnected!`),this.j.fire(new se(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1));break}catch(q){if(q.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(q),this.t(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(G>360){this.n.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(q),this.t(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(b.RemoteAuthorityResolverError.isTemporarilyNotAvailable(q)){this.n.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(q);continue}if((q.code==="ETIMEDOUT"||q.code==="ENETUNREACH"||q.code==="ECONNREFUSED"||q.code==="ECONNRESET")&&q.syscall==="connect"){this.n.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(q);continue}if((0,o.isCancellationError)(q)){this.n.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(q);continue}if(q instanceof b.RemoteAuthorityResolverError){this.n.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(q),this.t(this.protocol.getMillisSinceLastIncomingData(),G+1,b.RemoteAuthorityResolverError.isHandled(q));break}this.n.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(q),this.t(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}}while(!this.k)}t(W,B,G){this.p?ge.triggerPermanentFailure(W,B,G):this.u(W,B,G)}u(W,B,G){this.j.fire(new fe(this.reconnectionToken,W,B,G)),U(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ge,ge._permanentFailure=!1,ge.f=0,ge.g=0,ge.h=!1,ge.i=[];class H extends ge{constructor(W,B,G,N,q){super(1,W,N,q,!0),this.client=this.B(new v.Client(q,{remoteAuthority:B,clientId:G},W.ipcLogger))}async w(W,B){await n(W,B)}}e.ManagementPersistentConnection=H;class F extends ge{constructor(W,B,G,N,q){super(2,W,G,N,!1),this.y=B,this.debugPort=q}async w(W,B){await r(W,this.y,B)}}e.ExtensionHostPersistentConnection=F;function U(T){try{T.acceptDisconnect();const W=T.getSocket();T.dispose(),W.dispose()}catch(W){(0,o.onUnexpectedError)(W)}}function z(T){if(T&&T.type==="error"){const W=new Error(`Connection error: ${T.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function Y(T,W){for(;T.length<W;)T+=" ";return T}function ne(T,W){return`[remote-connection][${Y(c(T),13)}][${W.substr(0,5)}\u2026]`}function _(T,W,B){return`${ne(T,W)}[${B?"reconnect":"initial"}]`}function $(T,W){return`${_(W,T.reconnectionToken,!!T.reconnectionProtocol)}[${T.host}:${T.port}]`}function A(T){return`${Date.now()-T} ms`}}),define(te[227],ie([0,1,81,86]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,o,C,P,h,m){const S=b=>m(b,void 0),v=I.createConnection({host:k,port:o},()=>{v.removeListener("error",S);const b=Buffer.alloc(16);for(let c=0;c<16;c++)b[c]=Math.round(Math.random()*256);const f=b.toString("base64"),p=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${o}${C}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];v.write(p.join(`\r
`)+`\r
\r
`);const w=c=>{c.toString().indexOf(`\r
\r
`)>=0&&(v.off("data",w),m(void 0,new L.NodeSocket(v,h)))};v.on("data",w)});v.setNoDelay(!0),v.once("error",S)}}}),define(te[228],ie([0,1,26,46,41,186]),function(V,e,I,L,k,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let C;async function P(f=!1){return(C===void 0||f)&&(C=h()),C}e.hasWSLFeatureInstalled=P;async function h(){const f=m();if(f===void 0)return!1;if(f>=22e3){const p=v();if(p)return new Promise(w=>{L.execFile(p,["--status"],c=>w(!c))})}else{const p=b();if(p)try{if((await k.promises.stat(p)).isFile())return!0}catch{}}return!1}function m(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(I.release());if(f)return parseInt(f[3])}function S(f){const p=process.env.SystemRoot;if(p){const w=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return o.join(p,w?"Sysnative":"System32",f)}}function v(){return S("wsl.exe")}function b(){return S("lxss\\LxssManager.dll")}}),define(te[56],ie([0,1,17,170,67,6,50]),function(V,e,I,L,k,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,o.createDecorator)("requestService");function P(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}e.isSuccess=P;function h(w){return w.res.statusCode===204}async function m(w){return h(w)?null:(await(0,I.streamToBuffer)(w.stream)).toString()}e.asText=m;async function S(w){if(!P(w))throw new Error("Server returned "+w.res.statusCode);return m(w)}e.asTextOrError=S;async function v(w){if(!P(w))throw new Error("Server returned "+w.res.statusCode);if(h(w))return null;const u=(await(0,I.streamToBuffer)(w.stream)).toString();try{return JSON.parse(u)}catch(g){throw g.message+=`:
`+u,g}}e.asJson=v;function b(w){p(w)}e.updateProxyConfigurationsScope=b;let f;function p(w){const c=C.Registry.as(k.Extensions.Configuration),u=f;f={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},c.updateConfigurations({add:[f],remove:u?[u]:[]})}p(2)}),define(te[229],ie([0,1,17,22]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(P){this.a=P}listen(P,h){throw new Error("Invalid listen")}call(P,h,m,S=L.CancellationToken.None){switch(h){case"request":return this.a.request(m[0],S).then(async({res:v,stream:b})=>{const f=await(0,I.streamToBuffer)(b);return[{statusCode:v.statusCode,headers:v.headers},f]});case"resolveProxy":return this.a.resolveProxy(m[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class o{constructor(P){this.a=P}async request(P,h){const[m,S]=await this.a.call("request",[P],h);return{res:m,stream:(0,I.bufferToStream)(S)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.RequestChannelClient=o}),define(te[230],ie([0,1,231,10]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(C,P){return C.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:C.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function o(C,P,h={}){const m=(0,I.parse)(C),S=h.proxyUrl||k(m,P);if(!S)return null;const v=(0,I.parse)(S);if(!/^https?:$/.test(v.protocol||""))return null;const b={host:v.hostname||"",port:v.port||(v.protocol==="https"?"443":"80"),auth:v.auth,rejectUnauthorized:(0,L.isBoolean)(h.strictSSL)?h.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((f,p)=>{V(["http-proxy-agent"],f,p)}))(b):new(await new Promise((f,p)=>{V(["https-proxy-agent"],f,p)}))(b)}e.getProxyAgent=o}),define(te[112],ie([0,1,46,9,171,22,45,13,4,31,147,61,8,127]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let p;async function w(u,g,D,E){return D["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.isLaunchedFromCli)(E)&&!D["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.isLaunchedFromCli)(E)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=b.Promises.withAsyncBody(async(R,t)=>{const a=new o.CancellationTokenSource;let i=1e4;const n=u.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,f.clamp)(n,1,120)*1e3);const r=setTimeout(()=>{a.dispose(!0),t(new Error((0,k.localize)(0,null)))},i);try{R(await c(g,a.token))}catch(l){!(0,P.isCancellationError)(l)&&!a.token.isCancellationRequested?t(new Error((0,k.localize)(1,null,(0,C.toErrorMessage)(l)))):R({})}finally{clearTimeout(r),a.dispose()}})),p)}e.getResolvedShellEnv=w;async function c(u,g){const D=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",D);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",E);const R=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(R+"({.*})"+R),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",a);const i=await(0,S.getSystemShell)(h.OS,a);return u.trace("getUnixShellEnvironment#shell",i),new Promise((n,r)=>{if(g.isCancellationRequested)return r(new P.CancellationError);const l=(0,L.basename)(i);let s,d;const y=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(s=`& '${process.execPath}' ${y} -p '''${R}'' + JSON.stringify(process.env) + ''${R}'''`,d=["-Login","-Command"]):(s=`'${process.execPath}' ${y} -p '"${R}" + JSON.stringify(process.env) + "${R}"'`,l==="tcsh"||l==="csh"?d=["-ic"]:d=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),s);const M=(0,I.spawn)(i,[...d,s],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});g.onCancellationRequested(()=>(M.kill(),r(new P.CancellationError))),M.on("error",K=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,C.toErrorMessage)(K)),r(K)});const O=[];M.stdout.on("data",K=>O.push(K));const j=[];M.stderr.on("data",K=>j.push(K)),M.on("close",(K,x)=>{const J=Buffer.concat(O).toString("utf8");u.trace("getUnixShellEnvironment#raw",J);const re=Buffer.concat(j).toString("utf8");if(re.trim()&&u.trace("getUnixShellEnvironment#stderr",re),K||x)return r(new Error((0,k.localize)(2,null,K,x)));const se=t.exec(J),ae=se?se[1]:"{}";try{const fe=JSON.parse(ae);D?fe.ELECTRON_RUN_AS_NODE=D:delete fe.ELECTRON_RUN_AS_NODE,E?fe.ELECTRON_NO_ATTACH_CONSOLE=E:delete fe.ELECTRON_NO_ATTACH_CONSOLE,delete fe.VSCODE_RESOLVING_ENVIRONMENT,delete fe.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",fe),n(fe)}catch(fe){u.error("getUnixShellEnvironment#errorCaught",(0,C.toErrorMessage)(fe)),r(fe)}})})}}),define(te[91],ie([0,1,6]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,I.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[232],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class I{constructor(){this.b=new Map}c(){return new Promise((k,o)=>V(["vsda"],k,o))}async createNewMessage(k){try{const o=await this.c(),C=new o.validator;if(C){const P=String(I.a++);return this.b.set(P,C),{id:P,data:C.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,o){if(!k.id)return!0;const C=this.b.get(k.id);if(!C)return!1;this.b.delete(k.id);try{return C.validate(o)==="ok"}catch{return!1}}async sign(k){try{const o=await this.c(),C=new o.signer;if(C)return C.sign(k)}catch{}return k}}e.SignService=I,I.a=1}),define(te[34],ie([0,1,6]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,I.createDecorator)("stateMainService")}),define(te[21],ie([0,1,14,42,8,3,2,4,35,10,6,5,34,28]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,S.createDecorator)("lifecycleMainService");var p;(function(u){u[u.QUIT=1]="QUIT",u[u.KILL=2]="KILL"})(p=e.ShutdownReason||(e.ShutdownReason={}));var w;(function(u){u[u.Starting=1]="Starting",u[u.Ready=2]="Ready",u[u.AfterWindowOpen=3]="AfterWindowOpen",u[u.Eventually=4]="Eventually"})(w=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let c=class kt extends C.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(g,D,E){super(),this.v=g,this.w=D,this.y=E,this.c=this.B(new o.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.B(new o.Emitter),this.onWillShutdown=this.f.event,this.g=this.B(new o.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.B(new o.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.z(),this.when(2).then(()=>this.C())}z(){this.j=!!this.w.getItem(kt.b),this.j&&this.w.removeItem(kt.b)}C(){const g=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.isMacintosh&&this.n===0&&this.D(1))};I.app.addListener("before-quit",g);const D=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!P.isMacintosh)&&I.app.quit()};I.app.addListener("window-all-closed",D),I.app.once("will-quit",E=>{this.L("Lifecycle#app.on(will-quit)"),E.preventDefault(),this.D(1).finally(()=>{this.H(!1),I.app.removeListener("before-quit",g),I.app.removeListener("window-all-closed",D),I.app.quit()})})}D(g){if(this.s)return this.s;this.L("Lifecycle#onWillShutdown.fire()");const D=[];return this.f.fire({reason:g,join(E){D.push(E)}}),this.s=(async()=>{try{await k.Promises.settled(D)}catch(E){this.v.error(E)}try{await this.w.close()}catch(E){this.v.error(E)}})(),this.s}set phase(g){if(g<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===g)return;this.L(`lifecycle (main): phase changed (value: ${g})`),this.k=g;const D=this.u.get(this.k);D&&(D.open(),this.u.delete(this.k))}async when(g){if(g<=this.k)return;let D=this.u.get(g);D||(D=new k.Barrier,this.u.set(g,D)),await D.wait()}registerWindow(g){const D=new C.DisposableStore;this.n++,D.add(g.onWillLoad(R=>this.g.fire({window:g,workspace:R.workspace,reason:R.reason})));const E=(0,m.assertIsDefined)(g.win);E.on("close",R=>{const t=g.id;if(this.l.has(t)){this.l.delete(t);return}this.L(`Lifecycle#window.on('close') - window ID ${g.id}`),R.preventDefault(),this.unload(g,1).then(a=>{if(a){this.l.delete(t);return}this.l.add(t),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${t}`),this.h.fire(g),g.close()})}),E.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${g.id}`),this.n--,D.dispose(),this.n===0&&(!P.isMacintosh||this.i)&&this.D(1)})}async reload(g,D){await this.unload(g,3)||g.reload(D)}unload(g,D){const E=this.t.get(g.id);if(E)return E;const R=this.F(g,D).finally(()=>{this.t.delete(g.id)});return this.t.set(g.id,R),R}async F(g,D){if(!g.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${g.id}`);const E=this.i?2:D,R=await this.I(g,E);return R?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${g.id})`),this.G(R)):(await this.J(g,E),!1)}G(g){return g?(this.H(!0),this.i=!1,!0):!1}H(g){this.r&&(this.r(g),this.r=void 0,this.p=void 0)}I(g,D){return new Promise(E=>{const R=this.m++,t=`vscode:ok${R}`,a=`vscode:cancel${R}`;L.validatedIpcMain.once(t,()=>{E(!1)}),L.validatedIpcMain.once(a,()=>{E(!0)}),g.send("vscode:onBeforeUnload",{okChannel:t,cancelChannel:a,reason:D})})}J(g,D){return new Promise(E=>{const t=`vscode:reply${this.m++}`;L.validatedIpcMain.once(t,()=>E()),g.send("vscode:onWillUnload",{replyChannel:t,reason:D})})}quit(g){return this.L(`Lifecycle#quit() - begin (willRestart: ${g})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(g&&this.w.setItem(kt.b,!0),this.p=new Promise(D=>{this.r=D,this.L("Lifecycle#quit() - calling app.quit()"),I.app.quit()}),this.p)}L(g){this.y.args["enable-smoke-test-driver"]?this.v.info(g):this.v.trace(g)}async relaunch(g){this.L("Lifecycle#relaunch()");const D=process.argv.slice(1);if(g?.addArgs&&D.push(...g.addArgs),g?.removeArgs)for(const t of g.removeArgs){const a=D.indexOf(t);a>=0&&D.splice(a,1)}const E=()=>{try{if(P.isWindows){const t=(0,h.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.v.error(t)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),I.app.relaunch({args:D})};I.app.once("quit",E),await this.quit(!0)&&I.app.removeListener("quit",E)}async kill(g){this.L("Lifecycle#kill()"),await this.D(2),await Promise.race([(0,k.timeout)(1e3),(async()=>{for(const D of I.BrowserWindow.getAllWindows())if(D&&!D.isDestroyed()){let E;D.webContents&&!D.webContents.isDestroyed()?E=new Promise(R=>D.once("closed",R)):E=Promise.resolve(),D.destroy(),await E}})()]),I.app.exit(g)}};c.b="lifecycle.quitAndRestart",c=ve([ee(0,v.ILogService),ee(1,b.IStateMainService),ee(2,f.IEnvironmentMainService)],c),e.LifecycleMainService=c}),define(te[233],ie([0,1,4,3,2,6,21]),function(V,e,I,L,k,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,o.createDecorator)("keyboardLayoutMainService");let P=class extends k.Disposable{constructor(S){super(),this.a=this.B(new L.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,S.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const S=await new Promise((v,b)=>{V(["native-keymap"],v,b)});this.c=h(S),I.isCI||S.onDidChangeKeyboardLayout(()=>{this.c=h(S),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};P=ve([ee(0,C.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function h(m){const S=m.getKeyMap(),v=m.getCurrentKeyboardLayout();return{keyboardMapping:S,keyboardLayoutInfo:v}}}),define(te[234],ie([0,1,6]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,I.createDecorator)("stateService")}),define(te[235],ie([0,1,8,17,10,33,16,5]),function(V,e,I,L,k,o,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class h{constructor(v,b,f){this.f=v,this.g=b,this.h=f,this.a=Object.create(null),this.b="",this.c=new I.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(v){v.fileOperationResult!==1&&this.g.error(v)}}getItem(v,b){const f=this.a[v];return(0,k.isUndefinedOrNull)(f)?b:f}setItem(v,b){this.setItems([{key:v,data:b}])}setItems(v){let b=!1;for(const{key:f,data:p}of v)this.a[f]!==p&&((0,k.isUndefinedOrNull)(p)?(0,k.isUndefined)(this.a[f])||(this.a[f]=void 0,b=!0):(this.a[f]=p,b=!0));b&&this.j()}removeItem(v){(0,k.isUndefined)(this.a[v])||(this.a[v]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const v=JSON.stringify(this.a,null,4);if(v!==this.b)try{await this.h.writeFile(this.f,L.VSBuffer.fromString(v)),this.b=v}catch(b){this.g.error(b)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=h;let m=class{constructor(v,b,f){this.a=new h(v.stateResource,b,f)}async init(){await this.a.init()}getItem(v,b){return this.a.getItem(v,b)}};m=ve([ee(0,o.IEnvironmentService),ee(1,P.ILogService),ee(2,C.IFileService)],m),e.StateService=m}),define(te[236],ie([0,1,235]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class L extends I.StateService{setItem(o,C){this.a.setItem(o,C)}setItems(o){this.a.setItems(o)}removeItem(o){this.a.removeItem(o)}close(){return this.a.close()}}e.StateMainService=L}),define(te[92],ie([0,1,4,35,7,31]),function(V,e,I,L,k,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function C(m){if(I.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function P(m,S,v,b,f,p,w,c,u,g){const D=Object.create(null);D["common.machineId"]=w,D.sessionID=(0,o.generateUuid)()+Date.now(),D.commitHash=f,D.version=p,D["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),D["common.platform"]=(0,I.PlatformToString)(I.platform),D["common.nodePlatform"]=L.platform,D["common.nodeArch"]=b,D["common.product"]=g||"desktop",c&&(D["common.msftInternal"]=c);let E=0;const R=Date.now();Object.defineProperties(D,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-R,enumerable:!0},"common.sequence":{get:()=>E++,enumerable:!0}}),I.isLinuxSnap&&(D["common.snap"]="true");const t=C(v);t&&(D["common.platformDetail"]=t);try{const a=await m.readFile(k.URI.file(u));D["common.source"]=a.value.toString().slice(0,30)}catch{}return D}e.resolveCommonProperties=P;function h(m){const S=L.env.USERDNSDOMAIN;if(!S)return!1;const v=S.toLowerCase();return m.some(b=>v===b)}e.verifyMicrosoftInternalDomain=h}),define(te[24],ie([0,1,6]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,I.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,I.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(o){o[o.NONE=0]="NONE",o[o.CRASH=1]="CRASH",o[o.ERROR=2]="ERROR",o[o.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(o){o.OFF="off",o.CRASH="crash",o.ERROR="error",o.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[237],ie([0,1,26,8,43,15,9,4,7,84,23,103,87,16,19,24]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const c=new Map;async function u(t,a){const i=`${t}::${a.join(":")}`,n=c.get(i);if(n)return n;const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,s=new Map,d=2e4;function y(O,j,K,x){const J=j.substring(O.length+1);return L.Promises.withAsyncBody(async re=>{let se;try{se=await S.Promises.readdir(j,{withFileTypes:!0})}catch{re();return}if(x.count>=d){x.count+=se.length,x.maxReached=!0,re();return}let ae=se.length;if(ae===0){re();return}let fe=se;x.count+se.length>d&&(x.maxReached=!0,ae=d-x.count,fe=se.slice(0,ae)),x.count+=se.length;for(const ge of fe)if(ge.isDirectory()){if(K.includes(ge.name)||await y(O,(0,C.join)(j,ge.name),K,x),--ae===0){re();return}}else{const H=ge.name.lastIndexOf(".");if(H>=0){const F=ge.name.substring(H+1);F&&l.set(F,(l.get(F)??0)+1)}for(const F of r)F.relativePathPattern?.test(J)!==!1&&F.filePattern.test(ge.name)&&s.set(F.tag,(s.get(F.tag)??0)+1);if(--ae===0){re();return}}})}const M=L.Promises.withAsyncBody(async O=>{const j={count:0,maxReached:!1};await y(t,t,a,j);const K=await E(t);O({configFiles:g(s),fileTypes:g(l),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:K})});return c.set(i,M),M}e.collectWorkspaceStats=u;function g(t){return Array.from(t.entries(),([a,i])=>({name:a,count:i})).sort((a,i)=>i.count-a.count)}function D(){const t={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(m.virtualMachineHint.value()*100)}%`},a=I.cpus();return a&&a.length>0&&(t.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),t}e.getMachineInfo=D;async function E(t){try{const a=new Map,i=(0,C.join)(t,".vscode","launch.json"),n=await S.Promises.readFile(i),r=[],l=(0,k.parse)(n.toString(),r);if(r.length)return console.log(`Unable to parse ${i}`),[];if((0,k.getNodeType)(l)==="object"&&l.configurations)for(const s of l.configurations){const d=s.type;d&&(a.has(d)?a.set(d,a.get(d)+1):a.set(d,1))}return g(a)}catch{return[]}}e.collectLaunchConfigs=E;let R=class{constructor(a,i){this.c=a,this.d=i}f(a){const i=[];return i.push(`OS Version:       ${a.os}`),i.push(`CPUs:             ${a.cpus}`),i.push(`Memory (System):  ${a.memory}`),i.push(`VM:               ${a.vmHint}`),i.join(`
`)}g(a){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const n=I.cpus();return n&&n.length>0&&i.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),i.push(`Memory (System):  ${(I.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||i.push(`Load (avg):       ${I.loadavg().map(r=>Math.round(r)).join(", ")}`),i.push(`VM:               ${Math.round(m.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${a.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(a,i){return Promise.all([(0,v.listProcesses)(a.mainPID),this.k(a)]).then(async n=>{let[r,l]=n,s=this.m(a,r);return i.forEach(d=>{if((0,b.isRemoteDiagnosticError)(d))s+=`
${d.errorMessage}`,l+=`
${d.errorMessage}`;else if(s+=`

Remote: ${d.hostName}`,d.processes&&(s+=`
${this.m(a,d.processes)}`),d.workspaceMetadata){l+=`
|  Remote: ${d.hostName}`;for(const y of Object.keys(d.workspaceMetadata)){const M=d.workspaceMetadata[y];let O=`${M.fileCount} files`;M.maxFilesReached&&(O=`more than ${O}`),l+=`|    Folder (${y}): ${O}`,l+=this.h(M)}}}),{processInfo:s,workspaceInfo:l}})}async getSystemInfo(a,i){const{memory:n,vmHint:r,os:l,cpus:s}=D(),d={os:l,memory:n,cpus:s,vmHint:r,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:i};return P.isWindows||(d.load=`${I.loadavg().map(y=>Math.round(y)).join(", ")}`),P.isLinux&&(d.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(d)}async getDiagnostics(a,i){const n=[];return(0,v.listProcesses)(a.mainPID).then(async r=>(n.push(""),n.push(this.g(a)),n.push(""),n.push(this.m(a,r)),a.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(a))),i.forEach(l=>{if((0,b.isRemoteDiagnosticError)(l))n.push(`
${l.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${l.hostName}`),n.push(this.f(l.machineInfo)),l.processes&&n.push(this.m(a,l.processes)),l.workspaceMetadata)for(const s of Object.keys(l.workspaceMetadata)){const d=l.workspaceMetadata[s];let y=`${d.fileCount} files`;d.maxFilesReached&&(y=`more than ${y}`),n.push(`Folder (${s}): ${y}`),n.push(this.h(d))}}),n.push(""),n.push(""),n.join(`
`)))}h(a){const i=[];let r=0;const l=(M,O)=>{const j=` ${M}(${O})`;r+j.length>60?(i.push(s),s="|                 ",r=s.length):r+=j.length,s+=j};let s="|      File types:";const d=10,y=a.fileTypes.length>d?d:a.fileTypes.length;for(let M=0;M<y;M++){const O=a.fileTypes[M];l(O.name,O.count)}if(i.push(s),a.configFiles.length>=0&&(s="|      Conf files:",r=0,a.configFiles.forEach(M=>{l(M.name,M.count)}),i.push(s)),a.launchConfigFiles.length>0){let M="|      Launch Configs:";a.launchConfigFiles.forEach(O=>{M+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),i.push(M)}return i.join(`
`)}j(a){const i=Math.max(...Object.keys(a).map(n=>n.length));return Object.keys(a).map(n=>`${n}:  ${" ".repeat(i-n.length)}  ${a[n]}`).join(`
                  `)}k(a){const i=[],n=[];return a.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(i.push(`|  Window (${r.title})`),r.folderURIs.forEach(l=>{const s=h.URI.revive(l);if(s.scheme===o.Schemas.file){const d=s.fsPath;n.push(u(d,["node_modules",".git"]).then(y=>{let M=`${y.fileCount} files`;y.maxFilesReached&&(M=`more than ${M}`),i.push(`|    Folder (${(0,C.basename)(d)}): ${M}`),i.push(this.h(y))}).catch(y=>{i.push(`|      Error: Unable to collect workspace stats for folder ${d} (${y.toString()})`)}))}else i.push(`|    Folder (${s.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(r=>i.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}m(a,i){const n=new Map;a.windows.forEach(l=>n.set(l.pid,l.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),i&&this.n(a.mainPID,n,r,i,0),r.join(`
`)}n(a,i,n,r,l){const s=l===0;let d;s?d=r.pid===a?`${this.d.applicationName} main`:"remote agent":(d=`${"  ".repeat(l)} ${r.name}`,r.name==="window"&&(d=`${d} (${i.get(r.pid)})`));const y=process.platform==="win32"?r.mem:I.totalmem()*(r.mem/100);n.push(`${r.load.toFixed(0).padStart(5," ")}	${(y/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${d}`),Array.isArray(r.children)&&r.children.forEach(M=>this.n(a,i,n,M,l+1))}async getWorkspaceFileExtensions(a){const i=new Set;for(const{uri:n}of a.folders){const r=h.URI.revive(n);if(r.scheme!==o.Schemas.file)continue;const l=r.fsPath;try{(await u(l,["node_modules",".git"])).fileTypes.forEach(d=>i.add(d.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(a){for(const{uri:i}of a.folders){const n=h.URI.revive(i);if(n.scheme!==o.Schemas.file)continue;const r=n.fsPath;try{const l=await u(r,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),l.fileTypes.forEach(s=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:s.name,count:s.count})}),l.launchConfigFiles.forEach(s=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:s.name,count:s.count})}),l.configFiles.forEach(s=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:s.name,count:s.count})})}catch{}}}};R=ve([ee(0,w.ITelemetryService),ee(1,p.IProductService)],R),e.DiagnosticsService=R}),define(te[238],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class I{constructor(o){this.b=o}listen(o,C){throw new Error(`Event not found: ${C}`)}call(o,C,{eventName:P,data:h}){return this.b.forEach(m=>m.log(P,h)),Promise.resolve(null)}}e.TelemetryAppenderChannel=I;class L{constructor(o){this.b=o}log(o,C){return this.b.call("log",{eventName:o,data:C}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(te[51],ie([0,1,44,10,3,18,55,92,24]),function(V,e,I,L,k,o,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class m{constructor(s){this.value=s}}e.TelemetryTrustedValue=m;class S{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(s,d){return Promise.resolve(void 0)}publicLog2(s,d){return this.publicLog(s,d)}publicLogError(s,d){return Promise.resolve(void 0)}publicLogError2(s,d){return this.publicLogError(s,d)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=S,e.NullTelemetryService=new S;class v{async publicLog(s,d,y){}async publicLogError(s,d,y){}}e.NullEndpointTelemetryService=v,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(l,s){return k.Event.debounce(s.onDidChangeConfiguration,(y,M)=>{const O=y?new Set([...y.affectedKeys,...M.affectedKeys]):M.affectedKeys;return{...M,affectedKeys:O}},1e3,!0)(y=>{y.source!==7&&l.publicLog2("updateConfiguration",{configurationSource:(0,o.ConfigurationTargetToString)(y.source),configurationKeys:E(y.affectedKeys)})})}e.configurationTelemetry=b;function f(l,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!l.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=f;function p(l,s){return!(s.isBuilt||s.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}e.isLoggingOnly=p;function w(l){const s=l.getValue(h.TELEMETRY_SETTING_ID),d=l.getValue(h.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(l.getValue(h.TELEMETRY_OLD_SETTING_ID)===!1||d===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function c(l){const s={},d={},y={};D(l,y);for(let M in y){M=M.length>150?M.substr(M.length-149):M;const O=y[M];typeof O=="number"?d[M]=O:typeof O=="boolean"?d[M]=O?1:0:typeof O=="string"?(O.length>8192&&console.warn(`Telemetry property: ${M} has been trimmed to 8192, the original length is ${O.length}`),s[M]=O.substring(0,8191)):typeof O<"u"&&O!==null&&(s[M]=O)}return{properties:s,measurements:d}}e.validateTelemetryData=c;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function g(l){if(!l)return"none";const s=(0,C.getRemoteName)(l);return u.has(s)?s:"other"}e.cleanRemoteAuthority=g;function D(l,s,d=0,y){if(!!l)for(const M of Object.getOwnPropertyNames(l)){const O=l[M],j=y?y+M:M;Array.isArray(O)?s[j]=(0,I.safeStringify)(O):O instanceof Date?s[j]=O.toISOString():(0,L.isObject)(O)?d<2?D(O,s,d+1,j+"."):s[j]=(0,I.safeStringify)(O):s[j]=O}}function E(l){if(!l)return[];const s=[];return R(s,"",l),s}function R(l,s,d){d&&typeof d=="object"&&!Array.isArray(d)?Object.keys(d).forEach(y=>R(l,s?`${s}.${y}`:y,d[y])):l.push(s)}function t(l,s){const d=l.msftInternalDomains||[],y=s.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(d)||y}e.isInternalTelemetry=t;function a(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}e.getPiiPathsFromEnvironment=a;function i(l,s){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let d=l;const y=[];for(const K of s)for(;;){const x=K.exec(l);if(!x)break;y.push([x.index,K.lastIndex])}const M=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,O=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let j=0;for(d="";;){const K=O.exec(l);if(!K)break;const x=y.some(([J,re])=>K.index<re&&J<O.lastIndex);!M.test(K[0])&&!x&&(d+=l.substring(j,K.index)+"<REDACTED: user-file-path>",j=O.lastIndex)}return j<l.length&&(d+=l.substr(j)),d}function n(l){if(!l)return l;const s=l.toLowerCase(),d=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const y of d)if(y.regex.test(s))return`<REDACTED: ${y.label}>`;return l}function r(l,s){return(0,I.cloneAndChange)(l,d=>{if(d instanceof m)return d.value;if(typeof d=="string"){let y=d.replaceAll("%20"," ");y=i(y,s);for(const M of s)y=y.replace(M,"");return y=n(y),y}})}e.cleanData=r}),define(te[113],ie([0,1,27,196,90,4,7,13,35,51]),function(V,e,I,L,k,o,C,P,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function S(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,I.compareIgnoreCase)(i.id,n.id)===0}e.areSameExtensions=S;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(n){const r=n.manifest?n.manifest.version:n.version,l=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new b(n.identifier,r,l)}static parse(n){const r=v.exec(n);return r&&r[1]&&r[2]?new b({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,l="undefined"){this.version=r,this.targetPlatform=l,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof b?S(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=b;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(i){const n=f.exec(i);return n&&n[1]?[c(n[1]),n[2]]:[c(i),void 0]}e.getIdAndVersion=p;function w(i,n){return`${i}.${n}`}e.getExtensionId=w;function c(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=c;function u(i,n){return c(w(i,n))}e.getGalleryExtensionId=u;function g(i,n){const r=[],l=s=>{for(const d of r)if(d.some(y=>S(n(y),n(s))))return d;return null};for(const s of i){const d=l(s);d?d.push(s):r.push([s])}return r}e.groupByExtension=g;function D(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=D;function E(i){return{id:new m.TelemetryTrustedValue(i.identifier.id),name:new m.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function R(i,n){const r=[],l=n.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const s=l.shift();if(s&&r.every(d=>!S(d.identifier,{id:s}))){const d=i.filter(y=>S(y.identifier,{id:s}));d.length===1&&(r.push(d[0]),l.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=R;async function t(i,n){if(!o.isLinux)return!1;let r;try{r=(await i.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await i.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(s){n.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(s))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=t;async function a(i,n){const r=await t(i,n),l=(0,L.getTargetPlatform)(r?"alpine":o.platform,h.arch);return n.debug("ComputeTargetPlatform:",l),l}e.computeTargetPlatform=a}),define(te[239],ie([0,1,193,51]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(o,C,P,h,m,S,v){const b={"X-Market-Client-Id":`VSCode ${o}`,"User-Agent":`VSCode ${o} (${C.nameShort})`};if((0,L.supportsTelemetry)(C,P)&&(0,L.getTelemetryLevel)(h)===3){const f=await(0,I.getServiceMachineId)(P,m,S),{machineId:p}=await v.getTelemetryInfo();b["X-Market-User-Id"]=f,b["VSCode-SessionId"]=p||f}return b}e.resolveMarketplaceHeaders=k}),define(te[240],ie([0,1,13,44,51]),function(V,e,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const o="https://mobile.events.data.microsoft.com/OneCollector/1.0",C="https://mobile.events.data.microsoft.com/ping";async function P(m,S,v){const b=await new Promise((u,g)=>{V(["@microsoft/1ds-core-js"],u,g)}),f=await new Promise((u,g)=>{V(["@microsoft/1ds-post-js"],u,g)}),p=new b.AppInsightsCore,w=new f.PostChannel,c={instrumentationKey:m,endpointUrl:o,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(v){c.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:v};c.extensionConfig[w.identifier]=u}return p.initialize(c,[]),p.addTelemetryInitializer(u=>{S&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),p}class h{constructor(S,v,b,f,p){this.e=S,this.f=v,this.g=b,this.h=p,this.c=o,this.d=C,this.g||(this.g={}),typeof f=="function"?this.a=f():this.a=f,this.b=null}i(S){if(!!this.a){if(typeof this.a!="string"){S(this.a);return}this.b||(this.b=P(this.a,this.e,this.h)),this.b.then(v=>{S(v)},v=>{(0,I.onUnexpectedError)(v),console.error(v)})}}log(S,v){if(!this.a)return;v=(0,L.mixin)(v,this.g),v=(0,k.validateTelemetryData)(v);const b=this.f+"/"+S;try{this.i(f=>{f.pluginVersionString=v?.properties.version??"Unknown",f.track({name:b,baseData:{name:b,properties:v?.properties,measurements:v?.measurements}})})}catch{}}flush(){return this.a?new Promise(S=>{this.i(v=>{v.unload(!0,()=>{this.a=void 0,S(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=h}),define(te[114],ie([0,1,2,44,4,27,172,18,67,65,19,50,24,51]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(u,g,D){this.k=g,this.l=D,this.d={},this.i=new I.DisposableStore,this.j=[],this.b=u.appenders,this.c=u.commonProperties||Promise.resolve({}),this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,o.escapeRegExpCharacters)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,o.escapeRegExpCharacters)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(b.TELEMETRY_SETTING_ID)||E.affectsConfiguration(b.TELEMETRY_OLD_SETTING_ID)||E.affectsConfiguration(b.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(u,g){this.d[u]=g}m(){let u=(0,f.getTelemetryLevel)(this.k);const g=this.l.enabledTelemetryLevels;if(g){this.h=this.sendErrorTelemetry?g.error:!1;const D=g.usage?3:g.error?2:0;u=Math.min(u,D)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const u=await this.c,g=u.sessionID,D=u["common.machineId"],E=u["common.firstSessionDate"],R=u["common.msftInternal"];return{sessionId:g,machineId:D,firstSessionDate:E,msftInternal:R}}dispose(){this.i.dispose()}n(u,g,D){return this.g<g?Promise.resolve(void 0):this.c.then(E=>{D=(0,L.mixin)(D,this.d),D=(0,f.cleanData)(D,this.j),D=(0,L.mixin)(D,E),this.b.forEach(R=>R.log(u,D))},E=>{console.error(E)})}publicLog(u,g){return this.n(u,3,g)}publicLog2(u,g){return this.publicLog(u,g)}publicLogError(u,g){return this.h?this.n(u,2,g):Promise.resolve(void 0)}publicLogError2(u,g){return this.publicLogError(u,g)}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=ve([ee(1,P.IConfigurationService),ee(2,S.IProductService)],p),e.TelemetryService=p;function w(){const c=(0,C.localize)(0,null,m.default.nameLong),u=m.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=k.isWeb?"":(0,C.localize)(3,null),D=(0,C.localize)(4,null),E=(0,C.localize)(5,null),R=(0,C.localize)(6,null),t=(0,C.localize)(7,null),a=`
|       | ${D} | ${E} | ${R} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,C.localize)(8,null);return`
${c} ${u} ${g}

&nbsp;

${t}
${a}

&nbsp;

${i}
`}v.Registry.as(h.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(9,null),properties:{[b.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.Registry.as(h.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[b.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,C.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,C.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${b.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[241],ie([0,1,288,240]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class k extends L.AbstractOneDataSystemAppender{constructor(C,P,h,m){const S={sendPOST:(v,b)=>{const f={method:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data)}};try{const p=I.request(v.urlString,f,w=>{w.on("data",function(c){b(w.statusCode??200,w.headers,c.toString())}),w.on("error",function(c){b(0,{})})});p.write(v.data),p.end()}catch{b(0,{})}}};super(C,P,h,m,S)}}e.OneDataSystemAppender=k}),define(te[242],ie([0,1,4,84,24]),function(V,e,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function o(C){let P=C.getItem(k.machineIdKey);return(typeof P!="string"||I.isMacintosh&&P==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(P=await(0,L.getMachineId)()),P}e.resolveMachineId=o}),define(te[115],ie([0,1,24,242]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function k(o){const C=await(0,L.resolveMachineId)(o);return o.setItem(I.machineIdKey,C),C}e.resolveMachineId=k}),define(te[68],ie([0,1,14,3,2,4,18,6,34]),function(V,e,I,L,k,o,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const m="#FFFFFF",S="#1E1E1E",v="#000000",b="#FFFFFF",f="theme",p="themeBackground",w="windowSplash";e.IThemeMainService=(0,P.createDecorator)("themeMainService");let c=class extends k.Disposable{constructor(g,D){super(),this.b=g,this.c=D,this.a=this.B(new L.Emitter),this.onDidChangeColorScheme=this.a.event,I.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(o.isWindows){if(I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(o.isMacintosh){if(I.nativeTheme.shouldUseInvertedColorScheme||I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(o.isLinux&&I.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const g=this.getColorScheme();if(g.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return g.dark?v:b;let D=this.b.getItem(p,null);if(!D)switch(this.b.getItem(f,"vs-dark").split(" ")[0]){case"vs":D=m;break;case"hc-black":D=v;break;case"hc-light":D=b;break;default:D=S}return o.isMacintosh&&D.toUpperCase()===S&&(D="#171717"),D}saveWindowSplash(g,D){this.b.setItems([{key:f,data:D.baseTheme},{key:p,data:D.colorInfo.background},{key:w,data:D}]),typeof g=="number"&&this.f(g,D)}f(g,D){for(const E of I.BrowserWindow.getAllWindows())if(E.id===g){E.setBackgroundColor(D.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(w)}};c=ve([ee(0,h.IStateMainService),ee(1,C.IConfigurationService)],c),e.ThemeMainService=c}),define(te[116],ie([0,1,3,18,6,5]),function(V,e,I,L,k,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var C;(function(w){w.Http="http",w.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var h;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(h=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function m(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if(!!c)return{address:c[1],port:+c[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(w){return e.LOCALHOST_ADDRESSES.indexOf(w)>=0}e.isLocalhost=S,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(w){return e.ALL_INTERFACES_ADDRESSES.indexOf(w)>=0}e.isAllInterfaces=v;function b(w,c,u,g){if(u===1)return!1;if(u===2&&v(c)){const D=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(D?.length===4&&parseInt(D[1])>=18)return!1}return w<1024}e.isPortPrivileged=b;class f{constructor(c,u,g){this.remoteAddress=c,this.localAddress=u,this.b=g,this.a=new I.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=f;let p=class{constructor(c,u){this.i=c,this.j=u,this.a=new I.Emitter,this.onTunnelOpened=this.a.event,this.b=new I.Emitter,this.onTunnelClosed=this.b.event,this.c=new I.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const c=this.j.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.e=c,c?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.f=c.elevation,this.g=c.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const c=[],u=Array.from(this.d.values());for(const g of u){const D=Array.from(g.values());for(const E of D){const R=await E.value;R&&c.push(R)}}return c}async dispose(){for(const c of this.d.values()){for(const{value:u}of c.values())await u.then(g=>g?.dispose());c.clear()}this.d.clear()}setEnvironmentTunnel(c,u,g,D,E){this.o(c,u,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:u,localAddress:g,privacy:D,protocol:E,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,u){(v(c)||S(c))&&(c=e.LOCALHOST_ADDRESSES[0]);const g=this.q(c,u);if(g)return++g.refcount,g.value}openTunnel(c,u,g,D,E,R=!1,t,a){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${g} on local port ${E}.`),!c)return;if(u||(u="localhost"),D||(D=this.k),this.e&&this.h.has(g)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(c,u,g,D,E,R,t,a);return i?i.then(n=>{if(!n){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,g);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.m(n);return(n.tunnelRemoteHost!==u||n.tunnelRemotePort!==g)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(r),r}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const u=this.d.get(c.tunnelRemoteHost);if(u){const g=u.get(c.tunnelRemotePort);g&&(g.refcount--,await this.n(c.tunnelRemoteHost,c.tunnelRemotePort,g))}}}}async n(c,u,g){if(g.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${u}.`);const D=g.value.then(async E=>{E&&(await E.dispose(!0),this.b.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this.d.has(c)&&this.d.get(c).delete(u),D}}async closeTunnel(c,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${u} `);const g=this.d.get(c);if(g&&g.has(u)){const D=g.get(u);D.refcount=0,await this.n(c,u,D)}}o(c,u,g){this.d.has(c)||this.d.set(c,new Map),this.d.get(c).set(u,{refcount:1,value:g})}async p(c,u){const g=this.d.get(c);g&&(await g.get(u)||g.delete(u),g.size===0&&this.d.delete(c))}q(c,u){const g=[c];S(c)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):v(c)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const D=g.map(E=>this.d.get(E));for(const E of D){const R=E?.get(u);if(R)return R}}canTunnel(c){return!!m(c)}s(c,u,g,D,E,R,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${g} on local port ${D}.`);const a=g;this.h.add(a);const i=D===void 0?g:D,n={elevationRequired:E?this.isPortPrivileged(i):!1},r={remoteAddress:{host:u,port:g},localAddressPort:D,privacy:R,public:R?R!==P.Private:void 0,protocol:t},l=c.forwardPort(r,n);return l?(this.o(u,g,l),l.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(a)})):this.h.delete(a),l}};p=ve([ee(0,o.ILogService),ee(1,L.IConfigurationService)],p),e.AbstractTunnelService=p}),define(te[243],ie([0,1,81,26,99,227,8,2,18,5,19,226,116,91,4]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function w(E,R,t,a,i){let n;for(let r=3;r&&(n?.dispose(),n=await new c(E,R,t,a,i).waitForReady(),!(i&&k.BROWSER_RESTRICTED_PORTS[i]||!k.BROWSER_RESTRICTED_PORTS[n.tunnelLocalPort]));r--);return n}class c extends P.Disposable{constructor(R,t,a,i,n){super(),this.j=t,this.k=n,this.privacy=b.TunnelPrivacyId.Private,this.i=new Map,this.a=R,this.b=I.createServer(),this.c=new C.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=r=>this.l(r),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(t=>{t()})}async waitForReady(){const R=this.k??this.tunnelRemotePort,t=(0,b.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let a=await(0,k.findFreePortFaster)(R,2,1e3,t),i=null;return this.b.listen(a,this.j),await this.c.wait(),i=this.b.address(),i||(a=0,this.b.listen(a,this.j),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async l(R){R.pause();const t=(0,b.isLocalhost)(this.tunnelRemoteHost)||(0,b.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,a=await(0,v.connectRemoteAgentTunnel)(this.a,t,this.tunnelRemotePort),i=a.getSocket().socket,n=a.readEntireBuffer();a.dispose(),n.byteLength>0&&R.write(n.buffer),R.on("end",()=>{R.localAddress&&this.i.delete(R.localAddress),i.end()}),R.on("close",()=>i.end()),R.on("error",()=>{R.localAddress&&this.i.delete(R.localAddress),i.destroy()}),i.on("end",()=>R.end()),i.on("close",()=>R.end()),i.on("error",()=>{R.destroy()}),R.pipe(i),i.pipe(R),R.localAddress&&this.i.set(R.localAddress,()=>{R.end(),i.end()})}}let u=class extends b.AbstractTunnelService{constructor(R,t,a,i,n){super(t,n),this.t=R,this.u=a,this.v=i}isPortPrivileged(R){return(0,b.isPortPrivileged)(R,this.k,p.OS,L.release())}r(R,t,a,i,n,r,l,s){const d=this.q(t,a);if(d)return++d.refcount,d.value;if(this.e)return this.s(this.e,t,a,n,r,l,s);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${a} on local port ${n}.`);const y={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:R,signService:this.u,logService:this.i,ipcLogger:null},M=w(y,i,t,a,n);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(t,a,M),M}}};u=ve([ee(1,m.ILogService),ee(2,f.ISignService),ee(3,S.IProductService),ee(4,h.IConfigurationService)],u),e.BaseTunnelService=u;let g=class extends u{constructor(R,t,a,i){super(o.nodeSocketFactory,R,t,a,i)}};g=ve([ee(0,m.ILogService),ee(1,f.ISignService),ee(2,S.IProductService),ee(3,h.IConfigurationService)],g),e.TunnelService=g;let D=class extends P.Disposable{constructor(R,t,a,i){super(),this.b=R,this.c=t,this.f=a,this.g=i,this.a=new Map}async openTunnel(R,t,a,i,n,r,l,s,d){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${a}:${i} on local port ${r}.`),!this.a.has(R)){const y=new g(this.b,this.f,this.c,this.g);this.B(y),this.a.set(R,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(R))})}return this.a.get(R).openTunnel(t,a,i,n,r,l,s,d)}};D=ve([ee(0,m.ILogService),ee(1,S.IProductService),ee(2,f.ISignService),ee(3,h.IConfigurationService)],D),e.SharedTunnelsService=D}),define(te[48],ie([0,1,6]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.CheckingForUpdates="checking for updates",o.AvailableForDownload="available for download",o.Downloading="downloading",o.Downloaded="downloaded",o.Updating="updating",o.Ready="ready"})(L=e.StateType||(e.StateType={}));var k;(function(o){o[o.Setup=0]="Setup",o[o.Archive=1]="Archive",o[o.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(o,C)=>({type:"idle",updateType:o,error:C}),CheckingForUpdates:o=>({type:"checking for updates",explicit:o}),AvailableForDownload:o=>({type:"available for download",update:o}),Downloading:o=>({type:"downloading",update:o}),Downloaded:o=>({type:"downloaded",update:o}),Updating:o=>({type:"updating",update:o}),Ready:o=>({type:"ready",update:o})},e.IUpdateService=(0,I.createDecorator)("updateService")}),define(te[244],ie([0,1,4,173,67,50]),function(V,e,I,L,k,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),o.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:I.isWindows&&!I.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[245],ie([0,1,3,48]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(P){this.a=P}listen(P,h){switch(h){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${h}`)}call(P,h,m){switch(h){case"checkForUpdates":return this.a.checkForUpdates(m);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(m)}throw new Error(`Call not found: ${h}`)}}e.UpdateChannel=k;class o{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new I.Emitter,this.onStateChange=this.a.event,this.b=L.State.Uninitialized,this.c.listen("onStateChange")(h=>this.state=h),this.c.call("_getInitialState").then(h=>this.state=h)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.UpdateChannelClient=o}),define(te[93],ie([0,1,8,22,3,18,28,21,5,19,56,48]),function(V,e,I,L,k,o,C,P,h,m,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function b(p,w,c){return`${c.updateUrl}/api/update/${p}/${w}/${c.commit}`}e.createUpdateURL=b;let f=class{get state(){return this.b}d(w){this.j.info("update#setState",w.type),this.b=w,this.c.fire(w)}constructor(w,c,u,g,D,E){this.f=w,this.g=c,this.h=u,this.i=g,this.j=D,this.k=E,this.b=v.State.Uninitialized,this.c=new k.Emitter,this.onStateChange=this.c.event}async initialize(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const w=this.l(),c=this.m(w);if(!c){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(c),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(v.State.Idle(this.q())),w==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,u=>this.j.error(u))}l(){return(0,o.getMigratedSettingValue)(this.g,"update.mode","update.channel")}m(w){return w==="none"?void 0:this.k.quality}n(w=60*60*1e3){return(0,I.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(w){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(w)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(w){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){return this.a?await this.l()==="none"?!1:(await this.i.request({url:this.a},L.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(w){}q(){return 1}r(){}};f=ve([ee(0,P.ILifecycleMainService),ee(1,o.IConfigurationService),ee(2,C.IEnvironmentMainService),ee(3,S.IRequestService),ee(4,h.ILogService),ee(5,m.IProductService)],f),e.AbstractUpdateService=f}),define(te[246],ie([0,1,14,54,3,2,18,28,21,5,19,56,24,48,93]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let w=class extends p.AbstractUpdateService{get v(){return k.Event.fromNodeEventEmitter(I.autoUpdater,"error",(u,g)=>g)}get w(){return k.Event.fromNodeEventEmitter(I.autoUpdater,"update-not-available")}get x(){return k.Event.fromNodeEventEmitter(I.autoUpdater,"update-available",(u,g,D)=>({url:g,version:D,productVersion:D}))}get y(){return k.Event.fromNodeEventEmitter(I.autoUpdater,"update-downloaded",(u,g,D,E)=>({releaseNotes:g,version:D,productVersion:D,date:E}))}constructor(u,g,D,E,R,t,a){super(u,g,E,R,t,a),this.z=D,this.u=new o.DisposableStore}async initialize(){await super.initialize(),this.v(this.A,this,this.u),this.x(this.D,this,this.u),this.y(this.E,this,this.u),this.w(this.F,this,this.u)}A(u){this.j.error("UpdateService error:",u);const D=(this.state.type==="checking for updates"?this.state.explicit:!0)?u:void 0;this.d(f.State.Idle(1,D))}s(u){let g;this.k.darwinUniversalAssetId?g=this.k.darwinUniversalAssetId:g=process.arch==="x64"?"darwin":"darwin-arm64";const D=(0,p.createUpdateURL)(g,u,this.k);try{I.autoUpdater.setFeedURL({url:D})}catch(E){this.j.error("Failed to set update feed URL",E);return}return D}t(u){this.d(f.State.CheckingForUpdates(u)),I.autoUpdater.checkForUpdates()}D(u){this.state.type==="checking for updates"&&this.d(f.State.Downloading(u))}E(u){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:u.version}),this.d(f.State.Ready(u)))}F(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.State.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),I.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};ve([L.memoize],w.prototype,"v",null),ve([L.memoize],w.prototype,"w",null),ve([L.memoize],w.prototype,"x",null),ve([L.memoize],w.prototype,"y",null),w=ve([ee(0,h.ILifecycleMainService),ee(1,C.IConfigurationService),ee(2,b.ITelemetryService),ee(3,P.IEnvironmentMainService),ee(4,v.IRequestService),ee(5,m.ILogService),ee(6,S.IProductService)],w),e.DarwinUpdateService=w}),define(te[247],ie([0,1,46,41,8,3,9,28,21,5,24,48]),function(V,e,I,L,k,o,C,P,h,m,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let b=class{get state(){return this.a}d(w){this.g.info("update#setState",w.type),this.a=w,this.b.fire(w)}constructor(w,c,u){if(this.f=w,this.g=u,this.a=v.State.Uninitialized,this.b=new o.Emitter,this.onStateChange=this.b.event,c.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(v.State.Idle(this.k())),this.h(30*1e3).then(void 0,g=>this.g.error(g))}h(w=60*60*1e3){return(0,k.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(w){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(w)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(w){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(w){}};b=ve([ee(0,h.ILifecycleMainService),ee(1,P.IEnvironmentMainService),ee(2,m.ILogService)],b);let f=class extends b{constructor(w,c,u,g,D,E){super(u,g,D),this.o=w,this.p=c,this.q=E;const R=(0,L.watch)(C.dirname(this.o)),t=o.Event.fromNodeEventEmitter(R,"change",(r,l)=>l),a=o.Event.filter(t,r=>r==="current"),n=o.Event.debounce(a,(r,l)=>l,2e3)(()=>this.checkForUpdates(!1));u.onWillShutdown(()=>{n.dispose(),R.close()})}m(){this.d(v.State.CheckingForUpdates(!1)),this.u().then(w=>{w?this.d(v.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.State.Idle(2)))},w=>{this.g.error(w),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.State.Idle(2,w.message||w))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,I.spawn)("sleep 3 && "+C.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const w=await new Promise((u,g)=>(0,L.realpath)(`${C.dirname(this.o)}/current`,(D,E)=>D?g(D):u(E))),c=C.basename(w);return this.p!==c}isLatestVersion(){return this.u().then(void 0,w=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};f=ve([ee(2,h.ILifecycleMainService),ee(3,P.IEnvironmentMainService),ee(4,m.ILogService),ee(5,S.ITelemetryService)],f),e.SnapUpdateService=f}),define(te[40],ie([0,1,6]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,I.createDecorator)("IUriIdentityService")}),define(te[248],ie([0,1,40,194,16,20,128,3,2]),function(V,e,I,L,k,o,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class m{constructor(b){this.uri=b,this.time=m._clock++}touch(){return this.time=m._clock++,this}}m._clock=0;let S=class{constructor(b){this.g=b,this.c=new h.DisposableStore,this.f=2**16;const f=new Map,p=w=>{let c=f.get(w.scheme);return c===void 0&&(c=b.hasProvider(w)&&!this.g.hasCapability(w,1024),f.set(w.scheme,c)),c};this.c.add(P.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(w=>{f.delete(w.scheme)})),this.extUri=new o.ExtUri(p),this.d=new C.SkipList((w,c)=>this.extUri.compare(w,c,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(b){this.g.hasProvider(b)&&(b=(0,o.normalizePath)(b));const f=this.d.get(b);return f?f.touch().uri.with({fragment:b.fragment}):(this.d.set(b,new m(b)),this.h(),b)}h(){if(this.d.size<this.f)return;const b=[...this.d.entries()].sort((p,w)=>p[1].touch<w[1].touch?1:p[1].touch>w[1].touch?-1:0);m._clock=0,this.d.clear();const f=this.f*.5;for(let p=0;p<f;p++)this.d.set(b[p][0],b[p][1].touch())}};S=ve([ee(0,k.IFileService)],S),e.UriIdentityService=S,(0,L.registerSingleton)(I.IUriIdentityService,S,1)}),define(te[117],ie([0,1,6]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,I.createDecorator)("urlService")}),define(te[249],ie([0,1,7]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(P){this.a=P}listen(P,h){throw new Error(`Event not found: ${h}`)}call(P,h,m){switch(h){case"handleURL":return this.a.handleURL(I.URI.revive(m[0]),m[1])}throw new Error(`Call not found: ${h}`)}}e.URLHandlerChannel=L;class k{constructor(P){this.a=P}handleURL(P,h){return this.a.call("handleURL",[P.toJSON(),h])}}e.URLHandlerChannelClient=k;class o{constructor(P){this.a=P}async routeCall(P,h,m,S){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(m){const v=I.URI.revive(m);if(v&&v.query){const b=/\bwindowId=(\d+)/.exec(v.query);if(b){const f=b[1],p=new RegExp(`window:${f}`),w=P.connections.find(c=>p.test(c.ctx));if(w)return w}}}return this.a.routeCall(P,h,m,S)}routeEvent(P,h){throw new Error(`Event not found: ${h}`)}}e.URLHandlerRouter=o}),define(te[250],ie([0,1,8,2,7,19]),function(V,e,I,L,k,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class C extends L.Disposable{constructor(){super(...arguments),this.a=new Set}open(m,S){const v=[...this.a.values()];return(0,I.first)(v.map(b=>()=>b.handleURL(m,S)),void 0,!1).then(b=>b||!1)}registerHandler(m){return this.a.add(m),(0,L.toDisposable)(()=>this.a.delete(m))}}e.AbstractURLService=C;let P=class extends C{constructor(m){super(),this.b=m}create(m){let{authority:S,path:v,query:b,fragment:f}=m||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return S&&v&&v.indexOf("/")!==0&&(v=`/${v}`),k.URI.from({scheme:this.b.urlProtocol,authority:S,path:v,query:b,fragment:f})}};P=ve([ee(0,o.IProductService)],P),e.NativeURLService=P}),define(te[251],ie([0,1,14,8,3,2,4,7]),function(V,e,I,L,k,o,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class h{constructor(S,v,b,f,p,w){if(this.f=v,this.g=w,this.a=[],this.b=0,this.c=o.Disposable.None,this.d=new o.DisposableStore,w.trace("ElectronURLListener initialUrisToHandle:",S.map(g=>g.url)),this.a=S,C.isWindows){const g=f.isBuilt?[]:[`"${f.appRoot}"`];g.push("--open-url","--"),I.app.setAsDefaultProtocolClient(p.urlProtocol,process.execPath,g)}const c=k.Event.map(k.Event.fromNodeEventEmitter(I.app,"open-url",(g,D)=>({event:g,url:D})),({event:g,url:D})=>(g.preventDefault(),D));this.d.add(c(g=>{const D=this.h(g);!D||this.f.open(D,{originalUrl:g})})),b.getWindows().filter(g=>g.isReady).length>0?(w.trace("ElectronURLListener: window is ready to handle URLs"),this.i()):(w.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),k.Event.once(b.onDidSignalReadyWindow)(this.i,this,this.d))}h(S){try{return P.URI.parse(S)}catch{return}}async i(){if(this.b++>10){this.g.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.g.trace("ElectronURLListener#flush(): flushing URLs");const S=[];for(const v of this.a)await this.f.open(v.uri,{originalUrl:v.url})?this.g.trace("ElectronURLListener#flush(): URL was handled",v.url):(this.g.trace("ElectronURLListener#flush(): URL was not yet handled",v.url),S.push(v));S.length!==0&&(this.a=S,this.c=(0,L.disposableTimeout)(()=>this.i(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=h}),define(te[252],ie([0,1,6]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,I.createDecorator)("webviewManagerService")}),define(te[253],ie([0,1,14,2,15,7]),function(V,e,I,L,k,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class C extends L.Disposable{constructor(){super();const h=this.b.bind(this);I.protocol.registerFileProtocol(k.Schemas.vscodeWebview,h)}b(h,m){try{const S=o.URI.parse(h.url),v=C.a.get(S.path);if(typeof v=="string"){const b=`vs/workbench/contrib/webview/browser/pre/${v}`,f=k.FileAccess.asFileUri(b);return m({path:decodeURIComponent(f.fsPath),headers:{...k.COI.getHeadersFromQuery(h.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return m({error:-10})}catch{}return m({error:-2})}}e.WebviewProtocolProvider=C,C.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(te[76],ie([0,1,4]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(S){return!!S.workspaceUri}e.isWorkspaceToOpen=L;function k(S){return!!S.folderUri}e.isFolderToOpen=k;function o(S){return!!S.fileUri}e.isFileToOpen=o;function C(S){const v=P(S),b=S.getValue("window.menuBarVisibility");return b==="default"||v==="native"&&b==="compact"||I.isMacintosh&&I.isNative?"classic":b}e.getMenuBarVisibility=C;function P(S){if(I.isWeb)return"custom";const v=S.getValue("window");if(v){if(I.isMacintosh&&v.nativeTabs===!0||I.isMacintosh&&v.nativeFullScreen===!1)return"native";const p=v.titleBarStyle;if(p==="native"||p==="custom")return p}return I.isLinux?"native":"custom"}e.getTitleBarStyle=P;function h(S){if(!I.isWindows||I.isWeb||P(S)==="native")return!1;const v=S.getValue("window.experimental.windowControlsOverlay.enabled");return typeof v=="boolean"?v:!0}e.useWindowControlsOverlay=h;function m(S=0){return Math.pow(1.2,S)}e.zoomLevelToZoomFactor=m}),define(te[118],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var I;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(I=e.LoadReason||(e.LoadReason={}));var L;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(L=e.UnloadReason||(e.UnloadReason={}));const k=function(P=1){return{width:1024,height:768,mode:P}};e.defaultWindowState=k;var o;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(o=e.WindowMode||(e.WindowMode={}));var C;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(C=e.WindowError||(e.WindowError={}))}),define(te[30],ie([0,1,6]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,I.createDecorator)("windowsMainService");var L;(function(k){k[k.CLI=0]="CLI",k[k.DOCK=1]="DOCK",k[k.MENU=2]="MENU",k[k.DIALOG=3]="DIALOG",k[k.DESKTOP=4]="DESKTOP",k[k.API=5]="API"})(L=e.OpenContext||(e.OpenContext={}))}),define(te[254],ie([0,1,14,22,3,71,2,31,74,108,5,19,30]),function(V,e,I,L,k,o,C,P,h,m,S,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var f;(function(w){w[w.Initial=1]="Initial",w[w.StoredCredentialsUsed=2]="StoredCredentialsUsed",w[w.LoginDialogShown=3]="LoginDialogShown"})(f||(f={}));let p=class extends C.Disposable{constructor(c,u,g,D,E){super(),this.g=c,this.h=u,this.i=g,this.j=D,this.k=E,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=f.Initial,this.f=void 0,this.l()}l(){const c=k.Event.fromNodeEventEmitter(I.app,"login",(u,g,D,E,R)=>({event:u,webContents:g,req:D,authInfo:E,callback:R}));this.B(c(this.m,this))}async m({event:c,authInfo:u,req:g,callback:D}){if(!u.isProxy)return;if(!this.b&&this.c===f.LoginDialogShown&&g.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}c.preventDefault();let E;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),E=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(u);try{E=await this.b}finally{this.b=void 0}}D(E?.username,E?.password)}async n(c){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const u=await this.p(c);if(u)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),u;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(c){this.g.trace("auth#doResolveProxyCredentials - enter",c);const u=String((0,o.hash)({scheme:c.scheme,host:c.host,port:c.port}));let g,D;try{const a=await this.i.getPassword(this.a,u);if(a){const i=JSON.parse(await this.j.decrypt(a));g=i.username,D=i.password}}catch(a){this.g.error(a)}if(this.c!==f.StoredCredentialsUsed&&typeof g=="string"&&typeof D=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=f.StoredCredentialsUsed,{username:g,password:D};const E=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!E){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${E.id} to handle proxy login`);const R={authInfo:c,username:this.f?.username??g,password:this.f?.password??D,replyChannel:`vscode:proxyAuthResponse:${(0,P.generateUuid)()}`};E.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,R),this.c=f.LoginDialogShown;const t=await new Promise(a=>{const i=async(n,r,l)=>{if(r===R.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${E.id}`),E.win?.webContents.off("ipc-message",i),l){const s={username:l.username,password:l.password};try{if(l.remember){const d=await this.j.encrypt(JSON.stringify(s));await this.i.setPassword(this.a,u,d)}else await this.i.deletePassword(this.a,u)}catch(d){this.g.error(d)}a({username:s.username,password:s.password})}else a(void 0)};E.win?.webContents.on("ipc-message",i)});return this.f=t,t}};p=ve([ee(0,S.ILogService),ee(1,b.IWindowsMainService),ee(2,h.ICredentialsMainService),ee(3,m.IEncryptionMainService),ee(4,v.IProductService)],p),e.ProxyAuthHandler=p}),define(te[255],ie([0,1,74,5,33,19,30,206]),function(V,e,I,L,k,o,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let h=class extends P.BaseCredentialsMainService{constructor(S,v,b,f){super(S),this.j=v,this.k=b,this.l=f,this.i=p=>{this.l.sendToFocused("vscode:showCredentialsError",p.message??p)}}async getSecretStoragePrefix(){return Promise.resolve(this.k.urlProtocol)}async h(){if(this.f)return this.f;if(this.j.disableKeytar)return this.g.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new I.InMemoryCredentialsProvider,this.f;const S=await new Promise((v,b)=>{V(["keytar"],v,b)});return await S.findCredentials("test-keytar-loads"),this.f=S,this.f}};h=ve([ee(0,L.ILogService),ee(1,k.INativeEnvironmentService),ee(2,o.IProductService),ee(3,C.IWindowsMainService)],h),e.CredentialsNativeMainService=h}),define(te[256],ie([0,1,14,25,4,7,23,18,61,6,5,117,30]),function(V,e,I,L,k,o,C,P,h,m,S,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,m.createDecorator)(e.ID);let f=class{constructor(w,c,u,g){this.a=w,this.b=c,this.c=u,this.d=g}async start(w,c){this.a.trace("Received data from other instance: ",w,c),k.isMacintosh&&I.app.focus({steal:!0});const u=this.e(w);if(u.length){let g=Promise.resolve();if(this.b.getWindowCount()===0){const D=(0,L.firstOrDefault)(await this.b.openEmptyWindow({context:4}));D&&(g=D.ready())}g.then(()=>{for(const{uri:D,url:E}of u)this.c.open(D,{originalUrl:E})})}else return this.f(w,c)}e(w){return w["open-url"]&&w._urls&&w._urls.length>0?(0,L.coalesce)(w._urls.map(c=>{try{return{uri:o.URI.parse(c),url:c}}catch{return null}})):[]}async f(w,c){const u=(0,h.isLaunchedFromCli)(c)?0:4;let g=[];const D=w.wait&&w.waitMarkerFilePath?o.URI.file(w.waitMarkerFilePath):void 0,E=w.remote||void 0,R={context:u,cli:w,userEnv:c,waitMarkerFileURI:D,remoteAuthority:E,forceProfile:w.profile,forceTempProfile:w["profile-temp"]};if(w.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(w.extensionDevelopmentPath,R);else if(!w._.length&&!w["folder-uri"]&&!w["file-uri"]){let t=!1;if(w["new-window"]||w["unity-launch"]||R.forceProfile||R.forceTempProfile)t=!0;else if(w["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!k.isMacintosh}if(t)g=await this.b.open({...R,forceNewWindow:!0,forceEmpty:!0});else{const a=this.b.getLastActiveWindow();a?(this.b.openExistingWindow(a,R),g=[a]):g=await this.b.open({...R,forceEmpty:!0})}}else g=await this.b.open({...R,forceNewWindow:w["new-window"],preferNewWindow:!w["reuse-window"]&&!w.wait,forceReuseWindow:w["reuse-window"],diffMode:w.diff,mergeMode:w.merge,addMode:w.add,noRecentEntry:!!w["skip-add-to-recently-opened"],gotoLineMode:w.goto});if(D&&g.length===1&&g[0])return Promise.race([g[0].whenClosedOrLoaded,(0,C.whenDeleted)(D.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};f=ve([ee(0,S.ILogService),ee(1,b.IWindowsMainService),ee(2,v.IURLService),ee(3,P.IConfigurationService)],f),e.LaunchMainService=f}),define(te[257],ie([0,1,14,2,3,5,258,8,15,100,30,83,24]),function(V,e,I,L,k,o,C,P,h,m,S,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcess=void 0;let f=class jt extends L.Disposable{constructor(w,c,u){super(),this.n=w,this.p=c,this.r=u,this.b=String(++jt.a),this.c=this.B(new k.Emitter),this.onStdout=this.c.event,this.f=this.B(new k.Emitter),this.onStderr=this.f.event,this.g=this.B(new k.Emitter),this.onMessage=this.g.event,this.h=this.B(new k.Emitter),this.onExit=this.h.event,this.i=this.B(new k.Emitter),this.onCrash=this.i.event,this.j=void 0,this.k=void 0,this.l=void 0,this.m=!1}s(w,c){let u;switch(this.l?.correlationId?u=`[UtilityProcess id: ${this.l?.correlationId}, type: ${this.l?.type}, pid: ${this.k??"<none>"}]: ${w}`:u=`[UtilityProcess type: ${this.l?.type}, pid: ${this.k??"<none>"}]: ${w}`,c){case v.default.Error:this.n.error(u);break;case v.default.Warning:this.n.warn(u);break;case v.default.Info:this.n.info(u);break}}t(w){if(!m.canUseUtilityProcess)throw new Error("Cannot use UtilityProcess API from Electron!");if(this.j){this.s("Cannot start utility process because it is already running...",v.default.Error);return}const c=this.p.getWindowById(w.responseWindowId)?.win;if(!c||c.isDestroyed()||c.webContents.isDestroyed()){this.s("Refusing to start utility process because requesting window cannot be found or is destroyed...",v.default.Error);return}return c}start(w){const c=this.t(w);if(!c)return;this.l=w;const u=`${this.l.type}-${this.b}`,g=h.FileAccess.asFileUri("bootstrap-fork.js").fsPath,D=[...this.l.args??[],`--type=${this.l.type}`],E=this.l.execArgv,R=this.l.allowLoadingUnsignedLibraries,t="pipe";let a=this.l.env;if(a){a={...a};for(const i of Object.keys(a))a[i]=String(a[i])}this.s("creating new...",v.default.Info),this.j=m.UtilityProcess.fork(g,D,{serviceName:u,env:a,execArgv:E,allowLoadingUnsignedLibraries:R,stdio:t}),this.u(this.j,this.l,u),this.v(this.j,this.l,c)}u(w,c,u){if(w.stdout){const g=new C.StringDecoder("utf-8");this.B(k.Event.fromNodeEventEmitter(w.stdout,"data")(D=>this.c.fire(typeof D=="string"?D:g.write(D))))}if(w.stderr){const g=new C.StringDecoder("utf-8");this.B(k.Event.fromNodeEventEmitter(w.stderr,"data")(D=>this.f.fire(typeof D=="string"?D:g.write(D))))}this.B(k.Event.fromNodeEventEmitter(w,"message")(g=>this.g.fire(g))),this.B(k.Event.fromNodeEventEmitter(w,"spawn")(()=>{this.k=w.pid,this.s("successfully created",v.default.Info)})),this.B(k.Event.fromNodeEventEmitter(w,"exit")(g=>{this.s(`received exit event with code ${g}`,v.default.Info),this.m=!0,this.h.fire({pid:this.k,code:g,signal:"unknown"})})),this.B(k.Event.fromNodeEventEmitter(I.app,"child-process-gone",(g,D)=>({event:g,details:D}))(({details:g})=>{g.type==="Utility"&&g.name===u&&(this.s(`crashed with code ${g.exitCode} and reason '${g.reason}'`,v.default.Error),this.r.publicLog2("utilityprocesscrash",{type:c.type,reason:g.reason,code:g.exitCode}),this.i.fire({pid:this.k,code:g.exitCode,reason:g.reason}))}))}v(w,c,u){const{port1:g,port2:D}=new I.MessageChannelMain;w.postMessage("null",[D]),u.webContents.postMessage(c.responseChannel,c.responseNonce,[g])}enableInspectPort(){if(typeof this.k!="number")return!1;this.s("enabling inspect port",v.default.Info);const w=process;return typeof w._debugProcess=="function"?(w._debugProcess(this.k),!0):!1}kill(){if(!this.j){this.s("no running process to kill",v.default.Warning);return}this.s("attempting to kill the process...",v.default.Info),this.j.kill()?this.s("successfully killed the process",v.default.Info):this.s("unable to kill the process",v.default.Warning)}async waitForExit(w){if(!this.j){this.s("no running process to wait for exit",v.default.Warning);return}this.m||(this.s("waiting to exit...",v.default.Info),await Promise.race([k.Event.toPromise(this.onExit),(0,P.timeout)(w)]),this.m||(this.s("did not exit within ${maxWaitTimeMs}ms, will kill it now...",v.default.Info),this.kill()))}};f.a=0,f=ve([ee(0,o.ILogService),ee(1,S.IWindowsMainService),ee(2,b.ITelemetryService)],f),e.UtilityProcess=f}),define(te[259],ie([0,1,13,2,3,5,21,70,46,258,8,15,44,4,35,100,257,30,24]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f,p,w,c,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let D=class Bt{constructor(t,a,i,n){this.d=t,this.f=i,this.g=n,this.c=!1,this.b=new Map,a.onWillShutdown(r=>{this.c=!0,r.join(this._waitForAllExit(6e3))})}dispose(){}h(t){const a=this.b.get(t);if(!a)throw new Error("Unknown extension host!");return a}onDynamicStdout(t){return this.h(t).onStdout}onDynamicStderr(t){return this.h(t).onStderr}onDynamicMessage(t){return this.h(t).onMessage}onDynamicError(t){const a=this.h(t);return a instanceof c.UtilityProcess?k.Event.None:a.onError}onDynamicExit(t){return this.h(t).onExit}async canUseUtilityProcess(){return w.canUseUtilityProcess}async createExtensionHost(t){if(this.c)throw(0,I.canceled)();const a=String(++Bt.a);let i;if(t){if(!w.canUseUtilityProcess)throw new Error("Cannot use UtilityProcess!");i=new c.UtilityProcess(this.d,this.f,this.g)}else i=new E(a,this.d);return this.b.set(a,i),i.onExit(({pid:n,code:r,signal:l})=>{this.d.info(`Extension host with pid ${n} exited with code: ${r}, signal: ${l}.`),setTimeout(()=>{i.dispose(),this.b.delete(a)})}),{id:a}}async start(t,a){if(this.c)throw(0,I.canceled)();return this.h(t).start({...a,type:"extensionHost",args:["--skipWorkspaceStorageLock"],execArgv:a.execArgv??[],allowLoadingUnsignedLibraries:!0,correlationId:t})}async enableInspectPort(t){if(this.c)throw(0,I.canceled)();const a=this.b.get(t);return a?a.enableInspectPort():!1}async kill(t){if(this.c)throw(0,I.canceled)();const a=this.b.get(t);!a||a.kill()}async _killAllNow(){for(const[,t]of this.b)t.kill()}async _waitForAllExit(t){const a=[];for(const[,i]of this.b)a.push(i.waitForExit(t));return S.Promises.settled(a).then(()=>{})}};D.a=0,D=ve([ee(0,o.ILogService),ee(1,C.ILifecycleMainService),ee(2,u.IWindowsMainService),ee(3,g.ITelemetryService)],D),e.ExtensionHostStarter=D;let E=class extends L.Disposable{constructor(t,a){super(),this.id=t,this.c=a,this._onStdout=this.B(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this.B(new k.Emitter),this.onError=this._onError.event,this._onExit=this.B(new k.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(t){f.isCI&&this.c.info("Calling fork to start extension host...");const a=P.StopWatch.create(!1);this.a=(0,h.fork)(v.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,b.mixin)({cwd:(0,p.cwd)()},t));const i=a.elapsed(),n=this.a.pid;this.c.info(`Starting extension host with pid ${n} (fork() took ${i} ms).`);const r=new m.StringDecoder("utf-8");this.a.stdout?.on("data",s=>{const d=typeof s=="string"?s:r.write(s);this._onStdout.fire(d)});const l=new m.StringDecoder("utf-8");this.a.stderr?.on("data",s=>{const d=typeof s=="string"?s:l.write(s);this._onStderr.fire(d)}),this.a.on("message",s=>{this._onMessage.fire(s)}),this.a.on("error",s=>{this._onError.fire({error:(0,I.transformErrorForSerialization)(s)})}),this.a.on("exit",(s,d)=>{this.b=!0,this._onExit.fire({pid:n,code:s,signal:d})})}enableInspectPort(){return this.a?(this.c.info(`Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):f.isWindows?!1:(this.a.kill("SIGUSR1"),!0)):!1}kill(){!this.a||(this.c.info(`Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(t){if(!this.a)return;const a=this.a.pid;this.c.info(`Waiting for extension host with pid ${a} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,S.timeout)(t)]),this.b||(this.c.info(`Extension host with pid ${a} did not exit within ${t}ms.`),this.a.kill())}};E=ve([ee(1,o.ILogService)],E)}),define(te[260],ie([0,1,14,3,2,253,30]),function(V,e,I,L,k,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let P=class extends k.Disposable{constructor(m){super(),this.b=m,this.a=this.B(new L.Emitter),this.onFoundInFrame=this.a.event,this.B(new o.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(m,S){let v;if(typeof m.windowId=="number"){const{windowId:b}=m,f=this.b.getWindowById(b);if(!f?.win)throw new Error(`Invalid windowId: ${b}`);v=f.win.webContents}else{const{webContentsId:b}=m;if(v=I.webContents.fromId(b),!v)throw new Error(`Invalid webContentsId: ${b}`)}v.isDestroyed()||v.setIgnoreMenuShortcuts(S)}async findInFrame(m,S,v,b){const p=this.c(m,S);if(typeof p.findInFrame=="function"){p.findInFrame(v,{findNext:b.findNext,forward:b.forward});const w=(c,u)=>{u.finalUpdate&&(this.a.fire(u),p.removeListener("found-in-frame",w))};p.on("found-in-frame",w)}}async stopFindInFrame(m,S,v){const f=this.c(m,S);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame(v.keepSelection?"keepSelection":"clearSelection")}c(m,S){const v=this.b.getWindowById(m.windowId);if(!v?.win)throw new Error(`Invalid windowId: ${m}`);const b=v.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===S);if(!b)throw new Error(`Unknown frame: ${S}`);return b}};P=ve([ee(0,C.IWindowsMainService)],P),e.WebviewMainService=P}),define(te[261],ie([0,1,8,3,2]),function(V,e,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class o extends k.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:h,getActiveWindowId:m}){super(),this.a=this.B(new k.DisposableStore),L.Event.latch(L.Event.any(P,h))(this.f,this,this.a),this.b=(0,I.createCancelablePromise)(()=>m()),(async()=>{try{const v=await this.b;this.c=typeof this.c=="number"?this.c:v}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=o}),define(te[29],ie([0,1,177,9,60,20,7,6,15]),function(V,e,I,L,k,o,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function m(i){const n=i;return typeof n?.id=="string"&&C.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=m;function S(i){return typeof i?.id=="string"&&!m(i)&&!b(i)}e.isEmptyWorkspaceIdentifier=S,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function v(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,L.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=v;function b(i){const n=i;return typeof n?.id=="string"&&C.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=b;function f(i){const n=i;if(n?.uri)return{id:n.id,uri:C.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:C.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=f;var p;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(p=e.WorkbenchState||(e.WorkbenchState={}));function w(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=w;function c(i){const n=i;return!!(n&&typeof n=="object"&&C.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=c;class u{constructor(n,r,l,s,d){this.h=n,this.j=l,this.k=s,this.l=d,this.c=k.TernarySearchTree.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=k.TernarySearchTree.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class g{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,o.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function D(i){return new g({uri:i,index:0,name:(0,o.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=D,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(i,n){return o.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function R(i){let n;return C.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===h.Schemas.tmp}e.isTemporaryWorkspace=R;function t(i,n){return!E(i,n)&&!R(i)}e.isSavedWorkspace=t;function a(i){return(typeof i=="string"?(0,L.extname)(i):(0,o.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=a}),define(te[57],ie([0,1,14,8,71,36,2,79,4,10,23,154,6,5,29]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,b.createDecorator)("dialogMainService");let w=class{constructor(u){this.d=u,this.a=new Map,this.b=new Map,this.c=new L.Queue}pickFileFolder(u,g){return this.e({...u,pickFolders:!0,pickFiles:!0,title:(0,v.localize)(0,null)},g)}pickFolder(u,g){return this.e({...u,pickFolders:!0,title:(0,v.localize)(1,null)},g)}pickFile(u,g){return this.e({...u,pickFiles:!0,title:(0,v.localize)(2,null)},g)}pickWorkspace(u,g){const D=(0,v.localize)(3,null),E=(0,o.mnemonicButtonLabel)((0,v.localize)(4,null)),R=p.WORKSPACE_FILTER;return this.e({...u,pickFiles:!0,title:D,filters:R,buttonLabel:E},g)}async e(u,g){const D={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters,defaultPath:u.defaultPath};(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(D.properties=void 0,u.pickFiles&&u.pickFolders&&(D.properties=["multiSelections","openDirectory","openFile","createDirectory"])),D.properties||(D.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),h.isMacintosh&&D.properties.push("treatPackageAsDirectory");const E=await this.showOpenDialog(D,(0,m.withNullAsUndefined)(g||I.BrowserWindow.getFocusedWindow()));if(E&&E.filePaths&&E.filePaths.length>0)return E.filePaths}f(u){if(u){let g=this.b.get(u.id);return g||(g=new L.Queue,this.b.set(u.id,g)),g}else return this.c}showMessageBox(u,g){return this.f(g).queue(async()=>g?I.dialog.showMessageBox(g,u):I.dialog.showMessageBox(u))}async showSaveDialog(u,g){const D=this.i(u,g);if(!D)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.f(g).queue(async()=>{let E;return g?E=await I.dialog.showSaveDialog(g,u):E=await I.dialog.showSaveDialog(u),E.filePath=this.g(E.filePath),E})}finally{(0,C.dispose)(D)}}g(u){return u&&h.isMacintosh&&(u=(0,P.normalizeNFC)(u)),u}h(u){return u.map(g=>this.g(g))}async showOpenDialog(u,g){u.defaultPath&&(await S.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const D=this.i(u,g);if(!D)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.f(g).queue(async()=>{let E;return g?E=await I.dialog.showOpenDialog(g,u):E=await I.dialog.showOpenDialog(u),E.filePaths=this.h(E.filePaths),E})}finally{(0,C.dispose)(D)}}i(u,g){if(!g)return C.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",u);let D=this.a.get(g.id);D||(D=new Set,this.a.set(g.id,D));const E=(0,k.hash)(u);if(!D.has(E))return this.d.trace("[DialogMainService]: new file dialog lock created",u),D.add(E),(0,C.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",u),D?.delete(E),D?.size===0&&this.a.delete(g.id)})}};w=ve([ee(0,f.ILogService)],w),e.DialogMainService=w}),define(te[262],ie([0,1,3,2,72,29]),function(V,e,I,L,k,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class C extends L.Disposable{constructor(h,m){super(),this.f=h,this.g=m,this.b=this.B(new I.Emitter),this.c=new Map,this.h(m.applicationStorage,this.b)}h(h,m){this.B(I.Event.debounce(h.onDidChangeStorage,(S,v)=>(S?S.push(v):S=[v],S),C.a)(S=>{S.length&&m.fire(this.i(S,h))}))}i(h,m){const S=new Map,v=new Set;return h.forEach(b=>{const f=m.get(b.key);typeof f=="string"?S.set(b.key,f):v.add(b.key)}),{changed:Array.from(S.entries()),deleted:Array.from(v.values())}}listen(h,m,S){switch(m){case"onDidChangeStorage":{const v=S.profile?(0,k.revive)(S.profile):void 0;if(!v)return this.b.event;let b=this.c.get(v.id);return b||(b=this.B(new I.Emitter),this.h(this.g.profileStorage(v),b),this.c.set(v.id,b)),b.event}}throw new Error(`Event not found: ${m}`)}async call(h,m,S){const v=S.profile?(0,k.revive)(S.profile):void 0,b=(0,o.reviveIdentifier)(S.workspace),f=await this.j(v,b);switch(m){case"getItems":return Array.from(f.items.entries());case"updateItems":{const p=S;if(p.insert)for(const[w,c]of p.insert)f.set(w,c);p.delete?.forEach(w=>f.delete(w));break}case"isUsed":{const p=S.payload;if(typeof p=="string")return this.g.isUsed(p)}default:throw new Error(`Call not found: ${m}`)}}async j(h,m){let S;m?S=this.g.workspaceStorage(m):h?S=this.g.profileStorage(h):S=this.g.applicationStorage;try{await S.init()}catch(v){this.f.error(`StorageIPC#init: Unable to init ${m?"workspace":h?"profile":"application"} storage due to ${v}`)}return S}}e.StorageDatabaseChannel=C,C.a=100}),define(te[37],ie([0,1,71,3,2,20,7,174,33,16,6,5,29,38,40,8,31,27,10]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f,p,w,c,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function D(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&C.URI.isUri(n.location)&&C.URI.isUri(n.globalStorageHome)&&C.URI.isUri(n.settingsResource)&&C.URI.isUri(n.keybindingsResource)&&C.URI.isUri(n.tasksResource)&&C.URI.isUri(n.snippetsHome)&&C.URI.isUri(n.extensionsResource))}e.isUserDataProfile=D,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,S.createDecorator)("IUserDataProfilesService");function E(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:C.URI.revive(i.location).with({scheme:n}),globalStorageHome:C.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:C.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:C.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:C.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:C.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:C.URI.revive(i.extensionsResource)?.with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=E;function R(i,n,r,l){return{id:i,name:n,location:r,isDefault:!1,shortName:l?.shortName,globalStorageHome:(0,o.joinPath)(r,"globalStorage"),settingsResource:(0,o.joinPath)(r,"settings.json"),keybindingsResource:(0,o.joinPath)(r,"keybindings.json"),tasksResource:(0,o.joinPath)(r,"tasks.json"),snippetsHome:(0,o.joinPath)(r,"snippets"),extensionsResource:(0,o.joinPath)(r,"extensions.json"),useDefaultFlags:l?.useDefaultFlags,isTransient:l?.transient}}e.toUserDataProfile=R;let t=class extends k.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(n,r,l,s){super(),this.m=n,this.n=r,this.r=l,this.s=s,this.f=!1,this.g=this.B(new L.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new L.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new L.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new L.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new f.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,o.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(n){this.f!==n&&(this.t=void 0,this.f=n)}isEnabled(){return this.f}get u(){if(!this.t){const n=[];if(this.f)for(const d of this.G()){if(!d.name||!(0,g.isString)(d.name)||!d.location){this.s.warn("Skipping the invalid stored profile",d.location||d.name);continue}n.push(R((0,o.basename)(d.location),d.name,d.location,{shortName:d.shortName,useDefaultFlags:d.useDefaultFlags}))}const r=new f.ResourceMap,l=new Map,s=R((0,I.hash)(this.m.userRoamingDataHome.path).toString(16),(0,P.localize)(0,null),this.m.userRoamingDataHome);if(n.unshift({...s,extensionsResource:this.L()??s.extensionsResource,isDefault:!0}),n.length){const d=this.I();if(d.workspaces)for(const[y,M]of Object.entries(d.workspaces)){const O=C.URI.parse(y),j=C.URI.parse(M),K=n.find(x=>this.r.extUri.isEqual(x.location,j));K&&r.set(O,K)}if(d.emptyWindows)for(const[y,M]of Object.entries(d.emptyWindows)){const O=C.URI.parse(M),j=n.find(K=>this.r.extUri.isEqual(K.location,O));j&&l.set(y,j)}}this.t={profiles:n,workspaces:r,emptyWindows:l}}return this.t}async createTransientProfile(n){const r="Temp",l=new RegExp(`${(0,u.escapeRegExpCharacters)(r)}\\s(\\d+)`);let s=0;for(const y of this.profiles){const M=l.exec(y.name),O=M?parseInt(M[1]):0;s=O>s?O:s}const d=`${r} ${s+1}`;return this.createProfile((0,I.hash)((0,c.generateUuid)()).toString(16),d,{transient:!0},n)}async createNamedProfile(n,r,l){return this.createProfile((0,I.hash)((0,c.generateUuid)()).toString(16),n,r,l)}async createProfile(n,r,l,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const d=await this.v(n,r,l);return s&&await this.setProfileForWorkspace(s,d),d}async v(n,r,l){if(!(0,g.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let s=this.k.get(r);return s||(s=(async()=>{try{const d=this.profiles.find(O=>O.name===r||O.id===n);if(d)return d;const y=R(n,r,(0,o.joinPath)(this.profilesHome,n),l);await this.n.createFolder(y.location);const M=[];return this.h.fire({profile:y,join(O){M.push(O)}}),await w.Promises.settled(M),this.z([y],[],[]),y}finally{this.k.delete(r)}})(),this.k.set(r,s)),s}async updateProfile(n,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let l=this.profiles.find(s=>s.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);return l=R(l.id,r.name??l.name,l.location,{shortName:r.shortName??l.shortName,transient:r.transient??l.isTransient,useDefaultFlags:r.useDefaultFlags??l.useDefaultFlags}),this.z([],[],[l]),l}async removeProfile(n){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(s=>s.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const l=[];this.i.fire({profile:r,join(s){l.push(s)}});try{await Promise.allSettled(l)}catch(s){this.s.error(s)}for(const s of[...this.u.emptyWindows.keys()])r.id===this.u.emptyWindows.get(s)?.id&&this.u.emptyWindows.delete(s);for(const s of[...this.u.workspaces.keys()])r.id===this.u.workspaces.get(s)?.id&&this.u.workspaces.delete(s);this.F(),this.z([],[r],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(r.location,{recursive:!0})}catch(s){this.s.error(s)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const l=this.profiles.find(s=>s.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);this.D(n,l)}unsetWorkspace(n,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.D(n,void 0,r)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.F(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const n=await this.n.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(l=>!this.r.extUri.isEqual(l.location,r.resource))).map(r=>this.n.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.l.profiles.filter(r=>!this.y(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.w(n);return C.URI.isUri(r)?this.l.workspaces.get(r)??this.u.workspaces.get(r):this.l.emptyWindows.get(r)??this.u.emptyWindows.get(r)}w(n){return(0,b.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,b.isWorkspaceIdentifier)(n)?n.configPath:n.id}y(n){return!!([...this.l.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.l.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location)))}z(n,r,l){const s=[...this.profiles,...n],d=[];this.l.profiles=[];for(let y of s)y.isDefault||r.some(M=>y.id===M.id)||(y=l.find(M=>y.id===M.id)??y,y.isTransient?this.l.profiles.push(y):d.push({location:y.location,name:y.name,shortName:y.shortName,useDefaultFlags:y.useDefaultFlags}));this.H(d),this.t=void 0,this.C(n,r,l)}C(n,r,l){this.g.fire({added:n,removed:r,updated:l,all:this.profiles})}D(n,r,l){l=r?.isTransient?!0:l,l||this.D(n,void 0,!0);const s=this.w(n),d=l?this.l:this.u;C.URI.isUri(s)?(d.workspaces.delete(s),r&&d.workspaces.set(s,r)):(d.emptyWindows.delete(s),r&&d.emptyWindows.set(s,r)),l||this.F()}F(){const n={};for(const[l,s]of this.u.workspaces.entries())n[l.toString()]=s.location.toString();const r={};for(const[l,s]of this.u.emptyWindows.entries())r[l.toString()]=s.location.toString();this.J({workspaces:n,emptyWindows:r}),this.t=void 0}G(){return[]}H(n){throw new Error("not implemented")}I(){return{}}J(n){throw new Error("not implemented")}L(){}};t.b="userDataProfiles",t.c="profileAssociations",t=ve([ee(0,h.IEnvironmentService),ee(1,m.IFileService),ee(2,p.IUriIdentityService),ee(3,v.ILogService)],t),e.UserDataProfilesService=t;class a extends t{constructor(){super(...arguments),this.a=[],this.O={}}G(){return this.a}H(n){this.a=n}I(){return this.O}J(n){this.O=n}}e.InMemoryUserDataProfilesService=a}),define(te[77],ie([0,1,8,17,2,3,38,7,113,90,16,6,5,37,40,10,13,24]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f,p,w,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var g;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(g=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class D extends Error{constructor(i,n){super(i),this.code=n}}e.ExtensionsProfileScanningError=D,e.IExtensionsProfileScannerService=(0,v.createDecorator)("IExtensionsProfileScannerService");let E=class extends k.Disposable{constructor(i,n,r,l,s,d){super(),this.h=i,this.i=n,this.j=r,this.k=l,this.l=s,this.m=d,this.a=this.B(new o.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new o.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new o.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new o.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new C.ResourceMap}scanProfileExtensions(i,n){return this.n(i,void 0,n)}async addExtensionsToProfile(i,n){const r=[],l=[];try{return await this.n(n,s=>{const d=[];for(const y of s)i.some(([M])=>(0,h.areSameExtensions)(M.identifier,y.identifier)&&M.manifest.version!==y.version)?r.push(y):d.push(y);for(const[y,M]of i)if(!d.some(O=>(0,h.areSameExtensions)(O.identifier,y.identifier)&&O.version===y.manifest.version)){const O={identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:M};l.push(O),d.push(O)}return l.length&&this.a.fire({extensions:l,profileLocation:n}),r.length&&this.c.fire({extensions:r,profileLocation:n}),d}),l.length&&this.b.fire({extensions:l,profileLocation:n}),r.length&&this.f.fire({extensions:r,profileLocation:n}),l}catch(s){throw l.length&&this.b.fire({extensions:l,error:s,profileLocation:n}),r.length&&this.f.fire({extensions:r,error:s,profileLocation:n}),s}}async updateMetadata(i,n){const r=[];return await this.n(n,l=>{const s=[];for(const d of l){const y=i.find(([M])=>(0,h.areSameExtensions)(M.identifier,d.identifier)&&M.manifest.version===d.version);y&&(d.metadata={...d.metadata,...y[1]},r.push(d)),s.push(d)}return s}),r}async removeExtensionFromProfile(i,n){const r=[];this.c.fire({extensions:r,profileLocation:n});try{await this.n(n,l=>{const s=[];for(const d of l)(0,h.areSameExtensions)(d.identifier,i.identifier)?r.push(d):s.push(d);return r.length&&this.c.fire({extensions:r,profileLocation:n}),s}),r.length&&this.f.fire({extensions:r,profileLocation:n})}catch(l){throw r.length&&this.f.fire({extensions:r,error:l,profileLocation:n}),l}}async n(i,n,r){return this.v(i).queue(async()=>{let l=[],s;try{const d=await this.i.readFile(i);s=JSON.parse(d.value.toString())}catch(d){if((0,S.toFileOperationResult)(d)!==1)throw d;if(this.k.extUri.isEqual(i,this.j.defaultProfile.extensionsResource)&&(s=await this.u()),!s&&r?.bailOutWhenFileNotFound)throw new D((0,c.getErrorMessage)(d),"ERROR_PROFILE_NOT_FOUND")}if(s){Array.isArray(s)||this.p(i);let d=!1;for(const y of s){R(y)||this.p(i);let M;if((0,w.isString)(y.location))M=this.s(y.location);else{M=P.URI.revive(y.location);const O=this.r(M);O&&(d=!0,y.location=O)}l.push({identifier:y.identifier,location:M,version:y.version,metadata:y.metadata})}d&&await this.i.writeFile(i,L.VSBuffer.fromString(JSON.stringify(s)))}if(n){l=n(l);const d=l.map(y=>({identifier:y.identifier,version:y.version,location:this.r(y.location)??y.location.toJSON(),metadata:y.metadata}));await this.i.writeFile(i,L.VSBuffer.fromString(JSON.stringify(d)))}return l})}p(i){const n=new D(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.l.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}r(i){return this.k.extUri.isEqualOrParent(i,this.h)?this.k.extUri.relativePath(this.h,i):void 0}s(i){return this.k.extUri.joinPath(this.h,i)}async u(){return this.t||(this.t=(async()=>{const i=this.k.extUri.joinPath(this.j.defaultProfile.location,"extensions.json");let n;try{n=(await this.i.readFile(i)).value.toString()}catch(l){if((0,S.toFileOperationResult)(l)===1)return;throw l}this.m.info("Migrating extensions from old default profile location",i.toString());let r;try{const l=JSON.parse(n);Array.isArray(l)&&l.every(s=>R(s))?r=l:this.m.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.m.error(l)}if(r)try{await this.i.createFile(this.j.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify(r)),{overwrite:!1}),this.m.info("Migrated extensions from old default profile location to new location",i.toString(),this.j.defaultProfile.extensionsResource.toString())}catch(l){if((0,S.toFileOperationResult)(l)===3)this.m.info("Migration from old default profile location to new location is done by another window",i.toString(),this.j.defaultProfile.extensionsResource.toString());else throw l}try{await this.i.del(i)}catch(l){(0,S.toFileOperationResult)(l)!==1&&this.m.error(l)}return r})()),this.t}v(i){let n=this.g.get(i);return n||(n=new I.Queue,this.g.set(i,n)),n}};E=ve([ee(1,S.IFileService),ee(2,f.IUserDataProfilesService),ee(3,p.IUriIdentityService),ee(4,u.ITelemetryService),ee(5,b.ILogService)],E),e.AbstractExtensionsProfileScannerService=E;function R(a){return(0,w.isObject)(a)&&(0,m.isIExtensionIdentifier)(a.identifier)&&(t(a.location)||(0,w.isString)(a.location))&&a.version&&(0,w.isString)(a.version)}function t(a){return a?(0,w.isString)(a.path)&&(0,w.isString)(a.scheme):!1}}),define(te[119],ie([0,1,25,8,44,17,13,43,140,2,15,9,4,20,192,83,10,7,159,33,113,90,191,16,6,5,19,3,72,77,37,40,189,190]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f,p,w,c,u,g,D,E,R,t,a,i,n,r,l,s,d,y,M,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var K;(function(ge){function H(F,U){if(F===U)return!0;const z=Object.keys(F),Y=new Set;for(const ne of Object.keys(U))Y.add(ne);if(z.length!==Y.size)return!1;for(const ne of z){if(F[ne]!==U[ne])return!1;Y.delete(ne)}return Y.size===0}ge.equals=H})(K=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let x=class extends m.Disposable{constructor(H,F,U,z,Y,ne,_,$,A,T,W,B){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=F,this.l=U,this.m=z,this.n=Y,this.p=ne,this.r=_,this.s=$,this.t=A,this.u=T,this.v=W,this.w=B,this.g=this.B(new l.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,f.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(se,(0,f.joinPath)(this.m,R.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(se,(0,f.joinPath)(this.m,R.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(re,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,E.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(H,F,U){const[z,Y]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(F)]),ne=U?await this.scanExtensionsUnderDevelopment(H,[...z,...Y]):[];return this.F(z,Y,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const F=[];F.push(this.G(!!H.useCache,H.language)),F.push(this.H(H.language,!!H.checkControlFile));const[U,z]=await Promise.all(F);return this.D([...U,...z],0,H,!1)}async scanUserExtensions(H){const F=H.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",F);const U=this.v.extUri.isEqual(H.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.J(F,!!H.profileLocation,1,!H.includeUninstalled,H.language,!0,U),Y=H.useCache&&!z.devMode&&z.excludeObsolete?this.j:this.k;let ne;try{ne=await Y.scanExtensions(z)}catch(_){if(_ instanceof d.ExtensionsProfileScanningError&&_.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),ne=await Y.scanExtensions(z);else throw _}return ne=await this.D(ne,1,H,!0),this.s.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(H,F){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const U=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(z=>z.scheme===S.Schemas.file).map(async z=>{const Y=await this.J(z,!1,1,!0,H.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(Y)).map(_=>(_.type=F.find($=>(0,E.areSameExtensions)($.identifier,_.identifier))?.type??_.type,this.k.validate(_,Y)))}))).flat();return this.D(U,"development",H,!0)}return[]}async scanExistingExtension(H,F,U){const z=await this.J(H,!1,F,!0,U.language,!0,void 0),Y=await this.k.scanExtension(z);return!Y||!U.includeInvalid&&!Y.isValid?null:Y}async scanOneOrMultipleExtensions(H,F,U){const z=await this.J(H,!1,F,!0,U.language,!0,void 0),Y=await this.k.scanOneOrMultipleExtensions(z);return this.D(Y,F,U,!0)}async scanMetadata(H){const F=(0,f.joinPath)(H,"package.json"),U=(await this.r.readFile(F)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(H,F){const U=(0,f.joinPath)(H,"package.json"),z=(await this.r.readFile(U)).value.toString(),Y=JSON.parse(z);F.isMachineScoped=F.isMachineScoped||void 0,F.isBuiltin=F.isBuiltin||void 0,F.installedTimestamp=F.installedTimestamp||void 0,Y.__metadata={...Y.__metadata,...F},await this.r.writeFile((0,f.joinPath)(H,"package.json"),o.VSBuffer.fromString(JSON.stringify(Y,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof d.ExtensionsProfileScanningError&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw H}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.p.addExtensionsToProfile(H.map(F=>[F,F.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,o.VSBuffer.fromString(JSON.stringify([])))}catch(F){(0,a.toFileOperationResult)(F)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.getErrorMessage)(F))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.s.error(H)}finally{this.z=void 0}})()),this.z}async D(H,F,U,z){return U.includeAllVersions||(H=this.F(F===0?H:void 0,F===1?H:void 0,F==="development"?H:void 0,await this.getTargetPlatform(),z)),U.includeInvalid||(H=H.filter(Y=>Y.isValid)),H.sort((Y,ne)=>{const _=v.basename(Y.location.fsPath),$=v.basename(ne.location.fsPath);return _<$?-1:_>$?1:0})}F(H,F,U,z,Y){const ne=($,A,T)=>{if($.isValid&&!A.isValid)return!1;if($.isValid===A.isValid){if(Y&&p.gt($.manifest.version,A.manifest.version))return this.s.debug(`Skipping extension ${A.location.path} with lower version ${A.manifest.version} in favour of ${$.location.path} with version ${$.manifest.version}`),!1;if(p.eq($.manifest.version,A.manifest.version)){if($.type===0)return this.s.debug(`Skipping extension ${A.location.path} in favour of system extension ${$.location.path} with same version`),!1;if($.targetPlatform===z)return this.s.debug(`Skipping extension ${A.location.path} from different target platform ${A.targetPlatform}`),!1}}return T?this.s.warn(`Overwriting user extension ${$.location.path} with ${A.location.path}.`):this.s.debug(`Overwriting user extension ${$.location.path} with ${A.location.path}.`),!0},_=new Map;return H?.forEach($=>{const A=R.ExtensionIdentifier.toKey($.identifier.id),T=_.get(A);(!T||ne(T,$,!1))&&_.set(A,$)}),F?.forEach($=>{const A=R.ExtensionIdentifier.toKey($.identifier.id),T=_.get(A);if(!T&&H&&$.type===0){this.s.debug(`Skipping obsolete system extension ${$.location.path}.`);return}(!T||ne(T,$,!1))&&_.set(A,$)}),U?.forEach($=>{const A=R.ExtensionIdentifier.toKey($.identifier.id),T=_.get(A);(!T||ne(T,$,!0))&&_.set(A,$),_.set(A,$)}),[..._.values()]}async G(H,F){this.s.trace("Started scanning system extensions");const U=await this.J(this.systemExtensionsLocation,!1,0,!0,F,!0,void 0),Y=await(H&&!U.devMode?this.i:this.k).scanExtensions(U);return this.s.trace("Scanned system extensions:",Y.length),Y}async H(H,F){const U=this.t.isBuilt?[]:this.u.builtInExtensions;if(!U?.length)return[];this.s.trace("Started scanning dev system extensions");const z=F?await this.I():{},Y=[],ne=u.URI.file(v.normalize(v.join(S.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const $ of U){const A=z[$.name]||"marketplace";switch(A){case"disabled":break;case"marketplace":Y.push((0,f.joinPath)(ne,$.name));break;default:Y.push(u.URI.file(A));break}}const _=await Promise.all(Y.map(async $=>this.k.scanExtension(await this.J($,!1,0,!0,H,!0,void 0))));return this.s.trace("Scanned dev system extensions:",_.length),(0,I.coalesce)(_)}async I(){try{const H=await this.r.readFile(this.l);return JSON.parse(H.value.toString())}catch{return{}}}async J(H,F,U,z,Y,ne,_){const $=await this.f(Y??b.language),A=await this.L(H),T=F&&!this.v.extUri.isEqual(H,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,W=T?await this.L(T):void 0;return new J(H,A,T,W,F,_,U,z,ne,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,Y,$)}async L(H){try{const F=await this.r.stat(H);if(typeof F.mtime=="number")return F.mtime}catch{}}};x=ve([ee(4,y.IUserDataProfilesService),ee(5,d.IExtensionsProfileScannerService),ee(6,a.IFileService),ee(7,n.ILogService),ee(8,D.IEnvironmentService),ee(9,r.IProductService),ee(10,M.IUriIdentityService),ee(11,i.IInstantiationService)],x),e.AbstractExtensionsScannerService=x;class J{constructor(H,F,U,z,Y,ne,_,$,A,T,W,B,G,N,q){this.location=H,this.mtime=F,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=z,this.profile=Y,this.profileScanOptions=ne,this.type=_,this.excludeObsolete=$,this.validate=A,this.productVersion=T,this.productDate=W,this.productCommit=B,this.devMode=G,this.language=N,this.translations=q}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,F){return(0,f.isEqual)(H.location,F.location)&&H.mtime===F.mtime&&(0,f.isEqual)(H.applicationExtensionslocation,F.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===F.applicationExtensionslocationMtime&&H.profile===F.profile&&k.equals(H.profileScanOptions,F.profileScanOptions)&&H.type===F.type&&H.excludeObsolete===F.excludeObsolete&&H.validate===F.validate&&H.productVersion===F.productVersion&&H.productDate===F.productDate&&H.productCommit===F.productCommit&&H.devMode===F.devMode&&H.language===F.language&&K.equals(H.translations,F.translations)}}e.ExtensionScannerInput=J;let re=class extends m.Disposable{constructor(H,F,U,z,Y){super(),this.f=H,this.g=F,this.h=U,this.i=z,this.j=Y}async scanExtensions(H){const F=H.profile?await this.l(H):await this.k(H);let U={};if(H.excludeObsolete&&H.type===1)try{const z=(await this.i.readFile(this.f)).value.toString();U=JSON.parse(z)}catch{}return(0,c.isEmptyObject)(U)?F:F.filter(z=>!U[E.ExtensionKey.create(z).toString()])}async k(H){const F=await this.i.resolve(H.location);if(!F.children?.length)return[];const U=await Promise.all(F.children.map(async z=>{if(!z.isDirectory||H.type===1&&(0,f.basename)(z.resource).indexOf(".")===0)return null;const Y=new J(z.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(Y)}));return(0,I.coalesce)(U).sort((z,Y)=>z.location.path<Y.location.path?-1:1)}async l(H){let F=await this.m(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.h.extUri.isEqual(H.location,H.applicationExtensionslocation)){F=F.filter(z=>!z.metadata?.isApplicationScoped);const U=await this.m(H.applicationExtensionslocation,z=>!!z.metadata?.isApplicationScoped,H);F.push(...U)}return F}async m(H,F,U){const z=await this.g.scanProfileExtensions(H,U.profileScanOptions);if(!z.length)return[];const Y=await Promise.all(z.map(async ne=>{if(F(ne)){const _=new J(ne.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.profileScanOptions,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(_,ne.metadata)}return null}));return(0,I.coalesce)(Y)}async scanOneOrMultipleExtensions(H){try{if(await this.i.exists((0,f.joinPath)(H.location,"package.json"))){const F=await this.scanExtension(H);return F?[F]:[]}else return await this.scanExtensions(H)}catch(F){return this.j.error(`Error scanning extensions at ${H.location.path}:`,(0,C.getErrorMessage)(F)),[]}}async scanExtension(H,F){try{let U=await this.scanExtensionManifest(H.location);if(U){U.publisher||(U.publisher=R.UNDEFINED_PUBLISHER),F=F??U.__metadata,delete U.__metadata;const z=(0,E.getGalleryExtensionId)(U.publisher,U.name),Y=F?.id?{id:z,uuid:F.id}:{id:z},ne=F?.isSystem?0:H.type,_=ne===0||!!F?.isBuiltin;j.ImplicitActivationEvents.updateManifest(U),U=await this.n(H.location,U,J.createNlsConfiguration(H));const $={type:ne,identifier:Y,manifest:U,location:H.location,isBuiltin:_,targetPlatform:F?.targetPlatform??"undefined",metadata:F,isValid:!0,validations:[]};return H.validate?this.validate($,H):$}}catch(U){H.type!==0&&this.j.error(U)}return null}validate(H,F){let U=!0;const z=(0,t.validateExtensionManifest)(F.productVersion,F.productDate,F.location,H.manifest,H.isBuiltin);for(const[Y,ne]of z)Y===w.default.Error&&(U=!1,this.j.error(this.t(F.location,ne)));return H.isValid=U,H.validations=z,H}async scanExtensionManifest(H){const F=(0,f.joinPath)(H,"package.json");let U;try{U=(await this.i.readFile(F)).value.toString()}catch(Y){return(0,a.toFileOperationResult)(Y)!==1&&this.j.error(this.t(H,(0,g.localize)(0,null,F.path,Y.message))),null}let z;try{z=JSON.parse(U)}catch{const ne=[];(0,P.parse)(U,ne);for(const _ of ne)this.j.error(this.t(H,(0,g.localize)(1,null,F.path,_.offset,_.length,(0,h.getParseErrorMessage)(_.error))));return null}return(0,P.getNodeType)(z)!=="object"?(this.j.error(this.t(H,(0,g.localize)(2,null,F.path))),null):z}async n(H,F,U){const z=await this.p(H,F,U);if(z)try{const Y=[],ne=await this.r(z.default,Y);if(Y.length>0)return Y.forEach($=>{this.j.error(this.t(H,(0,g.localize)(3,null,z.default?.path,(0,h.getParseErrorMessage)($.error))))}),F;if((0,P.getNodeType)(z)!=="object")return this.j.error(this.t(H,(0,g.localize)(4,null,z.default?.path))),F;const _=z.values||Object.create(null);return(0,O.localizeManifest)(F,_,ne)}catch{}return F}async p(H,F,U){const z=(0,f.joinPath)(H,"package.nls.json"),Y=(A,T)=>{T.forEach(W=>{this.j.error(this.t(H,(0,g.localize)(5,null,A?.path,(0,h.getParseErrorMessage)(W.error))))})},ne=A=>{this.j.error(this.t(H,(0,g.localize)(6,null,A?.path)))},_=`${F.publisher}.${F.name}`,$=U.translations[_];if($)try{const A=u.URI.file($),T=(await this.i.readFile(A)).value.toString(),W=[],B=(0,P.parse)(T,W);return W.length>0?(Y(A,W),{values:void 0,default:z}):(0,P.getNodeType)(B)!=="object"?(ne(A),{values:void 0,default:z}):{values:B.contents?B.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.i.exists(z))return;let T;try{T=await this.s(H,U)}catch{return}if(!T.localized)return{values:void 0,default:T.original};try{const W=(await this.i.readFile(T.localized)).value.toString(),B=[],G=(0,P.parse)(W,B);return B.length>0?(Y(T.localized,B),{values:void 0,default:T.original}):(0,P.getNodeType)(G)!=="object"?(ne(T.localized),{values:void 0,default:T.original}):{values:G,default:T.original}}catch{return{values:void 0,default:T.original}}}}async r(H,F){if(H)try{const U=(await this.i.readFile(H)).value.toString();return(0,P.parse)(U,F)}catch{}}s(H,F){return new Promise((U,z)=>{const Y=ne=>{const _=(0,f.joinPath)(H,`package.nls.${ne}.json`);this.i.exists(_).then($=>{$&&U({localized:_,original:(0,f.joinPath)(H,"package.nls.json")});const A=ne.lastIndexOf("-");A===-1?U({localized:(0,f.joinPath)(H,"package.nls.json"),original:null}):(ne=ne.substring(0,A),Y(ne))})};if(F.devMode||F.pseudo||!F.language)return U({localized:(0,f.joinPath)(H,"package.nls.json"),original:null});Y(F.language)})}t(H,F){return`[${H.path}]: ${F}`}};re=ve([ee(1,d.IExtensionsProfileScannerService),ee(2,M.IUriIdentityService),ee(3,a.IFileService),ee(4,n.ILogService)],re);let se=class extends re{constructor(H,F,U,z,Y,ne){super(F,U,z,Y,ne),this.y=H,this.v=this.B(new L.ThrottledDelayer(3e3)),this.w=this.B(new l.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(H){const F=await this.z();if(this.u=H,F&&F.input&&J.equals(F.input,this.u))return this.j.debug("Using cached extensions scan result",H.location.toString()),this.v.trigger(()=>this.D()),F.result.map(z=>(z.location=u.URI.revive(z.location),z));const U=await super.scanExtensions(H);return await this.C({input:H,result:U}),U}async z(){try{const H=await this.i.readFile(this.y),F=JSON.parse(H.value.toString());return{result:F.result,input:(0,s.revive)(F.input)}}catch(H){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,C.getErrorMessage)(H))}return null}async C(H){try{await this.i.writeFile(this.y,o.VSBuffer.fromString(JSON.stringify(H)))}catch(F){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,C.getErrorMessage)(F))}}async D(){if(!this.u)return;const H=await this.z();if(!H)return;const F=H.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!k.equals(U,F))try{await this.i.del(this.y),this.w.fire()}catch(z){this.j.error(z)}}};se=ve([ee(2,d.IExtensionsProfileScannerService),ee(3,M.IUriIdentityService),ee(4,a.IFileService),ee(5,n.ILogService)],se);function ae(ge,H){const F=(0,E.getExtensionId)(ge.manifest.publisher,ge.manifest.name);return{id:F,identifier:new R.ExtensionIdentifier(F),isBuiltin:ge.type===0,isUserBuiltin:ge.type===1&&ge.isBuiltin,isUnderDevelopment:H,extensionLocation:ge.location,uuid:ge.identifier.uuid,targetPlatform:ge.targetPlatform,...ge.manifest}}e.toExtensionDescription=ae;class fe extends x{constructor(H,F,U,z,Y,ne,_,$,A,T,W,B){super(H,F,(0,f.joinPath)(U,".vscode-oss-dev","extensions","control.json"),(0,f.joinPath)(z,R.MANIFEST_CACHE_FOLDER),Y,ne,_,$,A,T,W,B),this.M=(async()=>{if(b.translationsConfigFile)try{const G=await this.r.readFile(u.URI.file(b.translationsConfigFile));return JSON.parse(G.value.toString())}catch{}return Object.create(null)})()}f(H){return this.M}}e.NativeExtensionsScannerService=fe}),define(te[263],ie([0,1,5,37,40,24,77,16,33,7]),function(V,e,I,L,k,o,C,P,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let S=class extends C.AbstractExtensionsProfileScannerService{constructor(b,f,p,w,c,u){super(m.URI.file(b.extensionsPath),f,p,w,c,u)}};S=ve([ee(0,h.INativeEnvironmentService),ee(1,P.IFileService),ee(2,L.IUserDataProfilesService),ee(3,k.IUriIdentityService),ee(4,o.ITelemetryService),ee(5,I.ILogService)],S),e.ExtensionsProfileScannerService=S}),define(te[264],ie([0,1,7,33,77,119,16,6,5,19,40,37]),function(V,e,I,L,k,o,C,P,h,m,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let b=class extends o.NativeExtensionsScannerService{constructor(p,w,c,u,g,D,E,R){super(I.URI.file(g.builtinExtensionsPath),I.URI.file(g.extensionsPath),g.userHome,I.URI.file(g.userDataPath),p,w,c,u,g,D,E,R)}};b=ve([ee(0,v.IUserDataProfilesService),ee(1,k.IExtensionsProfileScannerService),ee(2,C.IFileService),ee(3,h.ILogService),ee(4,L.INativeEnvironmentService),ee(5,m.IProductService),ee(6,S.IUriIdentityService),ee(7,P.IInstantiationService)],b),e.ExtensionsScannerService=b}),define(te[265],ie([0,1,14,2,15,9,4,60,7,31,42,33,5,37]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let p=class extends L.Disposable{constructor(c,u,g){super(),this.c=c,this.f=g,this.a=P.TernarySearchTree.forPaths(!C.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(c.appRoot),this.addValidFileRoot(c.extensionsPath),this.addValidFileRoot(u.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(c.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:c}=I.session;c.protocol.registerFileProtocol(k.Schemas.vscodeFileResource,(u,g)=>this.i(u,g)),c.protocol.interceptFileProtocol(k.Schemas.file,(u,g)=>this.h(u,g)),this.B((0,L.toDisposable)(()=>{c.protocol.unregisterProtocol(k.Schemas.vscodeFileResource),c.protocol.uninterceptProtocol(k.Schemas.file)}))}addValidFileRoot(c){const u=(0,o.normalize)(c);return this.a.get(u)?L.Disposable.None:(this.a.set(u,!0),(0,L.toDisposable)(()=>this.a.delete(u)))}h(c,u){const g=h.URI.parse(c.url);return this.f.error(`Refused to load resource ${g.fsPath} from ${k.Schemas.file}: protocol (original URL: ${c.url})`),u({error:-3})}i(c,u){const g=this.j(c);let D;return this.c.crossOriginIsolated&&((0,o.basename)(g)==="workbench.html"||(0,o.basename)(g)==="workbench-dev.html"?D=k.COI.CoopAndCoep:D=k.COI.getHeadersFromQuery(c.url)),this.a.findSubstr(g)?u({path:g,headers:D}):this.b.has((0,o.extname)(g).toLowerCase())?u({path:g}):(this.f.error(`${k.Schemas.vscodeFileResource}: Refused to load resource ${g} from ${k.Schemas.vscodeFileResource}: protocol (original URL: ${c.url})`),u({error:-3}))}j(c){const u=h.URI.parse(c.url),g=k.FileAccess.uriToFileUri(u);return(0,o.normalize)(g.fsPath)}createIPCObjectUrl(){let c;const u=h.URI.from({scheme:"vscode",path:(0,m.generateUuid)()}),g=u.toString(),D=async()=>c;return S.validatedIpcMain.handle(g,D),this.f.trace(`IPC Object URL: Registered new channel ${g}.`),{resource:u,update:E=>c=E,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${g}.`),S.validatedIpcMain.removeHandler(g)}}}};p=ve([ee(0,v.INativeEnvironmentService),ee(1,f.IUserDataProfilesService),ee(2,b.ILogService)],p),e.ProtocolMainService=p}),define(te[266],ie([0,1,14,42,8,3,2,15,10,105,28,21,5,65,66,68,45,37,39,64]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f,p,w,c,u,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let E=class extends C.Disposable{constructor(t,a,i,n,r,l,s,d,y,M){super(),this.g=t,this.h=a,this.i=i,this.j=n,this.k=r,this.l=l,this.m=s,this.n=d,this.p=y,this.r=M,this.a=new k.Barrier,this.b=void 0,this.c=void 0,this.f=this.B(new o.Emitter),this.onDidError=o.Event.buffer(this.f.event),this.y=void 0,this.z=void 0,this.s()}s(){L.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(t,a)=>this.t(t,a)),L.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(t,a)=>this.u(t,a)),this.B(this.k.onWillShutdown(()=>this.v()))}async t(t,a){this.l.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.a.isOpen()||this.a.open(),await this.whenReady();const i=await this.connect();if(t.sender.isDestroyed())return i.close();t.sender.postMessage("vscode:createSharedProcessMessageChannelResult",a,[i])}u(t,a){this.l.trace("SharedProcess: onWorkerConnection",a);const i=new C.DisposableStore,n=l=>{!this.G()||(this.l.trace(`SharedProcess: disposing worker (reason: '${l}')`,a),i.dispose(),this.w("vscode:electron-main->shared-process=disposeWorker",a))},r=I.BrowserWindow.fromId(a.reply.windowId);if(!r||r.isDestroyed()||r.webContents.isDestroyed()||!a.reply.channel){n("unavailable");return}i.add(o.Event.filter(this.k.onWillLoadWindow,l=>l.window.win===r)(()=>n("load"))),i.add(o.Event.fromNodeEventEmitter(r,"closed")(()=>n("closed"))),r.webContents.postMessage(a.reply.channel,a.reply.nonce,t.ports)}v(){const t=this.b;!t||(this.w("vscode:electron-main->shared-process=exit"),this.c&&(t.removeListener("close",this.c),this.c=void 0),setTimeout(()=>{try{t.close()}catch{}this.b=void 0},0))}w(t,...a){if(!this.G()){this.l.warn(`Sending IPC message to channel '${t}' for shared process window that is destroyed`);return}try{this.b?.webContents.send(t,...a)}catch(i){this.l.warn(`Error sending IPC message to channel '${t}' of shared process: ${(0,c.toErrorMessage)(i)}`)}}whenReady(){return this.y||(this.y=new Promise(t=>L.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.l.trace("SharedProcess: Overall ready"),t()}))),this.y}get C(){return this.z||(this.z=(async()=>{await this.a.wait(),this.D(),this.F(),await new Promise(t=>L.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.l.trace("SharedProcess: IPC ready"),t()}))})()),this.z}D(){const t=this.B(this.r.createIPCObjectUrl());this.b=new I.BrowserWindow({show:!1,backgroundColor:this.p.getBackgroundColor(),webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${t.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.i.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),t.update({machineId:this.g,windowId:this.b.id,appRoot:this.i.appRoot,codeCachePath:this.i.codeCachePath,profiles:this.j.profiles,userEnv:this.h,args:this.i.args,logLevel:this.l.getLevel(),loggers:this.m.getRegisteredLoggers(),product:f.default,policiesData:this.n.serialize()}),this.b.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.i.isBuilt?"":"-dev"}.html`).toString(!0))}F(){!this.b||(this.c=t=>{this.l.trace("SharedProcess#close prevented"),t.preventDefault(),this.b?.isVisible()&&this.b.hide()},this.b.on("close",this.c),this.b.webContents.on("render-process-gone",(t,a)=>this.f.fire({type:2,details:a})),this.b.on("unresponsive",()=>this.f.fire({type:1})),this.b.webContents.on("did-fail-load",(t,a,i)=>this.f.fire({type:3,details:{reason:i,exitCode:a}})))}async connect(){await this.C;const t=(0,h.assertIsDefined)(this.b);return(0,m.connect)(t)}async toggle(){await this.C,this.b&&(this.b.isVisible()?(this.b.webContents.closeDevTools(),this.b.hide()):(this.b.show(),this.b.webContents.openDevTools()))}isVisible(){return this.b?.isVisible()??!1}G(){const t=this.b;return t?!t.isDestroyed()&&!t.webContents.isDestroyed():!1}};E=ve([ee(2,S.IEnvironmentMainService),ee(3,u.IUserDataProfilesService),ee(4,v.ILifecycleMainService),ee(5,b.ILogService),ee(6,D.ILoggerMainService),ee(7,g.IPolicyService),ee(8,w.IThemeMainService),ee(9,p.IProtocolMainService)],E),e.SharedProcess=E}),define(te[94],ie([0,1,8,3,2,63,10,106,6,37]),function(V,e,I,L,k,o,C,P,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,h.createDecorator)("storageService");var S;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(S=e.WillSaveStateReason||(e.WillSaveStateReason={}));var v;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(v=e.StorageScope||(e.StorageScope={}));var b;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(b=e.StorageTarget||(e.StorageTarget={}));function f(g){const D=g.get(e.TARGET_KEY);if(D)try{return JSON.parse(D)}catch{}return Object.create(null)}e.loadKeyTargets=f;class p extends k.Disposable{constructor(D={flushInterval:p.a}){super(),this.j=D,this.b=this.B(new L.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new L.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new L.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new I.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new k.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,I.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,k.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,o.mark)("code/willInitStorage");try{await this.J()}finally{(0,o.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(D,E){if(E===e.TARGET_KEY){switch(D){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:D})}else this.b.fire({scope:D,key:E,target:this.F(D)[E]})}r(D){this.f.fire({reason:D})}get(D,E,R){return this.L(E)?.get(D,R)}getBoolean(D,E,R){return this.L(E)?.getBoolean(D,R)}getNumber(D,E,R){return this.L(E)?.getNumber(D,R)}store(D,E,R,t){if((0,C.isUndefinedOrNull)(E)){this.remove(D,R);return}this.t(()=>{this.u(D,R,t),this.L(R)?.set(D,E)})}remove(D,E){this.t(()=>{this.u(D,E,void 0),this.L(E)?.delete(D)})}t(D){this.b.pause(),this.c.pause();try{D()}finally{this.b.resume(),this.c.resume()}}keys(D,E){const R=[],t=this.F(D);for(const a of Object.keys(t))t[a]===E&&R.push(a);return R}u(D,E,R){const t=this.F(E);typeof R=="number"?t[D]!==R&&(t[D]=R,this.L(E)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[D]=="number"&&(delete t[D],this.L(E)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(D){switch(D){case-1:return this.D;case 0:return this.z;default:return this.w}}G(D){const E=this.L(D);return E?f(E):Object.create(null)}isNew(D){return this.getBoolean(e.IS_NEW_KEY,D)===!0}async flush(D=S.NONE){this.f.fire({reason:D});const E=this.L(-1),R=this.L(0),t=this.L(1);switch(D){case S.NONE:await I.Promises.settled([E?.whenFlushed()??Promise.resolve(),R?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case S.SHUTDOWN:await I.Promises.settled([E?.flush(0)??Promise.resolve(),R?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const D=this.L(-1)?.items??new Map,E=this.L(0)?.items??new Map,R=this.L(1)?.items??new Map;return u(D,E,R,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(D,E){return this.r(S.NONE),(0,m.isUserDataProfile)(D)?this.N(D,E):this.O(D,E)}H(D,E){return!(D.id===E.id||w(E)&&w(D))}I(D,E,R,t){this.t(()=>{if(t)for(const[a,i]of D)E.set(a,i);else{const a=new Set;for(const[i,n]of D)a.add(i),E.get(i)!==n&&this.n(R,i);for(const[i]of E.items)a.has(i)||this.n(R,i)}})}}e.AbstractStorageService=p,p.a=60*1e3;function w(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=w;class c extends p{constructor(){super(),this.p=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(D=>this.n(1,D))),this.B(this.P.onDidChangeStorage(D=>this.n(0,D))),this.B(this.p.onDidChangeStorage(D=>this.n(-1,D)))}L(D){switch(D){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(D){switch(D){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(D){return!1}}e.InMemoryStorageService=c;async function u(g,D,E,R,t,a){const i=j=>{try{return JSON.parse(j)}catch{return j}},n=new Map,r=new Map;g.forEach((j,K)=>{n.set(K,j),r.set(K,i(j))});const l=new Map,s=new Map;D.forEach((j,K)=>{l.set(K,j),s.set(K,i(j))});const d=new Map,y=new Map;E.forEach((j,K)=>{d.set(K,j),y.set(K,i(j))}),console.group(R!==t?`Storage: Application (path: ${R})`:`Storage: Application & Profile (path: ${R}, default profile)`);const M=[];if(n.forEach((j,K)=>{M.push({key:K,value:j})}),console.table(M),console.groupEnd(),console.log(r),R!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const j=[];l.forEach((K,x)=>{j.push({key:x,value:K})}),console.table(j),console.groupEnd(),console.log(s)}console.group(`Storage: Workspace (path: ${a})`);const O=[];d.forEach((j,K)=>{O.push({key:K,value:j})}),console.table(O),console.groupEnd(),console.log(y)}e.logStorage=u}),define(te[267],ie([0,1,25,8,3,2,9,70,7,23,106,151,5,94,24,29]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class c extends o.Disposable{get storage(){return this.f}constructor(a,i){super(),this.j=a,this.k=i,this.b=this.B(new k.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.B(new k.Emitter),this.onDidCloseStorage=this.c.event,this.f=new S.Storage(new S.InMemoryStorageDatabase,{hint:S.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new L.DeferredPromise,this.whenInit=this.h.p,this.i=S.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===S.StorageState.None)try{const a=await this.n();this.f.dispose(),this.f=a,this.B(a.onDidChangeStorage(n=>this.b.fire({key:n}))),await this.m(a);const i=a.getBoolean(f.IS_NEW_KEY);i===void 0?a.set(f.IS_NEW_KEY,!0):i&&a.set(f.IS_NEW_KEY,!1)}catch(a){this.j.error(`[storage main] initialize(): Unable to init storage due to ${a}`)}finally{this.i=S.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===b.LogLevel.Trace?a=>this.j.trace(a):void 0,logError:a=>this.j.error(a)}}m(a){return a.init()}get items(){return this.f.items}get(a,i){return this.f.get(a,i)}set(a,i){return this.f.set(a,i)}delete(a){return this.f.delete(a)}async close(){const a=new P.StopWatch(!1);await this.s(),a.stop(),a.elapsed()>c.a&&await this.r(a),this.c.fire()}async r(a){if(!!this.path)try{const i=(0,I.top)(Array.from(this.f.items.entries()).map(([r,l])=>({key:r,length:l.length})),(r,l)=>l.length-r.length,5).map(r=>`${r.key}:${r.length}`).join(", "),n=(await this.k.stat(h.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${a.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async s(){this.g&&await this.g,this.i=S.StorageState.Closed,await this.f.close()}}c.a=2e3;class u extends c{get path(){if(!this.v.useInMemoryStorage)return(0,C.join)(this.u.globalStorageHome.fsPath,u.t)}constructor(a,i,n,r){super(n,r),this.u=a,this.v=i}async n(){return new S.Storage(new v.SQLiteStorageDatabase(this.path??v.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:S.StorageHint.STORAGE_IN_MEMORY})}}u.t="state.vscdb";class g extends u{constructor(a,i,n,r){super(a,i,n,r)}}e.ProfileStorageMain=g;class D extends u{constructor(a,i,n,r){super(i.defaultProfile,a,n,r)}async m(a){await super.m(a),this.z(a)}z(a){a.get(p.firstSessionDateStorageKey,void 0)===void 0&&a.set(p.firstSessionDateStorageKey,new Date().toUTCString());const n=a.get(p.currentSessionDateStorageKey,void 0),r=new Date().toUTCString();a.set(p.lastSessionDateStorageKey,typeof n>"u"?null:n),a.set(p.currentSessionDateStorageKey,r)}}e.ApplicationStorageMain=D;class E extends c{get path(){if(!this.w.useInMemoryStorage)return(0,C.join)(this.y.workspaceStorageHome.fsPath,this.v.id,E.t)}constructor(a,i,n,r,l){super(n,l),this.v=a,this.w=i,this.y=r}async n(){const{storageFilePath:a,wasCreated:i}=await this.C();return new S.Storage(new v.SQLiteStorageDatabase(a,{logging:this.l()}),{hint:this.w.useInMemoryStorage?S.StorageHint.STORAGE_IN_MEMORY:i?S.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:v.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const a=(0,C.join)(this.y.workspaceStorageHome.fsPath,this.v.id),i=(0,C.join)(a,E.t);return await m.Promises.exists(a)?{storageFilePath:i,wasCreated:!1}:(await m.Promises.mkdir(a,{recursive:!0}),this.D(a),{storageFilePath:i,wasCreated:!0})}async D(a){let i;if((0,w.isSingleFolderWorkspaceIdentifier)(this.v)?i={folder:this.v.uri.toString()}:(0,w.isWorkspaceIdentifier)(this.v)&&(i={workspace:this.v.configPath.toString()}),i)try{const n=(0,C.join)(a,E.u);await m.Promises.exists(n)||await m.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.WorkspaceStorageMain=E,E.t="state.vscdb",E.u="workspace.json";class R extends c{get path(){}async n(){return new S.Storage(new S.InMemoryStorageDatabase,{hint:S.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=R}),define(te[268],ie([0,1,3,2,94]),function(V,e,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class o extends L.Disposable{constructor(P,h,m){super(),this.b=P,this.c=h,this.f=m;const S=this.B(new L.MutableDisposable);this.a=this.B(new I.Emitter({onWillAddFirstListener:()=>S.value=this.g(),onDidRemoveLastListener:()=>S.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new L.DisposableStore;return P.add(I.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(h,m)=>(h?h.push(m.key):h=[m.key],h),100)(h=>this.h(h))),P.add(I.Event.debounce(this.b.onDidChangeProfileStorage,(h,m)=>{h||(h=new Map);let S=h.get(m.profile.id);return S||h.set(m.profile.id,S={profile:m.profile,keys:[],storage:m.storage}),S.keys.push(m.key),h},100)(h=>this.i(h))),P}h(P){const h=P.includes(k.TARGET_KEY)?[this.c.defaultProfile]:[],m=[];if(P=P.filter(S=>S!==k.TARGET_KEY),P.length){const S=(0,k.loadKeyTargets)(this.b.applicationStorage.storage);m.push({profile:this.c.defaultProfile,changes:P.map(v=>({key:v,scope:0,target:S[v]}))})}this.j(h,m)}i(P){const h=[],m=new Map;for(const[S,v]of P.entries()){v.keys.includes(k.TARGET_KEY)&&h.push(v.profile);const b=v.keys.filter(f=>f!==k.TARGET_KEY);if(b.length){const f=(0,k.loadKeyTargets)(v.storage.storage);m.set(S,{profile:v.profile,changes:b.map(p=>({key:p,scope:0,target:f[p]}))})}}this.j(h,[...m.values()])}j(P,h){(P.length||h.length)&&this.a.fire({valueChanges:h,targetChanges:P})}listen(P,h,m){switch(h){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${h}`)}async call(P,h){throw new Error(`Call not found: ${h}`)}}e.ProfileStorageChangesListenerChannel=o}),define(te[269],ie([0,1,72,7,33,16,5,234,40,37]),function(V,e,I,L,k,o,C,P,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.ServerUserDataProfilesService=void 0;let S=class extends m.UserDataProfilesService{constructor(f,p,w,c){super(p,w,f,c),this.a=p}L(){return this.r.extUri.joinPath(L.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};S=ve([ee(0,h.IUriIdentityService),ee(1,k.INativeEnvironmentService),ee(2,o.IFileService),ee(3,C.ILogService)],S),e.ServerUserDataProfilesService=S;let v=class Tt extends S{constructor(f,p,w,c,u){super(p,w,c,u),this.N=f}G(){return(0,I.revive)(this.N.getItem(Tt.b,[]))}I(){return(0,I.revive)(this.N.getItem(Tt.c,{}))}L(){return this.r.extUri.joinPath(L.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};v=ve([ee(0,P.IStateService),ee(1,h.IUriIdentityService),ee(2,k.INativeEnvironmentService),ee(3,o.IFileService),ee(4,C.ILogService)],v),e.UserDataProfilesService=v}),define(te[52],ie([0,1,7,33,16,6,5,34,40,37,269]),function(V,e,I,L,k,o,C,P,h,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,o.refineServiceDecorator)(m.IUserDataProfilesService);let v=class lt extends S.UserDataProfilesService{constructor(f,p,w,c,u){super(f,p,w,c,u),this.R=f}setEnablement(f){super.setEnablement(f),this.f||(this.H([]),this.J({}))}getAssociatedEmptyWindows(){const f=[];for(const p of this.u.emptyWindows.keys())f.push({id:p});return f}H(f){f.length?this.R.setItem(lt.b,f):this.R.removeItem(lt.b)}J(f){f.emptyWindows||f.workspaces?this.R.setItem(lt.c,f):this.R.removeItem(lt.c)}I(){const f="workspaceAndProfileInfo",p=this.R.getItem(f,void 0);if(p){this.R.removeItem(f);const w=p.reduce((c,{workspace:u,profile:g})=>(c[I.URI.revive(u).toString()]=I.URI.revive(g).toString(),c),{});this.R.setItem(lt.c,{workspaces:w})}return super.I()}};v=ve([ee(0,P.IStateMainService),ee(1,h.IUriIdentityService),ee(2,L.INativeEnvironmentService),ee(3,k.IFileService),ee(4,C.ILogService)],v),e.UserDataProfilesMainService=v}),define(te[95],ie([0,1,7,49,3,2,33,16,6,21,5,94,267,37,52,40]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,h.createDecorator)("storageMainService");let c=class extends o.Disposable{constructor(D,E,R,t,a,i){super(),this.c=D,this.f=E,this.g=R,this.h=t,this.i=a,this.j=i,this.a=void 0,this.b=this.B(new k.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(D=>{D.window.profile&&this.profileStorage(D.window.profile).init(),D.workspace&&this.workspaceStorage(D.workspace).init()})),this.B(this.h.onWillShutdown(D=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=D.reason,D.join(this.applicationStorage.close());for(const[,E]of this.n)D.join(E.close());for(const[,E]of this.r)D.join(E.close())})),this.B(this.g.onWillCreateProfile(D=>{D.join((async()=>{await this.i.exists(D.profile.globalStorageHome)||await this.i.createFolder(D.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(D=>{const E=this.n.get(D.profile.id);E&&D.join(E.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const D=new b.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,L.once)(D.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),D}profileStorage(D){if((0,v.isProfileUsingDefaultStorage)(D))return this.applicationStorage;let E=this.n.get(D.id);if(!E){this.c.trace(`StorageMainService: creating profile storage (${D.name})`),E=this.p(D),this.n.set(D.id,E);const R=this.B(E.onDidChangeStorage(t=>this.b.fire({...t,storage:E,profile:D})));(0,L.once)(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${D.name})`),this.n.delete(D.id),R.dispose()})}return E}p(D){return this.a===2?new b.InMemoryStorageMain(this.c,this.i):new b.ProfileStorageMain(D,this.k(),this.c,this.i)}workspaceStorage(D){let E=this.r.get(D.id);return E||(this.c.trace(`StorageMainService: creating workspace storage (${D.id})`),E=this.s(D),this.r.set(D.id,E),(0,L.once)(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${D.id})`),this.r.delete(D.id)})),E}s(D){return this.a===2?new b.InMemoryStorageMain(this.c,this.i):new b.WorkspaceStorageMain(D,this.k(),this.c,this.f,this.i)}isUsed(D){const E=I.URI.file(D);for(const R of[this.applicationStorage,...this.n.values(),...this.r.values()])if(!!R.path&&this.j.extUri.isEqualOrParent(I.URI.file(R.path),E))return!0;return!1}};c=ve([ee(0,S.ILogService),ee(1,C.IEnvironmentService),ee(2,p.IUserDataProfilesMainService),ee(3,m.ILifecycleMainService),ee(4,P.IFileService),ee(5,w.IUriIdentityService)],c),e.StorageMainService=c,e.IApplicationStorageMainService=(0,h.createDecorator)("applicationStorageMainService");let u=class extends v.AbstractStorageService{constructor(D,E){super(),this.p=D,this.s=E,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(D){if(D===-1)return this.s.applicationStorage.storage}M(D){if(D===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};u=ve([ee(0,f.IUserDataProfilesService),ee(1,e.IStorageMainService)],u),e.ApplicationStorageMainService=u}),define(te[270],ie([0,1,2,21,52,29,8,30]),function(V,e,I,L,k,o,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let h=class extends I.Disposable{constructor(S,v,b){super(),this.a=v,this.b=b,this.B(S.onWillLoadWindow(f=>{f.reason===2&&this.c(f.window)})),this.B(S.onBeforeCloseWindow(f=>this.c(f))),this.B(new C.RunOnceScheduler(()=>this.g(),30*1e3)).schedule()}async c(S){const v=this.f(S),b=this.a.getProfileForWorkspace(v);b&&((0,o.isEmptyWorkspaceIdentifier)(v)||b.isTransient)&&(this.a.unsetWorkspace(v,b.isTransient),b.isTransient&&await this.a.cleanUpTransientProfiles())}f(S){return S.openedWorkspace??(0,o.toWorkspaceIdentifier)(S.backupPath,S.isExtensionDevelopmentHost)}g(){const S=this.a.getAssociatedEmptyWindows();if(S.length===0)return;const v=this.b.getWindows().map(b=>this.f(b));for(const b of S)v.some(f=>f.id===b.id)||this.a.unsetWorkspace(b,!1)}};h=ve([ee(0,L.ILifecycleMainService),ee(1,k.IUserDataProfilesMainService),ee(2,P.IWindowsMainService)],h),e.UserDataProfilesHandler=h}),define(te[120],ie([0,1,20,7,29]),function(V,e,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function o(h,m,S){for(const b of h){const f=b.openedWorkspace;if((0,k.isWorkspaceIdentifier)(f)){const p=await S(f);if(p){if(p.folders.some(w=>I.extUriBiasedIgnorePathCase.isEqualOrParent(m,w.uri)))return b}else if(I.extUriBiasedIgnorePathCase.isEqualOrParent(m,f.configPath))return b}}const v=h.filter(b=>(0,k.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqualOrParent(m,b.openedWorkspace.uri));if(v.length)return v.sort((b,f)=>-(b.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=o;function C(h,m){for(const S of h)if((0,k.isWorkspaceIdentifier)(S.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(S.openedWorkspace.configPath,m)||(0,k.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(S.openedWorkspace.uri,m))return S}e.findWindowOnWorkspaceOrFolder=C;function P(h,m){const S=v=>m.some(b=>I.extUriBiasedIgnorePathCase.isEqual(L.URI.file(b),L.URI.file(v)));for(const v of h)if(v.config?.extensionDevelopmentPath?.some(b=>S(b)))return v}e.findWindowOnExtensionDevelopmentPath=P}),define(te[271],ie([0,1,14,2,4,20,7,18,21,5,34,30,118,29]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let p=class Ft extends L.Disposable{get state(){return this.b}constructor(E,R,t,a,i){super(),this.g=E,this.h=R,this.i=t,this.j=a,this.k=i,this.b=w(this.h.getItem(Ft.a)),this.c=void 0,this.f=!1,this.l()}l(){I.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(E=>this.p(E)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(E=>{E.newCount-E.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(E=>this.p(E))}m(){this.f=!0,this.n()}n(){const E=new Set,R={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!R.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(R.lastActiveWindow=this.r(i),R.lastActiveWindow.uiState.mode===3&&E.add(R.lastActiveWindow.uiState.display))}const t=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);t&&(R.lastPluginDevelopmentHostWindow=this.r(t),R.lastPluginDevelopmentHostWindow.uiState.mode===3&&(E.has(R.lastPluginDevelopmentHostWindow.uiState.display)?k.isMacintosh&&!t.win?.isSimpleFullScreen()&&(R.lastPluginDevelopmentHostWindow.uiState.mode=1):E.add(R.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(R.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.r(i);return n.uiState.mode===3&&(E.has(n.uiState.display)?k.isMacintosh&&n.windowId!==R.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):E.add(n.uiState.display)),n}));const a=u(R);this.h.setItem(Ft.a,a),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",a)}p(E){if(this.i.quitRequested)return;const R=this.r(E);E.isExtensionDevelopmentHost&&!E.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=R:!E.isExtensionDevelopmentHost&&E.openedWorkspace&&this.b.openedWindows.forEach(t=>{const a=(0,f.isWorkspaceIdentifier)(E.openedWorkspace)&&t.workspace?.id===E.openedWorkspace.id,i=(0,f.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&t.folderUri&&o.extUriBiasedIgnorePathCase.isEqual(t.folderUri,E.openedWorkspace.uri);(a||i)&&(t.uiState=R.uiState)}),this.g.getWindowCount()===1&&(this.c=R)}r(E){return{windowId:E.id,workspace:(0,f.isWorkspaceIdentifier)(E.openedWorkspace)?E.openedWorkspace:void 0,folderUri:(0,f.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)?E.openedWorkspace.uri:void 0,backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.serializeWindowState()}}getNewWindowState(E){const R=this.s(E),t=this.k.getValue("window");if(R.mode===3){let a;R.hasDefaultState?a=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):a=!!(this.i.wasRestarted||t?.restoreFullscreen),a||(R.mode=1)}return R}s(E){const R=this.g.getLastActiveWindow();if(!E.extensionTestsPath){if(!!E.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const l=E.workspace;if((0,f.isWorkspaceIdentifier)(l)){const d=this.state.openedWindows.filter(y=>y.workspace&&y.workspace.id===l.id).map(y=>y.uiState);if(d.length)return d[0]}if((0,f.isSingleFolderWorkspaceIdentifier)(l)){const d=this.state.openedWindows.filter(y=>y.folderUri&&o.extUriBiasedIgnorePathCase.isEqual(y.folderUri,l.uri)).map(y=>y.uiState);if(d.length)return d[0]}else if(E.backupPath){const d=this.state.openedWindows.filter(y=>y.backupPath===E.backupPath).map(y=>y.uiState);if(d.length)return d[0]}const s=this.c||this.state.lastActiveWindow;if(!R&&s)return s.uiState}let t;const a=I.screen.getAllDisplays();if(a.length===1)t=a[0];else{if(k.isMacintosh){const l=I.screen.getCursorScreenPoint();t=I.screen.getDisplayNearestPoint(l)}!t&&R&&(t=I.screen.getDisplayMatching(R.getBounds())),t||(t=I.screen.getPrimaryDisplay()||a[0])}let i=(0,b.defaultWindowState)();i.x=Math.round(t.bounds.x+t.bounds.width/2-i.width/2),i.y=Math.round(t.bounds.y+t.bounds.height/2-i.height/2);const n=this.k.getValue("window");let r=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,r=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,r=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&R){const l=R.serializeWindowState();l.mode===3?i.mode=3:i=l,r=i.mode!==3&&n.newWindowDimensions==="offset"}}return r&&(i=this.t(i)),i.hasDefaultState=!0,i}t(E){if(this.g.getWindows().length===0)return E;E.x=typeof E.x=="number"?E.x:0,E.y=typeof E.y=="number"?E.y:0;const R=this.g.getWindows().map(t=>t.getBounds());for(;R.some(t=>t.x===E.x||t.y===E.y);)E.x+=30,E.y+=30;return E}};p.a="windowsState",p=ve([ee(0,v.IWindowsMainService),ee(1,S.IStateMainService),ee(2,h.ILifecycleMainService),ee(3,m.ILogService),ee(4,P.IConfigurationService)],p),e.WindowsStateHandler=p;function w(D){const E={openedWindows:[]},R=D||{openedWindows:[]};return R.lastActiveWindow&&(E.lastActiveWindow=c(R.lastActiveWindow)),R.lastPluginDevelopmentHostWindow&&(E.lastPluginDevelopmentHostWindow=c(R.lastPluginDevelopmentHostWindow)),Array.isArray(R.openedWindows)&&(E.openedWindows=R.openedWindows.map(t=>c(t))),E}e.restoreWindowsState=w;function c(D){const E={uiState:D.uiState};return D.backupPath&&(E.backupPath=D.backupPath),D.remoteAuthority&&(E.remoteAuthority=D.remoteAuthority),D.folder&&(E.folderUri=C.URI.parse(D.folder)),D.workspaceIdentifier&&(E.workspace={id:D.workspaceIdentifier.id,configPath:C.URI.parse(D.workspaceIdentifier.configURIPath)}),E}function u(D){return{lastActiveWindow:D.lastActiveWindow&&g(D.lastActiveWindow),lastPluginDevelopmentHostWindow:D.lastPluginDevelopmentHostWindow&&g(D.lastPluginDevelopmentHostWindow),openedWindows:D.openedWindows.map(E=>g(E))}}e.getWindowsStateStoreData=u;function g(D){return{workspaceIdentifier:D.workspace&&{id:D.workspace.id,configURIPath:D.workspace.configPath.toString()},folder:D.folderUri&&D.folderUri.toString(),backupPath:D.backupPath,remoteAuthority:D.remoteAuthority,uiState:D.uiState}}}),define(te[96],ie([0,1,32,43,125,36,15,9,4,20,7,6,55,29]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,v.createDecorator)("workspacesService");function p(y){return y.hasOwnProperty("workspace")}e.isRecentWorkspace=p;function w(y){return y.hasOwnProperty("folderUri")}e.isRecentFolder=w;function c(y){return y.hasOwnProperty("fileUri")}e.isRecentFile=c;function u(y){return g(y)||D(y)}e.isStoredWorkspaceFolder=u;function g(y){const M=y;return typeof M?.path=="string"&&(!M.name||typeof M.name=="string")}function D(y){const M=y;return typeof M?.uri=="string"&&(!M.name||typeof M.name=="string")}function E(y,M,O,j,K){if(y.scheme!==j.scheme)return{name:O,uri:y.toString(!0)};let x=M?void 0:K.relativePath(j,y);if(x!==void 0)x.length===0?x=".":h.isWindows&&(x=R(x));else if(y.scheme===C.Schemas.file)x=y.fsPath,h.isWindows&&(x=R(x));else if(K.isEqualAuthority(y.authority,j.authority))x=y.path;else return{name:O,uri:y.toString(!0)};return{name:O,path:x}}e.getStoredWorkspaceFolder=E;function R(y){return y=(0,o.normalizeDriveLetter)(y),(0,I.isUNC)(y)||(y=(0,I.toSlashes)(y)),y}function t(y,M,O){const j=[],K=new Set,x=O.dirname(M);for(const J of y){let re;if(g(J))J.path&&(re=O.resolvePath(x,J.path));else if(D(J))try{re=S.URI.parse(J.uri),re.path[0]!==P.posix.sep&&(re=re.with({path:P.posix.sep+re.path}))}catch(se){console.warn(se)}if(re){const se=O.getComparisonKey(re);if(!K.has(se)){K.add(se);const ae=J.name||O.basenameOrAuthority(re);j.push(new f.WorkspaceFolder({uri:re,name:ae,index:j.length},J))}}}return j}e.toWorkspaceFolders=t;function a(y,M,O,j,K){const x=i(M,y),J=K.dirname(M),re=K.dirname(j),se=[];for(const H of x.folders){const F=g(H)?K.resolvePath(J,H.path):S.URI.parse(H.uri);let U;O?U=!1:U=!g(H)||(0,P.isAbsolute)(H.path),se.push(E(F,U,H.name,re,K))}const ae={insertSpaces:!1,tabSize:4,eol:h.isLinux||h.isMacintosh?`
`:`\r
`},fe=k.setProperty(y,["folders"],se,ae);let ge=k.applyEdits(y,fe);return(0,m.isEqualAuthority)(x.remoteAuthority,(0,b.getRemoteAuthority)(j))&&(ge=k.applyEdits(ge,k.removeProperty(ge,["remoteAuthority"],ae))),ge}e.rewriteWorkspaceFileForNewLocation=a;function i(y,M){const O=L.parse(M);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter(j=>u(j));else throw new Error(`${y} looks like an invalid workspace file.`);return O}function n(y){return y.workspace&&typeof y.workspace=="object"&&typeof y.workspace.id=="string"&&typeof y.workspace.configPath=="string"}function r(y){return typeof y.folderUri=="string"}function l(y){return typeof y.fileUri=="string"}function s(y,M){const O={workspaces:[],files:[]};if(y){const j=function(x,J){for(let re=0;re<x.length;re++)try{J(x[re],re)}catch(se){M.warn(`Error restoring recent entry ${JSON.stringify(x[re])}: ${se.toString()}. Skip entry.`)}},K=y;Array.isArray(K.entries)&&j(K.entries,x=>{const J=x.label,re=x.remoteAuthority;n(x)?O.workspaces.push({label:J,remoteAuthority:re,workspace:{id:x.workspace.id,configPath:S.URI.parse(x.workspace.configPath)}}):r(x)?O.workspaces.push({label:J,remoteAuthority:re,folderUri:S.URI.parse(x.folderUri)}):l(x)&&O.files.push({label:J,remoteAuthority:re,fileUri:S.URI.parse(x.fileUri)})})}return O}e.restoreRecentlyOpened=s;function d(y){const M={entries:[]};for(const O of y.workspaces)w(O)?M.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):M.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of y.files)M.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return M}e.toStoreData=d}),define(te[97],ie([0,1,80,15,4,20]),function(V,e,I,L,k,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function C(m){function S(){let v=m.scheme===L.Schemas.file?(0,o.originalFSPath)(m):m.toString();return k.isLinux||(v=v.toLowerCase()),(0,I.createHash)("md5").update(v).digest("hex")}return{id:S(),configPath:m}}e.getWorkspaceIdentifier=C;function P(m,S){function v(){if(m.scheme!==L.Schemas.file)return(0,I.createHash)("md5").update(m.toString()).digest("hex");if(!S)return;let f;return k.isLinux?f=S.ino:k.isMacintosh?f=S.birthtime.getTime():k.isWindows&&(typeof S.birthtimeMs=="number"?f=Math.floor(S.birthtimeMs):f=S.birthtime.getTime()),(0,I.createHash)("md5").update(m.fsPath).update(f?String(f):"").digest("hex")}const b=v();if(typeof b=="string")return{id:b,uri:m}}e.getSingleFolderWorkspaceIdentifier=P;function h(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=h}),define(te[272],ie([0,1,80,32,15,9,4,20,23,181,18,28,34,16,5,180,29,97]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f,p,w,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let g=class Wt{constructor(E,R,t,a){this.j=E,this.k=R,this.l=t,this.m=a,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.extUriBiasedIgnorePathCase,this.i={isEqual:(i,n)=>(0,L.isEqual)(i,n,!C.isLinux)}}async initialize(){const E=this.m.getItem(Wt.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(E.emptyWindows),this.d=await this.u((0,m.deserializeWorkspaceInfos)(E)),this.e=await this.v((0,m.deserializeFolderInfos)(E)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==f.HotExitConfiguration.OFF}q(){return this.s()===f.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||f.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(E,R){this.d.some(a=>E.workspace.id===a.workspace.id)||(this.d.push(E),this.C());const t=(0,o.join)(this.c,E.workspace.id);return R?this.t(t,R).then(()=>t):t}async t(E,R){if(await h.Promises.exists(E)&&await this.z(E),await h.Promises.exists(R))try{await h.Promises.rename(R,E)}catch(t){this.l.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(E){return this.e.some(R=>this.h.isEqual(E.folderUri,R.folderUri))||(this.e.push(E),this.C()),(0,o.join)(this.c,this.D(E))}registerEmptyWindowBackup(E){return this.g.some(R=>!!R.backupFolder&&this.i.isEqual(R.backupFolder,E.backupFolder))||(this.g.push(E),this.C()),(0,o.join)(this.c,E.backupFolder)}async u(E){if(!Array.isArray(E))return[];const R=new Set,t=[];for(const a of E){const i=a.workspace;if(!(0,c.isWorkspaceIdentifier)(i))return[];if(!R.has(i.id)){R.add(i.id);const n=(0,o.join)(this.c,i.id);await this.B(n)?i.configPath.scheme!==k.Schemas.file||await h.Promises.exists(i.configPath.fsPath)?t.push(a):await this.z(n):await this.x(n)}}return t}async v(E){if(!Array.isArray(E))return[];const R=[],t=new Set;for(const a of E){const i=a.folderUri,n=this.h.getComparisonKey(i);if(!t.has(n)){t.add(n);const r=(0,o.join)(this.c,this.D(a));await this.B(r)?i.scheme!==k.Schemas.file||await h.Promises.exists(i.fsPath)?R.push(a):await this.z(r):await this.x(r)}}return R}async w(E){if(!Array.isArray(E))return[];const R=[],t=new Set;for(const a of E){const i=a.backupFolder;if(typeof i!="string")return[];if(!t.has(i)){t.add(i);const n=(0,o.join)(this.c,i);await this.B(n)?R.push(a):await this.x(n)}}return R}async x(E){try{await h.Promises.rm(E,h.RimRafMode.MOVE)}catch(R){this.l.error(`Backup: Could not delete stale backup: ${R.toString()}`)}}y(){let E=(0,u.createEmptyWorkspaceIdentifier)();for(;this.g.some(R=>!!R.backupFolder&&this.i.isEqual(R.backupFolder,E.id));)E=(0,u.createEmptyWorkspaceIdentifier)();return{backupFolder:E.id}}async z(E){const R=this.y(),t=(0,o.join)(this.c,R.backupFolder);try{await h.Promises.rename(E,t)}catch(a){return this.l.error(`Backup: Could not rename backup folder: ${a.toString()}`),!1}return this.g.push(R),!0}async getDirtyWorkspaces(){const E=[];for(const R of this.d)await this.A(R)&&E.push(R);for(const R of this.e)await this.A(R)&&E.push(R);return E}A(E){let R;return(0,m.isEmptyWindowBackupInfo)(E)?R=(0,o.join)(this.c,E.backupFolder):(0,w.isFolderBackupInfo)(E)?R=(0,o.join)(this.c,this.D(E)):R=(0,o.join)(this.c,E.workspace.id),this.B(R)}async B(E){try{const R=await h.Promises.readdir(E);for(const t of R)try{if((await h.Promises.readdir((0,o.join)(E,t))).length>0)return!0}catch{}}catch{}return!1}C(){const E={workspaces:this.d.map(({workspace:R,remoteAuthority:t})=>{const a={id:R.id,configURIPath:R.configPath.toString()};return t&&(a.remoteAuthority=t),a}),folders:this.e.map(({folderUri:R,remoteAuthority:t})=>{const a={folderUri:R.toString()};return t&&(a.remoteAuthority=t),a}),emptyWindows:this.g.map(({backupFolder:R,remoteAuthority:t})=>{const a={backupFolder:R};return t&&(a.remoteAuthority=t),a})};this.m.setItem(Wt.a,E)}D(E){const R=E.folderUri;let t;return R.scheme===k.Schemas.file?t=C.isLinux?R.fsPath:R.fsPath.toLowerCase():t=R.toString().toLowerCase(),(0,I.createHash)("md5").update(t).digest("hex")}};g.a="backupWorkspaces",g=ve([ee(0,v.IEnvironmentMainService),ee(1,S.IConfigurationService),ee(2,p.ILogService),ee(3,b.IStateMainService)],g),e.BackupMainService=g}),define(te[53],ie([0,1,14,3,43,36,2,15,9,20,10,23,179,62,57,28,6,5,19,52,120,29,96,97]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f,p,w,c,u,g,D,E,R,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,c.createDecorator)("workspacesManagementMainService");let i=class extends C.Disposable{constructor(r,l,s,d,y,M){super(),this.g=r,this.h=l,this.i=s,this.j=d,this.k=y,this.l=M,this.a=this.B(new L.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new L.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const r=(await v.Promises.readdir(this.c.fsPath)).map(l=>(0,m.joinPath)(this.c,l,R.UNTITLED_WORKSPACE_NAME));for(const l of r){const s=(0,a.getWorkspaceIdentifier)(l),d=await this.resolveLocalWorkspace(l);d?this.f.push({workspace:s,remoteAuthority:d.remoteAuthority}):await this.deleteUntitledWorkspace(s)}}catch(r){r.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${r}).`)}}resolveLocalWorkspace(r){return this.m(r,l=>v.Promises.readFile(l,"utf8"))}m(r,l){if(!!this.n(r)&&r.scheme===P.Schemas.file)try{const s=l(r.fsPath);return s instanceof Promise?s.then(d=>this.p(r,d),d=>{}):this.p(r,s)}catch{return}}n(r){return(0,R.isUntitledWorkspace)(r,this.g)||(0,R.hasWorkspaceFileExtension)(r)}p(r,l){try{const s=this.r(r,l),d=(0,a.getWorkspaceIdentifier)(r);return{id:d.id,configPath:d.configPath,folders:(0,t.toWorkspaceFolders)(s.folders,d.configPath,m.extUriBiasedIgnorePathCase),remoteAuthority:s.remoteAuthority,transient:s.transient}}catch(s){this.h.warn(s.toString())}}r(r,l){const s=(0,k.parse)(l);if(s&&Array.isArray(s.folders))s.folders=s.folders.filter(d=>(0,t.isStoredWorkspaceFolder)(d));else throw new Error(`${r.toString(!0)} looks like an invalid workspace file.`);return s}async createUntitledWorkspace(r,l){const{workspace:s,storedWorkspace:d}=this.s(r,l),y=s.configPath.fsPath;return await v.Promises.mkdir((0,h.dirname)(y),{recursive:!0}),await v.Promises.writeFile(y,JSON.stringify(d,null,"	")),this.f.push({workspace:s,remoteAuthority:l}),s}s(r=[],l){const s=(Date.now()+Math.round(Math.random()*1e3)).toString(),d=(0,m.joinPath)(this.c,s),y=(0,m.joinPath)(d,R.UNTITLED_WORKSPACE_NAME),M=[];for(const O of r)M.push((0,t.getStoredWorkspaceFolder)(O.uri,!0,O.name,d,m.extUriBiasedIgnorePathCase));return{workspace:(0,a.getWorkspaceIdentifier)(y),storedWorkspace:{folders:M,remoteAuthority:l}}}async getWorkspaceIdentifier(r){return(0,a.getWorkspaceIdentifier)(r)}isUntitledWorkspace(r){return(0,R.isUntitledWorkspace)(r.configPath,this.g)}async deleteUntitledWorkspace(r){!this.isUntitledWorkspace(r)||(await this.t(r),this.i.isEnabled()&&this.i.unsetWorkspace(r),this.a.fire(r))}async t(r){const l=(0,m.originalFSPath)(r.configPath);try{await v.Promises.rm((0,h.dirname)(l));const s=(0,h.join)(this.g.workspaceStorageHome.fsPath,r.id);await v.Promises.exists(s)&&await v.Promises.writeFile((0,h.join)(s,"obsolete"),""),this.f=this.f.filter(d=>d.workspace.id!==r.id)}catch(s){this.h.warn(`Unable to delete untitled workspace ${l} (${s}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(r,l,s){if(!r||!r.win||!r.isReady||!await this.u(r,l,s))return;const y=await this.v(r,(0,a.getWorkspaceIdentifier)(s));if(!!y)return this.b.fire({window:r,workspace:y.workspace}),y}async u(r,l,s){if(!s)return!0;if((0,R.isWorkspaceIdentifier)(r.openedWorkspace)&&m.extUriBiasedIgnorePathCase.isEqual(r.openedWorkspace.configPath,s))return!1;if((0,E.findWindowOnWorkspaceOrFolder)(l,s)){const d={title:this.l.nameLong,type:"info",buttons:[(0,o.mnemonicButtonLabel)((0,b.localize)(0,null))],message:(0,b.localize)(1,null,(0,m.basename)(s)),detail:(0,b.localize)(2,null),noLink:!0,defaultId:0};return await this.k.showMessageBox(d,(0,S.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow())),!1}return!0}async v(r,l){if(!r.config)return;r.focus();let s;return r.config.extensionDevelopmentPath||(r.config.backupPath?s=await this.j.registerWorkspaceBackup({workspace:l,remoteAuthority:r.remoteAuthority},r.config.backupPath):s=this.j.registerWorkspaceBackup({workspace:l,remoteAuthority:r.remoteAuthority})),(0,R.isWorkspaceIdentifier)(r.openedWorkspace)&&this.isUntitledWorkspace(r.openedWorkspace)&&await this.deleteUntitledWorkspace(r.openedWorkspace),r.config.workspace=l,r.config.backupPath=s,{workspace:l,backupPath:s}}};i=ve([ee(0,w.IEnvironmentMainService),ee(1,u.ILogService),ee(2,D.IUserDataProfilesMainService),ee(3,f.IBackupMainService),ee(4,p.IDialogMainService),ee(5,g.IProductService)],i),e.WorkspacesManagementMainService=i}),define(te[121],ie([0,1,14,42,22,6,30,29,53,10,5]),function(V,e,I,L,k,o,C,P,h,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,o.createDecorator)(e.ID);let v=class{constructor(f,p,w){this.a=f,this.b=p,this.c=w}async getRemoteDiagnostics(f){const p=this.a.getWindows();return(await Promise.all(p.map(async c=>{const u=c.remoteAuthority;if(!u)return;const g=`vscode:getDiagnosticInfoResponse${c.id}`,D={includeProcesses:f.includeProcesses,folders:f.includeWorkspaceMetadata?await this.f(c):void 0};return new Promise(E=>{c.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:g,args:D}),L.validatedIpcMain.once(g,(R,t)=>{t||E({hostName:u,errorMessage:`Unable to resolve connection to '${u}'.`}),E(t)}),setTimeout(()=>{E({hostName:u,errorMessage:`Connection to '${u}' could not be established`})},5e3)})}))).filter(c=>!!c)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const f=[];for(const p of I.BrowserWindow.getAllWindows()){const w=this.a.getWindowById(p.id);w?f.push(await this.d(w)):f.push(this.e(p))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:f,screenReader:!!I.app.accessibilitySupportEnabled,gpuFeatureStatus:I.app.getGPUFeatureStatus()}}async d(f){const p=await this.f(f),w=(0,m.assertIsDefined)(f.win);return this.e(w,p,f.remoteAuthority)}e(f,p=[],w){return{pid:f.webContents.getOSProcessId(),title:f.getTitle(),folderURIs:p,remoteAuthority:w}}async f(f){const p=[],w=f.openedWorkspace;if((0,P.isSingleFolderWorkspaceIdentifier)(w))p.push(w.uri);else if((0,P.isWorkspaceIdentifier)(w)){const c=await this.b.resolveLocalWorkspace(w.configPath);c&&c.folders.forEach(g=>{p.push(g.uri)})}return p}};v=ve([ee(0,C.IWindowsMainService),ee(1,h.IWorkspacesManagementMainService),ee(2,S.ILogService)],v),e.DiagnosticsMainService=v}),define(te[58],ie([0,1,46,14,26,145,54,3,36,2,15,9,4,7,102,84,23,99,169,57,28,6,21,5,19,68,30,29,53,17,228,221,34]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f,p,w,c,u,g,D,E,R,t,a,i,n,r,l,s,d,y,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,R.createDecorator)("nativeHostMainService");let j=class extends m.Disposable{constructor(x,J,re,se,ae,fe,ge,H,F,U){super(),this.a=x,this.b=J,this.c=re,this.f=se,this.g=ae,this.h=fe,this.i=ge,this.j=H,this.k=F,this.l=U,this.onDidOpenWindow=P.Event.map(this.b.onDidOpenWindow,z=>z.id),this.onDidTriggerSystemContextMenu=P.Event.filter(P.Event.map(this.b.onDidTriggerSystemContextMenu,({window:z,x:Y,y:ne})=>({windowId:z.id,x:Y,y:ne})),({windowId:z})=>!!this.b.getWindowById(z)),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(z,Y)=>Y.id),z=>!!this.b.getWindowById(z)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(z,Y)=>Y.id),z=>!!this.b.getWindowById(z)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(z,Y)=>Y.id),z=>!!this.b.getWindowById(z)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.b.onDidChangeWindowsCount,()=>this.b.getLastActiveWindow()),z=>!!z),z=>z.id),P.Event.filter(P.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(z,Y)=>Y.id),z=>!!this.b.getWindowById(z))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.m=this.B(new P.Emitter),this.onDidChangePassword=this.m.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(z,Y,ne)=>ne),z=>!(Array.isArray(z)&&z.length===1&&z[0]==="workArea")),P.Event.fromNodeEventEmitter(L.screen,"display-added"),P.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.b.getWindows().map(J=>({id:J.id,workspace:J.openedWorkspace??(0,l.toWorkspaceIdentifier)(J.backupPath,J.isExtensionDevelopmentHost),title:J.win?.getTitle()??"",filename:J.getRepresentedFilename(),dirty:J.isDocumentEdited()}))}async getWindowCount(x){return this.b.getWindowCount()}async getActiveWindowId(x){const J=L.BrowserWindow.getFocusedWindow()||this.b.getLastActiveWindow();if(J)return J.id}openWindow(x,J,re){return Array.isArray(J)?this.n(x,J,re):this.p(x,J)}async n(x,J,re=Object.create(null)){J.length>0&&await this.b.open({context:5,contextWindowId:x,urisToOpen:J,cli:this.g.args,forceNewWindow:re.forceNewWindow,forceReuseWindow:re.forceReuseWindow,preferNewWindow:re.preferNewWindow,diffMode:re.diffMode,mergeMode:re.mergeMode,addMode:re.addMode,gotoLineMode:re.gotoLineMode,noRecentEntry:re.noRecentEntry,waitMarkerFileURI:re.waitMarkerFileURI,remoteAuthority:re.remoteAuthority||void 0,forceProfile:re.forceProfile,forceTempProfile:re.forceTempProfile})}async p(x,J){await this.b.openEmptyWindow({context:5,contextWindowId:x},J)}async toggleFullScreen(x){this.w(x)?.toggleFullScreen()}async handleTitleDoubleClick(x){this.w(x)?.handleTitleDoubleClick()}async isMaximized(x){const J=this.w(x);return J?.win?J.win.isMaximized():!1}async maximizeWindow(x){const J=this.w(x);J?.win&&J.win.maximize()}async unmaximizeWindow(x){const J=this.w(x);J?.win&&J.win.unmaximize()}async minimizeWindow(x){const J=this.w(x);J?.win&&J.win.minimize()}async updateWindowControls(x,J){const re=this.w(x);re&&re.updateWindowControls(J)}async focusWindow(x,J){J&&typeof J.windowId=="number"&&(x=J.windowId),this.w(x)?.focus({force:J?.force??!1})}async setMinimumSize(x,J,re){const se=this.w(x);if(se?.win){const[ae,fe]=se.win.getSize(),[ge,H]=se.win.getMinimumSize(),[F,U]=[J??ge,re??H],[z,Y]=[Math.max(ae,F),Math.max(fe,U)];(ge!==F||H!==U)&&se.win.setMinimumSize(F,U),(ae!==z||fe!==Y)&&se.win.setSize(z,Y)}}async saveWindowSplash(x,J){this.j.saveWindowSplash(x,J)}async installShellCommand(x){const{source:J,target:re}=await this.r();try{const{symbolicLink:se}=await c.SymlinkSupport.stat(J);if(se&&!se.dangling){const ae=await(0,p.realpath)(J);if(re===ae)return}await c.Promises.unlink(J)}catch(se){if(se.code!=="ENOENT")throw se}try{await c.Promises.symlink(re,J)}catch(se){if(se.code!=="EACCES"&&se.code!=="ENOENT")throw se;const{response:ae}=await this.showMessageBox(x,{title:this.i.nameLong,type:"info",message:(0,g.localize)(0,null,this.i.nameShort),buttons:[(0,h.mnemonicButtonLabel)((0,g.localize)(1,null)),(0,h.mnemonicButtonLabel)((0,g.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ae===0)try{const fe=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${re}' '${J}'\\" with administrator privileges"`;await(0,o.promisify)(I.exec)(fe)}catch{throw new Error((0,g.localize)(3,null,J))}}}async uninstallShellCommand(x){const{source:J}=await this.r();try{await c.Promises.unlink(J)}catch(re){switch(re.code){case"EACCES":{const{response:se}=await this.showMessageBox(x,{title:this.i.nameLong,type:"info",message:(0,g.localize)(4,null,this.i.nameShort),buttons:[(0,h.mnemonicButtonLabel)((0,g.localize)(5,null)),(0,h.mnemonicButtonLabel)((0,g.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const ae=`osascript -e "do shell script \\"rm '${J}'\\" with administrator privileges"`;await(0,o.promisify)(I.exec)(ae)}catch{throw new Error((0,g.localize)(7,null,J))}break}case"ENOENT":break;default:throw re}}}async r(){const x=(0,v.resolve)(this.g.appRoot,"bin","code"),J=`/usr/local/bin/${this.i.applicationName}`;if(!await c.Promises.exists(x))throw new Error((0,g.localize)(8,null,x));return{source:J,target:x}}async showMessageBox(x,J){return this.c.showMessageBox(J,this.s(x))}async showSaveDialog(x,J){return this.c.showSaveDialog(J,this.s(x))}async showOpenDialog(x,J){return this.c.showOpenDialog(J,this.s(x))}s(x){const J=this.w(x);if(J?.win)return J.win}async pickFileFolderAndOpen(x,J){const re=await this.c.pickFileFolder(J);re&&await this.t(await Promise.all(re.map(async se=>await c.SymlinkSupport.existsDirectory(se)?{folderUri:f.URI.file(se)}:{fileUri:f.URI.file(se)})),J,x)}async pickFolderAndOpen(x,J){const re=await this.c.pickFolder(J);re&&await this.t(re.map(se=>({folderUri:f.URI.file(se)})),J,x)}async pickFileAndOpen(x,J){const re=await this.c.pickFile(J);re&&await this.t(re.map(se=>({fileUri:f.URI.file(se)})),J,x)}async pickWorkspaceAndOpen(x,J){const re=await this.c.pickWorkspace(J);re&&await this.t(re.map(se=>({workspaceUri:f.URI.file(se)})),J,x)}async t(x,J,re){await this.b.open({context:3,contextWindowId:re,cli:this.g.args,urisToOpen:x,forceNewWindow:J.forceNewWindow})}async showItemInFolder(x,J){L.shell.showItemInFolder(J)}async setRepresentedFilename(x,J){this.w(x)?.setRepresentedFilename(J)}async setDocumentEdited(x,J){this.w(x)?.setDocumentEdited(J)}async openExternal(x,J){return b.isLinuxSnap?this.u(J):L.shell.openExternal(J),!0}u(x){const J=process.env.GDK_PIXBUF_MODULE_FILE,re=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(x),process.env.GDK_PIXBUF_MODULE_FILE=J,process.env.GDK_PIXBUF_MODULEDIR=re}moveItemToTrash(x,J){return L.shell.trashItem(J)}async isAdmin(){let x;return b.isWindows?x=(await new Promise((J,re)=>{V(["native-is-elevated"],J,re)}))():x=process.getuid()===0,x}async writeElevated(x,J,re,se){const ae=await new Promise((fe,ge)=>{V(["@vscode/sudo-prompt"],fe,ge)});return new Promise((fe,ge)=>{const H=[`"${this.v}"`];se?.unlock&&H.push("--file-chmod"),H.push("--file-write",`"${J.fsPath}"`,`"${re.fsPath}"`);const F={name:this.i.nameLong.replace("-",""),icns:b.isMacintosh&&this.g.isBuilt?(0,v.join)((0,v.dirname)(this.g.appRoot),`${this.i.nameShort}.icns`):void 0};ae.exec(H.join(" "),F,(U,z,Y)=>{z&&this.h.trace(`[sudo-prompt] received stdout: ${z}`),Y&&this.h.trace(`[sudo-prompt] received stderr: ${Y}`),U?ge(U):fe(void 0)})})}get v(){return b.isWindows?this.g.isBuilt?(0,v.join)((0,v.dirname)(process.execPath),"bin",`${this.i.applicationName}.cmd`):(0,v.join)(this.g.appRoot,"scripts","code-cli.bat"):b.isLinux?this.g.isBuilt?(0,v.join)((0,v.dirname)(process.execPath),"bin",`${this.i.applicationName}`):(0,v.join)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,v.join)(this.g.appRoot,"bin","code"):(0,v.join)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return w.virtualMachineHint.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return b.isWindows&&(0,y.hasWSLFeatureInstalled)()}async killProcess(x,J,re){process.kill(J,re)}async readClipboardText(x,J){return L.clipboard.readText(J)}async writeClipboardText(x,J,re){return L.clipboard.writeText(J,re)}async readClipboardFindText(x){return L.clipboard.readFindText()}async writeClipboardFindText(x,J){return L.clipboard.writeFindText(J)}async writeClipboardBuffer(x,J,re,se){return L.clipboard.writeBuffer(J,Buffer.from(re.buffer),se)}async readClipboardBuffer(x,J){return d.VSBuffer.wrap(L.clipboard.readBuffer(J))}async hasClipboard(x,J,re){return L.clipboard.has(J,re)}async newWindowTab(){await this.b.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(x,J){this.w(x)?.updateTouchBar(J)}async notifyReady(x){this.w(x)?.setReady()}async relaunch(x,J){return this.f.relaunch(J)}async reload(x,J){const re=this.w(x);if(re){if((0,l.isWorkspaceIdentifier)(re.openedWorkspace)){const se=re.openedWorkspace.configPath;if(se.scheme===S.Schemas.file&&(await this.l.resolveLocalWorkspace(se))?.transient)return this.openWindow(re.id,{forceReuseWindow:!0})}return this.f.reload(re,J?.disableExtensions!==void 0?{_:[],"disable-extensions":J.disableExtensions}:void 0)}}async closeWindow(x){this.closeWindowById(x,x)}async closeWindowById(x,J){const re=this.w(J);if(re?.win)return re.win.close()}async quit(x){const J=this.b.getLastActiveWindow();J?.isExtensionDevelopmentHost&&this.b.getWindowCount()>1&&J.win?J.win.close():this.f.quit()}async exit(x,J){await this.f.kill(J)}async resolveProxy(x,J){const se=this.w(x)?.win?.webContents?.session;if(se)return se.resolveProxy(J)}findFreePort(x,J,re,se,ae=1){return(0,u.findFreePort)(J,re,se,ae)}async openDevTools(x,J){const re=this.w(x);re?.win&&re.win.webContents.openDevTools(J)}async toggleDevTools(x){const J=this.w(x);J?.win&&J.win.webContents.toggleDevTools()}async sendInputEvent(x,J){const re=this.w(x);re?.win&&(J.type==="mouseDown"||J.type==="mouseUp")&&re.win.webContents.sendInputEvent(J)}async enableSandbox(x,J){J?this.k.setItem("window.experimental.useSandbox",!0):this.k.removeItem("window.experimental.useSandbox")}async toggleSharedProcessWindow(){return this.a.toggle()}async profileRenderer(x,J,re){const se=this.w(x);if(!se||!se.win)throw new Error;return await new M.WindowProfiler(se.win,J,this.h).inspect(re)}async windowsGetStringRegKey(x,J,re,se){if(!b.isWindows)return;const ae=await new Promise((fe,ge)=>{V(["@vscode/windows-registry"],fe,ge)});try{return ae.GetStringRegKey(J,re,se)}catch{return}}w(x){if(typeof x=="number")return this.b.getWindowById(x)}};ve([C.memoize],j.prototype,"v",null),j=ve([ee(1,r.IWindowsMainService),ee(2,D.IDialogMainService),ee(3,t.ILifecycleMainService),ee(4,E.IEnvironmentMainService),ee(5,a.ILogService),ee(6,i.IProductService),ee(7,n.IThemeMainService),ee(8,O.IStateMainService),ee(9,s.IWorkspacesManagementMainService)],j),e.NativeHostMainService=j}),define(te[273],ie([0,1,14,42,26,36,2,15,4,103,167,87,121,57,28,6,5,58,65,19,66,76,32,10,34]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f,p,w,c,u,g,D,E,R,t,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,w.createDecorator)("issueMainService");const n="issue.processExplorerWindowState";let r=class $t{constructor(d,y,M,O,j,K,x,J,re,se){this.g=d,this.h=y,this.i=M,this.j=O,this.k=j,this.l=K,this.m=x,this.n=J,this.o=re,this.p=se,this.b=null,this.c=null,this.d=null,this.f=null,this.q()}q(){L.validatedIpcMain.on("vscode:issueSystemInfoRequest",async d=>{const[y,M]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),O=await this.j.getSystemInfo(y,M);this.r(d,"vscode:issueSystemInfoResponse",O)}),L.validatedIpcMain.on("vscode:listProcesses",async d=>{const y=[];try{y.push({name:(0,S.localize)(0,null),rootProcess:await(0,m.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(O=>{(0,v.isRemoteDiagnosticError)(O)?y.push({name:O.hostName,rootProcess:O}):O.processes&&y.push({name:O.hostName,rootProcess:O.processes})})}catch(M){this.i.error(`Listing processes failed: ${M}`)}this.r(d,"vscode:listProcessesResponse",y)}),L.validatedIpcMain.on("vscode:issueReporterClipboard",async d=>{const y={title:this.o.nameLong,message:(0,S.localize)(1,null),type:"warning",buttons:[(0,o.mnemonicButtonLabel)((0,S.localize)(2,null)),(0,o.mnemonicButtonLabel)((0,S.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.b){const M=await this.l.showMessageBox(y,this.b);this.r(d,"vscode:issueReporterClipboardResponse",M.response===0)}}),L.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async d=>{const y=await this.v();this.r(d,"vscode:issuePerformanceInfoResponse",y)}),L.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const d={title:this.o.nameLong,message:(0,S.localize)(4,null),type:"warning",buttons:[(0,o.mnemonicButtonLabel)((0,S.localize)(5,null)),(0,o.mnemonicButtonLabel)((0,S.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.b&&(await this.l.showMessageBox(d,this.b)).response===0&&this.b&&(this.b.destroy(),this.b=null)}),L.validatedIpcMain.on("vscode:workbenchCommand",(d,y)=>{const{id:M,from:O,args:j}=y;let K;switch(O){case"issueReporter":K=this.c;break;case"processExplorer":K=this.f;break;default:throw new Error(`Unexpected command source: ${O}`)}K?.webContents.send("vscode:runAction",{id:M,from:O,args:j})}),L.validatedIpcMain.on("vscode:openExternal",(d,y)=>{this.m.openExternal(void 0,y)}),L.validatedIpcMain.on("vscode:closeIssueReporter",d=>{this.b?.close()}),L.validatedIpcMain.on("vscode:closeProcessExplorer",d=>{this.d?.close()}),L.validatedIpcMain.on("vscode:windowsInfoRequest",async d=>{const y=await this.k.getMainDiagnostics();this.r(d,"vscode:windowsInfoResponse",y.windows)})}r(d,y,...M){d.sender.isDestroyed()||d.sender.send(y,...M)}async openReporter(d){if(!this.b&&(this.c=I.BrowserWindow.getFocusedWindow(),this.c)){const y=new C.DisposableStore,M=y.add(this.n.createIPCObjectUrl()),O=this.u(this.c,700,800);this.b=this.t(O,M,{backgroundColor:d.styles.backgroundColor,title:(0,S.localize)(7,null),zoomLevel:d.zoomLevel,alwaysOnTop:!1},"issue-reporter"),M.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:d,disableExtensions:!!this.h.disableExtensions,os:{type:(0,k.type)(),arch:(0,k.arch)(),release:(0,k.release)()},product:g.default}),this.b.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,y.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,y.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(d){if(!this.d&&(this.f=I.BrowserWindow.getFocusedWindow(),this.f)){const y=new C.DisposableStore,M=y.add(this.n.createIPCObjectUrl()),O=this.p.getItem(n,void 0),j=l(O)?O:this.u(this.f,800,500),K=I.screen.getDisplayNearestPoint({x:j.x,y:j.y});j.width/=K.scaleFactor,j.height/=K.scaleFactor,this.d=this.t(j,M,{backgroundColor:d.styles.backgroundColor,title:(0,S.localize)(8,null),zoomLevel:d.zoomLevel,alwaysOnTop:!0},"process-explorer"),M.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:d,product:g.default}),this.d.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,y.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,y.dispose())});const x=()=>{if(!this.d)return;const J=this.d.getSize(),re=this.d.getPosition();if(!J||!re)return;const se={width:J[0],height:J[1],x:re[0],y:re[1]};this.p.setItem(n,se)};this.d.on("moved",x),this.d.on("resized",x)}this.d&&this.s(this.d)}s(d){d.isMinimized()&&d.restore(),d.focus()}t(d,y,M,O){const j=new I.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:d.width,height:d.height,minWidth:300,minHeight:200,x:d.x,y:d.y,title:M.title,backgroundColor:M.backgroundColor||$t.a,webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${y.resource.toString()}`,`--vscode-window-kind=${O}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,R.zoomLevelToZoomFactor)(M.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:M.alwaysOnTop,experimentalDarkMode:!0});return j.setMenuBarVisibility(!1),j}async getSystemStatus(){const[d,y]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(d,y)}u(d,y,M){let O;const j=I.screen.getAllDisplays();if(j.length===1)O=j[0];else{if(h.isMacintosh){const J=I.screen.getCursorScreenPoint();O=I.screen.getDisplayNearestPoint(J)}!O&&d&&(O=I.screen.getDisplayMatching(d.getBounds())),O||(O=I.screen.getPrimaryDisplay()||j[0])}const K=O.bounds,x={width:y,height:M,x:K.x+K.width/2-y/2,y:K.y+K.height/2-M/2};return K.width>0&&K.height>0&&(x.x<K.x&&(x.x=K.x),x.y<K.y&&(x.y=K.y),x.x>K.x+K.width&&(x.x=K.x),x.y>K.y+K.height&&(x.y=K.y),x.width>K.width&&(x.width=K.width),x.height>K.height&&(x.height=K.height)),x}async v(){try{const[d,y]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(d,y)}catch(d){throw this.i.warn("issueService#getPerformanceInfo ",d.message),d}}async stopTracing(){if(!this.h.args.trace)return;const d=await I.contentTracing.stopRecording(`${(0,t.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({title:this.o.nameLong,type:"info",message:(0,S.localize)(9,null),detail:(0,S.localize)(10,null,d),buttons:[(0,o.mnemonicButtonLabel)((0,S.localize)(11,null))],defaultId:0,noLink:!0},(0,a.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,d)}};r.a="#1E1E1E",r=ve([ee(1,p.IEnvironmentMainService),ee(2,c.ILogService),ee(3,v.IDiagnosticsService),ee(4,b.IDiagnosticsMainService),ee(5,f.IDialogMainService),ee(6,u.INativeHostMainService),ee(7,E.IProtocolMainService),ee(8,D.IProductService),ee(9,i.IStateMainService)],r),e.IssueMainService=r;function l(s){return typeof s!="object"||s===null?!1:"x"in s&&"y"in s&&"width"in s&&"height"in s}}),define(te[274],ie([0,1,22,18,28,21,5,58,19,56,24,48,93]),function(V,e,I,L,k,o,C,P,h,m,S,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let f=class extends b.AbstractUpdateService{constructor(w,c,u,g,D,E,R,t){super(w,c,g,D,E,t),this.e=u,this.u=R}s(w){return(0,b.createUpdateURL)(`linux-${process.arch}`,w,this.k)}t(w){!this.a||(this.d(v.State.CheckingForUpdates(w)),this.i.request({url:this.a},I.CancellationToken.None).then(m.asJson).then(c=>{!c||!c.url||!c.version||!c.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!w}),this.d(v.State.Idle(1))):this.d(v.State.AvailableForDownload(c))}).then(void 0,c=>{this.j.error(c),this.e.publicLog2("update:notAvailable",{explicit:!!w});const u=w?c.message||c:void 0;this.d(v.State.Idle(1,u))}))}async o(w){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):w.update.url&&this.u.openExternal(void 0,w.update.url),this.d(v.State.Idle(1))}};f=ve([ee(0,o.ILifecycleMainService),ee(1,L.IConfigurationService),ee(2,S.ITelemetryService),ee(3,k.IEnvironmentMainService),ee(4,m.IRequestService),ee(5,C.ILogService),ee(6,P.INativeHostMainService),ee(7,h.IProductService)],f),e.LinuxUpdateService=f}),define(te[275],ie([0,1,46,41,26,8,22,54,9,7,131,23,18,28,16,21,5,58,19,56,24,48,93]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f,p,w,c,u,g,D,E,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function a(l,s=1e3){for(;!l();)await(0,o.timeout)(s)}let i;function n(){return typeof i>"u"&&(i=L.existsSync(h.join(h.dirname(process.execPath),"unins000.exe"))?0:1),i}let r=class extends t.AbstractUpdateService{get cachePath(){const s=h.join((0,k.tmpdir)(),`vscode-update-${this.k.target}-${process.arch}`);return v.Promises.mkdir(s,{recursive:!0}).then(()=>s)}constructor(s,d,y,M,O,j,K,x,J){super(s,d,M,O,j,J),this.u=y,this.v=K,this.w=x}async initialize(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}s(s){let d="win32";return process.arch!=="ia32"&&(d+=`-${process.arch}`),n()===1?d+="-archive":this.k.target==="user"&&(d+="-user"),(0,t.createUpdateURL)(d,s,this.k)}t(s){!this.a||(this.d(R.State.CheckingForUpdates(s)),this.i.request({url:this.a},C.CancellationToken.None).then(D.asJson).then(d=>{const y=n();return!d||!d.url||!d.version||!d.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!s}),this.d(R.State.Idle(y)),Promise.resolve(null)):y===1?(this.d(R.State.AvailableForDownload(d)),Promise.resolve(null)):(this.d(R.State.Downloading(d)),this.B(d.version).then(()=>this.A(d.version).then(M=>v.Promises.exists(M).then(O=>{if(O)return Promise.resolve(M);const j=d.url,K=d.hash,x=`${M}.tmp`;return this.i.request({url:j},C.CancellationToken.None).then(J=>this.v.writeFile(m.URI.file(x),J.stream)).then(K?()=>(0,S.checksum)(x,d.hash):()=>{}).then(()=>v.Promises.rename(x,M)).then(()=>M)})).then(M=>{const O=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:M},O&&d.supportsFastUpdate?this.k.target==="user"?this.p():this.d(R.State.Downloaded(d)):this.d(R.State.Ready(d))})))}).then(void 0,d=>{this.j.error(d),this.u.publicLog2("update:notAvailable",{explicit:!!s});const y=s?d.message||d:void 0;this.d(R.State.Idle(n(),y))}))}async o(s){s.update.url&&this.w.openExternal(void 0,s.update.url),this.d(R.State.Idle(n()))}async A(s){const d=await this.cachePath;return h.join(d,`CodeSetup-${this.k.quality}-${s}.exe`)}async B(s=null){const d=s?j=>!new RegExp(`${this.k.quality}-${s}\\.exe$`).test(j):()=>!0,y=await this.cachePath,O=(await v.Promises.readdir(y)).filter(d).map(async j=>{try{await v.Promises.unlink(h.join(y,j))}catch{}});await Promise.all(O)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const s=this.state.update;this.d(R.State.Updating(s));const d=await this.cachePath;this.e.updateFilePath=h.join(d,`CodeSetup-${this.k.quality}-${s.version}.flag`),await v.Promises.writeFile(this.e.updateFilePath,"flag"),(0,I.spawn)(this.e.packagePath,["/verysilent",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(R.State.Idle(n()))});const M=`${this.k.win32MutexName}-ready`,O=await new Promise((j,K)=>{V(["windows-mutex"],j,K)});a(()=>O.isActive(M)).then(()=>this.d(R.State.Ready(s)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?L.unlinkSync(this.e.updateFilePath):(0,I.spawn)(this.e.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return n()}async _applySpecificUpdate(s){if(this.state.type!=="idle")return;const d=this.g.getValue("update.enableWindowsBackgroundUpdates"),y={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!d};this.d(R.State.Downloading(y)),this.e={packagePath:s},d?this.k.target==="user"?this.p():this.d(R.State.Downloaded(y)):this.d(R.State.Ready(y))}};ve([P.memoize],r.prototype,"cachePath",null),r=ve([ee(0,w.ILifecycleMainService),ee(1,b.IConfigurationService),ee(2,E.ITelemetryService),ee(3,f.IEnvironmentMainService),ee(4,D.IRequestService),ee(5,c.ILogService),ee(6,p.IFileService),ee(7,u.INativeHostMainService),ee(8,g.IProductService)],r),e.Win32UpdateService=r}),define(te[276],ie([0,1,14,8,22,45,3,36,2,15,9,63,4,7,175,62,18,57,28,61,16,21,5,19,66,239,95,24,130,68,76,30,29,53,118,122,39,34,52,58,241,114,51,92,26,115,64]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f,p,w,c,u,g,D,E,R,t,a,i,n,r,l,s,d,y,M,O,j,K,x,J,re,se,ae,fe,ge,H,F,U,z,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var ne;(function($){$[$.NONE=0]="NONE",$[$.NAVIGATING=1]="NAVIGATING",$[$.READY=2]="READY"})(ne||(ne={}));let _=class ut extends h.Disposable{get id(){return this.k}get win(){return this.l}get lastFocusTime(){return this.m}get backupPath(){return this.n?.backupPath}get openedWorkspace(){return this.n?.workspace}get profile(){if(!this.config)return;const A=this.P.profiles.find(T=>T.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&A?A:this.P.getProfileForWorkspace(this.config.workspace??(0,O.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.P.defaultProfile}get remoteAuthority(){return this.n?.remoteAuthority}get config(){return this.n}get isExtensionDevelopmentHost(){return!!this.n?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.n?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.n?.debugId}constructor(A,T,W,B,G,N,q,Q,oe,ue,ye,ke,Ae,Re,Fe,we,pe,Se,Z,ce,de){super(),this.L=T,this.M=W,this.N=B,this.O=G,this.P=N,this.Q=q,this.R=Q,this.S=oe,this.U=ue,this.W=ye,this.X=ke,this.Y=Ae,this.Z=Re,this.ab=Fe,this.bb=we,this.db=pe,this.eb=Se,this.fb=Z,this.gb=ce,this.hb=de,this.c=this.B(new C.Emitter),this.onWillLoad=this.c.event,this.f=this.B(new C.Emitter),this.onDidSignalReady=this.f.event,this.g=this.B(new C.Emitter),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.B(new C.Emitter),this.onDidClose=this.h.event,this.j=this.B(new C.Emitter),this.onDidDestroy=this.j.event,this.m=-1,this.t=void 0,this.u=void 0,this.z=!1,this.C=[],this.D=[],this.F=void 0,this.G=void 0,this.H=this.B(this.eb.createIPCObjectUrl()),this.J=!1,this.ib=0;{const[Ee,Ce]=this.tb(A.state);this.r=Ee,this.L.trace("window#ctor: using window state",Ee);const Le=this.r.mode===0||this.r.mode===3;typeof ut.b>"u"&&(ut.b=this.gb.getItem("window.experimental.useSandbox",!1));const Te=this.U.getValue("window");let He=!1;typeof Te?.experimental?.useSandbox=="boolean"?He=Te.experimental.useSandbox:this.db.quality==="stable"&&ut.b?He=!0:He=typeof this.db.quality=="string"&&this.db.quality!=="stable";const je={width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y,backgroundColor:this.W.getBackgroundColor(),minWidth:y.WindowMinimumSize.WIDTH,minHeight:y.WindowMinimumSize.HEIGHT,show:!Le,title:this.db.nameLong,webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.H.resource.toString()}`],v8CacheOptions:this.N.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,y.zoomLevelToZoomFactor)(Te?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...He?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};b.isLinux?je.icon=(0,S.join)(this.N.appRoot,"resources/linux/code.png"):b.isWindows&&!this.N.isBuilt&&(je.icon=(0,S.join)(this.N.appRoot,"resources/win32/code_150x150.png")),b.isMacintosh&&!this.Ab()&&(je.fullscreenable=!1),b.isMacintosh&&(je.acceptFirstMouse=!0,Te?.clickThroughInactive===!1&&(je.acceptFirstMouse=!1));const ze=b.isMacintosh&&Te?.nativeTabs===!0;ze&&(je.tabbingIdentifier=this.db.nameShort);const xe=(0,y.getTitleBarStyle)(this.U)==="custom";if(xe&&(je.titleBarStyle="hidden",b.isMacintosh||(je.frame=!1),(0,y.useWindowControlsOverlay)(this.U))){const Ne=this.W.getWindowSplash()?.colorInfo.titleBarBackground??this.W.getBackgroundColor(),Ve=x.Color.fromHex(Ne).isDarker()?"#FFFFFF":"#000000";je.titleBarOverlay={height:29,color:Ne,symbolColor:Ve},this.z=!0}if((0,v.mark)("code/willCreateCodeBrowserWindow"),this.l=new I.BrowserWindow(je),(0,v.mark)("code/didCreateCodeBrowserWindow"),this.k=this.l.id,b.isMacintosh&&xe&&this.l.setSheetOffset(22),xe&&(b.isWindows&&(0,y.useWindowControlsOverlay)(this.U)||b.isMacintosh)){const Ne=this.gb.getItem(ut.a);Ne&&this.updateWindowControls({height:Ne})}b.isWindows&&xe&&this.l.hookWindowMessage(278,()=>{const[Ve,X]=this.l.getPosition(),le=I.screen.getCursorScreenPoint(),he=le.x-Ve,me=le.y-X;return(()=>!(he>30&&me>=0&&me<=Math.max(this.l.getBounds().height*.15,35)))()||(this.l.setEnabled(!1),this.l.setEnabled(!0),this.g.fire({x:he,y:me})),0}),(b.isMacintosh||b.isWindows)&&Ce&&(!ze||I.BrowserWindow.getAllWindows().length===1)&&[this.r.width,this.r.height,this.r.x,this.r.y].every(Ne=>typeof Ne=="number")&&this.l.setBounds({width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y}),Le&&((0,v.mark)("code/willMaximizeCodeWindow"),this.l.maximize(),this.r.mode===3&&this.wb(!0),this.l.show(),(0,v.mark)("code/didMaximizeCodeWindow")),this.m=Date.now()}this.N.args["open-devtools"]===!0&&this.l.webContents.openDevTools(),this.qb(),this.Eb(),this.jb()}setRepresentedFilename(A){b.isMacintosh?this.l.setRepresentedFilename(A):this.v=A}getRepresentedFilename(){return b.isMacintosh?this.l.getRepresentedFilename():this.v}setDocumentEdited(A){b.isMacintosh&&this.l.setDocumentEdited(A),this.w=A}isDocumentEdited(){return b.isMacintosh?this.l.isDocumentEdited():!!this.w}focus(A){b.isMacintosh&&A?.force&&I.app.focus({steal:!0}),this.l&&(this.l.isMinimized()&&this.l.restore(),this.l.focus())}setReady(){for(this.L.trace(`window#load: window reported ready (id: ${this.k})`),this.ib=2;this.C.length;)this.C.pop()(this);this.f.fire()}ready(){return new Promise(A=>{if(this.isReady)return A(this);this.C.push(A)})}get isReady(){return this.ib===2}get whenClosedOrLoaded(){return new Promise(A=>{function T(){W.dispose(),B.dispose(),A()}const W=this.onDidClose(()=>T()),B=this.onWillLoad(()=>T())})}jb(){this.l.on("unresponsive",()=>this.mb(1)),this.l.webContents.on("render-process-gone",(T,W)=>this.mb(2,W)),this.l.webContents.on("did-fail-load",(T,W,B)=>this.mb(3,{reason:B,exitCode:W})),this.l.webContents.on("will-prevent-unload",T=>{T.preventDefault()}),this.l.on("closed",()=>{this.h.fire(),this.dispose()}),this.l.webContents.on("did-finish-load",()=>{this.I&&(this.n=this.I,this.I=void 0)}),this.l.on("focus",()=>{this.m=Date.now()}),this.l.on("maximize",T=>{this.n&&(this.n.maximized=!0),I.app.emit("browser-window-maximize",T,this.l)}),this.l.on("unmaximize",T=>{this.n&&(this.n.maximized=!1),I.app.emit("browser-window-unmaximize",T,this.l)}),this.l.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.l.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.B(this.U.onDidChangeConfiguration(T=>this.qb(T))),this.B(this.X.onDidDeleteUntitledWorkspace(T=>this.pb(T)));const A=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.l.webContents.session.webRequest.onBeforeSendHeaders({urls:A},async(T,W)=>{const B=await this.lb();W({cancel:!1,requestHeaders:Object.assign(T.requestHeaders,B)})})}lb(){return this.kb||(this.kb=(0,n.resolveMarketplaceHeaders)(this.db.version,this.db,this.N,this.U,this.Q,this.R,this.Z)),this.kb}async mb(A,T){switch(A){case 2:this.L.error(`CodeWindow: renderer process gone (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break;case 1:this.L.error("CodeWindow: detected unresponsive");break;case 3:this.L.error(`CodeWindow: failed to load (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break}switch(this.Z.publicLog2("windowerror",{type:A,reason:T?.reason,code:T?.exitCode}),A){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.bb.kill(1);return}if(this.N.args["enable-smoke-test-driver"]){await this.ob(!1,!1),this.bb.quit();return}if(A===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.l&&this.l.webContents&&this.l.webContents.isDevToolsOpened())return;const W=await this.ab.showMessageBox({title:this.db.nameLong,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,p.localize)(0,null)),(0,P.mnemonicButtonLabel)((0,p.localize)(1,null)),(0,P.mnemonicButtonLabel)((0,p.localize)(2,null))],message:(0,p.localize)(3,null),detail:(0,p.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this.n?.workspace?(0,p.localize)(5,null):void 0},this.l);if(W.response!==1){const B=W.response===0;await this.ob(B,W.checkboxChecked)}}else if(A===2)if(b.isWindows&&T?.reason==="launch-failed"&&T.exitCode===18&&await this.hb.isAdmin(void 0))await this.nb(T);else{let W;T?W=(0,p.localize)(7,null,T.reason,T.exitCode??"<unknown>"):W=(0,p.localize)(6,null);const B=await this.ab.showMessageBox({title:this.db.nameLong,type:"warning",buttons:[this.n?.workspace?(0,P.mnemonicButtonLabel)((0,p.localize)(8,null)):(0,P.mnemonicButtonLabel)((0,p.localize)(9,null)),(0,P.mnemonicButtonLabel)((0,p.localize)(10,null))],message:W,detail:this.n?.workspace?(0,p.localize)(11,null):(0,p.localize)(12,null),noLink:!0,defaultId:0,checkboxLabel:this.n?.workspace?(0,p.localize)(13,null):void 0},this.l),G=B.response===0;await this.ob(G,B.checkboxChecked)}break}}async nb(A){const T=[],W=(0,H.isInternalTelemetry)(this.db,this.U);if((0,H.supportsTelemetry)(this.db,this.N)){this.db.aiConfig&&this.db.aiConfig.ariaKey&&T.push(new fe.OneDataSystemAppender(W,"monacoworkbench",null,this.db.aiConfig.ariaKey));const{installSourcePath:G}=this.N,N=await(0,z.resolveMachineId)(this.gb),q={appenders:T,sendErrorTelemetry:!1,commonProperties:(0,F.resolveCommonProperties)(this.Q,(0,U.release)(),(0,U.hostname)(),process.arch,this.db.commit,this.db.version,N,W,G),piiPaths:(0,H.getPiiPathsFromEnvironment)(this.N)};await new ge.TelemetryService(q,this.U,this.db).publicLog2("windowadminerror",{reason:A.reason,code:A.exitCode})}(await this.ab.showMessageBox({title:this.db.nameLong,type:"error",buttons:[(0,P.mnemonicButtonLabel)((0,p.localize)(14,null)),(0,P.mnemonicButtonLabel)((0,p.localize)(15,null))],message:(0,p.localize)(16,null),detail:(0,p.localize)(17,null,this.db.nameLong),noLink:!0,defaultId:0},this.l)).response===0&&await this.hb.openExternal(void 0,"https://go.microsoft.com/fwlink/?linkid=2220179"),await Promise.all(T.map(G=>G.flush())),await this.ob(!1,!1)}async ob(A,T){const W=this.n?.workspace;if(T&&W)try{const B=this.S.workspaceStorage(W);await B.init(),B.delete("memento/workbench.parts.editor"),await B.close()}catch(B){this.L.error(B)}if(this.j.fire(),this.l?.destroy(),A&&this.n){let B,G;(0,O.isSingleFolderWorkspaceIdentifier)(W)?B={folderUri:W.uri}:(0,O.isWorkspaceIdentifier)(W)?B={workspaceUri:W.configPath}:G=!0;const[N]=await this.fb.open({context:5,userEnv:this.n.userEnv,cli:{...this.N.args,_:[]},urisToOpen:B?[B]:void 0,forceEmpty:G,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});N.focus()}}pb(A){this.n?.workspace?.id===A.id&&(this.n.workspace=void 0)}qb(A){const T=this.Bb();if(T!==this.s&&(this.s=T,this.Cb(T)),!A||A.affectsConfiguration("http.proxy")){let W=(this.U.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;W?.endsWith("/")&&(W=W.substr(0,W.length-1));const B=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((W||"").indexOf("@")===-1&&(W!==this.F||B!==this.G)){this.F=W,this.G=B;const G=W||"",N=B?`${B},<local>`:"<local>";this.L.trace(`Setting proxy to '${G}', bypassing '${N}'`),this.l.webContents.session.setProxy({proxyRules:G,proxyBypassRules:N,pacScript:""})}}}addTabbedWindow(A){b.isMacintosh&&A.win&&this.l.addTabbedWindow(A.win)}load(A,T=Object.create(null)){this.L.trace(`window#load: attempt to load window (id: ${this.k})`),this.isDocumentEdited()&&(!T.isReload||!this.Y.isHotExitEnabled())&&this.setDocumentEdited(!1),T.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.l.setTitle(this.db.nameLong)),this.rb(A,T),this.ib===0?this.n=A:this.I=A,this.ib=1,this.l.loadURL(m.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.N.isBuilt?"":"-dev"}.html`).toString(!0));const W=this.J;this.J=!0,!this.N.isBuilt&&!this.N.extensionTestsLocationURI&&this.B(new L.RunOnceScheduler(()=>{this.l&&!this.l.isVisible()&&!this.l.isMinimized()&&(this.l.show(),this.focus({force:!0}),this.l.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:A.workspace,reason:T.isReload?3:W?2:1})}rb(A,T){const W=(this.n??this.I)?.userEnv;if(W){const B=(0,D.isLaunchedFromCli)(W)&&!(0,D.isLaunchedFromCli)(A.userEnv),G=this.isExtensionDevelopmentHost;(B||G)&&(A.userEnv={...W,...A.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(A.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),T.disableExtensions!==void 0&&(A["disable-extensions"]=T.disableExtensions),A.fullscreen=this.isFullScreen,A.maximized=this.l.isMaximized(),A.partsSplash=this.W.getWindowSplash(),(0,v.mark)("code/willOpenNewWindow"),A.perfMarks=(0,v.getMarks)(),this.H.update(A)}async reload(A){const T=Object.assign({},this.n);T.workspace=await this.sb(T),delete T.filesToOpenOrCreate,delete T.filesToDiff,delete T.filesToMerge,delete T.filesToWait,this.isExtensionDevelopmentHost&&A&&(T.verbose=A.verbose,T.debugId=A.debugId,T.extensionEnvironment=A.extensionEnvironment,T["inspect-extensions"]=A["inspect-extensions"],T["inspect-brk-extensions"]=A["inspect-brk-extensions"],T["extensions-dir"]=A["extensions-dir"]),T.accessibilitySupport=I.app.isAccessibilitySupportEnabled(),T.isInitialStartup=!1,T.policiesData=this.O.serialize(),T.continueOn=this.N.continueOn,T.profiles={all:this.P.profiles,profile:this.profile||this.P.defaultProfile},T.logLevel=this.L.getLevel(),T.loggers=this.M.getRegisteredLoggers(this.id),this.load(T,{isReload:!0,disableExtensions:A?.["disable-extensions"]})}async sb(A){if((0,O.isWorkspaceIdentifier)(A.workspace)){const T=A.workspace.configPath;if(T.scheme===m.Schemas.file&&!await this.Q.exists(T))return}else if((0,O.isSingleFolderWorkspaceIdentifier)(A.workspace)){const T=A.workspace.uri;if(T.scheme===m.Schemas.file&&!await this.Q.exists(T))return}return A.workspace}serializeWindowState(){if(!this.l)return(0,K.defaultWindowState)();if(this.isFullScreen){let W;try{W=I.screen.getDisplayMatching(this.getBounds())}catch{}const B=(0,K.defaultWindowState)();return{mode:3,display:W?W.id:void 0,width:this.r.width||B.width,height:this.r.height||B.height,x:this.r.x||0,y:this.r.y||0}}const A=Object.create(null);let T;if(!b.isMacintosh&&this.l.isMaximized()?T=0:T=1,T===0?A.mode=0:A.mode=1,T===1||T===0){let W;T===1?W=this.getBounds():W=this.l.getNormalBounds(),A.x=W.x,A.y=W.y,A.width=W.width,A.height=W.height}return A}updateWindowControls(A){if(A.height&&this.gb.setItem(ut.a,A.height),b.isWindows&&this.z)this.l.setTitleBarOverlay({color:A.backgroundColor?.trim()===""?void 0:A.backgroundColor,symbolColor:A.foregroundColor?.trim()===""?void 0:A.foregroundColor,height:A.height?A.height-1:void 0});else if(b.isMacintosh&&A.height!==void 0){const T=(A.height-15)/2;this.l.setTrafficLightPosition({x:T,y:T})}}tb(A){(0,v.mark)("code/willRestoreCodeWindowState");let T=!1;if(A)try{const W=I.screen.getAllDisplays();T=W.length>1,A=this.ub(A,W)}catch(W){this.L.warn(`Unexpected error validating window state: ${W}
${W.stack}`)}return(0,v.mark)("code/didRestoreCodeWindowState"),[A||(0,K.defaultWindowState)(),T]}ub(A,T){if(this.L.trace(`window#validateWindowState: validating window state on ${T.length} display(s)`,A),typeof A.x!="number"||typeof A.y!="number"||typeof A.width!="number"||typeof A.height!="number"){this.L.trace("window#validateWindowState: unexpected type of state values");return}if(A.width<=0||A.height<=0){this.L.trace("window#validateWindowState: unexpected negative values");return}if(T.length===1){const G=this.vb(T[0]);if(G){let N=function(){!A||typeof A.x!="number"||typeof A.y!="number"||!G||(A.x<G.x&&(A.x=G.x),A.y<G.y&&(A.y=G.y))};this.L.trace("window#validateWindowState: 1 monitor working area",G),N(),A.width>G.width&&(A.width=G.width),A.height>G.height&&(A.height=G.height),A.x>G.x+G.width-128&&(A.x=G.x+G.width-A.width),A.y>G.y+G.height-128&&(A.y=G.y+G.height-A.height),N()}return A}if(A.display&&A.mode===3){const G=T.find(N=>N.id===A.display);if(G&&typeof G.bounds?.x=="number"&&typeof G.bounds?.y=="number"){this.L.trace("window#validateWindowState: restoring fullscreen to previous display");const N=(0,K.defaultWindowState)(3);return N.x=G.bounds.x,N.y=G.bounds.y,N}}let W,B;try{W=I.screen.getDisplayMatching({x:A.x,y:A.y,width:A.width,height:A.height}),B=this.vb(W)}catch{}if(W&&B&&A.x+A.width>B.x&&A.y+A.height>B.y&&A.x<B.x+B.width&&A.y<B.y+B.height)return this.L.trace("window#validateWindowState: multi-monitor working area",B),A}vb(A){if(A.workArea.width>0&&A.workArea.height>0)return A.workArea;if(A.bounds.width>0&&A.bounds.height>0)return A.bounds}getBounds(){const[A,T]=this.l.getPosition(),[W,B]=this.l.getSize();return{x:A,y:T,width:W,height:B}}toggleFullScreen(){this.wb(!this.isFullScreen)}wb(A){this.Ab()?this.xb(A):this.zb(A),this.sendWhenReady(A?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.s&&this.Cb(this.s,!1)}get isFullScreen(){return b.isMacintosh&&typeof this.t=="boolean"?this.t:this.l.isFullScreen()||this.l.isSimpleFullScreen()}xb(A){this.l.isSimpleFullScreen()&&this.l.setSimpleFullScreen(!1),this.yb(A)}yb(A){b.isMacintosh&&(this.t=A,this.u=new L.DeferredPromise,Promise.race([this.u.p,(0,L.timeout)(1e3)]).finally(()=>this.t=void 0)),this.l.setFullScreen(A)}zb(A){this.l.isFullScreen()&&this.yb(!1),this.l.setSimpleFullScreen(A),this.l.webContents.focus()}Ab(){const A=this.U.getValue("window");return!A||typeof A.nativeFullScreen!="boolean"||A.nativeTabs?!0:A.nativeFullScreen!==!1}isMinimized(){return this.l.isMinimized()}Bb(){let A=(0,y.getMenuBarVisibility)(this.U);return["visible","toggle","hidden"].indexOf(A)<0&&(A="classic"),A}Cb(A,T=!0){b.isMacintosh||(A==="toggle"&&T&&this.send("vscode:showInfoMessage",(0,p.localize)(18,null)),A==="hidden"?setTimeout(()=>{this.Db(A)}):this.Db(A))}Db(A){const T=this.isFullScreen;switch(A){case"classic":this.l.setMenuBarVisibility(!T),this.l.autoHideMenuBar=T;break;case"visible":this.l.setMenuBarVisibility(!0),this.l.autoHideMenuBar=!1;break;case"toggle":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!0;break;case"hidden":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(b.isMacintosh)switch(I.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.l.minimize();break;case"None":break;case"Maximize":default:this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}else this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}close(){this.l?.close()}sendWhenReady(A,T,...W){this.isReady?this.send(A,...W):this.ready().then(()=>{T.isCancellationRequested||this.send(A,...W)})}send(A,...T){if(this.l){if(this.l.isDestroyed()||this.l.webContents.isDestroyed()){this.L.warn(`Sending IPC message to channel '${A}' for window that is destroyed`);return}try{this.l.webContents.send(A,...T)}catch(W){this.L.warn(`Error sending IPC message to channel '${A}' of window ${this.k}: ${(0,o.toErrorMessage)(W)}`)}}}updateTouchBar(A){!b.isMacintosh||this.D.forEach((T,W)=>{const B=A[W];T.segments=this.Gb(B)})}Eb(){if(!!b.isMacintosh){for(let A=0;A<10;A++){const T=this.Fb();this.D.push(T)}this.l.setTouchBar(new I.TouchBar({items:this.D}))}}Fb(A=[]){const T=this.Gb(A),W=new I.TouchBar.TouchBarSegmentedControl({segments:T,mode:"buttons",segmentStyle:"automatic",change:B=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:W.segments[B].id,from:"touchbar"})}});return W}Gb(A=[]){return A.map(W=>{let B;W.icon&&!s.ThemeIcon.isThemeIcon(W.icon)&&W.icon?.dark?.scheme===m.Schemas.file&&(B=I.nativeImage.createFromPath(f.URI.revive(W.icon.dark).fsPath),B.isEmpty()&&(B=void 0));let G;return typeof W.title=="string"?G=W.title:G=W.title.value,{id:W.id,label:B?void 0:G,icon:B}})}dispose(){super.dispose(),this.M.deregisterLoggers(this.id),this.l=null}};_.a="windowControlHeight",_.b=void 0,_=ve([ee(1,t.ILogService),ee(2,Y.ILoggerMainService),ee(3,g.IEnvironmentMainService),ee(4,J.IPolicyService),ee(5,se.IUserDataProfilesMainService),ee(6,E.IFileService),ee(7,r.IApplicationStorageMainService),ee(8,r.IStorageMainService),ee(9,c.IConfigurationService),ee(10,d.IThemeMainService),ee(11,j.IWorkspacesManagementMainService),ee(12,w.IBackupMainService),ee(13,l.ITelemetryService),ee(14,u.IDialogMainService),ee(15,R.ILifecycleMainService),ee(16,a.IProductService),ee(17,i.IProtocolMainService),ee(18,M.IWindowsMainService),ee(19,re.IStateMainService),ee(20,ae.INativeHostMainService)],_),e.CodeWindow=_}),define(te[78],ie([0,1,14,25,8,3,36,2,15,4,20,7,23,178,6,21,5,95,96,29,53,38]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f,p,w,c,u,g,D,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,p.createDecorator)("workspacesHistoryMainService");let t=class nt extends P.Disposable{constructor(i,n,r,l){super(),this.f=i,this.g=n,this.h=r,this.j=l,this.c=this.B(new o.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new k.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let n=[],r=[];for(const s of i)if((0,g.isRecentWorkspace)(s))!this.g.isUntitledWorkspace(s.workspace)&&!this.r(n,s.workspace)&&n.push(s);else if((0,g.isRecentFolder)(s))this.s(n,s.folderUri)||n.push(s);else{const d=this.t(r,s.fileUri),y=s.fileUri.scheme===h.Schemas.file&&nt.y.indexOf((0,S.basename)(s.fileUri))>=0;!d&&!y&&(r.push(s),m.isWindows&&s.fileUri.scheme===h.Schemas.file&&I.app.addRecentDocument(s.fileUri.fsPath))}const l=await this.l({workspaces:n,files:r});n=l.workspaces,r=l.files,n.length>nt.a&&(n.length=nt.a),r.length>nt.a&&(r.length=nt.a),await this.n({workspaces:n,files:r}),this.c.fire(),m.isMacintosh&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(i){const n=d=>{const y=this.p(d);for(const M of i)if(S.extUriBiasedIgnorePathCase.isEqual(M,y))return!1;return!0},r=await this.getRecentlyOpened(),l=r.workspaces.filter(n),s=r.files.filter(n);(l.length!==r.workspaces.length||s.length!==r.files.length)&&(await this.n({files:s,workspaces:l}),this.c.fire(),m.isMacintosh&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),I.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(i){const n=new R.ResourceMap(s=>S.extUriBiasedIgnorePathCase.getComparisonKey(s));if(i?.workspaces)for(const s of i.workspaces)n.set(this.p(s),s);const r=new R.ResourceMap(s=>S.extUriBiasedIgnorePathCase.getComparisonKey(s));if(i?.files)for(const s of i.files)r.set(this.p(s),s);const l=await this.m();for(const s of l.workspaces){const d=n.get(this.p(s));d?d.label=d.label??s.label:n.set(this.p(s),s)}for(const s of l.files){const d=r.get(this.p(s));d?d.label=d.label??s.label:r.set(this.p(s),s)}return{workspaces:[...n.values()],files:[...r.values()]}}async m(){await this.j.whenReady;let i;const n=this.j.get(nt.b,-1);if(typeof n=="string")try{i=JSON.parse(n)}catch(r){this.f.error("Unexpected error parsing opened paths list",r)}return(0,g.restoreRecentlyOpened)(i,this.f)}async n(i){await this.j.whenReady,this.j.store(nt.b,JSON.stringify((0,g.toStoreData)(i)),-1,1)}p(i){return(0,g.isRecentFolder)(i)?i.folderUri:(0,g.isRecentFile)(i)?i.fileUri:i.workspace.configPath}r(i,n){return!!i.find(r=>(0,g.isRecentWorkspace)(r)&&r.workspace.id===n.id)}s(i,n){return!!i.find(r=>(0,g.isRecentFolder)(r)&&S.extUriBiasedIgnorePathCase.isEqual(r.folderUri,n))}t(i,n){return!!i.find(r=>S.extUriBiasedIgnorePathCase.isEqual(r.fileUri,n))}async C(){!m.isWindows||(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!m.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(0,null),description:(0,f.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const s of I.app.getJumpListSettings().removedItems){const d=s.args;if(d){const y=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(d);y&&n.push(v.URI.parse(y[2]))}}await this.removeRecentlyOpened(n);let r=!1;const l=(0,L.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,nt.w).map(s=>{const d=(0,g.isRecentWorkspace)(s)?s.workspace:s.folderUri,{title:y,description:M}=this.F(d,s.label);let O;return v.URI.isUri(d)?O=`--folder-uri "${d.toString()}"`:(r=!0,O=`--file-uri "${d.configPath.toString()}"`),{type:"task",title:y.substr(0,255),description:M.substr(0,255),program:process.execPath,args:O,iconPath:"explorer.exe",iconIndex:0}}));l.length>0&&i.push({type:"custom",name:r?(0,f.localize)(2,null):(0,f.localize)(3,null),items:l})}i.push({type:"recent"});try{const n=I.app.setJumpList(i);n&&n!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.f.warn("updateWindowsJumpList#setJumpList",n)}}F(i,n){if(n)return{title:(0,C.splitName)(n).name,description:n};if(v.URI.isUri(i))return{title:(0,S.basename)(i),description:this.G(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,f.localize)(4,null),description:""};let r=(0,S.basename)(i.configPath);return r.endsWith(D.WORKSPACE_EXTENSION)&&(r=r.substr(0,r.length-D.WORKSPACE_EXTENSION.length-1)),{title:(0,f.localize)(5,null,r),description:this.G(i.configPath)}}G(i){return i.scheme==="file"?(0,C.normalizeDriveLetter)(i.fsPath):i.toString()}async H(){if(!m.isMacintosh)return;I.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),n=[];let r=0;for(let s=0;s<i.workspaces.length&&r<nt.u;s++){const d=this.p(i.workspaces[s]);if(d.scheme===h.Schemas.file){const y=(0,S.originalFSPath)(d);await b.Promises.exists(y)&&(n.push(y),r++)}}const l=[];for(let s=0;s<i.files.length&&r<nt.v;s++){const d=this.p(i.files[s]);if(d.scheme===h.Schemas.file){const y=(0,S.originalFSPath)(d);if(nt.y.includes((0,S.basename)(d))||n.includes(y))continue;await b.Promises.exists(y)&&(l.push(y),r++)}}l.reverse().forEach(s=>I.app.addRecentDocument(s)),n.reverse().forEach(s=>I.app.addRecentDocument(s))}};t.a=500,t.b="history.recentlyOpenedPathsList",t.u=7,t.v=10,t.w=7,t.y=["COMMIT_EDITMSG","MERGE_MSG"],t=ve([ee(0,c.ILogService),ee(1,E.IWorkspacesManagementMainService),ee(2,w.ILifecycleMainService),ee(3,u.IApplicationStorageMainService)],t),e.WorkspacesHistoryMainService=t}),define(te[277],ie([0,1,14,8,22,36,4,7,168,18,28,21,5,217,58,19,34,24,48,76,30,78]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f,p,w,c,u,g,D,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let a=class Ut{constructor(r,l,s,d,y,M,O,j,K,x,J){this.n=r,this.o=l,this.p=s,this.q=d,this.r=y,this.s=M,this.t=O,this.u=j,this.v=K,this.w=x,this.x=J,this.m=Object.create(null),this.g=new L.RunOnceScheduler(()=>this.E(),0),this.h=new L.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(C.isMacintosh||(0,D.getTitleBarStyle)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const r=this.t.getItem(Ut.a);r&&(r.menus&&(this.k=r.menus),r.keybindings&&(this.l=r.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(M,O,j)=>this.p.openEmptyWindow({context:2,contextWindowId:O?.id}),this.m["workbench.action.newWindow"]=(M,O,j)=>this.p.openEmptyWindow({context:2,contextWindowId:O?.id}),this.m["workbench.action.files.openFileFolder"]=(M,O,j)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(j),telemetryExtraData:{from:t}}),this.m["workbench.action.files.openFolder"]=(M,O,j)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(j),telemetryExtraData:{from:t}}),this.m["workbench.action.openWorkspace"]=(M,O,j)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(j),telemetryExtraData:{from:t}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const r=this.x.twitterUrl;r&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(r,"openTwitterUrl"));const l=this.x.requestFeatureUrl;l&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(l,"openUserVoiceUrl"));const s=this.x.reportIssueUrl;s&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(s,"openReportIssues"));const d=this.x.licenseUrl;d&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(C.language){const M=d.indexOf("?")>0?"&":"?";this.Z(`${d}${M}lang=${C.language}`,"openLicenseUrl")}else this.Z(d,"openLicenseUrl")});const y=this.x.privacyStatementUrl;y&&d&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(y,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(r=>this.F(r)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const r=this.o.getValue("window.enableMenuBarMnemonics");return typeof r!="boolean"?!0:r}get C(){if(!C.isMacintosh)return!1;const r=this.o.getValue("window.nativeTabs");return typeof r!="boolean"?!1:r}updateMenu(r,l){this.k=r.menus,this.l=r.keybindings,this.t.setItem(Ut.a,r),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(r){!C.isMacintosh||(r.oldCount===0&&r.newCount>0||r.oldCount>0&&r.newCount===0)&&(this.d=r.newCount===0,this.D())}G(){!C.isMacintosh||(this.f=!I.BrowserWindow.getFocusedWindow(),this.D())}H(){const r=I.Menu.getApplicationMenu();if(r&&this.j.push(r),Object.keys(this.k).length===0){I.Menu.setApplicationMenu(C.isMacintosh?new I.Menu:null);return}const l=new I.Menu;let s;if(C.isMacintosh){const y=new I.Menu;s=new I.MenuItem({label:this.x.nameShort,submenu:y}),this.I(y),l.append(s)}if(C.isMacintosh&&!this.c){this.c=!0;const y=new I.Menu;y.append(new I.MenuItem({label:this.bb(h.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),I.app.dock.setMenu(y)}if(this.K("File")){const y=new I.Menu,M=new I.MenuItem({label:this.bb(h.localize(1,null)),submenu:y});this.M(y,"File"),l.append(M)}if(this.K("Edit")){const y=new I.Menu,M=new I.MenuItem({label:this.bb(h.localize(2,null)),submenu:y});this.M(y,"Edit"),l.append(M)}if(this.K("Selection")){const y=new I.Menu,M=new I.MenuItem({label:this.bb(h.localize(3,null)),submenu:y});this.M(y,"Selection"),l.append(M)}if(this.K("View")){const y=new I.Menu,M=new I.MenuItem({label:this.bb(h.localize(4,null)),submenu:y});this.M(y,"View"),l.append(M)}if(this.K("Go")){const y=new I.Menu,M=new I.MenuItem({label:this.bb(h.localize(5,null)),submenu:y});this.M(y,"Go"),l.append(M)}if(this.K("Run")){const y=new I.Menu,M=new I.MenuItem({label:this.bb(h.localize(6,null)),submenu:y});this.M(y,"Run"),l.append(M)}if(this.K("Terminal")){const y=new I.Menu,M=new I.MenuItem({label:this.bb(h.localize(7,null)),submenu:y});this.M(y,"Terminal"),l.append(M)}let d;if(this.K("Window")){const y=new I.Menu;d=new I.MenuItem({label:this.bb(h.localize(8,null)),submenu:y,role:"window"}),this.S(y)}if(d&&l.append(d),this.K("Help")){const y=new I.Menu,M=new I.MenuItem({label:this.bb(h.localize(9,null)),submenu:y,role:"help"});this.M(y,"Help"),l.append(M)}l.items&&l.items.length>0?I.Menu.setApplicationMenu(l):I.Menu.setApplicationMenu(null),this.h.schedule()}I(r){const l=this.U(h.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),s=this.T();let d;if(this.K("Preferences")){const re=new I.Menu;this.M(re,"Preferences"),d=new I.MenuItem({label:this.bb(h.localize(11,null)),submenu:re})}const y=new I.Menu,M=new I.MenuItem({label:h.localize(12,null),role:"services",submenu:y}),O=new I.MenuItem({label:h.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),j=new I.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),K=new I.MenuItem({label:h.localize(15,null),role:"unhide"}),x=new I.MenuItem(this.Y("workbench.action.quit",{label:h.localize(16,null,this.x.nameLong),click:async(re,se,ae)=>{const fe=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||!!I.BrowserWindow.getFocusedWindow()||fe?.isMinimized())&&await this.J(ae)&&this.w.quit(void 0)}})),J=[l];J.push(...s),d&&J.push(i(),d),J.push(i(),M,i(),O,j,K,i(),x),J.forEach(re=>r.append(re))}async J(r){if(this.p.getWindowCount()===0)return!0;const l=this.o.getValue("window.confirmBeforeClose");if(l==="always"||l==="keyboardOnly"&&this.Q(r)){const s={title:this.x.nameLong,type:"question",buttons:[(0,o.mnemonicButtonLabel)(h.localize(17,null)),(0,o.mnemonicButtonLabel)(h.localize(18,null))],message:h.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:d}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,s);return d===0}return!0}K(r){if(!C.isMacintosh&&(0,D.getTitleBarStyle)(this.o)==="custom")return!1;switch(r){case"File":case"Help":if(C.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[r];case"Window":if(C.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[r]}}L(r,l){l.forEach(s=>{if((0,f.isMenubarMenuItemSeparator)(s))r.append(i());else if((0,f.isMenubarMenuItemSubmenu)(s)){const d=new I.Menu,y=new I.MenuItem({label:this.bb(s.label),submenu:d});this.L(d,s.submenu.items),r.append(y)}else(0,f.isMenubarMenuItemRecentAction)(s)?r.append(this.O(s)):(0,f.isMenubarMenuItemAction)(s)&&(s.id==="workbench.action.showAboutDialog"&&this.N(r),C.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[s.id]?r.append(new I.MenuItem(this.Y(s.id,{label:this.bb(s.label),click:this.m[s.id]}))):r.append(this.U(s.label,s.id,!1,s.checked)):r.append(this.U(s.label,s.id,s.enabled!==!1,!!s.checked)):r.append(this.U(s.label,s.id,s.enabled!==!1,!!s.checked)))})}M(r,l){this.k&&this.k[l]&&this.L(r,this.k[l].items)}N(r){const l=this.T();l.length&&(l.forEach(s=>r.append(s)),r.append(i()))}O(r){const l=P.URI.revive(r.uri),s=r.id,d=s==="openRecentFile"?{fileUri:l}:s==="openRecentWorkspace"?{workspaceUri:l}:{folderUri:l};return new I.MenuItem(this.Y(s,{label:r.label,click:async(y,M,O)=>{const j=this.P(O);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[d],forceNewWindow:j,gotoLineMode:!1,remoteAuthority:r.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([l])}},!1))}P(r){return!!(r&&(!C.isMacintosh&&(r.ctrlKey||r.shiftKey)||C.isMacintosh&&(r.metaKey||r.altKey)))}Q(r){return!!(r.triggeredByAccelerator||r.altKey||r.ctrlKey||r.metaKey||r.shiftKey)}R(r,l,s){const d={label:this.bb(r),role:s,enabled:!0};return new I.MenuItem(this.X(l,d))}S(r){const l=new I.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),s=new I.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),d=new I.MenuItem({label:h.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),y=this.U(h.localize(23,null),"workbench.action.switchWindow"),M=[];this.C&&(M.push(i()),M.push(this.U(h.localize(24,null),"workbench.action.newWindowTab")),M.push(this.R(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.R(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.R(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.R(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[l,s,i(),y,...M,i(),d].forEach(O=>r.append(O))}T(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new I.MenuItem({label:this.bb(h.localize(29,null)),click:()=>setTimeout(()=>{this.ab("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new I.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new I.MenuItem({label:this.bb(h.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new I.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return[new I.MenuItem({label:this.bb(h.localize(33,null)),click:()=>{this.ab("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new I.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new I.MenuItem({label:this.bb(h.localize(35,null)),click:()=>{this.ab("RestartToUpdate"),this.n.quitAndInstall()}})]}}U(r,l,s,d){const y=this.bb(r),M=typeof l=="function"?l:(J,re,se)=>{const ae=J?J.userSettingsLabel:null;let fe=l;Array.isArray(l)&&(fe=this.P(se)?l[1]:l[0]),ae&&se.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:ae}):this.W({type:"commandId",commandId:fe})},O=typeof s=="boolean"?s:this.p.getWindowCount()>0,j=typeof d=="boolean"?d:!1,K={label:y,click:M,enabled:O};j&&(K.type="checkbox",K.checked=j);let x;return typeof l=="string"?x=l:Array.isArray(l)&&(x=l[0]),C.isMacintosh&&(x==="editor.action.clipboardCutAction"?K.role="cut":x==="editor.action.clipboardCopyAction"?K.role="copy":x==="editor.action.clipboardPasteAction"&&(K.role="paste"),x==="undo"?K.click=this.V(M,{inDevTools:J=>J.undo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("undo:")}):x==="redo"?K.click=this.V(M,{inDevTools:J=>J.redo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("redo:")}):x==="editor.action.selectAll"&&(K.click=this.V(M,{inDevTools:J=>J.selectAll(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("selectAll:")}))),new I.MenuItem(this.X(x,K))}V(r,l){return(s,d,y)=>{const M=I.BrowserWindow.getFocusedWindow();if(!M)return l.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return l.inDevTools(M.webContents.devToolsWebContents);r(s,d||M,y)}}W(r){let l=I.BrowserWindow.getFocusedWindow();if(!l){const d=this.p.getLastActiveWindow();d?.isMinimized()&&(l=d.win)}const s=l?this.p.getWindowById(l.id):void 0;if(s){if(this.v.trace("menubar#runActionInRenderer",r),C.isMacintosh&&!this.q.isBuilt&&!s.isReady&&(r.type==="commandId"&&r.commandId==="workbench.action.toggleDevTools"||r.type!=="commandId"&&r.userSettingsLabel==="alt+cmd+i"))return;if(r.type==="commandId"){const d={id:r.commandId,from:"menu"};s.sendWhenReady("vscode:runAction",k.CancellationToken.None,d)}else{const d={userSettingsLabel:r.userSettingsLabel};s.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,d)}}else this.v.trace("menubar#runActionInRenderer: no active window found",r)}X(r,l){const s=typeof r=="string"?this.l[r]:void 0;if(s?.label){if(s.isNative!==!1)l.accelerator=s.label,l.userSettingsLabel=s.userSettingsLabel;else if(typeof l.label=="string"){const d=l.label.indexOf("[");d>=0?l.label=`${l.label.substr(0,d)} [${s.label}]`:l.label=`${l.label} [${s.label}]`}}else l.accelerator=void 0;return l}Y(r,l,s=!l.accelerator){s&&(l=this.X(r,l));const d=l.click;return l.click=(y,M,O)=>{this.ab(r),d?.(y,M,O)},l}Z(r,l){this.w.openExternal(void 0,r),this.ab(l)}ab(r){this.r.publicLog2("workbenchActionExecuted",{id:r,from:t})}bb(r){return(0,o.mnemonicMenuLabel)(r,!this.B)}};a.a="lastKnownMenubarData",a=ve([ee(0,g.IUpdateService),ee(1,m.IConfigurationService),ee(2,E.IWindowsMainService),ee(3,S.IEnvironmentMainService),ee(4,u.ITelemetryService),ee(5,R.IWorkspacesHistoryMainService),ee(6,c.IStateMainService),ee(7,v.ILifecycleMainService),ee(8,b.ILogService),ee(9,p.INativeHostMainService),ee(10,w.IProductService)],a),e.Menubar=a;function i(){return new I.MenuItem({type:"separator"})}}),define(te[278],ie([0,1,6,21,5,277]),function(V,e,I,L,k,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,I.createDecorator)("menubarMainService");let C=class{constructor(h,m,S){this.b=h,this.c=m,this.d=S,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(o.Menubar)}async updateMenubar(h,m){this.d.trace("menubarService#updateMenubar",h),(await this.a).updateMenu(m,h)}};C=ve([ee(0,I.IInstantiationService),ee(1,L.ILifecycleMainService),ee(2,k.ILogService)],C),e.MenubarMainService=C}),define(te[279],ie([0,1,14,23,26,25,22,3,32,49,36,2,15,9,63,4,35,20,10,7,176,62,18,57,28,16,6,21,5,65,19,66,55,34,76,276,120,271,29,97,78,53,68,39,52,64]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f,p,w,c,u,g,D,E,R,t,a,i,n,r,l,s,d,y,M,O,j,K,x,J,re,se,ae,fe,ge,H,F,U,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function Y($){return(0,se.isWorkspaceIdentifier)($?.workspace)}function ne($){return(0,se.isSingleFolderWorkspaceIdentifier)($?.workspace)}let _=class ht extends v.Disposable{constructor(A,T,W,B,G,N,q,Q,oe,ue,ye,ke,Ae,Re,Fe,we,pe,Se,Z){super(),this.k=A,this.l=T,this.m=W,this.n=B,this.r=G,this.s=N,this.t=q,this.u=Q,this.v=oe,this.w=ue,this.z=ye,this.C=ke,this.D=Ae,this.F=Re,this.G=Fe,this.H=we,this.I=pe,this.J=Se,this.L=Z,this.b=this.B(new P.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.B(new P.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new P.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.B(new P.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new P.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new re.WindowsStateHandler(this,this.r,this.v,this.m,this.z)),this.M()}M(){this.B(this.D.onDidEnterWorkspace(A=>this.c.fire(A.window))),this.B(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const T=new v.DisposableStore;if(T.add(P.Event.any(A.onDidClose,A.onDidDestroy)(()=>T.dispose())),A.config.extensionDevelopmentPath)for(const W of A.config.extensionDevelopmentPath)T.add(this.J.addValidFileRoot(W));A.config.extensionTestsPath&&T.add(this.J.addValidFileRoot(A.config.extensionTestsPath))}}))}openEmptyWindow(A,T){const W=this.t.args,B=T?.remoteAuthority||void 0,G=!0,N=T?.forceReuseWindow,q=!N;return this.open({...A,cli:W,forceEmpty:G,forceNewWindow:q,forceReuseWindow:N,remoteAuthority:B})}openExistingWindow(A,T){A.focus(),this.N(T,[A])}async open(A){this.m.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const T=[],W=[],B=[],G=[],N=[];let q,Q=0;const oe=await this.U(A);this.m.trace("windowsManager#open pathsToOpen",oe);for(const Re of oe)ne(Re)?A.addMode?T.push(Re):W.push(Re):Y(Re)?B.push(Re):Re.fileUri?(q||(q={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Re.remoteAuthority}),q.filesToOpenOrCreate.push(Re)):Re.backupPath?N.push({backupFolder:(0,f.basename)(Re.backupPath),remoteAuthority:Re.remoteAuthority}):Q++;A.diffMode&&q&&q.filesToOpenOrCreate.length>=2&&(q.filesToDiff=q.filesToOpenOrCreate.slice(0,2),q.filesToOpenOrCreate=[]),A.mergeMode&&q&&q.filesToOpenOrCreate.length===4&&(q.filesToMerge=q.filesToOpenOrCreate.slice(0,4),q.filesToOpenOrCreate=[],q.filesToDiff=[]),q&&A.waitMarkerFileURI&&(q.filesToWait={paths:(0,o.coalesce)([...q.filesToDiff,q.filesToMerge[3],...q.filesToOpenOrCreate]),waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(G.push(...this.D.getUntitledWorkspaces()),B.push(...G),N.push(...this.w.getEmptyWindowBackups())):N.length=0;const{windows:ue,filesOpenedInWindow:ye}=await this.O(A,B,W,N,Q,q,T);if(this.m.trace(`windowsManager#open used window count ${ue.length} (workspacesToOpen: ${B.length}, foldersToOpen: ${W.length}, emptyToRestore: ${N.length}, emptyToOpen: ${Q})`),ue.length>1)if(ye)ye.focus();else{const Re=this.j.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let Fe=!0,we=!0;if(Re){const pe=ue.filter(Se=>this.j.state.lastActiveWindow&&Se.backupPath===this.j.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),Fe=!1,we=!1)}if(Fe)for(let pe=ue.length-1;pe>=0;pe--){const Se=ue[pe];if(!(Se.openedWorkspace&&G.some(Z=>Se.openedWorkspace&&Z.workspace.id===Se.openedWorkspace.id)||Se.backupPath&&N.some(Z=>Se.backupPath&&Z.backupFolder===(0,f.basename)(Se.backupPath)))){Se.focus(),we=!1;break}}we&&ue[ue.length-1].focus()}const ke=q&&q.filesToDiff.length>0,Ae=q&&q.filesToMerge.length>0;if(!ue.some(Re=>Re.isExtensionDevelopmentHost)&&!ke&&!Ae&&!A.noRecentEntry){const Re=[];for(const Fe of oe)Y(Fe)&&!Fe.transient?Re.push({label:Fe.label,workspace:Fe.workspace,remoteAuthority:Fe.remoteAuthority}):ne(Fe)?Re.push({label:Fe.label,folderUri:Fe.workspace.uri,remoteAuthority:Fe.remoteAuthority}):Fe.fileUri&&Re.push({label:Fe.label,fileUri:Fe.fileUri,remoteAuthority:Fe.remoteAuthority});this.C.addRecentlyOpened(Re)}return this.N(A,ue),ue}N(A,T){const W=A.waitMarkerFileURI;A.context===0&&W&&T.length===1&&T[0]&&(async()=>{await T[0].whenClosedOrLoaded;try{await this.H.del(W)}catch{}})()}async O(A,T,W,B,G,N,q){const Q=[];let oe;function ue(pe,Se){Q.push(pe),Se&&(oe=pe,N=void 0)}let{openFolderInNewWindow:ye,openFilesInNewWindow:ke}=this.gb(A);if(!A.initialStartup&&q.length>0){const pe=q[0].remoteAuthority,Se=this.lb(pe);Se&&ue(this.Q(Se,q.map(Z=>Z.workspace.uri)))}const Ae=W.length+T.length+B.length;if(N&&Ae===0){const pe=N.filesToOpenOrCreate[0]||N.filesToDiff[0]||N.filesToMerge[3],Se=this.getWindows().filter(ce=>N&&(0,u.isEqualAuthority)(ce.remoteAuthority,N.remoteAuthority));let Z;pe?.fileUri&&!ke&&((A.context===4||A.context===0||A.context===1)&&(Z=await(0,J.findWindowOnFile)(Se,pe.fileUri,async ce=>ce.configPath.scheme===b.Schemas.file?this.D.resolveLocalWorkspace(ce.configPath):void 0)),Z||(Z=this.mb(Se))),Z?(0,se.isWorkspaceIdentifier)(Z.openedWorkspace)?T.push({workspace:Z.openedWorkspace,remoteAuthority:Z.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(Z.openedWorkspace)?W.push({workspace:Z.openedWorkspace,remoteAuthority:Z.remoteAuthority}):ue(this.P(A,Z,N),!0):ue(await this.hb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:N,forceNewWindow:!0,remoteAuthority:N.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile}),!0)}const Re=(0,o.distinct)(T,pe=>pe.workspace.id);if(Re.length>0){const pe=(0,o.coalesce)(Re.map(Se=>(0,J.findWindowOnWorkspaceOrFolder)(this.getWindows(),Se.workspace.configPath)));if(pe.length>0){const Se=pe[0],Z=(0,u.isEqualAuthority)(N?.remoteAuthority,Se.remoteAuthority)?N:void 0;ue(this.P(A,Se,Z),!!Z),ye=!0}for(const Se of Re){if(pe.some(de=>de.openedWorkspace&&de.openedWorkspace.id===Se.workspace.id))continue;const Z=Se.remoteAuthority,ce=(0,u.isEqualAuthority)(N?.remoteAuthority,Z)?N:void 0;ue(await this.S(A,Se,ye,ce),!!ce),ye=!0}}const Fe=(0,o.distinct)(W,pe=>u.extUriBiasedIgnorePathCase.getComparisonKey(pe.workspace.uri));if(Fe.length>0){const pe=(0,o.coalesce)(Fe.map(Se=>(0,J.findWindowOnWorkspaceOrFolder)(this.getWindows(),Se.workspace.uri)));if(pe.length>0){const Se=pe[0],Z=(0,u.isEqualAuthority)(N?.remoteAuthority,Se.remoteAuthority)?N:void 0;ue(this.P(A,Se,Z),!!Z),ye=!0}for(const Se of Fe){if(pe.some(de=>(0,se.isSingleFolderWorkspaceIdentifier)(de.openedWorkspace)&&u.extUriBiasedIgnorePathCase.isEqual(de.openedWorkspace.uri,Se.workspace.uri)))continue;const Z=Se.remoteAuthority,ce=(0,u.isEqualAuthority)(N?.remoteAuthority,Z)?N:void 0;ue(await this.S(A,Se,ye,ce),!!ce),ye=!0}}const we=(0,o.distinct)(B,pe=>pe.backupFolder);if(we.length>0)for(const pe of we){const Se=pe.remoteAuthority,Z=(0,u.isEqualAuthority)(N?.remoteAuthority,Se)?N:void 0;ue(await this.R(A,!0,Se,Z,pe),!!Z),ye=!0}if(Q.length===0||N){N&&!G&&G++;const pe=N?N.remoteAuthority:A.remoteAuthority;for(let Se=0;Se<G;Se++)ue(await this.R(A,ye,pe,N),!!N),ye=!0}return{windows:(0,o.distinct)(Q),filesOpenedInWindow:oe}}P(A,T,W){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:W}),T.focus();const B={filesToOpenOrCreate:W?.filesToOpenOrCreate,filesToDiff:W?.filesToDiff,filesToMerge:W?.filesToMerge,filesToWait:W?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return T.sendWhenReady("vscode:openFiles",C.CancellationToken.None,B),T}Q(A,T){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:T}),A.focus();const W={foldersToAdd:T};return A.sendWhenReady("vscode:addFolders",C.CancellationToken.None,W),A}R(A,T,W,B,G){this.m.trace("windowsManager#doOpenEmpty",{restore:!!G,remoteAuthority:W,filesToOpen:B,forceNewWindow:T});let N;return!T&&typeof A.contextWindowId=="number"&&(N=this.getWindowById(A.contextWindowId)),this.hb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:W,forceNewWindow:T,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:B,windowToUse:N,emptyWindowBackupInfo:G,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}S(A,T,W,B,G){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:T,filesToOpen:B}),!W&&!G&&typeof A.contextWindowId=="number"&&(G=this.getWindowById(A.contextWindowId)),this.hb({workspace:T.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:T.remoteAuthority,forceNewWindow:W,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:B,windowToUse:G,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}async U(A){let T,W=!1,B=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(T=await this.W(A),W=!0):A.forceEmpty?T=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(T=await this.X(A.cli),T.length===0&&T.push(Object.create(null)),W=!0):(T=await this.Z(),T.length===0&&T.push(Object.create(null)),B=!0),!A.addMode&&W){const G=T.filter(N=>ne(N));if(G.length>1){const N=G[0].remoteAuthority;if(G.every(q=>(0,u.isEqualAuthority)(q.remoteAuthority,N))){const q=await this.D.createUntitledWorkspace(G.map(Q=>({uri:Q.workspace.uri})));T.push({workspace:q,remoteAuthority:N}),T=T.filter(Q=>!ne(Q))}}}if(A.initialStartup&&!B&&this.z.getValue("window")?.restoreWindows==="preserve"){const G=await this.Z();T.unshift(...G.filter(N=>Y(N)||ne(N)||N.backupPath))}return T}async W(A){const T={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority},W=await Promise.all((0,o.coalesce)(A.urisToOpen||[]).map(async B=>{const G=await this.bb(B,T);if(G)return G.label=B.label,G;const N=this.db(B),q={title:this.I.nameLong,type:"info",buttons:[(0,S.mnemonicButtonLabel)((0,E.localize)(0,null))],defaultId:0,message:N.scheme===b.Schemas.file?(0,E.localize)(1,null):(0,E.localize)(2,null),detail:N.scheme===b.Schemas.file?(0,E.localize)(3,null,(0,S.getPathLabel)(N,{os:w.OS,tildify:this.t})):(0,E.localize)(4,null,N.toString(!0)),noLink:!0};this.G.showMessageBox(q,(0,g.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow()))}));return(0,o.coalesce)(W)}async X(A){const T=[],W={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:A.diff&&A._.length===2||A.merge&&A._.length===4},B=A["folder-uri"];if(B){const q=await Promise.all(B.map(Q=>{const oe=this.Y(Q);if(!!oe)return this.bb({folderUri:oe},W)}));T.push(...(0,o.coalesce)(q))}const G=A["file-uri"];if(G){const q=await Promise.all(G.map(Q=>{const oe=this.Y(Q);if(!!oe)return this.bb((0,se.hasWorkspaceFileExtension)(Q)?{workspaceUri:oe}:{fileUri:oe},W)}));T.push(...(0,o.coalesce)(q))}const N=await Promise.all(A._.map(q=>W.remoteAuthority?this.fb(q,W):this.eb(q,W)));return T.push(...(0,o.coalesce)(N)),T}Y(A){try{const T=D.URI.parse(A);if(!T.scheme){this.m.error(`Invalid URI input string, scheme missing: ${A}`);return}return T}catch(T){this.m.error(`Invalid URI input string: ${A}, ${T.message}`)}}async Z(){const A=this.ab();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":{const T=[];A!=="one"&&T.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&T.push(this.j.state.lastActiveWindow);const W=await Promise.all(T.map(async B=>{if(B.workspace){const G=await this.bb({workspaceUri:B.workspace.configPath},{remoteAuthority:B.remoteAuthority,rejectTransientWorkspaces:!0});if(Y(G))return G}else if(B.folderUri){const G=await this.bb({folderUri:B.folderUri},{remoteAuthority:B.remoteAuthority});if(ne(G))return G}else if(A!=="folders"&&B.backupPath)return{backupPath:B.backupPath,remoteAuthority:B.remoteAuthority}}));return(0,o.coalesce)(W)}}}ab(){let A;return this.v.wasRestarted?A="all":(A=this.z.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}async bb(A,T=Object.create(null)){const W=this.db(A);return W.scheme===b.Schemas.file?((0,K.isFileToOpen)(A)&&(T={...T,forceOpenWorkspaceAsFile:!0}),this.eb(W.fsPath,T)):this.cb(A,T)}cb(A,T){let W=this.db(A);const B=(0,O.getRemoteAuthority)(W)||T.remoteAuthority;if(W=(0,u.removeTrailingPathSeparator)((0,u.normalizePath)(W)),(0,K.isFileToOpen)(A)){if(T.gotoLineMode){const{path:G,line:N,column:q}=(0,h.parseLineAndColumnAware)(W.path);return{fileUri:W.with({path:G}),options:{selection:N?{startLineNumber:N,startColumn:q||1}:void 0},remoteAuthority:B}}return{fileUri:W,remoteAuthority:B}}else if((0,K.isWorkspaceToOpen)(A))return{workspace:(0,ae.getWorkspaceIdentifier)(W),remoteAuthority:B};return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(W),remoteAuthority:B}}db(A){return(0,K.isWorkspaceToOpen)(A)?A.workspaceUri:(0,K.isFolderToOpen)(A)?A.folderUri:A.fileUri}async eb(A,T){let W,B;T.gotoLineMode&&({path:A,line:W,column:B}=(0,h.parseLineAndColumnAware)(A)),A=(0,h.sanitizeFilePath)((0,f.normalize)(A),(0,c.cwd)());try{const G=await L.Promises.stat(A);if(G.isFile()){if(!T.forceOpenWorkspaceAsFile){const N=await this.D.resolveLocalWorkspace(D.URI.file(A));if(N)return N.transient&&T.rejectTransientWorkspaces?void 0:{workspace:{id:N.id,configPath:N.configPath},type:n.FileType.File,exists:!0,remoteAuthority:N.remoteAuthority,transient:N.transient}}return{fileUri:D.URI.file(A),type:n.FileType.File,exists:!0,options:{selection:W?{startLineNumber:W,startColumn:B||1}:void 0}}}else{if(G.isDirectory())return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(D.URI.file(A),G),type:n.FileType.Directory,exists:!0};if(!w.isWindows&&A==="/dev/null")return{fileUri:D.URI.file(A),type:n.FileType.File,exists:!0}}}catch{const N=D.URI.file(A);if(this.C.removeRecentlyOpened([N]),T.ignoreFileNotFound)return{fileUri:N,type:n.FileType.File,exists:!1}}}fb(A,T){const W=A.charCodeAt(0),B=T.remoteAuthority;let G,N;T.gotoLineMode&&({path:A,line:G,column:N}=(0,h.parseLineAndColumnAware)(A)),W!==47&&((0,h.isWindowsDriveLetter)(W)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,h.toSlashes)(A)),A=`/${A}`);const q=D.URI.from({scheme:b.Schemas.vscodeRemote,authority:B,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(A))return T.forceOpenWorkspaceAsFile?{fileUri:q,options:{selection:G?{startLineNumber:G,startColumn:N||1}:void 0},remoteAuthority:T.remoteAuthority}:{workspace:(0,ae.getWorkspaceIdentifier)(q),remoteAuthority:B};if(T.gotoLineMode||f.posix.basename(A).indexOf(".")!==-1)return{fileUri:q,options:{selection:G?{startLineNumber:G,startColumn:N||1}:void 0},remoteAuthority:B}}return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(q),remoteAuthority:B}}gb(A){const T=this.z.getValue("window"),W=T?.openFoldersInNewWindow||"default",B=T?.openFilesInNewWindow||"off";let G=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(W==="on"||W==="off")&&(G=W==="on");let N=!1;return A.forceNewWindow||A.forceReuseWindow?N=!!A.forceNewWindow&&!A.forceReuseWindow:(w.isMacintosh?A.context===1&&(N=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(N=!0),!A.cli.extensionDevelopmentPath&&(B==="on"||B==="off")&&(N=B==="on")),{openFolderInNewWindow:!!G,openFilesInNewWindow:N}}async openExtensionDevelopmentHostWindow(A,T){const W=(0,J.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(W)return this.v.reload(W,T.cli),W.focus(),[W];let B=T.cli["folder-uri"]||[],G=T.cli["file-uri"]||[],N=T.cli._;if(!N.length&&!B.length&&!G.length&&!T.cli.extensionTestsPath){const oe=this.j.state.lastPluginDevelopmentHostWindow,ue=oe?.workspace??oe?.folderUri;ue&&(D.URI.isUri(ue)?ue.scheme===b.Schemas.file?N=[ue.fsPath]:B=[ue.toString()]:ue.configPath.scheme===b.Schemas.file?N=[(0,u.originalFSPath)(ue.configPath)]:G=[ue.configPath.toString()])}let q=T.remoteAuthority;for(const oe of A)if(oe.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ue=D.URI.parse(oe),ye=(0,O.getRemoteAuthority)(ue);ye&&(q?(0,u.isEqualAuthority)(ye,q)||this.m.error("more than one extension development path authority"):q=ye)}N=N.filter(oe=>{const ue=D.URI.file(oe);return(0,J.findWindowOnWorkspaceOrFolder)(this.getWindows(),ue)?!1:(0,u.isEqualAuthority)((0,O.getRemoteAuthority)(ue),q)}),B=B.filter(oe=>{const ue=this.Y(oe);return ue&&!!(0,J.findWindowOnWorkspaceOrFolder)(this.getWindows(),ue)?!1:ue?(0,u.isEqualAuthority)((0,O.getRemoteAuthority)(ue),q):!1}),G=G.filter(oe=>{const ue=this.Y(oe);return ue&&!!(0,J.findWindowOnWorkspaceOrFolder)(this.getWindows(),ue)?!1:ue?(0,u.isEqualAuthority)((0,O.getRemoteAuthority)(ue),q):!1}),T.cli._=N,T.cli["folder-uri"]=B,T.cli["file-uri"]=G;const Q={context:T.context,cli:T.cli,forceNewWindow:!0,forceEmpty:!N.length&&!B.length&&!G.length,userEnv:T.userEnv,noRecentEntry:!0,waitMarkerFileURI:T.waitMarkerFileURI,remoteAuthority:q,forceProfile:T.forceProfile,forceTempProfile:T.forceTempProfile};return this.open(Q)}async hb(A){const T=this.z.getValue("window");let W;!A.forceNewWindow&&!A.forceNewTabbedWindow&&(W=A.windowToUse||this.getLastActiveWindow(),W&&W.focus());const B={...this.t.args,...A.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.t.appRoot,execPath:process.execPath,codeCachePath:this.t.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,f.join)(this.t.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.u.profiles,profile:this.u.defaultProfile},homeDir:this.t.userHome.fsPath,tmpDir:this.t.tmpDir.fsPath,userDataDir:this.t.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.l,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToMerge:A.filesToOpen?.filesToMerge,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.m.getLevel(),loggers:this.n.getRegisteredLoggers(),logsPath:this.t.logsPath,product:d.default,isInitialStartup:A.initialStartup,perfMarks:(0,p.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof T?.zoomLevel=="number"?T.zoomLevel:void 0,autoDetectHighContrast:T?.autoDetectHighContrast??!0,autoDetectColorScheme:T?.autoDetectColorScheme??!1,accessibilitySupport:I.app.accessibilitySupportEnabled,colorScheme:this.L.getColorScheme(),policiesData:this.s.serialize(),continueOn:this.t.continueOn};if(W){const G=W.config;!B.extensionDevelopmentPath&&G?.extensionDevelopmentPath&&(B.extensionDevelopmentPath=G.extensionDevelopmentPath,B.extensionDevelopmentKind=G.extensionDevelopmentKind,B["enable-proposed-api"]=G["enable-proposed-api"],B.verbose=G.verbose,B["inspect-extensions"]=G["inspect-extensions"],B["inspect-brk-extensions"]=G["inspect-brk-extensions"],B.debugId=G.debugId,B.extensionEnvironment=G.extensionEnvironment,B["extensions-dir"]=G["extensions-dir"],B["disable-extensions"]=G["disable-extensions"]),B.loggers=G?.loggers??B.loggers}else{const G=this.j.getNewWindowState(B);(0,p.mark)("code/willCreateCodeWindow");const N=W=this.F.createInstance(x.CodeWindow,{state:G,extensionDevelopmentPath:B.extensionDevelopmentPath,isExtensionTestHost:!!B.extensionTestsPath});(0,p.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(N),ht.a.push(N),this.b.fire(N),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.once)(N.onDidSignalReady)(()=>this.c.fire(N)),(0,m.once)(N.onDidClose)(()=>this.kb(N)),(0,m.once)(N.onDidDestroy)(()=>this.f.fire(N)),N.onDidTriggerSystemContextMenu(({x:Q,y:oe})=>this.h.fire({window:N,x:Q,y:oe}));const q=(0,g.assertIsDefined)(N.win?.webContents);q.removeAllListeners("devtools-reload-page"),q.on("devtools-reload-page",()=>this.v.reload(N)),this.v.registerWindow(N)}return B.windowId=W.id,W.isReady?this.v.unload(W,4).then(async G=>{G||await this.ib(W,B,A)}):await this.ib(W,B,A),W}async ib(A,T,W){if(T.extensionDevelopmentPath||((0,se.isWorkspaceIdentifier)(T.workspace)?T.backupPath=this.w.registerWorkspaceBackup({workspace:T.workspace,remoteAuthority:T.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(T.workspace)?T.backupPath=this.w.registerFolderBackup({folderUri:T.workspace.uri,remoteAuthority:T.remoteAuthority}):T.backupPath=this.w.registerEmptyWindowBackup({backupFolder:W.emptyWindowBackupInfo?.backupFolder??(0,ae.createEmptyWorkspaceIdentifier)().id,remoteAuthority:T.remoteAuthority})),this.u.isEnabled()){const B=T.workspace??(0,se.toWorkspaceIdentifier)(T.backupPath,!1),G=this.jb(W,B),N=G instanceof Promise?await G:G;T.profiles.profile=N,T.extensionDevelopmentPath||await this.u.setProfileForWorkspace(B,N)}A.load(T)}jb(A,T){return A.forceProfile?this.u.profiles.find(W=>W.name===A.forceProfile)??this.u.createNamedProfile(A.forceProfile):A.forceTempProfile?this.u.createTransientProfile():this.u.getProfileForWorkspace(T)??this.u.defaultProfile}kb(A){const T=ht.a.indexOf(A);ht.a.splice(T,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=I.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.mb(this.getWindows())}lb(A){return this.mb(this.getWindows().filter(T=>(0,u.isEqualAuthority)(T.remoteAuthority,A)))}mb(A){const T=Math.max.apply(Math,A.map(W=>W.lastFocusTime));return A.find(W=>W.lastFocusTime===T)}sendToFocused(A,...T){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(A,C.CancellationToken.None,...T)}sendToAll(A,T,W){for(const B of this.getWindows())W&&W.indexOf(B.id)>=0||B.sendWhenReady(A,C.CancellationToken.None,T)}getWindows(){return ht.a}getWindowCount(){return ht.a.length}getWindowById(A){const T=this.getWindows().filter(W=>W.id===A);return(0,o.firstOrDefault)(T)}getWindowByWebContents(A){const T=I.BrowserWindow.fromWebContents(A);if(!!T)return this.getWindowById(T.id)}};_.a=[],_=ve([ee(2,s.ILogService),ee(3,z.ILoggerMainService),ee(4,j.IStateMainService),ee(5,F.IPolicyService),ee(6,i.IEnvironmentMainService),ee(7,U.IUserDataProfilesMainService),ee(8,l.ILifecycleMainService),ee(9,R.IBackupMainService),ee(10,t.IConfigurationService),ee(11,fe.IWorkspacesHistoryMainService),ee(12,ge.IWorkspacesManagementMainService),ee(13,r.IInstantiationService),ee(14,a.IDialogMainService),ee(15,n.IFileService),ee(16,y.IProductService),ee(17,M.IProtocolMainService),ee(18,H.IThemeMainService)],_),e.WindowsMainService=_}),define(te[280],ie([0,1,62,30,78,53]),function(V,e,I,L,k,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let C=class{constructor(h,m,S,v){this.a=h,this.b=m,this.c=S,this.d=v,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(h,m){const S=this.b.getWindowById(h);if(S)return this.a.enterWorkspace(S,this.b.getWindows(),m)}createUntitledWorkspace(h,m,S){return this.a.createUntitledWorkspace(m,S)}deleteUntitledWorkspace(h,m){return this.a.deleteUntitledWorkspace(m)}getWorkspaceIdentifier(h,m){return this.a.getWorkspaceIdentifier(m)}getRecentlyOpened(h){return this.c.getRecentlyOpened()}addRecentlyOpened(h,m){return this.c.addRecentlyOpened(m)}removeRecentlyOpened(h,m){return this.c.removeRecentlyOpened(m)}clearRecentlyOpened(h){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};C=ve([ee(0,o.IWorkspacesManagementMainService),ee(1,L.IWindowsMainService),ee(2,k.IWorkspacesHistoryMainService),ee(3,I.IBackupMainService)],C),e.WorkspacesMainService=C}),define(te[281],ie([0,1,14,42,26,17,45,13,32,49,43,36,2,15,9,4,10,7,31,135,47,149,105,254,152,62,272,18,74,184,87,121,57,108,207,28,61,112,197,220,198,259,109,199,200,16,211,89,73,6,88,273,233,256,21,5,278,58,19,55,266,91,34,262,95,92,24,238,114,51,48,245,246,274,247,275,117,249,250,251,252,260,30,279,261,29,96,78,280,53,255,39,219,52,229,56,77,119,264,270,268,8,115,263,214,64]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f,p,w,c,u,g,D,E,R,t,a,i,n,r,l,s,d,y,M,O,j,K,x,J,re,se,ae,fe,ge,H,F,U,z,Y,ne,_,$,A,T,W,B,G,N,q,Q,oe,ue,ye,ke,Ae,Re,Fe,we,pe,Se,Z,ce,de,Ee,Ce,Le,Te,He,je,ze,xe,Ne,Ve,X,le,he,me,be,Oe,qe,tt,Ze,Ge,et,it,st,dt,zt,qt,Ht,Vt,xt,Gt,Dt,Kt,Jt,Xt,Yt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ct=class extends b.Disposable{constructor(Pe,De,Me,Ie,Ue,Be,Qe,_e,$e,Ke,Je){super(),this.c=Pe,this.f=De,this.g=Me,this.h=Ie,this.i=Ue,this.j=Be,this.k=Qe,this.l=_e,this.m=$e,this.n=Ke,this.p=Je,this.r(),this.s()}r(){const Pe=$e=>$e?.startsWith(`${f.Schemas.vscodeWebview}://`),De=new Set(["clipboard-read","clipboard-sanitized-write"]);I.session.defaultSession.setPermissionRequestHandler(($e,Ke,Je,Ye)=>Pe(Ye.requestingUrl)?Je(De.has(Ke)):Je(!1)),I.session.defaultSession.setPermissionCheckHandler(($e,Ke,Je,Ye)=>Pe(Ye.requestingUrl)?De.has(Ke):!1);const Me=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),Ie=$e=>{for(let Ke=$e;Ke;Ke=Ke.parent)if(Ke.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},Ue=$e=>$e.resourceType==="xhr"||Ie($e.frame),Be=$e=>{const Ke=$e.frame;if(!Ke||!this.a)return!1;const Je=I.BrowserWindow.getAllWindows();for(const Ye of Je)if(Ke.processId===Ye.webContents.mainFrame.processId)return!0;return!1},Qe=($e,Ke)=>{if($e.path!=="/index.html")return!0;const Je=Ke.frame;if(!Je||!this.a)return!1;for(const Ye of this.a.getWindows())if(Ye.win&&Je.processId===Ye.win.webContents.mainFrame.processId)return!0;return!1};I.session.defaultSession.webRequest.onBeforeRequest(($e,Ke)=>{const Je=u.URI.parse($e.url);return Je.scheme===f.Schemas.vscodeWebview&&!Qe(Je,$e)?(this.h.error("Blocked vscode-webview request",$e.url),Ke({cancel:!0})):Je.scheme===f.Schemas.vscodeFileResource&&!Be($e)?(this.h.error("Blocked vscode-file request",$e.url),Ke({cancel:!0})):Je.path.endsWith(".svg")&&!Me.has(Je.scheme)?Ke({cancel:!Ue($e)}):Ke({cancel:!1})}),I.session.defaultSession.webRequest.onHeadersReceived(($e,Ke)=>{const Je=$e.responseHeaders,Ye=Je["content-type"]||Je["Content-Type"];if(Ye&&Array.isArray(Ye)){const rt=u.URI.parse($e.url);if(rt.path.endsWith(".svg")&&Me.has(rt.scheme))return Je["Content-Type"]=["image/svg+xml"],Ke({cancel:!1,responseHeaders:Je});if(!rt.path.endsWith(f.Schemas.vscodeRemoteResource)&&Ye.some(at=>at.toLowerCase().includes("image/svg")))return Ke({cancel:!Ue($e)})}return Ke({cancel:!1})});const _e=I.session.defaultSession;typeof _e.setCodeCachePath=="function"&&this.i.codeCachePath&&_e.setCodeCachePath((0,p.join)(this.i.codeCachePath,"chrome"))}s(){(0,P.setUnexpectedErrorHandler)(Me=>this.u(Me)),process.on("uncaughtException",Me=>(0,P.onUnexpectedError)(Me)),process.on("unhandledRejection",Me=>(0,P.onUnexpectedError)(Me)),this.j.onWillShutdown(()=>this.dispose()),(0,D.registerContextMenuListener)(),I.app.on("accessibility-support-changed",(Me,Ie)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Ie)}),I.app.on("activate",async(Me,Ie)=>{this.h.trace("app#activate"),Ie||await this.a?.openEmptyWindow({context:1})}),I.app.on("web-contents-created",(Me,Ie)=>{Ie.on("will-navigate",Ue=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),Ue.preventDefault()}),Ie.setWindowOpenHandler(({url:Ue})=>(this.b?.openExternal(void 0,Ue),{action:"deny"}))});let Pe=[],De;I.app.on("open-file",(Me,Ie)=>{this.h.trace("app#open-file: ",Ie),Me.preventDefault(),Pe.push((0,be.hasWorkspaceFileExtension)(Ie)?{workspaceUri:u.URI.file(Ie)}:{fileUri:u.URI.file(Ie)}),De!==void 0&&(clearTimeout(De),De=void 0),De=setTimeout(async()=>{await this.a?.open({context:1,cli:this.i.args,urisToOpen:Pe,gotoLineMode:!1,preferNewWindow:!0}),Pe=[],De=void 0},100)}),I.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),L.validatedIpcMain.handle("vscode:fetchShellEnv",Me=>{const Ie=this.a?.getWindowByWebContents(Me.sender);let Ue,Be;return Ie?.config?(Ue=Ie.config,Be={...process.env,...Ie.config.userEnv}):(Ue=this.i.args,Be=process.env),this.J(Ue,Be,!1)}),L.validatedIpcMain.handle("vscode:writeNlsFile",(Me,Ie,Ue)=>{const Be=this.t([Ie]);if(!Be||typeof Ue!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.m.writeFile(Be,o.VSBuffer.fromString(Ue))}),L.validatedIpcMain.handle("vscode:readNlsFile",async(Me,...Ie)=>{const Ue=this.t(Ie);if(!Ue)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.m.readFile(Ue)).value.toString()}),L.validatedIpcMain.on("vscode:toggleDevTools",Me=>Me.sender.toggleDevTools()),L.validatedIpcMain.on("vscode:openDevTools",Me=>Me.sender.openDevTools()),L.validatedIpcMain.on("vscode:reloadWindow",Me=>Me.sender.reload())}t(Pe){let De;for(const Me of Pe)typeof Me=="string"&&(typeof De!="string"?De=Me:De=(0,p.join)(De,Me));if(!(typeof De!="string"||!(0,p.isAbsolute)(De)||!(0,h.isEqualOrParent)(De,this.i.cachedLanguagesPath,!w.isLinux)))return u.URI.file(De)}u(Pe){if(Pe){const De={message:`[uncaught exception in main]: ${Pe.message}`,stack:Pe.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(De))}this.h.error(`[uncaught exception in main]: ${Pe}`),Pe.stack&&this.h.error(Pe.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.i.appRoot}`),this.h.debug("args:",this.i.args);const Pe=this.n.win32AppUserModelId;w.isWindows&&Pe&&I.app.setAppUserModelId(Pe);try{w.isMacintosh&&this.k.getValue("window.nativeTabs")===!0&&!I.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&I.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch($e){this.h.error($e)}const De=new R.Server;this.j.onWillShutdown($e=>{$e.reason===2&&De.dispose()}),this.h.trace("Resolving machine identifier...");const Me=await(0,Kt.resolveMachineId)(this.l);this.h.trace(`Resolved machine identifier: ${Me}`);const{sharedProcess:Ie,sharedProcessReady:Ue,sharedProcessClient:Be}=this.w(Me),Qe=await this.y(Me,Ie,Ue);this.v(Qe),Qe.invokeFunction($e=>this.z($e,De,Be)),await Qe.invokeFunction($e=>this.C($e,De)),Qe.invokeFunction($e=>this.G($e,Ie)),this.B(new Dt.RunOnceScheduler(()=>{this.B((0,Dt.runWhenIdle)(()=>this.j.phase=4,2500))},2500)).schedule()}v(Pe){this.B(Pe.createInstance(a.ProxyAuthHandler)),this.B(Pe.createInstance(xt.UserDataProfilesHandler))}w(Pe){const De=this.B(this.g.createInstance(ye.SharedProcess,Pe,this.f)),Me=(async()=>{this.h.trace("Main->SharedProcess#connect");const Ue=await De.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new t.Client(Ue,"main")})(),Ie=(async()=>(await De.whenReady(),Me))();return{sharedProcess:De,sharedProcessReady:Ie,sharedProcessClient:Me}}async y(Pe,De,Me){const Ie=new A.ServiceCollection;switch(process.platform){case"win32":Ie.set(de.IUpdateService,new _.SyncDescriptor(He.Win32UpdateService));break;case"linux":w.isLinuxSnap?Ie.set(de.IUpdateService,new _.SyncDescriptor(Te.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ie.set(de.IUpdateService,new _.SyncDescriptor(Le.LinuxUpdateService));break;case"darwin":Ie.set(de.IUpdateService,new _.SyncDescriptor(Ce.DarwinUpdateService));break}Ie.set(le.IWindowsMainService,new _.SyncDescriptor(he.WindowsMainService,[Pe,this.f],!1));const Ue=new O.DialogMainService(this.h);Ie.set(O.IDialogMainService,Ue),Ie.set(B.ILaunchMainService,new _.SyncDescriptor(B.LaunchMainService,void 0,!1)),Ie.set(M.IDiagnosticsMainService,new _.SyncDescriptor(M.DiagnosticsMainService,void 0,!1)),Ie.set(y.IDiagnosticsService,E.ProxyChannel.toService((0,E.getDelayedChannel)(Me.then(_e=>_e.getChannel("diagnostics"))))),Ie.set(T.IIssueMainService,new _.SyncDescriptor(T.IssueMainService,[this.f])),Ie.set(j.IEncryptionMainService,new _.SyncDescriptor(K.EncryptionMainService,[Pe])),Ie.set(W.IKeyboardLayoutMainService,new _.SyncDescriptor(W.KeyboardLayoutMainService)),Ie.set(Q.INativeHostMainService,new _.SyncDescriptor(Q.NativeHostMainService,[De],!1)),Ie.set(s.ICredentialsMainService,new _.SyncDescriptor(Ge.CredentialsNativeMainService)),Ie.set(Ve.IWebviewManagerService,new _.SyncDescriptor(X.WebviewMainService)),Ie.set(q.IMenubarMainService,new _.SyncDescriptor(q.MenubarMainService)),Ie.set(se.IExtensionUrlTrustService,new _.SyncDescriptor(ae.ExtensionUrlTrustService)),Ie.set(fe.IExtensionHostStarter,new _.SyncDescriptor(ge.ExtensionHostStarter)),Ie.set(Fe.IStorageMainService,new _.SyncDescriptor(Fe.StorageMainService)),Ie.set(Fe.IApplicationStorageMainService,new _.SyncDescriptor(Fe.ApplicationStorageMainService)),w.isWindows?Ie.set(H.IExternalTerminalMainService,new _.SyncDescriptor(F.WindowsExternalTerminalService)):w.isMacintosh?Ie.set(H.IExternalTerminalMainService,new _.SyncDescriptor(F.MacExternalTerminalService)):w.isLinux&&Ie.set(H.IExternalTerminalMainService,new _.SyncDescriptor(F.LinuxExternalTerminalService));const Be=new r.BackupMainService(this.i,this.k,this.h,this.l);Ie.set(n.IBackupMainService,Be);const Qe=new Ze.WorkspacesManagementMainService(this.i,this.h,this.p,Be,Ue,this.n);if(Ie.set(Ze.IWorkspacesManagementMainService,Qe),Ie.set(Oe.IWorkspacesService,new _.SyncDescriptor(tt.WorkspacesMainService,void 0,!1)),Ie.set(qe.IWorkspacesHistoryMainService,new _.SyncDescriptor(qe.WorkspacesHistoryMainService,void 0,!1)),Ie.set(je.IURLService,new _.SyncDescriptor(xe.NativeURLService,void 0,!1)),(0,ce.supportsTelemetry)(this.n,this.i)){const _e=(0,ce.isInternalTelemetry)(this.n,this.k),$e=(0,E.getDelayedChannel)(Me.then(at=>at.getChannel("telemetryAppender"))),Ke=new Se.TelemetryAppenderClient($e),Je=(0,we.resolveCommonProperties)(this.m,(0,k.release)(),(0,k.hostname)(),process.arch,this.n.commit,this.n.version,Pe,_e,this.i.installSourcePath),Ye=(0,ce.getPiiPathsFromEnvironment)(this.i),rt={appenders:[Ke],commonProperties:Je,piiPaths:Ye,sendErrorTelemetry:!0};Ie.set(pe.ITelemetryService,new _.SyncDescriptor(Z.TelemetryService,[rt],!1))}else Ie.set(pe.ITelemetryService,ce.NullTelemetryService);return Ie.set(qt.IExtensionsProfileScannerService,new _.SyncDescriptor(Jt.ExtensionsProfileScannerService,void 0,!0)),Ie.set(Ht.IExtensionsScannerService,new _.SyncDescriptor(Vt.ExtensionsScannerService,void 0,!0)),await Dt.Promises.settled([Be.initialize(),Qe.initialize()]),this.g.createChild(Ie)}z(Pe,De,Me){const Ie=E.ProxyChannel.fromService(Pe.get(B.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",Ie);const Ue=E.ProxyChannel.fromService(Pe.get(M.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",Ue);const Be=new it.PolicyChannel(Pe.get(et.IPolicyService));De.registerChannel("policy",Be),Me.then(We=>We.registerChannel("policy",Be));const Qe=this.m.getProvider(f.Schemas.file);(0,c.assertType)(Qe instanceof ne.DiskFileSystemProvider);const _e=new Y.DiskFileSystemProviderChannel(Qe,this.h,this.i);De.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,_e),Me.then(We=>We.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,_e));const $e=E.ProxyChannel.fromService(Pe.get(st.IUserDataProfilesMainService));De.registerChannel("userDataProfiles",$e),Me.then(We=>We.registerChannel("userDataProfiles",$e));const Ke=new dt.RequestChannel(Pe.get(zt.IRequestService));Me.then(We=>We.registerChannel("request",Ke));const Je=new Ee.UpdateChannel(Pe.get(de.IUpdateService));De.registerChannel("update",Je);const Ye=E.ProxyChannel.fromService(Pe.get(T.IIssueMainService));De.registerChannel("issue",Ye);const rt=E.ProxyChannel.fromService(Pe.get(j.IEncryptionMainService));De.registerChannel("encryption",rt);const at=E.ProxyChannel.fromService(Pe.get(s.ICredentialsMainService));De.registerChannel("credentials",at);const Rt=E.ProxyChannel.fromService(Pe.get(ke.ISignService));De.registerChannel("sign",Rt);const Mt=E.ProxyChannel.fromService(Pe.get(W.IKeyboardLayoutMainService));De.registerChannel("keyboardLayout",Mt),this.b=Pe.get(Q.INativeHostMainService);const bt=E.ProxyChannel.fromService(this.b);De.registerChannel("nativeHost",bt),Me.then(We=>We.registerChannel("nativeHost",bt));const Xe=E.ProxyChannel.fromService(Pe.get(Oe.IWorkspacesService));De.registerChannel("workspaces",Xe);const yt=E.ProxyChannel.fromService(Pe.get(q.IMenubarMainService));De.registerChannel("menubar",yt);const ft=E.ProxyChannel.fromService(Pe.get(je.IURLService));De.registerChannel("url",ft);const St=E.ProxyChannel.fromService(Pe.get(se.IExtensionUrlTrustService));De.registerChannel("extensionUrlTrust",St);const Lt=E.ProxyChannel.fromService(Pe.get(Ve.IWebviewManagerService));De.registerChannel("webview",Lt);const Et=this.B(new Re.StorageDatabaseChannel(this.h,Pe.get(Fe.IStorageMainService)));De.registerChannel("storage",Et),Me.then(We=>We.registerChannel("storage",Et));const gt=this.B(new Gt.ProfileStorageChangesListenerChannel(Pe.get(Fe.IStorageMainService),Pe.get(st.IUserDataProfilesMainService),this.h));Me.then(We=>We.registerChannel("profileStorageListener",gt));const mt=E.ProxyChannel.fromService(Pe.get(H.IExternalTerminalMainService));De.registerChannel("externalTerminal",mt);const pt=new Xt.LoggerChannel(Pe.get(Yt.ILoggerMainService));De.registerChannel("logger",pt),Me.then(We=>We.registerChannel("logger",pt));const wt=new d.ElectronExtensionHostDebugBroadcastChannel(Pe.get(le.IWindowsMainService));De.registerChannel("extensionhostdebugservice",wt);const vt=E.ProxyChannel.fromService(Pe.get(fe.IExtensionHostStarter));De.registerChannel(fe.ipcExtensionHostStarterChannelName,vt)}async C(Pe,De){const Me=this.a=Pe.get(le.IWindowsMainService),Ie=Pe.get(je.IURLService),Ue=Pe.get(Q.INativeHostMainService),Be=this.h;this.j.phase=2;const Qe=this.i.args["open-url"]?this.i.args._urls||[]:[];Qe.length&&Be.trace("app#openFirstWindow() protocol links from command line:",Qe);const _e=global.getOpenUrls()||[];_e.length&&Be.trace("app#openFirstWindow() protocol links from macOS 'open-url' event:",_e);const $e=[],Ke=[...Qe,..._e].map(We=>{try{return{uri:u.URI.parse(We),url:We}}catch{Be.trace("app#openFirstWindow() protocol link failed to parse:",We);return}}).filter(We=>{if(!We)return!1;if(this.D(We.uri))return Be.trace("app#openFirstWindow() protocol link was blocked:",We.uri.toString(!0)),!1;const ot=this.F(We.uri);return ot?(Be.trace("app#openFirstWindow() protocol link will be handled as window to open:",We.uri.toString(!0),ot),$e.push(ot),!1):(Be.trace("app#openFirstWindow() protocol link will be passed to active window for handling:",We.uri.toString(!0)),!0)}),Je=this,Ye=this.i,rt=this.n;Ie.registerHandler({async handleURL(We,ot){if(Be.trace("app#handleURL():",We.toString(!0),ot),We.scheme===rt.urlProtocol&&We.path==="workspace"&&(We=We.with({authority:"file",path:u.URI.parse(We.query).path,query:""})),Je.D(We))return Be.trace("app#handleURL() protocol link was blocked:",We.toString(!0)),!0;let It=!1;const ct=new URLSearchParams(We.query);ct.get("windowId")==="_blank"?(Be.trace("app#handleURL() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",We.toString(!0)),ct.delete("windowId"),We=We.with({query:ct.toString()}),It=!0):w.isMacintosh&&Me.getWindowCount()===0&&(Be.trace("app#handleURL() running on macOS with no window open, setting shouldOpenInNewWindow=true:",We.toString(!0)),It=!0);const Nt=ct.get("continueOn");Nt!==null&&(Be.trace("app#handleURL() found 'continueOn' as parameter:",We.toString(!0)),ct.delete("continueOn"),We=We.with({query:ct.toString()}),Ye.continueOn=Nt??void 0);const At=Je.F(We);if(At){Be.trace("app#handleURL() opening protocol link as window:",At,We.toString(!0));const[Ot]=await Me.open({context:5,cli:{...Ye.args},urisToOpen:[At],forceNewWindow:It,gotoLineMode:!0});return Ot.focus(),!0}if(It){Be.trace("app#handleURL() opening empty window and passing in protocol link:",We.toString(!0));const[Ot]=await Me.open({context:5,cli:{...Ye.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ue.getRemoteAuthority)(We)});return await Ot.ready(),Ie.open(We,ot)}return!1}});const at=this.B(new me.ActiveWindowManager({onDidOpenWindow:Ue.onDidOpenWindow,onDidFocusWindow:Ue.onDidFocusWindow,getActiveWindowId:()=>Ue.getActiveWindowId(-1)})),Rt=new E.StaticRouter(We=>at.getActiveClientId().then(ot=>We===ot)),Mt=new ze.URLHandlerRouter(Rt),bt=De.getChannel("urlHandler",Mt);Ie.registerHandler(new ze.URLHandlerChannelClient(bt)),this.B(new Ne.ElectronURLListener(Ke,Ie,Me,this.i,this.n,this.h));const Xe=this.i.args,yt=global.macOpenFiles,ft=(0,J.isLaunchedFromCli)(process.env)?0:4,St=Xe._.length,Lt=!!Xe["folder-uri"],Et=!!Xe["file-uri"],gt=Xe["skip-add-to-recently-opened"]===!0,mt=Xe.wait&&Xe.waitMarkerFilePath?u.URI.file(Xe.waitMarkerFilePath):void 0,pt=Xe.remote||void 0,wt=Xe.profile,vt=Xe["profile-temp"];if($e.length>0)return Me.open({context:ft,cli:Xe,urisToOpen:$e,gotoLineMode:!0,initialStartup:!0});if(!St&&!Lt&&!Et){if(Xe["new-window"]||wt||vt)return Me.open({context:ft,cli:Xe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:gt,waitMarkerFileURI:mt,initialStartup:!0,remoteAuthority:pt,forceProfile:wt,forceTempProfile:vt});if(yt.length)return Me.open({context:1,cli:Xe,urisToOpen:yt.map(We=>(0,be.hasWorkspaceFileExtension)(We)?{workspaceUri:u.URI.file(We)}:{fileUri:u.URI.file(We)}),noRecentEntry:gt,waitMarkerFileURI:mt,initialStartup:!0})}return Me.open({context:ft,cli:Xe,forceNewWindow:Xe["new-window"]||!St&&Xe["unity-launch"],diffMode:Xe.diff,mergeMode:Xe.merge,noRecentEntry:gt,waitMarkerFileURI:mt,gotoLineMode:Xe.goto,initialStartup:!0,remoteAuthority:pt,forceProfile:wt,forceTempProfile:vt})}D(Pe){return!!(Pe.authority===f.Schemas.file&&w.isWindows&&I.dialog.showMessageBoxSync({title:this.n.nameLong,type:"question",buttons:[(0,v.mnemonicButtonLabel)((0,i.localize)(0,null)),(0,v.mnemonicButtonLabel)((0,i.localize)(1,null))],defaultId:0,cancelId:1,message:(0,i.localize)(2,null,(0,v.getPathLabel)(Pe,{os:w.OS,tildify:this.i}),this.n.nameShort),detail:(0,i.localize)(3,null),noLink:!0})===1)}F(Pe){if(!!Pe.path){if(Pe.authority===f.Schemas.file){const De=u.URI.file(Pe.fsPath);return(0,be.hasWorkspaceFileExtension)(De)?{workspaceUri:De}:{fileUri:De}}else if(Pe.authority===f.Schemas.vscodeRemote){const De=Pe.path.indexOf(p.posix.sep,1);if(De!==-1){const Me=Pe.path.substring(1,De),Ie=Pe.path.substring(De),Ue=u.URI.from({scheme:f.Schemas.vscodeRemote,authority:Me,path:Ie,query:Pe.query,fragment:Pe.fragment});return(0,be.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Ue}:/:[\d]+$/.test(Ie)?{fileUri:Ue}:{folderUri:Ue}}}}}G(Pe,De){const Me=Pe.get(pe.ITelemetryService),Ie=Pe.get(de.IUpdateService);this.j.phase=3,this.I(Me,De),this.H(),I.protocol.registerHttpProtocol(f.Schemas.vscodeRemoteResource,(Ue,Be)=>{Be({url:Ue.url.replace(/^vscode-remote-resource:/,"http:"),method:Ue.method})}),(Ie instanceof He.Win32UpdateService||Ie instanceof Le.LinuxUpdateService||Ie instanceof Ce.DarwinUpdateService)&&Ie.initialize(),this.J(this.i.args,process.env,!0),this.L()}async H(){const Pe=this.n.win32MutexName;if(w.isWindows&&Pe)try{const De=await new Promise((Ie,Ue)=>{V(["windows-mutex"],Ie,Ue)}),Me=new De.Mutex(Pe);(0,m.once)(this.j.onWillShutdown)(()=>Me.release())}catch(De){this.h.error(De)}}I(Pe,De){let Me=!1;(0,m.once)(this.j.onWillShutdown)(()=>Me=!0),this.B(De.onDidError(({type:Ie,details:Ue})=>{let Be;switch(Ie){case 1:Be="SharedProcess: detected unresponsive window";break;case 2:Be=`SharedProcess: renderer process gone (detail: ${Ue?.reason??"<unknown>"}, code: ${Ue?.exitCode??"<unknown>"})`;break;case 3:Be=`SharedProcess: failed to load (detail: ${Ue?.reason??"<unknown>"}, code: ${Ue?.exitCode??"<unknown>"})`;break}(0,P.onUnexpectedError)(new Error(Be)),Pe.publicLog2("sharedprocesserror",{type:Ie,reason:Ue?.reason,code:Ue?.exitCode,visible:De.isVisible(),shuttingdown:Me})}))}async J(Pe,De,Me){try{return await(0,re.getResolvedShellEnv)(this.k,this.h,Pe,De)}catch(Ie){const Ue=(0,C.toErrorMessage)(Ie);Me?this.a?.sendToFocused("vscode:showResolveShellEnvError",Ue):this.h.error(Ue)}return{}}async L(){try{const De=(await this.m.readFile(this.i.argvResource)).value.toString(),Me=JSON.parse((0,S.stripComments)(De)),Ue=(0,ce.getTelemetryLevel)(this.k)>=1;if(Me["enable-crash-reporter"]===void 0){const Be=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ue},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,g.generateUuid)()}"`,"}"],Qe=De.substring(0,De.length-2).concat(`,
`,Be.join(`
`));await this.m.writeFile(this.i.argvResource,o.VSBuffer.fromString(Qe))}else{const Be=De.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ue},`);Be!==De&&await this.m.writeFile(this.i.argvResource,o.VSBuffer.fromString(Be))}}catch(Pe){this.h.error(Pe)}}};Ct=ve([ee(2,$.IInstantiationService),ee(3,N.ILogService),ee(4,x.IEnvironmentMainService),ee(5,G.ILifecycleMainService),ee(6,l.IConfigurationService),ee(7,Ae.IStateMainService),ee(8,z.IFileService),ee(9,oe.IProductService),ee(10,st.IUserDataProfilesMainService)],Ct),e.CodeApplication=Ct}),define(te[282],ie([0,1,39,8,289,2,5]),function(V,e,I,L,k,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let P=class extends I.AbstractPolicyService{constructor(m,S){super(),this.j=m,this.k=S,this.a=new L.Throttler,this.b=this.B(new o.MutableDisposable)}async i(m){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(m).length} policy definitions`),await this.a.queue(()=>new Promise((S,v)=>{try{this.b.value=(0,k.createWatcher)(this.k,m,b=>{this.m(b),S()})}catch(b){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",b),v(b)}}))}m(m){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(m)}`);for(const S in m){const v=m[S];v===void 0?this.g.delete(S):this.g.set(S,v)}this.h.fire(Object.keys(m))}};P=ve([ee(0,C.ILogService)],P),e.NativePolicyService=P}),define(te[283],ie([0,1,231,8,17,13,2,10,18,33,112,5,230,290]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let p=class extends C.Disposable{constructor(c,u,g){super(),this.h=c,this.i=u,this.j=g,this.k(),this.B(c.onDidChangeConfiguration(D=>{D.affectsConfiguration("http")&&this.k()}))}k(){const c=this.h.getValue("http");this.a=c?.proxy,this.b=!!c?.proxyStrictSSL,this.f=c?.proxyAuthorization}async request(c,u){this.j.trace("RequestService#request (node) - begin",c.url);const{a:g,b:D}=this;let E;try{E=await(0,S.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(a){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",a))}const R={...process.env,...E},t=c.agent?c.agent:await(0,b.getProxyAgent)(c.url||"",R,{proxyUrl:g,strictSSL:D});c.agent=t,c.strictSSL=D,this.f&&(c.headers={...c.headers||{},"Proxy-Authorization":this.f});try{const a=await this.m(c,u);return this.j.trace("RequestService#request (node) - success",c.url),a}catch(a){throw this.j.trace("RequestService#request (node) - error",c.url,a),a}}async l(c){return((0,I.parse)(c.url).protocol==="https:"?await new Promise((D,E)=>{V(["https"],D,E)}):await new Promise((D,E)=>{V(["http"],D,E)})).request}m(c,u){return L.Promises.withAsyncBody(async(g,D)=>{const E=(0,I.parse)(c.url),R=c.getRawRequest?c.getRawRequest(c):await this.l(c),t={hostname:E.hostname,port:E.port?parseInt(E.port):E.protocol==="https:"?443:80,protocol:E.protocol,path:E.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,P.isBoolean)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(t.auth=c.user+":"+c.password);const a=R(t,i=>{const n=(0,P.isNumber)(c.followRedirects)?c.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this.m({...c,url:i.headers.location,followRedirects:n-1},u).then(g,D);else{let r=i;!c.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,f.createGunzip)())),g({res:i,stream:(0,k.streamToBufferReadableStream)(r)})}});a.on("error",D),c.timeout&&a.setTimeout(c.timeout),c.isChromiumNetwork&&a.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&a.write(c.data),a.end(),u.onCancellationRequested(()=>{a.abort(),D(new o.CancellationError)})})}async resolveProxy(c){}};p=ve([ee(0,h.IConfigurationService),ee(1,m.INativeEnvironmentService),ee(2,v.ILogService)],p),e.RequestService=p}),define(te[284],ie([0,1,14,283]),function(V,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(C){return I.net.request}class o extends L.RequestService{request(P,h){return super.request({...P||{},getRawRequest:k,isChromiumNetwork:!0},h)}}e.RequestMainService=o}),define(te[291],ie([0,1,14,41,7,25,8,45,13,32,49,36,15,9,63,4,35,27,23,47,86,281,11,18,224,237,28,61,188,16,209,89,73,205,88,21,212,5,65,19,66,265,116,243,56,284,91,232,34,236,51,68,52,39,282,218,2,40,248,37,64,213,244]),function(V,e,I,L,k,o,C,P,h,m,S,v,b,f,p,w,c,u,g,D,E,R,t,a,i,n,r,l,s,d,y,M,O,j,K,x,J,re,se,ae,fe,ge,H,F,U,z,Y,ne,_,$,A,T,W,B,G,N,q,Q,oe,ue,ye,ke){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Ae{main(){try{this.a()}catch(we){console.error(we.message),I.app.exit(1)}}async a(){(0,h.setUnexpectedErrorHandler)(Le=>console.error(Le));const[we,pe,Se,Z,ce,de,Ee,Ce]=this.b();try{try{await this.d(Se,Ce,Z,ce,Ee)}catch(Le){throw this.f(Se,Ee.nameLong,Le),Le}await we.invokeFunction(async Le=>{const Te=Le.get(re.ILogService),He=Le.get(x.ILifecycleMainService),je=Le.get(d.IFileService),ze=Le.get(re.ILoggerService),xe=await this.e(Te,Se,He,we,Ee,!0);return g.Promises.writeFile(Se.mainLockfile,String(process.pid)).catch(Ne=>{Te.warn(`Error writing main lockfile: ${Ne.stack}`)}),de.logger=ze.createLogger(k.URI.file((0,f.join)(Se.logsPath,"main.log")),{id:"mainLog",name:(0,t.localize)(0,null)}),(0,S.once)(He.onWillShutdown)(Ne=>{je.dispose(),Z.dispose(),Ne.join(g.Promises.unlink(Se.mainLockfile).catch(()=>{}))}),we.createInstance(R.CodeApplication,xe,pe).startup()})}catch(Le){we.invokeFunction(this.i,Le)}}b(){const we=new K.ServiceCollection,pe=new q.DisposableStore;process.once("exit",()=>pe.dispose());const Se={_serviceBrand:void 0,...se.default};we.set(ae.IProductService,Se);const Z=new r.EnvironmentMainService(this.j(),Se),ce=this.c(Z);we.set(r.IEnvironmentMainService,Z);const de=new ye.LoggerMainService((0,re.getLogLevel)(Z));we.set(ye.ILoggerMainService,de);const Ee=new J.BufferLogger(de.getLogLevel()),Ce=pe.add(new ke.LogService(Ee,[new re.ConsoleMainLogger(de.getLogLevel())]));we.set(re.ILogService,Ce);const Le=new y.FileService(Ce);we.set(d.IFileService,Le);const Te=new M.DiskFileSystemProvider(Ce);Le.registerProvider(b.Schemas.file,Te);const He=new oe.UriIdentityService(Le);we.set(Q.IUriIdentityService,He);const je=new $.StateMainService(Z,Ce,Le);we.set(_.IStateMainService,je);const ze=new W.UserDataProfilesMainService(je,He,Z,Le,Ce);we.set(W.IUserDataProfilesMainService,ze);const xe=w.isWindows&&Se.win32RegValueName?pe.add(new G.NativePolicyService(Ce,Se.win32RegValueName)):Z.policyFile?pe.add(new N.FilePolicyService(Z.policyFile,Le,Ce)):new B.NullPolicyService;we.set(B.IPolicyService,xe);const Ne=new i.ConfigurationService(ze.defaultProfile.settingsResource,Le,xe,Ce);return we.set(a.IConfigurationService,Ne),we.set(x.ILifecycleMainService,new O.SyncDescriptor(x.LifecycleMainService,void 0,!1)),we.set(U.IRequestService,new O.SyncDescriptor(z.RequestMainService,void 0,!0)),we.set(T.IThemeMainService,new O.SyncDescriptor(T.ThemeMainService)),we.set(Y.ISignService,new O.SyncDescriptor(ne.SignService,void 0,!1)),we.set(H.ITunnelService,new O.SyncDescriptor(F.TunnelService)),we.set(fe.IProtocolMainService,new ge.ProtocolMainService(Z,ze,Ce)),[new j.InstantiationService(we,!0),ce,Z,Ne,je,Ee,Se,ze]}c(we){const pe={VSCODE_IPC_HOOK:we.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Se=>{const Z=process.env[Se];typeof Z=="string"&&(pe[Se]=Z)}),Object.assign(process.env,pe),pe}async d(we,pe,Se,Z,ce){await C.Promises.settled([Promise.all([we.extensionsPath,we.codeCachePath,we.logsPath,pe.defaultProfile.globalStorageHome.fsPath,we.workspaceStorageHome.fsPath,we.localHistoryHome.fsPath,we.backupHome].map(de=>de?g.Promises.mkdir(de,{recursive:!0}):void 0)),Z.init(),Se.initialize()]),pe.setEnablement(ce.quality!=="stable"||Se.getValue(ue.PROFILES_ENABLEMENT_CONFIG))}async e(we,pe,Se,Z,ce,de){let Ee;try{(0,p.mark)("code/willStartMainServer"),Ee=await(0,E.serve)(pe.mainIPCHandle),(0,p.mark)("code/didStartMainServer"),(0,S.once)(Se.onWillShutdown)(()=>Ee.dispose())}catch(Ce){if(Ce.code!=="EADDRINUSE")throw this.f(pe,ce.nameLong,Ce),Ce;let Le;try{Le=await(0,E.connect)(pe.mainIPCHandle,"main")}catch(ze){if(!de||w.isWindows||ze.code!=="ECONNREFUSED")throw ze.code==="EPERM"&&this.g((0,t.localize)(1,null,ce.nameShort),(0,t.localize)(2,null),ce.nameLong),ze;try{(0,L.unlinkSync)(pe.mainIPCHandle)}catch(xe){throw we.warn("Could not delete obsolete instance handle",xe),xe}return this.e(we,pe,Se,Z,ce,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const ze=`Running extension tests from the command line is currently only supported if no other instance of ${ce.nameShort} is running.`;throw we.error(ze),Le.dispose(),new Error(ze)}let Te;!pe.args.wait&&!pe.args.status&&(Te=setTimeout(()=>{this.g((0,t.localize)(3,null,ce.nameShort),(0,t.localize)(4,null),ce.nameLong)},1e4));const He=D.ProxyChannel.toService(Le.getChannel("launch"),{disableMarshalling:!0}),je=D.ProxyChannel.toService(Le.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return Z.invokeFunction(async()=>{const ze=new n.DiagnosticsService(A.NullTelemetryService,ce),xe=await je.getMainDiagnostics(),Ne=await je.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ve=await ze.getDiagnostics(xe,Ne);throw console.log(Ve),new h.ExpectedError});throw w.isWindows&&await this.h(He,we),we.trace("Sending env to running instance..."),await He.start(pe.args,process.env),Le.dispose(),Te&&clearTimeout(Te),new h.ExpectedError("Sent env to running instance. Terminating...")}if(pe.args.status)throw we.warn(`Warning: The --status argument can only be used if ${ce.nameShort} is already running. Please run it again after {0} has started.`),new h.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ee}f(we,pe,Se){if(Se.code==="EACCES"||Se.code==="EPERM"){const Z=(0,o.coalesce)([we.userDataPath,we.extensionsPath,E.XDG_RUNTIME_DIR]).map(ce=>(0,v.getPathLabel)(k.URI.file(ce),{os:w.OS,tildify:we}));this.g((0,t.localize)(5,null),(0,t.localize)(6,null,(0,P.toErrorMessage)(Se),Z.join(`
`)),pe)}}g(we,pe,Se){I.dialog.showMessageBoxSync({title:Se,type:"warning",buttons:[(0,v.mnemonicButtonLabel)((0,t.localize)(7,null))],message:we,detail:pe,defaultId:0,noLink:!0})}async h(we,pe){if(w.isWindows){const Se=await we.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",Se);try{(await new Promise((Z,ce)=>{V(["windows-foreground-love"],Z,ce)})).allowSetForegroundWindow(Se)}catch(Z){pe.error(Z)}}}i(we,pe){const Se=we.get(re.ILogService),Z=we.get(x.ILifecycleMainService);let ce=0;pe&&(pe.isExpected?pe.message&&Se.trace(pe.message):(ce=1,pe.stack?Se.error(pe.stack):Se.error(`Startup error: ${pe.toString()}`))),Z.kill(ce)}j(){const we=this.k((0,l.parseMainProcessArgv)(process.argv));if(we.wait&&!we.waitMarkerFilePath){const pe=(0,s.createWaitMarkerFileSync)(we.verbose);pe&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",pe),we.waitMarkerFilePath=pe)}return we}k(we){if(we["open-url"]&&(we._urls=we._,we._=[]),!we.remote){const pe=this.l(we._,we.goto);we._=pe}return we}l(we,pe){const Se=(0,c.cwd)(),Z=we.map(Ee=>{let Ce=String(Ee),Le;pe&&(Le=(0,m.parseLineAndColumnAware)(Ce),Ce=Le.path),Ce&&(Ce=this.m(Se,Ce));const Te=(0,m.sanitizeFilePath)(Ce,Se),He=(0,f.basename)(Te);return He&&!(0,m.isValidBasename)(He)?null:pe&&Le?(Le.path=Te,this.n(Le)):Te}),ce=w.isWindows||w.isMacintosh,de=(0,o.distinct)(Z,Ee=>Ee&&ce?Ee.toLowerCase():Ee||"");return(0,o.coalesce)(de)}m(we,pe){return w.isWindows&&(pe=(0,u.rtrim)(pe,'"')),pe=(0,u.trim)((0,u.trim)(pe," "),"	"),w.isWindows&&(pe=(0,f.resolve)(we,pe),pe=(0,u.rtrim)(pe,".")),pe}n(we){const pe=[we.path];return typeof we.line=="number"&&pe.push(String(we.line)),typeof we.column=="number"&&pe.push(String(we.column)),pe.join(":")}}new Ae().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8be8d96ab86ed4077df554eb62727484d454699f/core/vs/code/electron-main/main.js.map
