/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ie=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/base/common/stopwatch","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/lazy","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ce=function(te){for(var e=[],r=0,k=te.length;r<k;r++)e[r]=Ie[te[r]];return e};define(Ie[62],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function r(S,R){const y=Object.create(null);for(const T of S){const M=R(T);let E=y[M];E||(E=y[M]=[]),E.push(T)}return y}e.groupBy=r;function k(S,R){const y=[],T=[];for(const M of S)R.has(M)||y.push(M);for(const M of R)S.has(M)||T.push(M);return{removed:y,added:T}}e.diffSets=k;function D(S,R){const y=[],T=[];for(const[M,E]of S)R.has(M)||y.push(E);for(const[M,E]of R)S.has(M)||T.push(E);return{removed:y,added:T}}e.diffMaps=D;class N{constructor(){this.a=new Map}add(R,y){let T=this.a.get(R);T||(T=new Set,this.a.set(R,T)),T.add(y)}delete(R,y){const T=this.a.get(R);!T||(T.delete(y),T.size===0&&this.a.delete(R))}forEach(R,y){const T=this.a.get(R);!T||T.forEach(y)}}e.SetMap=N}),define(Ie[63],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function r(S){return(R,y,T)=>{let M=null,E=null;if(typeof T.value=="function"?(M="value",E=T.value):typeof T.get=="function"&&(M="get",E=T.get),!E)throw new Error("not supported");T[M]=S(E,y)}}function k(S,R,y){let T=null,M=null;if(typeof y.value=="function"?(T="value",M=y.value,M.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(T="get",M=y.get),!M)throw new Error("not supported");const E=`$memoize$${R}`;y[T]=function(...f){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:M.apply(this,f)}),this[E]}}e.memoize=k;function D(S,R,y){return r((T,M)=>{const E=`$debounce$${M}`,f=`$debounce$result$${M}`;return function(...b){this[f]||(this[f]=y?y():void 0),clearTimeout(this[E]),R&&(this[f]=R(this[f],...b),b=[this[f]]),this[E]=setTimeout(()=>{T.apply(this,b),this[f]=y?y():void 0},S)}})}e.debounce=D;function N(S,R,y){return r((T,M)=>{const E=`$throttle$timer$${M}`,f=`$throttle$result$${M}`,b=`$throttle$lastRun$${M}`,m=`$throttle$pending$${M}`;return function(...s){if(this[f]||(this[f]=y?y():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),R&&(this[f]=R(this[f],...s)),this[m])return;const o=this[b]+S;o<=Date.now()?(this[b]=Date.now(),T.apply(this,[this[f]]),this[f]=y?y():void 0):(this[m]=!0,this[E]=setTimeout(()=>{this[m]=!1,this[b]=Date.now(),T.apply(this,[this[f]]),this[f]=y?y():void 0},o-Date.now()))}})}e.throttle=N}),define(Ie[83],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class r{constructor(D){this.a=D,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=r,e.defaultGenerator=new r("id#")}),define(Ie[111],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var r;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(r=e.ScanError||(e.ScanError={}));var k;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var N;(function(n){n.DEFAULT={allowTrailingComma:!0}})(N=e.ParseOptions||(e.ParseOptions={}));function S(n,h=!1){let i=0;const a=n.length;let t="",g=0,c=16,u=0;function d($){let P=0,F=0;for(;P<$;){const V=n.charCodeAt(i);if(V>=48&&V<=57)F=F*16+V-48;else if(V>=65&&V<=70)F=F*16+V-65+10;else if(V>=97&&V<=102)F=F*16+V-97+10;else break;i++,P++}return P<$&&(F=-1),F}function C($){i=$,t="",g=0,c=16,u=0}function O(){const $=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&T(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&T(n.charCodeAt(i)))for(i++;i<n.length&&T(n.charCodeAt(i));)i++;else return u=3,n.substring($,i);let P=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&T(n.charCodeAt(i))){for(i++;i<n.length&&T(n.charCodeAt(i));)i++;P=i}else u=3;return n.substring($,P)}function j(){let $="",P=i;for(;;){if(i>=a){$+=n.substring(P,i),u=2;break}const F=n.charCodeAt(i);if(F===34){$+=n.substring(P,i),i++;break}if(F===92){if($+=n.substring(P,i),i++,i>=a){u=2;break}switch(n.charCodeAt(i++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const q=d(4);q>=0?$+=String.fromCharCode(q):u=4;break}default:u=5}P=i;continue}if(F>=0&&F<=31)if(y(F)){$+=n.substring(P,i),u=2;break}else u=6;i++}return $}function Z(){if(t="",u=0,g=i,i>=a)return g=a,c=17;let $=n.charCodeAt(i);if(R($)){do i++,t+=String.fromCharCode($),$=n.charCodeAt(i);while(R($));return c=15}if(y($))return i++,t+=String.fromCharCode($),$===13&&n.charCodeAt(i)===10&&(i++,t+=`
`),c=14;switch($){case 123:return i++,c=1;case 125:return i++,c=2;case 91:return i++,c=3;case 93:return i++,c=4;case 58:return i++,c=6;case 44:return i++,c=5;case 34:return i++,t=j(),c=10;case 47:{const P=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<a&&!y(n.charCodeAt(i));)i++;return t=n.substring(P,i),c=12}if(n.charCodeAt(i+1)===42){i+=2;const F=a-1;let V=!1;for(;i<F;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,V=!0;break}i++}return V||(i++,u=1),t=n.substring(P,i),c=13}return t+=String.fromCharCode($),i++,c=16}case 45:if(t+=String.fromCharCode($),i++,i===a||!T(n.charCodeAt(i)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=O(),c=11;default:for(;i<a&&x($);)i++,$=n.charCodeAt(i);if(g!==i){switch(t=n.substring(g,i),t){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return t+=String.fromCharCode($),i++,c=16}}function x($){if(R($)||y($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let $;do $=Z();while($>=12&&$<=15);return $}return{setPosition:C,getPosition:()=>i,scan:h?L:Z,getToken:()=>c,getTokenValue:()=>t,getTokenOffset:()=>g,getTokenLength:()=>i-g,getTokenError:()=>u}}e.createScanner=S;function R(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function y(n){return n===10||n===13||n===8232||n===8233}function T(n){return n>=48&&n<=57}var M;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(M||(M={}));function E(n,h){const i=[],a=new Object;let t;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function u(d,C,O,j){g.value=d,g.offset=C,g.length=O,g.type=j,g.colonOffset=void 0,t=g}try{w(n,{onObjectBegin:(d,C)=>{if(h<=d)throw a;t=void 0,c=h>d,i.push("")},onObjectProperty:(d,C,O)=>{if(h<C||(u(d,C,O,"property"),i[i.length-1]=d,h<=C+O))throw a},onObjectEnd:(d,C)=>{if(h<=d)throw a;t=void 0,i.pop()},onArrayBegin:(d,C)=>{if(h<=d)throw a;t=void 0,i.push(0)},onArrayEnd:(d,C)=>{if(h<=d)throw a;t=void 0,i.pop()},onLiteralValue:(d,C,O)=>{if(h<C||(u(d,C,O,p(d)),h<=C+O))throw a},onSeparator:(d,C,O)=>{if(h<=C)throw a;if(d===":"&&t&&t.type==="property")t.colonOffset=C,c=!1,t=void 0;else if(d===","){const j=i[i.length-1];typeof j=="number"?i[i.length-1]=j+1:(c=!0,i[i.length-1]=""),t=void 0}}})}catch(d){if(d!==a)throw d}return{path:i,previousNode:t,isAtPropertyKey:c,matches:d=>{let C=0;for(let O=0;C<d.length&&O<i.length;O++)if(d[C]===i[O]||d[C]==="*")C++;else if(d[C]!=="**")return!1;return C===d.length}}}e.getLocation=E;function f(n,h=[],i=N.DEFAULT){let a=null,t=[];const g=[];function c(d){Array.isArray(t)?t.push(d):a!==null&&(t[a]=d)}return w(n,{onObjectBegin:()=>{const d={};c(d),g.push(t),t=d,a=null},onObjectProperty:d=>{a=d},onObjectEnd:()=>{t=g.pop()},onArrayBegin:()=>{const d=[];c(d),g.push(t),t=d,a=null},onArrayEnd:()=>{t=g.pop()},onLiteralValue:c,onError:(d,C,O)=>{h.push({error:d,offset:C,length:O})}},i),t[0]}e.parse=f;function b(n,h=[],i=N.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(d){a.type==="property"&&(a.length=d-a.offset,a=a.parent)}function g(d){return a.children.push(d),d}w(n,{onObjectBegin:d=>{a=g({type:"object",offset:d,length:-1,parent:a,children:[]})},onObjectProperty:(d,C,O)=>{a=g({type:"property",offset:C,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:d,offset:C,length:O,parent:a})},onObjectEnd:(d,C)=>{a.length=d+C-a.offset,a=a.parent,t(d+C)},onArrayBegin:(d,C)=>{a=g({type:"array",offset:d,length:-1,parent:a,children:[]})},onArrayEnd:(d,C)=>{a.length=d+C-a.offset,a=a.parent,t(d+C)},onLiteralValue:(d,C,O)=>{g({type:p(d),offset:C,length:O,parent:a,value:d}),t(C+O)},onSeparator:(d,C,O)=>{a.type==="property"&&(d===":"?a.colonOffset=C:d===","&&t(C))},onError:(d,C,O)=>{h.push({error:d,offset:C,length:O})}},i);const u=a.children[0];return u&&delete u.parent,u}e.parseTree=b;function m(n,h){if(!n)return;let i=n;for(const a of h)if(typeof a=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let t=!1;for(const g of i.children)if(Array.isArray(g.children)&&g.children[0].value===a){i=g.children[1],t=!0;break}if(!t)return}else{const t=a;if(i.type!=="array"||t<0||!Array.isArray(i.children)||t>=i.children.length)return;i=i.children[t]}return i}e.findNodeAtLocation=m;function s(n){if(!n.parent||!n.parent.children)return[];const h=s(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;h.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&h.push(i)}return h}e.getNodePath=s;function o(n){switch(n.type){case"array":return n.children.map(o);case"object":{const h=Object.create(null);for(const i of n.children){const a=i.children[1];a&&(h[i.children[0].value]=o(a))}return h}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=o;function l(n,h,i=!1){return h>=n.offset&&h<n.offset+n.length||i&&h===n.offset+n.length}e.contains=l;function v(n,h,i=!1){if(l(n,h,i)){const a=n.children;if(Array.isArray(a))for(let t=0;t<a.length&&a[t].offset<=h;t++){const g=v(a[t],h,i);if(g)return g}return n}}e.findNodeAtOffset=v;function w(n,h,i=N.DEFAULT){const a=S(n,!1);function t(re){return re?()=>re(a.getTokenOffset(),a.getTokenLength()):()=>!0}function g(re){return re?G=>re(G,a.getTokenOffset(),a.getTokenLength()):()=>!0}const c=t(h.onObjectBegin),u=g(h.onObjectProperty),d=t(h.onObjectEnd),C=t(h.onArrayBegin),O=t(h.onArrayEnd),j=g(h.onLiteralValue),Z=g(h.onSeparator),x=t(h.onComment),L=g(h.onError),$=i&&i.disallowComments,P=i&&i.allowTrailingComma;function F(){for(;;){const re=a.scan();switch(a.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:$||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(re){case 12:case 13:$?V(10):x();break;case 16:V(1);break;case 15:case 14:break;default:return re}}}function V(re,G=[],H=[]){if(L(re),G.length+H.length>0){let oe=a.getToken();for(;oe!==17;){if(G.indexOf(oe)!==-1){F();break}else if(H.indexOf(oe)!==-1)break;oe=F()}}}function q(re){const G=a.getTokenValue();return re?j(G):u(G),F(),!0}function le(){switch(a.getToken()){case 11:{let re=0;try{re=JSON.parse(a.getTokenValue()),typeof re!="number"&&(V(2),re=0)}catch{V(2)}j(re);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return F(),!0}function _(){return a.getToken()!==10?(V(3,[],[2,5]),!1):(q(!1),a.getToken()===6?(Z(":"),F(),de()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function pe(){c(),F();let re=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(re||V(4,[],[]),Z(","),F(),a.getToken()===2&&P)break}else re&&V(6,[],[]);_()||V(4,[],[2,5]),re=!0}return d(),a.getToken()!==2?V(7,[2],[]):F(),!0}function ue(){C(),F();let re=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(re||V(4,[],[]),Z(","),F(),a.getToken()===4&&P)break}else re&&V(6,[],[]);de()||V(4,[],[4,5]),re=!0}return O(),a.getToken()!==4?V(8,[4],[]):F(),!0}function de(){switch(a.getToken()){case 3:return ue();case 1:return pe();case 10:return q(!0);default:return le()}}return F(),a.getToken()===17?i.allowEmptyContent?!0:(V(4,[],[]),!1):de()?(a.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=w;function A(n,h){const i=S(n),a=[];let t,g=0,c;do switch(c=i.getPosition(),t=i.scan(),t){case 12:case 13:case 17:g!==c&&a.push(n.substring(g,c)),h!==void 0&&a.push(i.getTokenValue().replace(/[^\r\n]/g,h)),g=i.getPosition();break}while(t!==17);return a.join("")}e.stripComments=A;function p(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(Ie[28],Ce([1,0]),function(te,e){"use strict";var r,k,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function N(m,s,o){let l=m.get(s);return l===void 0&&(l=o,m.set(s,l)),l}e.getOrSet=N;function S(m){const s=[];return m.forEach((o,l)=>{s.push(`${l} => ${o}`)}),`Map(${m.size}) {${s.join(", ")}}`}e.mapToString=S;function R(m){const s=[];return m.forEach(o=>{s.push(o)}),`Set(${m.size}) {${s.join(", ")}}`}e.setToString=R;class y{constructor(s,o){this.uri=s,this.value=o}}class T{constructor(s,o){this[r]="ResourceMap",s instanceof T?(this.b=new Map(s.b),this.c=o??T.a):(this.b=new Map,this.c=s??T.a)}set(s,o){return this.b.set(this.c(s),new y(s,o)),this}get(s){return this.b.get(this.c(s))?.value}has(s){return this.b.has(this.c(s))}get size(){return this.b.size}clear(){this.b.clear()}delete(s){return this.b.delete(this.c(s))}forEach(s,o){typeof o<"u"&&(s=s.bind(o));for(const[l,v]of this.b)s(v.value,v.uri,this)}*values(){for(const s of this.b.values())yield s.value}*keys(){for(const s of this.b.values())yield s.uri}*entries(){for(const s of this.b.values())yield[s.uri,s.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.b)yield[s.uri,s.value]}}e.ResourceMap=T,T.a=m=>m.toString();class M{constructor(s,o){this[k]="ResourceSet",!s||typeof s=="function"?this.a=new T(s):(this.a=new T(o),s.forEach(this.add,this))}get size(){return this.a.size}add(s){return this.a.set(s,s),this}clear(){this.a.clear()}delete(s){return this.a.delete(s)}forEach(s,o){this.a.forEach((l,v)=>s.call(o,v,v,this))}has(s){return this.a.has(s)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=M;var E;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class f{constructor(){this[D]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(s){return this.a.has(s)}get(s,o=0){const l=this.a.get(s);if(!!l)return o!==0&&this.j(l,o),l.value}set(s,o,l=0){let v=this.a.get(s);if(v)v.value=o,l!==0&&this.j(v,l);else{switch(v={key:s,value:o,next:void 0,previous:void 0},l){case 0:this.h(v);break;case 1:this.g(v);break;case 2:this.h(v);break;default:this.h(v);break}this.a.set(s,v),this.d++}return this}delete(s){return!!this.remove(s)}remove(s){const o=this.a.get(s);if(!!o)return this.a.delete(s),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const s=this.b;return this.a.delete(s.key),this.i(s),this.d--,s.value}forEach(s,o){const l=this.e;let v=this.b;for(;v;){if(o?s.bind(o)(v.value,v.key,this):s(v.value,v.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const s=this,o=this.e;let l=this.b;const v={[Symbol.iterator](){return v},next(){if(s.e!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const w={value:l.key,done:!1};return l=l.next,w}else return{value:void 0,done:!0}}};return v}values(){const s=this,o=this.e;let l=this.b;const v={[Symbol.iterator](){return v},next(){if(s.e!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const w={value:l.value,done:!1};return l=l.next,w}else return{value:void 0,done:!0}}};return v}entries(){const s=this,o=this.e;let l=this.b;const v={[Symbol.iterator](){return v},next(){if(s.e!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const w={value:[l.key,l.value],done:!1};return l=l.next,w}else return{value:void 0,done:!0}}};return v}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(s){if(s>=this.size)return;if(s===0){this.clear();return}let o=this.b,l=this.size;for(;o&&l>s;)this.a.delete(o.key),o=o.next,l--;this.b=o,this.d=l,o&&(o.previous=void 0),this.e++}g(s){if(!this.b&&!this.c)this.c=s;else if(this.b)s.next=this.b,this.b.previous=s;else throw new Error("Invalid list");this.b=s,this.e++}h(s){if(!this.b&&!this.c)this.b=s;else if(this.c)s.previous=this.c,this.c.next=s;else throw new Error("Invalid list");this.c=s,this.e++}i(s){if(s===this.b&&s===this.c)this.b=void 0,this.c=void 0;else if(s===this.b){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.b=s.next}else if(s===this.c){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.c=s.previous}else{const o=s.next,l=s.previous;if(!o||!l)throw new Error("Invalid list");o.previous=l,l.next=o}s.next=void 0,s.previous=void 0,this.e++}j(s,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(s===this.b)return;const l=s.next,v=s.previous;s===this.c?(v.next=void 0,this.c=v):(l.previous=v,v.next=l),s.previous=void 0,s.next=this.b,this.b.previous=s,this.b=s,this.e++}else if(o===2){if(s===this.c)return;const l=s.next,v=s.previous;s===this.b?(l.previous=void 0,this.b=l):(l.previous=v,v.next=l),s.next=void 0,s.previous=this.c,this.c.next=s,this.c=s,this.e++}}}toJSON(){const s=[];return this.forEach((o,l)=>{s.push([l,o])}),s}fromJSON(s){this.clear();for(const[o,l]of s)this.set(o,l)}}e.LinkedMap=f;class b extends f{constructor(s,o=1){super(),this.k=s,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(s){this.k=s,this.m()}get ratio(){return this.l}set ratio(s){this.l=Math.min(Math.max(0,s),1),this.m()}get(s,o=2){return super.get(s,o)}peek(s){return super.get(s,0)}set(s,o){return super.set(s,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=b}),function(te,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ie[112],Ce([0]),e):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(Te,Se){for(var ke=0;ke<Se.length;ke++){var se=Se[ke];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Te,se.key,se)}}function r(Te,Se,ke){return Se&&e(Te.prototype,Se),ke&&e(Te,ke),Object.defineProperty(Te,"prototype",{writable:!1}),Te}function k(Te,Se){if(!!Te){if(typeof Te=="string")return D(Te,Se);var ke=Object.prototype.toString.call(Te).slice(8,-1);if(ke==="Object"&&Te.constructor&&(ke=Te.constructor.name),ke==="Map"||ke==="Set")return Array.from(Te);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return D(Te,Se)}}function D(Te,Se){(Se==null||Se>Te.length)&&(Se=Te.length);for(var ke=0,se=new Array(Se);ke<Se;ke++)se[ke]=Te[ke];return se}function N(Te,Se){var ke=typeof Symbol<"u"&&Te[Symbol.iterator]||Te["@@iterator"];if(ke)return(ke=ke.call(Te)).next.bind(ke);if(Array.isArray(Te)||(ke=k(Te))||Se&&Te&&typeof Te.length=="number"){ke&&(Te=ke);var se=0;return function(){return se>=Te.length?{done:!0}:{done:!1,value:Te[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function S(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=S();function R(Te){te.defaults=Te}var y=/[&<>"']/,T=/[&<>"']/g,M=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,f={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(Se){return f[Se]};function m(Te,Se){if(Se){if(y.test(Te))return Te.replace(T,b)}else if(M.test(Te))return Te.replace(E,b);return Te}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Te){return Te.replace(s,function(Se,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var l=/(^|[^\[])\^/g;function v(Te,Se){Te=typeof Te=="string"?Te:Te.source,Se=Se||"";var ke={replace:function(ce,J){return J=J.source||J,J=J.replace(l,"$1"),Te=Te.replace(ce,J),ke},getRegex:function(){return new RegExp(Te,Se)}};return ke}var w=/[^\w:]/g,A=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(Te,Se,ke){if(Te){var se;try{se=decodeURIComponent(o(ke)).replace(w,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}Se&&!A.test(ke)&&(ke=t(Se,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch{return null}return ke}var n={},h=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function t(Te,Se){n[" "+Te]||(h.test(Te)?n[" "+Te]=Te+"/":n[" "+Te]=d(Te,"/",!0)),Te=n[" "+Te];var ke=Te.indexOf(":")===-1;return Se.substring(0,2)==="//"?ke?Se:Te.replace(i,"$1")+Se:Se.charAt(0)==="/"?ke?Se:Te.replace(a,"$1")+Se:Te+Se}var g={exec:function(){}};function c(Te){for(var Se=1,ke,se;Se<arguments.length;Se++){ke=arguments[Se];for(se in ke)Object.prototype.hasOwnProperty.call(ke,se)&&(Te[se]=ke[se])}return Te}function u(Te,Se){var ke=Te.replace(/\|/g,function(J,I,B){for(var W=!1,K=I;--K>=0&&B[K]==="\\";)W=!W;return W?"|":" |"}),se=ke.split(/ \|/),ce=0;if(se[0].trim()||se.shift(),se.length>0&&!se[se.length-1].trim()&&se.pop(),se.length>Se)se.splice(Se);else for(;se.length<Se;)se.push("");for(;ce<se.length;ce++)se[ce]=se[ce].trim().replace(/\\\|/g,"|");return se}function d(Te,Se,ke){var se=Te.length;if(se===0)return"";for(var ce=0;ce<se;){var J=Te.charAt(se-ce-1);if(J===Se&&!ke)ce++;else if(J!==Se&&ke)ce++;else break}return Te.slice(0,se-ce)}function C(Te,Se){if(Te.indexOf(Se[1])===-1)return-1;for(var ke=Te.length,se=0,ce=0;ce<ke;ce++)if(Te[ce]==="\\")ce++;else if(Te[ce]===Se[0])se++;else if(Te[ce]===Se[1]&&(se--,se<0))return ce;return-1}function O(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function j(Te,Se){if(Se<1)return"";for(var ke="";Se>1;)Se&1&&(ke+=Te),Se>>=1,Te+=Te;return ke+Te}function Z(Te,Se,ke,se){var ce=Se.href,J=Se.title?m(Se.title):null,I=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){se.state.inLink=!0;var B={type:"link",raw:ke,href:ce,title:J,text:I,tokens:se.inlineTokens(I)};return se.state.inLink=!1,B}return{type:"image",raw:ke,href:ce,title:J,text:m(I)}}function x(Te,Se){var ke=Te.match(/^(\s+)(?:```)/);if(ke===null)return Se;var se=ke[1];return Se.split(`
`).map(function(ce){var J=ce.match(/^\s+/);if(J===null)return ce;var I=J[0];return I.length>=se.length?ce.slice(se.length):ce}).join(`
`)}var L=function(){function Te(ke){this.options=ke||te.defaults}var Se=Te.prototype;return Se.space=function(se){var ce=this.rules.block.newline.exec(se);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},Se.code=function(se){var ce=this.rules.block.code.exec(se);if(ce){var J=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?J:d(J,`
`)}}},Se.fences=function(se){var ce=this.rules.block.fences.exec(se);if(ce){var J=ce[0],I=x(J,ce[3]||"");return{type:"code",raw:J,lang:ce[2]?ce[2].trim():ce[2],text:I}}},Se.heading=function(se){var ce=this.rules.block.heading.exec(se);if(ce){var J=ce[2].trim();if(/#$/.test(J)){var I=d(J,"#");(this.options.pedantic||!I||/ $/.test(I))&&(J=I.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:J,tokens:this.lexer.inline(J)}}},Se.hr=function(se){var ce=this.rules.block.hr.exec(se);if(ce)return{type:"hr",raw:ce[0]}},Se.blockquote=function(se){var ce=this.rules.block.blockquote.exec(se);if(ce){var J=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(J,[]),text:J}}},Se.list=function(se){var ce=this.rules.block.list.exec(se);if(ce){var J,I,B,W,K,ee,he,ye,ae,be,Ee,We,Ve=ce[1].trim(),tt=Ve.length>1,Xe={type:"list",raw:"",ordered:tt,start:tt?+Ve.slice(0,-1):"",loose:!1,items:[]};Ve=tt?"\\d{1,9}\\"+Ve.slice(-1):"\\"+Ve,this.options.pedantic&&(Ve=tt?Ve:"[*+-]");for(var et=new RegExp("^( {0,3}"+Ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");se&&(We=!1,!(!(ce=et.exec(se))||this.rules.block.hr.test(se)));){if(J=ce[0],se=se.substring(J.length),ye=ce[2].split(`
`,1)[0],ae=se.split(`
`,1)[0],this.options.pedantic?(W=2,Ee=ye.trimLeft()):(W=ce[2].search(/[^ ]/),W=W>4?1:W,Ee=ye.slice(W),W+=ce[1].length),ee=!1,!ye&&/^ *$/.test(ae)&&(J+=ae+`
`,se=se.substring(ae.length+1),We=!0),!We)for(var it=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),dt=new RegExp("^ {0,"+Math.min(3,W-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Fe=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:```|~~~)"),ot=new RegExp("^ {0,"+Math.min(3,W-1)+"}#");se&&(be=se.split(`
`,1)[0],ye=be,this.options.pedantic&&(ye=ye.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Fe.test(ye)||ot.test(ye)||it.test(ye)||dt.test(se)));){if(ye.search(/[^ ]/)>=W||!ye.trim())Ee+=`
`+ye.slice(W);else if(!ee)Ee+=`
`+ye;else break;!ee&&!ye.trim()&&(ee=!0),J+=be+`
`,se=se.substring(be.length+1)}Xe.loose||(he?Xe.loose=!0:/\n *\n *$/.test(J)&&(he=!0)),this.options.gfm&&(I=/^\[[ xX]\] /.exec(Ee),I&&(B=I[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:J,task:!!I,checked:B,loose:!1,text:Ee}),Xe.raw+=J}Xe.items[Xe.items.length-1].raw=J.trimRight(),Xe.items[Xe.items.length-1].text=Ee.trimRight(),Xe.raw=Xe.raw.trimRight();var Y=Xe.items.length;for(K=0;K<Y;K++){this.lexer.state.top=!1,Xe.items[K].tokens=this.lexer.blockTokens(Xe.items[K].text,[]);var Q=Xe.items[K].tokens.filter(function(Me){return Me.type==="space"}),ge=Q.every(function(Me){for(var ze=Me.raw.split(""),He=0,Ye=N(ze),nt;!(nt=Ye()).done;){var vt=nt.value;if(vt===`
`&&(He+=1),He>1)return!0}return!1});!Xe.loose&&Q.length&&ge&&(Xe.loose=!0,Xe.items[K].loose=!0)}return Xe}},Se.html=function(se){var ce=this.rules.block.html.exec(se);if(ce){var J={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var I=this.options.sanitizer?this.options.sanitizer(ce[0]):m(ce[0]);J.type="paragraph",J.text=I,J.tokens=this.lexer.inline(I)}return J}},Se.def=function(se){var ce=this.rules.block.def.exec(se);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var J=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:J,raw:ce[0],href:ce[2],title:ce[3]}}},Se.table=function(se){var ce=this.rules.block.table.exec(se);if(ce){var J={type:"table",header:u(ce[1]).map(function(he){return{text:he}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(J.header.length===J.align.length){J.raw=ce[0];var I=J.align.length,B,W,K,ee;for(B=0;B<I;B++)/^ *-+: *$/.test(J.align[B])?J.align[B]="right":/^ *:-+: *$/.test(J.align[B])?J.align[B]="center":/^ *:-+ *$/.test(J.align[B])?J.align[B]="left":J.align[B]=null;for(I=J.rows.length,B=0;B<I;B++)J.rows[B]=u(J.rows[B],J.header.length).map(function(he){return{text:he}});for(I=J.header.length,W=0;W<I;W++)J.header[W].tokens=this.lexer.inline(J.header[W].text);for(I=J.rows.length,W=0;W<I;W++)for(ee=J.rows[W],K=0;K<ee.length;K++)ee[K].tokens=this.lexer.inline(ee[K].text);return J}}},Se.lheading=function(se){var ce=this.rules.block.lheading.exec(se);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},Se.paragraph=function(se){var ce=this.rules.block.paragraph.exec(se);if(ce){var J=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:J,tokens:this.lexer.inline(J)}}},Se.text=function(se){var ce=this.rules.block.text.exec(se);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},Se.escape=function(se){var ce=this.rules.inline.escape.exec(se);if(ce)return{type:"escape",raw:ce[0],text:m(ce[1])}},Se.tag=function(se){var ce=this.rules.inline.tag.exec(se);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):m(ce[0]):ce[0]}},Se.link=function(se){var ce=this.rules.inline.link.exec(se);if(ce){var J=ce[2].trim();if(!this.options.pedantic&&/^</.test(J)){if(!/>$/.test(J))return;var I=d(J.slice(0,-1),"\\");if((J.length-I.length)%2===0)return}else{var B=C(ce[2],"()");if(B>-1){var W=ce[0].indexOf("!")===0?5:4,K=W+ce[1].length+B;ce[2]=ce[2].substring(0,B),ce[0]=ce[0].substring(0,K).trim(),ce[3]=""}}var ee=ce[2],he="";if(this.options.pedantic){var ye=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ee);ye&&(ee=ye[1],he=ye[3])}else he=ce[3]?ce[3].slice(1,-1):"";return ee=ee.trim(),/^</.test(ee)&&(this.options.pedantic&&!/>$/.test(J)?ee=ee.slice(1):ee=ee.slice(1,-1)),Z(ce,{href:ee&&ee.replace(this.rules.inline._escapes,"$1"),title:he&&he.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},Se.reflink=function(se,ce){var J;if((J=this.rules.inline.reflink.exec(se))||(J=this.rules.inline.nolink.exec(se))){var I=(J[2]||J[1]).replace(/\s+/g," ");if(I=ce[I.toLowerCase()],!I||!I.href){var B=J[0].charAt(0);return{type:"text",raw:B,text:B}}return Z(J,I,J[0],this.lexer)}},Se.emStrong=function(se,ce,J){J===void 0&&(J="");var I=this.rules.inline.emStrong.lDelim.exec(se);if(!!I&&!(I[3]&&J.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var B=I[1]||I[2]||"";if(!B||B&&(J===""||this.rules.inline.punctuation.exec(J))){var W=I[0].length-1,K,ee,he=W,ye=0,ae=I[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ae.lastIndex=0,ce=ce.slice(-1*se.length+W);(I=ae.exec(ce))!=null;)if(K=I[1]||I[2]||I[3]||I[4]||I[5]||I[6],!!K){if(ee=K.length,I[3]||I[4]){he+=ee;continue}else if((I[5]||I[6])&&W%3&&!((W+ee)%3)){ye+=ee;continue}if(he-=ee,!(he>0)){if(ee=Math.min(ee,ee+he+ye),Math.min(W,ee)%2){var be=se.slice(1,W+I.index+ee);return{type:"em",raw:se.slice(0,W+I.index+ee+1),text:be,tokens:this.lexer.inlineTokens(be)}}var Ee=se.slice(2,W+I.index+ee-1);return{type:"strong",raw:se.slice(0,W+I.index+ee+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}}}}},Se.codespan=function(se){var ce=this.rules.inline.code.exec(se);if(ce){var J=ce[2].replace(/\n/g," "),I=/[^ ]/.test(J),B=/^ /.test(J)&&/ $/.test(J);return I&&B&&(J=J.substring(1,J.length-1)),J=m(J,!0),{type:"codespan",raw:ce[0],text:J}}},Se.br=function(se){var ce=this.rules.inline.br.exec(se);if(ce)return{type:"br",raw:ce[0]}},Se.del=function(se){var ce=this.rules.inline.del.exec(se);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},Se.autolink=function(se,ce){var J=this.rules.inline.autolink.exec(se);if(J){var I,B;return J[2]==="@"?(I=m(this.options.mangle?ce(J[1]):J[1]),B="mailto:"+I):(I=m(J[1]),B=I),{type:"link",raw:J[0],text:I,href:B,tokens:[{type:"text",raw:I,text:I}]}}},Se.url=function(se,ce){var J;if(J=this.rules.inline.url.exec(se)){var I,B;if(J[2]==="@")I=m(this.options.mangle?ce(J[0]):J[0]),B="mailto:"+I;else{var W;do W=J[0],J[0]=this.rules.inline._backpedal.exec(J[0])[0];while(W!==J[0]);I=m(J[0]),J[1]==="www."?B="http://"+I:B=I}return{type:"link",raw:J[0],text:I,href:B,tokens:[{type:"text",raw:I,text:I}]}}},Se.inlineText=function(se,ce){var J=this.rules.inline.text.exec(se);if(J){var I;return this.lexer.state.inRawBlock?I=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):m(J[0]):J[0]:I=m(this.options.smartypants?ce(J[0]):J[0]),{type:"text",raw:J[0],text:I}}},Te}(),$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:g,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=v($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.listItemStart=v(/^( *)(bull) */).replace("bull",$.bullet).getRegex(),$.list=v($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=v($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=v($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.blockquote=v($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=c({},$),$.gfm=c({},$.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.table=v($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.gfm.paragraph=v($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",$.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.pedantic=c({},$.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:g,paragraph:v($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var P={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:g,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:g,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};P._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",P.punctuation=v(P.punctuation).replace(/punctuation/g,P._punctuation).getRegex(),P.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,P.escapedEmSt=/\\\*|\\_/g,P._comment=v($._comment).replace("(?:-->|$)","-->").getRegex(),P.emStrong.lDelim=v(P.emStrong.lDelim).replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimAst=v(P.emStrong.rDelimAst,"g").replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimUnd=v(P.emStrong.rDelimUnd,"g").replace(/punct/g,P._punctuation).getRegex(),P._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,P._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,P._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,P.autolink=v(P.autolink).replace("scheme",P._scheme).replace("email",P._email).getRegex(),P._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,P.tag=v(P.tag).replace("comment",P._comment).replace("attribute",P._attribute).getRegex(),P._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,P._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,P._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,P.link=v(P.link).replace("label",P._label).replace("href",P._href).replace("title",P._title).getRegex(),P.reflink=v(P.reflink).replace("label",P._label).replace("ref",$._label).getRegex(),P.nolink=v(P.nolink).replace("ref",$._label).getRegex(),P.reflinkSearch=v(P.reflinkSearch,"g").replace("reflink",P.reflink).replace("nolink",P.nolink).getRegex(),P.normal=c({},P),P.pedantic=c({},P.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",P._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",P._label).getRegex()}),P.gfm=c({},P.normal,{escape:v(P.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),P.gfm.url=v(P.gfm.url,"i").replace("email",P.gfm._extended_email).getRegex(),P.breaks=c({},P.gfm,{br:v(P.br).replace("{2,}","*").getRegex(),text:v(P.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(Te){var Se="",ke,se,ce=Te.length;for(ke=0;ke<ce;ke++)se=Te.charCodeAt(ke),Math.random()>.5&&(se="x"+se.toString(16)),Se+="&#"+se+";";return Se}var q=function(){function Te(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||te.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:$.normal,inline:P.normal};this.options.pedantic?(se.block=$.pedantic,se.inline=P.pedantic):this.options.gfm&&(se.block=$.gfm,this.options.breaks?se.inline=P.breaks:se.inline=P.gfm),this.tokenizer.rules=se}Te.lex=function(se,ce){var J=new Te(ce);return J.lex(se)},Te.lexInline=function(se,ce){var J=new Te(ce);return J.inlineTokens(se)};var Se=Te.prototype;return Se.lex=function(se){se=se.replace(/\r\n|\r/g,`
`),this.blockTokens(se,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},Se.blockTokens=function(se,ce){var J=this;ce===void 0&&(ce=[]),this.options.pedantic?se=se.replace(/\t/g,"    ").replace(/^ +$/gm,""):se=se.replace(/^( *)(\t+)/gm,function(he,ye,ae){return ye+"    ".repeat(ae.length)});for(var I,B,W,K;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(he){return(I=he.call({lexer:J},se,ce))?(se=se.substring(I.raw.length),ce.push(I),!0):!1}))){if(I=this.tokenizer.space(se)){se=se.substring(I.raw.length),I.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(I);continue}if(I=this.tokenizer.code(se)){se=se.substring(I.raw.length),B=ce[ce.length-1],B&&(B.type==="paragraph"||B.type==="text")?(B.raw+=`
`+I.raw,B.text+=`
`+I.text,this.inlineQueue[this.inlineQueue.length-1].src=B.text):ce.push(I);continue}if(I=this.tokenizer.fences(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.heading(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.hr(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.blockquote(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.list(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.html(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.def(se)){se=se.substring(I.raw.length),B=ce[ce.length-1],B&&(B.type==="paragraph"||B.type==="text")?(B.raw+=`
`+I.raw,B.text+=`
`+I.raw,this.inlineQueue[this.inlineQueue.length-1].src=B.text):this.tokens.links[I.tag]||(this.tokens.links[I.tag]={href:I.href,title:I.title});continue}if(I=this.tokenizer.table(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.lheading(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(W=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var he=1/0,ye=se.slice(1),ae=void 0;J.options.extensions.startBlock.forEach(function(be){ae=be.call({lexer:this},ye),typeof ae=="number"&&ae>=0&&(he=Math.min(he,ae))}),he<1/0&&he>=0&&(W=se.substring(0,he+1))}(),this.state.top&&(I=this.tokenizer.paragraph(W))){B=ce[ce.length-1],K&&B.type==="paragraph"?(B.raw+=`
`+I.raw,B.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=B.text):ce.push(I),K=W.length!==se.length,se=se.substring(I.raw.length);continue}if(I=this.tokenizer.text(se)){se=se.substring(I.raw.length),B=ce[ce.length-1],B&&B.type==="text"?(B.raw+=`
`+I.raw,B.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=B.text):ce.push(I);continue}if(se){var ee="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(ee);break}else throw new Error(ee)}}return this.state.top=!0,ce},Se.inline=function(se,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:se,tokens:ce}),ce},Se.inlineTokens=function(se,ce){var J=this;ce===void 0&&(ce=[]);var I,B,W,K=se,ee,he,ye;if(this.tokens.links){var ae=Object.keys(this.tokens.links);if(ae.length>0)for(;(ee=this.tokenizer.rules.inline.reflinkSearch.exec(K))!=null;)ae.includes(ee[0].slice(ee[0].lastIndexOf("[")+1,-1))&&(K=K.slice(0,ee.index)+"["+j("a",ee[0].length-2)+"]"+K.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ee=this.tokenizer.rules.inline.blockSkip.exec(K))!=null;)K=K.slice(0,ee.index)+"["+j("a",ee[0].length-2)+"]"+K.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ee=this.tokenizer.rules.inline.escapedEmSt.exec(K))!=null;)K=K.slice(0,ee.index)+"++"+K.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(he||(ye=""),he=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ee){return(I=Ee.call({lexer:J},se,ce))?(se=se.substring(I.raw.length),ce.push(I),!0):!1}))){if(I=this.tokenizer.escape(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.tag(se)){se=se.substring(I.raw.length),B=ce[ce.length-1],B&&I.type==="text"&&B.type==="text"?(B.raw+=I.raw,B.text+=I.text):ce.push(I);continue}if(I=this.tokenizer.link(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(I.raw.length),B=ce[ce.length-1],B&&I.type==="text"&&B.type==="text"?(B.raw+=I.raw,B.text+=I.text):ce.push(I);continue}if(I=this.tokenizer.emStrong(se,K,ye)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.codespan(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.br(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.del(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.autolink(se,V)){se=se.substring(I.raw.length),ce.push(I);continue}if(!this.state.inLink&&(I=this.tokenizer.url(se,V))){se=se.substring(I.raw.length),ce.push(I);continue}if(W=se,this.options.extensions&&this.options.extensions.startInline&&function(){var Ee=1/0,We=se.slice(1),Ve=void 0;J.options.extensions.startInline.forEach(function(tt){Ve=tt.call({lexer:this},We),typeof Ve=="number"&&Ve>=0&&(Ee=Math.min(Ee,Ve))}),Ee<1/0&&Ee>=0&&(W=se.substring(0,Ee+1))}(),I=this.tokenizer.inlineText(W,F)){se=se.substring(I.raw.length),I.raw.slice(-1)!=="_"&&(ye=I.raw.slice(-1)),he=!0,B=ce[ce.length-1],B&&B.type==="text"?(B.raw+=I.raw,B.text+=I.text):ce.push(I);continue}if(se){var be="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(be);break}else throw new Error(be)}}return ce},r(Te,null,[{key:"rules",get:function(){return{block:$,inline:P}}}]),Te}(),le=function(){function Te(ke){this.options=ke||te.defaults}var Se=Te.prototype;return Se.code=function(se,ce,J){var I=(ce||"").match(/\S*/)[0];if(this.options.highlight){var B=this.options.highlight(se,I);B!=null&&B!==se&&(J=!0,se=B)}return se=se.replace(/\n$/,"")+`
`,I?'<pre><code class="'+this.options.langPrefix+m(I,!0)+'">'+(J?se:m(se,!0))+`</code></pre>
`:"<pre><code>"+(J?se:m(se,!0))+`</code></pre>
`},Se.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},Se.html=function(se){return se},Se.heading=function(se,ce,J,I){if(this.options.headerIds){var B=this.options.headerPrefix+I.slug(J);return"<h"+ce+' id="'+B+'">'+se+"</h"+ce+`>
`}return"<h"+ce+">"+se+"</h"+ce+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(se,ce,J){var I=ce?"ol":"ul",B=ce&&J!==1?' start="'+J+'"':"";return"<"+I+B+`>
`+se+"</"+I+`>
`},Se.listitem=function(se){return"<li>"+se+`</li>
`},Se.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(se){return"<p>"+se+`</p>
`},Se.table=function(se,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ce+`</table>
`},Se.tablerow=function(se){return`<tr>
`+se+`</tr>
`},Se.tablecell=function(se,ce){var J=ce.header?"th":"td",I=ce.align?"<"+J+' align="'+ce.align+'">':"<"+J+">";return I+se+("</"+J+`>
`)},Se.strong=function(se){return"<strong>"+se+"</strong>"},Se.em=function(se){return"<em>"+se+"</em>"},Se.codespan=function(se){return"<code>"+se+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(se){return"<del>"+se+"</del>"},Se.link=function(se,ce,J){if(se=p(this.options.sanitize,this.options.baseUrl,se),se===null)return J;var I='<a href="'+m(se)+'"';return ce&&(I+=' title="'+ce+'"'),I+=">"+J+"</a>",I},Se.image=function(se,ce,J){if(se=p(this.options.sanitize,this.options.baseUrl,se),se===null)return J;var I='<img src="'+se+'" alt="'+J+'"';return ce&&(I+=' title="'+ce+'"'),I+=this.options.xhtml?"/>":">",I},Se.text=function(se){return se},Te}(),_=function(){function Te(){}var Se=Te.prototype;return Se.strong=function(se){return se},Se.em=function(se){return se},Se.codespan=function(se){return se},Se.del=function(se){return se},Se.html=function(se){return se},Se.text=function(se){return se},Se.link=function(se,ce,J){return""+J},Se.image=function(se,ce,J){return""+J},Se.br=function(){return""},Te}(),pe=function(){function Te(){this.seen={}}var Se=Te.prototype;return Se.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(se,ce){var J=se,I=0;if(this.seen.hasOwnProperty(J)){I=this.seen[se];do I++,J=se+"-"+I;while(this.seen.hasOwnProperty(J))}return ce||(this.seen[se]=I,this.seen[J]=0),J},Se.slug=function(se,ce){ce===void 0&&(ce={});var J=this.serialize(se);return this.getNextSafeSlug(J,ce.dryrun)},Te}(),ue=function(){function Te(ke){this.options=ke||te.defaults,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _,this.slugger=new pe}Te.parse=function(se,ce){var J=new Te(ce);return J.parse(se)},Te.parseInline=function(se,ce){var J=new Te(ce);return J.parseInline(se)};var Se=Te.prototype;return Se.parse=function(se,ce){ce===void 0&&(ce=!0);var J="",I,B,W,K,ee,he,ye,ae,be,Ee,We,Ve,tt,Xe,et,it,dt,Fe,ot,Y=se.length;for(I=0;I<Y;I++){if(Ee=se[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(ot=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),ot!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ee.type))){J+=ot||"";continue}switch(Ee.type){case"space":continue;case"hr":{J+=this.renderer.hr();continue}case"heading":{J+=this.renderer.heading(this.parseInline(Ee.tokens),Ee.depth,o(this.parseInline(Ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{J+=this.renderer.code(Ee.text,Ee.lang,Ee.escaped);continue}case"table":{for(ae="",ye="",K=Ee.header.length,B=0;B<K;B++)ye+=this.renderer.tablecell(this.parseInline(Ee.header[B].tokens),{header:!0,align:Ee.align[B]});for(ae+=this.renderer.tablerow(ye),be="",K=Ee.rows.length,B=0;B<K;B++){for(he=Ee.rows[B],ye="",ee=he.length,W=0;W<ee;W++)ye+=this.renderer.tablecell(this.parseInline(he[W].tokens),{header:!1,align:Ee.align[W]});be+=this.renderer.tablerow(ye)}J+=this.renderer.table(ae,be);continue}case"blockquote":{be=this.parse(Ee.tokens),J+=this.renderer.blockquote(be);continue}case"list":{for(We=Ee.ordered,Ve=Ee.start,tt=Ee.loose,K=Ee.items.length,be="",B=0;B<K;B++)et=Ee.items[B],it=et.checked,dt=et.task,Xe="",et.task&&(Fe=this.renderer.checkbox(it),tt?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=Fe+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=Fe+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:Fe}):Xe+=Fe),Xe+=this.parse(et.tokens,tt),be+=this.renderer.listitem(Xe,dt,it);J+=this.renderer.list(be,We,Ve);continue}case"html":{J+=this.renderer.html(Ee.text);continue}case"paragraph":{J+=this.renderer.paragraph(this.parseInline(Ee.tokens));continue}case"text":{for(be=Ee.tokens?this.parseInline(Ee.tokens):Ee.text;I+1<Y&&se[I+1].type==="text";)Ee=se[++I],be+=`
`+(Ee.tokens?this.parseInline(Ee.tokens):Ee.text);J+=ce?this.renderer.paragraph(be):be;continue}default:{var Q='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(Q);return}else throw new Error(Q)}}}return J},Se.parseInline=function(se,ce){ce=ce||this.renderer;var J="",I,B,W,K=se.length;for(I=0;I<K;I++){if(B=se[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[B.type]&&(W=this.options.extensions.renderers[B.type].call({parser:this},B),W!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(B.type))){J+=W||"";continue}switch(B.type){case"escape":{J+=ce.text(B.text);break}case"html":{J+=ce.html(B.text);break}case"link":{J+=ce.link(B.href,B.title,this.parseInline(B.tokens,ce));break}case"image":{J+=ce.image(B.href,B.title,B.text);break}case"strong":{J+=ce.strong(this.parseInline(B.tokens,ce));break}case"em":{J+=ce.em(this.parseInline(B.tokens,ce));break}case"codespan":{J+=ce.codespan(B.text);break}case"br":{J+=ce.br();break}case"del":{J+=ce.del(this.parseInline(B.tokens,ce));break}case"text":{J+=ce.text(B.text);break}default:{var ee='Token with "'+B.type+'" type was not found.';if(this.options.silent){console.error(ee);return}else throw new Error(ee)}}}return J},Te}();function de(Te,Se,ke){if(typeof Te>"u"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof Se=="function"&&(ke=Se,Se=null),Se=c({},de.defaults,Se||{}),O(Se),ke){var se=Se.highlight,ce;try{ce=q.lex(Te,Se)}catch(K){return ke(K)}var J=function(ee){var he;if(!ee)try{Se.walkTokens&&de.walkTokens(ce,Se.walkTokens),he=ue.parse(ce,Se)}catch(ye){ee=ye}return Se.highlight=se,ee?ke(ee):ke(null,he)};if(!se||se.length<3||(delete Se.highlight,!ce.length))return J();var I=0;de.walkTokens(ce,function(K){K.type==="code"&&(I++,setTimeout(function(){se(K.text,K.lang,function(ee,he){if(ee)return J(ee);he!=null&&he!==K.text&&(K.text=he,K.escaped=!0),I--,I===0&&J()})},0))}),I===0&&J();return}function B(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+m(K.message+"",!0)+"</pre>";throw K}try{var W=q.lex(Te,Se);if(Se.walkTokens){if(Se.async)return Promise.all(de.walkTokens(W,Se.walkTokens)).then(function(){return ue.parse(W,Se)}).catch(B);de.walkTokens(W,Se.walkTokens)}return ue.parse(W,Se)}catch(K){B(K)}}de.options=de.setOptions=function(Te){return c(de.defaults,Te),R(de.defaults),de},de.getDefaults=S,de.defaults=te.defaults,de.use=function(){for(var Te=arguments.length,Se=new Array(Te),ke=0;ke<Te;ke++)Se[ke]=arguments[ke];var se=c.apply(void 0,[{}].concat(Se)),ce=de.defaults.extensions||{renderers:{},childTokens:{}},J;Se.forEach(function(I){if(I.extensions&&(J=!0,I.extensions.forEach(function(W){if(!W.name)throw new Error("extension name required");if(W.renderer){var K=ce.renderers?ce.renderers[W.name]:null;K?ce.renderers[W.name]=function(){for(var ee=arguments.length,he=new Array(ee),ye=0;ye<ee;ye++)he[ye]=arguments[ye];var ae=W.renderer.apply(this,he);return ae===!1&&(ae=K.apply(this,he)),ae}:ce.renderers[W.name]=W.renderer}if(W.tokenizer){if(!W.level||W.level!=="block"&&W.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[W.level]?ce[W.level].unshift(W.tokenizer):ce[W.level]=[W.tokenizer],W.start&&(W.level==="block"?ce.startBlock?ce.startBlock.push(W.start):ce.startBlock=[W.start]:W.level==="inline"&&(ce.startInline?ce.startInline.push(W.start):ce.startInline=[W.start]))}W.childTokens&&(ce.childTokens[W.name]=W.childTokens)})),I.renderer&&function(){var W=de.defaults.renderer||new le,K=function(ye){var ae=W[ye];W[ye]=function(){for(var be=arguments.length,Ee=new Array(be),We=0;We<be;We++)Ee[We]=arguments[We];var Ve=I.renderer[ye].apply(W,Ee);return Ve===!1&&(Ve=ae.apply(W,Ee)),Ve}};for(var ee in I.renderer)K(ee);se.renderer=W}(),I.tokenizer&&function(){var W=de.defaults.tokenizer||new L,K=function(ye){var ae=W[ye];W[ye]=function(){for(var be=arguments.length,Ee=new Array(be),We=0;We<be;We++)Ee[We]=arguments[We];var Ve=I.tokenizer[ye].apply(W,Ee);return Ve===!1&&(Ve=ae.apply(W,Ee)),Ve}};for(var ee in I.tokenizer)K(ee);se.tokenizer=W}(),I.walkTokens){var B=de.defaults.walkTokens;se.walkTokens=function(W){var K=[];return K.push(I.walkTokens.call(this,W)),B&&(K=K.concat(B.call(this,W))),K}}J&&(se.extensions=ce),de.setOptions(se)})},de.walkTokens=function(Te,Se){for(var ke=[],se=function(){var B=J.value;switch(ke=ke.concat(Se.call(de,B)),B.type){case"table":{for(var W=N(B.header),K;!(K=W()).done;){var ee=K.value;ke=ke.concat(de.walkTokens(ee.tokens,Se))}for(var he=N(B.rows),ye;!(ye=he()).done;)for(var ae=ye.value,be=N(ae),Ee;!(Ee=be()).done;){var We=Ee.value;ke=ke.concat(de.walkTokens(We.tokens,Se))}break}case"list":{ke=ke.concat(de.walkTokens(B.items,Se));break}default:de.defaults.extensions&&de.defaults.extensions.childTokens&&de.defaults.extensions.childTokens[B.type]?de.defaults.extensions.childTokens[B.type].forEach(function(Ve){ke=ke.concat(de.walkTokens(B[Ve],Se))}):B.tokens&&(ke=ke.concat(de.walkTokens(B.tokens,Se)))}},ce=N(Te),J;!(J=ce()).done;)se();return ke},de.parseInline=function(Te,Se){if(typeof Te>"u"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");Se=c({},de.defaults,Se||{}),O(Se);try{var ke=q.lexInline(Te,Se);return Se.walkTokens&&de.walkTokens(ke,Se.walkTokens),ue.parseInline(ke,Se)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+m(se.message+"",!0)+"</pre>";throw se}},de.Parser=ue,de.parser=ue.parse,de.Renderer=le,de.TextRenderer=_,de.Lexer=q,de.lexer=q.lex,de.Tokenizer=L,de.Slugger=pe,de.parse=de;var re=de.options,G=de.setOptions,H=de.use,oe=de.walkTokens,ve=de.parseInline,Ae=de,Ue=ue.parse,xe=q.lex;te.Lexer=q,te.Parser=ue,te.Renderer=le,te.Slugger=pe,te.TextRenderer=_,te.Tokenizer=L,te.getDefaults=S,te.lexer=xe,te.marked=de,te.options=re,te.parse=Ae,te.parseInline=ve,te.parser=Ue,te.setOptions=G,te.use=H,te.walkTokens=oe,Object.defineProperty(te,"__esModule",{value:!0})}),define(Ie[113],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function r(R,y,T){return Math.min(Math.max(R,y),T)}e.clamp=r;function k(R,y){return(y+R%y)%y}e.rot=k;class D{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=D;class N{constructor(){this.a=1,this.b=0}update(y){return this.b=this.b+(y-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=N;class S{constructor(y){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(y),this.c.fill(0,0,y)}update(y){const T=this.c[this.d];return this.c[this.d]=y,this.d=(this.d+1)%this.c.length,this.e-=T,this.e+=y,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=S}),function(){function te(D){const N=[];typeof D=="number"&&N.push("code/timeOrigin",D);function S(y){N.push(y,Date.now())}function R(){const y=[];for(let T=0;T<N.length;T+=2)y.push({name:N[T],startTime:N[T+1]});return y}return{mark:S,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const S of performance.getEntriesByType("mark"))N.push({name:S.name,startTime:Math.round(D+S.startTime)});return N}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function r(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=r(k))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var k in r)(typeof exports=="object"?exports:te)[k]=r[k]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function r(k){if(e[k])return e[k].exports;var D=e[k]={i:k,l:!1,exports:{}};return te[k].call(D.exports,D,D.exports,r),D.l=!0,D.exports}return r.m=te,r.c=e,r.d=function(k,D,N){r.o(k,D)||Object.defineProperty(k,D,{enumerable:!0,get:N})},r.r=function(k){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},r.t=function(k,D){if(1&D&&(k=r(k)),8&D||4&D&&typeof k=="object"&&k&&k.__esModule)return k;var N=Object.create(null);if(r.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:k}),2&D&&typeof k!="string")for(var S in k)r.d(N,S,function(R){return k[R]}.bind(null,S));return N},r.n=function(k){var D=k&&k.__esModule?function(){return k.default}:function(){return k};return r.d(D,"a",D),D},r.o=function(k,D){return Object.prototype.hasOwnProperty.call(k,D)},r.p="",r(r.s=0)}([function(te,e,r){(function(k){var D;e=te.exports=H,D=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,S=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],y=e.src=[],T=0,M=T++;y[M]="0|[1-9]\\d*";var E=T++;y[E]="[0-9]+";var f=T++;y[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=T++;y[b]="("+y[M]+")\\.("+y[M]+")\\.("+y[M]+")";var m=T++;y[m]="("+y[E]+")\\.("+y[E]+")\\.("+y[E]+")";var s=T++;y[s]="(?:"+y[M]+"|"+y[f]+")";var o=T++;y[o]="(?:"+y[E]+"|"+y[f]+")";var l=T++;y[l]="(?:-("+y[s]+"(?:\\."+y[s]+")*))";var v=T++;y[v]="(?:-?("+y[o]+"(?:\\."+y[o]+")*))";var w=T++;y[w]="[0-9A-Za-z-]+";var A=T++;y[A]="(?:\\+("+y[w]+"(?:\\."+y[w]+")*))";var p=T++,n="v?"+y[b]+y[l]+"?"+y[A]+"?";y[p]="^"+n+"$";var h="[v=\\s]*"+y[m]+y[v]+"?"+y[A]+"?",i=T++;y[i]="^"+h+"$";var a=T++;y[a]="((?:<|>)?=?)";var t=T++;y[t]=y[E]+"|x|X|\\*";var g=T++;y[g]=y[M]+"|x|X|\\*";var c=T++;y[c]="[v=\\s]*("+y[g]+")(?:\\.("+y[g]+")(?:\\.("+y[g]+")(?:"+y[l]+")?"+y[A]+"?)?)?";var u=T++;y[u]="[v=\\s]*("+y[t]+")(?:\\.("+y[t]+")(?:\\.("+y[t]+")(?:"+y[v]+")?"+y[A]+"?)?)?";var d=T++;y[d]="^"+y[a]+"\\s*"+y[c]+"$";var C=T++;y[C]="^"+y[a]+"\\s*"+y[u]+"$";var O=T++;y[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=T++;y[j]="(?:~>?)";var Z=T++;y[Z]="(\\s*)"+y[j]+"\\s+",R[Z]=new RegExp(y[Z],"g");var x=T++;y[x]="^"+y[j]+y[c]+"$";var L=T++;y[L]="^"+y[j]+y[u]+"$";var $=T++;y[$]="(?:\\^)";var P=T++;y[P]="(\\s*)"+y[$]+"\\s+",R[P]=new RegExp(y[P],"g");var F=T++;y[F]="^"+y[$]+y[c]+"$";var V=T++;y[V]="^"+y[$]+y[u]+"$";var q=T++;y[q]="^"+y[a]+"\\s*("+h+")$|^$";var le=T++;y[le]="^"+y[a]+"\\s*("+n+")$|^$";var _=T++;y[_]="(\\s*)"+y[a]+"\\s*("+h+"|"+y[c]+")",R[_]=new RegExp(y[_],"g");var pe=T++;y[pe]="^\\s*("+y[c]+")\\s+-\\s+("+y[c]+")\\s*$";var ue=T++;y[ue]="^\\s*("+y[u]+")\\s+-\\s+("+y[u]+")\\s*$";var de=T++;y[de]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)D(re,y[re]),R[re]||(R[re]=new RegExp(y[re]));function G(ae,be){if(ae instanceof H)return ae;if(typeof ae!="string"||ae.length>N||!(be?R[i]:R[p]).test(ae))return null;try{return new H(ae,be)}catch{return null}}function H(ae,be){if(ae instanceof H){if(ae.loose===be)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof H))return new H(ae,be);D("SemVer",ae,be),this.loose=be;var Ee=ae.trim().match(be?R[i]:R[p]);if(!Ee)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+Ee[1],this.minor=+Ee[2],this.patch=+Ee[3],this.major>S||this.major<0)throw new TypeError("Invalid major version");if(this.minor>S||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>S||this.patch<0)throw new TypeError("Invalid patch version");Ee[4]?this.prerelease=Ee[4].split(".").map(function(We){if(/^[0-9]+$/.test(We)){var Ve=+We;if(Ve>=0&&Ve<S)return Ve}return We}):this.prerelease=[],this.build=Ee[5]?Ee[5].split("."):[],this.format()}e.parse=G,e.valid=function(ae,be){var Ee=G(ae,be);return Ee?Ee.version:null},e.clean=function(ae,be){var Ee=G(ae.trim().replace(/^[=v]+/,""),be);return Ee?Ee.version:null},e.SemVer=H,H.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},H.prototype.toString=function(){return this.version},H.prototype.compare=function(ae){return D("SemVer.compare",this.version,this.loose,ae),ae instanceof H||(ae=new H(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},H.prototype.compareMain=function(ae){return ae instanceof H||(ae=new H(ae,this.loose)),ve(this.major,ae.major)||ve(this.minor,ae.minor)||ve(this.patch,ae.patch)},H.prototype.comparePre=function(ae){if(ae instanceof H||(ae=new H(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var be=0;do{var Ee=this.prerelease[be],We=ae.prerelease[be];if(D("prerelease compare",be,Ee,We),Ee===void 0&&We===void 0)return 0;if(We===void 0)return 1;if(Ee===void 0)return-1;if(Ee!==We)return ve(Ee,We)}while(++be)},H.prototype.inc=function(ae,be){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",be);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",be);break;case"prepatch":this.prerelease.length=0,this.inc("patch",be),this.inc("pre",be);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",be),this.inc("pre",be);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ee=this.prerelease.length;--Ee>=0;)typeof this.prerelease[Ee]=="number"&&(this.prerelease[Ee]++,Ee=-2);Ee===-1&&this.prerelease.push(0)}be&&(this.prerelease[0]===be?isNaN(this.prerelease[1])&&(this.prerelease=[be,0]):this.prerelease=[be,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,be,Ee,We){typeof Ee=="string"&&(We=Ee,Ee=void 0);try{return new H(ae,Ee).inc(be,We).version}catch{return null}},e.diff=function(ae,be){if(Te(ae,be))return null;var Ee=G(ae),We=G(be);if(Ee.prerelease.length||We.prerelease.length){for(var Ve in Ee)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&Ee[Ve]!==We[Ve])return"pre"+Ve;return"prerelease"}for(var Ve in Ee)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&Ee[Ve]!==We[Ve])return Ve},e.compareIdentifiers=ve;var oe=/^[0-9]+$/;function ve(ae,be){var Ee=oe.test(ae),We=oe.test(be);return Ee&&We&&(ae=+ae,be=+be),Ee&&!We?-1:We&&!Ee?1:ae<be?-1:ae>be?1:0}function Ae(ae,be,Ee){return new H(ae,Ee).compare(new H(be,Ee))}function Ue(ae,be,Ee){return Ae(ae,be,Ee)>0}function xe(ae,be,Ee){return Ae(ae,be,Ee)<0}function Te(ae,be,Ee){return Ae(ae,be,Ee)===0}function Se(ae,be,Ee){return Ae(ae,be,Ee)!==0}function ke(ae,be,Ee){return Ae(ae,be,Ee)>=0}function se(ae,be,Ee){return Ae(ae,be,Ee)<=0}function ce(ae,be,Ee,We){var Ve;switch(be){case"===":typeof ae=="object"&&(ae=ae.version),typeof Ee=="object"&&(Ee=Ee.version),Ve=ae===Ee;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof Ee=="object"&&(Ee=Ee.version),Ve=ae!==Ee;break;case"":case"=":case"==":Ve=Te(ae,Ee,We);break;case"!=":Ve=Se(ae,Ee,We);break;case">":Ve=Ue(ae,Ee,We);break;case">=":Ve=ke(ae,Ee,We);break;case"<":Ve=xe(ae,Ee,We);break;case"<=":Ve=se(ae,Ee,We);break;default:throw new TypeError("Invalid operator: "+be)}return Ve}function J(ae,be){if(ae instanceof J){if(ae.loose===be)return ae;ae=ae.value}if(!(this instanceof J))return new J(ae,be);D("comparator",ae,be),this.loose=be,this.parse(ae),this.semver===I?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ae,be){return ve(be,ae)},e.major=function(ae,be){return new H(ae,be).major},e.minor=function(ae,be){return new H(ae,be).minor},e.patch=function(ae,be){return new H(ae,be).patch},e.compare=Ae,e.compareLoose=function(ae,be){return Ae(ae,be,!0)},e.rcompare=function(ae,be,Ee){return Ae(be,ae,Ee)},e.sort=function(ae,be){return ae.sort(function(Ee,We){return e.compare(Ee,We,be)})},e.rsort=function(ae,be){return ae.sort(function(Ee,We){return e.rcompare(Ee,We,be)})},e.gt=Ue,e.lt=xe,e.eq=Te,e.neq=Se,e.gte=ke,e.lte=se,e.cmp=ce,e.Comparator=J;var I={};function B(ae,be){if(ae instanceof B)return ae.loose===be?ae:new B(ae.raw,be);if(ae instanceof J)return new B(ae.value,be);if(!(this instanceof B))return new B(ae,be);if(this.loose=be,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(Ee){return this.parseRange(Ee.trim())},this).filter(function(Ee){return Ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function W(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function K(ae,be,Ee,We,Ve,tt,Xe,et,it,dt,Fe,ot,Y){return((be=W(Ee)?"":W(We)?">="+Ee+".0.0":W(Ve)?">="+Ee+"."+We+".0":">="+be)+" "+(et=W(it)?"":W(dt)?"<"+(+it+1)+".0.0":W(Fe)?"<"+it+"."+(+dt+1)+".0":ot?"<="+it+"."+dt+"."+Fe+"-"+ot:"<="+et)).trim()}function ee(ae,be){for(var Ee=0;Ee<ae.length;Ee++)if(!ae[Ee].test(be))return!1;if(be.prerelease.length){for(Ee=0;Ee<ae.length;Ee++)if(D(ae[Ee].semver),ae[Ee].semver!==I&&ae[Ee].semver.prerelease.length>0){var We=ae[Ee].semver;if(We.major===be.major&&We.minor===be.minor&&We.patch===be.patch)return!0}return!1}return!0}function he(ae,be,Ee){try{be=new B(be,Ee)}catch{return!1}return be.test(ae)}function ye(ae,be,Ee,We){var Ve,tt,Xe,et,it;switch(ae=new H(ae,We),be=new B(be,We),Ee){case">":Ve=Ue,tt=se,Xe=xe,et=">",it=">=";break;case"<":Ve=xe,tt=ke,Xe=Ue,et="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(he(ae,be,We))return!1;for(var dt=0;dt<be.set.length;++dt){var Fe=be.set[dt],ot=null,Y=null;if(Fe.forEach(function(Q){Q.semver===I&&(Q=new J(">=0.0.0")),ot=ot||Q,Y=Y||Q,Ve(Q.semver,ot.semver,We)?ot=Q:Xe(Q.semver,Y.semver,We)&&(Y=Q)}),ot.operator===et||ot.operator===it||(!Y.operator||Y.operator===et)&&tt(ae,Y.semver)||Y.operator===it&&Xe(ae,Y.semver))return!1}return!0}J.prototype.parse=function(ae){var be=this.loose?R[q]:R[le],Ee=ae.match(be);if(!Ee)throw new TypeError("Invalid comparator: "+ae);this.operator=Ee[1],this.operator==="="&&(this.operator=""),Ee[2]?this.semver=new H(Ee[2],this.loose):this.semver=I},J.prototype.toString=function(){return this.value},J.prototype.test=function(ae){return D("Comparator.test",ae,this.loose),this.semver===I||(typeof ae=="string"&&(ae=new H(ae,this.loose)),ce(ae,this.operator,this.semver,this.loose))},J.prototype.intersects=function(ae,be){if(!(ae instanceof J))throw new TypeError("a Comparator is required");var Ee;if(this.operator==="")return Ee=new B(ae.value,be),he(this.value,Ee,be);if(ae.operator==="")return Ee=new B(this.value,be),he(ae.semver,Ee,be);var We=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Ve=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),tt=this.semver.version===ae.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),et=ce(this.semver,"<",ae.semver,be)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),it=ce(this.semver,">",ae.semver,be)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return We||Ve||tt&&Xe||et||it},e.Range=B,B.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},B.prototype.toString=function(){return this.range},B.prototype.parseRange=function(ae){var be=this.loose;ae=ae.trim(),D("range",ae,be);var Ee=be?R[ue]:R[pe];ae=ae.replace(Ee,K),D("hyphen replace",ae),ae=ae.replace(R[_],"$1$2$3"),D("comparator trim",ae,R[_]),ae=(ae=(ae=ae.replace(R[Z],"$1~")).replace(R[P],"$1^")).split(/\s+/).join(" ");var We=be?R[q]:R[le],Ve=ae.split(" ").map(function(tt){return function(Xe,et){return D("comp",Xe),Xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(ot,Y){D("caret",ot,Y);var Q=Y?R[V]:R[F];return ot.replace(Q,function(ge,Me,ze,He,Ye){var nt;return D("caret",ot,ge,Me,ze,He,Ye),W(Me)?nt="":W(ze)?nt=">="+Me+".0.0 <"+(+Me+1)+".0.0":W(He)?nt=Me==="0"?">="+Me+"."+ze+".0 <"+Me+"."+(+ze+1)+".0":">="+Me+"."+ze+".0 <"+(+Me+1)+".0.0":Ye?(D("replaceCaret pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),nt=Me==="0"?ze==="0"?">="+Me+"."+ze+"."+He+Ye+" <"+Me+"."+ze+"."+(+He+1):">="+Me+"."+ze+"."+He+Ye+" <"+Me+"."+(+ze+1)+".0":">="+Me+"."+ze+"."+He+Ye+" <"+(+Me+1)+".0.0"):(D("no pr"),nt=Me==="0"?ze==="0"?">="+Me+"."+ze+"."+He+" <"+Me+"."+ze+"."+(+He+1):">="+Me+"."+ze+"."+He+" <"+Me+"."+(+ze+1)+".0":">="+Me+"."+ze+"."+He+" <"+(+Me+1)+".0.0"),D("caret return",nt),nt})}(Fe,dt)}).join(" ")}(Xe,et),D("caret",Xe),Xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(ot,Y){var Q=Y?R[L]:R[x];return ot.replace(Q,function(ge,Me,ze,He,Ye){var nt;return D("tilde",ot,ge,Me,ze,He,Ye),W(Me)?nt="":W(ze)?nt=">="+Me+".0.0 <"+(+Me+1)+".0.0":W(He)?nt=">="+Me+"."+ze+".0 <"+Me+"."+(+ze+1)+".0":Ye?(D("replaceTilde pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),nt=">="+Me+"."+ze+"."+He+Ye+" <"+Me+"."+(+ze+1)+".0"):nt=">="+Me+"."+ze+"."+He+" <"+Me+"."+(+ze+1)+".0",D("tilde return",nt),nt})}(Fe,dt)}).join(" ")}(Xe,et),D("tildes",Xe),Xe=function(it,dt){return D("replaceXRanges",it,dt),it.split(/\s+/).map(function(Fe){return function(ot,Y){ot=ot.trim();var Q=Y?R[C]:R[d];return ot.replace(Q,function(ge,Me,ze,He,Ye,nt){D("xRange",ot,ge,Me,ze,He,Ye,nt);var vt=W(ze),wt=vt||W(He),Ct=wt||W(Ye);return Me==="="&&Ct&&(Me=""),vt?ge=Me===">"||Me==="<"?"<0.0.0":"*":Me&&Ct?(wt&&(He=0),Ct&&(Ye=0),Me===">"?(Me=">=",wt?(ze=+ze+1,He=0,Ye=0):Ct&&(He=+He+1,Ye=0)):Me==="<="&&(Me="<",wt?ze=+ze+1:He=+He+1),ge=Me+ze+"."+He+"."+Ye):wt?ge=">="+ze+".0.0 <"+(+ze+1)+".0.0":Ct&&(ge=">="+ze+"."+He+".0 <"+ze+"."+(+He+1)+".0"),D("xRange return",ge),ge})}(Fe,dt)}).join(" ")}(Xe,et),D("xrange",Xe),Xe=function(it,dt){return D("replaceStars",it,dt),it.trim().replace(R[de],"")}(Xe,et),D("stars",Xe),Xe}(tt,be)}).join(" ").split(/\s+/);return this.loose&&(Ve=Ve.filter(function(tt){return!!tt.match(We)})),Ve=Ve.map(function(tt){return new J(tt,be)})},B.prototype.intersects=function(ae,be){if(!(ae instanceof B))throw new TypeError("a Range is required");return this.set.some(function(Ee){return Ee.every(function(We){return ae.set.some(function(Ve){return Ve.every(function(tt){return We.intersects(tt,be)})})})})},e.toComparators=function(ae,be){return new B(ae,be).set.map(function(Ee){return Ee.map(function(We){return We.value}).join(" ").trim().split(" ")})},B.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new H(ae,this.loose));for(var be=0;be<this.set.length;be++)if(ee(this.set[be],ae))return!0;return!1},e.satisfies=he,e.maxSatisfying=function(ae,be,Ee){var We=null,Ve=null;try{var tt=new B(be,Ee)}catch{return null}return ae.forEach(function(Xe){tt.test(Xe)&&(We&&Ve.compare(Xe)!==-1||(Ve=new H(We=Xe,Ee)))}),We},e.minSatisfying=function(ae,be,Ee){var We=null,Ve=null;try{var tt=new B(be,Ee)}catch{return null}return ae.forEach(function(Xe){tt.test(Xe)&&(We&&Ve.compare(Xe)!==1||(Ve=new H(We=Xe,Ee)))}),We},e.validRange=function(ae,be){try{return new B(ae,be).range||"*"}catch{return null}},e.ltr=function(ae,be,Ee){return ye(ae,be,"<",Ee)},e.gtr=function(ae,be,Ee){return ye(ae,be,">",Ee)},e.outside=ye,e.prerelease=function(ae,be){var Ee=G(ae,be);return Ee&&Ee.prerelease.length?Ee.prerelease:null},e.intersects=function(ae,be,Ee){return ae=new B(ae,Ee),be=new B(be,Ee),ae.intersects(be)},e.coerce=function(ae){if(ae instanceof H)return ae;if(typeof ae!="string")return null;var be=ae.match(R[O]);return be==null?null:G((be[1]||"0")+"."+(be[2]||"0")+"."+(be[3]||"0"))}}).call(this,r(1))},function(te,e){var r,k,D=te.exports={};function N(){throw new Error("setTimeout has not been defined")}function S(){throw new Error("clearTimeout has not been defined")}function R(o){if(r===setTimeout)return setTimeout(o,0);if((r===N||!r)&&setTimeout)return r=setTimeout,setTimeout(o,0);try{return r(o,0)}catch{try{return r.call(null,o,0)}catch{return r.call(this,o,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:N}catch{r=N}try{k=typeof clearTimeout=="function"?clearTimeout:S}catch{k=S}})();var y,T=[],M=!1,E=-1;function f(){M&&y&&(M=!1,y.length?T=y.concat(T):E=-1,T.length&&b())}function b(){if(!M){var o=R(f);M=!0;for(var l=T.length;l;){for(y=T,T=[];++E<l;)y&&y[E].run();E=-1,l=T.length}y=null,M=!1,function(v){if(k===clearTimeout)return clearTimeout(v);if((k===S||!k)&&clearTimeout)return k=clearTimeout,clearTimeout(v);try{k(v)}catch{try{return k.call(null,v)}catch{return k.call(this,v)}}}(o)}}function m(o,l){this.fun=o,this.array=l}function s(){}D.nextTick=function(o){var l=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)l[v-1]=arguments[v];T.push(new m(o,l)),T.length!==1||M||R(b)},m.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=s,D.addListener=s,D.once=s,D.off=s,D.removeListener=s,D.removeAllListeners=s,D.emit=s,D.prependListener=s,D.prependOnceListener=s,D.listeners=function(o){return[]},D.binding=function(o){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(o){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(Ie[114],Ce([1,0,12,6]),function(te,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(A){const p=A;return p?typeof p.read=="function":!1}e.isReadable=D;function N(A){const p=A;return p?[p.on,p.pause,p.resume,p.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=N;function S(A){const p=A;return p?N(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=S;function R(A,p){return new y(A,p)}e.newWriteableStream=R;class y{constructor(p,n){this.e=p,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(p){if(!this.a.destroyed){if(this.a.flowing)this.g(p);else if(this.b.data.push(p),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(p){this.a.destroyed||(this.a.flowing?this.h(p):this.b.error.push(p))}end(p){this.a.destroyed||(typeof p<"u"&&this.write(p),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(p){this.c.data.slice(0).forEach(n=>n(p))}h(p){this.c.error.length===0?(0,r.onUnexpectedError)(p):this.c.error.slice(0).forEach(n=>n(p))}i(){this.c.end.slice(0).forEach(p=>p())}on(p,n){if(!this.a.destroyed)switch(p){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(p,n){if(this.a.destroyed)return;let h;switch(p){case"data":h=this.c.data;break;case"end":h=this.c.end;break;case"error":h=this.c.error;break}if(h){const i=h.indexOf(n);i>=0&&h.splice(i,1)}}j(){if(this.b.data.length>0){const p=this.e(this.b.data);this.g(p),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(h=>h())}}k(){if(this.c.error.length>0){for(const p of this.b.error)this.h(p);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function T(A,p){const n=[];let h;for(;(h=A.read())!==null;)n.push(h);return p(n)}e.consumeReadable=T;function M(A,p,n){const h=[];let i;for(;(i=A.read())!==null&&h.length<n;)h.push(i);return i===null&&h.length>0?p(h):{read:()=>{if(h.length>0)return h.shift();if(typeof i<"u"){const a=i;return i=void 0,a}return A.read()}}}e.peekReadable=M;function E(A,p){return new Promise((n,h)=>{const i=[];f(A,{onData:a=>{p&&i.push(a)},onError:a=>{p?h(a):n(void 0)},onEnd:()=>{n(p?p(i):void 0)}})})}e.consumeStream=E;function f(A,p){let n=!1;return A.on("error",h=>{n||p.onError(h)}),A.on("end",()=>{n||p.onEnd()}),A.on("data",h=>{n||p.onData(h)}),(0,k.toDisposable)(()=>n=!0)}e.listenStream=f;function b(A,p){return new Promise((n,h)=>{const i=new k.DisposableStore,a=[],t=u=>{if(a.push(u),a.length>p)return i.dispose(),A.pause(),n({stream:A,buffer:a,ended:!1})},g=u=>h(u),c=()=>n({stream:A,buffer:a,ended:!0});i.add((0,k.toDisposable)(()=>A.removeListener("error",g))),A.on("error",g),i.add((0,k.toDisposable)(()=>A.removeListener("end",c))),A.on("end",c),i.add((0,k.toDisposable)(()=>A.removeListener("data",t))),A.on("data",t)})}e.peekStream=b;function m(A,p){const n=R(p);return n.end(A),n}e.toStream=m;function s(){const A=R(()=>{throw new Error("not supported")});return A.end(),A}e.emptyStream=s;function o(A){let p=!1;return{read:()=>p?null:(p=!0,A)}}e.toReadable=o;function l(A,p,n){const h=R(n);return f(A,{onData:i=>h.write(p.data(i)),onError:i=>h.error(p.error?p.error(i):i),onEnd:()=>h.end()}),h}e.transform=l;function v(A,p,n){let h=!1;return{read:()=>{const i=p.read();return h?i:(h=!0,i!==null?n([A,i]):A)}}}e.prefixedReadable=v;function w(A,p,n){let h=!1;const i=R(n);return f(p,{onData:a=>h?i.write(a):(h=!0,i.write(n([A,a]))),onError:a=>i.error(a),onEnd:()=>{h||(h=!0,i.write(A)),i.end()}}),i}e.prefixedStream=w}),define(Ie[23],Ce([1,0,114]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer<"u";let D,N;class S{static alloc(u){return k?new S(Buffer.allocUnsafe(u)):new S(new Uint8Array(u))}static wrap(u){return k&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new S(u)}static fromString(u,d){return!(d?.dontUseNodeBuffer||!1)&&k?new S(Buffer.from(u)):(D||(D=new TextEncoder),new S(D.encode(u)))}static fromByteArray(u){const d=S.alloc(u.length);for(let C=0,O=u.length;C<O;C++)d.buffer[C]=u[C];return d}static concat(u,d){if(typeof d>"u"){d=0;for(let j=0,Z=u.length;j<Z;j++)d+=u[j].byteLength}const C=S.alloc(d);let O=0;for(let j=0,Z=u.length;j<Z;j++){const x=u[j];C.set(x,O),O+=x.byteLength}return C}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=S.alloc(this.byteLength);return u.set(this),u}toString(){return k?this.buffer.toString():(N||(N=new TextDecoder),N.decode(this.buffer))}slice(u,d){return new S(this.buffer.subarray(u,d))}set(u,d){if(u instanceof S)this.buffer.set(u.buffer,d);else if(u instanceof Uint8Array)this.buffer.set(u,d);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),d);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),d);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return T(this.buffer,u)}writeUInt32BE(u,d){M(this.buffer,u,d)}readUInt32LE(u){return E(this.buffer,u)}writeUInt32LE(u,d){f(this.buffer,u,d)}readUInt8(u){return b(this.buffer,u)}writeUInt8(u,d){m(this.buffer,u,d)}}e.VSBuffer=S;function R(c,u){return c[u+0]<<0>>>0|c[u+1]<<8>>>0}e.readUInt16LE=R;function y(c,u,d){c[d+0]=u&255,u=u>>>8,c[d+1]=u&255}e.writeUInt16LE=y;function T(c,u){return c[u]*2**24+c[u+1]*2**16+c[u+2]*2**8+c[u+3]}e.readUInt32BE=T;function M(c,u,d){c[d+3]=u,u=u>>>8,c[d+2]=u,u=u>>>8,c[d+1]=u,u=u>>>8,c[d]=u}e.writeUInt32BE=M;function E(c,u){return c[u+0]<<0>>>0|c[u+1]<<8>>>0|c[u+2]<<16>>>0|c[u+3]<<24>>>0}e.readUInt32LE=E;function f(c,u,d){c[d+0]=u&255,u=u>>>8,c[d+1]=u&255,u=u>>>8,c[d+2]=u&255,u=u>>>8,c[d+3]=u&255}e.writeUInt32LE=f;function b(c,u){return c[u]}e.readUInt8=b;function m(c,u,d){c[d]=u}e.writeUInt8=m;function s(c){return r.consumeReadable(c,u=>S.concat(u))}e.readableToBuffer=s;function o(c){return r.toReadable(c)}e.bufferToReadable=o;function l(c){return r.consumeStream(c,u=>S.concat(u))}e.streamToBuffer=l;async function v(c){return c.ended?S.concat(c.buffer):S.concat([...c.buffer,await l(c.stream)])}e.bufferedStreamToBuffer=v;function w(c){return r.toStream(c,u=>S.concat(u))}e.bufferToStream=w;function A(c){return r.transform(c,{data:u=>typeof u=="string"?S.fromString(u):S.wrap(u)},u=>S.concat(u))}e.streamToBufferReadableStream=A;function p(c){return r.newWriteableStream(u=>S.concat(u),c)}e.newWriteableBufferStream=p;function n(c,u){return r.prefixedReadable(c,u,d=>S.concat(d))}e.prefixedBufferReadable=n;function h(c,u){return r.prefixedStream(c,u,d=>S.concat(d))}e.prefixedBufferStream=h;function i(c){let u=0,d=0,C=0;const O=new Uint8Array(Math.floor(c.length/4*3)),j=x=>{switch(d){case 3:O[C++]=u|x,d=0;break;case 2:O[C++]=u|x>>>2,u=x<<6,d=3;break;case 1:O[C++]=u|x>>>4,u=x<<4,d=2;break;default:u=x<<2,d=1}};for(let x=0;x<c.length;x++){const L=c.charCodeAt(x);if(L>=65&&L<=90)j(L-65);else if(L>=97&&L<=122)j(L-97+26);else if(L>=48&&L<=57)j(L-48+52);else if(L===43||L===45)j(62);else if(L===47||L===95)j(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${c[x]}`)}}const Z=C;for(;d>0;)j(0);return S.wrap(O).slice(0,Z)}e.decodeBase64=i;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:c},u=!0,d=!1){const C=d?t:a;let O="";const j=c.byteLength%3;let Z=0;for(;Z<c.byteLength-j;Z+=3){const x=c[Z+0],L=c[Z+1],$=c[Z+2];O+=C[x>>>2],O+=C[(x<<4|L>>>4)&63],O+=C[(L<<2|$>>>6)&63],O+=C[$&63]}if(j===1){const x=c[Z+0];O+=C[x>>>2],O+=C[x<<4&63],u&&(O+="==")}else if(j===2){const x=c[Z+0],L=c[Z+1];O+=C[x>>>2],O+=C[(x<<4|L>>>4)&63],O+=C[L<<2&63],u&&(O+="=")}return O}e.encodeBase64=g}),define(Ie[38],Ce([1,0,84]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var k;(function(S){function R(y){return y&&typeof y=="object"&&typeof y.id=="string"}S.isThemeColor=R})(k=e.ThemeColor||(e.ThemeColor={}));function D(S){return{id:S}}e.themeColorFromId=D;var N;(function(S){S.iconNameSegment="[A-Za-z0-9]+",S.iconNameExpression="[A-Za-z0-9-]+",S.iconModifierExpression="~[A-Za-z]+",S.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${S.iconNameExpression})(${S.iconModifierExpression})?$`);function y(v){const w=R.exec(v.id);if(!w)return y(r.Codicon.error);const[,A,p]=w,n=["codicon","codicon-"+A];return p&&n.push("codicon-modifier-"+p.substring(1)),n}S.asClassNameArray=y;function T(v){return y(v).join(" ")}S.asClassName=T;function M(v){return"."+y(v).join(".")}S.asCSSSelector=M;function E(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(typeof v.color>"u"||k.isThemeColor(v.color))}S.isThemeIcon=E;const f=new RegExp(`^\\$\\((${S.iconNameExpression}(?:${S.iconModifierExpression})?)\\)$`);function b(v){const w=f.exec(v);if(!w)return;const[,A]=w;return{id:A}}S.fromString=b;function m(v){return{id:v}}S.fromId=m;function s(v,w){let A=v.id;const p=A.lastIndexOf("~");return p!==-1&&(A=A.substring(0,p)),w&&(A=`${A}~${w}`),{id:A}}S.modify=s;function o(v){const w=v.id.lastIndexOf("~");if(w!==-1)return v.id.substring(w+1)}S.getModifier=o;function l(v,w){return v.id===w.id&&v.color?.id===w.color?.id}S.isEqual=l})(N=e.ThemeIcon||(e.ThemeIcon={}))}),define(Ie[34],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(D){return r.test(D)}e.isUUID=k,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(R){for(let y=0;y<R.length;y++)R[y]=Math.floor(Math.random()*256);return R};const N=new Uint8Array(16),S=[];for(let R=0;R<256;R++)S.push(R.toString(16).padStart(2,"0"));return function(){D(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let y=0,T="";return T+=S[N[y++]],T+=S[N[y++]],T+=S[N[y++]],T+=S[N[y++]],T+="-",T+=S[N[y++]],T+=S[N[y++]],T+="-",T+=S[N[y++]],T+=S[N[y++]],T+="-",T+=S[N[y++]],T+=S[N[y++]],T+="-",T+=S[N[y++]],T+=S[N[y++]],T+=S[N[y++]],T+=S[N[y++]],T+=S[N[y++]],T+=S[N[y++]],T}}()}),define(Ie[115],Ce([1,0,18,34]),function(te,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function D(R){return{id:(0,k.generateUuid)(),asString:async()=>R,asFile:()=>{},value:typeof R=="string"?R:void 0}}e.createStringDataTransferItem=D;function N(R,y,T){return{id:(0,k.generateUuid)(),asString:async()=>"",asFile:()=>({name:R,uri:y,data:T}),value:void 0}}e.createFileDataTransferItem=N;class S{constructor(){this.a=new Map}get size(){return this.a.size}has(y){return this.a.has(this.b(y))}get(y){return this.a.get(this.b(y))?.[0]}append(y,T){const M=this.a.get(y);M?M.push(T):this.a.set(this.b(y),[T])}replace(y,T){this.a.set(this.b(y),[T])}delete(y){this.a.delete(this.b(y))}*entries(){for(const[y,T]of this.a.entries())for(const M of T)yield[y,M]}values(){return Array.from(this.a.values()).flat()}forEach(y){for(const[T,M]of this.entries())y(M,T)}b(y){return y.toLowerCase()}}e.VSDataTransfer=S,e.UriList=Object.freeze({create:R=>(0,r.distinct)(R.map(y=>y.toString())).join(`\r
`),split:R=>R.split(`\r
`),parse:R=>e.UriList.split(R).filter(y=>!y.startsWith("#"))})}),define(Ie[116],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ie[117],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var r;(function(S){S[S.None=0]="None",S[S.Indent=1]="Indent",S[S.IndentOutdent=2]="IndentOutdent",S[S.Outdent=3]="Outdent"})(r=e.IndentAction||(e.IndentAction={}));class k{constructor(R){if(this.e=null,this.f=!1,this.open=R.open,this.close=R.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(R.notIn))for(let y=0,T=R.notIn.length;y<T;y++)switch(R.notIn[y]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(R){switch(R){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(R,y){if(R.getTokenCount()===0)return!0;const T=R.findTokenIndexAtOffset(y-2),M=R.getStandardTokenType(T);return this.isOK(M)}g(R,y){for(let T=R;T<=y;T++){const M=String.fromCharCode(T);if(!this.open.includes(M)&&!this.close.includes(M))return M}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=k;class D{constructor(R){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of R)N(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),N(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),N(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),N(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&N(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=D;function N(S,R,y){S.has(R)?S.get(R).push(y):S.set(R,[y])}}),define(Ie[118],Ce([13,14]),function(te,e){return te.create("vs/base/common/actions",e)}),define(Ie[119],Ce([13,14]),function(te,e){return te.create("vs/base/common/date",e)}),define(Ie[120],Ce([1,0,119]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const k=60,D=k*60,N=D*24,S=N*7,R=N*30,y=N*365;function T(E,f,b,m){typeof E!="number"&&(E=E.getTime());const s=Math.round((new Date().getTime()-E)/1e3);if(s<-30)return(0,r.localize)(0,null,T(new Date().getTime()+s*1e3,!1));if(!m&&s<30)return(0,r.localize)(1,null);let o;return s<k?(o=s,f?o===1?b?(0,r.localize)(2,null,o):(0,r.localize)(3,null,o):b?(0,r.localize)(4,null,o):(0,r.localize)(5,null,o):o===1?b?(0,r.localize)(6,null,o):(0,r.localize)(7,null,o):b?(0,r.localize)(8,null,o):(0,r.localize)(9,null,o)):s<D?(o=Math.floor(s/k),f?o===1?b?(0,r.localize)(10,null,o):(0,r.localize)(11,null,o):b?(0,r.localize)(12,null,o):(0,r.localize)(13,null,o):o===1?b?(0,r.localize)(14,null,o):(0,r.localize)(15,null,o):b?(0,r.localize)(16,null,o):(0,r.localize)(17,null,o)):s<N?(o=Math.floor(s/D),f?o===1?b?(0,r.localize)(18,null,o):(0,r.localize)(19,null,o):b?(0,r.localize)(20,null,o):(0,r.localize)(21,null,o):o===1?b?(0,r.localize)(22,null,o):(0,r.localize)(23,null,o):b?(0,r.localize)(24,null,o):(0,r.localize)(25,null,o)):s<S?(o=Math.floor(s/N),f?o===1?(0,r.localize)(26,null,o):(0,r.localize)(27,null,o):o===1?(0,r.localize)(28,null,o):(0,r.localize)(29,null,o)):s<R?(o=Math.floor(s/S),f?o===1?b?(0,r.localize)(30,null,o):(0,r.localize)(31,null,o):b?(0,r.localize)(32,null,o):(0,r.localize)(33,null,o):o===1?b?(0,r.localize)(34,null,o):(0,r.localize)(35,null,o):b?(0,r.localize)(36,null,o):(0,r.localize)(37,null,o)):s<y?(o=Math.floor(s/R),f?o===1?b?(0,r.localize)(38,null,o):(0,r.localize)(39,null,o):b?(0,r.localize)(40,null,o):(0,r.localize)(41,null,o):o===1?b?(0,r.localize)(42,null,o):(0,r.localize)(43,null,o):b?(0,r.localize)(44,null,o):(0,r.localize)(45,null,o)):(o=Math.floor(s/y),f?o===1?b?(0,r.localize)(46,null,o):(0,r.localize)(47,null,o):b?(0,r.localize)(48,null,o):(0,r.localize)(49,null,o):o===1?b?(0,r.localize)(50,null,o):(0,r.localize)(51,null,o):b?(0,r.localize)(52,null,o):(0,r.localize)(53,null,o))}e.fromNow=T;function M(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=M}),define(Ie[121],Ce([13,14]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(Ie[39],Ce([1,0,18,9,121]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function N(E,f){return f&&(E.stack||E.stacktrace)?D.localize(0,null,R(E),S(E.stack)||S(E.stacktrace)):R(E)}function S(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?D.localize(1,null,E.message):E.message||D.localize(2,null)}function y(E=null,f=!1){if(!E)return D.localize(3,null);if(Array.isArray(E)){const b=r.coalesce(E),m=y(b[0],f);return b.length>1?D.localize(4,null,m,b.length):m}if(k.isString(E))return E;if(E.detail){const b=E.detail;if(b.error)return N(b.error,f);if(b.exception)return N(b.exception,f)}return E.stack?N(E,f):E.message?E.message:D.localize(5,null)}e.toErrorMessage=y;function T(E){const f=E;return f instanceof Error&&Array.isArray(f.actions)}e.isErrorWithActions=T;function M(E,f){let b;return typeof E=="string"?b=new Error(E):b=E,b.actions=f,b}e.createErrorWithActions=M}),define(Ie[122],Ce([1,0,85,19]),function(te,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new r.Lazy(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),N=new r.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),S=new r.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(u,d,C=!1){const O=u||"",j=d||"",Z=D.value.collator.compare(O,j);return D.value.collatorIsNumeric&&Z===0&&O!==j?O<j?-1:1:Z}e.compareFileNames=R;function y(u,d){const C=N.value.collator;return u=u||"",d=d||"",A(C,u,d)}e.compareFileNamesDefault=y;function T(u,d){const C=N.value.collator;return u=u||"",d=d||"",i(u,d)||A(C,u,d)}e.compareFileNamesUpper=T;function M(u,d){const C=N.value.collator;return u=u||"",d=d||"",h(u,d)||A(C,u,d)}e.compareFileNamesLower=M;function E(u,d){return u=u||"",d=d||"",u===d?0:u<d?-1:1}e.compareFileNamesUnicode=E;function f(u,d){const[C,O]=v(u),[j,Z]=v(d);let x=D.value.collator.compare(O,Z);if(x===0){if(D.value.collatorIsNumeric&&O!==Z)return O<Z?-1:1;if(x=D.value.collator.compare(C,j),D.value.collatorIsNumeric&&x===0&&C!==j)return C<j?-1:1}return x}e.compareFileExtensions=f;function b(u,d){u=u||"",d=d||"";const C=w(u),O=w(d),j=N.value.collator,Z=S.value.collator;return A(Z,C,O)||A(j,u,d)}e.compareFileExtensionsDefault=b;function m(u,d){u=u||"",d=d||"";const C=w(u),O=w(d),j=N.value.collator,Z=S.value.collator;return A(Z,C,O)||i(u,d)||A(j,u,d)}e.compareFileExtensionsUpper=m;function s(u,d){u=u||"",d=d||"";const C=w(u),O=w(d),j=N.value.collator,Z=S.value.collator;return A(Z,C,O)||h(u,d)||A(j,u,d)}e.compareFileExtensionsLower=s;function o(u,d){u=u||"",d=d||"";const C=w(u).toLowerCase(),O=w(d).toLowerCase();return C!==O?C<O?-1:1:u!==d?u<d?-1:1:0}e.compareFileExtensionsUnicode=o;const l=/^(.*?)(\.([^.]*))?$/;function v(u,d=!1){const C=u?l.exec(u):[];let O=[C&&C[1]||"",C&&C[3]||""];return d&&(!O[0]&&O[1]||O[0]&&O[0].charAt(0)===".")&&(O=[O[0]+"."+O[1],""]),O}function w(u){const d=u?l.exec(u):[];return d&&d[1]&&d[1].charAt(0)!=="."&&d[3]||""}function A(u,d,C){const O=u.compare(d,C);return O!==0?O:d.length!==C.length?d.length<C.length?-1:1:0}function p(u){const d=u.charAt(0);return d.toLocaleUpperCase()!==d}function n(u){const d=u.charAt(0);return d.toLocaleLowerCase()!==d}function h(u,d){return p(u)&&n(d)?-1:n(u)&&p(d)?1:0}function i(u,d){return n(u)&&p(d)?-1:p(u)&&n(d)?1:0}function a(u,d,C=!1){return C||(u=u&&u.toLowerCase(),d=d&&d.toLowerCase()),u===d?0:u<d?-1:1}function t(u,d,C=!1){const O=u.split(k.sep),j=d.split(k.sep),Z=O.length-1,x=j.length-1;let L,$;for(let P=0;;P++){if(L=Z===P,$=x===P,L&&$)return R(O[P],j[P],C);if(L)return-1;if($)return 1;const F=a(O[P],j[P],C);if(F!==0)return F}}e.comparePaths=t;function g(u,d,C){const O=u.toLowerCase(),j=d.toLowerCase(),Z=c(u,d,C);if(Z)return Z;const x=O.endsWith(C),L=j.endsWith(C);if(x!==L)return x?-1:1;const $=R(O,j);return $!==0?$:O.localeCompare(j)}e.compareAnything=g;function c(u,d,C){const O=u.toLowerCase(),j=d.toLowerCase(),Z=O.startsWith(C),x=j.startsWith(C);if(Z!==x)return Z?-1:1;if(Z&&x){if(O.length<j.length)return-1;if(O.length>j.length)return 1}return 0}e.compareByPrefix=c}),define(Ie[64],Ce([1,0,19]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(M){const E=(0,r.extname)(M),f=k[E.toLowerCase()];return f!==void 0?f:S(M)}e.getMediaOrTextMime=N;function S(M){const E=(0,r.extname)(M);return D[E.toLowerCase()]}e.getMediaMime=S;function R(M){for(const E in D)if(D[E]===M)return E}e.getExtensionForMimeType=R;const y=/^(.+)\/(.+?)(;.+)?$/;function T(M,E){const f=y.exec(M);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:E?void 0:M}e.normalizeMimeType=T}),define(Ie[123],Ce([1,0,4,6,118]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class N extends k.Disposable{constructor(f,b="",m="",s=!0,o){super(),this.h=this.B(new r.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=f,this.m=b,this.u=m,this.w=s,this.C=o}get id(){return this.j}get label(){return this.m}set label(f){this.D(f)}D(f){this.m!==f&&(this.m=f,this.h.fire({label:f}))}get tooltip(){return this.n||""}set tooltip(f){this.F(f)}F(f){this.n!==f&&(this.n=f,this.h.fire({tooltip:f}))}get class(){return this.u}set class(f){this.G(f)}G(f){this.u!==f&&(this.u=f,this.h.fire({class:f}))}get enabled(){return this.w}set enabled(f){this.H(f)}H(f){this.w!==f&&(this.w=f,this.h.fire({enabled:f}))}get checked(){return this.z}set checked(f){this.I(f)}I(f){this.z!==f&&(this.z=f,this.h.fire({checked:f}))}async run(f,b){this.C&&await this.C(f)}}e.Action=N;class S extends k.Disposable{constructor(){super(...arguments),this.f=this.B(new r.Emitter),this.onWillRun=this.f.event,this.h=this.B(new r.Emitter),this.onDidRun=this.h.event}async run(f,b){if(!f.enabled)return;this.f.fire({action:f});let m;try{await this.runAction(f,b)}catch(s){m=s}this.h.fire({action:f,error:m})}async runAction(f,b){await f.run(b)}}e.ActionRunner=S;class R{constructor(){this.id=R.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...f){let b=[];for(const m of f)m.length&&(b.length?b=[...b,new R,...m]:b=m);return b}async run(){}}e.Separator=R,R.ID="vs.actions.separator";class y{get actions(){return this.a}constructor(f,b,m,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=f,this.label=b,this.class=s,this.a=m}async run(){}}e.SubmenuAction=y;class T extends N{constructor(){super(T.ID,D.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=T,T.ID="vs.actions.empty";function M(E){return{id:E.id,label:E.label,class:void 0,enabled:E.enabled??!0,checked:E.checked??!1,run:async()=>E.run(),tooltip:E.label}}e.toAction=M}),define(Ie[40],Ce([1,0,19,20,10,9]),function(te,e,r,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function S(t){return t===47||t===92}e.isPathSeparator=S;function R(t){return t.replace(/[\\/]/g,r.posix.sep)}e.toSlashes=R;function y(t){return t.indexOf("/")===-1&&(t=R(t)),/^[a-zA-Z]:(\/|$)/.test(t)&&(t="/"+t),t}e.toPosixPath=y;function T(t,g=r.posix.sep){if(!t)return"";const c=t.length,u=t.charCodeAt(0);if(S(u)){if(S(t.charCodeAt(1))&&!S(t.charCodeAt(2))){let C=3;const O=C;for(;C<c&&!S(t.charCodeAt(C));C++);if(O!==C&&!S(t.charCodeAt(C+1))){for(C+=1;C<c;C++)if(S(t.charCodeAt(C)))return t.slice(0,C+1).replace(/[\\/]/g,g)}}return g}else if(l(u)&&t.charCodeAt(1)===58)return S(t.charCodeAt(2))?t.slice(0,2)+g:t.slice(0,2);let d=t.indexOf("://");if(d!==-1){for(d+=3;d<c;d++)if(S(t.charCodeAt(d)))return t.slice(0,d+1)}return""}e.getRoot=T;function M(t){if(!k.isWindows||!t||t.length<5)return!1;let g=t.charCodeAt(0);if(g!==92||(g=t.charCodeAt(1),g!==92))return!1;let c=2;const u=c;for(;c<t.length&&(g=t.charCodeAt(c),g!==92);c++);return!(u===c||(g=t.charCodeAt(c+1),isNaN(g)||g===92))}e.isUNC=M;const E=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(t,g=k.isWindows){const c=g?E:f;return!(!t||t.length===0||/^\s+$/.test(t)||(c.lastIndex=0,c.test(t))||g&&b.test(t)||t==="."||t===".."||g&&t[t.length-1]==="."||g&&t.length!==t.trim().length||t.length>255)}e.isValidBasename=m;function s(t,g,c){const u=t===g;return!c||u?u:!t||!g?!1:(0,D.equalsIgnoreCase)(t,g)}e.isEqual=s;function o(t,g,c,u=r.sep){if(t===g)return!0;if(!t||!g||g.length>t.length)return!1;if(c){if(!(0,D.startsWithIgnoreCase)(t,g))return!1;if(g.length===t.length)return!0;let C=g.length;return g.charAt(g.length-1)===u&&C--,t.charAt(C)===u}return g.charAt(g.length-1)!==u&&(g+=u),t.indexOf(g)===0}e.isEqualOrParent=o;function l(t){return t>=65&&t<=90||t>=97&&t<=122}e.isWindowsDriveLetter=l;function v(t,g){return k.isWindows&&t.endsWith(":")&&(t+=r.sep),(0,r.isAbsolute)(t)||(t=(0,r.join)(g,t)),t=(0,r.normalize)(t),k.isWindows?(t=(0,D.rtrim)(t,r.sep),t.endsWith(":")&&(t+=r.sep)):(t=(0,D.rtrim)(t,r.sep),t||(t=r.sep)),t}e.sanitizeFilePath=v;function w(t){const g=(0,r.normalize)(t);return k.isWindows?t.length>3?!1:A(g)&&(t.length===2||g.charCodeAt(2)===92):g===r.posix.sep}e.isRootOrDriveLetter=w;function A(t,g=k.isWindows){return g?l(t.charCodeAt(0))&&t.charCodeAt(1)===58:!1}e.hasDriveLetter=A;function p(t){return A(t)?t[0]:void 0}e.getDriveLetter=p;function n(t,g,c){return g.length>t.length?-1:t===g?0:(c&&(t=t.toLowerCase(),g=g.toLowerCase()),t.indexOf(g))}e.indexOfPath=n;function h(t){const g=t.split(":");let c,u,d;for(const C of g){const O=Number(C);(0,N.isNumber)(O)?u===void 0?u=O:d===void 0&&(d=O):c=c?[c,C].join(":"):C}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:u!==void 0?u:void 0,column:d!==void 0?d:u!==void 0?1:void 0}}e.parseLineAndColumnAware=h;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function a(t,g,c=8){let u="";for(let C=0;C<c;C++)u+=i.charAt(Math.floor(Math.random()*i.length));let d;return g?d=`${g}-${u}`:d=u,t?(0,r.join)(t,d):d}e.randomPath=a}),define(Ie[124],Ce([1,0,28,10]),function(te,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...J){return function(I,B){for(let W=0,K=J.length;W<K;W++){const ee=J[W](I,B);if(ee)return ee}return null}}e.or=D,e.matchesStrictPrefix=N.bind(void 0,!1),e.matchesPrefix=N.bind(void 0,!0);function N(J,I,B){if(!B||B.length<I.length)return null;let W;return J?W=k.startsWithIgnoreCase(B,I):W=B.indexOf(I)===0,W?I.length>0?[{start:0,end:I.length}]:[]:null}function S(J,I){const B=I.toLowerCase().indexOf(J.toLowerCase());return B===-1?null:[{start:B,end:B+J.length}]}e.matchesContiguousSubString=S;function R(J,I){return y(J.toLowerCase(),I.toLowerCase(),0,0)}e.matchesSubString=R;function y(J,I,B,W){if(B===J.length)return[];if(W===I.length)return null;if(J[B]===I[W]){let K=null;return(K=y(J,I,B+1,W+1))?l({start:W,end:W+1},K):null}return y(J,I,B,W+1)}function T(J){return 97<=J&&J<=122}function M(J){return 65<=J&&J<=90}e.isUpper=M;function E(J){return 48<=J&&J<=57}function f(J){return J===32||J===9||J===10||J===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(J=>b.add(J.charCodeAt(0)));function m(J){return f(J)||b.has(J)}function s(J,I){return J===I||m(J)&&m(I)}function o(J){return T(J)||M(J)||E(J)}function l(J,I){return I.length===0?I=[J]:J.end===I[0].start?I[0].start=J.start:I.unshift(J),I}function v(J,I){for(let B=I;B<J.length;B++){const W=J.charCodeAt(B);if(M(W)||E(W)||B>0&&!o(J.charCodeAt(B-1)))return B}return J.length}function w(J,I,B,W){if(B===J.length)return[];if(W===I.length)return null;if(J[B]!==I[W].toLowerCase())return null;{let K=null,ee=W+1;for(K=w(J,I,B+1,W+1);!K&&(ee=v(I,ee))<I.length;)K=w(J,I,B+1,ee),ee++;return K===null?null:l({start:W,end:W+1},K)}}function A(J){let I=0,B=0,W=0,K=0,ee=0;for(let Ee=0;Ee<J.length;Ee++)ee=J.charCodeAt(Ee),M(ee)&&I++,T(ee)&&B++,o(ee)&&W++,E(ee)&&K++;const he=I/J.length,ye=B/J.length,ae=W/J.length,be=K/J.length;return{upperPercent:he,lowerPercent:ye,alphaPercent:ae,numericPercent:be}}function p(J){const{upperPercent:I,lowerPercent:B}=J;return B===0&&I>.6}function n(J){const{upperPercent:I,lowerPercent:B,alphaPercent:W,numericPercent:K}=J;return B>.2&&I<.8&&W>.6&&K<.2}function h(J){let I=0,B=0,W=0,K=0;for(let ee=0;ee<J.length;ee++)W=J.charCodeAt(ee),M(W)&&I++,T(W)&&B++,f(W)&&K++;return(I===0||B===0)&&K===0?J.length<=30:I<=5}function i(J,I){if(!I||(I=I.trim(),I.length===0)||!h(J)||I.length>60)return null;const B=A(I);if(!n(B)){if(!p(B))return null;I=I.toLowerCase()}let W=null,K=0;for(J=J.toLowerCase();K<I.length&&(W=w(J,I,0,K))===null;)K=v(I,K+1);return W}e.matchesCamelCase=i;function a(J,I,B=!1){if(!I||I.length===0)return null;let W=null,K=0;for(J=J.toLowerCase(),I=I.toLowerCase();K<I.length&&(W=t(J,I,0,K,B))===null;)K=g(I,K+1);return W}e.matchesWords=a;function t(J,I,B,W,K){if(B===J.length)return[];if(W===I.length)return null;if(s(J.charCodeAt(B),I.charCodeAt(W))){let ee=null,he=W+1;if(ee=t(J,I,B+1,W+1,K),!K)for(;!ee&&(he=g(I,he))<I.length;)ee=t(J,I,B+1,he,K),he++;return ee?J.charCodeAt(B)!==I.charCodeAt(W)?ee:l({start:W,end:W+1},ee):null}else return null}function g(J,I){for(let B=I;B<J.length;B++)if(m(J.charCodeAt(B))||B>0&&m(J.charCodeAt(B-1)))return B;return J.length}const c=D(e.matchesPrefix,i,S),u=D(e.matchesPrefix,i,R),d=new r.LRUCache(1e4);function C(J,I,B=!1){if(typeof J!="string"||typeof I!="string")return null;let W=d.get(J);W||(W=new RegExp(k.convertSimple2RegExpPattern(J),"i"),d.set(J,W));const K=W.exec(I);return K?[{start:K.index,end:K.index+K[0].length}]:B?u(J,I):c(J,I)}e.matchesFuzzy=C;function O(J,I){const B=Ue(J,J.toLowerCase(),0,I,I.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return B?Z(B):null}e.matchesFuzzy2=O;function j(J,I,B,W,K,ee){const he=Math.min(13,J.length);for(;B<he;B++){const ye=Ue(J,I,B,W,K,ee,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ye)return ye}return[0,ee]}e.anyScore=j;function Z(J){if(typeof J>"u")return[];const I=[],B=J[1];for(let W=J.length-1;W>1;W--){const K=J[W]+B,ee=I[I.length-1];ee&&ee.end===K?ee.end=K+1:I.push({start:K,end:K+1})}return I}e.createMatches=Z;const x=128;function L(){const J=[],I=[];for(let B=0;B<=x;B++)I[B]=0;for(let B=0;B<=x;B++)J.push(I.slice(0));return J}function $(J){const I=[];for(let B=0;B<=J;B++)I[B]=0;return I}const P=$(2*x),F=$(2*x),V=L(),q=L(),le=L(),_=!1;function pe(J,I,B,W,K){function ee(ye,ae,be=" "){for(;ye.length<ae;)ye=be+ye;return ye}let he=` |   |${W.split("").map(ye=>ee(ye,3)).join("|")}
`;for(let ye=0;ye<=B;ye++)ye===0?he+=" |":he+=`${I[ye-1]}|`,he+=J[ye].slice(0,K+1).map(ae=>ee(ae.toString(),3)).join("|")+`
`;return he}function ue(J,I,B,W){J=J.substr(I),B=B.substr(W),console.log(pe(q,J,J.length,B,B.length)),console.log(pe(le,J,J.length,B,B.length)),console.log(pe(V,J,J.length,B,B.length))}function de(J,I){if(I<0||I>=J.length)return!1;const B=J.codePointAt(I);switch(B){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!k.isEmojiImprecise(B)}}function re(J,I){if(I<0||I>=J.length)return!1;switch(J.charCodeAt(I)){case 32:case 9:return!0;default:return!1}}function G(J,I,B){return I[J]!==B[J]}function H(J,I,B,W,K,ee,he=!1){for(;I<B&&K<ee;)J[I]===W[K]&&(he&&(P[I]=K),I+=1),K+=1;return I===B}e.isPatternInWord=H;var oe;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(oe||(oe={}));var ve;(function(J){J.Default=[-100,0];function I(B){return!B||B.length===2&&B[0]===-100&&B[1]===0}J.isDefault=I})(ve=e.FuzzyScore||(e.FuzzyScore={}));class Ae{constructor(I,B){this.firstMatchCanBeWeak=I,this.boostFullMatch=B}}e.FuzzyScoreOptions=Ae,Ae.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Ue(J,I,B,W,K,ee,he=Ae.default){const ye=J.length>x?x:J.length,ae=W.length>x?x:W.length;if(B>=ye||ee>=ae||ye-B>ae-ee||!H(I,B,ye,K,ee,ae,!0))return;xe(ye,ae,B,ee,I,K);let be=1,Ee=1,We=B,Ve=ee;const tt=[!1];for(be=1,We=B;We<ye;be++,We++){const Fe=P[We],ot=F[We],Y=We+1<ye?F[We+1]:ae;for(Ee=Fe-ee+1,Ve=Fe;Ve<Y;Ee++,Ve++){let Q=Number.MIN_SAFE_INTEGER,ge=!1;Ve<=ot&&(Q=Te(J,I,We,B,W,K,Ve,ae,ee,V[be-1][Ee-1]===0,tt));let Me=0;Q!==Number.MAX_SAFE_INTEGER&&(ge=!0,Me=Q+q[be-1][Ee-1]);const ze=Ve>Fe,He=ze?q[be][Ee-1]+(V[be][Ee-1]>0?-5:0):0,Ye=Ve>Fe+1&&V[be][Ee-1]>0,nt=Ye?q[be][Ee-2]+(V[be][Ee-2]>0?-5:0):0;if(Ye&&(!ze||nt>=He)&&(!ge||nt>=Me))q[be][Ee]=nt,le[be][Ee]=3,V[be][Ee]=0;else if(ze&&(!ge||He>=Me))q[be][Ee]=He,le[be][Ee]=2,V[be][Ee]=0;else if(ge)q[be][Ee]=Me,le[be][Ee]=1,V[be][Ee]=V[be-1][Ee-1]+1;else throw new Error("not possible")}}if(_&&ue(J,B,W,ee),!tt[0]&&!he.firstMatchCanBeWeak)return;be--,Ee--;const Xe=[q[be][Ee],ee];let et=0,it=0;for(;be>=1;){let Fe=Ee;do{const ot=le[be][Fe];if(ot===3)Fe=Fe-2;else if(ot===2)Fe=Fe-1;else break}while(Fe>=1);et>1&&I[B+be-1]===K[ee+Ee-1]&&!G(Fe+ee-1,W,K)&&et+1>V[be][Fe]&&(Fe=Ee),Fe===Ee?et++:et=1,it||(it=Fe),be--,Ee=Fe-1,Xe.push(Ee)}ae===ye&&he.boostFullMatch&&(Xe[0]+=2);const dt=it-ye;return Xe[0]-=dt,Xe}e.fuzzyScore=Ue;function xe(J,I,B,W,K,ee){let he=J-1,ye=I-1;for(;he>=B&&ye>=W;)K[he]===ee[ye]&&(F[he]=ye,he--),ye--}function Te(J,I,B,W,K,ee,he,ye,ae,be,Ee){if(I[B]!==ee[he])return Number.MIN_SAFE_INTEGER;let We=1,Ve=!1;return he===B-W?We=J[B]===K[he]?7:5:G(he,K,ee)&&(he===0||!G(he-1,K,ee))?(We=J[B]===K[he]?7:5,Ve=!0):de(ee,he)&&(he===0||!de(ee,he-1))?We=5:(de(ee,he-1)||re(ee,he-1))&&(We=5,Ve=!0),We>1&&B===W&&(Ee[0]=!0),Ve||(Ve=G(he,K,ee)||de(ee,he-1)||re(ee,he-1)),B===W?he>ae&&(We-=Ve?3:5):be?We+=Ve?2:0:We+=Ve?0:1,he+1===ye&&(We-=Ve?3:5),We}function Se(J,I,B,W,K,ee,he){return se(J,I,B,W,K,ee,!0,he)}e.fuzzyScoreGracefulAggressive=Se;function ke(J,I,B,W,K,ee,he){return se(J,I,B,W,K,ee,!1,he)}e.fuzzyScoreGraceful=ke;function se(J,I,B,W,K,ee,he,ye){let ae=Ue(J,I,B,W,K,ee,ye);if(ae&&!he)return ae;if(J.length>=3){const be=Math.min(7,J.length-1);for(let Ee=B+1;Ee<be;Ee++){const We=ce(J,Ee);if(We){const Ve=Ue(We,We.toLowerCase(),B,W,K,ee,ye);Ve&&(Ve[0]-=3,(!ae||Ve[0]>ae[0])&&(ae=Ve))}}}return ae}function ce(J,I){if(I+1>=J.length)return;const B=J[I],W=J[I+1];if(B!==W)return J.slice(0,I)+W+B+J.slice(I+2)}}),define(Ie[125],Ce([1,0,124,10,38]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const N="$(",S=new RegExp(`\\$\\(${D.ThemeIcon.iconNameExpression}(?:${D.ThemeIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${S.source}`,"g");function y(o){return o.replace(R,(l,v)=>v?l:`\\${l}`)}e.escapeIcons=y;const T=new RegExp(`\\\\${S.source}`,"g");function M(o){return o.replace(T,l=>`\\${l}`)}e.markdownEscapeEscapedIcons=M;const E=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function f(o){return o.indexOf(N)===-1?o:o.replace(E,(l,v,w,A)=>w?l:v||A||"")}e.stripIcons=f;const b=new RegExp(`\\$\\(${D.ThemeIcon.iconNameCharacter}+\\)`,"g");function m(o){b.lastIndex=0;let l="";const v=[];let w=0;for(;;){const A=b.lastIndex,p=b.exec(o),n=o.substring(A,p?.index);if(n.length>0){l+=n;for(let h=0;h<n.length;h++)v.push(w)}if(!p)break;w+=p[0].length}return{text:l,iconOffsets:v}}e.parseLabelWithIcons=m;function s(o,l,v=!1){const{text:w,iconOffsets:A}=l;if(!A||A.length===0)return(0,r.matchesFuzzy)(o,w,v);const p=(0,k.ltrim)(w," "),n=w.length-p.length,h=(0,r.matchesFuzzy)(o,p,v);if(h)for(const i of h){const a=A[i.start+n]+n;i.start+=a,i.end+=a}return h}e.matchesFuzzyIconAware=s}),define(Ie[29],Ce([1,0,10]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var k;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(k||(k={})),function(D){const N="error",S="warning",R="warn",y="info",T="ignore";function M(f){return f?r.equalsIgnoreCase(N,f)?D.Error:r.equalsIgnoreCase(S,f)||r.equalsIgnoreCase(R,f)?D.Warning:r.equalsIgnoreCase(y,f)?D.Info:D.Ignore:D.Ignore}D.fromValue=M;function E(f){switch(f){case D.Error:return N;case D.Warning:return S;case D.Info:return y;default:return T}}D.toString=E}(k||(k={})),e.default=k}),define(Ie[47],Ce([1,0,18,10]),function(te,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class D{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const m=b.charCodeAt(0),s=this.b.charCodeAt(this.c);return m-s}value(){return this.b[this.c]}}e.StringIterator=D;class N{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,k.compareSubstring)(b,this.b,0,b.length,this.c,this.d):(0,k.compareSubstringIgnoreCase)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=N;class S{constructor(b=!0,m=!0){this.f=b,this.g=m}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let m=b.length-1;m>=0;m--,this.c--){const s=this.b.charCodeAt(m);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,k.compareSubstring)(b,this.b,0,b.length,this.d,this.e):(0,k.compareSubstringIgnoreCase)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=S;var R;(function(f){f[f.Scheme=1]="Scheme",f[f.Authority=2]="Authority",f[f.Path=3]="Path",f[f.Query=4]="Query",f[f.Fragment=5]="Fragment"})(R||(R={}));class y{constructor(b,m){this.f=b,this.g=m,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new S(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,k.compareIgnoreCase)(b,this.c.scheme);if(this.d[this.e]===2)return(0,k.compareIgnoreCase)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,k.compare)(b,this.c.query);if(this.d[this.e]===5)return(0,k.compare)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=y;class T{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var M;(function(f){f[f.Left=-1]="Left",f[f.Mid=0]="Mid",f[f.Right=1]="Right"})(M||(M={}));class E{static forUris(b=()=>!1,m=()=>!1){return new E(new y(b,m))}static forPaths(b=!1){return new E(new S(void 0,!b))}static forStrings(){return new E(new D)}static forConfigKeys(){return new E(new N)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,m){if(m){const s=m.slice(0);(0,r.shuffle)(s);for(const o of s)this.set(o,b)}else{const s=b.slice(0);(0,r.shuffle)(s);for(const o of s)this.set(o[0],o[1])}}set(b,m){const s=this.b.reset(b);let o;this.c||(this.c=new T,this.c.segment=s.value());const l=[];for(o=this.c;;){const w=s.cmp(o.segment);if(w>0)o.left||(o.left=new T,o.left.segment=s.value()),l.push([-1,o]),o=o.left;else if(w<0)o.right||(o.right=new T,o.right.segment=s.value()),l.push([1,o]),o=o.right;else if(s.hasNext())s.next(),o.mid||(o.mid=new T,o.mid.segment=s.value()),l.push([0,o]),o=o.mid;else break}const v=o.value;o.value=m,o.key=b;for(let w=l.length-1;w>=0;w--){const A=l[w][1];A.updateHeight();const p=A.balanceFactor();if(p<-1||p>1){const n=l[w][0],h=l[w+1][0];if(n===1&&h===1)l[w][1]=A.rotateLeft();else if(n===-1&&h===-1)l[w][1]=A.rotateRight();else if(n===1&&h===-1)A.right=l[w+1][1]=l[w+1][1].rotateRight(),l[w][1]=A.rotateLeft();else if(n===-1&&h===1)A.left=l[w+1][1]=l[w+1][1].rotateLeft(),l[w][1]=A.rotateRight();else throw new Error;if(w>0)switch(l[w-1][0]){case-1:l[w-1][1].left=l[w][1];break;case 1:l[w-1][1].right=l[w][1];break;case 0:l[w-1][1].mid=l[w][1];break}else this.c=l[0][1]}}return v}get(b){return this.d(b)?.value}d(b){const m=this.b.reset(b);let s=this.c;for(;s;){const o=m.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(m.hasNext())m.next(),s=s.mid;else break}return s}has(b){const m=this.d(b);return!(m?.value===void 0&&m?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,m){const s=this.b.reset(b),o=[];let l=this.c;for(;l;){const v=s.cmp(l.segment);if(v>0)o.push([-1,l]),l=l.left;else if(v<0)o.push([1,l]),l=l.right;else if(s.hasNext())s.next(),o.push([0,l]),l=l.mid;else break}if(!!l){if(m?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const v=this.f(l.right);if(v.key){const{key:w,value:A,segment:p}=v;this.e(v.key,!1),l.key=w,l.value=A,l.segment=p}}else{const v=l.left??l.right;if(o.length>0){const[w,A]=o[o.length-1];switch(w){case-1:A.left=v;break;case 0:A.mid=v;break;case 1:A.right=v;break}}else this.c=v}for(let v=o.length-1;v>=0;v--){const w=o[v][1];w.updateHeight();const A=w.balanceFactor();if(A>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),o[v][1]=w.rotateLeft()):A<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),o[v][1]=w.rotateRight()),v>0)switch(o[v-1][0]){case-1:o[v-1][1].left=o[v][1];break;case 1:o[v-1][1].right=o[v][1];break;case 0:o[v-1][1].mid=o[v][1];break}else this.c=o[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const m=this.b.reset(b);let s=this.c,o;for(;s;){const l=m.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(m.hasNext())m.next(),o=s.value||o,s=s.mid;else break}return s&&s.value||o}findSuperstr(b){return this.g(b,!1)}g(b,m){const s=this.b.reset(b);let o=this.c;for(;o;){const l=s.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this.h(o.mid):m?o.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[m,s]of this)b(s,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const m=[];return this.j(b,m),m[Symbol.iterator]()}j(b,m){!b||(b.left&&this.j(b.left,m),b.value&&m.push([b.key,b.value]),b.mid&&this.j(b.mid,m),b.right&&this.j(b.right,m))}_isBalanced(){const b=m=>{if(!m)return!0;const s=m.balanceFactor();return s<-1||s>1?!1:b(m.left)&&b(m.right)};return b(this.c)}}e.TernarySearchTree=E}),define(Ie[65],Ce([1,0,23,10,2]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function N(T){return JSON.stringify(T,R)}e.stringify=N;function S(T){let M=JSON.parse(T);return M=y(M),M}e.parse=S;function R(T,M){return M instanceof RegExp?{$mid:2,source:M.source,flags:(0,k.regExpFlags)(M)}:M}function y(T,M=0){if(!T||M>200)return T;if(typeof T=="object"){switch(T.$mid){case 1:return D.URI.revive(T);case 2:return new RegExp(T.source,T.flags);case 16:return new Date(T.source)}if(T instanceof r.VSBuffer||T instanceof Uint8Array)return T;if(Array.isArray(T))for(let E=0;E<T.length;++E)T[E]=y(T[E],M+1);else for(const E in T)Object.hasOwnProperty.call(T,E)&&(T[E]=y(T[E],M+1))}return T}e.revive=y}),define(Ie[15],Ce([1,0,12,20,2]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var N;(function(T){T.inMemory="inmemory",T.vscode="vscode",T.internal="private",T.walkThrough="walkThrough",T.walkThroughSnippet="walkThroughSnippet",T.http="http",T.https="https",T.file="file",T.mailto="mailto",T.untitled="untitled",T.data="data",T.command="command",T.vscodeRemote="vscode-remote",T.vscodeRemoteResource="vscode-remote-resource",T.vscodeUserData="vscode-userdata",T.vscodeCustomEditor="vscode-custom-editor",T.vscodeNotebook="vscode-notebook",T.vscodeNotebookCell="vscode-notebook-cell",T.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",T.vscodeNotebookCellOutput="vscode-notebook-cell-output",T.vscodeInteractive="vscode-interactive",T.vscodeInteractiveInput="vscode-interactive-input",T.vscodeSettings="vscode-settings",T.vscodeWorkspaceTrust="vscode-workspace-trust",T.vscodeTerminal="vscode-terminal",T.webviewPanel="webview-panel",T.vscodeWebview="vscode-webview",T.extension="extension",T.vscodeFileResource="vscode-file",T.tmp="tmp",T.vsls="vsls",T.vscodeSourceControl="vscode-scm"})(N=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class S{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${N.vscodeRemoteResource}`}setPreferredWebSchema(M){this.d=M}setDelegate(M){this.e=M}setServerRootPath(M){this.f=`${M}/${N.vscodeRemoteResource}`}set(M,E,f){this.a[M]=E,this.b[M]=f}setConnectionToken(M,E){this.c[M]=E}getPreferredWebSchema(){return this.d}rewrite(M){if(this.e)try{return this.e(M)}catch(o){return r.onUnexpectedError(o),M}const E=M.authority;let f=this.a[E];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const b=this.b[E],m=this.c[E];let s=`path=${encodeURIComponent(M.path)}`;return typeof m=="string"&&(s+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),D.URI.from({scheme:k.isWeb?this.d:N.vscodeRemoteResource,authority:`${f}:${b}`,path:this.f,query:s})}}e.RemoteAuthorities=new S,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class R{asBrowserUri(M){const E=this.b(M,te);return this.uriToBrowserUri(E)}uriToBrowserUri(M){return M.scheme===N.vscodeRemote?e.RemoteAuthorities.rewrite(M):M.scheme===N.file&&(k.isNative||k.isWebWorker&&k.globals.origin===`${N.vscodeFileResource}://${R.a}`)?M.with({scheme:N.vscodeFileResource,authority:M.authority||R.a,query:null,fragment:null}):M}asFileUri(M){const E=this.b(M,te);return this.uriToFileUri(E)}uriToFileUri(M){return M.scheme===N.vscodeFileResource?M.with({scheme:N.file,authority:M.authority!==R.a?M.authority:null,query:null,fragment:null}):M}b(M,E){return D.URI.isUri(M)?M:D.URI.parse(E.toUrl(M))}}R.a="vscode-app",e.FileAccess=new R;var y;(function(T){const M=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);T.CoopAndCoep=Object.freeze(M.get("3"));const E="vscode-coi";function f(m){let s;typeof m=="string"?s=new URL(m).searchParams:m instanceof URL?s=m.searchParams:D.URI.isUri(m)&&(s=new URL(m.toString(!0)).searchParams);const o=s?.get(E);if(!!o)return M.get(o)}T.getHeadersFromQuery=f;function b(m,s,o){if(!globalThis.crossOriginIsolated)return;const l=s&&o?"3":o?"2":"1";m instanceof URLSearchParams?m.set(E,l):m[E]=l}T.addSearchParam=b})(y=e.COI||(e.COI={}))}),define(Ie[24],Ce([1,0,40,15,19,20,10,2]),function(te,e,r,k,D,N,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(b){return(0,R.uriToFsPath)(b,!0)}e.originalFSPath=y;class T{constructor(m){this.a=m}compare(m,s,o=!1){return m===s?0:(0,S.compare)(this.getComparisonKey(m,o),this.getComparisonKey(s,o))}isEqual(m,s,o=!1){return m===s?!0:!m||!s?!1:this.getComparisonKey(m,o)===this.getComparisonKey(s,o)}getComparisonKey(m,s=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,s,o=!1){if(m.scheme===s.scheme){if(m.scheme===k.Schemas.file)return r.isEqualOrParent(y(m),y(s),this.a(m))&&m.query===s.query&&(o||m.fragment===s.fragment);if((0,e.isEqualAuthority)(m.authority,s.authority))return r.isEqualOrParent(m.path,s.path,this.a(m),"/")&&m.query===s.query&&(o||m.fragment===s.fragment)}return!1}joinPath(m,...s){return R.URI.joinPath(m,...s)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return D.posix.basename(m.path)}extname(m){return D.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let s;return m.scheme===k.Schemas.file?s=R.URI.file(D.dirname(y(m))).path:(s=D.posix.dirname(m.path),m.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),s="/")),m.with({path:s})}normalizePath(m){if(!m.path.length)return m;let s;return m.scheme===k.Schemas.file?s=R.URI.file(D.normalize(y(m))).path:s=D.posix.normalize(m.path),m.with({path:s})}relativePath(m,s){if(m.scheme!==s.scheme||!(0,e.isEqualAuthority)(m.authority,s.authority))return;if(m.scheme===k.Schemas.file){const v=D.relative(y(m),y(s));return N.isWindows?r.toSlashes(v):v}let o=m.path||"/";const l=s.path||"/";if(this.a(m)){let v=0;for(const w=Math.min(o.length,l.length);v<w&&!(o.charCodeAt(v)!==l.charCodeAt(v)&&o.charAt(v).toLowerCase()!==l.charAt(v).toLowerCase());v++);o=l.substr(0,v)+o.substr(v)}return D.posix.relative(o,l)}resolvePath(m,s){if(m.scheme===k.Schemas.file){const o=R.URI.file(D.resolve(y(m),s));return m.with({authority:o.authority,path:o.path})}return s=r.toPosixPath(s),m.with({path:D.posix.resolve(m.path,s)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,s){return m===s||m!==void 0&&s!==void 0&&(0,S.equalsIgnoreCase)(m,s)}hasTrailingPathSeparator(m,s=D.sep){if(m.scheme===k.Schemas.file){const o=y(m);return o.length>r.getRoot(o).length&&o[o.length-1]===s}else{const o=m.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,s=D.sep){return(0,e.hasTrailingPathSeparator)(m,s)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,s=D.sep){let o=!1;if(m.scheme===k.Schemas.file){const l=y(m);o=l!==void 0&&l.length===r.getRoot(l).length&&l[l.length-1]===s}else{s="/";const l=m.path;o=l.length===1&&l.charCodeAt(l.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(m,s)?m.with({path:m.path+"/"}):m}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(b=>b.scheme===k.Schemas.file?!N.isLinux:!0),e.extUriIgnorePathCase=new T(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function M(b,m){const s=[];for(let o=0;o<b.length;o++){const l=m(b[o]);b.some((v,w)=>w===o?!1:(0,e.isEqualOrParent)(l,m(v)))||s.push(b[o])}return s}e.distinctParents=M;var E;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function m(s){const o=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(w=>{const[A,p]=w.split(":");A&&p&&o.set(A,p)});const v=s.path.substring(0,s.path.indexOf(";"));return v&&o.set(b.META_DATA_MIME,v),o}b.parseMetaData=m})(E=e.DataUri||(e.DataUri={}));function f(b,m,s){if(m){let o=b.path;return o&&o[0]!==D.posix.sep&&(o=D.posix.sep+o),b.with({scheme:s,authority:m,path:o})}return b.with({scheme:s})}e.toLocalResource=f}),define(Ie[16],Ce([1,0,21,12,4,6,24,20]),function(te,e,r,k,D,N,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(G){return!!G&&typeof G.then=="function"}e.isThenable=y;function T(G){const H=new r.CancellationTokenSource,oe=G(H.token),ve=new Promise((Ae,Ue)=>{const xe=H.token.onCancellationRequested(()=>{xe.dispose(),H.dispose(),Ue(new k.CancellationError)});Promise.resolve(oe).then(Te=>{xe.dispose(),H.dispose(),Ae(Te)},Te=>{xe.dispose(),H.dispose(),Ue(Te)})});return new class{cancel(){H.cancel()}then(Ae,Ue){return ve.then(Ae,Ue)}catch(Ae){return this.then(void 0,Ae)}finally(Ae){return ve.finally(Ae)}}}e.createCancelablePromise=T;function M(G,H,oe){return new Promise((ve,Ae)=>{const Ue=H.onCancellationRequested(()=>{Ue.dispose(),ve(oe)});G.then(ve,Ae).finally(()=>Ue.dispose())})}e.raceCancellation=M;function E(G,H){return new Promise((oe,ve)=>{const Ae=H.onCancellationRequested(()=>{Ae.dispose(),ve(new k.CancellationError)});G.then(oe,ve).finally(()=>Ae.dispose())})}e.raceCancellationError=E;async function f(G){let H=-1;const oe=G.map((Ae,Ue)=>Ae.then(xe=>(H=Ue,xe))),ve=await Promise.race(oe);return G.forEach((Ae,Ue)=>{Ue!==H&&Ae.cancel()}),ve}e.raceCancellablePromises=f;function b(G,H,oe){let ve;const Ae=setTimeout(()=>{ve?.(void 0),oe?.()},H);return Promise.race([G.finally(()=>clearTimeout(Ae)),new Promise(Ue=>ve=Ue)])}e.raceTimeout=b;function m(G){return new Promise((H,oe)=>{const ve=G();y(ve)?ve.then(H,oe):H(ve)})}e.asPromise=m;class s{constructor(){this.a=null,this.b=null,this.d=null}queue(H){if(this.a){if(this.d=H,!this.b){const oe=()=>{this.b=null;const ve=this.queue(this.d);return this.d=null,ve};this.b=new Promise(ve=>{this.a.then(oe,oe).then(ve)})}return new Promise((oe,ve)=>{this.b.then(oe,ve)})}return this.a=H(),new Promise((oe,ve)=>{this.a.then(Ae=>{this.a=null,oe(Ae)},Ae=>{this.a=null,ve(Ae)})})}}e.Throttler=s;class o{constructor(){this.a=Promise.resolve(null)}queue(H){return this.a=this.a.then(()=>H(),()=>H())}}e.Sequencer=o;class l{constructor(){this.a=new Map}queue(H,oe){const Ae=(this.a.get(H)??Promise.resolve()).catch(()=>{}).then(oe).finally(()=>{this.a.get(H)===Ae&&this.a.delete(H)});return this.a.set(H,Ae),Ae}}e.SequencerByKey=l;const v=(G,H)=>{let oe=!0;const ve=setTimeout(()=>{oe=!1,H()},G);return{isTriggered:()=>oe,dispose:()=>{clearTimeout(ve),oe=!1}}},w=G=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,G())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class A{constructor(H){this.defaultDelay=H,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(H,oe=this.defaultDelay){this.g=H,this.h(),this.b||(this.b=new Promise((Ae,Ue)=>{this.d=Ae,this.f=Ue}).then(()=>{if(this.b=null,this.d=null,this.g){const Ae=this.g;return this.g=null,Ae()}}));const ve=()=>{this.a=null,this.d?.(null)};return this.a=oe===e.MicrotaskDelay?w(ve):v(oe,ve),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new k.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=A;class p{constructor(H){this.a=new A(H),this.b=new s}trigger(H,oe){return this.a.trigger(()=>this.b.queue(H),oe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=p;class n{constructor(){this.a=!1,this.b=new Promise((H,oe)=>{this.d=H})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=n;class h extends n{constructor(H){super(),this.f=setTimeout(()=>this.open(),H)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=h;function i(G,H){return H?new Promise((oe,ve)=>{const Ae=setTimeout(()=>{Ue.dispose(),oe()},G),Ue=H.onCancellationRequested(()=>{clearTimeout(Ae),Ue.dispose(),ve(new k.CancellationError)})}):T(oe=>i(G,oe))}e.timeout=i;function a(G,H=0){const oe=setTimeout(G,H);return(0,N.toDisposable)(()=>clearTimeout(oe))}e.disposableTimeout=a;function t(G){const H=[];let oe=0;const ve=G.length;function Ae(){return oe<ve?G[oe++]():null}function Ue(xe){xe!=null&&H.push(xe);const Te=Ae();return Te?Te.then(Ue):Promise.resolve(H)}return Promise.resolve(null).then(Ue)}e.sequence=t;function g(G,H=ve=>!!ve,oe=null){let ve=0;const Ae=G.length,Ue=()=>{if(ve>=Ae)return Promise.resolve(oe);const xe=G[ve++];return Promise.resolve(xe()).then(Se=>H(Se)?Promise.resolve(Se):Ue())};return Ue()}e.first=g;function c(G,H=ve=>!!ve,oe=null){if(G.length===0)return Promise.resolve(oe);let ve=G.length;const Ae=()=>{ve=-1;for(const Ue of G)Ue.cancel?.()};return new Promise((Ue,xe)=>{for(const Te of G)Te.then(Se=>{--ve>=0&&H(Se)?(Ae(),Ue(Se)):ve===0&&Ue(oe)}).catch(Se=>{--ve>=0&&(Ae(),xe(Se))})})}e.firstParallel=c;class u{constructor(H){this.a=0,this.d=H,this.f=[],this.b=0,this.g=new D.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(H){return this.a++,new Promise((oe,ve)=>{this.f.push({factory:H,c:oe,e:ve}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const H=this.f.shift();this.b++;const oe=H.factory();oe.then(H.c,H.e),oe.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=u;class d extends u{constructor(){super(1)}}e.Queue=d;class C{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const H=new le;return this.b.add(H),H.p}d(){for(const[,H]of this.a)if(H.size>0)return!1;return!0}queueFor(H,oe=S.extUri){const ve=oe.getComparisonKey(H);let Ae=this.a.get(ve);return Ae||(Ae=new d,D.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete(ve),this.f()}),this.a.set(ve,Ae)),Ae}f(){!this.d()||this.g()}g(){for(const H of this.b)H.complete();this.b.clear()}dispose(){for(const[,H]of this.a)H.dispose();this.a.clear(),this.g()}}e.ResourceQueue=C;class O{constructor(H,oe){this.a=-1,typeof H=="function"&&typeof oe=="number"&&this.setIfNotSet(H,oe)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(H,oe){this.cancel(),this.a=setTimeout(()=>{this.a=-1,H()},oe)}setIfNotSet(H,oe){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,H()},oe))}}e.TimeoutTimer=O;class j{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(H,oe){this.cancel(),this.a=setInterval(()=>{H()},oe)}}e.IntervalTimer=j;class Z{constructor(H,oe){this.b=-1,this.a=H,this.d=oe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(H=this.d){this.cancel(),this.b=setTimeout(this.f,H)}get delay(){return this.d}set delay(H){this.d=H}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=Z;class x{constructor(H,oe){oe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.a=H,this.b=oe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(H=this.b){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(H/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=x;class L extends Z{constructor(H,oe){super(H,oe),this.j=[]}work(H){this.j.push(H),this.isScheduled()||this.schedule()}h(){const H=this.j;this.j=[],this.a?.(H)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=L;class $ extends N.Disposable{constructor(H,oe){super(),this.g=H,this.h=oe,this.a=[],this.b=this.B(new N.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(H){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+H.length>this.g.maxBufferedWork)return!1}else if(this.pending+H.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const oe of H)this.a.push(oe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=G=>{(0,R.setTimeout0)(()=>{if(H)return;const oe=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,oe-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:e.runWhenIdle=(G,H)=>{const oe=requestIdleCallback(G,typeof H=="number"?{timeout:H}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,cancelIdleCallback(oe))}}}}();class P{constructor(H){this.d=!1,this.a=()=>{try{this.f=H()}catch(oe){this.g=oe}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=P;async function F(G,H,oe){let ve;for(let Ae=0;Ae<oe;Ae++)try{return await G()}catch(Ue){ve=Ue,await i(H)}throw ve}e.retry=F;class V{hasPending(H){return this.a?typeof H=="number"?this.a.taskId===H:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(H,oe,ve){return this.a={taskId:H,cancel:()=>ve?.(),promise:oe},oe.then(()=>this.d(H),()=>this.d(H)),oe}d(H){this.a&&H===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const H=this.b;this.b=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}setNext(H){if(this.b)this.b.run=H;else{let oe,ve;const Ae=new Promise((Ue,xe)=>{oe=Ue,ve=xe});this.b={run:H,promise:Ae,promiseResolve:oe,promiseReject:ve}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=V;class q{constructor(H,oe=()=>Date.now()){this.d=H,this.f=oe,this.a=0,this.b=0}increment(){const H=this.f();return H-this.a>this.d&&(this.a=H,this.b=0),this.b++,this.b}}e.IntervalCounter=q;class le{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((H,oe)=>{this.a=H,this.b=oe})}complete(H){return new Promise(oe=>{this.a(H),this.f=!0,oe()})}error(H){return new Promise(oe=>{this.b(H),this.d=!0,oe()})}cancel(){new Promise(H=>{this.b(new k.CancellationError),this.d=!0,H()})}}e.DeferredPromise=le;var _;(function(G){async function H(ve){let Ae;const Ue=await Promise.all(ve.map(xe=>xe.then(Te=>Te,Te=>{Ae||(Ae=Te)})));if(typeof Ae<"u")throw Ae;return Ue}G.settled=H;function oe(ve){return new Promise(async(Ae,Ue)=>{try{await ve(Ae,Ue)}catch(xe){Ue(xe)}})}G.withAsyncBody=oe})(_=e.Promises||(e.Promises={}));var pe;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(pe||(pe={}));class ue{static fromArray(H){return new ue(oe=>{oe.emitMany(H)})}static fromPromise(H){return new ue(async oe=>{oe.emitMany(await H)})}static fromPromises(H){return new ue(async oe=>{await Promise.all(H.map(async ve=>oe.emitOne(await ve)))})}static merge(H){return new ue(async oe=>{await Promise.all(H.map(async ve=>{for await(const Ae of ve)oe.emitOne(Ae)}))})}constructor(H){this.a=0,this.b=[],this.d=null,this.f=new D.Emitter,queueMicrotask(async()=>{const oe={emitOne:ve=>this.g(ve),emitMany:ve=>this.h(ve),reject:ve=>this.k(ve)};try{await Promise.resolve(H(oe)),this.j()}catch(ve){this.k(ve)}finally{oe.emitOne=void 0,oe.emitMany=void 0,oe.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(H<this.b.length)return{done:!1,value:this.b[H++]};if(this.a===1)return{done:!0,value:void 0};await D.Event.toPromise(this.f.event)}while(!0)}}}static map(H,oe){return new ue(async ve=>{for await(const Ae of H)ve.emitOne(oe(Ae))})}map(H){return ue.map(this,H)}static filter(H,oe){return new ue(async ve=>{for await(const Ae of H)oe(Ae)&&ve.emitOne(Ae)})}filter(H){return ue.filter(this,H)}static coalesce(H){return ue.filter(H,oe=>!!oe)}coalesce(){return ue.coalesce(this)}static async toPromise(H){const oe=[];for await(const ve of H)oe.push(ve);return oe}toPromise(){return ue.toPromise(this)}g(H){this.a===0&&(this.b.push(H),this.f.fire())}h(H){this.a===0&&(this.b=this.b.concat(H),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(H){this.a===0&&(this.a=2,this.d=H,this.f.fire())}}e.AsyncIterableObject=ue,ue.EMPTY=ue.fromArray([]);class de extends ue{constructor(H,oe){super(oe),this.l=H}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=de;function re(G){const H=new r.CancellationTokenSource,oe=G(H.token);return new de(H,async ve=>{const Ae=H.token.onCancellationRequested(()=>{Ae.dispose(),H.dispose(),ve.reject(new k.CancellationError)});try{for await(const Ue of oe){if(H.token.isCancellationRequested)return;ve.emitOne(Ue)}Ae.dispose(),H.dispose()}catch(Ue){Ae.dispose(),H.dispose(),ve.reject(Ue)}})}e.createCancelableAsyncIterable=re}),define(Ie[35],Ce([1,0,18,16,40,28,19,20,10]),function(te,e,r,k,D,N,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function T(){return Object.create(null)}e.getEmptyExpression=T,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const M="[/\\\\]",E="[^/\\\\]",f=/\//g;function b(le,_){switch(le){case 0:return"";case 1:return`${E}*?`;default:return`(?:${M}|${E}+${M}${_?`|${M}${E}+`:""})*?`}}function m(le,_){if(!le)return[];const pe=[];let ue=!1,de=!1,re="";for(const G of le){switch(G){case _:if(!ue&&!de){pe.push(re),re="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":de=!0;break;case"]":de=!1;break}re+=G}return re&&pe.push(re),pe}e.splitGlobAware=m;function s(le){if(!le)return"";let _="";const pe=m(le,e.GLOB_SPLIT);if(pe.every(ue=>ue===e.GLOBSTAR))_=".*";else{let ue=!1;pe.forEach((de,re)=>{if(de===e.GLOBSTAR){if(ue)return;_+=b(2,re===pe.length-1)}else{let G=!1,H="",oe=!1,ve="";for(const Ae of de){if(Ae!=="}"&&G){H+=Ae;continue}if(oe&&(Ae!=="]"||!ve)){let Ue;Ae==="-"?Ue=Ae:(Ae==="^"||Ae==="!")&&!ve?Ue="^":Ae===e.GLOB_SPLIT?Ue="":Ue=(0,y.escapeRegExpCharacters)(Ae),ve+=Ue;continue}switch(Ae){case"{":G=!0;continue;case"[":oe=!0;continue;case"}":{_+=`(?:${m(H,",").map(Te=>s(Te)).join("|")})`,G=!1,H="";break}case"]":{_+="["+ve+"]",oe=!1,ve="";break}case"?":_+=E;continue;case"*":_+=b(1);continue;default:_+=(0,y.escapeRegExpCharacters)(Ae)}}re<pe.length-1&&(pe[re+1]!==e.GLOBSTAR||re+2<pe.length)&&(_+=M)}ue=de===e.GLOBSTAR})}return _}const o=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,A=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new N.LRUCache(1e4),h=function(){return!1},i=function(){return null};function a(le,_){if(!le)return i;let pe;typeof le!="string"?pe=le.pattern:pe=le,pe=pe.trim();const ue=`${pe}_${!!_.trimForExclusions}`;let de=n.get(ue);if(de)return t(de,le);let re;return o.test(pe)?de=c(pe.substr(4),pe):(re=l.exec(g(pe,_)))?de=u(re[1],pe):(_.trimForExclusions?w:v).test(pe)?de=d(pe,_):(re=A.exec(g(pe,_)))?de=C(re[1].substr(1),pe,!0):(re=p.exec(g(pe,_)))?de=C(re[1],pe,!1):de=O(pe),n.set(ue,de),t(de,le)}function t(le,_){if(typeof _=="string")return le;const pe=function(ue,de){return(0,D.isEqualOrParent)(ue,_.base,!R.isLinux)?le((0,y.ltrim)(ue.substr(_.base.length),S.sep),de):null};return pe.allBasenames=le.allBasenames,pe.allPaths=le.allPaths,pe.basenames=le.basenames,pe.patterns=le.patterns,pe}function g(le,_){return _.trimForExclusions&&le.endsWith("/**")?le.substr(0,le.length-2):le}function c(le,_){return function(pe,ue){return typeof pe=="string"&&pe.endsWith(le)?_:null}}function u(le,_){const pe=`/${le}`,ue=`\\${le}`,de=function(G,H){return typeof G!="string"?null:H?H===le?_:null:G===le||G.endsWith(pe)||G.endsWith(ue)?_:null},re=[le];return de.basenames=re,de.patterns=[_],de.allBasenames=re,de}function d(le,_){const pe=V(le.slice(1,-1).split(",").map(H=>a(H,_)).filter(H=>H!==i),le),ue=pe.length;if(!ue)return i;if(ue===1)return pe[0];const de=function(H,oe){for(let ve=0,Ae=pe.length;ve<Ae;ve++)if(pe[ve](H,oe))return le;return null},re=pe.find(H=>!!H.allBasenames);re&&(de.allBasenames=re.allBasenames);const G=pe.reduce((H,oe)=>oe.allPaths?H.concat(oe.allPaths):H,[]);return G.length&&(de.allPaths=G),de}function C(le,_,pe){const ue=S.sep===S.posix.sep,de=ue?le:le.replace(f,S.sep),re=S.sep+de,G=S.posix.sep+le;let H;return pe?H=function(oe,ve){return typeof oe=="string"&&(oe===de||oe.endsWith(re)||!ue&&(oe===le||oe.endsWith(G)))?_:null}:H=function(oe,ve){return typeof oe=="string"&&(oe===de||!ue&&oe===le)?_:null},H.allPaths=[(pe?"*/":"./")+le],H}function O(le){try{const _=new RegExp(`^${s(le)}$`);return function(pe){return _.lastIndex=0,typeof pe=="string"&&_.test(pe)?le:null}}catch{return i}}function j(le,_,pe){return!le||typeof _!="string"?!1:Z(le)(_,void 0,pe)}e.match=j;function Z(le,_={}){if(!le)return h;if(typeof le=="string"||x(le)){const pe=a(le,_);if(pe===i)return h;const ue=function(de,re){return!!pe(de,re)};return pe.allBasenames&&(ue.allBasenames=pe.allBasenames),pe.allPaths&&(ue.allPaths=pe.allPaths),ue}return P(le,_)}e.parse=Z;function x(le){const _=le;return _?typeof _.base=="string"&&typeof _.pattern=="string":!1}e.isRelativePattern=x;function L(le){return le.allBasenames||[]}e.getBasenameTerms=L;function $(le){return le.allPaths||[]}e.getPathTerms=$;function P(le,_){const pe=V(Object.getOwnPropertyNames(le).map(H=>F(H,le[H],_)).filter(H=>H!==i)),ue=pe.length;if(!ue)return i;if(!pe.some(H=>!!H.requiresSiblings)){if(ue===1)return pe[0];const H=function(Ae,Ue){let xe;for(let Te=0,Se=pe.length;Te<Se;Te++){const ke=pe[Te](Ae,Ue);if(typeof ke=="string")return ke;(0,k.isThenable)(ke)&&(xe||(xe=[]),xe.push(ke))}return xe?(async()=>{for(const Te of xe){const Se=await Te;if(typeof Se=="string")return Se}return null})():null},oe=pe.find(Ae=>!!Ae.allBasenames);oe&&(H.allBasenames=oe.allBasenames);const ve=pe.reduce((Ae,Ue)=>Ue.allPaths?Ae.concat(Ue.allPaths):Ae,[]);return ve.length&&(H.allPaths=ve),H}const de=function(H,oe,ve){let Ae,Ue;for(let xe=0,Te=pe.length;xe<Te;xe++){const Se=pe[xe];Se.requiresSiblings&&ve&&(oe||(oe=(0,S.basename)(H)),Ae||(Ae=oe.substr(0,oe.length-(0,S.extname)(H).length)));const ke=Se(H,oe,Ae,ve);if(typeof ke=="string")return ke;(0,k.isThenable)(ke)&&(Ue||(Ue=[]),Ue.push(ke))}return Ue?(async()=>{for(const xe of Ue){const Te=await xe;if(typeof Te=="string")return Te}return null})():null},re=pe.find(H=>!!H.allBasenames);re&&(de.allBasenames=re.allBasenames);const G=pe.reduce((H,oe)=>oe.allPaths?H.concat(oe.allPaths):H,[]);return G.length&&(de.allPaths=G),de}function F(le,_,pe){if(_===!1)return i;const ue=a(le,pe);if(ue===i)return i;if(typeof _=="boolean")return ue;if(_){const de=_.when;if(typeof de=="string"){const re=(G,H,oe,ve)=>{if(!ve||!ue(G,H))return null;const Ae=de.replace("$(basename)",()=>oe),Ue=ve(Ae);return(0,k.isThenable)(Ue)?Ue.then(xe=>xe?le:null):Ue?le:null};return re.requiresSiblings=!0,re}}return ue}function V(le,_){const pe=le.filter(H=>!!H.basenames);if(pe.length<2)return le;const ue=pe.reduce((H,oe)=>{const ve=oe.basenames;return ve?H.concat(ve):H},[]);let de;if(_){de=[];for(let H=0,oe=ue.length;H<oe;H++)de.push(_)}else de=pe.reduce((H,oe)=>{const ve=oe.patterns;return ve?H.concat(ve):H},[]);const re=function(H,oe){if(typeof H!="string")return null;if(!oe){let Ae;for(Ae=H.length;Ae>0;Ae--){const Ue=H.charCodeAt(Ae-1);if(Ue===47||Ue===92)break}oe=H.substr(Ae)}const ve=ue.indexOf(oe);return ve!==-1?de[ve]:null};re.basenames=ue,re.patterns=de,re.allBasenames=ue;const G=le.filter(H=>!H.basenames);return G.push(re),G}function q(le,_){return(0,r.equals)(le,_,(pe,ue)=>typeof pe=="string"&&typeof ue=="string"?pe===ue:typeof pe!="string"&&typeof ue!="string"?pe.base===ue.base&&pe.pattern===ue.pattern:!1)}e.patternsEquals=q}),define(Ie[86],Ce([1,0,12,125,24,10,2]),function(te,e,r,k,D,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var R;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(R=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(l="",v=!1){if(this.value=l,typeof this.value!="string")throw(0,r.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(l,v=0){return this.value+=f(this.supportThemeIcons?(0,k.escapeIcons)(l):l).replace(/([ \t]+)/g,(w,A)=>"&nbsp;".repeat(A.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,v){return this.value+="\n```",this.value+=l,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(l,v,w){return this.value+="[",this.value+=this.c(v,"]"),this.value+="](",this.value+=this.c(String(l),")"),w&&(this.value+=` "${this.c(this.c(w,'"'),")")}"`),this.value+=")",this}c(l,v){const w=new RegExp((0,N.escapeRegExpCharacters)(v),"g");return l.replace(w,(A,p)=>l.charAt(p-1)!=="\\"?`\\${A}`:A)}}e.MarkdownString=y;function T(o){return M(o)?!o.value:Array.isArray(o)?o.every(T):!0}e.isEmptyMarkdownString=T;function M(o){return o instanceof y?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=M;function E(o,l){return o===l?!0:!o||!l?!1:o.value===l.value&&o.isTrusted===l.isTrusted&&o.supportThemeIcons===l.supportThemeIcons&&o.supportHtml===l.supportHtml&&(o.baseUri===l.baseUri||!!o.baseUri&&!!l.baseUri&&(0,D.isEqual)(S.URI.from(o.baseUri),S.URI.from(l.baseUri)))}e.markdownStringEqual=E;function f(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=f;function b(o){return o.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=b;function m(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=m;function s(o){const l=[],v=o.split("|").map(A=>A.trim());o=v[0];const w=v[1];if(w){const A=/height=(\d+)/.exec(w),p=/width=(\d+)/.exec(w),n=A?A[1]:"",h=p?p[1]:"",i=isFinite(parseInt(h)),a=isFinite(parseInt(n));i&&l.push(`width="${h}"`),a&&l.push(`height="${n}"`)}return{href:o,dimensions:l}}e.parseHrefAndDimensions=s}),define(Ie[87],Ce([1,0,18,40,19,20,24,10]),function(te,e,r,k,D,N,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(i,a){const{os:t,tildify:g,relative:c}=a;if(c){const C=T(i,c,t);if(typeof C=="string")return C}let u=i.fsPath;if(t===1&&!N.isWindows?u=u.replace(/\//g,"\\"):t!==1&&N.isWindows&&(u=u.replace(/\\/g,"/")),t!==1&&g?.userHome){const C=g.userHome.fsPath;let O;i.scheme!==g.userHome.scheme&&i.path.startsWith(D.posix.sep)?O=g.userHome.with({path:i.path}).fsPath:O=i.fsPath,u=f(O,C,t)}return(t===1?D.win32:D.posix).normalize(M(u,t===1))}e.getPathLabel=y;function T(i,a,t){const g=t===1?D.win32:D.posix,c=t===3?S.extUri:S.extUriIgnorePathCase,u=a.getWorkspace(),d=(0,r.firstOrDefault)(u.folders);if(!d)return;i.scheme!==d.uri.scheme&&i.path.startsWith(D.posix.sep)&&(i=d.uri.with({path:i.path}));const C=a.getWorkspaceFolder(i);if(!C)return;let O;if(c.isEqual(C.uri,i)?O="":O=c.relativePath(C.uri,i)??"",O&&(O=g.normalize(O)),u.folders.length>1&&!a.noPrefix){const j=C.name?C.name:c.basenameOrAuthority(C.uri);O=O?`${j} \u2022 ${O}`:j}return O}function M(i,a=N.isWindows){return(0,k.hasDriveLetter)(i,a)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=M;let E=Object.create(null);function f(i,a,t=N.OS){if(t===1||!i||!a)return i;let g=E.original===a?E.normalized:void 0;g||(g=a,N.isWindows&&(g=(0,k.toSlashes)(g)),g=`${(0,R.rtrim)(g,D.posix.sep)}${D.posix.sep}`,E={original:a,normalized:g});let c=i;return N.isWindows&&(c=(0,k.toSlashes)(c)),(t===3?c.startsWith(g):(0,R.startsWithIgnoreCase)(c,g))?`~/${c.substr(g.length)}`:i}e.tildify=f;function b(i,a){return i.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=b;const m="\u2026",s="\\\\",o="~";function l(i,a=D.sep){const t=new Array(i.length);let g=!1;for(let c=0;c<i.length;c++){const u=i[c];if(u===""){t[c]=`.${a}`;continue}if(!u){t[c]=u;continue}g=!0;let d="",C=u;C.indexOf(s)===0?(d=C.substr(0,C.indexOf(s)+s.length),C=C.substr(C.indexOf(s)+s.length)):C.indexOf(a)===0?(d=C.substr(0,C.indexOf(a)+a.length),C=C.substr(C.indexOf(a)+a.length)):C.indexOf(o)===0&&(d=C.substr(0,C.indexOf(o)+o.length),C=C.substr(C.indexOf(o)+o.length));const O=C.split(a);for(let j=1;g&&j<=O.length;j++)for(let Z=O.length-j;g&&Z>=0;Z--){g=!1;let x=O.slice(Z,Z+j).join(a);for(let L=0;!g&&L<i.length;L++)if(L!==c&&i[L]&&i[L].indexOf(x)>-1){const $=Z+j===O.length,P=Z>0&&i[L].indexOf(a)>-1?a+x:x,F=i[L].endsWith(P);g=!$||F}if(!g){let L="";(O[0].endsWith(":")||d!=="")&&(Z===1&&(Z=0,j++,x=O[0]+a+x),Z>0&&(L=O[0]+a),L=d+L),Z>0&&(L=L+m+a),L=L+x,Z+j<O.length&&(L=L+a+m),t[c]=L}}g&&(t[c]=u)}return t}e.shorten=l;var v;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function w(i,a=Object.create(null)){const t=[];let g=!1,c="";for(const u of i)if(u==="$"||g&&u==="{")c&&t.push({value:c,type:v.TEXT}),c="",g=!0;else if(u==="}"&&g){const d=a[c];if(typeof d=="string")d.length&&t.push({value:d,type:v.VARIABLE});else if(d){const C=t[t.length-1];(!C||C.type!==v.SEPARATOR)&&t.push({value:d.label,type:v.SEPARATOR})}c="",g=!1}else c+=u;return c&&!g&&t.push({value:c,type:v.TEXT}),t.filter((u,d)=>{if(u.type===v.SEPARATOR){const C=t[d-1],O=t[d+1];return[C,O].every(j=>j&&(j.type===v.VARIABLE||j.type===v.TEXT)&&j.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=w;function A(i,a){return N.isMacintosh||a?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.isMacintosh?"&":"&&"):i.replace(/&&|&/g,t=>t==="&"?"&&":"&")}e.mnemonicMenuLabel=A;function p(i,a){return N.isMacintosh||a?i.replace(/\(&&\w\)|&&/g,""):N.isWindows?i.replace(/&&|&/g,t=>t==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=p;function n(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=n;function h(i){const a=i.indexOf("/")!==-1?D.posix:D.win32,t=a.basename(i),g=a.dirname(i);return t.length?{name:t,parentPath:g}:{name:g,parentPath:""}}e.splitName=h}),define(Ie[126],Ce([1,0,23,2]),function(te,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(E){return E.toJSON()}class N{constructor(f){this.a=f}transformIncoming(f){const b=this.a.transformIncoming(f);return b===f?f:D(k.URI.from(b))}transformOutgoing(f){const b=this.a.transformOutgoing(f);return b===f?f:D(k.URI.from(b))}transformOutgoingURI(f){const b=this.a.transformOutgoing(f);return b===f?f:k.URI.from(b)}transformOutgoingScheme(f){return this.a.transformOutgoingScheme(f)}}e.URITransformer=N,e.DefaultURITransformer=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function S(E,f,b){if(!E||b>200)return null;if(typeof E=="object"){if(E instanceof k.URI)return f.transformOutgoing(E);for(const m in E)if(Object.hasOwnProperty.call(E,m)){const s=S(E[m],f,b+1);s!==null&&(E[m]=s)}}return null}function R(E,f){const b=S(E,f,0);return b===null?E:b}e.transformOutgoingURIs=R;function y(E,f,b,m){if(!E||m>200)return null;if(typeof E=="object"){if(E.$mid===1)return b?k.URI.revive(f.transformIncoming(E)):f.transformIncoming(E);if(E instanceof r.VSBuffer)return null;for(const s in E)if(Object.hasOwnProperty.call(E,s)){const o=y(E[s],f,b,m+1);o!==null&&(E[s]=o)}}return null}function T(E,f){const b=y(E,f,!1,0);return b===null?E:b}e.transformIncomingURIs=T;function M(E,f){const b=y(E,f,!0,0);return b===null?E:b}e.transformAndReviveIncomingURIs=M}),define(Ie[127],Ce([1,0,35,19]),function(te,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(N,S,R,y,T,M){if(Array.isArray(N)){let E=0;for(const f of N){const b=D(f,S,R,y,T,M);if(b===10)return b;b>E&&(E=b)}return E}else{if(typeof N=="string")return y?N==="*"?5:N===R?10:0:0;if(N){const{language:E,pattern:f,scheme:b,hasAccessToAllModels:m,notebookType:s}=N;if(!y&&!m)return 0;s&&T&&(S=T);let o=0;if(b)if(b===S.scheme)o=10;else if(b==="*")o=5;else return 0;if(E)if(E===R)o=10;else if(E==="*")o=Math.max(o,5);else return 0;if(s)if(s===M)o=10;else if(s==="*"&&M!==void 0)o=Math.max(o,5);else return 0;if(f){let l;if(typeof f=="string"?l=f:l={...f,base:(0,k.normalize)(f.base)},l===S.fsPath||(0,r.match)(l,S.fsPath))o=10;else return 0}return o}else return 0}}e.score=D}),define(Ie[88],Ce([1,0,23,20]),function(te,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(D||(D={}));function N(E){for(let f=0,b=E.length;f<b;f+=4){const m=E[f+0],s=E[f+1],o=E[f+2],l=E[f+3];E[f+0]=l,E[f+1]=o,E[f+2]=s,E[f+3]=m}}function S(E){const f=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return k.isLittleEndian()||N(f),r.VSBuffer.wrap(f)}function R(E){const f=E.buffer;if(k.isLittleEndian()||N(f),f.byteOffset%4===0)return new Uint32Array(f.buffer,f.byteOffset,f.length/4);{const b=new Uint8Array(f.byteLength);return b.set(f),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function y(E){const f=new Uint32Array(T(E));let b=0;if(f[b++]=E.id,E.type==="full")f[b++]=1,f[b++]=E.data.length,f.set(E.data,b),b+=E.data.length;else{f[b++]=2,f[b++]=E.deltas.length;for(const m of E.deltas)f[b++]=m.start,f[b++]=m.deleteCount,m.data?(f[b++]=m.data.length,f.set(m.data,b),b+=m.data.length):f[b++]=0}return S(f)}e.encodeSemanticTokensDto=y;function T(E){let f=0;if(f+=1+1,E.type==="full")f+=1+E.data.length;else{f+=1,f+=(1+1+1)*E.deltas.length;for(const b of E.deltas)b.data&&(f+=b.data.length)}return f}function M(E){const f=R(E);let b=0;const m=f[b++];if(f[b++]===1){const v=f[b++],w=f.subarray(b,b+v);return b+=v,{id:m,type:"full",data:w}}const o=f[b++],l=[];for(let v=0;v<o;v++){const w=f[b++],A=f[b++],p=f[b++];let n;p>0&&(n=f.subarray(b,b+p),b+=p),l[v]={start:w,deleteCount:A,data:n}}return{id:m,type:"delta",deltas:l}}e.decodeSemanticTokensDto=M}),define(Ie[128],Ce([13,14]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(Ie[129],Ce([1,0,128,20,130,18,22,116]),function(te,e,r,k,D,N,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class T{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=T;class M{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=M;class E{constructor(Q,ge,Me,ze){this.id=Q,this.name=ge,this.defaultValue=Me,this.schema=ze}applyUpdate(Q,ge){return b(Q,ge)}compute(Q,ge,Me){return Me}}class f{constructor(Q,ge){this.newValue=Q,this.didChange=ge}}e.ApplyUpdateResult=f;function b(Y,Q){if(typeof Y!="object"||typeof Q!="object"||!Y||!Q)return new f(Q,Y!==Q);if(Array.isArray(Y)||Array.isArray(Q)){const Me=Array.isArray(Y)&&Array.isArray(Q)&&N.equals(Y,Q);return new f(Q,!Me)}let ge=!1;for(const Me in Q)if(Q.hasOwnProperty(Me)){const ze=b(Y[Me],Q[Me]);ze.didChange&&(Y[Me]=ze.newValue,ge=!0)}return new f(Y,ge)}class m{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,ge){return b(Q,ge)}validate(Q){return this.defaultValue}}class s{constructor(Q,ge,Me,ze){this.id=Q,this.name=ge,this.defaultValue=Me,this.schema=ze}applyUpdate(Q,ge){return b(Q,ge)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,ge,Me){return Me}}function o(Y,Q){return typeof Y>"u"?Q:Y==="false"?!1:Boolean(Y)}e.boolean=o;class l extends s{constructor(Q,ge,Me,ze=void 0){typeof ze<"u"&&(ze.type="boolean",ze.default=Me),super(Q,ge,Me,ze)}validate(Q){return o(Q,this.defaultValue)}}function v(Y,Q,ge,Me){if(typeof Y>"u")return Q;let ze=parseInt(Y,10);return isNaN(ze)?Q:(ze=Math.max(ge,ze),ze=Math.min(Me,ze),ze|0)}e.clampedInt=v;class w extends s{static clampedInt(Q,ge,Me,ze){return v(Q,ge,Me,ze)}constructor(Q,ge,Me,ze,He,Ye=void 0){typeof Ye<"u"&&(Ye.type="integer",Ye.default=Me,Ye.minimum=ze,Ye.maximum=He),super(Q,ge,Me,Ye),this.minimum=ze,this.maximum=He}validate(Q){return w.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class A extends s{static clamp(Q,ge,Me){return Q<ge?ge:Q>Me?Me:Q}static float(Q,ge){if(typeof Q=="number")return Q;if(typeof Q>"u")return ge;const Me=parseFloat(Q);return isNaN(Me)?ge:Me}constructor(Q,ge,Me,ze,He){typeof He<"u"&&(He.type="number",He.default=Me),super(Q,ge,Me,He),this.validationFn=ze}validate(Q){return this.validationFn(A.float(Q,this.defaultValue))}}class p extends s{static string(Q,ge){return typeof Q!="string"?ge:Q}constructor(Q,ge,Me,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.default=Me),super(Q,ge,Me,ze)}validate(Q){return p.string(Q,this.defaultValue)}}function n(Y,Q,ge){return typeof Y!="string"||ge.indexOf(Y)===-1?Q:Y}e.stringSet=n;class h extends s{constructor(Q,ge,Me,ze,He=void 0){typeof He<"u"&&(He.type="string",He.enum=ze,He.default=Me),super(Q,ge,Me,He),this.c=ze}validate(Q){return n(Q,this.defaultValue,this.c)}}class i extends E{constructor(Q,ge,Me,ze,He,Ye,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=He,nt.default=ze),super(Q,ge,Me,nt),this.c=He,this.d=Ye}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function a(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class t extends E{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[r.localize(0,null),r.localize(1,null),r.localize(2,null)],default:"auto",tags:["accessibility"],description:r.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,ge,Me){return Me===0?Q.accessibilitySupport:Me}}class g extends E{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:r.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:r.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{insertSpace:o(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var c;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(c=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function u(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(d=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function C(Y){switch(Y){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=C;function O(Y){switch(Y){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class j extends m{constructor(){super(135)}compute(Q,ge,Me){const ze=["monaco-editor"];return ge.get(36)&&ze.push(ge.get(36)),Q.extraEditorClassName&&ze.push(Q.extraEditorClassName),ge.get(70)==="default"?ze.push("mouse-default"):ge.get(70)==="copy"&&ze.push("mouse-copy"),ge.get(105)&&ze.push("showUnused"),ge.get(133)&&ze.push("showDeprecated"),ze.join(" ")}}class Z extends l{constructor(){super(34,"emptySelectionClipboard",!0,{description:r.localize(6,null)})}compute(Q,ge,Me){return Me&&Q.emptySelectionClipboard}}class x extends E{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:r.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[r.localize(8,null),r.localize(9,null),r.localize(10,null)],description:r.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[r.localize(12,null),r.localize(13,null),r.localize(14,null)],description:r.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:r.localize(16,null),included:k.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:r.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:r.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{cursorMoveOnType:o(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":n(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":n(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(ge.loop,this.defaultValue.loop)}}}class L extends E{constructor(){super(48,"fontLigatures",L.OFF,{anyOf:[{type:"boolean",description:r.localize(19,null)},{type:"string",description:r.localize(20,null)}],description:r.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?L.OFF:Q==="true"?L.ON:Q:Boolean(Q)?L.ON:L.OFF}}e.EditorFontLigatures=L,L.OFF='"liga" off, "calt" off',L.ON='"liga" on, "calt" on';class $ extends E{constructor(){super(51,"fontVariations",$.OFF,{anyOf:[{type:"boolean",description:r.localize(22,null)},{type:"string",description:r.localize(23,null)}],description:r.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?$.OFF:Q==="true"?$.TRANSLATE:Q:Boolean(Q)?$.TRANSLATE:$.OFF}compute(Q,ge,Me){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=$,$.OFF="normal",$.TRANSLATE="translate";class P extends m{constructor(){super(47)}compute(Q,ge,Me){return Q.fontInfo}}class F extends s{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:r.localize(25,null)})}validate(Q){const ge=A.float(Q,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:A.clamp(ge,6,100)}compute(Q,ge,Me){return Q.fontInfo.fontSize}}class V extends E{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.d,maximum:V.e,errorMessage:r.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:r.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(w.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,V.d,V.e))}}V.c=["normal","bold","100","200","300","400","500","600","700","800","900"],V.d=1,V.e=1e3;class q extends E{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[r.localize(28,null),r.localize(29,null),r.localize(30,null)]},Me=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:r.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:r.localize(32,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:r.localize(33,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:r.localize(34,null),...ge},"editor.gotoLocation.multipleImplementations":{description:r.localize(35,null),...ge},"editor.gotoLocation.multipleReferences":{description:r.localize(36,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Me,description:r.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Me,description:r.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Me,description:r.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Me,description:r.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Me,description:r.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{multiple:n(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??n(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??n(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??n(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??n(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??n(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class le extends E{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:r.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:r.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:r.localize(44,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:r.localize(45,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),delay:w.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:o(ge.sticky,this.defaultValue.sticky),above:o(ge.above,this.defaultValue.above)}}}var _;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(_=e.RenderMinimap||(e.RenderMinimap={}));class pe extends m{constructor(){super(138)}compute(Q,ge,Me){return pe.computeLayout(ge,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const ge=Q.height/Q.lineHeight,Me=Math.floor(Q.paddingTop/Q.lineHeight);let ze=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(ze=Math.max(ze,ge-1));const He=(Me+Q.viewLineCount+ze)/(Q.pixelRatio*Q.height),Ye=Math.floor(Q.viewLineCount/He);return{typicalViewportLineCount:ge,extraLinesBeforeFirstLine:Me,extraLinesBeyondLastLine:ze,desiredRatio:He,minimapLineCount:Ye}}static c(Q,ge){const Me=Q.outerWidth,ze=Q.outerHeight,He=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(He*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const Ye=ge.stableMinimapLayoutInput,nt=Ye&&Q.outerHeight===Ye.outerHeight&&Q.lineHeight===Ye.lineHeight&&Q.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Ye.pixelRatio&&Q.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&Q.paddingTop===Ye.paddingTop&&Q.paddingBottom===Ye.paddingBottom&&Q.minimap.enabled===Ye.minimap.enabled&&Q.minimap.side===Ye.minimap.side&&Q.minimap.size===Ye.minimap.size&&Q.minimap.showSlider===Ye.minimap.showSlider&&Q.minimap.renderCharacters===Ye.minimap.renderCharacters&&Q.minimap.maxColumn===Ye.minimap.maxColumn&&Q.minimap.scale===Ye.minimap.scale&&Q.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&Q.isViewportWrapping===Ye.isViewportWrapping,vt=Q.lineHeight,wt=Q.typicalHalfwidthCharacterWidth,Ct=Q.scrollBeyondLastLine,jt=Q.minimap.renderCharacters;let rt=He>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const mt=Q.minimap.maxColumn,Ft=Q.minimap.size,xt=Q.minimap.side,Pt=Q.verticalScrollbarWidth,ht=Q.viewLineCount,kt=Q.remainingWidth,Bt=Q.isViewportWrapping,Ot=jt?2:3;let Ge=Math.floor(He*ze);const Mt=Ge/He;let Nt=!1,zt=!1,ft=Ot*rt,De=rt/He,Pe=1;if(Ft==="fill"||Ft==="fit"){const{typicalViewportLineCount:Ze,extraLinesBeforeFirstLine:ct,extraLinesBeyondLastLine:Tt,desiredRatio:bt,minimapLineCount:Et}=pe.computeContainedMinimapLineCount({viewLineCount:ht,scrollBeyondLastLine:Ct,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:ze,lineHeight:vt,pixelRatio:He});if(ht/Et>1)Nt=!0,zt=!0,rt=1,ft=1,De=rt/He;else{let St=!1,yt=rt+1;if(Ft==="fit"){const qt=Math.ceil((ct+ht+Tt)*ft);Bt&&nt&&kt<=ge.stableFitRemainingWidth?(St=!0,yt=ge.stableFitMaxMinimapScale):St=qt>Ge}if(Ft==="fill"||St){Nt=!0;const qt=rt;ft=Math.min(vt*He,Math.max(1,Math.floor(1/bt))),Bt&&nt&&kt<=ge.stableFitRemainingWidth&&(yt=ge.stableFitMaxMinimapScale),rt=Math.min(yt,Math.max(1,Math.floor(ft/Ot))),rt>qt&&(Pe=Math.min(2,rt/qt)),De=rt/He/Pe,Ge=Math.ceil(Math.max(Ze,ct+ht+Tt)*ft),Bt?(ge.stableMinimapLayoutInput=Q,ge.stableFitRemainingWidth=kt,ge.stableFitMaxMinimapScale=rt):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const me=Math.floor(mt*De),X=Math.min(me,Math.max(0,Math.floor((kt-Pt-2)*De/(wt+De)))+e.MINIMAP_GUTTER_WIDTH);let Re=Math.floor(He*X);const Be=Re/He;Re=Math.floor(Re*Pe);const Qe=jt?1:2,$e=xt==="left"?0:Me-X-Pt;return{renderMinimap:Qe,minimapLeft:$e,minimapWidth:X,minimapHeightIsEditorHeight:Nt,minimapIsSampling:zt,minimapScale:rt,minimapLineHeight:ft,minimapCanvasInnerWidth:Re,minimapCanvasInnerHeight:Ge,minimapCanvasOuterWidth:Be,minimapCanvasOuterHeight:Mt}}static computeLayout(Q,ge){const Me=ge.outerWidth|0,ze=ge.outerHeight|0,He=ge.lineHeight|0,Ye=ge.lineNumbersDigitCount|0,nt=ge.typicalHalfwidthCharacterWidth,vt=ge.maxDigitWidth,wt=ge.pixelRatio,Ct=ge.viewLineCount,jt=Q.get(130),rt=jt==="inherit"?Q.get(129):jt,mt=rt==="inherit"?Q.get(125):rt,Ft=Q.get(128),xt=ge.isDominatedByLongLines,Pt=Q.get(54),ht=Q.get(64).renderType!==0,kt=Q.get(65),Bt=Q.get(99),Ot=Q.get(80),Ge=Q.get(69),Mt=Q.get(97),Nt=Mt.verticalScrollbarSize,zt=Mt.verticalHasArrows,ft=Mt.arrowSize,De=Mt.horizontalScrollbarSize,Pe=Q.get(40),me=Q.get(104)!=="never";let X=Q.get(62);Pe&&me&&(X+=16);let Re=0;if(ht){const pt=Math.max(Ye,kt);Re=Math.round(pt*vt)}let Be=0;Pt&&(Be=He);let Qe=0,$e=Qe+Be,Ze=$e+Re,ct=Ze+X;const Tt=Me-Be-Re-X;let bt=!1,Et=!1,It=-1;rt==="inherit"&&xt?(bt=!0,Et=!0):mt==="on"||mt==="bounded"?Et=!0:mt==="wordWrapColumn"&&(It=Ft);const St=pe.c({outerWidth:Me,outerHeight:ze,lineHeight:He,typicalHalfwidthCharacterWidth:nt,pixelRatio:wt,scrollBeyondLastLine:Bt,paddingTop:Ot.top,paddingBottom:Ot.bottom,minimap:Ge,verticalScrollbarWidth:Nt,viewLineCount:Ct,remainingWidth:Tt,isViewportWrapping:Et},ge.memory||new M);St.renderMinimap!==0&&St.minimapLeft===0&&(Qe+=St.minimapWidth,$e+=St.minimapWidth,Ze+=St.minimapWidth,ct+=St.minimapWidth);const yt=Tt-St.minimapWidth,qt=Math.max(1,Math.floor((yt-Nt-2)/nt)),Jt=zt?ft:0;return Et&&(It=Math.max(1,qt),mt==="bounded"&&(It=Math.min(It,Ft))),{width:Me,height:ze,glyphMarginLeft:Qe,glyphMarginWidth:Be,lineNumbersLeft:$e,lineNumbersWidth:Re,decorationsLeft:Ze,decorationsWidth:X,contentLeft:ct,contentWidth:yt,minimap:St,viewportColumn:qt,isWordWrapMinified:bt,isViewportWrapping:Et,wrappingColumn:It,verticalScrollbarWidth:Nt,horizontalScrollbarHeight:De,overviewRuler:{top:Jt,width:Nt,height:ze-2*Jt,right:0}}}}e.EditorLayoutInfoComputer=pe;class ue extends E{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[r.localize(46,null),r.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:r.localize(48,null)}})}validate(Q){return n(Q,"simple",["simple","advanced"])}compute(Q,ge,Me){return ge.get(2)===2?"advanced":Me}}class de extends E{constructor(){const Q={enabled:!0};super(61,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:r.localize(49,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:o(Q.enabled,this.defaultValue.enabled)}}}class re extends E{constructor(){const Q={enabled:!1,maxLineCount:5};super(109,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:r.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:r.localize(51,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),maxLineCount:w.clampedInt(ge.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class G extends E{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:r.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[r.localize(53,null),r.localize(54,null,k.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),r.localize(55,null,k.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),r.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:r.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:r.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:r.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return typeof ge.enabled=="boolean"&&(ge.enabled=ge.enabled?"on":"off"),{enabled:n(ge.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:w.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(ge.fontFamily,this.defaultValue.fontFamily),padding:o(ge.padding,this.defaultValue.padding)}}}class H extends E{constructor(){super(62,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):w.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,ge,Me){return Me<0?w.clampedInt(-Me*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Me}}class oe extends A{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>A.clamp(Q,0,150),{markdownDescription:r.localize(60,null)})}compute(Q,ge,Me){return Q.fontInfo.lineHeight}}class ve extends E{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:r.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:r.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[r.localize(63,null),r.localize(64,null),r.localize(65,null)],default:Q.size,description:r.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:r.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:r.localize(68,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:r.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:r.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:r.localize(71,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),autohide:o(ge.autohide,this.defaultValue.autohide),size:n(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:n(ge.side,this.defaultValue.side,["right","left"]),showSlider:n(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(ge.renderCharacters,this.defaultValue.renderCharacters),scale:w.clampedInt(ge.scale,1,1,3),maxColumn:w.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ae(Y){return Y==="ctrlCmd"?k.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Ue extends E{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(73,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{top:w.clampedInt(ge.top,0,0,1e3),bottom:w.clampedInt(ge.bottom,0,0,1e3)}}}class xe extends E{constructor(){const Q={enabled:!0,cycle:!0};super(81,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:r.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:r.localize(75,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),cycle:o(ge.cycle,this.defaultValue.cycle)}}}class Te extends m{constructor(){super(136)}compute(Q,ge,Me){return Q.pixelRatio}}class Se extends E{constructor(){const Q={other:"on",comments:"off",strings:"off"},ge=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[r.localize(76,null),r.localize(77,null),r.localize(78,null)]}];super(84,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ge,default:Q.strings,description:r.localize(79,null)},comments:{anyOf:ge,default:Q.comments,description:r.localize(80,null)},other:{anyOf:ge,default:Q.other,description:r.localize(81,null)}},default:Q,markdownDescription:r.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const wt=Q?"on":"off";return{comments:wt,strings:wt,other:wt}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:ge,comments:Me,strings:ze}=Q,He=["on","inline","off"];let Ye,nt,vt;return typeof ge=="boolean"?Ye=ge?"on":"off":Ye=n(ge,this.defaultValue.other,He),typeof Me=="boolean"?nt=Me?"on":"off":nt=n(Me,this.defaultValue.comments,He),typeof ze=="boolean"?vt=ze?"on":"off":vt=n(ze,this.defaultValue.strings,He),{other:Ye,comments:nt,strings:vt}}}var ke;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(ke=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class se extends E{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[r.localize(83,null),r.localize(84,null),r.localize(85,null),r.localize(86,null)],default:"on",description:r.localize(87,null)})}validate(Q){let ge=this.defaultValue.renderType,Me=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(ge=4,Me=Q):Q==="interval"?ge=3:Q==="relative"?ge=2:Q==="on"?ge=1:ge=0),{renderType:ge,renderFn:Me}}}function ce(Y){const Q=Y.get(92);return Q==="editable"?Y.get(86):Q!=="on"}e.filterValidationDecorations=ce;class J extends E{constructor(){const Q=[],ge={type:"number",description:r.localize(88,null)};super(96,"rulers",Q,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:r.localize(89,null),format:"color-hex"}}}]},default:Q,description:r.localize(90,null)})}validate(Q){if(Array.isArray(Q)){const ge=[];for(const Me of Q)if(typeof Me=="number")ge.push({column:w.clampedInt(Me,0,0,1e4),color:null});else if(Me&&typeof Me=="object"){const ze=Me;ge.push({column:w.clampedInt(ze.column,0,0,1e4),color:ze.color})}return ge.sort((Me,ze)=>Me.column-ze.column),ge}return this.defaultValue}}function I(Y,Q){if(typeof Y!="string")return Q;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends E{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(91,null),r.localize(92,null),r.localize(93,null)],default:"auto",description:r.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(95,null),r.localize(96,null),r.localize(97,null)],default:"auto",description:r.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:r.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:r.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:r.localize(101,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q,Me=w.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=w.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:w.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:I(ge.vertical,this.defaultValue.vertical),horizontal:I(ge.horizontal,this.defaultValue.horizontal),useShadows:o(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Me,horizontalSliderSize:w.clampedInt(ge.horizontalSliderSize,Me,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:w.clampedInt(ge.verticalSliderSize,ze,0,1e3),scrollByPage:o(ge.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class W extends E{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:r.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:r.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:r.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:r.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:r.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:r.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:r.localize(108,null)}})}applyUpdate(Q,ge){let Me=!1;ge.allowedCharacters&&Q&&(S.equals(Q.allowedCharacters,ge.allowedCharacters)||(Q={...Q,allowedCharacters:ge.allowedCharacters},Me=!0)),ge.allowedLocales&&Q&&(S.equals(Q.allowedLocales,ge.allowedLocales)||(Q={...Q,allowedLocales:ge.allowedLocales},Me=!0));const ze=super.applyUpdate(Q,ge);return Me?new f(ze.newValue,!0):ze}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{nonBasicASCII:ye(ge.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(ge.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(ge.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ye(ge.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ye(ge.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,ge){if(typeof Q!="object"||!Q)return ge;const Me={};for(const[ze,He]of Object.entries(Q))He===!0&&(Me[ze]=!0);return Me}}class K extends E{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(59,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:r.localize(109,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),mode:n(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ee extends E{constructor(){const Q={enabled:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:r.localize(110,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:r.localize(111,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(ge.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class he extends E{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(112,null),r.localize(113,null),r.localize(114,null)],default:Q.bracketPairs,description:r.localize(115,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(116,null),r.localize(117,null),r.localize(118,null)],default:Q.bracketPairsHorizontal,description:r.localize(119,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:r.localize(120,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:r.localize(121,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[r.localize(122,null),r.localize(123,null),r.localize(124,null)],default:Q.highlightActiveIndentation,description:r.localize(125,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{bracketPairs:ye(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ye(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:ye(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ye(Y,Q,ge){const Me=ge.indexOf(Y);return Me===-1?Q:ge[Me]}class ae extends E{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[r.localize(126,null),r.localize(127,null)],default:Q.insertMode,description:r.localize(128,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:r.localize(129,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:r.localize(130,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:r.localize(131,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[r.localize(132,null),r.localize(133,null),r.localize(134,null),r.localize(135,null)],default:Q.selectionMode,markdownDescription:r.localize(136,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:r.localize(137,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:r.localize(138,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:r.localize(139,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:r.localize(140,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:r.localize(141,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:r.localize(142,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:r.localize(143,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:r.localize(144,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:r.localize(145,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:r.localize(146,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:r.localize(147,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:r.localize(148,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:r.localize(149,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:r.localize(150,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:r.localize(151,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:r.localize(152,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:r.localize(153,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:r.localize(154,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:r.localize(155,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:r.localize(156,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:r.localize(157,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:r.localize(158,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:r.localize(159,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:r.localize(160,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:r.localize(161,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:r.localize(162,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:r.localize(163,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:r.localize(164,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:r.localize(165,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:r.localize(166,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:r.localize(167,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:r.localize(168,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:r.localize(169,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:r.localize(170,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:r.localize(171,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:r.localize(172,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:r.localize(173,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{insertMode:n(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:n(ge.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(ge.showIcons,this.defaultValue.showIcons),showStatusBar:o(ge.showStatusBar,this.defaultValue.showStatusBar),preview:o(ge.preview,this.defaultValue.preview),previewMode:n(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(ge.showMethods,this.defaultValue.showMethods),showFunctions:o(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:o(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(ge.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(ge.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(ge.showFields,this.defaultValue.showFields),showVariables:o(ge.showVariables,this.defaultValue.showVariables),showClasses:o(ge.showClasses,this.defaultValue.showClasses),showStructs:o(ge.showStructs,this.defaultValue.showStructs),showInterfaces:o(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:o(ge.showModules,this.defaultValue.showModules),showProperties:o(ge.showProperties,this.defaultValue.showProperties),showEvents:o(ge.showEvents,this.defaultValue.showEvents),showOperators:o(ge.showOperators,this.defaultValue.showOperators),showUnits:o(ge.showUnits,this.defaultValue.showUnits),showValues:o(ge.showValues,this.defaultValue.showValues),showConstants:o(ge.showConstants,this.defaultValue.showConstants),showEnums:o(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:o(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(ge.showKeywords,this.defaultValue.showKeywords),showWords:o(ge.showWords,this.defaultValue.showWords),showColors:o(ge.showColors,this.defaultValue.showColors),showFiles:o(ge.showFiles,this.defaultValue.showFiles),showReferences:o(ge.showReferences,this.defaultValue.showReferences),showFolders:o(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:o(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(ge.showSnippets,this.defaultValue.showSnippets),showUsers:o(ge.showUsers,this.defaultValue.showUsers),showIssues:o(ge.showIssues,this.defaultValue.showIssues)}}}class be extends E{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:r.localize(174,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Ee extends m{constructor(){super(137)}compute(Q,ge,Me){return ge.get(86)?!0:Q.tabFocusMode}}var We;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(We=e.WrappingIndent||(e.WrappingIndent={}));class Ve extends E{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[r.localize(175,null),r.localize(176,null),r.localize(177,null),r.localize(178,null)],description:r.localize(179,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,ge,Me){return ge.get(2)===2?0:Me}}class tt extends m{constructor(){super(139)}compute(Q,ge,Me){const ze=ge.get(138);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}class Xe extends E{constructor(){const Q={enabled:!0};super(33,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:r.localize(180,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:o(Q.enabled,this.defaultValue.enabled)}}}const et="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",dt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:k.isMacintosh?it:k.isLinux?dt:et,fontWeight:"normal",fontSize:k.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var ot;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.autoClosingBrackets=5]="autoClosingBrackets",Y[Y.autoClosingDelete=6]="autoClosingDelete",Y[Y.autoClosingOvertype=7]="autoClosingOvertype",Y[Y.autoClosingQuotes=8]="autoClosingQuotes",Y[Y.autoIndent=9]="autoIndent",Y[Y.automaticLayout=10]="automaticLayout",Y[Y.autoSurround=11]="autoSurround",Y[Y.bracketPairColorization=12]="bracketPairColorization",Y[Y.guides=13]="guides",Y[Y.codeLens=14]="codeLens",Y[Y.codeLensFontFamily=15]="codeLensFontFamily",Y[Y.codeLensFontSize=16]="codeLensFontSize",Y[Y.colorDecorators=17]="colorDecorators",Y[Y.colorDecoratorsLimit=18]="colorDecoratorsLimit",Y[Y.columnSelection=19]="columnSelection",Y[Y.comments=20]="comments",Y[Y.contextmenu=21]="contextmenu",Y[Y.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=23]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=25]="cursorStyle",Y[Y.cursorSurroundingLines=26]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=28]="cursorWidth",Y[Y.disableLayerHinting=29]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",Y[Y.domReadOnly=31]="domReadOnly",Y[Y.dragAndDrop=32]="dragAndDrop",Y[Y.dropIntoEditor=33]="dropIntoEditor",Y[Y.emptySelectionClipboard=34]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=36]="extraEditorClassName",Y[Y.fastScrollSensitivity=37]="fastScrollSensitivity",Y[Y.find=38]="find",Y[Y.fixedOverflowWidgets=39]="fixedOverflowWidgets",Y[Y.folding=40]="folding",Y[Y.foldingStrategy=41]="foldingStrategy",Y[Y.foldingHighlight=42]="foldingHighlight",Y[Y.foldingImportsByDefault=43]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=44]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=46]="fontFamily",Y[Y.fontInfo=47]="fontInfo",Y[Y.fontLigatures=48]="fontLigatures",Y[Y.fontSize=49]="fontSize",Y[Y.fontWeight=50]="fontWeight",Y[Y.fontVariations=51]="fontVariations",Y[Y.formatOnPaste=52]="formatOnPaste",Y[Y.formatOnType=53]="formatOnType",Y[Y.glyphMargin=54]="glyphMargin",Y[Y.gotoLocation=55]="gotoLocation",Y[Y.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",Y[Y.hover=57]="hover",Y[Y.inDiffEditor=58]="inDiffEditor",Y[Y.inlineSuggest=59]="inlineSuggest",Y[Y.letterSpacing=60]="letterSpacing",Y[Y.lightbulb=61]="lightbulb",Y[Y.lineDecorationsWidth=62]="lineDecorationsWidth",Y[Y.lineHeight=63]="lineHeight",Y[Y.lineNumbers=64]="lineNumbers",Y[Y.lineNumbersMinChars=65]="lineNumbersMinChars",Y[Y.linkedEditing=66]="linkedEditing",Y[Y.links=67]="links",Y[Y.matchBrackets=68]="matchBrackets",Y[Y.minimap=69]="minimap",Y[Y.mouseStyle=70]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=72]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=74]="multiCursorModifier",Y[Y.multiCursorPaste=75]="multiCursorPaste",Y[Y.multiCursorLimit=76]="multiCursorLimit",Y[Y.occurrencesHighlight=77]="occurrencesHighlight",Y[Y.overviewRulerBorder=78]="overviewRulerBorder",Y[Y.overviewRulerLanes=79]="overviewRulerLanes",Y[Y.padding=80]="padding",Y[Y.parameterHints=81]="parameterHints",Y[Y.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=84]="quickSuggestions",Y[Y.quickSuggestionsDelay=85]="quickSuggestionsDelay",Y[Y.readOnly=86]="readOnly",Y[Y.renameOnType=87]="renameOnType",Y[Y.renderControlCharacters=88]="renderControlCharacters",Y[Y.renderFinalNewline=89]="renderFinalNewline",Y[Y.renderLineHighlight=90]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=92]="renderValidationDecorations",Y[Y.renderWhitespace=93]="renderWhitespace",Y[Y.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",Y[Y.roundedSelection=95]="roundedSelection",Y[Y.rulers=96]="rulers",Y[Y.scrollbar=97]="scrollbar",Y[Y.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=99]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=100]="scrollPredominantAxis",Y[Y.selectionClipboard=101]="selectionClipboard",Y[Y.selectionHighlight=102]="selectionHighlight",Y[Y.selectOnLineNumbers=103]="selectOnLineNumbers",Y[Y.showFoldingControls=104]="showFoldingControls",Y[Y.showUnused=105]="showUnused",Y[Y.snippetSuggestions=106]="snippetSuggestions",Y[Y.smartSelect=107]="smartSelect",Y[Y.smoothScrolling=108]="smoothScrolling",Y[Y.stickyScroll=109]="stickyScroll",Y[Y.stickyTabStops=110]="stickyTabStops",Y[Y.stopRenderingLineAfter=111]="stopRenderingLineAfter",Y[Y.suggest=112]="suggest",Y[Y.suggestFontSize=113]="suggestFontSize",Y[Y.suggestLineHeight=114]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",Y[Y.suggestSelection=116]="suggestSelection",Y[Y.tabCompletion=117]="tabCompletion",Y[Y.tabIndex=118]="tabIndex",Y[Y.unicodeHighlighting=119]="unicodeHighlighting",Y[Y.unusualLineTerminators=120]="unusualLineTerminators",Y[Y.useShadowDOM=121]="useShadowDOM",Y[Y.useTabStops=122]="useTabStops",Y[Y.wordBreak=123]="wordBreak",Y[Y.wordSeparators=124]="wordSeparators",Y[Y.wordWrap=125]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=128]="wordWrapColumn",Y[Y.wordWrapOverride1=129]="wordWrapOverride1",Y[Y.wordWrapOverride2=130]="wordWrapOverride2",Y[Y.wrappingIndent=131]="wrappingIndent",Y[Y.wrappingStrategy=132]="wrappingStrategy",Y[Y.showDeprecated=133]="showDeprecated",Y[Y.inlayHints=134]="inlayHints",Y[Y.editorClassName=135]="editorClassName",Y[Y.pixelRatio=136]="pixelRatio",Y[Y.tabFocusMode=137]="tabFocusMode",Y[Y.layoutInfo=138]="layoutInfo",Y[Y.wrappingInfo=139]="wrappingInfo"})(ot=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new l(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:r.localize(181,null)})),acceptSuggestionOnEnter:Fe(new h(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",r.localize(182,null),""],markdownDescription:r.localize(183,null)})),accessibilitySupport:Fe(new t),accessibilityPageSize:Fe(new w(3,"accessibilityPageSize",10,1,1073741824,{description:r.localize(184,null),tags:["accessibility"]})),ariaLabel:Fe(new p(4,"ariaLabel",r.localize(185,null))),autoClosingBrackets:Fe(new h(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(186,null),r.localize(187,null),""],description:r.localize(188,null)})),autoClosingDelete:Fe(new h(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",r.localize(189,null),""],description:r.localize(190,null)})),autoClosingOvertype:Fe(new h(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",r.localize(191,null),""],description:r.localize(192,null)})),autoClosingQuotes:Fe(new h(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(193,null),r.localize(194,null),""],description:r.localize(195,null)})),autoIndent:Fe(new i(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[r.localize(196,null),r.localize(197,null),r.localize(198,null),r.localize(199,null),r.localize(200,null)],description:r.localize(201,null)})),automaticLayout:Fe(new l(10,"automaticLayout",!1)),autoSurround:Fe(new h(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[r.localize(202,null),r.localize(203,null),r.localize(204,null),""],description:r.localize(205,null)})),bracketPairColorization:Fe(new ee),bracketPairGuides:Fe(new he),stickyTabStops:Fe(new l(110,"stickyTabStops",!1,{description:r.localize(206,null)})),codeLens:Fe(new l(14,"codeLens",!0,{description:r.localize(207,null)})),codeLensFontFamily:Fe(new p(15,"codeLensFontFamily","",{description:r.localize(208,null)})),codeLensFontSize:Fe(new w(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:r.localize(209,null)})),colorDecorators:Fe(new l(17,"colorDecorators",!0,{description:r.localize(210,null)})),colorDecoratorsLimit:Fe(new w(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:r.localize(211,null)})),columnSelection:Fe(new l(19,"columnSelection",!1,{description:r.localize(212,null)})),comments:Fe(new g),contextmenu:Fe(new l(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new l(22,"copyWithSyntaxHighlighting",!0,{description:r.localize(213,null)})),cursorBlinking:Fe(new i(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:r.localize(214,null)})),cursorSmoothCaretAnimation:Fe(new h(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[r.localize(215,null),r.localize(216,null),r.localize(217,null)],description:r.localize(218,null)})),cursorStyle:Fe(new i(25,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],O,{description:r.localize(219,null)})),cursorSurroundingLines:Fe(new w(26,"cursorSurroundingLines",0,0,1073741824,{description:r.localize(220,null)})),cursorSurroundingLinesStyle:Fe(new h(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[r.localize(221,null),r.localize(222,null)],description:r.localize(223,null)})),cursorWidth:Fe(new w(28,"cursorWidth",0,0,1073741824,{markdownDescription:r.localize(224,null)})),disableLayerHinting:Fe(new l(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new l(30,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new l(31,"domReadOnly",!1)),dragAndDrop:Fe(new l(32,"dragAndDrop",!0,{description:r.localize(225,null)})),emptySelectionClipboard:Fe(new Z),dropIntoEditor:Fe(new Xe),stickyScroll:Fe(new re),experimentalWhitespaceRendering:Fe(new h(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[r.localize(226,null),r.localize(227,null),r.localize(228,null)],description:r.localize(229,null)})),extraEditorClassName:Fe(new p(36,"extraEditorClassName","")),fastScrollSensitivity:Fe(new A(37,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:r.localize(230,null)})),find:Fe(new x),fixedOverflowWidgets:Fe(new l(39,"fixedOverflowWidgets",!1)),folding:Fe(new l(40,"folding",!0,{description:r.localize(231,null)})),foldingStrategy:Fe(new h(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[r.localize(232,null),r.localize(233,null)],description:r.localize(234,null)})),foldingHighlight:Fe(new l(42,"foldingHighlight",!0,{description:r.localize(235,null)})),foldingImportsByDefault:Fe(new l(43,"foldingImportsByDefault",!1,{description:r.localize(236,null)})),foldingMaximumRegions:Fe(new w(44,"foldingMaximumRegions",5e3,10,65e3,{description:r.localize(237,null)})),unfoldOnClickAfterEndOfLine:Fe(new l(45,"unfoldOnClickAfterEndOfLine",!1,{description:r.localize(238,null)})),fontFamily:Fe(new p(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:r.localize(239,null)})),fontInfo:Fe(new P),fontLigatures2:Fe(new L),fontSize:Fe(new F),fontWeight:Fe(new V),fontVariations:Fe(new $),formatOnPaste:Fe(new l(52,"formatOnPaste",!1,{description:r.localize(240,null)})),formatOnType:Fe(new l(53,"formatOnType",!1,{description:r.localize(241,null)})),glyphMargin:Fe(new l(54,"glyphMargin",!0,{description:r.localize(242,null)})),gotoLocation:Fe(new q),hideCursorInOverviewRuler:Fe(new l(56,"hideCursorInOverviewRuler",!1,{description:r.localize(243,null)})),hover:Fe(new le),inDiffEditor:Fe(new l(58,"inDiffEditor",!1)),letterSpacing:Fe(new A(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>A.clamp(Y,-5,20),{description:r.localize(244,null)})),lightbulb:Fe(new de),lineDecorationsWidth:Fe(new H),lineHeight:Fe(new oe),lineNumbers:Fe(new se),lineNumbersMinChars:Fe(new w(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new l(66,"linkedEditing",!1,{description:r.localize(245,null)})),links:Fe(new l(67,"links",!0,{description:r.localize(246,null)})),matchBrackets:Fe(new h(68,"matchBrackets","always",["always","near","never"],{description:r.localize(247,null)})),minimap:Fe(new ve),mouseStyle:Fe(new h(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new A(71,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:r.localize(248,null)})),mouseWheelZoom:Fe(new l(72,"mouseWheelZoom",!1,{markdownDescription:r.localize(249,null)})),multiCursorMergeOverlapping:Fe(new l(73,"multiCursorMergeOverlapping",!0,{description:r.localize(250,null)})),multiCursorModifier:Fe(new i(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ae,{markdownEnumDescriptions:[r.localize(251,null),r.localize(252,null)],markdownDescription:r.localize(253,null)})),multiCursorPaste:Fe(new h(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[r.localize(254,null),r.localize(255,null)],markdownDescription:r.localize(256,null)})),multiCursorLimit:Fe(new w(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:r.localize(257,null)})),occurrencesHighlight:Fe(new l(77,"occurrencesHighlight",!0,{description:r.localize(258,null)})),overviewRulerBorder:Fe(new l(78,"overviewRulerBorder",!0,{description:r.localize(259,null)})),overviewRulerLanes:Fe(new w(79,"overviewRulerLanes",3,0,3)),padding:Fe(new Ue),parameterHints:Fe(new xe),peekWidgetDefaultFocus:Fe(new h(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[r.localize(260,null),r.localize(261,null)],description:r.localize(262,null)})),definitionLinkOpensInPeek:Fe(new l(83,"definitionLinkOpensInPeek",!1,{description:r.localize(263,null)})),quickSuggestions:Fe(new Se),quickSuggestionsDelay:Fe(new w(85,"quickSuggestionsDelay",10,0,1073741824,{description:r.localize(264,null)})),readOnly:Fe(new l(86,"readOnly",!1)),renameOnType:Fe(new l(87,"renameOnType",!1,{description:r.localize(265,null),markdownDeprecationMessage:r.localize(266,null)})),renderControlCharacters:Fe(new l(88,"renderControlCharacters",!0,{description:r.localize(267,null),restricted:!0})),renderFinalNewline:Fe(new h(89,"renderFinalNewline",k.isLinux?"dimmed":"on",["off","on","dimmed"],{description:r.localize(268,null)})),renderLineHighlight:Fe(new h(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",r.localize(269,null)],description:r.localize(270,null)})),renderLineHighlightOnlyWhenFocus:Fe(new l(91,"renderLineHighlightOnlyWhenFocus",!1,{description:r.localize(271,null)})),renderValidationDecorations:Fe(new h(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new h(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",r.localize(272,null),r.localize(273,null),r.localize(274,null),""],description:r.localize(275,null)})),revealHorizontalRightPadding:Fe(new w(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new l(95,"roundedSelection",!0,{description:r.localize(276,null)})),rulers:Fe(new J),scrollbar:Fe(new B),scrollBeyondLastColumn:Fe(new w(98,"scrollBeyondLastColumn",4,0,1073741824,{description:r.localize(277,null)})),scrollBeyondLastLine:Fe(new l(99,"scrollBeyondLastLine",!0,{description:r.localize(278,null)})),scrollPredominantAxis:Fe(new l(100,"scrollPredominantAxis",!0,{description:r.localize(279,null)})),selectionClipboard:Fe(new l(101,"selectionClipboard",!0,{description:r.localize(280,null),included:k.isLinux})),selectionHighlight:Fe(new l(102,"selectionHighlight",!0,{description:r.localize(281,null)})),selectOnLineNumbers:Fe(new l(103,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new h(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[r.localize(282,null),r.localize(283,null),r.localize(284,null)],description:r.localize(285,null)})),showUnused:Fe(new l(105,"showUnused",!0,{description:r.localize(286,null)})),showDeprecated:Fe(new l(133,"showDeprecated",!0,{description:r.localize(287,null)})),inlayHints:Fe(new G),snippetSuggestions:Fe(new h(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[r.localize(288,null),r.localize(289,null),r.localize(290,null),r.localize(291,null)],description:r.localize(292,null)})),smartSelect:Fe(new be),smoothScrolling:Fe(new l(108,"smoothScrolling",!1,{description:r.localize(293,null)})),stopRenderingLineAfter:Fe(new w(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new ae),inlineSuggest:Fe(new K),suggestFontSize:Fe(new w(113,"suggestFontSize",0,0,1e3,{markdownDescription:r.localize(294,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new w(114,"suggestLineHeight",0,0,1e3,{markdownDescription:r.localize(295,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new l(115,"suggestOnTriggerCharacters",!0,{description:r.localize(296,null)})),suggestSelection:Fe(new h(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[r.localize(297,null),r.localize(298,null),r.localize(299,null)],description:r.localize(300,null)})),tabCompletion:Fe(new h(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[r.localize(301,null),r.localize(302,null),r.localize(303,null)],description:r.localize(304,null)})),tabIndex:Fe(new w(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new W),unusualLineTerminators:Fe(new h(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[r.localize(305,null),r.localize(306,null),r.localize(307,null)],description:r.localize(308,null)})),useShadowDOM:Fe(new l(121,"useShadowDOM",!0)),useTabStops:Fe(new l(122,"useTabStops",!0,{description:r.localize(309,null)})),wordBreak:Fe(new h(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[r.localize(310,null),r.localize(311,null)],description:r.localize(312,null)})),wordSeparators:Fe(new p(124,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:r.localize(313,null)})),wordWrap:Fe(new h(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[r.localize(314,null),r.localize(315,null),r.localize(316,null),r.localize(317,null)],description:r.localize(318,null)})),wordWrapBreakAfterCharacters:Fe(new p(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new p(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new w(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:r.localize(319,null)})),wordWrapOverride1:Fe(new h(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new h(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new j),pixelRatio:Fe(new Te),tabFocusMode:Fe(new Ee),layoutInfo:Fe(new pe),wrappingInfo:Fe(new tt),wrappingIndent:Fe(new Ve),wrappingStrategy:Fe(new ue)}}),define(Ie[131],Ce([13,14]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ie[132],Ce([13,14]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ie[133],Ce([13,14]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ie[134],Ce([13,14]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(Ie[135],Ce([13,14]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(Ie[136],Ce([13,14]),function(te,e){return te.create("vs/platform/theme/common/iconRegistry",e)}),define(Ie[137],Ce([13,14]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(Ie[138],Ce([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ie[139],Ce([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ie[140],Ce([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(Ie[141],Ce([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ie[142],Ce([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ie[143],Ce([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ie[144],Ce([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ie[145],Ce([13,14]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(Ie[146],Ce([13,14]),function(te,e){return te.create("vs/workbench/common/views",e)}),define(Ie[147],Ce([13,14]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ie[148],Ce([13,14]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ie[149],Ce([13,14]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ie[150],Ce([13,14]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ie[151],Ce([13,14]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ie[152],Ce([13,14]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ie[153],Ce([13,14]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ie[154],Ce([1,0,12]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class k{constructor(){this.a=new Map}register(N,S){this.a.set(N,S)}updateManifest(N){if(!(typeof N.main>"u"&&typeof N.browser>"u")&&(N.activationEvents===void 0&&Object.assign(N,{activationEvents:[]}),!(!Array.isArray(N.activationEvents)||!N.contributes)))for(const S in N.contributes){const R=this.a.get(S);if(!R)continue;const y=N.contributes[S],T=Array.isArray(y)?y:[y];try{R(T,N.activationEvents)}catch(M){(0,r.onUnexpectedError)(M)}}}}e.ImplicitActivationEventsImpl=k,e.ImplicitActivationEvents=new k}),define(Ie[155],Ce([1,0,24,29,133,255]),function(te,e,r,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const S=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function y(l){return l=l.trim(),l==="*"||S.test(l)}e.isValidVersionStr=y;function T(l){if(!y(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=l.match(S);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=T;function M(l){if(!l)return null;const v=l.majorBase,w=l.majorMustEqual,A=l.minorBase;let p=l.minorMustEqual;const n=l.patchBase;let h=l.patchMustEqual;l.hasCaret&&(v===0||(p=!1),h=!1);let i=0;if(l.preRelease){const a=R.exec(l.preRelease);if(a){const[,t,g,c]=a;i=Date.UTC(Number(t),Number(g)-1,Number(c))}}return{majorBase:v,majorMustEqual:w,minorBase:A,minorMustEqual:p,patchBase:n,patchMustEqual:h,isMinimum:l.hasGreaterEquals,notBefore:i}}e.normalizeVersion=M;function E(l,v,w){let A;typeof l=="string"?A=M(T(l)):A=l;let p;v instanceof Date?p=v.getTime():typeof v=="string"&&(p=new Date(v).getTime());let n;if(typeof w=="string"?n=M(T(w)):n=w,!A||!n)return!1;const h=A.majorBase,i=A.minorBase,a=A.patchBase;let t=n.majorBase,g=n.minorBase,c=n.patchBase;const u=n.notBefore;let d=n.majorMustEqual,C=n.minorMustEqual,O=n.patchMustEqual;return n.isMinimum?h>t?!0:h<t?!1:i>g?!0:i<g||p&&p<u?!1:a>=c:(h===1&&t===0&&(!d||!C||!O)&&(t=1,g=0,c=0,d=!0,C=!1,O=!1),h<t?!1:h>t?!d:i<g?!1:i>g?!C:a<c?!1:a>c?!O:!(p&&p<u))}e.isValidVersion=E;function f(l,v,w,A,p){const n=[];if(typeof A.publisher<"u"&&typeof A.publisher!="string")return n.push([k.default.Error,D.localize(0,null)]),n;if(typeof A.name!="string")return n.push([k.default.Error,D.localize(1,null,"name")]),n;if(typeof A.version!="string")return n.push([k.default.Error,D.localize(2,null,"version")]),n;if(!A.engines)return n.push([k.default.Error,D.localize(3,null,"engines")]),n;if(typeof A.engines.vscode!="string")return n.push([k.default.Error,D.localize(4,null,"engines.vscode")]),n;if(typeof A.extensionDependencies<"u"&&!o(A.extensionDependencies))return n.push([k.default.Error,D.localize(5,null,"extensionDependencies")]),n;if(typeof A.activationEvents<"u"){if(!o(A.activationEvents))return n.push([k.default.Error,D.localize(6,null,"activationEvents")]),n;if(typeof A.main>"u"&&typeof A.browser>"u")return n.push([k.default.Error,D.localize(7,null,"activationEvents","main")]),n}if(typeof A.extensionKind<"u"&&typeof A.main>"u"&&n.push([k.default.Warning,D.localize(8,null,"extensionKind")]),typeof A.main<"u"){if(typeof A.main!="string")return n.push([k.default.Error,D.localize(9,null,"main")]),n;{const a=(0,r.joinPath)(w,A.main);(0,r.isEqualOrParent)(a,w)||n.push([k.default.Warning,D.localize(10,null,a.path,w.path)])}if(typeof A.activationEvents>"u")return n.push([k.default.Error,D.localize(11,null,"activationEvents","main")]),n}if(typeof A.browser<"u"){if(typeof A.browser!="string")return n.push([k.default.Error,D.localize(12,null,"browser")]),n;{const a=(0,r.joinPath)(w,A.browser);(0,r.isEqualOrParent)(a,w)||n.push([k.default.Warning,D.localize(13,null,a.path,w.path)])}if(typeof A.activationEvents>"u")return n.push([k.default.Error,D.localize(14,null,"activationEvents","browser")]),n}if(!N.valid(A.version))return n.push([k.default.Error,D.localize(15,null)]),n;const h=[];if(!b(l,v,A,p,h))for(const a of h)n.push([k.default.Error,a]);return n}e.validateExtensionManifest=f;function b(l,v,w,A,p){return A||typeof w.main>"u"&&typeof w.browser>"u"?!0:s(l,v,w.engines.vscode,p)}e.isValidExtensionVersion=b;function m(l,v,w){return l==="*"||s(v,w,l)}e.isEngineValid=m;function s(l,v,w,A=[]){const p=M(T(w));if(!p)return A.push(D.localize(16,null,w)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return A.push(D.localize(17,null,w)),!1}else if(!p.majorMustEqual)return A.push(D.localize(18,null,w)),!1;return E(l,v,p)?!0:(A.push(D.localize(19,null,l,w)),!1)}function o(l){if(!Array.isArray(l))return!1;for(let v=0,w=l.length;v<w;v++)if(typeof l[v]!="string")return!1;return!0}}),define(Ie[89],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class r{constructor(D,N=[],S=!1){this.ctor=D,this.staticArguments=N,this.supportsDelayedInstantiation=S}}e.SyncDescriptor=r}),define(Ie[66],Ce([1,0,89]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const k=[];var D;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function N(R,y,T){y instanceof r.SyncDescriptor||(y=new r.SyncDescriptor(y,[],Boolean(T))),k.push([R,y])}e.registerSingleton=N;function S(){return k}e.getSingletonServiceDescriptors=S}),define(Ie[156],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class r{constructor(N,S){this.key=N,this.data=S,this.incoming=new Map,this.outgoing=new Map}}e.Node=r;class k{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const S of this.a.values())S.outgoing.size===0&&N.push(S);return N}insertEdge(N,S){const R=this.lookupOrInsertNode(N),y=this.lookupOrInsertNode(S);R.outgoing.set(y.key,y),y.incoming.set(R.key,R)}removeNode(N){const S=this.b(N);this.a.delete(S);for(const R of this.a.values())R.outgoing.delete(S),R.incoming.delete(S)}lookupOrInsertNode(N){const S=this.b(N);let R=this.a.get(S);return R||(R=new r(S,N),this.a.set(S,R)),R}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[S,R]of this.a)N.push(`${S}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,S]of this.a){const R=new Set([N]),y=this.c(S,R);if(y)return y}}c(N,S){for(const[R,y]of N.outgoing){if(S.has(R))return[...S,R].join(" -> ");S.add(R);const T=this.c(y,S);if(T)return T;S.delete(R)}}}e.Graph=k}),define(Ie[3],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var r;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function R(y){return y[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=R})(r=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function k(S,R,y){R[r.DI_TARGET]===R?R[r.DI_DEPENDENCIES].push({id:S,index:y}):(R[r.DI_DEPENDENCIES]=[{id:S,index:y}],R[r.DI_TARGET]=R)}function D(S){if(r.serviceIds.has(S))return r.serviceIds.get(S);const R=function(y,T,M){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(R,y,M)};return R.toString=()=>S,r.serviceIds.set(S,R),R}e.createDecorator=D;function N(S){return S}e.refineServiceDecorator=N}),define(Ie[41],Ce([1,0,9,2,3]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function N(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof k.URI)}e.isConfigurationOverrides=N;function S(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof k.URI)}e.isConfigurationUpdateOverrides=S;var R;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function T(l,v){const w=Object.create(null);for(const A in l)M(w,A,l[A],v);return w}e.toValuesTree=T;function M(l,v,w,A){const p=v.split("."),n=p.pop();let h=l;for(let i=0;i<p.length;i++){const a=p[i];let t=h[a];switch(typeof t){case"undefined":t=h[a]=Object.create(null);break;case"object":break;default:A(`Ignoring ${v} as ${p.slice(0,i+1).join(".")} is ${JSON.stringify(t)}`);return}h=t}if(typeof h=="object"&&h!==null)try{h[n]=w}catch{A(`Ignoring ${v} as ${p.join(".")} is ${JSON.stringify(h)}`)}else A(`Ignoring ${v} as ${p.join(".")} is ${JSON.stringify(h)}`)}e.addToValueTree=M;function E(l,v){const w=v.split(".");f(l,w)}e.removeFromValueTree=E;function f(l,v){const w=v.shift();if(v.length===0){delete l[w];return}if(Object.keys(l).indexOf(w)!==-1){const A=l[w];typeof A=="object"&&!Array.isArray(A)&&(f(A,v),Object.keys(A).length===0&&delete l[w])}}function b(l,v,w){function A(h,i){let a=h;for(const t of i){if(typeof a!="object"||a===null)return;a=a[t]}return a}const p=v.split("."),n=A(l,p);return typeof n>"u"?w:n}e.getConfigurationValue=b;function m(l,v,w){Object.keys(v).forEach(A=>{A!=="__proto__"&&(A in l?r.isObject(l[A])&&r.isObject(v[A])?m(l[A],v[A],w):w&&(l[A]=v[A]):l[A]=v[A])})}e.merge=m;function s(l,v,w){const A=l.inspect(v),p=l.inspect(w);return typeof A.userValue<"u"||typeof A.workspaceValue<"u"||typeof A.workspaceFolderValue<"u"?A.value:typeof p.userValue<"u"||typeof p.workspaceValue<"u"||typeof p.workspaceFolderValue<"u"?p.value:A.defaultValue}e.getMigratedSettingValue=s;function o(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=o}),define(Ie[42],Ce([1,0,20,10,3]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const N=new Map;N.set("false",!1),N.set("true",!0),N.set("isMac",r.isMacintosh),N.set("isLinux",r.isLinux),N.set("isWindows",r.isWindows),N.set("isWeb",r.isWeb),N.set("isMacNative",r.isMacintosh&&!r.isWeb),N.set("isEdge",r.isEdge),N.set("isFirefox",r.isFirefox),N.set("isChrome",r.isChrome),N.set("isSafari",r.isSafari);const S=Object.prototype.hasOwnProperty;var R;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(R=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return E.INSTANCE}static true(){return f.INSTANCE}static has(L){return b.create(L)}static equals(L,$){return m.create(L,$)}static notEquals(L,$){return l.create(L,$)}static regex(L,$){return i.create(L,$)}static in(L,$){return s.create(L,$)}static notIn(L,$){return o.create(L,$)}static not(L){return v.create(L)}static and(...L){return g.create(L,null,!0)}static or(...L){return c.create(L,null,!0)}static greater(L,$){return A.create(L,$)}static greaterEquals(L,$){return p.create(L,$)}static smaller(L,$){return n.create(L,$)}static smallerEquals(L,$){return h.create(L,$)}static deserialize(L,$=!1){if(!!L)return this.c(L,$)}static c(L,$){const P=L.split("||");return c.create(P.map(F=>this.d(F,$)),null,!0)}static d(L,$){const P=L.split("&&");return g.create(P.map(F=>this.f(F,$)),null,!0)}static f(L,$){if(L=L.trim(),L.indexOf("!=")>=0){const P=L.split("!=");return l.create(P[0].trim(),this.g(P[1],$))}if(L.indexOf("==")>=0){const P=L.split("==");return m.create(P[0].trim(),this.g(P[1],$))}if(L.indexOf("=~")>=0){const P=L.split("=~");return i.create(P[0].trim(),this.h(P[1],$))}if(L.indexOf(" not in ")>=0){const P=L.split(" not in ");return o.create(P[0].trim(),this.g(P[1],$))}if(L.indexOf(" in ")>=0){const P=L.split(" in ");return s.create(P[0].trim(),this.g(P[1],$))}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const P=L.split(">=");return p.create(P[0].trim(),P[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const P=L.split(">");return A.create(P[0].trim(),P[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const P=L.split("<=");return h.create(P[0].trim(),P[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const P=L.split("<");return n.create(P[0].trim(),P[1].trim())}return/^\!\s*/.test(L)?v.create(L.substr(1).trim()):b.create(L)}static g(L,$){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;const P=/^'([^']*)'$/.exec(L);return P?P[1].trim():L}static h(L,$){if((0,k.isFalsyOrWhitespace)(L)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const P=L.indexOf("/"),F=L.lastIndexOf("/");if(P===F||P<0){if($)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}const V=L.slice(P+1,F),q=L[F+1]==="i"?"i":"";try{return new RegExp(V,q)}catch(le){if($)throw new Error(`bad regexp-value '${L}', parse error: ${le}`);return console.warn(`bad regexp-value '${L}', parse error: ${le}`),null}}}e.ContextKeyExpr=y;function T(x,L){const $=x?x.substituteConstants():void 0,P=L?L.substituteConstants():void 0;return!$&&!P?!0:!$||!P?!1:$.equals(P)}e.expressionsAreEqualWithConstantSubstitution=T;function M(x,L){return x.cmp(L)}class E{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class f{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class b{static create(L,$=null){const P=N.get(L);return typeof P=="boolean"?P?f.INSTANCE:E.INSTANCE:new b(L,$)}constructor(L,$){this.key=L,this.c=$,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:d(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=N.get(this.key);return typeof L=="boolean"?L?f.INSTANCE:E.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.c||(this.c=v.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=b;class m{static create(L,$,P=null){if(typeof $=="boolean")return $?b.create(L,P):v.create(L,P);const F=N.get(L);return typeof F=="boolean"?$===(F?"true":"false")?f.INSTANCE:E.INSTANCE:new m(L,$,P)}constructor(L,$,P){this.c=L,this.d=$,this.f=P,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:C(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=N.get(this.c);if(typeof L=="boolean"){const $=L?"true":"false";return this.d===$?f.INSTANCE:E.INSTANCE}return this}evaluate(L){return L.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(L){return L.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=m;class s{static create(L,$){return new s(L,$)}constructor(L,$){this.d=L,this.f=$,this.type=10,this.c=null}cmp(L){return L.type!==this.type?this.type-L.type:C(this.d,this.f,L.d,L.f)}equals(L){return L.type===this.type?this.d===L.d&&this.f===L.f:!1}substituteConstants(){return this}evaluate(L){const $=L.getValue(this.f),P=L.getValue(this.d);return Array.isArray($)?$.includes(P):typeof P=="string"&&typeof $=="object"&&$!==null?S.call($,P):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(L){return L.mapIn(this.d,this.f)}negate(){return this.c||(this.c=o.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=s;class o{static create(L,$){return new o(L,$)}constructor(L,$){this.d=L,this.f=$,this.type=11,this.c=s.create(L,$)}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(L){return L.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=o;class l{static create(L,$,P=null){if(typeof $=="boolean")return $?v.create(L,P):b.create(L,P);const F=N.get(L);return typeof F=="boolean"?$===(F?"true":"false")?E.INSTANCE:f.INSTANCE:new l(L,$,P)}constructor(L,$,P){this.c=L,this.d=$,this.f=P,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:C(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=N.get(this.c);if(typeof L=="boolean"){const $=L?"true":"false";return this.d===$?E.INSTANCE:f.INSTANCE}return this}evaluate(L){return L.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(L){return L.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=m.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=l;class v{static create(L,$=null){const P=N.get(L);return typeof P=="boolean"?P?E.INSTANCE:f.INSTANCE:new v(L,$)}constructor(L,$){this.c=L,this.d=$,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:d(this.c,L.c)}equals(L){return L.type===this.type?this.c===L.c:!1}substituteConstants(){const L=N.get(this.c);return typeof L=="boolean"?L?E.INSTANCE:f.INSTANCE:this}evaluate(L){return!L.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(L){return L.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.ContextKeyNotExpr=v;function w(x,L){if(typeof x=="string"){const $=parseFloat(x);isNaN($)||(x=$)}return typeof x=="string"||typeof x=="number"?L(x):E.INSTANCE}class A{static create(L,$,P=null){return w($,F=>new A(L,F,P))}constructor(L,$,P){this.c=L,this.d=$,this.f=P,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:C(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=A;class p{static create(L,$,P=null){return w($,F=>new p(L,F,P))}constructor(L,$,P){this.c=L,this.d=$,this.f=P,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:C(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=n.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=p;class n{static create(L,$,P=null){return w($,F=>new n(L,F,P))}constructor(L,$,P){this.c=L,this.d=$,this.f=P,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:C(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=n;class h{static create(L,$,P=null){return w($,F=>new h(L,F,P))}constructor(L,$,P){this.c=L,this.d=$,this.f=P,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:C(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=h;class i{static create(L,$){return new i(L,$)}constructor(L,$){this.d=L,this.f=$,this.type=7,this.c=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.d<L.d)return-1;if(this.d>L.d)return 1;const $=this.f?this.f.source:"",P=L.f?L.f.source:"";return $<P?-1:$>P?1:0}equals(L){if(L.type===this.type){const $=this.f?this.f.source:"",P=L.f?L.f.source:"";return this.d===L.d&&$===P}return!1}substituteConstants(){return this}evaluate(L){const $=L.getValue(this.d);return this.f?this.f.test($):!1}serialize(){const L=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${L}`}keys(){return[this.d]}map(L){return L.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=a.create(this)),this.c}}e.ContextKeyRegexExpr=i;class a{static create(L){return new a(L)}constructor(L){this.c=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(L){return new a(this.c.map(L))}negate(){return this.c}}e.ContextKeyNotRegexExpr=a;function t(x){let L=null;for(let $=0,P=x.length;$<P;$++){const F=x[$].substituteConstants();if(x[$]!==F&&L===null){L=[];for(let V=0;V<$;V++)L[V]=x[V]}L!==null&&(L[$]=F)}return L===null?x:L}class g{static create(L,$,P){return g.d(L,$,P)}constructor(L,$){this.expr=L,this.c=$,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let $=0,P=this.expr.length;$<P;$++){const F=M(this.expr[$],L.expr[$]);if(F!==0)return F}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let $=0,P=this.expr.length;$<P;$++)if(!this.expr[$].equals(L.expr[$]))return!1;return!0}return!1}substituteConstants(){const L=t(this.expr);return L===this.expr?this:g.create(L,this.c,!1)}evaluate(L){for(let $=0,P=this.expr.length;$<P;$++)if(!this.expr[$].evaluate(L))return!1;return!0}static d(L,$,P){const F=[];let V=!1;for(const q of L)if(!!q){if(q.type===1){V=!0;continue}if(q.type===0)return E.INSTANCE;if(q.type===6){F.push(...q.expr);continue}F.push(q)}if(F.length===0&&V)return f.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(M);for(let q=1;q<F.length;q++)F[q-1].equals(F[q])&&(F.splice(q,1),q--);if(F.length===1)return F[0];for(;F.length>1;){const q=F[F.length-1];if(q.type!==9)break;F.pop();const le=F.pop(),_=F.length===0,pe=c.create(q.expr.map(ue=>g.create([ue,le],null,P)),null,_);pe&&(F.push(pe),F.sort(M))}if(F.length===1)return F[0];if(P){for(let q=0;q<F.length;q++)for(let le=q+1;le<F.length;le++)if(F[q].negate().equals(F[le]))return E.INSTANCE;if(F.length===1)return F[0]}return new g(F,$)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const $ of this.expr)L.push(...$.keys());return L}map(L){return new g(this.expr.map($=>$.map(L)),null)}negate(){if(!this.c){const L=[];for(const $ of this.expr)L.push($.negate());this.c=c.create(L,this,!0)}return this.c}}class c{static create(L,$,P){return c.d(L,$,P)}constructor(L,$){this.expr=L,this.c=$,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let $=0,P=this.expr.length;$<P;$++){const F=M(this.expr[$],L.expr[$]);if(F!==0)return F}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let $=0,P=this.expr.length;$<P;$++)if(!this.expr[$].equals(L.expr[$]))return!1;return!0}return!1}substituteConstants(){const L=t(this.expr);return L===this.expr?this:c.create(L,this.c,!1)}evaluate(L){for(let $=0,P=this.expr.length;$<P;$++)if(this.expr[$].evaluate(L))return!0;return!1}static d(L,$,P){let F=[],V=!1;if(L){for(let q=0,le=L.length;q<le;q++){const _=L[q];if(!!_){if(_.type===0){V=!0;continue}if(_.type===1)return f.INSTANCE;if(_.type===9){F=F.concat(_.expr);continue}F.push(_)}}if(F.length===0&&V)return E.INSTANCE;F.sort(M)}if(F.length!==0){if(F.length===1)return F[0];for(let q=1;q<F.length;q++)F[q-1].equals(F[q])&&(F.splice(q,1),q--);if(F.length===1)return F[0];if(P){for(let q=0;q<F.length;q++)for(let le=q+1;le<F.length;le++)if(F[q].negate().equals(F[le]))return f.INSTANCE;if(F.length===1)return F[0]}return new c(F,$)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const $ of this.expr)L.push(...$.keys());return L}map(L){return new c(this.expr.map($=>$.map(L)),null)}negate(){if(!this.c){const L=[];for(const $ of this.expr)L.push($.negate());for(;L.length>1;){const $=L.shift(),P=L.shift(),F=[];for(const V of Z($))for(const q of Z(P))F.push(g.create([V,q],null,!1));L.unshift(c.create(F,null,!1))}this.c=c.create(L,this,!0)}return this.c}}class u extends b{static all(){return u.d.values()}constructor(L,$,P){super(L,null),this.f=$,typeof P=="object"?u.d.push({...P,key:L}):P!==!0&&u.d.push({key:L,description:P,type:$!=null?typeof $:void 0})}bindTo(L){return L.createKey(this.key,this.f)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return m.create(this.key,L)}notEqualsTo(L){return l.create(this.key,L)}}e.RawContextKey=u,u.d=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService");function d(x,L){return x<L?-1:x>L?1:0}function C(x,L,$,P){return x<$?-1:x>$?1:L<P?-1:L>P?1:0}function O(x,L){if(x.type===0||L.type===1)return!0;if(x.type===9)return L.type===9?j(x.expr,L.expr):!1;if(L.type===9){for(const $ of L.expr)if(O(x,$))return!0;return!1}if(x.type===6){if(L.type===6)return j(L.expr,x.expr);for(const $ of x.expr)if(O($,L))return!0;return!1}return x.equals(L)}e.implies=O;function j(x,L){let $=0,P=0;for(;$<x.length&&P<L.length;){const F=x[$].cmp(L[P]);if(F<0)return!1;F===0&&$++,P++}return $===x.length}function Z(x){return x.type===9?x.expr:[x]}}),define(Ie[157],Ce([1,0,3]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,r.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,r.refineServiceDecorator)(e.IEnvironmentService)}),define(Ie[90],Ce([1,0,132,3]),function(te,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function N(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=N;function S(l,v){switch(l){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function R(l,v){return v==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function y(l,v,w){return R(v,w)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===w?!0:T(w).includes(l)}e.isTargetPlatformCompatible=y;function T(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=T;function M(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=M;var E;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var f;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(f=e.SortOrder||(e.SortOrder={}));var b;(function(l){l.Install="install",l.Uninstall="uninstall"})(b=e.StatisticType||(e.StatisticType={}));var m;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService");var s;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(s=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class o extends Error{constructor(v,w){super(v),this.code=w,this.name=w}}e.ExtensionManagementError=o,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,r.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,r.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Ie[43],Ce([1,0,47,19,10,9,2,134,3,20]),function(te,e,r,k,D,N,S,R,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function M(_){return _.create===!0}e.isFileOpenForWriteOptions=M;var E;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(E=e.FileType||(e.FileType={}));var f;(function(_){_[_.Readonly=1]="Readonly"})(f=e.FilePermission||(e.FilePermission={}));var b;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileClone=32768]="FileClone"})(b=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(_){return!!(_.capabilities&2)}e.hasReadWriteCapability=m;function s(_){return!!(_.capabilities&8)}e.hasFileFolderCopyCapability=s;function o(_){return!!(_.capabilities&32768)}e.hasFileCloneCapability=o;function l(_){return!!(_.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function v(_){return!!(_.capabilities&16)}e.hasFileReadStreamCapability=v;function w(_){return m(_)?!!(_.capabilities&16384):!1}e.hasFileAtomicReadCapability=w;var A;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(A=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor(pe,ue){super(pe),this.code=ue}}e.FileSystemProviderError=p;function n(_,pe){const ue=new p(_.toString(),pe);return i(ue,pe),ue}e.createFileSystemProviderError=n;function h(_){return _||n((0,R.localize)(0,null),A.Unknown)}e.ensureFileSystemProviderError=h;function i(_,pe){return _.name=pe?`${pe} (FileSystemError)`:"FileSystemError",_}e.markAsFileSystemProviderError=i;function a(_){if(!_)return A.Unknown;if(_ instanceof p)return _.code;const pe=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!pe)return A.Unknown;switch(pe[1]){case A.FileExists:return A.FileExists;case A.FileIsADirectory:return A.FileIsADirectory;case A.FileNotADirectory:return A.FileNotADirectory;case A.FileNotFound:return A.FileNotFound;case A.FileExceedsMemoryLimit:return A.FileExceedsMemoryLimit;case A.FileTooLarge:return A.FileTooLarge;case A.FileWriteLocked:return A.FileWriteLocked;case A.NoPermissions:return A.NoPermissions;case A.Unavailable:return A.Unavailable}return A.Unknown}e.toFileSystemProviderErrorCode=a;function t(_){if(_ instanceof O)return _.fileOperationResult;switch(a(_)){case A.FileNotFound:return 1;case A.FileIsADirectory:return 0;case A.FileNotADirectory:return 10;case A.FileWriteLocked:return 5;case A.NoPermissions:return 6;case A.FileExists:return 4;case A.FileExceedsMemoryLimit:return 9;case A.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var g;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(g=e.FileOperation||(e.FileOperation={}));class c{constructor(pe,ue,de){this.resource=pe,this.operation=ue,this.target=de}isOperation(pe){return this.operation===pe}}e.FileOperationEvent=c;var u;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class d{constructor(pe,ue){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const de=new Map;for(const re of pe){const G=de.get(re.type);switch(G?G.push([re.resource,re]):de.set(re.type,[[re.resource,re]]),re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}}for(const[re,G]of de)switch(re){case 1:this.a=r.TernarySearchTree.forUris(()=>ue),this.a.fill(G);break;case 0:this.b=r.TernarySearchTree.forUris(()=>ue),this.b.fill(G);break;case 2:this.c=r.TernarySearchTree.forUris(()=>ue),this.c.fill(G);break}}contains(pe,...ue){return this.d(pe,{includeChildren:!1},...ue)}affects(pe,...ue){return this.d(pe,{includeChildren:!0},...ue)}d(pe,ue,...de){if(!pe)return!1;const re=de.length>0;return!!((!re||de.includes(1))&&(this.a?.get(pe)||ue.includeChildren&&this.a?.findSuperstr(pe))||(!re||de.includes(0))&&(this.b?.get(pe)||ue.includeChildren&&this.b?.findSuperstr(pe))||(!re||de.includes(2))&&(this.c?.findSubstr(pe)||ue.includeChildren&&this.c?.findSuperstr(pe)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=d;function C(_,pe,ue){return!_||!pe||_===pe||pe.length>_.length?!1:(pe.charAt(pe.length-1)!==k.sep&&(pe+=k.sep),ue?(0,D.startsWithIgnoreCase)(_,pe):_.indexOf(pe)===0)}e.isParent=C;class O extends Error{constructor(pe,ue,de){super(pe),this.fileOperationResult=ue,this.options=de}}e.FileOperationError=O;class j extends O{constructor(pe,ue,de,re){super(pe,ue,re),this.fileOperationResult=ue,this.size=de}}e.TooLargeFileOperationError=j;class Z extends O{constructor(pe,ue,de){super(pe,2,de),this.stat=ue}}e.NotModifiedSinceFileOperationError=Z;var x;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",_[_.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(x=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var L;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(L=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function $(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.etag=$;async function P(_,pe){if(!pe.hasProvider(S.URI.from({scheme:_.scheme})))return new Promise(ue=>{const de=pe.onDidChangeFileSystemProviderRegistrations(re=>{re.scheme===_.scheme&&re.added&&(de.dispose(),ue())})})}e.whenProviderRegistered=P,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(pe){return(0,N.isNumber)(pe)||(pe=0),pe<F.KB?(0,R.localize)(1,null,pe.toFixed(0)):pe<F.MB?(0,R.localize)(2,null,(pe/F.KB).toFixed(2)):pe<F.GB?(0,R.localize)(3,null,(pe/F.MB).toFixed(2)):pe<F.TB?(0,R.localize)(4,null,(pe/F.GB).toFixed(2)):(0,R.localize)(5,null,(pe/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var V;(function(_){_[_.IA32=0]="IA32",_[_.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function q(_){return{maxFileSize:_===0?300*F.MB:16*F.GB,maxHeapSize:_===0?700*F.MB:2*700*F.MB}}e.getPlatformFileLimits=q;function le(_){return T.isWeb?_?10*F.MB:50*F.MB:_?100*F.MB:1024*F.MB}e.getLargeFileConfirmationLimit=le}),define(Ie[67],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class r{constructor(...D){this.a=new Map;for(const[N,S]of D)this.set(N,S)}set(D,N){const S=this.a.get(D);return this.a.set(D,N),S}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.ServiceCollection=r}),define(Ie[158],Ce([1,0,16,12,6,89,156,3,67,159]),function(te,e,r,k,D,N,S,R,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const M=!1;class E extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class f{constructor(o=new y.ServiceCollection,l=!1,v,w=M){this.f=o,this.g=l,this.h=v,this.i=w,this.o=new Set,this.f.set(R.IInstantiationService,this),this._globalGraph=w?v?._globalGraph??new S.Graph(A=>A):void 0}createChild(o){return new f(o,this.g,this,this.i)}invokeFunction(o,...l){const v=m.traceInvocation(this.i,o);let w=!1;try{return o({get:p=>{if(w)throw(0,k.illegalState)("service accessor is only valid during the invocation of its target method");const n=this.m(p,v);if(!n)throw new Error(`[invokeFunction] unknown service '${p}'`);return n}},...l)}finally{w=!0,v.stop()}}createInstance(o,...l){let v,w;return o instanceof N.SyncDescriptor?(v=m.traceCreation(this.i,o.ctor),w=this.j(o.ctor,o.staticArguments.concat(l),v)):(v=m.traceCreation(this.i,o),w=this.j(o,l,v)),v.stop(),w}j(o,l=[],v){const w=R._util.getServiceDependencies(o).sort((n,h)=>n.index-h.index),A=[];for(const n of w){const h=this.m(n.id,v);h||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${n.id}.`,!1),A.push(h)}const p=w.length>0?w[0].index:l.length;if(l.length!==p){console.trace(`[createInstance] First service dependency of ${o.name} at position ${p+1} conflicts with ${l.length} static arguments`);const n=p-l.length;n>0?l=l.concat(new Array(n)):l=l.slice(0,p)}return Reflect.construct(o,l.concat(A))}k(o,l){if(this.f.get(o)instanceof N.SyncDescriptor)this.f.set(o,l);else if(this.h)this.h.k(o,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const l=this.f.get(o);return!l&&this.h?this.h.l(o):l}m(o,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const v=this.l(o);return v instanceof N.SyncDescriptor?this.q(o,v,l.branch(o,!0)):(l.branch(o,!1),v)}q(o,l,v){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,l,v)}finally{this.o.delete(o)}}r(o,l,v){const w=new S.Graph(n=>n.id.toString());let A=0;const p=[{id:o,desc:l,_trace:v}];for(;p.length;){const n=p.pop();if(w.lookupOrInsertNode(n),A++>1e3)throw new E(w);for(const h of R._util.getServiceDependencies(n.desc.ctor)){const i=this.l(h.id);if(i||this.u(`[createInstance] ${o} depends on ${h.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(h.id)),i instanceof N.SyncDescriptor){const a={id:h.id,desc:i,_trace:n._trace.branch(h.id,!0)};w.insertEdge(n,a),p.push(a)}}}for(;;){const n=w.roots();if(n.length===0){if(!w.isEmpty())throw new E(w);break}for(const{data:h}of n){if(this.l(h.id)instanceof N.SyncDescriptor){const a=this.s(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this.k(h.id,a)}w.removeNode(h)}}return this.l(o)}s(o,l,v=[],w,A){if(this.f.get(o)instanceof N.SyncDescriptor)return this.t(o,l,v,w,A);if(this.h)return this.h.s(o,l,v,w,A);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(o,l,v=[],w,A){if(w){const p=new f(void 0,this.g,this,this.i);p.c=String(o);const n=new Map,h=new r.IdleValue(()=>{const i=p.j(l,v,A);for(const[a,t]of n){const g=i[a];if(typeof g=="function")for(const c of t)g.apply(i,c)}return n.clear(),i});return new Proxy(Object.create(null),{get(i,a){if(!h.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let c=n.get(a);return c||(c=new T.LinkedList,n.set(a,c)),(d,C,O)=>{const j=c.push([d,C,O]);return(0,D.toDisposable)(j)}}if(a in i)return i[a];const t=h.value;let g=t[a];return typeof g!="function"||(g=g.bind(t),i[a]=g),g},set(i,a,t){return h.value[a]=t,!0},getPrototypeOf(i){return l.prototype}})}else return this.j(l,v,A)}u(o,l){if(l&&console.warn(o),this.g)throw new Error(o)}}e.InstantiationService=f;var b;(function(s){s[s.None=0]="None",s[s.Creation=1]="Creation",s[s.Invocation=2]="Invocation",s[s.Branch=3]="Branch"})(b||(b={}));class m{static traceInvocation(o,l){return o?new m(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(o,l){return o?new m(1,l.name):m.c}constructor(o,l){this.type=o,this.name=l,this.g=Date.now(),this.h=[]}branch(o,l){const v=new m(3,o.toString());return this.h.push([o,l,v]),v}stop(){const o=Date.now()-this.g;m.f+=o;let l=!1;function v(A,p){const n=[],h=new Array(A+1).join("	");for(const[i,a,t]of p.h)if(a&&t){l=!0,n.push(`${h}CREATES -> ${i}`);const g=v(A+1,t);g&&n.push(g)}else n.push(`${h}uses -> ${i}`);return n.join(`
`)}const w=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(o>2||l)&&m.all.add(w.join(`
`))}}e.Trace=m,m.all=new Set,m.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}},m.f=0}),define(Ie[11],Ce([1,0,39,4,6,28,20,9,2,3]),function(te,e,r,k,D,N,S,R,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.setLogLevel=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function M(){return new Date().toISOString()}function E(u){return(0,R.isNumber)(u)}e.isLogLevel=E;var f;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;function b(u,d,C){switch(d){case f.Trace:u.trace(C);break;case f.Debug:u.debug(C);break;case f.Info:u.info(C);break;case f.Warning:u.warn(C);break;case f.Error:u.error(C);break;case f.Off:break;default:throw new Error(`Invalid log level ${d}`)}}e.log=b;function m(u){let d="";for(let C=0;C<u.length;C++){let O=u[C];if(typeof O=="object")try{O=JSON.stringify(O)}catch{}d+=(C>0?" ":"")+O}return d}e.format=m;class s extends D.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new k.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(d){this.b!==d&&(this.b=d,this.c.fire(this.b))}getLevel(){return this.b}f(d){return this.b!==f.Off&&this.b<=d}}e.AbstractLogger=s;class o extends s{constructor(d){super(),this.h=d}f(d){return this.h||super.f(d)}trace(d,...C){this.f(f.Trace)&&this.g(f.Trace,m([d,...C]))}debug(d,...C){this.f(f.Debug)&&this.g(f.Debug,m([d,...C]))}info(d,...C){this.f(f.Info)&&this.g(f.Info,m([d,...C]))}warn(d,...C){this.f(f.Warning)&&this.g(f.Warning,m([d,...C]))}error(d,...C){if(this.f(f.Error))if(d instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=d.stack,this.g(f.Error,m(O))}else this.g(f.Error,m([d,...C]))}flush(){}}e.AbstractMessageLogger=o;class l extends s{constructor(d=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(d),this.g=!S.isWindows}trace(d,...C){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${M()}]\x1B[0m`,d,...C):console.log(`[main ${M()}]`,d,...C))}debug(d,...C){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${M()}]\x1B[0m`,d,...C):console.log(`[main ${M()}]`,d,...C))}info(d,...C){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${M()}]\x1B[0m`,d,...C):console.log(`[main ${M()}]`,d,...C))}warn(d,...C){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${M()}]\x1B[0m`,d,...C):console.warn(`[main ${M()}]`,d,...C))}error(d,...C){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${M()}]\x1B[0m`,d,...C):console.error(`[main ${M()}]`,d,...C))}dispose(){}flush(){}}e.ConsoleMainLogger=l;class v extends s{constructor(d=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(d)}trace(d,...C){this.f(f.Trace)&&console.log("%cTRACE","color: #888",d,...C)}debug(d,...C){this.f(f.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",d,...C)}info(d,...C){this.f(f.Info)&&console.log("%c INFO","color: #33f",d,...C)}warn(d,...C){this.f(f.Warning)&&console.log("%c WARN","color: #993",d,...C)}error(d,...C){this.f(f.Error)&&console.log("%c  ERR","color: #f33",d,...C)}dispose(){}flush(){}}e.ConsoleLogger=v;class w extends s{constructor(d,C=e.DEFAULT_LOG_LEVEL){super(),this.g=d,this.setLevel(C)}trace(d,...C){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(d),...C])}debug(d,...C){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(d),...C])}info(d,...C){this.f(f.Info)&&this.g.log(f.Info,[this.h(d),...C])}warn(d,...C){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(d),...C])}error(d,...C){this.f(f.Error)&&this.g.log(f.Error,[this.h(d),...C])}h(d){return typeof d=="string"?d:(0,r.toErrorMessage)(d,this.f(f.Trace))}dispose(){}flush(){}}e.AdapterLogger=w;class A extends s{constructor(d){super(),this.g=d,d.length&&this.setLevel(d[0].getLevel())}setLevel(d){for(const C of this.g)C.setLevel(d);super.setLevel(d)}trace(d,...C){for(const O of this.g)O.trace(d,...C)}debug(d,...C){for(const O of this.g)O.debug(d,...C)}info(d,...C){for(const O of this.g)O.info(d,...C)}warn(d,...C){for(const O of this.g)O.warn(d,...C)}error(d,...C){for(const O of this.g)O.error(d,...C)}flush(){for(const d of this.g)d.flush()}dispose(){for(const d of this.g)d.dispose()}}e.MultiplexLogger=A;class p extends D.Disposable{constructor(d,C){if(super(),this.j=d,this.b=new N.ResourceMap,this.c=new N.ResourceMap,this.f=this.B(new k.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new k.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new k.Emitter),this.onDidChangeVisibility=this.h.event,C)for(const O of C)this.c.set(O.resource,O)}getLogger(d){return this.b.get(d)}createLogger(d,C,O){let j=this.b.get(d);if(!j){const Z=C?.logLevel==="always"?f.Trace:C?.logLevel;j=this.k(d,Z??this.getLogLevel(d)??this.j,C),this.b.set(d,j),O||this.registerLogger({resource:d,id:C?.id??d.toString(),logLevel:Z,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId})}return j}setLogLevel(d,C){if(y.URI.isUri(d)){const O=d,j=C,Z=this.c.get(O);Z&&j!==Z.logLevel&&(Z.logLevel=j===this.j?void 0:j,this.b.get(O)?.setLevel(j),this.c.set(Z.resource,Z),this.g.fire([O,j]))}else{this.j=d;for(const[O,j]of this.b.entries())this.c.get(O)?.logLevel===void 0&&j.setLevel(this.j);this.g.fire(this.j)}}setVisibility(d,C){const O=this.c.get(d);O&&C!==!O.hidden&&(O.hidden=!C,this.c.set(O.resource,O),this.h.fire([d,C]))}getLogLevel(d){let C;return d&&(C=this.c.get(d)?.logLevel),C??this.j}registerLogger(d){const C=this.c.get(d.resource);C?C.hidden!==d.hidden&&this.setVisibility(d.resource,!d.hidden):(this.c.set(d.resource,d),this.f.fire({added:[d],removed:[]}))}deregisterLogger(d){const C=this.c.get(d);if(C){this.c.delete(d);const O=this.b.get(d);O&&(this.b.delete(d),O.dispose()),this.f.fire({added:[],removed:[C]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(d){return this.c.get(d)}dispose(){this.b.forEach(d=>d.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=p;class n{constructor(){this.onDidChangeLogLevel=new k.Emitter().event}setLevel(d){}getLevel(){return f.Info}trace(d,...C){}debug(d,...C){}info(d,...C){}warn(d,...C){}error(d,...C){}critical(d,...C){}dispose(){}flush(){}}e.NullLogger=n;class h extends n{}e.NullLogService=h;class i extends p{constructor(){super(f.Info)}k(d,C,O){return new n}}e.NullLoggerService=i;function a(u){if(u.verbose)return f.Trace;if(typeof u.logLevel=="string"){const d=g(u.logLevel.toLowerCase());if(d!==void 0)return d}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function t(u){switch(u){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}e.LogLevelToString=t;function g(u){switch(u){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.parseLogLevel=g;function c(u,d){E(d)?u.setLogLevel(d):u.setLogLevel(d[0],d[1])}e.setLogLevel=c}),define(Ie[160],Ce([1,0,6,11]),function(te,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class D extends r.Disposable{constructor(S,R=[]){super(),this.a=new k.MultiplexLogger([S,...R]),this.B(S.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(S){this.a.setLevel(S)}getLevel(){return this.a.getLevel()}trace(S,...R){this.a.trace(S,...R)}debug(S,...R){this.a.debug(S,...R)}info(S,...R){this.a.info(S,...R)}warn(S,...R){this.a.warn(S,...R)}error(S,...R){this.a.error(S,...R)}flush(){this.a.flush()}}e.LogService=D}),define(Ie[91],Ce([1,0,29,135,3]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var N;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(N=e.MarkerTag||(e.MarkerTag={}));var S;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(S=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function T(m,s){return s-m}y.compare=T;const M=Object.create(null);M[y.Error]=(0,k.localize)(0,null),M[y.Warning]=(0,k.localize)(1,null),M[y.Info]=(0,k.localize)(2,null);function E(m){return M[m]||""}y.toString=E;function f(m){switch(m){case r.default.Error:return y.Error;case r.default.Warning:return y.Warning;case r.default.Info:return y.Info;case r.default.Ignore:return y.Hint}}y.fromSeverity=f;function b(m){switch(m){case y.Error:return r.default.Error;case y.Warning:return r.default.Warning;case y.Info:return r.default.Info;case y.Hint:return r.default.Ignore}}y.toSeverity=b}(S=e.MarkerSeverity||(e.MarkerSeverity={}));var R;(function(y){const T="";function M(f){return E(f,!0)}y.makeKey=M;function E(f,b){const m=[T];return f.source?m.push(f.source.replace("\xA6","\\\xA6")):m.push(T),f.code?typeof f.code=="string"?m.push(f.code.replace("\xA6","\\\xA6")):m.push(f.code.value.replace("\xA6","\\\xA6")):m.push(T),f.severity!==void 0&&f.severity!==null?m.push(S.toString(f.severity)):m.push(T),f.message&&b?m.push(f.message.replace("\xA6","\\\xA6")):m.push(T),f.startLineNumber!==void 0&&f.startLineNumber!==null?m.push(f.startLineNumber.toString()):m.push(T),f.startColumn!==void 0&&f.startColumn!==null?m.push(f.startColumn.toString()):m.push(T),f.endLineNumber!==void 0&&f.endLineNumber!==null?m.push(f.endLineNumber.toString()):m.push(T),f.endColumn!==void 0&&f.endColumn!==null?m.push(f.endColumn.toString()):m.push(T),m.push(T),m.join("\xA6")}y.makeKeyOptionalMessage=E})(R=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(Ie[161],Ce([1,0,4,29,3]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=k.default,e.INotificationService=(0,D.createDecorator)("notificationService");var N;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.PROFILE=1]="PROFILE",T[T.APPLICATION=2]="APPLICATION"})(N=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var S;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(S=e.NotificationsFilter||(e.NotificationsFilter={}));class R{constructor(){this.progress=new y,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(M){}updateMessage(M){}updateActions(M){}close(){}}e.NoOpNotification=R;class y{infinite(){}done(){}total(M){}worked(M){}}e.NoOpProgress=y}),define(Ie[92],Ce([1,0,10,2,3]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,D.createDecorator)("openerService");function N(T,M){return k.URI.isUri(T)?(0,r.equalsIgnoreCase)(T.scheme,M):(0,r.startsWithIgnoreCase)(T,M+":")}e.matchesScheme=N;function S(T,...M){return M.some(E=>N(T,E))}e.matchesSomeScheme=S;function R(T,M){return T.with({fragment:`${M.startLineNumber},${M.startColumn}${M.endLineNumber?`-${M.endLineNumber}${M.endColumn?`,${M.endColumn}`:""}`:""}`})}e.withSelection=R;function y(T){let M;const E=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(T.fragment);return E&&(M={startLineNumber:parseInt(E[1]),startColumn:E[2]?parseInt(E[2]):1,endLineNumber:E[4]?parseInt(E[4]):void 0,endColumn:E[4]?E[5]?parseInt(E[5]):1:void 0},T=T.with({fragment:""})),{selection:M,uri:T}}e.extractSelection=y}),define(Ie[162],Ce([1,0,3]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,r.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(te,e,r,k){var D=arguments.length,N=D<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,r):k,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(te,e,r,k);else for(var R=te.length-1;R>=0;R--)(S=te[R])&&(N=(D<3?S(N):D>3?S(e,r,N):S(e,r))||N);return D>3&&N&&Object.defineProperty(e,r,N),N},je=this&&this.__param||function(te,e){return function(r,k){e(r,k,te)}};define(Ie[163],Ce([1,0,16,21,6,3]),function(te,e,r,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,N.createDecorator)("progressService");var S;(function(M){M[M.Explorer=1]="Explorer",M[M.Scm=3]="Scm",M[M.Extensions=5]="Extensions",M[M.Window=10]="Window",M[M.Notification=15]="Notification",M[M.Dialog=20]="Dialog"})(S=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class R{get value(){return this.a}constructor(E){this.b=E}report(E){this.a=E,this.b(this.a)}}e.Progress=R,R.None=Object.freeze({report(){}});let y=class extends D.Disposable{constructor(E,f){super(),this.a=new r.DeferredPromise,f.withProgress(E,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,D.toDisposable)(()=>this.a.complete()))}report(E){this.b?this.b.report(E):this.c=E}};y=qe([je(1,e.IProgressService)],y),e.UnmanagedProgress=y;class T extends D.Disposable{constructor(E){super(),this.g=E,this.a=0,this.b=this.B(new D.DisposableStore)}start(E){this.stop();const f=++this.a,b=new k.CancellationTokenSource;return this.f=setTimeout(()=>{f===this.a&&(this.c=this.g.show(!0))},E),this.b.add((0,D.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,D.toDisposable)(()=>b.cancel())),this.b.add((0,D.toDisposable)(()=>this.c?this.c.done():void 0)),{id:f,token:b.token,stop:()=>this.h(f),isCurrent:()=>this.a===f}}stop(){this.h(this.a)}h(E){this.a===E&&this.b.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,N.createDecorator)("editorProgressService")}),define(Ie[30],Ce([1,0,48,9]),function(te,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.a=new Map}add(S,R){r.ok(k.isString(S)),r.ok(k.isObject(R)),r.ok(!this.a.has(S),"There is already an extension with this id"),this.a.set(S,R)}knows(S){return this.a.has(S)}as(S){return this.a.get(S)||null}}e.Registry=new D}),define(Ie[68],Ce([1,0,4,30]),function(te,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class N{constructor(){this.b=new r.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,T){this.a[D(y)]=T,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const S=new N;k.Registry.add(e.Extensions.JSONContribution,S)}),define(Ie[93],Ce([1,0,18,4,9,131,41,68,30]),function(te,e,r,k,D,N,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var T;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(T=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var M;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(M=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=y.Registry.as(R.Extensions.JSONContribution);class f{constructor(){this.h=new Set,this.i=new k.Emitter,this.onDidSchemaChange=this.i.event,this.j=new k.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(n,h=!0){this.registerConfigurations([n],h)}registerConfigurations(n,h=!0){const i=new Set;this.n(n,h,i),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(n){const h=new Set;this.o(n,h),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:h})}updateConfigurations({add:n,remove:h}){const i=new Set;this.o(h,i),this.n(n,!1,i),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(n){const h=new Set;this.k(n,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:!0})}k(n,h){const i=[];for(const{overrides:a,source:t}of n)for(const g in a)if(h.add(g),e.OVERRIDE_PROPERTY_REGEX.test(g)){const c=this.a.get(g),u=c?.valuesSources??new Map;if(t)for(const j of Object.keys(a[g]))u.set(j,t);const d={...c?.value||{},...a[g]};this.a.set(g,{source:t,value:d,valuesSources:u});const C=(0,S.getLanguageTagSettingPlainKey)(g),O={type:"object",default:d,description:N.localize(1,null,C),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:d,source:D.isString(t)?void 0:t,defaultValueSource:t};i.push(...s(g)),this.d[g]=O,this.b.properties[g]=O}else{this.a.set(g,{value:a[g],source:t});const c=this.d[g];c&&(this.w(g,c),this.r(g,c))}this.m(i)}deregisterDefaultConfigurations(n){const h=new Set;this.l(n,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:!0})}l(n,h){for(const{overrides:i,source:a}of n)for(const t in i){const g=this.a.get(t),c=D.isString(a)?a:a?.id,u=D.isString(g?.source)?g?.source:g?.source?.id;if(c===u)if(h.add(t),this.a.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.d[t],delete this.b.properties[t];else{const d=this.d[t];d&&(this.w(t,d),this.r(t,d))}}this.u()}deltaConfiguration(n){let h=!1;const i=new Set;n.removedDefaults&&(this.l(n.removedDefaults,i),h=!0),n.addedDefaults&&(this.k(n.addedDefaults,i),h=!0),n.removedConfigurations&&this.o(n.removedConfigurations,i),n.addedConfigurations&&this.n(n.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:h})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const h of n)this.h.add(h);this.u()}n(n,h,i){n.forEach(a=>{this.p(a,h,a.extensionInfo,a.restrictedProperties,void 0,i),this.c.push(a),this.q(a)})}o(n,h){const i=a=>{if(a.properties)for(const t in a.properties){h.add(t);const g=this.d[t];g?.policy?.name&&this.e.delete(g.policy.name),delete this.d[t],this.s(t,a.properties[t])}a.allOf?.forEach(t=>i(t))};for(const a of n){i(a);const t=this.c.indexOf(a);t!==-1&&this.c.splice(t,1)}}p(n,h=!0,i,a,t=3,g){t=D.isUndefinedOrNull(n.scope)?t:n.scope;const c=n.properties;if(c)for(const d in c){const C=c[d];if(h&&w(d,C)){delete c[d];continue}if(C.source=i,C.defaultDefaultValue=c[d].default,this.w(d,C),e.OVERRIDE_PROPERTY_REGEX.test(d)?C.scope=void 0:(C.scope=D.isUndefinedOrNull(C.scope)?t:C.scope,C.restricted=D.isUndefinedOrNull(C.restricted)?!!a?.includes(d):C.restricted),c[d].hasOwnProperty("included")&&!c[d].included){this.f[d]=c[d],delete c[d];continue}else this.d[d]=c[d],c[d].policy?.name&&this.e.set(c[d].policy.name,d);!c[d].deprecationMessage&&c[d].markdownDeprecationMessage&&(c[d].deprecationMessage=c[d].markdownDeprecationMessage),g.add(d)}const u=n.allOf;if(u)for(const d of u)this.p(d,h,i,a,t,g)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const h=i=>{const a=i.properties;if(a)for(const g in a)this.r(g,a[g]);i.allOf?.forEach(h)};h(n)}r(n,h){switch(e.allSettings.properties[n]=h,h.scope){case 1:e.applicationSettings.properties[n]=h;break;case 2:e.machineSettings.properties[n]=h;break;case 6:e.machineOverridableSettings.properties[n]=h;break;case 3:e.windowSettings.properties[n]=h;break;case 4:e.resourceSettings.properties[n]=h;break;case 5:e.resourceSettings.properties[n]=h,this.g.properties[n]=h;break}}s(n,h){switch(delete e.allSettings.properties[n],h.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const h=`[${n}]`,i={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(h,i),e.allSettings.properties[h]=i,e.applicationSettings.properties[h]=i,e.machineSettings.properties[h]=i,e.machineOverridableSettings.properties[h]=i,e.windowSettings.properties[h]=i,e.resourceSettings.properties[h]=i}}v(){const n={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this.i.fire()}w(n,h){const i=this.a.get(n);let a=i?.value,t=i?.source;D.isUndefined(a)&&(a=h.defaultDefaultValue,t=void 0),D.isUndefined(a)&&(a=l(h.type)),h.default=a,h.defaultValueSource=t}}const b="\\[([^\\]]+)\\]",m=new RegExp(b,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${b})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function s(p){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let h=m.exec(p);for(;h?.length;){const i=h[1].trim();i&&n.push(i),h=m.exec(p)}}return(0,r.distinct)(n)}e.overrideIdentifiersFromKey=s;function o(p){return p.reduce((n,h)=>`${n}[${h}]`,"")}e.keyFromOverrideIdentifiers=o;function l(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const v=new f;y.Registry.add(e.Extensions.Configuration,v);function w(p,n){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?N.localize(7,null,p):v.getConfigurationProperties()[p]!==void 0?N.localize(8,null,p):n.policy?.name&&v.getPolicyConfigurations().get(n.policy?.name)!==void 0?N.localize(9,null,p,n.policy?.name,v.getPolicyConfigurations().get(n.policy?.name)):null:N.localize(6,null)}e.validateProperty=w;function A(){const p=[],n=v.getConfigurationProperties();for(const h of Object.keys(n))p.push([h,n[h].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=A}),define(Ie[164],Ce([1,0,18,4,111,6,28,22,9,2,41,93,30]),function(te,e,r,k,D,N,S,R,y,T,M,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function b(h){return Object.isFrozen(h)?h:R.deepFreeze(h)}class m{constructor(i={},a=[],t=[],g){this.b=i,this.c=a,this.d=t,this.raw=g,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(a=>{if(a instanceof m)return a;const t=new s("");return t.parseRaw(a),t.configurationModel});this.f=i.reduce((a,t)=>t===a?t:a.merge(t),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,M.getConfigurationValue)(this.contents,i):this.contents}inspect(i,a){const t=this.rawConfiguration.getValue(i),g=a?this.rawConfiguration.getOverrideValue(i,a):void 0,c=a?this.rawConfiguration.override(a).getValue(i):t;return{value:t,override:g,merged:c}}getOverrideValue(i,a){const t=this.i(a);return t?i?(0,M.getConfigurationValue)(t,i):t:void 0}getKeysForOverrideIdentifier(i){const a=[];for(const t of this.overrides)t.identifiers.includes(i)&&a.push(...t.keys);return r.distinct(a)}getAllOverrideIdentifiers(){const i=[];for(const a of this.overrides)i.push(...a.identifiers);return r.distinct(i)}override(i){let a=this.a.get(i);return a||(a=this.g(i),this.a.set(i,a)),a}merge(...i){const a=R.deepClone(this.contents),t=R.deepClone(this.overrides),g=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const u of i)if(c.push(...u.raw?.length?u.raw:[u]),!u.isEmpty()){this.h(a,u.contents);for(const d of u.overrides){const[C]=t.filter(O=>r.equals(O.identifiers,d.identifiers));C?(this.h(C.contents,d.contents),C.keys.push(...d.keys),C.keys=r.distinct(C.keys)):t.push(R.deepClone(d))}for(const d of u.keys)g.indexOf(d)===-1&&g.push(d)}return new m(a,g,t,c.every(u=>u instanceof m)?void 0:c)}g(i){const a=this.i(i);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const t={};for(const g of r.distinct([...Object.keys(this.contents),...Object.keys(a)])){let c=this.contents[g];const u=a[g];u&&(typeof c=="object"&&typeof u=="object"?(c=R.deepClone(c),this.h(c,u)):c=u),t[g]=c}return new m(t,this.keys,this.overrides)}h(i,a){for(const t of Object.keys(a)){if(t in i&&y.isObject(i[t])&&y.isObject(a[t])){this.h(i[t],a[t]);continue}i[t]=R.deepClone(a[t])}}i(i){let a=null,t=null;const g=c=>{c&&(t?this.h(t,c):t=R.deepClone(c))};for(const c of this.overrides)r.equals(c.identifiers,[i])?a=c.contents:c.identifiers.includes(i)&&g(c.contents);return g(a),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,a){this.j(i,a,!0)}setValue(i,a){this.j(i,a,!1)}removeValue(i){const a=this.keys.indexOf(i);a!==-1&&(this.keys.splice(a,1),(0,M.removeFromValueTree)(this.contents,i),E.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(t=>r.equals(t.identifiers,(0,E.overrideIdentifiersFromKey)(i))),1))}j(i,a,t){(0,M.addToValueTree)(this.contents,i,a,g=>console.error(g)),t=t||this.keys.indexOf(i)===-1,t&&this.keys.push(i),E.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,E.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,M.toValuesTree)(this.contents[i],g=>console.error(g))})}}e.ConfigurationModel=m;class s{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,a){if(!y.isUndefinedOrNull(i)){const t=this.g(i);this.parseRaw(t,a)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,a){this.a=i;const{contents:t,keys:g,overrides:c,restricted:u,hasExcludedProperties:d}=this.h(i,a);this.b=new m(t,g,c,d?[i]:void 0),this.c=u||[]}g(i){let a={},t=null,g=[];const c=[],u=[];function d(O){Array.isArray(g)?g.push(O):t!==null&&(g[t]=O)}const C={onObjectBegin:()=>{const O={};d(O),c.push(g),g=O,t=null},onObjectProperty:O=>{t=O},onObjectEnd:()=>{g=c.pop()},onArrayBegin:()=>{const O=[];d(O),c.push(g),g=O,t=null},onArrayEnd:()=>{g=c.pop()},onLiteralValue:d,onError:(O,j,Z)=>{u.push({error:O,offset:j,length:Z})}};if(i)try{D.visit(i,C),a=g[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return a}h(i,a){const t=f.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),g=this.i(i,t,!0,a);i=g.raw;const c=(0,M.toValuesTree)(i,C=>console.error(`Conflict in settings file ${this.f}: ${C}`)),u=Object.keys(i),d=this.j(i,C=>console.error(`Conflict in settings file ${this.f}: ${C}`));return{contents:c,keys:u,overrides:d,restricted:g.restricted,hasExcludedProperties:g.hasExcludedProperties}}i(i,a,t,g){let c=!1;if(!g?.scopes&&!g?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:c};const u={},d=[];for(const C in i)if(E.OVERRIDE_PROPERTY_REGEX.test(C)&&t){const O=this.i(i[C],a,!1,g);u[C]=O.raw,c=c||O.hasExcludedProperties,d.push(...O.restricted)}else{const O=a[C],j=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&d.push(C),(j===void 0||g.scopes===void 0||g.scopes.includes(j))&&!(g.skipRestricted&&O?.restricted)?u[C]=i[C]:c=!0}return{raw:u,restricted:d,hasExcludedProperties:c}}j(i,a){const t=[];for(const g of Object.keys(i))if(E.OVERRIDE_PROPERTY_REGEX.test(g)){const c={};for(const u in i[g])c[u]=i[g][u];t.push({identifiers:(0,E.overrideIdentifiersFromKey)(g),keys:Object.keys(c),contents:(0,M.toValuesTree)(c,a)})}return t}}e.ConfigurationModelParser=s;class o extends N.Disposable{constructor(i,a,t,g){super(),this.f=i,this.g=a,this.h=g,this.c=this.B(new k.Emitter),this.onDidChange=this.c.event,this.a=new s(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(t.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(k.Event.any(k.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),k.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&t.isEqual(c.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new m}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=o;class l{constructor(i,a,t,g,c,u,d,C,O,j,Z,x,L){this.a=i,this.b=a,this.c=t,this.overrideIdentifiers=g,this.d=c,this.f=u,this.g=d,this.h=C,this.i=O,this.j=j,this.k=Z,this.l=x,this.m=L}get value(){return b(this.c)}n(i,a,t){const g=i.inspect(a,t);return{get value(){return b(g.value)},get override(){return b(g.override)},get merged(){return b(g.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class v{constructor(i,a,t,g,c=new m,u=new m,d=new S.ResourceMap,C=new m,O=new S.ResourceMap){this.c=i,this.d=a,this.f=t,this.g=g,this.h=c,this.i=u,this.j=d,this.l=C,this.m=O,this.a=null,this.b=new S.ResourceMap,this.n=null}getValue(i,a,t){return this.q(i,a,t).getValue(i)}updateValue(i,a,t={}){let g;t.resource?(g=this.m.get(t.resource),g||(g=new m,this.m.set(t.resource,g))):g=this.l,a===void 0?g.removeValue(i):g.setValue(i,a),t.resource||(this.a=null)}inspect(i,a,t){const g=this.q(i,a,t),c=this.u(a.resource,t),u=a.resource?this.m.get(a.resource)||this.l:this.l,d=new Set;for(const C of g.overrides)for(const O of C.identifiers)g.getOverrideValue(i,O)!==void 0&&d.add(O);return new l(i,a,g.getValue(i),d.size?[...d]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,c||void 0,u)}keys(i){const a=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:a?a.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,a){this.j.set(i,a),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,a){const t=[];if(!a){const{added:g,updated:c,removed:u}=p(this.c,i);a=[...g,...c,...u]}for(const g of a)for(const c of(0,E.overrideIdentifiersFromKey)(g)){const u=this.c.getKeysForOverrideIdentifier(c),d=i.getKeysForOverrideIdentifier(c),C=[...d.filter(O=>u.indexOf(O)===-1),...u.filter(O=>d.indexOf(O)===-1),...u.filter(O=>!R.equals(this.c.override(c).getValue(O),i.override(c).getValue(O)))];t.push([c,C])}return this.updateDefaultConfiguration(i),{keys:a,overrides:t}}compareAndUpdatePolicyConfiguration(i){const{added:a,updated:t,removed:g}=p(this.d,i),c=[...a,...t,...g];return c.length&&this.updatePolicyConfiguration(i),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:a,updated:t,removed:g,overrides:c}=p(this.applicationConfiguration,i),u=[...a,...t,...g];return u.length&&this.updateApplicationConfiguration(i),{keys:u,overrides:c}}compareAndUpdateLocalUserConfiguration(i){const{added:a,updated:t,removed:g,overrides:c}=p(this.localUserConfiguration,i),u=[...a,...t,...g];return u.length&&this.updateLocalUserConfiguration(i),{keys:u,overrides:c}}compareAndUpdateRemoteUserConfiguration(i){const{added:a,updated:t,removed:g,overrides:c}=p(this.remoteUserConfiguration,i),u=[...a,...t,...g];return u.length&&this.updateRemoteUserConfiguration(i),{keys:u,overrides:c}}compareAndUpdateWorkspaceConfiguration(i){const{added:a,updated:t,removed:g,overrides:c}=p(this.workspaceConfiguration,i),u=[...a,...t,...g];return u.length&&this.updateWorkspaceConfiguration(i),{keys:u,overrides:c}}compareAndUpdateFolderConfiguration(i,a){const t=this.p.get(i),{added:g,updated:c,removed:u,overrides:d}=p(t,a),C=[...g,...c,...u];return(C.length||!t)&&this.updateFolderConfiguration(i,a),{keys:C,overrides:d}}compareAndDeleteFolderConfiguration(i){const a=this.p.get(i);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:t,updated:g,removed:c,overrides:u}=p(a,void 0);return{keys:[...t,...g,...c],overrides:u}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,a,t){let g=this.r(a,t);return a.overrideIdentifier&&(g=g.override(a.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(g=g.merge(this.d)),g}r({resource:i},a){let t=this.s();if(a&&i){const g=a.getFolder(i);g&&(t=this.t(g.uri)||t);const c=this.m.get(i);c&&(t=t.merge(c))}return t}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let a=this.b.get(i);if(!a){const t=this.s(),g=this.j.get(i);g?(a=t.merge(g),this.b.set(i,a)):a=t}return a}u(i,a){if(a&&i){const t=a.getFolder(i);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,a)=>{const{contents:t,overrides:g,keys:c}=this.j.get(a);return i.push([a,{contents:t,overrides:g,keys:c}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(a=>i.add(a)),this.userConfiguration.keys.forEach(a=>i.add(a)),this.i.keys.forEach(a=>i.add(a)),this.j.forEach(a=>a.keys.forEach(t=>i.add(t))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(a=>i.add(a)),this.userConfiguration.getAllOverrideIdentifiers().forEach(a=>i.add(a)),this.i.getAllOverrideIdentifiers().forEach(a=>i.add(a)),this.j.forEach(a=>a.getAllOverrideIdentifiers().forEach(t=>i.add(t))),[...i.values()]}w(i){const a=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(t=>a.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(t=>a.add(t)),this.i.getKeysForOverrideIdentifier(i).forEach(t=>a.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(i).forEach(g=>a.add(g))),[...a.values()]}static parse(i){const a=this.x(i.defaults),t=this.x(i.policy),g=this.x(i.application),c=this.x(i.user),u=this.x(i.workspace),d=i.folders.reduce((C,O)=>(C.set(T.URI.revive(O[0]),this.x(O[1])),C),new S.ResourceMap);return new v(a,t,g,c,new m,u,d,new m,new S.ResourceMap)}static x(i){return new m(i.contents,i.keys,i.overrides)}}e.Configuration=v;function w(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const i=new Set,a=new Map;for(const g of h)g.keys.forEach(c=>i.add(c)),g.overrides.forEach(([c,u])=>{const d=(0,S.getOrSet)(a,c,new Set);u.forEach(C=>d.add(C))});const t=[];return a.forEach((g,c)=>t.push([c,[...g.values()]])),{keys:[...i.values()],overrides:t}}e.mergeChanges=w;class A{constructor(i,a,t,g){this.change=i,this.f=a,this.g=t,this.h=g,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const c of i.keys)this.affectedKeys.add(c);for(const[,c]of i.overrides)for(const u of c)this.affectedKeys.add(u);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=v.parse(this.f.data)),this.i}affectsConfiguration(i,a){const t=this.a+i,g=this.d.indexOf(t);if(g<0)return!1;const c=g+t.length;if(c>=this.d.length)return!1;const u=this.d.charCodeAt(c);if(u!==this.b&&u!==this.c)return!1;if(a){const d=this.previousConfiguration?this.previousConfiguration.getValue(i,a,this.f?.workspace):void 0,C=this.g.getValue(i,a,this.h);return!R.equals(d,C)}return!0}}e.ConfigurationChangeEvent=A;function p(h,i){const{added:a,removed:t,updated:g}=n(i?.rawConfiguration,h?.rawConfiguration),c=[],u=h?.getAllOverrideIdentifiers()||[],d=i?.getAllOverrideIdentifiers()||[];if(i){const C=d.filter(O=>!u.includes(O));for(const O of C)c.push([O,i.getKeysForOverrideIdentifier(O)])}if(h){const C=u.filter(O=>!d.includes(O));for(const O of C)c.push([O,h.getKeysForOverrideIdentifier(O)])}if(i&&h){for(const C of u)if(d.includes(C)){const O=n({contents:h.getOverrideValue(void 0,C)||{},keys:h.getKeysForOverrideIdentifier(C)},{contents:i.getOverrideValue(void 0,C)||{},keys:i.getKeysForOverrideIdentifier(C)});c.push([C,[...O.added,...O.removed,...O.updated]])}}return{added:a,removed:t,updated:g,overrides:c}}function n(h,i){const a=h?i?h.keys.filter(c=>i.keys.indexOf(c)===-1):[...h.keys]:[],t=i?h?i.keys.filter(c=>h.keys.indexOf(c)===-1):[...i.keys]:[],g=[];if(h&&i){for(const c of i.keys)if(h.keys.indexOf(c)!==-1){const u=(0,M.getConfigurationValue)(i.contents,c),d=(0,M.getConfigurationValue)(h.contents,c);R.equals(u,d)||g.push(c)}}return{added:a,removed:t,updated:g}}}),define(Ie[94],Ce([1,0,12,3]),function(te,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,k.createDecorator)("remoteAuthorityResolverService");var D;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class N extends r.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof N&&y._code===D.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof N&&y._code===D.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof N&&y._code===D.NoResolverFound}static isHandled(y){return y instanceof N&&y.isHandled}constructor(y,T=D.Unknown,M){super(y),this._message=y,this._code=T,this._detail=M,this.isHandled=T===D.NotAvailable&&M===!0,Object.setPrototypeOf(this,N.prototype)}}e.RemoteAuthorityResolverError=N;function S(R){const y=R.indexOf("+");return y===-1?R:R.substring(0,y)}e.getRemoteAuthorityPrefix=S}),define(Ie[49],Ce([1,0,15]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function k(T){return T.scheme===r.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=k;function D(T){if(!T)return;const M=T.indexOf("+");return M<0?T:T.substr(0,M)}e.getRemoteName=D;function N(T){return`/${T.quality??"oss"}-${T.commit??"dev"}`}e.getRemoteServerRootPath=N;function S(T){const{host:M,port:E}=y(T);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:M,port:E}}e.parseAuthorityWithPort=S;function R(T,M){let{host:E,port:f}=y(T);return typeof f>"u"&&(f=M),{host:E,port:f}}e.parseAuthorityWithOptionalPort=R;function y(T){const M=T.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(M)return{host:M[1],port:parseInt(M[2],10)};const E=T.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const f=T.match(/(.*):(\d+)$/);return f?{host:f[1],port:parseInt(f[2],10)}:{host:T,port:void 0}}}),define(Ie[25],Ce([1,0,10,3,49]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function N(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=N;function S(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=S,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));var y;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));class T{constructor(s){this.value=s,this.c=s.toLowerCase()}static equals(s,o){if(typeof s>"u"||s===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof s=="string"||typeof o=="string"){const l=typeof s=="string"?s:s.value,v=typeof o=="string"?o:o.value;return r.equalsIgnoreCase(l,v)}return s.c===o.c}static toKey(s){return typeof s=="string"?s.toLowerCase():s.c}}e.ExtensionIdentifier=T;function M(m){return E(m)}e.isApplicationScopedExtension=M;function E(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function f(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=f;function b(m,s){if(s){const o=`onResolveRemoteAuthority:${(0,D.getRemoteName)(s)}`;return m.activationEvents?.indexOf(o)!==-1}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ie[165],Ce([1,0,20,50,2,34]),function(te,e,r,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function S(T){if(r.platform===2&&/^penguin(\.|$)/i.test(T))return"chromebook"}async function R(T,M,E,f,b,m,s,o,l,v){const w=Object.create(null);w["common.machineId"]=s,w.sessionID=(0,N.generateUuid)()+Date.now(),w.commitHash=b,w.version=m,w["common.platformVersion"]=(M||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,r.PlatformToString)(r.platform),w["common.nodePlatform"]=k.platform,w["common.nodeArch"]=f,w["common.product"]=v||"desktop",o&&(w["common.msftInternal"]=o);let A=0;const p=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>A++,enumerable:!0}}),r.isLinuxSnap&&(w["common.snap"]="true");const n=S(E);n&&(w["common.platformDetail"]=n);try{const h=await T.readFile(D.URI.file(l));w["common.source"]=h.value.toString().slice(0,30)}catch{}return w}e.resolveCommonProperties=R;function y(T){const M=k.env.USERDNSDOMAIN;if(!M)return!1;const E=M.toLowerCase();return T.some(f=>E===f)}e.verifyMicrosoftInternalDomain=y}),define(Ie[166],Ce([1,0,3]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,r.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,r.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var k;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(k=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ie[51],Ce([1,0,22,9,4,41,49,165,166]),function(te,e,r,k,D,N,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class T{constructor(c){this.value=c}}e.TelemetryTrustedValue=T;class M{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(c,u){return Promise.resolve(void 0)}publicLog2(c,u){return this.publicLog(c,u)}publicLogError(c,u){return Promise.resolve(void 0)}publicLogError2(c,u){return this.publicLogError(c,u)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=M,e.NullTelemetryService=new M;class E{async publicLog(c,u,d){}async publicLogError(c,u,d){}}e.NullEndpointTelemetryService=E,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(g,c){return D.Event.debounce(c.onDidChangeConfiguration,(d,C)=>{const O=d?new Set([...d.affectedKeys,...C.affectedKeys]):C.affectedKeys;return{...C,affectedKeys:O}},1e3,!0)(d=>{d.source!==7&&g.publicLog2("updateConfiguration",{configurationSource:(0,N.ConfigurationTargetToString)(d.source),configurationKeys:A(d.affectedKeys)})})}e.configurationTelemetry=f;function b(g,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!g.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=b;function m(g,c){return!(c.isBuilt||c.disableTelemetry||g.enableTelemetry&&g.aiConfig?.ariaKey)}e.isLoggingOnly=m;function s(g){const c=g.getValue(y.TELEMETRY_SETTING_ID),u=g.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(g.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=s;function o(g){const c={},u={},d={};w(g,d);for(let C in d){C=C.length>150?C.substr(C.length-149):C;const O=d[C];typeof O=="number"?u[C]=O:typeof O=="boolean"?u[C]=O?1:0:typeof O=="string"?(O.length>8192&&console.warn(`Telemetry property: ${C} has been trimmed to 8192, the original length is ${O.length}`),c[C]=O.substring(0,8191)):typeof O<"u"&&O!==null&&(c[C]=O)}return{properties:c,measurements:u}}e.validateTelemetryData=o;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function v(g){if(!g)return"none";const c=(0,S.getRemoteName)(g);return l.has(c)?c:"other"}e.cleanRemoteAuthority=v;function w(g,c,u=0,d){if(!!g)for(const C of Object.getOwnPropertyNames(g)){const O=g[C],j=d?d+C:C;Array.isArray(O)?c[j]=(0,r.safeStringify)(O):O instanceof Date?c[j]=O.toISOString():(0,k.isObject)(O)?u<2?w(O,c,u+1,j+"."):c[j]=(0,r.safeStringify)(O):c[j]=O}}function A(g){if(!g)return[];const c=[];return p(c,"",g),c}function p(g,c,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(d=>p(g,c?`${c}.${d}`:d,u[d])):g.push(c)}function n(g,c){const u=g.msftInternalDomains||[],d=c.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(u)||d}e.isInternalTelemetry=n;function h(g){return[g.appRoot,g.extensionsPath,g.userHome.fsPath,g.tmpDir.fsPath,g.userDataPath]}e.getPiiPathsFromEnvironment=h;function i(g,c){if(!g||!g.includes("/")&&!g.includes("\\"))return g;let u=g;const d=[];for(const Z of c)for(;;){const x=Z.exec(g);if(!x)break;d.push([x.index,Z.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,O=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let j=0;for(u="";;){const Z=O.exec(g);if(!Z)break;const x=d.some(([L,$])=>Z.index<$&&L<O.lastIndex);!C.test(Z[0])&&!x&&(u+=g.substring(j,Z.index)+"<REDACTED: user-file-path>",j=O.lastIndex)}return j<g.length&&(u+=g.substr(j)),u}function a(g){if(!g)return g;const c=g.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of u)if(d.regex.test(c))return`<REDACTED: ${d.label}>`;return g}function t(g,c){return(0,r.cloneAndChange)(g,u=>{if(u instanceof T)return u.value;if(typeof u=="string"){let d=u.replaceAll("%20"," ");d=i(d,c);for(const C of c)d=d.replace(C,"");return d=a(d),d}})}e.cleanData=t}),define(Ie[167],Ce([1,0,10,90,25,20,2,12,50,51]),function(te,e,r,k,D,N,S,R,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function M(i,a){return i.uuid&&a.uuid?i.uuid===a.uuid:i.id===a.id?!0:(0,r.compareIgnoreCase)(i.id,a.id)===0}e.areSameExtensions=M;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class f{static create(a){const t=a.manifest?a.manifest.version:a.version,g=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new f(a.identifier,t,g)}static parse(a){const t=E.exec(a);return t&&t[1]&&t[2]?new f({id:t[1]},t[2],t[4]||void 0):null}constructor(a,t,g="undefined"){this.version=t,this.targetPlatform=g,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof f?M(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.ExtensionKey=f;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(i){const a=b.exec(i);return a&&a[1]?[o(a[1]),a[2]]:[o(i),void 0]}e.getIdAndVersion=m;function s(i,a){return`${i}.${a}`}e.getExtensionId=s;function o(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=o;function l(i,a){return o(s(i,a))}e.getGalleryExtensionId=l;function v(i,a){const t=[],g=c=>{for(const u of t)if(u.some(d=>M(a(d),a(c))))return u;return null};for(const c of i){const u=g(c);u?u.push(c):t.push([c])}return t}e.groupByExtension=v;function w(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=w;function A(i){return{id:new T.TelemetryTrustedValue(i.identifier.id),name:new T.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=A,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function p(i,a){const t=[],g=a.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const c=g.shift();if(c&&t.every(u=>!M(u.identifier,{id:c}))){const u=i.filter(d=>M(d.identifier,{id:c}));u.length===1&&(t.push(u[0]),g.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.getExtensionDependencies=p;async function n(i,a){if(!N.isLinux)return!1;let t;try{t=(await i.readFile(S.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await i.readFile(S.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){a.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(c))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=n;async function h(i,a){const t=await n(i,a),g=(0,k.getTargetPlatform)(t?"alpine":N.platform,y.arch);return a.debug("ComputeTargetPlatform:",g),g}e.computeTargetPlatform=h}),define(Ie[168],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function r(S){return[...S.entries()]}e.serializeEnvironmentVariableCollection=r;function k(S){return new Map(S)}e.deserializeEnvironmentVariableCollection=k;function D(S){return Array.from(S.entries()).map(R=>[R[0],r(R[1].map)])}e.serializeEnvironmentVariableCollections=D;function N(S){return new Map(S.map(R=>[R[0],{map:k(R[1])}]))}e.deserializeEnvironmentVariableCollections=N}),define(Ie[169],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class r{constructor(D){this.b=D,this.a=new Map}dispose(){for(const D of this.a.values())D.dispose()}startBuffering(D,N,S=5){const R=N(y=>{const T=typeof y=="string"?y:y.data;let M=this.a.get(D);if(M){M.data.push(T);return}const E=setTimeout(()=>this.flushBuffer(D),S);M={data:[T],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(D),R.dispose()}},this.a.set(D,M)});return R}stopBuffering(D){this.a.get(D)?.dispose()}flushBuffer(D){const N=this.a.get(D);N&&(this.a.delete(D),this.b(D,N.data.join("")))}}e.TerminalDataBufferer=r}),define(Ie[170],Ce([1,0,16,84,38,4,9,2,136,68,30]),function(te,e,r,k,D,N,S,R,y,T,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var E;(function(A){function p(n,h){let i=n.defaults;for(;D.ThemeIcon.isThemeIcon(i);){const a=m.getIcon(i.id);if(!a)return;i=a.defaults}return i}A.getDefinition=p})(E=e.IconContribution||(e.IconContribution={}));var f;(function(A){function p(h){return{weight:h.weight,style:h.style,src:h.src.map(i=>({format:i.format,location:i.location.toString()}))}}A.toJSONObject=p;function n(h){const i=a=>(0,S.isString)(a)?a:void 0;if(h&&Array.isArray(h.src)&&h.src.every(a=>(0,S.isString)(a.format)&&(0,S.isString)(a.location)))return{weight:i(h.weight),style:i(h.style),src:h.src.map(a=>({format:a.format,location:R.URI.parse(a.location)}))}}A.fromJSONObject=n})(f=e.IconFontDefinition||(e.IconFontDefinition={}));class b{constructor(){this.a=new N.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${D.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(p,n,h,i){const a=this.b[p];if(a){if(h&&!a.description){a.description=h,this.d.properties[p].markdownDescription=`${h} $(${p})`;const c=this.e.enum.indexOf(p);c!==-1&&(this.e.enumDescriptions[c]=h),this.a.fire()}return a}const t={id:p,description:h,defaults:n,deprecationMessage:i};this.b[p]=t;const g={$ref:"#/definitions/icons"};return i&&(g.deprecationMessage=i),h&&(g.markdownDescription=`${h}: $(${p})`),this.d.properties[p]=g,this.e.enum.push(p),this.e.enumDescriptions.push(h||""),this.a.fire(),{id:p}}deregisterIcon(p){delete this.b[p],delete this.d.properties[p];const n=this.e.enum.indexOf(p);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(p=>this.b[p])}getIcon(p){return this.b[p]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(p,n){const h=this.f[p];return h||(this.f[p]=n,this.a.fire(),n)}deregisterIconFont(p){delete this.f[p]}getIconFont(p){return this.f[p]}toString(){const p=(a,t)=>a.id.localeCompare(t.id),n=a=>{for(;D.ThemeIcon.isThemeIcon(a.defaults);)a=this.b[a.defaults.id];return`codicon codicon-${a?a.id:""}`},h=[];h.push("| preview     | identifier                        | default codicon ID                | description"),h.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const i=Object.keys(this.b).map(a=>this.b[a]);for(const a of i.filter(t=>!!t.description).sort(p))h.push(`|<i class="${n(a)}"></i>|${a.id}|${D.ThemeIcon.isThemeIcon(a.defaults)?a.defaults.id:a.id}|${a.description||""}|`);h.push("| preview     | identifier                        "),h.push("| ----------- | --------------------------------- |");for(const a of i.filter(t=>!D.ThemeIcon.isThemeIcon(t.defaults)).sort(p))h.push(`|<i class="${n(a)}"></i>|${a.id}|`);return h.join(`
`)}}const m=new b;M.Registry.add(e.Extensions.IconContribution,m);function s(A,p,n,h){return m.registerIcon(A,p,n,h)}e.registerIcon=s;function o(){return m}e.getIconRegistry=o;function l(){const A=(0,k.getCodiconFontCharacters)();for(const p in A){const n="\\"+A[p].toString(16);m.registerIcon(p,{fontCharacter:n})}}l(),e.iconsSchemaId="vscode://schemas/icons";const v=M.Registry.as(T.Extensions.JSONContribution);v.registerSchema(e.iconsSchemaId,m.getIconSchema());const w=new r.RunOnceScheduler(()=>v.notifySchemaChanged(e.iconsSchemaId),200);m.onDidChange(()=>{w.isScheduled()||w.schedule()}),e.widgetClose=s("widget-close",k.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=s("goto-previous-location",k.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=s("goto-next-location",k.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=D.ThemeIcon.modify(k.Codicon.sync,"spin"),e.spinningLoading=D.ThemeIcon.modify(k.Codicon.loading,"spin")}),define(Ie[171],Ce([1,0,4,41,3,11]),function(te,e,r,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var S;(function(s){s.Http="http",s.Https="https"})(S=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function T(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(!!o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=T,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function M(s){return e.LOCALHOST_ADDRESSES.indexOf(s)>=0}e.isLocalhost=M,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(s){return e.ALL_INTERFACES_ADDRESSES.indexOf(s)>=0}e.isAllInterfaces=E;function f(s,o,l,v){if(l===1)return!1;if(l===2&&E(o)){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(v);if(w?.length===4&&parseInt(w[1])>=18)return!1}return s<1024}e.isPortPrivileged=f;class b{constructor(o,l,v){this.remoteAddress=o,this.localAddress=l,this.b=v,this.a=new r.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=b;let m=class{constructor(o,l){this.i=o,this.j=l,this.a=new r.Emitter,this.onTunnelOpened=this.a.event,this.b=new r.Emitter,this.onTunnelClosed=this.b.event,this.c=new r.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const o=this.j.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.e=o,o?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.f=o.elevation,this.g=o.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const o=[],l=Array.from(this.d.values());for(const v of l){const w=Array.from(v.values());for(const A of w){const p=await A.value;p&&o.push(p)}}return o}async dispose(){for(const o of this.d.values()){for(const{value:l}of o.values())await l.then(v=>v?.dispose());o.clear()}this.d.clear()}setEnvironmentTunnel(o,l,v,w,A){this.o(o,l,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:l,localAddress:v,privacy:w,protocol:A,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,l){(E(o)||M(o))&&(o=e.LOCALHOST_ADDRESSES[0]);const v=this.q(o,l);if(v)return++v.refcount,v.value}openTunnel(o,l,v,w,A,p=!1,n,h){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${v} on local port ${A}.`),!o)return;if(l||(l="localhost"),w||(w=this.k),this.e&&this.h.has(v)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(o,l,v,w,A,p,n,h);return i?i.then(a=>{if(!a){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(l,v);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const t=this.m(a);return(a.tunnelRemoteHost!==l||a.tunnelRemotePort!==v)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(t),t}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const l=this.d.get(o.tunnelRemoteHost);if(l){const v=l.get(o.tunnelRemotePort);v&&(v.refcount--,await this.n(o.tunnelRemoteHost,o.tunnelRemotePort,v))}}}}async n(o,l,v){if(v.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${l}.`);const w=v.value.then(async A=>{A&&(await A.dispose(!0),this.b.fire({host:A.tunnelRemoteHost,port:A.tunnelRemotePort}))});return this.d.has(o)&&this.d.get(o).delete(l),w}}async closeTunnel(o,l){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${l} `);const v=this.d.get(o);if(v&&v.has(l)){const w=v.get(l);w.refcount=0,await this.n(o,l,w)}}o(o,l,v){this.d.has(o)||this.d.set(o,new Map),this.d.get(o).set(l,{refcount:1,value:v})}async p(o,l){const v=this.d.get(o);v&&(await v.get(l)||v.delete(l),v.size===0&&this.d.delete(o))}q(o,l){const v=[o];M(o)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):E(o)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const w=v.map(A=>this.d.get(A));for(const A of w){const p=A?.get(l);if(p)return p}}canTunnel(o){return!!T(o)}s(o,l,v,w,A,p,n){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${v} on local port ${w}.`);const h=v;this.h.add(h);const i=w===void 0?v:w,a={elevationRequired:A?this.isPortPrivileged(i):!1},t={remoteAddress:{host:l,port:v},localAddressPort:w,privacy:p,public:p?p!==R.Private:void 0,protocol:n},g=o.forwardPort(t,a);return g?(this.o(l,v,g),g.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(h)})):this.h.delete(h),g}};m=qe([je(0,N.ILogService),je(1,k.IConfigurationService)],m),e.AbstractTunnelService=m}),define(Ie[172],Ce([1,0,3]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,r.createDecorator)("editSessionIdentityService");var k;(function(D){D[D.Complete=100]="Complete",D[D.Partial=50]="Partial",D[D.None=0]="None"})(k=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Ie[173],Ce([1,0,15]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function k(y){return y.scheme!==r.Schemas.file&&y.scheme!==r.Schemas.vscodeRemote}e.isVirtualResource=k;function D(y){if(y.folders.length)return y.folders.every(T=>k(T.uri))?y.folders[0].uri:void 0;if(y.configuration&&k(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=D;function N(y){return D(y)?.scheme}e.getVirtualWorkspaceScheme=N;function S(y){return D(y)?.authority}e.getVirtualWorkspaceAuthority=S;function R(y){return D(y)!==void 0}e.isVirtualWorkspace=R}),define(Ie[52],Ce([1,0,137,19,47,24,2,3,15]),function(te,e,r,k,D,N,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function T(i){const a=i;return typeof a?.id=="string"&&S.URI.isUri(a.uri)}e.isSingleFolderWorkspaceIdentifier=T;function M(i){return typeof i?.id=="string"&&!T(i)&&!f(i)}e.isEmptyWorkspaceIdentifier=M,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function E(i,a){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,k.basename)(i)}:a?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const t=i;return t.configuration?{id:t.id,configPath:t.configuration}:t.folders.length===1?{id:t.id,uri:t.folders[0].uri}:{id:t.id}}e.toWorkspaceIdentifier=E;function f(i){const a=i;return typeof a?.id=="string"&&S.URI.isUri(a.configPath)}e.isWorkspaceIdentifier=f;function b(i){const a=i;if(a?.uri)return{id:a.id,uri:S.URI.revive(a.uri)};const t=i;if(t?.configPath)return{id:t.id,configPath:S.URI.revive(t.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=b;var m;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(m=e.WorkbenchState||(e.WorkbenchState={}));function s(i){const a=i;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.isWorkspace=s;function o(i){const a=i;return!!(a&&typeof a=="object"&&S.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.isWorkspaceFolder=o;class l{constructor(a,t,g,c,u){this.h=a,this.j=g,this.k=c,this.l=u,this.c=D.TernarySearchTree.forUris(this.l,()=>!0),this.folders=t}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=D.TernarySearchTree.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class v{constructor(a,t){this.raw=t,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,N.joinPath)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=v;function w(i){return new v({uri:i,index:0,name:(0,N.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=w,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,r.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function A(i,a){return N.extUriBiasedIgnorePathCase.isEqualOrParent(i,a.untitledWorkspacesHome)}e.isUntitledWorkspace=A;function p(i){let a;return S.URI.isUri(i)?a=i:a=i.configuration,a?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=p;function n(i,a){return!A(i,a)&&!p(i)}e.isSavedWorkspace=n;function h(i){return(typeof i=="string"?(0,k.extname)(i):(0,N.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=h}),define(Ie[53],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class r{constructor(D){this.d=D,this.b=new Map,this.c=1}add(D){const N=this.c++;return this.b.set(N,D),this.e(),N}get(D,N){return this.b.has(D)?this.b.get(D)[N]:void 0}delete(D){this.b.delete(D),this.e()}e(){!r.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=r,r.a=!1}),define(Ie[36],Ce([1,0,15,24,3]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class N{constructor(){this.a=new Set(Object.keys(r.Schemas)),this.b=new Map,this.extUri=new k.ExtUri(R=>{const y=this.b.get(R.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(R,y){y===null?this.b.delete(R.scheme):this.b.set(R.scheme,y)}isFreeScheme(R){return!this.b.has(R)&&!this.a.has(R)}getCapabilities(R){return this.b.get(R)}}e.ExtHostFileSystemInfo=N,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(Ie[26],Ce([1,0,3]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,r.createDecorator)("IExtHostInitDataService")}),define(Ie[174],Ce([1,0,11,160,26]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let N=class extends k.LogService{constructor(R,y){super(R.createLogger(y.logFile,{name:y.logName}))}};N=qe([je(0,r.ILoggerService),je(1,D.IExtHostInitDataService)],N),e.ExtHostLogService=N}),define(Ie[175],Ce([1,0,16]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class k{constructor(S,R,y){this.h=new Map,this.a=S,this.b=R,this.c=y,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(T=>(this.f=T,this)),this.g=this.c.onDidChangeStorage(T=>{T.shared===this.b&&T.key===this.a&&(this.f=T.value)}),this.i=new r.RunOnceScheduler(()=>{const T=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const M of T.values())M.complete()}catch(M){for(const E of T.values())E.error(M)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,S])=>S!==void 0).map(([S])=>S)}get whenReady(){return this.d}get(S,R){let y=this.f[S];return typeof y>"u"&&(y=R),y}update(S,R){this.f[S]=R;const y=this.h.get(S);if(y!==void 0)return y.p;const T=new r.DeferredPromise;return this.h.set(S,T),this.i.isScheduled()||this.i.schedule(),T.p}dispose(){this.g.dispose()}}e.ExtensionMemento=k;class D extends k{setKeysForSync(S){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},S)}constructor(S,R){super(S.identifier.value,!0,R),this.j=S}}e.ExtensionGlobalMemento=D}),define(Ie[176],Ce([1,0,4,2]),function(te,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class D{constructor(S){this.c=S,this.a=new r.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new r.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(S,R,y,T){const E=this.c.getNotebookDocument(k.URI.revive(S)).acceptModelChanged(R.value,y,T);this.b.fire(E)}$acceptDirtyStateChanged(S,R){this.c.getNotebookDocument(k.URI.revive(S)).acceptDirty(R)}$acceptModelSaved(S){const R=this.c.getNotebookDocument(k.URI.revive(S));this.a.fire(R.apiNotebook)}}e.ExtHostNotebookDocuments=D}),define(Ie[17],Ce([1,0,3]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,r.createDecorator)("IExtHostRpcService");class k{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.ExtHostRpcService=k});var Je=this&&this.__classPrivateFieldSet||function(te,e,r,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,r):D?D.value=r:e.set(te,r),r},Le=this&&this.__classPrivateFieldGet||function(te,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(te):k?k.value:e.get(te)};define(Ie[177],Ce([1,0,25,4]),function(te,e,r,k){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class N{constructor(R,y){D.set(this,void 0),this.b=new k.Emitter,this.onDidChange=this.b.event,this.a=r.ExtensionIdentifier.toKey(R.identifier),Je(this,D,y,"f"),Le(this,D,"f").onDidChangePassword(T=>{T.extensionId===this.a&&this.b.fire({key:T.key})})}get(R){return Le(this,D,"f").get(this.a,R)}store(R,y){return Le(this,D,"f").store(this.a,R,y)}delete(R){return Le(this,D,"f").delete(this.a,R)}}e.ExtensionSecrets=N,D=new WeakMap}),define(Ie[69],Ce([1,0,3,171,4,17]),function(te,e,r,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var S;(function(y){function T(E){return{remoteAddress:E.remoteAddress,localAddress:E.localAddress,public:!!E.public,privacy:E.privacy??(E.public?k.TunnelPrivacyId.Public:k.TunnelPrivacyId.Private),protocol:E.protocol}}y.fromApiTunnel=T;function M(E){return{remoteAddress:{host:E.tunnelRemoteHost,port:E.tunnelRemotePort},localAddress:E.localAddress,public:E.privacy!==k.TunnelPrivacyId.ConstantPrivate&&E.privacy!==k.TunnelPrivacyId.ConstantPrivate,privacy:E.privacy,protocol:E.protocol}}y.fromServiceTunnel=M})(S=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,r.createDecorator)("IExtHostTunnelService");let R=class{constructor(T){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(T){return T}async openTunnel(T,M){}async getTunnels(){return[]}async setTunnelFactory(T){return{dispose:()=>{}}}registerPortsAttributesProvider(T,M){return{dispose:()=>{}}}async $providePortAttributes(T,M,E,f,b){return[]}async $forwardPort(T,M){}async $closeTunnel(T){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=qe([je(0,N.IExtHostRpcService)],R),e.ExtHostTunnelService=R}),define(Ie[54],Ce([1,0,3]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,r.createDecorator)("IURITransformerService");class k{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=S=>S,this.transformOutgoing=S=>S,this.transformOutgoingURI=S=>S,this.transformOutgoingScheme=S=>S)}}e.URITransformerService=k}),define(Ie[178],Ce([1,0,23]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class k{constructor(){this.buffers=[]}add(y){let T=this.buffers.indexOf(y);return T<0&&(T=this.buffers.length,this.buffers.push(y)),T}}function D(R,y){if(y.serializeBuffersForPostMessage){const T=new k,M=(b,m)=>{if(m instanceof ArrayBuffer){const s=T.add(m);return{$$vscode_array_buffer_reference$$:!0,index:s}}else if(ArrayBuffer.isView(m)){const s=N(m);if(s){const o=T.add(m.buffer);return{$$vscode_array_buffer_reference$$:!0,index:o,view:{type:s,byteLength:m.byteLength,byteOffset:m.byteOffset}}}}return m},E=JSON.stringify(R,M),f=T.buffers.map(b=>{const m=new Uint8Array(b);return r.VSBuffer.wrap(m)});return{message:E,buffers:f}}else return{message:JSON.stringify(R),buffers:[]}}e.serializeWebviewMessage=D;function N(R){switch(R.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function S(R,y){const T=y.map(f=>{const b=new ArrayBuffer(f.byteLength);return new Uint8Array(b).set(f.buffer),b}),M=y.length?(f,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const m=b,{index:s}=m,o=T[s];if(m.view)switch(m.view.type){case 1:return new Int8Array(o,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return b}:void 0;return{message:JSON.parse(R,M),arrayBuffers:T}}e.deserializeWebviewMessage=S}),define(Ie[95],Ce([1,0,145,9,2,6,3,30,43,15,39,123,29]),function(te,e,r,k,D,N,S,R,y,T,M,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,r.localize)(0,null),providerDisplayName:(0,r.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var b;(function(G){G[G.PROGRAMMATIC=1]="PROGRAMMATIC",G[G.USER=2]="USER",G[G.EDIT=3]="EDIT",G[G.NAVIGATION=4]="NAVIGATION",G[G.JUMP=5]="JUMP"})(b=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var m;(function(G){G[G.IDENTICAL=1]="IDENTICAL",G[G.SIMILAR=2]="SIMILAR",G[G.DIFFERENT=3]="DIFFERENT"})(m=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function s(G){const H=G;return!!H&&typeof H.getSelection=="function"&&!!H.onDidChangeSelection}e.isEditorPaneWithSelection=s;function o(G,H,oe){for(const ve of oe.visibleEditorPanes)if(ve.group.id===H&&G.matches(ve.input))return ve.getViewState()}e.findViewStateForEditor=o;function l(G){if(u(G))return!1;const H=G;return D.URI.isUri(H?.resource)}e.isResourceEditorInput=l;function v(G){if(u(G))return!1;const H=G;return H?.original!==void 0&&H.modified!==void 0}e.isResourceDiffEditorInput=v;function w(G){if(u(G)||v(G))return!1;const H=G;return H?.primary!==void 0&&H.secondary!==void 0}e.isResourceSideBySideEditorInput=w;function A(G){if(u(G))return!1;const H=G;return H?H.resource===void 0||H.resource.scheme===T.Schemas.untitled||H.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=A;const p=/Untitled-\d+/;function n(G){return G.scheme===T.Schemas.untitled&&G.path.length>1&&!p.test(G.path)}e.isUntitledWithAssociatedResource=n;function h(G){if(u(G))return!1;const H=G;return D.URI.isUri(H?.base?.resource)&&D.URI.isUri(H?.input1?.resource)&&D.URI.isUri(H?.input2?.resource)&&D.URI.isUri(H?.result?.resource)}e.isResourceMergeEditorInput=h;var i;(function(G){G[G.SHORT=0]="SHORT",G[G.MEDIUM=1]="MEDIUM",G[G.LONG=2]="LONG"})(i=e.Verbosity||(e.Verbosity={}));var a;(function(G){G[G.EXPLICIT=1]="EXPLICIT",G[G.AUTO=2]="AUTO",G[G.FOCUS_CHANGE=3]="FOCUS_CHANGE",G[G.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a=e.SaveReason||(e.SaveReason={}));class t{constructor(){this.a=new Map}registerSource(H,oe){let ve=this.a.get(H);return ve||(ve={source:H,label:oe},this.a.set(H,ve)),ve.source}getSourceLabel(H){return this.a.get(H)?.label??H}}e.SaveSourceRegistry=new t;var g;(function(G){G[G.None=0]="None",G[G.Readonly=2]="Readonly",G[G.Untitled=4]="Untitled",G[G.Singleton=8]="Singleton",G[G.RequiresTrust=16]="RequiresTrust",G[G.CanSplitInGroup=32]="CanSplitInGroup",G[G.ForceDescription=64]="ForceDescription",G[G.CanDropIntoEditor=128]="CanDropIntoEditor",G[G.MultipleEditors=256]="MultipleEditors"})(g=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class c extends N.Disposable{}e.AbstractEditorInput=c;function u(G){return G instanceof c}e.isEditorInput=u;function d(G){const H=G;return D.URI.isUri(H?.preferredResource)}function C(G){const H=G;return u(H?.primary)&&u(H?.secondary)}e.isSideBySideEditorInput=C;function O(G){const H=G;return u(H?.modified)&&u(H?.original)}e.isDiffEditorInput=O;function j(G,H,oe,ve,Ae){return re(ve,[(0,E.toAction)({id:"workbench.action.openLargeFile",label:(0,r.localize)(2,null),run:()=>{const Ue={...oe,limits:{size:Number.MAX_VALUE}};G.openEditor(H,Ue)}}),(0,E.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,r.localize)(3,null),run:()=>Ae.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:f.default.Warning})}e.createTooLargeFileError=j;function Z(G){return u(G?.editor)}e.isEditorInputWithOptions=Z;function x(G){const H=G;return Z(G)&&H?.group!==void 0}e.isEditorInputWithOptionsAndGroup=x;function L(G){const H=G;return typeof H?.groupId=="number"&&u(H.editor)}e.isEditorIdentifier=L;var $;(function(G){G[G.UNKNOWN=0]="UNKNOWN",G[G.REPLACE=1]="REPLACE",G[G.MOVE=2]="MOVE",G[G.UNPIN=3]="UNPIN"})($=e.EditorCloseContext||(e.EditorCloseContext={}));var P;(function(G){G[G.GROUP_ACTIVE=0]="GROUP_ACTIVE",G[G.GROUP_INDEX=1]="GROUP_INDEX",G[G.GROUP_LOCKED=2]="GROUP_LOCKED",G[G.EDITOR_OPEN=3]="EDITOR_OPEN",G[G.EDITOR_CLOSE=4]="EDITOR_CLOSE",G[G.EDITOR_MOVE=5]="EDITOR_MOVE",G[G.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",G[G.EDITOR_LABEL=7]="EDITOR_LABEL",G[G.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",G[G.EDITOR_PIN=9]="EDITOR_PIN",G[G.EDITOR_STICKY=10]="EDITOR_STICKY",G[G.EDITOR_DIRTY=11]="EDITOR_DIRTY",G[G.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(P=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var F;(function(G){G[G.PRIMARY=1]="PRIMARY",G[G.SECONDARY=2]="SECONDARY",G[G.BOTH=3]="BOTH",G[G.ANY=4]="ANY"})(F=e.SideBySideEditor||(e.SideBySideEditor={}));class V{getOriginalUri(H,oe){if(!H)return;if(h(H))return e.EditorResourceAccessor.getOriginalUri(H.result,oe);if(oe?.supportSideBySide){const{primary:Ae,secondary:Ue}=this.a(H);if(Ae&&Ue){if(oe?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(Ae,{filterByScheme:oe.filterByScheme}),secondary:this.getOriginalUri(Ue,{filterByScheme:oe.filterByScheme})};if(oe?.supportSideBySide===F.ANY)return this.getOriginalUri(Ae,{filterByScheme:oe.filterByScheme})??this.getOriginalUri(Ue,{filterByScheme:oe.filterByScheme});H=oe.supportSideBySide===F.PRIMARY?Ae:Ue}}if(v(H)||w(H)||h(H))return;const ve=d(H)?H.preferredResource:H.resource;return!ve||!oe||!oe.filterByScheme?ve:this.b(ve,oe.filterByScheme)}a(H){return C(H)||w(H)?{primary:H.primary,secondary:H.secondary}:O(H)||v(H)?{primary:H.modified,secondary:H.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(H,oe){if(!H)return;if(h(H))return e.EditorResourceAccessor.getCanonicalUri(H.result,oe);if(oe?.supportSideBySide){const{primary:Ae,secondary:Ue}=this.a(H);if(Ae&&Ue){if(oe?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(Ae,{filterByScheme:oe.filterByScheme}),secondary:this.getCanonicalUri(Ue,{filterByScheme:oe.filterByScheme})};if(oe?.supportSideBySide===F.ANY)return this.getCanonicalUri(Ae,{filterByScheme:oe.filterByScheme})??this.getCanonicalUri(Ue,{filterByScheme:oe.filterByScheme});H=oe.supportSideBySide===F.PRIMARY?Ae:Ue}}if(v(H)||w(H)||h(H))return;const ve=H.resource;return!ve||!oe||!oe.filterByScheme?ve:this.b(ve,oe.filterByScheme)}b(H,oe){if(Array.isArray(oe)){if(oe.some(ve=>H.scheme===ve))return H}else if(oe===H.scheme)return H}}e.EditorResourceAccessor=new V;var q;(function(G){G[G.LEFT=0]="LEFT",G[G.RIGHT=1]="RIGHT"})(q=e.CloseDirection||(e.CloseDirection={}));class le{constructor(){this.c=new Map,this.d=new Map}start(H){const oe=this.a=H.get(S.IInstantiationService);for(const[ve,Ae]of this.c)this.e(ve,Ae,oe);this.c.clear()}e(H,oe,ve){const Ae=ve.createInstance(oe);this.d.set(H,Ae)}registerFileEditorFactory(H){if(this.b)throw new Error("Can only register one file editor factory.");this.b=H}getFileEditorFactory(){return(0,k.assertIsDefined)(this.b)}registerEditorSerializer(H,oe){if(this.c.has(H)||this.d.has(H))throw new Error(`A editor serializer with type ID '${H}' was already registered.`);return this.a?this.e(H,oe,this.a):this.c.set(H,oe),(0,N.toDisposable)(()=>{this.c.delete(H),this.d.delete(H)})}getEditorSerializer(H){return this.d.get(typeof H=="string"?H:H.typeId)}}R.Registry.add(e.EditorExtensions.EditorFactory,new le);async function _(G,H,oe){return!G||!G.length?[]:await Promise.all(G.map(async ve=>{const Ae=D.URI.revive(ve.fileUri);if(!Ae){oe.info("Cannot resolve the path because it is not valid.",ve);return}if(!await H.canHandleResource(Ae)){oe.info("Cannot resolve the path because it cannot be handled",ve);return}let xe=ve.exists,Te=ve.type;if(typeof xe!="boolean"||typeof Te!="number")try{Te=(await H.stat(Ae)).isDirectory?y.FileType.Directory:y.FileType.Unknown,xe=!0}catch(ke){oe.error(ke),xe=!1}if(!xe&&ve.openOnlyIfExists){oe.info("Cannot resolve the path because it does not exist",ve);return}if(Te===y.FileType.Directory){oe.info("Cannot resolve the path because it is a directory",ve);return}const Se={...ve.options,pinned:!0};return xe?{resource:Ae,options:Se}:{resource:Ae,options:Se,forceUntitled:!0}}))}e.pathsToEditors=_;var pe;(function(G){G[G.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",G[G.SEQUENTIAL=1]="SEQUENTIAL"})(pe=e.EditorsOrder||(e.EditorsOrder={}));function ue(G){const H=G;if(!H)return!1;const oe=H;if(oe.modified)return ue(oe.modified);const ve=H;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}e.isTextEditorViewState=ue;function de(G){return(0,M.isErrorWithActions)(G)}e.isEditorOpenError=de;function re(G,H,oe){const ve=(0,M.createErrorWithActions)(G,H);return ve.forceMessage=oe?.forceMessage,ve.forceSeverity=oe?.forceSeverity,ve.allowDialog=oe?.allowDialog,ve}e.createEditorOpenError=re}),define(Ie[179],Ce([1,0,4,146,3,6,28,30,18,62,22,84,170]),function(te,e,r,k,D,N,S,R,y,T,M,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",E.Codicon.window,(0,k.localize)(0,null));var b;(function(i){i.ViewContainersRegistry="workbench.registry.view.containers",i.ViewsRegistry="workbench.registry.view"})(b=e.Extensions||(e.Extensions={}));var m;(function(i){i[i.Sidebar=0]="Sidebar",i[i.Panel=1]="Panel",i[i.AuxiliaryBar=2]="AuxiliaryBar"})(m=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function s(i){switch(i){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=s;class o extends N.Disposable{constructor(){super(...arguments),this.c=this.B(new r.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new r.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,y.flatten)([...this.g.values()])}registerViewContainer(a,t,g){const c=this.get(a.id);if(c)return c;const u=a;return u.openCommandActionDescriptor=g?.doNotRegisterOpenCommand?void 0:u.openCommandActionDescriptor??{id:u.id},(0,S.getOrSet)(this.g,t,[]).push(u),g?.isDefault&&this.h.push(u),this.c.fire({viewContainer:u,viewContainerLocation:t}),u}deregisterViewContainer(a){for(const t of this.g.keys()){const g=this.g.get(t),c=g?.indexOf(a);if(c!==-1){g?.splice(c,1),g.length===0&&this.g.delete(t),this.f.fire({viewContainer:a,viewContainerLocation:t});return}}}get(a){return this.all.filter(t=>t.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(t=>this.getViewContainers(t).filter(g=>g?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(t=>this.getViewContainerLocation(t)===a)}}R.Registry.add(b.ViewContainersRegistry,new o);var l;(function(i){i.Open="2_open",i.Debug="4_debug",i.SCM="5_scm",i.More="9_more"})(l=e.ViewContentGroups||(e.ViewContentGroups={}));function v(i,a){const t=i.group??l.More,g=a.group??l.More;return t!==g?t.localeCompare(g):(i.order??5)-(a.order??5)}class w extends N.Disposable{constructor(){super(...arguments),this.c=this.B(new r.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new r.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new r.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new r.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new T.SetMap}registerViews(a,t){this.registerViews2([{views:a,viewContainer:t}])}registerViews2(a){a.forEach(({views:t,viewContainer:g})=>this.l(t,g)),this.c.fire(a)}deregisterViews(a,t){const g=this.m(a,t);g.length&&this.f.fire({views:g,viewContainer:t})}moveViews(a,t){for(const g of this.j.keys())if(g!==t){const c=this.m(a,g);c.length&&(this.l(c,t),this.g.fire({views:c,from:g,to:t}))}}getViews(a){return this.j.get(a)||[]}getView(a){for(const t of this.i){const g=(this.j.get(t)||[]).filter(c=>c.id===a)[0];if(g)return g}return null}getViewContainer(a){for(const t of this.i)if((this.j.get(t)||[]).filter(c=>c.id===a)[0])return t;return null}registerViewWelcomeContent(a,t){return this.k.add(a,t),this.h.fire(a),(0,N.toDisposable)(()=>{this.k.delete(a,t),this.h.fire(a)})}registerViewWelcomeContent2(a,t){const g=new Map;for(const[c,u]of t)this.k.add(a,u),g.set(c,(0,N.toDisposable)(()=>{this.k.delete(a,u),this.h.fire(a)}));return this.h.fire(a),g}getViewWelcomeContent(a){const t=[];return this.k.forEach(a,g=>t.push(g)),t.sort(v)}l(a,t){let g=this.j.get(t);g||(g=[],this.j.set(t,g),this.i.push(t));for(const c of a){if(this.getView(c.id)!==null)throw new Error((0,k.localize)(1,null,c.id));g.push(c)}}m(a,t){const g=this.j.get(t);if(!g)return[];const c=[],u=[];for(const d of g)a.includes(d)?c.push(d):u.push(d);return c.length&&(u.length?this.j.set(t,u):(this.j.delete(t),this.i.splice(this.i.indexOf(t),1))),c}}R.Registry.add(b.ViewsRegistry,new w),e.IViewsService=(0,D.createDecorator)("viewsService"),e.IViewDescriptorService=(0,D.createDecorator)("viewDescriptorService");var A;(function(i){i[i.Default=0]="Default",i[i.Expand=1]="Expand"})(A=e.ViewVisibilityState||(e.ViewVisibilityState={}));var p;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(p=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class n{constructor(a,t){this.c=!1,this.d=!1,(0,M.mixin)(this,a),this.d=!!t,this.resolve=async g=>{if(t&&!this.c){const c=await t(g);c&&(this.tooltip=this.tooltip??c.tooltip,this.command=this.command??c.command)}g.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=n;class h extends Error{constructor(a){super((0,k.localize)(2,null,a))}}e.NoTreeViewError=h}),define(Ie[180],Ce([1,0,4,16,147]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class N{constructor(){this.f=new Map,this.k=[],this.m=new r.Emitter,this.n=new r.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(R){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=R}onEvent(R){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=R}onRequest(R){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=R}sendResponse(R){R.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.s("response",R)}sendRequest(R,y,T,M){const E={command:R};if(y&&Object.keys(y).length>0&&(E.arguments=y),this.s("request",E),typeof M=="number"){const f=setTimeout(()=>{clearTimeout(f);const b=this.f.get(E.seq);if(b){this.f.delete(E.seq);const m={type:"response",seq:0,request_seq:E.seq,success:!1,command:R,message:(0,D.localize)(0,null,M,R)};b(m)}},M)}return T&&this.f.set(E.seq,T),E.seq}acceptMessage(R){this.j?this.j(R):(this.k.push(R),this.k.length===1&&this.q())}o(R,y){return R.type!=="event"||y.type!=="event"}async q(){let R;for(;this.k.length;){if((!R||this.o(this.k[0],R))&&await(0,k.timeout)(0),R=this.k.shift(),!R)return;switch(R.type){case"event":this.i?.(R);break;case"request":this.g?.(R);break;case"response":{const y=R,T=this.f.get(y.request_seq);T&&(this.f.delete(y.request_seq),T(y));break}}}}s(R,y){y.type=R,y.seq=this.d++,this.sendMessage(y)}async u(){if(this.f.size===0)return Promise.resolve();const R=new Map;this.f.forEach((y,T)=>R.set(T,y)),await(0,k.timeout)(500),R.forEach((y,T)=>{y({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.f.delete(T)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=N}),define(Ie[181],Ce([1,0,148,42,3]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new k.RawContextKey("debugType",void 0,{type:"string",description:r.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new k.RawContextKey("debugConfigurationType",void 0,{type:"string",description:r.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new k.RawContextKey("debugState","inactive",{type:"string",description:r.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new k.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:r.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new k.RawContextKey("hasDebugged",!1,{type:"boolean",description:r.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new k.RawContextKey("inDebugMode",!1,{type:"boolean",description:r.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new k.RawContextKey("inDebugRepl",!1,{type:"boolean",description:r.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new k.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:r.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new k.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:r.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new k.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:r.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new k.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:r.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new k.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:r.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new k.RawContextKey("variablesFocused",!0,{type:"boolean",description:r.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new k.RawContextKey("expressionSelected",!1,{type:"boolean",description:r.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new k.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:r.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new k.RawContextKey("callStackItemType",void 0,{type:"string",description:r.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new k.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:r.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new k.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:r.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new k.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:r.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new k.RawContextKey("watchItemType",void 0,{type:"string",description:r.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new k.RawContextKey("canViewMemory",void 0,{type:"boolean",description:r.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new k.RawContextKey("breakpointItemType",void 0,{type:"string",description:r.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new k.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:r.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new k.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:r.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new k.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:r.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new k.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:r.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new k.RawContextKey("stepBackSupported",!1,{type:"boolean",description:r.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new k.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:r.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new k.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:r.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new k.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:r.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new k.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:r.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new k.RawContextKey("breakpointsExist",!1,{type:"boolean",description:r.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new k.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:r.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new k.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:r.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new k.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:r.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new k.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:r.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new k.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:r.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new k.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:r.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new k.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:r.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new k.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:r.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new k.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:r.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new k.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:r.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new k.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:r.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new k.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:r.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new k.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:r.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new k.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:r.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new k.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:r.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new k.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:r.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new k.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:r.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new k.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:r.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new k.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:r.localize(50,null)});const N=f=>r.localize(51,null,f);e.debuggerDisabledMessage=N,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:r.localize(52,null)};var S;(function(f){f[f.Inactive=0]="Inactive",f[f.Initializing=1]="Initializing",f[f.Stopped=2]="Stopped",f[f.Running=3]="Running"})(S=e.State||(e.State={}));function R(f){switch(f){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=R;var y;(function(f){f[f.Valid=0]="Valid",f[f.Unreadable=1]="Unreadable",f[f.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var T;(function(f){f[f.Initial=1]="Initial",f[f.Dynamic=2]="Dynamic"})(T=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var M;(function(f){f.UnverifiedBreakpoints="unverifiedBreakpoints"})(M=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,D.createDecorator)("debugService");var E;(function(f){f[f.CONDITION=0]="CONDITION",f[f.HIT_COUNT=1]="HIT_COUNT",f[f.LOG_MESSAGE=2]="LOG_MESSAGE"})(E=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ie[182],Ce([1,0,10,2,19,22,15]),function(te,e,r,k,D,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const R=/{([^}]+)}/g;function y(i,a,t){return i.replace(R,function(g,c){return a&&c.length>0&&c[0]!=="_"?g:t&&t.hasOwnProperty(c)?t[c]:g})}e.formatPII=y;function T(i){const a={};for(const t of Object.keys(i))t.startsWith("!")||(a[t]=i[t]);return a}e.filterExceptionsFromTelemetry=T;function M(i){return i.configuration.request==="attach"&&!E(i)&&(!i.parentSession||M(i.parentSession))}e.isSessionAttach=M;function E(i){let a=i.configuration.type;if(!!a)return a==="vslsShare"&&(a=i.configuration.adapterProxy.configuration.type),(0,r.equalsIgnoreCase)(a,"extensionhost")||(0,r.equalsIgnoreCase)(a,"pwa-extensionhost")?i:i.parentSession?E(i.parentSession):void 0}e.getExtensionHostDebugSession=E;function f(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=f;function b(i,a,t){let g,c=0;const u=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let d=null;for(;d=u.exec(i);){const C=d.index+1,O=C+d[0].length;if(C<=a&&O>=t){g=d[0],c=C;break}}if(g){const C=/\w+/g;let O=null;for(;(O=C.exec(g))&&!(O.index+1+c+O[0].length>=t););O&&(g=g.substring(0,C.lastIndex))}return g?{start:c,end:c+g.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=b;const m=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function s(i){return!!(i&&i.match(m))}e.isUri=s;function o(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(s(i.path))return k.URI.parse(i.path);if((0,D.isAbsolute)(i.path))return k.URI.file(i.path)}return i.path}function l(i){if(typeof i.path=="object"){const a=k.URI.revive(i.path);if(a)return a.scheme===S.Schemas.file?a.fsPath:a.toString()}return i.path}function v(i,a){const t=a?o:l,g=(0,N.deepClone)(i);return A(g,(c,u)=>{c&&u&&(u.path=t(u))}),g}e.convertToDAPaths=v;function w(i,a){const t=a?o:l,g=(0,N.deepClone)(i);return A(g,(c,u)=>{!c&&u&&(u.path=t(u))}),g}e.convertToVSCPaths=w;function A(i,a){switch(i.type){case"event":{const t=i;switch(t.event){case"output":a(!1,t.body.source);break;case"loadedSource":a(!1,t.body.source);break;case"breakpoint":a(!1,t.body.breakpoint.source);break;default:break}break}case"request":{const t=i;switch(t.command){case"setBreakpoints":a(!0,t.arguments.source);break;case"breakpointLocations":a(!0,t.arguments.source);break;case"source":a(!0,t.arguments.source);break;case"gotoTargets":a(!0,t.arguments.source);break;case"launchVSCode":t.arguments.args.forEach(g=>a(!1,g));break;default:break}break}case"response":{const t=i;if(t.success&&t.body)switch(t.command){case"stackTrace":t.body.stackFrames.forEach(g=>a(!1,g.source));break;case"loadedSources":t.body.sources.forEach(g=>a(!1,g));break;case"scopes":t.body.scopes.forEach(g=>a(!1,g.source));break;case"setFunctionBreakpoints":t.body.breakpoints.forEach(g=>a(!1,g.source));break;case"setBreakpoints":t.body.breakpoints.forEach(g=>a(!1,g.source));break;case"disassemble":t.body?.instructions.forEach(c=>a(!1,c.location));break;default:break}break}}}function p(i){return i.filter(a=>!a.presentation?.hidden).sort((a,t)=>a.presentation?t.presentation?a.presentation.group?t.presentation.group?a.presentation.group!==t.presentation.group?a.presentation.group.localeCompare(t.presentation.group):n(a.presentation.order,t.presentation.order):-1:t.presentation.group?1:n(a.presentation.order,t.presentation.order):-1:t.presentation?1:0)}e.getVisibleAndSorted=p;function n(i,a){return typeof i!="number"?typeof a!="number"?0:1:typeof a!="number"?-1:i-a}async function h(i,a){const t=i.getValue("debug.saveBeforeStart",{overrideIdentifier:a.activeTextEditorLanguageId});if(t!=="none"&&(await a.saveAll(),t==="allEditorsInActiveGroup")){const g=a.activeEditorPane;g&&g.input.resource?.scheme===S.Schemas.untitled&&await a.save({editor:g.input,groupId:g.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=h}),define(Ie[70],Ce([1,0,23,35,183,64,15,19,20,42]),function(te,e,r,k,D,N,S,R,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var M;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(M=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",N.Mimes.latex,N.Mimes.markdown,"image/png","image/jpeg",N.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[N.Mimes.latex,N.Mimes.markdown,"application/json",N.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var E;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(E=e.NotebookRunState||(e.NotebookRunState={}));var f;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(f=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var b;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(b=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var s;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(s=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var l;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(l=e.CellEditType||(e.CellEditType={}));var v;(function(F){F.scheme=S.Schemas.vscodeNotebookCell;const V=["W","X","Y","Z","a","b","c","d","e","f"],q=new RegExp(`^[${V.join("")}]+`),le=7;function _(H,oe){const ve=oe.toString(le),Ue=`${ve.length<V.length?V[ve.length-1]:"z"}${ve}s${(0,r.encodeBase64)(r.VSBuffer.fromString(H.scheme),!0,!0)}`;return H.with({scheme:F.scheme,fragment:Ue})}F.generate=_;function pe(H){if(H.scheme!==F.scheme)return;const oe=H.fragment.indexOf("s");if(oe<0)return;const ve=parseInt(H.fragment.substring(0,oe).replace(q,""),le),Ae=(0,r.decodeBase64)(H.fragment.substring(oe+1)).toString();if(!isNaN(ve))return{handle:ve,notebook:H.with({scheme:Ae,fragment:null})}}F.parse=pe;function ue(H,oe){return H.with({scheme:S.Schemas.vscodeNotebookCellOutput,fragment:`op${oe??""},${H.scheme!==S.Schemas.file?H.scheme:""}`})}F.generateCellOutputUri=ue;function de(H){if(H.scheme!==S.Schemas.vscodeNotebookCellOutput)return;const oe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(H.fragment);if(!oe)return;const ve=oe[1]&&oe[1]!==""?oe[1]:void 0,Ae=oe[2];return{outputId:ve,notebook:H.with({scheme:Ae||S.Schemas.file,fragment:null})}}F.parseCellOutputUri=de;function re(H,oe,ve){return F.generate(H,oe).with({scheme:ve})}F.generateCellPropertyUri=re;function G(H,oe){if(H.scheme===oe)return F.parse(H.with({scheme:F.scheme}))}F.parseCellPropertyUri=G})(v=e.CellUri||(e.CellUri={}));const w=F=>y.isWindows?F.replace(/\//g,"\\"):F;class A{constructor(V=[],q=e.NOTEBOOK_DISPLAY_ORDER){this.e=q,this.d=[...new Set(V)].map(le=>({pattern:le,matches:k.parse(w(le))}))}sort(V){const q=new Map(D.Iterable.map(V,_=>[_,w(_)]));let le=[];for(const{matches:_}of this.d)for(const[pe,ue]of q)if(_(ue)){le.push(pe),q.delete(pe);break}return q.size&&(le=le.concat([...q.keys()].sort((_,pe)=>this.e.indexOf(_)-this.e.indexOf(pe)))),le}prioritize(V,q){const le=this.f(V);if(le===-1){this.d.unshift({pattern:V,matches:k.parse(w(V))});return}const _=new Set(q.map(ue=>this.f(ue,le)));_.delete(-1);const pe=Array.from(_).sort();this.d.splice(le+1,0,...pe.map(ue=>this.d[ue]));for(let ue=pe.length-1;ue>=0;ue--)this.d.splice(pe[ue],1)}toArray(){return this.d.map(V=>V.pattern)}f(V,q=this.d.length){const le=w(V);for(let _=0;_<q;_++)if(this.d[_].matches(le))return _;return-1}}e.MimeTypeDisplayOrder=A;function p(F,V,q,le=(_,pe)=>_===pe){const _=[];function pe(re,G,H){if(G===0&&H.length===0)return;const oe=_[_.length-1];oe&&oe.start+oe.deleteCount===re?(oe.deleteCount+=G,oe.toInsert.push(...H)):_.push({start:re,deleteCount:G,toInsert:H})}let ue=0,de=0;for(;;){if(ue===F.length){pe(ue,0,V.slice(de));break}if(de===V.length){pe(ue,F.length-ue,[]);break}const re=F[ue],G=V[de];if(le(re,G)){ue+=1,de+=1;continue}q(G)?(pe(ue,1,[]),ue+=1):(pe(ue,0,[G]),de+=1)}return _}e.diff=p,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new T.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(F){F.default="default",F.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function h(F){const V=F;return!!((typeof V.include=="string"||k.isRelativePattern(V.include))&&(typeof V.exclude=="string"||k.isRelativePattern(V.exclude)))}e.isDocumentExcludePattern=h;function i(F,V,q){if(Array.isArray(F.viewType)&&F.viewType.indexOf(V)>=0||F.viewType===V)return!0;if(F.filenamePattern){const le=h(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,_=h(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(k.match(le,(0,R.basename)(q.fsPath).toLowerCase()))return!(_&&k.match(_,(0,R.basename)(q.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=i,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var a;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(a=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class t{static create(V){return`${t.d}${V}`}static parse(V){if(V.startsWith(t.d))return V.substring(t.d.length)}}e.NotebookWorkingCopyTypeIdentifier=t,t.d="notebook/";function g(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}e.isTextStreamMime=g;const c=new TextDecoder;function u(F){const V=[];let q=!1;for(const le of F)(V.length===0||q)&&(V.push(le),q=!0);return j(V),P(r.VSBuffer.concat(V.map(le=>r.VSBuffer.wrap(le))))}e.compressOutputItemStreams=u;const d=`${String.fromCharCode(27)}[A`,C=d.split("").map(F=>F.charCodeAt(0)),O=10;function j(F){F.forEach((V,q)=>{if(q===0||V.length<d.length)return;const le=F[q-1],_=V.subarray(0,d.length);if(_[0]===C[0]&&_[1]===C[1]&&_[2]===C[2]){const pe=le.lastIndexOf(O);if(pe===-1)return;F[q-1]=le.subarray(0,pe),F[q]=V.subarray(d.length)}})}function Z(F){let V=F;do F=V,V=F.replace(/[^\n]\x08/gm,"");while(V.length<F.length);return F}function x(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const V=F.match(/^(.*)\r+/m)[1];let q=F.match(/\r+(.*)$/m)[1];q=q+V.slice(q.length,V.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,q)}return F}const L="\b".charCodeAt(0),$="\r".charCodeAt(0);function P(F){return!F.buffer.includes(L)&&!F.buffer.includes($)?F:r.VSBuffer.fromString(x(Z(c.decode(F.buffer))))}}),define(Ie[184],Ce([1,0,3]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var k;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState"})(k=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,r.createDecorator)("INotebookExecutionService")}),define(Ie[44],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(N){N.Delimiter="\0"})(r=e.TestIdPathParts||(e.TestIdPathParts={}));var k;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(k=e.TestPosition||(e.TestPosition={}));class D{static fromExtHostTestItem(S,R,y=S.parent){if(S._isRoot)return new D([R]);const T=[S.id];for(let M=y;M&&M.id!==R;M=M.parent)T.push(M.id);return T.push(R),new D(T.reverse())}static isRoot(S){return!S.includes("\0")}static root(S){const R=S.indexOf("\0");return R===-1?S:S.slice(0,R)}static fromString(S){return new D(S.split("\0"))}static join(S,R){return new D([...S.path,R])}static joinToString(S,R){return S.toString()+"\0"+R}static parentId(S){const R=S.lastIndexOf("\0");return R===-1?void 0:S.slice(0,R)}static localId(S){const R=S.lastIndexOf("\0");return R===-1?S:S.slice(R+1)}static compare(S,R){return S===R?0:R.startsWith(S+"\0")?2:S.startsWith(R+"\0")?3:1}constructor(S,R=S.length){if(this.path=S,this.d=R,S.length===0||R<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new D(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let S=1;S<=this.d;S++)yield new D(this.path,S)}*idsToRoot(){for(let S=this.d;S>0;S--)yield new D(this.path,S)}compare(S){if(typeof S=="string")return D.compare(this.toString(),S);for(let R=0;R<S.d&&R<this.d;R++)if(S.path[R]!==this.path[R])return 1;return S.d>this.d?2:S.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let S=1;S<this.d;S++)this.c+="\0",this.c+=this.path[S]}return this.c}}e.TestId=D}),define(Ie[55],Ce([1,0,2,56,44]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var N;(function(c){c[c.Unset=0]="Unset",c[c.Queued=1]="Queued",c[c.Running=2]="Running",c[c.Passed=3]="Passed",c[c.Failed=4]="Failed",c[c.Skipped=5]="Skipped",c[c.Errored=6]="Errored"})(N=e.TestResultState||(e.TestResultState={}));var S;(function(c){c[c.Run=2]="Run",c[c.Debug=4]="Debug",c[c.Coverage=8]="Coverage",c[c.HasNonDefaultProfile=16]="HasNonDefaultProfile",c[c.HasConfigurable=32]="HasConfigurable",c[c.SupportsContinuousRun=64]="SupportsContinuousRun"})(S=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const R=c=>"runIn"in c;e.isStartControllerTests=R;var y;(function(c){c.serialize=u=>({range:u.range.toJSON(),uri:u.uri.toJSON()}),c.deserialize=u=>({range:k.Range.lift(u.range),uri:r.URI.revive(u.uri)})})(y=e.IRichLocation||(e.IRichLocation={}));var T;(function(c){c[c.Error=0]="Error",c[c.Output=1]="Output"})(T=e.TestMessageType||(e.TestMessageType={}));var M;(function(c){c.serialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,location:u.location&&y.serialize(u.location)}),c.deserialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,location:u.location&&y.deserialize(u.location)})})(M=e.ITestErrorMessage||(e.ITestErrorMessage={}));const E=(c,u)=>`${u?"s":"e"}${c}`;e.getMarkId=E;var f;(function(c){c.serialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&y.serialize(u.location)}),c.deserialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&y.deserialize(u.location)})})(f=e.ITestOutputMessage||(e.ITestOutputMessage={}));var b;(function(c){c.serialize=u=>u.type===0?M.serialize(u):f.serialize(u),c.deserialize=u=>u.type===0?M.deserialize(u):f.deserialize(u)})(b=e.ITestMessage||(e.ITestMessage={}));var m;(function(c){c.serializeWithoutMessages=u=>({state:u.state,duration:u.duration,messages:[]}),c.serialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(b.serialize)}),c.deserialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(b.deserialize)})})(m=e.ITestTaskState||(e.ITestTaskState={}));const s="\0",o=(c,u)=>c+s+u;e.namespaceTestTag=o;const l=c=>{const u=c.indexOf(s);return{ctrlId:c.slice(0,u),tagId:c.slice(u+1)}};e.denamespaceTestTag=l;var v;(function(c){c.serialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?.toJSON(),range:u.range?.toJSON()||null,description:u.description,error:u.error,sortText:u.sortText}),c.deserialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?r.URI.revive(u.uri):void 0,range:u.range?k.Range.lift(u.range):null,description:u.description,error:u.error,sortText:u.sortText})})(v=e.ITestItem||(e.ITestItem={}));var w;(function(c){c[c.NotExpandable=0]="NotExpandable",c[c.Expandable=1]="Expandable",c[c.BusyExpanding=2]="BusyExpanding",c[c.Expanded=3]="Expanded"})(w=e.TestItemExpandState||(e.TestItemExpandState={}));var A;(function(c){c.serialize=u=>({expand:u.expand,item:v.serialize(u.item)}),c.deserialize=u=>({controllerId:D.TestId.root(u.item.extId),expand:u.expand,item:v.deserialize(u.item)})})(A=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(c){c.serialize=u=>{let d;return u.item&&(d={},u.item.label!==void 0&&(d.label=u.item.label),u.item.tags!==void 0&&(d.tags=u.item.tags),u.item.busy!==void 0&&(d.busy=u.item.busy),u.item.uri!==void 0&&(d.uri=u.item.uri?.toJSON()),u.item.range!==void 0&&(d.range=u.item.range?.toJSON()),u.item.description!==void 0&&(d.description=u.item.description),u.item.error!==void 0&&(d.error=u.item.error),u.item.sortText!==void 0&&(d.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:d}},c.deserialize=u=>{let d;return u.item&&(d={},u.item.label!==void 0&&(d.label=u.item.label),u.item.tags!==void 0&&(d.tags=u.item.tags),u.item.busy!==void 0&&(d.busy=u.item.busy),u.item.range!==void 0&&(d.range=u.item.range?k.Range.lift(u.item.range):null),u.item.description!==void 0&&(d.description=u.item.description),u.item.error!==void 0&&(d.error=u.item.error),u.item.sortText!==void 0&&(d.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:d}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const n=(c,u)=>{u.expand!==void 0&&(c.expand=u.expand),u.item!==void 0&&(c.item=c.item?Object.assign(c.item,u.item):u.item)};e.applyTestItemUpdate=n;var h;(function(c){c.serializeWithoutMessages=u=>({...A.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(m.serializeWithoutMessages),retired:u.retired}),c.serialize=u=>({...A.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(m.serialize),retired:u.retired}),c.deserialize=u=>({...A.deserialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(m.deserialize),retired:!0})})(h=e.TestResultItem||(e.TestResultItem={}));var i;(function(c){c[c.Function=0]="Function",c[c.Statement=1]="Statement"})(i=e.DetailType||(e.DetailType={}));var a;(function(c){c[c.Add=0]="Add",c[c.Update=1]="Update",c[c.DocumentSynced=2]="DocumentSynced",c[c.Remove=3]="Remove",c[c.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",c[c.Retire=5]="Retire",c[c.AddTag=6]="AddTag",c[c.RemoveTag=7]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var t;(function(c){c.deserialize=u=>u.op===0?{op:u.op,item:A.deserialize(u.item)}:u.op===1?{op:u.op,item:p.deserialize(u.item)}:u.op===2?{op:u.op,uri:r.URI.revive(u.uri),docv:u.docv}:u,c.serialize=u=>u.op===0?{op:u.op,item:A.serialize(u.item)}:u.op===1?{op:u.op,item:p.serialize(u.item)}:u})(t=e.TestsDiffOp||(e.TestsDiffOp={}));class g{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(u){const d=this.o();for(const C of u)switch(C.op){case 0:this.j(A.deserialize(C.item),d);break;case 1:this.k(p.deserialize(C.item),d);break;case 3:this.l(C.itemId,d);break;case 5:this.m(C.itemId);break;case 4:this.updatePendingRoots(C.amount);break;case 6:this.c.set(C.tag.id,C.tag);break;case 7:this.c.delete(C.id);break}d.complete?.()}j(u,d){const C=D.TestId.parentId(u.item.extId)?.toString();let O;if(!C)O=this.p(u),this.f.add(O),this.d.set(u.item.extId,O);else if(this.d.has(C)){const j=this.d.get(C);j.children.add(u.item.extId),O=this.p(u,j),this.d.set(u.item.extId,O)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(u)}`);return}return d.add?.(O),u.expand===2&&this.g++,O}k(u,d){const C=this.d.get(u.extId);if(!!C)return u.expand!==void 0&&(C.expand===2&&this.g--,u.expand===2&&this.g++),(0,e.applyTestItemUpdate)(C,u),d.update?.(C),C}l(u,d){const C=this.d.get(u);if(!C)return;const O=D.TestId.parentId(C.item.extId)?.toString();O?this.d.get(O).children.delete(C.item.extId):this.f.delete(C);const j=[[u]];for(;j.length;)for(const Z of j.pop()){const x=this.d.get(Z);x&&(j.push(x.children),this.d.delete(Z),d.remove?.(x,x!==C),x.expand===2&&this.g--)}}m(u){}updatePendingRoots(u){this.h+=u}o(){return{}}}e.AbstractIncrementalTestCollection=g}),define(Ie[71],Ce([1,0,16,4,6,48,55,44]),function(te,e,r,k,D,N,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(v){v[v.Upsert=0]="Upsert",v[v.SetTags=1]="SetTags",v[v.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",v[v.RemoveChild=3]="RemoveChild",v[v.SetProp=4]="SetProp",v[v.Bulk=5]="Bulk",v[v.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const T=(v,w)=>v===w,E=Object.entries({range:(v,w)=>v===w?!0:!v||!w?!1:v.equalsRange(w),busy:T,label:T,description:T,error:T,sortText:T,tags:(v,w)=>!(v.length!==w.length||v.some(A=>!w.includes(A)))}),f=(v,w)=>{let A;for(const[p,n]of E)n(v[p],w[p])||(A?A[p]=w[p]:A={[p]:w[p]});return A};class b extends D.Disposable{get root(){return this.m.root}constructor(w){super(),this.m=w,this.f=this.B(new r.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new k.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(w){this.h=w;for(const A of this.tree.values())this.G(A)}collectDiff(){const w=this.k;return this.k=[],w}pushDiff(w){switch(w.op){case 2:{for(const A of this.k)if(A.op===2&&A.uri===w.uri){A.docv=w.docv;return}break}case 1:{const A=this.k[this.k.length-1];if(A){if(A.op===1&&A.item.extId===w.item.extId){(0,S.applyTestItemUpdate)(A.item,w.item);return}if(A.op===0&&A.item.item.extId===w.item.extId){(0,S.applyTestItemUpdate)(A.item,w.item);return}}break}}this.k.push(w),this.f.isScheduled()||this.f.schedule()}expand(w,A){const p=this.tree.get(w);if(!!p){if((p.expandLevels===void 0||A>p.expandLevels)&&(p.expandLevels=A),p.expand===1){const n=this.I(p);return n.isOpen()?this.H(p,A-1):n.wait().then(()=>this.H(p,A-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.H(p,A-1)):this.H(p,A-1)}}dispose(){for(const w of this.tree.values())this.m.getApiFor(w.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(w,A){switch(A.op){case 3:this.L(R.TestId.joinToString(w.fullId,A.id));break;case 0:this.u(A.item,w);break;case 5:for(const p of A.ops)this.p(w,p);break;case 1:this.w(A.new,A.old,w.fullId.toString());break;case 2:this.G(w);break;case 4:this.pushDiff({op:1,item:{extId:w.fullId.toString(),item:A.update}});break;case 6:this.s(w.actual.uri);break;default:(0,N.assertNever)(A)}}s(w){w&&this.pushDiff({op:2,uri:w,docv:this.m.getDocumentVersion(w)})}u(w,A){const p=R.TestId.fromExtHostTestItem(w,this.root.id,A?.actual),n=this.m.getApiFor(w);n.parent&&n.parent!==A?.actual&&this.m.getChildren(n.parent).delete(w.id);let h=this.tree.get(p.toString());if(!h){h={fullId:p,actual:w,expandLevels:A?.expandLevels?A.expandLevels-1:void 0,expand:0},w.tags.forEach(this.y,this),this.tree.set(h.fullId.toString(),h),this.C(w,A),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:h.expand,item:this.m.toITestItem(w)}}),this.F(w,h,A);return}if(h.actual===w){this.D(w,h,A);return}if(h.actual.uri?.toString()!==w.uri?.toString())return this.L(p.toString()),this.u(w,A);const i=this.m.getChildren(h.actual),a=h.actual,t=f(this.m.toITestItem(a),this.m.toITestItem(w));this.m.getApiFor(a).listener=void 0,h.actual=w,h.expand=0,t&&(t.hasOwnProperty("tags")&&(this.w(w.tags,a.tags,p.toString()),delete t.tags),this.p(h,{op:4,update:t})),this.F(w,h,A);for(const[g,c]of i)this.m.getChildren(w).get(c.id)||this.L(R.TestId.joinToString(p,c.id));this.s(h.actual.uri)}w(w,A,p){const n=new Set(A.map(h=>h.id));for(const h of w)n.delete(h.id)||this.y(h);this.pushDiff({op:1,item:{extId:p,item:{tags:w.map(h=>(0,S.namespaceTestTag)(this.m.controllerId,h.id))}}}),n.forEach(this.z,this)}y(w){const A=this.j.get(w.id);A?A.refCount++:(this.j.set(w.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,S.namespaceTestTag)(this.m.controllerId,w.id)}}))}z(w){const A=this.j.get(w);A&&!--A.refCount&&(this.j.delete(w),this.pushDiff({op:7,id:(0,S.namespaceTestTag)(this.m.controllerId,w)}))}C(w,A){this.m.getApiFor(w).parent=A&&A.actual!==this.root?A.actual:void 0}D(w,A,p){this.C(w,p);const n=this.m.getApiFor(w);n.parent=p?.actual,n.listener=h=>this.p(A,h),this.G(A)}F(w,A,p){this.D(w,A,p);for(const[n,h]of this.m.getChildren(w))this.u(h,A)}G(w){let A;this.h?w.resolveBarrier?A=w.resolveBarrier.isOpen()?3:2:A=w.actual.canResolveChildren?1:0:A=0,A!==w.expand&&(w.expand=A,this.pushDiff({op:1,item:{extId:w.fullId.toString(),expand:A}}),A===1&&w.expandLevels!==void 0&&this.I(w))}H(w,A){if(A<0)return;const p=[];for(const[n,h]of this.m.getChildren(w.actual)){const i=this.expand(R.TestId.joinToString(w.fullId,h.id),A);(0,r.isThenable)(i)&&p.push(i)}if(p.length)return Promise.all(p).then(()=>{})}I(w){if(w.resolveBarrier)return w.resolveBarrier;if(!this.h){const h=new r.Barrier;return h.open(),h}w.expand=2,this.J(w);const A=w.resolveBarrier=new r.Barrier,p=h=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,h)};let n;try{n=this.h(w.actual===this.root?void 0:w.actual)}catch(h){p(h)}return(0,r.isThenable)(n)?n.catch(p).then(()=>{A.open(),this.G(w)}):(A.open(),this.G(w)),w.resolveBarrier}J(w){this.pushDiff({op:1,item:{extId:w.fullId.toString(),expand:w.expand}})}L(w){const A=this.tree.get(w);if(!A)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:w});const p=[A];for(;p.length;){const n=p.pop();if(!!n){this.m.getApiFor(n.actual).listener=void 0;for(const h of n.actual.tags)this.z(h.id);this.tree.delete(n.fullId.toString());for(const[h,i]of this.m.getChildren(n.actual))p.push(this.tree.get(R.TestId.joinToString(n.fullId,i.id)))}}}flushDiff(){const w=this.collectDiff();w.length&&this.g.fire(w)}}e.TestItemCollection=b;class m extends Error{constructor(w){super(`Attempted to insert a duplicate test item ID ${w}`)}}e.DuplicateTestItemError=m;class s extends Error{constructor(w){super(`TestItem with ID "${w}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=s;class o extends Error{constructor(w,A,p){super(`TestItem with ID "${w}" is from controller "${A}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=o;const l=(v,w,A)=>{let p=new Map;return{get size(){return p.size},forEach(n,h){for(const i of p.values())n.call(h,i,this)},[Symbol.iterator](){return p.entries()},replace(n){const h=new Map,i=new Set(p.keys()),a={op:5,ops:[]};for(const t of n){if(!(t instanceof A))throw new s(t.id);const g=w(t).controllerId;if(g!==v.controllerId)throw new o(t.id,g,v.controllerId);if(h.has(t.id))throw new m(t.id);h.set(t.id,t),i.delete(t.id),a.ops.push({op:0,item:t})}for(const t of i.keys())a.ops.push({op:3,id:t});v.listener?.(a),p=h},add(n){if(!(n instanceof A))throw new s(n.id);p.set(n.id,n),v.listener?.({op:0,item:n})},delete(n){p.delete(n)&&v.listener?.({op:3,id:n})},get(n){return p.get(n)},toJSON(){return Array.from(p.values())}}};e.createTestItemChildren=l}),define(Ie[96],Ce([1,0,71]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const k=new WeakMap,D=(S,R)=>{const y={controllerId:R};return k.set(S,y),y};e.createPrivateApiFor=D;const N=S=>{const R=k.get(S);if(!R)throw new r.InvalidTestItemError(S?.id||"<unknown>");return R};e.getPrivateApiFor=N}),define(Ie[72],Ce([1,0,15,2]),function(te,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function D(R,y){return R.scheme===r.Schemas.http||R.scheme===r.Schemas.https?R:(y&&y.authority&&y.isRemote&&R.scheme===r.Schemas.file&&(R=k.URI.from({scheme:r.Schemas.vscodeRemote,authority:y.authority,path:R.path})),k.URI.from({scheme:r.Schemas.https,authority:`${R.scheme}+${N(R.authority)}.${e.webviewRootResourceAuthority}`,path:R.path,fragment:R.fragment,query:R.query}))}e.asWebviewUri=D;function N(R){return R.replace(/./g,y=>{const T=y.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?y:"-"+T.toString(16).padStart(4,"0")})}function S(R){return R.replace(/-([0-9a-f]{4})/g,(y,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=S}),define(Ie[185],Ce([1,0,4,6,72]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class N{constructor(R,y,T){this.d=R,this.e=y,this.f=T,this.a=0,this.b=new k.DisposableStore,this.c=new Map,this.b.add(y.onDidChangeVisibleTextEditors(()=>{const M=y.getVisibleTextEditors();for(const E of this.c.values())M.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this.c.forEach(R=>R.inset.dispose()),this.b.dispose()}createWebviewEditorInset(R,y,T,M,E){let f;for(const w of this.e.getVisibleTextEditors(!0))if(w.value===R){f=w;break}if(!f)throw new Error("not a visible editor");const b=this,m=this.a++,s=new r.Emitter,o=new r.Emitter,l=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(w){return(0,D.asWebviewUri)(w,b.f)}get cspSource(){return D.webviewGenericCspSource}set options(w){this.b=w,b.d.$setOptions(m,w)}get options(){return this.b}set html(w){this.a=w,b.d.$setHtml(m,w)}get html(){return this.a}get onDidReceiveMessage(){return s.event}postMessage(w){return b.d.$postMessage(m,w)}},v=new class{constructor(){this.editor=R,this.line=y,this.height=T,this.webview=l,this.onDidDispose=o.event}dispose(){b.c.has(m)&&(b.c.delete(m),b.d.$disposeEditorInset(m),o.fire(),o.dispose(),s.dispose())}};return this.d.$createEditorInset(m,f.id,f.value.document.uri,y+1,T,M||{},E.identifier,E.extensionLocation),this.c.set(m,{editor:R,inset:v,onDidReceiveMessage:s}),v}$onDidDispose(R){const y=this.c.get(R);y&&y.inset.dispose()}$onDidReceiveMessage(R,y){this.c.get(R)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=N}),define(Ie[186],Ce([1,0,3]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,r.createDecorator)("configurationResolverService");var k;(function(N){N.Unknown="unknown",N.Env="env",N.Config="config",N.Command="command",N.Input="input",N.ExtensionInstallFolder="extensionInstallFolder",N.WorkspaceFolder="workspaceFolder",N.Cwd="cwd",N.WorkspaceFolderBasename="workspaceFolderBasename",N.UserHome="userHome",N.LineNumber="lineNumber",N.SelectedText="selectedText",N.File="file",N.FileWorkspaceFolder="fileWorkspaceFolder",N.RelativeFile="relativeFile",N.RelativeFileDirname="relativeFileDirname",N.FileDirname="fileDirname",N.FileExtname="fileExtname",N.FileBasename="fileBasename",N.FileBasenameNoExtension="fileBasenameNoExtension",N.FileDirnameBasename="fileDirnameBasename",N.ExecPath="execPath",N.ExecInstallFolder="execInstallFolder",N.PathSeparator="pathSeparator"})(k=e.VariableKind||(e.VariableKind={}));class D extends Error{constructor(S,R){super(R),this.variable=S}}e.VariableError=D}),define(Ie[187],Ce([1,0,19,50,9,22,20,87,151,186,10]),function(te,e,r,k,D,N,S,R,y,T,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class E{constructor(b,m,s,o){this.g=new Map,this.a=b,this.b=m,this.d=s,o&&(this.c=o.then(l=>this.h(l)))}h(b){if(S.isWindows){const m=Object.create(null);return Object.keys(b).forEach(s=>{m[s.toLowerCase()]=b[s]}),m}return b}resolveWithEnvironment(b,m,s){return this.j({env:this.h(b),userHome:void 0},m?m.uri:void 0,s)}async resolveAsync(b,m){const s={env:await this.c,userHome:await this.d};return this.j(s,b?b.uri:void 0,m)}async i(b,m,s,o){const l=N.deepClone(m);S.isWindows&&l.windows?Object.keys(l.windows).forEach(w=>l[w]=l.windows[w]):S.isMacintosh&&l.osx?Object.keys(l.osx).forEach(w=>l[w]=l.osx[w]):S.isLinux&&l.linux&&Object.keys(l.linux).forEach(w=>l[w]=l.linux[w]),delete l.windows,delete l.osx,delete l.linux;const v={env:await this.c,userHome:await this.d};return this.j(v,b?b.uri:void 0,l,s,o)}async resolveAnyAsync(b,m,s){return this.i(b,m,s)}async resolveAnyMap(b,m,s){const o=new Map;return{newConfig:await this.i(b,m,s,o),resolvedVariables:o}}resolveWithInteractionReplace(b,m,s,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,m,s,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,m){if(this.g.has(b))throw new Error("Variable "+b+" is contributed twice.");this.g.set(b,m)}async j(b,m,s,o,l){if(D.isString(s))return this.l(b,m,s,o,l);if(Array.isArray(s))return Promise.all(s.map(v=>this.j(b,m,v,o,l)));if(D.isObject(s)){const v=Object.create(null),w=await Promise.all(Object.keys(s).map(async A=>[await this.l(b,m,A,o,l),await this.j(b,m,s[A],o,l)]));for(const[A,p]of w)v[A]=p;return v}return s}l(b,m,s,o,l){return(0,M.replaceAsync)(s,E.VARIABLE_REGEXP,async(v,w)=>{if(w.includes(E.VARIABLE_LHS))return v;let A=await this.n(b,v,w,m,o);return l?.set(w,A),A!==v&&D.isString(A)&&A.match(E.VARIABLE_REGEXP)&&(A=await this.l(b,m,A,o,l)),A})}m(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async n(b,m,s,o,l){let v;const w=s.split(":");w.length>1&&(s=w[0],v=w[1]);const A=h=>{const i=this.a.getFilePath();if(i)return(0,R.normalizeDriveLetter)(i);throw new T.VariableError(h,(0,y.localize)(0,null,m))},p=h=>{const i=A(h);if(this.a.getWorkspaceFolderPathForFile){const a=this.a.getWorkspaceFolderPathForFile();if(a)return(0,R.normalizeDriveLetter)(a)}throw new T.VariableError(h,(0,y.localize)(1,null,m,r.basename(i)))},n=h=>{if(v){const i=this.a.getFolderUri(v);if(i)return i;throw new T.VariableError(h,(0,y.localize)(2,null,m,v))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new T.VariableError(h,(0,y.localize)(3,null,m)):new T.VariableError(h,(0,y.localize)(4,null,m))};switch(s){case"env":if(v){if(b.env){const h=b.env[S.isWindows?v.toLowerCase():v];if(D.isString(h))return h}return""}throw new T.VariableError(T.VariableKind.Env,(0,y.localize)(5,null,m));case"config":if(v){const h=this.a.getConfigurationValue(o,v);if(D.isUndefinedOrNull(h))throw new T.VariableError(T.VariableKind.Config,(0,y.localize)(6,null,m,v));if(D.isObject(h))throw new T.VariableError(T.VariableKind.Config,(0,y.localize)(7,null,m,v));return h}throw new T.VariableError(T.VariableKind.Config,(0,y.localize)(8,null,m));case"command":return this.o(T.VariableKind.Command,m,v,l,"command");case"input":return this.o(T.VariableKind.Input,m,v,l,"input");case"extensionInstallFolder":if(v){const h=await this.a.getExtension(v);if(!h)throw new T.VariableError(T.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,m,v));return this.m(h.extensionLocation)}throw new T.VariableError(T.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,m));default:switch(s){case"workspaceRoot":case"workspaceFolder":return(0,R.normalizeDriveLetter)(this.m(n(T.VariableKind.WorkspaceFolder)));case"cwd":return o||v?(0,R.normalizeDriveLetter)(this.m(n(T.VariableKind.Cwd))):k.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,R.normalizeDriveLetter)(r.basename(this.m(n(T.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new T.VariableError(T.VariableKind.UserHome,(0,y.localize)(11,null,m))}case"lineNumber":{const h=this.a.getLineNumber();if(h)return h;throw new T.VariableError(T.VariableKind.LineNumber,(0,y.localize)(12,null,m))}case"selectedText":{const h=this.a.getSelectedText();if(h)return h;throw new T.VariableError(T.VariableKind.SelectedText,(0,y.localize)(13,null,m))}case"file":return A(T.VariableKind.File);case"fileWorkspaceFolder":return p(T.VariableKind.FileWorkspaceFolder);case"relativeFile":return o||v?r.relative(this.m(n(T.VariableKind.RelativeFile)),A(T.VariableKind.RelativeFile)):A(T.VariableKind.RelativeFile);case"relativeFileDirname":{const h=r.dirname(A(T.VariableKind.RelativeFileDirname));if(o||v){const i=r.relative(this.m(n(T.VariableKind.RelativeFileDirname)),h);return i.length===0?".":i}return h}case"fileDirname":return r.dirname(A(T.VariableKind.FileDirname));case"fileExtname":return r.extname(A(T.VariableKind.FileExtname));case"fileBasename":return r.basename(A(T.VariableKind.FileBasename));case"fileBasenameNoExtension":{const h=r.basename(A(T.VariableKind.FileBasenameNoExtension));return h.slice(0,h.length-r.extname(h).length)}case"fileDirnameBasename":return r.basename(r.dirname(A(T.VariableKind.FileDirnameBasename)));case"execPath":{const h=this.a.getExecPath();return h||m}case"execInstallFolder":{const h=this.a.getAppRoot();return h||m}case"pathSeparator":return r.sep;default:try{const h=v?`${s}:${v}`:s;return this.o(T.VariableKind.Unknown,m,h,l,void 0)}catch{return m}}}}o(b,m,s,o,l){if(s&&o){const v=l===void 0?o[s]:o[l+":"+s];if(typeof v=="string")return v;throw new T.VariableError(b,(0,y.localize)(14,null,m))}return m}}e.AbstractVariableResolverService=E,E.VARIABLE_LHS="${",E.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ie[97],Ce([1,0,3,95]),function(te,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,r.createDecorator)("editorGroupsService");var D;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var N;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(N=e.GroupOrientation||(e.GroupOrientation={}));var S;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(S=e.GroupLocation||(e.GroupLocation={}));var R;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(R=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function T(m){const s=m;return(0,k.isEditorInput)(s?.editor)&&(0,k.isEditorInput)(s?.replacement)}e.isEditorReplacement=T;var M;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(M=e.GroupsOrder||(e.GroupsOrder={}));var E;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(E=e.OpenEditorContext||(e.OpenEditorContext={}));function f(m){const s=m;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}e.isEditorGroup=f;function b(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=b}),define(Ie[188],Ce([1,0,3,97]),function(te,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,r.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(N){const S=N;return typeof N=="number"||(0,k.isEditorGroup)(S)}e.isPreferredGroup=D}),define(Ie[189],Ce([1,0,3,157]),function(te,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,r.refineServiceDecorator)(k.IEnvironmentService)}),define(Ie[98],Ce([1,0,25,4,19]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class N{constructor(E){this.removedDueToLooping=E}}e.DeltaExtensionsResult=N;class S{static isHostExtension(E,f,b){if(f.getExtensionDescription(E))return!1;const m=b.getExtensionDescription(E);return m?!!((m.main||m.browser)&&m.api==="none"):!1}constructor(E){this.c=new k.Emitter,this.onDidChange=this.c.event,this.d=E,this.h()}h(){this.d.sort(y),this.e=new Map,this.f=[],this.g=new Map;for(const E of this.d){if(this.e.has(r.ExtensionIdentifier.toKey(E.identifier))){console.error("Extension `"+E.identifier.value+"` is already registered");continue}if(this.e.set(r.ExtensionIdentifier.toKey(E.identifier),E),this.f.push(E),Array.isArray(E.activationEvents))for(let f of E.activationEvents)f==="onUri"&&(f=`onUri:${r.ExtensionIdentifier.toKey(E.identifier)}`),this.g.has(f)||this.g.set(f,[]),this.g.get(f).push(E)}}set(E){this.d=E,this.h(),this.c.fire(void 0)}deltaExtensions(E,f){this.d=T(this.d,f),this.d=this.d.concat(E);const b=S.j(this.d);return this.d=T(this.d,b.map(m=>m.identifier)),this.h(),this.c.fire(void 0),new N(b)}static j(E){const f=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(l){this.d.has(l)||(this.d.add(l),this.e.push(l))}addArc(l,v){this.addNode(l),this.addNode(v),this.c.has(l)?this.c.get(l).push(v):this.c.set(l,[v])}getArcs(l){return this.c.has(l)?this.c.get(l):[]}hasOnlyGoodArcs(l,v){const w=f.getArcs(l);for(let A=0;A<w.length;A++)if(!v.has(w[A]))return!1;return!0}getNodes(){return this.e}},b=new Map;for(const l of E){const v=r.ExtensionIdentifier.toKey(l.identifier);if(b.set(v,l),l.extensionDependencies)for(const w of l.extensionDependencies){const A=r.ExtensionIdentifier.toKey(w);f.addArc(v,A)}}const m=new Set;f.getNodes().filter(l=>f.getArcs(l).length===0).forEach(l=>m.add(l));const s=f.getNodes().filter(l=>!m.has(l));let o;do{o=!1;for(let l=0;l<s.length;l++){const v=s[l];f.hasOnlyGoodArcs(v,m)&&(s.splice(l,1),l--,m.add(v),o=!0)}}while(o);return s.map(l=>b.get(l))}containsActivationEvent(E){return this.g.has(E)}containsExtension(E){return this.e.has(r.ExtensionIdentifier.toKey(E))}getExtensionDescriptionsForActivationEvent(E){const f=this.g.get(E);return f?f.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(E){const f=this.e.get(r.ExtensionIdentifier.toKey(E));return f||void 0}getExtensionDescriptionByUUID(E){for(const f of this.f)if(f.uuid===E)return f}getExtensionDescriptionByIdOrUUID(E,f){return this.getExtensionDescription(E)??(f?this.getExtensionDescriptionByUUID(f):void 0)}}e.ExtensionDescriptionRegistry=S;var R;(function(M){M[M.Builtin=0]="Builtin",M[M.User=1]="User",M[M.Dev=2]="Dev"})(R||(R={}));function y(M,E){const f=M.isBuiltin?0:M.isUnderDevelopment?2:1,b=E.isBuiltin?0:E.isUnderDevelopment?2:1;if(f!==b)return f-b;const m=D.posix.basename(M.extensionLocation.path),s=D.posix.basename(E.extensionLocation.path);return m<s?-1:m>s?1:0}function T(M,E){const f=new Set;return E.forEach(b=>f.add(r.ExtensionIdentifier.toKey(b))),M.filter(b=>!f.has(r.ExtensionIdentifier.toKey(b.identifier)))}}),define(Ie[73],Ce([1,0,23]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var k;(function(T){T[T.Desktop=1]="Desktop",T[T.Web=2]="Web"})(k=e.UIKind||(e.UIKind={}));var D;(function(T){T[T.VersionMismatch=55]="VersionMismatch",T[T.UnexpectedError=81]="UnexpectedError"})(D=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var N;(function(T){T[T.Initialized=0]="Initialized",T[T.Ready=1]="Ready",T[T.Terminate=2]="Terminate"})(N=e.MessageType||(e.MessageType={}));function S(T){const M=r.VSBuffer.alloc(1);switch(T){case 0:M.writeUInt8(1,0);break;case 1:M.writeUInt8(2,0);break;case 2:M.writeUInt8(3,0);break}return M}e.createMessageOfType=S;function R(T,M){if(T.byteLength!==1)return!1;switch(T.readUInt8(0)){case 1:return M===0;case 2:return M===1;case 3:return M===2;default:return!1}}e.isMessageOfType=R;var y;(function(T){T.Start="START_NATIVE_LOG",T.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ie[74],Ce([1,0,3,4,11,26,73,49,51,22,2]),function(te,e,r,k,D,N,S,R,y,T,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let E=class{constructor(s,o){this.i=s,this.a=new k.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new k.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=o.createLogger(M.URI.revive(this.i.environment.extensionTelemetryLogResource),{hidden:!0}),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(s,o,l){const v=this.getTelemetryDetails(),w=new f(o,l,s,this.g,this.f,this.getBuiltInCommonProperties(s),{isUsageEnabled:v.isUsageEnabled,isErrorsEnabled:v.isErrorsEnabled});return this.h.set(s.identifier.value,w),w.apiTelemetryLogger}$initializeTelemetryLevel(s,o,l){this.d=s,this.f=o,this.c=l??{usage:!0,error:!0}}getBuiltInCommonProperties(s){const o={};switch(o["common.extname"]=`${s.publisher}.${s.name}`,o["common.extversion"]=s.version,o["common.vscodemachineid"]=this.i.telemetryInfo.machineId,o["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,o["common.vscodeversion"]=this.i.version,o["common.isnewappinstall"]=b(this.i.telemetryInfo.firstSessionDate),o["common.product"]=this.i.environment.appHost,this.i.uiKind){case S.UIKind.Web:o["common.uikind"]="web";break;case S.UIKind.Desktop:o["common.uikind"]="desktop";break;default:o["common.uikind"]="unknown"}return o["common.remotename"]=(0,R.getRemoteName)((0,y.cleanRemoteAuthority)(this.i.remote.authority)),o}$onDidChangeTelemetryLevel(s){this.e=this.getTelemetryConfiguration(),this.d=s;const o=this.getTelemetryDetails();this.h.forEach(l=>{l.updateTelemetryEnablements(o.isUsageEnabled,o.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(s,o){const l=this.h.get(s.value);return!l||l.ignoreUnhandledExtHostErrors?!1:(l.logError(o),!0)}};E=qe([je(0,N.IExtHostInitDataService),je(1,D.ILoggerService)],E),e.ExtHostTelemetry=E;class f{constructor(s,o,l,v,w,A,p){this.g=l,this.h=v,this.i=w,this.j=A,this.b=new k.Emitter,this.ignoreUnhandledExtHostErrors=o?.ignoreUnhandledErrors??!1,this.e=o?.ignoreBuiltInCommonProperties??!1,this.f=o?.additionalCommonProperties,this.a=s,this.c={isUsageEnabled:p.isUsageEnabled,isErrorsEnabled:p.isErrorsEnabled}}updateTelemetryEnablements(s,o){this.d&&(this.c={isUsageEnabled:s,isErrorsEnabled:o},this.b.fire(this.d))}mixInCommonPropsAndCleanData(s){let o=s.properties??s;return o=(0,y.cleanData)(o,[]),this.f&&(o=(0,T.mixin)(o,this.f)),this.e||(o=(0,T.mixin)(o,this.j)),s.properties?s.properties=o:s=o,s}k(s,o){this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,o=this.mixInCommonPropsAndCleanData(o||{}),this.i||this.a.sendEventData(s,o),this.h.trace(s,o)}logUsage(s,o){!this.c.isUsageEnabled||this.k(s,o)}logError(s,o){!this.c.isErrorsEnabled||(typeof s=="string"?this.k(s,o):this.a.sendErrorData(s,o))}get apiTelemetryLogger(){if(!this.d){const s=this,o={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.c.isUsageEnabled},get isErrorsEnabled(){return s.c.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.b.event.bind(s)};this.d=Object.freeze(o)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=f;function b(m){const s=Date.now()-new Date(m).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.isNewAppInstall=b,e.IExtHostTelemetry=(0,r.createDecorator)("IExtHostTelemetry")}),define(Ie[27],Ce([1,0,4,2,3,25,167]),function(te,e,r,k,D,N,S){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new N.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:k.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class y{constructor(g){this.affinity=g,this.kind=1}equals(g){return this.kind===g.kind&&this.affinity===g.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=y;class T{constructor(g){this.affinity=g,this.kind=2}equals(g){return this.kind===g.kind&&this.affinity===g.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=T;class M{constructor(){this.kind=3,this.affinity=0}equals(g){return this.kind===g.kind}asString(){return"Remote"}}e.RemoteRunningLocation=M;class E{constructor(g){this.dependency=g}}e.MissingExtensionDependency=E;var f;(function(t){t[t.LocalProcess=1]="LocalProcess",t[t.LocalWebWorker=2]="LocalWebWorker",t[t.Remote=3]="Remote"})(f=e.ExtensionHostKind||(e.ExtensionHostKind={}));function b(t){if(t===null)return"None";switch(t){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=b;class m{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(g,c){const u=[],d=[],C=[],O=[],j=l(this.c),Z=l(g),x=(F,V)=>F.extensionLocation.toString()===V.extensionLocation.toString()||F.isBuiltin===V.isBuiltin||F.isUserBuiltin===V.isUserBuiltin||F.isUnderDevelopment===V.isUnderDevelopment;for(const F of this.c){const V=Z.get(N.ExtensionIdentifier.toKey(F.identifier));if(!V){u.push(F.identifier),j.delete(N.ExtensionIdentifier.toKey(F.identifier));continue}if(!x(F,V)){u.push(F.identifier),j.delete(N.ExtensionIdentifier.toKey(F.identifier));continue}}for(const F of g){const V=j.get(N.ExtensionIdentifier.toKey(F.identifier));if(!V){d.push(F);continue}if(!x(V,F)){u.push(V.identifier),j.delete(N.ExtensionIdentifier.toKey(V.identifier));continue}}const L=o(this.d),$=o(c);for(const F of this.d)$.has(N.ExtensionIdentifier.toKey(F))||C.push(F);for(const F of c)L.has(N.ExtensionIdentifier.toKey(F))||O.push(F);const P={toRemove:u,toAdd:d,myToRemove:C,myToAdd:O};return this.delta(P),P}delta(g){const{toRemove:c,toAdd:u,myToRemove:d,myToAdd:C}=g,O=o(c),j=o(d);for(let Z=0;Z<this.c.length;Z++)O.has(N.ExtensionIdentifier.toKey(this.c[Z].identifier))&&(this.c.splice(Z,1),Z--);for(let Z=0;Z<this.d.length;Z++)j.has(N.ExtensionIdentifier.toKey(this.d[Z]))&&(this.d.splice(Z,1),Z--);for(const Z of u)this.c.push(Z);for(const Z of C)this.d.push(Z)}containsExtension(g){for(const c of this.d)if(N.ExtensionIdentifier.equals(c,g))return!0;return!1}}e.ExtensionHostExtensions=m;class s{constructor(g){if(this[R]="ExtensionIdentifierSet",this.c=new Map,this.d=N.ExtensionIdentifier.toKey,g)for(const c of g)this.add(c)}get size(){return this.c.size}add(g){return this.c.set(this.d(g),g),this}clear(){this.c.clear()}delete(g){return this.c.delete(this.d(g))}has(g){return this.c.has(this.d(g))}forEach(g,c){this.c.forEach(u=>g.call(c,u,u,this))}*entries(){for(const[g,c]of this.c)yield[c,c]}keys(){return this.c.values()}values(){return this.c.values()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=s;function o(t){const g=new Set;for(const c of t)g.add(N.ExtensionIdentifier.toKey(c));return g}e.extensionIdentifiersArrayToSet=o;function l(t){const g=new Map;for(const c of t)g.set(N.ExtensionIdentifier.toKey(c.identifier),c);return g}function v(t,g){return t.enabledApiProposals?t.enabledApiProposals.includes(g):!1}e.isProposedApiEnabled=v;function w(t,g){if(!v(t,g))throw new Error(`Extension '${t.identifier.value}' CANNOT use API proposal: ${g}.
Its package.json#enabledApiProposals-property declares: ${t.enabledApiProposals?.join(", ")??"[]"} but NOT ${g}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${t.identifier.value}`)}e.checkProposedApiEnabled=w;class A{constructor(g,c,u,d){this.codeLoadingTime=g,this.activateCallTime=c,this.activateResolvedTime=u,this.activationReason=d}}e.ActivationTimes=A;class p{constructor(g,c){this.description=g,this.value=c}}e.ExtensionPointContribution=p,e.ExtensionHostLogFileName="exthost";var n;(function(t){t[t.Normal=0]="Normal",t[t.Immediate=1]="Immediate"})(n=e.ActivationKind||(e.ActivationKind={}));function h(t){return{type:t.isBuiltin?0:1,isBuiltin:t.isBuiltin||t.isUserBuiltin,identifier:{id:(0,S.getGalleryExtensionId)(t.publisher,t.name),uuid:t.uuid},manifest:t,location:t.extensionLocation,targetPlatform:t.targetPlatform,validations:[],isValid:!0}}e.toExtension=h;function i(t,g){return{identifier:new N.ExtensionIdentifier((0,S.getExtensionId)(t.manifest.publisher,t.manifest.name)),isBuiltin:t.type===0,isUserBuiltin:t.type===1&&t.isBuiltin,isUnderDevelopment:!!g,extensionLocation:t.location,...t.manifest,uuid:t.identifier.uuid,targetPlatform:t.targetPlatform,browserNlsBundleUris:t.browserNlsBundleUris}}e.toExtensionDescription=i;class a{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None,this.extensions=[]}activateByEvent(g){return Promise.resolve(void 0)}activationEventIsDone(g){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(g){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(g,c){return Promise.resolve(0)}getInspectPorts(g,c){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(g){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=a}),define(Ie[190],Ce([1,0,12,98,25,27,11,16]),function(te,e,r,k,D,N,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(l,v,w,A){this.startup=l,this.codeLoadingTime=v,this.activateCallTime=w,this.activateResolvedTime=A}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class T{constructor(l){this.a=l,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(l,v){return l===-1||v===-1?-1:v-l}build(){return new y(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=T;class M{constructor(l,v,w,A,p,n){this.activationFailed=l,this.activationFailedError=v,this.activationTimes=w,this.module=A,this.exports=p,this.subscriptions=n}}e.ActivatedExtension=M;class E extends M{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=E;class f extends M{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=f;class b extends M{constructor(l){super(!0,l,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let m=class{constructor(l,v,w,A){this.g=A,this.a=l,this.b=v,this.c=w,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[l,v]of this.d)v.dispose()}isActivated(l){const v=this.d.get(D.ExtensionIdentifier.toKey(l));return Boolean(v&&v.value)}getActivatedExtension(l){const v=this.d.get(D.ExtensionIdentifier.toKey(l));if(!v||!v.value)throw new Error(`Extension '${l.value}' is not known or not activated`);return v.value}async activateByEvent(l,v){if(this.f[l])return;const w=this.a.getExtensionDescriptionsForActivationEvent(l);await this.h(w.map(A=>({id:A.identifier,reason:{startup:v,extensionId:A.identifier,activationEvent:l}}))),this.f[l]=!0}activateById(l,v){const w=this.a.getExtensionDescription(l);if(!w)throw new Error(`Extension '${l}' is not known`);return this.h([{id:w.identifier,reason:v}])}async h(l){const v=l.filter(w=>!this.isActivated(w.id)).map(w=>this.j(w));await Promise.all(v.map(w=>w.wait()))}j(l){if(this.d.has(D.ExtensionIdentifier.toKey(l.id)))return this.d.get(D.ExtensionIdentifier.toKey(l.id));if(this.l(l.id))return this.k(l,null,[],null);const v=this.a.getExtensionDescription(l.id);if(!v){const p=new Error(`Cannot activate unknown extension '${l.id.value}'`),n=this.k(l,null,[],new b(p));return this.c.onExtensionActivationError(l.id,p,new N.MissingExtensionDependency(l.id.value)),n}const w=[],A=typeof v.extensionDependencies>"u"?[]:v.extensionDependencies;for(const p of A){if(this.m(p))continue;const n=this.d.get(D.ExtensionIdentifier.toKey(p));if(n){w.push(n);continue}if(this.l(p)){w.push(this.j({id:this.b.getExtensionDescription(p).identifier,reason:l.reason}));continue}const h=this.a.getExtensionDescription(p);if(h){if(!h.main&&!h.browser)continue;w.push(this.j({id:h.identifier,reason:l.reason}));continue}const i=v.displayName||v.identifier.value,a=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${p}'`),t=this.k(l,v.displayName,[],new b(a));return this.c.onExtensionActivationError(v.identifier,a,new N.MissingExtensionDependency(p)),t}return this.k(l,v.displayName,w,null)}k(l,v,w,A){const p=new s(l.id,v,l.reason,w,A,this.c,this.g);return this.d.set(D.ExtensionIdentifier.toKey(l.id),p),p}l(l){return k.ExtensionDescriptionRegistry.isHostExtension(l,this.a,this.b)}m(l){const v=this.b.getExtensionDescription(l);return v?!v.main&&!v.browser:!1}};m=qe([je(3,S.ILogService)],m),e.ExtensionsActivator=m;let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(l,v,w,A,p,n,h){this.c=l,this.d=v,this.f=w,this.g=A,this.h=p,this.j=n,this.k=h,this.a=new R.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let l=0;l<this.g.length;l++){const v=this.g[l];if(v.value&&!v.value.activationFailed){this.g.splice(l,1),l--;continue}if(v.value&&v.value.activationFailed){const w=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${v.friendlyName}' failed to activate`);w.detail=v.value.activationFailedError,this.h=new b(w),this.j.onExtensionActivationError(this.c,w,null);return}}this.g.length>0&&await Promise.race(this.g.map(l=>l.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(l){const v=new Error;if(l&&l.name&&(v.name=l.name),l&&l.message?v.message=`Activating extension '${this.c.value}' failed: ${l.message}.`:v.message=`Activating extension '${this.c.value}' failed: ${l}.`,l&&l.stack&&(v.stack=l.stack),this.h=new b(v),this.b&&r.isCancellationError(l))return;this.j.onExtensionActivationError(this.c,v,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(l)}}};s=qe([je(6,S.ILogService)],s)});var Je=this&&this.__classPrivateFieldSet||function(te,e,r,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,r):D?D.value=r:e.set(te,r),r},Le=this&&this.__classPrivateFieldGet||function(te,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(te):k?k.value:e.get(te)};define(Ie[7],Ce([1,0,18,12,86,28,64,10,9,2,34,43,94,70,27]),function(te,e,r,k,D,N,S,R,y,T,M,E,f,b,m){"use strict";var s,o,l,v,w,A,p,n,h,i,a,t,g,c,u,d,C,O,j,Z,x,L,$;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(z){return Object.assign(z,{apply:function(){const ie=arguments.length===1?[]:arguments[1];return Reflect.construct(z,ie,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(z,[]);{const[ie,...we]=arguments;return Reflect.construct(z,we,ie.constructor)}}})}var F;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(F=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var V;(function(z){z[z.Command=0]="Command",z[z.Opener=1]="Opener"})(V=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let q=A=class{static from(...U){let ie=U;return new A(function(){if(ie){for(const we of ie)we&&typeof we.dispose=="function"&&we.dispose();ie=void 0}})}constructor(U){s.set(this,void 0),Je(this,s,U,"f")}dispose(){typeof Le(this,s,"f")=="function"&&(Le(this,s,"f").call(this),Je(this,s,void 0,"f"))}};s=new WeakMap,q=A=qe([P],q),e.Disposable=q;let le=p=class{static Min(...U){if(U.length===0)throw new TypeError;let ie=U[0];for(let we=1;we<U.length;we++){const Ke=U[we];Ke.isBefore(ie)&&(ie=Ke)}return ie}static Max(...U){if(U.length===0)throw new TypeError;let ie=U[0];for(let we=1;we<U.length;we++){const Ke=U[we];Ke.isAfter(ie)&&(ie=Ke)}return ie}static isPosition(U){if(!U)return!1;if(U instanceof p)return!0;const{line:ie,character:we}=U;return typeof ie=="number"&&typeof we=="number"}static of(U){if(U instanceof p)return U;if(this.isPosition(U))return new p(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(U,ie){if(U<0)throw(0,k.illegalArgument)("line must be non-negative");if(ie<0)throw(0,k.illegalArgument)("character must be non-negative");this.c=U,this.e=ie}isBefore(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<U.e}isBeforeOrEqual(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<=U.e}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this.c===U.c&&this.e===U.e}compareTo(U){return this.c<U.c?-1:this.c>U.line?1:this.e<U.e?-1:this.e>U.e?1:0}translate(U,ie=0){if(U===null||ie===null)throw(0,k.illegalArgument)();let we;return typeof U>"u"?we=0:typeof U=="number"?we=U:(we=typeof U.lineDelta=="number"?U.lineDelta:0,ie=typeof U.characterDelta=="number"?U.characterDelta:0),we===0&&ie===0?this:new p(this.line+we,this.character+ie)}with(U,ie=this.character){if(U===null||ie===null)throw(0,k.illegalArgument)();let we;return typeof U>"u"?we=this.line:typeof U=="number"?we=U:(we=typeof U.line=="number"?U.line:this.line,ie=typeof U.character=="number"?U.character:this.character),we===this.line&&ie===this.character?this:new p(we,ie)}toJSON(){return{line:this.line,character:this.character}}};le=p=qe([P],le),e.Position=le;let _=n=class{static isRange(U){return U instanceof n?!0:U?le.isPosition(U.start)&&le.isPosition(U.end):!1}static of(U){if(U instanceof n)return U;if(this.isRange(U))return new n(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(U,ie,we,Ke){let _e,at;if(typeof U=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof Ke=="number"?(_e=new le(U,ie),at=new le(we,Ke)):le.isPosition(U)&&le.isPosition(ie)&&(_e=le.of(U),at=le.of(ie)),!_e||!at)throw new Error("Invalid arguments");_e.isBefore(at)?(this.c=_e,this.e=at):(this.c=at,this.e=_e)}contains(U){return n.isRange(U)?this.contains(U.start)&&this.contains(U.end):le.isPosition(U)?!(le.of(U).isBefore(this.c)||this.e.isBefore(U)):!1}isEqual(U){return this.c.isEqual(U.c)&&this.e.isEqual(U.e)}intersection(U){const ie=le.Max(U.start,this.c),we=le.Min(U.end,this.e);if(!ie.isAfter(we))return new n(ie,we)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const ie=le.Min(U.start,this.c),we=le.Max(U.end,this.end);return new n(ie,we)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(U,ie=this.end){if(U===null||ie===null)throw(0,k.illegalArgument)();let we;return U?le.isPosition(U)?we=U:(we=U.start||this.start,ie=U.end||this.end):we=this.start,we.isEqual(this.c)&&ie.isEqual(this.end)?this:new n(we,ie)}toJSON(){return[this.start,this.end]}};_=n=qe([P],_),e.Range=_;let pe=h=class extends _{static isSelection(U){return U instanceof h?!0:U?_.isRange(U)&&le.isPosition(U.anchor)&&le.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(U,ie,we,Ke){let _e,at;if(typeof U=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof Ke=="number"?(_e=new le(U,ie),at=new le(we,Ke)):le.isPosition(U)&&le.isPosition(ie)&&(_e=le.of(U),at=le.of(ie)),!_e||!at)throw new Error("Invalid arguments");super(_e,at),this.f=_e,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};pe=h=qe([P],pe),e.Selection=pe;class ue{constructor(U,ie,we){if(typeof U!="string"||U.length===0)throw(0,k.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,k.illegalArgument)("port");if(typeof we<"u"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z_\-]+$/.test(we)))throw(0,k.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(ie),this.connectionToken=we}}e.ResolvedAuthority=ue;class de extends Error{static NotAvailable(U,ie){return new de(U,f.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(U){return new de(U,f.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,ie=f.RemoteAuthorityResolverErrorCode.Unknown,we){super(U),this._message=U,this._code=ie,this._detail=we,Object.setPrototypeOf(this,de.prototype)}}e.RemoteAuthorityResolverError=de;var re;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(re=e.EndOfLine||(e.EndOfLine={}));var G;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(G=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let H=i=class{static isTextEdit(U){return U instanceof i?!0:U?_.isRange(U)&&typeof U.newText=="string":!1}static replace(U,ie){return new i(U,ie)}static insert(U,ie){return i.replace(new _(U,U),ie)}static delete(U){return i.replace(U,"")}static setEndOfLine(U){const ie=new i(new _(new le(0,0),new le(0,0)),"");return ie.newEol=U,ie}get range(){return this.c}set range(U){if(U&&!_.isRange(U))throw(0,k.illegalArgument)("range");this.c=U}get newText(){return this.e||""}set newText(U){if(U&&typeof U!="string")throw(0,k.illegalArgument)("newText");this.e=U}get newEol(){return this.f}set newEol(U){if(U&&typeof U!="number")throw(0,k.illegalArgument)("newEol");this.f=U}constructor(U,ie){this.c=U,this.e=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};H=i=qe([P],H),e.TextEdit=H;let oe=a=class{static isNotebookCellEdit(U){return U instanceof a?!0:U?Kt.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,ie){return new a(U,ie)}static insertCells(U,ie){return new a(new Kt(U,U),ie)}static deleteCells(U){return new a(U,[])}static updateCellMetadata(U,ie){const we=new a(new Kt(U,U),[]);return we.newCellMetadata=ie,we}static updateNotebookMetadata(U){const ie=new a(new Kt(0,0),[]);return ie.newNotebookMetadata=U,ie}constructor(U,ie){this.range=U,this.newCells=ie}};oe=a=qe([P],oe),e.NotebookEdit=oe;class ve{static isSnippetTextEdit(U){return U instanceof ve?!0:U?_.isRange(U.range)&&xe.isSnippetString(U.snippet):!1}static replace(U,ie){return new ve(U,ie)}static insert(U,ie){return ve.replace(new _(U,U),ie)}constructor(U,ie){this.range=U,this.snippet=ie}}e.SnippetTextEdit=ve;var Ae;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(Ae=e.FileEditType||(e.FileEditType={}));let Ue=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(U,ie,we,Ke){this.c.push({_type:1,from:U,to:ie,options:we,metadata:Ke})}createFile(U,ie,we){this.c.push({_type:1,from:void 0,to:U,options:ie,metadata:we})}deleteFile(U,ie,we){this.c.push({_type:1,from:U,to:void 0,options:ie,metadata:we})}e(U,ie,we){this.c.push({_type:3,metadata:we,uri:U,edit:{editType:5,metadata:ie},notebookMetadata:ie})}f(U,ie,we,Ke){const _e=ie.start,at=ie.end;(_e!==at||we.length>0)&&this.c.push({_type:5,uri:U,index:_e,count:at-_e,cells:we,metadata:Ke})}g(U,ie,we,Ke){this.c.push({_type:3,metadata:Ke,uri:U,edit:{editType:8,index:ie,metadata:we}})}replace(U,ie,we,Ke){this.c.push({_type:2,uri:U,edit:new H(ie,we),metadata:Ke})}insert(U,ie,we,Ke){this.replace(U,new _(ie,ie),we,Ke)}delete(U,ie,we){this.replace(U,ie,"",we)}has(U){return this.c.some(ie=>ie._type===2&&ie.uri.toString()===U.toString())}set(U,ie){if(ie)for(const we of ie){if(!we)continue;let Ke,_e;Array.isArray(we)?(Ke=we[0],_e=we[1]):Ke=we,oe.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(U,Ke.range.start,Ke.newCellMetadata,_e):Ke.newNotebookMetadata?this.e(U,Ke.newNotebookMetadata,_e):this.f(U,Ke.range,Ke.newCells,_e):ve.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:U,range:Ke.range,edit:Ke.snippet,metadata:_e}):this.c.push({_type:2,uri:U,edit:Ke,metadata:_e})}else{for(let we=0;we<this.c.length;we++){const Ke=this.c[we];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===U.toString()&&(this.c[we]=void 0);break}}(0,r.coalesceInPlace)(this.c)}}get(U){const ie=[];for(const we of this.c)we._type===2&&we.uri.toString()===U.toString()&&ie.push(we.edit);return ie}entries(){const U=new N.ResourceMap;for(const ie of this.c)if(ie._type===2){let we=U.get(ie.uri);we||(we=[ie.uri,[]],U.set(ie.uri,we)),we[1].push(ie.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Ue=qe([P],Ue),e.WorkspaceEdit=Ue;let xe=t=class{static isSnippetString(U){return U instanceof t?!0:U?typeof U.value=="string":!1}static c(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this.e=1,this.value=U||""}appendText(U){return this.value+=t.c(U),this}appendTabstop(U=this.e++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,ie=this.e++){if(typeof U=="function"){const we=new t;we.e=this.e,U(we),this.e=we.e,U=we.value}else U=t.c(U);return this.value+="${",this.value+=ie,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,ie=this.e++){const we=U.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(U,ie){if(typeof ie=="function"){const we=new t;we.e=this.e,ie(we),this.e=we.e,ie=we.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};xe=t=qe([P],xe),e.SnippetString=xe;var Te;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(Te=e.DiagnosticTag||(e.DiagnosticTag={}));var Se;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(Se=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ke=g=class{static isLocation(U){return U instanceof g?!0:U?_.isRange(U.range)&&T.URI.isUri(U.uri):!1}constructor(U,ie){if(this.uri=U,ie)if(_.isRange(ie))this.range=_.of(ie);else if(le.isPosition(ie))this.range=new _(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ke=g=qe([P],ke),e.Location=ke;let se=class{static is(U){return U?typeof U.message=="string"&&U.location&&_.isRange(U.location.range)&&T.URI.isUri(U.location.uri):!1}constructor(U,ie){this.location=U,this.message=ie}static isEqual(U,ie){return U===ie?!0:!U||!ie?!1:U.message===ie.message&&U.location.range.isEqual(ie.location.range)&&U.location.uri.toString()===ie.location.uri.toString()}};se=qe([P],se),e.DiagnosticRelatedInformation=se;let ce=class{constructor(U,ie,we=Se.Error){if(!_.isRange(U))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=U,this.message=ie,this.severity=we}toJSON(){return{severity:Se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,ie){return U===ie?!0:!U||!ie?!1:U.message===ie.message&&U.severity===ie.severity&&U.code===ie.code&&U.severity===ie.severity&&U.source===ie.source&&U.range.isEqual(ie.range)&&(0,r.equals)(U.tags,ie.tags)&&(0,r.equals)(U.relatedInformation,ie.relatedInformation,se.isEqual)}};ce=qe([P],ce),e.Diagnostic=ce;let J=class{constructor(U,ie){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=ie}};J=qe([P],J),e.Hover=J;var I;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(I=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let B=class{constructor(U,ie=I.Text){this.range=U,this.kind=ie}toJSON(){return{range:this.range,kind:I[this.kind]}}};B=qe([P],B),e.DocumentHighlight=B;var W;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(W=e.SymbolKind||(e.SymbolKind={}));var K;(function(z){z[z.Deprecated=1]="Deprecated"})(K=e.SymbolTag||(e.SymbolTag={}));let ee=c=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,ie,we,Ke,_e){this.name=U,this.kind=ie,this.containerName=_e,typeof we=="string"&&(this.containerName=we),Ke instanceof ke?this.location=Ke:we instanceof _&&(this.location=new ke(Ke,we)),c.validate(this)}toJSON(){return{name:this.name,kind:W[this.kind],location:this.location,containerName:this.containerName}}};ee=c=qe([P],ee),e.SymbolInformation=ee;let he=u=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(u.validate)}constructor(U,ie,we,Ke,_e){this.name=U,this.detail=ie,this.kind=we,this.range=Ke,this.selectionRange=_e,this.children=[],u.validate(this)}};he=u=qe([P],he),e.DocumentSymbol=he;var ye;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(ye=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(U,ie){this.title=U,this.kind=ie}};ae=qe([P],ae),e.CodeAction=ae;let be=d=class{constructor(U){this.value=U}append(U){return new d(this.value?this.value+d.c+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+d.c)}};be.c=".",be=d=qe([P],be),e.CodeActionKind=be,be.Empty=new be(""),be.QuickFix=be.Empty.append("quickfix"),be.Refactor=be.Empty.append("refactor"),be.RefactorExtract=be.Refactor.append("extract"),be.RefactorInline=be.Refactor.append("inline"),be.RefactorMove=be.Refactor.append("move"),be.RefactorRewrite=be.Refactor.append("rewrite"),be.Source=be.Empty.append("source"),be.SourceOrganizeImports=be.Source.append("organizeImports"),be.SourceFixAll=be.Source.append("fixAll");let Ee=class{constructor(U,ie){if(this.range=U,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ee=qe([P],Ee),e.SelectionRange=Ee;class We{constructor(U,ie,we,Ke,_e,at){this.kind=U,this.name=ie,this.detail=we,this.uri=Ke,this.range=_e,this.selectionRange=at}}e.CallHierarchyItem=We;class Ve{constructor(U,ie){this.fromRanges=ie,this.from=U}}e.CallHierarchyIncomingCall=Ve;class tt{constructor(U,ie){this.fromRanges=ie,this.to=U}}e.CallHierarchyOutgoingCall=tt;var Xe;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(U,ie){this.range=U,this.command=ie}get isResolved(){return!!this.command}};et=qe([P],et),e.CodeLens=et;let it=C=class{static isMarkdownString(U){return U instanceof C?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,ie=!1){o.set(this,void 0),Je(this,o,new D.MarkdownString(U,{supportThemeIcons:ie}),"f")}get value(){return Le(this,o,"f").value}set value(U){Le(this,o,"f").value=U}get isTrusted(){return Le(this,o,"f").isTrusted}set isTrusted(U){Le(this,o,"f").isTrusted=U}get supportThemeIcons(){return Le(this,o,"f").supportThemeIcons}set supportThemeIcons(U){Le(this,o,"f").supportThemeIcons=U}get supportHtml(){return Le(this,o,"f").supportHtml}set supportHtml(U){Le(this,o,"f").supportHtml=U}get baseUri(){return Le(this,o,"f").baseUri}set baseUri(U){Le(this,o,"f").baseUri=U}appendText(U){return Le(this,o,"f").appendText(U),this}appendMarkdown(U){return Le(this,o,"f").appendMarkdown(U),this}appendCodeblock(U,ie){return Le(this,o,"f").appendCodeblock(ie??"",U),this}};o=new WeakMap,it=C=qe([P],it),e.MarkdownString=it;let dt=class{constructor(U,ie){this.label=U,this.documentation=ie}};dt=qe([P],dt),e.ParameterInformation=dt;let Fe=class{constructor(U,ie){this.label=U,this.documentation=ie,this.parameters=[]}};Fe=qe([P],Fe),e.SignatureInformation=Fe;let ot=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ot=qe([P],ot),e.SignatureHelp=ot;var Y;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(Y=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Q;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(Q=e.InlayHintKind||(e.InlayHintKind={}));let ge=class{constructor(U){this.value=U}};ge=qe([P],ge),e.InlayHintLabelPart=ge;let Me=class{constructor(U,ie,we){this.position=U,this.label=ie,this.kind=we}};Me=qe([P],Me),e.InlayHint=Me;var ze;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var He;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(He=e.CompletionItemKind||(e.CompletionItemKind={}));var Ye;(function(z){z[z.Deprecated=1]="Deprecated"})(Ye=e.CompletionItemTag||(e.CompletionItemTag={}));let nt=class{constructor(U,ie){this.label=U,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&He[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};nt=qe([P],nt),e.CompletionItem=nt;let vt=class{constructor(U=[],ie=!1){this.items=U,this.isIncomplete=ie}};vt=qe([P],vt),e.CompletionList=vt;let wt=class{constructor(U,ie,we){this.insertText=U,this.range=ie,this.command=we}};wt=qe([P],wt),e.InlineSuggestion=wt;let Ct=class{constructor(U){this.commands=void 0,this.items=U}};Ct=qe([P],Ct),e.InlineSuggestionList=Ct;var jt;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(jt=e.ViewColumn||(e.ViewColumn={}));var rt;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(rt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var mt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(mt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ft;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Ft=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var xt;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(xt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Pt;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ht;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(ht=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var kt;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(kt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function U(ie){switch(ie){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=U}(Pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Bt=class{constructor(U,ie){if(ie&&!T.URI.isUri(ie))throw(0,k.illegalArgument)("target");if(!_.isRange(U)||U.isEmpty)throw(0,k.illegalArgument)("range");this.range=U,this.target=ie}};Bt=qe([P],Bt),e.DocumentLink=Bt;let Ot=class{constructor(U,ie,we,Ke){this.red=U,this.green=ie,this.blue=we,this.alpha=Ke}};Ot=qe([P],Ot),e.Color=Ot;let Ge=class{constructor(U,ie){if(ie&&!(ie instanceof Ot))throw(0,k.illegalArgument)("color");if(!_.isRange(U)||U.isEmpty)throw(0,k.illegalArgument)("range");this.range=U,this.color=ie}};Ge=qe([P],Ge),e.ColorInformation=Ge;let Mt=class{constructor(U){if(!U||typeof U!="string")throw(0,k.illegalArgument)("label");this.label=U}};Mt=qe([P],Mt),e.ColorPresentation=Mt;var Nt;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Nt=e.ColorFormat||(e.ColorFormat={}));var zt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(zt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var ft;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(ft=e.TerminalExitReason||(e.TerminalExitReason={}));class De{constructor(U,ie,we){if(this.startIndex=U,this.length=ie,this.tooltip=we,typeof U!="number"||U<0)throw(0,k.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,k.illegalArgument)("length");if(we!==void 0&&typeof we!="string")throw(0,k.illegalArgument)("tooltip")}}e.TerminalLink=De;class Pe{constructor(U){this.uri=U}}e.TerminalQuickFixOpener=Pe;class me{constructor(U){this.terminalCommand=U}}e.TerminalQuickFixCommand=me;var X;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(X=e.TerminalLocation||(e.TerminalLocation={}));class Re{constructor(U){if(this.options=U,typeof U!="object")throw(0,k.illegalArgument)("options")}}e.TerminalProfile=Re;var Be;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(Be=e.TaskRevealKind||(e.TaskRevealKind={}));var Qe;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(Qe=e.TaskPanelKind||(e.TaskPanelKind={}));let $e=O=class{static from(U){switch(U){case"clean":return O.Clean;case"build":return O.Build;case"rebuild":return O.Rebuild;case"test":return O.Test;default:return}}constructor(U,ie){if(this.label=ie,typeof U!="string"||typeof ie!="string")throw(0,k.illegalArgument)("name");this.c=U}get id(){return this.c}};$e.Clean=new O("clean","Clean"),$e.Build=new O("build","Build"),$e.Rebuild=new O("rebuild","Rebuild"),$e.Test=new O("test","Test"),$e=O=qe([P],$e),e.TaskGroup=$e;function Ze(z){let U="";for(let ie=0;ie<z.length;ie++)U+=z[ie].replace(/,/g,",,")+",";return U}let ct=class{constructor(U,ie,we){if(typeof U!="string")throw(0,k.illegalArgument)("process");this.e=[],this.c=U,ie!==void 0&&(Array.isArray(ie)?(this.e=ie,this.f=we):this.f=ie)}get process(){return this.c}set process(U){if(typeof U!="string")throw(0,k.illegalArgument)("process");this.c=U}get args(){return this.e}set args(U){Array.isArray(U)||(U=[]),this.e=U}get options(){return this.f}set options(U){this.f=U}computeId(){const U=[];if(U.push("process"),this.c!==void 0&&U.push(this.c),this.e&&this.e.length>0)for(const ie of this.e)U.push(ie);return Ze(U)}};ct=qe([P],ct),e.ProcessExecution=ct;let Tt=class{constructor(U,ie,we){if(this.f=[],Array.isArray(ie)){if(!U)throw(0,k.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,k.illegalArgument)("command");this.e=U,this.f=ie,this.g=we}else{if(typeof U!="string")throw(0,k.illegalArgument)("commandLine");this.c=U,this.g=ie}}get commandLine(){return this.c}set commandLine(U){if(typeof U!="string")throw(0,k.illegalArgument)("commandLine");this.c=U}get command(){return this.e?this.e:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,k.illegalArgument)("command");this.e=U}get args(){return this.f}set args(U){this.f=U||[]}get options(){return this.g}set options(U){this.g=U}computeId(){const U=[];if(U.push("shell"),this.c!==void 0&&U.push(this.c),this.e!==void 0&&U.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ie of this.f)U.push(typeof ie=="string"?ie:ie.value);return Ze(U)}};Tt=qe([P],Tt),e.ShellExecution=Tt;var bt;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(bt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class It{constructor(U){this.c=U}computeId(){return"customExecution"+(0,M.generateUuid)()}set callback(U){this.c=U}get callback(){return this.c}}e.CustomExecution=It;let St=j=class{constructor(U,ie,we,Ke,_e,at){this.j=!1,this.k=this.definition=U;let lt;typeof ie=="string"?(this.m=this.name=ie,this.t=this.source=we,this.execution=Ke,lt=_e,this.j=!0):ie===Et.Global||ie===Et.Workspace?(this.target=ie,this.m=this.name=we,this.t=this.source=Ke,this.execution=_e,lt=at):(this.target=ie,this.m=this.name=we,this.t=this.source=Ke,this.execution=_e,lt=at),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(U){this.h=U}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof ct?this.k={type:j.e,id:this.n.computeId()}:this.n instanceof Tt?this.k={type:j.f,id:this.n.computeId()}:this.n instanceof It?this.k={type:j.c,id:this.n.computeId()}:this.k={type:j.g,id:(0,M.generateUuid)()}}get definition(){return this.k}set definition(U){if(U==null)throw(0,k.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=U}get scope(){return this.l}set target(U){this.y(),this.l=U}get name(){return this.m}set name(U){if(typeof U!="string")throw(0,k.illegalArgument)("name");this.y(),this.m=U}get execution(){return this.n}set execution(U){U===null&&(U=void 0),this.y(),this.n=U;const ie=this.k.type;(j.g===ie||j.e===ie||j.f===ie||j.c===ie)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(U){if(Array.isArray(U))this.y(),this.o=U,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.y(),this.r=U}get source(){return this.t}set source(U){if(typeof U!="string"||U.length===0)throw(0,k.illegalArgument)("source must be a string of length > 0");this.y(),this.t=U}get group(){return this.u}set group(U){U===null&&(U=void 0),this.y(),this.u=U}get detail(){return this.x}set detail(U){U===null&&(U=void 0),this.x=U}get presentationOptions(){return this.v}set presentationOptions(U){U==null&&(U=Object.create(null)),this.y(),this.v=U}get runOptions(){return this.w}set runOptions(U){U==null&&(U=Object.create(null)),this.y(),this.w=U}};St.c="customExecution",St.e="process",St.f="shell",St.g="$empty",St=j=qe([P],St),e.Task=St;var yt;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(yt=e.ProgressLocation||(e.ProgressLocation={}));var qt;(function(z){function U(ie){const we=ie;return(0,y.isNumber)(we.value)?we.tooltip&&!(0,y.isString)(we.tooltip)?(console.log("INVALID view badge, invalid tooltip",we.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",we.value),!1)}z.isViewBadge=U})(qt=e.ViewBadge||(e.ViewBadge={}));let Jt=Z=class{static isTreeItem(U,ie){if(U instanceof Z)return!0;const we=U;if(we.label!==void 0&&!(0,y.isString)(we.label)&&!we.label?.label)return console.log("INVALID tree item, invalid label",we.label),!1;if(we.id!==void 0&&!(0,y.isString)(we.id))return console.log("INVALID tree item, invalid id",we.id),!1;if(we.iconPath!==void 0&&!(0,y.isString)(we.iconPath)&&!T.URI.isUri(we.iconPath)&&(!we.iconPath||!(0,y.isString)(we.iconPath.id))){const Ke=we.iconPath;if(!Ke||!(0,y.isString)(Ke.light)&&!T.URI.isUri(Ke.light)&&!(0,y.isString)(Ke.dark)&&!T.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",we.iconPath),!1}if(we.description!==void 0&&!(0,y.isString)(we.description)&&typeof we.description!="boolean")return console.log("INVALID tree item, invalid description",we.description),!1;if(we.resourceUri!==void 0&&!T.URI.isUri(we.resourceUri))return console.log("INVALID tree item, invalid resourceUri",we.resourceUri),!1;if(we.tooltip!==void 0&&!(0,y.isString)(we.tooltip)&&!(we.tooltip instanceof it))return console.log("INVALID tree item, invalid tooltip",we.tooltip),!1;if(we.command!==void 0&&!we.command.command)return console.log("INVALID tree item, invalid command",we.command),!1;if(we.collapsibleState!==void 0&&we.collapsibleState<pt.None&&we.collapsibleState>pt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",we.collapsibleState),!1;if(we.contextValue!==void 0&&!(0,y.isString)(we.contextValue))return console.log("INVALID tree item, invalid contextValue",we.contextValue),!1;if(we.accessibilityInformation!==void 0&&!we.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",we.accessibilityInformation),!1;if(we.checkboxState!==void 0){(0,m.checkProposedApiEnabled)(ie,"treeItemCheckbox");const Ke=(0,y.isNumber)(we.checkboxState)?we.checkboxState:(0,y.isObject)(we.checkboxState)&&(0,y.isNumber)(we.checkboxState.state)?we.checkboxState.state:void 0,_e=!(0,y.isNumber)(we.checkboxState)&&(0,y.isObject)(we.checkboxState)?we.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==si.Checked&&Ke!==si.Unchecked||_e!==void 0&&!(0,y.isString)(_e))return console.log("INVALID tree item, invalid checkboxState",we.checkboxState),!1}return!0}constructor(U,ie=pt.None){this.collapsibleState=ie,T.URI.isUri(U)?this.resourceUri=U:this.label=U}};Jt=Z=qe([P],Jt),e.TreeItem=Jt;var pt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(pt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var si;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(si=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let oi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U,ie){this.value=U,this.id=ie??(0,M.generateUuid)()}};oi=qe([P],oi),e.DataTransferItem=oi;let Zt=class{constructor(U){l.set(this,new Map);for(const[ie,we]of U??[]){const Ke=Le(this,l,"f").get(ie);Ke?Ke.push(we):Le(this,l,"f").set(ie,[we])}}get(U){return Le(this,l,"f").get(U)?.[0]}set(U,ie){Le(this,l,"f").set(U,[ie])}forEach(U,ie){for(const[we,Ke]of Le(this,l,"f"))for(const _e of Ke)U.call(ie,_e,we,this)}*[(l=new WeakMap,Symbol.iterator)](){for(const[U,ie]of Le(this,l,"f"))for(const we of ie)yield[U,we]}};Zt=qe([P],Zt),e.DataTransfer=Zt;let vi=class{constructor(U){this.insertText=U}};vi=qe([P],vi),e.DocumentDropEdit=vi;let At=class{constructor(U){this.insertText=U}};At=qe([P],At),e.DocumentPasteEdit=At;let Wt=class{constructor(U,ie){this.id=U,this.color=ie}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};Wt=qe([P],Wt),e.ThemeIcon=Wt,Wt.File=new Wt("file"),Wt.Folder=new Wt("folder");let bi=class{constructor(U){this.id=U}};bi=qe([P],bi),e.ThemeColor=bi;var ai;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(ai=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ei=class{get base(){return this.c}set base(U){this.c=U,this.e=T.URI.file(U)}get baseUri(){return this.e}set baseUri(U){this.e=U,this.c=U.fsPath}constructor(U,ie){if(typeof U!="string"&&(!U||!T.URI.isUri(U)&&!T.URI.isUri(U.uri)))throw(0,k.illegalArgument)("base");if(typeof ie!="string")throw(0,k.illegalArgument)("pattern");typeof U=="string"?this.baseUri=T.URI.file(U):T.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ei=qe([P],ei),e.RelativePattern=ei;const ut=new WeakMap;function Bi(z,U){ut.set(z,U)}e.setBreakpointId=Bi;let Ut=class{constructor(U,ie,we,Ke){this.enabled=typeof U=="boolean"?U:!0,typeof ie=="string"&&(this.condition=ie),typeof we=="string"&&(this.hitCondition=we),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=ut.get(this)??(0,M.generateUuid)()),this.c}};Ut=qe([P],Ut),e.Breakpoint=Ut;let Qt=class extends Ut{constructor(U,ie,we,Ke,_e){if(super(ie,we,Ke,_e),U===null)throw(0,k.illegalArgument)("location");this.location=U}};Qt=qe([P],Qt),e.SourceBreakpoint=Qt;let ci=class extends Ut{constructor(U,ie,we,Ke,_e){super(ie,we,Ke,_e),this.functionName=U}};ci=qe([P],ci),e.FunctionBreakpoint=ci;let Ei=class extends Ut{constructor(U,ie,we,Ke,_e,at,lt){if(super(Ke,_e,at,lt),!ie)throw(0,k.illegalArgument)("dataId");this.label=U,this.dataId=ie,this.canPersist=we}};Ei=qe([P],Ei),e.DataBreakpoint=Ei;let wi=class{constructor(U,ie,we){this.command=U,this.args=ie||[],this.options=we}};wi=qe([P],wi),e.DebugAdapterExecutable=wi;let ui=class{constructor(U,ie){this.port=U,this.host=ie}};ui=qe([P],ui),e.DebugAdapterServer=ui;let Si=class{constructor(U){this.path=U}};Si=qe([P],Si),e.DebugAdapterNamedPipeServer=Si;let li=class{constructor(U){this.implementation=U}};li=qe([P],li),e.DebugAdapterInlineImplementation=li;let ti=class{constructor(U,ie){this.range=U,this.expression=ie}};ti=qe([P],ti),e.EvaluatableExpression=ti;var $i;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})($i=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ii=class{constructor(U,ie){this.range=U,this.text=ie}};ii=qe([P],ii),e.InlineValueText=ii;let ni=class{constructor(U,ie,we=!0){this.range=U,this.variableName=ie,this.caseSensitiveLookup=we}};ni=qe([P],ni),e.InlineValueVariableLookup=ni;let yi=class{constructor(U,ie){this.range=U,this.expression=ie}};yi=qe([P],yi),e.InlineValueEvaluatableExpression=yi;let Di=class{constructor(U,ie){this.frameId=U,this.stoppedLocation=ie}};Di=qe([P],Di),e.InlineValueContext=Di;var ri;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(ri=e.FileChangeType||(e.FileChangeType={}));let Ii=x=class extends Error{static FileExists(U){return new x(U,E.FileSystemProviderErrorCode.FileExists,x.FileExists)}static FileNotFound(U){return new x(U,E.FileSystemProviderErrorCode.FileNotFound,x.FileNotFound)}static FileNotADirectory(U){return new x(U,E.FileSystemProviderErrorCode.FileNotADirectory,x.FileNotADirectory)}static FileIsADirectory(U){return new x(U,E.FileSystemProviderErrorCode.FileIsADirectory,x.FileIsADirectory)}static NoPermissions(U){return new x(U,E.FileSystemProviderErrorCode.NoPermissions,x.NoPermissions)}static Unavailable(U){return new x(U,E.FileSystemProviderErrorCode.Unavailable,x.Unavailable)}constructor(U,ie=E.FileSystemProviderErrorCode.Unknown,we){super(T.URI.isUri(U)?U.toString(!0):U),this.code=we?.name??"Unknown",(0,E.markAsFileSystemProviderError)(this,ie),Object.setPrototypeOf(this,x.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}};Ii=x=qe([P],Ii),e.FileSystemError=Ii;let Ci=class{constructor(U,ie,we){this.start=U,this.end=ie,this.kind=we}};Ci=qe([P],Ci),e.FoldingRange=Ci;var zi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(zi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wi;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Hi;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Hi=e.CommentMode||(e.CommentMode={}));var ki;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(ki=e.CommentThreadState||(e.CommentThreadState={}));class Ri{constructor(U,ie=[]){this.tokenTypes=U,this.tokenModifiers=ie}}e.SemanticTokensLegend=Ri;function Oi(z){return typeof z>"u"||(0,y.isStringArray)(z)}class Ne{constructor(U){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,U){this.l=!0;for(let ie=0,we=U.tokenTypes.length;ie<we;ie++)this.j.set(U.tokenTypes[ie],ie);for(let ie=0,we=U.tokenModifiers.length;ie<we;ie++)this.k.set(U.tokenModifiers[ie],ie)}}push(U,ie,we,Ke,_e){if(typeof U=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof Ke=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.n(U,ie,we,Ke,_e);if(_.isRange(U)&&typeof ie=="string"&&Oi(we))return this.m(U,ie,we);throw(0,k.illegalArgument)()}m(U,ie,we){if(!this.l)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ke=U.start.line,_e=U.start.character,at=U.end.character-U.start.character,lt=this.j.get(ie);let Lt=0;if(we)for(const Vt of we){if(!this.k.has(Vt))throw new Error("`tokenModifier` is not in the provided legend");const Gt=this.k.get(Vt);Lt|=1<<Gt>>>0}this.n(Ke,_e,at,lt,Lt)}n(U,ie,we,Ke,_e){if(this.f&&(U<this.c||U===this.c&&ie<this.e)){this.f=!1;const Lt=this.g.length/5|0;let Vt=0,Gt=0;for(let Xt=0;Xt<Lt;Xt++){let Yt=this.g[5*Xt],Pi=this.g[5*Xt+1];Yt===0?(Yt=Vt,Pi+=Gt):Yt+=Vt,this.g[5*Xt]=Yt,this.g[5*Xt+1]=Pi,Vt=Yt,Gt=Pi}}let at=U,lt=ie;this.f&&this.h>0&&(at-=this.c,at===0&&(lt-=this.e)),this.g[this.h++]=at,this.g[this.h++]=lt,this.g[this.h++]=we,this.g[this.h++]=Ke,this.g[this.h++]=_e,this.c=U,this.e=ie}static o(U){const ie=[],we=U.length/5|0;for(let lt=0;lt<we;lt++)ie[lt]=lt;ie.sort((lt,Lt)=>{const Vt=U[5*lt],Gt=U[5*Lt];if(Vt===Gt){const Xt=U[5*lt+1],Yt=U[5*Lt+1];return Xt-Yt}return Vt-Gt});const Ke=new Uint32Array(U.length);let _e=0,at=0;for(let lt=0;lt<we;lt++){const Lt=5*ie[lt],Vt=U[Lt+0],Gt=U[Lt+1],Xt=U[Lt+2],Yt=U[Lt+3],Pi=U[Lt+4],sn=Vt-_e,Rn=sn===0?Gt-at:Gt,Ai=5*lt;Ke[Ai+0]=sn,Ke[Ai+1]=Rn,Ke[Ai+2]=Xt,Ke[Ai+3]=Yt,Ke[Ai+4]=Pi,_e=Vt,at=Gt}return Ke}build(U){return this.f?new Ht(new Uint32Array(this.g),U):new Ht(Ne.o(this.g),U)}}e.SemanticTokensBuilder=Ne;class Ht{constructor(U,ie){this.resultId=ie,this.data=U}}e.SemanticTokens=Ht;class Li{constructor(U,ie,we){this.start=U,this.deleteCount=ie,this.data=we}}e.SemanticTokensEdit=Li;class gt{constructor(U,ie){this.resultId=ie,this.edits=U}}e.SemanticTokensEdits=gt;var Vi;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Vi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let di=class{constructor(){}};di.Back={iconPath:new Wt("arrow-left")},di=qe([P],di),e.QuickInputButtons=di;var Fi;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(Fi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ji;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(ji=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var hi;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(hi=e.ExtensionKind||(e.ExtensionKind={}));class qi{static validate(U){if(typeof U.badge=="string"){let ie=(0,R.nextCharLength)(U.badge,0);if(ie<U.badge.length&&(ie+=(0,R.nextCharLength)(U.badge,ie)),U.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!Wt.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,ie,we){this.badge=U,this.tooltip=ie,this.color=we}}e.FileDecoration=qi;let Ti=class{constructor(U){this.kind=U}};Ti=qe([P],Ti),e.ColorTheme=Ti;var Ki;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Ki=e.ColorThemeKind||(e.ColorThemeKind={}));class Kt{static isNotebookRange(U){return U instanceof Kt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(U,ie){if(U<0)throw(0,k.illegalArgument)("start must be positive");if(ie<0)throw(0,k.illegalArgument)("end must be positive");U<=ie?(this.c=U,this.e=ie):(this.c=ie,this.e=U)}with(U){let ie=this.c,we=this.e;return U.start!==void 0&&(ie=U.start),U.end!==void 0&&(we=U.end),ie===this.c&&we===this.e?this:new Kt(ie,we)}}e.NotebookRange=Kt;class fi{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(ie=>fi.isNotebookCellData(ie))}static isNotebookCellData(U){return!0}constructor(U,ie,we,Ke,_e,at,lt){this.kind=U,this.value=ie,this.languageId=we,this.mime=Ke,this.outputs=_e??[],this.metadata=at,this.executionSummary=lt,fi.validate(this)}}e.NotebookCellData=fi;class Gi{constructor(U){this.cells=U}}e.NotebookData=Gi;class $t{static isNotebookCellOutputItem(U){return U instanceof $t?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const ie={name:U.name,message:U.message,stack:U.stack};return $t.json(ie,"application/vnd.code.notebook.error")}static stdout(U){return $t.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return $t.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,ie="application/octet-stream"){return new $t(U,ie)}static text(U,ie=S.Mimes.text){const we=Le($t,v,"f",w).encode(String(U));return new $t(we,ie)}static json(U,ie="text/x-json"){const we=JSON.stringify(U,void 0,"	");return $t.text(we,ie)}constructor(U,ie){this.data=U,this.mime=ie;const we=(0,S.normalizeMimeType)(ie,!0);if(!we)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}}e.NotebookCellOutputItem=$t,v=$t,w={value:new TextEncoder};class mi{static isNotebookCellOutput(U){return U instanceof mi?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,ie=!1){const we=new Set,Ke=new Set;for(let _e=0;_e<U.length;_e++){const at=U[_e],lt=(0,S.normalizeMimeType)(at.mime);if(!we.has(lt)||(0,b.isTextStreamMime)(lt)){we.add(lt);continue}Ke.add(_e),ie&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ke.size===0?U:U.filter((_e,at)=>!Ke.has(at))}constructor(U,ie,we){this.items=mi.ensureUniqueMimeTypes(U,!0),typeof ie=="string"?(this.id=ie,this.metadata=we):(this.id=(0,M.generateUuid)(),this.metadata=ie??we)}}e.NotebookCellOutput=mi;var xi;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(xi=e.NotebookCellKind||(e.NotebookCellKind={}));var Xi;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(Xi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ne;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(ne=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var fe;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(fe=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Oe{constructor(U,ie){this.text=U,this.alignment=ie}}e.NotebookCellStatusBarItem=Oe;var st;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(st=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Dt;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(Dt=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Rt{constructor(U,ie=[]){this.uri=U,this.provides=(0,r.asArray)(ie)}}e.NotebookRendererScript=Rt;class un{constructor(U){this.label=U}}e.NotebookKernelSourceAction=un;let Qi=class{constructor(U,ie){this.label=U,this.timestamp=ie}};Qi=qe([P],Qi),e.TimelineItem=Qi;var ln;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(ln=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(U,ie){this.ranges=U,this.wordPattern=ie}}e.LinkedEditingRanges=fn;class mn{constructor(U,ie){this.c=U,this.e=ie}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=mn;var gn;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Mi=class{constructor(U=void 0,ie=void 0,we=void 0){this.include=U,this.exclude=ie,this.profile=we}};Mi=qe([P],Mi),e.TestRunRequest=Mi;let Yi=class extends Mi{constructor(U=void 0,ie=void 0,we=void 0,Ke=!1){super(U,ie,we),this.continuous=Ke}};Yi=qe([P],Yi),e.TestRunRequest2=Yi;let _i=L=class{static diff(U,ie,we){const Ke=new L(U);return Ke.expectedOutput=ie,Ke.actualOutput=we,Ke}constructor(U){this.message=U}};_i=L=qe([P],_i),e.TestMessage=_i;let Ji=class{constructor(U){this.id=U}};Ji=qe([P],Ji),e.TestTag=Ji;let gi=class{constructor(U,ie){this.covered=U,this.total=ie}};gi=qe([P],gi),e.CoveredCount=gi;let Zi=$=class{static fromDetails(U,ie){const we=new gi(0,0),Ke=new gi(0,0),_e=new gi(0,0);for(const lt of ie)if("branches"in lt){we.total+=1,we.covered+=lt.executionCount>0?1:0;for(const Lt of lt.branches)Ke.total+=1,Ke.covered+=Lt.executionCount>0?1:0}else _e.total+=1,_e.covered+=lt.executionCount>0?1:0;const at=new $(U,we,Ke.total>0?Ke:void 0,_e.total>0?_e:void 0);return at.detailedCoverage=ie,at}constructor(U,ie,we,Ke){this.uri=U,this.statementCoverage=ie,this.branchCoverage=we,this.functionCoverage=Ke}};Zi=$=qe([P],Zi),e.FileCoverage=Zi;let en=class{constructor(U,ie,we=[]){this.executionCount=U,this.location=ie,this.branches=we}};en=qe([P],en),e.StatementCoverage=en;let tn=class{constructor(U,ie){this.executionCount=U,this.location=ie}};tn=qe([P],tn),e.BranchCoverage=tn;let nn=class{constructor(U,ie){this.executionCount=U,this.location=ie}};nn=qe([P],nn),e.FunctionCoverage=nn;var vn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(vn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var bn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(bn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var En;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(En=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class wn{constructor(U,ie,we,Ke,_e,at){this.kind=U,this.name=ie,this.detail=we,this.uri=Ke,this.range=_e,this.selectionRange=at}}e.TypeHierarchyItem=wn;class Sn{constructor(U){this.uri=U}}e.TextTabInput=Sn;class yn{constructor(U,ie){this.original=U,this.modified=ie}}e.TextDiffTabInput=yn;class Dn{constructor(U,ie,we,Ke){this.base=U,this.input1=ie,this.input2=we,this.result=Ke}}e.TextMergeTabInput=Dn;class In{constructor(U,ie){this.uri=U,this.viewType=ie}}e.CustomEditorTabInput=In;class Cn{constructor(U){this.viewType=U}}e.WebviewEditorTabInput=Cn;class kn{constructor(U,ie){this.uri=U,this.notebookType=ie}}e.NotebookEditorTabInput=kn;class Tn{constructor(U,ie,we){this.original=U,this.modified=ie,this.notebookType=we}}e.NotebookDiffEditorTabInput=Tn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class An{constructor(U,ie){this.uri=U,this.inputBoxUri=ie}}e.InteractiveWindowInput=An}),define(Ie[99],Ce([1,0,48,15,10,256,130,7,18]),function(te,e,r,k,D,N,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const T=new Map;function M(m,s){s?T.set(m,s):T.delete(m)}e.setWordDefinitionFor=M;function E(m){return T.get(m)}class f extends N.MirrorTextModel{constructor(s,o,l,v,w,A,p,n){super(o,l,v,w),this.m=s,this.p=A,this.q=p,this.notebook=n,this.b=!1}dispose(){(0,r.ok)(!this.b),this.b=!0,this.q=!1}equalLines(s){return(0,y.equals)(this.d,s)}get document(){if(!this.a){const s=this;this.a={get uri(){return s.c},get fileName(){return s.c.fsPath},get isUntitled(){return s.c.scheme===k.Schemas.untitled},get languageId(){return s.p},get version(){return s.g},get isClosed(){return s.b},get isDirty(){return s.q},save(){return s.r()},getText(o){return o?s.s(o):s.getText()},get eol(){return s.f===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return s.d.length},lineAt(o){return s.t(o)},offsetAt(o){return s.u(o)},positionAt(o){return s.v(o)},validateRange(o){return s.w(o)},validatePosition(o){return s.x(o)},getWordRangeAtPosition(o,l){return s.y(o,l)}}}return Object.freeze(this.a)}_acceptLanguageId(s){(0,r.ok)(!this.b),this.p=s}_acceptIsDirty(s){(0,r.ok)(!this.b),this.q=s}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(s){const o=this.w(s);if(o.isEmpty)return"";if(o.isSingleLine)return this.d[o.start.line].substring(o.start.character,o.end.character);const l=this.f,v=o.start.line,w=o.end.line,A=[];A.push(this.d[v].substring(o.start.character));for(let p=v+1;p<w;p++)A.push(this.d[p]);return A.push(this.d[w].substring(0,o.end.character)),A.join(l)}t(s){let o;if(s instanceof R.Position?o=s.line:typeof s=="number"&&(o=s),typeof o!="number"||o<0||o>=this.d.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new b(o,this.d[o],o===this.d.length-1)}u(s){return s=this.x(s),this.k(),this.h.getPrefixSum(s.line-1)+s.character}v(s){s=Math.floor(s),s=Math.max(0,s),this.k();const o=this.h.getIndexOf(s),l=this.d[o.index].length;return new R.Position(o.index,Math.min(o.remainder,l))}w(s){if(!(s instanceof R.Range))throw new Error("Invalid argument");const o=this.x(s.start),l=this.x(s.end);return o===s.start&&l===s.end?s:new R.Range(o.line,o.character,l.line,l.character)}x(s){if(!(s instanceof R.Position))throw new Error("Invalid argument");if(this.d.length===0)return s.with(0,0);let{line:o,character:l}=s,v=!1;if(o<0)o=0,l=0,v=!0;else if(o>=this.d.length)o=this.d.length-1,l=this.d[o].length,v=!0;else{const w=this.d[o].length;l<0?(l=0,v=!0):l>w&&(l=w,v=!0)}return v?new R.Position(o,l):s}y(s,o){const l=this.x(s);if(!o)o=E(this.p);else if((0,D.regExpLeadsToEndlessLoop)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const v=(0,S.getWordAtText)(l.character+1,(0,S.ensureValidWordDefinition)(o),this.d[l.line],0);if(v)return new R.Range(l.line,v.startColumn-1,l.line,v.endColumn-1)}}e.ExtHostDocumentData=f;class b{constructor(s,o,l){this.a=s,this.b=o,this.c=l}get lineNumber(){return this.a}get text(){return this.b}get range(){return new R.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new R.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=b}),define(Ie[191],Ce([1,0,7,17,4]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let N=class{constructor(R){this.a=new r.ColorTheme(r.ColorThemeKind.Dark),this.b=new D.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(R){let y;switch(R){case"light":y=r.ColorThemeKind.Light;break;case"hcDark":y=r.ColorThemeKind.HighContrast;break;case"hcLight":y=r.ColorThemeKind.HighContrastLight;break;default:y=r.ColorThemeKind.Dark}this.a=new r.ColorTheme(y),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};N=qe([je(0,k.IExtHostRpcService)],N),e.ExtHostTheming=N}),define(Ie[8],Ce([1,0,18,23,115,192,86,28,112,65,64,22,9,2,56,75,91,96,95,70,44,55,188,7]),function(te,e,r,k,D,N,S,R,y,T,M,E,f,b,m,s,o,l,v,w,A,p,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var i;(function(De){function Pe(X){const{selectionStartLineNumber:Re,selectionStartColumn:Be,positionLineNumber:Qe,positionColumn:$e}=X,Ze=new h.Position(Re-1,Be-1),ct=new h.Position(Qe-1,$e-1);return new h.Selection(Ze,ct)}De.to=Pe;function me(X){const{anchor:Re,active:Be}=X;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}De.from=me})(i=e.Selection||(e.Selection={}));var a;(function(De){function Pe(X){if(!X)return;const{start:Re,end:Be}=X;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}De.from=Pe;function me(X){if(!X)return;const{startLineNumber:Re,startColumn:Be,endLineNumber:Qe,endColumn:$e}=X;return new h.Range(Re-1,Be-1,Qe-1,$e-1)}De.to=me})(a=e.Range||(e.Range={}));var t;(function(De){function Pe(me){switch(me){case 1:return h.StandardTokenType.Comment;case 0:return h.StandardTokenType.Other;case 3:return h.StandardTokenType.RegEx;case 2:return h.StandardTokenType.String}}De.to=Pe})(t=e.TokenType||(e.TokenType={}));var g;(function(De){function Pe(X){return new h.Position(X.lineNumber-1,X.column-1)}De.to=Pe;function me(X){return{lineNumber:X.line+1,column:X.character+1}}De.from=me})(g=e.Position||(e.Position={}));var c;(function(De){function Pe(Re,Be){return(0,r.coalesce)((0,r.asArray)(Re).map(Qe=>me(Qe,Be)))}De.from=Pe;function me(Re,Be){if(typeof Re=="string")return{$serialized:!0,language:Re};if(Re)return{$serialized:!0,language:Re.language,scheme:X(Re.scheme,Be),pattern:Q.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType}}function X(Re,Be){return Be&&typeof Re=="string"?Be.transformOutgoingScheme(Re):Re}})(c=e.DocumentSelector||(e.DocumentSelector={}));var u;(function(De){function Pe(X){switch(X){case h.DiagnosticTag.Unnecessary:return 1;case h.DiagnosticTag.Deprecated:return 2}}De.from=Pe;function me(X){switch(X){case 1:return h.DiagnosticTag.Unnecessary;case 2:return h.DiagnosticTag.Deprecated;default:return}}De.to=me})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var d;(function(De){function Pe(X){let Re;return X.code&&((0,f.isString)(X.code)||(0,f.isNumber)(X.code)?Re=String(X.code):Re={value:String(X.code.value),target:X.code.target}),{...a.from(X.range),message:X.message,source:X.source,code:Re,severity:O.from(X.severity),relatedInformation:X.relatedInformation&&X.relatedInformation.map(C.from),tags:Array.isArray(X.tags)?(0,r.coalesce)(X.tags.map(u.from)):void 0}}De.from=Pe;function me(X){const Re=new h.Diagnostic(a.to(X),X.message,O.to(X.severity));return Re.source=X.source,Re.code=(0,f.isString)(X.code)?X.code:X.code?.value,Re.relatedInformation=X.relatedInformation&&X.relatedInformation.map(C.to),Re.tags=X.tags&&(0,r.coalesce)(X.tags.map(u.to)),Re}De.to=me})(d=e.Diagnostic||(e.Diagnostic={}));var C;(function(De){function Pe(X){return{...a.from(X.location.range),message:X.message,resource:X.location.uri}}De.from=Pe;function me(X){return new h.DiagnosticRelatedInformation(new h.Location(X.resource,a.to(X)),X.message)}De.to=me})(C=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var O;(function(De){function Pe(X){switch(X){case h.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case h.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case h.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case h.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}De.from=Pe;function me(X){switch(X){case o.MarkerSeverity.Info:return h.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return h.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return h.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return h.DiagnosticSeverity.Hint;default:return h.DiagnosticSeverity.Error}}De.to=me})(O=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var j;(function(De){function Pe(X){return typeof X=="number"&&X>=h.ViewColumn.One?X-1:X===h.ViewColumn.Beside?n.SIDE_GROUP:n.ACTIVE_GROUP}De.from=Pe;function me(X){if(typeof X=="number"&&X>=0)return X+1;throw new Error("invalid 'EditorGroupColumn'")}De.to=me})(j=e.ViewColumn||(e.ViewColumn={}));function Z(De){return typeof De.range<"u"}function x(De){return De.length===0?!0:!!Z(De[0])}e.isDecorationOptionsArr=x;var L;(function(De){function Pe($e){return $e.map(De.from)}De.fromMany=Pe;function me($e){return $e&&typeof $e=="object"&&typeof $e.language=="string"&&typeof $e.value=="string"}function X($e){let Ze;if(me($e)){const{language:Et,value:It}=$e;Ze={value:"```"+Et+`
`+It+"\n```\n"}}else h.MarkdownString.isMarkdownString($e)?Ze={value:$e.value,isTrusted:$e.isTrusted,supportThemeIcons:$e.supportThemeIcons,supportHtml:$e.supportHtml,baseUri:$e.baseUri}:typeof $e=="string"?Ze={value:$e}:Ze={value:""};const ct=Object.create(null);Ze.uris=ct;const Tt=Et=>{try{let It=b.URI.parse(Et,!0);It=It.with({query:Re(It.query,ct)}),ct[Et]=It}catch{}return""},bt=new y.marked.Renderer;return bt.link=Tt,bt.image=Et=>typeof Et=="string"?Tt(S.parseHrefAndDimensions(Et).href):"",(0,y.marked)(Ze.value,{renderer:bt}),Ze}De.from=X;function Re($e,Ze){if(!$e)return $e;let ct;try{ct=(0,T.parse)($e)}catch{}if(!ct)return $e;let Tt=!1;return ct=(0,E.cloneAndChange)(ct,bt=>{if(b.URI.isUri(bt)){const Et=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[Et]=bt,Tt=!0,Et}else return}),Tt?JSON.stringify(ct):$e}function Be($e){const Ze=new h.MarkdownString($e.value,$e.supportThemeIcons);return Ze.isTrusted=$e.isTrusted,Ze.supportHtml=$e.supportHtml,Ze.baseUri=$e.baseUri?b.URI.from($e.baseUri):void 0,Ze}De.to=Be;function Qe($e){if(!!$e)return typeof $e=="string"?$e:De.from($e)}De.fromStrict=Qe})(L=e.MarkdownString||(e.MarkdownString={}));function $(De){return x(De)?De.map(Pe=>({range:a.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?L.fromMany(Pe.hoverMessage):Pe.hoverMessage?L.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):De.map(Pe=>({range:a.from(Pe)}))}e.fromRangeOrRangeWithMessage=$;function P(De){return typeof De>"u"?De:typeof De=="string"?b.URI.file(De):De}e.pathOrURIToURI=P;var F;(function(De){function Pe(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?P(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}De.from=Pe})(F=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var V;(function(De){function Pe(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?P(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?F.from(me.before):void 0,after:me.after?F.from(me.after):void 0}}De.from=Pe})(V=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var q;(function(De){function Pe(me){if(typeof me>"u")return me;switch(me){case h.DecorationRangeBehavior.OpenOpen:return 0;case h.DecorationRangeBehavior.ClosedClosed:return 1;case h.DecorationRangeBehavior.OpenClosed:return 2;case h.DecorationRangeBehavior.ClosedOpen:return 3}}De.from=Pe})(q=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var le;(function(De){function Pe(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?q.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?V.from(me.light):void 0,dark:me.dark?V.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?P(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?F.from(me.before):void 0,after:me.after?F.from(me.after):void 0}}De.from=Pe})(le=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var _;(function(De){function Pe(X){return{text:X.newText,eol:X.newEol&&it.from(X.newEol),range:a.from(X.range)}}De.from=Pe;function me(X){const Re=new h.TextEdit(a.to(X.range),X.text);return Re.newEol=typeof X.eol>"u"?void 0:it.to(X.eol),Re}De.to=me})(_=e.TextEdit||(e.TextEdit={}));var pe;(function(De){function Pe(X,Re){const Be={edits:[]};if(X instanceof h.WorkspaceEdit){const Qe=new R.ResourceSet;for(const $e of X._allEntries())$e._type===1&&b.URI.isUri($e.to)&&$e.from===void 0&&Qe.add($e.to);for(const $e of X._allEntries())$e._type===1?Be.edits.push({oldResource:$e.from,newResource:$e.to,options:{...$e.options,contentsBase64:$e.options?.contents&&(0,k.encodeBase64)(k.VSBuffer.wrap($e.options.contents))},metadata:$e.metadata}):$e._type===2?Be.edits.push({resource:$e.uri,textEdit:_.from($e.edit),versionId:Qe.has($e.uri)?void 0:Re?.getTextDocumentVersion($e.uri),metadata:$e.metadata}):$e._type===6?Be.edits.push({resource:$e.uri,textEdit:{range:a.from($e.range),text:$e.edit.value,insertAsSnippet:!0},versionId:Qe.has($e.uri)?void 0:Re?.getTextDocumentVersion($e.uri),metadata:$e.metadata}):$e._type===3?Be.edits.push({metadata:$e.metadata,resource:$e.uri,cellEdit:$e.edit,notebookMetadata:$e.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion($e.uri)}):$e._type===5&&Be.edits.push({metadata:$e.metadata,resource:$e.uri,notebookVersionId:Re?.getNotebookDocumentVersion($e.uri),cellEdit:{editType:1,index:$e.index,count:$e.count,cells:$e.cells.map(vt.from)}})}return Be}De.from=Pe;function me(X){const Re=new h.WorkspaceEdit;for(const Be of X.edits)Be.textEdit?Re.replace(b.URI.revive(Be.resource),a.to(Be.textEdit.range),Be.textEdit.text):Re.renameFile(b.URI.revive(Be.oldResource),b.URI.revive(Be.newResource),Be.options);return Re}De.to=me})(pe=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ue;(function(De){const Pe=Object.create(null);Pe[h.SymbolKind.File]=0,Pe[h.SymbolKind.Module]=1,Pe[h.SymbolKind.Namespace]=2,Pe[h.SymbolKind.Package]=3,Pe[h.SymbolKind.Class]=4,Pe[h.SymbolKind.Method]=5,Pe[h.SymbolKind.Property]=6,Pe[h.SymbolKind.Field]=7,Pe[h.SymbolKind.Constructor]=8,Pe[h.SymbolKind.Enum]=9,Pe[h.SymbolKind.Interface]=10,Pe[h.SymbolKind.Function]=11,Pe[h.SymbolKind.Variable]=12,Pe[h.SymbolKind.Constant]=13,Pe[h.SymbolKind.String]=14,Pe[h.SymbolKind.Number]=15,Pe[h.SymbolKind.Boolean]=16,Pe[h.SymbolKind.Array]=17,Pe[h.SymbolKind.Object]=18,Pe[h.SymbolKind.Key]=19,Pe[h.SymbolKind.Null]=20,Pe[h.SymbolKind.EnumMember]=21,Pe[h.SymbolKind.Struct]=22,Pe[h.SymbolKind.Event]=23,Pe[h.SymbolKind.Operator]=24,Pe[h.SymbolKind.TypeParameter]=25;function me(Re){return typeof Pe[Re]=="number"?Pe[Re]:6}De.from=me;function X(Re){for(const Be in Pe)if(Pe[Be]===Re)return Number(Be);return h.SymbolKind.Property}De.to=X})(ue=e.SymbolKind||(e.SymbolKind={}));var de;(function(De){function Pe(X){switch(X){case h.SymbolTag.Deprecated:return 1}}De.from=Pe;function me(X){switch(X){case 1:return h.SymbolTag.Deprecated}}De.to=me})(de=e.SymbolTag||(e.SymbolTag={}));var re;(function(De){function Pe(X){return{name:X.name,kind:ue.from(X.kind),tags:X.tags&&X.tags.map(de.from),containerName:X.containerName,location:Ae.from(X.location)}}De.from=Pe;function me(X){const Re=new h.SymbolInformation(X.name,ue.to(X.kind),X.containerName,Ae.to(X.location));return Re.tags=X.tags&&X.tags.map(de.to),Re}De.to=me})(re=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var G;(function(De){function Pe(X){const Re={name:X.name||"!!MISSING: name!!",detail:X.detail,range:a.from(X.range),selectionRange:a.from(X.selectionRange),kind:ue.from(X.kind),tags:X.tags?.map(de.from)??[]};return X.children&&(Re.children=X.children.map(Pe)),Re}De.from=Pe;function me(X){const Re=new h.DocumentSymbol(X.name,X.detail,ue.to(X.kind),a.to(X.range),a.to(X.selectionRange));return(0,r.isNonEmptyArray)(X.tags)&&(Re.tags=X.tags.map(de.to)),X.children&&(Re.children=X.children.map(me)),Re}De.to=me})(G=e.DocumentSymbol||(e.DocumentSymbol={}));var H;(function(De){function Pe(X){const Re=new h.CallHierarchyItem(ue.to(X.kind),X.name,X.detail||"",b.URI.revive(X.uri),a.to(X.range),a.to(X.selectionRange));return Re._sessionId=X._sessionId,Re._itemId=X._itemId,Re}De.to=Pe;function me(X,Re,Be){if(Re=Re??X._sessionId,Be=Be??X._itemId,Re===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Be,name:X.name,detail:X.detail,kind:ue.from(X.kind),uri:X.uri,range:a.from(X.range),selectionRange:a.from(X.selectionRange),tags:X.tags?.map(de.from)}}De.from=me})(H=e.CallHierarchyItem||(e.CallHierarchyItem={}));var oe;(function(De){function Pe(me){return new h.CallHierarchyIncomingCall(H.to(me.from),me.fromRanges.map(X=>a.to(X)))}De.to=Pe})(oe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ve;(function(De){function Pe(me){return new h.CallHierarchyOutgoingCall(H.to(me.to),me.fromRanges.map(X=>a.to(X)))}De.to=Pe})(ve=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Ae;(function(De){function Pe(X){return{range:X.range&&a.from(X.range),uri:X.uri}}De.from=Pe;function me(X){return new h.Location(b.URI.revive(X.uri),a.to(X.range))}De.to=me})(Ae=e.location||(e.location={}));var Ue;(function(De){function Pe(X){const Re=X,Be=X;return{originSelectionRange:Re.originSelectionRange?a.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Be.uri,range:a.from(Re.targetRange?Re.targetRange:Be.range),targetSelectionRange:Re.targetSelectionRange?a.from(Re.targetSelectionRange):void 0}}De.from=Pe;function me(X){return{targetUri:b.URI.revive(X.uri),targetRange:a.to(X.range),targetSelectionRange:X.targetSelectionRange?a.to(X.targetSelectionRange):void 0,originSelectionRange:X.originSelectionRange?a.to(X.originSelectionRange):void 0}}De.to=me})(Ue=e.DefinitionLink||(e.DefinitionLink={}));var xe;(function(De){function Pe(X){return{range:a.from(X.range),contents:L.fromMany(X.contents)}}De.from=Pe;function me(X){return new h.Hover(X.contents.map(L.to),a.to(X.range))}De.to=me})(xe=e.Hover||(e.Hover={}));var Te;(function(De){function Pe(X){return{range:a.from(X.range),expression:X.expression}}De.from=Pe;function me(X){return new h.EvaluatableExpression(a.to(X.range),X.expression)}De.to=me})(Te=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Se;(function(De){function Pe(X){if(X instanceof h.InlineValueText)return{type:"text",range:a.from(X.range),text:X.text};if(X instanceof h.InlineValueVariableLookup)return{type:"variable",range:a.from(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};if(X instanceof h.InlineValueEvaluatableExpression)return{type:"expression",range:a.from(X.range),expression:X.expression};throw new Error("Unknown 'InlineValue' type")}De.from=Pe;function me(X){switch(X.type){case"text":return{range:a.to(X.range),text:X.text};case"variable":return{range:a.to(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};case"expression":return{range:a.to(X.range),expression:X.expression}}}De.to=me})(Se=e.InlineValue||(e.InlineValue={}));var ke;(function(De){function Pe(X){return{frameId:X.frameId,stoppedLocation:a.from(X.stoppedLocation)}}De.from=Pe;function me(X){return new h.InlineValueContext(X.frameId,a.to(X.stoppedLocation))}De.to=me})(ke=e.InlineValueContext||(e.InlineValueContext={}));var se;(function(De){function Pe(X){return{range:a.from(X.range),kind:X.kind}}De.from=Pe;function me(X){return new h.DocumentHighlight(a.to(X.range),X.kind)}De.to=me})(se=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(De){function Pe(me){switch(me){case 1:return h.CompletionTriggerKind.TriggerCharacter;case 2:return h.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return h.CompletionTriggerKind.Invoke}}De.to=Pe})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var J;(function(De){function Pe(me){return{triggerKind:ce.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}De.to=Pe})(J=e.CompletionContext||(e.CompletionContext={}));var I;(function(De){function Pe(X){switch(X){case h.CompletionItemTag.Deprecated:return 1}}De.from=Pe;function me(X){switch(X){case 1:return h.CompletionItemTag.Deprecated}}De.to=me})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var B;(function(De){const Pe=new Map([[h.CompletionItemKind.Method,0],[h.CompletionItemKind.Function,1],[h.CompletionItemKind.Constructor,2],[h.CompletionItemKind.Field,3],[h.CompletionItemKind.Variable,4],[h.CompletionItemKind.Class,5],[h.CompletionItemKind.Interface,7],[h.CompletionItemKind.Struct,6],[h.CompletionItemKind.Module,8],[h.CompletionItemKind.Property,9],[h.CompletionItemKind.Unit,12],[h.CompletionItemKind.Value,13],[h.CompletionItemKind.Constant,14],[h.CompletionItemKind.Enum,15],[h.CompletionItemKind.EnumMember,16],[h.CompletionItemKind.Keyword,17],[h.CompletionItemKind.Snippet,27],[h.CompletionItemKind.Text,18],[h.CompletionItemKind.Color,19],[h.CompletionItemKind.File,20],[h.CompletionItemKind.Reference,21],[h.CompletionItemKind.Folder,23],[h.CompletionItemKind.Event,10],[h.CompletionItemKind.Operator,11],[h.CompletionItemKind.TypeParameter,24],[h.CompletionItemKind.Issue,26],[h.CompletionItemKind.User,25]]);function me(Be){return Pe.get(Be)??9}De.from=me;const X=new Map([[0,h.CompletionItemKind.Method],[1,h.CompletionItemKind.Function],[2,h.CompletionItemKind.Constructor],[3,h.CompletionItemKind.Field],[4,h.CompletionItemKind.Variable],[5,h.CompletionItemKind.Class],[7,h.CompletionItemKind.Interface],[6,h.CompletionItemKind.Struct],[8,h.CompletionItemKind.Module],[9,h.CompletionItemKind.Property],[12,h.CompletionItemKind.Unit],[13,h.CompletionItemKind.Value],[14,h.CompletionItemKind.Constant],[15,h.CompletionItemKind.Enum],[16,h.CompletionItemKind.EnumMember],[17,h.CompletionItemKind.Keyword],[27,h.CompletionItemKind.Snippet],[18,h.CompletionItemKind.Text],[19,h.CompletionItemKind.Color],[20,h.CompletionItemKind.File],[21,h.CompletionItemKind.Reference],[23,h.CompletionItemKind.Folder],[10,h.CompletionItemKind.Event],[11,h.CompletionItemKind.Operator],[24,h.CompletionItemKind.TypeParameter],[25,h.CompletionItemKind.User],[26,h.CompletionItemKind.Issue]]);function Re(Be){return X.get(Be)??h.CompletionItemKind.Property}De.to=Re})(B=e.CompletionItemKind||(e.CompletionItemKind={}));var W;(function(De){function Pe(me,X){const Re=new h.CompletionItem(me.label);return Re.insertText=me.insertText,Re.kind=B.to(me.kind),Re.tags=me.tags?.map(I.to),Re.detail=me.detail,Re.documentation=S.isMarkdownString(me.documentation)?L.to(me.documentation):me.documentation,Re.sortText=me.sortText,Re.filterText=me.filterText,Re.preselect=me.preselect,Re.commitCharacters=me.commitCharacters,m.Range.isIRange(me.range)?Re.range=a.to(me.range):typeof me.range=="object"&&(Re.range={inserting:a.to(me.range.insert),replacing:a.to(me.range.replace)}),Re.keepWhitespace=typeof me.insertTextRules>"u"?!1:Boolean(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Re.insertText=new h.SnippetString(me.insertText):(Re.insertText=me.insertText,Re.textEdit=Re.range instanceof h.Range?new h.TextEdit(Re.range,Re.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Re.additionalTextEdits=me.additionalTextEdits.map(Be=>_.to(Be))),Re.command=X&&me.command?X.fromInternal(me.command):void 0,Re}De.to=Pe})(W=e.CompletionItem||(e.CompletionItem={}));var K;(function(De){function Pe(X){if(typeof X.label!="string"&&!Array.isArray(X.label))throw new TypeError("Invalid label");return{label:X.label,documentation:L.fromStrict(X.documentation)}}De.from=Pe;function me(X){return{label:X.label,documentation:S.isMarkdownString(X.documentation)?L.to(X.documentation):X.documentation}}De.to=me})(K=e.ParameterInformation||(e.ParameterInformation={}));var ee;(function(De){function Pe(X){return{label:X.label,documentation:L.fromStrict(X.documentation),parameters:Array.isArray(X.parameters)?X.parameters.map(K.from):[],activeParameter:X.activeParameter}}De.from=Pe;function me(X){return{label:X.label,documentation:S.isMarkdownString(X.documentation)?L.to(X.documentation):X.documentation,parameters:Array.isArray(X.parameters)?X.parameters.map(K.to):[],activeParameter:X.activeParameter}}De.to=me})(ee=e.SignatureInformation||(e.SignatureInformation={}));var he;(function(De){function Pe(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(ee.from):[]}}De.from=Pe;function me(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(ee.to):[]}}De.to=me})(he=e.SignatureHelp||(e.SignatureHelp={}));var ye;(function(De){function Pe(me,X){const Re=new h.InlayHint(g.to(X.position),typeof X.label=="string"?X.label:X.label.map(ae.to.bind(void 0,me)),X.kind&&be.to(X.kind));return Re.textEdits=X.textEdits&&X.textEdits.map(_.to),Re.tooltip=S.isMarkdownString(X.tooltip)?L.to(X.tooltip):X.tooltip,Re.paddingLeft=X.paddingLeft,Re.paddingRight=X.paddingRight,Re}De.to=Pe})(ye=e.InlayHint||(e.InlayHint={}));var ae;(function(De){function Pe(me,X){const Re=new h.InlayHintLabelPart(X.label);return Re.tooltip=S.isMarkdownString(X.tooltip)?L.to(X.tooltip):X.tooltip,s.Command.is(X.command)&&(Re.command=me.fromInternal(X.command)),X.location&&(Re.location=Ae.to(X.location)),Re}De.to=Pe})(ae=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var be;(function(De){function Pe(X){return X}De.from=Pe;function me(X){return X}De.to=me})(be=e.InlayHintKind||(e.InlayHintKind={}));var Ee;(function(De){function Pe(X){return{range:a.from(X.range),url:X.target,tooltip:X.tooltip}}De.from=Pe;function me(X){let Re;if(X.url)try{Re=typeof X.url=="string"?b.URI.parse(X.url,!0):b.URI.revive(X.url)}catch{}return new h.DocumentLink(a.to(X.range),Re)}De.to=me})(Ee=e.DocumentLink||(e.DocumentLink={}));var We;(function(De){function Pe(X){const Re=new h.ColorPresentation(X.label);return X.textEdit&&(Re.textEdit=_.to(X.textEdit)),X.additionalTextEdits&&(Re.additionalTextEdits=X.additionalTextEdits.map(Be=>_.to(Be))),Re}De.to=Pe;function me(X){return{label:X.label,textEdit:X.textEdit?_.from(X.textEdit):void 0,additionalTextEdits:X.additionalTextEdits?X.additionalTextEdits.map(Re=>_.from(Re)):void 0}}De.from=me})(We=e.ColorPresentation||(e.ColorPresentation={}));var Ve;(function(De){function Pe(X){return new h.Color(X[0],X[1],X[2],X[3])}De.to=Pe;function me(X){return[X.red,X.green,X.blue,X.alpha]}De.from=me})(Ve=e.Color||(e.Color={}));var tt;(function(De){function Pe(X){return{range:a.from(X.range)}}De.from=Pe;function me(X){return new h.SelectionRange(a.to(X.range))}De.to=me})(tt=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(De){function Pe(me){switch(me){case 2:return h.TextDocumentSaveReason.AfterDelay;case 1:return h.TextDocumentSaveReason.Manual;case 3:case 4:return h.TextDocumentSaveReason.FocusOut}}De.to=Pe})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(De){function Pe(X){switch(X){case h.TextEditorLineNumbersStyle.Off:return 0;case h.TextEditorLineNumbersStyle.Relative:return 2;case h.TextEditorLineNumbersStyle.On:default:return 1}}De.from=Pe;function me(X){switch(X){case 0:return h.TextEditorLineNumbersStyle.Off;case 2:return h.TextEditorLineNumbersStyle.Relative;case 1:default:return h.TextEditorLineNumbersStyle.On}}De.to=me})(et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var it;(function(De){function Pe(X){if(X===h.EndOfLine.CRLF)return 1;if(X===h.EndOfLine.LF)return 0}De.from=Pe;function me(X){if(X===1)return h.EndOfLine.CRLF;if(X===0)return h.EndOfLine.LF}De.to=me})(it=e.EndOfLine||(e.EndOfLine={}));var dt;(function(De){function Pe(me){if(typeof me=="object")return me.viewId;switch(me){case h.ProgressLocation.SourceControl:return 3;case h.ProgressLocation.Window:return 10;case h.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}De.from=Pe})(dt=e.ProgressLocation||(e.ProgressLocation={}));var Fe;(function(De){function Pe(me){const X={start:me.start+1,end:me.end+1};return me.kind&&(X.kind=ot.from(me.kind)),X}De.from=Pe})(Fe=e.FoldingRange||(e.FoldingRange={}));var ot;(function(De){function Pe(me){if(me)switch(me){case h.FoldingRangeKind.Comment:return s.FoldingRangeKind.Comment;case h.FoldingRangeKind.Imports:return s.FoldingRangeKind.Imports;case h.FoldingRangeKind.Region:return s.FoldingRangeKind.Region}}De.from=Pe})(ot=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Y;(function(De){function Pe(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?a.from(me.selection):void 0,override:typeof me.override=="boolean"?v.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}De.from=Pe})(Y=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Q;(function(De){function Pe(Be){return Be instanceof h.RelativePattern?Be.toJSON():typeof Be=="string"?Be:me(Be)||X(Be)?new h.RelativePattern(Be.baseUri??Be.base,Be.pattern).toJSON():Be}De.from=Pe;function me(Be){const Qe=Be;return Qe?b.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function X(Be){const Qe=Be;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Re(Be){return typeof Be=="string"?Be:new h.RelativePattern(b.URI.revive(Be.baseUri),Be.pattern)}De.to=Re})(Q=e.GlobPattern||(e.GlobPattern={}));var ge;(function(De){function Pe(me){if(me){if(Array.isArray(me))return me.map(Pe);if(typeof me=="string")return me;{const X=me;return{language:X.language,scheme:X.scheme,pattern:Q.from(X.pattern),exclusive:X.exclusive,notebookType:X.notebookType}}}else return}De.from=Pe})(ge=e.LanguageSelector||(e.LanguageSelector={}));var Me;(function(De){function Pe(X){return{start:X.start,end:X.end}}De.from=Pe;function me(X){return new h.NotebookRange(X.start,X.end)}De.to=me})(Me=e.NotebookRange||(e.NotebookRange={}));var ze;(function(De){function Pe(X){return{timing:typeof X.runStartTime=="number"&&typeof X.runEndTime=="number"?{startTime:X.runStartTime,endTime:X.runEndTime}:void 0,executionOrder:X.executionOrder,success:X.lastRunSuccess}}De.to=Pe;function me(X){return{lastRunSuccess:X.success,runStartTime:X.timing?.startTime,runEndTime:X.timing?.endTime,executionOrder:X.executionOrder}}De.from=me})(ze=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var He;(function(De){function Pe(me){if(me===w.NotebookCellExecutionState.Unconfirmed)return h.NotebookCellExecutionState.Pending;if(me===w.NotebookCellExecutionState.Pending)return;if(me===w.NotebookCellExecutionState.Executing)return h.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}De.to=Pe})(He=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ye;(function(De){function Pe(X){switch(X){case h.NotebookCellKind.Markup:return w.CellKind.Markup;case h.NotebookCellKind.Code:default:return w.CellKind.Code}}De.from=Pe;function me(X){switch(X){case w.CellKind.Markup:return h.NotebookCellKind.Markup;case w.CellKind.Code:default:return h.NotebookCellKind.Code}}De.to=me})(Ye=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(De){function Pe(X){const Re={metadata:X.metadata??Object.create(null),cells:[]};for(const Be of X.cells)h.NotebookCellData.validate(Be),Re.cells.push(vt.from(Be));return Re}De.from=Pe;function me(X){const Re=new h.NotebookData(X.cells.map(vt.to));return(0,f.isEmptyObject)(X.metadata)||(Re.metadata=X.metadata),Re}De.to=me})(nt=e.NotebookData||(e.NotebookData={}));var vt;(function(De){function Pe(X){return{cellKind:Ye.from(X.kind),language:X.languageId,mime:X.mime,source:X.value,metadata:X.metadata,internalMetadata:ze.from(X.executionSummary??{}),outputs:X.outputs?X.outputs.map(Ct.from):[]}}De.from=Pe;function me(X){return new h.NotebookCellData(Ye.to(X.cellKind),X.source,X.language,X.mime,X.outputs?X.outputs.map(Ct.to):void 0,X.metadata,X.internalMetadata?ze.to(X.internalMetadata):void 0)}De.to=me})(vt=e.NotebookCellData||(e.NotebookCellData={}));var wt;(function(De){function Pe(X){return{mime:X.mime,valueBytes:k.VSBuffer.wrap(X.data)}}De.from=Pe;function me(X){return new h.NotebookCellOutputItem(X.valueBytes.buffer,X.mime)}De.to=me})(wt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ct;(function(De){function Pe(X){return{outputId:X.id,items:X.items.map(wt.from),metadata:X.metadata}}De.from=Pe;function me(X){const Re=X.items.map(wt.to);return new h.NotebookCellOutput(Re,X.outputId,X.metadata)}De.to=me})(Ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var jt;(function(De){function Pe(Re){return X(Re)?{include:(0,f.withNullAsUndefined)(Q.from(Re.include)),exclude:(0,f.withNullAsUndefined)(Q.from(Re.exclude))}:(0,f.withNullAsUndefined)(Q.from(Re))}De.from=Pe;function me(Re){return X(Re)?{include:Q.to(Re.include),exclude:Q.to(Re.exclude)}:Q.to(Re)}De.to=me;function X(Re){const Be=Re;return Be?!(0,f.isUndefinedOrNull)(Be.include)&&!(0,f.isUndefinedOrNull)(Be.exclude):!1}})(jt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var rt;(function(De){function Pe(me,X,Re){const Be=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===h.NotebookCellStatusBarAlignment.Left?1:2,command:X.toInternal(Be,Re),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}De.from=Pe})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var mt;(function(De){function Pe(me,X,Re){const Be=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{command:X.toInternal(Be,Re),label:me.label,description:me.description,detail:me.detail}}De.from=Pe})(mt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Ft;(function(De){function Pe(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{},cellContentMetadata:me?.cellContentMetadata??{}}}De.from=Pe})(Ft=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var xt;(function(De){function Pe(X){return{uri:X.uri,provides:X.provides}}De.from=Pe;function me(X){return new h.NotebookRendererScript(b.URI.revive(X.uri),X.provides)}De.to=me})(xt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Pt;(function(De){function Pe(X){return{message:L.fromStrict(X.message)||"",type:0,expected:X.expectedOutput,actual:X.actualOutput,location:X.location&&{range:a.from(X.location.range),uri:X.location.uri}}}De.from=Pe;function me(X){const Re=new h.TestMessage(typeof X.message=="string"?X.message:L.to(X.message));return Re.actualOutput=X.actual,Re.expectedOutput=X.expected,Re.location=X.location?Ae.to(X.location):void 0,Re}De.to=me})(Pt=e.TestMessage||(e.TestMessage={}));var ht;(function(De){De.namespace=p.namespaceTestTag,De.denamespace=p.denamespaceTestTag})(ht=e.TestTag||(e.TestTag={}));var kt;(function(De){function Pe(X){const Re=(0,l.getPrivateApiFor)(X).controllerId;return{extId:A.TestId.fromExtHostTestItem(X,Re).toString(),label:X.label,uri:b.URI.revive(X.uri),busy:X.busy,tags:X.tags.map(Be=>ht.namespace(Re,Be.id)),range:m.Range.lift(a.from(X.range)),description:X.description||null,sortText:X.sortText||null,error:X.error&&L.fromStrict(X.error)||null}}De.from=Pe;function me(X){return{parent:void 0,error:void 0,id:A.TestId.fromString(X.extId).localId,label:X.label,uri:b.URI.revive(X.uri),tags:(X.tags||[]).map(Re=>{const{tagId:Be}=ht.denamespace(Re);return new h.TestTag(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:a.to(X.range||void 0),canResolveChildren:!1,busy:X.busy,description:X.description||void 0,sortText:X.sortText||void 0}}De.toPlain=me})(kt=e.TestItem||(e.TestItem={})),function(De){function Pe(X){return{id:X.id}}De.from=Pe;function me(X){return new h.TestTag(X.id)}De.to=me}(ht=e.TestTag||(e.TestTag={}));var Bt;(function(De){const Pe=(X,Re)=>{const Be=[];for(const[$e,Ze]of Re)A.TestId.compare(Ze.item.extId,$e)===2&&(Re.delete($e),Be.push(Ze));const Qe={...kt.toPlain(X.item),parent:void 0,taskStates:X.tasks.map($e=>({state:$e.state,duration:$e.duration,messages:$e.messages.filter(Ze=>Ze.type===0).map(Pt.to)})),children:Be.map($e=>Pe($e,Re))};for(const $e of Qe.children)$e.parent=Qe;return Qe};function me(X){const Re=[],Be=new Map;for(const Qe of X.items){Be.set(Qe.item.extId,Qe);const $e=A.TestId.root(Qe.item.extId);X.request.targets.some(Ze=>Ze.controllerId===$e&&Ze.testIds.includes(Qe.item.extId))&&Re.push(Qe)}return{completedAt:X.completedAt,results:Re.map(Qe=>Pe(Qe,Be))}}De.to=me})(Bt=e.TestResults||(e.TestResults={}));var Ot;(function(De){function Pe(Be){return{covered:Be.covered,total:Be.covered}}function me(Be){return"line"in Be?g.from(Be):a.from(Be)}function X(Be){return"branches"in Be?{count:Be.executionCount,location:me(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&me(Qe.location)})):void 0}:{type:0,count:Be.executionCount,location:me(Be.location)}}De.fromDetailed=X;function Re(Be){return{uri:Be.uri,statement:Pe(Be.statementCoverage),branch:Be.branchCoverage&&Pe(Be.branchCoverage),function:Be.functionCoverage&&Pe(Be.functionCoverage),details:Be.detailedCoverage?.map(X)}}De.fromFile=Re})(Ot=e.TestCoverage||(e.TestCoverage={}));var Ge;(function(De){function Pe(me){switch(me){case 1:return h.CodeActionTriggerKind.Invoke;case 2:return h.CodeActionTriggerKind.Automatic}}De.to=Pe})(Ge=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Mt;(function(De){function Pe(X){const Re=new h.TypeHierarchyItem(ue.to(X.kind),X.name,X.detail||"",b.URI.revive(X.uri),a.to(X.range),a.to(X.selectionRange));return Re._sessionId=X._sessionId,Re._itemId=X._itemId,Re}De.to=Pe;function me(X,Re,Be){if(Re=Re??X._sessionId,Be=Be??X._itemId,Re===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Be,kind:ue.from(X.kind),name:X.name,detail:X.detail??"",uri:X.uri,range:a.from(X.range),selectionRange:a.from(X.selectionRange),tags:X.tags?.map(de.from)}}De.from=me})(Mt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Nt;(function(De){function Pe(me){if(!!me)return{value:me.value,tooltip:me.tooltip}}De.from=Pe})(Nt=e.ViewBadge||(e.ViewBadge={}));var zt;(function(De){function Pe(Be,Qe,$e){const Ze=Qe.fileData;return Ze?new class extends h.DataTransferItem{asFile(){return{name:Ze.name,uri:b.URI.revive(Ze.uri),data:(0,N.once)(()=>$e())}}}("",Qe.id):Be===M.Mimes.uriList&&Qe.uriListData?new h.DataTransferItem(Re(Qe.uriListData)):new h.DataTransferItem(Qe.asString)}De.to=Pe;async function me(Be,Qe){const $e=await Qe.asString();if(Be===M.Mimes.uriList)return{id:Qe.id,asString:"",fileData:void 0,uriListData:X($e)};const Ze=Qe.asFile();return{id:Qe.id,asString:$e,fileData:Ze?{name:Ze.name,uri:Ze.uri}:void 0}}De.from=me;function X(Be){return D.UriList.split(Be).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return b.URI.parse(Qe)}catch{}return Qe})}function Re(Be){return D.UriList.create(Be.map(Qe=>typeof Qe=="string"?Qe:b.URI.revive(Qe)))}})(zt=e.DataTransferItem||(e.DataTransferItem={}));var ft;(function(De){function Pe(X,Re){const Be=X.items.map(([Qe,$e])=>[Qe,zt.to(Qe,$e,()=>Re($e.id))]);return new h.DataTransfer(Be)}De.toDataTransfer=Pe;async function me(X){const Re={items:[]},Be=[];return X.forEach((Qe,$e)=>{Be.push((async()=>{Re.items.push([$e,await zt.from($e,Qe)])})())}),await Promise.all(Be),Re}De.toDataTransferDTO=me})(ft=e.DataTransfer||(e.DataTransfer={}))}),define(Ie[193],Ce([1,0,2,12,7,8,159]),function(te,e,r,k,D,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class R{constructor(T,M,E,f={timeout:1500,errors:3}){this.c=T,this.d=M,this.f=E,this.g=f,this.a=new S.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(T){return(M,E,f)=>{const m={dispose:this.a.push([M,E,T])};return Array.isArray(f)&&f.push(m),m}}async $participateInSave(T,M){const E=r.URI.revive(T);let f=!1;const b=setTimeout(()=>f=!0,this.g.timeout),m=[];try{for(const s of[...this.a]){if(f)break;const o=this.d.getDocument(E),l=await this.h(s,{document:o,reason:N.TextDocumentSaveReason.to(M)});m.push(l)}}finally{clearTimeout(b)}return m}h([T,M,E],f){const b=this.b.get(T);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(E,T,M,f).then(()=>!0,m=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' threw ERROR`),this.c.error(m),!(m instanceof Error)||m.message!=="concurrent_edits"){const s=this.b.get(T);this.b.set(T,s?s+1:1),typeof s=="number"&&s>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(T,M,E,f){const b=[],m=Date.now(),{document:s,reason:o}=f,{version:l}=s,v=Object.freeze({document:s,reason:o,waitUntil(w){if(Object.isFrozen(b))throw(0,k.illegalState)("waitUntil can not be called async");b.push(Promise.resolve(w))}});try{M.apply(E,[v])}catch(w){return Promise.reject(w)}return Object.freeze(b),new Promise((w,A)=>{const p=setTimeout(()=>A(new Error("timeout")),this.g.timeout);return Promise.all(b).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-m}ms`),clearTimeout(p),w(n)}).catch(n=>{clearTimeout(p),A(n)})}).then(w=>{const A={edits:[]};for(const p of w)if(Array.isArray(p)&&p.every(n=>n instanceof D.TextEdit))for(const{newText:n,newEol:h,range:i}of p)A.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:i&&N.Range.from(i),text:n,eol:h&&N.EndOfLine.from(h)}});if(A.edits.length!==0)return l===s.version?this.f.$tryApplyWorkspaceEdit(A):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=R}),define(Ie[194],Ce([1,0,15,2,8,7,70]),function(te,e,r,k,D,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class R{constructor(E,f,b,m){this.start=E,this.deletedCount=f,this.deletedItems=b,this.items=m}asApiEvent(){return{range:new N.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(E=>E.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(E,f){return{EOL:f.eol,lines:f.source,languageId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:E}}constructor(E,f,b){this.notebook=E,this.h=f,this.j=b,this.handle=b.handle,this.uri=k.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(D.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(D.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const E=this,f=this.h.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return E.notebook.getCellIndex(E)},notebook:E.notebook.apiNotebook,kind:D.NotebookCellKind.to(this.j.cellKind),document:f.document,get mime(){return E.g},set mime(m){E.g=m},get outputs(){return E.a.slice(0)},get metadata(){return E.b},get executionSummary(){return E.d}};this.f=Object.freeze(b)}return this.f}setOutputs(E){this.a=E.map(D.NotebookCellOutput.to)}setOutputItems(E,f,b){const m=b.map(D.NotebookCellOutputItem.to),s=this.a.find(o=>o.id===E);if(s&&(f||(s.items.length=0),s.items.push(...m),s.items.length>1&&s.items.every(o=>S.isTextStreamMime(o.mime)))){const o=new Map,l=[];s.items.forEach(v=>{let w;o.has(v.mime)?w=o.get(v.mime):(w=[],o.set(v.mime,w),l.push(v.mime)),w.push(v.data)}),s.items.length=0,l.forEach(v=>{const w=S.compressOutputItemStreams(o.get(v));s.items.push({mime:v,data:w.buffer})})}}setMetadata(E){this.b=Object.freeze(E)}setInternalMetadata(E){this.e=E,this.d=Object.freeze(D.NotebookCellExecutionSummary.to(E))}setMime(E){}}e.ExtHostCell=y;class T{constructor(E,f,b,m,s){this.k=E,this.l=f,this.m=b,this.uri=m,this.handle=T.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=s.viewType,this.f=Object.freeze(s.metadata??Object.create(null)),this.r([[0,0,s.cells]],!0,void 0),this.g=s.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const E=this,f={get uri(){return E.uri},get version(){return E.g},get notebookType(){return E.d},get isDirty(){return E.h},get isUntitled(){return E.uri.scheme===r.Schemas.untitled},get isClosed(){return E.j},get metadata(){return E.f},get cellCount(){return E.b.length},cellAt(b){return b=E.n(b),E.b[b].apiCell},getCells(b){return(b?E.p(b):E.b).map(s=>s.apiCell)},save(){return E.q()}};this.e=Object.freeze(f)}return this.e}acceptDocumentPropertiesChanged(E){E.metadata&&(this.f=Object.freeze({...this.f,...E.metadata}))}acceptDirty(E){this.h=E}acceptModelChanged(E,f,b){this.g=E.versionId,this.h=f,this.acceptDocumentPropertiesChanged({metadata:b});const m={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},s=[];for(const l of E.rawEvents)l.kind===S.NotebookCellsChangeType.ModelChange?this.r(l.changes,!1,m.contentChanges):l.kind===S.NotebookCellsChangeType.Move?this.s(l.index,l.length,l.newIdx,m.contentChanges):l.kind===S.NotebookCellsChangeType.Output?(this.t(l.index,l.outputs),s.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===S.NotebookCellsChangeType.OutputItem?(this.u(l.index,l.outputId,l.append,l.outputItems),s.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===S.NotebookCellsChangeType.ChangeCellLanguage?(this.v(l.index,l.language),s.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document})):l.kind===S.NotebookCellsChangeType.ChangeCellContent?s.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document}):l.kind===S.NotebookCellsChangeType.ChangeCellMime?this.w(l.index,l.mime):l.kind===S.NotebookCellsChangeType.ChangeCellMetadata?(this.x(l.index,l.metadata),s.push({cell:this.b[l.index].apiCell,metadata:this.b[l.index].apiCell.metadata})):l.kind===S.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(l.index,l.internalMetadata),s.push({cell:this.b[l.index].apiCell,executionSummary:this.b[l.index].apiCell.executionSummary}));const o=new Map;for(let l=0;l<s.length;l++){const v=s[l],w=o.get(v.cell);if(w===void 0){const A=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...v});o.set(v.cell,A-1)}else m.cellChanges[w]={...m.cellChanges[w],...v}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}n(E){return E=E|0,E<0?0:E>=this.b.length?this.b.length-1:E}o(E){let f=E.start|0,b=E.end|0;return f<0&&(f=0),b>this.b.length&&(b=this.b.length),E.with({start:f,end:b})}p(E){E=this.o(E);const f=[];for(let b=E.start;b<E.end;b++)f.push(this.b[b]);return f}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(E,f,b){if(this.j)return;const m=[],s=[],o=[];if(E.reverse().forEach(l=>{const w=l[2].map(n=>{const h=new y(this,this.l,n);return f||s.push(y.asModelAddData(this.apiNotebook,n)),h}),A=new R(l[0],l[1],[],w),p=this.b.splice(l[0],l[1],...w);for(const n of p)o.push(n.uri),A.deletedItems.push(n.apiCell);m.push(A)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:o}),b)for(const l of m)b.push(l.asApiEvent())}s(E,f,b,m){const s=this.b.splice(E,f);this.b.splice(b,0,...s);const o=[new R(E,f,s.map(l=>l.apiCell),[]),new R(b,0,[],s)];for(const l of o)m.push(l.asApiEvent())}t(E,f){this.b[E].setOutputs(f)}u(E,f,b,m){this.b[E].setOutputItems(f,b,m)}v(E,f){const b=this.b[E];b.apiCell.document.languageId!==f&&this.m.$acceptModelLanguageChanged(b.uri,f)}w(E,f){const b=this.b[E];b.apiCell.mime=f}x(E,f){this.b[E].setMetadata(f)}y(E,f){this.b[E].setInternalMetadata(f)}getCellFromApiCell(E){return this.b.find(f=>f.apiCell===E)}getCellFromIndex(E){return this.b[E]}getCell(E){return this.b.find(f=>f.handle===E)}getCellIndex(E){return this.b.indexOf(E)}}e.ExtHostNotebookDocument=T,T.a=0}),define(Ie[100],Ce([1,0,12,8,7]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class N{constructor(R,y,T,M,E,f){this.id=R,this.f=y,this.notebookData=T,this.a=[],this.b=[],this.d=!1,this.a=E,this.b=M,this.c=f}get apiEditor(){if(!this.e){const R=this;this.e={get notebook(){return R.notebookData.apiNotebook},get selection(){return R.a[0]},set selection(y){this.selections=[y]},get selections(){return R.a},set selections(y){if(!Array.isArray(y)||!y.every(D.NotebookRange.isNotebookRange))throw(0,r.illegalArgument)("selections");R.a=y,R.g(y)},get visibleRanges(){return R.b},revealRange(y,T){R.f.$tryRevealRange(R.id,k.NotebookRange.from(y),T??D.NotebookEditorRevealType.Default)},get viewColumn(){return R.c}},N.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(R){this.d=R}_acceptVisibleRanges(R){this.b=R}_acceptSelections(R){this.a=R}g(R){this.f.$trySetSelections(this.id,R.map(k.NotebookRange.from))}_acceptViewColumn(R){this.c=R}}e.ExtHostNotebookEditor=N,N.apiEditorsToExtHost=new WeakMap}),define(Ie[195],Ce([1,0,4,11,8]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let N=class{constructor(R,y){this.c=R,this.d=y,this.a=new r.Emitter,this.b=new r.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(R,y){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",R,y);const T=this.d.getEditorById(R);y.visibleRanges&&T._acceptVisibleRanges(y.visibleRanges.ranges.map(D.NotebookRange.to)),y.selections&&T._acceptSelections(y.selections.selections.map(D.NotebookRange.to)),y.visibleRanges&&this.b.fire({notebookEditor:T.apiEditor,visibleRanges:T.apiEditor.visibleRanges}),y.selections&&this.a.fire(Object.freeze({notebookEditor:T.apiEditor,selections:T.apiEditor.selections}))}$acceptEditorViewColumns(R){for(const y in R)this.d.getEditorById(y)._acceptViewColumn(D.ViewColumn.to(R[y]))}};N=qe([je(0,k.ILogService)],N),e.ExtHostNotebookEditors=N}),define(Ie[196],Ce([1,0,8,163,140,21,63,12]),function(te,e,r,k,D,N,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(f){this.b=0,this.c=new Map,this.a=f}async withProgress(f,b,m){const s=this.b++,{title:o,location:l,cancellable:v}=b,w={label:(0,D.localize)(0,null,f.displayName||f.name),id:f.identifier.value};return this.a.$startProgress(s,{location:r.ProgressLocation.from(l),title:o,source:w,cancellable:v},f.isUnderDevelopment?void 0:f.identifier.value).catch(R.onUnexpectedExternalError),this.d(s,m,!!v)}d(f,b,m){let s;m&&(s=new N.CancellationTokenSource,this.c.set(f,s));const o=v=>{this.a.$progressEnd(v),this.c.delete(v),s?.dispose()};let l;try{l=b(new M(this.a,f),m&&s?s.token:N.CancellationToken.None)}catch(v){throw o(f),v}return l.then(v=>o(f),v=>o(f)),l}$acceptProgressCanceled(f){const b=this.c.get(f);b&&(b.cancel(),this.c.delete(f))}}e.ExtHostProgress=y;function T(E,f){return E.message=f.message,typeof f.increment=="number"&&(typeof E.increment=="number"?E.increment+=f.increment:E.increment=f.increment),E}class M extends k.Progress{constructor(f,b){super(m=>this.throttledReport(m)),this.c=f,this.d=b}throttledReport(f){this.c.$progressReport(this.d,f)}}qe([(0,S.throttle)(100,(E,f)=>T(E,f),()=>Object.create(null))],M.prototype,"throttledReport",null)}),define(Ie[101],Ce([1,0,56,96,44,71,55,8,2]),function(te,e,r,k,D,N,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const T=(w,A,p,n)=>{let h=A;return{enumerable:!0,configurable:!1,get(){return h},set(i){if(!p(h,i)){const a=h;h=i,w.listener?.(n(i,a))}}}},M=(w,A)=>w===A,E={range:(w,A)=>w===A?!0:!w||!A?!1:w.isEqual(A),label:M,description:M,sortText:M,busy:M,error:M,canResolveChildren:M,tags:(w,A)=>!(w.length!==A.length||w.some(p=>!A.find(n=>p.id===n.id)))},f=w=>A=>({op:4,update:w(A)}),b=(w,A)=>({range:(()=>{let p;const n=f(h=>({range:r.Range.lift(R.Range.from(h))}));return{enumerable:!0,configurable:!1,get(){return p},set(h){w.listener?.({op:6}),E.range(p,h)||(p=h,w.listener?.(n(h)))}}})(),label:T(w,A,E.label,f(p=>({label:p}))),description:T(w,void 0,E.description,f(p=>({description:p}))),sortText:T(w,void 0,E.sortText,f(p=>({sortText:p}))),canResolveChildren:T(w,!1,E.canResolveChildren,p=>({op:2,state:p})),busy:T(w,!1,E.busy,f(p=>({busy:p}))),error:T(w,void 0,E.error,f(p=>({error:R.MarkdownString.fromStrict(p)||null}))),tags:T(w,[],E.tags,(p,n)=>({op:1,new:p.map(R.TestTag.from),old:n.map(R.TestTag.from)}))}),m=w=>{const A=D.TestId.fromString(w.extId),p=new o(A.controllerId,A.localId,w.label,y.URI.revive(w.uri)||void 0);return p.range=R.Range.to(w.range||void 0),p.description=w.description||void 0,p.sortText=w.sortText||void 0,p.tags=w.tags.map(n=>R.TestTag.to({id:(0,S.denamespaceTestTag)(n).tagId})),p},s=w=>{let A;for(const p of w.tests){const n=m(p.item);(0,k.getPrivateApiFor)(n).parent=A,A=n}return A};e.toItemFromContext=s;class o{constructor(A,p,n,h){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const i=(0,k.createPrivateApiFor)(this,A);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:h,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof l?void 0:i.parent}},children:{value:(0,N.createTestItemChildren)(i,k.getPrivateApiFor,o),enumerable:!0,writable:!1},...b(i,n)})}}e.TestItemImpl=o;class l extends o{constructor(A,p){super(A,A,p,void 0),this._isRoot=!0}}e.TestItemRootImpl=l;class v extends N.TestItemCollection{constructor(A,p,n){super({controllerId:A,getDocumentVersion:h=>h&&n.getDocument(h)?.version,getApiFor:k.getPrivateApiFor,getChildren:h=>h.children,root:new l(A,p),toITestItem:R.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(Ie[102],Ce([1,0,48,12,83,8,7]),function(te,e,r,k,D,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class R{constructor(f,b,m){const s=R.c.nextId();f.$registerTextEditorDecorationType(b.identifier,s,N.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:s,dispose(){f.$removeTextEditorDecorationType(s)}})}}e.TextEditorDecorationType=R,R.c=new D.IdGenerator("TextEditorDecorationType");class y{constructor(f,b){this.g=[],this.h=void 0,this.j=!1,this.c=f,this.d=f.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(f,b){this.k();let m=null;if(f instanceof S.Position)m=new S.Range(f,f);else if(f instanceof S.Range)m=f;else throw new Error("Unrecognized location");this.l(m,b,!1)}insert(f,b){this.k(),this.l(new S.Range(f,f),b,!0)}delete(f){this.k();let b=null;if(f instanceof S.Range)b=f;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(f,b,m){const s=this.c.validateRange(f);this.g.push({range:s,text:b,forceMoveMarkers:m})}setEndOfLine(f){if(this.k(),f!==S.EndOfLine.LF&&f!==S.EndOfLine.CRLF)throw(0,k.illegalArgument)("endOfLine");this.h=f}}class T{constructor(f,b,m,s){this.c=f,this.d=b,this._accept(m),this.e=s;const o=this;this.value={get tabSize(){return o.f},set tabSize(l){o.m(l)},get indentSize(){return o.g},set indentSize(l){o.o(l)},get insertSpaces(){return o.h},set insertSpaces(l){o.q(l)},get cursorStyle(){return o.j},set cursorStyle(l){o.s(l)},get lineNumbers(){return o.k},set lineNumbers(l){o.t(l)}}}_accept(f){this.f=f.tabSize,this.g=f.indentSize,this.h=f.insertSpaces,this.j=f.cursorStyle,this.k=N.TextEditorLineNumbersStyle.to(f.lineNumbers)}l(f){if(f==="auto")return"auto";if(typeof f=="number"){const b=Math.floor(f);return b>0?b:null}if(typeof f=="string"){const b=parseInt(f,10);return isNaN(b)?null:b>0?b:null}return null}m(f){const b=this.l(f);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(f){if(f==="tabSize")return"tabSize";if(typeof f=="number"){const b=Math.floor(f);return b>0?b:null}if(typeof f=="string"){const b=parseInt(f,10);return isNaN(b)?null:b>0?b:null}return null}o(f){const b=this.n(f);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(f){return f==="auto"?"auto":f==="false"?!1:Boolean(f)}q(f){const b=this.p(f);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(f){this.j!==f&&(this.j=f,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:f})))}t(f){this.k!==f&&(this.k=f,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:N.TextEditorLineNumbersStyle.from(f)})))}assign(f){const b={};let m=!1;if(typeof f.tabSize<"u"){const s=this.l(f.tabSize);s==="auto"?(m=!0,b.tabSize=s):typeof s=="number"&&this.f!==s&&(this.f=s,m=!0,b.tabSize=s)}if(typeof f.indentSize<"u"){const s=this.n(f.indentSize);s==="tabSize"?(m=!0,b.indentSize=s):typeof s=="number"&&this.g!==s&&(this.g=s,m=!0,b.indentSize=s)}if(typeof f.insertSpaces<"u"){const s=this.p(f.insertSpaces);s==="auto"?(m=!0,b.insertSpaces=s):this.h!==s&&(this.h=s,m=!0,b.insertSpaces=s)}typeof f.cursorStyle<"u"&&this.j!==f.cursorStyle&&(this.j=f.cursorStyle,m=!0,b.cursorStyle=f.cursorStyle),typeof f.lineNumbers<"u"&&this.k!==f.lineNumbers&&(this.k=f.lineNumbers,m=!0,b.lineNumbers=N.TextEditorLineNumbersStyle.from(f.lineNumbers)),m&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(f,b){b.catch(m=>{this.e.warn(`ExtHostTextEditorOptions '${f}' failed:'`),this.e.warn(m)})}}e.ExtHostTextEditorOptions=T;class M{constructor(f,b,m,s,o,l,v,w){this.id=f,this.j=b,this.k=m,this.g=!1,this.h=new Set,this.c=o,this.d=new T(this.j,this.id,l,m),this.e=v,this.f=w;const A=this;this.value=Object.freeze({get document(){return s.value},set document(p){throw(0,k.readonly)("document")},get selection(){return A.c&&A.c[0]},set selection(p){if(!(p instanceof S.Selection))throw(0,k.illegalArgument)("selection");A.c=[p],A.l()},get selections(){return A.c},set selections(p){if(!Array.isArray(p)||p.some(n=>!(n instanceof S.Selection)))throw(0,k.illegalArgument)("selections");A.c=p,A.l()},get visibleRanges(){return A.e},set visibleRanges(p){throw(0,k.readonly)("visibleRanges")},get options(){return A.d.value},set options(p){A.g||A.d.assign(p)},get viewColumn(){return A.f},set viewColumn(p){throw(0,k.readonly)("viewColumn")},edit(p,n={undoStopBefore:!0,undoStopAfter:!0}){if(A.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const h=new y(s.value,n);return p(h),A.m(h)},insertSnippet(p,n,h={undoStopBefore:!0,undoStopAfter:!0}){if(A.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!n||Array.isArray(n)&&n.length===0)i=A.c.map(a=>N.Range.from(a));else if(n instanceof S.Position){const{lineNumber:a,column:t}=N.Position.from(n);i=[{startLineNumber:a,startColumn:t,endLineNumber:a,endColumn:t}]}else if(n instanceof S.Range)i=[N.Range.from(n)];else{i=[];for(const a of n)if(a instanceof S.Range)i.push(N.Range.from(a));else{const{lineNumber:t,column:g}=N.Position.from(a);i.push({startLineNumber:t,startColumn:g,endLineNumber:t,endColumn:g})}}return b.$tryInsertSnippet(f,s.value.version,p.value,i,h)},setDecorations(p,n){const h=n.length===0;h&&!A.h.has(p.key)||(h?A.h.delete(p.key):A.h.add(p.key),A.n(()=>{if(N.isDecorationOptionsArr(n))return b.$trySetDecorations(f,p.key,N.fromRangeOrRangeWithMessage(n));{const i=new Array(4*n.length);for(let a=0,t=n.length;a<t;a++){const g=n[a];i[4*a]=g.start.line+1,i[4*a+1]=g.start.character+1,i[4*a+2]=g.end.line+1,i[4*a+3]=g.end.character+1}return b.$trySetDecorationsFast(f,p.key,i)}}))},revealRange(p,n){A.n(()=>b.$tryRevealRange(f,N.Range.from(p),n||S.TextEditorRevealType.Default))},show(p){b.$tryShowEditor(f,N.ViewColumn.from(p))},hide(){b.$tryHideEditor(f)}})}dispose(){(0,r.ok)(!this.g),this.g=!0}_acceptOptions(f){(0,r.ok)(!this.g),this.d._accept(f)}_acceptVisibleRanges(f){(0,r.ok)(!this.g),this.e=f}_acceptViewColumn(f){(0,r.ok)(!this.g),this.f=f}_acceptSelections(f){(0,r.ok)(!this.g),this.c=f}async l(){const f=this.c.map(N.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,f)),this.value}m(f){const b=f.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const m=b.edits.map(o=>o.range);m.sort((o,l)=>o.end.line===l.end.line?o.end.character===l.end.character?o.start.line===l.start.line?o.start.character-l.start.character:o.start.line-l.start.line:o.end.character-l.end.character:o.end.line-l.end.line);for(let o=0,l=m.length-1;o<l;o++){const v=m[o].end;if(m[o+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=b.edits.map(o=>({range:N.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,s,{setEndOfLine:typeof b.setEndOfLine=="number"?N.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(f){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):f().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.ExtHostTextEditor=M}),define(Ie[197],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ie[198],Ce([1,0,152,12,29,90,68,30,25,197,162,154]),function(te,e,r,k,D,N,S,R,y,T,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const f=R.Registry.as(S.Extensions.JSONContribution);class b{constructor(p,n,h){this.a=p,this.b=n,this.c=h}d(p,n){this.a({type:p,message:n,extensionId:this.b.identifier,extensionPointId:this.c})}error(p){this.d(D.default.Error,p)}warn(p){this.d(D.default.Warning,p)}info(p){this.d(D.default.Info,p)}}e.ExtensionMessageCollector=b;class m{static a(p){const n=new Set;for(let h=0,i=p.length;h<i;h++)n.add(y.ExtensionIdentifier.toKey(p[h].description.identifier));return n}static compute(p,n){if(!p||!p.length)return new m(n,[]);if(!n||!n.length)return new m([],p);const h=this.a(p),i=this.a(n),a=n.filter(g=>!h.has(y.ExtensionIdentifier.toKey(g.description.identifier))),t=p.filter(g=>!i.has(y.ExtensionIdentifier.toKey(g.description.identifier)));return new m(a,t)}constructor(p,n){this.added=p,this.removed=n}}e.ExtensionPointUserDelta=m;class s{constructor(p,n){this.name=p,this.defaultExtensionKind=n,this.a=null,this.b=null,this.c=null}setHandler(p){if(this.a!==null)throw new Error("Handler already set!");this.a=p,this.d()}acceptUsers(p){this.c=m.compute(this.b,p),this.b=p,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(p){(0,k.onUnexpectedError)(p)}}}e.ExtensionPoint=s;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(0,null),r.localize(1,null)]},l="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:r.localize(2,null),properties:{vscode:{type:"string",description:r.localize(3,null),default:"^1.22.0"}}},publisher:{description:r.localize(4,null),type:"string"},displayName:{description:r.localize(5,null),type:"string"},categories:{description:r.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:r.localize(7,null)}]}},galleryBanner:{type:"object",description:r.localize(8,null),properties:{color:{description:r.localize(9,null),type:"string"},theme:{description:r.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(13,null)},enabledApiProposals:{markdownDescription:r.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(T.allApiProposals),markdownEnumDescriptions:Object.values(T.allApiProposals)}},api:{markdownDescription:r.localize(15,null),type:"string",enum:["none"],enumDescriptions:[r.localize(16,null)]},activationEvents:{description:r.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(32,null)},{label:"onUri",body:"onUri",description:r.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(37,null)},{label:"onRenderer",description:r.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:r.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(41,null)},{label:"*",description:r.localize(42,null),body:"*"}]}},badges:{type:"array",description:r.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(44,null)},href:{type:"string",description:r.localize(45,null)},description:{type:"string",description:r.localize(46,null)}}}},markdown:{type:"string",description:r.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:r.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:r.localize(51,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(52,null)},{body:["workspace"],description:r.localize(53,null)},{body:["ui","workspace"],description:r.localize(54,null)},{body:["workspace","ui"],description:r.localize(55,null)},{body:[],description:r.localize(56,null)}]},capabilities:{description:r.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(60,null),r.localize(61,null),r.localize(62,null)]},description:{type:"string",markdownDescription:r.localize(63,null)}}},untrustedWorkspaces:{description:r.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(66,null),r.localize(67,null),r.localize(68,null)]},restrictedConfigurations:{description:r.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(70,null)}}}}},sponsor:{description:r.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(73,null),type:"string"},"vscode:uninstall":{description:r.localize(74,null),type:"string"}}},icon:{type:"string",description:r.localize(75,null)},l10n:{type:"string",description:r.localize(76,null)}}};class v{constructor(){this.a=new Map}registerExtensionPoint(p){if(this.a.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const n=new s(p.extensionPoint,p.defaultExtensionKind);return this.a.set(p.extensionPoint,n),p.activationEventsGenerator&&E.ImplicitActivationEvents.register(p.extensionPoint,p.activationEventsGenerator),e.schema.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,f.registerSchema(l,e.schema),n}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=v;const w={ExtensionsRegistry:"ExtensionsRegistry"};R.Registry.add(w.ExtensionsRegistry,new v),e.ExtensionsRegistry=R.Registry.as(w.ExtensionsRegistry),f.registerSchema(l,e.schema),f.registerSchema(M.productSchemaId,{properties:{extensionEnabledApiProposals:{description:r.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(T.allApiProposals),markdownEnumDescriptions:Object.values(T.allApiProposals)}}]}}}})}),define(Ie[199],Ce([1,0,149,9,22,198,42,4]),function(te,e,r,k,D,N,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(2,null),default:""}}};var T;(function(f){function b(m,s,o){if(!m)return;const l=k.isString(m.type)?m.type:void 0;if(!l||l.length===0){o.error(r.localize(3,null));return}const v=[];if(Array.isArray(m.required))for(const w of m.required)k.isString(w)&&v.push(w);return{extensionId:s.value,taskType:l,required:v,properties:m.properties?D.deepClone(m.properties):{},when:m.when?S.ContextKeyExpr.deserialize(m.when):void 0}}f.from=b})(T||(T={}));const M=N.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:r.localize(4,null),type:"array",items:y}});class E{constructor(){this.d=new R.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,m)=>{M.setHandler((s,o)=>{this.c=void 0;try{for(const l of o.removed){const v=l.value;for(const w of v)this.a&&w.type&&this.a[w.type]&&delete this.a[w.type]}for(const l of o.added){const v=l.value;for(const w of v){const A=T.from(w,l.description.identifier,l.collector);A&&(this.a[A.taskType]=A)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const m of this.all()){const s={type:"object",additionalProperties:!1};m.required.length>0&&(s.required=m.required.slice(0)),m.properties!==void 0?s.properties=D.deepClone(m.properties):s.properties=Object.create(null),s.properties.type={type:"string",enum:[m.taskType]},b.push(s)}this.c={oneOf:b}}return this.c}}e.TaskDefinitionRegistry=new E}),define(Ie[200],Ce([1,0,150,9,24,22,42,199]),function(te,e,r,k,D,N,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new S.RawContextKey("taskRunning",!1,r.localize(0,null)),e.TASKS_CATEGORY={value:r.localize(1,null),original:"Tasks"};var y;(function(P){P[P.Escape=1]="Escape",P[P.Strong=2]="Strong",P[P.Weak=3]="Weak"})(y=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(P){function F(V){if(!V)return P.Strong;switch(V.toLowerCase()){case"escape":return P.Escape;case"strong":return P.Strong;case"weak":return P.Weak;default:return P.Strong}}P.from=F}(y=e.ShellQuoting||(e.ShellQuoting={}));var T;(function(P){P.defaults={cwd:"${workspaceFolder}"}})(T=e.CommandOptions||(e.CommandOptions={}));var M;(function(P){P[P.Always=1]="Always",P[P.Silent=2]="Silent",P[P.Never=3]="Never"})(M=e.RevealKind||(e.RevealKind={})),function(P){function F(V){switch(V.toLowerCase()){case"always":return P.Always;case"silent":return P.Silent;case"never":return P.Never;default:return P.Always}}P.fromString=F}(M=e.RevealKind||(e.RevealKind={}));var E;(function(P){P[P.Never=1]="Never",P[P.OnProblem=2]="OnProblem",P[P.Always=3]="Always"})(E=e.RevealProblemKind||(e.RevealProblemKind={})),function(P){function F(V){switch(V.toLowerCase()){case"always":return P.Always;case"never":return P.Never;case"onproblem":return P.OnProblem;default:return P.OnProblem}}P.fromString=F}(E=e.RevealProblemKind||(e.RevealProblemKind={}));var f;(function(P){P[P.Shared=1]="Shared",P[P.Dedicated=2]="Dedicated",P[P.New=3]="New"})(f=e.PanelKind||(e.PanelKind={})),function(P){function F(V){switch(V.toLowerCase()){case"shared":return P.Shared;case"dedicated":return P.Dedicated;case"new":return P.New;default:return P.Shared}}P.fromString=F}(f=e.PanelKind||(e.PanelKind={}));var b;(function(P){P.defaults={echo:!0,reveal:M.Always,revealProblems:E.Never,focus:!1,panel:f.Shared,showReuseMessage:!0,clear:!1}})(b=e.PresentationOptions||(e.PresentationOptions={}));var m;(function(P){P[P.Shell=1]="Shell",P[P.Process=2]="Process",P[P.CustomExecution=3]="CustomExecution"})(m=e.RuntimeType||(e.RuntimeType={})),function(P){function F(q){switch(q.toLowerCase()){case"shell":return P.Shell;case"process":return P.Process;case"customExecution":return P.CustomExecution;default:return P.Process}}P.fromString=F;function V(q){switch(q){case P.Shell:return"shell";case P.Process:return"process";case P.CustomExecution:return"customExecution";default:return"process"}}P.toString=V}(m=e.RuntimeType||(e.RuntimeType={}));var s;(function(P){function F(V){return k.isString(V)?V:V.value}P.value=F})(s=e.CommandString||(e.CommandString={}));var o;(function(P){P.Clean={_id:"clean",isDefault:!1},P.Build={_id:"build",isDefault:!1},P.Rebuild={_id:"rebuild",isDefault:!1},P.Test={_id:"test",isDefault:!1};function F(q){return q===P.Clean._id||q===P.Build._id||q===P.Rebuild._id||q===P.Test._id}P.is=F;function V(q){if(q!==void 0)return k.isString(q)?F(q)?{_id:q,isDefault:!1}:void 0:q}P.from=V})(o=e.TaskGroup||(e.TaskGroup={}));var l;(function(P){P[P.Global=1]="Global",P[P.Workspace=2]="Workspace",P[P.Folder=3]="Folder"})(l=e.TaskScope||(e.TaskScope={}));var v;(function(P){P.Workspace="workspace",P.Extension="extension",P.InMemory="inMemory",P.WorkspaceFile="workspaceFile",P.User="user";function F(V){switch(V){case P.User:return 2;case P.WorkspaceFile:return 5;default:return 6}}P.toConfigurationTarget=F})(v=e.TaskSourceKind||(e.TaskSourceKind={}));var w;(function(P){P.parallel="parallel",P.sequence="sequence"})(w=e.DependsOrder||(e.DependsOrder={}));var A;(function(P){P[P.default=1]="default",P[P.folderOpen=2]="folderOpen"})(A=e.RunOnOptions||(e.RunOnOptions={}));var p;(function(P){P.defaults={reevaluateOnRerun:!0,runOn:A.default,instanceLimit:1}})(p=e.RunOptions||(e.RunOptions={}));class n{constructor(F,V,q,le,_,pe){this._label="",this._id=F,V&&(this._label=V),q&&(this.type=q),this.runOptions=le,this.configurationProperties=_,this._source=pe}getDefinition(F){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,V=!1){if(F===void 0)return!1;if(k.isString(F))return F===this._label||F===this.configurationProperties.identifier||V&&F===this._id;const q=this.getDefinition(!0);return q!==void 0&&q._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.CommonTask=n;class h extends n{constructor(F,V,q,le,_,pe,ue,de){super(F,q,void 0,ue,de,V),this.command={},this._source=V,this.hasDefinedMatchers=pe,_&&(this.command=_)}clone(){return new h(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let V;switch(this.command?this.command.runtime:void 0){case m.Shell:V="shell";break;case m.Process:V="process";break;case m.CustomExecution:V="customExecution";break;case void 0:V="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:V,_key:this._id,id:this._id}}}static is(F){return F instanceof h}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const F=this.d();if(!F)return;let V=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(V+=this._source.kind);const q={type:e.CUSTOMIZED_TASK_TYPE,folder:F,id:V};return JSON.stringify(q)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new h(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.CustomTask=h;class i extends n{constructor(F,V,q,le,_,pe,ue){super(F,q,le,pe,ue,V),this._source=V,this.configures=_}static is(F){return F instanceof i}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const F=this.d();if(!F)return;let V=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(V+=this._source.kind);const q={type:e.CUSTOMIZED_TASK_TYPE,folder:F,id:V};return JSON.stringify(q)}}e.ConfiguringTask=i;class a extends n{constructor(F,V,q,le,_,pe,ue,de,re){super(F,q,le,de,re,V),this.defines=_,this.hasDefinedMatchers=ue,this.command=pe,this.icon=re.icon,this.hide=re.hide}clone(){return new a(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof a}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new a(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.ContributedTask=a;class t extends n{constructor(F,V,q,le,_,pe){super(F,q,le,_,pe,V),this._source=V}clone(){return new t(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof t}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new t(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.InMemoryTask=t;var g;(function(P){P[P.Process=1]="Process",P[P.Terminal=2]="Terminal"})(g=e.ExecutionEngine||(e.ExecutionEngine={})),function(P){P._default=P.Terminal}(g=e.ExecutionEngine||(e.ExecutionEngine={}));var c;(function(P){P[P.V0_1_0=1]="V0_1_0",P[P.V2_0_0=2]="V2_0_0"})(c=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class u{constructor(F){this.c=new Map;for(let V=0;V<F.length;V++)this.c.set(F[V].uri.toString(),V)}compare(F,V){const q=F.getWorkspaceFolder(),le=V.getWorkspaceFolder();if(q&&le){let _=this.c.get(q.uri.toString());_=_===void 0?0:_+1;let pe=this.c.get(le.uri.toString());return pe=pe===void 0?0:pe+1,_===pe?F._label.localeCompare(V._label):_-pe}else return!q&&le?-1:q&&!le?1:0}}e.TaskSorter=u;var d;(function(P){P.DependsOnStarted="dependsOnStarted",P.AcquiredInput="acquiredInput",P.Start="start",P.ProcessStarted="processStarted",P.Active="active",P.Inactive="inactive",P.Changed="changed",P.Terminated="terminated",P.ProcessEnded="processEnded",P.End="end"})(d=e.TaskEventKind||(e.TaskEventKind={}));var C;(function(P){P.SingleRun="singleRun",P.Background="background"})(C=e.TaskRunType||(e.TaskRunType={}));var O;(function(P){P[P.System=0]="System",P[P.User=1]="User",P[P.FolderOpen=2]="FolderOpen",P[P.ConfigurationChange=3]="ConfigurationChange",P[P.Reconnect=4]="Reconnect"})(O=e.TaskRunSource||(e.TaskRunSource={}));var j;(function(P){function F(V,q,le,_){if(q){const pe={kind:V,taskId:q._id,taskName:q.configurationProperties.name,runType:q.configurationProperties.isBackground?"background":"singleRun",group:q.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:le,__task:q};return V==="start"?pe.resolvedVariables=_:V==="processStarted"?pe.processId=_:V==="processEnded"&&(pe.exitCode=_),Object.freeze(pe)}else return Object.freeze({kind:"changed"})}P.create=F})(j=e.TaskEvent||(e.TaskEvent={}));var Z;(function(P){function F(q){const le=Object.keys(q).sort();let _="";for(const pe of le){let ue=q[pe];ue instanceof Object?ue=F(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),_+=pe+","+ue+","}return _}function V(q){const _={_key:F(q),type:q.taskType};return Object.assign(_,q),_}P.create=V})(Z=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var x;(function(P){P.AutoDetect="task.autoDetect",P.SaveBeforeRun="task.saveBeforeRun",P.ShowDecorations="task.showDecorations",P.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",P.SlowProviderWarning="task.slowProviderWarning",P.QuickOpenHistory="task.quickOpen.history",P.QuickOpenDetail="task.quickOpen.detail",P.QuickOpenSkip="task.quickOpen.skip",P.QuickOpenShowAll="task.quickOpen.showAll",P.AllowAutomaticTasks="task.allowAutomaticTasks",P.Reconnection="task.reconnection"})(x=e.TaskSettingId||(e.TaskSettingId={}));var L;(function(P){P.Tasks="tasks",P.SuppressTaskName="tasks.suppressTaskName",P.Windows="tasks.windows",P.Osx="tasks.osx",P.Linux="tasks.linux",P.ShowOutput="tasks.showOutput",P.IsShellCommand="tasks.isShellCommand",P.ServiceTestSetting="tasks.service.testSetting"})(L=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var $;(function(P){function F(V,q){const le=R.TaskDefinitionRegistry.get(V.type);if(le===void 0){const de=N.deepClone(V);return delete de._key,Z.create(de)}const _=Object.create(null);_.type=le.taskType;const pe=new Set;le.required.forEach(de=>pe.add(de));const ue=le.properties;for(const de of Object.keys(ue)){const re=V[de];if(re!=null)_[de]=re;else if(pe.has(de)){const G=ue[de];if(G.default!==void 0)_[de]=N.deepClone(G.default);else switch(G.type){case"boolean":_[de]=!1;break;case"number":case"integer":_[de]=0;break;case"string":_[de]="";break;default:q.error(r.localize(2,null,JSON.stringify(V,void 0,0),de));return}}}return Z.create(_)}P.createTaskIdentifier=F})($=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ie[201],Ce([1,0,12]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class k{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((S,R)=>{this.b=S,this.d=R,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(S){this.f||this.h||(this.f=!0,this.g=S,this.a&&this.b(S))}resolveErr(S){this.f||this.h||(this.h=!0,this.i=S,this.a?this.d(S):(0,r.onUnexpectedError)(S))}then(S,R){return this.j().then(S,R)}catch(S){return this.j().then(void 0,S)}finally(S){return this.j().finally(S)}}e.LazyPromise=k;class D extends k{constructor(){super(),this.h=!0,this.i=new r.CancellationError}}e.CanceledLazyPromise=D}),define(Ie[45],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class r{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++r.count}}e.ProxyIdentifier=r,r.count=0;const k=[];function D(R){const y=new r(R);return k[y.nid]=y,y}e.createProxyIdentifier=D;function N(R){return k[R].sid}e.getStringIdentifierForProxy=N;class S{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=S}),define(Ie[5],Ce([1,0,45]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var k;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(k=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(s){s[s.UnknownInput=0]="UnknownInput",s[s.TextInput=1]="TextInput",s[s.TextDiffInput=2]="TextDiffInput",s[s.TextMergeInput=3]="TextMergeInput",s[s.NotebookInput=4]="NotebookInput",s[s.NotebookDiffInput=5]="NotebookDiffInput",s[s.CustomEditorInput=6]="CustomEditorInput",s[s.WebviewEditorInput=7]="WebviewEditorInput",s[s.TerminalEditorInput=8]="TerminalEditorInput",s[s.InteractiveEditorInput=9]="InteractiveEditorInput"})(D=e.TabInputKind||(e.TabInputKind={}));var N;(function(s){s[s.TAB_OPEN=0]="TAB_OPEN",s[s.TAB_CLOSE=1]="TAB_CLOSE",s[s.TAB_UPDATE=2]="TAB_UPDATE",s[s.TAB_MOVE=3]="TAB_MOVE"})(N=e.TabModelOperationKind||(e.TabModelOperationKind={}));var S;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(S=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var R;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(R=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var T;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(T=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var M;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(M=e.CandidatePortSource||(e.CandidatePortSource={}));class E{static mixin(o){return o._id=E.a++,o}}e.IdObject=E,E.a=0;var f;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.kindModifier="m",s.commandIdent="n",s.commandId="o",s.commandArguments="p"})(f=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var b;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(b=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(m=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,r.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,r.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,r.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,r.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,r.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,r.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,r.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,r.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,r.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,r.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,r.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,r.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,r.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,r.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,r.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,r.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,r.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,r.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,r.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,r.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,r.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,r.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,r.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,r.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,r.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,r.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,r.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,r.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,r.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,r.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,r.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,r.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,r.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,r.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,r.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,r.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,r.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,r.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,r.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,r.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,r.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,r.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,r.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,r.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,r.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,r.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,r.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,r.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,r.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,r.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,r.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,r.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,r.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,r.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,r.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,r.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,r.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,r.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,r.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,r.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,r.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,r.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,r.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,r.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,r.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,r.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,r.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,r.createProxyIdentifier)("ExtHostLocalization")}}),define(Ie[76],Ce([1,0,3,11,5,17]),function(te,e,r,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,r.createDecorator)("IExtHostApiDeprecationService");let S=class{constructor(y,T){this.c=T,this.a=new Set,this.b=y.getProxy(D.MainContext.MainThreadTelemetry)}report(y,T,M){const E=this.d(y,T);this.a.has(E)||(this.a.add(E),T.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${y}' is deprecated. ${M}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:y}))}d(y,T){return`${y}-${T.identifier.value}`}};S=qe([je(0,N.IExtHostRpcService),je(1,k.ILogService)],S),e.ExtHostApiDeprecationService=S,e.NullApiDeprecationService=Object.freeze(new class{report(R,y,T){}})}),define(Ie[202],Ce([1,0,4,5,7,25]),function(te,e,r,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class S{constructor(y){this.b=new Map,this.c=[],this.d=new r.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=y.getProxy(k.MainContext.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,T,M,E={}){const f=N.ExtensionIdentifier.toKey(y.identifier),b=this.f.get(f)||[],m=[...M].sort().join(" ");let s=b.find(o=>o.providerId===T&&o.scopes===m);if(s)return s.result;{const o=this.g(y,f,T,M,E);s={providerId:T,scopes:m,result:o},b.push(s),this.f.set(f,b);try{await o}finally{const l=b.findIndex(v=>v.providerId===T&&v.scopes===m);l>-1&&(b.splice(l),this.f.set(f,b))}return o}}async g(y,T,M,E,f={}){await this.a.$ensureProvider(M);const b=y.displayName||y.name;return this.a.$getSession(M,E,T,b,f)}async removeSession(y,T){const M=this.b.get(y);return M?M.provider.removeSession(T):this.a.$removeSession(y,T)}registerAuthenticationProvider(y,T,M,E){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:T,provider:M,options:E??{supportsMultipleAccounts:!1}}),this.c.find(b=>b.id===y)||this.c.push({id:y,label:T});const f=M.onDidChangeSessions(b=>{this.a.$sendDidChangeSessions(y,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this.a.$registerAuthenticationProvider(y,T,E?.supportsMultipleAccounts??!1),new D.Disposable(()=>{f.dispose(),this.b.delete(y);const b=this.c.findIndex(m=>m.id===y);b>-1&&this.c.splice(b),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,T){const M=this.b.get(y);if(M)return Promise.resolve(M.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,T){const M=this.b.get(y);if(M)return Promise.resolve(M.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,T){const M=this.b.get(y);if(M)return Promise.resolve(M.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,T){return this.d.fire({provider:{id:y,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=S}),define(Ie[203],Ce([1,0,5,17,8]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let N=class{constructor(R,y){this.a=R.getProxy(r.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:T=>y.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(R,y,T){const M=D.WorkspaceEdit.from(R,this.b);return this.a.$tryApplyWorkspaceEdit(M,void 0,T?.isRefactoring??!1)}};N=qe([je(0,k.IExtHostRpcService)],N),e.ExtHostBulkEdits=N}),define(Ie[204],Ce([1,0,5]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class k{constructor(N){const S=N.getProxy(r.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return S.$readText()},writeText(R){return S.$writeText(R)}})}}e.ExtHostClipboard=k});var Je=this&&this.__classPrivateFieldSet||function(te,e,r,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,r):D?D.value=r:e.set(te,r),r},Le=this&&this.__classPrivateFieldGet||function(te,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(te):k?k.value:e.get(te)};define(Ie[37],Ce([1,0,9,7,8,22,5,18,11,65,56,257,2,6,3,17,101,23,45,39,77,51]),function(te,e,r,k,D,N,S,R,y,T,M,E,f,b,m,s,o,l,v,w,A,p){"use strict";var n,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let i=class{constructor(d,C){n.set(this,void 0),this.b=new Map,this.c=new Map,h.set(this,void 0),Je(this,n,d.getProxy(S.MainContext.MainThreadCommands),"f"),this.d=C,Je(this,h,d.getProxy(S.MainContext.MainThreadTelemetry),"f"),this.converter=new a(this,O=>{const j=this.c.get(O);return j?.result===g.Void?j:void 0},C),this.f=[{processArgument(O){return(0,T.revive)(O)}},{processArgument(O){return(0,N.cloneAndChange)(O,function(j){if(M.Range.isIRange(j))return D.Range.to(j);if(E.Position.isIPosition(j))return D.Position.to(j);if(M.Range.isIRange(j.range)&&f.URI.isUri(j.uri))return D.location.to(j);if(j instanceof l.VSBuffer)return j.buffer.buffer;if(!Array.isArray(j))return j})}}]}registerArgumentProcessor(d){this.f.push(d)}registerApiCommand(d){const C=this.registerCommand(!1,d.id,async(...O)=>{const j=d.args.map((x,L)=>{if(!x.validate(O[L]))throw new Error(`Invalid argument '${x.name}' when running '${d.id}', received: ${O[L]}`);return x.convert(O[L])}),Z=await this.executeCommand(d.internalId,...j);return d.result.convert(Z,O,this.converter)},void 0,{description:d.description,args:d.args,returns:d.result.description});return this.c.set(d.id,d),new k.Disposable(()=>{C.dispose(),this.c.delete(d.id)})}registerCommand(d,C,O,j,Z,x){if(this.d.trace("ExtHostCommands#registerCommand",C),!C.trim().length)throw new Error("invalid id");if(this.b.has(C))throw new Error(`command '${C}' already exists`);return this.b.set(C,{callback:O,thisArg:j,description:Z,extension:x}),d&&Le(this,n,"f").$registerCommand(C),new k.Disposable(()=>{this.b.delete(C)&&d&&Le(this,n,"f").$unregisterCommand(C)})}executeCommand(d,...C){return this.d.trace("ExtHostCommands#executeCommand",d),this.g(d,C,!0)}async g(d,C,O){if(this.b.has(d))return Le(this,n,"f").$fireCommandActivationEvent(d),this.h(d,C,!1);{let j=!1;const Z=(0,N.cloneAndChange)(C,function(x){if(x instanceof k.Position)return D.Position.from(x);if(x instanceof k.Range)return D.Range.from(x);if(x instanceof k.Location)return D.location.from(x);if(k.NotebookRange.isNotebookRange(x))return D.NotebookRange.from(x);if(x instanceof ArrayBuffer)return j=!0,l.VSBuffer.wrap(new Uint8Array(x));if(x instanceof Uint8Array)return j=!0,l.VSBuffer.wrap(x);if(x instanceof l.VSBuffer)return j=!0,x;if(!Array.isArray(x))return x});try{const x=await Le(this,n,"f").$executeCommand(d,j?new v.SerializableObjectWithBuffers(Z):Z,O);return(0,T.revive)(x)}catch(x){if(x instanceof Error&&x.message==="$executeCommand:retry")return this.g(d,C,!1);throw x}}}async h(d,C,O){const j=this.b.get(d);if(!j)throw new Error("Unknown command");const{callback:Z,thisArg:x,description:L}=j;if(L)for(let P=0;P<L.args.length;P++)try{(0,r.validateConstraint)(C[P],L.args[P].constraint)}catch{throw new Error(`Running the contributed command: '${d}' failed. Illegal argument '${L.args[P].name}' - ${L.args[P].description}`)}const $=A.StopWatch.create();try{return await Z.apply(x,C)}catch(P){if(d===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...C);F&&(d=F.command)}throw this.d.error(P,d,j.extension?.identifier),O?new class extends Error{constructor(){super((0,w.toErrorMessage)(P)),this.id=d,this.source=j.extension?.displayName??j.extension?.name}}:P}finally{this.j(j,d,$.elapsed())}}j(d,C,O){!d.extension||Le(this,h,"f").$publicLog2("Extension:ActionExecuted",{extensionId:d.extension.identifier.value,id:new p.TelemetryTrustedValue(C),duration:O})}$executeContributedCommand(d,...C){this.d.trace("ExtHostCommands#$executeContributedCommand",d);const O=this.b.get(d);return O?(C=C.map(j=>this.f.reduce((Z,x)=>x.processArgument(Z,O.extension?.identifier),j)),this.h(d,C,!0)):Promise.reject(new Error(`Contributed command '${d}' does not exist.`))}getCommands(d=!1){return this.d.trace("ExtHostCommands#getCommands",d),Le(this,n,"f").$getCommands().then(C=>(d&&(C=C.filter(O=>O[0]!=="_")),C))}$getContributedCommandHandlerDescriptions(){const d=Object.create(null);for(const[C,O]of this.b){const{description:j}=O;j&&(d[C]=j)}return Promise.resolve(d)}};n=new WeakMap,h=new WeakMap,i=qe([je(0,s.IExtHostRpcService),je(1,y.ILogService)],i),e.ExtHostCommands=i,e.IExtHostCommands=(0,m.createDecorator)("IExtHostCommands");class a{constructor(d,C,O){this.d=d,this.f=C,this.g=O,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(d,C){if(!d)return;const O={$ident:void 0,id:d.command,title:d.title,tooltip:d.tooltip};if(!d.command)return O;const j=this.f(d.command);if(j)O.id=j.internalId,O.arguments=j.args.map((Z,x)=>Z.convert(d.arguments&&d.arguments[x]));else if((0,R.isNonEmptyArray)(d.arguments)){const Z=`${d.command}/${++this.c}`;this.b.set(Z,d),C.add((0,b.toDisposable)(()=>{this.b.delete(Z),this.g.trace("CommandsConverter#DISPOSE",Z)})),O.$ident=Z,O.id=this.delegatingCommandId,O.arguments=[Z],this.g.trace("CommandsConverter#CREATE",d.command,Z)}return O}fromInternal(d){return typeof d.$ident=="string"?this.b.get(d.$ident):{command:d.id,title:d.title,arguments:d.arguments}}getActualCommand(...d){return this.b.get(d[0])}h(...d){const C=this.getActualCommand(...d);return this.g.trace("CommandsConverter#EXECUTE",d[0],C?C.command:"MISSING"),C?this.d.executeCommand(C.command,...C.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${d[0]}`)}}e.CommandsConverter=a;class t{constructor(d,C,O,j){this.name=d,this.description=C,this.validate=O,this.convert=j}optional(){return new t(this.name,`(optional) ${this.description}`,d=>d==null||this.validate(d),d=>d===void 0?void 0:d===null?null:this.convert(d))}with(d,C){return new t(d??this.name,C??this.description,this.validate,this.convert)}}e.ApiCommandArgument=t,t.Uri=new t("uri","Uri of a text document",u=>f.URI.isUri(u),u=>u),t.Position=new t("position","A position in a text document",u=>k.Position.isPosition(u),D.Position.from),t.Range=new t("range","A range in a text document",u=>k.Range.isRange(u),D.Range.from),t.Selection=new t("selection","A selection in a text document",u=>k.Selection.isSelection(u),D.Selection.from),t.Number=new t("number","",u=>typeof u=="number",u=>u),t.String=new t("string","",u=>typeof u=="string",u=>u),t.CallHierarchyItem=new t("item","A call hierarchy item",u=>u instanceof k.CallHierarchyItem,D.CallHierarchyItem.from),t.TypeHierarchyItem=new t("item","A type hierarchy item",u=>u instanceof k.TypeHierarchyItem,D.TypeHierarchyItem.from),t.TestItem=new t("testItem","A VS Code TestItem",u=>u instanceof o.TestItemImpl,D.TestItem.from);class g{constructor(d,C){this.description=d,this.convert=C}}e.ApiCommandResult=g,g.Void=new g("no result",u=>u);class c{constructor(d,C,O,j,Z){this.id=d,this.internalId=C,this.description=O,this.args=j,this.result=Z}}e.ApiCommand=c}),define(Ie[205],Ce([1,0,2,8,7,75,37,18,88,92,15]),function(te,e,r,k,D,N,S,R,y,T,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const E=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",b(k.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,o)=>{if((0,R.isFalsyOrEmpty)(s))return;class l extends D.SymbolInformation{static to(w){const A=new l(w.name,k.SymbolKind.to(w.kind),w.containerName||"",new D.Location(o[0],k.Range.to(w.range)));return A.detail=w.detail,A.range=A.location.range,A.selectionRange=k.Range.to(w.selectionRange),A.children=w.children?w.children.map(l.to):[],A}}return s.map(l.to)})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(k.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(k.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",s=>typeof s=="string",s=>s),new S.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(k.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",b(k.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",b(k.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",s=>Array.isArray(s)&&s.every(o=>D.Position.isPosition(o)),s=>s.map(k.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",s=>s.map(o=>{let l;for(const v of o.reverse())l=new D.SelectionRange(k.Range.to(v),l);return l}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(k.WorkspaceSymbol.to))),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(k.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(k.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(k.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to a range and placeholder text.",s=>{if(!!s)return{range:k.Range.to(s.range),placeholder:s.text}})),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",s=>{if(!!s){if(s.rejectReason)throw new Error(s.rejectReason);return k.WorkspaceEdit.to(s)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(k.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(!!s)return new D.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,y.decodeSemanticTokensDto)(s);if(o.type==="full")return new D.SemanticTokens(o.data,void 0)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range.optional()],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(!!s)return new D.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,y.decodeSemanticTokensDto)(s);if(o.type==="full")return new D.SemanticTokens(o.data,void 0)})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(s,o,l)=>{if(!s)return new D.CompletionList([]);const v=s.suggestions.map(w=>k.CompletionItem.to(w,l));return new D.CompletionList(v,s.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",s=>{if(s)return k.SignatureHelp.to(s)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(s,o,l)=>b(v=>new D.CodeLens(k.Range.to(v.range),v.command&&l.fromInternal(v.command)))(s))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>D.Range.isRange(s),s=>D.Selection.isSelection(s)?k.Selection.from(s):k.Range.from(s)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(s,o,l)=>b(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(v.command)}else{const w=new D.CodeAction(v.title,v.kind?new D.CodeActionKind(v.kind):void 0);return v.edit&&(w.edit=k.WorkspaceEdit.to(v.edit)),v.command&&(w.command=l.fromInternal(v.command)),w.isPreferred=v.isPreferred,w}})(s))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(o=>new D.ColorInformation(k.Range.to(o.range),k.Color.to(o.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",s=>s instanceof D.Color,k.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:k.Range.from(s.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(k.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of Inlay objects",(s,o,l)=>s.map(k.InlayHint.to.bind(void 0,l)))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",b(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(o=>k.NotebookExclusiveDocumentPattern.to(o))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",s=>s.map(k.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new S.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",s=>r.URI.isUri(s)||typeof s=="string"&&(0,T.matchesSomeScheme)(s,M.Schemas.http,M.Schemas.https),s=>s),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[k.ViewColumn.from(s),void 0]:[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[k.ViewColumn.from(s),void 0]:[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)]).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new S.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[S.ApiCommandArgument.TestItem],S.ApiCommandResult.Void),new S.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[S.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],S.ApiCommandResult.Void),new S.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[S.ApiCommandArgument.String.with("name","The context key name"),new S.ApiCommandArgument("value","The context key value",()=>!0,s=>s)],S.ApiCommandResult.Void)];class f{static register(o){E.forEach(o.registerApiCommand,o)}}e.ExtHostApiCommands=f;function b(s){return o=>{if(Array.isArray(o))return o.map(s)}}function m(s){if(!Array.isArray(s))return;const o=[];for(const l of s)N.isLocationLink(l)?o.push(k.DefinitionLink.to(l)):o.push(k.location.to(l));return o}}),define(Ie[206],Ce([1,0,16,63,4,6,2,75,25,8,7,5]),function(te,e,r,k,D,N,S,R,y,T,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function f(b,m,s){const o=b.getProxy(E.MainContext.MainThreadComments);class l{constructor(){this.b=new Map,this.c=new Map,m.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const g=this.b.get(t.handle);return g?g.value:t}else if(t&&t.$mid===7){const g=this.b.get(t.commentControlHandle);if(!g)return t;const c=g.getCommentThread(t.commentThreadHandle);return c?c.value:t}else if(t&&(t.$mid===9||t.$mid===8)){const g=this.b.get(t.thread.commentControlHandle);if(!g)return t;const c=g.getCommentThread(t.thread.commentThreadHandle);return c?t.$mid===8?c.value:{thread:c.value,text:t.text}:t}else if(t&&t.$mid===10){const g=this.b.get(t.thread.commentControlHandle);if(!g)return t;const c=g.getCommentThread(t.thread.commentThreadHandle);if(!c)return t;const u=t.commentUniqueId,d=c.getCommentByUniqueId(u);return d||t}else if(t&&t.$mid===11){const g=this.b.get(t.thread.commentControlHandle);if(!g)return t;const c=g.getCommentThread(t.thread.commentThreadHandle);if(!c)return t;const u=t.text,d=t.commentUniqueId,C=c.getCommentByUniqueId(d);return C?(typeof C.body=="string"?C.body=u:C.body=new M.MarkdownString(u),C):t}return t}})}createCommentController(t,g,c){const u=l.a++,d=new w(t,u,g,c);this.b.set(d.handle,d);const C=this.c.get(y.ExtensionIdentifier.toKey(t.identifier))||[];return C.push(d),this.c.set(y.ExtensionIdentifier.toKey(t.identifier),C),d.value}$createCommentThreadTemplate(t,g,c){const u=this.b.get(t);!u||u.$createCommentThreadTemplate(g,c)}async $updateCommentThreadTemplate(t,g,c){const u=this.b.get(t);!u||u.$updateCommentThreadTemplate(g,c)}$deleteCommentThread(t,g){this.b.get(t)?.$deleteCommentThread(g)}$provideCommentingRanges(t,g,c){const u=this.b.get(t);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const d=s.getDocument(S.URI.revive(g));return(0,r.asPromise)(()=>u.commentingRangeProvider.provideCommentingRanges(d,c)).then(C=>C?C.map(O=>T.Range.from(O)):void 0)}$toggleReaction(t,g,c,u,d){const C=this.b.get(t);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,r.asPromise)(()=>{const O=C.getCommentThread(g);if(O){const j=O.getCommentByUniqueId(u.uniqueIdInThread);if(C!==void 0&&j&&C.reactionHandler)return C.reactionHandler(j,n(d))}return Promise.resolve(void 0)})}dispose(){}}l.a=0;class v{set threadId(t){this.n=t}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(t){t.isEqual(this.p)||(this.p=t,this.b.range=t,this.c.fire())}get range(){return this.p}set canReply(t){this.d!==t&&(this.d=t,this.b.canReply=t,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(t){this.e=t,this.b.label=t,this.c.fire()}get contextValue(){return this.f}set contextValue(t){this.f=t,this.b.contextValue=t,this.c.fire()}get comments(){return this.q}set comments(t){this.q=t,this.b.comments=t,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(t){this.g=t,this.b.collapsibleState=t,this.c.fire()}get state(){return this.h}set state(t){this.h=t,this.b.state=t,this.c.fire()}get isDisposed(){return this.j}constructor(t,g,c,u,d,C,O,j){this.m=g,this.n=c,this.o=u,this.p=d,this.q=C,this.extensionDescription=O,this.r=j,this.handle=v.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new D.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new N.MutableDisposable,this.l.value=new N.DisposableStore,this.n===void 0&&(this.n=`${t}.${this.handle}`),o.$createCommentThread(g,this.handle,this.n,this.o,T.Range.from(this.p),O.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{o.$deleteCommentThread(g,this.handle)}});const Z=this;this.value={get uri(){return Z.uri},get range(){return Z.range},set range(x){Z.range=x},get comments(){return Z.comments},set comments(x){Z.comments=x},get collapsibleState(){return Z.collapsibleState},set collapsibleState(x){Z.collapsibleState=x},get canReply(){return Z.canReply},set canReply(x){Z.canReply=x},get contextValue(){return Z.contextValue},set contextValue(x){Z.contextValue=x},get label(){return Z.label},set label(x){Z.label=x},get state(){return Z.state},set state(x){Z.state=x},dispose:()=>{Z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new N.DisposableStore);const t=c=>Object.prototype.hasOwnProperty.call(this.b,c),g={};t("range")&&(g.range=T.Range.from(this.p)),t("label")&&(g.label=this.label),t("contextValue")&&(g.contextValue=this.contextValue??null),t("comments")&&(g.comments=this.q.map(c=>A(this,c,this.k))),t("collapsibleState")&&(g.collapseState=h(this.g)),t("canReply")&&(g.canReply=this.canReply),t("state")&&(g.state=i(this.h)),t("isTemplate")&&(g.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,g)}getCommentByUniqueId(t){for(const g of this.k){const c=g[0],u=g[1];if(t===u)return c}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(t=>t.dispose())}}v.a=0,qe([(0,k.debounce)(100)],v.prototype,"eventuallyUpdateCommentThread",null);class w{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(t){this.b=t,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(t){this.c=t,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this.d}set options(t){this.d=t,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(t,g,c,u){this.f=t,this.g=g,this.h=c,this.i=u,this.a=new Map,o.$registerCommentController(this.handle,c,u);const d=this;this.value=Object.freeze({id:d.id,label:d.label,get options(){return d.options},set options(C){d.options=C},get commentingRangeProvider(){return d.commentingRangeProvider},set commentingRangeProvider(C){d.commentingRangeProvider=C},get reactionHandler(){return d.reactionHandler},set reactionHandler(C){d.reactionHandler=C},createCommentThread(C,O,j){return d.createCommentThread(C,O,j).value},dispose:()=>{d.dispose()}}),this.e=[],this.e.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(t,g,c,u){if(typeof t=="string"){const d=new v(this.id,this.handle,t,g,c,u,this.f,!1);return this.a.set(d.handle,d),d}else{const d=new v(this.id,this.handle,void 0,t,g,c,this.f,!1);return this.a.set(d.handle,d),d}}$createCommentThreadTemplate(t,g){const c=new v(this.id,this.handle,void 0,S.URI.revive(t),T.Range.to(g),[],this.f,!0);return c.collapsibleState=R.CommentThreadCollapsibleState.Expanded,this.a.set(c.handle,c),c}$updateCommentThreadTemplate(t,g){const c=this.a.get(t);c&&(c.range=T.Range.to(g))}$deleteCommentThread(t){this.a.get(t)?.dispose(),this.a.delete(t)}getCommentThread(t){return this.a.get(t)}dispose(){this.a.forEach(t=>{t.dispose()}),this.e.forEach(t=>t.dispose())}}function A(a,t,g){let c=g.get(t);c||(c=++a.commentHandle,g.set(t,c));const u=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:c,body:typeof t.body=="string"?t.body:T.MarkdownString.from(t.body),userName:t.author.name,userIconPath:u,label:t.label,commentReactions:t.reactions?t.reactions.map(d=>p(d)):void 0,timestamp:t.timestamp?.toJSON()}}function p(a){return{label:a.label,iconPath:a.iconPath?T.pathOrURIToURI(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function n(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?S.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function h(a){if(a!==void 0)switch(a){case M.CommentThreadCollapsibleState.Expanded:return R.CommentThreadCollapsibleState.Expanded;case M.CommentThreadCollapsibleState.Collapsed:return R.CommentThreadCollapsibleState.Collapsed}return R.CommentThreadCollapsibleState.Collapsed}function i(a){if(a!==void 0)switch(a){case M.CommentThreadState.Unresolved:return R.CommentThreadState.Unresolved;case M.CommentThreadState.Resolved:return R.CommentThreadState.Resolved}return R.CommentThreadState.Unresolved}return new l}e.createExtHostComments=f}),define(Ie[207],Ce([1,0,22,5,26,17]),function(te,e,r,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let S=class{constructor(M,E){this.a=M.getProxy(k.MainContext.MainThreadConsole),this.b=E.consoleForward.includeStack,this.c=E.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(M,E){const f=this,b=console[M];Object.defineProperty(console,M,{set:()=>{},get:()=>function(){f.e(M,E,b,arguments)}})}e(M,E,f,b){this.a.$logExtensionHostMessage({type:"__$console",severity:E,arguments:y(b,this.b)}),this.c&&this.f(M,f,b)}};S=qe([je(0,N.IExtHostRpcService),je(1,D.IExtHostInitDataService)],S),e.AbstractExtHostConsoleForwarder=S;const R=1e5;function y(T,M){const E=[];if(T.length)for(let f=0;f<T.length;f++){let b=T[f];if(typeof b>"u")b="undefined";else if(b instanceof Error){const m=b;m.stack?b=m.stack:b=m.toString()}E.push(b)}if(M){const f=new Error().stack;f&&E.push({__$stack:f.split(`
`).slice(3).join(`
`)})}try{const f=(0,r.safeStringify)(E);return f.length>R?"Output omitted for a large object that exceeds the limits":f}catch(f){return`Output omitted for an object that cannot be inspected ('${f.toString()}')`}}}),define(Ie[103],Ce([1,0,2,5,7,3,17,11,18,10,19,27]),function(te,e,r,k,D,N,S,R,y,T,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let f=class Ni{constructor(m,s){this.h=s,this.f=new Map,this.g=m.getProxy(k.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,s){const o=Ni.c++;this.f.set(o,{provider:m,extensionDescription:s}),this.g.$registerDecorationProvider(o,s.identifier.value);const l=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(v=>{if(!v){this.g.$onDidChange(o,null);return}const w=(0,y.asArray)(v);if(w.length<=Ni.d){this.g.$onDidChange(o,w);return}this.h.warn("[Decorations] CAPPING events from decorations provider",s.identifier.value,w.length);const A=w.map(h=>({uri:h,rank:(0,T.count)(h.path,"/")})),p=(0,y.groupBy)(A,(h,i)=>h.rank-i.rank||(0,T.compare)(h.uri.path,i.uri.path)),n=[];e:for(const h of p){let i;for(const a of h){const t=(0,M.dirname)(a.uri.path);if(i!==t&&(i=t,n.push(a.uri)>=Ni.d))break e}}this.g.$onDidChange(o,n)});return new D.Disposable(()=>{l?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(m,s,o){if(!this.f.has(m))return Object.create(null);const l=Object.create(null),{provider:v,extensionDescription:w}=this.f.get(m);return await Promise.all(s.map(async A=>{try{const{uri:p,id:n}=A,h=await Promise.resolve(v.provideFileDecoration(r.URI.revive(p),o));if(!h)return;try{D.FileDecoration.validate(h),h.badge&&typeof h.badge!="string"&&(0,E.checkProposedApiEnabled)(w,"codiconDecoration"),l[n]=[h.propagate,h.tooltip,h.badge,h.color]}catch(i){this.h.warn(`INVALID decoration from extension '${w}': ${i}`)}}catch(p){this.h.error(p)}})),l}};f.c=0,f.d=250,f=qe([je(0,S.IExtHostRpcService),je(1,R.ILogService)],f),e.ExtHostDecorations=f,e.IExtHostDecorations=(0,N.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(te,e,r,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,r):D?D.value=r:e.set(te,r),r},Le=this&&this.__classPrivateFieldGet||function(te,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(te):k?k.value:e.get(te)};define(Ie[208],Ce([1,0,138,91,2,5,7,8,4,11,28,36]),function(te,e,r,k,D,N,S,R,y,T,M,E){"use strict";var f,b,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class s{constructor(v,w,A,p,n,h,i){this.d=v,this.e=w,this.f=A,this.g=p,f.set(this,void 0),b.set(this,void 0),m.set(this,void 0),this.c=!1,Je(this,m,new M.ResourceMap(a=>n.getComparisonKey(a)),"f"),Je(this,f,h,"f"),Je(this,b,i,"f")}dispose(){this.c||(Le(this,b,"f").fire([...Le(this,m,"f").keys()]),Le(this,f,"f")?.$clear(this.e),Le(this,m,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(v,w){if(!v){this.clear();return}this.h();let A=[];if(D.URI.isUri(v)){if(!w){this.delete(v);return}Le(this,m,"f").set(v,w.slice()),A=[v]}else if(Array.isArray(v)){A=[];let n;v=[...v].sort(s.j);for(const h of v){const[i,a]=h;if((!n||i.toString()!==n.toString())&&(n&&Le(this,m,"f").get(n).length===0&&Le(this,m,"f").delete(n),n=i,A.push(i),Le(this,m,"f").set(i,[])),a)Le(this,m,"f").get(i)?.push(...a);else{const t=Le(this,m,"f").get(i);t&&(t.length=0)}}}if(Le(this,b,"f").fire(A),!Le(this,f,"f"))return;const p=[];for(const n of A){let h=[];const i=Le(this,m,"f").get(n);if(i)if(i.length>this.f){h=[];const a=[S.DiagnosticSeverity.Error,S.DiagnosticSeverity.Warning,S.DiagnosticSeverity.Information,S.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(const g of i)if(g.severity===a[t]&&h.push({...R.Diagnostic.from(g),modelVersionId:this.g(n)})===this.f)break e;h.push({severity:k.MarkerSeverity.Info,message:(0,r.localize)(0,null,i.length-this.f),startLineNumber:h[h.length-1].startLineNumber,startColumn:h[h.length-1].startColumn,endLineNumber:h[h.length-1].endLineNumber,endColumn:h[h.length-1].endColumn})}else h=i.map(a=>({...R.Diagnostic.from(a),modelVersionId:this.g(n)}));p.push([n,h])}Le(this,f,"f").$changeMany(this.e,p)}delete(v){this.h(),Le(this,b,"f").fire([v]),Le(this,m,"f").delete(v),Le(this,f,"f")?.$changeMany(this.e,[[v,void 0]])}clear(){this.h(),Le(this,b,"f").fire([...Le(this,m,"f").keys()]),Le(this,m,"f").clear(),Le(this,f,"f")?.$clear(this.e)}forEach(v,w){this.h();for(const[A,p]of this)v.call(w,A,p,this)}*[(f=new WeakMap,b=new WeakMap,m=new WeakMap,Symbol.iterator)](){this.h();for(const v of Le(this,m,"f").keys())yield[v,this.get(v)]}get(v){this.h();const w=Le(this,m,"f").get(v);return Array.isArray(w)?Object.freeze(w.slice(0)):[]}has(v){return this.h(),Array.isArray(Le(this,m,"f").get(v))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(v,w){return v[0].toString()<w[0].toString()?-1:v[0].toString()>w[0].toString()?1:0}}e.DiagnosticCollection=s;let o=class pi{static _mapper(v){const w=new M.ResourceMap;for(const A of v)w.set(A,A);return{uris:Object.freeze(Array.from(w.values()))}}constructor(v,w,A,p){this.h=w,this.j=A,this.k=p,this.f=new Map,this.g=new y.DebounceEmitter({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this.g.event,pi._mapper),this.e=v.getProxy(N.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(v,w){const{f:A,e:p,g:n,h,j:i,k:a}=this,t=new class{$changeMany(u,d){p.$changeMany(u,d),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,u,d.length===0?"CLEARING":d)}$clear(u){p.$clear(u),h.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,u)}dispose(){p.dispose()}};let g;if(!w)w="_generated_diagnostic_collection_name_#"+pi.c++,g=w;else if(!A.has(w))g=w;else{this.h.warn(`DiagnosticCollection with name '${w}' does already exist.`);do g=w+pi.c++;while(A.has(g))}return new class extends s{constructor(){super(w,g,pi.d,u=>a.getDocument(u)?.version,i.extUri,t,n),A.set(g,this)}dispose(){super.dispose(),A.delete(g)}}}getDiagnostics(v){if(v)return this.l(v);{const w=new Map,A=[];for(const p of this.f.values())p.forEach((n,h)=>{let i=w.get(n.toString());typeof i>"u"&&(i=A.length,w.set(n.toString(),i),A.push([n,[]])),A[i][1]=A[i][1].concat(...h)});return A}}l(v){let w=[];for(const A of this.f.values())A.has(v)&&(w=w.concat(A.get(v)));return w}$acceptMarkersChange(v){if(!this.m){const w="_generated_mirror",A=new s(w,w,pi.d,p=>{},this.j.extUri,void 0,this.g);this.f.set(w,A),this.m=A}for(const[w,A]of v)this.m.set(D.URI.revive(w),A.map(R.Diagnostic.to))}};o.c=0,o.d=1e3,o=qe([je(1,T.ILogService),je(2,E.IExtHostFileSystemInfo)],o),e.ExtHostDiagnostics=o}),define(Ie[209],Ce([1,0,2,5]),function(te,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(S){this.a=S.getProxy(k.MainContext.MainThreadDialogs)}showOpenDialog(S){return this.a.$showOpenDialog(S).then(R=>R?R.map(y=>r.URI.revive(y)):void 0)}showSaveDialog(S){return this.a.$showSaveDialog(S).then(R=>R?r.URI.revive(R):void 0)}}e.ExtHostDialogs=D}),define(Ie[210],Ce([1,0,12,2,7,5,15,21,10]),function(te,e,r,k,D,N,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(E,f,b){this.d=f,this.e=b,this.b=new Map,this.c=E.getProxy(N.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,f){if(Object.keys(S.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const b=T.a++;this.b.set(b,f),this.c.$registerTextContentProvider(b,E);let m;return typeof f.onDidChange=="function"&&(m=f.onDidChange(s=>{if(s.scheme!==E){this.e.warn(`Provider for scheme '${E}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}this.d.getDocument(s)&&this.$provideTextDocumentContent(b,s).then(o=>{if(!o&&typeof o!="string")return;const l=this.d.getDocument(s);if(!l)return;const v=(0,y.splitLines)(o);if(!l.equalLines(v))return this.c.$onVirtualDocumentChange(s,o)},r.onUnexpectedError)})),new D.Disposable(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(E,f){const b=this.b.get(E);return b?Promise.resolve(b.provideTextDocumentContent(k.URI.revive(f),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${f.scheme}`))}}e.ExtHostDocumentContentProvider=T,T.a=0}),define(Ie[211],Ce([1,0,4,6,2,5,99,8,9,22,7]),function(te,e,r,k,D,N,S,R,y,T,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class E{constructor(b,m){this.a=new r.Emitter,this.b=new r.Emitter,this.c=new r.Emitter,this.d=new r.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new k.DisposableStore,this.h=new Map,this.f=b.getProxy(N.MainContext.MainThreadDocuments),this.g=m,this.g.onDidRemoveDocuments(s=>{for(const o of s)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const o of s)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const m=this.g.getDocument(b);if(m)return m}getDocument(b){const m=this.getDocumentData(b);if(!m?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return m.document}ensureDocumentData(b){const m=this.g.getDocument(b);if(m)return Promise.resolve(m);let s=this.h.get(b.toString());return s||(s=this.f.$tryOpenDocument(b).then(o=>{this.h.delete(b.toString());const l=D.URI.revive(o);return(0,y.assertIsDefined)(this.g.getDocument(l))},o=>(this.h.delete(b.toString()),Promise.reject(o))),this.h.set(b.toString(),s)),s}createDocumentData(b){return this.f.$tryCreateDocument(b).then(m=>D.URI.revive(m))}$acceptModelLanguageChanged(b,m){const s=D.URI.revive(b),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(m),this.a.fire(o.document)}$acceptModelSaved(b){const m=D.URI.revive(b),s=this.g.getDocument(m);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(b,m){const s=D.URI.revive(b),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");o._acceptIsDirty(m),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,m,s){const o=D.URI.revive(b),l=this.g.getDocument(o);if(!l)throw new Error("unknown document");l._acceptIsDirty(s),l.onEvents(m);let v;m.isUndoing?v=M.TextDocumentChangeReason.Undo:m.isRedoing&&(v=M.TextDocumentChangeReason.Redo),this.c.fire((0,T.deepFreeze)({document:l.document,contentChanges:m.changes.map(w=>({range:R.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text})),reason:v}))}setWordDefinitionFor(b,m){(0,S.setWordDefinitionFor)(b,m)}}e.ExtHostDocuments=E}),define(Ie[57],Ce([1,0,48,4,6,2,3,5,99,17,102,8,11,28,15,183,85]),function(te,e,r,k,D,N,S,R,y,T,M,E,f,b,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class l{constructor(A){this.value=A,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let v=class{constructor(A,p){this.h=A,this.i=p,this.a=null,this.b=new Map,this.c=new b.ResourceMap,this.d=new k.Emitter,this.e=new k.Emitter,this.f=new k.Emitter,this.g=new k.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(A){this.acceptDocumentsAndEditorsDelta(A)}acceptDocumentsAndEditorsDelta(A){const p=[],n=[],h=[];if(A.removedDocuments)for(const i of A.removedDocuments){const a=N.URI.revive(i),t=this.c.get(a);t?.unref()&&(this.c.delete(a),p.push(t.value))}if(A.addedDocuments)for(const i of A.addedDocuments){const a=N.URI.revive(i.uri);let t=this.c.get(a);if(t&&a.scheme!==m.Schemas.vscodeNotebookCell&&a.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${a} already exists!'`);t||(t=new l(new y.ExtHostDocumentData(this.h.getProxy(R.MainContext.MainThreadDocuments),a,i.lines,i.EOL,i.versionId,i.languageId,i.isDirty,i.notebook)),this.c.set(a,t),n.push(t.value)),t.ref()}if(A.removedEditors)for(const i of A.removedEditors){const a=this.b.get(i);this.b.delete(i),a&&h.push(a)}if(A.addedEditors)for(const i of A.addedEditors){const a=N.URI.revive(i.documentUri);r.ok(this.c.has(a),`document '${a}' does not exist`),r.ok(!this.b.has(i.id),`editor '${i.id}' already exists!`);const t=this.c.get(a).value,g=new M.ExtHostTextEditor(i.id,this.h.getProxy(R.MainContext.MainThreadTextEditors),this.i,new o.Lazy(()=>t.document),i.selections.map(E.Selection.to),i.options,i.visibleRanges.map(c=>E.Range.to(c)),typeof i.editorPosition=="number"?E.ViewColumn.to(i.editorPosition):void 0);this.b.set(i.id,g)}A.newActiveEditor!==void 0&&(r.ok(A.newActiveEditor===null||this.b.has(A.newActiveEditor),`active editor '${A.newActiveEditor}' does not exist`),this.a=A.newActiveEditor),(0,D.dispose)(p),(0,D.dispose)(h),A.removedDocuments&&this.e.fire(p),A.addedDocuments&&this.d.fire(n),(A.removedEditors||A.addedEditors)&&this.f.fire(this.allEditors().map(i=>i.value)),A.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(A){return this.c.get(A)?.value}allDocuments(){return s.Iterable.map(this.c.values(),A=>A.value)}getEditor(A){return this.b.get(A)}activeEditor(A){if(!this.a)return;const p=this.b.get(this.a);return A?p:p?.value}allEditors(){return[...this.b.values()]}};v=qe([je(0,T.IExtHostRpcService),je(1,f.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,S.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ie[58],Ce([1,0,8,5,2,4,3,7,17,9,62]),function(te,e,r,k,D,N,S,R,y,T,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,S.createDecorator)("IExtHostEditorTabs");class E{constructor(o,l,v){this.e=v,this.d=l,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,l={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(l)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.TextTabInput(D.URI.revive(this.b.input.uri));case 2:return new R.TextDiffTabInput(D.URI.revive(this.b.input.original),D.URI.revive(this.b.input.modified));case 3:return new R.TextMergeTabInput(D.URI.revive(this.b.input.base),D.URI.revive(this.b.input.input1),D.URI.revive(this.b.input.input2),D.URI.revive(this.b.input.result));case 6:return new R.CustomEditorTabInput(D.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.WebviewEditorTabInput(this.b.input.viewType);case 4:return new R.NotebookEditorTabInput(D.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.NotebookDiffEditorTabInput(D.URI.revive(this.b.input.original),D.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.TerminalEditorTabInput;case 9:return new R.InteractiveWindowInput(D.URI.revive(this.b.input.uri),D.URI.revive(this.b.input.inputBoxUri));default:return}}}class f{constructor(o,l){this.c=[],this.d="",this.b=o,this.e=l;for(const v of o.tabs)v.isActive&&(this.d=v.id),this.c.push(new E(v,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,l={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return r.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(v=>v.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(v=>v.apiObject))}};this.a=Object.freeze(l)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const v=new E(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,v),o.tabDto.isActive&&(this.d=v.tabId),v}else if(o.kind===1){const v=this.c.splice(o.index,1)[0];if(!v)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return v.tabId===this.d&&(this.d=""),v}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const v=this.c.splice(o.oldIndex,1)[0];if(!v)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,v),v}const l=this.c.find(v=>v.tabId===o.tabDto.id);if(!l)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),l.acceptDtoUpdate(o.tabDto),l}activeTabId(){return this.d}}let b=class{constructor(o){this.b=new N.Emitter,this.c=new N.Emitter,this.e=[],this.a=o.getProxy(k.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,l={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(v=>v.apiObject))},get activeTabGroup(){const v=o.d;return(0,T.assertIsDefined)(o.e.find(A=>A.groupId===v)?.apiObject)},close:async(v,w)=>{const A=Array.isArray(v)?v:[v];return A.length?m(A[0])?this.j(A,w):this.i(A,w):!0}};this.f=Object.freeze(l)}return this.f}$acceptEditorTabModel(o){const l=new Set(this.e.map(i=>i.groupId)),v=new Set(o.map(i=>i.groupId)),w=(0,M.diffSets)(l,v),A=this.e.filter(i=>w.removed.includes(i.groupId)).map(i=>i.apiObject),p=[],n=[];this.e=o.map(i=>{const a=new f(i,()=>this.d);return w.added.includes(a.groupId)?p.push(a.apiObject):n.push(a.apiObject),a});const h=(0,T.assertIsDefined)(o.find(i=>i.isActive===!0)?.groupId);h!==void 0&&this.d!==h&&(this.d=h),this.c.fire(Object.freeze({opened:p,closed:A,changed:n}))}$acceptTabGroupUpdate(o){const l=this.e.find(v=>v.groupId===o.groupId);if(!l)throw new Error("Update Group IPC call received before group creation.");l.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[l.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const l=this.e.find(w=>w.groupId===o.groupId);if(!l)throw new Error("Update Tabs IPC call received before group creation.");const v=l.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[v.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[v.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[v.apiObject]}));return}}g(o){for(const l of this.e)for(const v of l.tabs)if(v.apiObject===o)return v}h(o){return this.e.find(l=>l.apiObject===o)}async i(o,l){const v=[];for(const w of o){const A=this.g(w);if(!A)throw new Error("Tab close: Invalid tab not found!");v.push(A.tabId)}return this.a.$closeTab(v,l)}async j(o,l){const v=[];for(const w of o){const A=this.h(w);if(!A)throw new Error("Group close: Invalid group not found!");v.push(A.groupId)}return this.a.$closeGroup(v,l)}};b=qe([je(0,y.IExtHostRpcService)],b),e.ExtHostEditorTabs=b;function m(s){return s.tabs!==void 0}}),define(Ie[212],Ce([1,0,2,5,6,7,8,258,10,23,27]),function(te,e,r,k,D,N,S,R,y,T,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class E{constructor(){this.a=[]}add(m){this.b=void 0,this.a.push(m)}delete(m){const s=this.a.indexOf(m);s>=0&&(this.a.splice(s,1),this.b=void 0)}c(){if(!this.b){const m=this.a.sort(),s=[];let o,l,v=14,w=14;for(const A of m){let p=o?(0,y.commonPrefixLength)(o,A):0;for(p===0?l=1:l=w;p<A.length;p++)p+1===A.length?(v=w,w=9):w+=1,s.push([l,A.toUpperCase().charCodeAt(p),w]),s.push([l,A.toLowerCase().charCodeAt(p),w]),l=w;o=A,w=v}s.push([9,58,10]),s.push([10,47,12]),this.b=new R.StateMachine(s)}}provideDocumentLinks(m){this.c();const s=[],o=R.LinkComputer.computeLinks({getLineContent(l){return m.lineAt(l-1).text},getLineCount(){return m.lineCount}},this.b);for(const l of o){const v=S.DocumentLink.to(l);v.target&&s.push(v)}return s}}class f{constructor(m,s){this.i=s,this.b=new E,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=m.getProxy(k.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(m,s,o,l={}){if(this.d.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(m,"*",this.b));const v=this.h++;this.b.add(s),this.d.add(s),this.c.set(v,o);let w=2;l.isCaseSensitive&&(w+=1024),l.isReadonly&&(w+=2048),typeof o.copy=="function"&&(w+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,M.checkProposedApiEnabled)(m,"fsChunks"),w+=4),this.a.$registerFileSystemProvider(v,s,w).catch(p=>{console.error(`FAILED to register filesystem provider of ${m.identifier.value}-extension for the scheme ${s}`),console.error(p)});const A=o.onDidChangeFile(p=>{const n=[];for(const h of p){const{uri:i,type:a}=h;if(i.scheme!==s)continue;let t;switch(a){case N.FileChangeType.Changed:t=0;break;case N.FileChangeType.Created:t=1;break;case N.FileChangeType.Deleted:t=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:i,type:t})}this.a.$onFileSystemChange(v,n)});return(0,D.toDisposable)(()=>{A.dispose(),this.b.delete(s),this.d.delete(s),this.c.delete(v),this.a.$unregisterProvider(v)})}static j(m){const{type:s,ctime:o,mtime:l,size:v,permissions:w}=m;return{type:s,ctime:o,mtime:l,size:v,permissions:w}}$stat(m,s){return Promise.resolve(this.k(m).stat(r.URI.revive(s))).then(o=>f.j(o))}$readdir(m,s){return Promise.resolve(this.k(m).readDirectory(r.URI.revive(s)))}$readFile(m,s){return Promise.resolve(this.k(m).readFile(r.URI.revive(s))).then(o=>T.VSBuffer.wrap(o))}$writeFile(m,s,o,l){return Promise.resolve(this.k(m).writeFile(r.URI.revive(s),o.buffer,l))}$delete(m,s,o){return Promise.resolve(this.k(m).delete(r.URI.revive(s),o))}$rename(m,s,o,l){return Promise.resolve(this.k(m).rename(r.URI.revive(s),r.URI.revive(o),l))}$copy(m,s,o,l){const v=this.k(m);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(r.URI.revive(s),r.URI.revive(o),l))}$mkdir(m,s){return Promise.resolve(this.k(m).createDirectory(r.URI.revive(s)))}$watch(m,s,o,l){const v=this.k(m).watch(r.URI.revive(o),l);this.f.set(s,v)}$unwatch(m,s){const o=this.f.get(s);o&&(o.dispose(),this.f.delete(s))}$open(m,s,o){const l=this.k(m);if(!l.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(l.open(r.URI.revive(s),o))}$close(m,s){const o=this.k(m);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(s))}$read(m,s,o,l){const v=this.k(m);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const w=T.VSBuffer.alloc(l);return Promise.resolve(v.read(s,o,w.buffer,0,l)).then(A=>w.slice(0,A))}$write(m,s,o,l){const v=this.k(m);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(s,o,l.buffer,0,l.byteLength))}k(m){const s=this.c.get(m);if(!s){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return s}}e.ExtHostFileSystem=f}),define(Ie[59],Ce([1,0,5,43,7,23,3,17,36,6]),function(te,e,r,k,D,N,S,R,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let M=class _t{constructor(f,b){this.b=new Map,this.a=f.getProxy(r.MainContext.MainThreadFileSystem);const m=this;this.value=Object.freeze({async stat(s){try{const o=m.b.get(s.scheme);if(!o)return await m.a.$stat(s);await m.a.$ensureActivation(s.scheme);const l=await o.stat(s);return{type:l.type,ctime:l.ctime,mtime:l.mtime,size:l.size,permissions:l.permissions}}catch(o){_t.c(o)}},async readDirectory(s){try{const o=m.b.get(s.scheme);return o?(await m.a.$ensureActivation(s.scheme),(await o.readDirectory(s)).slice()):await m.a.$readdir(s)}catch(o){return _t.c(o)}},async createDirectory(s){try{return await m.a.$mkdir(s)}catch(o){return _t.c(o)}},async readFile(s){try{const o=m.b.get(s.scheme);return o?(await m.a.$ensureActivation(s.scheme),(await o.readFile(s)).slice()):(await m.a.$readFile(s)).buffer}catch(o){return _t.c(o)}},async writeFile(s,o){try{return await m.a.$writeFile(s,N.VSBuffer.wrap(o))}catch(l){return _t.c(l)}},async delete(s,o){try{const l=m.b.get(s.scheme);return l?(await m.a.$ensureActivation(s.scheme),await l.delete(s,{recursive:!1,...o})):await m.a.$delete(s,{recursive:!1,useTrash:!1,...o})}catch(l){return _t.c(l)}},async rename(s,o,l){try{return await m.a.$rename(s,o,{overwrite:!1,...l})}catch(v){return _t.c(v)}},async copy(s,o,l){try{return await m.a.$copy(s,o,{overwrite:!1,...l})}catch(v){return _t.c(v)}},isWritableFileSystem(s){const o=b.getCapabilities(s);if(typeof o=="number")return!(o&2048)}})}static c(f){if(f instanceof D.FileSystemError)throw f;if(!(f instanceof Error))throw new D.FileSystemError(String(f));if(f.name==="ENOPRO"||f.message.includes("ENOPRO"))throw D.FileSystemError.Unavailable(f.message);switch(f.name){case k.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(f.message);case k.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(f.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(f.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(f.message);case k.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(f.message);case k.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(f.message);default:throw new D.FileSystemError(f.message,f.name)}}addFileSystemProvider(f,b){return this.b.set(f,b),(0,T.toDisposable)(()=>this.b.delete(f))}};M=qe([je(0,R.IExtHostRpcService),je(1,y.IExtHostFileSystemInfo)],M),e.ExtHostConsumerFileSystem=M,e.IExtHostConsumerFileSystem=(0,S.createDecorator)("IExtHostConsumerFileSystem")}),define(Ie[213],Ce([1,0,4,35,2,5,8,7]),function(te,e,r,k,D,N,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(E,f,b,m,s,o,l,v){this.a=new r.Emitter,this.b=new r.Emitter,this.c=new r.Emitter;const w=this.h(E,b,s);this.g=0,o&&(this.g+=1),l&&(this.g+=2),v&&(this.g+=4);const A=(0,k.parse)(s),p=typeof s=="string",n=m(h=>{if(!o)for(const i of h.created){const a=D.URI.revive(i);A(a.fsPath)&&(!p||f.getWorkspaceFolder(a))&&this.a.fire(a)}if(!l)for(const i of h.changed){const a=D.URI.revive(i);A(a.fsPath)&&(!p||f.getWorkspaceFolder(a))&&this.b.fire(a)}if(!v)for(const i of h.deleted){const a=D.URI.revive(i);A(a.fsPath)&&(!p||f.getWorkspaceFolder(a))&&this.c.fire(a)}});this.d=R.Disposable.from(w,this.a,this.b,this.c,n)}h(E,f,b){const m=R.Disposable.from();if(typeof b=="string")return m;const s=E.getProxy(N.MainContext.MainThreadFileSystem);let o=!1;(b.pattern.includes(k.GLOBSTAR)||b.pattern.includes(k.GLOB_SPLIT))&&(o=!0);const l=Math.random();return s.$watch(f.identifier.value,l,b.baseUri,{recursive:o,excludes:[]}),R.Disposable.from({dispose:()=>s.$unwatch(l)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class T{constructor(E,f,b){this.j=E,this.k=f,this.l=b,this.a=new r.Emitter,this.b=new r.Emitter,this.c=new r.Emitter,this.d=new r.Emitter,this.g=new r.AsyncEmitter,this.h=new r.AsyncEmitter,this.i=new r.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(E,f,b,m,s,o){return new y(this.j,E,f,this.a.event,S.GlobPattern.from(b),m,s,o)}$onFileEvent(E){this.a.fire(E)}$onDidRunFileOperation(E,f){switch(E){case 2:this.b.fire(Object.freeze({files:f.map(b=>({oldUri:D.URI.revive(b.source),newUri:D.URI.revive(b.target)}))}));break;case 1:this.d.fire(Object.freeze({files:f.map(b=>D.URI.revive(b.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:f.map(b=>D.URI.revive(b.target))}));break;default:}}getOnWillRenameFileEvent(E){return this.m(E,this.g)}getOnWillCreateFileEvent(E){return this.m(E,this.h)}getOnWillDeleteFileEvent(E){return this.m(E,this.i)}m(E,f){return(b,m,s)=>{const o=function(v){b.call(m,v)};return o.extension=E,f.event(o,void 0,s)}}async $onWillRunFileOperation(E,f,b,m){switch(E){case 2:return await this.n(this.g,{files:f.map(s=>({oldUri:D.URI.revive(s.source),newUri:D.URI.revive(s.target)}))},b,m);case 1:return await this.n(this.i,{files:f.map(s=>D.URI.revive(s.target))},b,m);case 0:case 3:return await this.n(this.h,{files:f.map(s=>D.URI.revive(s.target))},b,m)}}async n(E,f,b,m){const s=new Set,o=[];if(await E.fireAsync(f,m,async(v,w)=>{const A=Date.now(),p=await Promise.resolve(v);p instanceof R.WorkspaceEdit&&(o.push([w.extension,p]),s.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-A>b&&this.k.warn("SLOW file-participant",w.extension.identifier)}),m.isCancellationRequested||o.length===0)return;const l={edits:[]};for(const[,v]of o){const{edits:w}=S.WorkspaceEdit.from(v,{getTextDocumentVersion:A=>this.l.getDocument(A)?.version,getNotebookDocumentVersion:()=>{}});l.edits=l.edits.concat(w)}return{edit:l,extensionNames:Array.from(s)}}}e.ExtHostFileSystemEventService=T}),define(Ie[214],Ce([1,0,2,37]),function(te,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(S,R,y,T,M){this.a=R,this.b=y,this.c=T;const E=new k.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new k.ApiCommandArgument("showOptions","Show Options",f=>!0,f=>f),new k.ApiCommandArgument("resource","Interactive resource Uri",f=>!0,f=>f),new k.ApiCommandArgument("controllerId","Notebook controller Id",f=>!0,f=>f),new k.ApiCommandArgument("title","Interactive editor title",f=>!0,f=>f)],new k.ApiCommandResult("Notebook and input URI",f=>{if(M.debug("[ExtHostInteractive] open iw with notebook editor id",f.notebookEditorId),f.notebookEditorId!==void 0){const b=this.a.getEditorById(f.notebookEditorId);return M.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:r.URI.revive(f.notebookUri),inputUri:r.URI.revive(f.inputUri),notebookEditor:b.apiEditor}}return M.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",f.notebookUri,f.inputUri),{notebookUri:r.URI.revive(f.notebookUri),inputUri:r.URI.revive(f.inputUri)}}));this.c.registerApiCommand(E)}$willAddInteractiveDocument(S,R,y,T){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:y,uri:S,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(r.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(S,R){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[S]})}}e.ExtHostInteractive=D}),define(Ie[215],Ce([1,0,6,5]),function(te,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(S){this.b=0,this.a=S.getProxy(k.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(S){const R=this.b++;return this.a.$registerResourceLabelFormatter(R,S),(0,r.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(R)})}}e.ExtHostLabelService=D}),define(Ie[216],Ce([1,0,2,22,8,7,75,5,10,56,18,9,259,21,6,88,83,53,77,12,16,27]),function(te,e,r,k,D,N,S,R,y,T,M,E,f,b,m,s,o,l,v,w,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class n{constructor(I,B){this.d=I,this.e=B}async provideDocumentSymbols(I,B){const W=this.d.getDocument(I),K=await this.e.provideDocumentSymbols(W,B);if(!(0,M.isFalsyOrEmpty)(K))return K[0]instanceof N.DocumentSymbol?K.map(D.DocumentSymbol.from):n.f(K)}static f(I){I=I.slice(0).sort((K,ee)=>{let he=K.location.range.start.compareTo(ee.location.range.start);return he===0&&(he=ee.location.range.end.compareTo(K.location.range.end)),he});const B=[],W=[];for(const K of I){const ee={name:K.name||"!!MISSING: name!!",kind:D.SymbolKind.from(K.kind),tags:K.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:K.containerName,range:D.Range.from(K.location.range),selectionRange:D.Range.from(K.location.range),children:[]};for(;;){if(W.length===0){W.push(ee),B.push(ee);break}const he=W[W.length-1];if(T.Range.containsRange(he.range,ee.range)&&!T.Range.equalsRange(he.range,ee.range)){he.children?.push(ee),W.push(ee);break}W.pop()}}return B}}class h{constructor(I,B,W){this.g=I,this.h=B,this.j=W,this.e=new l.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(I,B){const W=this.g.getDocument(I),K=await this.j.provideCodeLenses(W,B);if(!K||B.isCancellationRequested)return;const ee=this.e.add(K),he=new m.DisposableStore;this.f.set(ee,he);const ye={cacheId:ee,lenses:[]};for(let ae=0;ae<K.length;ae++)ye.lenses.push({cacheId:[ee,ae],range:D.Range.from(K[ae].range),command:this.h.toInternal(K[ae].command,he)});return ye}async resolveCodeLens(I,B){const W=I.cacheId&&this.e.get(...I.cacheId);if(!W)return;let K;if(typeof this.j.resolveCodeLens!="function"||W.isResolved?K=W:K=await this.j.resolveCodeLens(W,B),K||(K=W),B.isCancellationRequested)return;const ee=I.cacheId&&this.f.get(I.cacheId[0]);if(!!ee)return I.command=this.h.toInternal(K.command??h.d,ee),I}releaseCodeLenses(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}}h.d={command:"missing",title:"!!MISSING: command!!"};function i(J){return Array.isArray(J)?J.map(D.DefinitionLink.from):J?[D.DefinitionLink.from(J)]:[]}class a{constructor(I,B){this.d=I,this.e=B}async provideDefinition(I,B,W){const K=this.d.getDocument(I),ee=D.Position.to(B),he=await this.e.provideDefinition(K,ee,W);return i(he)}}class t{constructor(I,B){this.d=I,this.e=B}async provideDeclaration(I,B,W){const K=this.d.getDocument(I),ee=D.Position.to(B),he=await this.e.provideDeclaration(K,ee,W);return i(he)}}class g{constructor(I,B){this.d=I,this.e=B}async provideImplementation(I,B,W){const K=this.d.getDocument(I),ee=D.Position.to(B),he=await this.e.provideImplementation(K,ee,W);return i(he)}}class c{constructor(I,B){this.d=I,this.e=B}async provideTypeDefinition(I,B,W){const K=this.d.getDocument(I),ee=D.Position.to(B),he=await this.e.provideTypeDefinition(K,ee,W);return i(he)}}class u{constructor(I,B){this.d=I,this.e=B}async provideHover(I,B,W){const K=this.d.getDocument(I),ee=D.Position.to(B),he=await this.e.provideHover(K,ee,W);if(!(!he||(0,M.isFalsyOrEmpty)(he.contents)))return he.range||(he.range=K.getWordRangeAtPosition(ee)),he.range||(he.range=new N.Range(ee,ee)),D.Hover.from(he)}}class d{constructor(I,B){this.d=I,this.e=B}async provideEvaluatableExpression(I,B,W){const K=this.d.getDocument(I),ee=D.Position.to(B),he=await this.e.provideEvaluatableExpression(K,ee,W);if(he)return D.EvaluatableExpression.from(he)}}class C{constructor(I,B){this.d=I,this.e=B}async provideInlineValues(I,B,W,K){const ee=this.d.getDocument(I),he=await this.e.provideInlineValues(ee,D.Range.to(B),D.InlineValueContext.to(W),K);if(Array.isArray(he))return he.map(ye=>D.InlineValue.from(ye))}}class O{constructor(I,B){this.d=I,this.e=B}async provideDocumentHighlights(I,B,W){const K=this.d.getDocument(I),ee=D.Position.to(B),he=await this.e.provideDocumentHighlights(K,ee,W);if(Array.isArray(he))return he.map(D.DocumentHighlight.from)}}class j{constructor(I,B){this.d=I,this.e=B}async provideLinkedEditingRanges(I,B,W){const K=this.d.getDocument(I),ee=D.Position.to(B),he=await this.e.provideLinkedEditingRanges(K,ee,W);if(he&&Array.isArray(he.ranges))return{ranges:(0,M.coalesce)(he.ranges.map(D.Range.from)),wordPattern:he.wordPattern}}}class Z{constructor(I,B){this.d=I,this.e=B}async provideReferences(I,B,W,K){const ee=this.d.getDocument(I),he=D.Position.to(B),ye=await this.e.provideReferences(ee,he,W,K);if(Array.isArray(ye))return ye.map(D.location.from)}}class x{constructor(I,B,W,K,ee,he,ye){this.g=I,this.h=B,this.j=W,this.k=K,this.l=ee,this.m=he,this.n=ye,this.e=new l.Cache("CodeAction"),this.f=new Map}async provideCodeActions(I,B,W,K){const ee=this.g.getDocument(I),he=f.Selection.isISelection(B)?D.Selection.to(B):D.Range.to(B),ye=[];for(const tt of this.j.getDiagnostics(I))if(he.intersection(tt.range)&&ye.push(tt)>x.d)break;const ae={diagnostics:ye,only:W.only?new N.CodeActionKind(W.only):void 0,triggerKind:D.CodeActionTriggerKind.to(W.trigger)},be=await this.k.provideCodeActions(ee,he,ae,K);if(!(0,M.isNonEmptyArray)(be)||K.isCancellationRequested)return;const Ee=this.e.add(be),We=new m.DisposableStore;this.f.set(Ee,We);const Ve=[];for(let tt=0;tt<be.length;tt++){const Xe=be[tt];!Xe||(x.o(Xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),Ve.push({_isSynthetic:!0,title:Xe.title,command:this.h.toInternal(Xe,We)})):(ae.only&&(Xe.kind?ae.only.contains(Xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ae.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ve.push({cacheId:[Ee,tt],title:Xe.title,command:Xe.command&&this.h.toInternal(Xe.command,We),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(D.Diagnostic.from),edit:Xe.edit&&D.WorkspaceEdit.from(Xe.edit,void 0),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:Ee,actions:Ve}}async resolveCodeAction(I,B){const[W,K]=I,ee=this.e.get(W,K);if(!ee||x.o(ee)||!this.k.resolveCodeAction)return;const he=await this.k.resolveCodeAction(ee,B)??ee;return he?.edit?D.WorkspaceEdit.from(he.edit,void 0):void 0}releaseCodeActions(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}static o(I){return typeof I.command=="string"&&typeof I.title=="string"}}x.d=1e3;class L{constructor(I,B,W,K){this.d=I,this.e=B,this.f=W,this.g=K}async prepareDocumentPaste(I,B,W,K){if(!this.f.prepareDocumentPaste)return;const ee=this.e.getDocument(I),he=B.map(ae=>D.Range.to(ae)),ye=D.DataTransfer.toDataTransfer(W,()=>{throw new w.NotImplementedError});return await this.f.prepareDocumentPaste(ee,he,ye,K),D.DataTransfer.toDataTransferDTO(ye)}async providePasteEdits(I,B,W,K,ee){const he=this.e.getDocument(B),ye=W.map(Ee=>D.Range.to(Ee)),ae=D.DataTransfer.toDataTransfer(K,async Ee=>(await this.d.$resolvePasteFileData(this.g,I,Ee)).buffer),be=await this.f.provideDocumentPasteEdits(he,ye,ae,ee);if(!!be)return{insertText:typeof be.insertText=="string"?be.insertText:{snippet:be.insertText.value},additionalEdit:be.additionalEdit?D.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}}class ${constructor(I,B){this.d=I,this.e=B}async provideDocumentFormattingEdits(I,B,W){const K=this.d.getDocument(I),ee=await this.e.provideDocumentFormattingEdits(K,B,W);if(Array.isArray(ee))return ee.map(D.TextEdit.from)}}class P{constructor(I,B){this.d=I,this.e=B}async provideDocumentRangeFormattingEdits(I,B,W,K){const ee=this.d.getDocument(I),he=D.Range.to(B),ye=await this.e.provideDocumentRangeFormattingEdits(ee,he,W,K);if(Array.isArray(ye))return ye.map(D.TextEdit.from)}}class F{constructor(I,B){this.d=I,this.e=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(I,B,W,K,ee){const he=this.d.getDocument(I),ye=D.Position.to(B),ae=await this.e.provideOnTypeFormattingEdits(he,ye,W,K,ee);if(Array.isArray(ae))return ae.map(D.TextEdit.from)}}class V{constructor(I,B){this.e=I,this.f=B,this.d=new l.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(I,B){const W=await this.e.provideWorkspaceSymbols(I,B);if(!(0,M.isNonEmptyArray)(W))return{symbols:[]};const K=this.d.add(W),ee={cacheId:K,symbols:[]};for(let he=0;he<W.length;he++){const ye=W[he];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}ee.symbols.push({...D.WorkspaceSymbol.from(ye),cacheId:[K,he]})}return ee}async resolveWorkspaceSymbol(I,B){if(typeof this.e.resolveWorkspaceSymbol!="function"||!I.cacheId)return I;const W=this.d.get(...I.cacheId);if(W){const K=await this.e.resolveWorkspaceSymbol(W,B);return K&&(0,k.mixin)(I,D.WorkspaceSymbol.from(K),!0)}}releaseWorkspaceSymbols(I){this.d.delete(I)}}class q{static supportsResolving(I){return typeof I.prepareRename=="function"}constructor(I,B,W){this.d=I,this.e=B,this.f=W}async provideRenameEdits(I,B,W,K){const ee=this.d.getDocument(I),he=D.Position.to(B);try{const ye=await this.e.provideRenameEdits(ee,he,W,K);return ye?D.WorkspaceEdit.from(ye):void 0}catch(ye){const ae=q.g(ye);return ae?{rejectReason:ae,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(I,B,W){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const K=this.d.getDocument(I),ee=D.Position.to(B);try{const he=await this.e.prepareRename(K,ee,W);let ye,ae;if(N.Range.isRange(he)?(ye=he,ae=K.getText(he)):(0,E.isObject)(he)&&(ye=he.range,ae=he.placeholder),!ye||!ae)return;if(ye.start.line>ee.line||ye.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(ye),text:ae}}catch(he){const ye=q.g(he);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(he)}}static g(I){return typeof I=="string"?I:I instanceof Error&&typeof I.message=="string"?I.message:void 0}}class le{constructor(I,B){this.resultId=I,this.tokens=B}}class _{constructor(I,B){this.f=I,this.g=B,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(I,B,W){const K=this.f.getDocument(I),ee=B!==0?this.d.get(B):null;let he=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(K,ee.resultId,W):await this.g.provideDocumentSemanticTokens(K,W);return ee&&this.d.delete(B),he?(he=_.h(he),this.o(_.n(ee,he),he)):null}async releaseDocumentSemanticColoring(I){this.d.delete(I)}static h(I){return _.j(I)?_.k(I)?I:new N.SemanticTokens(new Uint32Array(I.data),I.resultId):_.l(I)?_.m(I)?I:new N.SemanticTokensEdits(I.edits.map(B=>new N.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),I.resultId):I}static j(I){return I&&!!I.data}static k(I){return I.data instanceof Uint32Array}static l(I){return I&&Array.isArray(I.edits)}static m(I){for(const B of I.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static n(I,B){if(!_.j(B)||!I||!I.tokens)return B;const W=I.tokens,K=W.length,ee=B.data,he=ee.length;let ye=0;const ae=Math.min(K,he);for(;ye<ae&&W[ye]===ee[ye];)ye++;if(ye===K&&ye===he)return new N.SemanticTokensEdits([],B.resultId);let be=0;const Ee=ae-ye;for(;be<Ee&&W[K-be-1]===ee[he-be-1];)be++;return new N.SemanticTokensEdits([{start:ye,deleteCount:K-ye-be,data:ee.subarray(ye,he-be)}],B.resultId)}o(I,B){if(_.j(I)){const W=this.e++;return this.d.set(W,new le(I.resultId,I.data)),(0,s.encodeSemanticTokensDto)({id:W,type:"full",data:I.data})}if(_.l(I)){const W=this.e++;return _.j(B)?this.d.set(W,new le(B.resultId,B.data)):this.d.set(W,new le(I.resultId)),(0,s.encodeSemanticTokensDto)({id:W,type:"delta",deltas:(I.edits||[]).map(K=>({start:K.start,deleteCount:K.deleteCount,data:K.data}))})}return null}}class pe{constructor(I,B){this.d=I,this.e=B}async provideDocumentRangeSemanticTokens(I,B,W){const K=this.d.getDocument(I),ee=await this.e.provideDocumentRangeSemanticTokens(K,D.Range.to(B),W);return ee?this.f(ee):null}f(I){return(0,s.encodeSemanticTokensDto)({id:0,type:"full",data:I.data})}}class ue{static supportsResolving(I){return typeof I.resolveCompletionItem=="function"}constructor(I,B,W,K,ee){this.f=I,this.g=B,this.h=W,this.j=K,this.k=ee,this.d=new l.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(I,B,W,K){const ee=this.f.getDocument(I),he=D.Position.to(B),ye=ee.getWordRangeAtPosition(he)||new N.Range(he,he),ae=ye.with({end:he}),be=new v.StopWatch(!0),Ee=await this.h.provideCompletionItems(ee,he,K,D.CompletionContext.to(W));if(!Ee||K.isCancellationRequested)return;const We=Array.isArray(Ee)?new N.CompletionList(Ee):Ee,Ve=ue.supportsResolving(this.h)?this.d.add(We.items):this.d.add([]),tt=new m.DisposableStore;this.e.set(Ve,tt);const Xe=[],et={x:Ve,b:Xe,a:{replace:D.Range.from(ye),insert:D.Range.from(ae)},c:We.isIncomplete||void 0,d:be.elapsed()};for(let it=0;it<We.items.length;it++){const dt=We.items[it],Fe=this.l(dt,[Ve,it],ae,ye);Xe.push(Fe)}return et}async resolveCompletionItem(I,B){if(typeof this.h.resolveCompletionItem!="function")return;const W=this.d.get(...I);if(!W)return;const K=await this.h.resolveCompletionItem(W,B);if(!!K)return this.l(K,I)}releaseCompletionItems(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,B,W,K){const ee=this.e.get(B[0]);if(!ee)throw Error("DisposableStore is missing...");const he=this.g.toInternal(I.command,ee),ye={x:B,a:I.label,b:I.kind!==void 0?D.CompletionItemKind.from(I.kind):void 0,m:I.tags&&I.tags.map(D.CompletionItemTag.from),c:I.detail,d:typeof I.documentation>"u"?void 0:D.MarkdownString.fromStrict(I.documentation),e:I.sortText!==I.label?I.sortText:void 0,f:I.filterText!==I.label?I.filterText:void 0,g:I.preselect||void 0,i:I.keepWhitespace?1:0,k:I.commitCharacters?.join(""),l:I.additionalTextEdits&&I.additionalTextEdits.map(D.TextEdit.from),n:he?.$ident,o:he?.id,p:he?.$ident?void 0:he?.arguments};I.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=I.textEdit.newText):typeof I.insertText=="string"?ye.h=I.insertText:I.insertText instanceof N.SnippetString&&(ye.h=I.insertText.value,ye.i|=4);let ae;return I.textEdit?ae=I.textEdit.range:I.range&&(ae=I.range),N.Range.isRange(ae)?ye.j=D.Range.from(ae):ae&&(!W?.isEqual(ae.inserting)||!K?.isEqual(ae.replacing))&&(ye.j={insert:D.Range.from(ae.inserting),replace:D.Range.from(ae.replacing)}),ye}}class de{async provideInlineCompletions(I,B,W,K){}disposeCompletions(I){}handleDidShowCompletionItem(I,B){}}class re extends de{constructor(I,B,W,K){super(),this.f=I,this.g=B,this.h=W,this.j=K,this.d=new G,this.e=(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[S.InlineCompletionTriggerKind.Automatic]:N.InlineCompletionTriggerKind.Automatic,[S.InlineCompletionTriggerKind.Explicit]:N.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(I,B,W,K){const ee=this.g.getDocument(I),he=D.Position.to(B),ye=await this.h.provideInlineCompletionItems(ee,he,{selectedCompletionInfo:W.selectedSuggestionInfo?{range:D.Range.to(W.selectedSuggestionInfo.range),text:W.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[W.triggerKind]},K);if(!ye||K.isCancellationRequested)return;const ae=Array.isArray(ye)?ye:ye.items,be=this.e?Array.isArray(ye)?[]:ye.commands||[]:[];let Ee;return{pid:this.d.createReferenceId({dispose(){Ee?.dispose()},items:ae}),items:ae.map((Ve,tt)=>{let Xe;Ve.command&&(Ee||(Ee=new m.DisposableStore),Xe=this.j.toInternal(Ve.command,Ee));const et=Ve.insertText;return{insertText:typeof et=="string"?et:{snippet:et.value},filterText:Ve.filterText,range:Ve.range?D.Range.from(Ve.range):void 0,command:Xe,idx:tt,completeBracketPairs:this.e?Ve.completeBracketPairs:!1}}),commands:be.map(Ve=>(Ee||(Ee=new m.DisposableStore),this.j.toInternal(Ve,Ee)))}}disposeCompletions(I){this.d.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,B){const W=this.d.get(I)?.items[B];W&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(W)}}class G{constructor(){this.d=new Map,this.e=1}createReferenceId(I){const B=this.e++;return this.d.set(B,I),B}disposeReferenceId(I){const B=this.d.get(I);return this.d.delete(I),B}get(I){return this.d.get(I)}}class H{constructor(I,B){this.e=I,this.f=B,this.d=new l.Cache("SignatureHelp")}async provideSignatureHelp(I,B,W,K){const ee=this.e.getDocument(I),he=D.Position.to(B),ye=this.g(W),ae=await this.f.provideSignatureHelp(ee,he,K,ye);if(ae){const be=this.d.add([ae]);return{...D.SignatureHelp.from(ae),id:be}}}g(I){let B;if(I.activeSignatureHelp){const W=D.SignatureHelp.to(I.activeSignatureHelp),K=this.d.get(I.activeSignatureHelp.id,0);K?(B=K,B.activeSignature=W.activeSignature,B.activeParameter=W.activeParameter):B=W}return{...I,activeSignatureHelp:B}}releaseSignatureHelp(I){this.d.delete(I)}}class oe{constructor(I,B,W,K,ee){this.f=I,this.g=B,this.h=W,this.j=K,this.k=ee,this.d=new l.Cache("InlayHints"),this.e=new Map}async provideInlayHints(I,B,W){const K=this.f.getDocument(I),ee=D.Range.to(B),he=await this.h.provideInlayHints(K,ee,W);if(!Array.isArray(he)||he.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${B}`);return}if(W.isCancellationRequested)return;const ye=this.d.add(he);this.e.set(ye,new m.DisposableStore);const ae={hints:[],cacheId:ye};for(let be=0;be<he.length;be++)this.l(he[be],ee)&&ae.hints.push(this.m(he[be],[ye,be]));return this.j.trace(`[InlayHints] ${ae.hints.length} inlay hints from '${this.k.identifier.value}' for ${B}`),ae}async resolveInlayHint(I,B){if(typeof this.h.resolveInlayHint!="function")return;const W=this.d.get(...I);if(!W)return;const K=await this.h.resolveInlayHint(W,B);if(!!K&&!!this.l(K))return this.m(K,I)}releaseHints(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,B){return I.label.length===0||Array.isArray(I.label)&&I.label.every(W=>W.value.length===0)?(console.log("INVALID inlay hint, empty label",I),!1):!(B&&!B.contains(I.position))}m(I,B){const W=this.e.get(B[0]);if(!W)throw Error("DisposableStore is missing...");const K={label:"",cacheId:B,tooltip:D.MarkdownString.fromStrict(I.tooltip),position:D.Position.from(I.position),textEdits:I.textEdits&&I.textEdits.map(D.TextEdit.from),kind:I.kind&&D.InlayHintKind.from(I.kind),paddingLeft:I.paddingLeft,paddingRight:I.paddingRight};return typeof I.label=="string"?K.label=I.label:K.label=I.label.map(ee=>{const he={label:ee.value};return he.tooltip=D.MarkdownString.fromStrict(ee.tooltip),N.Location.isLocation(ee.location)&&(he.location=D.location.from(ee.location)),ee.command&&(he.command=this.g.toInternal(ee.command,W)),he}),K}}class ve{constructor(I,B){this.e=I,this.f=B,this.d=new l.Cache("DocumentLink")}async provideLinks(I,B){const W=this.e.getDocument(I),K=await this.f.provideDocumentLinks(W,B);if(!(!Array.isArray(K)||K.length===0)&&!B.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:K.filter(ve.g).map(D.DocumentLink.from)};{const ee=this.d.add(K),he={links:[],cacheId:ee};for(let ye=0;ye<K.length;ye++){if(!ve.g(K[ye]))continue;const ae=D.DocumentLink.from(K[ye]);ae.cacheId=[ee,ye],he.links.push(ae)}return he}}}static g(I){return I.target&&I.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(I,B){if(typeof this.f.resolveDocumentLink!="function")return;const W=this.d.get(...I);if(!W)return;const K=await this.f.resolveDocumentLink(W,B);if(!(!K||!ve.g(K)))return D.DocumentLink.from(K)}releaseLinks(I){this.d.delete(I)}}class Ae{constructor(I,B){this.d=I,this.e=B}async provideColors(I,B){const W=this.d.getDocument(I),K=await this.e.provideDocumentColors(W,B);return Array.isArray(K)?K.map(he=>({color:D.Color.from(he.color),range:D.Range.from(he.range)})):[]}async provideColorPresentations(I,B,W){const K=this.d.getDocument(I),ee=D.Range.to(B.range),he=D.Color.to(B.color),ye=await this.e.provideColorPresentations(he,{document:K,range:ee},W);if(!!Array.isArray(ye))return ye.map(D.ColorPresentation.from)}}class Ue{constructor(I,B){this.d=I,this.e=B}async provideFoldingRanges(I,B,W){const K=this.d.getDocument(I),ee=await this.e.provideFoldingRanges(K,B,W);if(!!Array.isArray(ee))return ee.map(D.FoldingRange.from)}}class xe{constructor(I,B,W){this.d=I,this.e=B,this.f=W}async provideSelectionRanges(I,B,W){const K=this.d.getDocument(I),ee=B.map(D.Position.to),he=await this.e.provideSelectionRanges(K,ee,W);if(!(0,M.isNonEmptyArray)(he))return[];if(he.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let ae=0;ae<ee.length;ae++){const be=[];ye.push(be);let Ee=ee[ae],We=he[ae];for(;;){if(!We.range.contains(Ee))throw new Error("INVALID selection range, must contain the previous range");if(be.push(D.SelectionRange.from(We)),!We.parent)break;Ee=We.range,We=We.parent}}return ye}}class Te{constructor(I,B){this.f=I,this.g=B,this.d=new o.IdGenerator(""),this.e=new Map}async prepareSession(I,B,W){const K=this.f.getDocument(I),ee=D.Position.to(B),he=await this.g.prepareCallHierarchy(K,ee,W);if(!he)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(he)?he.map(ae=>this.h(ye,ae)):[this.h(ye,he)]}async provideCallsTo(I,B,W){const K=this.j(I,B);if(!K)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(K,W);if(!!ee)return ee.map(he=>({from:this.h(I,he.from),fromRanges:he.fromRanges.map(ye=>D.Range.from(ye))}))}async provideCallsFrom(I,B,W){const K=this.j(I,B);if(!K)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(K,W);if(!!ee)return ee.map(he=>({to:this.h(I,he.to),fromRanges:he.fromRanges.map(ye=>D.Range.from(ye))}))}releaseSession(I){this.e.delete(I)}h(I,B){const W=this.e.get(I),K=D.CallHierarchyItem.from(B,I,W.size.toString(36));return W.set(K._itemId,B),K}j(I,B){return this.e.get(I)?.get(B)}}class Se{constructor(I,B){this.f=I,this.g=B,this.d=new o.IdGenerator(""),this.e=new Map}async prepareSession(I,B,W){const K=this.f.getDocument(I),ee=D.Position.to(B),he=await this.g.prepareTypeHierarchy(K,ee,W);if(!he)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(he)?he.map(ae=>this.h(ye,ae)):[this.h(ye,he)]}async provideSupertypes(I,B,W){const K=this.j(I,B);if(!K)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(K,W);if(!!ee)return ee.map(he=>this.h(I,he))}async provideSubtypes(I,B,W){const K=this.j(I,B);if(!K)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(K,W);if(!!ee)return ee.map(he=>this.h(I,he))}releaseSession(I){this.e.delete(I)}h(I,B){const W=this.e.get(I),K=D.TypeHierarchyItem.from(B,I,W.size.toString(36));return W.set(K._itemId,B),K}j(I,B){return this.e.get(I)?.get(B)}}class ke{constructor(I,B,W,K){this.d=I,this.e=B,this.f=W,this.g=K}async provideDocumentOnDropEdits(I,B,W,K,ee){const he=this.e.getDocument(B),ye=D.Position.to(W),ae=D.DataTransfer.toDataTransfer(K,async Ee=>(await this.d.$resolveDocumentOnDropFileData(this.g,I,Ee)).buffer),be=await this.f.provideDocumentDropEdits(he,ye,ae,ee);if(!!be)return{insertText:typeof be.insertText=="string"?be.insertText:{snippet:be.insertText.value},additionalEdit:be.additionalEdit?D.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}}class se{constructor(I,B){this.adapter=I,this.extension=B}}class ce{constructor(I,B,W,K,ee,he,ye,ae){this.g=B,this.h=W,this.j=K,this.k=ee,this.l=he,this.m=ye,this.n=ae,this.f=new Map,this.e=I.getProxy(R.MainContext.MainThreadLanguageFeatures)}o(I){return D.DocumentSelector.from(I,this.g)}p(I){return new N.Disposable(()=>{this.f.delete(I),this.e.$unregister(I)})}q(){return ce.d++}async s(I,B,W,K,ee,he=!1){const ye=this.f.get(I);if(!ye||!(ye.adapter instanceof B))return K;const ae=Date.now();he||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${W.toString().replace(/[\r\n]/g,"")}'`);const be=W(ye.adapter,ye.extension);return Promise.resolve(be).catch(Ee=>{(0,w.isCancellationError)(Ee)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(Ee),this.n.onExtensionError(ye.extension.identifier,Ee))}).finally(()=>{he||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-ae}ms`)}),b.CancellationToken.isCancellationToken(ee)?(0,A.raceCancellationError)(be,ee):be}t(I,B){const W=this.q();return this.f.set(W,new se(I,B)),W}static u(I){return I.displayName||I.name}registerDocumentSymbolProvider(I,B,W,K){const ee=this.t(new n(this.h,W),I),he=K&&K.label||ce.u(I);return this.e.$registerDocumentSymbolProvider(ee,this.o(B),he),this.p(ee)}$provideDocumentSymbols(I,B,W){return this.s(I,n,K=>K.provideDocumentSymbols(r.URI.revive(B),W),void 0,W)}registerCodeLensProvider(I,B,W){const K=this.q(),ee=typeof W.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(K,new se(new h(this.h,this.j.converter,W),I)),this.e.$registerCodeLensSupport(K,this.o(B),ee);let he=this.p(K);if(ee!==void 0){const ye=W.onDidChangeCodeLenses(ae=>this.e.$emitCodeLensEvent(ee));he=N.Disposable.from(he,ye)}return he}$provideCodeLenses(I,B,W){return this.s(I,h,K=>K.provideCodeLenses(r.URI.revive(B),W),void 0,W)}$resolveCodeLens(I,B,W){return this.s(I,h,K=>K.resolveCodeLens(B,W),void 0,void 0)}$releaseCodeLenses(I,B){this.s(I,h,W=>Promise.resolve(W.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(I,B,W){const K=this.t(new a(this.h,W),I);return this.e.$registerDefinitionSupport(K,this.o(B)),this.p(K)}$provideDefinition(I,B,W,K){return this.s(I,a,ee=>ee.provideDefinition(r.URI.revive(B),W,K),[],K)}registerDeclarationProvider(I,B,W){const K=this.t(new t(this.h,W),I);return this.e.$registerDeclarationSupport(K,this.o(B)),this.p(K)}$provideDeclaration(I,B,W,K){return this.s(I,t,ee=>ee.provideDeclaration(r.URI.revive(B),W,K),[],K)}registerImplementationProvider(I,B,W){const K=this.t(new g(this.h,W),I);return this.e.$registerImplementationSupport(K,this.o(B)),this.p(K)}$provideImplementation(I,B,W,K){return this.s(I,g,ee=>ee.provideImplementation(r.URI.revive(B),W,K),[],K)}registerTypeDefinitionProvider(I,B,W){const K=this.t(new c(this.h,W),I);return this.e.$registerTypeDefinitionSupport(K,this.o(B)),this.p(K)}$provideTypeDefinition(I,B,W,K){return this.s(I,c,ee=>ee.provideTypeDefinition(r.URI.revive(B),W,K),[],K)}registerHoverProvider(I,B,W,K){const ee=this.t(new u(this.h,W),I);return this.e.$registerHoverProvider(ee,this.o(B)),this.p(ee)}$provideHover(I,B,W,K){return this.s(I,u,ee=>ee.provideHover(r.URI.revive(B),W,K),void 0,K)}registerEvaluatableExpressionProvider(I,B,W,K){const ee=this.t(new d(this.h,W),I);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(B)),this.p(ee)}$provideEvaluatableExpression(I,B,W,K){return this.s(I,d,ee=>ee.provideEvaluatableExpression(r.URI.revive(B),W,K),void 0,K)}registerInlineValuesProvider(I,B,W,K){const ee=typeof W.onDidChangeInlineValues=="function"?this.q():void 0,he=this.t(new C(this.h,W),I);this.e.$registerInlineValuesProvider(he,this.o(B),ee);let ye=this.p(he);if(ee!==void 0){const ae=W.onDidChangeInlineValues(be=>this.e.$emitInlineValuesEvent(ee));ye=N.Disposable.from(ye,ae)}return ye}$provideInlineValues(I,B,W,K,ee){return this.s(I,C,he=>he.provideInlineValues(r.URI.revive(B),W,K,ee),void 0,ee)}registerDocumentHighlightProvider(I,B,W){const K=this.t(new O(this.h,W),I);return this.e.$registerDocumentHighlightProvider(K,this.o(B)),this.p(K)}$provideDocumentHighlights(I,B,W,K){return this.s(I,O,ee=>ee.provideDocumentHighlights(r.URI.revive(B),W,K),void 0,K)}registerLinkedEditingRangeProvider(I,B,W){const K=this.t(new j(this.h,W),I);return this.e.$registerLinkedEditingRangeProvider(K,this.o(B)),this.p(K)}$provideLinkedEditingRanges(I,B,W,K){return this.s(I,j,async ee=>{const he=await ee.provideLinkedEditingRanges(r.URI.revive(B),W,K);if(he)return{ranges:he.ranges,wordPattern:he.wordPattern?ce.w(he.wordPattern):void 0}},void 0,K)}registerReferenceProvider(I,B,W){const K=this.t(new Z(this.h,W),I);return this.e.$registerReferenceSupport(K,this.o(B)),this.p(K)}$provideReferences(I,B,W,K,ee){return this.s(I,Z,he=>he.provideReferences(r.URI.revive(B),W,K,ee),void 0,ee)}registerCodeActionProvider(I,B,W,K){const ee=new m.DisposableStore,he=this.t(new x(this.h,this.j.converter,this.k,W,this.l,I,this.m),I);return this.e.$registerQuickFixSupport(he,this.o(B),{providedKinds:K?.providedCodeActionKinds?.map(ye=>ye.value),documentation:K?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,ee)}))},ce.u(I),Boolean(W.resolveCodeAction)),ee.add(this.p(he)),ee}$provideCodeActions(I,B,W,K,ee){return this.s(I,x,he=>he.provideCodeActions(r.URI.revive(B),W,K,ee),void 0,ee)}$resolveCodeAction(I,B,W){return this.s(I,x,K=>K.resolveCodeAction(B,W),void 0,void 0)}$releaseCodeActions(I,B){this.s(I,x,W=>Promise.resolve(W.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(I,B,W){const K=this.t(new $(this.h,W),I);return this.e.$registerDocumentFormattingSupport(K,this.o(B),I.identifier,I.displayName||I.name),this.p(K)}$provideDocumentFormattingEdits(I,B,W,K){return this.s(I,$,ee=>ee.provideDocumentFormattingEdits(r.URI.revive(B),W,K),void 0,K)}registerDocumentRangeFormattingEditProvider(I,B,W){const K=this.t(new P(this.h,W),I);return this.e.$registerRangeFormattingSupport(K,this.o(B),I.identifier,I.displayName||I.name),this.p(K)}$provideDocumentRangeFormattingEdits(I,B,W,K,ee){return this.s(I,P,he=>he.provideDocumentRangeFormattingEdits(r.URI.revive(B),W,K,ee),void 0,ee)}registerOnTypeFormattingEditProvider(I,B,W,K){const ee=this.t(new F(this.h,W),I);return this.e.$registerOnTypeFormattingSupport(ee,this.o(B),K,I.identifier),this.p(ee)}$provideOnTypeFormattingEdits(I,B,W,K,ee,he){return this.s(I,F,ye=>ye.provideOnTypeFormattingEdits(r.URI.revive(B),W,K,ee,he),void 0,he)}registerWorkspaceSymbolProvider(I,B){const W=this.t(new V(B,this.l),I);return this.e.$registerNavigateTypeSupport(W,typeof B.resolveWorkspaceSymbol=="function"),this.p(W)}$provideWorkspaceSymbols(I,B,W){return this.s(I,V,K=>K.provideWorkspaceSymbols(B,W),{symbols:[]},W)}$resolveWorkspaceSymbol(I,B,W){return this.s(I,V,K=>K.resolveWorkspaceSymbol(B,W),void 0,void 0)}$releaseWorkspaceSymbols(I,B){this.s(I,V,W=>W.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(I,B,W){const K=this.t(new q(this.h,W,this.l),I);return this.e.$registerRenameSupport(K,this.o(B),q.supportsResolving(W)),this.p(K)}$provideRenameEdits(I,B,W,K,ee){return this.s(I,q,he=>he.provideRenameEdits(r.URI.revive(B),W,K,ee),void 0,ee)}$resolveRenameLocation(I,B,W,K){return this.s(I,q,ee=>ee.resolveRenameLocation(r.URI.revive(B),W,K),void 0,K)}registerDocumentSemanticTokensProvider(I,B,W,K){const ee=this.t(new _(this.h,W),I),he=typeof W.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(B),K,he);let ye=this.p(ee);if(he){const ae=W.onDidChangeSemanticTokens(be=>this.e.$emitDocumentSemanticTokensEvent(he));ye=N.Disposable.from(ye,ae)}return ye}$provideDocumentSemanticTokens(I,B,W,K){return this.s(I,_,ee=>ee.provideDocumentSemanticTokens(r.URI.revive(B),W,K),null,K)}$releaseDocumentSemanticTokens(I,B){this.s(I,_,W=>W.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(I,B,W,K){const ee=this.t(new pe(this.h,W),I);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(B),K),this.p(ee)}$provideDocumentRangeSemanticTokens(I,B,W,K){return this.s(I,pe,ee=>ee.provideDocumentRangeSemanticTokens(r.URI.revive(B),W,K),null,K)}registerCompletionItemProvider(I,B,W,K){const ee=this.t(new ue(this.h,this.j.converter,W,this.m,I),I);return this.e.$registerCompletionsProvider(ee,this.o(B),K,ue.supportsResolving(W),`${I.identifier.value}(${K.join("")})`),this.p(ee)}$provideCompletionItems(I,B,W,K,ee){return this.s(I,ue,he=>he.provideCompletionItems(r.URI.revive(B),W,K,ee),void 0,ee)}$resolveCompletionItem(I,B,W){return this.s(I,ue,K=>K.resolveCompletionItem(B,W),void 0,W)}$releaseCompletionItems(I,B){this.s(I,ue,W=>W.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(I,B,W){const K=new re(I,this.h,W,this.j.converter),ee=this.t(K,I);return this.e.$registerInlineCompletionsSupport(ee,this.o(B),K.supportsHandleDidShowCompletionItem),this.p(ee)}$provideInlineCompletions(I,B,W,K,ee){return this.s(I,de,he=>he.provideInlineCompletions(r.URI.revive(B),W,K,ee),void 0,ee)}$handleInlineCompletionDidShow(I,B,W){this.s(I,de,async K=>{K.handleDidShowCompletionItem(B,W)},void 0,void 0)}$freeInlineCompletionsList(I,B){this.s(I,de,async W=>{W.disposeCompletions(B)},void 0,void 0)}registerSignatureHelpProvider(I,B,W,K){const ee=Array.isArray(K)?{triggerCharacters:K,retriggerCharacters:[]}:K,he=this.t(new H(this.h,W),I);return this.e.$registerSignatureHelpProvider(he,this.o(B),ee),this.p(he)}$provideSignatureHelp(I,B,W,K,ee){return this.s(I,H,he=>he.provideSignatureHelp(r.URI.revive(B),W,K,ee),void 0,ee)}$releaseSignatureHelp(I,B){this.s(I,H,W=>W.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(I,B,W){const K=typeof W.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new oe(this.h,this.j.converter,W,this.l,I),I);this.e.$registerInlayHintsProvider(ee,this.o(B),typeof W.resolveInlayHint=="function",K,ce.u(I));let he=this.p(ee);if(K!==void 0){const ye=W.onDidChangeInlayHints(ae=>this.e.$emitInlayHintsEvent(K));he=N.Disposable.from(he,ye)}return he}$provideInlayHints(I,B,W,K){return this.s(I,oe,ee=>ee.provideInlayHints(r.URI.revive(B),W,K),void 0,K)}$resolveInlayHint(I,B,W){return this.s(I,oe,K=>K.resolveInlayHint(B,W),void 0,W)}$releaseInlayHints(I,B){this.s(I,oe,W=>W.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(I,B,W){const K=this.t(new ve(this.h,W),I);return this.e.$registerDocumentLinkProvider(K,this.o(B),typeof W.resolveDocumentLink=="function"),this.p(K)}$provideDocumentLinks(I,B,W){return this.s(I,ve,K=>K.provideLinks(r.URI.revive(B),W),void 0,W,B.scheme==="output")}$resolveDocumentLink(I,B,W){return this.s(I,ve,K=>K.resolveLink(B,W),void 0,void 0,!0)}$releaseDocumentLinks(I,B){this.s(I,ve,W=>W.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(I,B,W){const K=this.t(new Ae(this.h,W),I);return this.e.$registerDocumentColorProvider(K,this.o(B)),this.p(K)}$provideDocumentColors(I,B,W){return this.s(I,Ae,K=>K.provideColors(r.URI.revive(B),W),[],W)}$provideColorPresentations(I,B,W,K){return this.s(I,Ae,ee=>ee.provideColorPresentations(r.URI.revive(B),W,K),void 0,K)}registerFoldingRangeProvider(I,B,W){const K=this.q(),ee=typeof W.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(K,new se(new Ue(this.h,W),I)),this.e.$registerFoldingRangeProvider(K,this.o(B),I.identifier,ee);let he=this.p(K);if(ee!==void 0){const ye=W.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));he=N.Disposable.from(he,ye)}return he}$provideFoldingRanges(I,B,W,K){return this.s(I,Ue,ee=>ee.provideFoldingRanges(r.URI.revive(B),W,K),void 0,K)}registerSelectionRangeProvider(I,B,W){const K=this.t(new xe(this.h,W,this.l),I);return this.e.$registerSelectionRangeProvider(K,this.o(B)),this.p(K)}$provideSelectionRanges(I,B,W,K){return this.s(I,xe,ee=>ee.provideSelectionRanges(r.URI.revive(B),W,K),[],K)}registerCallHierarchyProvider(I,B,W){const K=this.t(new Te(this.h,W),I);return this.e.$registerCallHierarchyProvider(K,this.o(B)),this.p(K)}$prepareCallHierarchy(I,B,W,K){return this.s(I,Te,ee=>Promise.resolve(ee.prepareSession(r.URI.revive(B),W,K)),void 0,K)}$provideCallHierarchyIncomingCalls(I,B,W,K){return this.s(I,Te,ee=>ee.provideCallsTo(B,W,K),void 0,K)}$provideCallHierarchyOutgoingCalls(I,B,W,K){return this.s(I,Te,ee=>ee.provideCallsFrom(B,W,K),void 0,K)}$releaseCallHierarchy(I,B){this.s(I,Te,W=>Promise.resolve(W.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(I,B,W){const K=this.t(new Se(this.h,W),I);return this.e.$registerTypeHierarchyProvider(K,this.o(B)),this.p(K)}$prepareTypeHierarchy(I,B,W,K){return this.s(I,Se,ee=>Promise.resolve(ee.prepareSession(r.URI.revive(B),W,K)),void 0,K)}$provideTypeHierarchySupertypes(I,B,W,K){return this.s(I,Se,ee=>ee.provideSupertypes(B,W,K),void 0,K)}$provideTypeHierarchySubtypes(I,B,W,K){return this.s(I,Se,ee=>ee.provideSubtypes(B,W,K),void 0,K)}$releaseTypeHierarchy(I,B){this.s(I,Se,W=>Promise.resolve(W.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(I,B,W){const K=this.q();return this.f.set(K,new se(new ke(this.e,this.h,W,K),I)),this.e.$registerDocumentOnDropEditProvider(K,this.o(B)),this.p(K)}$provideDocumentOnDropEdits(I,B,W,K,ee,he){return this.s(I,ke,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(B,r.URI.revive(W),K,ee,he)),void 0,void 0)}registerDocumentPasteEditProvider(I,B,W,K){const ee=this.q();return this.f.set(ee,new se(new L(this.e,this.h,W,ee),I)),this.e.$registerPasteEditProvider(ee,this.o(B),!!W.prepareDocumentPaste,K.pasteMimeTypes),this.p(ee)}$prepareDocumentPaste(I,B,W,K,ee){return this.s(I,L,he=>he.prepareDocumentPaste(r.URI.revive(B),W,K,ee),void 0,ee)}$providePasteEdits(I,B,W,K,ee,he){return this.s(I,L,ye=>ye.providePasteEdits(B,r.URI.revive(W),K,ee,he),void 0,he)}static w(I){return{pattern:I.source,flags:(0,y.regExpFlags)(I)}}static y(I){return{decreaseIndentPattern:ce.w(I.decreaseIndentPattern),increaseIndentPattern:ce.w(I.increaseIndentPattern),indentNextLinePattern:I.indentNextLinePattern?ce.w(I.indentNextLinePattern):void 0,unIndentedLinePattern:I.unIndentedLinePattern?ce.w(I.unIndentedLinePattern):void 0}}static z(I){return{beforeText:ce.w(I.beforeText),afterText:I.afterText?ce.w(I.afterText):void 0,previousLineText:I.previousLineText?ce.w(I.previousLineText):void 0,action:I.action}}static B(I){return I.map(ce.z)}setLanguageConfiguration(I,B,W){const{wordPattern:K}=W;if(K&&(0,y.regExpLeadsToEndlessLoop)(K))throw new Error(`Invalid language configuration: wordPattern '${K}' is not allowed to match the empty string.`);K?this.h.setWordDefinitionFor(B,K):this.h.setWordDefinitionFor(B,void 0),W.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",I,"Do not use."),W.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",I,"Do not use.");const ee=this.q(),he={comments:W.comments,brackets:W.brackets,wordPattern:W.wordPattern?ce.w(W.wordPattern):void 0,indentationRules:W.indentationRules?ce.y(W.indentationRules):void 0,onEnterRules:W.onEnterRules?ce.B(W.onEnterRules):void 0,__electricCharacterSupport:W.__electricCharacterSupport,__characterPairSupport:W.__characterPairSupport};return this.e.$setLanguageConfiguration(ee,B,he),this.p(ee)}$setWordDefinitions(I){for(const B of I)this.h.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.ExtHostLanguageFeatures=ce,ce.d=0}),define(Ie[217],Ce([1,0,5,8,7,29,16,6]),function(te,e,r,k,D,N,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(M,E,f,b){this.c=E,this.d=f,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=M.getProxy(r.MainContext.MainThreadLanguages)}$acceptLanguageIds(M){this.b=M}async getLanguages(){return this.b.slice(0)}async changeLanguage(M,E){await this.a.$changeLanguage(M,E);const f=this.c.getDocumentData(M);if(!f)throw new Error(`document '${M.toString()}' NOT found`);return f.document}async tokenAtPosition(M,E){const f=M.version,b=k.Position.from(E),m=await this.a.$tokensAtPosition(M.uri,b),s={type:D.StandardTokenType.Other,range:M.getWordRangeAtPosition(E)??new D.Range(E.line,E.character,E.line,E.character)};if(!m)return s;const o={range:k.Range.to(m.range),type:k.TokenType.to(m.type)};return!o.range.contains(E)||f!==M.version?s:o}createLanguageStatusItem(M,E,f){const b=this.f++,m=this.a,s=this.g,o=`${M.identifier.value}/${E}`;if(s.has(o))throw new Error(`LanguageStatusItem with id '${E}' ALREADY exists`);s.add(o);const l={selector:f,id:E,name:M.displayName??M.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v;const w=new R.DisposableStore,A=()=>{v?.dispose(),v=(0,S.disposableTimeout)(()=>{w.clear(),this.a.$setLanguageStatus(b,{id:o,name:l.name??M.displayName??M.name,source:M.displayName??M.name,selector:k.DocumentSelector.from(l.selector,this.e),label:l.text,detail:l.detail??"",severity:l.severity===D.LanguageStatusSeverity.Error?N.default.Error:l.severity===D.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:l.command&&this.d.toInternal(l.command,w),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},p={dispose(){w.dispose(),v?.dispose(),m.$removeLanguageStatus(b),s.delete(o)},get id(){return l.id},get name(){return l.name},set name(n){l.name=n,A()},get selector(){return l.selector},set selector(n){l.selector=n,A()},get text(){return l.text},set text(n){l.text=n,A()},get detail(){return l.detail},set detail(n){l.detail=n,A()},get severity(){return l.severity},set severity(n){l.severity=n,A()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(n){l.accessibilityInformation=n,A()},get command(){return l.command},set command(n){l.command=n,A()},get busy(){return l.busy},set busy(n){l.busy=n,A()}};return A(),p}}e.ExtHostLanguages=y}),define(Ie[78],Ce([1,0,20,10,2,3,11,5,26,17]),function(te,e,r,k,D,N,S,R,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let M=class{constructor(f,b,m){this.f=m,this.d=new Map,this.a=b.getProxy(R.MainContext.MainThreadLocalization),this.b=f.environment.appLanguage,this.c=this.b===r.LANGUAGE_DEFAULT}getMessage(f,b){const{message:m,args:s,comment:o}=b;if(this.c)return(0,k.format2)(m,s??{});let l=m;o&&o.length>0&&(l+=`/${Array.isArray(o)?o.join(""):o}`);const v=this.d.get(f)?.contents[l];return v||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${l}`),(0,k.format2)(v??m,s??{})}getBundle(f){return this.d.get(f)?.contents}getBundleUri(f){return this.d.get(f)?.uri}async initializeLocalizedMessages(f){if(this.c||!f.l10n&&!f.isBuiltin||this.d.has(f.identifier.value))return;let b;const m=await this.g(f);if(!m){this.f.error(`No bundle location found for extension ${f.identifier.value}`);return}try{const s=await this.a.$fetchBundleContents(m),o=JSON.parse(s);b=f.isBuiltin?o.contents?.bundle:o}catch(s){this.f.error(`Failed to load translations for ${f.identifier.value} from ${m}: ${s.message}`);return}b&&this.d.set(f.identifier.value,{contents:b,uri:m})}async g(f){if(f.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(f.identifier.value);return D.URI.revive(b)}return f.l10n?D.URI.joinPath(f.extensionLocation,f.l10n,`bundle.l10n.${this.b}.json`):void 0}};M=qe([je(0,y.IExtHostInitDataService),je(1,T.IExtHostRpcService),je(2,S.ILogService)],M),e.ExtHostLocalizationService=M,e.IExtHostLocalizationService=(0,N.createDecorator)("IExtHostLocalizationService")}),define(Ie[218],Ce([1,0,11,5,26,17,2,65]),function(te,e,r,k,D,N,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=class extends r.AbstractLoggerService{constructor(E,f){super(f.logLevel,f.loggers.map(b=>(0,R.revive)(b))),this.l=E.getProxy(k.MainContext.MainThreadLogger)}$setLogLevel(E,f){f?this.setLogLevel(S.URI.revive(f),E):this.setLogLevel(E)}k(E,f,b){return new T(this.l,E,f,b)}};y=qe([je(0,N.IExtHostRpcService),je(1,D.IExtHostInitDataService)],y),e.ExtHostLoggerService=y;class T extends r.AbstractMessageLogger{constructor(E,f,b,m){super(m?.logLevel==="always"),this.m=E,this.n=f,this.k=!1,this.l=[],this.setLevel(b),this.m.$createLogger(f,m).then(()=>{this.r(this.l),this.k=!0})}g(E,f){const b=[[E,f]];this.k?this.r(b):this.l.push(...b)}r(E){this.m.$log(this.n,E)}}}),define(Ie[219],Ce([1,0,5,11,27]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function N(R){return R&&R.title}let S=class{constructor(y,T){this.b=T,this.a=y.getProxy(r.MainContext.MainThreadMessageService)}showMessage(y,T,M,E,f){const b={source:{identifier:y.identifier,label:y.displayName||y.name}};let m;typeof E=="string"||N(E)?m=[E,...f]:(b.modal=E?.modal,b.useCustom=E?.useCustom,b.detail=E?.detail,m=f),b.useCustom&&(0,D.checkProposedApiEnabled)(y,"resolvers");const s=[];for(let o=0;o<m.length;o++){const l=m[o];if(typeof l=="string")s.push({title:l,handle:o,isCloseAffordance:!1});else if(typeof l=="object"){const{title:v,isCloseAffordance:w}=l;s.push({title:v,isCloseAffordance:!!w,handle:o})}else this.b.warn("Invalid message item:",l)}return this.a.$showMessage(T,M,b,s).then(o=>{if(typeof o=="number")return m[o]})}};S=qe([je(1,k.ILogService)],S),e.ExtHostMessageService=S}),define(Ie[220],Ce([1,0,23,4,6,28,10,9,2,53,5,37,8,7,45,194,100]),function(te,e,r,k,D,N,S,R,y,T,M,E,f,b,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class l{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(w=>w.apiEditor)}constructor(w,A,p,n){this.q=p,this.r=n,this.f=new Map,this.g=new N.ResourceMap,this.h=new Map,this.j=new k.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new k.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new k.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new k.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new T.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=w.getProxy(M.MainContext.MainThreadNotebook),this.c=w.getProxy(M.MainContext.MainThreadNotebookDocuments),this.d=w.getProxy(M.MainContext.MainThreadNotebookEditors),this.i=A.converter,A.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===13){const i=h.notebookEditor?.notebookUri,a=h.cell.handle,g=this.g.get(i)?.getCell(a);if(g)return g.apiCell}if(h&&h.$mid===14){const i=h.uri,a=this.g.get(i);if(a)return a.apiNotebook}return h}}),l.x(A)}getEditorById(w){const A=this.h.get(w);if(!A)throw new Error(`unknown text editor: ${w}. known editors: ${[...this.h.keys()]} `);return A}getIdByEditor(w){for(const[A,p]of this.h)if(p.apiEditor===w)return A}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(w,A){const p=this.g.get(w);if(!p&&!A)throw new Error(`NO notebook document for '${w}'`);return p}static s(w,A){if(!A)return;const p=A.filenamePattern.map(n=>f.NotebookExclusiveDocumentPattern.from(n)).filter(n=>n!==void 0);if(A.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${A.filenamePattern}`);return}return{extension:w.identifier,providerDisplayName:w.displayName||w.name,displayName:A.displayName,filenamePattern:p,exclusive:A.exclusive||!1}}registerNotebookCellStatusBarItemProvider(w,A,p){const n=l.a++,h=typeof p.onDidChangeCellStatusBarItems=="function"?l.a++:void 0;this.f.set(n,p),this.b.$registerNotebookCellStatusBarItemProvider(n,h,A);let i;return h!==void 0&&(i=p.onDidChangeCellStatusBarItems(a=>this.b.$emitCellStatusBarEvent(h))),new b.Disposable(()=>{this.f.delete(n),this.b.$unregisterNotebookCellStatusBarItemProvider(n,h),i?.dispose()})}async createNotebookDocument(w){const A=await this.c.$tryCreateNotebook({viewType:w.viewType,content:w.content&&f.NotebookData.from(w.content)});return y.URI.revive(A)}async openNotebookDocument(w){const A=this.g.get(w);if(A)return A.apiNotebook;const p=await this.c.$tryOpenNotebook(w),n=this.g.get(y.URI.revive(p));return(0,R.assertIsDefined)(n?.apiNotebook)}async showNotebookDocument(w,A){y.URI.isUri(w)&&(w=await this.openNotebookDocument(w));let p;typeof A=="object"?p={position:f.ViewColumn.from(A.viewColumn),preserveFocus:A.preserveFocus,selections:A.selections&&A.selections.map(f.NotebookRange.from),pinned:typeof A.preview=="boolean"?!A.preview:void 0}:p={preserveFocus:!1};const n=await this.d.$tryShowNotebookDocument(w.uri,w.notebookType,p),h=n&&this.h.get(n)?.apiEditor;if(h)return h;throw n?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(w,A,p,n){const h=this.f.get(w),i=y.URI.revive(A),a=this.g.get(i);if(!a||!h)return;const t=a.getCellFromIndex(p);if(!t)return;const g=await h.provideCellStatusBarItems(t.apiCell,n);if(!g)return;const c=new D.DisposableStore,u=this.p.add([c]),C=(Array.isArray(g)?g:[g]).map(O=>f.NotebookStatusBarItem.from(O,this.i,c));return{cacheId:u,items:C}}$releaseNotebookCellStatusBarItems(w){this.p.delete(w)}registerNotebookSerializer(w,A,p,n,h){if((0,S.isFalsyOrWhitespace)(A))throw new Error("viewType cannot be empty or just whitespace");const i=this.t++;return this.u.set(i,p),this.b.$registerNotebookSerializer(i,{id:w.identifier,location:w.extensionLocation},A,f.NotebookDocumentContentOptions.from(n),l.s(w,h)),(0,D.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(i)})}async $dataToNotebook(w,A,p){const n=this.u.get(w);if(!n)throw new Error("NO serializer found");const h=await n.deserializeNotebook(A.buffer,p);return new m.SerializableObjectWithBuffers(f.NotebookData.from(h))}async $notebookToData(w,A,p){const n=this.u.get(w);if(!n)throw new Error("NO serializer found");const h=await n.serializeNotebook(f.NotebookData.to(A.value),p);return r.VSBuffer.wrap(h)}w(w,A,p){if(this.h.has(A))throw new Error(`editor with id ALREADY EXSIST: ${A}`);const n=new o.ExtHostNotebookEditor(A,this.d,w,p.visibleRanges.map(f.NotebookRange.to),p.selections.map(f.NotebookRange.to),typeof p.viewColumn=="number"?f.ViewColumn.to(p.viewColumn):void 0);this.h.set(A,n)}$acceptDocumentAndEditorsDelta(w){if(w.value.removedDocuments)for(const p of w.value.removedDocuments){const n=y.URI.revive(p),h=this.g.get(n);h&&(h.dispose(),this.g.delete(n),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:h.apiNotebook.getCells().map(i=>i.document.uri)}),this.n.fire(h.apiNotebook));for(const i of this.h.values())i.notebookData.uri.toString()===n.toString()&&this.h.delete(i.id)}if(w.value.addedDocuments){const p=[];for(const n of w.value.addedDocuments){const h=y.URI.revive(n.uri);if(this.g.has(h))throw new Error(`adding EXISTING notebook ${h} `);const i=new s.ExtHostNotebookDocument(this.c,this.q,this.r,h,n);p.push(...n.cells.map(a=>s.ExtHostCell.asModelAddData(i.apiNotebook,a))),this.g.get(h)?.dispose(),this.g.set(h,i),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this.m.fire(i.apiNotebook)}}if(w.value.addedEditors)for(const p of w.value.addedEditors){if(this.h.has(p.id))return;const n=y.URI.revive(p.documentUri),h=this.g.get(n);h&&this.w(h,p.id,p)}const A=[];if(w.value.removedEditors)for(const p of w.value.removedEditors){const n=this.h.get(p);n&&(this.h.delete(p),this.k?.id===n.id&&(this.k=void 0),A.push(n))}if(w.value.visibleEditors){this.l=w.value.visibleEditors.map(n=>this.h.get(n)).filter(n=>!!n);const p=new Set;this.l.forEach(n=>p.add(n.id));for(const n of this.h.values()){const h=p.has(n.id);n._acceptVisibility(h)}this.l=[...this.h.values()].map(n=>n).filter(n=>n.visible),this.o.fire(this.visibleNotebookEditors)}w.value.newActiveEditor===null?this.k=void 0:w.value.newActiveEditor&&(this.k=this.h.get(w.value.newActiveEditor)),w.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(w){const A=E.ApiCommandArgument.String.with("notebookType","A notebook type"),p=new E.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[A,new E.ApiCommandArgument("data","Bytes to convert to data",h=>h instanceof Uint8Array,h=>r.VSBuffer.wrap(h))],new E.ApiCommandResult("Notebook Data",h=>f.NotebookData.to(h.value))),n=new E.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[A,new E.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",h=>!0,h=>new m.SerializableObjectWithBuffers(f.NotebookData.from(h)))],new E.ApiCommandResult("Bytes",h=>h.buffer));w.registerApiCommand(p),w.registerApiCommand(n)}}e.ExtHostNotebookController=l,l.a=0}),define(Ie[221],Ce([1,0,18,16,21,4,6,28,2,25,11,53,5,37,8,7,72,184,27,45]),function(te,e,r,k,D,N,S,R,y,T,M,E,f,b,m,s,o,l,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let A=class{constructor(t,g,c,u,d){this.k=g,this.l=c,this.m=u,this.n=d,this.b=new R.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new E.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new N.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=t.getProxy(f.MainContext.MainThreadNotebookKernels);const C=new b.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new b.ApiCommandArgument("options","Select kernel options",O=>!0,O=>{if(O&&"notebookEditor"in O&&"id"in O){const j=this.l.getIdByEditor(O.notebookEditor);return{id:O.id,extension:O.extension,notebookEditorId:j}}else if(O&&"notebookEditor"in O){const j=this.l.getIdByEditor(O.notebookEditor);if(j===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${O.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:j}}return O})],b.ApiCommandResult.Void);this.m.registerApiCommand(C)}createNotebookController(t,g,c,u,d,C){for(const de of this.h.values())if(de.controller.id===g&&T.ExtensionIdentifier.equals(t.identifier,de.extensionId))throw new Error(`notebook controller with id '${g}' ALREADY exist`);const O=this.i++,j=this;this.n.trace(`NotebookController[${O}], CREATED by ${t.identifier.value}, ${g}`);const Z=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${t.identifier}'`);let x=!1;const L=new S.DisposableStore,$=new N.Emitter,P=new N.Emitter,F={id:i(t.identifier,g),notebookType:c,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:u||t.identifier.value,preloads:C?C.map(m.NotebookRendererScript.from):[]};let V=d??Z,q;this.a.$addKernel(O,F).catch(de=>{console.log(de),x=!0});let le=0;const _=()=>{if(x)return;const de=++le;Promise.resolve().then(()=>{de===le&&this.a.$updateKernel(O,F)})},pe=new R.ResourceMap,ue={get id(){return g},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:$.event,get label(){return F.label},set label(de){F.label=de??t.displayName??t.name,_()},get detail(){return F.detail??""},set detail(de){F.detail=de,_()},get description(){return F.description??""},set description(de){F.description=de,_()},get kind(){return(0,v.checkProposedApiEnabled)(t,"notebookControllerKind"),F.kind??""},set kind(de){(0,v.checkProposedApiEnabled)(t,"notebookControllerKind"),F.kind=de,_()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(de){F.supportedLanguages=de,_()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(de){F.supportsExecutionOrder=de,_()},get rendererScripts(){return F.preloads?F.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return V},set executeHandler(de){V=de??Z},get interruptHandler(){return q},set interruptHandler(de){q=de,F.supportsInterrupt=Boolean(de),_()},createNotebookCellExecution(de){if(x)throw new Error("notebook controller is DISPOSED");if(!pe.has(de.notebook.uri))throw j.n.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${de.notebook.uri.toString()}`);return j._createNotebookCellExecution(de,i(t.identifier,this.id))},dispose:()=>{x||(this.n.trace(`NotebookController[${O}], DISPOSED`),x=!0,this.h.delete(O),L.dispose(),$.dispose(),P.dispose(),this.a.$removeKernel(O))},updateNotebookAffinity(de,re){re===s.NotebookControllerAffinity2.Hidden&&(0,v.checkProposedApiEnabled)(t,"notebookControllerAffinityHidden"),j.a.$updateNotebookPriority(O,de.uri,re)},onDidReceiveMessage:P.event,postMessage(de,re){return(0,v.checkProposedApiEnabled)(t,"notebookMessaging"),j.a.$postMessage(O,re&&j.l.getIdByEditor(re),de)},asWebviewUri(de){return(0,v.checkProposedApiEnabled)(t,"notebookMessaging"),(0,o.asWebviewUri)(de,j.k.remote)}};return this.h.set(O,{extensionId:t.identifier,controller:ue,onDidReceiveMessage:P,onDidChangeSelection:$,associatedNotebooks:pe}),ue}getIdByController(t){for(const[g,c]of this.h)if(c.controller===t)return i(c.extensionId,t.id);return null}createNotebookControllerDetectionTask(t,g){const c=this.d++,u=this;this.n.trace(`NotebookControllerDetectionTask[${c}], CREATED by ${t.identifier.value}`),this.a.$addKernelDetectionTask(c,g);const d={dispose:()=>{this.c.delete(c),u.a.$removeKernelDetectionTask(c)}};return this.c.set(c,d),d}registerKernelSourceActionProvider(t,g,c){const u=this.f++,d=this;return this.e.set(u,c),this.n.trace(`NotebookKernelSourceActionProvider[${u}], CREATED by ${t.identifier.value}`),this.a.$addKernelSourceActionProvider(u,g),{dispose:()=>{this.e.delete(u),d.a.$removeKernelSourceActionProvider(u)}}}async $provideKernelSourceActions(t,g){const c=this.e.get(t);if(c){const u=new S.DisposableStore;return this.g.add([u]),(await c.provideNotebookKernelSourceActions(g)??[]).map(C=>m.NotebookKernelSourceAction.from(C,this.m.converter,u))}return[]}$acceptNotebookAssociation(t,g,c){const u=this.h.get(t);if(u){const d=this.l.getNotebookDocument(y.URI.revive(g));c?u.associatedNotebooks.set(d.uri,!0):u.associatedNotebooks.delete(d.uri),this.n.trace(`NotebookController[${t}] ASSOCIATE notebook`,d.uri.toString(),c),u.onDidChangeSelection.fire({selected:c,notebook:d.apiNotebook})}}async $executeCells(t,g,c){const u=this.h.get(t);if(!u)return;const d=this.l.getNotebookDocument(y.URI.revive(g)),C=[];for(const O of c){const j=d.getCell(O);j&&C.push(j.apiCell)}try{this.n.trace(`NotebookController[${t}] EXECUTE cells`,d.uri.toString(),C.length),await u.controller.executeHandler.call(u.controller,C,d.apiNotebook,u.controller)}catch(O){this.n.error(`NotebookController[${t}] execute cells FAILED`,O),console.error(O)}}async $cancelCells(t,g,c){const u=this.h.get(t);if(!u)return;const d=this.l.getNotebookDocument(y.URI.revive(g));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,d.apiNotebook);else for(const C of c){const O=d.getCell(C);O&&this.b.get(O.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,g,c){const u=this.h.get(t);if(!u)return;const d=this.l.getEditorById(g);u.onDidReceiveMessage.fire(Object.freeze({editor:d.apiEditor,message:c}))}$cellExecutionChanged(t,g,c){const d=this.l.getNotebookDocument(y.URI.revive(t)).getCell(g);if(d){const C=c?m.NotebookCellExecutionState.to(c):s.NotebookCellExecutionState.Idle;C!==void 0&&this.j.fire({cell:d.apiCell,state:C})}}_createNotebookCellExecution(t,g){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this.l.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!u)throw new Error("invalid cell");if(this.b.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const d=new n(g,u,this.a);this.b.set(u.uri,d);const C=d.onDidChangeState(()=>{d.state===p.Resolved&&(d.dispose(),C.dispose(),this.b.delete(u.uri))});return d.asApiObject()}};A=qe([je(4,M.ILogService)],A),e.ExtHostNotebookKernels=A;var p;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(p||(p={}));class n extends S.Disposable{get state(){return this.f}constructor(t,g,c){super(),this.j=g,this.k=c,this.b=n.a++,this.c=new N.Emitter,this.onDidChangeState=this.c.event,this.f=p.Init,this.g=this.B(new D.CancellationTokenSource),this.h=new h(10,u=>this.m(u)),this.i=g.internalMetadata.executionOrder,this.k.$createExecution(this.b,t,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(t){await this.h.addItem(t)}async m(t){const g=Array.isArray(t)?t:[t];return this.k.$updateExecution(this.b,new w.SerializableObjectWithBuffers(g))}n(){if(this.f===p.Init)throw new Error("Must call start before modifying cell output");if(this.f===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(t){let g=this.j;if(t&&(g=this.j.notebook.getCellFromApiCell(t)),!g)throw new Error("INVALID cell");return g.handle}s(t){return t.map(g=>{const c=s.NotebookCellOutput.ensureUniqueMimeTypes(g.items,!0);return c===g.items?m.NotebookCellOutput.from(g):m.NotebookCellOutput.from({items:c,id:g.id,metadata:g.metadata})})}async t(t,g,c){const u=this.r(g),d=this.s((0,r.asArray)(t));return this.l({editType:l.CellExecutionUpdateType.Output,cellHandle:u,append:c,outputs:d})}async w(t,g,c){return t=s.NotebookCellOutput.ensureUniqueMimeTypes((0,r.asArray)(t),!0),this.l({editType:l.CellExecutionUpdateType.OutputItems,items:t.map(m.NotebookCellOutputItem.from),outputId:g.id,append:c})}asApiObject(){const t=this;return Object.freeze({get token(){return t.g.token},get cell(){return t.j.apiCell},get executionOrder(){return t.i},set executionOrder(c){t.i=c,t.m([{editType:l.CellExecutionUpdateType.ExecutionState,executionOrder:t.i}])},start(c){if(t.f===p.Resolved||t.f===p.Started)throw new Error("Cannot call start again");t.f=p.Started,t.c.fire(),t.m({editType:l.CellExecutionUpdateType.ExecutionState,runStartTime:c})},end(c,u){if(t.f===p.Resolved)throw new Error("Cannot call resolve twice");t.f=p.Resolved,t.c.fire(),t.h.flush(),t.k.$completeExecution(t.b,new w.SerializableObjectWithBuffers({runEndTime:u,lastRunSuccess:c}))},clearOutput(c){return t.n(),t.t([],c,!1)},appendOutput(c,u){return t.n(),t.t(c,u,!0)},replaceOutput(c,u){return t.n(),t.t(c,u,!1)},appendOutputItems(c,u){return t.n(),t.w(c,u,!0)},replaceOutputItems(c,u){return t.n(),t.w(c,u,!1)}})}}n.a=0;class h{constructor(t,g){this.d=t,this.e=g,this.a=[],this.b=Date.now()}addItem(t){return this.a.push(t),this.c||(this.c=new k.DeferredPromise,this.b=Date.now(),(0,k.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const t=this.c;this.c=void 0;const g=this.a;return this.a=[],this.e(g).finally(()=>t.complete())}}function i(a,t){return`${a.value}/${t}`}e.createKernelId=i}),define(Ie[222],Ce([1,0,4,5,100]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class N{constructor(R,y){this.c=y,this.a=new Map,this.b=R.getProxy(k.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(R,y,T){const M=this.c.getEditorById(R);this.a.get(y)?.fire({editor:M.apiEditor,message:T})}createRendererMessaging(R,y){if(!R.contributes?.notebookRenderer?.some(M=>M.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(M,E,f)=>this.d(y).event(M,E,f),postMessage:(M,E)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(M)&&([M,E]=[E,M]);const f=E&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(E);return this.b.$postMessage(f?.id,y,M)}}}d(R){let y=this.a.get(R);return y||(y=new r.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this.a.delete(R)}}),this.a.set(R,y),y)}}e.ExtHostNotebookRenderers=N}),define(Ie[223],Ce([1,0,6,9,2,27,5]),function(te,e,r,k,D,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class R{constructor(T){this.b=new Map,this.a=T.getProxy(S.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(T,M,E){if((0,N.checkProposedApiEnabled)(T,"profileContentHandlers"),this.b.has(M))throw new Error(`Handler with id '${M}' already registered`);return this.b.set(M,E),this.a.$registerProfileContentHandler(M,E.name,E.description,T.identifier.value),(0,r.toDisposable)(()=>{this.b.delete(M),this.a.$unregisterProfileContentHandler(M)})}async $saveProfile(T,M,E,f){const b=this.b.get(T);if(!b)throw new Error(`Unknown handler with id: ${T}`);return b.saveProfile(M,E,f)}async $readProfile(T,M,E){const f=this.b.get(T);if(!f)throw new Error(`Unknown handler with id: ${T}`);return f.readProfile((0,k.isString)(M)?M:D.URI.revive(M),E)}}e.ExtHostProfileContentHandlers=R}),define(Ie[224],Ce([1,0,2,5,16]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class N{constructor(R){this.c=new Map,this.b=R.getProxy(k.MainContext.MainThreadQuickDiff)}$provideOriginalResource(R,y,T){const M=r.URI.revive(y),E=this.c.get(R);return E?(0,D.asPromise)(()=>E.provideOriginalResource(M,T)).then(f=>f||null):Promise.resolve(null)}async registerQuickDiffProvider(R,y,T){const M=N.a++;return this.c.set(M,R),await this.b.$registerQuickDiffProvider(M,y,T),{dispose:()=>this.c.delete(M)}}}e.ExtHostQuickDiff=N,N.a=0}),define(Ie[225],Ce([1,0,21,4,6,5,2,7,12,18,29,38]),function(te,e,r,k,D,N,S,R,y,T,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(b,m,s){const o=b.getProxy(N.MainContext.MainThreadQuickOpen);class l{constructor(t,g){this.e=new Map,this.f=0,this.a=t,this.b=g}showQuickPick(t,g,c=r.CancellationToken.None){this.c=void 0;const u=Promise.resolve(t),d=++this.f,C=o.$show(d,{title:g?.title,placeHolder:g?.placeHolder,matchOnDescription:g?.matchOnDescription,matchOnDetail:g?.matchOnDetail,ignoreFocusLost:g?.ignoreFocusOut,canPickMany:g?.canPickMany},c),O={},j=C.then(()=>O);return Promise.race([j,u]).then(Z=>{if(Z!==O)return u.then(x=>{const L=[];for(let $=0;$<x.length;$++){const P=x[$];typeof P=="string"?L.push({label:P,handle:$}):P.kind===R.QuickPickItemKind.Separator?L.push({type:"separator",label:P.label}):L.push({label:P.label,description:P.description,detail:P.detail,picked:P.picked,alwaysShow:P.alwaysShow,handle:$})}return g&&typeof g.onDidSelectItem=="function"&&(this.c=$=>{g.onDidSelectItem(x[$])}),o.$setItems(d,L),C.then($=>{if(typeof $=="number")return x[$];if(Array.isArray($))return $.map(P=>x[P])})})}).then(void 0,Z=>{if(!(0,y.isCancellationError)(Z))return o.$setError(d,Z),Promise.reject(Z)})}$onItemSelected(t){this.c?.(t)}showInput(t,g=r.CancellationToken.None){return this.d=t?.validateInput,o.$input(t,typeof this.d=="function",g).then(void 0,c=>{if(!(0,y.isCancellationError)(c))return Promise.reject(c)})}async $validateInput(t){if(!this.d)return;const g=await this.d(t);if(!g||typeof g=="string")return g;let c;switch(g.severity){case R.InputBoxValidationSeverity.Info:c=M.default.Info;break;case R.InputBoxValidationSeverity.Warning:c=M.default.Warning;break;case R.InputBoxValidationSeverity.Error:c=M.default.Error;break;default:c=g.message?M.default.Error:M.default.Ignore;break}return{content:g.message,severity:c}}async showWorkspaceFolderPick(t,g=r.CancellationToken.None){const c=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[t]);if(!c)return;const u=await this.a.getWorkspaceFolders2();if(!!u)return u.find(d=>d.uri.toString()===c.uri.toString())}createQuickPick(t){const g=new h(t,()=>this.e.delete(g._id));return this.e.set(g._id,g),g}createInputBox(t){const g=new i(t,()=>this.e.delete(g._id));return this.e.set(g._id,g),g}$onDidChangeValue(t,g){this.e.get(t)?._fireDidChangeValue(g)}$onDidAccept(t){this.e.get(t)?._fireDidAccept()}$onDidChangeActive(t,g){const c=this.e.get(t);c instanceof h&&c._fireDidChangeActive(g)}$onDidChangeSelection(t,g){const c=this.e.get(t);c instanceof h&&c._fireDidChangeSelection(g)}$onDidTriggerButton(t,g){this.e.get(t)?._fireDidTriggerButton(g)}$onDidTriggerItemButton(t,g,c){const u=this.e.get(t);u instanceof h&&u._fireDidTriggerItemButton(g,c)}$onDidHide(t){this.e.get(t)?._fireDidHide()}}class v{constructor(t,g){this.x=t,this.y=g,this._id=h.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new k.Emitter,this.q=new k.Emitter,this.r=new k.Emitter,this.s=new k.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(t){this.b=t,this.z({title:t})}get step(){return this.c}set step(t){this.c=t,this.z({step:t})}get totalSteps(){return this.d}set totalSteps(t){this.d=t,this.z({totalSteps:t})}get enabled(){return this.g}set enabled(t){this.g=t,this.z({enabled:t})}get busy(){return this.j}set busy(t){this.j=t,this.z({busy:t})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(t){this.k=t,this.z({ignoreFocusOut:t})}get value(){return this.l}set value(t){this.l=t,this.z({value:t})}get placeholder(){return this.m}set placeholder(t){this.m=t,this.z({placeholder:t})}get buttons(){return this.n}set buttons(t){this.n=t.slice(),this.o.clear(),t.forEach((g,c)=>{const u=g===R.QuickInputButtons.Back?-1:c;this.o.set(u,g)}),this.z({buttons:t.map((g,c)=>({...n(g),tooltip:g.tooltip,handle:g===R.QuickInputButtons.Back?-1:c}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(t){this.l=t,this.q.fire(t)}_fireDidTriggerButton(t){const g=this.o.get(t);g&&this.r.fire(g)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,D.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),o.$dispose(this._id))}z(t){if(!this.v){for(const g of Object.keys(t)){const c=t[g];this.u[g]=c===void 0?null:c}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){o.$createOrUpdate(this.u),this.u={id:this._id}}}v.a=1;function w(a){if(a instanceof R.ThemeIcon)return{id:a.id};const t=p(a),g=A(a);return{dark:typeof t=="string"?S.URI.file(t):t,light:typeof g=="string"?S.URI.file(g):g}}function A(a){return typeof a=="object"&&"light"in a?a.light:a}function p(a){return typeof a=="object"&&"dark"in a?a.dark:a}function n(a){const t=w(a.iconPath);let g,c;return"id"in t?c=E.ThemeIcon.asClassName(t):g=t,{iconPath:g,iconClass:c}}class h extends v{constructor(t,g){super(t.identifier,g),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new k.Emitter,this.L=[],this.M=new k.Emitter,this.N=new k.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(t){this.B=t.slice(),this.C.clear(),this.D.clear(),t.forEach((c,u)=>{this.C.set(u,c),this.D.set(c,u)});const g=[];for(let c=0;c<t.length;c++){const u=t[c];u.kind===R.QuickPickItemKind.Separator?g.push({type:"separator",label:u.label}):g.push({handle:c,label:u.label,description:u.description,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow,buttons:u.buttons?.map((d,C)=>({...n(d),tooltip:d.tooltip,handle:C}))})}this.z({items:g})}get canSelectMany(){return this.E}set canSelectMany(t){this.E=t,this.z({canSelectMany:t})}get matchOnDescription(){return this.F}set matchOnDescription(t){this.F=t,this.z({matchOnDescription:t})}get matchOnDetail(){return this.G}set matchOnDetail(t){this.G=t,this.z({matchOnDetail:t})}get sortByLabel(){return this.H}set sortByLabel(t){this.H=t,this.z({sortByLabel:t})}get keepScrollPosition(){return this.I}set keepScrollPosition(t){this.I=t,this.z({keepScrollPosition:t})}get activeItems(){return this.J}set activeItems(t){this.J=t.filter(g=>this.D.has(g)),this.z({activeItems:this.J.map(g=>this.D.get(g))})}get selectedItems(){return this.L}set selectedItems(t){this.L=t.filter(g=>this.D.has(g)),this.z({selectedItems:this.L.map(g=>this.D.get(g))})}_fireDidChangeActive(t){const g=(0,T.coalesce)(t.map(c=>this.C.get(c)));this.J=g,this.K.fire(g)}_fireDidChangeSelection(t){const g=(0,T.coalesce)(t.map(c=>this.C.get(c)));this.L=g,this.M.fire(g)}_fireDidTriggerItemButton(t,g){const c=this.C.get(t);if(!c||!c.buttons||!c.buttons.length)return;const u=c.buttons[g];u&&this.N.fire({button:u,item:c})}}class i extends v{constructor(t,g){super(t.identifier,g),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(t){this.B=t,this.z({password:t})}get prompt(){return this.C}set prompt(t){this.C=t,this.z({prompt:t})}get valueSelection(){return this.D}set valueSelection(t){this.D=t,this.z({valueSelection:t})}get validationMessage(){return this.E}set validationMessage(t){this.E=t,t?typeof t=="string"?this.z({validationMessage:t,severity:M.default.Error}):this.z({validationMessage:t.message,severity:t.severity??M.default.Error}):this.z({validationMessage:void 0,severity:M.default.Ignore})}}return new l(m,s)}e.createExtHostQuickOpen=f});var Le=this&&this.__classPrivateFieldGet||function(te,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(te):k?k.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,r,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,r):D?D.value=r:e.set(te,r),r};define(Ie[226],Ce([1,0,2,4,63,6,16,5,18,122,11,25,38,8,27]),function(te,e,r,k,D,N,S,R,y,T,M,E,f,b,m){"use strict";var s,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(u){if(u)return typeof u.iconPath=="string"?r.URI.file(u.iconPath):r.URI.isUri(u.iconPath)||f.ThemeIcon.isThemeIcon(u.iconPath)?u.iconPath:void 0}function v(u,d){if(!u.iconPath&&!d.iconPath)return 0;if(u.iconPath){if(!d.iconPath)return 1}else return-1;const C=typeof u.iconPath=="string"?u.iconPath:r.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id,O=typeof d.iconPath=="string"?d.iconPath:r.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,T.comparePaths)(C,O)}function w(u,d){let C=0;if(u.strikeThrough!==d.strikeThrough)return u.strikeThrough?1:-1;if(u.faded!==d.faded)return u.faded?1:-1;if(u.tooltip!==d.tooltip)return(u.tooltip||"").localeCompare(d.tooltip||"");if(C=v(u,d),C!==0)return C;if(u.light&&d.light)C=v(u.light,d.light);else{if(u.light)return 1;if(d.light)return-1}if(C!==0)return C;if(u.dark&&d.dark)C=v(u.dark,d.dark);else{if(u.dark)return 1;if(d.dark)return-1}return C}function A(u,d){if(u.command!==d.command)return u.command<d.command?-1:1;if(u.title!==d.title)return u.title<d.title?-1:1;if(u.tooltip!==d.tooltip){if(u.tooltip!==void 0&&d.tooltip!==void 0)return u.tooltip<d.tooltip?-1:1;if(u.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(u.arguments===d.arguments)return 0;if(u.arguments)if(d.arguments){if(u.arguments.length!==d.arguments.length)return u.arguments.length-d.arguments.length}else return 1;else return-1;for(let C=0;C<u.arguments.length;C++){const O=u.arguments[C],j=d.arguments[C];if(O!==j)return O<j?-1:1}return 0}function p(u,d){let C=(0,T.comparePaths)(u.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(C!==0)return C;if(u.command&&d.command)C=A(u.command,d.command);else{if(u.command)return 1;if(d.command)return-1}if(C!==0)return C;if(u.decorations&&d.decorations)C=w(u.decorations,d.decorations);else{if(u.decorations)return 1;if(d.decorations)return-1}return C}function n(u,d){for(let C=0;C<u.length;C++)if(u[C]!==d[C])return!1;return!0}function h(u,d){return u.command===d.command&&u.title===d.title&&u.tooltip===d.tooltip&&(u.arguments&&d.arguments?n(u.arguments,d.arguments):u.arguments===d.arguments)}function i(u,d){return(0,y.equals)(u,d,h)}class a{get value(){return this.d}set value(d){d=d??"",Le(this,s,"f").$setInputBoxValue(this.l,d),this.m(d)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(d){Le(this,s,"f").$setInputBoxPlaceholder(this.l,d),this.f=d}get validateInput(){return(0,m.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(d){if((0,m.checkProposedApiEnabled)(this.k,"scmValidation"),d&&typeof d!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=d,Le(this,s,"f").$setValidationProviderIsEnabled(this.l,!!d)}get enabled(){return this.h}set enabled(d){d=!!d,this.h!==d&&(this.h=d,Le(this,s,"f").$setInputBoxEnablement(this.l,d))}get visible(){return this.j}set visible(d){d=!!d,this.j!==d&&(this.j=d,Le(this,s,"f").$setInputBoxVisibility(this.l,d))}constructor(d,C,O){this.k=d,this.l=O,s.set(this,void 0),this.d="",this.e=new k.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,s,C,"f")}showValidationMessage(d,C){(0,m.checkProposedApiEnabled)(this.k,"scmValidation"),Le(this,s,"f").$showValidationMessage(this.l,d,C)}$onInputBoxValueChange(d){this.m(d)}m(d){this.d=d,this.e.fire(d)}}e.ExtHostSCMInputBox=a,s=new WeakMap;class t{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(d){this.v=d,this.q.$updateGroupLabel(this.t,this.handle,d)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(d){this.p=d,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(d){this.f=[...d],this.k.fire()}constructor(d,C,O,j,Z){this.q=d,this.s=C,this.t=O,this.u=j,this.v=Z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new k.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new k.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=t.d++}getResourceState(d){return this.g.get(d)}$executeResourceCommand(d,C){const O=this.h.get(d);return O?(0,S.asPromise)(()=>this.s.executeCommand(O.command,...O.arguments||[],C)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this.f].sort(p),O=(0,y.sortedDiff)(this.o,d,p).map(x=>{const L=x.toInsert.map($=>{const P=this.e++;this.g.set(P,$);const F=$.resourceUri;let V;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const oe=new N.DisposableStore;V=this.s.converter.toInternal($.command,oe),this.j.set(P,oe)}else this.h.set(P,$.command);const q=l($.decorations),le=$.decorations&&l($.decorations.light)||q,_=$.decorations&&l($.decorations.dark)||q,pe=[le,_],ue=$.decorations&&$.decorations.tooltip||"",de=$.decorations&&!!$.decorations.strikeThrough,re=$.decorations&&!!$.decorations.faded,G=$.contextValue||"";return{rawResource:[P,F,pe,ue,de,re,G,V],handle:P}});return{start:x.start,deleteCount:x.deleteCount,toInsert:L}}),j=O.map(({start:x,deleteCount:L,toInsert:$})=>[x,L,$.map(P=>P.rawResource)]),Z=O.reverse();for(const{start:x,deleteCount:L,toInsert:$}of Z){const P=$.map(V=>V.handle),F=this.n.splice(x,L,...P);for(const V of F)this.g.delete(V),this.h.delete(V),this.j.get(V)?.dispose(),this.j.delete(V)}return this.o=d,j}dispose(){this.l=!0,this.m.fire()}}t.d=0;class g{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(d){this.g!==d&&(this.g=d,Le(this,o,"f").$updateSourceControl(this.t,{count:d}))}get quickDiffProvider(){return this.h}set quickDiffProvider(d){this.h=d,Le(this,o,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!d})}get commitTemplate(){return this.j}set commitTemplate(d){d!==this.j&&(this.j=d,Le(this,o,"f").$updateSourceControl(this.t,{commitTemplate:d}))}get acceptInputCommand(){return this.l}set acceptInputCommand(d){this.k.value=new N.DisposableStore,this.l=d;const C=this.v.converter.toInternal(d,this.k.value);Le(this,o,"f").$updateSourceControl(this.t,{acceptInputCommand:C})}get actionButton(){return(0,m.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(d){(0,m.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new N.DisposableStore,this.n=d;const C=d!==void 0?{command:this.v.converter.toInternal(d.command,this.m.value),secondaryCommands:d.secondaryCommands?.map(O=>O.map(j=>this.v.converter.toInternal(j,this.m.value))),description:d.description,enabled:d.enabled}:void 0;Le(this,o,"f").$updateSourceControl(this.t,{actionButton:C??null})}get statusBarCommands(){return this.p}set statusBarCommands(d){if(this.p&&d&&i(this.p,d))return;this.o.value=new N.DisposableStore,this.p=d;const C=(d||[]).map(O=>this.v.converter.toInternal(O,this.o.value));Le(this,o,"f").$updateSourceControl(this.t,{statusBarCommands:C})}get selected(){return this.q}constructor(d,C,O,j,Z,x){this.u=d,this.v=O,this.w=j,this.x=Z,this.y=x,o.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new N.MutableDisposable,this.l=void 0,this.m=new N.MutableDisposable,this.o=new N.MutableDisposable,this.p=void 0,this.q=!1,this.s=new k.Emitter,this.onDidChangeSelection=this.s.event,this.t=g.d++,this.z=new Map,this.A=new Set,Je(this,o,C,"f"),this.f=new a(d,Le(this,o,"f"),this.t),Le(this,o,"f").$registerSourceControl(this.t,j,Z,x)}createResourceGroup(d,C){const O=new t(Le(this,o,"f"),this.v,this.t,d,C),j=k.Event.once(O.onDidDispose)(()=>this.z.delete(O));return this.z.set(O,j),this.eventuallyAddResourceGroups(),O}eventuallyAddResourceGroups(){const d=[],C=[];for(const[O,j]of this.z){j.dispose();const Z=O.onDidUpdateResourceStates(()=>{this.A.add(O),this.eventuallyUpdateResourceStates()});k.Event.once(O.onDidDispose)(()=>{this.A.delete(O),Z.dispose(),this.e.delete(O.handle),Le(this,o,"f").$unregisterGroup(this.t,O.handle)}),d.push([O.handle,O.id,O.label,O.features]);const x=O._takeResourceStateSnapshot();x.length>0&&C.push([O.handle,x]),this.e.set(O.handle,O)}Le(this,o,"f").$registerGroups(this.t,d,C),this.z.clear()}eventuallyUpdateResourceStates(){const d=[];this.A.forEach(C=>{const O=C._takeResourceStateSnapshot();O.length!==0&&d.push([C.handle,O])}),d.length>0&&Le(this,o,"f").$spliceResourceStates(this.t,d),this.A.clear()}getResourceGroup(d){return this.e.get(d)}setSelectionState(d){this.q=d,this.s.fire(d)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(d=>d.dispose()),Le(this,o,"f").$unregisterSourceControl(this.t)}}o=new WeakMap,g.d=0,qe([(0,D.debounce)(100)],g.prototype,"eventuallyAddResourceGroups",null),qe([(0,D.debounce)(100)],g.prototype,"eventuallyUpdateResourceStates",null);let c=class on{get onDidChangeActiveProvider(){return this.j.event}constructor(d,C,O){this.l=C,this.m=O,this.g=new Map,this.h=new Map,this.j=new k.Emitter,this.e=d.getProxy(R.MainContext.MainThreadSCM),this.f=d.getProxy(R.MainContext.MainThreadTelemetry),C.registerArgumentProcessor({processArgument:j=>{if(j&&j.$mid===3){const Z=this.g.get(j.sourceControlHandle);if(!Z)return j;const x=Z.getResourceGroup(j.groupHandle);return x?x.getResourceState(j.handle):j}else if(j&&j.$mid===4){const Z=this.g.get(j.sourceControlHandle);return Z?Z.getResourceGroup(j.groupHandle):j}else if(j&&j.$mid===5){const Z=this.g.get(j.handle);return Z||j}return j}})}createSourceControl(d,C,O,j){this.m.trace("ExtHostSCM#createSourceControl",d.identifier.value,C,O,j),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const Z=on.d++,x=new g(d,this.e,this.l,C,O,j);this.g.set(Z,x);const L=this.h.get(E.ExtensionIdentifier.toKey(d.identifier))||[];return L.push(x),this.h.set(E.ExtensionIdentifier.toKey(d.identifier),L),x}getLastInputBox(d){this.m.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const C=this.h.get(E.ExtensionIdentifier.toKey(d.identifier)),O=C&&C[C.length-1];return O&&O.inputBox}$provideOriginalResource(d,C,O){const j=r.URI.revive(C);this.m.trace("ExtHostSCM#$provideOriginalResource",d,j.toString());const Z=this.g.get(d);return!Z||!Z.quickDiffProvider||!Z.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,S.asPromise)(()=>Z.quickDiffProvider.provideOriginalResource(j,O)).then(x=>x||null)}$onInputBoxValueChange(d,C){this.m.trace("ExtHostSCM#$onInputBoxValueChange",d);const O=this.g.get(d);return O&&O.inputBox.$onInputBoxValueChange(C),Promise.resolve(void 0)}$executeResourceCommand(d,C,O,j){this.m.trace("ExtHostSCM#$executeResourceCommand",d,C,O);const Z=this.g.get(d);if(!Z)return Promise.resolve(void 0);const x=Z.getResourceGroup(C);return x?x.$executeResourceCommand(O,j):Promise.resolve(void 0)}$validateInput(d,C,O){this.m.trace("ExtHostSCM#$validateInput",d);const j=this.g.get(d);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,S.asPromise)(()=>j.inputBox.validateInput(C,O)).then(Z=>{if(!Z)return Promise.resolve(void 0);const x=b.MarkdownString.fromStrict(Z.message);return x?Promise.resolve([x,Z.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this.g.get(d)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=d,Promise.resolve(void 0)}};c.d=0,c=qe([je(2,M.ILogService)],c),e.ExtHostSCM=c}),define(Ie[79],Ce([1,0,5,4,3]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class N{constructor(R){this.b=new k.Emitter,this.onDidChangePassword=this.b.event,this.a=R.getProxy(r.MainContext.MainThreadSecretState)}async $onDidChangePassword(R){this.b.fire(R)}get(R,y){return this.a.$getPassword(R,y)}store(R,y,T){return this.a.$setPassword(R,y,T)}delete(R,y){return this.a.$deletePassword(R,y)}}e.ExtHostSecretState=N,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(te,e,r,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,r):D?D.value=r:e.set(te,r),r},Le=this&&this.__classPrivateFieldGet||function(te,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(te):k?k.value:e.get(te)};define(Ie[227],Ce([1,0,7,5,141,6,8,9]),function(te,e,r,k,D,N,S,R){"use strict";var y,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class M{constructor(m,s,o,l,v=r.StatusBarAlignment.Left,w){y.set(this,void 0),T.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new N.DisposableStore,Je(this,y,m,"f"),Je(this,T,s,"f"),this.c=M.a++,this.e=o,this.f=l,this.g=v,this.h=this.u(w)}u(m){if(!!(0,R.isNumber)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(m){this.k=m,this.v()}set name(m){this.m=m,this.v()}set tooltip(m){this.l=m,this.v()}set color(m){this.n=m,this.v()}set backgroundColor(m){m&&!M.b.has(m.id)&&(m=void 0),this.o=m,this.v()}set command(m){this.r?.fromApi!==m&&(this.p&&this.q.add(this.p),this.p=new N.DisposableStore,typeof m=="string"?this.r={fromApi:m,internal:Le(this,T,"f").toInternal({title:"",command:m},this.p)}:m?this.r={fromApi:m,internal:Le(this,T,"f").toInternal(m,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(m){this.t=m,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Le(this,y,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let m;this.e?this.f?m=`${this.e.identifier.value}.${this.f}`:m=this.e.identifier.value:m=this.f;let s;this.m?s=this.m:s=(0,D.localize)(0,null,this.e.displayName||this.e.name);let o=this.n;this.o&&(o=M.b.get(this.o.id));const l=S.MarkdownString.fromStrict(this.l);Le(this,y,"f").$setEntry(this.c,m,s,this.k,l,this.r?.internal,o,this.o,this.g===r.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=M,y=new WeakMap,T=new WeakMap,M.a=0,M.b=new Map([["statusBarItem.errorBackground",new r.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.ThemeColor("statusBarItem.warningForeground")]]);class E{constructor(m){this.b=[],this.a=m.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,D.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(m){const s={message:m};return this.b.unshift(s),this.c(),new r.Disposable(()=>{const o=this.b.indexOf(s);o>=0&&(this.b.splice(o,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class f{constructor(m,s){this.a=m.getProxy(k.MainContext.MainThreadStatusBar),this.b=s,this.c=new E(this)}createStatusBarEntry(m,s,o,l){return new M(this.a,this.b,m,s,o,l)}setStatusBarMessage(m,s){const o=this.c.setMessage(m);let l;return typeof s=="number"?l=setTimeout(()=>o.dispose(),s):typeof s<"u"&&s.then(()=>o.dispose(),()=>o.dispose()),new r.Disposable(()=>{o.dispose(),clearTimeout(l)})}}e.ExtHostStatusBar=f}),define(Ie[80],Ce([1,0,5,4,3]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class N{constructor(R,y){this.c=y,this.b=new k.Emitter,this.onDidChangeStorage=this.b.event,this.a=R.getProxy(r.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(R,y){this.a.$registerExtensionStorageKeysToSync(R,y)}async initializeExtensionStorage(R,y,T){const M=await this.a.$initializeExtensionStorage(R,y);let E;return M&&(E=this.d(R,y,M)),E||T}setValue(R,y,T){return this.a.$setValue(R,y,T)}$acceptValue(R,y,T){const M=this.d(R,y,T);M&&this.b.fire({shared:R,key:y,value:M})}d(R,y,T){try{return JSON.parse(T)}catch(M){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${R}): ${M}`)}}}e.ExtHostStorage=N,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(Ie[81],Ce([1,0,3,26,11,59,2]),function(te,e,r,k,D,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,r.createDecorator)("IExtensionStoragePaths");let R=class{constructor(T,M,E){this.d=M,this.f=E,this.a=T.workspace??void 0,this.b=T.environment,this.whenReady=this.h().then(f=>this.c=f)}async g(T){return S.URI.joinPath(this.b.workspaceStorageHome,T)}async h(){if(!this.a)return Promise.resolve(void 0);const T=this.a.id,M=await this.g(T);try{return await this.f.value.stat(M),this.d.trace("[ExtHostStorage] storage dir already exists",M),M}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",M),await this.f.value.createDirectory(M),await this.f.value.writeFile(S.URI.joinPath(M,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:S.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),M}catch(E){this.d.error("[ExtHostStorage]",E);return}}workspaceValue(T){if(this.c)return S.URI.joinPath(this.c,T.identifier.value)}globalValue(T){return S.URI.joinPath(this.b.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};R=qe([je(0,k.IExtHostInitDataService),je(1,D.ILogService),je(2,N.IExtHostConsumerFileSystem)],R),e.ExtensionStoragePaths=R}),define(Ie[60],Ce([1,0,4,5,3,2,17,6,7,142,12,168,21,34,169,38,9,16,8]),function(te,e,r,k,D,N,S,R,y,T,M,E,f,b,m,s,o,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class w{constructor(c,u,d,C){this.k=c,this._id=u,this.l=d,this.m=C,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(j=>this.f=j);const O=this;this.value={get name(){return O.m||""},get processId(){return O.b},get creationOptions(){return O.l},get exitStatus(){return O.h},get state(){return O.j},sendText(j,Z=!0){O.o(),O.k.$sendText(O._id,j,Z)},show(j){O.o(),O.k.$show(O._id,j)},hide(){O.o(),O.k.$hide(O._id)},dispose(){O.a||(O.a=!0,O.k.$dispose(O._id))},get dimensions(){if(!(O.d===void 0||O.g===void 0))return{columns:O.d,rows:O.g}}}}async create(c,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:c.name,shellPath:(0,o.withNullAsUndefined)(c.shellPath),shellArgs:(0,o.withNullAsUndefined)(c.shellArgs),cwd:(0,o.withNullAsUndefined)(c.cwd),env:(0,o.withNullAsUndefined)(c.env),icon:(0,o.withNullAsUndefined)(a(c.iconPath)),color:s.ThemeColor.isThemeColor(c.color)?c.color.id:void 0,initialText:(0,o.withNullAsUndefined)(c.message),strictEnv:(0,o.withNullAsUndefined)(c.strictEnv),hideFromUser:(0,o.withNullAsUndefined)(c.hideFromUser),isFeatureTerminal:(0,o.withNullAsUndefined)(u?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,o.withNullAsUndefined)(u?.useShellEnvironment),location:u?.location||this.n(c.location,u?.resolvedExtHostIdentifier),isTransient:(0,o.withNullAsUndefined)(c.isTransient)})}async createExtensionTerminal(c,u,d,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:d,color:s.ThemeColor.isThemeColor(C)?C.id:void 0,location:this.n(c,u),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(c,u){return typeof c=="object"?"parentTerminal"in c&&c.parentTerminal&&u?{parentTerminal:u}:"viewColumn"in c?{viewColumn:v.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus}:void 0:c}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(c){this.m=c}setExitStatus(c,u){this.h=Object.freeze({code:c,reason:u})}setDimensions(c,u){return c===this.d&&u===this.g||c===0||u===0?!1:(this.d=c,this.g=u,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(c){this.f?(this.f(c),this.f=void 0):this.b.then(u=>{u!==c&&(this.b=Promise.resolve(c))})}}e.ExtHostTerminal=w;class A{get onProcessReady(){return this.b.event}constructor(c){this.g=c,this.id=0,this.shouldPersist=!1,this.a=new r.Emitter,this.onProcessData=this.a.event,this.b=new r.Emitter,this.d=new r.Emitter,this.onDidChangeProperty=this.d.event,this.f=new r.Emitter,this.onProcessExit=this.f.event}refreshProperty(c){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${c}`)}updateProperty(c,u){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${c}, value: ${u}`)}async start(){}shutdown(){this.g.close()}input(c){this.g.handleInput?.(c)}resize(c,u){this.g.setDimensions?.({columns:c,rows:u})}async processBinary(c){}acknowledgeDataEvent(c){}async setUnicodeVersion(c){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(c){this.g.onDidWrite(u=>this.a.fire(u)),this.g.onDidClose?.((u=void 0)=>{this.f.fire(u===void 0?void 0:u)}),this.g.onDidOverrideDimensions?.(u=>{u&&this.d.fire({type:"overrideDimensions",value:{cols:u.columns,rows:u.rows}})}),this.g.onDidChangeName?.(u=>{this.d.fire({type:"title",value:u})}),this.g.open(c||void 0),c&&this.g.setDimensions?.(c),this.b.fire({pid:-1,cwd:""})}}let p=1,n=class extends R.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(c=>c.value)}get onDidWriteTerminalData(){return this.I.event}constructor(c,u){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new r.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new r.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new r.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new r.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new r.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new r.Emitter,this.onDidChangeShell=this.J.event,this.a=u.getProxy(k.MainContext.MainThreadTerminalService),this.s=new m.TerminalDataBufferer(this.a.$sendProcessData),this.I=new r.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(c),this.B({dispose:()=>{for(const[d,C]of this.g)C.shutdown(!0)}})}getDefaultShell(c){return(c?this.n:this.m)?.path||""}getDefaultShellArgs(c){return(c?this.n:this.m)?.args||[]}createExtensionTerminal(c,u){const d=new w(this.a,(0,b.generateUuid)(),c,c.name),C=new A(c.pty);return d.createExtensionTerminal(c.location,this.L(c,u).resolvedExtHostIdentifier,a(c.iconPath),t(c.color)).then(O=>{const j=this.M(O,C);this.h[O]=j}),this.f.push(d),d.value}L(c,u){if(u=u||{},c.location&&typeof c.location=="object"&&"parentTerminal"in c.location){const d=c.location.parentTerminal;if(d){const C=this.f.find(O=>O.value===d);C&&(u.resolvedExtHostIdentifier=C._id)}}else c.location&&typeof c.location!="object"?u.location=c.location:u.location&&typeof u.location=="object"&&"splitActiveTerminal"in u.location&&(u.location={splitActiveTerminal:!0});return u}attachPtyToTerminal(c,u){if(!this.O(c))throw new Error(`Cannot resolve terminal with id ${c} for virtual process`);const C=new A(u),O=this.M(c,C);this.h[c]=O}async $acceptActiveTerminalChanged(c){const u=this.b;if(c===null){this.b=void 0,u!==this.b&&this.F.fire(this.b);return}const d=this.O(c);d&&(this.b=d,u!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(c,u){const d=this.O(c);d&&this.I.fire({terminal:d.value,data:u})}async $acceptTerminalDimensions(c,u,d){const C=this.O(c);C&&C.setDimensions(u,d)&&this.G.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptTerminalMaximumDimensions(c,u,d){this.g.get(c)?.resize(u,d)}async $acceptTerminalTitleChange(c,u){const d=this.O(c);d&&(d.name=u)}async $acceptTerminalClosed(c,u,d){const C=this.Q(this.f,c);if(C!==null){const O=this.f.splice(C,1)[0];O.setExitStatus(u,d),this.C.fire(O.value)}}$acceptTerminalOpened(c,u,d,C){if(u){const Z=this.Q(this.f,u);if(Z!==null){this.f[Z]._id=c,this.D.fire(this.terminals[Z]),this.f[Z].isOpen=!0;return}}const O={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:N.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},j=new w(this.a,c,O,d);this.f.push(j),this.D.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(c,u){this.O(c)?._setProcessId(u)}async $startExtensionTerminal(c,u){const d=this.O(c);if(!d)return{message:(0,T.localize)(0,null,c)};d.isOpen||await new Promise(O=>{const j=this.onDidOpenTerminal(async Z=>{Z===d.value&&(j.dispose(),O())})});const C=this.g.get(c);C?C.startSendingEvents(u):this.j[c]={initialDimensions:u}}M(c,u){const d=new R.DisposableStore;d.add(u.onProcessReady(O=>this.a.$sendProcessReady(c,O.pid,O.cwd))),d.add(u.onDidChangeProperty(O=>this.a.$sendProcessProperty(c,O))),this.s.startBuffering(c,u.onProcessData),d.add(u.onProcessExit(O=>this.N(c,O))),this.g.set(c,u);const C=this.j[c];return C&&u instanceof A&&(u.startSendingEvents(C.initialDimensions),delete this.j[c]),d}$acceptProcessAckDataEvent(c,u){this.g.get(c)?.acknowledgeDataEvent(u)}$acceptProcessInput(c,u){this.g.get(c)?.input(u)}$acceptTerminalInteraction(c){const u=this.O(c);u?.setInteractedWith()&&this.H.fire(u.value)}$acceptProcessResize(c,u,d){try{this.g.get(c)?.resize(u,d)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(c,u){this.g.get(c)?.shutdown(u)}$acceptProcessRequestInitialCwd(c){this.g.get(c)?.getInitialCwd().then(u=>this.a.$sendProcessProperty(c,{type:"initialCwd",value:u}))}$acceptProcessRequestCwd(c){this.g.get(c)?.getCwd().then(u=>this.a.$sendProcessProperty(c,{type:"cwd",value:u}))}$acceptProcessRequestLatency(c){return Promise.resolve(c)}registerLinkProvider(c){return this.u.add(c),this.u.size===1&&this.a.$startLinkProvider(),new y.Disposable(()=>{this.u.delete(c),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(c,u,d){if(this.v.has(u))throw new Error(`Terminal profile provider "${u}" already registered`);return this.v.set(u,d),this.a.$registerProfileProvider(u,c.identifier.value),new y.Disposable(()=>{this.v.delete(u),this.a.$unregisterProfileProvider(u)})}registerTerminalQuickFixProvider(c,u,d){if(this.w.has(c))throw new Error(`Terminal quick fix provider "${c}" is already registered`);return this.w.set(c,d),this.a.$registerQuickFixProvider(c,u),new y.Disposable(()=>{this.w.delete(c),this.a.$unregisterQuickFixProvider(c)})}async $provideTerminalQuickFixes(c,u){const d=new f.CancellationTokenSource().token;if(d.isCancellationRequested)return;const C=this.w.get(c);if(!C)return;const O=await C.provideTerminalQuickFixes(u,d);if(O!==null)return O}async $createContributedProfileTerminal(c,u){const d=new f.CancellationTokenSource().token;let C=await this.v.get(c)?.provideTerminalProfile(d);if(!d.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${c}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,u);return}this.createTerminalFromOptions(C.options,u)}}async $provideLinks(c,u){const d=this.O(c);if(!d)return[];this.y.delete(c),this.z.get(c)?.dispose(!0);const O=new f.CancellationTokenSource;this.z.set(c,O);const j=[],Z={terminal:d.value,line:u},x=[];for(const P of this.u)x.push(l.Promises.withAsyncBody(async F=>{O.token.onCancellationRequested(()=>F({provider:P,links:[]}));const V=await P.provideTerminalLinks(Z,O.token)||[];O.token.isCancellationRequested||F({provider:P,links:V})}));const L=await Promise.all(x);if(O.token.isCancellationRequested)return[];const $=new Map;for(const P of L)P&&P.links.length>0&&j.push(...P.links.map(F=>{const V={id:p++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return $.set(V.id,{provider:P.provider,link:F}),V}));return this.y.set(c,$),j}$activateLink(c,u){const d=this.y.get(c)?.get(u);!d||d.provider.handleTerminalLink(d.link)}N(c,u){this.s.stopBuffering(c),this.g.delete(c),delete this.j[c];const d=this.h[c];d&&(d.dispose(),delete this.h[c]),this.a.$sendProcessExit(c,u)}O(c){return this.P(this.f,c)}P(c,u){const d=this.Q(c,u);return d!==null?c[d]:null}Q(c,u){let d=null;return c.some((C,O)=>C._id===u?(d=O,!0):!1),d}getEnvironmentVariableCollection(c){let u=this.l.get(c.identifier.value);return u||(u=new h,this.S(c.identifier.value,u)),u}R(c,u){const d=(0,E.serializeEnvironmentVariableCollection)(u.map);this.a.$setEnvironmentVariableCollection(c,u.persistent,d.length===0?void 0:d)}$initEnvironmentVariableCollections(c){c.forEach(u=>{const d=u[0],C=new h(u[1]);this.S(d,C)})}$acceptDefaultProfile(c,u){const d=this.m;this.m=c,this.n=u,d?.path!==c.path&&this.J.fire(c.path)}S(c,u){this.l.set(c,u),u.onDidChangeCollection(()=>{this.R(c,u)})}};n=qe([je(1,S.IExtHostRpcService)],n),e.BaseExtHostTerminalService=n;class h{get persistent(){return this.a}set persistent(c){this.a=c,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(c){this.map=new Map,this.a=!0,this.b=new r.Emitter,this.map=new Map(c)}get size(){return this.map.size}replace(c,u){this.d(c,{value:u,type:y.EnvironmentVariableMutatorType.Replace})}append(c,u){this.d(c,{value:u,type:y.EnvironmentVariableMutatorType.Append})}prepend(c,u){this.d(c,{value:u,type:y.EnvironmentVariableMutatorType.Prepend})}d(c,u){const d=this.map.get(c);(!d||d.value!==u.value||d.type!==u.type)&&(this.map.set(c,u),this.b.fire())}get(c){return this.map.get(c)}forEach(c,u){this.map.forEach((d,C)=>c.call(u,C,d,this))}[Symbol.iterator](){return this.map.entries()}delete(c){this.map.delete(c),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let i=class extends n{constructor(c){super(!1,c)}createTerminal(c,u,d){throw new M.NotSupportedError}createTerminalFromOptions(c,u){throw new M.NotSupportedError}};i=qe([je(0,S.IExtHostRpcService)],i),e.WorkerExtHostTerminalService=i;function a(g){if(!(!g||typeof g=="string"))return"id"in g?{id:g.id,color:g.color}:g}function t(g){return s.ThemeColor.isThemeColor(g)?g:void 0}});var Le=this&&this.__classPrivateFieldGet||function(te,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(te):k?k.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,r,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,r):D?D.value=r:e.set(te,r),r};define(Ie[228],Ce([1,0,18,16,23,21,4,192,229,6,22,9,34,5,17,101,8,7,44,71,55,27]),function(te,e,r,k,D,N,S,R,y,T,M,E,f,b,m,s,o,l,v,w,A,p){"use strict";var n,h;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let i=class{constructor(P,F,V){this.j=V,this.c=new S.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=P.getProxy(b.MainContext.MainThreadTesting),this.h=new Z(this.f),this.g=new c(this.f),F.registerArgumentProcessor({processArgument:q=>{if(q?.$mid!==15)return q;const le=q,_=le.tests[le.tests.length-1].item.extId;return this.d.get(v.TestId.root(_))?.collection.tree.get(_)?.actual??(0,s.toItemFromContext)(q)}})}createTestController(P,F,V,q){if(this.d.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const le=new T.DisposableStore,_=le.add(new s.ExtHostTestItemCollection(F,V,this.j));_.root.label=V;const pe=new Map,ue=this.f,de={items:_.root.children,get label(){return V},set label(G){V=G,_.root.label=G,ue.$updateController(F,{label:V})},get refreshHandler(){return q},set refreshHandler(G){q=G,ue.$updateController(F,{canRefresh:!!G})},get id(){return F},createRunProfile:(G,H,oe,ve,Ae,Ue)=>{let xe=(0,y.hash)(G);for(;pe.has(xe);)xe++;return Ue!==void 0&&(0,p.checkProposedApiEnabled)(P,"testContinuousRun"),new x(this.f,pe,F,xe,G,H,oe,ve,Ae,Ue)},createTestItem(G,H,oe){return new s.TestItemImpl(F,G,H,oe)},createTestRun:(G,H,oe=!0)=>this.g.createTestRun(F,_,G,H,oe),set resolveHandler(G){_.resolveHandler=G},get resolveHandler(){return _.resolveHandler},dispose:()=>{le.dispose()}};ue.$registerTestController(F,V,!!q),le.add((0,T.toDisposable)(()=>ue.$unregisterTestController(F)));const re={controller:de,collection:_,profiles:pe};return this.d.set(F,re),le.add((0,T.toDisposable)(()=>this.d.delete(F))),le.add(_.onDidGenerateDiff(G=>ue.$publishDiff(F,G.map(A.TestsDiffOp.serialize)))),de}createTestObserver(){return this.h.checkout()}async runTests(P,F=N.CancellationToken.None){const V=u(P);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.d.get(V.controllerId);if(!q)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:P.include?.map(le=>v.TestId.fromExtHostTestItem(le,q.collection.root.id).toString())??[q.collection.root.id],profileGroup:L[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:P.exclude?.map(le=>le.id)},F)}$syncTests(){for(const{collection:P}of this.d.values())P.flushDiff();return Promise.resolve()}$provideFileCoverage(P,F,V){return(0,r.mapFind)(this.g.trackers,le=>le.id===P?le.getCoverage(F):void 0)?.provideFileCoverage(V)??Promise.resolve([])}$resolveFileCoverage(P,F,V,q){return(0,r.mapFind)(this.g.trackers,_=>_.id===P?_.getCoverage(F):void 0)?.resolveFileCoverage(V,q)??Promise.resolve([])}$configureRunProfile(P,F){this.d.get(P)?.profiles.get(F)?.configureHandler?.()}async $refreshTests(P,F){await this.d.get(P)?.controller.refreshHandler?.(F)}$publishTestResults(P){this.results=Object.freeze(P.map(F=>(0,M.deepFreeze)(o.TestResults.to(F))).concat(this.results).sort((F,V)=>V.completedAt-F.completedAt).slice(0,32)),this.c.fire()}async $expandTest(P,F){const V=this.d.get(v.TestId.fromString(P).controllerId)?.collection;V&&(await V.expand(P,F<0?1/0:F),V.flushDiff())}$acceptDiff(P){this.h.applyDiff(P.map(A.TestsDiffOp.deserialize))}async $runControllerTests(P,F){return Promise.all(P.map(V=>this.k(V,!1,F)))}async $startContinuousRun(P,F){const V=new N.CancellationTokenSource(F),q=await Promise.all(P.map(le=>this.k(le,!0,V.token)));return!F.isCancellationRequested&&!q.some(le=>le.error)&&await new Promise(le=>F.onCancellationRequested(le)),V.dispose(!0),q}async k(P,F,V){const q=this.d.get(P.controllerId);if(!q)return{};const{collection:le,profiles:_}=q,pe=_.get(P.profileId);if(!pe)return{};const ue=P.testIds.map(H=>le.tree.get(H)).filter(E.isDefined),de=P.excludeExtIds.map(H=>q.collection.tree.get(H)).filter(E.isDefined).filter(H=>ue.some(oe=>oe.fullId.compare(H.fullId)===2));if(!ue.length)return{};const re=new l.TestRunRequest2(ue.some(H=>H.actual instanceof s.TestItemRootImpl)?void 0:ue.map(H=>H.actual),de.map(H=>H.actual),pe,F),G=(0,A.isStartControllerTests)(P)&&this.g.prepareForMainThreadTestRun(re,d.fromInternal(P,q.collection),V);try{return await pe.runHandler(re,V),{}}catch(H){return{error:String(H)}}finally{G&&(G.hasRunningTasks&&!V.isCancellationRequested&&await S.Event.toPromise(G.onEnd),G.dispose())}}$cancelExtensionTestRun(P){P===void 0?this.g.cancelAllRuns():this.g.cancelRunById(P)}};i=qe([je(0,m.IExtHostRpcService)],i),e.ExtHostTesting=i;const a=1e4;var t;(function($){$[$.Running=0]="Running",$[$.Cancelling=1]="Cancelling",$[$.Ended=2]="Ended"})(t||(t={}));class g extends T.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(P,F,V){super(),this.k=P,this.l=F,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new S.Emitter),this.onEnd=this.j.event,this.h=this.B(new N.CancellationTokenSource(V));const q=this.B(new k.RunOnceScheduler(()=>this.m(),a));this.B(this.h.token.onCancellationRequested(()=>q.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(P){return this.f.get(P)?.coverage}createRun(P){const F=this.k.id,V=this.k.controllerId,q=(0,f.generateUuid)(),le=new C(this.l,F,q),_=re=>(G,...H)=>{if(ue){console.warn(`Setting the state of test "${G.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(G)||(this.s(G),re(G,...H))},pe=(re,G)=>{const H=G instanceof Array?G.map(o.TestMessage.from):[o.TestMessage.from(G)];if(re.uri&&re.range){const oe={range:o.Range.from(re.range),uri:re.uri};for(const ve of H)ve.location=ve.location||oe}this.l.$appendTestMessagesInRun(F,q,v.TestId.fromExtHostTestItem(re,V).toString(),H)};let ue=!1;const de={isPersisted:this.k.isPersisted,token:this.h.token,name:P,get coverageProvider(){return le.coverageProvider},set coverageProvider(re){le.coverageProvider=re},enqueued:_(re=>{this.l.$updateTestStateInRun(F,q,v.TestId.fromExtHostTestItem(re,V).toString(),1)}),skipped:_(re=>{this.l.$updateTestStateInRun(F,q,v.TestId.fromExtHostTestItem(re,V).toString(),5)}),started:_(re=>{this.l.$updateTestStateInRun(F,q,v.TestId.fromExtHostTestItem(re,V).toString(),2)}),errored:_((re,G,H)=>{pe(re,G),this.l.$updateTestStateInRun(F,q,v.TestId.fromExtHostTestItem(re,V).toString(),6,H)}),failed:_((re,G,H)=>{pe(re,G),this.l.$updateTestStateInRun(F,q,v.TestId.fromExtHostTestItem(re,V).toString(),4,H)}),passed:_((re,G)=>{this.l.$updateTestStateInRun(F,q,v.TestId.fromExtHostTestItem(re,this.k.controllerId).toString(),3,G)}),appendOutput:(re,G,H)=>{ue||(H&&(this.k.isIncluded(H)?this.s(H):H=void 0),this.l.$appendOutputToRun(F,q,D.VSBuffer.fromString(re),G&&o.location.from(G),H&&v.TestId.fromExtHostTestItem(H,V).toString()))},end:()=>{ue||(ue=!0,this.l.$finishedTestRunTask(F,q),this.f.delete(q),this.f.size||this.p())}};return this.f.set(q,{run:de,coverage:le}),this.l.$startedTestRunTask(F,{id:q,name:P,running:!0}),de}m(){for(const{run:P}of this.f.values())P.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(P){if(!(P instanceof s.TestItemImpl))throw new w.InvalidTestItemError(P.id);if(this.g.has(v.TestId.fromExtHostTestItem(P,this.k.controllerId).toString()))return;const F=[],V=this.k.colllection.root;for(;;){const q=o.TestItem.from(P);if(F.unshift(q),this.g.has(q.extId)||(this.g.add(q.extId),P===V))break;P=P.parent||V}this.l.$addTestsToRun(this.k.controllerId,this.k.id,F)}}class c{get trackers(){return this.c.values()}constructor(P){this.d=P,this.c=new Map}prepareForMainThreadTestRun(P,F,V){return this.f(P,F,V)}cancelRunById(P){for(const F of this.c.values())if(F.id===P){F.cancel();return}}cancelAllRuns(){for(const P of this.c.values())P.cancel()}createTestRun(P,F,V,q,le){const _=this.c.get(V);if(_)return _.createRun(q);const pe=d.fromPublic(P,F,V,le),ue=u(V);this.d.$startedExtensionTestRun({controllerId:P,continuous:!!V.continuous,profile:ue&&{group:L[ue.kind],id:ue.profileId},exclude:V.exclude?.map(re=>v.TestId.fromExtHostTestItem(re,F.root.id).toString())??[],id:pe.id,include:V.include?.map(re=>v.TestId.fromExtHostTestItem(re,F.root.id).toString())??[F.root.id],persist:le});const de=this.f(V,pe);return de.onEnd(()=>{this.d.$finishedExtensionTestRun(pe.id),de.dispose()}),de.createRun(q)}f(P,F,V){const q=new g(F,this.d,V);return this.c.set(P,q),q.onEnd(()=>this.c.delete(P)),q}}e.TestRunCoordinator=c;const u=$=>{if(!!$.profile){if(!($.profile instanceof x))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return $.profile}};class d{static fromPublic(P,F,V,q){return new d(P,(0,f.generateUuid)(),V.include?.map(le=>v.TestId.fromExtHostTestItem(le,P).toString())??[P],V.exclude?.map(le=>v.TestId.fromExtHostTestItem(le,P).toString())??[],q,F)}static fromInternal(P,F){return new d(P.controllerId,P.runId,P.testIds,P.excludeExtIds,!0,F)}constructor(P,F,V,q,le,_){this.controllerId=P,this.id=F,this.isPersisted=le,this.colllection=_,this.c=V.map(pe=>pe+"\0"),this.d=q.map(pe=>pe+"\0")}isIncluded(P){const F=v.TestId.fromExtHostTestItem(P,this.controllerId).toString()+"\0";for(const V of this.d)if(F===V||F.startsWith(V))return!1;for(const V of this.c)if(F===V||F.startsWith(V))return!0;return!1}}e.TestRunDto=d;class C{set coverageProvider(P){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!P||(this.c=P,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(P,F,V){this.f=P,this.g=F,this.h=V}async provideFileCoverage(P){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(P))());try{return(await this.d)?.map(o.TestCoverage.fromFile)??[]}catch(F){throw this.d=void 0,F}}async resolveFileCoverage(P,F){const V=await this.d;let q=V?.[P];return!this.c||!V||!q?[]:(q.detailedCoverage||(q=V[P]=await this.c.resolveFileCoverage?.(q,F)??q),q.detailedCoverage?.map(o.TestCoverage.fromDetailed)??[])}}class O{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(P){this.h=P,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(P){this.c.add(P)}update(P){Object.assign(P.revived,o.TestItem.toPlain(P.item)),this.c.has(P)||this.d.add(P)}remove(P){if(this.c.has(P)){this.c.delete(P);return}this.d.delete(P);const F=v.TestId.parentId(P.item.extId);if(F&&this.g.has(F.toString())){this.g.add(P.item.extId);return}this.f.add(P)}getChangeEvent(){const{c:P,d:F,f:V}=this;return{get added(){return[...P].map(q=>q.revived)},get updated(){return[...F].map(q=>q.revived)},get removed(){return[...V].map(q=>q.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class j extends A.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new S.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(P){return this.d.get(P)}getMirroredTestDataByReference(P){return this.d.get(P.id)}p(P,F){return{...P,revived:o.TestItem.toPlain(P.item),depth:F?F.depth+1:0,children:new Set}}o(){return new O(this.q)}}class Z{constructor(P){this.d=P}checkout(){this.c||(this.c=this.f());const P=this.c;return P.observers++,{onDidChangeTest:P.tests.onDidChangeTests,get tests(){return[...P.tests.rootTests].map(F=>F.revived)},dispose:(0,R.once)(()=>{--P.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(P){return this.c?.tests.getMirroredTestDataByReference(P)}applyDiff(P){this.c?.tests.apply(P)}f(){const P=new j;return this.d.$subscribeToDiffs(),{observers:0,tests:P}}}class x{get label(){return this.d}set label(P){P!==this.d&&(this.d=P,Le(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:P}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(P){P!==this.g&&(this.g=P,Le(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:P}))}get isDefault(){return this.f}set isDefault(P){P!==this.f&&(this.f=P,Le(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:P}))}get tag(){return this._tag}set tag(P){P?.id!==this._tag?.id&&(this._tag=P,Le(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:P?o.TestTag.namespace(this.controllerId,P.id):null}))}get configureHandler(){return this.c}set configureHandler(P){P!==this.c&&(this.c=P,Le(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!P}))}constructor(P,F,V,q,le,_,pe,ue=!1,de=void 0,re=!1){this.controllerId=V,this.profileId=q,this.d=le,this.kind=_,this.runHandler=pe,this.f=ue,this._tag=de,this.g=re,n.set(this,void 0),h.set(this,void 0),Je(this,n,P,"f"),Je(this,h,F,"f"),F.set(q,this);const G=L[_];if(typeof G!="number")throw new Error(`Unknown TestRunProfile.group ${_}`);Le(this,n,"f").$publishTestRunProfile({profileId:q,controllerId:V,tag:de?o.TestTag.namespace(this.controllerId,de.id):null,label:le,group:G,isDefault:ue,hasConfigurationHandler:!1,supportsContinuousRun:re})}dispose(){Le(this,h,"f")?.delete(this.profileId)&&(Je(this,h,void 0,"f"),Le(this,n,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=x,n=new WeakMap,h=new WeakMap;const L={[l.TestRunProfileKind.Coverage]:8,[l.TestRunProfileKind.Debug]:4,[l.TestRunProfileKind.Run]:2}}),define(Ie[230],Ce([1,0,18,4,5,102,8,7]),function(te,e,r,k,D,N,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(M,E){this.i=E,this.a=new k.Emitter,this.b=new k.Emitter,this.c=new k.Emitter,this.d=new k.Emitter,this.f=new k.Emitter,this.g=new k.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=M.getProxy(D.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(f=>this.g.fire(f)),this.i.onDidChangeActiveTextEditor(f=>this.f.fire(f))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(M){const E=this.i.allEditors();return M?E:E.map(f=>f.value)}async showTextDocument(M,E,f){let b;typeof E=="number"?b={position:S.ViewColumn.from(E),preserveFocus:f}:typeof E=="object"?b={position:S.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selection:typeof E.selection=="object"?S.Range.from(E.selection):void 0,pinned:typeof E.preview=="boolean"?!E.preview:void 0}:b={preserveFocus:!1};const m=await this.h.$tryShowTextDocument(M.uri,b),s=m&&this.i.getEditor(m);if(s)return s.value;throw m?new Error(`Could NOT open editor for "${M.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${M.uri.toString()}".`)}createTextEditorDecorationType(M,E){return new N.TextEditorDecorationType(this.h,M,E).value}$acceptEditorPropertiesChanged(M,E){const f=this.i.getEditor(M);if(!f)throw new Error("unknown text editor");if(E.options&&f._acceptOptions(E.options),E.selections){const b=E.selections.selections.map(S.Selection.to);f._acceptSelections(b)}if(E.visibleRanges){const b=r.coalesce(E.visibleRanges.map(S.Range.to));f._acceptVisibleRanges(b)}if(E.options&&this.b.fire({textEditor:f.value,options:{...E.options,lineNumbers:S.TextEditorLineNumbersStyle.to(E.options.lineNumbers)}}),E.selections){const b=R.TextEditorSelectionChangeKind.fromValue(E.selections.source),m=E.selections.selections.map(S.Selection.to);this.a.fire({textEditor:f.value,selections:m,kind:b})}if(E.visibleRanges){const b=r.coalesce(E.visibleRanges.map(S.Range.to));this.c.fire({textEditor:f.value,visibleRanges:b})}}$acceptEditorPositionData(M){for(const E in M){const f=this.i.getEditor(E);if(!f)throw new Error("Unknown text editor");const b=S.ViewColumn.to(M[E]);f.value.viewColumn!==b&&(f._acceptViewColumn(b),this.d.fire({textEditor:f.value,viewColumn:b}))}}getDiffInformation(M){return Promise.resolve(this.h.$getDiffInformation(M))}}e.ExtHostEditors=y}),define(Ie[231],Ce([1,0,2,3,5,6,7,8,25,9]),function(te,e,r,k,D,N,S,R,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,k.createDecorator)("IExtHostTimeline");class M{constructor(b,m){this.b=new Map,this.c=new Map,this.a=b.getProxy(D.MainContext.MainThreadTimeline),m.registerArgumentProcessor({processArgument:(s,o)=>{if(s&&s.$mid===12)if(this.b.get(s.source)&&y.ExtensionIdentifier.equals(o,this.b.get(s.source)?.extension)){const l=s.uri===void 0?void 0:r.URI.revive(s.uri);return this.c.get(s.source)?.get(E(l))?.get(s.handle)}else return;return s}})}async $getTimeline(b,m,s,o){return this.b.get(b)?.provider.provideTimeline(r.URI.revive(m),s,o)}registerTimelineProvider(b,m,s,o){const l=new N.DisposableStore,v=this.d(m.id,o,l).bind(this);let w;m.onDidChange&&(w=m.onDidChange(p=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:m.id}),this));const A=this.c;return this.f({...m,scheme:b,onDidChange:void 0,async provideTimeline(p,n,h){n?.resetCache&&(l.clear(),A.get(m.id)?.clear());const i=await m.provideTimeline(p,n,h);if(i==null)return;const a=v(p,n);return{...i,source:m.id,items:i.items.map(a)}},dispose(){for(const p of A.values())p.get(m.id)?.clear();w?.dispose(),l.dispose()}},s)}d(b,m,s){return(o,l)=>{let v;if(l?.cacheResults){let w=this.c.get(b);w===void 0&&(w=new Map,this.c.set(b,w));const A=E(o);v=w.get(A),v===void 0&&(v=new Map,w.set(A,v))}return w=>{const{iconPath:A,...p}=w,n=`${b}|${w.id??w.timestamp}`;v?.set(n,w);let h,i,a;w.iconPath&&(A instanceof S.ThemeIcon?a={id:A.id,color:A.color}:r.URI.isUri(A)?(h=A,i=A):{light:h,dark:i}=A);let t;return S.MarkdownString.isMarkdownString(p.tooltip)?t=R.MarkdownString.from(p.tooltip):(0,T.isString)(p.tooltip)?t=p.tooltip:S.MarkdownString.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),t=R.MarkdownString.from(p.detail)):(0,T.isString)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),t=p.detail),{...p,id:p.id??void 0,handle:n,source:b,command:w.command?m.toInternal(w.command,s):void 0,icon:h,iconDark:i,themeIcon:a,tooltip:t,accessibilityInformation:w.accessibilityInformation}}}}f(b,m){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:m}),(0,N.toDisposable)(()=>{for(const o of this.c.values())o.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.ExtHostTimeline=M;function E(f){return f?.toString()}}),define(Ie[232],Ce([1,0,6,15,2,5]),function(te,e,r,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class S{constructor(y){this.c=new Map,this.b=y.getProxy(N.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,T,M,E){if(this.c.has(T))throw new Error(`Opener with id '${T}' already registered`);const f=E.schemes.find(b=>!S.a.has(b));if(f)throw new Error(`Scheme '${f}' is not supported. Only http and https are currently supported.`);return this.c.set(T,M),this.b.$registerUriOpener(T,E.schemes,y,E.label),(0,r.toDisposable)(()=>{this.c.delete(T),this.b.$unregisterUriOpener(T)})}async $canOpenUri(y,T,M){const E=this.c.get(y);if(!E)throw new Error(`Unknown opener with id: ${y}`);const f=D.URI.revive(T);return E.canOpenExternalUri(f,M)}async $openUri(y,T,M){const E=this.c.get(y);if(!E)throw new Error(`Unknown opener id: '${y}'`);return E.openExternalUri(D.URI.revive(T.resolvedUri),{sourceUri:D.URI.revive(T.sourceUri)},M)}}e.ExtHostUriOpeners=S,S.a=new Set([k.Schemas.http,k.Schemas.https])}),define(Ie[233],Ce([1,0,5,2,6,12,25]),function(te,e,r,k,D,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class R{constructor(T){this.c=new Set,this.d=new Map,this.b=T.getProxy(r.MainContext.MainThreadUrls)}registerUriHandler(T,M){if(this.c.has(S.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const E=R.a++;return this.c.add(S.ExtensionIdentifier.toKey(T)),this.d.set(E,M),this.b.$registerUriHandler(E,T),(0,D.toDisposable)(()=>{this.c.delete(S.ExtensionIdentifier.toKey(T)),this.d.delete(E),this.b.$unregisterUriHandler(E)})}$handleExternalUri(T,M){const E=this.d.get(T);if(!E)return Promise.resolve(void 0);try{E.handleUri(k.URI.revive(M))}catch(f){(0,N.onUnexpectedError)(f)}return Promise.resolve(void 0)}async createAppUri(T){return k.URI.revive(await this.b.$createAppUri(T))}}e.ExtHostUrls=R,R.a=0});var Je=this&&this.__classPrivateFieldSet||function(te,e,r,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,r):D?D.value=r:e.set(te,r),r},Le=this&&this.__classPrivateFieldGet||function(te,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(te):k?k.value:e.get(te)};define(Ie[61],Ce([1,0,4,15,22,2,155,178,72,5]),function(te,e,r,k,D,N,S,R,y,T){"use strict";var M,E,f,b,m,s,o,l,v,w,A,p,n;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class h{constructor(O,j,Z,x,L,$,P){M.set(this,void 0),E.set(this,void 0),f.set(this,void 0),b.set(this,void 0),m.set(this,void 0),s.set(this,void 0),o.set(this,""),l.set(this,void 0),v.set(this,!1),w.set(this,!1),A.set(this,void 0),p.set(this,void 0),this._onMessageEmitter=new r.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,n.set(this,new r.Emitter),this._onDidDispose=Le(this,n,"f").event,Je(this,M,O,"f"),Je(this,E,j,"f"),Je(this,l,Z,"f"),Je(this,b,x,"f"),Je(this,m,L,"f"),Je(this,s,$,"f"),Je(this,A,i($),"f"),Je(this,p,a($),"f"),Je(this,f,P,"f")}dispose(){Je(this,v,!0,"f"),Le(this,n,"f").fire(),Le(this,n,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(O){return Je(this,w,!0,"f"),(0,y.asWebviewUri)(O,Le(this,b,"f"))}get cspSource(){const O=Le(this,s,"f").extensionLocation;if(O.scheme===k.Schemas.https||O.scheme===k.Schemas.http){let j=O.toString();return j.endsWith("/")||(j+="/"),j+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.a(),Le(this,o,"f")}set html(O){this.a(),Le(this,o,"f")!==O&&(Je(this,o,O,"f"),Le(this,p,"f")&&!Le(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(O)&&(Je(this,w,!0,"f"),Le(this,f,"f").report("Webview vscode-resource: uris",Le(this,s,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Le(this,E,"f").$setHtml(Le(this,M,"f"),this.b(O)))}get options(){return this.a(),Le(this,l,"f")}set options(O){this.a(),D.equals(Le(this,l,"f"),O)||Le(this,E,"f").$setOptions(Le(this,M,"f"),c(Le(this,s,"f"),Le(this,m,"f"),O)),Je(this,l,O,"f")}async postMessage(O){if(Le(this,v,"f"))return!1;const j=(0,R.serializeWebviewMessage)(O,{serializeBuffersForPostMessage:Le(this,A,"f")});return Le(this,E,"f").$postMessage(Le(this,M,"f"),j.message,...j.buffers)}a(){if(Le(this,v,"f"))throw new Error("Webview is disposed")}b(O){if(!Le(this,p,"f"))return O;const j=Le(this,s,"f").extensionLocation?.scheme===k.Schemas.vscodeRemote,Z=Le(this,s,"f").extensionLocation.scheme===k.Schemas.vscodeRemote?Le(this,s,"f").extensionLocation.authority:void 0;return O.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(x,L,$,P,F,V)=>{const q=N.URI.from({scheme:P||"file",path:decodeURIComponent(F)}),le=(0,y.asWebviewUri)(q,{isRemote:j,authority:Z}).toString();return`${L}${le}${V}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(x,L,$,P,F,V)=>{const q=N.URI.from({scheme:P||"file",path:decodeURIComponent(F)}),le=(0,y.asWebviewUri)(q,{isRemote:j,authority:Z}).toString();return`${L}${le}${V}`})}}e.ExtHostWebview=h,M=new WeakMap,E=new WeakMap,f=new WeakMap,b=new WeakMap,m=new WeakMap,s=new WeakMap,o=new WeakMap,l=new WeakMap,v=new WeakMap,w=new WeakMap,A=new WeakMap,p=new WeakMap,n=new WeakMap;function i(C){try{const O=(0,S.normalizeVersion)((0,S.parseVersion)(C.engines.vscode));return!!O&&O.majorBase>=1&&O.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=i;function a(C){try{const O=(0,S.normalizeVersion)((0,S.parseVersion)(C.engines.vscode));return O?O.majorBase<1||O.majorBase===1&&O.minorBase<60:!1}catch{return!1}}class t{constructor(O,j,Z,x,L){this.c=j,this.d=Z,this.e=x,this.f=L,this.b=new Map,this.a=O.getProxy(T.MainContext.MainThreadWebviews)}$onMessage(O,j,Z){const x=this.g(O);if(x){const{message:L}=(0,R.deserializeWebviewMessage)(j,Z.value);x._onMessageEmitter.fire(L)}}$onMissingCsp(O,j){this.e.warn(`${j} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(O,j,Z){const x=new h(O,this.a,u(j),this.c,this.d,Z,this.f);return this.b.set(O,x),x._onDidDispose(()=>{this.b.delete(O)}),x}deleteWebview(O){this.b.delete(O)}g(O){return this.b.get(O)}}e.ExtHostWebviews=t;function g(C){return{id:C.identifier,location:C.extensionLocation}}e.toExtensionData=g;function c(C,O,j){return{enableCommandUris:j.enableCommandUris,enableScripts:j.enableScripts,enableForms:j.enableForms,portMapping:j.portMapping,localResourceRoots:j.localResourceRoots||d(C,O)}}e.serializeWebviewOptions=c;function u(C){return{enableCommandUris:C.enableCommandUris,enableScripts:C.enableScripts,enableForms:C.enableForms,portMapping:C.portMapping,localResourceRoots:C.localResourceRoots?.map(O=>N.URI.from(O))}}function d(C,O){return[...(O?.getWorkspaceFolders()||[]).map(j=>j.uri),C.extensionLocation]}}),define(Ie[234],Ce([1,0,21,229,6,15,24,2,8,61,53,5,7]),function(te,e,r,k,D,N,S,R,y,T,M,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class b{constructor(h,i){this.document=h,this.b=i,this.a=1,this.c=new M.Cache("custom documents")}addEdit(h){return this.c.add([h])}async undo(h,i){await this.f(h).undo(),i||this.disposeBackup()}async redo(h,i){await this.f(h).redo(),i||this.disposeBackup()}disposeEdits(h){for(const i of h)this.c.delete(i)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const h=p(this.document.uri)+this.a++;return(0,S.joinPath)(this.b,h)}updateBackup(h){this.d?.delete(),this.d=h}disposeBackup(){this.d?.delete(),this.d=void 0}f(h){const i=this.c.get(h,0);if(!i)throw new Error("No edit found");return i}}class m{constructor(){this.a=new Map}get(h,i){return this.a.get(this.b(h,i))}add(h,i,a){const t=this.b(h,i.uri);if(this.a.has(t))throw new Error(`Document already exists for viewType:${h} resource:${i.uri}`);const g=new b(i,a);return this.a.set(t,g),g}delete(h,i){const a=this.b(h,i.uri);this.a.delete(a)}b(h,i){return`${h}@@@${i}`}}var s;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(s||(s={}));class o{constructor(){this.a=new Map}addTextProvider(h,i,a){return this.b(0,h,i,a)}addCustomProvider(h,i,a){return this.b(1,h,i,a)}get(h){return this.a.get(h)}b(h,i,a,t){if(this.a.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this.a.set(i,{type:h,extension:a,provider:t}),new f.Disposable(()=>this.a.delete(i))}}class l{constructor(h,i,a,t,g){this.d=i,this.f=a,this.g=t,this.h=g,this.b=new o,this.c=new m,this.a=h.getProxy(E.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(h,i,a,t){const g=new D.DisposableStore;return w(a)?(g.add(this.b.addTextProvider(i,h,a)),this.a.$registerTextEditorProvider((0,T.toExtensionData)(h),i,t.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(h))):(g.add(this.b.addCustomProvider(i,h,a)),v(a)&&g.add(a.onDidChangeCustomDocument(c=>{const u=this.i(i,c.document.uri);if(A(c)){const d=u.addEdit(c);this.a.$onDidEdit(c.document.uri,i,d,c.label)}else this.a.$onContentChange(c.document.uri,i)})),this.a.$registerCustomEditorProvider((0,T.toExtensionData)(h),i,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(h))),f.Disposable.from(g,new f.Disposable(()=>{this.a.$unregisterEditorProvider(i)}))}async $createCustomDocument(h,i,a,t,g){const c=this.b.get(i);if(!c)throw new Error(`No provider found for '${i}'`);if(c.type!==1)throw new Error(`Invalid provide type for '${i}'`);const u=R.URI.revive(h),d=await c.provider.openCustomDocument(u,{backupId:a,untitledDocumentData:t?.buffer},g);let C;return v(c.provider)&&this.f&&(C=this.f.workspaceValue(c.extension)??this.f.globalValue(c.extension)),this.c.add(i,d,C),{editable:v(c.provider)}}async $disposeCustomDocument(h,i){const a=this.b.get(i);if(!a)throw new Error(`No provider found for '${i}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${i}'`);const t=R.URI.revive(h),{document:g}=this.i(i,t);this.c.delete(i,g),g.dispose()}async $resolveCustomEditor(h,i,a,t,g,c){console.log("xxxx");const u=this.b.get(a);if(!u)throw new Error(`No provider found for '${a}'`);const d=y.ViewColumn.to(g),C=this.g.createNewWebview(i,t.contentOptions,u.extension),O=this.h.createNewWebviewPanel(i,a,t.title,d,t.options,C,!0),j=R.URI.revive(h);switch(u.type){case 1:{const{document:Z}=this.i(a,j);return u.provider.resolveCustomEditor(Z,O,c)}case 0:{const Z=this.d.getDocument(j);return u.provider.resolveCustomTextEditor(Z,O,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(h,i,a){this.i(i,h).disposeEdits(a)}async $onMoveCustomEditor(h,i,a){const t=this.b.get(a);if(!t)throw new Error(`No provider found for '${a}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const g=this.h.getWebviewPanel(h);if(!g)throw new Error("No webview found");const c=R.URI.revive(i),u=this.d.getDocument(c);await t.provider.moveCustomTextEditor(u,g,r.CancellationToken.None)}async $undo(h,i,a,t){return this.i(i,h).undo(a,t)}async $redo(h,i,a,t){return this.i(i,h).redo(a,t)}async $revert(h,i,a){const t=this.i(i,h);await this.j(i).revertCustomDocument(t.document,a),t.disposeBackup()}async $onSave(h,i,a){const t=this.i(i,h);await this.j(i).saveCustomDocument(t.document,a),t.disposeBackup()}async $onSaveAs(h,i,a,t){const g=this.i(i,h);return this.j(i).saveCustomDocumentAs(g.document,R.URI.revive(a),t)}async $backup(h,i,a){const t=this.i(i,h),c=await this.j(i).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},a);return t.updateBackup(c),c.id}i(h,i){const a=this.c.get(h,R.URI.revive(i));if(!a)throw new Error("No custom document found");return a}j(h){const a=this.b.get(h)?.provider;if(!a||!v(a))throw new Error("Custom document is not editable");return a}}e.ExtHostCustomEditors=l;function v(n){return!!n.onDidChangeCustomDocument}function w(n){return typeof n.resolveCustomTextEditor=="function"}function A(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function p(n){const h=n.scheme===N.Schemas.file||n.scheme===N.Schemas.untitled?n.fsPath:n.toString();return(0,k.hash)(h)+""}});var Je=this&&this.__classPrivateFieldSet||function(te,e,r,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,r):D?D.value=r:e.set(te,r),r},Le=this&&this.__classPrivateFieldGet||function(te,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(te):k?k.value:e.get(te)};define(Ie[235],Ce([1,0,4,6,2,34,8,61,5,7]),function(te,e,r,k,D,N,S,R,y,T){"use strict";var M,E,f,b,m,s,o,l,v,w,A,p,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class h extends k.Disposable{constructor(g,c,u,d){super(),M.set(this,void 0),E.set(this,void 0),f.set(this,void 0),b.set(this,void 0),m.set(this,void 0),s.set(this,void 0),o.set(this,void 0),l.set(this,void 0),v.set(this,!0),w.set(this,void 0),A.set(this,!1),p.set(this,this.B(new r.Emitter)),this.onDidDispose=Le(this,p,"f").event,n.set(this,this.B(new r.Emitter)),this.onDidChangeViewState=Le(this,n,"f").event,Je(this,M,g,"f"),Je(this,E,c,"f"),Je(this,b,u,"f"),Je(this,f,d.viewType,"f"),Je(this,m,d.panelOptions,"f"),Je(this,l,d.viewColumn,"f"),Je(this,s,d.title,"f"),Je(this,w,d.active,"f")}dispose(){Le(this,A,"f")||(Je(this,A,!0,"f"),Le(this,p,"f").fire(),Le(this,E,"f").$disposeWebview(Le(this,M,"f")),Le(this,b,"f").dispose(),super.dispose())}get webview(){return this.c(),Le(this,b,"f")}get viewType(){return this.c(),Le(this,f,"f")}get title(){return this.c(),Le(this,s,"f")}set title(g){this.c(),Le(this,s,"f")!==g&&(Je(this,s,g,"f"),Le(this,E,"f").$setTitle(Le(this,M,"f"),g))}get iconPath(){return this.c(),Le(this,o,"f")}set iconPath(g){this.c(),Le(this,o,"f")!==g&&(Je(this,o,g,"f"),Le(this,E,"f").$setIconPath(Le(this,M,"f"),D.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return Le(this,m,"f")}get viewColumn(){if(this.c(),!(typeof Le(this,l,"f")=="number"&&Le(this,l,"f")<0))return Le(this,l,"f")}get active(){return this.c(),Le(this,w,"f")}get visible(){return this.c(),Le(this,v,"f")}_updateViewState(g){Le(this,A,"f")||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(Je(this,w,g.active,"f"),Je(this,v,g.visible,"f"),Je(this,l,g.viewColumn,"f"),Le(this,n,"f").fire({webviewPanel:this}))}reveal(g,c){this.c(),Le(this,E,"f").$reveal(Le(this,M,"f"),{viewColumn:typeof g>"u"?void 0:S.ViewColumn.from(g),preserveFocus:!!c})}c(){if(Le(this,A,"f"))throw new Error("Webview is disposed")}}M=new WeakMap,E=new WeakMap,f=new WeakMap,b=new WeakMap,m=new WeakMap,s=new WeakMap,o=new WeakMap,l=new WeakMap,v=new WeakMap,w=new WeakMap,A=new WeakMap,p=new WeakMap,n=new WeakMap;class i{static c(){return(0,N.generateUuid)()}constructor(g,c,u){this.g=c,this.h=u,this.e=new Map,this.f=new Map,this.d=g.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(g,c,u,d,C={}){const O=typeof d=="object"?d.viewColumn:d,j={viewColumn:S.ViewColumn.from(O),preserveFocus:typeof d=="object"&&!!d.preserveFocus},Z=(0,R.shouldSerializeBuffersForPostMessage)(g),x=i.c();this.d.$createWebviewPanel((0,R.toExtensionData)(g),x,c,{title:u,panelOptions:a(C),webviewOptions:(0,R.serializeWebviewOptions)(g,this.h,C),serializeBuffersForPostMessage:Z},j);const L=this.g.createNewWebview(x,C,g);return this.createNewWebviewPanel(x,c,u,O,C,L,!0)}$onDidChangeWebviewPanelViewStates(g){const c=Object.keys(g);c.sort((u,d)=>{const C=g[u],O=g[d];return C.active?1:O.active?-1:+C.visible-+O.visible});for(const u of c){const d=this.getWebviewPanel(u);if(!d)continue;const C=g[u];d._updateViewState({active:C.active,visible:C.visible,viewColumn:S.ViewColumn.to(C.position)})}}async $onDidDisposeWebviewPanel(g){this.getWebviewPanel(g)?.dispose(),this.e.delete(g),this.g.deleteWebview(g)}registerWebviewPanelSerializer(g,c,u){if(this.f.has(c))throw new Error(`Serializer for '${c}' already registered`);return this.f.set(c,{serializer:u,extension:g}),this.d.$registerSerializer(c,{serializeBuffersForPostMessage:(0,R.shouldSerializeBuffersForPostMessage)(g)}),new T.Disposable(()=>{this.f.delete(c),this.d.$unregisterSerializer(c)})}async $deserializeWebviewPanel(g,c,u,d){const C=this.f.get(c);if(!C)throw new Error(`No serializer found for '${c}'`);const{serializer:O,extension:j}=C,Z=this.g.createNewWebview(g,u.webviewOptions,j),x=this.createNewWebviewPanel(g,c,u.title,d,u.panelOptions,Z,u.active);await O.deserializeWebviewPanel(x,u.state)}createNewWebviewPanel(g,c,u,d,C,O,j){const Z=new h(g,this.d,O,{viewType:c,title:u,viewColumn:d,panelOptions:C,active:j});return this.e.set(g,Z),Z}getWebviewPanel(g){return this.e.get(g)}}e.ExtHostWebviewPanels=i;function a(t){return{enableFindWidget:t.enableFindWidget,retainContextWhenHidden:t.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(te,e,r,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,r):D?D.value=r:e.set(te,r),r},Le=this&&this.__classPrivateFieldGet||function(te,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(te):k?k.value:e.get(te)};define(Ie[236],Ce([1,0,4,6,61,8,5,7]),function(te,e,r,k,D,N,S,R){"use strict";var y,T,M,E,f,b,m,s,o,l,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends k.Disposable{constructor(n,h,i,a,t,g){super(),y.set(this,void 0),T.set(this,void 0),M.set(this,void 0),E.set(this,void 0),f.set(this,!1),b.set(this,void 0),m.set(this,void 0),s.set(this,void 0),o.set(this,void 0),l.set(this,this.B(new r.Emitter)),this.onDidChangeVisibility=Le(this,l,"f").event,v.set(this,this.B(new r.Emitter)),this.onDidDispose=Le(this,v,"f").event,Je(this,M,i,"f"),Je(this,m,a,"f"),Je(this,y,n,"f"),Je(this,T,h,"f"),Je(this,E,t,"f"),Je(this,b,g,"f")}dispose(){Le(this,f,"f")||(Je(this,f,!0,"f"),Le(this,v,"f").fire(),Le(this,E,"f").dispose(),super.dispose())}get title(){return this.a(),Le(this,m,"f")}set title(n){this.a(),Le(this,m,"f")!==n&&(Je(this,m,n,"f"),Le(this,T,"f").$setWebviewViewTitle(Le(this,y,"f"),n))}get description(){return this.a(),Le(this,s,"f")}set description(n){this.a(),Le(this,s,"f")!==n&&(Je(this,s,n,"f"),Le(this,T,"f").$setWebviewViewDescription(Le(this,y,"f"),n))}get visible(){return Le(this,b,"f")}get webview(){return Le(this,E,"f")}get viewType(){return Le(this,M,"f")}_setVisible(n){n===Le(this,b,"f")||Le(this,f,"f")||(Je(this,b,n,"f"),Le(this,l,"f").fire())}get badge(){return this.a(),Le(this,o,"f")}set badge(n){this.a(),!(n?.value===Le(this,o,"f")?.value&&n?.tooltip===Le(this,o,"f")?.tooltip)&&(Je(this,o,N.ViewBadge.from(n),"f"),Le(this,T,"f").$setWebviewViewBadge(Le(this,y,"f"),n))}show(n){this.a(),Le(this,T,"f").$show(Le(this,y,"f"),!!n)}a(){if(Le(this,f,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,T=new WeakMap,M=new WeakMap,E=new WeakMap,f=new WeakMap,b=new WeakMap,m=new WeakMap,s=new WeakMap,o=new WeakMap,l=new WeakMap,v=new WeakMap;class A{constructor(n,h){this.d=h,this.b=new Map,this.c=new Map,this.a=n.getProxy(S.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(n,h,i,a){if(this.b.has(h))throw new Error(`View provider for '${h}' already registered`);return this.b.set(h,{provider:i,extension:n}),this.a.$registerWebviewViewProvider((0,D.toExtensionData)(n),h,{retainContextWhenHidden:a?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(n)}),new R.Disposable(()=>{this.b.delete(h),this.a.$unregisterWebviewViewProvider(h)})}async $resolveWebviewView(n,h,i,a,t){const g=this.b.get(h);if(!g)throw new Error(`No view provider found for '${h}'`);const{provider:c,extension:u}=g,d=this.d.createNewWebview(n,{},u),C=new w(n,this.a,h,i,d,!0);this.c.set(n,C),await c.resolveWebviewView(C,{state:a},t)}async $onDidChangeWebviewViewVisibility(n,h){this.e(n)._setVisible(h)}async $disposeWebviewView(n){const h=this.e(n);this.c.delete(n),h.dispose(),this.d.deleteWebview(n)}e(n){const h=this.c.get(n);if(!h)throw new Error("No webview found");return h}}e.ExtHostWebviewViews=A}),define(Ie[104],Ce([1,0,4,5,2,15,10,3,17]),function(te,e,r,k,D,N,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class an{get state(){return this.d}constructor(E){this.c=new r.Emitter,this.onDidChangeWindowState=this.c.event,this.d=an.a,this.b=E.getProxy(k.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(f=>this.$onDidChangeWindowFocus(f))}$onDidChangeWindowFocus(E){E!==this.d.focused&&(this.d={...this.d,focused:E},this.c.fire(this.d))}openUri(E,f){let b;if(typeof E=="string"){b=E;try{E=D.URI.parse(E)}catch{return Promise.reject(`Invalid uri - '${E}'`)}}return(0,S.isFalsyOrWhitespace)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this.b.$openUri(E,b,f)}async asExternalUri(E,f){if((0,S.isFalsyOrWhitespace)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this.b.$asExternalUri(E,f);return D.URI.from(b)}};T.a={focused:!0},T=qe([je(0,y.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,R.createDecorator)("IExtHostWindow")}),define(Ie[237],Ce([1,0,207,26,17]),function(te,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let N=class extends r.AbstractExtHostConsoleForwarder{constructor(R,y){super(R,y)}f(R,y,T){y.apply(console,T)}};N=qe([je(0,D.IExtHostRpcService),je(1,k.IExtHostInitDataService)],N),e.ExtHostConsoleForwarder=N}),define(Ie[238],Ce([1,0,16,23,21,12,4,6,126,201,45]),function(te,e,r,k,D,N,S,R,y,T,M){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function f(C,O){try{return JSON.stringify(C,O)}catch{return"null"}}const b="$$ref$$",m={[b]:-1};class s{constructor(O,j){this.jsonString=O,this.referencedBuffers=j}}function o(C,O=null,j=!1){const Z=[];return{jsonString:(j?f:JSON.stringify)(C,(L,$)=>{if(typeof $>"u")return m;if(typeof $=="object"){if($ instanceof k.VSBuffer){const P=Z.push($)-1;return{[b]:P}}if(O)return O(L,$)}return $}),referencedBuffers:Z}}e.stringifyJsonWithBufferRefs=o;function l(C,O,j){return JSON.parse(C,(Z,x)=>{if(x){const L=x[b];if(typeof L=="number")return O[L];if(j&&x.$mid===1)return j.transformIncoming(x)}return x})}e.parseJsonAndRestoreBufferRefs=l;function v(C,O){return JSON.stringify(C,O)}function w(C){return C?(O,j)=>j&&j.$mid===1?C.transformOutgoing(j):j:null}var A;(function(C){C[C.LocalSide=0]="LocalSide",C[C.OtherSide=1]="OtherSide"})(A=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(C){C[C.Responsive=0]="Responsive",C[C.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const n=()=>{},h=Symbol.for("rpcProtocol"),i=Symbol.for("rpcProxy");class a extends R.Disposable{constructor(O,j=null,Z=null){super(),this[E]=!0,this.b=this.B(new S.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=O,this.f=j,this.g=Z,this.h=w(this.g),this.j=!1,this.k=[],this.l=[];for(let x=0,L=M.ProxyIdentifier.count;x<L;x++)this.k[x]=null,this.l[x]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new r.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(x=>this.G(x))}dispose(){this.j=!0,Object.keys(this.s).forEach(O=>{this.s[O].resolveErr(N.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(O){this.u===0&&(this.v=Date.now()+a.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(O){this.v=Date.now()+a.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(O){this.t!==O&&(this.t=O,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(O){return this.g?(0,y.transformIncomingURIs)(O,this.g):O}getProxy(O){const{nid:j,sid:Z}=O;return this.l[j]||(this.l[j]=this.F(j,Z)),this.l[j]}F(O,j){const Z={get:(x,L)=>(typeof L=="string"&&!x[L]&&L.charCodeAt(0)===36&&(x[L]=(...$)=>this.O(O,L,$)),L===i?j:x[L])};return new Proxy(Object.create(null),Z)}set(O,j){return this.k[O.nid]=j,j}assertRegistered(O){for(let j=0,Z=O.length;j<Z;j++){const x=O[j];if(!this.k[x.nid])throw new Error(`Missing proxy instance ${x.sid}`)}}G(O){if(this.j)return;const j=O.byteLength,Z=t.read(O,0),x=Z.readUInt8(),L=Z.readUInt32();switch(x){case 1:case 2:{let{rpcId:$,method:P,args:F}=c.deserializeRequestJSONArgs(Z);this.g&&(F=(0,y.transformIncomingURIs)(F,this.g)),this.H(j,L,$,P,F,x===2);break}case 3:case 4:{let{rpcId:$,method:P,args:F}=c.deserializeRequestMixedArgs(Z);this.g&&(F=(0,y.transformIncomingURIs)(F,this.g)),this.H(j,L,$,P,F,x===4);break}case 5:{this.f?.logIncoming(j,L,0,"ack"),this.z(L);break}case 6:{this.I(j,L);break}case 7:{this.J(j,L,void 0);break}case 9:{let $=c.deserializeReplyOKJSON(Z);this.g&&($=(0,y.transformIncomingURIs)($,this.g)),this.J(j,L,$);break}case 10:{const $=c.deserializeReplyOKJSONWithBuffers(Z,this.g);this.J(j,L,$);break}case 8:{const $=c.deserializeReplyOKVSBuffer(Z);this.J(j,L,$);break}case 11:{let $=c.deserializeReplyErrError(Z);this.g&&($=(0,y.transformIncomingURIs)($,this.g)),this.L(j,L,$);break}case 12:{this.L(j,L,void 0);break}default:console.error("received unexpected message"),console.error(O)}}H(O,j,Z,x,L,$){this.f?.logIncoming(O,j,1,`receiveRequest ${(0,M.getStringIdentifierForProxy)(Z)}.${x}(`,L);const P=String(j);let F,V;if($){const le=new D.CancellationTokenSource;L.push(le.token),F=this.M(Z,x,L),V=()=>le.cancel()}else F=this.M(Z,x,L),V=n;this.p[P]=V;const q=c.serializeAcknowledged(j);this.f?.logOutgoing(q.byteLength,j,1,"ack"),this.c.send(q),F.then(le=>{delete this.p[P];const _=c.serializeReplyOK(j,le,this.h);this.f?.logOutgoing(_.byteLength,j,1,"reply:",le),this.c.send(_)},le=>{delete this.p[P];const _=c.serializeReplyErr(j,le);this.f?.logOutgoing(_.byteLength,j,1,"replyErr:",le),this.c.send(_)})}I(O,j){this.f?.logIncoming(O,j,1,"receiveCancel");const Z=String(j);this.p[Z]?.()}J(O,j,Z){this.f?.logIncoming(O,j,0,"receiveReply:",Z);const x=String(j);if(!this.s.hasOwnProperty(x))return;const L=this.s[x];delete this.s[x],L.resolveOk(Z)}L(O,j,Z){this.f?.logIncoming(O,j,0,"receiveReplyErr:",Z);const x=String(j);if(!this.s.hasOwnProperty(x))return;const L=this.s[x];delete this.s[x];let $;Z&&(Z.$isError?($=new Error,$.name=Z.name,$.message=Z.message,$.stack=Z.stack):$=Z),L.resolveErr($)}M(O,j,Z){try{return Promise.resolve(this.N(O,j,Z))}catch(x){return Promise.reject(x)}}N(O,j,Z){const x=this.k[O];if(!x)throw new Error("Unknown actor "+(0,M.getStringIdentifierForProxy)(O));const L=x[j];if(typeof L!="function")throw new Error("Unknown method "+j+" on actor "+(0,M.getStringIdentifierForProxy)(O));return L.apply(x,Z)}O(O,j,Z){if(this.j)return new T.CanceledLazyPromise;let x=null;if(Z.length>0&&D.CancellationToken.isCancellationToken(Z[Z.length-1])&&(x=Z.pop()),x&&x.isCancellationRequested)return Promise.reject(N.canceled());const L=c.serializeRequestArguments(Z,this.h),$=++this.m,P=String($),F=new T.LazyPromise;x&&x.onCancellationRequested(()=>{const q=c.serializeCancel($);this.f?.logOutgoing(q.byteLength,$,0,"cancel"),this.c.send(c.serializeCancel($))}),this.s[P]=F,this.y($);const V=c.serializeRequest($,O,j,L,!!x);return this.f?.logOutgoing(V.byteLength,$,0,`request: ${(0,M.getStringIdentifierForProxy)(O)}.${j}(`,Z),this.c.send(V),F}}e.RPCProtocol=a,E=h,a.a=3*1e3;class t{static alloc(O,j,Z){const x=new t(k.VSBuffer.alloc(Z+1+4),0);return x.writeUInt8(O),x.writeUInt32(j),x}static read(O,j){return new t(O,j)}get buffer(){return this.a}constructor(O,j){this.a=O,this.b=j}static sizeUInt8(){return 1}writeUInt8(O){this.a.writeUInt8(O,this.b),this.b+=1}readUInt8(){const O=this.a.readUInt8(this.b);return this.b+=1,O}writeUInt32(O){this.a.writeUInt32BE(O,this.b),this.b+=4}readUInt32(){const O=this.a.readUInt32BE(this.b);return this.b+=4,O}static sizeShortString(O){return 1+O.byteLength}writeShortString(O){this.a.writeUInt8(O.byteLength,this.b),this.b+=1,this.a.set(O,this.b),this.b+=O.byteLength}readShortString(){const O=this.a.readUInt8(this.b);this.b+=1;const Z=this.a.slice(this.b,this.b+O).toString();return this.b+=O,Z}static sizeLongString(O){return 4+O.byteLength}writeLongString(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}readLongString(){const O=this.a.readUInt32BE(this.b);this.b+=4;const Z=this.a.slice(this.b,this.b+O).toString();return this.b+=O,Z}writeBuffer(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}static sizeVSBuffer(O){return 4+O.byteLength}writeVSBuffer(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}readVSBuffer(){const O=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+O);return this.b+=O,j}static sizeMixedArray(O){let j=0;j+=1;for(let Z=0,x=O.length;Z<x;Z++){const L=O[Z];switch(j+=1,L.type){case 1:j+=this.sizeLongString(L.value);break;case 2:j+=this.sizeVSBuffer(L.value);break;case 3:j+=this.sizeUInt32,j+=this.sizeLongString(L.value);for(let $=0;$<L.buffers.length;++$)j+=this.sizeVSBuffer(L.buffers[$]);break;case 4:break}}return j}writeMixedArray(O){this.a.writeUInt8(O.length,this.b),this.b+=1;for(let j=0,Z=O.length;j<Z;j++){const x=O[j];switch(x.type){case 1:this.writeUInt8(1),this.writeLongString(x.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(x.value);break;case 3:this.writeUInt8(3),this.writeUInt32(x.buffers.length),this.writeLongString(x.value);for(let L=0;L<x.buffers.length;++L)this.writeBuffer(x.buffers[L]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const O=this.a.readUInt8(this.b);this.b+=1;const j=new Array(O);for(let Z=0;Z<O;Z++)switch(this.readUInt8()){case 1:j[Z]=this.readLongString();break;case 2:j[Z]=this.readVSBuffer();break;case 3:{const L=this.readUInt32(),$=this.readLongString(),P=[];for(let F=0;F<L;++F)P.push(this.readVSBuffer());j[Z]=new M.SerializableObjectWithBuffers(l($,P,null));break}case 4:j[Z]=void 0;break}return j}}t.sizeUInt32=4;var g;(function(C){C[C.Simple=0]="Simple",C[C.Mixed=1]="Mixed"})(g||(g={}));class c{static a(O){for(let j=0,Z=O.length;j<Z;j++)if(O[j]instanceof k.VSBuffer||O[j]instanceof M.SerializableObjectWithBuffers||typeof O[j]>"u")return!0;return!1}static serializeRequestArguments(O,j){if(this.a(O)){const Z=[];for(let x=0,L=O.length;x<L;x++){const $=O[x];if($ instanceof k.VSBuffer)Z[x]={type:2,value:$};else if(typeof $>"u")Z[x]={type:4};else if($ instanceof M.SerializableObjectWithBuffers){const{jsonString:P,referencedBuffers:F}=o($.value,j);Z[x]={type:3,value:k.VSBuffer.fromString(P),buffers:F}}else Z[x]={type:1,value:k.VSBuffer.fromString(v($,j))}}return{type:1,args:Z}}return{type:0,args:v(O,j)}}static serializeRequest(O,j,Z,x,L){switch(x.type){case 0:return this.b(O,j,Z,x.args,L);case 1:return this.c(O,j,Z,x.args,L)}}static b(O,j,Z,x,L){const $=k.VSBuffer.fromString(Z),P=k.VSBuffer.fromString(x);let F=0;F+=t.sizeUInt8(),F+=t.sizeShortString($),F+=t.sizeLongString(P);const V=t.alloc(L?2:1,O,F);return V.writeUInt8(j),V.writeShortString($),V.writeLongString(P),V.buffer}static deserializeRequestJSONArgs(O){const j=O.readUInt8(),Z=O.readShortString(),x=O.readLongString();return{rpcId:j,method:Z,args:JSON.parse(x)}}static c(O,j,Z,x,L){const $=k.VSBuffer.fromString(Z);let P=0;P+=t.sizeUInt8(),P+=t.sizeShortString($),P+=t.sizeMixedArray(x);const F=t.alloc(L?4:3,O,P);return F.writeUInt8(j),F.writeShortString($),F.writeMixedArray(x),F.buffer}static deserializeRequestMixedArgs(O){const j=O.readUInt8(),Z=O.readShortString(),x=O.readMixedArray(),L=new Array(x.length);for(let $=0,P=x.length;$<P;$++){const F=x[$];typeof F=="string"?L[$]=JSON.parse(F):L[$]=F}return{rpcId:j,method:Z,args:L}}static serializeAcknowledged(O){return t.alloc(5,O,0).buffer}static serializeCancel(O){return t.alloc(6,O,0).buffer}static serializeReplyOK(O,j,Z){if(typeof j>"u")return this.d(O);if(j instanceof k.VSBuffer)return this.e(O,j);if(j instanceof M.SerializableObjectWithBuffers){const{jsonString:x,referencedBuffers:L}=o(j.value,Z,!0);return this.g(O,x,L)}else return this.f(O,f(j,Z))}static d(O){return t.alloc(7,O,0).buffer}static e(O,j){let Z=0;Z+=t.sizeVSBuffer(j);const x=t.alloc(8,O,Z);return x.writeVSBuffer(j),x.buffer}static deserializeReplyOKVSBuffer(O){return O.readVSBuffer()}static f(O,j){const Z=k.VSBuffer.fromString(j);let x=0;x+=t.sizeLongString(Z);const L=t.alloc(9,O,x);return L.writeLongString(Z),L.buffer}static g(O,j,Z){const x=k.VSBuffer.fromString(j);let L=0;L+=t.sizeUInt32,L+=t.sizeLongString(x);for(const P of Z)L+=t.sizeVSBuffer(P);const $=t.alloc(10,O,L);$.writeUInt32(Z.length),$.writeLongString(x);for(const P of Z)$.writeBuffer(P);return $.buffer}static deserializeReplyOKJSON(O){const j=O.readLongString();return JSON.parse(j)}static deserializeReplyOKJSONWithBuffers(O,j){const Z=O.readUInt32(),x=O.readLongString(),L=[];for(let $=0;$<Z;++$)L.push(O.readVSBuffer());return new M.SerializableObjectWithBuffers(l(x,L,j))}static serializeReplyErr(O,j){const Z=j?f(N.transformErrorForSerialization(j),null):void 0;if(typeof Z!="string")return this.h(O);const x=k.VSBuffer.fromString(Z);let L=0;L+=t.sizeLongString(x);const $=t.alloc(11,O,L);return $.writeLongString(x),$.buffer}static deserializeReplyErrError(O){const j=O.readLongString();return JSON.parse(j)}static h(O){return t.alloc(12,O,0).buffer}}var u;(function(C){C[C.RequestJSONArgs=1]="RequestJSONArgs",C[C.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",C[C.RequestMixedArgs=3]="RequestMixedArgs",C[C.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",C[C.Acknowledged=5]="Acknowledged",C[C.Cancel=6]="Cancel",C[C.ReplyOKEmpty=7]="ReplyOKEmpty",C[C.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",C[C.ReplyOKJSON=9]="ReplyOKJSON",C[C.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",C[C.ReplyErrError=11]="ReplyErrError",C[C.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var d;(function(C){C[C.String=1]="String",C[C.VSBuffer=2]="VSBuffer",C[C.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",C[C.Undefined=4]="Undefined"})(d||(d={}))}),define(Ie[239],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const r=function(N){const S=R=>{self.removeEventListener("message",S);const y=R.data;Object.defineProperties(self,{postMessage:{value(T,M){y.postMessage(T,M)}},onmessage:{get(){return y.onmessage},set(T){y.onmessage=T}}}),y.addEventListener("message",T=>{self.dispatchEvent(new MessageEvent("message",{data:T.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};self.addEventListener("message",S)}.toString();class k extends EventTarget{constructor(N,S,R){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${r})('${S}'))`,T=new Blob([y],{type:"application/javascript"}),M=URL.createObjectURL(T),E=new MessageChannel,f=M,b={type:"_newWorker",id:f,port:E.port2,url:M,options:R};N(b,[E.port2]),this.postMessage=E.port1.postMessage.bind(E.port1),this.terminate=()=>{N({type:"_terminateWorker",id:f}),URL.revokeObjectURL(M),E.port1.close(),E.port2.close()},Object.defineProperties(this,{onmessage:{get(){return E.port1.onmessage},set(m){E.port1.onmessage=m}},onmessageerror:{get(){return E.port1.onmessageerror},set(m){E.port1.onmessageerror=m}}}),E.port1.addEventListener("messageerror",m=>{const s=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(s)}),E.port1.addEventListener("message",m=>{const s=new MessageEvent("message",{data:m.data});this.dispatchEvent(s)}),E.port1.start()}}e.NestedWorker=k}),define(Ie[240],Ce([1,0,4,30,42,3]),function(te,e,r,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new D.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new D.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new D.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,N.createDecorator)(e.OUTPUT_SERVICE_ID);var S;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(S=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.a=new Map,this.b=new r.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new r.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(T){this.a.has(T.id)||(this.a.set(T.id,T),this.b.fire(T.id))}getChannels(){const T=[];return this.a.forEach(M=>T.push(M)),T}getChannel(T){return this.a.get(T)}removeChannel(T){this.a.delete(T),this.c.fire(T)}}k.Registry.add(e.Extensions.OutputChannels,new R),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new D.RawContextKey("activeOutputChannel","")}),define(Ie[105],Ce([1,0,5,3,17,25,11,240,59,26,36,120,23,9,43,4,6]),function(te,e,r,k,D,N,S,R,y,T,M,E,f,b,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class l extends S.AbstractMessageLogger{get disposed(){return this.l}constructor(p,n,h,i,a){super(),this.id=p,this.name=n,this.m=h,this.n=i,this.extension=a,this.k=0,this.l=!1,this.visible=!1,this.setLevel(h.getLevel()),this.B(h.onDidChangeLogLevel(t=>this.setLevel(t)))}get logLevel(){return this.getLevel()}appendLine(p){this.append(p+`
`)}append(p){this.info(p)}clear(){const p=this.k;this.m.flush(),this.n.$update(this.id,R.OutputChannelUpdateMode.Clear,p)}replace(p){const n=this.k;this.info(p),this.n.$update(this.id,R.OutputChannelUpdateMode.Replace,n),this.visible&&this.m.flush()}show(p,n){this.m.flush(),this.n.$reveal(this.id,!!(typeof p=="boolean"?p:n))}hide(){this.n.$close(this.id)}g(p,n){this.k+=f.VSBuffer.fromString(n).byteLength,(0,S.log)(this.m,p,n),this.visible&&(this.m.flush(),this.n.$update(this.id,R.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class v extends l{appendLine(p){this.append(p)}}let w=class{constructor(p,n,h,i,a,t){this.i=n,this.j=h,this.k=i,this.l=a,this.m=t,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=p.getProxy(r.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(n.logsLocation,`output_logging_${(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.h=p;for(const[n,h]of this.g)h.visible=n===this.h}createOutputChannel(p,n,h){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const i=typeof n=="object"&&n.log,a=(0,b.isString)(n)?n:void 0;if((0,b.isString)(a)&&!a.trim())throw new Error("illegal argument `languageId`. must not be empty");let t;const g=this.i.environment.extensionLogLevel?.find(([u])=>N.ExtensionIdentifier.equals(h.identifier,u))?.[1];g&&(t=(0,S.parseLogLevel)(g));const c=i?this.o(p,t,h):this.n(p,a,h);return c.then(u=>{this.g.set(u.id,u),u.visible=u.id===this.h}),i?this.r(p,t??this.m.getLevel(),c):this.q(p,c)}async n(p,n,h){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const i=await this.c,a=this.k.extUri.joinPath(i,`${this.f++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),t=this.l.createLogger(a,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),g=await this.a.$register(p,a,n,h.identifier.value);return new l(g,p,t,this.a,h)}async o(p,n,h){const i=await this.p(h),a=this.k.extUri.joinPath(i,`${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),t=a.toString(),g=this.l.createLogger(a,{id:t,name:p,logLevel:n,extensionId:h.identifier.value});return new v(t,p,g,this.a,h)}p(p){let n=this.d.get(p.identifier.value);if(!n){const h=this.k.extUri.joinPath(this.i.logsLocation,p.identifier.value);this.d.set(p.identifier.value,n=(async()=>{try{await this.j.value.createDirectory(h)}catch(i){if((0,m.toFileSystemProviderErrorCode)(i)!==m.FileSystemProviderErrorCode.FileExists)throw i}return h})())}return n}q(p,n){let h=!1;const i=()=>{if(h)throw new Error("Channel has been closed")};return{get name(){return p},append(a){i(),n.then(t=>t.append(a))},appendLine(a){i(),n.then(t=>t.appendLine(a))},clear(){i(),n.then(a=>a.clear())},replace(a){i(),n.then(t=>t.replace(a))},show(a,t){i(),n.then(g=>g.show(a,t))},hide(){i(),n.then(a=>a.hide())},dispose(){h=!0,n.then(a=>a.dispose())}}}r(p,n,h){const i=new o.DisposableStore,a=()=>{if(i.isDisposed)throw new Error("Channel has been closed")},t=i.add(new s.Emitter);function g(c){n=c,t.fire(c)}return h.then(c=>{i.add(c),c.logLevel!==n&&g(c.logLevel),i.add(c.onDidChangeLogLevel(u=>g(u)))}),{...this.q(p,h),get logLevel(){return n},onDidChangeLogLevel:t.event,trace(c,...u){a(),h.then(d=>d.trace(c,...u))},debug(c,...u){a(),h.then(d=>d.debug(c,...u))},info(c,...u){a(),h.then(d=>d.info(c,...u))},warn(c,...u){a(),h.then(d=>d.warn(c,...u))},error(c,...u){a(),h.then(d=>d.error(c,...u))},dispose(){i.dispose()}}}};w=qe([je(0,D.IExtHostRpcService),je(1,T.IExtHostInitDataService),je(2,y.IExtHostConsumerFileSystem),je(3,M.IExtHostFileSystemInfo),je(4,S.ILoggerService),je(5,S.ILogService)],w),e.ExtHostOutputService=w,e.IExtHostOutputService=(0,k.createDecorator)("IExtHostOutputService")}),define(Ie[241],Ce([1,0,3]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,r.createDecorator)("remoteAgentService")}),define(Ie[242],Ce([1,0,40,15,19,20,24,2,3,173,52,189,241]),function(te,e,r,k,D,N,S,R,y,T,M,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let b=class cn{constructor(s,o,l,v){this.d=s,this.e=o,this.f=l,this.g=v,this.a=(async()=>(await this.e.getEnvironment())?.os||N.OS)(),this.b=(async()=>{const w=await this.e.getEnvironment();return this.c=w?.userHome??s})()}hasValidBasename(s,o,l){return typeof o=="string"||typeof o>"u"?this.a.then(v=>this.h(s,v,o)):this.h(s,o,l)}h(s,o,l){return s.scheme===k.Schemas.file||s.scheme===k.Schemas.vscodeRemote?(0,r.isValidBasename)(l??(0,S.basename)(s),o===1):!0}get defaultUriScheme(){return cn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(s,o){if(s.remoteAuthority)return k.Schemas.vscodeRemote;const l=(0,T.getVirtualWorkspaceScheme)(o.getWorkspace());if(l)return l;const v=o.getWorkspace().folders[0];if(v)return v.uri.scheme;const w=o.getWorkspace().configuration;return w?w.scheme:k.Schemas.file}userHome(s){return s?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(s=>s===1?D.win32:D.posix)}async fileURI(s){let o="";if(await this.a===1&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const v=s.indexOf("/",2);v===-1?(o=s.substring(2),s="/"):(o=s.substring(2,v),s=s.substring(v)||"/")}return R.URI.from({scheme:k.Schemas.file,authority:o,path:s,query:"",fragment:""})}};b=qe([je(1,f.IRemoteAgentService),je(2,E.IWorkbenchEnvironmentService),je(3,M.IWorkspaceContextService)],b),e.AbstractPathService=b}),define(Ie[106],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class r{constructor(S,R){this.line=S,this.character=R}isBefore(S){return!1}isBeforeOrEqual(S){return!1}isAfter(S){return!1}isAfterOrEqual(S){return!1}isEqual(S){return!1}compareTo(S){return 0}translate(S,R){return new r(0,0)}with(S){return new r(0,0)}}e.Position=r;class k{constructor(S,R,y,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(S,R),this.end=new r(y,T)}contains(S){return!1}isEqual(S){return!1}intersection(S){}union(S){return new k(0,0,0,0)}with(S){return new k(0,0,0,0)}}e.Range=k;var D;(function(N){N[N.Information=1]="Information",N[N.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ie[46],Ce([1,0,18,35,22,40,10,3,19,12,106,16]),function(te,e,r,k,D,N,S,R,y,T,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return M.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const f="\u27EA ",b=" characters skipped \u27EB",m=(f.length+b.length+5)*2;e.ISearchService=(0,R.createDecorator)("searchService");var s;(function(ue){ue[ue.file=0]="file",ue[ue.text=1]="text"})(s=e.SearchProviderType||(e.SearchProviderType={}));var o;(function(ue){ue[ue.File=1]="File",ue[ue.Text=2]="Text"})(o=e.QueryType||(e.QueryType={}));function l(ue){return!!ue.preview}e.resultIsMatch=l;function v(ue){return!!ue.resource}e.isFileMatch=v;function w(ue){return!!ue.message}e.isProgressMessage=w;var A;(function(ue){ue[ue.Normal=0]="Normal",ue[ue.NewSearchStarted=1]="NewSearchStarted"})(A=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(de){this.resource=de,this.results=[]}}e.FileMatch=p;class n{constructor(de,re,G){this.ranges=re;const H=Array.isArray(re)?re:[re];if(G&&G.matchLines===1&&h(H)){de=(0,S.getNLines)(de,G.matchLines);let oe="",ve=0,Ae=0;const Ue=Math.floor(G.charsPerLine/5),xe=[];for(const Te of H){const Se=Math.max(Te.startColumn-Ue,0),ke=Te.startColumn+G.charsPerLine;if(Se>Ae+Ue+m){const se=f+(Se-Ae)+b;oe+=se+de.slice(Se,ke),ve+=Se-(Ae+se.length)}else oe+=de.slice(Ae,ke);xe.push(new a(0,Te.startColumn-ve,Te.endColumn-ve)),Ae=ke}this.preview={text:oe,matches:Array.isArray(this.ranges)?xe:xe[0]}}else{const oe=Array.isArray(re)?re[0].startLineNumber:re.startLineNumber;this.preview={text:de,matches:(0,r.mapArrayOrNot)(re,ve=>new i(ve.startLineNumber-oe,ve.startColumn,ve.endLineNumber-oe,ve.endColumn))}}}}e.TextSearchMatch=n;function h(ue){const de=ue[0].startLineNumber;for(const re of ue)if(re.startLineNumber!==de||re.endLineNumber!==de)return!1;return!0}class i{constructor(de,re,G,H){this.startLineNumber=de,this.startColumn=re,this.endLineNumber=G,this.endColumn=H}}e.SearchRange=i;class a extends i{constructor(de,re,G){super(de,re,de,G)}}e.OneLineRange=a;var t;(function(ue){ue.List="list",ue.Tree="tree"})(t=e.ViewMode||(e.ViewMode={}));var g;(function(ue){ue.Default="default",ue.FileNames="fileNames",ue.Type="type",ue.Modified="modified",ue.CountDescending="countDescending",ue.CountAscending="countAscending"})(g=e.SearchSortOrder||(e.SearchSortOrder={}));function c(ue,de=!0){const re=ue&&ue.files&&ue.files.exclude,G=de&&ue&&ue.search&&ue.search.exclude;if(!re&&!G)return;if(!re||!G)return re||G;let H=Object.create(null);return H=D.mixin(H,D.deepClone(re)),H=D.mixin(H,D.deepClone(G),!0),H}e.getExcludes=c;function u(ue,de){return ue.excludePattern&&k.match(ue.excludePattern,de)?!1:ue.includePattern||ue.usingSearchPaths?ue.includePattern&&k.match(ue.includePattern,de)?!0:ue.usingSearchPaths?!!ue.folderQueries&&ue.folderQueries.some(re=>{const G=re.folder.fsPath;if(N.isEqualOrParent(de,G)){const H=y.relative(G,de);return!re.includePattern||!!k.match(re.includePattern,H)}else return!1}):!1:!0}e.pathIncludedInQuery=u;var d;(function(ue){ue[ue.unknownEncoding=1]="unknownEncoding",ue[ue.regexParseError=2]="regexParseError",ue[ue.globParseError=3]="globParseError",ue[ue.invalidLiteral=4]="invalidLiteral",ue[ue.rgProcessError=5]="rgProcessError",ue[ue.other=6]="other",ue[ue.canceled=7]="canceled"})(d=e.SearchErrorCode||(e.SearchErrorCode={}));class C extends Error{constructor(de,re){super(de),this.code=re}}e.SearchError=C;function O(ue){const de=ue.message;if((0,T.isCancellationError)(ue))return new C(de,d.canceled);try{const re=JSON.parse(de);return new C(re.message,re.code)}catch{return new C(de,d.other)}}e.deserializeSearchError=O;function j(ue){const de={message:ue.message,code:ue.code};return new Error(JSON.stringify(de))}e.serializeSearchError=j;function Z(ue){return ue.type==="error"?!0:ue.type==="success"}e.isSerializedSearchComplete=Z;function x(ue){return ue.type==="success"}e.isSerializedSearchSuccess=x;function L(ue){return!!ue.path}e.isSerializedFileMatch=L;function $(ue,de){const re=ue.searchPath?ue.searchPath:ue.relativePath;return(0,S.fuzzyContains)(re,de)}e.isFilePatternMatch=$;class P{constructor(de){this.path=de,this.results=[]}addMatch(de){this.results.push(de)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=P;function F(ue,de){const re={...ue||{},...de||{}};return Object.keys(re).filter(G=>{const H=re[G];return typeof H=="boolean"&&H})}e.resolvePatternsForProvider=F;class V{constructor(de,re){this.c=null,this.a={...de.excludePattern||{},...re.excludePattern||{}},this.b=k.parse(this.a);let G=de.includePattern;re.includePattern&&(G?G={...G,...re.includePattern}:G=re.includePattern),G&&(this.c=k.parse(G))}matchesExcludesSync(de,re,G){return!!(this.b&&this.b(de,re,G))}includedInQuerySync(de,re,G){return!(this.b&&this.b(de,re,G)||this.c&&!this.c(de,re,G))}includedInQuery(de,re,G){const H=this.b(de,re,G),oe=()=>this.c?!!this.c(de,re,G):!0;return(0,E.isThenable)(H)?H.then(ve=>ve?!1:oe()):oe()}hasSiblingExcludeClauses(){return q(this.a)}}e.QueryGlobTester=V;function q(ue){for(const de in ue)if(typeof ue[de]!="boolean")return!0;return!1}function le(ue){if(!ue)return;let de;return re=>(de||(de=(ue()||Promise.resolve([])).then(G=>G?pe(G):{})),de.then(G=>!!G[re]))}e.hasSiblingPromiseFn=le;function _(ue){if(!ue)return;let de;return re=>{if(!de){const G=ue();de=G?pe(G):{}}return!!de[re]}}e.hasSiblingFn=_;function pe(ue){const de={};for(const re of ue)de[re]=!0;return de}}),define(Ie[31],Ce([1,0,18,16,21,4,6,47,15,113,24,10,9,2,144,3,11,161,52,36,26,17,8,7,54,46,5]),function(te,e,r,k,D,N,S,R,y,T,M,E,f,b,m,s,o,l,v,w,A,p,n,h,i,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function g(x,L,$){return new M.ExtUri(P=>C(P,$)).isEqual(x,L)}function c(x,L,$){return g(x.uri,L.uri,$)?0:(0,E.compare)(x.uri.toString(),L.uri.toString())}function u(x,L,$){return x.index!==L.index?x.index<L.index?-1:1:g(x.uri,L.uri,$)?(0,E.compare)(x.name,L.name):(0,E.compare)(x.uri.toString(),L.uri.toString())}function d(x,L,$,P){const F=x.slice(0).sort((q,le)=>$(q,le,P)),V=L.slice(0).sort((q,le)=>$(q,le,P));return(0,r.delta)(F,V,(q,le)=>$(q,le,P))}function C(x,L){const $=L.getCapabilities(x.scheme);return!($&&$&1024)}class O extends v.Workspace{static toExtHostWorkspace(L,$,P,F){if(!L)return{workspace:null,added:[],removed:[]};const{id:V,name:q,folders:le,configuration:_,transient:pe,isUntitled:ue}=L,de=[],re=$;$?le.forEach((ve,Ae)=>{const Ue=b.URI.revive(ve.uri),xe=O.o(P||$,Ue,F);xe?(xe.name=ve.name,xe.index=ve.index,de.push(xe)):de.push({uri:Ue,name:ve.name,index:Ae})}):de.push(...le.map(({uri:ve,name:Ae,index:Ue})=>({uri:b.URI.revive(ve),name:Ae,index:Ue}))),de.sort((ve,Ae)=>ve.index<Ae.index?-1:1);const G=new O(V,q,de,!!pe,_?b.URI.revive(_):null,!!ue,ve=>C(ve,F)),{added:H,removed:oe}=d(re?re.workspaceFolders:[],G.workspaceFolders,c,F);return{workspace:G,added:H,removed:oe}}static o(L,$,P){for(let F=0;F<L.folders.length;F++){const V=L.workspaceFolders[F];if(g(V.uri,$,P))return V}}constructor(L,$,P,F,V,q,le){super(L,P.map(_=>new v.WorkspaceFolder(_)),F,V,le),this.t=$,this.u=q,this.q=[],this.s=R.TernarySearchTree.forUris(le),P.forEach(_=>{this.q.push(_),this.s.set(_.uri,_)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(L,$){return $&&this.s.get(L)&&(L=(0,M.dirname)(L)),this.s.findSubstr(L)}resolveWorkspaceFolder(L){return this.s.get(L)}}let j=class{constructor(L,$,P,F,V){this.c=new N.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new N.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new N.AsyncEmitter,this.h=F,this.s=P,this.t=V,this.j=new T.Counter,this.k=new k.Barrier,this.o=L.getProxy(t.MainContext.MainThreadWorkspace),this.q=L.getProxy(t.MainContext.MainThreadMessageService);const q=$.workspace;this.l=q?new O(q.id,q.name,[],!!q.transient,q.configuration?b.URI.revive(q.configuration):null,!!q.isUntitled,le=>C(le,P)):void 0}$initializeWorkspace(L,$){this.v=$,this.$acceptWorkspaceData(L),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?b.URI.from({scheme:y.Schemas.untitled,path:(0,M.basename)((0,M.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(!!this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(L,$,P,...F){const V=[];if(Array.isArray(F)&&F.forEach(ue=>{b.URI.isUri(ue.uri)&&!V.some(de=>g(de.uri,ue.uri,this.s))&&V.push({uri:ue.uri,name:ue.name||(0,M.basenameOrAuthority)(ue.uri)})}),this.n||[$,P].some(ue=>typeof ue!="number"||ue<0)||P===0&&V.length===0)return!1;const q=this.x?this.x.workspaceFolders:[];if($+P>q.length)return!1;const le=q.slice(0);le.splice($,P,...V.map(ue=>({uri:ue.uri,name:ue.name||(0,M.basenameOrAuthority)(ue.uri),index:void 0})));for(let ue=0;ue<le.length;ue++){const de=le[ue];if(le.some((re,G)=>G!==ue&&g(de.uri,re.uri,this.s)))return!1}le.forEach((ue,de)=>ue.index=de);const{added:_,removed:pe}=d(q,le,u,this.s);if(_.length===0&&pe.length===0)return!1;if(this.o){const ue=L.displayName||L.name;this.o.$updateWorkspaceFolders(ue,$,P,V).then(void 0,de=>{this.n=void 0;const re={source:{identifier:L.identifier,label:L.displayName||L.name}};this.q.$showMessage(l.Severity.Error,(0,m.localize)(0,null,ue,de.toString()),re,[])})}return this.y(le),!0}getWorkspaceFolder(L,$){if(!!this.x)return this.x.getWorkspaceFolder(L,$)}async getWorkspaceFolder2(L,$){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(L,$)}async resolveWorkspaceFolder(L){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(L)}getPath(){if(!this.x)return;const{folders:L}=this.x;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,$){let P,F="";if(typeof L=="string"?(P=b.URI.file(L),F=L):typeof L<"u"&&(P=L,F=L.fsPath),!P)return F;const V=this.getWorkspaceFolder(P,!0);if(!V)return F;typeof $>"u"&&this.x&&($=this.x.folders.length>1);let q=(0,M.relativePath)(V.uri,P);return $&&V.name&&(q=`${V.name}/${q}`),q}y(L){this.x&&(this.n=O.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:L,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:$,added:P,removed:F}=O.toExtHostWorkspace(L,this.l,this.n,this.s);this.l=$||void 0,this.n=void 0,this.c.fire(Object.freeze({added:P,removed:F}))}findFiles(L,$,P,F,V=D.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let q;if($===null?q=!1:$&&(typeof $=="string"?q=$:q=$.pattern),V&&V.isCancellationRequested)return Promise.resolve([]);const{includePattern:le,folder:_}=Z(n.GlobPattern.from(L));return this.o.$startFileSearch((0,f.withUndefinedAsNull)(le),(0,f.withUndefinedAsNull)(_),(0,f.withUndefinedAsNull)(q),(0,f.withUndefinedAsNull)(P),V).then(pe=>Array.isArray(pe)?pe.map(ue=>b.URI.revive(ue)):[])}async findTextInFiles(L,$,P,F,V=D.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const q=this.j.getNext(),le=typeof $.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:_,folder:pe}=Z(n.GlobPattern.from($.include)),ue=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,de={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof $.useParentIgnoreFiles=="boolean"?!$.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:le,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:_,excludePattern:ue},re=!1;if(this.u[q]=G=>{if(re)return;const H=b.URI.revive(G.resource);G.results.forEach(oe=>{(0,a.resultIsMatch)(oe)?P({uri:H,preview:{text:oe.preview.text,matches:(0,r.mapArrayOrNot)(oe.preview.matches,ve=>new h.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,r.mapArrayOrNot)(oe.ranges,ve=>new h.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):P({uri:H,text:oe.text,lineNumber:oe.lineNumber})})},V.isCancellationRequested)return{};try{const G=await this.o.$startTextSearch(L,(0,f.withUndefinedAsNull)(pe),de,q,V);return delete this.u[q],G||{}}catch(G){throw delete this.u[q],G}}$handleTextSearchResult(L,$){this.u[$]?.(L)}saveAll(L){return this.o.$saveAll(L)}resolveProxy(L){return this.o.$resolveProxy(L)}get trusted(){return this.v}requestWorkspaceTrust(L){return this.o.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(L,$){if(this.w.has(L))throw new Error(`A provider has already been registered for scheme ${L}`);this.w.set(L,$);const P=this.t.transformOutgoingScheme(L),F=this.z++;return this.o.$registerEditSessionIdentityProvider(F,P),(0,S.toDisposable)(()=>{this.w.delete(L),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(L,$){this.h.info("Getting edit session identifier for workspaceFolder",L);const P=await this.resolveWorkspaceFolder(b.URI.revive(L));if(!P){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",P);const F=this.w.get(P.uri.scheme);if(this.h.info(`Provider for scheme ${P.uri.scheme} is defined: `,!!F),!F)return;const V=await F.provideEditSessionIdentity(P,$);if(this.h.info("Provider returned edit session identifier: ",V),!!V)return V}async $provideEditSessionIdentityMatch(L,$,P,F){this.h.info("Getting edit session identifier for workspaceFolder",L);const V=await this.resolveWorkspaceFolder(b.URI.revive(L));if(!V){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",V);const q=this.w.get(V.uri.scheme);if(this.h.info(`Provider for scheme ${V.uri.scheme} is defined: `,!!q),!q)return;const le=await q.provideEditSessionIdentityMatch?.($,P,F);if(this.h.info("Provider returned edit session identifier match result: ",le),!!le)return le}getOnWillCreateEditSessionIdentityEvent(L){return($,P,F)=>{const V=function(le){$.call(P,le)};return V.extension=L,this.A.event(V,void 0,F)}}async $onWillCreateEditSessionIdentity(L,$,P){const F=await this.resolveWorkspaceFolder(b.URI.revive(L));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:F},$,async(V,q)=>{const le=Date.now();await Promise.resolve(V),Date.now()-le>P&&this.h.warn("SLOW edit session create-participant",q.extension.identifier)}),$.isCancellationRequested}};j=qe([je(0,p.IExtHostRpcService),je(1,A.IExtHostInitDataService),je(2,w.IExtHostFileSystemInfo),je(3,o.ILogService),je(4,i.IURITransformerService)],j),e.ExtHostWorkspace=j,e.IExtHostWorkspace=(0,s.createDecorator)("IExtHostWorkspace");function Z(x){let L,$;return x&&(typeof x=="string"?L=x:(L=x.pattern,$=b.URI.revive(x.baseUri))),{includePattern:L,folder:$}}}),define(Ie[32],Ce([1,0,22,4,31,5,7,164,93,9,16,3,17,11,2]),function(te,e,r,k,D,N,S,R,y,T,M,E,f,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function s(h,i){if(i){const a=i.split(".");let t=h;for(let g=0;t&&g<a.length;g++)t=t[a[g]];return t}}function o(h){return h instanceof m.URI}function l(h){return h&&h.uri instanceof m.URI&&h.languageId&&typeof h.languageId=="string"}function v(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function w(h){return h&&h.uri instanceof m.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function A(h){if(o(h))return{resource:h};if(l(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(v(h))return{overrideIdentifier:h.languageId};if(w(h))return{resource:h.uri};if(h===null)return{resource:null}}let p=class{constructor(i,a,t){this.a=i.getProxy(N.MainContext.MainThreadConfiguration),this.c=a,this.b=t,this.d=new M.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(i=>this.e)}$initializeConfiguration(i){this.e=new n(this.a,this.c,i,this.b),this.d.open()}$acceptConfigurationChanged(i,a){this.getConfigProvider().then(t=>t.$acceptConfigurationChanged(i,a))}};p=qe([je(0,f.IExtHostRpcService),je(1,D.IExtHostWorkspace),je(2,b.ILogService)],p),e.ExtHostConfiguration=p;class n{constructor(i,a,t,g){this.a=new k.Emitter,this.b=i,this.f=g,this.c=a,this.e=R.Configuration.parse(t),this.d=this.k(t.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(i,a){const t={data:this.e.toData(),workspace:this.c.workspace};this.e=R.Configuration.parse(i),this.d=this.k(i.configurationScopes),this.a.fire(this.j(a,t))}getConfiguration(i,a,t){const g=A(a)||{},c=this.g(i?s(this.e.getValue(void 0,g,this.c.workspace),i):this.e.getValue(void 0,g,this.c.workspace));i&&this.h(i,g,t?.identifier);function u(C){if(C==null)return null;if(typeof C=="boolean")return C?2:5;switch(C){case S.ConfigurationTarget.Global:return 2;case S.ConfigurationTarget.Workspace:return 5;case S.ConfigurationTarget.WorkspaceFolder:return 6}}const d={has(C){return typeof s(c,C)<"u"},get:(C,O)=>{this.h(i?`${i}.${C}`:C,g,t?.identifier);let j=s(c,C);if(typeof j>"u")j=O;else{let Z;const x=(L,$)=>{let P;const F=()=>{Z=Z||(0,r.deepClone)(c),P=P||s(Z,$)};return(0,T.isObject)(L)?new Proxy(L,{get:(V,q)=>{if(typeof q=="string"&&q.toLowerCase()==="tojson")return F(),()=>P;if(Z)return P=P||s(Z,$),P[q];const le=V[q];return typeof q=="string"?x(le,`${$}.${q}`):le},set:(V,q,le)=>(F(),P&&(P[q]=le),!0),deleteProperty:(V,q)=>(F(),P&&delete P[q],!0),defineProperty:(V,q,le)=>(F(),P&&Object.defineProperty(P,q,le),!0)}):L};j=x(j,C)}return j},update:(C,O,j,Z)=>{C=i?`${i}.${C}`:C;const x=u(j);return O!==void 0?this.b.$updateConfigurationOption(x,C,O,g,Z):this.b.$removeConfigurationOption(x,C,g,Z)},inspect:C=>{C=i?`${i}.${C}`:C;const O=this.e.inspect(C,g,this.c.workspace);if(O)return{key:C,defaultValue:(0,r.deepClone)(O.policy?.value??O.default?.value),globalValue:(0,r.deepClone)(O.user?.value??O.application?.value),workspaceValue:(0,r.deepClone)(O.workspace?.value),workspaceFolderValue:(0,r.deepClone)(O.workspaceFolder?.value),defaultLanguageValue:(0,r.deepClone)(O.default?.override),globalLanguageValue:(0,r.deepClone)(O.user?.override??O.application?.override),workspaceLanguageValue:(0,r.deepClone)(O.workspace?.override),workspaceFolderLanguageValue:(0,r.deepClone)(O.workspaceFolder?.override),languageIds:(0,r.deepClone)(O.overrideIdentifiers)}}};return typeof c=="object"&&(0,r.mixin)(d,c,!1),Object.freeze(d)}g(i){const a=t=>(0,T.isObject)(t)?new Proxy(t,{get:(g,c)=>a(g[c]),set:(g,c,u)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(g,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(g,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):t;return a(i)}h(i,a,t){const g=y.OVERRIDE_PROPERTY_REGEX.test(i)?4:this.d.get(i),c=t?`[${t.value}] `:"";if(g===4){typeof a?.resource>"u"&&this.f.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){a?.resource&&this.f.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(i,a){const t=new R.ConfigurationChangeEvent(i,a,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(g,c)=>t.affectsConfiguration(g,A(c))})}k(i){return i.reduce((a,t)=>(a.set(t[0],t[1]),a),new Map)}}e.ExtHostConfigProvider=n,e.IExtHostConfiguration=(0,E.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(te,e,r,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,r):D?D.value=r:e.set(te,r),r},Le=this&&this.__classPrivateFieldGet||function(te,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(te):k?k.value:e.get(te)};define(Ie[107],Ce([1,0,2,16,4,5,7,31,57,32,21,60,17,26,3,15,20,11,76,200,12]),function(te,e,r,k,D,N,S,R,y,T,M,E,f,b,m,s,o,l,v,w,A){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var n;(function(L){function $(F){if(F!=null)return F}L.from=$;function P(F){if(F!=null)return F}L.to=P})(n||(n={}));var h;(function(L){function $(F){if(F!=null)return F}L.from=$;function P(F){if(F!=null)return F}L.to=P})(h||(h={}));var i;(function(L){function $(F){if(F!=null)return F}L.from=$;function P(F){if(F!=null)return F}L.to=P})(i||(i={}));var a;(function(L){function $(V){if(V){const q=V;return q&&!!q.process}else return!1}L.is=$;function P(V){if(V==null)return;const q={process:V.process,args:V.args};return V.options&&(q.options=i.from(V.options)),q}L.from=P;function F(V){if(V!=null)return new S.ProcessExecution(V.process,V.args,V.options)}L.to=F})(a||(a={}));var t;(function(L){function $(F){if(F!=null)return F}L.from=$;function P(F){if(F!=null)return F}L.to=P})(t||(t={}));var g;(function(L){function $(V){if(V){const q=V;return q&&(!!q.commandLine||!!q.command)}else return!1}L.is=$;function P(V){if(V==null)return;const q={};return V.commandLine!==void 0?q.commandLine=V.commandLine:(q.command=V.command,q.args=V.args),V.options&&(q.options=t.from(V.options)),q}L.from=P;function F(V){if(!(V==null||V.command===void 0&&V.commandLine===void 0))return V.commandLine?new S.ShellExecution(V.commandLine,V.options):new S.ShellExecution(V.command,V.args?V.args:[],V.options)}L.to=F})(g||(g={}));var c;(function(L){function $(V){if(V){const q=V;return q&&q.customExecution==="customExecution"}else return!1}L.is=$;function P(V){return{customExecution:"customExecution"}}L.from=P;function F(V,q){return q.get(V)}L.to=F})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var u;(function(L){function $(P,F){let V;return P.scope!==void 0&&typeof P.scope!="number"?V=P.scope.uri:P.scope!==void 0&&typeof P.scope=="number"&&(P.scope===S.TaskScope.Workspace&&F&&F.workspaceFile?V=F.workspaceFile:V=w.USER_TASKS_GROUP_KEY),{id:P._id,workspaceFolder:V}}L.from=$})(u=e.TaskHandleDTO||(e.TaskHandleDTO={}));var d;(function(L){function $(P){if(P!=null)return{_id:P.id,isDefault:P.isDefault}}L.from=$})(d||(d={}));var C;(function(L){function $(V,q){if(V==null)return[];const le=[];for(const _ of V){const pe=P(_,q);pe&&le.push(pe)}return le}L.fromMany=$;function P(V,q){if(V==null)return;let le;V.execution instanceof S.ProcessExecution?le=a.from(V.execution):V.execution instanceof S.ShellExecution?le=g.from(V.execution):V.execution&&V.execution instanceof S.CustomExecution&&(le=c.from(V.execution));const _=n.from(V.definition);let pe;return V.scope?typeof V.scope=="number"?pe=V.scope:pe=V.scope.uri:pe=S.TaskScope.Workspace,!_||!pe?void 0:{_id:V._id,definition:_,name:V.name,source:{extensionId:q.identifier.value,label:V.source,scope:pe},execution:le,isBackground:V.isBackground,group:d.from(V.group),presentationOptions:h.from(V.presentationOptions),problemMatchers:V.problemMatchers,hasDefinedMatchers:V.hasDefinedMatchers,runOptions:V.runOptions?V.runOptions:{reevaluateOnRerun:!0},detail:V.detail}}L.from=P;async function F(V,q,le){if(V==null)return;let _;a.is(V.execution)?_=a.to(V.execution):g.is(V.execution)?_=g.to(V.execution):c.is(V.execution)&&(_=c.to(V._id,le));const pe=n.to(V.definition);let ue;if(V.source&&(V.source.scope!==void 0?typeof V.source.scope=="number"?ue=V.source.scope:ue=await q.resolveWorkspaceFolder(r.URI.revive(V.source.scope)):ue=S.TaskScope.Workspace),!pe||!ue)return;const de=new S.Task(pe,ue,V.name,V.source.label,_,V.problemMatchers);return V.isBackground!==void 0&&(de.isBackground=V.isBackground),V.group!==void 0&&(de.group=S.TaskGroup.from(V.group._id),de.group&&V.group.isDefault&&(de.group=new S.TaskGroup(de.group.id,de.group.label),V.group.isDefault===!0&&(de.group.isDefault=V.group.isDefault))),V.presentationOptions&&(de.presentationOptions=h.to(V.presentationOptions)),V._id&&(de._id=V._id),V.detail&&(de.detail=V.detail),de}L.to=F})(C=e.TaskDTO||(e.TaskDTO={}));var O;(function(L){function $(F){return F}L.from=$;function P(F){if(!!F)return Object.assign(Object.create(null),F)}L.to=P})(O||(O={}));class j{constructor($,P,F){this._id=P,this.a=F,p.set(this,void 0),Je(this,p,$,"f")}get task(){return this.a}terminate(){Le(this,p,"f").terminateTask(this)}fireDidStartProcess($){}fireDidEndProcess($){}}p=new WeakMap;let Z=class{constructor($,P,F,V,q,le,_,pe){this.q=new D.Emitter,this.r=new D.Emitter,this.s=new D.Emitter,this.t=new D.Emitter,this.a=$.getProxy(N.MainContext.MainThreadTask),this.b=F,this.c=V,this.d=q,this.e=le,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=_,this.g=pe,this.a.$registerSupportedExecutions(!0)}registerTaskProvider($,P,F){if(!F)return new S.Disposable(()=>{});const V=this.w();return this.j.set(V,{type:P,provider:F,extension:$}),this.a.$registerTaskProvider(V,P),new S.Disposable(()=>{this.j.delete(V),this.a.$unregisterTaskProvider(V)})}registerTaskSystem($,P){this.a.$registerTaskSystem($,P)}fetchTasks($){return this.a.$fetchTasks(O.from($)).then(async P=>{const F=[];for(const V of P){const q=await C.to(V,this.b,this.m);q&&F.push(q)}return F})}get taskExecutions(){const $=[];return this.k.forEach(P=>$.push(P)),$}terminateTask($){if(!($ instanceof j))throw new Error("No valid task execution provided");return this.a.$terminateTask($._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask($,P,F){const V=this.m.get($.id);V&&(this.o.set($.id,V),this.e.attachPtyToTerminal(P,await V.callback(F))),this.p=$.id,this.q.fire({execution:await this.y($)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask($){const P=await this.y($);this.l.delete($.id),this.k.delete($.id),this.A($),this.r.fire({execution:P})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess($){const P=await this.y($.id);this.s.fire({execution:P,processId:$.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess($){const P=await this.y($.id);this.t.fire({execution:P,exitCode:$.exitCode})}$provideTasks($,P){const F=this.j.get($);if(!F)return Promise.reject(new Error("no handler found"));const V=[],q=(0,k.asPromise)(()=>F.provider.provideTasks(M.CancellationToken.None)).then(le=>this.u(P,V,F,le));return new Promise(le=>{q.then(_=>{Promise.all(V).then(()=>{le(_)})})})}async $resolveTask($,P){const F=this.j.get($);if(!F)return Promise.reject(new Error("no handler found"));if(P.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${P.definition.type}] cannot be resolved by provider of type [${F.type}].`);const V=await C.to(P,this.b,this.m);if(!V)throw new Error("Unexpected: Task cannot be resolved.");const q=await F.provider.resolveTask(V,M.CancellationToken.None);if(!q)return;this.z(q,F);const le=C.from(q,F.extension);if(!le)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==V.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(le.execution)&&await this.x(le,q,!0),await this.v(le)}w(){return this.h++}async x($,P,F){const V=await this.a.$createTaskId($);!F&&!this.m.has(V)&&(this.n.add(V),this.o.set(V,P.execution)),this.m.set(V,P.execution)}async y($,P){if(typeof $=="string"){const q=this.l.get($);if(!q)throw new A.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return q}const F=this.l.get($.id);if(F)return F;const V=new Promise((q,le)=>{function _(pe,ue,de){de?q(new j(pe,ue.id,de)):le("Unexpected: Task does not exist.")}P?_(this,$,P):C.to($.task,this.b,this.m).then(pe=>_(this,$,pe))});return this.l.set($.id,V),V.then(q=>(this.k.set($.id,q),q),q=>Promise.reject(q))}z($,P){$._deprecated&&this.g.report("Task.constructor",P.extension,"Use the Task constructor that takes a `scope` instead.")}A($){this.o.get($.id)&&this.o.delete($.id),this.n.has($.id)&&this.p!==$.id&&(this.m.delete($.id),this.n.delete($.id));const F=this.n.values();let V=F.next();for(;!V.done;)!this.o.has(V.value)&&this.p!==V.value&&(this.m.delete(V.value),this.n.delete(V.value)),V=F.next()}};Z=qe([je(0,f.IExtHostRpcService),je(1,b.IExtHostInitDataService),je(2,R.IExtHostWorkspace),je(3,y.IExtHostDocumentsAndEditors),je(4,T.IExtHostConfiguration),je(5,E.IExtHostTerminalService),je(6,l.ILogService),je(7,v.IExtHostApiDeprecationService)],Z),e.ExtHostTaskBase=Z;let x=class extends Z{constructor($,P,F,V,q,le,_,pe){super($,P,F,V,q,le,_,pe),this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:o.PlatformToString(0)})}async executeTask($,P){if(!P.execution)throw new Error("Tasks to execute must include an execution");const F=C.from(P,$);if(F===void 0)throw new Error("Task is not valid");if(c.is(F.execution))await this.x(F,P,!1);else throw new A.NotSupportedError;const V=await this.y(await this.a.$getTaskExecution(F),P);return this.a.$executeTask(F).catch(q=>{throw new Error(q)}),V}u($,P,F,V){const q=[];if(V)for(const le of V){this.z(le,F),(!le.definition||!$[le.definition.type])&&this.f.warn(`The task [${le.source}, ${le.name}] uses an undefined task type. The task will be ignored in the future.`);const _=C.from(le,F.extension);_&&c.is(_.execution)?(q.push(_),P.push(this.x(_,le,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:q,extension:F.extension}}async v($){if(c.is($.execution))return $;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables($,P){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable($,P,F){}};x=qe([je(0,f.IExtHostRpcService),je(1,b.IExtHostInitDataService),je(2,R.IExtHostWorkspace),je(3,y.IExtHostDocumentsAndEditors),je(4,T.IExtHostConfiguration),je(5,E.IExtHostTerminalService),je(6,l.ILogService),je(7,v.IExtHostApiDeprecationService)],x),e.WorkerExtHostTask=x,e.IExtHostTask=(0,m.createDecorator)("IExtHostTask")}),define(Ie[243],Ce([1,0,19,21,39,35,24,77,46]),function(te,e,r,k,D,N,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(f,b,m){this.k=f,this.l=b,this.o=m,this.e=!1,this.f=0,this.g=!1,this.a=f.filePattern,this.b=f.includePattern&&N.parse(f.includePattern),this.c=f.maxResults||void 0,this.d=f.exists,this.h=new Set,this.j=f.excludePattern&&N.parse(f.excludePattern)}cancel(){this.g=!0,this.h.forEach(f=>f.cancel()),this.h=new Set}search(f){const b=this.k.folderQueries||[];return new Promise((m,s)=>{const o=l=>{this.f++,f(l)};if(this.g)return m({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(l=>{const v=l.toString(),w=r.basename(v);this.j&&this.j(v,w)||this.v(o,{base:l,basename:w})}),Promise.all(b.map(l=>this.p(l,o))).then(l=>{m({limitHit:this.e,stats:l[0]||void 0})},l=>{s(new Error((0,D.toErrorMessage)(l)))})})}async p(f,b){const m=new k.CancellationTokenSource,s=this.q(f),o=this.r(),l=new y.QueryGlobTester(this.k,f),v=!l.hasSiblingExcludeClauses();let w;try{this.h.add(m),w=R.StopWatch.create();const A=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},s,m.token),p=w.elapsed(),n=R.StopWatch.create();return this.g&&!this.e||(A&&A.forEach(h=>{const i=r.posix.relative(f.folder.path,h.path);if(v){const a=r.basename(h.path);this.v(b,{base:f.folder,relativePath:i,basename:a});return}this.s(o,f.folder,i,b)}),this.g&&!this.e)?null:(this.u(o,l,b),{providerTime:p,postProcessTime:n.elapsed()})}finally{m.dispose(),this.h.delete(m)}}q(f){const b=(0,y.resolvePatternsForProvider)(this.k.includePattern,f.includePattern),m=(0,y.resolvePatternsForProvider)(this.k.excludePattern,f.excludePattern);return{folder:f.folder,excludes:m,includes:b,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}s({pathToEntries:f},b,m,s){if(m===this.a){const l=r.basename(this.a);this.v(s,{base:b,relativePath:this.a,basename:l})}function o(l){const v=r.basename(l),w=r.dirname(l);let A=f[w];A||(A=f[w]=[],o(w)),A.push({base:b,relativePath:l,basename:v})}o(m)}u({rootEntries:f,pathToEntries:b},m,s){const o=this,l=this.a;function v(w){const A=(0,y.hasSiblingFn)(()=>w.map(p=>p.basename));for(let p=0,n=w.length;p<n;p++){const h=w[p],{relativePath:i,basename:a}=h;if(m.matchesExcludesSync(i,a,l!==a?A:void 0))continue;const t=b[i];if(t)v(t);else{if(i===l)continue;o.v(s,h)}if(o.e)break}}v(f)}v(f,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||f(b))}}class M{constructor(){this.b=new Map}fileSearch(f,b,m,s){const o=this.c(f.cacheKey),l=new T(f,b,o&&o.token);let v=0;const w=A=>{v+=A.length,m(A.map(p=>this.d(p)))};return this.e(l,M.a,w,s).then(A=>({limitHit:A.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:A.stats}}))}clearCache(f){this.c(f)?.cancel()}c(f){if(!!f)return this.b.has(f)||this.b.set(f,new k.CancellationTokenSource),this.b.get(f)}d(f){return f.relativePath?{resource:S.joinPath(f.base,f.relativePath)}:{resource:f.base}}e(f,b,m,s){s.onCancellationRequested(()=>{f.cancel()});const o=v=>{v&&(l.push(v),b>0&&l.length>=b&&(m(l),l=[]))};let l=[];return f.search(o).then(v=>(l.length&&m(l),v),v=>(l.length&&m(l),Promise.reject(v)))}}e.FileSearchManager=M,M.a=512}),define(Ie[244],Ce([1,0,18,62,35,87,28,15,19,24,10,9,2,260,153,41,11,52,97,242,46]),function(te,e,r,k,D,N,S,R,y,T,M,E,f,b,m,s,o,l,v,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(d,C,O,j,Z){this.a=d,this.b=C,this.c=O,this.d=j,this.e=Z}text(d,C,O={}){d=this.f(d,O);const j=this.a.getValue(),Z=C&&C.some(L=>!this.a.getValue({resource:L}).search.useRipgrep);return{...this.h(C?.map(l.toWorkspaceFolder),O),type:2,contentPattern:d,previewOptions:O.previewOptions,maxFileSize:O.maxFileSize,usePCRE2:j.search.usePCRE2||Z||!1,beforeContext:O.beforeContext,afterContext:O.afterContext,userDisabledExcludesAndIgnoreFiles:O.disregardExcludeSettings&&O.disregardIgnoreFiles}}f(d,C){const O=this.a.getValue();d.isRegExp&&(d.pattern=d.pattern.replace(/\r?\n/g,"\\n"));const j={...d,wordSeparators:O.editor.wordSeparators};return this.j(d,C)&&(j.isCaseSensitive=!0),this.k(d)&&(j.isMultiline=!0),j}file(d,C={}){return{...this.h(d,C),type:1,filePattern:C.filePattern?C.filePattern.trim():C.filePattern,exists:C.exists,sortByScore:C.sortByScore,cacheKey:C.cacheKey}}g(d,C){return d?(d=Array.isArray(d)?d.map(t):t(d),C?this.parseSearchPaths(d):{pattern:h(...Array.isArray(d)?d:[d])}):{}}h(d=[],C={}){const O=this.g(C.includePattern,C.expandPatterns),j=this.g(C.excludePattern,C.expandPatterns),Z=d.length>1,x=(O.searchPaths&&O.searchPaths.length?O.searchPaths.map(P=>this.q(P,C,j)):d.map(P=>this.r(P,C,j,Z))).filter(P=>!!P),L={_reason:C._reason,folderQueries:x,usingSearchPaths:!!(O.searchPaths&&O.searchPaths.length),extraFileResources:C.extraFileResources,excludePattern:j.pattern,includePattern:O.pattern,onlyOpenEditors:C.onlyOpenEditors,maxResults:C.maxResults};if(C.onlyOpenEditors){const P=r.coalesce(r.flatten(this.c.groups.map(q=>q.editors.map(le=>le.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(P));const F=P.filter(q=>(0,A.pathIncludedInQuery)(L,q.fsPath)),V=this.i(F);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(V)),{...L,...V}}const $=C.extraFileResources&&C.extraFileResources.filter(P=>(0,A.pathIncludedInQuery)(L,P.fsPath));return L.extraFileResources=$&&$.length?$:void 0,L}i(d){const C=[],O=new S.ResourceMap,j={};let Z=!1;return d.forEach(x=>{if(x.scheme===R.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(x)){const $=this.b.getWorkspaceFolder(x)?.uri??x.with({path:y.dirname(x.fsPath)});let P=O.get($);P||(Z=!0,P={folder:$,includePattern:{}},C.push(P),O.set($,P));const F=y.relative($.fsPath,x.fsPath);(0,E.assertIsDefined)(P.includePattern)[F.replace(/\\/g,"/")]=!0}else x.fsPath&&(Z=!0,j[x.fsPath]=!0)}),{folderQueries:C,includePattern:j,usingSearchPaths:!0,excludePattern:Z?void 0:{"**/*":!0}}}j(d,C){if(C.isSmartCase){if(d.isRegExp){if(M.containsUppercaseCharacter(d.pattern,!0))return!0}else if(M.containsUppercaseCharacter(d.pattern))return!0}return!!d.isCaseSensitive}k(d){return d.isMultiline||d.isRegExp&&(0,b.isMultilineRegexSource)(d.pattern)||d.pattern.indexOf(`
`)>=0?!0:!!d.isMultiline}parseSearchPaths(d){const C=V=>y.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),j=(Array.isArray(d)?d:i(d)).map(V=>{const q=this.e.resolvedUserHome;return q?(0,N.untildify)(V,q.scheme===R.Schemas.file?q.fsPath:q.path):V}),Z=k.groupBy(j,V=>C(V)?"searchPaths":"exprSegments"),x=(Z.exprSegments||[]).map(V=>M.rtrim(V,"/")).map(V=>M.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),a(V))),L={},$=this.m(Z.searchPaths||[]);$&&$.length&&(L.searchPaths=$);const P=r.flatten(x),F=h(...P);return F&&(L.pattern=F),L}l(d,C){return C.disregardExcludeSettings?void 0:(0,A.getExcludes)(d,!C.disregardSearchExcludeSettings)}m(d){if(!d||!d.length)return[];const C=d.flatMap(j=>{let{pathPortion:Z,globPortion:x}=n(j);return x&&(x=g(x)),this.n(Z).flatMap($=>this.o($,x))}),O=new Map;return C.forEach(j=>{const Z=j.searchPath.toString(),x=O.get(Z);x?j.pattern&&(x.pattern=x.pattern||{},x.pattern[j.pattern]=!0):O.set(Z,{searchPath:j.searchPath,pattern:j.pattern?h(j.pattern):void 0})}),Array.from(O.values())}n(d){if(y.isAbsolute(d)){const C=this.b.getWorkspace().folders;return C[0]&&C[0].uri.scheme!==R.Schemas.file?[{searchPath:C[0].uri.with({path:d})}]:[{searchPath:f.URI.file(y.normalize(d))}]}if(this.b.getWorkbenchState()===2){const C=this.b.getWorkspace().folders[0].uri;if(d=t(d),d.startsWith("../")||d===".."){const j=y.posix.resolve(C.path,d);return[{searchPath:C.with({path:j})}]}const O=g(d);return[{searchPath:C,pattern:O}]}else{if(d==="./"||d===".\\")return[];{const C=d.replace(/^\.[\/\\]/,""),j=this.b.getWorkspace().folders.map(Z=>{const x=C.match(new RegExp(`^${M.escapeRegExpCharacters(Z.name)}(?:/(.*)|$)`));return x?{match:x,folder:Z}:null}).filter(E.isDefined);if(j.length)return j.map(Z=>{const x=Z.match[1];return{searchPath:Z.folder.uri,pattern:x&&g(x)}});{const Z=d.match(/\.[\/\\](.+)[\/\\]?/),x=Z?Z[1]:d,L=m.localize(0,null,x);throw new Error(L)}}}}o(d,C){const O=d.pattern&&C?`${d.pattern}/${C}`:d.pattern||C,j=[{searchPath:d.searchPath,pattern:O}];return O&&!O.endsWith("**")&&j.push({searchPath:d.searchPath,pattern:O+"/**"}),j}q(d,C,O){const j=this.r((0,l.toWorkspaceFolder)(d.searchPath),C,O,!1);return j?{...j,includePattern:d.pattern}:null}r(d,C,O,j){let Z;const x=f.URI.isUri(d)?d:d.uri;if(O.searchPaths){const V=O.searchPaths.filter(q=>(0,T.isEqual)(q.searchPath,x))[0];if(V&&!V.pattern)return null;V&&(Z=V.pattern)}const L=this.a.getValue({resource:x}),P={...this.l(L,C)||{},...Z||{}},F=f.URI.isUri(d)?(0,T.basename)(d):d.name;return{folder:x,folderName:j?F:void 0,excludePattern:Object.keys(P).length>0?P:void 0,fileEncoding:L.files&&L.files.encoding,disregardIgnoreFiles:typeof C.disregardIgnoreFiles=="boolean"?C.disregardIgnoreFiles:!L.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof C.disregardGlobalIgnoreFiles=="boolean"?C.disregardGlobalIgnoreFiles:!L.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof C.disregardParentIgnoreFiles=="boolean"?C.disregardParentIgnoreFiles:!L.search.useParentIgnoreFiles,ignoreSymlinks:typeof C.ignoreSymlinks=="boolean"?C.ignoreSymlinks:!L.search.followSymlinks}}};p=qe([je(0,s.IConfigurationService),je(1,l.IWorkspaceContextService),je(2,v.IEditorGroupsService),je(3,o.ILogService),je(4,w.IPathService)],p),e.QueryBuilder=p;function n(u){const d=u.match(/[\*\{\}\(\)\[\]\?]/);if(d){const C=d.index,O=u.substr(0,C).match(/[/|\\][^/\\]*$/);if(O){let j=u.substr(0,O.index);return j.match(/[/\\]/)||(j+="/"),{pathPortion:j,globPortion:u.substr((O.index||0)+1)}}}return{pathPortion:u}}function h(...u){return u.length?u.reduce((d,C)=>(d[C]=!0,d),Object.create(null)):void 0}function i(u){return D.splitGlobAware(u,",").map(d=>d.trim()).filter(d=>!!d.length)}function a(u){return[`**/${u}/**`,`**/${u}`].map(C=>C.replace(/\*\*\/\*\*/g,"**"))}function t(u){return u.replace(/\\/g,"/")}function g(u){return t(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(u,d){u=r.distinct(u,j=>j.toString());const C=[],O=d.getWorkspace();return u&&u.forEach(j=>{let Z;if(d.getWorkbenchState()===2)Z=(0,T.relativePath)(O.folders[0].uri,j),Z&&Z!=="."&&(Z="./"+Z);else{const x=d.getWorkspaceFolder(j);if(x){const L=x.name;if(O.folders.filter(P=>P.name===L).length===1){const P=(0,T.relativePath)(x.uri,j);P===""?Z=`./${x.name}`:Z=`./${x.name}/${P}`}else Z=j.fsPath}}Z&&C.push(Z)}),C}e.resolveResourcesForSearchIncludes=c}),define(Ie[245],Ce([1,0,24,2,21,12,3,244,46,52]),function(te,e,r,k,D,N,S,R,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const M=7e3;function E(s,o){const l=o.activationEvents;if(!l)return Promise.resolve(void 0);const v=[],w=[];for(const a of l)if(/^workspaceContains:/.test(a)){const t=a.substr(18);t.indexOf("*")>=0||t.indexOf("?")>=0||s.forceUsingSearch?w.push(t):v.push(t)}if(v.length===0&&w.length===0)return Promise.resolve(void 0);let A;const p=new Promise((a,t)=>{A=a}),n=a=>A({activationEvent:a}),h=Promise.all(v.map(a=>f(s,a,n))).then(()=>{}),i=b(s,o.identifier,w,n);return Promise.all([h,i]).then(()=>{A(void 0)}),p}e.checkActivateWorkspaceContainsExtension=E;async function f(s,o,l){for(const v of s.folders)if(await s.exists(r.joinPath(k.URI.revive(v),o))){l(`workspaceContains:${o}`);return}}async function b(s,o,l,v){if(l.length===0)return Promise.resolve(void 0);const w=new D.CancellationTokenSource,A=s.checkExists(s.folders,l,w.token),p=setTimeout(async()=>{w.cancel(),s.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${l.join(",")}`)},M);let n=!1;try{n=await A}catch(h){N.isCancellationError(h)||N.onUnexpectedError(h)}w.dispose(),clearTimeout(p),n&&v(`workspaceContains:${l.join(",")}`)}function m(s,o,l,v){const w=s.get(S.IInstantiationService),A=s.get(y.ISearchService),n=w.createInstance(R.QueryBuilder).file(o.map(h=>(0,T.toWorkspaceFolder)(k.URI.revive(h))),{_reason:"checkExists",includePattern:l,exists:!0});return A.fileSearch(n,v).then(h=>!!h.limitHit,h=>N.isCancellationError(h)?!1:Promise.reject(h))}e.checkGlobFileExists=m});var Je=this&&this.__classPrivateFieldSet||function(te,e,r,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,r):D?D.value=r:e.set(te,r),r},Le=this&&this.__classPrivateFieldGet||function(te,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(te):k?k.value:e.get(te)};define(Ie[33],Ce([1,0,139,19,82,24,16,6,47,2,11,5,32,190,80,31,27,98,12,25,23,175,7,94,3,26,81,17,67,69,60,4,245,79,177,15,78,77]),function(te,e,r,k,D,N,S,R,y,T,M,E,f,b,m,s,o,l,v,w,A,p,n,h,i,a,t,g,c,u,d,C,O,j,Z,x,L,$){"use strict";var P,F,V;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,i.createDecorator)("IHostUtils");let q=class Ui extends R.Disposable{constructor(re,G,H,oe,ve,Ae,Ue,xe,Te,Se,ke){super(),this.a=this.B(new C.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=G,this.g=H,this.f=Ue,this.j=oe,this.k=ve,this.l=Ae,this.m=Te,this.p=Se,this.s=ke,this.t=this.g.getProxy(E.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(E.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(E.MainContext.MainThreadExtensionService),this.w=new S.Barrier,this.y=new S.Barrier,this.z=new S.Barrier,this.C=new S.Barrier,this.F=new l.ExtensionDescriptionRegistry(this.f.allExtensions);const se=(0,o.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new l.ExtensionDescriptionRegistry(pe(this.F,se)),this.G=new m.ExtHostStorage(this.g,this.l),this.H=new j.ExtHostSecretState(this.g),this.I=xe,this.h=re.createChild(new c.ServiceCollection([m.IExtHostStorage,this.G],[j.IExtHostSecretState,this.H])),this.J=this.B(new b.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(ce,J,I)=>{this.v.$onExtensionActivationError(ce,v.transformErrorForSerialization(J),I)},actualActivateExtension:async(ce,J)=>{if(l.ExtensionDescriptionRegistry.isHostExtension(ce,this.D,this.F))return await this.v.$activateExtension(ce,J),new b.HostExtension;const I=this.D.getExtensionDescription(ce);return this.Y(I,J)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),D.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(re){v.onUnexpectedError(re)}}async Q(){this.I.onWillDeactivateAll();let re=[];try{re=this.D.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this.X(ve))}catch{}await Promise.all(re)}terminate(re,G=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${re}`),this.l.flush(),this.p.dispose(),this.J.dispose(),v.setUnexpectedErrorHandler(oe=>{this.l.error(oe)}),this.g.dispose();const H=this.Q();Promise.race([(0,S.timeout)(5e3),H]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${G}`):this.l.info(`Extension host exiting with code ${G}`),this.l.flush(),this.l.dispose(),this.c.exit(G)})}isActivated(re){return this.z.isOpen()?this.J.isActivated(re):!1}async getExtension(re){const G=await this.v.$getExtension(re);let H;if(G?.browserNlsBundleUris){H={};for(const oe of Object.keys(G.browserNlsBundleUris))H[oe]=T.URI.revive(G.browserNlsBundleUris[oe])}return G&&{...G,identifier:new w.ExtensionIdentifier(G.identifier.value),extensionLocation:T.URI.revive(G.extensionLocation),browserNlsBundleUris:H}}R(re,G){return this.J.activateByEvent(re,G)}S(re,G){return this.J.activateById(re,G)}activateByIdWithErrors(re,G){return this.S(re,G).then(()=>{const H=this.J.getActivatedExtension(re);if(H.activationFailed)return Promise.reject(H.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(re=>this.D)}getExtensionExports(re){return this.z.isOpen()?this.J.getActivatedExtension(re).exports:null}async U(re){if(re.scheme!==x.Schemas.file)return re;const G=await this.c.realpath(re.fsPath);return T.URI.file(G)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(re=>new ue(re))),this.L}async W(re){const G=y.TernarySearchTree.forUris(H=>N.extUriBiasedIgnorePathCase.ignorePathCasing(H));return await Promise.all(re.map(async H=>{if(this.ob(H)){const oe=await this.U(H.extensionLocation);G.set(oe,H)}})),G}X(re){let G=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(re))return G;const H=this.J.getActivatedExtension(re);if(!H)return G;try{typeof H.module.deactivate=="function"&&(G=Promise.resolve(H.module.deactivate()).then(void 0,oe=>(this.l.error(oe),Promise.resolve(void 0))))}catch(oe){this.l.error(`An error occurred when deactivating the extension '${re.value}':`),this.l.error(oe)}try{(0,R.dispose)(H.subscriptions)}catch(oe){this.l.error(`An error occurred when deactivating the subscriptions for extension '${re.value}':`),this.l.error(oe)}return G}async Y(re,G){return this.f.remote.isRemote?this.v.$onWillActivateExtension(re.identifier):await this.v.$onWillActivateExtension(re.identifier),this.ab(re,G).then(H=>{const oe=H.activationTimes;return this.v.$onDidActivateExtension(re.identifier,oe.codeLoadingTime,oe.activateCallTime,oe.activateResolvedTime,G),this.Z(re,G,"success",oe),H},H=>{throw this.Z(re,G,"failure"),H})}Z(re,G,H,oe){const ve=le(re,G);this.u.$publicLog2("extensionActivationTimes",{...ve,...oe||{},outcome:H})}ab(re,G){const H=le(re,G);this.u.$publicLog2("activatePlugin",H);const oe=this.ob(re);if(!oe)return Promise.resolve(new b.EmptyExtension(b.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${re.identifier.value}, startup: ${G.startup}, activationEvent: '${G.activationEvent}'${re.identifier.value!==G.extensionId.value?`, root cause: ${G.extensionId.value}`:""}`),this.l.flush();const ve=new b.ExtensionActivationTimesBuilder(G.startup);return Promise.all([this.pb(re,(0,N.joinPath)(re.extensionLocation,oe),ve),this.bb(re)]).then(Ae=>(D.mark(`code/extHost/willActivateExtension/${re.identifier.value}`),Ui.cb(this.l,re.identifier,Ae[0],Ae[1],ve))).then(Ae=>(D.mark(`code/extHost/didActivateExtension/${re.identifier.value}`),Ae))}bb(re){const G=new p.ExtensionGlobalMemento(re,this.G),H=new p.ExtensionMemento(re.identifier.value,!1,this.G),oe=new Z.ExtensionSecrets(re,this.H),ve=re.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,Ae=this.f.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${re.identifier.value}`),Promise.all([G.whenReady,H.whenReady,this.I.whenReady]).then(()=>{const Ue=this;let xe,Te;const Se=(0,o.isProposedApiEnabled)(re,"ipc")?this.f.messagePorts?.get(w.ExtensionIdentifier.toKey(re.identifier)):void 0;return Object.freeze({globalState:G,workspaceState:H,secrets:oe,subscriptions:[],get extensionUri(){return re.extensionLocation},get extensionPath(){return re.extensionLocation.fsPath},asAbsolutePath(ke){return k.join(re.extensionLocation.fsPath,ke)},get storagePath(){return Ue.I.workspaceValue(re)?.fsPath},get globalStoragePath(){return Ue.I.globalValue(re).fsPath},get logPath(){return k.join(Ue.f.logsLocation.fsPath,re.identifier.value)},get logUri(){return T.URI.joinPath(Ue.f.logsLocation,re.identifier.value)},get storageUri(){return Ue.I.workspaceValue(re)},get globalStorageUri(){return Ue.I.globalValue(re)},get extensionMode(){return ve},get extension(){return xe===void 0&&(xe=new _(Ue,re.identifier,re,Ae,!1)),xe},get extensionRuntime(){return(0,o.checkProposedApiEnabled)(re,"extensionRuntime"),Ue.extensionRuntime},get environmentVariableCollection(){return Ue.p.getEnvironmentVariableCollection(re)},get messagePassingProtocol(){if(!Te){if(!Se)return;const ke=C.Event.buffer(C.Event.fromDOMEventEmitter(Se,"message",se=>se.data));Se.start(),Te={onDidReceiveMessage:ke,postMessage:Se.postMessage.bind(Se)}}return Te}})})}static cb(re,G,H,oe,ve){return H=H||{activate:void 0,deactivate:void 0},this.db(re,G,H,oe,ve).then(Ae=>new b.ActivatedExtension(!1,null,ve.build(),H,Ae,oe.subscriptions))}static db(re,G,H,oe,ve){if(typeof H.activate=="function")try{ve.activateCallStart(),re.trace(`ExtensionService#_callActivateOptional ${G.value}`);const Ae=typeof global=="object"?global:self,Ue=H.activate.apply(Ae,[oe]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(Ue).then(xe=>(ve.activateResolveStop(),xe))}catch(Ae){return Promise.reject(Ae)}else return Promise.resolve(H)}eb(re,G){this.S(re.identifier,{startup:!1,extensionId:re.identifier,activationEvent:G}).then(void 0,H=>{this.l.error(H)})}fb(){this.v.$setPerformanceMarks(D.getMarks());for(const re of this.D.getAllExtensionDescriptions())if(re.activationEvents)for(const G of re.activationEvents)G==="onStartupFinished"&&this.eb(re,G)}gb(){const re=this.R("*",!0).then(void 0,ve=>{this.l.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.hb(ve.added)));const G=this.j.workspace?this.j.workspace.folders:[],H=this.hb(G),oe=Promise.all([re,H]).then(()=>{});return Promise.race([oe,(0,S.timeout)(1e4)]).then(()=>{this.fb()}),oe}hb(re){return re.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(G=>this.ib(re,G))).then(()=>{})}async ib(re,G){if(this.isActivated(G.identifier))return;const H=!this.f.remote.isRemote&&!!this.f.remote.authority,oe={logService:this.l,folders:re.map(Ae=>Ae.uri),forceUsingSearch:H,exists:Ae=>this.c.exists(Ae.fsPath),checkExists:(Ae,Ue,xe)=>this.t.$checkExists(Ae,Ue,xe)},ve=await(0,O.checkActivateWorkspaceContainsExtension)(oe,G);if(!!ve)return this.S(G.identifier,{startup:!0,extensionId:G.identifier,activationEvent:ve.activationEvent}).then(void 0,Ae=>this.l.error(Ae))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(re){throw console.error(re),re}}async jb(){const{extensionDevelopmentLocationURI:re,extensionTestsLocationURI:G}=this.f.environment;if(!re||!G)throw new Error(r.localize(0,null));const H=await this.pb(null,G,new b.ExtensionActivationTimesBuilder(!1));if(!H||typeof H.run!="function")throw new Error(r.localize(1,null,G.toString()));return new Promise((oe,ve)=>{const Ae=(Te,Se)=>{Te?ve(Te):oe(typeof Se=="number"&&Se>0?1:0)},Ue=(0,N.originalFSPath)(G),xe=H.run(Ue,Ae);xe&&xe.then&&xe.then(()=>{oe(0)}).catch(Te=>{ve(Te instanceof Error&&Te.stack?Te.stack:String(Te))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(re,G){return this.M[re]=G,(0,R.toDisposable)(()=>{delete this.M[re]})}async lb(re){const G=re.indexOf("+");if(G===-1)throw new Error("Not an authority that can be resolved!");const H=re.substr(0,G);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${H}`,!1),{authorityPrefix:H,resolver:this.M[H]}}async $resolveAuthority(re,G){const H=$.StopWatch.create(!1),oe=()=>`[resolveAuthority(${(0,h.getRemoteAuthorityPrefix)(re)},${G})][${H.elapsed()}ms] `,ve=Se=>this.l.info(`${oe()}${Se}`),Ae=(Se,ke=void 0)=>this.l.error(`${oe()}${Se}`,ke);ve("activating resolver...");const{authorityPrefix:Ue,resolver:xe}=await this.lb(re);if(!xe)return Ae("no resolver"),{type:"error",error:{code:h.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Ue}.`,detail:void 0}};const Te=new S.IntervalTimer;try{ve("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(xe)),Te.cancelAndSet(()=>ve("waiting..."),1e3),ve("invoking resolve()..."),D.mark(`code/extHost/willResolveAuthority/${Ue}`);const Se=await xe.resolve(re,{resolveAttempt:G});D.mark(`code/extHost/didResolveAuthorityOK/${Ue}`),Te.dispose(),ve(`returned ${Se.host}:${Se.port}`);const ke={authority:re,host:Se.host,port:Se.port,connectionToken:Se.connectionToken},se={extensionHostEnv:Se.extensionHostEnv,isTrusted:Se.isTrusted,authenticationSession:Se.authenticationSessionForInitializingExtensions?{id:Se.authenticationSessionForInitializingExtensions.id,providerId:Se.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ke,options:se,tunnelInformation:{environmentTunnels:Se.environmentTunnels,features:Se.tunnelFeatures}}}}catch(Se){if(D.mark(`code/extHost/didResolveAuthorityError/${Ue}`),Te.dispose(),Ae("returned an error",Se),Se instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:Se._code,message:Se._message,detail:Se._detail}};throw Se}}async $getCanonicalURI(re,G){this.l.info(`$getCanonicalURI invoked for authority (${(0,h.getRemoteAuthorityPrefix)(re)})`);const{resolver:H}=await this.lb(re);if(!H)return null;const oe=T.URI.revive(G);if(typeof H.getCanonicalURI>"u")return oe;const ve=await(0,S.asPromise)(()=>H.getCanonicalURI(oe));return ve||oe}static mb(re,G,H){const oe=new l.ExtensionDescriptionRegistry(re.getAllExtensionDescriptions());oe.deltaExtensions(H.toAdd,H.toRemove);const ve=(0,o.extensionIdentifiersArrayToSet)(G.getAllExtensionDescriptions().map(Ue=>Ue.identifier));for(const Ue of H.myToRemove)ve.delete(w.ExtensionIdentifier.toKey(Ue));for(const Ue of H.myToAdd)ve.add(w.ExtensionIdentifier.toKey(Ue));const Ae=pe(oe,ve);return{globalRegistry:oe,myExtensions:Ae}}$startExtensionHost(re){re.toAdd.forEach(oe=>oe.extensionLocation=T.URI.revive(oe.extensionLocation));const{globalRegistry:G,myExtensions:H}=Ui.mb(this.F,this.D,re);return this.F.set(G.getAllExtensionDescriptions()),this.D.set(H),this.kb()}$activateByEvent(re,G){return G===1?this.R(re,!1):this.z.wait().then(H=>this.R(re,!1))}async $activate(re,G){return await this.z.wait(),this.D.getExtensionDescription(re)?(await this.S(re,G),!0):!1}async $deltaExtensions(re){re.toAdd.forEach(Ae=>Ae.extensionLocation=T.URI.revive(Ae.extensionLocation));const{globalRegistry:G,myExtensions:H}=Ui.mb(this.F,this.D,re),oe=await this.W(H);return(await this.getExtensionPathIndex()).setSearchTree(oe),this.F.set(G.getAllExtensionDescriptions()),this.D.set(H),Promise.resolve(void 0)}async $test_latency(re){return re}async $test_up(re){return re.byteLength}async $test_down(re){const G=A.VSBuffer.alloc(re),H=Math.random()%256;for(let oe=0;oe<re;oe++)G.writeUInt8(H,oe);return G}async $updateRemoteConnectionData(re){this.P=re,this.a.fire()}};q=qe([je(0,i.IInstantiationService),je(1,e.IHostUtils),je(2,g.IExtHostRpcService),je(3,s.IExtHostWorkspace),je(4,f.IExtHostConfiguration),je(5,M.ILogService),je(6,a.IExtHostInitDataService),je(7,t.IExtensionStoragePaths),je(8,u.IExtHostTunnelService),je(9,d.IExtHostTerminalService),je(10,L.IExtHostLocalizationService)],q),e.AbstractExtHostExtensionService=q;function le(de,re){return{id:de.identifier.value,name:de.name,extensionVersion:de.version,publisherDisplayName:de.publisher,activationEvents:de.activationEvents?de.activationEvents.join(","):null,isBuiltin:de.isBuiltin,reason:re.activationEvent,reasonId:re.extensionId.value}}e.IExtHostExtensionService=(0,i.createDecorator)("IExtHostExtensionService");class _{constructor(re,G,H,oe,ve){P.set(this,void 0),F.set(this,void 0),V.set(this,void 0),Je(this,P,re,"f"),Je(this,F,G,"f"),Je(this,V,H.identifier,"f"),this.id=H.identifier.value,this.extensionUri=H.extensionLocation,this.extensionPath=k.normalize((0,N.originalFSPath)(H.extensionLocation)),this.packageJSON=H,this.extensionKind=oe,this.isFromDifferentExtensionHost=ve}get isActive(){return Le(this,P,"f").isActivated(Le(this,V,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Le(this,P,"f").getExtensionExports(Le(this,V,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Le(this,P,"f").activateByIdWithErrors(Le(this,V,"f"),{startup:!1,extensionId:Le(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=_,P=new WeakMap,F=new WeakMap,V=new WeakMap;function pe(de,re){return de.getAllExtensionDescriptions().filter(G=>re.has(w.ExtensionIdentifier.toKey(G.identifier)))}class ue{constructor(re){this.a=re}setSearchTree(re){this.a=re}findSubstr(re){return this.a.findSubstr(re)}forEach(re){return this.a.forEach(re)}}e.ExtensionPaths=ue}),define(Ie[246],Ce([1,0,82,2,5,32,27,25,17,26,3,33,50,11,10]),function(te,e,r,k,D,N,S,R,y,T,M,E,f,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let s=class{constructor(p,n,h,i,a,t,g){this.c=p,this.d=n,this.e=h,this.f=i,this.g=a,this.h=t,this.i=g,this.a=new Map,this.b=[]}async install(){this.j(),r.mark("code/extHost/willWaitForConfig");const p=await this.f.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const n=await this.g.getExtensionPathIndex();this.register(new l(this.c,n,this.d,p,this.i)),this.register(this.e.createInstance(v,n)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(w,n,this.h.environment.appUriScheme))}register(p){if("nodeModuleName"in p)if(Array.isArray(p.nodeModuleName))for(const n of p.nodeModuleName)this.a.set(n,p);else this.a.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this.b.push(n=>p.alternativeModuleName(n))}};s=qe([je(2,M.IInstantiationService),je(3,N.IExtHostConfiguration),je(4,E.IExtHostExtensionService),je(5,T.IExtHostInitDataService),je(6,b.ILogService)],s),e.RequireInterceptor=s;let o=class rn{constructor(p){if(p.environment.appRoot&&rn.a.size){const n=(0,m.escapeRegExpCharacters)(this.c(p.environment.appRoot.fsPath)),h="[a-z0-9_.-]",i=`@${h}+\\/${h}+|${h}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${n}/${a}\\/)(${i})(.*)$`,"i")}}alternativeModuleName(p){if(!this.b)return;const n=this.b.exec(this.c(p));if(!n)return;const[,h,i,a]=n,t=rn.a.get(i);if(t!==void 0)return console.warn(`${i} as been renamed to ${t}, please update your imports`),h+t+a}c(p){return p.replace(/\\/g,"/")}};o.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),o=qe([je(0,T.IExtHostInitDataService)],o);class l{constructor(p,n,h,i,a){this.c=p,this.d=n,this.e=h,this.f=i,this.g=a,this.nodeModuleName="vscode",this.a=new Map}load(p,n){const h=this.d.findSubstr(n);if(h){let i=this.a.get(R.ExtensionIdentifier.toKey(h.identifier));return i||(i=this.c(h,this.e,this.f),this.a.set(R.ExtensionIdentifier.toKey(h.identifier),i)),i}if(!this.b){let i="";this.d.forEach((a,t)=>i+=`	${t} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${n}. These are the extension path mappings: 
${i}`),this.b=this.c(S.nullExtensionDescription,this.e,this.f)}return this.b}}let v=class{constructor(p,n,h){this.d=p,this.nodeModuleName="keytar",this.a=n.getProxy(D.MainContext.MainThreadTelemetry);const{environment:i}=h,a=n.getProxy(D.MainContext.MainThreadKeytar);if(i.appRoot){let t=i.appRoot.fsPath;f.platform==="win32"&&(t=t.replace(/\\/g,"/")),t[t.length-1]==="/"&&(t=t.substr(0,t.length-1)),this.b=new Set,this.b.add(`${t}/node_modules.asar/keytar`),this.b.add(`${t}/node_modules/keytar`)}this.c={getPassword:(t,g)=>a.$getPassword(t,g),setPassword:(t,g,c)=>a.$setPassword(t,g,c),deletePassword:(t,g)=>a.$deletePassword(t,g),findPassword:t=>a.$findPassword(t),findCredentials(t){return a.$findCredentials(t)}}}load(p,n){const h=this.d.findSubstr(n);return this.a.$publicLog2("shimming.keytar",{extension:h?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(p){const n=p.length;if(n<=7||!this.b)return;const h=n-7;if((p.charAt(h)==="/"||p.charAt(h)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.b.has(p)))return"keytar"}};v=qe([je(1,y.IExtHostRpcService),je(2,T.IExtHostInitDataService)],v);let w=class{constructor(p,n,h){this.e=p,this.f=n,this.nodeModuleName=["open","opn"],this.d=h.getProxy(D.MainContext.MainThreadTelemetry);const i=h.getProxy(D.MainContext.MainThreadWindow);this.c=(a,t)=>{const g=k.URI.parse(a);return t?this.g(a,t):g.scheme==="http"||g.scheme==="https"?i.$openUri(g,a,{allowTunneling:!0}):g.scheme==="mailto"||g.scheme===this.f?i.$openUri(g,a,{}):this.g(a,t)}}load(p,n,h){const i=this.e.findSubstr(n);return i&&(this.a=i.identifier.value,this.h()),this.b=h(p),this.c}g(p,n){return this.i(),this.b(p,n)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};w=qe([je(2,y.IExtHostRpcService)],w)}),define(Ie[108],Ce([1,0,85,6,19,50,3,57,58,33,7,31,187,32]),function(te,e,r,k,D,N,S,R,y,T,M,E,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,S.createDecorator)("IExtHostVariableResolverProvider");class m extends f.AbstractVariableResolverService{constructor(l,v,w,A,p,n,h){function i(){if(w){const a=w.activeEditor();if(a)return a.document.uri;const t=A.tabGroups.all.find(g=>g.isActive)?.activeTab;if(t!==void 0){if(t.input instanceof M.TextDiffTabInput||t.input instanceof M.NotebookDiffEditorTabInput)return t.input.modified;if(t.input instanceof M.TextTabInput||t.input instanceof M.NotebookEditorTabInput||t.input instanceof M.CustomEditorTabInput)return t.input.uri}}}super({getFolderUri:a=>{const t=n.folders.filter(g=>g.name===a);if(t&&t.length>0)return t[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(a,t)=>p.getConfiguration(void 0,a).get(t),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const a=i();if(a)return D.normalize(a.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const a=i();if(a){const t=v.getWorkspaceFolder(a);if(t)return D.normalize(t.uri.fsPath)}}},getSelectedText:()=>{if(w){const a=w.activeEditor();if(a&&!a.selection.isEmpty)return a.document.getText(a.selection)}},getLineNumber:()=>{if(w){const a=w.activeEditor();if(a)return String(a.selection.end.line+1)}},getExtension:a=>l.getExtension(a)},void 0,h?Promise.resolve(h):void 0,Promise.resolve(N.env))}}let s=class extends k.Disposable{constructor(l,v,w,A,p){super(),this.b=l,this.c=v,this.g=w,this.h=A,this.i=p,this.a=new r.Lazy(async()=>{const n=await this.h.getConfigProvider(),i={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async a=>{i.folders=await this.c.getWorkspaceFolders2()||[]})),new m(this.b,this.c,this.g,this.i,n,i,this.j())})}getResolver(){return this.a.value}j(){}};s=qe([je(0,T.IExtHostExtensionService),je(1,E.IExtHostWorkspace),je(2,R.IExtHostDocumentsAndEditors),je(3,b.IExtHostConfiguration),je(4,y.IExtHostEditorTabs)],s),e.ExtHostVariableResolverProviderService=s}),define(Ie[109],Ce([1,0,16,4,9,2,3,5,58,33,17,7,31,180,182,32,108]),function(te,e,r,k,D,N,S,R,y,T,M,E,f,b,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,S.createDecorator)("IExtHostDebugService");let l=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(i,a,t,g,c,u){this.D=a,this.E=t,this.F=g,this.G=c,this.H=u,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new k.Emitter,this.n=new k.Emitter,this.o=new k.Emitter,this.u=new k.Emitter,this.k=i.getProxy(R.MainContext.MainThreadDebugService),this.z=new k.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new w(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(d=>{d.onDidChange(C=>{this.I(d)}),this.I(d)})}asDebugSourceUri(i,a){const t=i;if(typeof t.sourceReference=="number"&&t.sourceReference>0){let g=`debug:${encodeURIComponent(t.path||"")}`,c="?";return a&&(g+=`${c}session=${encodeURIComponent(a.id)}`,c="&"),g+=`${c}ref=${t.sourceReference}`,N.URI.parse(g)}else{if(t.path)return N.URI.file(t.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(i){const a=[];for(const t of i.getAllExtensionDescriptions())if(t.contributes){const g=t.contributes.debuggers;if(g&&g.length>0)for(const c of g)(0,m.isDebuggerMainContribution)(c)&&a.push(c.type)}this.k.$registerDebugTypes(a)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const i=[];return this.w.forEach(a=>i.push(a)),i}addBreakpoints(i){this.T();const a=i.filter(c=>{const u=c.id;return this.w.has(u)?!1:(this.w.set(u,c),!0)});this.U(a,[],[]);const t=[],g=new Map;for(const c of a)if(c instanceof E.SourceBreakpoint){let u=g.get(c.location.uri.toString());u||(u={type:"sourceMulti",uri:c.location.uri,lines:[]},g.set(c.location.uri.toString(),u),t.push(u)),u.lines.push({id:c.id,enabled:c.enabled,condition:c.condition,hitCondition:c.hitCondition,logMessage:c.logMessage,line:c.location.range.start.line,character:c.location.range.start.character})}else c instanceof E.FunctionBreakpoint&&t.push({type:"function",id:c.id,enabled:c.enabled,hitCondition:c.hitCondition,logMessage:c.logMessage,condition:c.condition,functionName:c.functionName});return this.k.$registerBreakpoints(t)}removeBreakpoints(i){this.T();const a=i.filter(u=>this.w.delete(u.id));this.U([],a,[]);const t=a.filter(u=>u instanceof E.SourceBreakpoint).map(u=>u.id),g=a.filter(u=>u instanceof E.FunctionBreakpoint).map(u=>u.id),c=a.filter(u=>u instanceof E.DataBreakpoint).map(u=>u.id);return this.k.$unregisterBreakpoints(t,g,c)}startDebugging(i,a,t){return this.k.$startDebugging(i?i.uri:void 0,a,{parentSessionID:t.parentSession?t.parentSession.id:void 0,lifecycleManagedByParent:t.lifecycleManagedByParent,repl:t.consoleMode===E.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:t.noDebug,compact:t.compact,suppressSaveBeforeStart:t.suppressSaveBeforeStart,suppressDebugStatusbar:t.suppressDebugStatusbar??t.debugUI?.simple,suppressDebugToolbar:t.suppressDebugToolbar??t.debugUI?.simple,suppressDebugView:t.suppressDebugView??t.debugUI?.simple})}stopDebugging(i){return this.k.$stopDebugging(i?i.id:void 0)}registerDebugConfigurationProvider(i,a,t){if(!a)return new E.Disposable(()=>{});const g=this.d++;return this.f.push({type:i,handle:g,provider:a}),this.k.$registerDebugConfigurationProvider(i,t,!!a.provideDebugConfigurations,!!a.resolveDebugConfiguration,!!a.resolveDebugConfigurationWithSubstitutedVariables,g),new E.Disposable(()=>{this.f=this.f.filter(c=>c.provider!==a),this.k.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(i,a,t){if(!t)return new E.Disposable(()=>{});if(!this.P(i,a))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${a}' debugger.`);if(this.M(a))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this.g++;return this.h.push({type:a,handle:g,factory:t}),this.k.$registerDebugAdapterDescriptorFactory(a,g),new E.Disposable(()=>{this.h=this.h.filter(c=>c.factory!==t),this.k.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(i,a){if(!a)return new E.Disposable(()=>{});const t=this.i++;return this.j.push({type:i,handle:t,factory:a}),new E.Disposable(()=>{this.j=this.j.filter(g=>g.factory!==a)})}async $runInTerminal(i,a){return Promise.resolve(void 0)}async $substituteVariables(i,a){let t;const g=await this.W(i);return g&&(t={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(t,a)}J(i,a){if(i.type==="implementation")return new p(i.implementation)}K(){}async $startDASession(i,a){const t=this,g=await this.V(a);return this.R(this.M(g.type),g).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const u=this.L(c),d=this.J(u,g);if(!d)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const C=d;return this.A.set(i,C),this.Q(g).then(O=>(O&&this.B.set(i,O),C.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const Z=j,x={type:"response",seq:0,command:Z.command,request_seq:Z.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const L=await this.C.sign(Z.arguments.value);x.body={signature:L},C.sendResponse(x)}else throw new Error("no signer")}catch(L){x.success=!1,x.message=L.message,C.sendResponse(x)}}else O&&O.onDidSendMessage&&O.onDidSendMessage(j),j=(0,m.convertToVSCPaths)(j,!0),t.k.$acceptDAMessage(i,j)}),C.onError(j=>{O&&O.onError&&O.onError(j),this.k.$acceptDAError(i,j.name,j.message,j.stack)}),C.onExit(j=>{O&&O.onExit&&O.onExit((0,D.withNullAsUndefined)(j),void 0),this.k.$acceptDAExit(i,(0,D.withNullAsUndefined)(j),void 0)}),O&&O.onWillStartSession&&O.onWillStartSession(),C.startSession()))})}$sendDAMessage(i,a){a=(0,m.convertToDAPaths)(a,!1);const t=this.B.get(i);t&&t.onWillReceiveMessage&&t.onWillReceiveMessage(a),this.A.get(i)?.sendMessage(a)}$stopDASession(i){const a=this.B.get(i);this.B.delete(i),a&&a.onWillStopSession&&a.onWillStopSession();const t=this.A.get(i);return this.A.delete(i),t?t.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(i){const a=[],t=[],g=[];if(i.added)for(const c of i.added){const u=c.id;if(u&&!this.w.has(u)){let d;if(c.type==="function")d=new E.FunctionBreakpoint(c.functionName,c.enabled,c.condition,c.hitCondition,c.logMessage);else if(c.type==="data")d=new E.DataBreakpoint(c.label,c.dataId,c.canPersist,c.enabled,c.hitCondition,c.condition,c.logMessage);else{const C=N.URI.revive(c.uri);d=new E.SourceBreakpoint(new E.Location(C,new E.Position(c.line,c.character)),c.enabled,c.condition,c.hitCondition,c.logMessage)}(0,E.setBreakpointId)(d,u),this.w.set(u,d),a.push(d)}}if(i.removed)for(const c of i.removed){const u=this.w.get(c);u&&(this.w.delete(c),t.push(u))}if(i.changed){for(const c of i.changed)if(c.id){const u=this.w.get(c.id);if(u){if(u instanceof E.FunctionBreakpoint&&c.type==="function"){const d=u;d.enabled=c.enabled,d.condition=c.condition,d.hitCondition=c.hitCondition,d.logMessage=c.logMessage,d.functionName=c.functionName}else if(u instanceof E.SourceBreakpoint&&c.type==="source"){const d=u;d.enabled=c.enabled,d.condition=c.condition,d.hitCondition=c.hitCondition,d.logMessage=c.logMessage,d.location=new E.Location(N.URI.revive(c.uri),new E.Position(c.line,c.character))}g.push(u)}}}this.U(a,t,g)}$provideDebugConfigurations(i,a,t){return(0,r.asPromise)(async()=>{const g=this.O(i);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const c=await this.W(a);return g.provideDebugConfigurations(c,t)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(i,a,t,g){return(0,r.asPromise)(async()=>{const c=this.O(i);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const u=await this.W(a);return c.resolveDebugConfiguration(u,t,g)})}$resolveDebugConfigurationWithSubstitutedVariables(i,a,t,g){return(0,r.asPromise)(async()=>{const c=this.O(i);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const u=await this.W(a);return c.resolveDebugConfigurationWithSubstitutedVariables(u,t,g)})}async $provideDebugAdapter(i,a){const t=this.N(i);if(!t)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.V(a);return this.R(t,g).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.L(c)})}async $acceptDebugSessionStarted(i){const a=await this.V(i);this.m.fire(a)}async $acceptDebugSessionTerminated(i){const a=await this.V(i);a&&(this.n.fire(a),this.l.delete(a.id))}async $acceptDebugSessionActiveChanged(i){this.q=i?await this.V(i):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(i,a){(await this.V(i))?._acceptNameChanged(a)}async $acceptDebugSessionCustomEvent(i,a){const g={session:await this.V(i),event:a.event,body:a.body};this.u.fire(g)}L(i){if(i instanceof E.DebugAdapterExecutable)return{type:"executable",command:i.command,args:i.args,options:i.options};if(i instanceof E.DebugAdapterServer)return{type:"server",port:i.port,host:i.host};if(i instanceof E.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:i.path};if(i instanceof E.DebugAdapterInlineImplementation)return{type:"implementation",implementation:i.implementation};throw new Error("convertToDto unexpected type")}M(i){const a=this.h.filter(t=>t.type===i);if(a.length>0)return a[0].factory}N(i){const a=this.h.filter(t=>t.handle===i);if(a.length>0)return a[0].factory}O(i){const a=this.f.filter(t=>t.handle===i);if(a.length>0)return a[0].provider}P(i,a){if(i.contributes){const t=i.contributes.debuggers;if(t&&t.length>0){for(const g of t)if(g.label&&g.type&&g.type===a)return!0}}return!1}Q(i){const t=i.configuration.type,g=this.j.filter(c=>c.type===t||c.type==="*").map(c=>(0,r.asPromise)(()=>c.factory.createDebugAdapterTracker(i)).then(u=>u,u=>null));return Promise.race([Promise.all(g).then(c=>{const u=c.filter(d=>!!d);if(u.length>0)return new A(u)}),new Promise(c=>setTimeout(()=>c(void 0),1e3))]).catch(c=>{})}async R(i,a){const t=a.configuration.debugServer;if(typeof t=="number")return Promise.resolve(new E.DebugAdapterServer(t));if(i){const c=await this.E.getExtensionRegistry();return(0,r.asPromise)(()=>i.createDebugAdapterDescriptor(a,this.S(a,c))).then(u=>{if(u)return u})}const g=await this.E.getExtensionRegistry();return Promise.resolve(this.S(a,g))}S(i,a){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(i,a,t){(i.length>0||a.length>0||t.length>0)&&this.z.fire(Object.freeze({added:i,removed:a,changed:t}))}async V(i){if(i)if(typeof i=="string"){const a=this.l.get(i);if(a)return a}else{let a=this.l.get(i.id);if(!a){const t=await this.W(i.folderUri),g=i.parent?this.l.get(i.parent):void 0;a=new v(this.k,i.id,i.type,i.name,t,i.configuration,g),this.l.set(a.id,a),this.k.$sessionCached(a.id)}return a}throw new Error("cannot find session")}W(i){if(i){const a=N.URI.revive(i);return this.D.resolveWorkspaceFolder(a)}return Promise.resolve(void 0)}};l=qe([je(0,M.IExtHostRpcService),je(1,f.IExtHostWorkspace),je(2,T.IExtHostExtensionService),je(3,s.IExtHostConfiguration),je(4,y.IExtHostEditorTabs),je(5,o.IExtHostVariableResolverProvider)],l),e.ExtHostDebugServiceBase=l;class v{constructor(i,a,t,g,c,u,d){this.d=i,this.f=a,this.g=t,this.h=g,this.i=c,this.j=u,this.k=d}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(i){this.h=i,this.d.$setDebugSessionName(this.f,i)}get parentSession(){return this.k}_acceptNameChanged(i){this.h=i}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(i,a){return this.d.$customDebugAdapterRequest(this.f,i,a)}getDebugProtocolBreakpoint(i){return this.d.$getDebugProtocolBreakpoint(this.f,i.id)}}e.ExtHostDebugSession=v;class w{constructor(i){this.value=Object.freeze({append(a){i.$appendDebugConsole(a)},appendLine(a){this.append(a+`
`)}})}}e.ExtHostDebugConsole=w;class A{constructor(i){this.d=i}onWillStartSession(){this.d.forEach(i=>i.onWillStartSession?i.onWillStartSession():void 0)}onWillReceiveMessage(i){this.d.forEach(a=>a.onWillReceiveMessage?a.onWillReceiveMessage(i):void 0)}onDidSendMessage(i){this.d.forEach(a=>a.onDidSendMessage?a.onDidSendMessage(i):void 0)}onWillStopSession(){this.d.forEach(i=>i.onWillStopSession?i.onWillStopSession():void 0)}onError(i){this.d.forEach(a=>a.onError?a.onError(i):void 0)}onExit(i,a){this.d.forEach(t=>t.onExit?t.onExit(i,a):void 0)}}class p extends b.AbstractDebugAdapter{constructor(i){super(),this.h=i,i.onDidSendMessage(a=>{this.acceptMessage(a)})}startSession(){return Promise.resolve(void 0)}sendMessage(i){this.h.handleMessage(i)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let n=class extends l{constructor(i,a,t,g,c,u){super(i,a,t,g,c,u)}};n=qe([je(0,M.IExtHostRpcService),je(1,f.IExtHostWorkspace),je(2,T.IExtHostExtensionService),je(3,s.IExtHostConfiguration),je(4,y.IExtHostEditorTabs),je(5,o.IExtHostVariableResolverProvider)],n),e.WorkerExtHostDebugService=n}),define(Ie[247],Ce([1,0,12,82,2,5,238,11,66,67,26,158,17,54,33,74]),function(te,e,r,k,D,N,S,R,y,T,M,E,f,b,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class o{static async installEarlyHandler(w){const A=w.get(R.ILogService),n=w.get(f.IExtHostRpcService).getProxy(N.MainContext.MainThreadErrors);r.setUnexpectedErrorHandler(h=>{A.error(h);const i=r.transformErrorForSerialization(h);n.$onUnexpectedError(i)})}static async installFullHandler(w){const A=w.get(R.ILogService),p=w.get(f.IExtHostRpcService),n=w.get(m.IExtHostExtensionService),h=w.get(s.IExtHostTelemetry),i=p.getProxy(N.MainContext.MainThreadExtensionService),a=p.getProxy(N.MainContext.MainThreadErrors),t=await n.getExtensionPathIndex(),g=new WeakMap;Error.prepareStackTrace=(c,u)=>{let d="",C,O;for(const j of u)d+=`
	at ${j.toString()}`,O=j.getFileName(),!C&&O&&(C=t.findSubstr(D.URI.file(O)));return g.set(c,C?.identifier),`${c.name||"Error"}: ${c.message||""}${d}`},r.setUnexpectedErrorHandler(c=>{A.error(c);const u=r.transformErrorForSerialization(c),d=g.get(c);if(!d){a.$onUnexpectedError(u);return}i.$onExtensionRuntimeError(d,u);const C=h.onExtensionError(d,c);A.trace("forwarded error to extension?",C,d)})}}Error.stackTraceLimit=100;class l{constructor(w,A,p,n,h){this.a=p,this.b=new S.RPCProtocol(w,null,n),A=l.e(A,this.b);const i=new T.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());i.set(M.IExtHostInitDataService,{_serviceBrand:void 0,...A,messagePorts:h}),i.set(f.IExtHostRpcService,new f.ExtHostRpcService(this.b)),i.set(b.IURITransformerService,new b.URITransformerService(n)),i.set(m.IHostUtils,p);const a=new E.InstantiationService(i,!0);a.invokeFunction(o.installEarlyHandler),this.d=a.invokeFunction(t=>t.get(R.ILogService)),k.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",A),this.c=a.invokeFunction(t=>t.get(m.IExtHostExtensionService)),this.c.initialize(),a.invokeFunction(o.installFullHandler)}async asBrowserUri(w){const A=this.b.getProxy(N.MainContext.MainThreadExtensionService);return D.URI.revive(await A.$asBrowserUri(w))}terminate(w){this.c.terminate(w)}static e(w,A){w.allExtensions.forEach(n=>{n.extensionLocation=D.URI.revive(A.transformIncomingURIs(n.extensionLocation));const h={};n.browserNlsBundleUris&&(Object.keys(n.browserNlsBundleUris).forEach(i=>h[i]=D.URI.revive(A.transformIncomingURIs(n.browserNlsBundleUris[i]))),n.browserNlsBundleUris=h)}),w.environment.appRoot=D.URI.revive(A.transformIncomingURIs(w.environment.appRoot));const p=w.environment.extensionDevelopmentLocationURI;return p&&(w.environment.extensionDevelopmentLocationURI=p.map(n=>D.URI.revive(A.transformIncomingURIs(n)))),w.environment.extensionTestsLocationURI=D.URI.revive(A.transformIncomingURIs(w.environment.extensionTestsLocationURI)),w.environment.globalStorageHome=D.URI.revive(A.transformIncomingURIs(w.environment.globalStorageHome)),w.environment.workspaceStorageHome=D.URI.revive(A.transformIncomingURIs(w.environment.workspaceStorageHome)),w.environment.extensionTelemetryLogResource=D.URI.revive(A.transformIncomingURIs(w.environment.extensionTelemetryLogResource)),w.nlsBaseUrl=D.URI.revive(A.transformIncomingURIs(w.nlsBaseUrl)),w.logsLocation=D.URI.revive(A.transformIncomingURIs(w.logsLocation)),w.logFile=D.URI.revive(A.transformIncomingURIs(w.logFile)),w.workspace=A.transformIncomingURIs(w.workspace),w}}e.ExtensionHostMain=l}),define(Ie[248],Ce([1,0,18,16,21,39,15,19,24,2,46]),function(te,e,r,k,D,N,S,R,y,T,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class E{constructor(v,w,A,p){this.d=v,this.e=w,this.f=A,this.g=p,this.a=null,this.b=!1,this.c=0}search(v,w){const A=this.d.folderQueries||[],p=new D.CancellationTokenSource;return w.onCancellationRequested(()=>p.cancel()),new Promise((n,h)=>{this.a=new b(v);let i=!1;const a=(t,g)=>{if(!i&&!this.b){const c=this.h(t);s(t)&&typeof this.d.maxResults=="number"&&this.c+c>this.d.maxResults&&(this.b=!0,i=!0,p.cancel(),t=this.j(t,this.d.maxResults-this.c));const u=this.h(t);this.c+=u,(u>0||!s(t))&&this.a.add(t,g)}};Promise.all(A.map((t,g)=>this.k(t,c=>a(c,g),p.token))).then(t=>{p.dispose(),this.a.flush();const g=t.some(c=>!!c&&!!c.limitHit);n({limitHit:this.b||g,messages:(0,r.flatten)(t.map(c=>c?.message?Array.isArray(c.message)?c.message:[c.message]:[])),stats:{type:this.g}})},t=>{p.dispose();const g=(0,N.toErrorMessage)(t);h(new Error(g))})})}h(v){return s(v)?Array.isArray(v.ranges)?v.ranges.length:1:0}j(v,w){const A=Array.isArray(v.ranges)?v.ranges:[v.ranges],p=Array.isArray(v.preview.matches)?v.preview.matches:[v.preview.matches];return{ranges:A.slice(0,w),preview:{matches:p.slice(0,w),text:v.preview.text},uri:v.uri}}async k(v,w,A){const p=new M.QueryGlobTester(this.d,v),n=[],h={report:t=>{if(!this.l(t))return;const g=v.folder.scheme===S.Schemas.file?(0,M.hasSiblingPromiseFn)(()=>this.f.readdir(y.dirname(t.uri))):void 0,c=y.relativePath(v.folder,t.uri);if(c){const u=p.includedInQuery(c,R.basename(c),g);(0,k.isThenable)(u)?n.push(u.then(d=>{d&&w(t)})):u&&w(t)}}},i=this.n(v),a=await this.e.provideTextSearchResults(f(this.d.contentPattern),i,h,A);return n.length&&await Promise.all(n),a}l(v){if(s(v)){if(Array.isArray(v.ranges)){if(!Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(v.preview.matches.length!==v.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(v){const w=(0,M.resolvePatternsForProvider)(this.d.includePattern,v.includePattern),A=(0,M.resolvePatternsForProvider)(this.d.excludePattern,v.excludePattern),p={folder:T.URI.from(v.folder),excludes:A,includes:w,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,encoding:v.fileEncoding&&this.f.toCanonicalName(v.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return p.usePCRE2=this.d.usePCRE2,p}}e.TextSearchManager=E;function f(l){return{isCaseSensitive:l.isCaseSensitive||!1,isRegExp:l.isRegExp||!1,isWordMatch:l.isWordMatch||!1,isMultiline:l.isMultiline||!1,pattern:l.pattern}}class b{constructor(v){this.e=v,this.b=-1,this.d=null,this.a=new o(512,w=>this.g(w))}add(v,w){this.d&&(this.b!==w||!y.isEqual(this.c,v.uri))&&(this.f(),this.d=null),this.d||(this.b=w,this.d={resource:v.uri,results:[]}),this.d.results.push(m(v))}f(){const v=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,v)}flush(){this.f(),this.a.flush()}g(v){this.e(v)}}e.TextSearchResultsCollector=b;function m(l){return s(l)?{preview:{matches:(0,r.mapArrayOrNot)(l.preview.matches,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character})),text:l.preview.text},ranges:(0,r.mapArrayOrNot)(l.ranges,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character}))}:{text:l.text,lineNumber:l.lineNumber}}function s(l){return!!l.preview}e.extensionResultIsMatch=s;class o{constructor(v,w){this.g=v,this.h=w,this.c=0,this.d=[],this.e=0}addItem(v,w){!v||this.j(v,w)}addItems(v,w){!v||this.k(v,w)}j(v,w){this.d.push(v),this.e+=w,this.l()}k(v,w){this.d=this.d.concat(v),this.e+=w,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=o,o.a=4e3,o.b=50}),define(Ie[110],Ce([1,0,6,5,3,243,17,54,11,2,248]),function(te,e,r,k,D,N,S,R,y,T,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let E=class{constructor(s,o,l){this.k=s,this.l=o,this.n=l,this.c=this.k.getProxy(k.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new N.FileSearchManager}o(s){return this.l.transformOutgoingScheme(s)}registerTextSearchProvider(s,o){if(this.g.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this.g.add(s);const l=this.d++;return this.e.set(l,o),this.c.$registerTextSearchProvider(l,this.o(s)),(0,r.toDisposable)(()=>{this.g.delete(s),this.e.delete(l),this.c.$unregisterProvider(l)})}registerFileSearchProvider(s,o){if(this.i.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this.i.add(s);const l=this.d++;return this.h.set(l,o),this.c.$registerFileSearchProvider(l,this.o(s)),(0,r.toDisposable)(()=>{this.i.delete(s),this.h.delete(l),this.c.$unregisterProvider(l)})}$provideFileSearchResults(s,o,l,v){const w=f(l),A=this.h.get(s);if(A)return this.j.fileSearch(w,A,p=>{this.c.$handleFileMatch(s,o,p.map(n=>n.resource))},v);throw new Error("unknown provider: "+s)}$clearCache(s){return this.j.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,o,l,v){const w=this.e.get(s);if(!w||!w.provideTextSearchResults)throw new Error(`Unknown provider ${s}`);const A=f(l);return this.q(A,w).search(n=>this.c.$handleTextMatch(s,o,n),v)}$enableExtensionHostSearch(){}q(s,o){return new M.TextSearchManager(s,o,{readdir:l=>Promise.resolve([]),toCanonicalName:l=>l},"textSearchProvider")}};E=qe([je(0,S.IExtHostRpcService),je(1,R.IURITransformerService),je(2,y.ILogService)],E),e.ExtHostSearch=E;function f(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(b),extraFileResources:m.extraFileResources&&m.extraFileResources.map(s=>T.URI.revive(s))}}e.reviveQuery=f;function b(m){return{...m,folder:T.URI.revive(m.folder)}}}),define(Ie[249],Ce([1,0,66,105,31,103,32,37,57,60,107,109,110,80,69,76,104,59,36,79,74,58,218,11,174,108,78]),function(te,e,r,k,D,N,S,R,y,T,M,E,f,b,m,s,o,l,v,w,A,p,n,h,i,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(t.IExtHostLocalizationService,t.ExtHostLocalizationService,1),(0,r.registerSingleton)(h.ILoggerService,n.ExtHostLoggerService,1),(0,r.registerSingleton)(h.ILogService,i.ExtHostLogService,1),(0,r.registerSingleton)(s.IExtHostApiDeprecationService,s.ExtHostApiDeprecationService,1),(0,r.registerSingleton)(R.IExtHostCommands,R.ExtHostCommands,0),(0,r.registerSingleton)(S.IExtHostConfiguration,S.ExtHostConfiguration,0),(0,r.registerSingleton)(l.IExtHostConsumerFileSystem,l.ExtHostConsumerFileSystem,0),(0,r.registerSingleton)(E.IExtHostDebugService,E.WorkerExtHostDebugService,0),(0,r.registerSingleton)(N.IExtHostDecorations,N.ExtHostDecorations,0),(0,r.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,r.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo,0),(0,r.registerSingleton)(k.IExtHostOutputService,k.ExtHostOutputService,1),(0,r.registerSingleton)(f.IExtHostSearch,f.ExtHostSearch,0),(0,r.registerSingleton)(b.IExtHostStorage,b.ExtHostStorage,0),(0,r.registerSingleton)(M.IExtHostTask,M.WorkerExtHostTask,0),(0,r.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService,0),(0,r.registerSingleton)(m.IExtHostTunnelService,m.ExtHostTunnelService,0),(0,r.registerSingleton)(o.IExtHostWindow,o.ExtHostWindow,0),(0,r.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace,0),(0,r.registerSingleton)(w.IExtHostSecretState,w.ExtHostSecretState,0),(0,r.registerSingleton)(A.IExtHostTelemetry,A.ExtHostTelemetry,0),(0,r.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs,0),(0,r.registerSingleton)(a.IExtHostVariableResolverProvider,a.ExtHostVariableResolverProviderService,0)}),define(Ie[250],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class r{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(D){if(D&&this.a.has(D)){const N=this.a.get(D);return this.a.delete(D),N}}addDragOperationTransfer(D,N){this.a.set(D,N)}getRenderedTreeElement(D){if(this.b.has(D))return this.b.get(D)}addRenderedTreeItemElement(D,N){this.b.set(D,N)}removeRenderedTreeItemElement(D){this.b.has(D)&&this.b.delete(D)}}e.TreeviewsService=r}),define(Ie[251],Ce([1,0,143,7,24,2,4,6,179,16,7,9,18,8,21,250,27]),function(te,e,r,k,D,N,S,R,y,T,M,E,f,b,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function l(A,p){if((0,E.isString)(A))return{label:A};if(A&&typeof A=="object"&&typeof A.label=="string"){let n;return Array.isArray(A.highlights)&&(n=A.highlights.filter(h=>h.length===2&&typeof h[0]=="number"&&typeof h[1]=="number"),n=n.length?n:void 0),{label:A.label,highlights:n}}}class v{constructor(p,n,h){this.d=p,this.e=n,this.f=h,this.a=new Map,this.b=new s.TreeviewsService;function i(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:a=>i(a)?this.i(a):Array.isArray(a)&&a.length>0?a.map(t=>i(t)?this.i(t):t):a})}registerTreeDataProvider(p,n,h){const i=this.createTreeView(p,{treeDataProvider:n},h);return{dispose:()=>i.dispose()}}createTreeView(p,n,h){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=n.dragAndDropController?.dropMimeTypes??[],a=n.dragAndDropController?.dragMimeTypes??[],t=!!n.dragAndDropController?.handleDrag,g=!!n.dragAndDropController?.handleDrop,c=this.h(p,n,h),u=this.d.$registerTreeViewDataProvider(p,{showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:i,dragMimeTypes:a,hasHandleDrag:t,hasHandleDrop:g});return{get onDidCollapseElement(){return c.onDidCollapseElement},get onDidExpandElement(){return c.onDidExpandElement},get selection(){return c.selectedElements},get onDidChangeSelection(){return c.onDidChangeSelection},get visible(){return c.visible},get onDidChangeVisibility(){return c.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,o.checkProposedApiEnabled)(h,"treeItemCheckbox"),c.onDidChangeCheckboxState},get message(){return c.message},set message(d){c.message=d},get title(){return c.title},set title(d){c.title=d},get description(){return c.description},set description(d){c.description=d},get badge(){return c.badge},set badge(d){d!==void 0&&M.ViewBadge.isViewBadge(d)?c.badge={value:Math.floor(Math.abs(d.value)),tooltip:d.tooltip}:d===void 0&&(c.badge=void 0)},reveal:(d,C)=>c.reveal(d,C),dispose:async()=>{await u,this.a.delete(p),c.dispose()}}}$getChildren(p,n){const h=this.a.get(p);return h?h.getChildren(n):Promise.reject(new y.NoTreeViewError(p))}async $handleDrop(p,n,h,i,a,t,g,c){const u=this.a.get(p);if(!u)return Promise.reject(new y.NoTreeViewError(p));const d=b.DataTransfer.toDataTransfer(h,async C=>(await this.d.$resolveDropFileData(p,n,C)).buffer);return g===p&&c&&await this.g(d,u,c,a,t),u.onDrop(d,i,a)}async g(p,n,h,i,a){const t=this.b.removeDragOperationTransfer(a);if(t)(await t)?.forEach((g,c)=>{g&&p.set(c,g)});else if(a&&n.handleDrag){const g=n.handleDrag(h,p,i);this.b.addDragOperationTransfer(a,g),await g}return p}async $handleDrag(p,n,h,i){const a=this.a.get(p);if(!a)return Promise.reject(new y.NoTreeViewError(p));const t=await this.g(new k.DataTransfer,a,n,i,h);if(!!t)return b.DataTransfer.toDataTransferDTO(t)}async $hasResolve(p){const n=this.a.get(p);if(!n)throw new y.NoTreeViewError(p);return n.hasResolve}$resolve(p,n,h){const i=this.a.get(p);if(!i)throw new y.NoTreeViewError(p);return i.resolveTreeItem(n,h)}$setExpanded(p,n,h){const i=this.a.get(p);if(!i)throw new y.NoTreeViewError(p);i.setExpanded(n,h)}$setSelection(p,n){const h=this.a.get(p);if(!h)throw new y.NoTreeViewError(p);h.setSelection(n)}$setFocus(p,n){const h=this.a.get(p);if(!h)throw new y.NoTreeViewError(p);h.setFocus(n)}$setVisible(p,n){const h=this.a.get(p);if(!h)throw new y.NoTreeViewError(p);h.setVisible(n)}$changeCheckboxState(p,n){const h=this.a.get(p);if(!h)throw new y.NoTreeViewError(p);h.setCheckboxState(n)}h(p,n,h){const i=new w(p,n,this.d,this.e.converter,this.f,h);return this.a.set(p,i),i}i(p){const n=this.a.get(p.$treeViewId);return n&&"$treeItemHandle"in p?n.getExtensionElement(p.$treeItemHandle):n&&"$focusedTreeItem"in p&&p.$focusedTreeItem?n.focusedElement:null}}e.ExtHostTreeViews=v;class w extends R.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(p=>this.getExtensionElement(p)).filter(p=>!(0,E.isUndefinedOrNull)(p))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(p,n,h,i,a,t){if(super(),this.C=p,this.D=h,this.F=i,this.G=a,this.H=t,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new S.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new S.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new S.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new S.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new S.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new S.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new m.CancellationTokenSource,t.contributes&&t.contributes.views)for(const u in t.contributes.views)for(const d of t.contributes.views[u])d.id===p&&(this.J=d.name);this.f=n.treeDataProvider,this.g=n.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(u=>this.w.fire({message:!1,element:u})));let g,c;this.B(S.Event.debounce(this.w.event,(u,d)=>(u||(u={message:!1,elements:[]}),d.element!==!1&&(g||(g=new Promise(C=>c=C),this.y=this.y.then(()=>g)),Array.isArray(d.element)?u.elements.push(...d.element):u.elements.push(d.element)),d.message&&(u.message=!0),u),200,!0)(({message:u,elements:d})=>{d.length&&(this.z=this.z.then(()=>{const C=c;return g=null,this.U(d).then(()=>C())})),u&&this.D.$setMessage(this.C,this.I)}))}async getChildren(p){const n=p?this.getExtensionElement(p):void 0;if(p&&!n)return this.G.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let h=this.Q(p);return h||(h=await this.R(n)),h?h.map(i=>i.item):void 0}getExtensionElement(p){return this.i.get(p)}reveal(p,n){n=n||{select:!0,focus:!1};const h=(0,E.isUndefinedOrNull)(n.select)?!0:n.select,i=(0,E.isUndefinedOrNull)(n.focus)?!1:n.focus,a=(0,E.isUndefinedOrNull)(n.expand)?!1:n.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.y.then(()=>this.N(p)).then(t=>this.P(p,t[t.length-1]).then(g=>this.D.$reveal(this.C,{item:g.item,parentChain:t.map(c=>c.item)},{select:h,focus:i,expand:a})),t=>this.G.error(t)):this.D.$reveal(this.C,void 0,{select:h,focus:i,expand:a})}get message(){return this.I}set message(p){this.I=p,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(p){this.J=p,this.D.$setTitle(this.C,p,this.L)}get description(){return this.L}set description(p){this.L=p,this.D.$setTitle(this.C,this.J,p)}get badge(){return this.M}set badge(p){this.M?.value===p?.value&&this.M?.tooltip===p?.tooltip||(this.M=b.ViewBadge.from(p),this.D.$setBadge(this.C,p))}setExpanded(p,n){const h=this.getExtensionElement(p);h&&(n?this.r.fire(Object.freeze({element:h})):this.s.fire(Object.freeze({element:h})))}setSelection(p){(0,f.equals)(this.l,p)||(this.l=p,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this.m=p}setVisible(p){p!==this.k&&(this.k=p,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(p){const n=(await Promise.all(p.map(async h=>{const i=this.getExtensionElement(h.treeItemHandle);return i?{extensionItem:i,treeItem:await this.f.getTreeItem(i),newState:h.newState?M.TreeItemCheckboxState.Checked:M.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(h=>h!==void 0);n.forEach(h=>{h.treeItem.checkboxState=h.newState?M.TreeItemCheckboxState.Checked:M.TreeItemCheckboxState.Unchecked}),this.v.fire({items:n.map(h=>[h.extensionItem,h.newState])})}async handleDrag(p,n,h){const i=[];for(const a of p){const t=this.getExtensionElement(a);t&&i.push(t)}if(!(!this.g?.handleDrag||i.length===0))return await this.g.handleDrag(i,n,h),n}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(p,n,h){const i=n?this.getExtensionElement(n):void 0;if(!(!i&&n||!this.g?.handleDrop))return(0,T.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(i,p,h):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(p,n){if(!this.f.resolveTreeItem)return;const h=this.i.get(p);if(h){const i=this.j.get(h);if(i){const a=await this.f.resolveTreeItem(i.extensionItem,h,n)??i.extensionItem;return this.db(a),i.item.tooltip=this.ab(a.tooltip),i.item.command=this.bb(i.disposableStore,a.command),i.item}}}N(p){return this.O(p).then(n=>n?this.N(n).then(h=>this.P(n,h[h.length-1]).then(i=>(h.push(i),h))):Promise.resolve([]))}O(p){const n=this.j.get(p);return n?Promise.resolve(n.parent?this.i.get(n.parent.item.handle):void 0):(0,T.asPromise)(()=>this.f.getParent(p))}P(p,n){const h=this.j.get(p);return h?Promise.resolve(h):(0,T.asPromise)(()=>this.f.getTreeItem(p)).then(i=>this.gb(p,i,n,!0)).then(i=>this.getChildren(n?n.item.handle:void 0).then(()=>{const a=this.getExtensionElement(i);if(a){const t=this.j.get(a);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}Q(p){if(p){let n;if(typeof p=="string"){const h=this.getExtensionElement(p);n=h?this.j.get(h):void 0}else n=p;return n&&n.children||void 0}return this.h}async R(p){this.nb(p);const n=new m.CancellationTokenSource(this.S.token);try{const h=p?this.j.get(p):void 0,i=await this.f.getChildren(p);if(n.token.isCancellationRequested)return;const a=await Promise.all((0,f.coalesce)(i||[]).map(async t=>{const g=await this.f.getTreeItem(t);return g&&!n.token.isCancellationRequested?this.Z(t,g,h):null}));return n.token.isCancellationRequested?void 0:(0,f.coalesce)(a)}finally{n.dispose()}}U(p){if(p.some(h=>!h))return this.S.dispose(!0),this.S=new m.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const h=this.W(p);if(h.length)return this.X(h)}return Promise.resolve(void 0)}W(p){const n=new Set,h=p.map(a=>this.j.get(a));for(const a of h)if(a&&!n.has(a.item.handle)){let t=a;for(;t&&t.parent&&h.findIndex(g=>t&&t.parent&&g&&g.item.handle===t.parent.item.handle)===-1;){const g=this.i.get(t.parent.item.handle);t=g?this.j.get(g):void 0}t&&!t.parent&&n.add(a.item.handle)}const i=[];return n.forEach(a=>{const t=this.i.get(a);if(t){const g=this.j.get(t);g&&(!g.parent||!n.has(g.parent.item.handle))&&i.push(a)}}),i}X(p){const n={};return Promise.all(p.map(h=>this.Y(h).then(i=>{i&&(n[h]=i.item)}))).then(()=>Object.keys(n).length?this.D.$refresh(this.C,n):void 0)}Y(p){const n=this.getExtensionElement(p);if(n){const h=this.j.get(n);if(h)return this.nb(n),(0,T.asPromise)(()=>this.f.getTreeItem(n)).then(i=>{if(i){const a=this.eb(n,i,h.parent);return this.lb(n,a,h,h.parent),h.dispose(),a}return null})}return Promise.resolve(null)}Z(p,n,h){const i=this.eb(p,n,h);if(n.id&&this.i.has(i.item.handle))throw new Error((0,r.localize)(0,null,n.id));return this.kb(p,i),this.mb(i,h),i}ab(p){return M.MarkdownString.isMarkdownString(p)?b.MarkdownString.from(p):p}bb(p,n){return n?{...this.F.toInternal(n,p),originalId:n.command}:void 0}cb(p){if(!p.checkboxState)return;let n,h;return typeof p.checkboxState=="number"?n=p.checkboxState:(n=p.checkboxState.state,h=p.checkboxState.tooltip),{isChecked:n===M.TreeItemCheckboxState.Checked,tooltip:h}}db(p){if(!M.TreeItem.isTreeItem(p,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(p,n,h){this.db(n);const i=new R.DisposableStore,a=this.gb(p,n,h),t=this.hb(n);return{item:{handle:a,parentHandle:h?h.item.handle:void 0,label:l(n.label,this.H),description:n.description,resourceUri:n.resourceUri,tooltip:this.ab(n.tooltip),command:this.bb(i,n.command),contextValue:n.contextValue,icon:t,iconDark:this.ib(n)||t,themeIcon:this.fb(n),collapsibleState:(0,E.isUndefinedOrNull)(n.collapsibleState)?M.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.cb(n)},extensionItem:n,parent:h,children:void 0,disposableStore:i,dispose(){i.dispose()}}}fb(p){return p.iconPath instanceof M.ThemeIcon?p.iconPath:void 0}gb(p,{id:n,label:h,resourceUri:i},a,t){if(n)return`${w.b}/${n}`;const g=l(h,this.H),c=a?a.item.handle:w.a;let u=g?g.label:i?(0,D.basename)(i):"";u=u.indexOf("/")!==-1?u.replace("/","//"):u;const d=this.j.has(p)?this.j.get(p).item.handle:void 0,C=this.Q(a)||[];let O,j=0;do{if(O=`${c}/${j}:${u}`,t||!this.i.has(O)||d===O)break;j++}while(j<=C.length);return O}hb(p){if(p.iconPath&&!(p.iconPath instanceof M.ThemeIcon))return typeof p.iconPath=="string"||N.URI.isUri(p.iconPath)?this.jb(p.iconPath):this.jb(p.iconPath.light)}ib(p){if(p.iconPath&&!(p.iconPath instanceof M.ThemeIcon)&&p.iconPath.dark)return this.jb(p.iconPath.dark)}jb(p){return N.URI.isUri(p)?p:N.URI.file(p)}kb(p,n){this.i.set(n.item.handle,p),this.j.set(p,n)}lb(p,n,h,i){this.i.delete(n.item.handle),this.j.delete(p),n.item.handle!==h.item.handle&&this.i.delete(h.item.handle),this.kb(p,n);const a=this.Q(i)||[],t=a.filter(g=>g.item.handle===h.item.handle)[0];t&&a.splice(a.indexOf(t),1,n)}mb(p,n){n?(n.children||(n.children=[]),n.children.push(p)):(this.h||(this.h=[]),this.h.push(p))}nb(p){if(p){const n=this.j.get(p);if(n){if(n.children)for(const h of n.children){const i=this.i.get(h.item.handle);i&&this.ob(i)}n.children=void 0}}else this.pb()}ob(p){const n=this.j.get(p);if(n){if(n.children)for(const h of n.children){const i=this.i.get(h.item.handle);i&&this.ob(i)}this.j.delete(p),this.i.delete(n.item.handle),n.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(p=>p.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}w.a="0",w.b="1"}),define(Ie[252],Ce([1,0,21,12,4,29,2,129,261,117,127,43,5,73,205,204,37,206,32,208,209,210,193,211,57,33,212,213,216,217,219,105,196,225,226,227,80,60,230,251,8,7,51,233,61,104,31,185,215,49,103,107,109,110,11,54,17,26,220,191,69,76,202,231,81,59,236,234,235,203,36,228,232,79,58,74,221,106,222,15,92,195,176,214,6,27,181,78,172,223,224]),function(te,e,r,k,D,N,S,R,y,T,M,E,f,b,m,s,o,l,v,w,A,p,n,h,i,a,t,g,c,u,d,C,O,j,Z,x,L,$,P,F,V,q,le,_,pe,ue,de,re,G,H,oe,ve,Ae,Ue,xe,Te,Se,ke,se,ce,J,I,B,W,K,ee,he,ye,ae,be,Ee,We,Ve,tt,Xe,et,it,dt,Fe,ot,Y,Q,ge,Me,ze,He,Ye,nt,vt,wt,Ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function jt(rt){const mt=rt.get(ke.IExtHostInitDataService),Ft=rt.get(Ee.IExtHostFileSystemInfo),xt=rt.get(ee.IExtHostConsumerFileSystem),Pt=rt.get(a.IExtHostExtensionService),ht=rt.get(de.IExtHostWorkspace),kt=rt.get(et.IExtHostTelemetry),Bt=rt.get(v.IExtHostConfiguration),Ot=rt.get(Te.IURITransformerService),Ge=rt.get(Se.IExtHostRpcService),Mt=rt.get(L.IExtHostStorage),Nt=rt.get(K.IExtensionStoragePaths),zt=rt.get(xe.ILoggerService),ft=rt.get(xe.ILogService),De=rt.get(J.IExtHostTunnelService),Pe=rt.get(I.IExtHostApiDeprecationService),me=rt.get(ue.IExtHostWindow),X=rt.get(tt.IExtHostSecretState),Re=rt.get(Xe.IExtHostEditorTabs);Ge.set(f.ExtHostContext.ExtHostFileSystemInfo,Ft),Ge.set(f.ExtHostContext.ExtHostLogLevelServiceShape,zt),Ge.set(f.ExtHostContext.ExtHostWorkspace,ht),Ge.set(f.ExtHostContext.ExtHostConfiguration,Bt),Ge.set(f.ExtHostContext.ExtHostExtensionService,Pt),Ge.set(f.ExtHostContext.ExtHostStorage,Mt),Ge.set(f.ExtHostContext.ExtHostTunnelService,De),Ge.set(f.ExtHostContext.ExtHostWindow,me),Ge.set(f.ExtHostContext.ExtHostSecretState,X),Ge.set(f.ExtHostContext.ExtHostTelemetry,kt),Ge.set(f.ExtHostContext.ExtHostEditorTabs,Re);const Be=Ge.set(f.ExtHostContext.ExtHostDecorations,rt.get(oe.IExtHostDecorations)),Qe=Ge.set(f.ExtHostContext.ExtHostDocumentsAndEditors,rt.get(i.IExtHostDocumentsAndEditors)),$e=Ge.set(f.ExtHostContext.ExtHostCommands,rt.get(o.IExtHostCommands)),Ze=Ge.set(f.ExtHostContext.ExtHostTerminalService,rt.get($.IExtHostTerminalService)),ct=Ge.set(f.ExtHostContext.ExtHostDebugService,rt.get(Ae.IExtHostDebugService)),Tt=Ge.set(f.ExtHostContext.ExtHostSearch,rt.get(Ue.IExtHostSearch)),bt=Ge.set(f.ExtHostContext.ExtHostTask,rt.get(ve.IExtHostTask)),Et=Ge.set(f.ExtHostContext.ExtHostOutputService,rt.get(C.IExtHostOutputService)),It=Ge.set(f.ExtHostContext.ExtHostLocalization,rt.get(nt.IExtHostLocalizationService)),St=Ge.set(f.ExtHostContext.ExtHostUrls,new _.ExtHostUrls(Ge)),yt=Ge.set(f.ExtHostContext.ExtHostDocuments,new h.ExtHostDocuments(Ge,Qe)),qt=Ge.set(f.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(Ge,Qe,ft)),Jt=Ge.set(f.ExtHostContext.ExtHostDocumentSaveParticipant,new n.ExtHostDocumentSaveParticipant(ft,yt,Ge.getProxy(f.MainContext.MainThreadBulkEdits))),pt=Ge.set(f.ExtHostContext.ExtHostNotebook,new se.ExtHostNotebookController(Ge,$e,Qe,yt)),si=Ge.set(f.ExtHostContext.ExtHostNotebookDocuments,new ge.ExtHostNotebookDocuments(pt)),oi=Ge.set(f.ExtHostContext.ExtHostNotebookEditors,new Q.ExtHostNotebookEditors(ft,pt)),Zt=Ge.set(f.ExtHostContext.ExtHostNotebookKernels,new it.ExtHostNotebookKernels(Ge,mt,pt,$e,ft)),vi=Ge.set(f.ExtHostContext.ExtHostNotebookRenderers,new Fe.ExtHostNotebookRenderers(Ge,pt)),At=Ge.set(f.ExtHostContext.ExtHostEditors,new P.ExtHostEditors(Ge,Qe)),Wt=Ge.set(f.ExtHostContext.ExtHostTreeViews,new F.ExtHostTreeViews(Ge.getProxy(f.MainContext.MainThreadTreeViews),$e,ft)),bi=Ge.set(f.ExtHostContext.ExtHostEditorInsets,new re.ExtHostEditorInsets(Ge.getProxy(f.MainContext.MainThreadEditorInsets),At,mt.remote)),ai=Ge.set(f.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(Ge,ft,Ft,Qe)),ei=Ge.set(f.ExtHostContext.ExtHostLanguages,new u.ExtHostLanguages(Ge,yt,$e.converter,Ot)),ut=Ge.set(f.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(Ge,Ot,yt,$e,ai,ft,Pe,kt)),Bi=Ge.set(f.ExtHostContext.ExtHostFileSystem,new t.ExtHostFileSystem(Ge,ut)),Ut=Ge.set(f.ExtHostContext.ExtHostFileSystemEventService,new g.ExtHostFileSystemEventService(Ge,ft,Qe)),Qt=Ge.set(f.ExtHostContext.ExtHostQuickOpen,(0,j.createExtHostQuickOpen)(Ge,ht,$e)),ci=Ge.set(f.ExtHostContext.ExtHostSCM,new Z.ExtHostSCM(Ge,$e,ft)),Ei=Ge.set(f.ExtHostContext.ExtHostQuickDiff,new Ct.ExtHostQuickDiff(Ge)),wi=Ge.set(f.ExtHostContext.ExtHostComments,(0,l.createExtHostComments)(Ge,$e,yt)),ui=Ge.set(f.ExtHostContext.ExtHostProgress,new O.ExtHostProgress(Ge.getProxy(f.MainContext.MainThreadProgress))),Si=Ge.set(f.ExtHostContext.ExtHosLabelService,new G.ExtHostLabelService(Ge)),li=Ge.set(f.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(Ge)),ti=Ge.set(f.ExtHostContext.ExtHostAuthentication,new B.ExtHostAuthentication(Ge)),$i=Ge.set(f.ExtHostContext.ExtHostTimeline,new W.ExtHostTimeline(Ge,$e)),ii=Ge.set(f.ExtHostContext.ExtHostWebviews,new pe.ExtHostWebviews(Ge,mt.remote,ht,ft,Pe)),ni=Ge.set(f.ExtHostContext.ExtHostWebviewPanels,new ae.ExtHostWebviewPanels(Ge,ii,ht)),yi=Ge.set(f.ExtHostContext.ExtHostCustomEditors,new ye.ExtHostCustomEditors(Ge,yt,Nt,ii,ni)),Di=Ge.set(f.ExtHostContext.ExtHostWebviewViews,new he.ExtHostWebviewViews(Ge,ii)),ri=Ge.set(f.ExtHostContext.ExtHostTesting,new We.ExtHostTesting(Ge,$e,Qe)),Ii=Ge.set(f.ExtHostContext.ExtHostUriOpeners,new Ve.ExtHostUriOpeners(Ge)),Ci=Ge.set(f.ExtHostContext.ExtHostProfileContentHandlers,new wt.ExtHostProfileContentHandlers(Ge));Ge.set(f.ExtHostContext.ExtHostInteractive,new Me.ExtHostInteractive(Ge,pt,Qe,$e,ft));const zi=Object.values(f.ExtHostContext);Ge.assertRegistered(zi);const Wi=new be.ExtHostBulkEdits(Ge,Qe),Hi=new s.ExtHostClipboard(Ge),ki=new d.ExtHostMessageService(Ge,ft),Ri=new A.ExtHostDialogs(Ge),Oi=new x.ExtHostStatusBar(Ge,$e.converter);return m.ExtHostApiCommands.register($e),function(Ne,Ht,Li){const gt=function(){let ne=!Ne.isUnderDevelopment;function fe(){ne||(ft.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Oe(st){if(Array.isArray(st))st.forEach(Oe);else if(typeof st=="string")fe();else{const Dt=st;typeof Dt.scheme>"u"&&fe(),typeof Dt.exclusive=="boolean"&&(0,He.checkProposedApiEnabled)(Ne,"documentFiltersExclusive")}return st}}(),Vi={getSession(ne,fe,Oe){return ti.getSession(Ne,ne,fe,Oe)},async hasSession(ne,fe){return(0,He.checkProposedApiEnabled)(Ne,"authSession"),!!await ti.getSession(Ne,ne,fe,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(ne,fe,Oe,st){return ti.registerAuthenticationProvider(ne,fe,Oe,st)}},di={registerCommand(ne,fe,Oe){return $e.registerCommand(!0,ne,fe,Oe,void 0,Ne)},registerTextEditorCommand(ne,fe,Oe){return $e.registerCommand(!0,ne,(...st)=>{const Dt=At.getActiveTextEditor();if(!Dt){ft.warn("Cannot execute "+ne+" because there is no active text editor.");return}return Dt.edit(Rt=>{fe.apply(Oe,[Dt,Rt,...st])}).then(Rt=>{Rt||ft.warn("Edits from command "+ne+" were not applied.")},Rt=>{ft.warn("An error occurred while running command "+ne,Rt)})},void 0,void 0,Ne)},registerDiffInformationCommand:(ne,fe,Oe)=>((0,He.checkProposedApiEnabled)(Ne,"diffCommand"),$e.registerCommand(!0,ne,async(...st)=>{const Dt=Qe.activeEditor(!0);if(!Dt){ft.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Rt=await At.getDiffInformation(Dt.id);fe.apply(Oe,[Rt,...st])},void 0,void 0,Ne)),executeCommand(ne,...fe){return $e.executeCommand(ne,...fe)},getCommands(ne=!1){return $e.getCommands(ne)}},Fi={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return Hi.value},get shell(){return Ze.getDefaultShell(!1)},get onDidChangeShell(){return(0,He.checkProposedApiEnabled)(Ne,"envShellEvent"),Ze.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,He.checkProposedApiEnabled)(Ne,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,He.checkProposedApiEnabled)(Ne,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.isNewAppInstall)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ne){return(0,He.checkProposedApiEnabled)(Ne,"telemetryLogger"),kt.instantiateLogger(Ne,ne)},openExternal(ne,fe){return me.openUri(ne,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===mt.environment.appUriScheme)return St.createAppUri(ne);try{return await me.asExternalUri(ne,{allowTunneling:!!mt.remote.authority})}catch(fe){if((0,Y.matchesScheme)(ne,ot.Schemas.http)||(0,Y.matchesScheme)(ne,ot.Schemas.https))return ne;throw fe}},get remoteName(){return(0,H.getRemoteName)(mt.remote.authority)},get remoteAuthority(){return(0,He.checkProposedApiEnabled)(Ne,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return ft.onDidChangeLogLevel}};mt.environment.extensionTestsLocationURI||Object.freeze(Fi);const ji={createTestController(ne,fe,Oe){return ri.createTestController(Ne,ne,fe,Oe)},createTestObserver(){return(0,He.checkProposedApiEnabled)(Ne,"testObserver"),ri.createTestObserver()},runTests(ne){return(0,He.checkProposedApiEnabled)(Ne,"testObserver"),ri.runTests(ne)},get onDidChangeTestResults(){return(0,He.checkProposedApiEnabled)(Ne,"testObserver"),ri.onResultsChanged},get testResults(){return(0,He.checkProposedApiEnabled)(Ne,"testObserver"),ri.results}},hi=mt.remote.isRemote?q.ExtensionKind.Workspace:q.ExtensionKind.UI,qi={getExtension(ne,fe){(0,He.isProposedApiEnabled)(Ne,"extensionsAny")||(fe=!1);const Oe=Ht.mine.getExtensionDescription(ne);if(Oe)return new a.Extension(Pt,Ne.identifier,Oe,hi,!1);if(fe){const st=Ht.all.getExtensionDescription(ne);if(st)return new a.Extension(Pt,Ne.identifier,st,hi,!0)}},get all(){const ne=[];for(const fe of Ht.mine.getAllExtensionDescriptions())ne.push(new a.Extension(Pt,Ne.identifier,fe,hi,!1));return ne},get allAcrossExtensionHosts(){(0,He.checkProposedApiEnabled)(Ne,"extensionsAny");const ne=new He.ExtensionIdentifierSet(Ht.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),fe=[];for(const Oe of Ht.all.getAllExtensionDescriptions()){const st=!ne.has(Oe.identifier);fe.push(new a.Extension(Pt,Ne.identifier,Oe,hi,st))}return fe},get onDidChange(){return(0,He.isProposedApiEnabled)(Ne,"extensionsAny")?D.Event.any(Ht.mine.onDidChange,Ht.all.onDidChange):Ht.mine.onDidChange}},Ti={createDiagnosticCollection(ne){return ai.createDiagnosticCollection(Ne.identifier,ne)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:ne=>ai.getDiagnostics(ne),getLanguages(){return ei.getLanguages()},setTextDocumentLanguage(ne,fe){return ei.changeLanguage(ne.uri,fe)},match(ne,fe){const Oe=yt.getDocumentData(fe.uri)?.notebook;return(0,M.score)(V.LanguageSelector.from(ne),fe.uri,fe.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(ne,fe,Oe){return ut.registerCodeActionProvider(Ne,gt(ne),fe,Oe)},registerDocumentPasteEditProvider(ne,fe,Oe){return(0,He.checkProposedApiEnabled)(Ne,"documentPaste"),ut.registerDocumentPasteEditProvider(Ne,gt(ne),fe,Oe)},registerCodeLensProvider(ne,fe){return ut.registerCodeLensProvider(Ne,gt(ne),fe)},registerDefinitionProvider(ne,fe){return ut.registerDefinitionProvider(Ne,gt(ne),fe)},registerDeclarationProvider(ne,fe){return ut.registerDeclarationProvider(Ne,gt(ne),fe)},registerImplementationProvider(ne,fe){return ut.registerImplementationProvider(Ne,gt(ne),fe)},registerTypeDefinitionProvider(ne,fe){return ut.registerTypeDefinitionProvider(Ne,gt(ne),fe)},registerHoverProvider(ne,fe){return ut.registerHoverProvider(Ne,gt(ne),fe,Ne.identifier)},registerEvaluatableExpressionProvider(ne,fe){return ut.registerEvaluatableExpressionProvider(Ne,gt(ne),fe,Ne.identifier)},registerInlineValuesProvider(ne,fe){return ut.registerInlineValuesProvider(Ne,gt(ne),fe,Ne.identifier)},registerDocumentHighlightProvider(ne,fe){return ut.registerDocumentHighlightProvider(Ne,gt(ne),fe)},registerLinkedEditingRangeProvider(ne,fe){return ut.registerLinkedEditingRangeProvider(Ne,gt(ne),fe)},registerReferenceProvider(ne,fe){return ut.registerReferenceProvider(Ne,gt(ne),fe)},registerRenameProvider(ne,fe){return ut.registerRenameProvider(Ne,gt(ne),fe)},registerDocumentSymbolProvider(ne,fe,Oe){return ut.registerDocumentSymbolProvider(Ne,gt(ne),fe,Oe)},registerWorkspaceSymbolProvider(ne){return ut.registerWorkspaceSymbolProvider(Ne,ne)},registerDocumentFormattingEditProvider(ne,fe){return ut.registerDocumentFormattingEditProvider(Ne,gt(ne),fe)},registerDocumentRangeFormattingEditProvider(ne,fe){return ut.registerDocumentRangeFormattingEditProvider(Ne,gt(ne),fe)},registerOnTypeFormattingEditProvider(ne,fe,Oe,...st){return ut.registerOnTypeFormattingEditProvider(Ne,gt(ne),fe,[Oe].concat(st))},registerDocumentSemanticTokensProvider(ne,fe,Oe){return ut.registerDocumentSemanticTokensProvider(Ne,gt(ne),fe,Oe)},registerDocumentRangeSemanticTokensProvider(ne,fe,Oe){return ut.registerDocumentRangeSemanticTokensProvider(Ne,gt(ne),fe,Oe)},registerSignatureHelpProvider(ne,fe,Oe,...st){return typeof Oe=="object"?ut.registerSignatureHelpProvider(Ne,gt(ne),fe,Oe):ut.registerSignatureHelpProvider(Ne,gt(ne),fe,typeof Oe>"u"?[]:[Oe,...st])},registerCompletionItemProvider(ne,fe,...Oe){return ut.registerCompletionItemProvider(Ne,gt(ne),fe,Oe)},registerInlineCompletionItemProvider(ne,fe){return fe.handleDidShowCompletionItem&&(0,He.checkProposedApiEnabled)(Ne,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Ne,gt(ne),fe)},registerDocumentLinkProvider(ne,fe){return ut.registerDocumentLinkProvider(Ne,gt(ne),fe)},registerColorProvider(ne,fe){return ut.registerColorProvider(Ne,gt(ne),fe)},registerFoldingRangeProvider(ne,fe){return ut.registerFoldingRangeProvider(Ne,gt(ne),fe)},registerSelectionRangeProvider(ne,fe){return ut.registerSelectionRangeProvider(Ne,ne,fe)},registerCallHierarchyProvider(ne,fe){return ut.registerCallHierarchyProvider(Ne,ne,fe)},registerTypeHierarchyProvider(ne,fe){return ut.registerTypeHierarchyProvider(Ne,ne,fe)},setLanguageConfiguration:(ne,fe)=>ut.setLanguageConfiguration(Ne,ne,fe),getTokenInformationAtPosition(ne,fe){return(0,He.checkProposedApiEnabled)(Ne,"tokenInformation"),ei.tokenAtPosition(ne,fe)},registerInlayHintsProvider(ne,fe){return ut.registerInlayHintsProvider(Ne,ne,fe)},createLanguageStatusItem(ne,fe){return ei.createLanguageStatusItem(Ne,ne,fe)},registerDocumentDropEditProvider(ne,fe){return ut.registerDocumentOnDropEditProvider(Ne,ne,fe)}},Ki={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return Ze.activeTerminal},get terminals(){return Ze.terminals},async showTextDocument(ne,fe,Oe){const st=await(S.URI.isUri(ne)?Promise.resolve(Kt.openTextDocument(ne)):Promise.resolve(ne));return At.showTextDocument(st,fe,Oe)},createTextEditorDecorationType(ne){return At.createTextEditorDecorationType(Ne,ne)},onDidChangeActiveTextEditor(ne,fe,Oe){return At.onDidChangeActiveTextEditor(ne,fe,Oe)},onDidChangeVisibleTextEditors(ne,fe,Oe){return At.onDidChangeVisibleTextEditors(ne,fe,Oe)},onDidChangeTextEditorSelection(ne,fe,Oe){return At.onDidChangeTextEditorSelection(ne,fe,Oe)},onDidChangeTextEditorOptions(ne,fe,Oe){return At.onDidChangeTextEditorOptions(ne,fe,Oe)},onDidChangeTextEditorVisibleRanges(ne,fe,Oe){return At.onDidChangeTextEditorVisibleRanges(ne,fe,Oe)},onDidChangeTextEditorViewColumn(ne,fe,Oe){return At.onDidChangeTextEditorViewColumn(ne,fe,Oe)},onDidCloseTerminal(ne,fe,Oe){return Ze.onDidCloseTerminal(ne,fe,Oe)},onDidOpenTerminal(ne,fe,Oe){return Ze.onDidOpenTerminal(ne,fe,Oe)},onDidChangeActiveTerminal(ne,fe,Oe){return Ze.onDidChangeActiveTerminal(ne,fe,Oe)},onDidChangeTerminalDimensions(ne,fe,Oe){return(0,He.checkProposedApiEnabled)(Ne,"terminalDimensions"),Ze.onDidChangeTerminalDimensions(ne,fe,Oe)},onDidChangeTerminalState(ne,fe,Oe){return Ze.onDidChangeTerminalState(ne,fe,Oe)},onDidWriteTerminalData(ne,fe,Oe){return(0,He.checkProposedApiEnabled)(Ne,"terminalDataWriteEvent"),Ze.onDidWriteTerminalData(ne,fe,Oe)},get state(){return me.state},onDidChangeWindowState(ne,fe,Oe){return me.onDidChangeWindowState(ne,fe,Oe)},showInformationMessage(ne,...fe){return ki.showMessage(Ne,N.default.Info,ne,fe[0],fe.slice(1))},showWarningMessage(ne,...fe){return ki.showMessage(Ne,N.default.Warning,ne,fe[0],fe.slice(1))},showErrorMessage(ne,...fe){return ki.showMessage(Ne,N.default.Error,ne,fe[0],fe.slice(1))},showQuickPick(ne,fe,Oe){return Qt.showQuickPick(ne,fe,Oe)},showWorkspaceFolderPick(ne){return Qt.showWorkspaceFolderPick(ne)},showInputBox(ne,fe){return Qt.showInput(ne,fe)},showOpenDialog(ne){return Ri.showOpenDialog(ne)},showSaveDialog(ne){return Ri.showSaveDialog(ne)},createStatusBarItem(ne,fe,Oe){let st,Dt,Rt;return typeof ne=="string"?(st=ne,Dt=fe,Rt=Oe):(Dt=ne,Rt=fe),Oi.createStatusBarEntry(Ne,st,Dt,Rt)},setStatusBarMessage(ne,fe){return Oi.setStatusBarMessage(ne,fe)},withScmProgress(ne){return Pe.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),ui.withProgress(Ne,{location:q.ProgressLocation.SourceControl},(fe,Oe)=>ne({report(st){}}))},withProgress(ne,fe){return ui.withProgress(Ne,ne,fe)},createOutputChannel(ne,fe){return Et.createOutputChannel(ne,fe,Ne)},createWebviewPanel(ne,fe,Oe,st){return ni.createWebviewPanel(Ne,ne,fe,Oe,st)},createWebviewTextEditorInset(ne,fe,Oe,st){return(0,He.checkProposedApiEnabled)(Ne,"editorInsets"),bi.createWebviewEditorInset(ne,fe,Oe,st,Ne)},createTerminal(ne,fe,Oe){return typeof ne=="object"?"pty"in ne?Ze.createExtensionTerminal(ne):Ze.createTerminalFromOptions(ne):Ze.createTerminal(ne,fe,Oe)},registerTerminalLinkProvider(ne){return Ze.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,fe){return Ze.registerProfileProvider(Ne,ne,fe)},registerTerminalQuickFixProvider(ne,fe){return(0,He.checkProposedApiEnabled)(Ne,"terminalQuickFixProvider"),Ze.registerTerminalQuickFixProvider(ne,Ne.identifier.value,fe)},registerTreeDataProvider(ne,fe){return Wt.registerTreeDataProvider(ne,fe,Ne)},createTreeView(ne,fe){return Wt.createTreeView(ne,fe,Ne)},registerWebviewPanelSerializer:(ne,fe)=>ni.registerWebviewPanelSerializer(Ne,ne,fe),registerCustomEditorProvider:(ne,fe,Oe={})=>yi.registerCustomEditorProvider(Ne,ne,fe,Oe),registerFileDecorationProvider(ne){return Be.registerFileDecorationProvider(ne,Ne)},registerUriHandler(ne){return St.registerUriHandler(Ne.identifier,ne)},createQuickPick(){return Qt.createQuickPick(Ne)},createInputBox(){return Qt.createInputBox(Ne)},get activeColorTheme(){return li.activeColorTheme},onDidChangeActiveColorTheme(ne,fe,Oe){return li.onDidChangeActiveColorTheme(ne,fe,Oe)},registerWebviewViewProvider(ne,fe,Oe){return Di.registerWebviewViewProvider(Ne,ne,fe,Oe?.webviewOptions)},get activeNotebookEditor(){return pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,fe,Oe){return pt.onDidChangeActiveNotebookEditor(ne,fe,Oe)},get visibleNotebookEditors(){return pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,fe,Oe){return oi.onDidChangeNotebookEditorSelection(ne,fe,Oe)},onDidChangeNotebookEditorVisibleRanges(ne,fe,Oe){return oi.onDidChangeNotebookEditorVisibleRanges(ne,fe,Oe)},showNotebookDocument(ne,fe){return pt.showNotebookDocument(ne,fe)},registerExternalUriOpener(ne,fe,Oe){return(0,He.checkProposedApiEnabled)(Ne,"externalUriOpener"),Ii.registerExternalUriOpener(Ne.identifier,ne,fe,Oe)},registerProfileContentHandler(ne,fe){return(0,He.checkProposedApiEnabled)(Ne,"profileContentHandlers"),Ci.registrProfileContentHandler(Ne,ne,fe)},async registerQuickDiffProvider(ne,fe,Oe){return(0,He.checkProposedApiEnabled)(Ne,"quickDiffProvider"),Ei.registerQuickDiffProvider(ne,fe,Oe)},get tabGroups(){return Re.tabGroups}},Kt={get rootPath(){return Pe.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(ne){throw k.readonly()},getWorkspaceFolder(ne){return ht.getWorkspaceFolder(ne)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(ne){throw k.readonly()},get workspaceFile(){return ht.workspaceFile},set workspaceFile(ne){throw k.readonly()},updateWorkspaceFolders:(ne,fe,...Oe)=>ht.updateWorkspaceFolders(Ne,ne,fe||0,...Oe),onDidChangeWorkspaceFolders:function(ne,fe,Oe){return ht.onDidChangeWorkspace(ne,fe,Oe)},asRelativePath:(ne,fe)=>ht.getRelativePath(ne,fe),findFiles:(ne,fe,Oe,st)=>ht.findFiles(ne,fe,Oe,Ne.identifier,st),findTextInFiles:(ne,fe,Oe,st)=>{(0,He.checkProposedApiEnabled)(Ne,"findTextInFiles");let Dt,Rt;return typeof fe=="object"?(Dt=fe,Rt=Oe):(Dt={},Rt=fe,st=Oe),ht.findTextInFiles(ne,Dt||{},Rt,Ne.identifier,st)},saveAll:ne=>ht.saveAll(ne),applyEdit(ne,fe){return Wi.applyWorkspaceEdit(ne,Ne,fe)},createFileSystemWatcher:(ne,fe,Oe,st)=>Ut.createFileSystemWatcher(ht,Ne,ne,fe,Oe,st),get textDocuments(){return yt.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw k.readonly()},openTextDocument(ne){let fe;const Oe=ne;if(typeof ne=="string")fe=Promise.resolve(S.URI.file(ne));else if(S.URI.isUri(ne))fe=Promise.resolve(ne);else if(!Oe||typeof Oe=="object")fe=yt.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(st=>yt.ensureDocumentData(st).then(Dt=>Dt.document))},onDidOpenTextDocument:(ne,fe,Oe)=>yt.onDidAddDocument(ne,fe,Oe),onDidCloseTextDocument:(ne,fe,Oe)=>yt.onDidRemoveDocument(ne,fe,Oe),onDidChangeTextDocument:(ne,fe,Oe)=>yt.onDidChangeDocument(ne,fe,Oe),onDidSaveTextDocument:(ne,fe,Oe)=>yt.onDidSaveDocument(ne,fe,Oe),onWillSaveTextDocument:(ne,fe,Oe)=>Jt.getOnWillSaveTextDocumentEvent(Ne)(ne,fe,Oe),get notebookDocuments(){return pt.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,fe){let Oe;if(S.URI.isUri(ne))Oe=ne,await pt.openNotebookDocument(ne);else if(typeof ne=="string")Oe=S.URI.revive(await pt.createNotebookDocument({viewType:ne,content:fe}));else throw new Error("Invalid arguments");return pt.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(ne,fe,Oe){return si.onDidSaveNotebookDocument(ne,fe,Oe)},onDidChangeNotebookDocument(ne,fe,Oe){return si.onDidChangeNotebookDocument(ne,fe,Oe)},get onDidOpenNotebookDocument(){return pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return pt.onDidCloseNotebookDocument},registerNotebookSerializer(ne,fe,Oe,st){return pt.registerNotebookSerializer(Ne,ne,fe,Oe,(0,He.isProposedApiEnabled)(Ne,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(ne,fe,Oe)=>Li.onDidChangeConfiguration(ne,fe,Oe),getConfiguration(ne,fe){return fe=arguments.length===1?void 0:fe,Li.getConfiguration(ne,fe,Ne)},registerTextDocumentContentProvider(ne,fe){return qt.registerTextDocumentContentProvider(ne,fe)},registerTaskProvider:(ne,fe)=>(Pe.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),bt.registerTaskProvider(Ne,ne,fe)),registerFileSystemProvider(ne,fe,Oe){return(0,ze.combinedDisposable)(Bi.registerFileSystemProvider(Ne,ne,fe,Oe),xt.addFileSystemProvider(ne,fe))},get fs(){return xt.value},registerFileSearchProvider:(ne,fe)=>((0,He.checkProposedApiEnabled)(Ne,"fileSearchProvider"),Tt.registerFileSearchProvider(ne,fe)),registerTextSearchProvider:(ne,fe)=>((0,He.checkProposedApiEnabled)(Ne,"textSearchProvider"),Tt.registerTextSearchProvider(ne,fe)),registerRemoteAuthorityResolver:(ne,fe)=>((0,He.checkProposedApiEnabled)(Ne,"resolvers"),Pt.registerRemoteAuthorityResolver(ne,fe)),registerResourceLabelFormatter:ne=>((0,He.checkProposedApiEnabled)(Ne,"resolvers"),Si.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,fe,Oe)=>Ut.onDidCreateFile(ne,fe,Oe),onDidDeleteFiles:(ne,fe,Oe)=>Ut.onDidDeleteFile(ne,fe,Oe),onDidRenameFiles:(ne,fe,Oe)=>Ut.onDidRenameFile(ne,fe,Oe),onWillCreateFiles:(ne,fe,Oe)=>Ut.getOnWillCreateFileEvent(Ne)(ne,fe,Oe),onWillDeleteFiles:(ne,fe,Oe)=>Ut.getOnWillDeleteFileEvent(Ne)(ne,fe,Oe),onWillRenameFiles:(ne,fe,Oe)=>Ut.getOnWillRenameFileEvent(Ne)(ne,fe,Oe),openTunnel:ne=>((0,He.checkProposedApiEnabled)(Ne,"tunnels"),De.openTunnel(Ne,ne).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,He.checkProposedApiEnabled)(Ne,"tunnels"),De.getTunnels()},onDidChangeTunnels:(ne,fe,Oe)=>((0,He.checkProposedApiEnabled)(Ne,"tunnels"),De.onDidChangeTunnels(ne,fe,Oe)),registerPortAttributesProvider:(ne,fe)=>((0,He.checkProposedApiEnabled)(Ne,"portsAttributes"),De.registerPortsAttributesProvider(ne,fe)),registerTimelineProvider:(ne,fe)=>((0,He.checkProposedApiEnabled)(Ne,"timeline"),$i.registerTimelineProvider(ne,fe,Ne.identifier,$e.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:ne=>((0,He.checkProposedApiEnabled)(Ne,"workspaceTrust"),ht.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,fe,Oe)=>ht.onDidGrantWorkspaceTrust(ne,fe,Oe),registerEditSessionIdentityProvider:(ne,fe)=>((0,He.checkProposedApiEnabled)(Ne,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(ne,fe)),onWillCreateEditSessionIdentity:(ne,fe,Oe)=>((0,He.checkProposedApiEnabled)(Ne,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(Ne)(ne,fe,Oe))},fi={get inputBox(){return Pe.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),ci.getLastInputBox(Ne)},createSourceControl(ne,fe,Oe){return ci.createSourceControl(Ne,ne,fe,Oe)}},Gi={createCommentController(ne,fe){return wi.createCommentController(Ne,ne,fe)}},$t={get activeDebugSession(){return ct.activeDebugSession},get activeDebugConsole(){return ct.activeDebugConsole},get breakpoints(){return ct.breakpoints},onDidStartDebugSession(ne,fe,Oe){return ct.onDidStartDebugSession(ne,fe,Oe)},onDidTerminateDebugSession(ne,fe,Oe){return ct.onDidTerminateDebugSession(ne,fe,Oe)},onDidChangeActiveDebugSession(ne,fe,Oe){return ct.onDidChangeActiveDebugSession(ne,fe,Oe)},onDidReceiveDebugSessionCustomEvent(ne,fe,Oe){return ct.onDidReceiveDebugSessionCustomEvent(ne,fe,Oe)},onDidChangeBreakpoints(ne,fe,Oe){return ct.onDidChangeBreakpoints(ne,fe,Oe)},registerDebugConfigurationProvider(ne,fe,Oe){return ct.registerDebugConfigurationProvider(ne,fe,Oe||Ye.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,fe){return ct.registerDebugAdapterDescriptorFactory(Ne,ne,fe)},registerDebugAdapterTrackerFactory(ne,fe){return ct.registerDebugAdapterTrackerFactory(ne,fe)},startDebugging(ne,fe,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?ct.startDebugging(ne,fe,{parentSession:Oe}):ct.startDebugging(ne,fe,Oe||{})},stopDebugging(ne){return ct.stopDebugging(ne)},addBreakpoints(ne){return ct.addBreakpoints(ne)},removeBreakpoints(ne){return ct.removeBreakpoints(ne)},asDebugSourceUri(ne,fe){return ct.asDebugSourceUri(ne,fe)}},mi={registerTaskProvider:(ne,fe)=>bt.registerTaskProvider(Ne,ne,fe),fetchTasks:ne=>bt.fetchTasks(ne),executeTask:ne=>bt.executeTask(Ne,ne),get taskExecutions(){return bt.taskExecutions},onDidStartTask:(ne,fe,Oe)=>bt.onDidStartTask(ne,fe,Oe),onDidEndTask:(ne,fe,Oe)=>bt.onDidEndTask(ne,fe,Oe),onDidStartTaskProcess:(ne,fe,Oe)=>bt.onDidStartTaskProcess(ne,fe,Oe),onDidEndTaskProcess:(ne,fe,Oe)=>bt.onDidEndTaskProcess(ne,fe,Oe)},xi={createNotebookController(ne,fe,Oe,st,Dt){return Zt.createNotebookController(Ne,ne,fe,Oe,st,(0,He.isProposedApiEnabled)(Ne,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,fe)=>pt.registerNotebookCellStatusBarItemProvider(Ne,ne,fe),createRendererMessaging(ne){return vi.createRendererMessaging(Ne,ne)},createNotebookControllerDetectionTask(ne){return(0,He.checkProposedApiEnabled)(Ne,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(Ne,ne)},registerKernelSourceActionProvider(ne,fe){return(0,He.checkProposedApiEnabled)(Ne,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(Ne,ne,fe)},onDidChangeNotebookCellExecutionState(ne,fe,Oe){return(0,He.checkProposedApiEnabled)(Ne,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(ne,fe,Oe)}},Xi={t(...ne){if(typeof ne[0]=="string"){const fe=ne.shift(),Oe=!ne||typeof ne[0]!="object"?ne:ne[0];return It.getMessage(Ne.identifier.value,{message:fe,args:Oe})}return It.getMessage(Ne.identifier.value,ne[0])},get bundle(){return It.getBundle(Ne.identifier.value)},get uri(){return It.getBundleUri(Ne.identifier.value)}};return{version:mt.version,authentication:Vi,commands:di,comments:Gi,debug:$t,env:Fi,extensions:qi,l10n:Xi,languages:Ti,notebooks:xi,scm:fi,tasks:mi,tests:ji,window:Ki,workspace:Kt,Breakpoint:q.Breakpoint,TerminalOutputAnchor:q.TerminalOutputAnchor,CallHierarchyIncomingCall:q.CallHierarchyIncomingCall,CallHierarchyItem:q.CallHierarchyItem,CallHierarchyOutgoingCall:q.CallHierarchyOutgoingCall,CancellationError:k.CancellationError,CancellationTokenSource:r.CancellationTokenSource,CandidatePortSource:f.CandidatePortSource,CodeAction:q.CodeAction,CodeActionKind:q.CodeActionKind,CodeActionTriggerKind:q.CodeActionTriggerKind,CodeLens:q.CodeLens,Color:q.Color,ColorInformation:q.ColorInformation,ColorPresentation:q.ColorPresentation,ColorThemeKind:q.ColorThemeKind,CommentMode:q.CommentMode,CommentThreadCollapsibleState:q.CommentThreadCollapsibleState,CommentThreadState:q.CommentThreadState,CompletionItem:q.CompletionItem,CompletionItemKind:q.CompletionItemKind,CompletionItemTag:q.CompletionItemTag,CompletionList:q.CompletionList,CompletionTriggerKind:q.CompletionTriggerKind,ConfigurationTarget:q.ConfigurationTarget,CustomExecution:q.CustomExecution,DebugAdapterExecutable:q.DebugAdapterExecutable,DebugAdapterInlineImplementation:q.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:q.DebugAdapterNamedPipeServer,DebugAdapterServer:q.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ye.DebugConfigurationProviderTriggerKind,DebugConsoleMode:q.DebugConsoleMode,DecorationRangeBehavior:q.DecorationRangeBehavior,Diagnostic:q.Diagnostic,DiagnosticRelatedInformation:q.DiagnosticRelatedInformation,DiagnosticSeverity:q.DiagnosticSeverity,DiagnosticTag:q.DiagnosticTag,Disposable:q.Disposable,DocumentHighlight:q.DocumentHighlight,DocumentHighlightKind:q.DocumentHighlightKind,DocumentLink:q.DocumentLink,DocumentSymbol:q.DocumentSymbol,EndOfLine:q.EndOfLine,EnvironmentVariableMutatorType:q.EnvironmentVariableMutatorType,EvaluatableExpression:q.EvaluatableExpression,InlineValueText:q.InlineValueText,InlineValueVariableLookup:q.InlineValueVariableLookup,InlineValueEvaluatableExpression:q.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:q.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:q.ExtensionKind,ExtensionMode:q.ExtensionMode,ExternalUriOpenerPriority:q.ExternalUriOpenerPriority,FileChangeType:q.FileChangeType,FileDecoration:q.FileDecoration,FileDecoration2:q.FileDecoration,FileSystemError:q.FileSystemError,FileType:E.FileType,FilePermission:E.FilePermission,FoldingRange:q.FoldingRange,FoldingRangeKind:q.FoldingRangeKind,FunctionBreakpoint:q.FunctionBreakpoint,InlineCompletionItem:q.InlineSuggestion,InlineCompletionList:q.InlineSuggestionList,Hover:q.Hover,IndentAction:T.IndentAction,Location:q.Location,MarkdownString:q.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:q.ParameterInformation,PortAutoForwardAction:q.PortAutoForwardAction,Position:q.Position,ProcessExecution:q.ProcessExecution,ProgressLocation:q.ProgressLocation,QuickInputButtons:q.QuickInputButtons,Range:q.Range,RelativePattern:q.RelativePattern,Selection:q.Selection,SelectionRange:q.SelectionRange,SemanticTokens:q.SemanticTokens,SemanticTokensBuilder:q.SemanticTokensBuilder,SemanticTokensEdit:q.SemanticTokensEdit,SemanticTokensEdits:q.SemanticTokensEdits,SemanticTokensLegend:q.SemanticTokensLegend,ShellExecution:q.ShellExecution,ShellQuoting:q.ShellQuoting,SignatureHelp:q.SignatureHelp,SignatureHelpTriggerKind:q.SignatureHelpTriggerKind,SignatureInformation:q.SignatureInformation,SnippetString:q.SnippetString,SourceBreakpoint:q.SourceBreakpoint,StandardTokenType:q.StandardTokenType,StatusBarAlignment:q.StatusBarAlignment,SymbolInformation:q.SymbolInformation,SymbolKind:q.SymbolKind,SymbolTag:q.SymbolTag,Task:q.Task,TaskGroup:q.TaskGroup,TaskPanelKind:q.TaskPanelKind,TaskRevealKind:q.TaskRevealKind,TaskScope:q.TaskScope,TerminalLink:q.TerminalLink,TerminalQuickFixCommand:q.TerminalQuickFixCommand,TerminalQuickFixOpener:q.TerminalQuickFixOpener,TerminalLocation:q.TerminalLocation,TerminalProfile:q.TerminalProfile,TerminalExitReason:q.TerminalExitReason,TerminalQuickFixType:q.TerminalQuickFixType,TextDocumentSaveReason:q.TextDocumentSaveReason,TextEdit:q.TextEdit,SnippetTextEdit:q.SnippetTextEdit,TextEditorCursorStyle:R.TextEditorCursorStyle,TextEditorLineNumbersStyle:q.TextEditorLineNumbersStyle,TextEditorRevealType:q.TextEditorRevealType,TextEditorSelectionChangeKind:q.TextEditorSelectionChangeKind,TextDocumentChangeReason:q.TextDocumentChangeReason,ThemeColor:q.ThemeColor,ThemeIcon:q.ThemeIcon,TreeItem:q.TreeItem,TreeItem2:q.TreeItem,TreeItemCheckboxState:q.TreeItemCheckboxState,TreeItemCollapsibleState:q.TreeItemCollapsibleState,TypeHierarchyItem:q.TypeHierarchyItem,UIKind:b.UIKind,Uri:S.URI,ViewColumn:q.ViewColumn,WorkspaceEdit:q.WorkspaceEdit,DocumentDropEdit:q.DocumentDropEdit,DocumentPasteEdit:q.DocumentPasteEdit,InlayHint:q.InlayHint,InlayHintLabelPart:q.InlayHintLabelPart,InlayHintKind:q.InlayHintKind,RemoteAuthorityResolverError:q.RemoteAuthorityResolverError,ResolvedAuthority:q.ResolvedAuthority,SourceControlInputBoxValidationType:q.SourceControlInputBoxValidationType,ExtensionRuntime:q.ExtensionRuntime,TimelineItem:q.TimelineItem,NotebookRange:q.NotebookRange,NotebookCellKind:q.NotebookCellKind,NotebookCellExecutionState:q.NotebookCellExecutionState,NotebookCellData:q.NotebookCellData,NotebookData:q.NotebookData,NotebookRendererScript:q.NotebookRendererScript,NotebookCellStatusBarAlignment:q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:q.NotebookEditorRevealType,NotebookCellOutput:q.NotebookCellOutput,NotebookCellOutputItem:q.NotebookCellOutputItem,NotebookCellStatusBarItem:q.NotebookCellStatusBarItem,NotebookControllerAffinity:q.NotebookControllerAffinity,NotebookControllerAffinity2:q.NotebookControllerAffinity2,NotebookEdit:q.NotebookEdit,NotebookKernelSourceAction:q.NotebookKernelSourceAction,PortAttributes:q.PortAttributes,LinkedEditingRanges:q.LinkedEditingRanges,TestResultState:q.TestResultState,TestRunRequest:q.TestRunRequest,TestRunRequest2:q.TestRunRequest2,TestMessage:q.TestMessage,TestTag:q.TestTag,TestRunProfileKind:q.TestRunProfileKind,TextSearchCompleteMessageType:dt.TextSearchCompleteMessageType,DataTransfer:q.DataTransfer,DataTransferItem:q.DataTransferItem,CoveredCount:q.CoveredCount,FileCoverage:q.FileCoverage,StatementCoverage:q.StatementCoverage,BranchCoverage:q.BranchCoverage,FunctionCoverage:q.FunctionCoverage,WorkspaceTrustState:q.WorkspaceTrustState,LanguageStatusSeverity:q.LanguageStatusSeverity,QuickPickItemKind:q.QuickPickItemKind,InputBoxValidationSeverity:q.InputBoxValidationSeverity,TabInputText:q.TextTabInput,TabInputTextDiff:q.TextDiffTabInput,TabInputTextMerge:q.TextMergeTabInput,TabInputCustom:q.CustomEditorTabInput,TabInputNotebook:q.NotebookEditorTabInput,TabInputNotebookDiff:q.NotebookDiffEditorTabInput,TabInputWebview:q.WebviewEditorTabInput,TabInputTerminal:q.TerminalEditorTabInput,TabInputInteractiveWindow:q.InteractiveWindowInput,TelemetryTrustedValue:le.TelemetryTrustedValue,LogLevel:xe.LogLevel,EditSessionIdentityMatch:vt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=jt}),define(Ie[253],Ce([1,0,252,33,2,246,7,16,237]),function(te,e,r,k,D,N,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class T extends N.RequireInterceptor{j(){}getModule(b,m){for(const s of this.b){const o=s(b);if(o){b=o;break}}if(this.a.has(b))return this.a.get(b).load(b,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class M extends k.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=S.ExtensionRuntime.Webworker}async nb(){this.h.createInstance(y.ExtHostConsoleForwarder);const b=this.h.invokeFunction(r.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(T,b,{mine:this.D,all:this.F}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.tb()}ob(b){return b.browser}async pb(b,m,s){m=m.with({path:E(m.path,".js")});const o=b?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const l=D.URI.revive(await this.v.$asBrowserUri(m)),v=await fetch(l.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),v.status!==200)throw new Error(v.statusText);const w=await v.text(),A=`${m.toString(!0)}#vscode-extension`,p=`${w}
//# sourceURL=${A}`;let n;try{n=new Function("module","exports","require",p)}catch(t){throw console.error(o?`Loading code for extension ${o} failed: ${t.message}`:`Loading code failed: ${t.message}`),console.error(`${m.toString(!0)}${typeof t.line=="number"?` line ${t.line}`:""}${typeof t.column=="number"?` column ${t.column}`:""}`),console.error(t),t}b&&await this.s.initializeLocalizedMessages(b);const h={},i={exports:h},a=t=>{const g=this.r.getModule(t,m);if(g===void 0)throw new Error(`Cannot load module '${t}'`);return g};try{return s.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),n(i,h,a),i.exports!==h?i.exports:h}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),s.codeLoadingStop()}}async $setRemoteEnvironment(b){}async tb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+b;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,R.timeout)(10)}}e.ExtHostExtensionService=M;function E(f,b){return f.endsWith(b)?f:f+b}}),define(Ie[254],Ce([1,0,66,33,81,253]),function(te,e,r,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(k.IExtHostExtensionService,N.ExtHostExtensionService,0),(0,r.registerSingleton)(D.IExtensionStoragePaths,D.ExtensionStoragePaths,0)}),define(Ie[262],Ce([1,0,23,4,73,247,239,19,82,15,2,249,254]),function(te,e,r,k,D,N,S,R,y,T,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const E=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const f=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(n){return/^(file|vscode-remote):/i.test(n)}const m=fetch.bind(self);function s(n){self.fetch=async function(h,i){return h instanceof Request||b(String(h))&&(h=(await n(M.URI.parse(String(h)))).toString(!0)),m(h,i)},self.XMLHttpRequest=class extends XMLHttpRequest{open(h,i,a,t,g){(async()=>(b(i.toString())&&(i=(await n(M.URI.parse(i.toString()))).toString(!0)),super.open(h,i,a??!0,t,g)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(h,i){if(/^file:/i.test(h.toString()))h=T.FileAccess.uriToBrowserUri(M.URI.parse(h.toString())).toString(!0);else if(/^vscode-remote:/i.test(h.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const t=`(${function(d){function C(Z){return typeof Z=="string"||Z instanceof URL?String(Z).replace(/^file:\/\//i,"vscode-file://vscode-app"):Z}const O=fetch.bind(self);self.fetch=function(Z,x){return Z instanceof Request?O(Z,x):O(C(Z),x)},self.XMLHttpRequest=class extends XMLHttpRequest{open(Z,x,L,$,P){return super.open(Z,C(x),L??!0,$,P)}};const j=importScripts.bind(self);self.importScripts=(...Z)=>{j(...Z.map(C))},j(d)}.toString()}('${h}'))`;i=i||{},i.name=i.name||R.basename(h.toString());const g=new Blob([t],{type:"application/javascript"}),c=URL.createObjectURL(g);return new n(c,i)}}else self.Worker=class extends S.NestedWorker{constructor(n,h){super(f,n,{name:R.basename(n.toString()),...h})}};const o=new class{constructor(){this.pid=void 0}exit(n){E()}async exists(n){return!0}async realpath(n){return n}};class l{constructor(){const h=new MessageChannel,i=new k.Emitter;let a=!1;f(h.port2,[h.port2]),h.port1.onmessage=t=>{const{data:g}=t;if(!(g instanceof ArrayBuffer)){console.warn("UNKNOWN data received",g);return}const c=r.VSBuffer.wrap(new Uint8Array(g,0,g.byteLength));if((0,D.isMessageOfType)(c,2)){a=!0,w("received terminate message from renderer");return}i.fire(c)},this.protocol={onMessage:i.event,send:t=>{if(!a){const g=t.buffer.buffer.slice(t.buffer.byteOffset,t.buffer.byteOffset+t.buffer.byteLength);h.port1.postMessage(g,[g])}}}}}function v(n){return new Promise(h=>{const i=n.onMessage(a=>{i.dispose();const t=JSON.parse(a.toString());n.send((0,D.createMessageOfType)(0)),h({protocol:n,initData:t})});n.send((0,D.createMessageOfType)(1))})}let w=n=>E();function A(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function p(){y.mark("code/extHost/willConnectToRenderer");const n=new l;return{onmessage(h){!A(h)||v(n.protocol).then(i=>{y.mark("code/extHost/didWaitForInitData");const a=new N.ExtensionHostMain(i.protocol,i.initData,o,null,h.data);s(t=>a.asBrowserUri(t)),w=t=>a.terminate(t)})}}}e.create=p})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8be8d96ab86ed4077df554eb62727484d454699f/core/vs/workbench/api/worker/extensionHostWorker.js.map
